module modem
   ! provides moder for NJOY2016
   use locale
   implicit none
   private
   public moder

   ! global variables
   integer::ntw,ng

contains

   subroutine moder
   !-------------------------------------------------------------------
   !
   !  Change the mode of an ENDF tape.
   !
   !  Converts ENDF-type files between binary and text formats.
   !  Also works for PENDF, GENDF and covariance tapes.
   !  Moder can also be used to select materials from an ENDF-type
   !  tape, or to merge several materials into a new tape.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1       unit numbers
   !      nin     input unit
   !      nout    output unit
   !
   !  a positive unit is coded (mode 3).
   !  a negative unit is blocked binary (njoy mode).
   !
   !  note: abs(nin) ge 1 and le 19 is a flag to select various
   !        materials from one or more input tapes, with or
   !        without mode conversion.  the kind of data to be
   !        processed is keyed to nin as follows:
   !             nin=1, for endf or pendf input and output,
   !                 2, for gendf input and output,
   !                 3, for errorr-format input and output.
   !
   !      cards 2 and 3 for abs (nin) ge 1 and le 19 only.
   !
   ! card 2
   !      tpid    tapeid for nout.  66 characters allowed
   !              (delimited with *, ended with /)
   ! card 3
   !      nin     input unit
   !              terminate moder by setting nin=0
   !      matd    material on this tape to add to nout
   !-------------------------------------------------------------------
   use mainio ! provides nysi,nsyso
   use util   ! provides timer,openz,repoz,error,mess,skiprz,closz
   use endf   ! provides endf routines and variables
   ! internals
   integer::nin,nout,no,loop,i,nz,inout
   integer::matd,mend,ig,nk,ik,nb,nw
   integer::nscr,ninl,matl
   integer,parameter::nbuf=1000000
   real(kr)::time
   character(105)::strng
   character(4)::hb(17)
   real(kr)::rb(17)
   equivalence(hb(1),rb(1))
   real(kr),allocatable::a(:)
   real(kr)::z(20)
   character(4)::zc(20)
   equivalence(zc(1),z(1))

   nscr=0
   ninl=0
   matl=-2

   allocate(a(nbuf)) ! deallocated automatically at end of subroutine

   !--read user input, initialize,
   !--and write output header.
   call timer(time)
   write(nsyso,'(/&
     &'' moder...change the mode of an endf tape or njoy '',&
     &''output tape'',9x,f8.1,''s'')') time
   write(nsyse,'(/'' moder...'',60x,f8.1,''s'')') time
   read(nsysi,*) nin,nout
   call openz(nout,1)
   if (iabs(nin).ge.20) call openz(nin,0)
   nsh=0
   nsp=0
   nsc=0
   call repoz(nout)
   no=nout
   loop=0
   if (iabs(nin).ge.1.and.iabs(nin).le.19) loop=1
   if (loop.eq.1) go to 110
   write(nsyso,'(/&
     &'' input unit (+ for coded, - for bb) ... '',i10/&
     &'' output unit (+ for coded, - for bb) .. '',i10)')&
     nin,nout
   go to 140

  110 continue
   write(nsyso,'(/&
     &'' put materials from various tapes on output tape '',i3)') nout
   strng=' '
   read(nsysi,*) strng
   read(strng,'(16a4,a2)') (zc(i),i=1,17)
   nz=17
   write(nsyso,'(/&
     &'' tape id for nout''/'' ----------------''/1x,16a4,a2)')&
     (zc(i),i=1,nz)
   math=1
   mfh=0
   mth=0
   inout=1
   if (nin.eq.2) inout=2
   if (nin.eq.3) inout=3
   if (inout.eq.1) then
      write(nsyso,'(/'' processing endf or pendf tape.'')')
      write(nsyse,'(/'' processing endf or pendf tape.'')')
   else if (inout.eq.2) then
      write(nsyso,'(/'' processing gendf tape'')')
      write(nsyse,'(/'' processing gendf tape'')')
   else if (inout.eq.3) then
      write(nsyso,'(/'' processing covariance tape'')')
      write(nsyse,'(/'' processing covariance tape'')')
   endif
   call tpidio(0,nout,nscr,z,nb,nz)
   no=0
   write(nsyso,'(/10x,''nin'',10x,''matd''/&
     &10x,''---'',10x,''----'')')

  130 continue
   nz=2
   nin=0
   read(nsysi,*) nin,matd
   if (nin.eq.0) go to 1000
   write(nsyso,'(10x,i3,10x,i4)') nin,matd
   if (inout.eq.1.and.matd.le.matl) call error('moder',&
     'endf materials must be in ascending order.',' ')
   if (nin.ne.ninl) call closz(ninl)
   if (nin.ne.ninl) call openz(nin,0)
   if (nin.eq.ninl.and.inout.ge.2) go to 140
   if (nin.eq.ninl.and.matd.gt.matl) go to 180

  140 continue
   call repoz(nin)
   call repoz(nscr)
   call tpidio(nin,no,nscr,a,nb,nw)
   if (loop.gt.0) go to 180
   do i=1,17
      rb(i)=a(i)
   enddo
   write(strng,'(16a4,a2)') (hb(i),i=1,17)
   if (strng.ne.' ') then
      write(nsyso,&
        '(/'' tape label''/1x,9(''----''),''--''/2x,17a4)')&
        (hb(i),i=1,17)
   else
      write(nsyso,'('' tape id is blank'')')
   endif
   go to 205
  180 continue
   call contio(nin,0,0,a,nb,nw)
   if (n1h.eq.-1) go to 190
   call findf(matd,0,0,nin)
   ninl=nin
   matl=matd
   go to 205
  190 continue
   if (math.ne.matd) go to 200
   ninl=nin
   matl=matd
   go to 700
  200 continue
   call tomend(nin,0,0,a)
   call contio(nin,0,0,a,nb,nw)
   if (math.ne.-1) go to 190
   write(strng,'(''mat='',i4,'' not found on gendf tape'')') matd
   call mess('moder',strng,' ')
   go to 130
  205 continue
   iverf=0

   !--process endf or pendf files
  210 continue
   call contio(nin,0,0,a,nb,nw)
   if (mfh.ne.1.or.mth.ne.451) go to 215
   nsh=1
   if (n1h.eq.-1) go to 700
   if (iverf.ne.0) go to 215
   call contio(nin,0,0,a(7),nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' using endf-'',i1,'' format'')') iverf
   call skiprz(nin,-1)
  215 continue
   if (loop.eq.0.or.math.eq.0) go to 220
   if (math.ne.matd) go to 130
  220 continue
   call contio(0,nout,nscr,a,nb,nw)
   if (loop.gt.0.and.math.eq.0) go to 130
   if (math.eq.-1) go to 1010
   if (mfh.gt.0) go to 230
   if (math.gt.0) go to 210
   nsh=1
   nsp=1
   nsc=1
   go to 210
  230 continue
   if (mfh.eq.1) go to 270
   if (mfh.eq.2) then
      call file2(nin,nout,nscr,a)
   else if (mfh.eq.3) then
      call file3(nin,nout,nscr,a)
   else if (mfh.eq.4) then
      call file4(nin,nout,nscr,a)
   else if (mfh.eq.5) then
      call file5(nin,nout,nscr,a)
   else if (mfh.eq.6) then
      call file6(nin,nout,nscr,a)
   else if (mfh.eq.7) then
      call file7(nin,nout,nscr,a)
   else if (mfh.eq.8) then
      call file8(nin,nout,nscr,a)
   else if (mfh.eq.9.or.mfh.eq.10) then
      call file9(nin,nout,nscr,a)
   else if (mfh.eq.12) then
      call file1x(nin,nout,nscr,a)
   else if (mfh.eq.13) then
      call file1x(nin,nout,nscr,a)
   else if (mfh.eq.14) then
      call file14(nin,nout,nscr,a)
   else if (mfh.eq.15) then
      call file15(nin,nout,nscr,a)
   else if (mfh.eq.23) then
      call file3(nin,nout,nscr,a)
   else if (mfh.eq.24) then
      call file4(nin,nout,nscr,a)
   else if (mfh.eq.25) then
      call file5(nin,nout,nscr,a)
   else if (mfh.eq.26) then
      call file6(nin,nout,nscr,a)
   else if (mfh.eq.27) then
      call file3(nin,nout,nscr,a)
   else if (mfh.eq.28) then
      call file28(nin,nout,nscr,a)
   else if (mfh.eq.30) then
      call file1x(nin,nout,nscr,a)
   else if (mfh.eq.31) then
      call file3x(nin,nout,nscr,a)
   else if (mfh.eq.32) then
      call file32(nin,nout,nscr,a)
   else if (mfh.eq.33) then
      call file3x(nin,nout,nscr,a)
   else if (mfh.eq.34) then
      call file34(nin,nout,nscr,a)
   else if (mfh.eq.35) then
      call file35(nin,nout,nscr,a)
   else if (mfh.eq.40) then
      call file40(nin,nout,nscr,a)
   else
      write(strng,'(''conversion not coded for mf='',i3)') mfh
      call error('moder',strng,' ')
   endif
   go to 410
  270 continue
   if (mth.eq.451.and.n1h.eq.-11) go to 800
   if (mth.eq.451.and.n1h.eq.-12) go to 800
   if (mth.eq.451.and.n1h.eq.-14) go to 800
   if (loop.ne.0) then
      if (inout.eq.2)&
        call error('moder','this material is not a gendf material.',' ')
      if (inout.eq.3)&
        call error('moder','input is not an errorr output tape.',' ')
   endif
   call file1(nin,nout,nscr,a)
   go to 410
  410 continue
   call contio(nin,nout,nscr,a,nb,nw)
   if (mth.ne.0) then
      write(strng,'(1x,5i6,1p,6e12.5)') math,mfh,mth,nb,nw,(a(i),i=1,6)
      call error('moder','should have found send card',strng)
   endif
   go to 210

   !--process gendf tapes
  700 continue
   if (loop.ne.0) then
      if (inout.eq.1)&
        call error('moder','input is not an endf or pendf tape.',' ')
      if (inout.eq.3)&
        call error('moder','input is not an errorr output tape.',' ')
   endif
   ntw=n2h
  705 continue
   if (n1h.ne.-1) then
      write(strng,'(''mat='',i4,'' is not a gendf material'')') math
      call error('moder',strng,' ')
   endif
   call glstio(nin,nout,nscr,a,nb,nw)
   mend=0
   go to 740
  710 continue
   call listio(nin,nout,nscr,a,nb,nw)
   ig=n2h
   do while (nb.ne.0)
      call moreio(nin,nout,nscr,a,nb,nw)
   enddo
   if (mfh.ne.1.and.ig.ne.ng) go to 710
  740 continue
   call contio(nin,0,0,a,nb,nw)
   if (loop.gt.0) then
       if (math.ne.matd.and.math.ne.0) go to 130
   endif
   if (math.eq.-1) go to 1000
   if (math.gt.0) go to 750
   mend=1
   call amend(nout,nscr)
   nsp=1
   nsc=1
   go to 740
  750 continue
   if (mend.gt.0) go to 705
   call contio(0,nout,nscr,a,nb,nw)
   if (math.le.0) go to 740
   if (mfh.eq.0) go to 740
   if (mth.eq.0) go to 740
   go to 710

   !--process covariance tape
  800 continue
   if (loop.ne.0) then
      if (inout.eq.1)&
        call error('moder','input is not an endf tape.',' ')
      if (inout.eq.2)&
        call error('moder','input is not a gendf tape.',' ')
   endif
  805 call listio(nin,nout,nscr,a,nb,nw)
   ng=l1h
   do while (nb.ne.0)
      call moreio(nin,nout,nscr,a,nb,nw)
   enddo
  820 continue
   call contio(nin,nout,nscr,a,nb,nw)
   if (loop.gt.0.and.math.eq.0) go to 130
   if (math.eq.-1) go to 1010
   if (mth.eq.0) go to 820
   if (mfh.eq.1) go to 805

   !--covariance tape mf3
   if (mfh.eq.3.or.mfh.eq.5) then
      ! files 3 & 5 have no head cards.  backspace and read list record
      call skiprz(nin,-1)
      call skiprz(nout,-1)
      if (nout.gt.0) nsh=nsh-1
      call listio(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo

   !--covariance tapes mf33 or mf40
   else if (mfh.eq.33.or.mfh.eq.40) then
      nk=n2h
      ! loop over subsections
      do ik=1,nk
         call contio(nin,nout,nscr,a,nb,nw)
         ! loop over groups
         ig=0
         do while (ig.lt.ng)
            call listio(nin,nout,nscr,a,nb,nw)
            ig=n2h
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      enddo

   !--covariance tape mf34 or mf35
   else if (mfh.eq.34.or.mfh.eq.35) then
      call contio(nin,nout,nscr,a,nb,nw)
      ng=n2h
      ig=0
      ! loop over groups
      do while (ig.lt.ng)
         call listio(nin,nout,nscr,a,nb,nw)
         ig=n2h
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo

   !--only allow mf1, mf3 and mf33, 34, 35 & 40 on covariance tapes
   else
      write(strng,'(''illegal covariance mf='',i3)') mfh
      call error('moder',strng,' ')
   endif
   go to 820

   !--moder complete
 1000 continue
   call atend(nout,nscr)
 1010 continue
   call repoz(nout)
   call repoz(nin)
   call closz(nin)
   call closz(nout)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine moder

   subroutine file1(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 1.
   ! General information.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nx,ns,i,npr,j,lep1,lnd,lnp,ns457,nb,nw,ng,ng460,lfc,nfc,lo,nply

   !--hollerith descriptive data and tape dictionary.
   if (mth.eq.451) then
      if (iverf.le.4) nx=n2h
      if (iverf.ge.5) call contio(nin,nout,nscr,a,nb,nw)
      if (iverf.ge.6) call contio(nin,nout,nscr,a,nb,nw)
      call hdatio(nin,nout,nscr,a,nb,nw)
      if (iverf.ge.5) nx=n2h
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      nw=nx
      call dictio(nin,nout,nscr,a,nb,nw)

   !--total fission yield (nu-bar).
   else if (mth.eq.452) then
      if (l2h.ne.2) then
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      endif

   !--induced reaction branching ratios.
   else if (mth.eq.453) then
      ns=n1h
      do i=1,ns
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
         npr=n2h
         do j=1,npr
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      enddo

   !--fission product yield data.
   else if (mth.eq.454) then
      lep1=l1h
      do i=1,lep1
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo

   !--delayed fission yield (nu-bar).
   else if (mth.eq.455) then
      lnd=l2h
      call listio(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      if (lnd.ne.2) then
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      endif

   !--prompt fission yield (nu-bar).
   else if (mth.eq.456) then
      lnp=l2h
      if (lnp.ne.2) then
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      endif

   !--radioactive decay data.
   else if (mth.eq.457) then
      ns457=n2h
      do i=1,2
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo
      ns=0
      do while (ns.lt.ns457)
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
         ns=ns+1
      enddo

   !--components of energy release due to fission.
   else if (mth.eq.458) then
      lfc=l2h
      nfc=n2h
      call listio(nin,nout,nscr,a,nb,nw)
      nply=l2h
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      if (lfc.eq.1) then
         if (nply.ne.0) then
            call error('file1','bad NPLY in mt=458.',' ')
         endif
         do i=1,nfc
            call tab1io(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else if (lfc.ne.0) then
         call error('file1','bad LFC in mt=458.',' ')
      endif

   !--beta-delayed photon spectra
   else if (mth.eq.460) then
      lo=l1h
      if (lo.eq.1) then
         ng460=n1h
         do ng=1,ng460
            call tab1io(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else if (lo.eq.2) then
         call listio(nin,nout,nscr,a,nb,nw)
      else
         call error('file1','bad LO in mt=460.',' ')
      endif

   !--illegal mt for file 1
   else
      call error('file1','illegal mt.',' ')
   endif
   return
   end subroutine file1

   subroutine file2(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 2.
   ! Resonance parameters.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)

   !--normal endf resonance parameters
   if (mth.eq.151) then
      call file2a(nin,nout,nscr,a)

   !--special point-unresolved and probability-table formats
   else if (mth.eq.152.or.mth.eq.153) then
      call file2b(nin,nout,nscr,a)

   !--illegal mt for file 2.
   else
      call error('file2','illegal mt.',' ')
   endif
   return
   end subroutine file2

   subroutine file2a(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 2.
   ! Resonance parameters.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nis,i,ner,lfw,n,lru,lrf,nro,nls,l,njs,j,nb,nw
   integer::kbk,kps,lbk,lps

   nis=n1h
   do i=1,nis
      call contio(nin,nout,nscr,a,nb,nw)
      ner=n1h
      lfw=l2h
      do n=1,ner
         call contio(nin,nout,nscr,a,nb,nw)
         lru=l1h
         lrf=l2h
         nro=n1h
         if (nro.ne.0) call tab1io(nin,nout,nscr,a,nb,nw)
         if (lru.eq.2.and.lrf.eq.1.and.lfw.eq.1) then
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
            nls=n2h
            do l=1,nls
               call contio(nin,nout,nscr,a,nb,nw)
               njs=n1h
               do j=1,njs
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               enddo
            enddo
         else
            call contio(nin,nout,nscr,a,nb,nw)
            if (lrf.ne.7) then
               nls=n1h
               if (nls.ne.0) then
                  do l=1,nls
                     if (lru.eq.2.and.lrf.eq.2) then
                        call contio(nin,nout,nscr,a,nb,nw)
                        njs=n1h
                        do j=1,njs
                           call listio(nin,nout,nscr,a,nb,nw)
                           do while (nb.ne.0)
                              call moreio(nin,nout,nscr,a,nb,nw)
                           enddo
                        enddo
                     else
                        call listio(nin,nout,nscr,a,nb,nw)
                        do while (nb.ne.0)
                           call moreio(nin,nout,nscr,a,nb,nw)
                        enddo
                        if ((lru.eq.1.and.lrf.eq.4)&
                          .or.(lru.eq.2.and.lfw.ne.0)) then
                           call contio(nin,nout,nscr,a,nb,nw)
                           njs=n1h
                           do j=1,njs
                              call listio(nin,nout,nscr,a,nb,nw)
                              do while (nb.ne.0)
                                 call moreio(nin,nout,nscr,a,nb,nw)
                              enddo
                           enddo
                        endif
                     endif
                  enddo
               endif
            else
               njs=n1h
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
               do j=1,njs
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
                  kbk=l1h
                  kps=l2h
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
                  if (kbk.gt.0) then
                     do l=1,kbk
                        call contio(nin,nout,nscr,a,nb,nw)
                        lbk=l2h
                        if (lbk.eq.1) then
                           call tab1io(nin,nout,nscr,a,nb,nw)
                           do while (nb.ne.0)
                              call moreio(nin,nout,nscr,a,nb,nw)
                           enddo
                           call tab1io(nin,nout,nscr,a,nb,nw)
                           do while (nb.ne.0)
                              call moreio(nin,nout,nscr,a,nb,nw)
                           enddo
                        else if (lbk.eq.2.or.lbk.eq.3) then
                           call listio(nin,nout,nscr,a,nb,nw)
                           do while (nb.ne.0)
                              call moreio(nin,nout,nscr,a,nb,nw)
                           enddo
                        endif
                     enddo
                  endif
                  if (kps.eq.1)then
                     call listio(nin,nout,nscr,a,nb,nw)
                     lps=n1h
                     if (lps.eq.1) then
                        call tab1io(nin,nout,nscr,a,nb,nw)
                        do while (nb.ne.0)
                           call moreio(nin,nout,nscr,a,nb,nw)
                        enddo
                     endif
                  endif
               enddo
            endif
         endif
      enddo
   enddo
   return
   end subroutine file2a

   subroutine file2b(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 2 for
   ! special NJOY point-unresolved and probability-table formats.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nb,nw

   call  listio(nin,nout,nscr,a,nb,nw)
   do while (nb.ne.0)
      call moreio(nin,nout,nscr,a,nb,nw)
   enddo
   return
   end subroutine file2b

   subroutine file3(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 3.
   ! Cross sections.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::lt,nb,nw

   call tab1io(nin,nout,nscr,a,nb,nw)
   lt=l1h
   do while (nb.ne.0)
      call moreio(nin,nout,nscr,a,nb,nw)
   enddo
   do while (lt.gt.0)
      call listio(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      lt=lt-1
   enddo
   end subroutine file3

   subroutine file4(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 4.
   ! Angular distributions.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::lvt,ltt,nk,ik,ne,ie,lt,nb,nw

   lvt=l1h
   ltt=l2h
   nk=n1h
   if (nk.eq.0) nk=1
   do ik=1,nk
      if (lvt.eq.0) call contio(nin,nout,nscr,a,nb,nw)
      if (lvt.ne.0.or.l1h.ne.1) then
         if (lvt.eq.1) then
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         endif
         call tab2io(nin,nout,nscr,a,nb,nw)
         ne=n2h
         if (ltt.ne.2) then
            do ie=1,ne
               call listio(nin,nout,nscr,a,nb,nw)
               lt=l1h
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
               do while (lt.gt.0)
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
                  lt=lt-1
               enddo
            enddo
         else
            do ie=1,ne
               call tab1io(nin,nout,nscr,a,nb,nw)
               lt=l1h
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
               do while (lt.gt.0)
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
                  lt=lt-1
               enddo
            enddo
         endif
      endif
      if (ltt.ge.3) then
         call tab2io(nin,nout,nscr,a,nb,nw)
         ne=n2h
         do ie=1,ne
            call tab1io(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      endif
   enddo
   return
   end subroutine file4

   subroutine file5(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 5.
   ! Secondary energy distributions.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nk,k,lf,ne,ie,nb,nw

   nk=n1h
   do k=1,nk
      call tab1io(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      lf=l2h
      if (lf.eq.1) then
         call tab2io(nin,nout,nscr,a,nb,nw)
         ne=n2h
         do ie=1,ne
            call tab1io(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else if (lf.eq.5.or.lf.eq.11) then
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else if (lf.eq.7.or.lf.eq.9.or.lf.eq.12) then
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else if (lf.eq.10) then
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else if (lf.ne.3) then
         call error('file5','illegal lf.',' ')
      endif
   enddo
   return
   end subroutine file5

   subroutine file6(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 6.
   ! Particle energy-angle distributions
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nk,ik,law,ne,ie,nmu,imu,nb,nw
   character(60)::strng

   nk=n1h
   do ik=1,nk
      call tab1io(nin,nout,nscr,a,nb,nw)
      law=l2h
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      if (law.eq.6) then
         call contio(nin,nout,nscr,a,nb,nw)
      else if (law.eq.1.or.law.eq.2.or.law.eq.5) then
         call tab2io(nin,nout,nscr,a,nb,nw)
         ne=n2h
         do ie=1,ne
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else if (law.eq.7) then
         call tab2io(nin,nout,nscr,a,nb,nw)
         ne=n2h
         do ie=1,ne
            call tab2io(nin,nout,nscr,a,nb,nw)
            nmu=n2h
            do imu=1,nmu
               call tab1io(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            enddo
         enddo
      else if (law.lt.0) then
         if (mth.ne.18) then
            write(strng,'(''illegal endf6 law for mt='',i3)') mth
            call error('file6',strng,' ')
         endif
      else if (law.ne.0.and.law.ne.3.and.law.ne.4) then
         call error('file6','illegal endf6 law.',' ')
      endif
   enddo
   return
   end subroutine file6

   subroutine file7(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 7.
   ! Thermal neutron scattering law.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::it2,n,i,ii,lt,lthr,nb,nw
   real(kr)::b
   integer::ia1(3)
   character(60)::strng
   real(kr),parameter::zero=0

   !--incoherent inelastic (mt=4)
   if (mth.eq.4) then
      call listio(nin,nout,nscr,a,nb,nw)
      b=a(7)
      it2=0
      ia1(1)=0
      ia1(2)=0
      ia1(3)=0
      if (iverf.ge.6) then
         it2=n2h
         if (it2.gt.0.and.it2.le.3) then
            do i=1,it2
               ii=6*i+7
               ia1(i)=nint(a(ii))
            enddo
         elseif (it2.gt.3) then
            call error('file7','bad NS in mt=4.',' ')
         endif
      endif
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      if (b.eq.zero) return
      call tab2io(nin,nout,nscr,a,nb,nw)
      n=n2h
      do i=1,n
         call tab1io(nin,nout,nscr,a,nb,nw)
         lt=l1h
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
         do while (lt.gt.0)
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
            lt=lt-1
         enddo
      enddo

      !--effective temperatures
      if (iverf.ge.6) then
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
         if (it2.ne.0) then
            do i=1,it2
               if (ia1(i).eq.0) then
                  call tab1io(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               endif
            enddo
         endif
      endif

   !--elastic (mt=2)
   else if (mth.eq.2.and.iverf.ge.6) then
      lthr=l1h

      !--coherent (lthr=1) or mixed (lthr=3)
      if (lthr.eq.1.or.lthr.eq.3) then
         call tab1io(nin,nout,nscr,a,nb,nw)
         lt=l1h
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
         do while (lt.gt.0)
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
            lt=lt-1
         enddo
      endif

      !--incoherent (lthr=2) or mixed (lthr=3)
      if (lthr.eq.2.or.lthr.eq.3) then
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      endif

      !--illegal lthr for mt=2
      if (lthr.lt.1.or.lthr.gt.3) then
         write(strng,'(''illegal value of lthr='',i4)') lthr
         call error('file7',strng,' ')
      endif

   !--general information (mt=451)
   else if (mth.eq.451) then

      n=l1h
      do i=1,n
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo

   !--illegal mt
   else
      write(strng,'(''illegal mt='',i3)') mth
      call error('file7',strng,' ')
   endif
   return
   end subroutine file7

   subroutine file8(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 8.
   ! Radioactive decay and fission product yield data.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::ne,ie,ns,is,lcon,no,lfs,nb,nw

   !--fission product yield data.
   if (mth.eq.454.or.mth.eq.459) then
      ne=l1h
      do ie=1,ne
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo

   !--radioactive decay data.
   else if (mth.eq.457) then
      ns=n2h
      call listio(nin,nout,nscr,a,nb,nw)
      call listio(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
      if (ns.gt.0) then
         do is=1,ns
            call listio(nin,nout,nscr,a,nb,nw)
            lcon=l1h
            if (lcon.ne.1) then
               ne=n2h
               do ie=1,ne
                  call listio(nin,nout,nscr,a,nb,nw)
               enddo
            endif
            if (lcon.ne.0) then
               call tab1io(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            endif
         enddo
      endif

   !--radioactive nuclide production.
   else
      ns=n1h
      no=n2h
      if (no.ne.1) then
         do lfs=1,ns
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else
         do lfs=1,ns
            call contio(nin,nout,nscr,a,nb,nw)
         enddo
      endif
   endif
   return
   end subroutine file8

   subroutine file9(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 9 or File 10.
   ! Yields or cross sections for radioactive nuclide production.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::ns,lfs,nb,nw

   ns=n1h
   do lfs=1,ns
      call tab1io(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
   enddo
   return
   end subroutine file9

   subroutine file1x(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 12 or File 13.
   ! Photon yields (MF12) or photon cross sections (MF13).
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::lo,nk,nkp,k,nb,nw,ng,ng460

   !--special path for beta delayed gammas (mt=460)
   lo=l1h
   if (mfh.eq.12.and.mth.eq.460) then
      if (lo.eq.1) then
         ng460=n1h
         do ng=1,ng460+1
            call tab1io(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else if (lo.eq.2) then
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      else
         call error('file12','bad LO in mt=460.',' ')
      endif

   !--normal path for other mf1x formats
   else
      if (lo.ne.2) then
         nk=n1h
         nkp=nk+1
         if (nk.eq.1) nkp=nkp-1
         do k=1,nkp
            call tab1io(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
              call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      else
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      endif
   endif
   return
   end subroutine file1x

   subroutine file14(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 14.
   ! Photon angular distributions.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::li,ltt,nk,ni,i,ne,j,nb,nw

   li=l1h
   if (li.eq.1) return
   ltt=l2h
   nk=n1h
   ni=n2h
   do i=1,nk
      if (i.le.ni) then
         call contio(nin,nout,nscr,a,nb,nw)
      else
         call tab2io(nin,nout,nscr,a,nb,nw)
         ne=n2h
         if (ltt.ne.2) then
            do j=1,ne
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            enddo
         else
            do j=1,ne
               call tab1io(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            enddo
         endif
      endif
   enddo
   return
   end subroutine file14

   subroutine file15(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 15.
   ! Photon secondary energy distributions.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::lf,ne,i,nb,nw

   call tab1io(nin,nout,nscr,a,nb,nw)
   lf=l2h
   do while (nb.ne.0)
      call moreio(nin,nout,nscr,a,nb,nw)
   enddo

   !--tabulated distribution.
   if (lf.eq.1) then
      call tab2io(nin,nout,nscr,a,nb,nw)
      ne=n2h
      do i=1,ne
         call tab1io(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo

   !--special lanl format.
   else if (lf.eq.2) then
      call tab2io(nin,nout,nscr,a,nb,nw)
      ne=l2h
      do i=1,ne
         call listio(nin,nout,nscr,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a,nb,nw)
         enddo
      enddo

   !--illegal lf
   else
      call error('file15','illegal lf.',' ')
   endif
   return
   end subroutine file15

   subroutine file28(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 28.
   ! Atomic relaxation data.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nss,i,nb,nw

   nss=n1h
   do i=1,nss
      call listio(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
   enddo
   return
   end subroutine file28

   subroutine file3x(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 31 or File 33.
   ! Cross section covariances.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nl,l,nc,ni,n,i,nb,nw

   nl=l2h
   if (iverf.ge.5) nl=n2h
   if (nl.eq.0) return
   do l=1,nl
      call contio(nin,nout,nscr,a,nb,nw)
      nc=n1h
      ni=n2h
      if (nc.ne.0) then
         do n=1,nc
            if (iverf.ge.5) call contio(nin,nout,nscr,a,nb,nw)
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      endif
      if (ni.ne.0) then
         do i=1,ni
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
      endif
   enddo
   return
   end subroutine file3x

   subroutine file32(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 32.
   ! Resonance-parameter covariances.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nis,i,nls,l,nb,nw,ner,j,lru,nro,ni,k,lcomp,nsrs,nlrs,nn,ndigit
   integer::isr,lrf,njsx,njs,nsg

   nis=n1h
   do i=1,nis
      call contio(nin,nout,nscr,a,nb,nw)
      ner=n1h
      do j=1,ner
         call contio(nin,nout,nscr,a,nb,nw)
         lru=l1h
         lrf=l2h
         nro=n1h
         if (nro.gt.0) then
            call contio(nin,nout,nscr,a,nb,nw)
            ni=n2h
            do k=1,ni
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            enddo
         endif
         call contio(nin,nout,nscr,a,nb,nw)
         lcomp=l2h
         nls=n1h
         isr=n2h
         if (lrf.ne.7) then
            if (isr.ne.0) then
               if (isr.eq.1.and.lrf.le.2) then
                  call contio(nin,nout,nscr,a,nb,nw)
               else if (isr.eq.1.and.lrf.eq.3) then
                  call listio(nin,nout,nscr,a,nb,nw)
               else
                  call error('file32','unknown isr',' ')
               endif
            endif
            if (lru.eq.2) then
               do l=1,nls
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               enddo
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            else if (lcomp.eq.0) then
               do l=1,nls
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               enddo
            else if (lcomp.eq.1) then
               call contio(nin,nout,nscr,a,nb,nw)
               nsrs=n1h
               nlrs=n2h
               do k=1,nsrs
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               enddo
               if (nlrs.gt.0) then
                  do k=1,nsrs
                     call listio(nin,nout,nscr,a,nb,nw)
                     do while (nb.ne.0)
                        call moreio(nin,nout,nscr,a,nb,nw)
                     enddo
                  enddo
               endif
            else if (lcomp.eq.2) then
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
               call contio(nin,nout,nscr,a,nb,nw)
               nn=n1h
               ndigit=l1h
               if (ndigit.lt.2 .or. ndigit.gt.6) then
                  if(ndigit.eq.0) then
                    ndigit=2
                    call mess('file32','1illegal value of ndigit',&
                              'set default, ndigit=2')
                  else
                    call error('file32','illegal value of ndigit',' ')
                  endif
               endif
               do k=1,nn
                  nw=ndigit
                  call intgio(nin,nout,nscr,a,nb,nw)
               end do
            else
               call error('file32','illegal value of lcomp',' ')
            endif
         else
            if (isr.ne.0) call error('file32',&
              'isr>0 not supported for lrf=7',' ')
            if (lcomp.eq.1) then
               call contio(nin,nout,nscr,a,nb,nw)
               nsg=n1h
               do k=1,nsg
                  call contio(nin,nout,nscr,a,nb,nw)
                  njsx=l1h
                  do l=1,njsx
                     call listio(nin,nout,nscr,a,nb,nw)
                     do while (nb.ne.0)
                        call moreio(nin,nout,nscr,a,nb,nw)
                     enddo
                  enddo
               enddo
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            else if (lcomp.eq.2) then
               njs=n1h
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
               do k=1,njs
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               enddo
               call contio(nin,nout,nscr,a,nb,nw)
               nn=n1h
               ndigit=l1h
               if (ndigit.lt.2.or.ndigit.gt.6) then
                  if (ndigit.eq.0) then
                    ndigit=2
                    call mess('file32','2illegal value of ndigit',&
                              'set default, ndigit=2')
                  else
                    call error('file32','illegal value of ndigit',' ')
                  endif
               endif
               do k=1,nn
                  nw=ndigit
                  call intgio(nin,nout,nscr,a,nb,nw)
               enddo
            else
               call error('file32','illegal value of lcomp',' ')
            endif
         endif
      enddo
   enddo
   return
   end subroutine file32

   subroutine file34(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 34
   ! Covariances for angular distributions.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nmt1,i,mt1,nl,nl1,l,l1,ni,j,nb,nw

   nmt1=n2h
   do i=1,nmt1
      call contio(nin,nout,nscr,a,nb,nw)
      mt1=l2h
      nl=n1h
      nl1=n2h
      do l=1,nl
         do l1=1,nl1
            if (mt1.ne.mth.or.l1.ge.l) then
               call contio(nin,nout,nscr,a,nb,nw)
               ni=n2h
               do j=1,ni
                  call listio(nin,nout,nscr,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,nout,nscr,a,nb,nw)
                  enddo
               enddo
            endif
         enddo
      enddo
   enddo
   return
   end subroutine file34

   subroutine file35(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 35.
   ! Covariances for secondary energy distributions.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::nk,i,nb,nw

   nk=n1h
   do i=1,nk
      call listio(nin,nout,nscr,a,nb,nw)
      do while (nb.ne.0)
         call moreio(nin,nout,nscr,a,nb,nw)
      enddo
   enddo
   return
   end subroutine file35

   subroutine file40(nin,nout,nscr,a)
   !-------------------------------------------------------------------
   ! Convert mode of File 40.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! external
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::ns,i,nl,j,nc,ni,k,l,nb,nw

   ns=n1h
   do i=1,ns
      call contio(nin,nout,nscr,a,nb,nw)
      nl=n2h
      do j=1,nl
         call contio(nin,nout,nscr,a,nb,nw)
         nc=n1h
         ni=n2h
         do k=1,nc
            call contio(nin,nout,nscr,a,nb,nw)
            call listio(nin,nout,nscr,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a,nb,nw)
            enddo
         enddo
         if (ni.ne.0) then
            do l=1,ni
               call listio(nin,nout,nscr,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,nout,nscr,a,nb,nw)
               enddo
            enddo
         endif
      enddo
   enddo
   return
   end subroutine file40

   subroutine glstio(nin,nout,nscr,a,nb,nw)
   !-------------------------------------------------------------------
   ! Convert a GENDF File 1 MT451 list record to opposite format.
   ! glstio processes the entire record.
   ! Text GOUT tapes do not have titles.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr,nb,nw,nbt,nwt
   real(kr)::a(*)
   ! internals
   integer::n1,n2,l,noff,i

   !--read in rest of header record.
   !--binary outputs can also be written.
   n1=nout
   if (n1.gt.0) n1=0
   n2=nscr
   if (n2.gt.0) n2=0
   call contio(0,n1,n2,a(1),nb,nw)
   ntw=n2h
   l=7
   call listio(nin,n1,n2,a(l),nb,nw)
   ng=l1h
   do while (nb.ne.0)
      l=l+nw
      call moreio(nin,n1,n2,a(l),nb,nw)
   enddo
   nw=l+nw-7
   if (nout.le.0.and.nscr.le.0) return

   !--remove title from binary input and write bcd outputs, if any.
   n1=nout
   if (n1.lt.0) n1=0
   n2=nscr
   if (n2.lt.0) n2=0
   a(6)=1
   call contio(0,n1,n2,a(1),nbt,nwt)
   noff=ntw-1
   nw=nw-noff
   do i=2,nw
      l=12+i
      a(l)=a(l+noff)
   enddo
   a(11)=a(11)-noff
   a(13)=0
   l=7
   call listio(0,n1,n2,a(l),nb,nw)
   do while (nb.ne.0)
      l=l+nw
      call moreio(0,n1,n2,a(l),nb,nw)
   enddo
   return
   end subroutine glstio

end module modem

module reconm
   ! Module to provide reconr for NJOY2016
   use locale
   implicit none
   private
   public reconr

   ! global variables for reconr

   integer::nin,nout
   real(kr)::zain,awin
   real(kr)::zai,el,eh,err,errmax,errint,za,awr,tempr,q18
   real(kr)::tempi
   real(kr)::elis,sta,efmax
   integer::lis,lis0,nfor,lrel,nver
   integer::lfw,mata,itype,lrp,lfi,lssf,lrx
   integer,parameter::nmtmax=10
   integer::mtr4,mtr18,mtr(nmtmax),mtrt(nmtmax),nmtr
   integer::mt103,mt104,mt105,mt106,mt107
   integer::mpmin,mpmax,mdmin,mdmax,mtmin,mtmax,m3min,m3max,m4min,m4max
   integer::nxc,ngo,mtr522,ncards
   integer::isot(20),modet(20),ibaset(20),isect,nsect
   real(kr)::abnt(20),elt(20),eht(20)
   real(kr)::eresl,eresr,eresh,eresu,eresm
   integer::nodes,nunr,maxres
   real(kr)::elst(20),slst(20,4),enxt(20),snxt(20,4)
   integer::ilast(20)
   integer::mmtres(10),mcards(10)
   integer::nmtres,ncoef,nsig,nresp
   real(kr)::spin,ascat,thr6
   character(4),dimension(:),allocatable::card
   real(kr),dimension(:),allocatable::enode
   real(kr),dimension(:),allocatable::eunr
   real(kr),dimension(:),allocatable::res
   real(kr),dimension(:,:),allocatable::tr,ti
   real(kr),dimension(:),allocatable::dict
   integer,dimension(:),allocatable::mfs,mts,ncs
   real(kr),dimension(:),allocatable::sunr

   integer,parameter::maxunr=500
   integer,parameter::nodmax=800000
   integer,parameter::nbufg=2000
   integer,parameter::nbufr=2000
   integer,parameter::nbuf=2000
   integer,parameter::nbufl=2000

   !--option for sammy method
   !integer::isammy=0  ! no sammy calculation
   integer::isammy=1  ! sammy calculation

contains

   subroutine reconr
   !-------------------------------------------------------------------
   !
   ! Reconstruct pointwise cross sections
   !
   ! Resonance cross sections are calculated using methods from the
   ! earlier versions of NJOY (which are descended from those of
   ! the early RESEND code) or the methods developed for the SAMMY
   ! R-matrix fitting code, depending on the format used.
   !
   ! This program generates an energy grid which is the union of an
   ! input grid (if any), the resonance energies (if any), and the
   ! energies of cross sections in mf3 and mf13 (or mf23). The
   ! pointwise cross sections are then computed on this grid and
   ! points are added so that the resonance cross sections and any
   ! cross sections represented by non-linear interpolation are
   ! reproduced within a specified tolerance by linear interpolation.
   ! Psi-Chi reconstruction can be used if desired.  Sections which
   ! are not cross sections (mubar,nubar) and photon multiplicities
   ! (MF12) are not processed.  Redundant reactions are reconstructed
   ! to be the sum of their parts.  The pendf tape contains point
   ! cross sections in MF3 and MF13 (or MF23) and a description of
   ! the processing in MF1.  The MF1 dictionary is updated.  The
   ! C1 and C2 fields of the second card in MF1 contain the temper-
   ! ature and reconstruction tolerance, respectively.  An MF2
   ! appropriate to no resonance parameters is constructed with
   ! the potential scattering length added.
   !
   ! If unresolved parameters are present, the infinitely dilute
   ! cross sections are computed on a special energy grid chosen to
   ! preserve the required interpolation properties.  This table is
   ! added to the pendf tape using a special format in MF2/MT152,
   ! and the table is also used to compute the unresolved contribu-
   ! tions in MF3.  This allows resolved resonance cross sections
   ! which overlap the resolved range to be recovered by subtraction.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1
   !    nendf    unit for endf tape
   !    npend    unit for pendf tape
   ! card 2
   !    tlabel   66 character label for new pendf tape
   !             delimited with quotes, ended with /.
   ! card 3
   !    mat      material to be reconstructed
   !    ncards   number of cards of descriptive data for new mf1
   !             (default=0)
   !    ngrid    number of user energy grid points to be added.
   !             (default=0)
   ! card 4
   !    err      fractional reconstruction tolerance used when
   !             resonance-integral error criterion (see errint)
   !             is not satisfied.
   !    tempr    reconstruction temperature (deg kelvin)
   !             (default=0)
   !    errmax   fractional reconstruction tolerance used when
   !             resonance-integral error criterion is satisfied
   !             (errmax.ge.err, default=10*err)
   !    errint   maximum resonance-integral error (in barns)
   !             per grid point (default=err/20000)
   !             (note: the max cross section difference for
   !             linearization, errlim, and for reconstruction,
   !             errmin, are also tied to errint.  to get maximum
   !             accuracy, set errint to a very small number.
   !             for economical production, use the defaults.)
   ! card 5
   !    cards    ncards of descriptive comments for mt451
   !             each card delimited with quotes, ended with /.
   ! card 6
   !    enode    users energy grid points
   !
   !     cards 3, 4, 5, 6 must be input for each material desired
   !     mat=0/ terminates execution of reconr.
   !
   !-------------------------------------------------------------------
   use util   ! provides timer,repoz,closz,error
   use endf   ! provides endf routines and variables
   use samm   ! provides s2sammy,desammy
   use mainio ! provides nsysi,nsyso,nsyse
   ! internals
   integer::i,nb,nw,nrtot,nwscr,n6,nx,nsub,iold,inew,ngrid
   integer::nendf,npend,nscr1,nscr2,nscr3,nscr4,intunr
   real(kr)::time
   real(kr)::rlabel(17),z(17)
   character(4)::tlabel(17),tz(17)
   equivalence(tlabel(1),rlabel(1))
   equivalence(z(1),tz(1))
   character(66)::text
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::elow=1.e-5_kr
   real(kr),parameter::ehigh=20.e6_kr
   real(kr),parameter::elarge=9.e9_kr
   logical there

   !--set samrml options
   Want_Partial_Derivs=.false.
   Want_Angular_Dist=.false.
   Want_SAMRML_BW=.false.
   Want_SAMRML_RM=.false.

   !--define local i/o units
   nscr1=-10
   nscr2=11
   nscr3=12

   !--write heading and read user input
   call timer(time)
   write(nsyso,'(/'' reconr...'',&
     &''reconstruct pointwise cross sections in pendf format'',&
     &7x,f8.1,''s'')') time
   write(nsyse,'(/'' reconr...'',59x,f8.1,''s'')') time
   read(nsysi,*) nendf,npend
   call openz(nendf,0)
   call openz(npend,1)
   read(nsysi,*) text
   read(text,'(16a4,a2)') (tlabel(i),i=1,17)
   write(nsyso,'(/&
     &'' unit for endf tape ................... '',i10/&
     &'' unit for pendf tape .................. '',i10)')&
     nendf,npend
   write(nsyso,'(/&
     &'' label for pendf tape''/1x,66(''-'')/1x,17a4)')&
     (tlabel(i),i=1,17)

   !--read tape identification record from input tape.
   !--write new tape identification label on output tape.
   nin=nendf
   nout=npend
   call repoz(nin)
   call repoz(nout)
   call tpidio(nin,0,0,z,nb,nw)
   write(nsyso,'(/'' tape label''/1x,66(''-'')/1x,17a4)')&
     (tz(i),i=1,nw)
   math=1
   mfh=0
   mth=0
   nsh=0
   nw=17
   call tpidio(0,nout,0,rlabel,nb,nw)
   if (npend.gt.0) nscr1=10
   mata=1

   !--loop through users materials
   do while (mata.ne.0)
      allocate(enode(nodmax))

      !--read users input for next material.
      call ruina
      if (mata.ne.0) then

         !--open files for this material
         call openz(-nscr2,1)
         call openz(-nscr3,1)
         call openz(nscr1,1)
         call repoz(nscr1)
         call repoz(nscr2)
         call repoz(nscr3)
         nscr4=13
         nwscr=npage+50
         allocate(scr(nwscr))

         !--position to required material
         call findf(mata,1,451,nin)

         !--process file 1
         tempi=0
         call contio(nin,0,0,scr,nb,nw)
         za=c1h
         awr=c2h
         lrp=l1h
         lfi=l2h
         n6=n2h
         call contio(nin,0,0,scr,nb,nw)
         if (n1h.ne.0) then
            iverf=4
            nx=n6
         else if (n2h.eq.0) then
            iverf=5
         else
            iverf=6
         endif
         call skiprz(nin,-1)
         if (iverf.ge.5) then
            call contio(nin,0,0,scr,nb,nw)
            elis=c1h
            sta=c2h
            lis=l1h
            lis0=l2h
            nfor=n2h
         endif
         nsub=10
         zain=1
         awin=1
         if (iverf.ge.6) then
            call contio(nin,0,0,scr,nb,nw)
            nsub=n1h
            zain=int(nsub/10)
            awin=c1h
            efmax=c2h
            lrel=l1h
            nver=n2h
         endif
         if (10*nint(zain).ne.nsub.and.nsub.ne.3) then
            call error('reconr','illegal nsub for reconr',' ')
         endif
         call hdatio(nin,0,0,scr,nb,nw)
         if (iverf.ge.6) tempi=scr(1)
         do i=1,17
            z(i)=scr(6+i)
         enddo
         write(nsyso,'(/&
           &'' processing mat '',i4,&
           &'' in endf-'',i1,'' format''/&
           &1x,66(''-'')/1x,17a4/)')&
           mata,iverf,(tz(i),i=1,17)
         do while (nb.ne.0)
            call moreio(nin,0,0,scr,nb,nw)
         enddo
         if (iverf.ne.4) nx=n2h
         call anlyzd(nin,nx)
         call tofend(nin,0,0,scr)

         !--scan file 2 to check whether sammy method is needed.
         !--get sizes for sammy arrays and allocate some arrays.
         lrx=0
         nmtres=0
         if (lrp.eq.1) then
            if (isammy.gt.0) then
              allocate(res(maxres))
              call s2sammy(nin,res,maxres,mmtres,nmtres)
              if (nmtres.gt.0) then
                 do i=1,nmtres
                    if (mmtres(i).eq.103) mmtres(i)=600
                    if (mmtres(i).eq.104) mmtres(i)=650
                    if (mmtres(i).eq.105) mmtres(i)=700
                    if (mmtres(i).eq.106) mmtres(i)=750
                    if (mmtres(i).eq.107) mmtres(i)=800
                 enddo
              else
                 call desammy
              endif
              call repoz(nin)
              call findf(mata,2,0,nin)
              deallocate(res)
            endif
         endif

         !--process file 2
         allocate(eunr(maxunr))
         nunr=0
         if (lrp.ne.1) then
            write(nsyso,'(/'' mat has no resonance parameters'')')
            nrtot=0
            eresl=elow
            eresr=ehigh
            eresh=ehigh
            eresu=elarge
            eresm=elarge
            if (lrp.eq.0 .or. lrp.gt.1) then
               call contio(nin,0,0,scr,nb,nw)
               call contio(nin,0,0,scr,nb,nw)
               call contio(nin,0,0,scr,nb,nw)
               call contio(nin,0,0,scr,nb,nw)
               spin=c1h
               ascat=c2h
            elseif (lrp.lt.0) then
               spin=0
               ascat=0
            endif
         else
            nrtot=maxres
            allocate(res(nrtot))
            ncoef=1
            do i=1,10
               mcards(i)=0
            enddo
            call rdfil2(nrtot,intunr)
            if (nmtres.eq.0) then
               nsig=5
            else
               nsig=4
               write(nsyso,'(/''   samm resonance reactions:'',10i5)')&
                 (mmtres(i),i=1,nmtres)
               if (nmtres.gt.2) then
                  do i=3,nmtres
                     if (mmtres(i).ne.18) nsig=nsig+1
                  enddo
               endif
            endif
            write(nsyso,'(''   samm max legendre order:'',i3)') ncoef-1
            if (ncoef.gt.1)&
              write(nsyso,&
               '(''   generating File 4 for resonance angular distributions'')')
            if (lrp.eq.1) write(nsyso,'(/&
              &'' mat has no unresolved resonance parameters'')')
            ! temporary meaning of lrp------
            !   1 means resolved only
            !   3 means resolved and unresolved
            if (lrp.eq.3) call genunr(nin,intunr)
            if (lssf.gt.0) eresh=eresr
         endif
         deallocate(eunr)

         !--process file 3 and file 13
         call lunion(nin,nscr1,nscr2,ngrid)
         deallocate(enode)

         !--compute resonance cross sections
         if (lrp.eq.1.or.lrp.eq.3) then
            call resxs(nscr2,nscr3,nscr4,nrtot)
            deallocate(res)
         endif

         !--clean up after sammy calculation
         if (nmtres.gt.0) call desammy

         !--do energy merge and add resonance cross sections
         if (npend.lt.0) nscr4=-nscr4
         call emerge(nscr1,nscr2,ngrid,nscr3,nrtot,iold,inew,nscr4)

         !--write output tape.
         call recout(iold,nscr4,nrtot)

         !--deallocate arrays for this material
         deallocate(card)
         deallocate(scr)
         deallocate(mfs)
         deallocate(mts)
         deallocate(ncs)
         if (allocated(tr)) deallocate(tr)
         if (allocated(ti)) deallocate(ti)
         if (allocated(sunr)) deallocate(sunr)
         !-- careful, unit number must match nscrl from resxs.
         inquire(unit=16,exist=there)
         if (there) call closz(16)
      else
         deallocate(enode)
      endif
   enddo

   !--reconstruction complete.
   call atend(nout,0)
   call repoz(nout)
   call closz(nout)
   call closz(nin)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine reconr

   subroutine ruina
   !-------------------------------------------------------------------
   ! Read user input for reconr
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use util   ! provides sigfig
   ! internals
   integer::nw,ic,i,j,nwords,ngrid,n2
   real(kr)::z(17)
   character(4)::tz(17)
   equivalence(tz(1),z(1))
   character(66)::text
   real(kr),parameter::zero=0

   !--read user input
   ncards=0
   ngrid=0
   read(nsysi,*) mata,ncards,ngrid
   if (mata.eq.0) return
   tempr=0
   errmax=-1
   errint=-1
   read(nsysi,*) err,tempr,errmax,errint
   if (errmax.le.zero) errmax=10*err
   if (errmax.lt.err) errmax=err
   if (errint.le.zero) errint=err/20000
   if (ncards.gt.0) then
      nw=17*ncards
      allocate(card(nw))
      ic=-17
      do i=1,ncards
         text=' '
         read(nsysi,*) text
         read(text,'(16a4,a2)') (tz(j),j=1,17)
         ic=ic+17
         do j=1,17
            card(j+ic)=tz(j)
         enddo
      enddo
   else
      ncards=1
      nwords=17
      allocate(card(nwords))
      text=' '
      read(text,'(16a4,a2)') (tz(j),j=1,17)
      do i=1,17
         card(i)=tz(i)
      enddo
   endif
   if (ngrid.gt.0) then
      read(nsysi,*) (enode(i),i=1,ngrid)
      do i=1,ngrid
         enode(i)=sigfig(enode(i),7,0)
      enddo
   endif

   !--write out user input
   write(nsyso,'(/&
     &'' material to be processed ............. '',i10/&
     &'' reconstruction tolerance ............. '',f10.3/&
     &'' reconstruction temperature ........... '',f10.2,''k''/&
     &'' resonance-integral-check tolerance ... '',f10.3/&
     &'' max resonance-integral error ......... '',1p,e10.3)')&
     mata,err,tempr,errmax,errint
   if (ncards.gt.0) then
      write(nsyso,'(/&
        &'' descriptive cards for pendf tape''/1x,66(''-''))')
      n2=17*ncards
      write(nsyso,'(1x,17a4)') (card(i),i=1,n2)
   endif
   write(nsyso,'('' '')')
   if (ngrid.gt.0) then
      write(nsyso,'(&
        &'' no. users energy grid points ......... '',i10)') ngrid
      write(nsyso,'(3x,1p,6e12.5)') (enode(i),i=1,ngrid)
   endif
   nodes=ngrid

   !--construct w table if needed for psi-chi.
   if (tempr.gt.zero) then
      allocate(tr(62,62))
      allocate(ti(62,62))
      call wtab(tr,ti)
   endif
   return
   end subroutine ruina

   subroutine anlyzd(nin,nx)
   !-------------------------------------------------------------------
   ! Analyze the dictionary, initialize quantities for new
   ! dictionary, and select desired redundant reactions.
   !-------------------------------------------------------------------
   use endf ! provides dictio
   use util ! provides error
   ! externals
   integer::nin,nx
   ! internals
   integer::nb,nw,i,j,igam,nxn,mfi,mti,i2,j1,mtsave

   !--read in old dictionary.
   nw=6*nx
   allocate(dict(nw))
   nw=nx
   call dictio(nin,0,0,dict,nb,nw)

   !--select desired redundant reactions.
   igam=0
   nxn=0
   nmtr=0
   mtr4=0
   mtr18=0
   mt103=0
   mt104=0
   mt105=0
   mt106=0
   mt107=0
   if (iverf.ge.6) then
       mpmin=600
       mpmax=649
       mdmin=650
       mdmax=699
       mtmin=700
       mtmax=749
       m3min=750
       m3max=799
       m4min=800
       m4max=849
   else
       mpmin=700
       mpmax=718
       mdmin=720
       mdmax=738
       mtmin=740
       mtmax=758
       m3min=760
       m3max=768
       m4min=780
       m4max=798
   endif
   mtr522=0
   do i=1,nw,6
      if (nmtr.ge.nmtmax)&
        call error('anlyzd','too many redundant reactions.',' ')
      mfi=nint(dict(i+2))
      if (mfi.eq.2) then
         mti=nint(dict(i+3))
         if (mti.eq.151) maxres=12*nint(dict(i+4))
      else if (mfi.eq.3) then
         nxn=nxn+1
         if (nmtr.eq.0) mtr(1)=1
         if (nmtr.eq.0) nmtr=1
         mti=nint(dict(i+3))
         if (mti.eq.19) then
            nmtr=nmtr+1
            mtr(nmtr)=18
            mtr18=1
         endif
         if (mti.ge.51.and.mti.le.91.and.mtr4.eq.0) then
            nmtr=nmtr+1
            mtr(nmtr)=4
            mtr4=1
         endif
         if (mti.ge.mpmin.and.mti.le.mpmax.and.mt103.eq.0) then
            nmtr=nmtr+1
            mtr(nmtr)=103
            mt103=1
         endif
         if (mti.ge.mdmin.and.mti.le.mdmax.and.mt104.eq.0) then
            nmtr=nmtr+1
            mtr(nmtr)=104
            mt104=1
         endif
         if (mti.ge.mtmin.and.mti.le.mtmax.and.mt105.eq.0) then
            nmtr=nmtr+1
            mtr(nmtr)=105
            mt105=1
         endif
         if (mti.ge.m3min.and.mti.le.m3max.and.mt106.eq.0) then
            nmtr=nmtr+1
            mtr(nmtr)=106
            mt106=1
         endif
         if (mti.ge.m4min.and.mti.le.m4max.and.mt107.eq.0) then
            nmtr=nmtr+1
            mtr(nmtr)=107
            mt107=1
         endif
      else if (mfi.eq.10) then
         nxn=nxn+1
      else if (mfi.eq.12) then
         nxn=nxn+1
         mti=nint(dict(i+3))
         if (mti.eq.3) nmtr=nmtr+1
         if (mti.eq.3) mtr(nmtr)=3
      else if (mfi.eq.13) then
         nxn=nxn+1
      else if (mfi.eq.23) then
         nxn=nxn+1
         igam=1
         if (iverf.lt.6) then
            zain=0
            awin=0
         endif
         if (nmtr.eq.0) mtr(1)=501
         if (nmtr.eq.0) nmtr=1
         if (mtr522.eq.0) then
            mti=nint(dict(i+3))
            if (mti.ge.534.and.mti.le.572) then
               nmtr=nmtr+1
               mtr(nmtr)=522
               mtr522=1
            endif
         endif
      endif
   enddo
   do i=1,nmtr
      mtrt(i)=1000000
   enddo
   do i=1,nmtr
      if (mtr(i).eq.1) mtrt(i)=1
      if (mtr(i).eq.501) mtrt(i)=1
   enddo

   !--sort reactions into increasing order.
   if (nmtr.gt.2) then
      i2=nmtr-1
      do i=2,i2
         j1=i+1
         do j=j1,nmtr
            if (mtr(j).le.mtr(i)) then
               mtsave=mtr(i)
               mtr(i)=mtr(j)
               mtr(j)=mtsave
            endif
         enddo
      enddo
   endif

   !--initialize new dictionary.
   deallocate(dict)
   nxn=nxn+4
   allocate(mfs(nxn))
   allocate(mts(nxn))
   allocate(ncs(nxn))
   mfs(1)=1
   mts(1)=451
   ncs(1)=ncards+2
   nxc=1
   if (igam.eq.1) return
   mfs(2)=2
   mts(2)=151
   ncs(2)=4
   nxc=2
   return
   end subroutine anlyzd

   subroutine rdfil2(nrtot,intunr)
   !-------------------------------------------------------------------
   ! Read ENDF File 2 data and store it into res, or for the sammy
   ! options, read the data into special arrays.  Nodes are added
   ! just below and above the boundaries of energy ranges, at the
   ! resonance energies, and at values one half-width above and
   ! below the resonance energies.  In the unresolved range, the
   ! scheme depends on the representation.  For energy independent
   ! parameters, nodes are added at 10 standard values per decade.
   ! for sections with only fission widths dependent on energy, the
   ! given values are used as nodes unless an energy step exceeds a
   ! ratio of 1.26 (see wide).  This is then assumed to be a carry-over
   ! evaluation which violates the current rules, and nodes are
   ! added at the 13-per-decade standard values.  A similar procedure
   ! is followed for energy-dependent parameters.  At the same time,
   ! a special grid of unresolved energies is constructed using the
   ! same rules.  This grid is chosen to preserve the correct inter-
   ! polation of unresolved cross sections for MF2, MT153.
   !-------------------------------------------------------------------
   use endf   ! provides endf routines and variable
   use samm   ! provides rdsammy,ppsammy
   use util   ! provides error
   use mainio ! provides nsyso
   ! externals
   integer::nrtot,intunr
   ! internals
   integer::i,j,nb,nw,nis,mode,ner,lru,lrf,nro,naps,jnow
   real(kr)::e,abn
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::eps=1.e-10_kr
   real(kr),parameter::elow=1.e-5_kr
   real(kr),parameter::elarge=9.e9_kr
   real(kr),parameter::small=1.e-6_kr

   !--initialize.
   ! eresl is lowest resonance lower bound
   ! eresh is highest resonance upper bound
   ! eresr is highest resolved upper bound
   ! eresu is lowest unresolved lower bound
   ! eresm is lowest unresolved upper bound
   eresl=elarge
   eresh=0
   eresr=0
   eresu=elarge
   eresm=elarge

   !--read head record.
   jnow=1
   call contio(nin,0,0,res(jnow),nb,nw)
   if (mfh.ne.2) then
      write(nsyso,'(/'' mat has no file 2.'')')
      nrtot=0
      lrp=0
      call tosend(nin,0,0,res)
      return
   endif
   nis=n1h
   ! preset counters
   nsect=0

   !--do loop over all isotopes.
   do i=1,nis
      call contio(nin,0,0,res(jnow),nb,nw)
      jnow=jnow+nw
      if (jnow.gt.maxres) call error('rdfil2',&
        'res storage exceeded',' ')
      zai=c1h
      abn=c2h
      lfw=l2h
      ner=n1h

      !--do loop over all energy ranges.
      do j=1,ner
         call contio(nin,0,0,res(jnow),nb,nw)
         el=c1h
         eh=c2h
         lru=l1h
         lrf=l2h

         !--add el and eh to list of nodes.
         !--shade nodes to prevent discontinuities.
         if (el.lt.eresl) eresl=el
         if (eh.gt.eresh) eresh=eh
         if (lru.le.1.and.eh.gt.eresr) eresr=eh
         if (lru.ne.0) then
            if (abs(el-elow).le.small) then
               nodes=nodes+1
               enode(nodes)=el
            else
               nodes=nodes+1
               enode(nodes)=sigfig(el,7,-1)
               nodes=nodes+1
               enode(nodes)=sigfig(el,7,+1)
               if (lru.eq.2) then
                  if (el.lt.eresu) eresu=el
                  if (nunr.ge.maxunr) call error('rdfil2',&
                    'storage in eunr exceeded.',' ')
                  nunr=nunr+1
                  eunr(nunr)=sigfig(el,7,-1)
                  nunr=nunr+1
                  eunr(nunr)=sigfig(el,7,+1)
               endif
            endif
            nodes=nodes+1
            enode(nodes)=sigfig(eh,7,-1)
            nodes=nodes+1
            enode(nodes)=sigfig(eh,7,+1)
            if (lru.eq.2) then
               if (eh.lt.eresm) eresm=eh
               if (nunr.ge.maxunr) call error('rdfil2',&
                 &'storage in eunr exceeded.',' ')
               nunr=nunr+1
               eunr(nunr)=sigfig(eh,7,-1)
               nunr=nunr+1
               eunr(nunr)=sigfig(eh,7,+1)
            endif
         endif

         !--check for energy-dependent scattering radius
         !--or energy-dependent fission widths
         nro=n1h
         if (lru.eq.1) then
            res(jnow+4)=nro
         else
            res(jnow+4)=lfw
         endif
         ! get scattering radius flag
         naps=n2h
         res(jnow+5)=naps
         ! test formalism
         mode=lrf+10*(lru-1)
         if (lru.eq.0) mode=0
         if (lru.eq.2) lrp=3
         ! store isotope-section table data
         nsect=nsect+1
         isot(nsect)=i
         abnt(nsect)=abn
         elt(nsect)=el
         eht(nsect)=eh
         modet(nsect)=mode
         ! ibaset stores location of isotope card
         ibaset(nsect)=jnow
         jnow=jnow+nw
         if (jnow.gt.maxres) call error('rdfil2',&
           'res storage exceeded',' ')

         !--process the rest of this part
         !--according to its formalism
         intunr=5
         if (mode.le.3.and.nmtres.eq.0) then
            call rdf2bw(nin,jnow,lrf,nro,naps,mode)
         else if (mode.le.3.and.nmtres.gt.0) then
            call rdsammy(nin,j,jnow,nro,naps,mode,el,eh,&
              enode,nodes,nodmax,spin,ascat,res,maxres)
            call ppsammy(j,ncoef,nresp)
         else if (mode.eq.4) then
            call rdf2aa(nin,jnow,mode)
         else if (mode.eq.6) then
            call rdf2hy(nin,jnow)
         else if (mode.eq.7.and.nmtres.gt.0) then
            call rdsammy(nin,j,jnow,nro,naps,mode,el,eh,&
              enode,nodes,nodmax,spin,ascat,res,maxres)
            call ppsammy(j,ncoef,nresp)
         else if (mode.eq.11.and.lfw.eq.0) then
            call rdf2u0(nin,jnow,nro)
         else if (mode.eq.11.and.lfw.eq.1) then
            call rdf2u1(nin,jnow,nro)
         else if (mode.eq.12) then
            call rdf2u2(nin,jnow,nro,intunr)
         else
            call error('rdfil2','illegal resonance mode',' ')
         endif

         !--add .0253 ev to the list of nodes
         if (el.lt.therm) then
            nodes=nodes+1
            enode(nodes)=therm
         endif

      !--continue loop over energy ranges
      enddo

   !--continue loop over isotopes
   enddo
   if (eresr.lt.eresl) eresr=eresl
   if (eresr.gt.eresh) eresr=eresh

   !--finish off file and sort nodes into order.
   call tofend(nin,0,0,res(jnow))
   nrtot=jnow
   call order(enode,nodes)
   if (nunr.eq.0) return

   !--sort unresolved nodes into order.
   !--mark resolved-unresolved overlaps.
   call order(eunr,nunr)
   j=0
   el=0
   do i=1,nunr
      e=eunr(i)
      if (e.gt.(1-eps)*eresu.and.e.lt.(1+eps)*eresh&
        .and.e.ge.el) then
         j=j+1
         if (e.lt.eresr) e=-e
         eunr(j)=e
         el=sigfig(abs(e),7,+1)
      endif
   enddo
   nunr=j
   if (eresu.lt.eresr) then
      write(nsyso,'(/&
        &'' mat has resolved-unresolved overlap in range''/&
        &5x,1p,2e12.3)') eresu,eresr
   endif
   if (eresm.lt.eresh) then
      write(nsyso,'(/&
        &'' mat has unresolved-smooth overlap in range''/&
        &5x,1p,2e12.3)') eresm,eresh
   endif
   return
   end subroutine rdfil2

   subroutine rdf2bw(nin,jnow,lrf,nro,naps,mode)
   !-------------------------------------------------------------------
   ! Read in resonance data for single-level Breit-Wigner,
   ! multi-level Breit-Wigner, and Reich-Moore formats.
   !-------------------------------------------------------------------
   use util    ! provides error,mess
   use endf    ! provides endf routines and variables
   use physics ! provides amassn,amu,hbar,ev
   ! externals
   integer::nin,jnow,lrf,nro,naps,mode
   ! internals
   integer::nb,nw,nls,lad,nrs,ncyc,ll,lp,n,jj,l,ndig
   real(kr)::cwaven,awri,ascatl,arat,aw,ra,ral,qx
   real(kr)::hw,ehalf,rho,rhoc,ser,per,sec,pec
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::gxmin=1.0e-5_kr
   real(kr),parameter::zero=0
   character::strng*60
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--check for energy-dependent scattering radius
   if (nro.ne.0) then
      if (mode.ne.2) call error('rdf2bw',&
        &'energy-dep scattering length',&
        &'only works for mlbw')
      call tab1io(nin,0,0,res(jnow),nb,nw)
      jnow=jnow+nw
      if (jnow.gt.maxres) then
         call error('rdfil2','res storage exceeded',' ')
      endif
   endif

   !--read some parameters
   call contio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   if (jnow.gt.maxres) call error('rdf2bw','res storage exceeded',' ')
   nls=n1h
   lad=0
   if (mode.eq.3) lad=l1h
   if (lad.ne.0) call mess('rdf2bw',&
     &'calculation of angular distribution not installed.',' ')
   lssf=0
   spin=c1h
   ascat=c2h

   !--do loop over all l states
   do l=1,nls
      call listio(nin,0,0,res(jnow),nb,nw)
      awri=res(jnow)
      ascatl=ascat
      if (lrf.eq.3) ascatl=res(jnow+1)
      if (ascatl.eq.zero) ascatl=ascat
      arat=awri/(awri+1)
      aw=amassn*awri
      ra=rc1*aw**third+rc2
      ral=ra
      if (naps.eq.1) then
         ral=ascatl
         ra=ascat
      endif
      jj=jnow+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,res(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.maxres) call error('rdf2bw',&
           'res storage exceeded',' ')
      enddo
      ll=nint(res(jnow+2))
      nrs=nint(res(jnow+5))
      ! some files are malformed and have a list record for l values without
      ! resonances, issue a warning and move to the next l value
      if (nrs.eq.0) then
         write(strng,'(''nrs=0 for SLBW/MLBW and l='',i2)') ll
         call mess('rdf2bw',strng,'malformed ENDF file, check evaluation')
         jnow = jnow+6
         cycle
      end if
      ncyc=nint(res(jnow+4))/nrs
      qx=res(jnow+1)
      lrx=nint(res(jnow+3))
      if (lrx.ne.0) then
         nsig=5
      endif
      jnow=jnow+6

      !--loop over resonances in this sequence
      do n=1,nrs
         if (res(jnow).gt.el.and.res(jnow).le.eh) then
            if (nodes.ge.nodmax) call error('rdf2bw',&
              'storage in enode exceeded.',' ')
            nodes=nodes+1
            hw=res(jnow+2)/2
            if (mode.eq.3)&
              hw=hw+(res(jnow+3)+abs(res(jnow+4))+abs(res(jnow+5)))/2
            ndig=5
            if (res(jnow).gt.zero) ndig=2+nint(log10(res(jnow)/(hw/10)))
            if (ndig.lt.5) ndig=5
            if (ndig.gt.9) ndig=9
            enode(nodes)=sigfig(res(jnow),ndig,0)
            if ((res(jnow)+hw).lt.eh) then
               if (nodes.ge.nodmax) call error('rdf2bw',&
                 &'storage in enode exceeded.',' ')
               ehalf=res(jnow)+hw
               nodes=nodes+1
               enode(nodes)=sigfig(ehalf,ndig,0)
            endif
            if ((res(jnow)-hw).gt.el) then
               if (nodes.ge.nodmax) call error('rdf2bw',&
                 &'storage in enode exceeded.',' ')
               ehalf=res(jnow)-hw
               nodes=nodes+1
               enode(nodes)=sigfig(ehalf,ndig,0)
            endif
         endif
         rho=cwaven*arat*sqrt(abs(res(jnow)))*ral
         call facts(ll,rho,ser,per)
         res(jj)=ser
         res(jj+1)=per
         res(jj+2)=0
         res(jj+3)=0
         res(jj+4)=0
         res(jj+5)=0
         if (lrx.ne.0) then
            rhoc=cwaven*arat*sqrt(abs(res(jnow)+qx/arat))*ra
            lp=ll
            ! set competing l' value for a 2+ inelastic residual (u238)
              if (ll.eq.0) lp=2
              if (ll.eq.2) lp=0
            ! use ll to compute gx0
            call facts(lp,rhoc,sec,pec)
            res(jj+2)=res(jnow+2)-res(jnow+3)-res(jnow+4)-res(jnow+5)
            if (res(jj+2).lt.gxmin*res(jnow+2)) res(jj+2)=0
            if (res(jnow).lt.-qx/arat) res(jj+2)=0
            res(jj+3)=pec
         endif
         jj=jj+6
         if (jj.gt.maxres) call error('rdf2bw',&
           'res storage exceeded',' ')
         jnow=jnow+ncyc
      enddo
      jnow=jj
   enddo
   return
   end subroutine rdf2bw

   subroutine rdf2aa(nin,jnow,mode)
   !-------------------------------------------------------------------
   ! Read in resonance data for the Adler-Adler format.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variable
   use util ! provides error
   ! externals
   integer::nin,jnow,mode
   ! internals
   integer::nb,nw,nls,lssf,l,njs,n,nen,jen,nloc,ien,ndig
   real(kr)::ener,hw,ehalf
   real(kr),parameter::zero=0

   !--read some parameters
   call contio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   if (jnow.gt.maxres) call error('rdf2aa','res storage exceeded',' ')
   nls=n1h
   lssf=0
   spin=c1h
   ascat=c2h

   !--read adler-adler background corrections.
   call listio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   do while (nb.ne.0)
      if (jnow.gt.maxres) call error('rdf2aa',&
        'res storage exceeded',' ')
      call moreio(nin,0,0,res(jnow),nb,nw)
      jnow=jnow+nw
   enddo

   !--do loop over all l states
   do l=1,nls
      call contio(nin,0,0,res(jnow),nb,nw)
      jnow=jnow+nw
      if (jnow.gt.maxres) call error('rdf2aa',&
        &'res storage exceeded',' ')
      njs=n1h
      do n=1,njs
         call listio(nin,0,0,res(jnow),nb,nw)
         nen=n2h
         jen=12
         nloc=jnow-6
         jnow=jnow+nw
         do while (nb.ne.0)
            if (jnow.gt.maxres) call error('rdf2aa',&
              &'res storage exceeded',' ')
            call moreio(nin,0,0,res(jnow),nb,nw)
            jnow=jnow+nw
         enddo
         if (n.eq.1.and.l.eq.1) then
            do ien=1,nen
               ener=res(nloc+ien*jen)
               if (ener.gt.el.and.ener.le.eh) then
                  if (nodes.ge.nodmax) call error('rdf2aa',&
                    &'storage in enode exceeded.',' ')
                  nodes=nodes+1
                  hw=res(nloc+ien*jen+1)
                  ndig=5
                  if (ener.gt.zero) ndig=2+nint(log10(ener/(hw/10)))
                  if (ndig.lt.5) ndig=5
                  if (ndig.gt.9) ndig=9
                  enode(nodes)=sigfig(ener,ndig,0)
                  if ((ener+hw).le.eh) then
                     if (nodes.ge.nodmax) call error('rdf2aa',&
                       &'storage in enode exceeded.',' ')
                     ehalf=ener+hw
                     nodes=nodes+1
                     enode(nodes)=sigfig(ehalf,ndig,0)
                  endif
                  if (ener-hw.gt.el) then
                     if (nodes.ge.nodmax) call error('rdf2aa',&
                       &'storage in enode exceeded.',' ')
                     ehalf=ener-hw
                     nodes=nodes+1
                     enode(nodes)=sigfig(ehalf,ndig,0)
                  endif
               endif
            enddo
         endif
      enddo
   enddo
   return
   end subroutine rdf2aa

   subroutine rdf2hy(nin,jnow)
   !-------------------------------------------------------------------
   ! Read in resonance data for the hybrid R-matrix format.
   !-------------------------------------------------------------------
   use util ! provides error,mess
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,jnow
   ! internals
   integer::nb,nw,nls,lad,l,ns,nj,ir,ll,ig,ndig
   integer::nire,ncre,ncr,lil,nss,njs,lbk,lps,nlsj
   real(kr)::hw,ehalf,enow
   real(kr),parameter::zero=0

   !--read some parameters
   call contio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   if (jnow.gt.maxres) call error('rdf2hy','res storage exceeded',' ')
   nls=n1h
   lad=l1h
   if (lad.ne.0) call mess('rdf2hy',&
     &'calculation of angular distribution not installed.',' ')
   lssf=0
   spin=c1h
   ascat=c2h

   !--read additional hybrid-r parameters
   call contio(nin,0,0,res(jnow),nb,nw)
   nire=n1h
   ncre=n2h
   if (nire+ncre.gt.0) call mess('rdf2hy',&
     &'hybrid competing reactions not yet added to file 3.',' ')
   jnow=jnow+nw
   call contio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   call listio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   if (ncre.ne.0) then
      do ncr=1,ncre
         do lil=1,4
            call tab1io(nin,0,0,res(jnow),nb,nw)
            jnow=jnow+nw
         enddo
      enddo
   endif
   if (nls.eq.0) return

   !--do loop over all l states
   do l=1,nls
      call contio(nin,0,0,res(jnow),nb,nw)
      nss=n1h
      jnow=jnow+nw
      do ns=1,nss
         call contio(nin,0,0,res(jnow),nb,nw)
         njs=n1h
         jnow=jnow+nw
         do nj=1,njs
            call listio(nin,0,0,res(jnow),nb,nw)
            lbk=l1h
            lps=l2h
            nlsj=n2h
            ll=jnow+6
            do ir=1,nlsj
               hw=0
               do ig=1,7
                  hw=hw+res(ll+ig)
               enddo
               hw=hw/2
               enow=res(ll)
               ndig=5
               if (enow.gt.zero) ndig=2+nint(log10(enow/(hw/10)))
               if (ndig.lt.5) ndig=5
               if (ndig.gt.9) ndig=9
               if (nodes+3.ge.nodmax) call error('rdf2hy',&
                 &'storage in enode exceeded.',' ')
               if (enow.gt.el.and.enow.le.eh) then
                  nodes=nodes+1
                  enode(nodes)=sigfig(enow,ndig,0)
                  if (enow-hw.gt.el) then
                     ehalf=enow-hw
                     nodes=nodes+1
                     enode(nodes)=sigfig(ehalf,ndig,0)
                  endif
                  if (enow+hw.lt.eh) then
                     ehalf=enow+hw
                     nodes=nodes+1
                     enode(nodes)=sigfig(ehalf,ndig,0)
                  endif
               endif
               ll=ll+12
            enddo
            jnow=jnow+nw
            if (lbk.ne.0) then
               call tab1io(nin,0,0,res(jnow),nb,nw)
               jnow=jnow+nw
               call tab1io(nin,0,0,res(jnow),nb,nw)
               jnow=jnow+nw
            endif
            if (lps.ne.0) then
               call tab1io(nin,0,0,res(jnow),nb,nw)
               jnow=jnow+nw
               call tab1io(nin,0,0,res(jnow),nb,nw)
               jnow=jnow+nw
            endif
         enddo
      enddo
   enddo
   return
   end subroutine rdf2hy

   subroutine rdf2u0(nin,jnow,nro)
   !-------------------------------------------------------------------
   ! Read in resonance data for the energy-independent
   ! unresolved format (mode=11, lfw=0).
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::nin,jnow,nro
   ! internals
   integer::nb,nw,nls,l,jj,ii
   real(kr)::ener,enut
   integer,parameter::ngridu=78
   real(kr),dimension(78)::egridu=(/&
     1.0e1_kr,1.25e1_kr,1.5e1_kr,1.7e1_kr,2.0e1_kr,2.5e1_kr,3.0e1_kr,&
     3.5e1_kr,4.0e1_kr,5.0e1_kr,6.0e1_kr,7.2e1_kr,8.5e1_kr,1.0e2_kr,&
     1.25e2_kr,1.5e2_kr,1.7e2_kr,2.0e2_kr,2.5e2_kr,3.0e2_kr,3.5e2_kr,&
     4.0e2_kr,5.0e2_kr,6.0e2_kr,7.2e2_kr,8.5e2_kr,1.0e3_kr,1.25e3_kr,&
     1.5e3_kr,1.7e3_kr,2.0e3_kr,2.5e3_kr,3.0e3_kr,3.5e3_kr,4.0e3_kr,&
     5.0e3_kr,6.0e3_kr,7.2e3_kr,8.5e3_kr,1.0e4_kr,1.25e4_kr,1.5e4_kr,&
     1.7e4_kr,2.0e4_kr,2.5e4_kr,3.0e4_kr,3.5e4_kr,4.0e4_kr,5.0e4_kr,&
     6.0e4_kr,7.2e4_kr,8.5e4_kr,1.0e5_kr,1.25e5_kr,1.5e5_kr,1.7e5_kr,&
     2.0e5_kr,2.5e5_kr,3.0e5_kr,3.5e5_kr,4.0e5_kr,5.0e5_kr,6.0e5_kr,&
     7.2e5_kr,8.5e5_kr,1.e6_kr,1.25e6_kr,1.5e6_kr,1.7e6_kr,2.0e6_kr,&
     2.5e6_kr,3.0e6_kr,3.5e6_kr,4.0e6_kr,5.0e6_kr,6.0e6_kr,7.2e6_kr,&
     8.5e6_kr/)

   !--read some parameters
   if (nro.eq.1) then
      call tab1io(nin,0,0,res(jnow),nb,nw)
      res(jnow+1)=-float(nro)
      jj=jnow+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,res(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.maxres) then
            call error('rdf2u0','storage in res exceeded',' ')
         endif
      enddo
      jnow=jj
   endif
   call contio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   if (jnow.gt.maxres) call error('rdf2u0','res storage exceeded',' ')
   nls=n1h
   lssf=l1h
   spin=c1h
   ascat=c2h

   !--do loop over all l states
   do l=1,nls
      call listio(nin,0,0,res(jnow),nb,nw)
      jj=jnow+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,res(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.maxres) call error('rdf2u0',&
           &'res storage exceeded',' ')
      enddo
      jnow=jj

      !--add extra unresolved nodes
      ener=el
      do while (ener.lt.eh)
         enut=0
         ii=0
         do while (ii.le.ngridu.and.enut.lt.ener+ener/100)
            ii=ii+1
            enut=egridu(ii)
         enddo
         ener=enut
         if (ener.lt.eh) then
            if (nodes.ge.nodmax)&
              call error('rdf2u0','storage in enode exceeded.',' ')
            nodes=nodes+1
            enode(nodes)=sigfig(ener,7,0)
            if (nunr.ge.maxunr)&
              call error('rdf2u0','storage in eunr exceeded.',' ')
            nunr=nunr+1
            eunr(nunr)=sigfig(ener,7,0)
         endif
      enddo
   enddo
   return
   end subroutine rdf2u0

   subroutine rdf2u1(nin,jnow,nro)
   !-------------------------------------------------------------------
   ! Read in resonance data for the energy-independent
   ! unresolved format with energy-dependent fission widths
   ! (mode=11, lfw=1).
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::nin,jnow,nro
   ! internals
   integer::nb,nw,nloc,ifill,ii,l,njs,ne,nls,n,jj
   real(kr)::enut,ener,enex
   integer,parameter::ngridu=78
   real(kr),dimension(78)::egridu=(/&
     1.0e1_kr,1.25e1_kr,1.5e1_kr,1.7e1_kr,2.0e1_kr,2.5e1_kr,3.0e1_kr,&
     3.5e1_kr,4.0e1_kr,5.0e1_kr,6.0e1_kr,7.2e1_kr,8.5e1_kr,1.0e2_kr,&
     1.25e2_kr,1.5e2_kr,1.7e2_kr,2.0e2_kr,2.5e2_kr,3.0e2_kr,3.5e2_kr,&
     4.0e2_kr,5.0e2_kr,6.0e2_kr,7.2e2_kr,8.5e2_kr,1.0e3_kr,1.25e3_kr,&
     1.5e3_kr,1.7e3_kr,2.0e3_kr,2.5e3_kr,3.0e3_kr,3.5e3_kr,4.0e3_kr,&
     5.0e3_kr,6.0e3_kr,7.2e3_kr,8.5e3_kr,1.0e4_kr,1.25e4_kr,1.5e4_kr,&
     1.7e4_kr,2.0e4_kr,2.5e4_kr,3.0e4_kr,3.5e4_kr,4.0e4_kr,5.0e4_kr,&
     6.0e4_kr,7.2e4_kr,8.5e4_kr,1.0e5_kr,1.25e5_kr,1.5e5_kr,1.7e5_kr,&
     2.0e5_kr,2.5e5_kr,3.0e5_kr,3.5e5_kr,4.0e5_kr,5.0e5_kr,6.0e5_kr,&
     7.2e5_kr,8.5e5_kr,1.e6_kr,1.25e6_kr,1.5e6_kr,1.7e6_kr,2.0e6_kr,&
     2.5e6_kr,3.0e6_kr,3.5e6_kr,4.0e6_kr,5.0e6_kr,6.0e6_kr,7.2e6_kr,&
     8.5e6_kr/)
   real(kr),parameter::wide=1.26e0_kr

   !--read some parameters
   if (nro.eq.1) then
      call tab1io(nin,0,0,res(jnow),nb,nw)
      res(jnow+1)=-float(nro)
      jj=jnow+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,res(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.maxres) then
            call error('rdf2u1','storage in res exceeded',' ')
         endif
      enddo
      jnow=jj
   endif
   call listio(nin,0,0,res(jnow),nb,nw)
   nloc=jnow+5
   jnow=jnow+nw
   if (jnow.gt.maxres) call error('rdf2u1','res storage exceeded',' ')
   do while (nb.ne.0)
      call moreio(nin,0,0,res(jnow),nb,nw)
   enddo
   lssf=l1h
   ne=n1h
   nls=n2h
   spin=c1h
   ascat=c2h

   !--read in the energy-dependent fission widths
   do n=1,ne
      ener=res(nloc+n)
      if (ener.ge.el.and.ener.lt.eh) then
         enex=res(nloc+n+1)
         ifill=0
         if (enex.gt.wide*ener) ifill=1
         if (nodes.ge.nodmax)&
           &call error('rdf2u1','storage in enode exceeded.',' ')
         nodes=nodes+1
         enode(nodes)=sigfig(ener,7,0)
         if (nunr.ge.maxunr)&
           &call error('rdf2u1','storage in eunr exceeded.',' ')
         nunr=nunr+1
         eunr(nunr)=sigfig(ener,7,0)
         do while (ifill.ne.0)
            enut=0
            ii=0
            do while (ii.lt.ngridu.and.enut.lt.ener+ener/100)
               ii=ii+1
               enut=egridu(ii)
            enddo
            ener=enut
            if (ener.ge.enex) ifill=0
            if (ifill.eq.1) then
               if (nodes.ge.nodmax) call error('rdf2u1',&
                 &'storage in enode exceeded.',' ')
               nodes=nodes+1
               enode(nodes)=sigfig(ener,7,0)
               if (nunr.ge.maxunr) call error('rdf2u1',&
                 &'storage in eunr exceeded.',' ')
               nunr=nunr+1
                  eunr(nunr)=sigfig(ener,7,0)
            endif
         enddo
      endif
   enddo

   !--do loop over all l states
   do l=1,nls
      call contio(nin,0,0,res(jnow),nb,nw)
      jnow=jnow+nw
      if (jnow.gt.maxres) call error('rdf2u1',&
        &'res storage exceeded',' ')
      njs=n1h
      do n=1,njs
         call listio(nin,0,0,res(jnow),nb,nw)
         nloc=jnow+6
         jnow=jnow+nw
         do while (nb.ne.0)
            if (jnow.gt.maxres) call error('rdf2u1',&
              'res storage exceeded',' ')
            call moreio(nin,0,0,res(jnow),nb,nw)
            jnow=jnow+nw
         enddo
      enddo
   enddo
   return
   end subroutine rdf2u1

   subroutine rdf2u2(nin,jnow,nro,intunr)
   !-------------------------------------------------------------------
   ! Read in resonance data for the energy-dependent
   ! unresolved format (mode=12).
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::nin,jnow,nro,intunr
   ! internals
   integer::nb,nw,nls,l,njs,n,nen,jen,nloc,ien,ifill,ii,jj
   real(kr)::ener,enex,enut
   integer,parameter::ngridu=78
   real(kr),dimension(78)::egridu=(/&
     1.0e1_kr,1.25e1_kr,1.5e1_kr,1.7e1_kr,2.0e1_kr,2.5e1_kr,3.0e1_kr,&
     3.5e1_kr,4.0e1_kr,5.0e1_kr,6.0e1_kr,7.2e1_kr,8.5e1_kr,1.0e2_kr,&
     1.25e2_kr,1.5e2_kr,1.7e2_kr,2.0e2_kr,2.5e2_kr,3.0e2_kr,3.5e2_kr,&
     4.0e2_kr,5.0e2_kr,6.0e2_kr,7.2e2_kr,8.5e2_kr,1.0e3_kr,1.25e3_kr,&
     1.5e3_kr,1.7e3_kr,2.0e3_kr,2.5e3_kr,3.0e3_kr,3.5e3_kr,4.0e3_kr,&
     5.0e3_kr,6.0e3_kr,7.2e3_kr,8.5e3_kr,1.0e4_kr,1.25e4_kr,1.5e4_kr,&
     1.7e4_kr,2.0e4_kr,2.5e4_kr,3.0e4_kr,3.5e4_kr,4.0e4_kr,5.0e4_kr,&
     6.0e4_kr,7.2e4_kr,8.5e4_kr,1.0e5_kr,1.25e5_kr,1.5e5_kr,1.7e5_kr,&
     2.0e5_kr,2.5e5_kr,3.0e5_kr,3.5e5_kr,4.0e5_kr,5.0e5_kr,6.0e5_kr,&
     7.2e5_kr,8.5e5_kr,1.e6_kr,1.25e6_kr,1.5e6_kr,1.7e6_kr,2.0e6_kr,&
     2.5e6_kr,3.0e6_kr,3.5e6_kr,4.0e6_kr,5.0e6_kr,6.0e6_kr,7.2e6_kr,&
     8.5e6_kr/)
   real(kr),parameter::wide=1.26e0_kr

   !--read some parameters
   if (nro.eq.1) then
      call tab1io(nin,0,0,res(jnow),nb,nw)
      res(jnow+1)=-float(nro)
      jj=jnow+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,res(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.maxres) then
            call error('rdf2u2','storage in res exceeded',' ')
         endif
      enddo
      jnow=jj
   endif
   call contio(nin,0,0,res(jnow),nb,nw)
   jnow=jnow+nw
   if (jnow.gt.maxres) call error('rdf2u2','res storage exceeded',' ')
   nls=n1h
   lssf=l1h
   spin=c1h
   ascat=c2h

   !--do loop over all l states
   do l=1,nls
      call contio(nin,0,0,res(jnow),nb,nw)
      jnow=jnow+nw
      if (jnow.gt.maxres) call error('rdf2u2',&
        &'res storage exceeded',' ')
      njs=n1h
      do n=1,njs
         call listio(nin,0,0,res(jnow),nb,nw)
         intunr=l1h
         nen=n2h
         jen=6
         nloc=jnow+6
         jnow=jnow+nw
         do while (nb.ne.0)
            if (jnow.gt.maxres) call error('rdf2u2',&
              &'res storage exceeded',' ')
            call moreio(nin,0,0,res(jnow),nb,nw)
            jnow=jnow+nw
         enddo
         if (n.eq.1.and.l.eq.1) then
            do ien=1,nen
               ener=res(nloc+(ien-1)*jen)
               if (ener.ge.el.and.ener.lt.eh) then
                  enex=res(nloc+(ien-1)*jen+jen)
                  ifill=0
                  if (enex.gt.wide*ener) ifill=1
                  if (nodes.ge.nodmax) call error('rdf2u2',&
                    &'storage in enode exceeded.',' ')
                  nodes=nodes+1
                  enode(nodes)=sigfig(ener,7,0)
                  if (nunr.ge.maxunr) call error('rdf2u2',&
                    &'storage in eunr exceeded.',' ')
                  nunr=nunr+1
                  eunr(nunr)=sigfig(ener,7,0)
                  do while (ifill.ne.0)
                     enut=0
                     ii=0
                     do while (ii.lt.ngridu.and.&
                       &enut.lt.ener+ener/1000)
                        ii=ii+1
                        enut=egridu(ii)
                     enddo
                     ener=enut
                     if (ener.ge.enex) ifill=0
                     if (ifill.eq.1) then
                        if (nodes.ge.nodmax) call error('rdf2u2',&
                          &'storage in enode exceeded.',' ')
                        nodes=nodes+1
                        enode(nodes)=sigfig(ener,7,0)
                        if (nunr.ge.maxunr) call error('rdf2u2',&
                          &'storage in eunr exceeded.',' ')
                        nunr=nunr+1
                        eunr(nunr)=sigfig(ener,7,0)
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
   enddo
   return
   end subroutine rdf2u2

   subroutine order(x,n)
   !-------------------------------------------------------------------
   ! Sort the n elements of x into ascending order
   ! removing any duplicate elements
   !-------------------------------------------------------------------
   ! externals
   integer::n
   real(kr)::x(*)
   ! internals
   integer::m,i,j,k
   real(kr)::tsave
   real(kr),parameter::small=1.e-10_kr

   if (n.le.2) return
   m=n
   i=0
   do while (i.lt.m-1)
      i=i+1
      j=i
      do while (j.lt.m)
         j=j+1
         if (x(j).lt.x(i)) then
            tsave=x(j)
            x(j)=x(i)
            x(i)=tsave
         endif
      enddo
      if (i.gt.1) then
         if (abs(x(i)-x(i-1)).le.small*x(i)) then
            m=m-1
            if (i.ge.m) then
               n=m
               return
            endif
            do k=i,m
               x(k)=x(k+1)
            enddo
            i=i-1
         endif
      endif
   enddo
   if (abs(x(m)-x(m-1)).le.small*x(m)) m=m-1
   n=m
   return
   end subroutine order

   subroutine facts (l,rho,se,pe)
   !-------------------------------------------------------------------
   ! Calculates penetration and shift factors
   !-------------------------------------------------------------------
   ! externals
   integer::l
   real(kr)::rho,se,pe
   ! internals
   real(kr)::den,r2,r4,r6,r8

   r2=rho*rho
   if (l.eq.0) then
      se=0
      pe=rho
   else if (l.eq.1) then
      den=1+r2
      pe=r2*rho/den
      se=-1/den
   else if (l.eq.2) then
      r4=r2*r2
      den=3*r2+r4+9
      pe=r4*rho/den
      se=-(18+3*r2)/den
   else if (l.eq.3) then
      r4=r2*r2
      r6=r4*r2
      den=225+45*r2+6*r4+r6
      pe=r6*rho/den
      se=-(675+90*r2+6*r4)/den
   else if (l.eq.4) then
      r4=r2*r2
      r6=r4*r2
      r8=r4*r4
      den=11025+1575*r2+135*r4+10*r6+r8
      pe=r8*rho/den
      se=-(44100+4725*r2+270*r4+10*r6)/den
   endif
   return
   end subroutine facts

   subroutine genunr(nin,intunr)
   !-------------------------------------------------------------------
   ! Compute infinitely dilute cross sections on the unresolved energy
   ! grid for later retrieval with sigunr.  The table is prepared in
   ! the format of MF2/MT152.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides sigfig
   ! externals
   integer::nin,intunr
   !internals
   real(kr)::sigu(4)
   integer::nb,nw,l,i,j,k,ix,idis,mode,mt1
   real(kr)::e,enext,abn,bkg
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::zero=0

   !--reserve space for unresolved table
   nw=6*nunr+13
   allocate(sunr(nw))

   !--store cont and list constants
   sunr(1)=za
   sunr(2)=awr
   sunr(3)=lssf
   sunr(4)=0
   sunr(5)=0
   sunr(6)=intunr
   sunr(7)=tempr
   sunr(8)=0
   sunr(9)=5
   sunr(10)=1
   sunr(11)=1+6*nunr
   sunr(12)=nunr
   sunr(13)=big

   !--compute and store unresolved part of cross sections
   e=0
   call csunr1(e,sigu)
   call csunr2(e,sigu)
   l=14
   do i=1,nunr
      e=eunr(i)
      sunr(l)=e
      e=abs(e)
      do k=1,4
         sunr(l+k)=0
      enddo
      do j=1,nsect
         mode=modet(j)
         if (mode.ge.11.and.e.ge.elt(j).and.e.lt.eht(j)) then
            abn=abnt(j)
            isect=j
            if (mode.eq.11) call csunr1(e,sigu)
            if (mode.eq.12) call csunr2(e,sigu)
            do k=1,4
               sunr(l+k)=sunr(l+k)+abn*sigu(k)
               sunr(l+k)=sigfig(sunr(l+k),7,0)
            enddo
         endif
      enddo
      sunr(l+5)=sunr(l+1)
      l=l+6
   enddo
   if (lssf.ne.0) return

   !--add on unresolved background from mf3 on endf tape
   !--any mf3 background in a range of resolved-unresolved
   !--overlap is omitted.
   allocate(scr(npage+50))
   mt1=0
   call findf(mata,3,0,nin)
   mfh=3
   do while (mfh.ne.0)
      call contio(nin,0,0,scr,nb,nw)
      if (mfh.ne.0) then
         if (mt1.eq.0) mt1=mth
         ix=0
         if (mth.eq.1) ix=1
         if (mth.eq.2) ix=2
         if (mth.eq.18) ix=3
         if (mth.eq.102) ix=4
         if (ix.ne.0) then
            e=0
            call gety1(e,enext,idis,bkg,nin,scr)
            l=14
            do i=1,nunr
               e=sunr(l)
               if (e.ge.zero) then
                  call gety1(e,enext,idis,bkg,nin,scr)
                  sunr(l+ix)=sunr(l+ix)+bkg
                  sunr(l+ix)=sigfig(sunr(l+ix),7,0)
                  if (ix.eq.1) then
                     sunr(l+5)=sunr(l+5)+bkg
                     sunr(l+5)=sigfig(sunr(l+5),7,0)
                  endif
               endif
               l=l+6
            enddo
         endif
         call tosend(nin,0,0,scr)
      endif
   enddo
   call findf(mata,3,mt1,nin)
   deallocate(scr)
   return
   end subroutine genunr

   subroutine sigunr(e,sigu)
   !-------------------------------------------------------------------
   ! Retrieve infinitely dilute unresolved cross sections
   ! from table produced by genunr.
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   real(kr)::e,sigu(4)
   ! internals
   integer::intunr,l,l1,l2,i
   real(kr)::en,e1,e2

   intunr=nint(sunr(6))
   l=14
   en=0
   i=1
   do while (i.lt.nunr.and.e.ge.en)
      i=i+1
      l2=l+6*(i-1)
      en=abs(sunr(l2))
   enddo
   l1=l2-6
   e1=abs(sunr(l1))
   e2=abs(sunr(l2))
   do i=1,4
      if (e.ge.e1.and.e.le.e2) then
         call terp1(e1,sunr(l1+i),e2,sunr(l2+i),e,sigu(i),intunr)
      else
         sigu(i)=0
      endif
   enddo
   return
   end subroutine sigunr

   subroutine lunion(nin,nout,ngrid,ngr)
   !-------------------------------------------------------------------
   ! Copy desired reactions from MF3 and MF13 on nin to nout.
   ! Check each reaction against the energy grid and add any points
   ! needed to unionize and linearize all desired reactions to
   ! the given tolerance.  Remove singularities by moving first
   ! point down and second point up in last sig fig.
   !-------------------------------------------------------------------
   use util   ! provides openz,repoz,error,timer
   use endf   ! provides endf routines and variables
   use mainio ! provides nsyso
   ! externals
   integer::nin,nout,ngrid,ngr
   ! internals
   integer::ndim,iold,inew,i,j,mfl,nb,nw,nss,iss
   integer::l,lsave,in,ig,ir,jr,lr,ibase,nbta,inta,intn
   integer::ipwr,inx,ngn,isave,ngneg,jg,igt,ngpos,npr,nmf12
   character(40)::text
   real(kr)::stpmax,awrx,eg,qx,thrx,thrxx,et
   real(kr)::er,sr,ernext,srnext,enl,test,snl,erl,srl
   real(kr)::en,sn,xm,ym,yl,errn,ent,egl,time
   real(kr)::aa(1)
   real(kr),dimension(:),allocatable::bufn,bufo
   real(kr),dimension(:),allocatable::x,y
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::elow=1.e-5_kr
   real(kr)::elim=.99e6_kr
   real(kr),parameter::up=1.001e0_kr
   real(kr),parameter::dn=0.999e0_kr
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::small=1.e-9_kr
   real(kr),parameter::ten=10.e0_kr
   real(kr),parameter::ssmall=1.e-30_kr
   real(kr),parameter::stpmin=1.001e0_kr
   real(kr),parameter::ovfact=5.3e0_kr
   real(kr),parameter::trange=.4999e0_kr
   real(kr),parameter::emax=19.e6_kr
   real(kr),parameter::zero=0

   !--initialize.
   if (eresr.lt.elim) elim=eresr
   ndim=50
   nmf12=0
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))
   allocate(x(ndim))
   allocate(y(ndim))
   allocate(scr(npage+50))

   ! this value fits 1/v to within err
   stpmax=1+sqrt(ovfact*err)

   !--copy nodes from the global area to *old* tape
   iold=14
   inew=15
   call openz(-iold,1)
   call openz(-inew,1)
   call repoz(-iold)
   call repoz(-inew)
   if (nodes.gt.0) then
      do i=1,nodes
         j=i
         if (i.eq.nodes) j=-i
         aa(1)=enode(i)
         call loada(j,aa,1,iold,bufo,nbuf)
      enddo
   endif
   ngo=nodes

   !--find next reaction to be processed
   !--last card read from nin was fend card
   call repoz(nout)
   nsh=0
   mfl=0
  110 continue
   call contio(nin,0,0,scr,nb,nw)
   nss=1
   if (mfh.eq.10) nss=n1h
   iss=nss
   if (math.gt.0) go to 120
   call amend(nout,0)
   call atend(nout,0)
   go to 410
  120 continue
   if (mfh.gt.0) go to 130
   ! always add a fend record for MF3, MF10, MF13 and MF23
   if (mfl.eq.3.or.mfl.eq.10.or.mfl.eq.13.or.mfl.eq.23) then
     call afend(nout,0)
   endif
   ! only add a fend record for MF12 if we have written sections to nout
   if (mfl.eq.12.and.nmf12.ne.0) then
     call afend(nout,0)
   endif
   mfl=0
   go to 110
   ! process mf3, mf10, mf12, mf13 and mf23 only.
  130 continue
   if (mfh.eq.3.or.mfh.eq.10.or.mfh.eq.12.or.mfh.eq.13.or.mfh.eq.23) go to 140
   call tofend(nin,0,0,scr)
   go to 110
   ! skip redundant reactions and non-cross-sections in n files
   ! remove discrete photon records from file 13.
  140 continue
   mfl=mfh
   if (mth.eq.501) go to 150
   if (mth.eq.522.and.mtr522.gt.0) go to 150
   if (mth.eq.460) go to 150
   if (mfh.eq.12.and.nint(scr(3)).ne.1) go to 150
   if (mfh.eq.12) scr(5)=1
   if (mfh.eq.13) scr(5)=1
   if (mfh.ne.3) go to 180
   if (mth.eq.1.or.mth.eq.3) go to 150
   if (mth.eq.4.and.mtr4.gt.0) go to 150
   if (mth.eq.103.and.mt103.gt.0) go to 150
   if (mth.eq.104.and.mt104.gt.0) go to 150
   if (mth.eq.105.and.mt105.gt.0) go to 150
   if (mth.eq.106.and.mt106.gt.0) go to 150
   if (mth.eq.107.and.mt107.gt.0) go to 150
   if (mth.eq.101) go to 150
   if (mth.eq.120) go to 150
   if (mth.eq.151) go to 150
   if ((mth.ge.251.and.mth.le.300).and.mth.ne.261) go to 150
   if (mth.eq.18.and.mtr18.gt.0) go to 150
   if (iverf.lt.6) then
      if (mth.ge.451.and.mth.lt.700) go to 150
      if (mth.ge.800) go to 150
   else
      if (mth.ge.451.and.mth.lt.600) go to 150
      if (mth.gt.850.and.mth.le.870) go to 150
      if (mth.gt.891) go to 150
   endif
   go to 180
  150 continue
   call tosend(nin,0,0,scr)
   go to 110

   !--process this reaction
  180 continue
   if (mfh.eq.12) nmf12=nmf12+1
   call contio(0,nout,0,scr,nb,nw)
   if (mfh.ne.23.and.awin.ne.zero) awrx=c2h/awin
  181 continue
   call tab1io(nin,0,0,scr,nb,nw)
   if (mfh.eq.23) go to 190
   qx=c2h
   if (mth.eq.19.and.mtr18.gt.0) q18=qx
   if (awin.ne.0) then
       thrx=-qx*(awrx+1)/awrx
   else
       thrx=-qx
   endif
   thr6=thrx
   if (thr6.lt.zero) thr6=0
   if (thrx.le.zero) go to 190
   thrxx=sigfig(thrx,7,+1)
   l=7+2*nint(scr(5))
   if (scr(l+1).ne.zero) then
      write(text,'(''xsec nonzero at threshold for mt='',i3)') mth
      call mess('lunion',text,'adjusted using jump in xsec')
   endif
   if (scr(l).ge.thrxx) go to 190
   thrx=thrxx
   write(nsyso,'(/&
     &'' changed threshold from'',1p,e13.6,'' to'',e13.6,&
     &'' for mt'',i3,''.'')') scr(l),thrx,mth
   scr(l)=thrx
   lsave=l
   do while (scr(l+2).le.scr(l))
      if (l.gt.lsave+20) call error('lunion',&
         'ill-behaved threshold.',' ')
      scr(l+2)=sigfig(scr(l),7,+1)
      l=l+2
   enddo
  190 continue
   call tab1io(0,nout,0,scr,nb,nw)

   !--set up points for first panel
   in=0
   ig=1
   ir=0
   jr=1
   lr=0
   npr=nint(scr(6))
   ibase=6+2*nint(scr(5))
   nbta=1
  205 continue
   ir=ir+1
   if (lr+ir.gt.nbta) jr=jr+1
   nbta=nint(scr(5+2*jr))
   inta=nint(scr(6+2*jr))
   er=scr(ibase+ir*2-1)
   sr=scr(ibase+ir*2)
   eg=er
   if (mth.eq.2) go to 210
   if (mth.eq.18.or.mth.eq.19) go to 210
   if (mth.eq.102) go to 210
   ! check for pseudo threshold
   if ((ibase+2*ir).lt.nw.or.nb.eq.0) go to 207
   call moreio(nin,nout,0,scr(ibase+1),nb,nw)
   lr=lr+ir
   ir=0
   nw=ibase+nw
  207 continue
   ernext=scr(ibase+ir*2+1)
   srnext=scr(ibase+ir*2+2)
   if (sr.lt.ssmall.and.srnext.lt.ssmall.and.ir.lt.npr-1) go to 205
   ! check for initial discontinuity
   if (abs(er-ernext).gt.small*er) go to 210
   er=sigfig(er,7,0)
   ernext=sigfig(ernext,7,+1)
   scr(ibase+ir*2+1)=ernext
   210 if (ig.gt.ngo) go to 220
   call finda(ig,aa,1,iold,bufo,nbuf)
   eg=aa(1)
   if (abs(eg).ge.er*(1-small)) go to 220
   enl=eg
   in=in+1
   aa(1)=enl
   call loada(in,aa,1,inew,bufn,nbuf)
   ig=ig+1
   go to 210
  220 continue
   test=elow
   test=sigfig(test,7,+1)
   if (er.lt.test) go to 225
   if ((er-sigfig(abs(eg),7,-1)).gt.1.e-8_kr*er) go to 222
   if (sr.eq.zero) go to 225
   enl=sigfig(er,7,0)
   er=sigfig(er,7,+1)
   in=in+1
   aa(1)=enl
   call loada(in,aa,1,inew,bufn,nbuf)
   go to 225
  222 continue
   er=abs(eg)
  225 continue
   enl=er
   snl=sr
   erl=er
   srl=sr
   if (ig.lt.ngo.and.abs(eg).le.er*(1+small)) then
      ig=ig+1
      call finda(ig,aa,1,iold,bufo,nbuf)
      eg=aa(1)
   endif
   ir=ir+1
   er=scr(ibase+ir*2-1)
   sr=scr(ibase+ir*2)
   if (lr+ir.gt.nbta) then
      jr=jr+1
      nbta=nint(scr(5+2*jr))
      inta=nint(scr(6+2*jr))
   endif
   ! check ahead for discontinuity
   if (ir.lt.nbta) then
      ernext=scr(ibase+2*ir+1)
      srnext=scr(ibase+2*ir+2)
      if (abs(er-ernext).le.small*er) then
         er=sigfig(er,7,-1)
         ernext=sigfig(ernext,7,+1)
         scr(ibase+2*ir+1)=ernext
      endif
   endif
   et=0

   !--determine upper limit of this panel
  240 continue
   if (lr+ir.gt.n2h) go to 350
   if (ig.ge.ngo) go to 250
   if (abs(eg).ge.er*(1-small)) go to 250
   en=abs(eg)
   call terp1(abs(erl),srl,er,sr,en,sn,inta)
   if (eg.lt.zero) en=-en
   intn=inta
   ig=ig+1
   call finda(ig,aa,1,iold,bufo,nbuf)
   eg=aa(1)
   go to 300
   ! histogram interpolation
  250 continue
   if (inta.ne.1) go to 255
   if (lr+ir.ge.n2h) go to 255
   if (er.lt.(1+small)*enl) go to 255
   if (abs(et-enl).lt.small*et) go to 252
   en=er
   et=sigfig(en,7,-1)
   en=et
   sn=snl
   intn=inta
   erl=en
   srl=sr
   go to 300
  252 continue
   er=sigfig(er,7,+1)
   ! normal interpolation
  255 continue
   en=er
   sn=sr
   intn=inta
   erl=er
   srl=sr
   260 ir=ir+1
   if (lr+ir.gt.n2h) go to 280
   er=scr(ibase+ir*2-1)
   sr=scr(ibase+ir*2)
   if (lr+ir.gt.nbta) then
      jr=jr+1
      nbta=nint(scr(5+2*jr))
      inta=nint(scr(6+2*jr))
   endif
   if ((ibase+2*ir).ge.nw.and.nb.ne.0) then
      call moreio(nin,nout,0,scr(ibase+1),nb,nw)
      lr=lr+ir
      ir=0
      nw=ibase+nw
   endif
   ! check ahead for a discontinuity.
   if (lr+ir.ge.n2h) go to 280
   ernext=scr(ibase+2*ir+1)
   srnext=scr(ibase+2*ir+2)
   if (abs(ernext-er).gt.small*er) go to 280
   if (abs(srnext-sr).lt.small*sr) go to 260
   er=sigfig(er,7,-1)
   ernext=sigfig(ernext,7,+1)
   scr(ibase+2*ir+1)=ernext
  280 continue
   if (abs(eg).gt.erl*(1+small)) go to 300
   ig=ig+1
   if (ig.gt.ngo) go to 300
   call finda(ig,aa,1,iold,bufo,nbuf)
   eg=aa(1)
  300 continue
   if (abs(en).le.abs(enl)*(1+small)) go to 240

   !--check panel for linearity and add points if needed.
   i=2
   x(2)=abs(enl)
   y(2)=snl
   x(1)=abs(en)
   y(1)=sn
  310 continue
   if (x(i-1)/x(i).lt.stpmin) go to 325
   ! force the 1,2,5,10,... points and the .0253 ev
   ! thermal point to appear in the grid.
   if (x(i).gt.elim) go to 320
   do 312 ipwr=-4,5
      xm=ten**ipwr
      if (x(i-1).gt.up*xm.and.x(i).lt.dn*xm) go to 315
      xm=xm/2
      xm=sigfig(xm,1,0)
      if (x(i-1).gt.up*xm.and.x(i).lt.dn*xm) go to 315
      xm=4*xm/10
      xm=sigfig(xm,1,0)
      if (x(i-1).gt.up*xm.and.x(i).lt.dn*xm) go to 315
  312 continue
   xm=therm
   if (x(i-1).gt.up*xm.and.x(i).lt.dn*xm) go to 315
   go to 320
   315 call terp1(x(i),y(i),x(i-1),y(i-1),xm,ym,intn)
   go to 330
   320 if (intn.gt.2) go to 322
   ! linear interpolation.
   ! for energies less than elim, add points by dividing
   ! panels in half to make sure that a 1/v shape is represented
   ! to the desired accuracy.
   if (x(i).gt.elim) go to 325
   if (x(i-1)/x(i).le.stpmax) go to 325
   xm=(x(i-1)+x(i))/2
   xm=sigfig(xm,7,0)
   call terp1(x(i),y(i),x(i-1),y(i-1),xm,ym,2)
   go to 330
   ! nonlinear interpolation.
   ! add points by dividing panels in half to make sure that
   ! the cross section is represented to the desired accuracy.
   322 xm=(x(i-1)+x(i))/2
   xm=sigfig(xm,7,0)
   call terp1(x(i),y(i),x(i-1),y(i-1),xm,ym,intn)
   call terp1(x(i),y(i),x(i-1),y(i-1),xm,yl,2)
   errn=err
   if (x(i-1).lt.trange) errn=err/5
   test=errn*ym+ssmall
   if (abs(ym-yl).lt.test) go to 325
   go to 330
  325 continue
   in=in+1
   ent=-x(i)
   if (abs(abs(enl)-x(i)).lt.small*x(i)) ent=enl
   aa(1)=ent
   call loada(in,aa,1,inew,bufn,nbuf)
   i=i-1
   if (i.gt.1) go to 310
   enl=en
   snl=sn
   go to 240
  330 continue
   i=i+1
   if (i.le.ndim) go to 340
   call error('lunion','exceeded stack.',' ')
  340 continue
   x(i)=x(i-1)
   y(i)=y(i-1)
   x(i-1)=xm
   y(i-1)=ym
   go to 310
  350 continue
   in=in+1
   inx=-in
   aa(1)=en
   call loada(inx,aa,1,inew,bufn,nbuf)

   !--finished with this reaction
   ngn=in
   ngo=ngn
   isave=iold
   iold=inew
   inew=isave
   iss=iss-1
   if (iss.gt.0) go to 181

   !--write send record and find next reaction.
   call tosend(nin,0,0,scr)
   call asend(nout,0)
   go to 110

   !--linearization and unionization complete
  410 continue
   ngr=ngo
   ngneg=0
   jg=0
   egl=0
   do 420 ig=1,ngo
   call finda(ig,aa,1,iold,bufo,nbuf)
   eg=aa(1)
   if (abs(abs(eg)-egl).le.small*egl) go to 430
   if (eg.lt.zero) ngneg=ngneg+1
   eg=abs(eg)
   if (ig.eq.1.or.ig.eq.ngo) go to 415
   if (eg.gt.emax) go to 415
   if (abs(eg-eresl).le.small*eresl) go to 430
   if (abs(eg-eresr).le.small*eresr) go to 430
   if (abs(eg-eresu).le.small*eresu) go to 430
   if (abs(eg-eresm).le.small*eresm) go to 430
   if (abs(eg-eresh).le.small*eresh) go to 430
  415 continue
   egl=eg
   jg=jg+1
   igt=jg
   if (ig.eq.ngo) igt=-igt
   aa(1)=eg
   call loada(igt,aa,1,ngrid,bufn,nbuf)
   go to 420
  430 continue
   ngr=ngr-1
  420 continue
   ngo=ngr
   ngpos=ngo-ngneg
   call timer(time)
   write(nsyso,'(/&
     &'' number of user and resonance nodes           ='',i8,/&
     &'' points in initial unionized grid             ='',i8,/&
     &'' points added by linearization                ='',i8,14x,f8.1,''s'')')&
     nodes,ngpos,ngneg,time
   deallocate(y)
   deallocate(x)
   deallocate(bufn)
   deallocate(bufo)
   return
   end subroutine lunion

   subroutine resxs(ngrid,nout,nscr,nrtot)
   !-------------------------------------------------------------------
   ! Compute resonance cross sections on existing energy grid.
   ! Reconstruct the resonance cross sections between the grid
   ! points to the specified tolerance.  The final unionized
   ! energy grid is on nout with the resonance cross sections.
   !-------------------------------------------------------------------
   use util   ! provides error,timer,releas,closz,openz
   use mainio ! provides nsyso
   ! externals
   integer::ngrid,nout,nscr,nrtot
   ! internals
   integer::ngneg,nmax,iii,in,ig,i,j,k,l,inf,ip,ndig,no
   real(kr)::cint,cmax,eint,emax,fint,fmax
   real(kr)::elo,ehi,xxx,e,egl,eg
   real(kr)::xm,dx,c1,c2
   real(kr)::fr1,fr2,sl,dm1,dm2,dm3,errm,errn
   real(kr)::tsti,est,time
   real(kr)::dm(10)
   real(kr)::sig(nsig),sigl(nsig),res(1+nsig)
   real(kr)::sigd(10,10),resl(101)
   real(kr)::aa(1)
   real(kr),dimension(:),allocatable::bufr,bufg,bufl
   real(kr),dimension(:),allocatable::x,y
   real(kr),dimension(:,:),allocatable::sigs
   integer,parameter::ndim=30
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::estp=4.1e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::one=1,ten=10
   real(kr),parameter::trange=.4999e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::tenth=0.1e0_kr
   integer::nscrl=16

   !--if urr region only and lssf=1, set nrtot=0 & return
   if (lssf.eq.1.and.eresl.eq.eresu) then
      nrtot=0
      return
   endif

   !--initialize.
   call openz(-nscr,1)
   call openz(-nscrl,1)
   allocate(bufr(nbufr))
   allocate(bufg(nbufg))
   allocate(bufl(nbufl))
   allocate(x(ndim))
   allocate(y(ndim))
   allocate(sigs(nsig-1,ndim))
   ngneg=0
   nmax=0
   cmax=0
   cint=0
   eint=0
   emax=0
   fint=0
   fmax=0
   do i=1,nsig+1
      res(i)=0
   enddo
   elo=eresl
   iii=int(log10(elo*(1+small))+small)
   if (log10(elo*(1+small)).lt.zero) iii=iii-1
   xxx=ten**iii
   if (2*xxx.gt.elo*(1+small).and.elo.ge.one*(1-small)) then
      ehi=2*xxx
   else if (5*xxx.gt.elo*(1+small).and.elo.ge.one*(1-small)) then
      ehi=5*xxx
   else
      ehi=10*xxx
   endif
   if (ehi.gt.eresr) ehi=eresr
   e=0
   call csunr1(e,sig)
   call csunr2(e,sig)
   write(nsyso,'(/&
     &15x,''estimated maximum error due to''/&
     &15x,''resonance integral check (errmax,errint)''//&
     &4x,''upper'',6x,''elastic'',3x,''percent'',3x,&
     &''capture'',3x,''percent'',3x,''fission'',3x,''percent''/&
     &4x,''energy'',5x,''integral'',3x,''error'',4x,&
     &''integral'',3x,''error'',4x,''integral'',3x,''error''/&
     &1p,e10.2)') elo

   !--set up the first grid point in the resonance range.
   in=0
   ig=0
  100 continue
   ig=ig+1
   call finda(ig,aa,1,ngrid,bufg,nbufg)
   egl=aa(1)
   if (egl.lt.eresl) go to 100
   call sigma(egl,sigl,sigd)

   !--set up the next grid point
  105 continue
   ig=ig+1
   call finda(ig,aa,1,ngrid,bufg,nbufg)
   eg=aa(1)
   call sigma(eg,sig,sigd)
   if (eg.ge.eresh) go to 190

   !--add points between nodes if needed.
   i=2
   x(2)=egl
   y(2)=sigl(1)
   x(1)=eg
   y(1)=sig(1)
   do j=1,nsig-1
      sigs(j,2)=sigl(j+1)
      sigs(j,1)=sig(j+1)
   enddo
   if (x(2).lt.eresr.and.x(1).gt.eresr) go to 150
   if (x(2).lt.eresu.and.x(1).gt.eresu) go to 150
   if (x(2).lt.eresm.and.x(1).gt.eresm) go to 150
   ! compare the true function to linear interpolation at the mid point
  115 continue
   xm=half*(x(i)+x(i-1))
   dx=x(i-1)-x(i)
   ndig=9
   if (xm.gt.tenth.and.xm.lt.one) ndig=8
   if (xm.gt.sigfig(x(i),ndig,+1).and.&
     xm.lt.sigfig(x(i-1),ndig,-1)) go to 135
   ! convergence forced by significant figures check
   go to 150
  135 continue
   if (xm.gt.sigfig(x(i),7,+1).and.&
     xm.lt.sigfig(x(i-1),7,-1)) then
      xm=sigfig(xm,7,0)
   else
      xm=sigfig(xm,ndig,0)
   endif
   call sigma(xm,sig,sigd)
   fr2=(xm-x(i))/dx
   fr1=1-fr2
   do j=1,nsig-1
      ! temporary patch to cope with the shift of l>0 resonances
      ! when RML (LRF=7) is used.  the initial grid points are
      ! wrong, resulting in sometimes missing part of the peak.
      ! if (sigs(j,i-1).ne.zero) then
      !    if (sigs(j,i)/sigs(j,i-1).gt.1.25e0_kr) go to 175
      ! endif
      ! if (sigs(j,i).ne.zero) then
      !    if (sigs(j,i-1)/sigs(j,i).gt.1.25e0_kr) go to 175
      ! endif
      sl=fr1*sigs(j,i)+fr2*sigs(j,i-1)
      dm(j)=abs(sig(j+1)-sl)
   enddo
   errn=err
   if (x(i-1).lt.trange) errn=err/5
   errm=errmax
   if (x(i-1).lt.trange) errm=errmax/5
   no=0
   do j=1,nsig-1
      if (dm(j).gt.errn*sig(j+1)) no=1
   enddo
   if (no.eq.0) go to 145
   do j=1,nsig-1
      if (dm(j).gt.errm*sig(j+1)) go to 175
   enddo
   tsti=2*errint*xm/dx
   do j=1,nsig-1
      if (dm(j).ge.tsti) go to 175
   enddo
   dm1=dm(1)
   dm2=dm(2)
   dm3=dm(3)

   ! convergence forced by resonance integral check
   nmax=nmax+1
   cmax=cmax+dm3*dx/(2*xm)
   emax=emax+dm1*dx/(2*xm)
   fmax=fmax+dm2*dx/(2*xm)
   go to 150
   ! don't allow big increases in the energy step
   ! they may be misconvergences
  145 continue
   est=estp*(x(i)-res(1))
   if (in.gt.3.and.dx.gt.est.and.xm.lt.eresr) go to 175
   ! converged.  write out top point in stack.
  150 continue
   in=in+1
   res(1)=x(i)
   if (abs(egl-x(i)).le.small*egl) then
      res(1)=egl
   else
      ngneg=ngneg+1
   endif
   res(2)=y(i)
   do j=1,nsig-1
      res(j+2)=sigs(j,i)
   enddo
   call loada(in,res,nsig+1,nscr,bufr,nbufr)
   if (ncoef.gt.1) then
      call sigma(res(1),sig,sigd)
      do j=1,nmtres
         if (mcards(j).eq.0) then
            if (sigd(1,j).gt.zero) then
               mcards(j)=in
            endif
         endif
      enddo
      k=1
      resl(k)=res(1)
      do l=1,ncoef
         do j=1,nmtres
            k=k+1
            resl(k)=sigd(l,j)
         enddo
      enddo
      call loada(in,resl,1+ncoef*nmtres,nscrl,bufl,nbufl)
   endif
   c1=sigs(3,i)
   c2=sigs(3,i-1)
   cint=cint+(c1+c2)*dx/(2*xm)
   c1=sigs(1,i)
   c2=sigs(1,i-1)
   eint=eint+(c1+c2)*dx/(2*xm)
   c1=sigs(2,i)
   c2=sigs(2,i-1)
   fint=fint+(c1+c2)*dx/(2*xm)
   if (x(i-1).lt.ehi*(1-small)) go to 165
   if (ehi.gt.eresh) go to 165
   if (elo.ge.ehi*(1-small)) go to 165
   ! print resonance integral diagnostics
   if (cint.ne.zero) cmax=100*cmax/cint
   if (eint.ne.zero) emax=100*emax/eint
   if (fint.ne.zero) fmax=100*fmax/fint
   write(nsyso,'(1p,e10.2,1x,3(1p,e12.2,f8.3))')&
     x(i-1),eint,emax,cint,cmax,fint,fmax
   elo=x(i-1)
   iii=int(log10(elo*(1+small))+small)
   if (log10(elo*(1+small)).lt.0) iii=iii-1
   xxx=ten**iii
   if (2*xxx.gt.elo*(1+small).and.elo.ge.one*(1-small)) then
      ehi=2*xxx
   else if (5*xxx.gt.elo*(1+small).and.elo.ge.one*(1-small)) then
      ehi=5*xxx
   else
      ehi=10*xxx
   endif
   if (ehi.gt.eresr) ehi=eresr
   if (elo.ge.eresr) ehi=eresh
   cint=0
   eint=0
   fint=0
   cmax=0
   emax=0
   fmax=0
  165 continue
   i=i-1
   if (i.gt.1) go to 115
   ! finished with stack.  go to next panel.
   egl=eg
   sigl(1)=y(1)
   do j=1,nsig-1
      sigl(j+1)=sigs(j,1)
   enddo
   go to 105
   ! not converged.  add mid point to stack and continue.
  175 continue
   i=i+1
   if (i.gt.ndim) call error('resxs','stack exceeded.',' ')
   x(i)=x(i-1)
   y(i)=y(i-1)
   x(i-1)=xm
   y(i-1)=sig(1)
   do j=1,nsig-1
      sigs(j,i)=sigs(j,i-1)
      sigs(j,i-1)=sig(j+1)
   enddo
   go to 115
   ! write out last point in grid.
  190 continue
   in=in+1
   inf=-in
   res(1)=egl
   res(2)=sigl(1)
   do j=1,nsig-1
      res(j+2)=sigs(j,1)
   enddo
   nrtot=in
   call loada(inf,res,nsig+1,nscr,bufr,nbufr)
   if (ncoef.gt.1) then
      call sigma(res(1),sig,sigd)
      k=1
      resl(k)=res(1)
      do l=1,ncoef
         do j=1,nmtres
            k=k+1
            resl(k)=sigd(l,j)
         enddo
      enddo
      call loada(inf,resl,1+ncoef*nmtres,nscrl,bufl,nbufl)
      do i=1,nmtres
         if (mcards(i).gt.0) mcards(i)=3+2*(nrtot-mcards(i)+1)
      enddo
   endif

   !--copy resonance data to output
   ip=1
   call finda(ip,x,nsig+1,nscr,bufr,nbufr)
   in=1
   call loada(in,x,nsig+1,nout,bufg,nbufg)
   do while (ip.lt.nrtot)
      ip=ip+1
      call finda(ip,x,nsig+1,nscr,bufr,nbufr)
      in=in+1
      inf=in
      if (ip.eq.nrtot) inf=-in
      call loada(inf,x,nsig+1,nout,bufg,nbufg)
   enddo

   !--finished writing resonance tape.
   nrtot=in
   call timer(time)
   write(nsyso,'(/&
     &'' points added by resonance reconstruction     ='',i8/&
     &'' points affected by resonance integral check  ='',i8/&
     &'' final number of resonance points             ='',i8)')&
     ngneg,nmax,nrtot
   deallocate(sigs)
   deallocate(y)
   deallocate(x)
   deallocate(bufg)
   deallocate(bufr)
   call closz(-nscr)
   return
   end subroutine resxs

   subroutine sigma(e,sig,sigd)
   !-------------------------------------------------------------------
   ! Calculate cross section at energy e from resonance parameters.
   !-------------------------------------------------------------------
   use samm ! provides cssammy
   use util ! provides error
   ! externals
   real(kr)::e,sig(nsig),sigd(10,10)
   ! internals
   integer::i,j,mode
   real(kr)::abn
   real(kr)::sigp(nsig)
   real(kr)::siga(ncoef,nmtres),sigx(1,1)
   real(kr),parameter::zero=0

   !--initialize reaction cross sections to zero
   do i=1,nsig
      sig(i)=0
   enddo
   if (ncoef.gt.1) then
      do i=1,ncoef
         do j=1,nmtres
            siga(i,j)=0
         enddo
      enddo
   endif

   !--calculate cross sections from data in a for each section
   do i=1,nsect
      isect=i
      abn=abnt(i)
      ! test if present section contributes
      if (e.ge.elt(i).and.e.lt.eht(i)) then
         ! determine formalism
         mode=modet(i)
         if (mode.ne.11.and.mode.ne.12) then
            if (mode.eq.0) then
               ! no res parameters
               call csnorp(e,sigp)
            else if (mode.eq.1) then
               ! single level breit-wigner
               call csslbw(e,sigp)
            else if (mode.eq.2.and.tempr.eq.zero) then
               ! multilevel breit-wigner
               call csmlbw(e,sigp)
            else if (mode.eq.2.and.tempr.gt.zero) then
               ! multilevel breit-wigner using g/h method
               call csmlbw2(e,sigp)
            else if (mode.eq.3.and.(isammy.eq.0.or.nmtres.eq.0)) then
               ! multi-level reich-moore (r-matrix)
               call csrmat(e,sigp)
            else if (mode.eq.3.and.isammy.eq.1.and.nmtres.gt.0) then
               ! sammy calculation
               call cssammy(e,sigp,siga,sigx,mmtres,nmtres,ncoef,nresp,i)
            else if (mode.eq.4) then
               ! multilevel adler-adler
                  call csaa(e,sigp)
            else if (mode.eq.5) then
               ! general r-matrix
               call error('sigma',&
                 'general r-matrix not installed.',' ')
            else if (mode.eq.6) then
               ! hybrid r-function
               call cshybr(e,sigp)
            else if (mode.eq.7) then
               ! sammy calculation
               call cssammy(e,sigp,siga,sigx,mmtres,nmtres,ncoef,nresp,i)
            else
               ! illegal mode
               call error('sigma','illegal option.',' ')
            endif
            do j=1,nsig
               if (sigp(j).lt.zero) sigp(j)=0
               sig(j)=sig(j)+sigp(j)*abn
            enddo
         endif
      endif
   enddo

   !--output angular coefficients
   if (ncoef.gt.1) then
      do i=1,ncoef
         do j=1,nmtres
            sigd(i,j)=siga(i,j)
         enddo
      enddo
    endif

   !--add unresolved contribution, if any.
   if (e.lt.eresu) return
   if (e.ge.eresh) return
   call sigunr(e,sigp)
   do j=1,4
      sig(j)=sig(j)+sigp(j)
   enddo
   return
   end subroutine sigma

   subroutine csnorp(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates potential scattering cross section for an isotope
   ! with a section without res paramters (lru=0, lrf=0)
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   real(kr)::e,sigp(nsig)
   ! internals
   integer::i,inow
   real(kr)::ap

   ! zero out cross section contribution from this section (sigp)
   do i=1,nsig
      sigp(i)=0
   enddo
   ! retrieve starting location for data in a
   inow=ibaset(isect)
   ap=res(inow+7)
   sigp(2)=4*pi*ap*ap
   return
   end subroutine csnorp

   subroutine csslbw(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates single level Breit-Wigner cross sections at energy e
   ! for one section (one isotope-one energy range)
   !-------------------------------------------------------------------
   use physics ! provides pi,bk,amassn,amu,hbar,ev
   use util    ! provides sigfig
   ! externals
   real(kr)::e,sigp(nsig)
   ! internals
   integer::i,ki,inow,naps,nls,l,nrs,ll,lp,in
   real(kr)::rpi,cwaven
   real(kr)::tbk,awri,ap,aw,ra,spi,spifac,k,pifac,rho,rhoc
   real(kr)::qx,se,pe,sec,pec,pex,phi,cos2p,sin2p,sinsq,spot
   real(kr)::er,aj,gn,gg,gf,ser,per,rper,gc,gx,gj
   real(kr)::erp,edelt,gne,gtt,ex,delta,theta,ax,y
   real(kr)::rew,aimw,psi,chi,smax,comfac,arat,rhop,add
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::zero=0
   rpi=sqrt(pi)
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--compute cross sections for this energy
   do i=1,nsig
      sigp(i)=0
   enddo
   tbk=tempr*bk
   ki=1
   ! retrieve starting location for data in res
   inow=ibaset(isect)
   ! retrieve nuclide information
   naps=nint(res(inow+5))
   awri=res(inow+12)
   ap=res(inow+7)
   ! calculate channel radius (ra)
   aw=amassn*awri
   ra=rc1*aw**third+rc2
   if (naps.eq.1) ra=ap
   spi=res(inow+6)
   spifac=1/(2*spi+1)
   nls=nint(res(inow+10))
   inow=inow+12
   ! calculate wave number(k),rho and rhocap at energy (e)
   arat=awri/(awri+1)
   k=cwaven*arat*sqrt(abs(e))
   pifac=pi/(k*k)
   rho=k*ra
   rhoc=k*ap

   !--loop over l states
   do l=1,nls
      nrs=nint(res(inow+5))
      ll=nint(res(inow+2))
      qx=res(inow+1)
      lrx=nint(res(inow+3))
      in=inow+nrs*6+6

      !--calculate shift and penetration factors
      !--at cross section energy
      call facts(ll,rho,se,pe)
      pec=0
      if (lrx.ne.0) then
         rhop=cwaven*arat*sqrt(abs(e+qx/arat))*ra
         lp=ll
         ! set competing l' value for a 2+ inelastic residual (u238)
         if (ll.eq.0) lp=2
         if (ll.eq.2) lp=0
         call facts(lp,rhop,sec,pec)
         if (e+qx/arat.lt.zero) pec=0
      endif
      call facphi(ll,rhoc,phi)

      !--constants independent of res. energy
      cos2p=cos(2*phi)
      sin2p=sin(2*phi)
      sinsq=(sin(phi))**2

      ! calculate potential scattering
      spot=4*(2*ll+1)*pifac*sinsq

      !--use doppler-broadened line shapes
      if (tempr.gt.zero) then
         do i=1,nrs
            inow=inow+6
            er=res(inow)
            aj=res(inow+1)
            gn=res(inow+3)
            gg=res(inow+4)
            gf=res(inow+5)
            ser=res(in)
            per=res(in+1)
            rper=1/per
            gc=res(in+2)
            pex=res(in+3)
            in=in+6
            gx=gg+gf
            gj=(2*aj+1)*spifac/2
            erp=er+gn*(ser-se)*rper/2
            edelt=e-erp
            gne=gn*pe*rper
            gtt=gne+gx
            if (gc.ne.zero) gtt=gtt+gc*pec/pex
            ex=2*(e-erp)/gtt
            delta=sqrt(4*tbk*e/awri)
            theta=gtt/delta
            ax=theta*ex/2
            y=theta/2
            call quickw(ax,y,rew,aimw,ki,tr,ti)
            psi=rpi*theta*rew/2
            chi=rpi*theta*aimw/2
            smax=4*pifac*gj*gne/gtt**2
            sigp(2)=sigp(2)+smax*((cos2p*gtt-gx)*psi+sin2p*chi*gtt)
            sigp(3)=sigp(3)+smax*gf*psi
            sigp(4)=sigp(4)+smax*gg*psi
            if (lrx.ne.0.and.gc.ne.zero) sigp(5)=sigp(5)+smax*gc*pec*psi/pex
         enddo
         inow=in

      !--use zero-temperature line shapes
      else
         do i=1,nrs
            inow=inow+6
            er=res(inow)
            aj=res(inow+1)
            gn=res(inow+3)
            gg=res(inow+4)
            gf=res(inow+5)
            ser=res(in)
            per=res(in+1)
            rper=1/per
            gc=res(in+2)
            pex=res(in+3)
            in=in+6
            gx=gg+gf
            gj=(2*aj+1)*spifac/2
            erp=er+gn*(ser-se)*rper/2
            edelt=e-erp
            gne=gn*pe*rper
            gtt=gne+gx
            if (gc.ne.zero) gtt=gtt+gc*pec/pex
            comfac=pifac*gj*gne/(edelt**2+gtt*gtt/4)
            add=comfac*(gne*cos2p-2*gx*sinsq+2*edelt*sin2p)
            sigp(2)=sigp(2)+add
            sigp(3)=sigp(3)+comfac*gf
            sigp(4)=sigp(4)+comfac*gg
            if (lrx.ne.0.and.gc.ne.zero) sigp(5)=sigp(5)+comfac*gc*pec/pex
         enddo
         inow=in
      endif

      !--add potential scattering
      sigp(2)=sigfig(sigp(2),8,0)
      spot=sigfig(spot,8,0)
      sigp(2)=sigp(2)+spot
   enddo

   !--construct the total cross section
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
   if (lrx.ne.0) sigp(1)=sigp(1)+sigp(5)
   return
   end subroutine csslbw

   subroutine csmlbw(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates multilevel Breit-Wigner cross sections at energy e
   ! for one section (one isotope-one energy range)
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev
   use util    ! provides error
   use endf    ! provides terpa
   ! externals
   real(kr)::e,sigp(nsig)
   ! internals
   integer::i,inow,nro,naps,iro,ip,ir,idx,nls,l,ll,lp,nrs
   integer::nj,ii,in,j
   real(kr)::cwaven,ape,enx,awri,ap,aw,ra,spi,den
   real(kr)::arat,k,pifac,rho,rhoc,qx,se,pe,rhop,sec,pec,pex
   real(kr)::phi,cos2p,sin2p,sum,fl,ajmin,ajmax,aj,diff
   real(kr)::er,gn,gg,gf,ser,per,gc,erp,edelt,gne,gx,gtt
   real(kr)::x,comfac,rper,add
   real(kr)::sigj(10,2),gj(10)
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::half=.5e0_kr
   real(kr),parameter::zero=0
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--doppler broadening not allowed
   if (tempr.gt.zero) call error('csmlbw',&
     'not coded for temperature gt 0 deg k.',' ')

   !--compute cross sections for this energy
   do i=1,nsig
      sigp(i)=0
   enddo
   ! retrieve starting location for data in a
   inow=ibaset(isect)
   ! retrieve nuclide information
   nro=nint(res(inow+4))
   naps=nint(res(inow+5))
   if (nro.ne.0) then
      iro=inow+6
      inow=inow+6+2*nint(res(iro+4))+2*nint(res(iro+5))
      ip=2
      ir=1
      call terpa(ape,e,enx,idx,res(iro),ip,ir)
   endif
   awri=res(inow+12)
   ap=res(inow+7)
   aw=amassn*awri
   ra=rc1*aw**third+rc2
   if (nro.eq.0) then
      if (naps.eq.1) ra=ap
   else
      if (naps.eq.0) then
         ap=ape
      else if (naps.eq.1) then
         ap=ape
         ra=ape
      else
         ra=ap
         ap=ape
      endif
   endif
   spi=res(inow+6)
   den=4*spi+2
   nls=nint(res(inow+10))
   ! calculate wave number(k),rho and rhocap at energy (e)
   arat=awri/(awri+1)
   k=cwaven*arat*sqrt(abs(e))
   pifac=pi/(k*k)
   rho=k*ra
   rhoc=k*ap
   inow=inow+12

   !--loop over l states
   do l=1,nls
      nrs=nint(res(inow+5))
      ll=nint(res(inow+2))
      qx=res(inow+1)
      lrx=nint(res(inow+3))
      call facts(ll,rho,se,pe)
      pec=0
      if (lrx.ne.0) then
         rhop=cwaven*arat*sqrt(abs(e+qx/arat))*ra
         lp=ll
         ! set competing l' value for a 2+ inelastic residual (u238)
         if (ll.eq.0) lp=2
         if (ll.eq.2) lp=0
         call facts(lp,rhop,sec,pec)
         if (e+qx/arat.lt.zero) pec=0
      endif
      call facphi(ll,rhoc,phi)
      cos2p=1-cos(2*phi)
      sin2p=sin(2*phi)
      sum=0
      fl=ll
      ajmin=abs(abs(spi-fl)-half)
      ajmax=spi+fl+half
      nj=nint(ajmax-ajmin+1)
      aj=ajmin
      do i=1,nj
         gj(i)=(2*aj+1)/den
         aj=aj+1
         sum=sum+gj(i)
      enddo
      diff=2*fl+1-sum
      do ii=1,2
         do i=1,nj
            sigj(i,ii)=0
         enddo
      enddo
      inow=inow+6
      in=inow+nrs*6

      !--loop over all resonances
      do i=1,nrs
         er=res(inow)
         j=nint(res(inow+1)-ajmin+1)
         gn=res(inow+3)
         gg=res(inow+4)
         gf=res(inow+5)
         ser=res(in)
         per=res(in+1)
         rper=1/per
         gc=res(in+2)
         pex=res(in+3)
         in=in+6
         inow=inow+6
         erp=er+gn*(ser-se)*rper/2
         edelt=e-erp
         gne=gn*pe*rper
         gx=gg+gf
         gtt=gne+gx
         if (gc.ne.zero) gtt=gtt+gc*pec/pex
         x=2*edelt/gtt
         comfac=2*gne/gtt/(1+x*x)
         sigj(j,1)=sigj(j,1)+comfac
         sigj(j,2)=sigj(j,2)+comfac*x
         comfac=comfac*gj(j)/gtt
         sigp(3)=sigp(3)+comfac*gf
         sigp(4)=sigp(4)+comfac*gg
         if (lrx.ne.0.and.gc.ne.zero) sigp(5)=sigp(5)+comfac*gc*pec/pex
      enddo
      do j=1,nj
         add=gj(j)*((cos2p-sigj(j,1))**2+(sin2p+sigj(j,2))**2)
         sigp(2)=sigp(2)+add
      enddo
      sigp(2)=sigp(2)+2*diff*cos2p
      inow=in
   enddo

   !--construct the final cross sections
   sigp(2)=sigp(2)*pifac
   sigp(3)=sigp(3)*2*pifac
   sigp(4)=sigp(4)*2*pifac
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
   if (lrx.ne.0) sigp(1)=sigp(1)+sigp(5)
   return
   end subroutine csmlbw

   subroutine csmlbw2(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates multi level Breit-Wigner cross sections at energy e
   ! using the g/h method
   ! for one section (one isotope-one energy range)
   !-------------------------------------------------------------------
   use physics ! provides pi,bk,amassn,amu,hbar,ev
   use util    ! provides sigfig
   ! externals
   real(kr)::e,sigp(nsig)
   ! internals
   integer::i,j,ki,inow,naps,nls,l,nrs,ll,in,igh
   real(kr)::rpi,cwaven
   real(kr)::tbk,awri,ap,aw,ra,spi,spifac,k,pifac,rho,rhoc
   real(kr)::qx,se,pe,sec,pec,phi,cos2p,sin2p,sinsq,spot
   real(kr)::er,aj,gt,gn,gg,gf,ser,per,rper,gc,gx,gj,gne
   real(kr)::g,h,ajj,erj,gnj,ggj,gfj,gtj,sej,pej,gcj,sml,ssl
   real(kr)::erp,gtt,ex,delta,theta,ax,y,pex,rpex,pcj,enow,test
   real(kr)::rew,aimw,psi,chi,smax,comfac,arat,rhop,add
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::tmin=10e0_kr
   real(kr),parameter::zero=0
   save enow
   rpi=sqrt(pi)
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--compute cross sections for this energy
   do i=1,nsig
      sigp(i)=0
   enddo
   tbk=tempr*bk
   ki=1
   ! retrieve starting location for data in res
   inow=ibaset(isect)
   ! retrieve nuclide information
   naps=nint(res(inow+5))
   awri=res(inow+12)
   ap=res(inow+7)
   ! calculate channel radius (ra)
   aw=amassn*awri
   ra=rc1*aw**third+rc2
   if (naps.eq.1) ra=ap
   spi=res(inow+6)
   spifac=1/(2*spi+1)
   nls=nint(res(inow+10))
   inow=inow+12
   ! calculate wave number(k),rho and rhocap at energy (e)
   arat=awri/(awri+1)
   k=cwaven*arat*sqrt(abs(e))
   pifac=pi/(k*k)
   rho=k*ra
   rhoc=k*ap

   !--accelerating the gh calculation
   igh=0
   if (abs(e-1.e-5_kr).lt.1.e-7_kr) then
      enow=e
      igh=1
   endif
   test=enow+enow/20
   if (enow+10.lt.test) test=enow+10
   if (e.ge.test) then
      enow=e
      igh=1
   endif

   !--loop over l states
   do l=1,nls
      nrs=nint(res(inow+5))
      ll=nint(res(inow+2))
      qx=res(inow+1)
      lrx=nint(res(inow+3))
      in=inow+nrs*6+6

      !--calculate shift and penetration factors
      !--at cross section energy
      call facts(ll,rho,se,pe)
      pec=0
      if (lrx.ne.0) then
         rhop=cwaven*arat*sqrt(abs(e+qx))*ra
         call facts(ll,rhop,sec,pec)
         if (e+qx/arat.lt.zero) pec=0
      endif
      call facphi(ll,rhoc,phi)

      !--constants independent of res. energy
      cos2p=cos(2*phi)
      sin2p=sin(2*phi)
      sinsq=(sin(phi))**2

      ! calculate potential scattering
      spot=4*(2*ll+1)*pifac*sinsq
      sml=0

      !--loop over resonances for this sequence
      inow=inow+6
      do i=1,nrs

         !--get parameters for this resonance
         er=res(inow+6*(i-1))
         aj=res(inow+6*(i-1)+1)
         gt=res(inow+6*(i-1)+2)
         gn=res(inow+6*(i-1)+3)
         gg=res(inow+6*(i-1)+4)
         gf=res(inow+6*(i-1)+5)
         ser=res(in+6*(i-1))
         per=res(in+6*(i-1)+1)
         rper=1/per
         gc=res(in+6*(i-1)+2)
         pex=res(in+6*(i-1)+3)
         rpex=1/pex
         gx=gg+gf
         gj=(2*aj+1)*spifac/2
         erp=er+gn*(ser-se)*rper/2
         gne=gn*pe*rper
         gtt=gne+gx
         if (gc.ne.zero) gtt=gtt+gc*pec*rpex

         !--compute g and h for multi level correction
         !--at the resonance centers
         if (igh.eq.1) then
            g=0
            h=0
            do j=1,nrs
               ajj=res(inow+6*(j-1)+1)
               if (j.ne.i.and.ajj.eq.aj.and.abs(i-j).lt.200) then
                  erj=res(inow+6*(j-1))
                  sej=res(in+6*(j-1))
                  pej=res(in+6*(j-1)+1)
                  gcj=res(in+6*(j-1)+2)
                  pcj=res(in+6*(j-1)+3)
                  gnj=res(inow+6*(j-1)+3)
                  ggj=res(inow+6*(j-1)+4)
                  gfj=res(inow+6*(j-1)+5)
                  erj=erj+(sej-se)*gnj/(2*pej)
                  gnj=gnj*pe/pej
                  gtj=gnj+ggj+gfj
                  if (gcj.ne.zero) gtj=gtj+gcj*pec/pcj
                  g=g+gne*gnj*(gtt+gtj)/((erp-erj)**2+(gtt+gtj)**2/4)
                  h=h+gne*gnj*(erp-erj)/((erp-erj)**2+(gtt+gtj)**2/4)
               endif
            enddo
            g=g/2
            res(in+6*(i-1)+4)=g/e
            res(in+6*(i-1)+5)=h/e
         endif

         !--finish cross section calculation
         ex=2*(e-erp)/gtt
         if (tempr.gt.tmin) then
            delta=sqrt(4*tbk*e/awri)
            theta=gtt/delta
            ax=theta*ex/2
            y=theta/2
            call quickw(ax,y,rew,aimw,ki,tr,ti)
            psi=rpi*theta*rew/2
            chi=rpi*theta*aimw/2
         else
            psi=1/(1+ex**2)
            chi=ex/(1+ex**2)
         endif
         g=res(in+6*(i-1)+4)
         h=res(in+6*(i-1)+5)
         smax=4*pifac*gj*gne/gtt**2
         sigp(2)=sigp(2)+smax*((cos2p*gtt-gx)*psi+sin2p*gtt*chi)
         sml=sml+smax*e*(g*psi+h*chi)*gtt/gne
         sigp(3)=sigp(3)+smax*gf*psi
         sigp(4)=sigp(4)+smax*gg*psi
      enddo
      inow=inow+12*nrs

      !--add potential scattering
      ssl=sigp(2)+spot
      sigp(2)=ssl+sml
   enddo

   !--construct the total cross section
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
   return
   end subroutine csmlbw2

   subroutine csrmat(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates R-matrix (Reich-Moore) cross sections at energy e
   ! for one section  (one isotope-one energy range)
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev
   use util    ! provides error
   ! externals
   real(kr)::e,sigp(nsig)
   ! internals
   integer::i,inow,naps,nls,l,inowb,nrs,ncyc,ll,numj
   integer::jj,jjl,j,in,kchanl,idone,kpstv,kngtv,iskip,kkkkkk
   real(kr)::cwaven,awri,ap,aw,ra,spi,arat,k,pifac,gjd
   real(kr)::rho,rhoc,gfa,gfb,gf,apl,se,pe,dum1
   real(kr)::phi,phid,p1,p2,fl,ajmin,ajmax,ajc,gj,aj
   real(kr)::er,gn,gg,per,a1,a2,a3,diff,den,de2,gg4
   real(kr)::t1,t2,t3,t4,u11r,u11i,termt,termn,termf,termg
   real(kr)::dd,rr,ss,amag,rri,ssi,uur,uui,xx
   real(kr)::r(3,3),s(3,3),ri(3,3),si(3,3)
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::quar=.25e0_kr
   real(kr),parameter::haf=.5e0_kr
   real(kr),parameter::uno=1.e0_kr
   real(kr),parameter::two=2.e0_kr
   real(kr),parameter::four=4.0e0_kr
   real(kr),parameter::small=3.e-4_kr
   real(kr),parameter::zero=0
   character::strng*60
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--doppler broadening not provided.
   if (tempr.gt.zero) call error('csrmat',&
     'not coded for temperatures gt 0 deg k.',' ')

   !--compute cross sections at this energy
   do i=1,nsig
      sigp(i)=0
   enddo
   ! retrieve starting location for data in a
   inow=ibaset(isect)
   ! retrieve nuclide information
   naps=nint(res(inow+5))
   awri=res(inow+12)
   ap=res(inow+7)
   aw=amassn*awri
   ra=rc1*aw**third+rc2
   if (naps.eq.1) ra=ap
   spi=res(inow+6)
   gjd=2*(2*spi+1)
   nls=nint(res(inow+10))
   ! calculate wave number(k),rho and rhocap at energy (e)
   arat=awri/(awri+1)
   k=cwaven*arat*sqrt(abs(e))
   pifac=pi/(k*k)
   rho=k*ra
   rhoc=k*ap
   gfa=0
   gfb=0
   gf=0
   inow=inow+12

   !--loop over l states
   do l=1,nls
      inowb=inow
      ll=nint(res(inow+2))
      nrs=nint(res(inow+5))
      ! some files are malformed and have a list record for l values without
      ! resonances, issue a warning and move to the next l value
      if (nrs.eq.0) then
         write(strng,'(''nrs=0 for Reich-Moore and l='',i2)') ll
         call mess('csrmat',strng,'malformed ENDF file, check evaluation')
         inow = inow+6
         cycle
      end if
      ncyc=nint(res(inow+4))/nrs
      apl=res(inow+1)
      rhoc=k*ap
      rho=k*ra
      if (apl.ne.zero) rhoc=k*apl
      if (apl.ne.zero.and.naps.eq.1) rho=k*apl
      ! calculate shift and penetration factors
      call facts(ll,rho,se,dum1)
      pe=dum1
      call facphi(ll,rhoc,phi)
      ! constants independent of res. energy
      phid=phi
      p1=cos(2*phid)
      p2=sin(2*phid)

      !--loop over possible j values
      fl=ll
      ajmin=abs(abs(spi-fl)-haf)
      ajmax=spi+fl+haf
      numj=nint(ajmax-ajmin+1)
      ajc=ajmin-1
      if (ll.ne.0.and.(fl.gt.spi-haf.and.fl.le.spi)) then
         jjl=0
      else
         jjl=1
      endif
      do jj=1,numj
         inow=inowb
         ajc=ajc+1
         gj=(2*ajc+1)/gjd

         !--loop over possible channel spins
         kchanl=0
         idone=0
         do while (kchanl.lt.2.and.idone.eq.0)
            kchanl=kchanl+1
            inow=inowb
            kpstv=0
            kngtv=0
            !initialize matrix
               do j=1,3
                  do i=1,3
                     s(j,i)=0
                     r(j,i)=0
                  enddo
               enddo
            !--loop over resonances
            inow=inow+6
            in=inow+nrs*6
            do i=1,nrs
               aj=abs(res(inow+1))
               !select only resonances with current j value
               if (abs(aj-ajc).le.quar) then
                  if (res(inow+1).lt.zero) kngtv=kngtv+1
                  if (res(inow+1).gt.zero) kpstv=kpstv+1
                  iskip=0
                  if (kchanl.eq.1.and.res(inow+1).lt.zero) iskip=1
                  if (kchanl.eq.2.and.res(inow+1).gt.zero) iskip=1
                  if (iskip.eq.0) then
                     !retrieve parameters
                     er=res(inow)
                     gn=res(inow+2)
                     gg=res(inow+3)
                     gfa=res(inow+4)
                     gfb=res(inow+5)
                     per=res(in+1)
                     !gc=res(in+2)
                     a1=sqrt(gn*pe/per)
                     a2=0
                     if (gfa.ne.zero) a2=sqrt(abs(gfa))
                     if (gfa.lt.zero) a2=-a2
                     a3=0
                     if (gfb.ne.zero) a3=sqrt(abs(gfb))
                     if (gfb.lt.zero) a3=-a3
                     !compute energy factors
                     diff=er-e
                     den=diff*diff+quar*gg*gg
       if(den.eq.0)write(*,'("er,e,diff,gg=",4(1pe11.4))')&
                              er,e,diff,gg
                     de2=haf*diff/den
                     gg4=quar*gg/den
                     !calculate r-function, or
                     !calculate upper triangular matrix terms
                     r(1,1)=r(1,1)+gg4*a1*a1
                     s(1,1)=s(1,1)-de2*a1*a1
                     if (gfa.ne.zero.or.gfb.ne.zero) then
                        r(1,2)=r(1,2)+gg4*a1*a2
                        s(1,2)=s(1,2)-de2*a1*a2
                        r(1,3)=r(1,3)+gg4*a1*a3
                        s(1,3)=s(1,3)-de2*a1*a3
                        r(2,2)=r(2,2)+gg4*a2*a2
                        s(2,2)=s(2,2)-de2*a2*a2
                        r(3,3)=r(3,3)+gg4*a3*a3
                        s(3,3)=s(3,3)-de2*a3*a3
                        r(2,3)=r(2,3)+gg4*a2*a3
                        s(2,3)=s(2,3)-de2*a2*a3
                        gf=1
                     endif
                  endif
               endif
               inow=inow+ncyc
               in=in+6
            enddo

            !--take care of extra channel spin as defined
            !--by the sign of aj:
            !-- kkkkkk = 0 => do not add anything in here
            !-- kkkkkk = 1 => add resonance contribution but
            !--  not extra hard-sphere
            !-- kkkkkk = 2 => add resonance plus hard-sphere
            !--  phase shift contribution
            kkkkkk = 0
            if (kchanl.eq.1) then
               if (kpstv.gt.0) then
                  if (kngtv.eq.0) then
                     if (jj.gt.jjl.and.jj.lt.numj) then
                        kkkkkk=2
                     else
                        kkkkkk=1
                     endif
                  else if (kngtv.gt.0) then
                     kkkkkk=1
                  endif
               else if (kpstv.eq.0) then
                  if (kngtv.eq.0) then
                     if (jj.gt.jjl.and.jj.lt.numj) then
                        kkkkkk=2
                     else
                        kkkkkk=1
                     endif
                  else if (kngtv.gt.0) then
                     kkkkkk=0
                  endif
               endif
            else if (kchanl.eq.2) then
               if (kpstv.gt.0) then
                  if (kngtv.eq.0) then
                  else if (kngtv.gt.0) then
                     kkkkkk=1
                  endif
               else if (kpstv.eq.0) then
                  if (kngtv.eq.0) then
                  else if (kngtv.gt.0) then
                     if (jj.gt.jjl.and.jj.lt.numj) then
                        kkkkkk=2
                     else
                        kkkkkk=1
                     endif
                  endif
               endif
            endif
            if (kkkkkk.ne.0) then

               !--r-matrix path -- make symmetric matrix
               if (gf.ne.zero) then
                  r(1,1)=uno+r(1,1)
                  r(2,2)=uno+r(2,2)
                  r(3,3)=uno+r(3,3)
                  r(2,1)=r(1,2)
                  s(2,1)=s(1,2)
                  r(3,1)=r(1,3)
                  s(3,1)=s(1,3)
                  r(3,2)=r(2,3)
                  s(3,2)=s(2,3)
                  !invert the complex matrix
                  call frobns(r,s,ri,si)
                  !fission term for r-matrix path
                  t1=ri(1,2)
                  t2=si(1,2)
                  t3=ri(1,3)
                  t4=si(1,3)
                  termf=four*gj*(t1*t1+t2*t2+t3*t3+t4*t4)
                  u11r=p1*(two*ri(1,1)-uno)+two*p2*si(1,1)
                  u11i=p2*(uno-two*ri(1,1))+two*p1*si(1,1)
                  termt=two*gj*(uno-u11r)
                  termn=gj*((uno-u11r)**2+u11i**2)

               !--r-function path
               else
                  dd=r(1,1)
                  rr=uno+dd
                  ss=s(1,1)
                  amag=rr**2+ss**2
                  rri=rr/amag
                  ssi=-ss/amag
                  uur=p1*(two*rri-uno)+two*p2*ssi
                  uui=p2*(uno-two*rri)+two*p1*ssi
                  if (abs(dd).lt.small.and.&
                    abs(phid).lt.small) then
                     xx=2*dd
                     xx=xx+2*(dd*dd+ss*ss+phid*phid+p2*ss)
                     xx=xx-2*phid*phid*(dd*dd+ss*ss)
                     xx=xx/amag
                     termt=two*gj*xx
                     termn=gj*(xx**2+uui**2)
                  else
                     termt=two*gj*(uno-uur)
                     termn=gj*((uno-uur)**2+uui**2)
                  endif
                  termf=0
               endif

               !--cross sections contributions
               if (kkkkkk.eq.2) then
                  termn=termn+two*gj*(1-p1)
                  termt=termt+two*gj*(1-p1)
               endif
               termg=termt-termf-termn
               sigp(2)=sigp(2)+termn
               sigp(4)=sigp(4)+termg
               sigp(3)=sigp(3)+termf
               sigp(1)=sigp(1)+termt
            endif
         enddo
      enddo
      inow=in

   !--continue the loop over l values
   enddo

   !--calculate final cross sections and store for return
   sigp(1)=pifac*sigp(1)
   sigp(2)=pifac*sigp(2)
   sigp(3)=pifac*sigp(3)
   sigp(4)=pifac*sigp(4)
   return
   end subroutine csrmat

   subroutine frobns(a,b,c,d)
   !-------------------------------------------------------------------
   ! This subroutine inverts a complex matrix with real and imaginary
   ! parts a and b and gives c and d the real and imaginary parts of
   ! the inverse. Frobenius-Schur method of inversion.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::a(3,3),b(3,3),c(3,3),d(3,3),q(3,3)
   ! internals
   integer::i,j,ind

   do i=1,3
      do j=1,3
         c(i,j)=a(i,j)
      enddo
   enddo
   call thrinv(a,3,ind)
   if (ind.ne.1) then
      call abcmat(a,b,q)
      call abcmat(b,q,d)
      do i=1,3
         do j=1,3
            c(i,j)=c(i,j)+d(i,j)
         enddo
      enddo
      call thrinv(c,3,ind)
      call abcmat(q,c,d)
      do i=1,3
         do j=1,3
            d(i,j)=-d(i,j)
         enddo
      enddo
   endif
   return
   end subroutine frobns

   subroutine thrinv(d,n,kimerr)
   !-------------------------------------------------------------------
   ! Inverts symmetric matrix (d(i,j),j=1,n,i=1,j)
   !-------------------------------------------------------------------
   ! externals
   integer::n,kimerr
   real(kr)::d(3,3)
   ! internals
   integer::i,j,lr
   real(kr)::fooey
   real(kr)::s(3)
   real(kr),parameter::zero=0
   real(kr),parameter::uno=1

   kimerr=0
   do j=1,n
      do i=1,j
         d(i,j)=-d(i,j)
         d(j,i)=d(i,j)
      enddo
      d(j,j)=uno+d(j,j)
   enddo
   do lr=1,n
      fooey=uno-d(lr,lr)
      if (fooey.eq.zero) then
         kimerr=1
         return
      endif
      d(lr,lr)=uno/fooey
      do j=1,n
         s(j)=d(lr,j)
         if (j.ne.lr) then
            d(j,lr)=d(j,lr)*d(lr,lr)
            d(lr,j)=d(j,lr)
         endif
      enddo
      do j=1,n
         if (j.ne.lr) then
            do i=1,j
               if (i.ne.lr) then
                  d(i,j)=d(i,j)+d(i,lr)*s(j)
                     d(j,i)=d(i,j)
               endif
            enddo
         endif
      enddo
   enddo
   return
   end subroutine thrinv

   subroutine abcmat(a,b,c)
   !-------------------------------------------------------------------
   ! Routine to do a matrix multiplication
   !-------------------------------------------------------------------
   ! externals
   real(kr)::a(3,3),b(3,3),c(3,3)
   ! internals
   integer::i,j,k

   do i=1,3
      do j=1,3
         c(i,j)=0
         do k=1,3
            c(i,j)=c(i,j)+a(i,k)*b(k,j)
         enddo
      enddo
   enddo
   return
   end subroutine abcmat

   subroutine cshybr(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates hybrid R-function cross sections at energy e
   ! for one section (one isotope-one energy range)
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev
   use util    ! provides error
   use endf    ! provides terpa
   ! externals
   real(kr)::e,sigp(nsig)
   ! internals
   integer::i,inow,nls,ngre,nfre,nire,ncre,nrchan,np,nr,itpt
   integer::n,l,nw,nss,ns,njs,nj,ll,lbk,lps,nrs,ii,ip,ir,idis,iii
   real(kr)::cwaven,spi,awri,arat,k,kfac,pifac
   real(kr)::aj,gj,ac,rho,phir,se,pe
   real(kr)::er,gn,gg,gf,gelim,eeff,ereff,phres,pd,phen
   real(kr)::sn,pn,eenn,rhres,ser,per,gne,gnr,gtt
   real(kr)::edelt,den,comfac,sd,rr0,ri0,phro,phri,rpart,sabs
   complex(kr)::one,eye,rfcnn,slsjnn,phi0,phi,r0,exphi
   integer::lc(4),icrpt(4,4)
   real(kr)::qre(4),gc(4),sigc(4)
   real(kr)::zero=0
   real(kr)::uno=1

   eye=dcmplx(zero,uno)
   one=dcmplx(uno,zero)
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--no doppler broadening
   if (tempr.gt.zero) call error('cshybr',&
     'doppler broadening not provided for hybrid r-mtrix.',' ')

   !--zero out cross section contribution from this section (sigp)
   do i=1,4
      sigp(i)=0
   enddo

   !--retrieve nuclide information
   inow=ibaset(isect)
   spi=res(inow+6)
   nls=nint(res(inow+10))

   !--retrieve competing channel descriptions
   ngre=nint(res(inow+14))
   nfre=nint(res(inow+15))
   nire=nint(res(inow+16))
   ncre=nint(res(inow+17))
   nrchan=nire+ncre
   qre(1)=res(inow+29)
   qre(2)=res(inow+30)
   qre(3)=res(inow+31)
   qre(4)=res(inow+32)
   if (nrchan.gt.0) then
      do n=1,nrchan
         sigc(n)=0
      enddo
   endif

   !--make pointer index for charged particle penetrabilities
   inow=inow+34
   if (ncre.ne.0) then
      do n=1,ncre
         do l=1,4
            icrpt(l,n)=inow
            nw=6+2*nint(res(inow+4))+2*nint(res(inow+5))
            inow=inow+nw
         enddo
      enddo
   endif

   !--calculate wave number(k) at energy(e)
   awri=res(inow)
   arat=awri/(awri+1)
   kfac=cwaven*arat
   k=kfac*sqrt(abs(e))
   pifac=pi/(k*k)

   !--loop over l states
   do 140 l=1,nls
   ll=nint(res(inow+2))
   nss=nint(res(inow+4))
   inow=inow+6

   !--loop over channel spin states
   do 130 ns=1,nss
   njs=nint(res(inow+4))
   inow=inow+6

   !--loop over j states
   do 120 nj=1,njs
   aj=res(inow)
   gj=(2*aj+1)/(4*spi+2)
   ac=res(inow+1)
   lbk=nint(res(inow+2))
   lps=nint(res(inow+3))
   nrs=nint(res(inow+5))
   inow=inow+6
   rho=k*ac
   ! calculate hard sphere phase shift
   call facphi(ll,rho,phir)
   phi0=dcmplx(phir,zero)
   ! calculate shift and penetration factors at cross section energy
   call facts(ll,rho,se,pe)

   !--loop over all resonances
   rfcnn=dcmplx(zero,zero)
   if (nrs.eq.0) go to 140
   do 110 i=1,nrs
   er=res(inow)
   gn=res(inow+1)
   gg=res(inow+2)
   gf=res(inow+3)
   inow=inow+3
   gelim=gg+gf
   if (nrchan.ne.0) then
      ! determine value of competitive widths
      do ii=1,nrchan
         gc(ii)=0
         lc(ii)=nint(res(inow+ii+4))
         eeff=e+(qre(ii)/arat)
         if (eeff.gt.zero) then
            ereff=abs(er+(qre(ii)/arat))
            ! inelastic penetrability
            if (ii.le.nire) then
               phres=kfac*sqrt(ereff)*ac
               call facts(lc(ii),phres,sd,pd)
               phen=kfac*sqrt(eeff)*ac
               call facts(lc(ii),phen,sn,pn)
               gc(ii)=pn*res(inow+ii)/pd
            ! charged particle penetrability
            else if (lc(ii)+1.le.4) then
               itpt=icrpt(lc(ii)+1,ii)
               ip=2
               ir=1
               call terpa(pd,ereff,eenn,idis,res(itpt),ip,ir)
               call terpa(pn,eeff,eenn,idis,res(itpt),ip,ir)
               gc(ii)=pn*res(inow+ii)/pd
            endif
         endif
         gelim=gelim+gc(ii)
      enddo
   endif
   inow=inow+9

   !--cross section calculations
   rhres=kfac*sqrt(abs(er))*ac
   call facts(ll,rhres,ser,per)
   gne=gn*pe/per
   gnr=gn/(2*per)
   gtt=gne+gelim
   edelt=er-e
   den=edelt**2+gtt*gtt/4
   comfac=pifac*gj*gne/den
   rfcnn=rfcnn+gnr/(edelt-eye*gelim/2)
   if (ngre.ne.0) sigp(4)=sigp(4)+comfac*gg
   if (nfre.ne.0) sigp(3)=sigp(3)+comfac*gf
   if (nrchan.gt.0) then
      do iii=1,nrchan
         sigc(iii)=sigc(iii)+comfac*gc(iii)
      enddo
   endif

   !--end of loop over resonances
  110 continue

   !--background r-function
   r0=dcmplx(zero,zero)
   if (lbk.ne.0)  then
      ip=2
      ir=1
      call terpa(rr0,eeff,eenn,idis,res(inow),ip,ir)
      np=nint(res(inow+5))
      nr=nint(res(inow+4))
      inow=inow+6+2*nr+2*np
      call terpa(ri0,eeff,eenn,idis,res(inow),ip,ir)
      np=nint(res(inow+5))
      nr=nint(res(inow+4))
      inow=inow+6+2*nr+2*np
      r0=dcmplx(rr0,ri0)
   endif
   rfcnn=rfcnn+r0

   !--optical model phase shift
   phi=phi0
   if (lps.ne.0)  then
      ip=2
      ir=1
      call terpa(phro,eeff,eenn,idis,res(inow),ip,ir)
      np=nint(res(inow+5))
      nr=nint(res(inow+4))
      inow=inow+6+2*nr+2*np
      call terpa(phri,eeff,eenn,idis,res(inow),ip,ir)
      np=nint(res(inow+5))
      nr=nint(res(inow+4))
      inow=inow+6+2*nr+2*np
      phi=dcmplx(phro,phri)
   endif

   !--r-function calculations
   exphi=exp(-2*eye*phi)
   slsjnn=(one-exphi)-eye*pe*rfcnn*(one+exphi)
   slsjnn=slsjnn/(one-eye*pe*rfcnn)
   rpart=dble(slsjnn)
   sabs=abs(slsjnn)
   sigp(1)=sigp(1)+2*pifac*gj*rpart
   sigp(2)=sigp(2)+pifac*gj*sabs*sabs
   sigp(1)=sigp(2)+sigp(3)+sigp(4)

   !--continue l, s, and j loops
  120 continue
  130 continue
  140 continue

   !--finished.
   return
   end subroutine cshybr

   subroutine csunr1(e,sigp)
   !-------------------------------------------------------------------
   ! Unresolved resonance region (format 1).
   ! Single-level Breit-Wigner formalism.
   ! Energy independent parameters:
   !    lfw=0  no fission widths given
   !    lfw=1  fission widths tabulated
   ! For lfw=0, parameter interpolation is always used.
   ! For lfw=1, linear cross section interpolation is used
   ! unless the energy step is too large (see wide), then
   ! parameter interpolation is used.  Call csunr1 with
   ! e=0 to intialize flags for each section.
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev
   use endf    ! provides terp1
   use util    ! provides error
   ! externals
   real(kr)::e,sigp(4)
   ! internals
   integer::ne,ie,i,iest,inow,lfw,nls,l,ll,j,muf,nep6,ifst
   integer::mu,nu,lamda,i1,i2,njs,nro,ip,ir,iro,idx,naps
   real(kr)::ee,enext,elast,spi,ay,aaa,awri,rat,aw,aa,const
   real(kr)::gfx,gxx,dx,aj,amun,gnox,ggx,gj
   real(kr)::e2,k,rho,rhoc,vl,ps,gnx,diff,den,enx
   real(kr)::cwaven,spot,y1,y2
   real(kr)::temp,terg,ters,terf,gs,gc,gff,add
   integer::ifirst=1
   real(kr),parameter::wide=1.26e0_kr
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::zero=0
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--initialize (e=0.)
   ne=0
   if (e.gt.zero) go to 125
   do i=1,20
      ilast(i)=0
   enddo
   go to 220
  125 continue
   ee=e
   ifirst=ilast(isect)
   inow=ibaset(isect)
   lfw=nint(res(inow+4))

   ! check sign of res(inow+7).  If < 0, it equals -nro and
   ! res(inow+6) marks the beginning of an energy dependent tab1
   ! record for the scattering radius; if > 0 then res(inow+6)
   ! is the cont record beginning with spin data.
   nro=0
   if (res(inow+7).lt.zero) then
      nro=-nint(res(inow+7))
      inow=inow+6+2*nint(res(inow+10))+2*nint(res(inow+11))
   endif

   if (ifirst.gt.0) go to 100
   enext=e
   elast=0
   enxt(isect)=e
   elst(isect)=0
   ie=1
   go to 120

   !--check energy range
  100 continue
   enext=enxt(isect)
   elast=elst(isect)
   ie=ilast(isect)
   if (lfw.eq.0) go to 130
   iest=inow+12
   if (e.lt.enext.and.enext.ge.wide*elast) go to 130
   if (e.le.enext) go to 210
   if (ie.eq.ne) go to 120
  110 continue
   elast=enext
   elst(isect)=elast
   do i=1,4
      slst(isect,i)=snxt(isect,i)
   enddo
   ie=ie+1
   enext=res(iest+ie-1)
   enxt(isect)=enext
   ilast(isect)=ie
  120 continue
   e=enext

   !--compute unresolved cross sections
  130 continue
   do i=2,4
      sigp(i)=0
   enddo
   ! retrieve starting for location for data in a for this section
   inow=ibaset(isect)
   ! retrieve nuclide information
   lfw=nint(res(inow+4))
   naps=nint(res(inow+5))
   if (res(inow+7).gt.0.) then
      ay=res(inow+7)
   else
      iro=inow+6
      ip=2
      ir=1
      call terpa(ay,e,enx,idx,res(iro),ip,ir)
      inow=inow+6+2*nint(res(iro+4))+2*nint(res(iro+5))
   endif
   spi=res(inow+6)
   aaa=res(inow+7)
   if (lfw.ne.1) then
      ne=0
      nls=nint(res(inow+10))
      inow=inow+12
      awri=res(inow)
   else
      ne=nint(res(inow+10))
      nls=nint(res(inow+11))
      ! save starting location for fission width energies
      iest=inow+12
      inow=inow+12+ne
      awri=res(inow)
   endif
   ! calculate channel radius
   rat=awri/(awri+1)
   aw=awri*amassn
   if (naps.eq.0) then
      aa=rc1*aw**third+rc2
   else if (naps.eq.1) then
      aa=ay
   else if (naps.eq.2.and.nro.eq.1) then
      aa=aaa
   else
      call error('csunr1','illegal naps',' ')
   endif
   const=(2*pi**2)/(cwaven*rat)**2

   !--do loop over all l states
   do l=1,nls
      if (lfw.eq.0) njs=nint(res(inow+5))
      if (lfw.eq.1) njs=nint(res(inow+4))
      ll=nint(res(inow+2))
      inow=inow+6

      !do loop  over all j states
      do j=1,njs
         gfx=0
         gxx=0
         if (lfw.le.0) then
            muf=0
            dx=res(inow)
            aj=res(inow+1)
            amun=res(inow+2)
            gnox=res(inow+3)
            ggx=res(inow+4)
            inow=inow+6
         else
            muf=nint(res(inow+3))
            nep6=nint(res(inow+4))
            dx=res(inow+6)
            aj=res(inow+7)
            amun=res(inow+8)
            gnox=res(inow+9)
            ggx=res(inow+10)
            ! save starting location for fission widths
            ifst=inow+12
            inow=inow+6+nep6
         endif
         gj=(2*aj+1)/(4*spi+2)
         mu=int(amun)
         nu= muf
         lamda=0
         ! interpolate parameters at energy of interest
         if (lfw.ne.0) then
            i1=iest
            if (ie.gt.1) i1=iest+ie-2
            i2=ifst
            if (ie.gt.1) i2=ifst+ie-2
            call terp1(res(i1),res(i2),res(i1+1),res(i2+1),e,gfx,2)
         endif
         e2=sqrt(e)
         k=rat*e2*cwaven
         rho=k*aa
         rhoc=k*ay
         ! calculate penetrability (vl) and phase shift(ps)
         call unfac(ll,rho,rhoc,amun,vl,ps)
         vl=vl*e2
         ! calculate potential scattering
         if (j.eq.1) spot=4*pi*(2*ll+1)*(sin(ps)/k)**2
         ! compute cross section contributions
         gnx=gnox*vl
         diff=gxx
         den=e*dx
         temp=const*gj*gnx/den
         terg=temp*ggx
         ters=temp*gnx
         terf=temp*gfx
         ! calculate fluctuation integrals
         call gnrl(gnx,gfx,ggx,mu,nu,lamda,gs ,diff,1)
         call gnrl(gnx,gfx,ggx,mu,nu,lamda,gc ,diff,2)
         call gnrl(gnx,gfx,ggx,mu,nu,lamda,gff,diff,3)
         gc=gc*terg
         gff=gff*terf
         gs=gs*ters
         ! add interference correction
         add=const*gj*2*gnx*sin(ps)**2
         add=add/(e*dx)
         gs=gs-add
         ! cross sections
         sigp(2)=sigp(2)+gs
         sigp(3)=sigp(3)+gff
         sigp(4)=sigp(4)+gc

      !continue j loop
      enddo
      sigp(2)=sigp(2)+spot

   !--continue l loop
   enddo
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
   if (ifirst.eq.0.and.lfw.eq.0) ifirst=1
   if (lfw.eq.0) go to 220
   if (ifirst.gt.0.and.e.lt.enext.and.&
     enext.gt.wide*elast) go to 220

   !--replace snext with sigp.
   do i=1,4
      snxt(isect,i)=sigp(i)
   enddo
   if (ifirst.gt.0.and.e.eq.enext.and.&
     enext.gt.wide*elast) go to 200
   if (ifirst.gt.0) go to 210
   if (ifirst.lt.0) go to 205
   ifirst=-1
   go to 110
  200 continue
   e=ee
   go to 130
  205 continue
   ifirst=1

   !--interpolate.
  210 continue
   e=ee
   do i=2,4
      y1=slst(isect,i)
      y2=snxt(isect,i)
      call terp1(elast,y1,enext,y2,e,sigp(i),2)
   enddo
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
  220 continue
   return
   end subroutine csunr1

   subroutine csunr2(e,sigp)
   !-------------------------------------------------------------------
   ! Unresolved resonance region (format 2).
   ! Single-level Breit-Wigner formalism.
   ! Energy-dependent parameters.
   ! On initial entry (e=0.), initialization flags are set for all
   ! sections.  On subsequent entries (e.gt.0.), cross sections
   ! are either computed at energy grid points or interpolated
   ! from previously computed values.  The energy grid is the
   ! grid given by the evaluator.  If the energy step is too large
   ! (see wide), parameter interpolation is used. in that panel.
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev
   use endf    ! provides terp1
   use util    ! provides error
   ! externals
   real(kr)::e,sigp(4)
   ! internals
   integer::i,inow,inoww,int,ne,iloc,ie,nls,l,ll,njs,j,jnow
   integer::mu,nu,lamda,i1,i2,nro,ip,ir,iro,idx,naps
   real(kr)::ee,enext,elast,awri,ay,aaa,spi,rat,aw,aa,const,e2,k
   real(kr)::rho,rhoc,aj,amux,amun,amuf,gj,vl,ps,spot
   real(kr)::gnx,gamma,galpha,gbeta,diff,den,enx
   real(kr)::cwaven,dx,gxx,gnox,ggx,gfx
   real(kr)::temp,terg,ters,terf,gs,gc,gff,add,y1,y2
   integer::ifirst=1
   real(kr),parameter::wide=1.26e0_kr
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::small=1.e-8_kr
   real(kr),parameter::zero=0
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--initialize (e=0.)
   if (e.gt.zero) go to 125
   do i=1,20
      ilast(i)=0
   enddo
   go to 210
  125 continue
   ee=e
   ifirst=ilast(isect)
   inow=ibaset(isect)

   ! check sign of res(inow+7).  If < 0, it equals -nro and
   ! res(inow+6) marks the beginning of an energy dependent tab1
   ! record for the scattering radius; if > 0 then res(inow+6)
   ! is the cont record beginning with spin data.
   nro=0
   if (res(inow+7).lt.0.) then
      nro=-nint(res(inow+7))
      inoww=inow+6+2*nint(res(inow+10))+2*nint(res(inow+11))
   else
      inoww=inow
   endif
   int=nint(res(inoww+20))
   ne=nint(res(inoww+23))
   iloc=inoww+30
   if (ifirst.gt.0) go to 100
   enext=e
   elast=0
   enxt(isect)=e
   elst(isect)=0
   ie=1
   go to 120

   !--check energy range
  100 continue
   enext=enxt(isect)
   elast=elst(isect)
   ie=ilast(isect)
   if (e.lt.enext.and.enext.ge.wide*elast) go to 130
   if (e.le.enext) go to 200
   if (ie.eq.ne) go to 120
  110 continue
   elast=enext
   elst(isect)=elast
   do i=1,4
      slst(isect,i)=snxt(isect,i)
   enddo
   ie=ie+1
   enext=res(iloc+(ie-1)*6)
   enxt(isect)=enext
   ilast(isect)=ie
  120 continue
   e=enext

   !--compute unresolved cross sections
  130 continue
   do i=2,4
      sigp(i)=0
   enddo
   ! retrieve starting location for data in a (for this section)
   inow=ibaset(isect)
   ! retrieve nuclide information
   naps=nint(res(inow+5))
   if (res(inow+7).gt.0.) then
      ay=res(inow+7)
   else
      iro=inow+6
      ip=2
      ir=1
      call terpa(ay,e,enx,idx,res(iro),ip,ir)
      inow=inow+6+2*nint(res(iro+4))+2*nint(res(iro+5))
   endif
   spi=res(inow+6)
   aaa=res(inow+7)
   nls=nint(res(inow+10))
   awri=res(inow+12)
   spi=res(inow+6)
   nls=nint(res(inow+10))
   inow=inow+12
   ! calculate channel radius
   rat=awri/(awri+1)
   aw=awri*amassn
   if (naps.eq.0) then
      aa=rc1*aw**third+rc2
   else if (naps.eq.1) then
      aa=ay
   else if (naps.eq.2.and.nro.eq.1) then
      aa=aaa
   else
      call error('csunr2','illegal naps',' ')
   endif
   const=(2*pi**2)/(cwaven*rat)**2
   e2=sqrt(e)
   k=cwaven*rat*e2
   rho=k*aa
   rhoc=k*ay

   !--do loop over all l states
   do l=1,nls
      njs=nint(res(inow+4))
      ll=nint(res(inow+2))
      inow=inow+6

      !--do loop  over all j states
      do j=1,njs
         aj=res(inow)
         int=nint(res(inow+2))
         ne=nint(res(inow+5))
         amux=res(inow+8)
         amun=res(inow+9)
         amuf=res(inow+11)
         jnow=nint(res(inow+4))+inow+6
         inow=inow+12
         gj=(2*aj+1)/(4*spi+2)
         mu=nint(amun)
         nu=nint(amuf)
         lamda=nint(amux)
         ! interpolate parameters at energy of interest
         i1=inow
         if ((i1+6).lt.jnow) then
            do while (res(i1+6).le.e-small)
               i1=i1+6
            enddo
         endif
         i2=i1+6
         call terp1(res(i1),res(i1+1),res(i2),res(i2+1),e,dx,2)
         call terp1(res(i1),res(i1+2),res(i2),res(i2+2),e,gxx,2)
         call terp1(res(i1),res(i1+3),res(i2),res(i2+3),e,gnox,2)
         call terp1(res(i1),res(i1+4),res(i2),res(i2+4),e,ggx,2)
         call terp1(res(i1),res(i1+5),res(i2),res(i2+5),e,gfx,2)
         if (gxx.lt.small) gxx=0
         if (gfx.lt.small) gfx=0
         ! calculate penetrability (vl) and phase shift(ps)
         call unfac(ll,rho,rhoc,amun,vl,ps)
         vl=vl*e2
         ! calculate potential scattering
         if (j.le.1) then
            spot=4*pi*(2*ll+1)*(sin(ps)/k)**2
         endif
         ! compute cross section contributions
         gnx=gnox*vl
         gamma=ggx
         galpha=gnx
         gbeta=gfx
         diff=gxx
         den=e*dx
         temp=const*gj*gnx/den
         terg=temp*gamma
         ters=temp*gnx
         terf=temp*gbeta
         ! calculate fluctuation integrals
         call gnrl(galpha,gbeta,gamma,mu,nu,lamda,gs ,diff,1)
         call gnrl(galpha,gbeta,gamma,mu,nu,lamda,gc ,diff,2)
         call gnrl(galpha,gbeta,gamma,mu,nu,lamda,gff,diff,3)
         gc=gc*terg
         gff=gff*terf
         gs=gs*ters
         ! add interference correction term
         add=const*gj*2*gnx*(sin(ps))**2
         add=add/(e*dx)
         gs=gs-add
         ! cross sections
         sigp(2)=sigp(2)+gs
         sigp(3)=sigp(3)+gff
         sigp(4)=sigp(4)+gc
         inow=jnow

      !--continue j loop
      enddo
      sigp(2)=sigp(2)+spot

   !--continue l loop
   enddo
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
   if (ifirst.gt.0.and.e.lt.enext.and.&
     enext.ge.wide*elast) go to 210

   !--replace snext with sigp
   do i=1,4
      snxt(isect,i)=sigp(i)
   enddo
   if (ifirst.gt.0.and.e.eq.enext.and.&
     enext.ge.wide*elast) go to 185
   if (ifirst.gt.0) go to 200
   if (ifirst.lt.0) go to 190
   ifirst=-1
   go to 110
  185 continue
   e=ee
   go to 130
  190 continue
   ifirst=1

   !--interpolate.
  200 continue
   e=ee
   do i=2,4
      y1=slst(isect,i)
      y2=snxt(isect,i)
      call terp1(elast,y1,enext,y2,e,sigp(i),int)
   enddo
   sigp(1)=sigp(2)+sigp(3)+sigp(4)
  210 continue
   return
   end subroutine csunr2

   subroutine csaa(e,sigp)
   !-------------------------------------------------------------------
   ! Calculates multilevel Adler-Adler cross sections at energy e
   ! for one section (one isotope-one energy range)
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev,bk
   use util    ! provides error
   ! externals
   real(kr)::e,sigp(4)
   ! internals
   integer::i,inow,nls,l,njs,j,nlj,n,ist,li
   real(kr)::rpi,cwaven,awri,ap,delta,arat,eroot,esq,ecub,k
   real(kr)::c,omg,snf,csf,bakt,bakf,bakc
   real(kr)::de,dw,gr,gi,x,psi,chi,theta,ax,y,rew,aimw
   integer::ki=1
   real(kr)::cadler=6.5099897e5_kr
   real(kr),parameter::zero=0
   rpi=sqrt(pi)
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--compute cross sections for this energy
   do i=1,4
      sigp(i)=0
   enddo
   ! retrieve starting location for data in a
   inow=ibaset(isect)
   ! retrieve nuclide information
   awri=res(inow+12)
   ap=res(inow+7)
   nls=nint(res(inow+10))
   li=nint(res(inow+14))
   inow=inow+18
   ! calculate constants
   if (tempr.gt.zero) delta=1/sqrt(4*bk*tempr*e/awri)
   arat=awri/(awri+1)
   eroot=sqrt(abs(e))
   esq=e*e
   ecub=esq*e
   k=cwaven*arat*eroot
   c=cadler/(arat*arat)
   omg=2*k*ap
   snf=sin(omg)
   csf=cos(omg)
   ! calculate background
   bakt=0
   bakf=0
   bakc=0
   if (li.lt.5) call error('csaa','bad li value',' ')
   if (li.ne.6) then
      bakt=res(inow)+res(inow+1)/e+res(inow+2)/esq
      bakt=bakt+res(inow+3)/ecub+res(inow+4)*e+res(inow+5)*esq
      bakt=bakt*c/eroot
   endif
   inow=inow+6
   if (li.ne.5) then
      bakf=res(inow)+res(inow+1)/e+res(inow+2)/esq
      bakf=bakf+res(inow+3)/ecub+res(inow+4)*e+res(inow+5)*esq
      bakf=bakf*c/eroot
   endif
   inow=inow+6
   bakc=res(inow)+res(inow+1)/e+res(inow+2)/esq
   bakc=bakc+res(inow+3)/ecub+res(inow+4)*e+res(inow+5)*esq
   bakc=bakc*c/eroot
   inow=inow+6

   !--calculate resonance contribution
   do l=1,nls
      njs=nint(res(inow+4))
      inow=inow+6
      do j=1,njs
         nlj=nint(res(inow+5))
         inow=inow+6
         ! loop over individual resonances for this l-j state
         do n=1,nlj
            ! loop over reaction types
            ist=inow
            do i=1,4
               if (i.ne.2) then
                  de=res(ist)
                  dw=res(ist+1)
                  gr=res(ist+2)
                  gi=res(ist+3)
                  ist=ist+4
                  x=(de-e)/dw
                  if (tempr.le.zero) then
                     psi=1/(1+x*x)
                     chi=x*psi
                  else
                     theta=2*dw*delta
                     ax=theta*x/2
                     y=theta/2
                     call quickw(ax,y,rew,aimw,ki,tr,ti)
                     psi=rpi*theta*rew/2
                     chi=rpi*theta*aimw/2
                  endif
                  ! compute cross section contributions
                  if (i.eq.1) sigp(i)=sigp(i)+((gr*csf+gi*snf)*psi+&
                    (gi*csf-gr*snf)*chi)/dw
                  if (i.gt.1) sigp(i)=sigp(i)+(gr*psi+gi*chi)/dw
               endif
            enddo
            inow=ist
         enddo
      enddo
   enddo

   !--add background and factors
   sigp(1)=(sigp(1)+bakt)*c/eroot
   ! total
   sigp(1)=sigp(1)+2*c*(1-csf)/e
   ! fission
   sigp(3)=(sigp(3)+bakf)*c/eroot
   ! capture
   sigp(4)=(sigp(4)+bakc)*c/eroot
   if (li.ne.6) then
      sigp(2)=sigp(1)-(sigp(3)+sigp(4))
   else
      sigp(1)=sigp(3)+sigp(4)
   endif
   return
   end subroutine csaa

   subroutine facphi(l,rho,phi)
   !-------------------------------------------------------------------
   ! Calculates phase shift.
   !-------------------------------------------------------------------
   ! externals
   integer::l
   real(kr)::rho,phi
   ! internals
   real(kr)::r2,r4,top,bot
   real(kr),parameter::test=1.e-6_kr

   r2=rho*rho
   if (l.eq.0) then
      phi=rho
   else if (l.eq.1) then
      phi=rho-atan(rho)
   else if (l.eq.2)then
      phi=rho-atan(3*rho/(3-r2))
      if ((phi/rho).lt.test) phi=0
   else if (l.eq.3) then
      phi=rho-atan((15*rho-rho*r2)/(15-6*r2))
      if ((phi/rho).lt.test) phi=0
   else
      r4=r2*r2
      top=105*rho-10*r2*rho
      bot=105-45*r2+r4
      phi=rho-atan(top/bot)
      if ((phi/rho).lt.test) phi=0
   endif
   return
   end subroutine facphi

   subroutine unfac(l,rho,rhoc,amun,vl,ps)
   !-------------------------------------------------------------------
   ! Calculates the penetrability factor (vl) and phase shift (ps).
   !-------------------------------------------------------------------
   ! externals
   integer::l
   real(kr)::rho,rhoc,amun,vl,ps
   ! internals
   real(kr)::r2,r4

   r2=rho*rho
   if (l.eq.0) then
      vl=amun
      ps=rhoc
   else if (l.eq.1) then
      vl=amun*r2/(1+r2)
      ps=rhoc-atan(rhoc)
   else if (l.eq.2) then
      r4=r2*r2
      vl=amun*r4/(9+3*r2+r4)
      ps=rhoc-atan(3*rhoc/(3-rhoc*rhoc))
   endif
   return
   end subroutine unfac

   subroutine gnrl(galpha,gbeta,gamma,mu,nu,lamda,s,df,id)
   !-------------------------------------------------------------------
   ! Calculates fluctuation integrals for unresolved resonances.
   !-------------------------------------------------------------------
   ! externals
   integer::mu,nu,lamda,id
   real(kr)::galpha,gbeta,gamma,s,df
   ! internals
   integer::j,k,l
   real(kr)::xj
   real(kr),dimension(10,4)::qw=reshape((/&
     1.1120413e-1_kr,2.3546798e-1_kr,2.8440987e-1_kr,&
     2.2419127e-1_kr,0.10967668e0_kr,.030493789e0_kr,&
     0.0042930874e0_kr,2.5827047e-4_kr,4.9031965e-6_kr,&
     1.4079206e-8_kr,0.033773418e0_kr,0.079932171e0_kr,&
     0.12835937e0_kr,0.17652616e0_kr,0.21347043e0_kr,&
     0.21154965e0_kr,0.13365186e0_kr,0.022630659e0_kr,&
     1.6313638e-5_kr,2.745383e-31_kr,3.3376214e-4_kr,&
     0.018506108e0_kr,0.12309946e0_kr,0.29918923e0_kr,&
     0.33431475e0_kr,0.17766657e0_kr,0.042695894e0_kr,&
     4.0760575e-3_kr,1.1766115e-4_kr,5.0989546e-7_kr,&
     1.7623788e-3_kr,0.021517749e0_kr,0.080979849e0_kr,&
     0.18797998e0_kr,0.30156335e0_kr,0.29616091e0_kr,&
     0.10775649e0_kr,2.5171914e-3_kr,8.9630388e-10_kr,&
     0.e0_kr/),(/10,4/))
   real(kr),dimension(10,4)::qp=reshape((/&
     3.0013465e-3_kr,7.8592886e-2_kr,4.3282415e-1_kr,&
     1.3345267e0_kr,3.0481846e0_kr,5.8263198e0_kr,&
     9.9452656e0_kr,1.5782128e1_kr,23.996824e0_kr,&
     36.216208e0_kr,1.3219203e-2_kr,7.2349624e-2_kr,&
     0.19089473e0_kr,0.39528842e0_kr,0.74083443e0_kr,&
     1.3498293e0_kr,2.5297983e0_kr,5.2384894e0_kr,&
     13.821772e0_kr,75.647525e0_kr,1.0004488e-3_kr,&
     0.026197629e0_kr,0.14427472e0_kr,0.44484223e0_kr,&
     1.0160615e0_kr,1.9421066e0_kr,3.3150885e0_kr,&
     5.2607092e0_kr,7.9989414e0_kr,12.072069e0_kr,&
     0.013219203e0_kr,0.072349624e0_kr,0.19089473e0_kr,&
     0.39528842e0_kr,0.74083443e0_kr,1.3498293e0_kr,&
     2.5297983e0_kr,5.2384894e0_kr,13.821772e0_kr,&
     75.647525e0_kr/),(/10,4/))
   real(kr),parameter::zero=0

   s=0
   if (galpha.le.zero) return
   if (gamma.le.zero) return
   if (gbeta.lt.zero) return
   if (gbeta.gt.zero.and.df.lt.zero) return

   if (gbeta.eq.zero.and.df.eq.zero) then
      if (id.eq.1) then
         do j=1,10
            s=s+qw(j,mu)*qp(j,mu)*qp(j,mu)/(galpha*qp(j,mu)+gamma)
         enddo
      else if (id.eq.2) then
         do j=1,10
            s=s+qw(j,mu)*qp(j,mu)/(galpha*qp(j,mu)+gamma)
         enddo
      endif
      return
   endif

   if (gbeta.eq.zero.and.df.gt.zero) then
      if (id.eq.1) then
         do j=1,10
            xj=qp(j,mu)
            do k=1,10
               s=s+qw(j,mu)*qw(k,lamda)*xj*xj/(galpha*xj+gamma&
                 +df*qp(k,lamda))
            enddo
         enddo
      else if (id.eq.2) then
         do j=1,10
            xj=qp(j,mu)
            do k=1,10
               s=s+qw(j,mu)*qw(k,lamda)*xj/(galpha*xj+gamma&
                 +df*qp(k,lamda))
            enddo
         enddo
      endif
      return
   endif

   if (gbeta.gt.zero.and.df.eq.0) then
      if (id.eq.1) then
         do j=1,10
            xj=qp(j,mu)
            do k=1,10
               s=s+qw(j,mu)*qw(k,nu)*xj*xj/(galpha*xj&
                 +gbeta*qp(k,nu)+gamma)
            enddo
         enddo
      else if (id.eq.2) then
         do j=1,10
            xj=qp(j,mu)
            do k=1,10
               s=s+qw(j,mu)*qw(k,nu)*xj/(galpha*xj&
                 +gbeta*qp(k,nu)+gamma)
            enddo
         enddo
      else if (id.eq.3) then
         do j=1,10
            do k=1,10
               s=s+qw(j,mu)*qw(k,nu)*qp(j,mu)*qp(k,nu)&
                 /(galpha*qp(j,mu)+gbeta*qp(k,nu)+gamma)
            enddo
         enddo
      endif
      return
   endif

   if (gbeta.gt.zero.and.df.gt.zero) then
      if (id.eq.1) then
         do j=1,10
            xj=qp(j,mu)
            do k=1,10
               do l=1,10
                  s=s+qw(j,mu)*qw(k,nu)*qw(l,lamda)*xj*xj&
                    /(galpha*xj+gbeta*qp(k,nu)+gamma&
                    +df*qp(l,lamda))
               enddo
            enddo
         enddo
      else if (id.eq.2) then
         do j=1,10
            do k=1,10
               do l=1,10
                  s=s+qw(j,mu)*qw(k,nu)*qw(l,lamda)*qp(j,mu)/&
                    (galpha*qp(j,mu)+gbeta*qp(k,nu)+gamma&
                    +df*qp(l,lamda))
               enddo
            enddo
         enddo
      else if (id.eq.3) then
         do j=1,10
            do k=1,10
               do l=1,10
                  s=s+qw(j,mu)*qw(k,nu)*qw(l,lamda)*qp(j,mu)&
                    *qp(k,nu)/(galpha*qp(j,mu)+gbeta*qp(k,nu)&
                    +gamma+df*qp(l,lamda))
               enddo
            enddo
         enddo
      endif
      return
   endif
   return
   end subroutine gnrl

   subroutine emerge(nin,ngrid,ngp,nres,nrtot,iold,inew,nscr)
   !-------------------------------------------------------------------
   ! Merge energies from input grid with resonance grid (if any).
   ! Compute all cross sections on full grid and add resonance cross
   ! sections where needed.  Accumulate the total cross sections.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use endf   ! provides endf routines and variables
   use util   ! provides loada,finda,openz,repoz,closz
   ! externals
   integer::nin,ngrid,ngp,nres,nrtot,iold,inew,nscr
   ! internals
   integer::nneg,ntot,i,in,ig,inn,nss,iss,nb,nw,idis,it
   integer::imtr,itt,k,istart,iend,j,ib,isave,ir,ith
   real(kr)::er,eg,en,e,thresh,sn,sg,enext,awrx,qx
   real(kr)::res(nsig+1),tot(10)
   real(kr)::aa(1)
   real(kr),dimension(:),allocatable::bufo,bufn,bufg,bufr
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::test=1.e-10_kr
   real(kr),parameter::finity=.99e12_kr
   real(kr),parameter::small=1.e-8_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--set up storage allocations.
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))
   allocate(bufg(nbufg))
   allocate(bufr(nbufr))
   allocate(scr(npage+50))
   nneg=0
   ntot=nmtr+1
   do i=1,nmtr
      tot(i+1)=0
   enddo

   !--assign scratch units.
   iold=14
   inew=15

   !--merge background grid with resonance grid
   in=0
   ig=1
   call finda(ig,aa,1,ngrid,bufg,nbufg)
   eg=aa(1)
   er=finity
   if (nrtot.gt.0) then
      ir=1
      call finda(ir,res,nsig+1,nres,bufr,nbufr)
      er=res(1)
   endif
  130 continue
   in=in+1
   en=eg
   if (er.lt.eg) en=er
   tot(1)=en
   inn=in
   if (ig.eq.ngp.and.en.eq.eg) inn=-in
   call loada(inn,tot,ntot,iold,bufo,nbuf)
  135 continue
   if (en.ne.er) go to 150
   if (ir.lt.nrtot) go to 140
   er=finity
   go to 150
  140 continue
   ir=ir+1
   call finda(ir,res,nsig+1,nres,bufr,nbufr)
   er=res(1)
   go to 135
  150 continue
   if (en.ne.eg) go to 130
   if (ig.eq.ngp) go to 160
   ig=ig+1
   call finda(ig,aa,1,ngrid,bufg,nbufg)
   eg=aa(1)
   go to 150
  160 continue
   ngo=in

   !--find next reaction on input file
   call openz(nscr,1)
   call repoz(nin)
   call repoz(nscr)
   nsc=0
  210 continue
   call contio(nin,0,nscr,scr,nb,nw)
   nss=1
   if (mfh.eq.10) nss=n1h
   iss=nss
   if (math.gt.0) go to 220
   call atend(0,nscr)
   go to 510
  220 continue
   if (mth.eq.0) go to 210
   if (iss.eq.nss) then ! needed for MF10
      if (mfh.ne.23.and.awin.ne.zero) awrx=c2h/awin
      qx=c2h
      if (awin.ne.0) then
          thr6=-qx*(awrx+1)/awrx
      else
          thr6=-qx
      endif
      if (thr6.lt.zero) thr6=0
   endif
   e=0
   call gety1(e,thresh,idis,sn,nin,scr)
   thresh=sigfig(thresh,7,0)

   !--identify resonance reactions
   itype=0
   if (nrtot.ne.0.and.mfh.eq.3) then
      if (mth.eq.2) itype=2
      if (mth.eq.18) itype=3
      if (mth.eq.19) itype=3
      if (mth.eq.102) itype=4
      if (nmtres.gt.2) then
         do i=3,nmtres
            if (mth.ne.18.and.mth.ne.19.and.mth.eq.mmtres(i)) then
               itype=2+i
            endif
         enddo
      endif
      if (lrx.ne.0.and.mth.eq.51) itype=5
   endif

   !--set up first resonance point.
   er=finity
   if (itype.ne.0) then
      ir=1
      call finda(ir,res,nsig+1,nres,bufr,nbufr)
      er=res(1)
      if (er.lt.thresh) thresh=sigfig(er,7,0)
   endif
   in=0
   ith=0
   it=0
   ig=0

   !--compute cross section at next grid point
  340 continue
   ig=ig+1
   call finda(ig,tot,ntot,iold,bufo,nbuf)
   eg=tot(1)
   sg=tot(2)
   sn=0
   if (thresh-eg.gt.test*thresh.and.itype.eq.0) go to 370
   call gety1(eg,enext,idis,sn,nin,scr)
   if (thresh.gt.one.and.abs(thresh-eg).lt.test*thresh) sn=0
   ! backgrounds in a range of unresolved-smooth overlap
   ! are arbitrarily assigned to the unresolved component
   ! this only applies to total, elastic, fission and capture.
   ! for lrf=7 evaluations that can have additional resonance reactions,
   ! we still need to add the background.
   if (eg.ge.eresr.and.eg.lt.eresh.and.itype.gt.0.and.itype.lt.5) sn=0
  345 continue
   if (er-eg.gt.test*eg) go to 360
   if (abs(eg-er).lt.test*eg) go to 355
   ir=ir+1
   call finda(ir,res,nsig+1,nres,bufr,nbufr)
   er=res(1)
   go to 345
  355 continue
   sn=sn+res(1+itype)
   if (ir.ge.nrtot) then
      er=finity
   else
      ir=ir+1
      call finda(ir,res,nsig+1,nres,bufr,nbufr)
      er=res(1)
   endif
  360 continue
   in=in+1
   if (itype.eq.2.and.sn.le.small) then
      nneg=nneg+1
      if (nneg.eq.1) then
         if (sn .le. 0.0) then
            call mess('emerge',&
            'nonpositive elastic cross sections found.',' ')
         else
            call mess('emerge',&
            'tiny elastic cross sections replaced by the lower limit.',' ')
         end if
      endif
      sn=small
   endif
   sn=sigfig(sn,7,0)
   tot(2)=sn
   if (ith.eq.0.and.sn.gt.zero) ith=in
   inn=in
   if (ig.eq.ngo) inn=-in
   call loada(inn,tot,2,ngrid,bufg,nbufg)
   tot(2)=sg

   !--accumulate redundant reactions.
  370 continue
   it=it+1
   if (thresh-eg.gt.test*thresh.and.itype.eq.0) go to 440
   if (mth.eq.10) go to 440
   if (mfh.ne.3) go to 430
   if (mth.ge.46.and.mth.le.49) go to 440
   if (mth.gt.200.and.mth.lt.mpmin) go to 440
   do 410 imtr=1,nmtr
   if (mtr(imtr).ne.1) go to 375
   go to 400
  375 continue
   if (mtr(imtr).ne.3) go to 380
   if (mth.eq.2) go to 410
   go to 400
  380 continue
   if (mtr(imtr).ne.4) go to 381
   if (mth.lt.51.or.mth.gt.91) go to 410
   if (sn.eq.zero) go to 410
   go to 400
  381 continue
   if (mtr(imtr).ne.103) go to 382
   if (mth.lt.mpmin.or.mth.gt.mpmax) go to 410
   if (sn.eq.zero) go to 410
   go to 400
  382 continue
   if (mtr(imtr).ne.104) go to 383
   if (mth.lt.mdmin.or.mth.gt.mdmax) go to 410
   if (sn.eq.zero) go to 410
   go to 400
  383 continue
   if (mtr(imtr).ne.105) go to 384
   if (mth.lt.mtmin.or.mth.gt.mtmax) go to 410
   if (sn.eq.zero) go to 410
   go to 400
  384 continue
   if (mtr(imtr).ne.106) go to 385
   if (mth.lt.m3min.or.mth.gt.m3max) go to 410
   if (sn.eq.zero) go to 410
   go to 400
  385 continue
   if (mtr(imtr).ne.107) go to 386
   if (mth.lt.m4min.or.mth.gt.m4max) go to 410
   if (sn.eq.zero) go to 410
   go to 400
  386 continue
   if (mtr(imtr).ne.18) go to 410
   if (mth.lt.19.or.mth.gt.21.and.mth.ne.38) go to 410
  400 continue
   if (it.lt.mtrt(imtr)) then
        mtrt(imtr)=it
       if (mtrt(imtr).gt.1) mtrt(imtr)=mtrt(imtr)-1
   endif
   tot(1+imtr)=tot(1+imtr)+sn
  410 continue
  430 continue
   if (mfh.ne.23) go to 440
   do 435 imtr=1,nmtr
   if (mtr(imtr).ne.501) go to 433
   if (mth.eq.515.or.mth.eq.517) go to 435
   go to 434
  433 continue
   if (mtr(imtr).ne.522) go to 435
   if (mth.lt.534.or.mth.gt.572) go to 435
  434 continue
   if (it.lt.mtrt(imtr)) then
       mtrt(imtr)=it
       if (mtrt(imtr).gt.1) mtrt(imtr)=mtrt(imtr)-1
   endif
   tot(1+imtr)=tot(1+imtr)+sn
  435 continue
  440 continue
   itt=it
   if (ig.eq.ngo) itt=-it
   call loada(itt,tot,ntot,inew,bufn,nbuf)
   if (ig.lt.ngo) go to 340

   !--finished with this reaction
   if (ith.gt.1) ith=ith-1
   if (iss.eq.nss) nxc=nxc+1
   mfs(nxc)=mfh
   mts(nxc)=mth
   if (iss.eq.nss) ncs(nxc)=1
   ncs(nxc)=ncs(nxc)+2+int(((in-ith+1)+2)/3)
   scr(5)=1
   scr(6)=in-ith+1
   scr(7)=in-ith+1
   scr(8)=2
   k=8
   if (ith.gt.0) then
      do ib=1,ith
         call finda(ib,tot,2,ngrid,bufg,nbufg)
      enddo
   endif
   istart=ith
   nb=1
   do while (nb.ne.0)
      iend=in
      if ((iend-istart).ge.npage/2) iend=istart+npage/2-1
      j=k-1
      ib=istart-1
      do while (ib.lt.iend)
         j=j+2
         ib=ib+1
         call finda(ib,tot,2,ngrid,bufg,nbufg)
         scr(j)=tot(1)
         scr(j+1)=tot(2)
      enddo
      nw=j+1
      if (k.ne.0) then
         k=0
         call tab1io(0,0,nscr,scr,nb,nw)
      else
         call moreio(0,0,nscr,scr,nb,nw)
      endif
      if (nb.ne.0) istart=iend+1
   enddo
   iss=iss-1
   if (iss.gt.0) go to 220
   call tosend(nin,0,0,scr)
   call asend(0,nscr)
   isave=iold
   iold=inew
   inew=isave
   go to 210

   !--merge is finished.
  510 continue

   if (nneg.gt.0) write(nsyso,'(/&
     &'' number of nonpositive cross sections removed ='',i8)') nneg
   write(nsyso,'(&
     &'' number of points in final unionized grid     ='',i8)') ngo
   deallocate(bufr)
   deallocate(bufg)
   deallocate(bufn)
   deallocate(bufo)
   call closz(-inew)
   call closz(nin)
   call closz(-ngrid)
   call closz(-nres)
   return
   end subroutine emerge

   subroutine recout(iold,nscr,nrtot)
   !-------------------------------------------------------------------
   ! Add a new material to the output pendf tape.
   !-------------------------------------------------------------------
   use endf   ! provides endf routines and variable
   use util   ! provides error,closz,repoz
   ! externals
   integer::iold,nscr,nrtot
   ! internals
   integer::i152,nb,nw,nwd,i,j,nc,no2,no3,imtr,np,nxcc
   integer::l,ntot,lis3,lfs,mtl,istart,k,last,iend,ib,mtd
   integer::mfl,n1l,n2l
   integer::iang,imt,idone
   real(kr)::resl(1+ncoef*nmtres)
   real(kr),dimension(:),allocatable::bufo,bufn,bufl
   real(kr),dimension(:),allocatable::scr,dict
   real(kr)::tot(10)
   character::strng*60
   character(4)::tz(17)
   real(kr)::z(17)
   equivalence(tz(1),z(1))
   real(kr),parameter::emin=1.e-5_kr
   real(kr),parameter::zero=0

   !--initialize.
   allocate(scr(npage+50))
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))
   allocate(bufl(nbufl))
   i152=0
   if (nunr.gt.0) i152=1
   iang=16

!  --set flag for presence of file 3 with incident neutrons.  if
!    none found increment nxc since we'll insert a dummy mf3, mt1
!    section into the output tape later.
   no3=0
   if (nint(zain).eq.1) then
      do i=1,nxc
         if (mfs(i).eq.3)no3=1
      enddo
      if (no3.eq.0) nxc=nxc+1
   endif

   !--write control records.
   scr(1)=za
   scr(2)=awr
   if (iverf.eq.6) lrp=2
   scr(3)=lrp
   scr(4)=lfi
   scr(5)=0
   scr(6)=0
   if (iverf.eq.4) scr(6)=nxc+nmtr+i152
   math=mata
   mfh=1
   mth=451
   nsh=1
   nw=6
   call contio(0,nout,0,scr,nb,nw)
   if (iverf.ne.4) then
      scr(1)=elis
      scr(2)=sta
      scr(3)=lis
      scr(4)=lis0
      scr(5)=0
      scr(6)=nfor
      if (iverf.eq.6) scr(6)=6
      call contio(0,nout,0,scr,nb,nw)
   endif
   if (iverf.eq.6) then
      scr(1)=awin
      scr(2)=efmax
      scr(3)=lrel
      scr(4)=0
      scr(5)=int(10*zain)
      scr(6)=nver
      call contio(0,nout,0,scr,nb,nw)
   endif
   scr(1)=tempr
   if (tempr.eq.0) scr(1)=tempi
   scr(2)=err
   scr(3)=0
   if (iverf.eq.6) scr(3)=1
   scr(4)=0
   nwd=ncards*17
   scr(5)=nwd
   scr(6)=0
   if (iverf.ge.5) scr(6)=nxc+nmtr+i152
   ncs(1)=ncs(1)+nxc+nmtr+i152
   if (ncoef.gt.1) then
      scr(6)=scr(6)+nmtres-1
      ncs(1)=ncs(1)+nmtres-1
   endif

   !--write descriptive information and dictionary.
   nw=6
   nc=0
   do i=1,ncards
      do j=1,17
         tz(j)=card(j+nc)
      enddo
      do j=1,17
         scr(j+nw)=z(j)
      enddo
      nw=nw+17
      nc=nc+17
   enddo
   nxcc=nxc
   if (nint(zain).eq.1.and.no3.eq.0) nxcc=nxcc-1
   scr(6)=nxcc+nmtr+i152
   call hdatio(0,nout,0,scr,nb,nw)
   no2=1
   if (nxc.ne.0) then
      nw=(nxc+nmtr+i152)*6
      if (ncoef.gt.1) nw=nw+(nmtres-1)*6
      allocate(dict(nw))
      j=0
      imtr=1
      idone=0
      do i=1,nxcc
         if (mfs(i).eq.2) no2=0
         if (mfs(i).eq.3.or.mfs(i).eq.23) then
            do while (imtr.le.nmtr.and.mts(i).ge.mtr(imtr))
               dict(j+1)=0
               dict(j+2)=0
               dict(j+3)=mfs(i)
               if (mfs(i).eq.3.and.mtr(imtr).eq.1.and.awin.eq.0) then
                  dict(j+4)=3
               else
                  dict(j+4)=mtr(imtr)
               endif
               np=ngo-mtrt(imtr)+1
               dict(j+5)=3+int((np+2)/3)
               dict(j+6)=0
               j=j+6
               imtr=imtr+1
            enddo
         endif
         if (no3.eq.0.and.nint(zain).eq.1.and.mfs(i).gt.3)then
             no3=-1
             dict(j+1)=0
             dict(j+2)=0
             dict(j+3)=3
             dict(j+4)=1
             dict(j+5)=4
             dict(j+6)=0
             j=j+6
        endif
        if (ncoef.gt.1.and.(i.eq.nxc.or.mfs(i).gt.4).and.idone.eq.0) then
            idone=1
            do k=1,nmtres
               if (k.eq.1.or.k.gt.2) then
                  dict(j+1)=0
                  dict(j+2)=0
                  dict(j+3)=4
                  if (k.eq.1) then
                     dict(j+4)=mmtres(1)
                     dict(j+5)=mcards(1)
                  endif
                  if (k.gt.2) then
                     dict(j+4)=mmtres(k)
                     dict(j+5)=mcards(k)
                  endif
                  dict(j+6)=0
                  j=j+6
               endif
            enddo
         endif
         dict(j+1)=0
         dict(j+2)=0
         dict(j+3)=mfs(i)
         dict(j+4)=mts(i)
         dict(j+5)=ncs(i)
         dict(j+6)=0
         j=j+6
         if (mfs(i).eq.2.and.i152.ne.0) then
            dict(j+1)=0
            dict(j+2)=0
            dict(j+3)=2
            dict(j+4)=152
            dict(j+5)=3+nunr
            dict(j+6)=0
            j=j+6
         endif
      enddo
      nw=nxcc+nmtr+i152
      if (ncoef.gt.1) then
         nw=nw+nmtres-1
      endif
      call dictio(0,nout,0,dict,nb,nw)
      deallocate(dict)
   endif
   call asend(nout,0)
   call afend(nout,0)

   !--write default mf2/mt151.
   !--if unresolved present, write mf2/mt152.
   if (no2.le.0) then
      scr(1)=za
      scr(2)=awr
      scr(3)=0
      scr(4)=0
      scr(5)=1
      scr(6)=0
      mfh=2
      mth=151
      call contio(0,nout,0,scr,nb,nw)
      scr(2)=1
      call contio(0,nout,0,scr,nb,nw)
      scr(1)=emin
      ! use top of resolved range for upper limit
      scr(2)=eresh
      if (eresr.lt.eresh) scr(2)=eresr
      scr(5)=0
      call contio(0,nout,0,scr,nb,nw)
      scr(1)=spin
      scr(2)=ascat
      call contio(0,nout,0,scr,nb,nw)
      call asend(nout,0)
      if (i152.gt.0) then
         mfh=2
         mth=152
         call contio(0,nout,0,sunr,nb,nw)
         l=7
         call listio(0,nout,0,sunr(l),nb,nw)
         do while (nb.ne.0)
            l=l+nw
            call moreio(0,nout,0,sunr(l),nb,nw)
         enddo
         call asend(nout,0)
      endif
      call afend(nout,0)
   endif

   !--write file 3 using reactions from scratch tape
   !--and adding desired redundant reactions.
   ntot=nmtr+1
   call repoz(nscr)
   call contio(nscr,0,0,scr,nb,nw)
   za=c1h
   awr=c2h
   lis3=l1h
   lfs=l2h
   n1l=n1h
   n2l=n2h
   mfl=mfh
   mtl=mth
   !--test mfl=0 (occurs when all mf3 data are redundant and removed)
   if (nint(zain).eq.1.and.(mfl.eq.0.or.mfl.gt.3)) then
      scr(3)=0
      scr(4)=99
      scr(5)=0
      scr(6)=0
      mfh=3
      mth=1
      call contio(0,nout,0,scr,nb,nw)
      scr(1)=tempr
      scr(2)=0
      scr(3)=0
      scr(4)=0
      scr(5)=1
      scr(6)=2
      scr(7)=2
      scr(8)=2
      scr(9)=emin
      scr(10)=0
      scr(11)=eresh
      scr(12)=0
      nw=12
      call tab1io(0,nout,0,scr,nb,nw)
      call asend(nout,0)
      call afend(nout,0)
   !--if no other mf3 sections on scratch, copy the rest
      if(mfl.eq.0) go to 272
      goto 270
   endif
   mth=1
   if (awin.eq.0) then
      mth=3
   endif
   if (mfh.eq.23) mth=501
   scr(3)=0
   scr(4)=99
   imtr=1
   call contio(0,nout,0,scr,nb,nw)

   !--create a new section for a redundant reaction.
  210 continue
   istart=mtrt(imtr)
   np=ngo-istart+1
   if (np.le.0) then
      write(strng,'(''for mf'',i2,'' mt'',i3,&
        &'' np:'',i6,''-'',i6,''+1='',i6)') mfh,mth,ngo,istart,np
      call error('recout',strng,' ')
   endif
   scr(1)=tempr
   scr(2)=0
   if (mth.eq.18) scr(2)=sigfig(q18,7,0)
   scr(3)=0
   scr(4)=0
   scr(5)=1
   scr(6)=np
   scr(7)=np
   scr(8)=2
   k=8
   if (istart.gt.1) then
      last=istart-1
      i=0
      do while (i.lt.last)
         i=i+1
         call finda(i,tot,ntot,iold,bufo,nbuf)
      enddo
   endif
   nb=1
   do while (nb.ne.0)
      iend=ngo
      if ((iend-istart).ge.npage/2) iend=istart+npage/2-1
      j=k-1
      ib=istart-1
      do while (ib.lt.iend)
         j=j+2
         ib=ib+1
         call finda(ib,tot,ntot,iold,bufo,nbuf)
         scr(j)=tot(1)
         scr(j+1)=sigfig(tot(imtr+1),7,0)
      enddo
      nw=j+1
      if (k.ne.0) then
         k=0
         call tab1io(0,nout,0,scr,nb,nw)
      else
         call moreio(0,nout,0,scr,nb,nw)
      endif
      if (nb.ne.0) istart=iend+1
   enddo
   call asend(nout,0)
   imtr=imtr+1
   if (imtr.gt.nmtr) go to 270
   mtd=mtr(imtr)
  250 continue
   if (mtl.gt.mtd) go to 260

   !--this is a non-redundant reaction.
   mth=mtl
   scr(1)=za
   scr(2)=awr
   scr(3)=lis3
   scr(4)=lfs
   scr(5)=0
   scr(6)=0
   call contio(0,nout,0,scr,nb,nw)
   call tosend(nscr,nout,0,scr)
   call contio(nscr,0,0,scr,nb,nw)
   lis3=l1h
   lfs=l2h
   mtl=mth
   go to 250

   !--this is a redundant reaction.
  260 continue
   mth=mtd
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=99
   scr(5)=0
   scr(6)=0
   call contio(0,nout,0,scr,nb,nw)
   go to 210

   !--all remaining reactions are non-redundant.
  270 continue
   scr(1)=za
   scr(2)=awr
   scr(3)=lis3
   scr(4)=lfs
   scr(5)=n1l
   scr(6)=n2l
   mfh=mfl
   mth=mtl
   call contio(0,nout,0,scr,nb,nw)
   call tofend(nscr,nout,0,scr)

   !--process angular coefficients
  272 continue
   if (ncoef.gt.1) then
      do imt=2,nmtres
         if (imt.eq.2) l=1
         if (imt.gt.2) l=imt
         k=0
         do i=1,nrtot
            call finda(i,resl,1+ncoef*nmtres,iang,bufl,nbufl)
            if (resl(1+l+nmtres).ne.zero) exit
            k=i
         enddo
         mfh=4
         mth=mmtres(imt)
         if (imt.eq.2) mth=mmtres(1)
         scr(1)=za
         scr(2)=awr
         scr(3)=0
         scr(4)=1
         scr(5)=0
         scr(6)=0
         call contio(0,nout,0,scr,nb,nw)
         scr(1)=0
         scr(2)=awr
         scr(3)=0
         scr(4)=2
         scr(5)=0
         scr(6)=0
         call contio(0,nout,0,scr,nb,nw)
         scr(1)=0
         scr(2)=0
         scr(3)=0
         scr(4)=0
         scr(5)=1
         scr(6)=nrtot-k
         scr(7)=nrtot-k
         scr(8)=2
         nw=8
         call tab2io(0,nout,0,scr,nb,nw)
         if (imt.eq.2) l=1
         if (imt.gt.2) l=imt
         do i=k+1,nrtot
            call finda(i,resl,1+ncoef*nmtres,iang,bufl,nbufl)
            scr(1)=0
            scr(2)=resl(1)
            scr(3)=0
            scr(4)=0
            scr(5)=0
            scr(6)=0
            if (resl(1+l).ne.zero) then
               do j=2,ncoef
                  if (resl(1+l+(j-1)*nmtres).ne.zero) then
                     scr(5+j)=resl(1+l+(j-1)*nmtres)
                     scr(5)=scr(5)+1
                  endif
               enddo
            else
               scr(5)=1
               scr(7)=0
            endif
            call listio(0,nout,0,scr,nb,nw)
         enddo
         call asend(nout,0)
      enddo
      call afend(nout,0)
   endif
   call tomend(nscr,nout,0,scr)

   call closz(-iold)
   call closz(nscr)
   deallocate(scr)
   deallocate(bufn)
   deallocate(bufo)
   return
   end subroutine recout

   subroutine quickw(ax,y,rew,aimw,ki,tr,ti)
   !-------------------------------------------------------------------
   ! Used to calculate Psi and Chi line shape functions.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   integer::ki
   real(kr)::ax,y,rew,aimw
   real(kr)::tr(62,62),ti(62,62)
   ! internals
   integer::ii,jj,i,j,n
   real(kr)::rpi,aki,x,test,p,q,p2,q2,pq,hp,hq,hq2,hp2
   real(kr)::a1,a2,a3,a4,a5,d1,d2
   real(kr),parameter::break1=36.e0_kr
   real(kr),parameter::break2=144.e0_kr
   real(kr),parameter::break3=10000.e0_kr
   real(kr),parameter::c1=.2752551e0_kr
   real(kr),parameter::c2=2.724745e0_kr
   real(kr),parameter::c3=.5124242e0_kr
   real(kr),parameter::c4=.05176536e0_kr
   real(kr),parameter::c5=1.1283792e0_kr
   real(kr),parameter::zero=0
   rpi=sqrt(pi)

   aki=1
   if (ax.lt.zero) aki=-1
   x=abs(ax)
   test=x*x+y*y
   if (test.lt.break1) then
      ii=int(x*10)
      jj=int(y*10)
      i=ii+2
      j=jj+2
      n=j-1
      p=10*x-ii
      q=10*y-jj
      p2=p*p
      q2=q*q
      pq=p*q
      hp=p/2
      hq=q/2
      hq2=q2/2
      hp2=p2/2
      a1=hq2-hq
      a2=hp2-hp
      a3=1+pq-p2-q2
      a4=hp2-pq+hp
      a5=hq2-pq+hq
      rew=a1*tr(i,n)+a2*tr(i-1,j)+a3*tr(i,j)+a4*tr(i+1,j)&
        +a5*tr(i,j+1)+pq*tr(i+1,j+1)
      if (ki.gt.0) then
         aimw=a1*ti(i,n)+a2*ti(i-1,j)+a3*ti(i,j)+a4*ti(i+1,j)&
           +a5*ti(i,j+1)+pq*ti(i+1,j+1)
         aimw=aimw*aki
      endif
   else if (test.lt.break2) then
      a1=x**2-y**2
      a2=2*x*y
      a3=a2**2
      a4=a1-c1
      a5=a1-c2
      d1=c3/(a4**2+a3)
      d2=c4/(a5**2+a3)
      rew=d1*(a2*x-a4*y)+d2*(a2*x-a5*y)
      if (ki.gt.0) then
         aimw=d1*(a4*x+a2*y)+d2*(a5*x+a2*y)
         aimw=aimw*aki
      endif
   else if (test.lt.break3) then
      a1=(x**2-y**2)*2
      a2=4*x*y
      a4=a1-1
      d1=c5/(a4**2+a2**2)
      rew=d1*(a2*x-a4*y)
      if (ki.gt.0) then
         aimw=d1*(a4*x+a2*y)
         aimw=aimw*aki
      endif
   else
      a1=1/(rpi*test)
      rew=y*a1
      if (ki.gt.0) aimw=x*a1*aki
   endif
   return
   end subroutine quickw

   subroutine wtab(rw,aimw)
   !-------------------------------------------------------------------
   ! Generate table of complex probability integral w.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::rw(62,62),aimw(62,62)
   ! internals
   integer::nx,ny,nx1,ny1,i,j
   real(kr)::x0,y0,dx,dy,xi,yj,rwt,aimt
   real(kr)::x(62),y(62)
   real(kr),parameter::tenth=.1e0_kr

   x0=-tenth
   y0=-tenth
   dx=tenth
   dy=tenth
   nx=62
   ny=62
   y(1)=y0
   nx1=nx-1
   ny1=ny-1
   do i=1,ny1
      y(i+1)=i*dy+y0
   enddo
   x(1)=x0
   do i=1,nx1
      x(i+1)=i*dx+x0
   enddo
   do i=1,nx
      do j=1,ny
         xi=x(i)
         yj=y(j)
         call w (xi,yj,rwt,aimt)
         rw(i,j)=rwt
         aimw(i,j)=aimt
      enddo
   enddo
   return
   end subroutine wtab

   subroutine w(rez,aim1,rew,aimw)
   !-------------------------------------------------------------------
   ! Compute complex probability integral w.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   real(kr)::rez,aim1,rew,aimw
   ! internals
   integer::kw,k,jsig
   real(kr)::tempc,tempd,r2,ai2,aimz
   real(kr)::rv,ak,el,a,b,h,g,am,aak
   real(kr)::prr,pii,amagn,temp1,temp2,aj,c,d
   real(kr)::ajtemp,temp4,ajp,ajsig,sigp,expon,expc,exps
   real(kr)::sig2p,aj4sig,temp3,tt4,temp7
   real(kr)::ref,aimf,rpi,abrez,tempm,temel,aj4sm1
   real(kr),parameter::c1=1.1283792e0_kr
   real(kr),parameter::c2=1.5e0_kr
   real(kr),parameter::up=1.e15_kr
   real(kr),parameter::dn=1.e-15_kr
   real(kr),parameter::brk1=1.25e0_kr
   real(kr),parameter::brk2=5.0e0_kr
   real(kr),parameter::brk3=1.863636e0_kr
   real(kr),parameter::brk4=4.1e0_kr
   real(kr),parameter::brk5=1.71e0_kr
   real(kr),parameter::brk6=2.89e0_kr
   real(kr),parameter::brk7=1.18e0_kr
   real(kr),parameter::brk8=5.76e0_kr
   real(kr),parameter::brk9=1.5e0_kr
   real(kr),parameter::eps=1.e-7_kr
   real(kr),parameter::zero=0
   rpi=sqrt(pi)

   rew=0
   aimw=0
   aimz=abs(aim1)
   abrez=abs(rez)
   if (abrez+aimz.ne.zero) go to 20
   rew=1
   aimw=0
   return

  20 continue
   tempc=0
   tempd=0
   r2=rez*rez
   ai2=aimz*aimz
   if (abrez+brk1*aimz-brk2.gt.zero) go to 350
   if (abrez+brk3*aimz-brk4.gt.zero) go to 350
   if (r2+brk5*ai2-brk6.lt.zero) go to 340
   if (r2+brk7*ai2-brk8.ge.zero) go to 340
   if (aimz-brk9.ge.zero) go to 350
  340 continue
   kw=2
   aimz=aim1
   go to 420
  350 continue
   kw=1
   if (aim1.ge.zero) go to 370
   kw=2
   aimz=aim1
   go to 420

   !--wa is obtained from asymtotic series
  370 continue
   rv=2*(r2-ai2)
   ak=4*rez*aimz
   el=ak
   h=0
   b=0
   a=0
   tempm=0
   temel=0
   g=1
   c=-c1*aimz
   d=c1*rez
   am=rv-1
   aak=1
   k=0
  380 continue
   ajtemp=2*aak
   temp4=(1-ajtemp)*ajtemp
   ajp=rv-(4*aak+1)
   go to 480
  390 continue
   aak=aak+1
   k=k+1
   prr=rew
   pii=aimw
   amagn=tempm**2+temel**2
   rew=(tempc*tempm+tempd*temel)/amagn
   aimw=(tempm*tempd-temel*tempc)/amagn
   if (abs(rew-prr).ge.eps) go to 380
   if (abs(aimw-pii).ge.eps) go to 380
   return
   ! wt is obtained from taylor series
  420 continue
   temp1=r2+ai2
   temp2=2*temp1*temp1
   aj=-(r2-ai2)/temp2
   ak=2*rez*aimz/temp2
   c=0
   b=0
   ajsig=0
   d=0
   jsig=0
   g=0
   h=0
   el=0
   a=1
   am=1
   sigp=c2
   expon=exp(temp2*aj)
   expc=expon*cos(temp2*ak)
   exps=-expon*sin(temp2*ak)
   sig2p=2*sigp
  430 continue
   aj4sig=4*ajsig
   aj4sm1=aj4sig-1
   temp3=1/(aj4sm1*(aj4sig+3))
   tt4=sig2p*(2*ajsig-1)
   temp4=tt4/(aj4sm1*(aj4sig+1)*(aj4sig-3)*aj4sm1)
   ajp=aj+temp3
   go to 480
  440 continue
   ajsig=ajsig+1
   jsig=jsig+1
   temp7=rpi*(am*am+el*el)
   ref=(aimz*(c*am+d*el)-rez*(am*d-c*el))/temp7/temp1
   aimf=(aimz*(am*d-c*el)+rez*(c*am+d*el))/temp7/temp1
   prr=rew
   pii=aimw
   rew=expc-ref
   aimw=exps-aimf
   if (abs(rew-prr).ge.eps) go to 470
   if (abs(aimw-pii).ge.eps) go to 470
   return
  470 continue
   sig2p=2*ajsig
   go to 430
  480 continue
   tempc=ajp*c+temp4*a-ak*d
   tempd=ajp*d+temp4*b+ak*c
   temel=ajp*el+temp4*h+ak*am
   tempm=ajp*am+temp4*g-ak*el
   a=c
   b=d
   g=am
   h=el
   c=tempc
   d=tempd
   am=tempm
   el=temel
   if ((abs(tempm)+abs(temel)-up).lt.zero) go to 500
   c=dn*c
   d=dn*d
   am=dn*am
   el=dn*el
   tempc=dn*tempc
   tempd=dn*tempd
   tempm=dn*tempm
   temel=dn*temel
   go to 520
  500 continue
   if ((abs(tempm)+abs(temel)-dn).gt.zero) go to 520
   c=up*c
   d=up*d
   am=up*am
   el=up*el
   tempc=up*tempc
   tempd=up*tempd
   tempm=up*tempm
   temel=up*temel
  520 continue
   go to (390,440,530),kw
  530 continue
   return
   end subroutine w

end module reconm

module viewm
   ! provides subroutine viewr for NJOY2016
   use locale
   implicit none
   private
   public viewr

   ! common variables

   ! setup1
   real(kr)::xpage,ypage,wline,csize
   integer::lori,istyle,ipcol

   ! setup2
   real(kr)::xll,yll,ww,wh,wr,xg,yg
   integer::iwcol

   ! setup3
   real(kr)::hlab
   integer::n1,n2,nx,ny,nr
   character(80)::t1,t2,xl,yl,rl

   ! setup4
   real(kr)::xmin,xmax,xstp
   real(kr)::ymin,ymax,ystp
   real(kr)::zmin,zmax,zstp
   integer::itype,jtype,igrid,ileg

   ! setup5
   integer::icon,isym,idash,ithick,ishade,iccol

   ! setup6
   real(kr)::xtag,ytag,xpoint,xpt,ypt,hleg
   integer::nleg
   character(80)::aleg

   ! setup7
   real(kr)::x3,y3,z3,xv,yv,zv

contains

   subroutine viewr
   !--------------------------------------------------------------------
   !
   ! View plots generated by plotr, covr, or dtfr.
   ! Postscript version.
   !
   ! Character specifications are similar to DISSPLA, except that
   ! the default case is lower instead of upper.  This allows
   ! mixed-case strings to be used in Postscript mode.  The
   ! following shift characters are used:
   !     < = upper-case standard
   !     > = lower-case or mixed-case standard
   !     [ = upper-case greek
   !     ] = lower-case or mixed-case greek
   !     # = instructions
   ! Give one of the shift characters twice to get it instead of
   ! its action.  The following instructions are supported:
   !     Ev = elevate by v as a fraction of the height
   !           if v is missing or D is given, use .5
   !     Lv = lower by v as a fraction of the height
   !           if v is missing or D is given, use .5
   !     Hv = change height by v as a fraction of the height
   !           if v is missing or D is given, use .5
   !     Fi = change to font number i
   !     Mi = change mode number, where mode 0 is the lower 128
   !           postscript characters and mode 1 is the upper 128
   !     X  = reset E, L, or H.  Font and Mode must be
   !           reset explicitly.
   !     c is a real number, i is an integer.
   !
   !---input--------------------------------------------------------
   !
   !  card 1
   !     infile        input file
   !     nps           postscript output file
   !
   !---data file format---------------------------------------------
   !
   !  card 1
   !     lori          page orientation (def=1)
   !                    0  portrait (7.5x10in)
   !                    1  landscape (10x7.5in)
   !     istyle        character style (def=2)
   !                     1  roman
   !                     2  swiss
   !     size          character size option
   !                     pos = height in page units
   !                     neg = height as fraction of subplot size
   !                       (default=.30)
   !     ipcol         page color (def=white)
   !                    0=white
   !                    1=navajo white
   !                    2=blanched almond
   !                    3=antique white
   !                    4=very pale yellow
   !                    5=very pale rose
   !                    6=very pale green
   !                    7=very pale blue
   !
   ! -----repeat cards 2 through 13 for each curve-----
   !
   !  card 2
   !     iplot         plot index
   !                     99 = terminate plotting job
   !                      1 = new axes, new page
   !                     -1 = new axes, existing page
   !                      n = nth additional plot on existing axes
   !                     -n = start a new set of curves using
   !                          the alternate y axis
   !                     default = 1
   !     iwcol         window color (def=white)
   !                    color list same as for ipcol above
   !     factx         factor for energies (default=1.)
   !     facty         factor for cross-sections (default=1.)
   !     xll,yll       lower-left corner of plot area
   !     ww,wh,wr      window width, height, and rotation angle
   !                   (plot area defaults to one plot per page)
   !
   ! -----cards 3 thru 7 for iplot = 1 or -1 only-----
   !
   !  card 3
   !     t1            first line of title
   !                   80 characters allowed.
   !                   default=none
   !
   !  card 3a
   !     t2            second line of title
   !                   80 characters allowed.
   !                   default=none
   !
   !  card 4
   !     itype         type for primary axes
   !                     1 = linear x - linear y
   !                     2 = linear x - log y
   !                     3 = log x - linear y
   !                     4 = log x - log y
   !                     set negative for 3d axes
   !                     0 = no plot, titles only
   !                     default=4
   !     jtype         type for alternate y axis or z axis
   !                     0 = none
   !                     1 = linear
   !                     2 = log
   !                     default=0
   !     igrid         grid and tic mark control
   !                     0 = no grid lines or tic marks
   !                     1 = grid lines
   !                     2 = tic marks on outside
   !                     3 = tic marks on inside
   !                     default=2
   !     ileg          option to write a legend.
   !                     0 = none
   !                     1 = write a legend block with upper left
   !                         corner at xtag,ytag (see below)
   !                     2 = use tag labels on each curve with
   !                         a vector from the tag to the curve
   !                     default=0
   !     xtag          x coordinate of upper left corner
   !                   of legend block
   !     ytag          y coord of upper left corner
   !                   default=upper left corner of plot
   !
   !  card 5
   !     xmin          lowest energy to be plotted
   !     xmax          highest energy to be plotted
   !     xstep         x axis step
   !                   default = automatic scales
   !                   (for linear, give all 3, or none)
   !                   (for log, give first 2, or none)
   !
   !  card 5a
   !     xlabl         label for x axis
   !                   80 characters allowed.
   !                   (default = no label, no numbering)
   !
   !  card 6
   !     ymin          lowest value of y axis.
   !     ymax          highest value of y axis.
   !     ystep         step for y ayis (linear scales only)
   !                   default = automatic scales
   !                   (for linear, give all 3, or none)
   !                   (for log, give first 2, or none)
   !
   !  card 6a
   !     ylabl         label for y axis
   !                   80 characters allowed.
   !                   (default = no label, no numbering)
   !
   !  card 7   (jtype.gt.0 only)
   !     rmin          lowest value of secondary y axis or z axis
   !     rmax          highest value of secondary y axis or z axis
   !     rstep         step for secondary y axis or z axis
   !                   (default = automatic scale)
   !                   (for linear, give all 3, or none)
   !                   (for log, give first 2, or none)
   !
   !  card 7a  (jtype.gt.0 only)
   !     rl            label for alternate y axis or z axis
   !                   80 characters allowed.
   !                   (default = no label, no numbering)
   !
   !   card 8  -- dummy input card for consistency with plotr
   !               it always should be 0/
   !
   ! -----cards 9 and 10 for 2d plots only-----
   !
   !   card 9
   !     icon          symbol and connection option
   !                     0 = points connected, no symbols
   !                    -i = points not connected, symbol at every
   !                         ith point
   !                     i = points connected, symbol at every ith
   !                         points
   !                     default=0
   !     isym          no. of symbol to be used
   !                     0 = square
   !                     1 = octagon
   !                     2 = triangle
   !                     3 = cross
   !                     4 = ex
   !                     5 = diamond
   !                     6 = inverted triangle
   !                     7 = exed square
   !                     8 = crossed ex
   !                     9 = crossed diamond
   !                     10 = crossed octagon
   !                     11 = double triangle
   !                     12 = crossed square
   !                     13 = exed octagon
   !                     14 = triangle and square
   !                     15 = filled circle
   !                     16 = open circle
   !                     17 = open square
   !                     18 = filled square
   !                     19 = filled diamond
   !                     20 = filled triangle
   !                     21 = filled inverted triangle
   !                     22 = crossed circle
   !                     23 = exed circle
   !                     24 = exed diamond
   !                     default=0
   !     idash         type of line to plot
   !                     0 = solid
   !                     1 = dashed
   !                     2 = chain dash
   !                     3 = chain dot
   !                     4 = dot
   !                     5 = invisible
   !                     default=0
   !     iccol         curve color (def=black)
   !                     0=black
   !                     1=red
   !                     2=green
   !                     3=blue
   !                     4=magenta
   !                     5=cyan
   !                     6=brown
   !                     7=purple
   !                     8=orange
   !     ithick        controls thickness of curve
   !                     0 = invisible (for shaded areas)
   !                     (default=1)
   !     ishade        shade pattern
   !                     0 = none
   !                     1 to 10 = 10% to 100% gray
   !                     11 to 20 = 45 deg right hatching
   !                     21 to 30 = 45 deg left hatching
   !                     31 to 40 = 45 deg cross hatching
   !                     41 to 50 = shades of green
   !                     51 to 60 = shades of red
   !                     61 to 70 = shades of brown
   !                     71 to 80 = shades of blue
   !                     default=0
   !
   !   card 10   ---ileg.ne.0 only---
   !     aleg          title for curve tag or legend block
   !                   80 characters allowed.
   !                   default=blank
   !
   !   card 10a  ---ileg.eq.2 only---
   !     xtag          x position of tag title
   !     ytag          y position of tag title
   !     xpoint        x coordinate of vector point
   !                    (.le.0 to omit vector)
   !
   ! -----card 11 for 3d plots only-----
   !
   !   card 11
   !     xv,yv,zv      abs. coords of view point
   !                   defaults= 15.,-15.,15.
   !     x3,y3,z3      abs. sides of work box volume
   !                   defaults=2.5,6.5,2.5
   !
   !          set x3 negative to flip the order of the axis on
   !          that side of the box (secondary energy, cosine).
   !
   !   card 12
   !     nform          format code for input data
   !                    0 = free format input with
   !                        optional x and y error bars
   !                    1 = free format input for a
   !                        3d family of curves z(x) vs y
   !
   !   card 13   ---nform = 0 only---   2-d data
   !     xdata          independent value
   !                    terminate with empty card (/)
   !     ydata          dependent value
   !     yerr1          lower y error limit
   !                    no y error bar if zero
   !     yerr2          upper y error limit
   !                    if zero, equals yerr1
   !     xerr1          x left error limit
   !                    no x error bar if zero
   !     xerr2          x right error limit
   !                    if zero, equals xerr1
   !
   !   card 14   ---nform = 1 only---   3-d data
   !     y              y value for curve
   !                    repeat cards 13 and 13a for each curve
   !                    terminate with empty card (/)
   !
   !   card14a   ---nform = 1 only---
   !     x              x value
   !     z              z value
   !                    repeat card 13a for each point in curve
   !                    terminate with empty card (/)
   !                    disspla version requires same x grid
   !                    for each value of y.
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides timer,openz,mess,closz
   use graph ! provides gplot,endp,endw,gdone
   ! internals
   integer::infile,nps,nplot,i3d,iplot,ierrb
   integer::i,idone,j,n,l,iskip,nform,ll,nn,inside,naa
   real(kr)::time,zz1,zz2,flag
   real(kr)::factx,facty
   real(kr)::xx,yy,zz
   character(80)::text
   integer,parameter::mmax=20000   !same in plotr and viewr
   integer,parameter::maxaa=500000
   real(kr),dimension(15)::z
   real(kr),dimension(maxaa)::aa
   real(kr),dimension(mmax)::x,y,b,dxm,dxp,dym,dyp
   equivalence (x(1),aa(1)),(y(1),aa(mmax+1)),(b(1),aa(2*mmax+1))
   equivalence (dxm(1),aa(3*mmax+1)),(dxp(1),aa(4*mmax+1))
   equivalence (dym(1),aa(5*mmax+1)),(dyp(1),aa(6*mmax+1))
   real(kr),parameter::zero=0
   integer,parameter::mxc=80

   ! default paper size is us letter size.
   ! default margin is 0.5in all around.
   ! default character size is 0.3 in.
   ! default line width is .0134 in.
   ! see similar statements in plotr.
   real(kr),parameter::xpaper=8.5e0_kr
   real(kr),parameter::ypaper=11.0e0_kr
   real(kr),parameter::xmarg=1.0e0_kr
   real(kr),parameter::ymarg=1.0e0_kr
   real(kr),parameter::dsize=.3e0_kr
   real(kr),parameter::dline=.0134e0_kr
   ! default viewpoint and workbox
   real(kr),parameter::dxv=15.e0_kr
   real(kr),parameter::dyv=-15.e0_kr
   real(kr),parameter::dzv=15.e0_kr
   real(kr),parameter::dx3=2.5e0_kr
   real(kr),parameter::dy3=6.5e0_kr
   real(kr),parameter::dz3=2.5e0_kr

   !--start up the module
   call timer(time)
   write(nsyso,&
     '(/'' viewr...display plots'',47x,f8.1,''s'')') time
   write(nsyse,'(/'' viewr...'',60x,f8.1,''s'')') time
   read(nsysi,*) infile,nps
   call openz(infile,0)
   lori=1
   istyle=2
   csize=dsize
   ipcol=0
   call repoz(infile)
   read(infile,*) lori,istyle,csize,ipcol
   ! default page size is paper size with 0.5in margin all around
   if (lori.eq.1) then
      xpage=ypaper-ymarg
      ypage=xpaper-xmarg
   else
      xpage=xpaper-xmarg
      ypage=ypaper-ymarg
   endif
   wline=dline
   write(nsyso,'(/&
     &'' lori ................................. '',i10/&
     &'' xpage ................................ '',f10.3/&
     &'' ypage ................................ '',f10.3/&
     &'' istyle ............................... '',i10/&
     &'' size ................................. '',f10.3/&
     &'' ipcol ................................ '',i10)')&
     lori,xpage,ypage,istyle,csize,ipcol

   !--initialize plotting
   call gplot(lori,xpage,ypage,nps)

   !--loop over plots
   nplot=0
   i3d=0
   iplot=1
   do while (iplot.ne.99)
      iplot=1
      iwcol=0
      factx=1
      facty=1
      xll=0
      yll=0
      ww=xpage
      wh=ypage
      wr=0
      read(infile,*) iplot,iwcol,factx,facty,xll,yll,ww,wh,wr
      if (iplot.ne.99) then
         write(nsyso,'(/&
           &'' -------------------------------------------------''//&
           &'' iplot ................................ '',i10/&
           &'' iwcol ................................ '',i10/&
           &'' factx ................................ '',1p,e10.2/&
           &'' facty ................................ '',e10.2/&
           &'' xll .................................. '',0p,f10.3/&
           &'' yll .................................. '',f10.3/&
           &'' ww ................................... '',f10.3/&
           &'' wh ................................... '',f10.3/&
           &'' wa ................................... '',f10.3)')&
           iplot,iwcol,factx,facty,xll,yll,ww,wh,wr
         ierrb=0

         !--if this is first plot on these axes
         !--read in title lines
         if (iabs(iplot).eq.1) then
            text=' '
            read(infile,*) text
            n1=0
            do i=1,mxc
               if (text(i:i).ne.' ') n1=i
            enddo
            t1=' '
            if (n1.gt.0) t1=text(1:n1)
            text=' '
            read(infile,*) text
            n2=0
            do i=1,mxc
               if (text(i:i).ne.' ') n2=i
            enddo
            t2=' '
            if (n2.gt.0) t2=text(1:n2)
            write(nsyso,'(/12x,a/12x,a)') t1,t2

            !--set up plot type and grids
            itype=4
            jtype=0
            igrid=2
            ileg=0
            xtag=0
            ytag=0
            read(infile,*) itype,jtype,igrid,ileg,xtag,ytag
            write(nsyso,'(/&
              &'' itype ................................ '',i10/&
              &'' jtype ................................ '',i10/&
              &'' igrid ................................ '',i10/&
              &'' ileg ................................. '',i10)')&
              itype,jtype,igrid,ileg
            if (ileg.eq.1) write(nsyso,'(/&
              &'' xtag ................................. '',1p,e10.2/&
              &'' ytag ................................. '',e10.2)')&
              xtag,ytag

            !--no more input needed if itype=0
            if (itype.ne.0) then
               i3d=0
               if (itype.le.0) then
                  i3d=1
                  itype=-itype
               endif

               !--read in x-axis limits and label
               xmin=0
               xmax=0
               xstp=0
               read(infile,*) xmin,xmax,xstp
               if ((itype.eq.3.or.itype.eq.4)&
                 .and.(xmin.ne.zero.or.xmax.ne.zero)) xstp=1
               text=' '
               read(infile,*) text
               nx=0
               do i=1,mxc
                  if (text(i:i).ne.' ') nx=i
               enddo
               xl=' '
               if (nx.gt.0) xl=text(1:nx)
               write(nsyso,'(/&
                 &'' xlo .................................. '',&
                 &1p,e10.2/&
                 &'' xhi .................................. '',&
                 &e10.2/&
                 &'' xstep ................................ '',&
                 &e10.2/&
                 &'' xlabel ... '',a)') xmin,xmax,xstp,xl

               !--read in y-axis limits and label
               ymin=0
               ymax=0
               ystp=0
               read(infile,*) ymin,ymax,ystp
               if ((itype.eq.2.or.itype.eq.4)&
                  .and.(ymin.ne.zero.or.ymax.ne.zero)) ystp=1
               text=' '
               read(infile,*) text
               ny=0
               do i=1,mxc
                  if (text(i:i).ne.' ') ny=i
               enddo
               yl=' '
               if (ny.gt.0) yl=text(1:ny)
               write(nsyso,'(/&
                 &'' ylo .................................. '',&
                 &1p,e10.2/&
                 &'' yhi .................................. '',&
                 &e10.2/&
                 &'' ystep ................................ '',&
                 &e10.2/&
                 &'' ylabel ... '',a)')&
                 ymin,ymax,ystp,yl

               !--read in data for alternate y axis or z axis
               if (jtype.ne.0) then
                  zmin=0
                  zmax=0
                  zstp=0
                  read(infile,*) zmin,zmax,zstp
                  if (jtype.eq.2.and.(zmin.ne.zero.or.zmax.ne.zero))&
                    zstp=1
                  text=' '
                  read(infile,*) text
                  nr=0
                  do i=1,mxc
                     if (text(i:i).ne.' ') nr=i
                  enddo
                  rl=' '
                  if (nr.gt.0) rl=text(1:nr)
                  write(nsyso,'(/&
                    &'' rlo .................................. '',&
                    &1p,e10.2/&
                    &'' rhi .................................. '',&
                    &e10.2/&
                    &'' rstep ................................ '',&
                    &e10.2/&
                    &'' rlabel ... '',a)')&
                    zmin,zmax,zstp,rl
               endif
            endif
         endif

         !--additional input for real plots
         if (itype.ne.0) then

            !--read dummy card for consistency with plotr input
            read(infile,*)

            !--read plotting parameters for next 2d curve
            if (i3d.eq.0) then
               icon=0
               isym=0
               idash=0
               iccol=0
               ithick=1
               ishade=0
               read(infile,*) icon,isym,idash,iccol,ithick,ishade
               write(nsyso,'(/&
                 &'' icon ................................. '',i10/&
                 &'' isym ................................. '',i10/&
                 &'' idash ................................ '',i10/&
                 &'' iccol ................................ '',i10/&
                 &'' ithick ............................... '',i10/&
                 &'' ishade ............................... '',i10)')&
                 icon,isym,idash,iccol,ithick,ishade

               !--read in legend or tag title lines
               if (ileg.ne.0) then
                  text=' '
                  read(infile,*) text
                  nleg=0
                  do i=1,mxc
                     if (text(i:i).ne.' ') nleg=i
                  enddo
                  aleg=' '
                  if (nleg.gt.0) aleg=text(1:nleg)
                  if (ileg.eq.1) write(nsyso,&
                    '(/'' legend ... '',a)') aleg
                  if (ileg.eq.2) then
                     xtag=0
                     ytag=0
                     xpoint=0
                     read(infile,*) xtag,ytag,xpoint
                     write(nsyso,'(/&
                       &'' tag ...... '',a/&
                       &'' xtag ................................. '',&
                       &1p,e10.2/&
                       &'' ytag ................................. '',&
                       &e10.2/&
                       &'' xpoint ............................... '',&
                       &e10.2)')&
                       aleg,xtag,ytag,xpoint
                     endif
               endif

            !--read parameters for plotting 3d surface
            else
               xv=dxv
               yv=dyv
               zv=dzv
               x3=dx3
               y3=dy3
               z3=dz3
               read(infile,*) xv,yv,zv,x3,y3,z3
               write(nsyso,'(/&
                 &'' 3d viewpoint ......................... '',f10.3/&
                 &''                                        '',f10.3/&
                 &''                                        '',f10.3/&
                 &'' 3d workbox ........................... '',f10.3/&
                 &''                                        '',f10.3/&
                 &''                                        '',f10.3&
                 &)')&
                 xv,yv,zv,x3,y3,z3
            endif

            !--determine input type
            nform=0
            read(infile,*) nform
            write(nsyso,&
              &'(/'' data nform ........................... '',i10)')&
              nform

            !--for format zero -- 2d data
            !--loop thru input lines until xdata.lt.0
            if (nform.eq.0) then
               i=0
               ierrb=0
               idone=0
               do while (idone.eq.0)
                  i=i+1
                  flag=-99
                  z(1)=flag
                  z(2)=flag
                  z(3)=0
                  z(4)=0
                  z(5)=0
                  z(6)=0
                  read(infile,*) (z(j),j=1,6)
                  zz1=z(1)
                  zz2=z(2)
                  if (zz1.eq.flag.and.zz2.eq.flag) then
                     idone=1
                  else
                     x(i)=z(1)*factx
                     y(i)=z(2)*facty
                     dym(i)=z(3)*facty
                     dyp(i)=z(4)*facty
                     if (dyp(i).eq.zero) dyp(i)=dym(i)
                     dxm(i)=z(5)*factx
                     dxp(i)=z(6)*factx
                     if (dxp(i).eq.zero) dxp(i)=dxm(i)
                     if (dym(i).ne.zero) ierrb=1
                     if (dxm(i).ne.zero) ierrb=2
                     if (dym(i).ne.zero.and.dxm(i).ne.zero) ierrb=3
                  endif
               enddo
               n=i-1

            !--format 1 for 3-d data
            !--assume same x grids for each value of y
            else if (nform.eq.1) then
               l=0
               iskip=0
               flag=-99
               idone=0
               do while (idone.eq.0)
                  yy=flag
                  read(infile,*) yy
                  if (yy.eq.flag) then
                     idone=1
                  else
                     if (iskip.eq.0) then
                       if (l+5000.ge.maxaa) then
                           call mess('viewr','too much 3d data',&
                             'data truncated')
                           iskip=1
                        endif
                        l=l+1
                        aa(l)=yy
                        l=l+1
                        aa(l)=0
                        ll=l
                     endif
                     nn=0
                     inside=0
                     do while (inside.eq.0)
                        xx=flag
                        zz=flag
                        read(infile,*) xx,zz
                        if (xx.eq.flag.and.zz.eq.flag) then
                           inside=1
                        else
                           if (iskip.eq.0) then
                              nn=nn+1
                              l=l+1
                              aa(l)=xx
                              l=l+1
                              aa(l)=zz
                           endif
                        endif
                     enddo
                     if (iskip.eq.0) aa(ll)=nn
                  endif
               enddo
               l=l+1
               aa(l)=0
               l=l+1
               aa(l)=0
               naa=l
            endif
         endif

         !--do plot
         if (nplot.ne.0.and.iplot.eq.1) call endp
         if (iplot.eq.-1) call endw
         if (nform.eq.0) then
            call set2d(iplot,x,y,dxm,dxp,dym,dyp,n,ierrb)
         else
            call set3d(iplot,aa,naa)
         endif
         nplot=1
      endif

   !--loop back for next curve
   enddo

   !--viewr is finished
   call endw
   call endp
   call gdone
   call closz(infile)
   call timer(time)
   write(nsyso,&
     '(/69x,f8.1,''s''/1x,7(''**********''),''*******'')')&
     time
   end subroutine viewr

   subroutine set2d(iplot,x,y,dxm,dxp,dym,dyp,n,ierrb)
   !--------------------------------------------------------------------
   ! Set up 2-dimensional multi-curve plots.
   ! ------------------------
   ! input variables
   !   iplot            curve number
   !                      1 = first plot, new axes, new page
   !                     -1 = first plot, new axes, existing page
   !                      n = nth plot on existing axes
   !                          (set n negative to start a new set of
   !                            curves with an alternate y axis)
   !   x,y              data to be plotted
   !   dxm,dxp          x error bar limits
   !   dym,dyp          y error bar limits
   !   n                number of data points
   !   ierrb            error bar control
   ! setup1 variables
   !   lori             page orientation (0=portrait, 1=landscape)
   !   xpage,ypage      definition of absolute coordinates
   !   istyle           character style (1=roman, 2=helvetica)
   !   size             character size control
   !                      positive for abs. coordinates
   !                      negative for fraction of subplot size
   !   ipcol           page color
   !   wline            base line width (inches)
   ! setup2 variables
   !   iwcol           window color
   !   xll,yll          abs. coords of lower-left corner of window
   !   ww,wh            window width and height
   !   wr               window rotation angle
   !   xg,yg            lengths of x and y axes in abs. coords.
   ! setup3 variables
   !   t1,n1            title line 1 and character count
   !   t2,n2            title line 2 and character count
   !   xl,nx            x-axis label and count
   !   yl,ny            y-axis label and count
   !   rl,nr            right-axis label and count
   !   hlab             size for labels and titles (abs. coords)
   ! setup4 variables
   !   xmin,xmax        limits on x axis
   !   xstp             step size on x axis
   !                    zero triggers automatic scaling
   !                    value is ignored for log axis
   !   ymin,ymax        limits on y axis
   !   ystp             step size on y axis
   !                    zero triggers automatic scaling
   !                    value is ignored for log axis
   !   rmin,rmax        limits on right axis
   !   rstp             step size on r axis
   !                    zero triggers automatic scaling
   !                    value is ignored for log axis
   !   itype            plot type
   !                      1 = lin-lin
   !                      2 = lin-log
   !                      3 = log-lin
   !                      4 = log-log
   !   jtype            type for right axis
   !                      0 = none
   !                      1 = lin
   !                      2 = log
   !   igrid            control grid lines and tick marks
   !                      0 = no grid lines or tic marks
   !                      1 = grid lines
   !                      2 = tic marks on outside
   !                      3 = tic marks on inside
   !   ileg             legend or tag option
   !                      0 = none
   !                      1 = legend block at xtag,ytag
   !                      2 = curve tag at xtag,ytag with vector
   !                            to xpoint
   ! setup5 variables
   !   icon             controls symbols and connection
   !                      0 = points connected, no symbols
   !                      i = points connected, symbol every ith point
   !                     -i = not connected, symbol every ith point
   !   isym             selects plotting symbol
   !                      0 = square
   !                      1 = circle
   !                      2 = triangle
   !                      3 = cross
   !                      4 = ex
   !                      5 = diamond
   !                      6 = inverted triangle
   !                      7 = filled square
   !                      8 = filled circle
   !   idash            type of connecting line
   !                      0 = solid
   !                      1 = dashed
   !                      2 = chain dash
   !                      3 = chain dot
   !                      4 = dot
   !   ithick           controls thickness of line
   !                      0 = invisible
   !   ishade           shading pattern
   !   iccol           curve color
   ! setup6 variables
   !   aleg,nleg        tag or legend string and char count
   !   xtag,ytag        location of legend block or curve tag
   !                     in units of x and y coordinates
   !   xpoint           x coordinate where vector from tag
   !                     touches the tagged curve
   !   xpt,ypt          abs. location of legend block, if any
   !   hleg             height for legend lines
   !--------------------------------------------------------------------
   use graph ! provides initp,window,init2,axis2,grid2
             ! xscale,yscale,frame2,curv2,endfr
   ! externals
   integer::iplot,n,ierrb
   real(kr)::xpos,ypos
   real(kr)::x(n),y(n),dxm(n),dxp(n),dym(n),dyp(n)
   ! internals
   integer::i,major,minor,ixlft,ibot,itic
   real(kr)::wt,xstep,ystep,top,xlft,bot,xop,yop,rstep,rop
   real(kr)::bar,w,ssym,rmin,rmax
   real(kr),parameter::shade=.99e0_kr
   real(kr),parameter::bard=.03e0_kr
   real(kr),parameter::small=1.e-15_kr
   real(kr),parameter::twenty=20e6_kr
   real(kr),parameter::grace=0
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   save itic
   wt=wline

   !--initial settings
   if (iplot.eq.1) then
      if (csize.gt.zero) hlab=csize
      if (csize.lt.zero) hlab=-csize*wh
      hleg=2*hlab/3
      call initp(lori,xpage,ypage,istyle,hlab,wline,0,ipcol)
   endif

   !--set up subplot area for current axes
   if (iabs(iplot).eq.1) then
      call window(xll,yll,ww,wh,wr,t1,n1,t2,n2,0)
      if (itype.eq.0) return
      call init2(xpos,ypos,xg,yg,jtype,iwcol)
   endif

   !--set up regular axes
   !--or alternate y scale
   if (iplot.le.1) then
      if (iplot.lt.-1) then
         ymin=zmin
         ymax=zmax
         ystp=zstp
      endif

      !--check for automatic scaling
      xstep=xstp
      ystep=ystp
      if (xstp.eq.zero.or.ystp.eq.zero) then

         !--search for min and max values
         if (xstp.eq.zero) then
            xmin=x(1)
            xmax=x(1)
         endif
         if (ystp.eq.zero.or.iplot.ge.-1) then
            if (ystp.eq.zero) then
               ymax=y(1)
               ymin=y(1)
            endif
            do i=2,n
               if (xstp.eq.zero.and.iplot.ge.-1) then
                  if (x(i).lt.xmin) xmin=x(i)
                  if (x(i).gt.xmax) xmax=x(i)
               endif
               if (ystp.eq.zero) then
                  if (y(i).lt.ymin.and.y(i).ne.small) ymin=y(i)
                  if (y(i).gt.ymax) ymax=y(i)
               endif
            enddo

            !--choose limits and step sizes
            !--for linear axes, if any
            if (itype.le.2.and.iplot.ge.-1) then
               if (xstp.eq.zero) then
                  call ascalv(4,xmin,xmax,major,minor)
                  xstep=(xmax-xmin)/major
               endif
            endif
            if (iplot.lt.-1.or.itype.eq.1.or.itype.eq.3) then
               if (iplot.ge.-1.or.jtype.eq.1) then
                  if (ystp.eq.zero) then
                     call ascalv(4,ymin,ymax,major,minor)
                     ystep=(ymax-ymin)/major
                  endif
               endif
            endif
         endif
      endif

      !--adjust limits for log scales
      !--limit number of x and y decades
      if (iplot.ge.-1.and.itype.ge.3.and.xstp.eq.zero) then
         top=log10(xmax)
         if (xmax.ne.twenty) then
            if (top.ge.zero) xmax=ten**int(top+shade)
            if (top.lt.zero) xmax=ten**int(top)
         endif
         xlft=log10(xmin)
         ixlft=int(xlft)
         if (xlft.gt.zero) xmin=ten**ixlft
         if (xlft.lt.zero) xmin=ten**(ixlft-1)
         if (xmax/xmin.gt.ten**13) xmin=ten**int(top-13)
      endif
      if (iplot.lt.-1.or.itype.eq.2.or.itype.eq.4) then
         if (iplot.ge.-1.or.jtype.eq.2) then
            if (ystp.eq.zero) then
               top=log10(ymax)
               if (top.ge.zero) ymax=ten**int(top+shade)
               if (top.lt.zero) ymax=ten**int(top)
               bot=log10(ymin)
               ibot=int(bot)
               if (bot.gt.zero) ymin=ten**ibot
               if (bot.lt.zero) ymin=ten**(ibot-1)
               if (ymax/ymin.gt.ten**8) ymin=ten**int(top-8)
            endif
         endif
      endif

      !--set up the axes and grid
      if (iplot.ge.-1) then
         itic=0
         if (igrid.eq.2) itic=-1
         if (igrid.eq.3) itic=1
         xop=xstep
         yop=ystep
         if (itype.eq.3.or.itype.eq.4) xop=0
         if (itype.eq.2.or.itype.eq.4) yop=0
         call axis2(xmin,xmax,xop,xl,-nx,itic,0,xg,&
           zero,zero,one,zero,zero,one,0)
         call axis2(xmin,xmax,xop,' ',0,-itic,0,xg,&
           zero,yg,one,zero,zero,one,0)
         call axis2(ymin,ymax,yop,yl,ny,-itic,0,yg,&
           zero,zero,zero,one,-one,zero,1)
         call axis2(ymin,ymax,yop,' ',0,itic,0,yg,&
           xg,zero,zero,one,-one,zero,1)
         if (igrid.eq.1) call grid2(1,1)

      !--alternate y axis
      else
         rmin=ymin
         rmax=ymax
         rstep=ystep
         rop=rstep
         if (jtype.eq.2) rop=0
         call axis2(rmin,rmax,rop,rl,-nr,-itic,0,yg,&
           xg,zero,zero,one,-one,zero,1)
         call axis2(rmin,rmax,rop,' ',0,itic,0,yg,&
           zero,zero,zero,one,-one,zero,1)
      endif

      !--locate legend block, if any
      if (ileg.eq.1) then
         if (xtag.eq.zero.and.ytag.eq.zero) then
            xpt=xscale(xmin)+hleg
            ypt=yscale(ymax)-3*hleg/2
         else
            xpt=xscale(xtag)
            ypt=yscale(ytag)
         endif
      endif
   endif

   !--draw the curves on the new or existing frame
   !--using a clipping path just outside of the frame.
   call frame2(xg,yg,grace,iccol)
   bar=bard
   if (ierrb.gt.0) call erbar(x,y,n,dxm,dxp,dym,dyp,ierrb,bar)
   w=ithick*wt
   ssym=3*hleg/10
   call curv2(x,y,n,idash,w,icon,isym,ssym,ishade)

   !--add curves tags or legend lines
   if (ileg.eq.1) call legndb(iplot)
   if (ileg.eq.2) call tagit(x,y,n,itype)

   !--finished with this call to setup
   call endfr
   return
   end subroutine set2d

   subroutine erbar(xx,yy,n,dxm,dxp,dym,dyp,ixy,w)
   !--------------------------------------------------------------------
   ! Put error bars on previously drawn plot.
   ! Companion routine for set2d.
   ! --------------------------------
   !   xx,yy,nn           arrays of centers and count
   !   dxm,dxp            left & right error bars
   !   dym,dyp            bottom & top error bars
   !   w                  cap size for error bars (in)
   !                       (w=0 defaults to .02)
   !   ixy                option for x, y, or both
   !--------------------------------------------------------------------
   use graph ! provides xscale,yscale,vect3
   ! externals
   integer::n,ixy
   real(kr)::xx(n),yy(n),dxm(n),dxp(n),dym(n),dyp(n),w
   ! internals
   integer::np
   real(kr)::wt,wd,xn,yn,x1,x2,y1,y2
   real(kr),parameter::capd=.02e0_kr
   real(kr),parameter::zero=0
   wt=wline

   !--set up cap size
   wd=w
   if (wd.eq.zero) wd=capd

   !--loop over data points
   do np=1,n
      xn=xscale(xx(np))
      yn=yscale(yy(np))

      !--draw x error bars, if any
      if (ixy.gt.1) then
         if (dxm(np).ne.zero.or.dxp(np).ne.zero) then
            x1=xscale(xx(np)-dxm(np))
            x2=xscale(xx(np)+dxp(np))
            call vect3(x1,yn,zero,x2,yn,zero,wt,0)
            call vect3(x1,yn+wd,zero,x1,yn-wd,zero,wt,0)
            call vect3(x2,yn+wd,zero,x2,yn-wd,zero,wt,0)
         endif
      endif

      !--draw y error bars, if any
      if (ixy.ne.0.and.ixy.ne.2) then
         if (xx(np).ge.xmin.and.xx(np).le.xmax) then
            if (yy(np).ge.ymin.and.yy(np).le.ymax) then
               if (dym(np).ne.zero.or.dyp(np).ne.zero) then
                  y1=yscale(yy(np)-dym(np))
                  y2=yscale(yy(np)+dyp(np))
                  call vect3(xn,y1,zero,xn,y2,zero,wt,0)
                  call vect3(xn-wd,y1,zero,xn+wd,y1,zero,wt,0)
                  call vect3(xn-wd,y2,zero,xn+wd,y2,zero,wt,0)
               endif
            endif
         endif
      endif

   !--continue loop over data points
   enddo
   return
   end subroutine erbar

   subroutine legndb(iplot)
   !--------------------------------------------------------------------
   ! Write the legend, a line at a time.
   ! Companion routine for set2d.
   ! -----------------------------------
   !   iplot              curve number
   !   icon               symbol and connection flag
   !   hleg               height for legend lines
   !   imk                marker (symbol)
   !   xpt,ypt            abs. position of the upper left
   !                       corner of the legend block
   !   leg,nleg           legend line and character count
   !--------------------------------------------------------------------
   use graph ! provides txtlen,trans3,xinvrs,yinvrs,poly2,curv2,dsym
   ! externals
   integer::iplot
   ! internals
   real(kr)::wt,x,y,xta,yta,wleg,w,ssym,u,v
   real(kr)::xc(2),yc(2)
   real(kr)::xb(5),yb(5)
   real(kr),parameter::wd=.005e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::backgr=1
   save x,y
   wt=wline

   if (iabs(iplot).eq.1) then
      x=xpt
      y=ypt
      call trans3(x,y,zero,xta,yta)
      wleg=txtlen(aleg,nleg,istyle,hleg)
      xb(1)=xta-2*hleg/10
      yb(1)=yta-3*hleg/10
      xb(2)=xta+wleg+7*one/10+4*hleg/10
      yb(2)=yta-3*hleg/10
      xb(3)=xta+wleg+7*one/10+4*hleg/10
      yb(3)=yta
      xb(4)=xta-2*hleg/10
      yb(4)=yta
      xb(5)=xta-2*hleg/10
      yb(5)=yta-3*hleg/10
      w=wd
      call poly2(xb,yb,5,-w,backgr)
   endif
   xc(1)=xinvrs(x)
   yc(1)=yinvrs(y-7*hleg/10)
   xc(2)=xinvrs(x+5*one/10)
   yc(2)=yinvrs(y-7*hleg/10)
   call trans3(x,y,zero,xta,yta)
   wleg=txtlen(aleg,nleg,istyle,hleg)
   xb(1)=xta-2*hleg/10
   yb(1)=yta-14*hleg/10
   xb(2)=xta+wleg+7*one/10+4*hleg/10
   yb(2)=yta-14*hleg/10
   xb(3)=xta+wleg+7*one/10+4*hleg/10
   yb(3)=yta-3*hleg/10
   xb(4)=xta-2*hleg/10
   yb(4)=yta-3*hleg/10
   xb(5)=xta-2*hleg/10
   yb(5)=yta-14*hleg/10
   w=wd
   call poly2(xb,yb,5,-w,backgr)
   w=ithick*wt
   if (icon.ge.0) call curv2(xc,yc,2,idash,w,0,0,zero,0)
   ssym=3*hleg/10
   call trans3(x+one/4,y-7*hleg/10,zero,u,v)
   if (icon.ne.0) call dsym(u,v,isym,ssym)
   call text3(aleg,nleg,istyle,hleg,x+7*one/10,y-11*hleg/10,zero,&
     one,zero,zero,zero,one,zero)
   y=y-11*hleg/10
   return
   end subroutine legndb

   subroutine tagit(x,y,n,it)
   !--------------------------------------------------------------------
   ! Places a tag string at xtag,ytag and
   ! draws a vector to meet the curve at xpoint.
   ! -----------------------------------
   !   x,y,n              array of data points and count
   !   it                 interpolation law
   !   xpoint             x value where arrow touches curve
   !                       (.le.0 to omit vector)
   !   xtag,ytag          position of tag in curve coordinates
   !   aleg,nleg          tag message and count
   !   ivec               style code for arrow head
   !   hleg               size of tag characters
   !--------------------------------------------------------------------
   use endf ! provides terp1
   use graph ! provides txtlen,xscale,yscale,trans3
   ! externals
   integer::n,it
   real(kr)::x(n),y(n)
   ! internals
   integer::j,jt
   real(kr)::wt,ypoint,xtp,ytp,xta,yta,wleg,w,backgr,xpp,ypp
   real(kr)::xxx,yyy
   real(kr)::xb(5),yb(5)
   real(kr),parameter::wd=.005e0_kr
   integer::ivec=1021
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   wt=wline
   backgr=0

   !--search curve for xpoint,ypoint
   if (xpoint.gt.zero) then
      j=1
      do while (x(j).lt.xpoint.and.j.lt.n)
         j=j+1
      enddo
      if (j.eq.1) j=2
      jt=it+1
      call terp1(x(j-1),y(j-1),x(j),y(j),xpoint,ypoint,jt)
   endif

   !--write tag (with a blanked background) and draw vector
   xtp=xscale(xtag)
   ytp=yscale(ytag)
   call trans3(xtp,ytp,zero,xta,yta)
   wleg=txtlen(aleg,nleg,istyle,hleg)
   xb(1)=xta-2*hleg/10
   yb(1)=yta-2*hleg/10
   xb(2)=xta+wleg+4*hleg/10
   yb(2)=yta-2*hleg/10
   xb(3)=xta+wleg+4*hleg/10
   yb(3)=yta+12*hleg/10
   xb(4)=xta-2*hleg/10
   yb(4)=yta+12*hleg/10
   xb(5)=xta-2*hleg/10
   yb(5)=yta-2*hleg/10
   w=wd
   call poly2(xb,yb,5,-w,backgr)
   call text3(aleg,nleg,istyle,hleg,xtp,ytp,&
     zero,one,zero,zero,zero,one,zero)
   if (xpoint.le.zero) return
   xpp=xscale(xpoint)
   ypp=yscale(ypoint)
   xxx=xtp-hleg/2
   yyy=ytp+hleg/2
   call vect3(xxx,yyy,zero,xpp,ypp,zero,wt,ivec)
   return
   end subroutine tagit

   subroutine set3d(iplot,xyz,nxyz)
   !--------------------------------------------------------------------
   ! Set up 3-dimensional surface plots.
   ! ---------------------------------
   ! input variables
   !   iplot            curve number
   !                      1 = first plot, new axes, new page
   !                     -1 = first plot, new axes, existing page
   !                      n = nth plot on existing axes
   !   xyz              packed data array of curves
   !   nxyz             length of data array
   !   a                scratch area (not used for ps)
   ! common variables
   !   x3,y3,z3         abs. sides of work box volume
   !   xv,yv,zv         abs. coordinates of view point
   !                set x3 negative to verse direction of axis
   !--------------------------------------------------------------------
   use util ! provides mess
   use graph ! provides initp,window,init3,curv3
   ! externals
   integer::iplot,nxyz
   real(kr)::xyz(nxyz)
   ! internals
   integer,parameter::length=2000
   integer::i,j,nn,k,ncurv,major,minor,itop,ibot,l,n
   real(kr)::wt,xlo,xhi,ylo,yhi,zlo,zhi,xn,yn,zn,yy
   real(kr)::top,bot,xop,yop,zop
   integer::lll(length)
   real(kr)::x(2000),y(2000),z(2000)
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::d0=.001e0_kr
   real(kr),parameter::d3=.301e0_kr
   real(kr),parameter::d7=.699e0_kr
   integer::kmax=1999
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   wt=wline

   !--set up the window and titles
   if (csize.gt.zero) hlab=csize
   if (csize.lt.zero) hlab=-csize*wh
   if (iplot.eq.1)&
     call initp(lori,xpage,ypage,istyle,hlab,wline,0,ipcol)
   call window(xll,yll,ww,wh,wr,t1,n1,t2,n2,0)

   !--set up the 3-d perspective projection
   call init3(x3,y3,z3,xv,yv,zv,iwcol)

   !--locate the different curves in the family
   !--find lo and hi limits for each axis
   xlo=big
   xhi=-big
   ylo=big
   yhi=-big
   zlo=big
   zhi=-big
   i=1
   j=1
   nn=1
   do while (nn.ne.0)
      lll(j)=i
      yn=xyz(i)
      nn=nint(xyz(i+1))
      if (nn.ne.0) then
         if (yn.lt.ylo) ylo=yn
         if (yn.gt.yhi) yhi=yn
         do k=1,nn
            xn=xyz(i+2*k)
            if (xn.lt.xlo) xlo=xn
            if (xn.gt.xhi) xhi=xn
            zn=xyz(i+2*k+1)
            if (zn.lt.zlo) zlo=zn
            if (zn.gt.zhi) zhi=zn
         enddo
         i=i+2+2*nn
         j=j+1
         if (j.gt.length) then
            call error('set3d','array overflow, increase the length parameter',' ')
         endif
      endif
   enddo
   ncurv=j-1

   !--choose z axis limits and step sizes
   if (zstp.eq.zero) then
      zmin=zlo
      zmax=zhi
      if (jtype.eq.1) then
         call ascalv(2,zmin,zmax,major,minor)
         zstp=(zmax-zmin)/major
      else
         top=log10(zmax)
         itop=int(top)
         if (top.lt.zero) itop=itop-1
         zmax=itop+1
         if (top.le.itop+d7+d0) zmax=itop+d7
         if (top.le.itop+d3+d0) zmax=itop+d3
         if (top.le.itop+d0) zmax=itop
         zmax=ten**zmax
         bot=log10(zmin)
         ibot=int(bot)
         if (bot.lt.zero) ibot=ibot-1
         zmin=ibot
         if (bot.ge.ibot+d3-d0) zmin=ibot+d3
         if (bot.ge.ibot+d7-d0) zmin=ibot+d7
         if (bot.ge.ibot+1-d0) zmin=ibot+1
         zmin=ten**zmin
         if (zmax/zmin.gt.ten**13) zmin=ten**(itop-13)
      endif
   endif

   !--choose y axis limits and step sizes
   if (ystp.eq.zero) then
      ymin=ylo
      ymax=yhi
      if (itype.eq.1.or.itype.eq.3) then
         call ascalv(2,ymin,ymax,major,minor)
         ystp=(ymax-ymin)/major
      else
         top=log10(ymax)
         itop=int(top)
         if (top.lt.zero) itop=itop-1
         ymax=itop+1
         if (top.le.itop+d7+d0) ymax=itop+d7
         if (top.le.itop+d3+d0) ymax=itop+d3
         if (top.le.itop+d0) ymax=itop
         ymax=ten**ymax
         bot=log10(ymin)
         ibot=int(bot)
         if (bot.lt.zero) ibot=ibot-1
         ymin=ibot
         if (bot.ge.ibot+d3-d0) ymin=ibot+d3
         if (bot.ge.ibot+d7-d0) ymin=ibot+d7
         if (bot.ge.ibot+1-d0) ymin=ibot+1
         ymin=ten**ymin
         if (ymax/ymin.gt.ten**13) ymin=ten**(itop-13)
      endif
   endif

   !--chose x axis limits and step sizes
   if (xstp.eq.zero) then
      xmin=xlo
      xmax=xhi
      if (itype.eq.1.or.itype.eq.2) then
         call ascalv(2,xmin,xmax,major,minor)
         xstp=(xmax-xmin)/major
      else
         top=log10(xmax)
         itop=int(top)
         if (top.lt.zero) itop=itop-1
         xmax=itop+1
         if (top.le.itop+d7+d0) xmax=itop+d7
         if (top.le.itop+d3+d0) xmax=itop+d3
         if (top.le.itop+d0) xmax=itop
         xmax=ten**xmax
         bot=log10(xmin)
         ibot=int(bot)
         if (bot.lt.zero) ibot=ibot-1
         xmin=ibot
         if (bot.ge.ibot+d3-d0) xmin=ibot+d3
         if (bot.ge.ibot+d7-d0) xmin=ibot+d7
         if (bot.ge.ibot+1-d0) xmin=ibot+1
         xmin=ten**xmin
         if (xmax/xmin.gt.ten**13) xmin=ten**(itop-13)
      endif
   endif

   !--draw 3d z axis, which uses 2d right axis parameters
   zop=zstp
   if (jtype.eq.2) zop=0
   if (x3.gt.zero) then
      call axis3(zmin,zmax,zop,rl,nr,1,1,z3,zero,zero,zero,&
        zero,zero,one,zero,-one,zero,1)
   else
      call axis3(zmin,zmax,zop,rl,nr,1,1,z3,x3,zero,zero,&
        zero,zero,one,zero,-one,zero,1)
   endif

   !--draw 3d x axis
   xop=xstp
   if (itype.eq.3.or.itype.eq.4) xop=0
   call axis3(xmin,xmax,xop,xl,-nx,-1,0,x3,zero,zero,zero,&
     one,zero,zero,zero,one,zero,0)

   !--draw 3d y axis
   yop=ystp
   if (itype.eq.2.or.itype.eq.4) yop=0
   if (x3.gt.zero) then
      call axis3(ymin,ymax,yop,yl,-ny,-1,0,y3,&
        x3,zero,zero,zero,one,zero,-one,zero,zero,0)
   else
      call axis3(ymin,ymax,yop,yl,-ny,-1,0,y3,&
        zero,zero,zero,zero,one,zero,-one,zero,zero,0)
   endif

   !--draw extra axes to complete the 3-d frame
   if (x3.gt.zero) then
      call axis3(ymin,ymax,yop,' ',0,0,0,y3,&
        zero,zero,zero,zero,one,zero,-one,zero,zero,0)
   else
      call axis3(ymin,ymax,yop,' ',0,0,0,y3,&
        x3,zero,zero,zero,one,zero,-one,zero,zero,0)
   endif
   if (x3.gt.zero) then
      call axis3(ymin,ymax,yop,' ',0,0,0,y3,&
        zero,zero,z3,zero,one,zero,-one,zero,zero,0)
   else
      call axis3(ymin,ymax,yop,' ',0,0,0,y3,&
        x3,zero,z3,zero,one,zero,-one,zero,zero,0)
   endif
   if (x3.gt.zero) then
      call axis3(zmin,zmax,zop,' ',0,0,0,z3,&
        zero,y3,zero,zero,zero,one,zero,-one,zero,0)
   else
      call axis3(zmin,zmax,zop,' ',0,0,0,z3,&
        x3,y3,zero,zero,zero,one,zero,-one,zero,0)
   endif
   if (x3.gt.zero) then
      call axis3(zmin,zmax,zop,' ',0,0,0,z3,&
        x3,y3,zero,zero,zero,one,zero,-one,zero,0)
   else
      call axis3(zmin,zmax,zop,' ',0,0,0,z3,&
        zero,y3,zero,zero,zero,one,zero,-one,zero,0)
   endif
   call axis3(xmin,xmax,xop,' ',0,0,0,x3,&
     zero,y3,zero,one,zero,zero,zero,one,zero,0)
   call axis3(xmin,xmax,xop,' ',0,0,0,x3,&
     zero,y3,z3,one,zero,zero,zero,one,zero,0)

   !--add the base-plane grids if requested
   if (igrid.eq.1) then
      call grid3(1,1,0)
      if (x3.gt.zero) then
         call grid3(0,1,1)
      else
         call grid3(-1,1,1)
      endif
      call grid3(1,-1,1)
   endif

   !--draw the curves
   do j=1,ncurv
      l=lll(ncurv-j+1)
      yy=xyz(l)
      if (yy.ge.ymin.and.yy.le.ymax) then
         n=nint(xyz(l+1))
         x(1)=xyz(l+2)
         y(1)=yy
         z(1)=zmin
         k=2
         do i=1,n
            if (k.lt.kmax) then
               x(k)=xyz(l+2*i)
               if (x(k).lt.xmin) x(k)=xmin
               if (x(k).gt.xmax) x(k)=xmax
               y(k)=yy
               z(k)=xyz(l+2*i+1)
               if (z(k).lt.zmin) z(k)=zmin
               if (z(k).gt.zmax) z(k)=zmax
               k=k+1
            endif
         enddo
         if (k.ge.kmax) then
            call mess('set3d','curve truncated',' ')
         endif
         x(k)=xyz(l+2*n)
         y(k)=yy
         z(k)=zmin
         call curv3(x,y,z,k,wt)
      endif
   enddo

   !--finished.
   return
   end subroutine set3d

   subroutine ascalv(m,z1,z2,major,minor)
   !--------------------------------------------------------------------
   ! Automatic scaling routine for a linear axis
   ! borrowed from Los Alamos SC4020 library (with modifications).
   ! on input------------
   !   m              minimum number of major divisions desired
   !   z1,z2          min and max values of data to be plotted
   ! on output-----------
   !   z1,z2          min and max limits of axis
   !   major          number of major division on axis
   !   minor          number of minor divisions on axis
   !--------------------------------------------------------------------
   ! externals
   integer::m,major,minor
   real(kr)::z1,z2
   ! internals
   integer::iflag,k,nm,n1,n2
   real(kr)::zmin,zmax,fm,zbar,z,p,tenk,test,dz,fn
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::tentho=10000

   !--check input
   !--exit if parameters are unreasonable
   zmin=z1
   zmax=z2
   if (zmax.le.zmin.or.m.le.0.or.m.gt.20) then
      major=1
      minor=0
      z1=0
      z2=2*z2
      return
   endif

   !--find minimum span per interval
   fm=m
   if (zmax.eq.zero.or.zmin.eq.zero) then
      zmax=zmax-abs(zmax)/1000000
      zmin=zmin+abs(zmin)/1000000
   else
      zbar=zmax/zmin
      if (abs(zbar)/1000.ge.one) zmin=0
      if (abs(zbar)*1000.le.one) then
         zmax=0
         zmax=zmax-abs(zmax)/1000000
         zmin=zmin+abs(zmin)/1000000
      else
         if ((abs(zbar-1)-5*fm/100000).gt.zero) then
            zmax=zmax-abs(zmax)/1000000
            zmin=zmin+abs(zmin)/1000000
         else
            zbar=(zmax+zmin)/2
            z=26*fm*abs(zbar)/1000000
            zmax=zbar+z
            zmin=zbar-z
         endif
      endif
   endif
   p=(zmax-zmin)/fm

   !--determine k such that
   !--    10**k.le.p.lt.10**(k+1)
   iflag=0
   tenk=1
   k=0
   if (p.lt.one) then
      iflag=1
      p=1/p
   endif
   do while (p.ge.tentho)
      p=p/10000
      tenk=tenk*10000
      k=k+4
   enddo
   do while (p.ge.ten)
      p=p/10
      tenk=tenk*10
      k=k+1
   enddo
   if (iflag.ne.0) then
      p=10/p
      tenk=one/10/tenk
      k=k-1
   endif

   !--determine dz such that
   !--    dz = 1*10**k, or
   !--    dz = 2*10**k, or
   !--    dz = 5*10**k.
   test=2+one/100
   if (p.le.test) then
      test=2-one/100
      if (p.le.test) then
         p=1
         nm=5
      else
         p=2
         nm=4
      endif
   else
      test=5-one/100
      if (p.lt.test) then
         p=2
         nm=4
      else
         p=5
         nm=5
      endif
   endif
   dz=p*tenk

   !--find integers n1 and n2 such that
   !--    n1*dz.le.zmin.lt.(n1+1)*dz, and
   !--    (n2-1)*dz.lt.zmax.le.n2*dz
   !--the new zmin and zmax become
   !--    zmin = n1*dz
   !--    zmax = n2*dz
   n1=int(zmin/dz)
   fn=n1
   z=fn*dz
   if (z.gt.zmin) then
      z=z-dz
      n1=n1-1
   endif
   zmin=z
   z1=zmin
   n2=int(zmax/dz)
   fn=n2
   z=fn*dz
   if (z.lt.zmax) then
      n2=n2+1
      z=z+dz
   endif
   zmax=z
   z2=zmax

   !--the values of major and minor can be set
   major=n2-n1
   minor=nm*major
   return
   end subroutine ascalv

end module viewm

module dtfm
   ! Module to provide dtfr for NJOY2016
   use locale
   implicit none
   private
   public dtfr

   ! global variables for dtfr

   ! units
   integer::nout,npend,nin,nplot

   ! neutron group structure
   real(kr)::egn(2501)
   integer::ngn

   ! gamma group structure
   real(kr)::egg(400)
   integer::ngp

   ! dtfr parameters
   integer::iprint,ifilm,iedit,nlmax,ng,iptotl,ipingp
   integer::itabl,ned,nptabl,jgthrm
   integer,parameter::nedmax=50
   character(6)::hednam(3+nedmax)
   integer::jped(3+nedmax),mted(3+nedmax)
   integer::multed(3+nedmax),ids(3+nedmax)
   character(6)::hisnam
   integer::matd,jz
   real(kr)::dtemp
   integer::kpos,ked,lpos,led,iphph
   integer::mti,mtc,nlc
   real(kr)::bot,axl,axd,top
   integer::ixo,iyo
   integer::nplt
   real(kr)::xmin,xmax,ymin,ymax

   ! sigma-zero storage
   real(kr)::sigz(10)
   integer::nsigz

   ! storage arrays
   integer,parameter::ndim=7000
   real(kr)::x(ndim),y(ndim),z(ndim)
   integer,parameter::nwamax=40000
   real(kr)::a(nwamax)
   integer,parameter::nwsmax=500000
   real(kr)::sig(nwsmax)

contains

   subroutine dtfr
   !-------------------------------------------------------------------
   !
   ! convert output of groupr to dtf format.
   !
   ! Processes neutron and gamma production cross sections and
   ! matrices.  The neutron tables can have reduced table length.
   ! Up-scatter is allowed.  The absorption reaction is computed
   ! from the total cross section and total scattering.  Any edits
   ! can be produced which are either given in the ENDF file
   ! or are linear combinations of ENDF cross sections.  The
   ! fission nu*sigf and chi are computed from the fission matrices
   ! for all partial fission reactions.  Chi includes source
   ! weighting.  The Pl tables for l.gt.0 contain the Pl weighted
   ! total in the total position and the pl transport cross section
   ! in the absorption position.  The gamma tables have gamma group
   ! 1 in position 1, 2 in position 2, etc, with a table length
   ! equal to the number of gamma groups.
   !
   ! Plots can be prepared in viewr format.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1       units
   !    nin       input unit with data from groupr (binary).
   !    nout      output unit containing dtf tables (coded).
   !              (default=0=none)
   !    npend     input unit with pendf tape for point plots.
   !              (default=0=none)
   !    nplot     output plot info for plotr module
   !              (default=0=none)
   ! card 2       options
   !    iprint    print control (0 minimum, 1 maximum)
   !    ifilm     film control (0/1/2=no/yes with 1 plot per frame/
   !              yes with 4 plots per frame (default=0)
   !    iedit     edit control (0/1=in table/separate) (default=0)
   !
   !       cards 3 through 5 only for iedit=0
   !
   ! card 3       neutron tables
   !    nlmax     number of neutron tables desired.
   !    ng        number of neutron groups
   !    iptotl    position of total cross section
   !    ipingp    position of in-group scattering cross section.
   !    itabl     neutron table length desired.
   !    ned       number of entries in edit table (default=0).
   !    ntherm    number of thermal groups (default=0).
   !  card 3a only for ntherm ne 0
   ! card 3a      thermal incoherent and coherent mts
   !    mti       mt for thermal incoherent data
   !    mtc       mt for thermal coherent data (default=0)
   !    nlc       no. coherent legendre orders (default=0)
   ! card 4       edit names
   !       six character hollerith names for edits for as many
   !       cards as needed.  there will be iptotl-3 names read.
   !       each name is delimited with *.
   ! card 5       edit specifications
   !       ned triplets of numbers on as many cards as needed.
   !       positions can appear more than once.
   !       reaction types can appear more than once.
   !    jpos      position of edit quantity.
   !    mt        endf reaction number.
   !    mult      multiplicity to be used when adding this mt.
   !
   !       card 6 for iedit=1
   !
   ! card 6       claw-format tables
   !    nlmax     number of neutron tables (def=5)
   !    ng        number of neutron groups (def=30)
   !              (number of thermal groups is zero)
   !
   ! card 7       gamma ray tables
   !    nptabl    number of gamma tables desired (default=0)
   !    ngp       number of gamma groups (default=0)
   ! card 8       material description
   !       one card for each table set desired.
   !       empty card (/) terminates execution of dtfr.
   !    hisnam    6-character isotope name
   !    mat       material number as in endf (default=0)
   !    jsigz     index number of sigma-zero desired (default=1)
   !    dtemp     temperature desired (default=300)
   !
   !-------------------------------------------------------------------
   use util ! provides timer,openz,repoz,error,closz
   use endf ! provides endf routines and variables
   use mainio ! provides nsysi,nsyso
   ! internals
   integer::nscr,nb,nw,i,nl,nz,ng2,ig2lo,lz,nwa
   integer::ntw,ngg,jbase,j,ngnp1,nggp1,il,ip,i618,ig,nws,n3
   integer::jg,loca,locs,ied,jpos,k,jg2,locb,locf,kg,id,jgp
   integer::jzd,ilmax,ipmax,loc,idone
   real(kr)::time,csz,temp,test,t,ff,sss,cnorm,cnm,dnorm
   real(kr)::spect(2501),fcap(2501),ffis(2501)
   real(kr),parameter::size=.30e0_kr
   real(kr),parameter::zero=0

   !--read  user input and write heading
   call timer(time)
   write(nsyso,'(/&
     &'' dtfr...produce dtf format from groupr output'',&
     &24x,f8.1,''s'')') time
   write(nsyse,'(/'' dtfr...'',61x,f8.1,''s'')') time
   call ruin
   nscr=11
   if (nin.lt.0) nscr=-nscr
   call openz(nscr,1)

   !--initialize plotting
   csz=size
   if (ifilm.gt.1) csz=csz/2
   write(nplot,'(''1 2'',f6.3,'' /'')') csz

   !--select next material, dilution, and temperature.
  105 continue
   hisnam=' '
   matd=0
   jzd=1
   dtemp=300
   read(nsysi,*) hisnam,matd,jzd,dtemp
   cnorm=0
   cnm=0
   dnorm=0
   ilmax=0
   ipmax=0
   ixo=0
   iyo=0
   if (matd.eq.0) go to 900
   write(nsyso,'(//&
     &'' mat='',i4,''  iso='',a6,''  sigzero no='',i2,&
     &''  temp='',1p,e10.3)') matd,hisnam,jzd,dtemp

   !--find desired material on input tape, process header section,
   !--and copy rest of material to scratch tape
   call repoz(nin)
   call tpidio(nin,0,0,a,nb,nw)
   call repoz(nscr)
   nsc=0
  130 continue
   call contio(nin,0,0,a,nb,nw)
   if (math.eq.matd) go to 135
   if (math.eq.-1) go to 132
   if (mfh.eq.0) go to 130
   call tomend(nin,0,0,a)
   go to 130
  132 continue
   write(nsyso,'(/'' ***material not found'')')
   go to 105
  135 continue
   loc=7
   call listio(nin,0,0,a(loc),nb,nw)
   temp=a(7)
   test=1
   test=test/1000
   if (abs(temp-dtemp).le.test) go to 136
   call tomend(nin,0,0,a)
   go to 130
  136 continue
   do while (nb.ne.0)
      loc=loc+nw
      call moreio(nin,0,0,a(loc),nb,nw)
   enddo
   nsigz=nint(a(4))
   ntw=nint(a(6))
   ngn=nint(a(9))
   if (ngn.ne.ng) call error('dtfr',&
     'number of neutron groups disagrees with number requested.',&
     ' ')
   ngg=nint(a(10))
   if (ngp.gt.0.and.ngg.ne.ngp) call error('dtfr',&
     'number of gamma groups disagrees with number requested.',&
     ' ')
   jbase=12
   jbase=jbase+ntw
   do j=1,nsigz
      sigz(j)=a(j+jbase)
   enddo
   jbase=jbase+nsigz
   ngnp1=ngn+1
   do j=1,ngnp1
      egn(j)=a(j+jbase)
   enddo
   jbase=jbase+ngnp1
   nggp1=ngg+1
   do j=1,nggp1
      egg(j)=a(j+jbase)
   enddo
   call tofend(nin,0,0,a)
   call tomend(nin,0,nscr,a)

   !--find desired material and temperature on pendf tape
   if (npend.eq.0) go to 129
   call repoz(npend)
   call tpidio(npend,0,0,a,nb,nw)
   call findf(matd,1,451,npend)
   test=dtemp/1000+1
   t=0
   idone=0
   do while (idone.eq.0)
      call contio(npend,0,0,a,nb,nw)
      if (math.ne.matd) then
         call error('dtfr','desired temperature not on pendf',' ')
      endif
      call contio(npend,0,0,a,nb,nw)
      if (n1h.ne.0) then
         iverf=4
      else if (n2h.eq.0) then
         iverf=5
      else
         iverf=6
      endif
      call skiprz(npend,-1)
      if (iverf.ge.5) call contio(npend,0,0,a,nb,nw)
      if (iverf.ge.6) call contio(npend,0,0,a,nb,nw)
      call hdatio(npend,0,0,a,nb,nw)
      t=a(1)
      if (abs(t-dtemp).ge.test) then
         call tomend(npend,0,0,a)
      else
         idone=1
      endif
   enddo

   !--generate requested neutron and photon tables.
  129 continue
   il=1
   if (nlmax.eq.0) il=0
   ip=0
   if (nlmax.eq.0) ip=1
   i618=0
  110 continue
   call repoz(nscr)
   ig=ngn
   if (il.gt.0) nws=itabl*ng
   if (ip.gt.0) nws=ngp*ng
   if (nws.gt.nwsmax)&
     call error('dtfr','not enough storage for table.',' ')
   n3=ned+3
   do i=1,nwsmax
      if (i.le.n3) ids(i)=0
      sig(i)=0
   enddo

   !--read next record.  process according to type.
  150 continue
   if (ig.lt.ngn) go to 160
   call contio(nscr,0,0,a,nb,nw)
   if (math.eq.0) go to 800
   if (mfh.eq.0.or.mth.eq.0) go to 150
   if (mth.eq.501) mted(ned+3)=501
   if (mfh.eq.23) iphph=1
   nl=nint(a(3))
   if (il.gt.nl.or.ip.gt.nl) go to 155
   nz=nint(a(4))
   jz=jzd
   if (jz.gt.nz) jz=1
   go to 160
  155 continue
   call tosend(nscr,0,0,a)
   go to 150
  160 continue
   call listio(nscr,0,0,a,nb,nw)
   ng2=nint(a(3))
   ig2lo=nint(a(4))
   ig=nint(a(6))
   lz=6
   nwa=1+nw
   do while (nb.ne.0)
      call moreio(nscr,0,0,a(nwa),nb,nw)
      nwa=nwa+nw
      if (nwa.gt.nwamax)&
        call error('dtfr','not enough storage for record.',' ')
   enddo
   if (il.eq.1.and.mth.eq.455) go to 400
   if (il.gt.0.and.mfh.eq.3) go to 200
   if (il.gt.0.and.mfh.eq.23) go to 200
   if (il.gt.0.and.mfh.eq.6) go to 300
   if (il.gt.0.and.mfh.eq.26) go to 300
   if (ip.gt.0.and.(mfh.eq.16.or.mfh.eq.17)) go to 600
   go to 150

   !--process neutron cross sections.
  200 continue
   if (mth.eq.1) go to 210
   if (mth.eq.501) go to 210
   if (mth.eq.102.or.mth.eq.18) go to 220
   if (ned.gt.0) go to 240
   go to 260
   ! save total.
  210 continue
   if (il.gt.nl) go to 150
   jg=ng-ig+1
   loca=lz+il+nl*((jz-1)+nz)
   locs=iptotl+itabl*(jg-1)
   ids(ned+3)=1
   sig(locs)=a(loca)
   if (il.gt.1) go to 150
   locs=locs-2
   sig(locs)=sig(locs)+a(loca)
   ids(ned+1)=1
   if (ned.eq.0) go to 150
   go to 240
   ! save capture and fission self-shielding factors
  220 continue
   jg=ng-ig+1
   loca=lz+il+nl*nz
   if (mth.eq.18) ffis(jg)=1
   if (mth.eq.18.and.a(loca).ne.zero)&
     ffis(jg)=a(loca+nl*(jz-1))/a(loca)
   if (mth.eq.102) fcap(jg)=1
   if (mth.eq.102.and.a(loca).ne.zero)&
     fcap(jg)=a(loca+nl*(jz-1))/a(loca)
   if (ned.gt.0) go to 240
   go to 260
   ! save edit cross sections
  240 continue
   if (il.gt.1) go to 150
   do ied=1,ned
      if (mth.eq.1.and.mted(ied).eq.300) then
         loca=lz+il+nl*(jz-1)
         jpos=jped(ied)
         locs=jpos+itabl*(jg-1)
         sig(locs)=a(loca)*multed(ied)+sig(locs)
         ids(ied)=ied
      else if (mth.eq.mted(ied)) then
         jg=ng-ig+1
         loca=lz+il+nl*((jz-1)+nz)
         locs=jped(ied)+itabl*(jg-1)
         sig(locs)=sig(locs)+multed(ied)*a(loca)
         ids(ied)=ied
      endif
   enddo
   ! thermal correction for total and absorption
  260 continue
   if (il.gt.1) go to 150
   if (mth.ne.2.and.mth.ne.mti.and.mth.ne.mtc) go to 150
   jg=ng-ig+1
   if (jg.lt.jgthrm) go to 150
   loca=lz+il+nl*((jz-1)+nz)
   locs=iptotl+itabl*(jg-1)
   if (mth.eq.2) sig(locs)=sig(locs)-a(loca)
   if (mth.eq.mti.or.mth.eq.mtc) sig(locs)=sig(locs)+a(loca)
   if (mth.eq.2) sig(locs-2)=sig(locs-2)-a(loca)
   if (mth.eq.mti.or.mth.eq.mtc) sig(locs-2)=sig(locs-2)+a(loca)
   go to 150

   !--accumulate neutron transfer matrices.
  300 continue
   if (mth.eq.18) go to 340
   if (mth.eq.19.or.mth.eq.20.or.mth.eq.21.or.mth.eq.38) go to 340
   ilmax=il
   jg=ng-ig+1
   if (mth.eq.2.and.jg.ge.jgthrm) go to 150
   if (mth.lt.200.or.mth.gt.250) go to 305
   if (jg.lt.jgthrm) go to 150
   if (mth.eq.mti) go to 305
   if (mth.eq.mtc.and.mth-mtc+1.eq.il) go to 305
   go to 150
  305 continue
   do k=2,ng2
      jg2=ng-ig2lo-k+3
      jpos=ipingp+(jg2-jg)
      if (jpos.gt.itabl) jg2=jg2-jpos+itabl
      if (jpos.gt.itabl) jpos=itabl
      if (jpos.le.iptotl) jg2=jg2+iptotl+1-jpos
      if (jpos.le.iptotl) jpos=iptotl+1
      if (jpos.le.itabl) then
         loca=lz+il+nl*((jz-1)+nz*(k-1))
         locs=jpos+itabl*(jg2-1)
         sig(locs)=sig(locs)+a(loca)
         if (il.le.1) then
            locb=iptotl-2+itabl*(jg-1)
            sig(locb)=sig(locb)-a(loca)
         endif
      endif
   enddo
   go to 150

   !--special branch for fission reactions.
   !--accumulate nu*sigf and chi.
  340 continue
   if (il.gt.1) go to 150
   if (mth.eq.18) i618=1
   if (mth.eq.19.and.i618.gt.0)&
     call error('dtfr','mt18 already processed, mt19 not allowed.',&
     ' ')
   ids(ned+2)=1
   if (ig.eq.0) go to 360
   if (ig2lo.eq.0) go to 380
   jg=ng-ig+1
   do k=2,ng2
      loca=lz+il+nl*((jz-1)+nz*(k-1))
      locs=iptotl-1+itabl*(jg-1)
      sss=a(loca)
      if (mth.eq.18.or.mth.eq.19) sss=sss*ffis(jg)
      sig(locs)=sig(locs)+sss
      if (kpos.gt.0) then
         locf=lz+il+nl*(jz-1)
         jg2=ng-ig2lo-k+3
         locs=kpos+itabl*(jg2-1)
         sig(locs)=sig(locs)+a(locf)*sss
         cnorm=cnorm+a(locf)*sss
         ids(ked)=ked
      endif
   enddo
   go to 390
  360 continue
   do k=1,ng
      jg=ng-k+1
      spect(jg)=0
      if (k.ge.ig2lo.and.k.le.(ig2lo+ng2-1)) then
         loca=lz+k-ig2lo+1
         spect(jg)=a(loca)
      endif
   enddo
   go to 150
  380 continue
   if (kpos.eq.0) go to 150
   jg=ng-ig+1
   loca=lz+il+nl*(jz-1)+jz
   locf=lz+il
   locs=iptotl-1+itabl*(jg-1)
   sss=a(loca)
   if (mth.eq.18.or.mth.eq.19) sss=sss*ffis(jg)
   sig(locs)=sig(locs)+sss
   cnm=cnm+sss*a(locf)
  390 continue
   if (ig.ge.ng.and.cnm.ne.zero) then
      do k=1,ng
         locs=kpos+itabl*(k-1)
         sig(locs)=sig(locs)+cnm*spect(k)
         cnorm=cnorm+cnm*spect(k)
         ids(ked)=ked
      enddo
   endif
   go to 150

   !--special branch for delayed neutrons.
  400 continue
   if (mfh.eq.5) go to 440
   jg=ng-ig+1
   locs=iptotl-1+itabl*(jg-1)
   loca=lz+1
   sig(locs)=sig(locs)+a(loca+1)*a(loca+2)*ffis(jg)
   ids(ned+2)=1
   dnorm=dnorm+a(loca)*a(loca+1)*a(loca+2)*ffis(jg)
   go to 200
  440 continue
   do kg=2,ng2
      jg=ng-ig2lo-kg+3
      do id=1,nl
         loca=lz+id+nl*(kg-1)
         if (lpos.gt.0) then
            locs=lpos+itabl*(jg-1)
            sig(locs)=sig(locs)+a(loca)
            ids(led)=led
         endif
         if (kpos.gt.0) then
            if (dnorm.eq.zero) call error('dtfr',&
              'delayed nubar required',&
              'to add delayed chi to total.')
            locs=kpos+itabl*(jg-1)
            sig(locs)=sig(locs)+dnorm*a(loca)
            cnorm=cnorm+dnorm*a(loca)
            ids(ked)=ked
         endif
      enddo
   enddo
   go to 150

   !--accumulate photon production matrices.
  600 continue
   jg=ng-ig+1
   ff=1
   if (mth.eq.102) ff=fcap(jg)
   if (mth.eq.18) ff=ffis(jg)
   if (ig.eq.0) then
      do k=1,ngp
         jgp=ngp-k+1
         spect(jgp)=0
         if (k.ge.ig2lo.and.k.le.(ig2lo+ng2-1)) then
            loca=lz+k-ig2lo+1
            spect(jgp)=a(loca)
         endif
      enddo
   else if (ig2lo.eq.0) then
      loca=lz+ip+nl*((jz-1)+nz)
      do k=1,ngp
         locs=k+ngp*(jg-1)
         sig(locs)=sig(locs)+a(loca)*ff*spect(k)
      enddo
   else
      ipmax=ip
      do k=2,ng2
         jpos=ngp-ig2lo-k+3
         if (jpos.ge.1.and.jpos.le.ngp) then
            loca=lz+ip+nl*((jz-1)+nz*(k-1))
            locs=jpos+ngp*(jg-1)
            sig(locs)=sig(locs)+a(loca)*ff
         endif
      enddo
   endif
   go to 150

   !--accumulation complete
   !--make transport corrections if desired.
   !--normalize fission chi vector if desired.
   !--print out dtf tables if desired
  800 continue
   if (il.eq.1.and.kpos.ne.0.and.cnorm.ne.zero) then
      do k=1,ng
         locs=kpos+itabl*(k-1)
         sig(locs)=sig(locs)/cnorm
      enddo
   endif
   call dtfout(sig,il,ip,ilmax,ipmax)
   if (ip.eq.0) il=il+1
   if (il.gt.nlmax) il=0
   if (il.eq.0) ip=ip+1
   if (ip.gt.nptabl) ip=0
   if (il.gt.0) go to 110
   if (ip.gt.0) go to 110
   go to 105

   !--dtfr is finished.
  900 continue
   ! terminate plotting system
   write(nplot,'('' 99/'')')
   call closz(nplot)
   call closz(nin)
   call closz(npend)
   call closz(nout)
   call closz(nscr)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine dtfr

   subroutine ruin
   !-------------------------------------------------------------------
   ! Read user input.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util   ! provides error,openz,repoz
   ! internals
   integer::i,j,jlast,jedit,nthrm,nedpos
   character(6)::hword
   character(6),parameter::hnusf='nusigf'
   character(6),parameter::hnabs='absorp'
   character(6),parameter::hntotl='total '
   character(6),parameter::hblank='      '
   integer,dimension(50),parameter::kmted=(/2,4,16,6,7,8,9,17,&
     102,107,103,19,20,21,18,104,105,106,111,112,113,114,108,109,&
     32,35,34,22,24,23,25,28,29,30,33,36,37,38,470,471,455,300,&
     301,443,443,444,452,1,0,0/)
   integer,dimension(50),parameter::kjped=(/1,2,3,3,3,3,3,4,5,&
     6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,&
     27,28,29,30,31,32,33,34,35,36,37,38,39,39,40,41,42,43,44,45/)
   integer,dimension(50),parameter::kmultd=(/1,1,1,1,1,1,1,1,1,1,&
     1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,&
     1,1,1,0,1,1,1,1,1,1/)
   character(5),dimension(50),parameter::hmtid=(/&
     '  els','  ins','  n2n','  n3n','  ngm','  nal','   np',&
     ' fdir','  nnf',' n2nf',' ftot','   nd','   nt',' nhe3',&
     '  n2p','  npa',' nt2a',' nd2a','  n2a','  n3a','  nnd',&
     'nnd2a','nnhe3','  nna',' n2na',' nn3a',' n3na','  nnp',&
     ' nn2a','n2n2a','  nnt','nnt2a','  n4n',' n3nf','  chi',&
     ' chid','  nud','  phi','theat','kerma','tdame',' nusf',&
     ' totl','     ','     ','     ','     ','     ','     ',&
     '     '/)

   !--read initial parameters
   mti=0
   mtc=0
   nlc=0
   nout=0
   npend=0
   nplot=0
   read(nsysi,*) nin,nout,npend,nplot
   call openz(nin,0)
   call openz(nout,1)
   call openz(npend,0)
   call openz(nplot,1)
   ifilm=0
   iedit=0
   read(nsysi,*) iprint,ifilm,iedit
   if (nplot.eq.0) ifilm=0
   write(nsyso,'(/&
     &'' input gendf unit ..................... '',i10/&
     &'' output unit .......................... '',i10/&
     &'' input pendf unit ..................... '',i10/&
     &'' output plot data ..................... '',i10)')&
     nin,nout,npend,nplot
   write(nsyso,'(&
     &'' print option (0 min, 1 max) .......... '',i10/&
     &'' film option (none, 1/plot, 4/plot ) .. '',i10/&
     &'' edit option (0 table, 1 sep.)......... '',i10)')&
     iprint, ifilm, iedit

   !--read parameter values for iedit=0
   if (iedit.eq.0) then
      ned=0
      nthrm=0
      read(nsysi,*) nlmax,ng,iptotl,ipingp,itabl,ned,nthrm
      if (ipingp.le.iptotl) call error('dtfr','iping.le.iptotl.',' ')
      jgthrm=ng+1-nthrm
      if (nthrm.ne.0) then
         mtc=0
         nlc=0
         read(nsysi,*) mti,mtc,nlc
      endif

   !--set standard values for iedit=1 (claw format)
   else
      nlmax=5
      ng=30
      read(nsysi,*) nlmax,ng
      iptotl=43+3
      ned=48
      jgthrm=ng+1
      ipingp=iptotl+1
      itabl=iptotl+ng
      nedpos=iptotl-3
      nptabl=0
      do i=1,nedpos
      hednam(i)=hmtid(i)
      enddo
      do i=1,ned
         jped(i)=kjped(i)
         mted(i)=kmted(i)
         multed(i)=kmultd(i)
      enddo
   endif

   !--write out neutron table specifications
   write(nsyso,'(&
     &'' number of neutron tables ............. '',i10/&
     &'' number of neutron groups ............. '',i10)')&
     nlmax, ng
   if (nlmax.gt.0) then
      write(nsyso,'(&
        &'' position of total .................... '',i10/&
        &'' position of in-group ................. '',i10/&
        &'' table length ......................... '',i10)')&
        iptotl, ipingp, itabl
      if (jgthrm.le.ng) write(nsyso,'(&
        &'' thermal break group .................. '',i10)')&
        jgthrm
      if (jgthrm.le.ng) write(nsyso,'(&
        &'' thermal incoherent mt ................ '',i10/&
        &'' thermal coherent mt .................. '',i10/&
        &'' no. coherent legendre orders ......... '',i10)')&
        mti,mtc,nlc

      !--read edit descriptions for iedit=0
      if (iedit.eq.0) then
         if (ned+3.gt.nedmax)&
           call error('dtfr','not enough storage for edits.',' ')
         if (ned.ne.0) then
            nedpos=iptotl-3
            if (nedpos.ne.0) then
              read(nsysi,*) (hednam(i),i=1,nedpos)
            endif
            read(nsysi,*) (jped(j),mted(j),multed(j),j=1,ned)
         endif
      endif

      !--write out edit specifications
      if (ned.gt.0) then
         write(nsyso,'(&
           &'' edit cross sections .................. '',&
           &'' name   position reaction multiplicity'')')
         jlast=0
         jedit=0
         kpos=0
         lpos=0
         do i=1,ned
            hword=hblank
            if (nedpos.ne.0.and.jped(i).ne.jlast) then
               jedit=jedit+1
               jlast=jped(i)
               hword=hednam(jedit)
            endif
            if (mted(i).eq.470) kpos=jped(i)
            if (mted(i).eq.470) ked=i
            if (mted(i).eq.471) lpos=jped(i)
            if (mted(i).eq.471) led=i
            write(nsyso,'(40x,a6,3x,i2,7x,i3,8x,i2)')&
              hword,jped(i),mted(i),multed(i)
         enddo
      endif
   endif

   !--add three standard edits
   hednam(iptotl-1)=hnusf
   jped(ned+2)=iptotl-1
   mted(ned+2)=1000
   hednam(iptotl-2)=hnabs
   jped(ned+1)=iptotl-2
   mted(ned+1)=1000
   hednam(iptotl)=hntotl
   jped(ned+3)=iptotl
   mted(ned+3)=1

   !--read and display photon table specifications
   nptabl=0
   ngp=0
   read(nsysi,*) nptabl,ngp
   write(nsyso,'(&
     &'' number of photon tables .............. '',i10)') nptabl
   if (nptabl.gt.0) write(nsyso,'(&
     &'' number of photon groups .............. '',i10)') ngp
   write(nsyso,'(/)')
   call repoz(nout)
   return
   end subroutine ruin

   subroutine dtfout(sig,il,ip,ilmax,ipmax)
   !-------------------------------------------------------------------
   ! Write and/or plot group constants in DTF format.
   !-------------------------------------------------------------------
   use util ! provides dater
   use mainio ! provides nsyso
   ! externals
   integer::il,ip,ilmax,ipmax
   real(kr)::sig(*)
   ! internals
   integer::j,nj,ifis,i,jpos,iseq,k,ig,locs,i1,ii,l
   integer::med,nws,ltabn,igp,nw
   real(kr)::dat(6)
   character(6)::hmti
   character(8)::hdat
   character(8),parameter::id='njoy    '

   !--special format 0 -- output dtf tables with internal edits.
   if (iedit.ne.0) go to 130
   if (il.ne.0) then
      nw=itabl*ng
      if (nout.gt.0) write(nout,'(/'' il= '',i1,'' table'',i3,&
        &'' gp'',i3,'' pos, mat='',i5,'' iz='',i2,&
        &'' temp='',1p,e12.5)') il,ng,itabl,matd,jz,dtemp
      if (iprint.eq.1) write(nsyso,'(/'' il= '',i1,'' table'',i3,&
        &'' gp'',i3,'' pos, mat='',i5,'' iz='',i2,&
        &'' temp='',1p,e12.5)') il,ng,itabl,matd,jz,dtemp
   else
      nw=ngp*ng
      if (nout.gt.0) write(nout,'(/'' ip= '',i1,'' table'',i3,&
        &'' gp'',i3,'' pos, mat='',i5,'' iz='',i2,&
        &'' temp='',1p,e12.5)') ip,ng,ngp,matd,jz,dtemp
      if (iprint.eq.1) write(nsyso,'(/'' ip= '',i1,'' table'',i3,&
        &'' gp'',i3,'' pos, mat='',i5,'' iz='',i2,&
        &'' temp='',1p,e12.5)') ip,ng,ngp,matd,jz,dtemp
   endif
   if (nout.gt.0) write(nout,'(1p,6e12.4)') (sig(j),j=1,nw)
   if (iprint.eq.1) write(nsyso,'(1x,1p,6e12.4)') (sig(j),j=1,nw)
   go to 300

   !--special format 1 -- td6 format.  write separate edits
  130 continue
   if (il.eq.0) go to 250
   if (il.gt.1) go to 200
   call dater(hdat)
   if (nout.gt.0) write(nout,'(a6,''     edit xsec ('',&
     &i3,''x'',i3,'') proc by '',a6,'' on '',2a8)')&
     hisnam,ng,ned,id,hdat
   if (iprint.eq.1) write(nsyso,'(1x,a6,''     edit xsec ('',&
     &i3,''x'',i3,'') proc by '',a6,'' on '',2a8)')&
     hisnam,ng,ned,id,hdat
   ifis=ids(ned+2)
   nj=iptotl-3
   do 140 j=1,nj
   if (j.le.7) go to 150
   if (ifis.gt.0.and.j.le.11) go to 150
   if (j.ge.nj-1) go to 150
   do 145 i=1,ned
   if (jped(i).eq.j.and.ids(i).gt.0) go to 150
  145 continue
   go to 140
  150 continue
   jpos=j
   if (j.eq.nj-1.and.ifis.eq.0) go to 140
   if (j.eq.nj-1) jpos=iptotl-1
   if (j.eq.nj) jpos=iptotl
   hmti=hednam(j)
   iseq=0
   k=0
   do ig=1,ng
      locs=jpos+itabl*(ig-1)
      k=k+1
      dat(k)=sig(locs)
      if (k.ge.6.or.ig.ge.ng) then
         iseq=iseq+1
         if (k.ne.6) then
            i1=k+1
            do ii=i1,6
               dat(ii)=0
            enddo
         endif
         if (nout.gt.0) write(nout,'(1p,6e12.5,a2,a5,i1)')&
           (dat(i),i=1,6),hisnam,hmti,iseq
         if (iprint.eq.1) write(nsyso,'(1x,1p,6e12.5,a2,a5,i1)')&
           (dat(i),i=1,6),hisnam,hmti,iseq
         k=0
      endif
   enddo
  140 continue

   !--write reduced neutron table with edits removed.
  200 continue
   l=il-1
   if (il.le.ilmax) then
      med=iptotl-3
      nws=ng*itabl
      iseq=0
      ltabn=itabl-iptotl+3
      if (nout.gt.0) write(nout,'(a6,'' l='',i1,&
        &'' n-n table ('',i3,''x'',i3,'')'')')&
        hisnam,l,ltabn,ng
      if (iprint.eq.1) write(nsyso,'(1x,a6,'' l='',i1,&
        &'' n-n table ('',i3,''x'',i3,'')'')')&
        hisnam,l,ltabn,ng
      k=0
      do ig=1,ng
         do jpos=1,itabl
            if (jpos.gt.med) then
               k=k+1
               locs=jpos+itabl*(ig-1)
               dat(k)=sig(locs)
               if (k.ge.6.or.locs.ge.nws) then
                  iseq=iseq+1
                  if (k.ne.6) then
                     i1=k+1
                     do i=i1,6
                        dat(i)=0
                     enddo
                  endif
                  if (nout.gt.0) write(nout,&
                    '(1p,6e12.5,a2,i2,i4)')&
                    (dat(i),i=1,6),hisnam,l,iseq
                  if (iprint.eq.1) write(nsyso,&
                    '(1p,6e12.5,a2,i2,i4)')&
                    (dat(i),i=1,6),hisnam,l,iseq
                  k=0
               endif
            endif
         enddo
      enddo
   endif
   go to 300

   !--write photon table
  250 continue
   l=ip-1
   if (ip.le.ipmax) then
      iseq=0
      if (nout.gt.0) write(nout,'(1x,a6,'' l='',i1,&
        &''h n-p table ('',i3,''x'',i3,'')'')')&
        hisnam,l,ngp,ng
      if (iprint.eq.1) write(nsyso,'(a6,'' l='',i1,&
        &'' n-p table ('',i3,''x'',i3,'')'')')&
        hisnam,l,ngp,ng
      k=0
      nws=ng*ngp
      do ig=1,ng
         do igp=1,ngp
            k=k+1
            locs=igp+ngp*(ig-1)
            dat(k)=sig(locs)
            if (k.ge.6.or.locs.ge.nws) then
               iseq=iseq+1
               if (k.ne.6) then
                  i1=k+1
                  do i=i1,6
                     dat(i)=0
                  enddo
               endif
               if (nout.gt.0) write(nout,&
                 '(1p,6e12.5,a2,i2,i4)')&
                 (dat(i),i=1,6),hisnam,l,iseq
               if (iprint.eq.1) write(nsyso,&
                 '(1p,6e12.5,a2,i2,i4)')&
                 (dat(i),i=1,6),hisnam,l,iseq
               k=0
            endif
         enddo
      enddo
   endif

   !--plot dtf edit quantities and scattering tables
  300 continue
   if (ifilm.gt.0.and.il.eq.1) call ploted(sig)
   if (ifilm.gt.0.and.il.eq.1.and.il.le.ilmax) call plotnn(sig,il)
   if (ifilm.gt.0.and.ip.eq.1.and.ip.le.ipmax) call plotnp(sig,ip)
   return
   end subroutine dtfout

   subroutine ploted(sig)
   !-------------------------------------------------------------------
   ! Generate plots of all edit and cross section positions.
   ! Overlay corresponding pointwise cross sections from pendf.
   !-------------------------------------------------------------------
   use endf ! provides iverf
   ! externals
   real(kr)::sig(*)
   ! internals
   integer::i,nk,k,ksave,jpos,mt,locs
   integer::nh,ih,j,iy1,lin,nsym,ndash,ipt,npts
   real(kr)::deltay,xll,yll,xur,yur,xtag,ytag
   character(6)::hedn
   character(16)::labelz
   character(8)::l1
   character(1)::qu=''''
   character(1),dimension(5),parameter::nchar=(/' ','x','+','*','0'/)
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::ww=5.e0_kr
   real(kr),parameter::hh=3.75e0_kr
   real(kr),parameter::zero=0

   !--plot cross sections (non-zero reactions only)
   nplt=iptotl
   deltay=16
   do 100 i=1,nplt
   nk=ned+3
   do 110 k=1,nk
   ksave=k
   if (jped(k).eq.i.and.ids(k).gt.0) go to 112
  110 continue
   go to 100
  112 continue
   jpos=i
   mt=mted(ksave)
   if (mt.eq.300) go to 100
   if (mt.eq.1.and.i.ne.iptotl) go to 100
   hedn=hednam(jpos)

   !--draw histogram.
   write(labelz,'(a6,4x,a6)') hisnam,hedn
   do k=1,ngn
      locs=jpos+itabl*(ngn-k)
      y(k)=sig(locs)
   enddo
   call histod(x,y,z,nh,ngn,egn)
   if (ifilm.eq.1) then
      write(nplot,'('' 1/'')')
   else
      xll=ww*ixo
      yll=hh-hh*iyo
      xur=ww
      yur=hh
      if (ixo.eq.0.and.iyo.eq.0) then
         write(nplot,'('' 1 0 1. 1.'',5f6.2,''/'')')&
           xll,yll,xur,yur,zero
      else
         write(nplot,'('' -1 0 1. 1.'',5f6.2,''/'')')&
           xll,yll,xur,yur,zero
      endif
   endif
   if (mt.ge.500.and.mt.le.522) then
      if (ifilm.eq.1) xtag=ten**xmax/10
      if (ifilm.eq.2) xtag=3*ten**xmax/100
   else
      xtag=xmin+(xmax-xmin)/50
      xtag=ten**xtag
   endif
   ytag=ymax-(ymax-ymin)/50
   ytag=ten**ytag
   write(nplot,'(1x,a,''<'',a20,a,''/'')') qu,labelz,qu
   write(nplot,'('' /'')')
   write(nplot,'('' 4 0 3 1'',2e10.2,''/'')') xtag,ytag
   write(nplot,'(1p,3e10.2,''/'')') ten**xmin,ten**xmax,one
   write(nplot,'(1x,a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
   write(nplot,'(1p,3e10.2,''/'')') ten**ymin,ten**ymax,one
   write(nplot,'(1x,a,''<c>ross <s>ection (barns)'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   write(nplot,'('' 0 0 0 0 1/'')')
   write(nplot,'(1x,a,''<m.g.>'',a,''/'')') qu,qu
   write(nplot,'('' 0'')')
   do ih=1,nh
      write(nplot,'(1p,2e13.4,''/'')') x(ih),z(ih)
   enddo
   write(nplot,'('' /'')')
   if (ifilm.ne.1) then
      ixo=ixo+1
      if (ixo.gt.1) ixo=0
      if (ixo.eq.0) iyo=iyo+1
      if (iyo.gt.1) iyo=0
   endif
   if (iphph.eq.1) then
      if (iverf.ge.6) then
         if (mt.lt.501.or.mt.gt.522) go to 100
      else
         if (mt.lt.501.or.mt.gt.602) go to 100
      endif
   else
      if (iverf.ge.6) then
         if (mt.gt.150.and.mt.lt.301) go to 100
         if (mt.gt.450.and.mt.lt.600) go to 100
         if (mt.gt.849) go to 100
      else
         if (mt.gt.150.and.mt.lt.301) go to 100
         if (mt.gt.450.and.mt.lt.700) go to 100
         if (mt.gt.799) go to 100
      endif
   endif

   !--draw smooth plot(s)
   j=0
   k=ksave
   iy1=10
  140 continue
   j=j+1
   write(l1,'(''mt'',i3)') mt
   nsym=ichar(nchar(j))
   call dpend(a,dtemp,matd,mt,x,y,npts)
   if (j.lt.5) then
      lin=0
      nsym=0
      ndash=j
   else if (j.ge.5.and.j.lt.9) then
      lin=1+npts/5
      nsym=4
      ndash=j-4
   else
      lin=1+npts/5
      nsym=3
      ndash=j-8
   endif
   write(nplot,'(i3,''/ pendf plot for mt='',i4)') j+1,mt
   write(nplot,'(''/'')')
   write(nplot,'(i5,i3,i3,'' 0 1/'')') lin,nsym,ndash
   write(nplot,'(1x,a,''<'',a8,a,''/'')') qu,l1,qu
   write(nplot,'('' 0'')')
   do ipt=1,npts
      write(nplot,'(1p,2e13.4,''/'')') x(ipt),y(ipt)
   enddo
   write(nplot,'('' /'')')
   iy1=iy1+nint(deltay)
  150 continue
   k=k+1
   if (k.gt.ned) go to 100
   if (ids(k).eq.0.or.jped(k).ne.i) go to 150
   mt=mted(k)
   go to 140
  100 continue
   return
   end subroutine ploted

   subroutine histod(x,y,z,n,ng,eg)
   !-------------------------------------------------------------------
   ! Prepare histogram data for plotting and choose scales for plots.
   !-------------------------------------------------------------------
   ! externals
   integer::n,ng
   real(kr)::x(*),y(*),z(*),eg(*)
   ! internals
   integer::i,iph,ipl,ipx
   real(kr)::yh,yl,ayh,ayl,ynow,axh,xnow
   real(kr),parameter::zero=0
   real(kr),parameter::two=2
   real(kr),parameter::five=5
   real(kr),parameter::ten=10
   real(kr),parameter::ptwo=.2e0_kr
   real(kr),parameter::pfive=.5e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::big=1.e+10_kr
   real(kr),parameter::fact=1.7e0_kr

   !--construct histogram removing leading and trailing zeros
   yh=small
   yl=big
   n=1
   z(n)=0
   do i=1,ng
      if (y(i).ne.zero.or.n.ne.1) then
         n=n+2
         z(n-1)=y(i)
         z(n)=y(i)
         x(n-2)=eg(i)
         x(n-1)=eg(i)
         if (y(i).gt.yh) yh=y(i)
         if (y(i).gt.zero.and.y(i).lt.yl) yl=y(i)
      endif
   enddo
   x(n)=eg(ng+1)
   n=n+1
   x(n)=eg(ng+1)
   z(n)=0

   !--set scales for plotting
   z(n)=0
   yh=fact*yh
   ayh=log10(yh)
   iph=int(ayh)
   if (iph.ge.0) iph=iph+1
   ayl=log10(yl)
   ipl=int(ayl-1)
   if ((iph-ipl).gt.6) ipl=iph-6
   if (iph.eq.ipl) iph=iph+1
   ymin=ipl
   ymax=iph
   if (iph-ipl.le.3) then
      ynow=ymin
      if (yl.gt.two*ten**ynow) ymin=ynow+log10(two)
      if (yl.gt.five*ten**ynow) ymin=ynow+log10(five)
      ynow=ymax
      if (yh.lt.pfive*ten**ynow) ymax=ynow+log10(pfive)
      if (yh.lt.ptwo*ten**ynow) ymax=ynow+log10(ptwo)
   endif
   bot=ten**ymin
   top=ten**ymax
   axh=log10(x(n))
   iph=int(axh)
   if (axh-iph.ne.zero) iph=iph+1
   xmax=iph
   ipl=int(log10(x(1))+small)
   ipx=-4
   if (ipl.gt.ipx) ipx=-2
   if (ipl.gt.ipx) ipx=4
   if (ipl.gt.ipx) ipx=5
   if (ipl.gt.ipx) ipx=6
   xmin=ipx
   if (iph-ipx.le.2) then
      xnow=xmax
      if (x(n).lt.pfive*ten**xnow) xmax=xnow+log10(pfive)
      if (x(n).lt.ptwo*ten**xnow) xmax=xnow+log10(ptwo)
      xnow=xmin
      if (x(1).gt.two*ten**xnow) xmin=xnow+log10(two)
      if (x(1).gt.five*ten**xnow) xmin=xnow+log10(five)
   endif
   axl=xmin
   axd=xmax-xmin
   do i=1,n
      if (z(i).le.bot) z(i)=bot
   enddo
   return
   end subroutine histod

   subroutine dpend(a,tempr,mat,mt,x,y,npts)
   !-------------------------------------------------------------------
   ! Retrieve point cross sections from pendf file and thin for
   ! plotting if necessary.  Add points for plotting lin-lin
   ! functions on a log-log graph if necessary.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides findf,contio,gety1
   ! externals
   integer::mat,mt,npts
   real(kr)::tempr,a(*),x(*),y(*)
   ! internals
   integer::mft,nb,nw,idis,ixlast,ix,ns
   real(kr)::e,enext,fact,step,elow,elast,s,s1,s2
   real(kr),parameter::ehigh=5.e7_kr
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   integer,parameter::nstep=50
   real(kr),parameter::zero=0

   !--find desired reaction.
   npts=0
   mft=3
   if (iphph.eq.1) mft=23
   call findf(mat,mft,mt,npend)
   call contio(npend,0,0,a,nb,nw)
   e=0
   call gety1(e,enext,idis,s,npend,a)
   fact=2000/axd
   step=ten**(one/nstep)
   elow=ten**axl

   !--read this reaction, thinning or thickening as necessary.
   ixlast=-100
   elast=enext
  210 continue
   e=enext
   if (e.gt.step*elast) e=step*elast
   elast=e
   call gety1(e,enext,idis,s,npend,a)
   if (enext.lt.elow) go to 210
   if (s.lt.zero) s=-s
   if (s.gt.top) s=top
   if (s.lt.bot) s=bot
   if (e.lt.elow) e=elow
   ix=int((log10(e)-axl)*fact)
   if (ix.eq.ixlast) go to 220
   ixlast=ix
   ns=0
   go to 230
  220 continue
   if (s.eq.y(npts)) go to 260
   go to (230,240,240,250,270),ns
  240 continue
   if ((s-y(npts))*(y(npts)-y(npts-1)).gt.zero) go to 260
  230 continue
   npts=npts+1
   if (npts.gt.ndim) call error('dpend','npts exceeds ndim.',' ')
   ns=ns+1
  260 continue
   x(npts)=e
   y(npts)=s
   if (enext.le.ehigh) go to 210
   return
  250 continue
   ns=5
   s2=y(npts-2)
   s1=y(npts-1)
   if (s2.gt.s1) go to 270
   y(npts-2)=s1
   y(npts-1)=s2
  270 continue
   if (s.le.y(npts-2)) go to 280
   y(npts-2)=s
   go to 260
  280 continue
   if (s.ge.y(npts-1)) go to 260
   y(npts-1)=s
   go to 260
   end subroutine dpend

   subroutine plotnn(sig,il)
   !-------------------------------------------------------------------
   ! Generate an isometric plot of a neutron table.
   ! This routine destroys the table.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::sig(*)
   integer::il
   ! internals
   integer::ngn,ltabn,j,k,ig,ig2,i,lim,ip,l,ig1,ig2l
   real(kr)::top,bot,dl,sigj,xll,yll,xur,yur,zlast,ss
   character(26)::ititle*26
   character(1),parameter::qu=''''
   real(kr),parameter::emin=1.e3_kr
   real(kr),parameter::emax=1.e8_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::ten=10
   real(kr),parameter::ww=5.0e0_kr
   real(kr),parameter::hh=3.75e0_kr
   real(kr),parameter::zero=0

   !--remove edits and cross sections.
   ngn=ng
   ltabn=itabl-iptotl
   j=0
   k=0
   top=-big
   do ig=1,ngn
      j=itabl*(ig-1)+iptotl
      ig2=ngn-ig+1
      dl=log(egn(ig2+1))-log(egn(ig2))
      do ip=1,ltabn
         k=k+1
         j=j+1
         sigj=sig(j)
         if (egn(ig2).lt.emin) sigj=0
         if (egn(ig2+1).gt.emax) sigj=0
         sig(k)=sigj/dl
         if (sig(k).gt.top) top=sig(k)
      enddo
   enddo
   i=int(log10(top))
   if (i.ge.0) i=i+1
   bot=ten**(i-5)
   top=ten**i
   lim=ngn*ltabn
   do k=1,lim
      if (sig(k).lt.bot) sig(k)=bot
   enddo

   !--plot the modified table
   l=il-1
   if (iphph.eq.0) write(ititle,&
     '(a6,'' l='',i1,'' neut-neut table'')') hisnam,l
   if (iphph.eq.1) write(ititle,&
     '(a6,'' l='',i1,'' phot-phot table'')') hisnam,l
   xmin=egn(1)
   if (xmin.lt.emin) xmin=emin
   i=int(log10(xmin))
   if (i.lt.0) i=i-1
   xmin=ten**i
   xmax=egn(ngn+1)
   if (xmax.gt.emax) xmax=emax
   i=int(log10(xmax))
   if (i.ge.0) i=i+1
   xmax=ten**i
   if (ifilm.eq.1) then
      write(nplot,'('' 1/ 3d data'')')
   else
      xll=ww*ixo
      yll=hh-hh*iyo
      xur=ww
      yur=hh
      if (ixo.eq.0.and.iyo.eq.0) then
         write(nplot,'('' 1 0 1. 1.'',5f6.2,''/ 3d data'')')&
           xll,yll,xur,yur,zero
      else
         write(nplot,'('' -1 0 1. 1.'',5f6.2,''/ 3d data'')')&
           xll,yll,xur,yur,zero
      endif
   endif
   write(nplot,'(1x,a,''<'',a26,a,''/'')') qu,ititle,qu
   write(nplot,'('' /'')')
   write(nplot,'('' -4 2/'')')
   write(nplot,'(1p,2e12.4,'' 1./'')') xmin,xmax
   write(nplot,'(1x,a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
   write(nplot,'(1p,2e12.4,'' 1./'')') xmin,xmax
   write(nplot,'(1x,a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
   write(nplot,'(1p,2e12.4,'' 1./'')') bot,top
   write(nplot,'(1x,a,''<x>sec/leth'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   if (ifilm.eq.1) then
      write(nplot,'('' 15. -15. 15. -2.5 6.5 2.5/'')')
   else
      write(nplot,'('' 12. -12. 12. -2. 5.25 2./'')')
   endif
   write(nplot,'('' 1/ 3d data'')')
   do ig1=1,ngn
      if (egn(ig1).ge.xmin.and.egn(ig1+1).le.xmax) then
         i=ngn-ig1+1
         write(nplot,'(1x,1p,e12.4,''/'')') egn(ig1)
         zlast=bot
         do ig2=1,ngn
            if (egn(ig2).ge.xmin.and.egn(ig2+1).le.xmax) then
               j=ngn-ig2+1
               k=j-i+ipingp-iptotl
               if (k.ge.1) then
                  ss=sig(k+ltabn*(j-1))
                  if (k.gt.ltabn) ss=bot
                  if (ss.lt.bot) ss=bot
                  write(nplot,'(1x,1p,2e12.4,''/'')') egn(ig2),zlast
                  write(nplot,'(1x,1p,2e12.4,''/'')') egn(ig2),ss
                  zlast=ss
                  ig2l=ig2
               endif
            endif
         enddo
         write(nplot,'(1x,1p,2e12.4,''/'')') egn(ig2l+1),zlast
         write(nplot,'(1x,1p,2e12.4,''/'')') egn(ig2l+1),bot
         write(nplot,'('' /'')')
      endif
   enddo
   write(nplot,'('' /'')')
   if (ifilm.eq.1) return
   ixo=ixo+1
   if (ixo.gt.1) ixo=0
   if (ixo.eq.0) iyo=iyo+1
   if (iyo.gt.1) iyo=0
   return
   end subroutine plotnn

   subroutine plotnp(sig,ip)
   !-------------------------------------------------------------------
   ! Generate an isometric plot of a photon table.
   ! This routine destroys the table.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::sig(*)
   integer::ip
   ! internals
   integer::ign,i,igp,j,igpl
   real(kr)::xll,yll,xur,yur,top,bot,ss,xmin,xmax,zlast
   character(26)::ititle
   character(1),parameter::qu=''''
   real(kr),parameter::emin=1.e3_kr
   real(kr),parameter::emax=1.e8_kr
   real(kr),parameter::ten=10
   real(kr),parameter::ww=5
   real(kr),parameter::hh=3.75e0_kr
   real(kr),parameter::zero=0

   write(ititle,'(a6,'' l='',i1,'' neut-phot table'')') hisnam,ip-1
   if (ifilm.eq.1) then
      write(nplot,'('' 1/ 3d data'')')
   else
      xll=ww*ixo
      yll=hh-hh*iyo
      xur=ww
      yur=hh
      if (ixo.eq.0.and.iyo.eq.0) then
         write(nplot,'('' 1 0 1. 1.'',5f6.2,''/ 3d data'')')&
           xll,yll,xur,yur,zero
      else
         write(nplot,'('' -1 0 1. 1.'',5f6.2,''/ 3d data'')')&
           xll,yll,xur,yur,zero
      endif
   endif
   top=0
   do ign=1,ngn
      i=ngn-ign+1
      do igp=1,ngp
         j=ngp-igp+1
         ss=sig(j+ngp*(i-1))/(egg(igp+1)-egg(igp))
         if (egn(ign).ge.emin.and.egn(ign+1).le.emax) then
            if (egg(igp).ge.emin.and.egg(igp+1).le.emax) then
               if (ss.gt.top) top=ss
            endif
         endif
      enddo
   enddo
   i=int(log10(top))
   if (i.ge.0) i=i+1
   bot=ten**(i-5)
   top=ten**i
   xmin=egn(1)
   if (xmin.lt.emin) xmin=emin
   i=int(log10(xmin))
   if (i.lt.0) i=i-1
   xmin=ten**i
   xmax=egn(ngn+1)
   if (xmax.gt.emax) xmax=emax
   i=int(log10(xmax))
   if (i.ge.0) i=i+1
   xmax=ten**i
   write(nplot,'(1x,a,''<'',a26,a,''/'')') qu,ititle,qu
   write(nplot,'('' /'')')
   write(nplot,'('' -4 2/'')')
   write(nplot,'(1p,2e12.4,'' 1./'')') xmin,xmax
   write(nplot,'(1x,a,''<g>amma <e>nergy'',a,''/'')') qu,qu
   write(nplot,'(1p,2e12.4,'' 1./'')') xmin,xmax
   write(nplot,'(1x,a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
   write(nplot,'(1p,2e12.4,'' 1./'')') bot,top
   write(nplot,'(1x,a,''<x>sec/e<v>'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   if (ifilm.eq.1) then
      write(nplot,'('' 15. -15. 15. -2.5 6.5 2.5/'')')
   else
      write(nplot,'('' 12. -12. 12. -2. 5.25 2./'')')
   endif
   write(nplot,'('' 1/ 3d data'')')
   do ign=1,ngn
      if (egn(ign).ge.xmin.and.egn(ign+1).le.xmax) then
         i=ngn-ign+1
         write(nplot,'(1x,1p,e12.4,''/'')') egn(ign)
         zlast=bot
         do igp=1,ngp
            j=ngp-igp+1
            ss=sig(j+ngp*(i-1))/(egg(igp+1)-egg(igp))
            if (ss.lt.bot) ss=bot
            write(nplot,'(1x,1p,2e12.4,''/'')') egg(igp),zlast
            write(nplot,'(1x,1p,2e12.4,''/'')') egg(igp),ss
            zlast=ss
            igpl=igp
         enddo
         write(nplot,'(1x,1p,2e12.4,''/'')') egg(igpl+1),zlast
         write(nplot,'(1x,1p,2e12.4,''/'')') egg(igpl+1),ss
         write(nplot,'('' /'')')
      endif
   enddo
   write(nplot,'('' /'')')
   if (ifilm.eq.1) return
   ixo=ixo+1
   if (ixo.gt.1) ixo=0
   if (ixo.eq.0) iyo=iyo+1
   if (iyo.gt.1) iyo=0
   return
   end subroutine plotnp

end module dtfm

module util
   ! Utility routines for NJOY2016.
   use locale
   implicit none
   private

   !--Public routines
   public error,mess
   public timer,dater,wclock
   public repoz,skiprz,openz,closz
   public loada,finda,scana
   public sigfig
   public a10

contains

   subroutine error(from,mess1,mess2)
   !--------------------------------------------------------------------
   ! Machine dependent error exit routine.
   ! Use system fatal error exit if available.
   !--------------------------------------------------------------------
   use mainio ! provides nsyso,nsyse
   ! externals
   character::from*(*),mess1*(*),mess2*(*)

   write(nsyso,'(/'' ***error in '',a,''***'',a)') from,trim(mess1)
   if (len_trim(mess2).gt.0) write(nsyso,'(22x,a)') trim(mess2)
   write(nsyso,'('' '')')
   if (nsyse.ne.nsyso) then
      write(nsyse,'(/'' ***error in '',a,''***'',a)') from,trim(mess1)
      if (len_trim(mess2).gt.0) write(nsyse,'(22x,a)') trim(mess2)
      write(nsyse,'('' '')')
   endif
   stop 77
   end subroutine error

   subroutine mess(from,mess1,mess2)
   !--------------------------------------------------------------------
   ! Message routine (not fatal).
   !--------------------------------------------------------------------
   use mainio ! provides nsyso,nsyse
   ! externals
   character::from*(*),mess1*(*),mess2*(*)

   write(nsyso,'(/'' ---message from '',a,''---'',a)') from,trim(mess1)
   if (len_trim(mess2).gt.0) write(nsyso,'(26x,a)') trim(mess2)
   if (nsyse.ne.nsyso) then
      write(nsyse,'(/'' ---message from '',a,''---'',a)') &
        from,trim(mess1)
      if (len_trim(mess2).gt.0) write(nsyse,'(26x,a)') trim(mess2)
   endif
   return
   end subroutine mess

   subroutine timer(time)
   !--------------------------------------------------------------------
   ! Get elapsed time in seconds from beginning of execution.
   ! Should be "charge time" (e.g., cp+pp+sys).
   !--------------------------------------------------------------------
   ! externals
   real(kr)::time
   ! internals
   real(k4),dimension(2)::tarray
   !real(k8),external::etime

   !time=etime(tarray)
   !time=tarray(1)+tarray(2)
   call cpu_time(time)
   return
   end subroutine timer

   subroutine dater(hdate)
   !--------------------------------------------------------------------
   ! Return the date as as 8 character string.
   ! Either mm/dd/yy or ddmmmyy (eg, 03jun83) are acceptable.
   !--------------------------------------------------------------------
   ! externals
   character(8)::hdate
   ! internals
   character(8)::date
   character(10)::time
   character(5)::zone
   integer,dimension(8)::values
   integer i
   intrinsic date_and_time

   call date_and_time(date,time,zone,values)
   write(hdate,'(i2,''/'',i2,''/'',i2)') &
      values(2),values(3),mod(values(1),100)
   do i=1,8
      if (hdate(i:i).eq.' ') hdate(i:i)='0'
   end do
   return
   end subroutine dater

   subroutine wclock(htime)
   !--------------------------------------------------------------------
   ! Return the wall clock time as an 8 character string.
   ! For example, 12:13:47.
   !--------------------------------------------------------------------
   ! externals
   character(8)::htime
   ! internals
   character(8)::date
   character(10)::time
   character(5)::zone
   integer,dimension(8)::values
   integer i
   intrinsic date_and_time

   call date_and_time(date,time,zone,values)
   write(htime,'(i2,'':'',i2,'':'',i2)') &
      values(5),values(6),values(7)
   do i=1,8
      if (htime(i:i).eq.' ') htime(i:i)='0'
   end do
   return
   end subroutine wclock

   subroutine repoz(ntape)
   !--------------------------------------------------------------------
   ! Rewind an ENDF/B coded or blocked binary tape.
   ! Positive units are coded, negative ones are blocked binary.
   !--------------------------------------------------------------------
   ! externals
   integer::ntape
   ! internals
   integer::i

   if (ntape.eq.0) return
   i=iabs(ntape)
   rewind i
   return
   end subroutine repoz

   subroutine skiprz(nunit,nrt)
   !--------------------------------------------------------------------
   ! Skip forward or backward on a coded or blocked binary tape.
   ! Positive units are coded, negative ones are blocked binary.
   ! No action for zero units.
   !--------------------------------------------------------------------
   ! externals
   integer::nunit,nrt
   ! internals
   integer::nun,nr,i
   character(1)::idum

   if (nunit.eq.0) return
   nun=iabs(nunit)
   if (nrt.eq.0) return
   nun=iabs(nunit)
   if (nrt.eq.0) return
   nr=iabs(nrt)
   if (nrt.gt.0) then
      do i=1,nr
         if (nunit.gt.0) read(nun,'(a1)') idum
         if (nunit.lt.0) read(nun) idum
      enddo
   else if (nrt.lt.0) then
      do i=1,nr
         backspace nun
      enddo
   endif
   return
   end subroutine skiprz

   subroutine openz(lun,new)
   !--------------------------------------------------------------------
   ! System-dependent routine to open files.
   ! No action if iabs(lun) ge 5 and le 7.
   ! Mode--coded (formatted) if lun gt 0
   !       binary (unformatted) if lun lt 0
   ! Destroy--on close or job termination if iabs(lun) ge 10 and
   !                                      iabs(lun) lt 20
   ! Status--if new=1, destroy lun if it already exists, then
   !         open a new version.
   !--------------------------------------------------------------------
   ! externals
   integer::lun,new
   ! internals
   integer::nun
   character::for*15,age*7,fn*7
   logical::there

   nun=iabs(lun)
   if ((nun.ge.5.and.nun.le.7).or.nun.eq.0) return
   if (nun.gt.999) call error('openz','illegal unit number.',' ')
   ! construct file name
   write(fn,'(''tape'',i0)') nun
   ! set format based on sign of unit number
   for='formatted'
   if (lun.lt.0) for='unformatted'
   if (nun.ge.10.and.nun.le.19) then
      ! scratch units
      age='scratch'
      open(nun,form=for,status=age)
   else
      ! regular units
      if (new.ne.1) then
         ! existing units
         age='old'
      else
         ! new units
         age='new'
         inquire(file=fn,exist=there)
         if (there) then
            open(nun,file=fn,status='old')
            close(nun,status='delete')
         endif
      endif
      ! open the connection
      open(nun,file=fn,form=for,status=age)
   endif
   return
   end subroutine openz

   subroutine closz(lun)
   !--------------------------------------------------------------------
   ! File closing routine.
   ! No action if iabs(lun) lt 10.
   ! Destroy flag set by openz.
   !--------------------------------------------------------------------
   ! externals
   integer::lun
   ! internals
   integer::nun

   nun=iabs(lun)
   if (nun.lt.10) return
   if (nun.gt.999) call error('closz','illegal unit number.',' ')
   close(nun)
   return
   end subroutine closz

   subroutine loada(i,a,na,ntape,buf,nbuf)
   !--------------------------------------------------------------------
   ! Buffered sequential i/o routine.
   ! Store na elements of array a into
   ! core buffer and associated binary tape.
   !--------------------------------------------------------------------
   !externals
   integer::i,na,ntape,nbuf
   real(kr)::a(na),buf(nbuf)
   !internals
   integer::nl,j,ix,inow,k
   real(kr)::x,xnow

   nl=nbuf/na
   j=iabs(i)
   x=j
   x=x/nl
   ix=j/nl
   xnow=(x-ix)*nl
   inow=nint(xnow)
   if (inow.eq.0) inow=nl
   k=na*(inow-1)
   do j=1,na
      k=k+1
      buf(k)=a(j)
   enddo
   if (i.eq.1) call repoz(-ntape)
   if (inow.eq.nl.or.i.lt.0) write(ntape) buf
   return
   end subroutine loada

   subroutine finda(i,a,na,ntape,buf,nbuf)
   !--------------------------------------------------------------------
   ! Buffered sequential i/o routine.
   ! Find na elements of array a from
   ! core buffer and associated binary tape.
   !--------------------------------------------------------------------
   ! externals
   integer::i,na,ntape,nbuf
   real(kr)::a(na),buf(nbuf)
   ! internals
   integer::nl,inow,k,j

   nl=nbuf/na
   inow=mod(i,nl)
   if (inow.eq.0) inow=nl
   if (i.eq.1) call repoz(-ntape)
   if (inow.eq.1) read(ntape) buf
   k=na*(inow-1)
   do j=1,na
      k=k+1
      a(j)=buf(k)
   enddo
   return
   end subroutine finda

   subroutine scana(e,ip,np,na,ntape,buf,nbuf)
   !--------------------------------------------------------------------
   ! Search the loada/finda buffer for e.  Read in new buffers as
   ! necessary.  Value of ip returned corresponds to the location
   ! of e in the buffer, or, if e does not appear, to the nearest
   ! lower energy.
   !--------------------------------------------------------------------
   ! externals
   integer::ip,np,na,ntape,nbuf
   real(kr)::e,buf(nbuf)
   ! internals
   integer::nl,j,last,ibufl,indx,jp,ipn
   real(kr)::ef,el,en
   character(36)::strng

   if (ip.ne.0) call error('scana','initial ip ne 0.',' ')
   nl=nbuf/na
   j=1
   last=0
   j=1
   last=0
   110 continue
   ef=buf(1)
   ibufl=na*(nl-1)+1
   if (np.lt.ip+nl) ibufl=(np-ip-1)*na+1
   el=buf(ibufl)
   if (e.lt.ef.and.j.eq.1) go to 130
   if (e.lt.ef.and.j.gt.1) go to 140
   if (e.ge.ef.and.e.lt.el) go to 120
   ! e gt highest energy in this buffer.  read in a new buffer
   if (last.gt.0) write(strng,&
     '(''did not find energy '',1p,e12.4)') e
   if (last.gt.0) call error('scana',strng,' ')
   read(ntape) buf
   j=j+1
   ip=ip+nl
   if (np.le.ip+nl) last=1
   go to 110
   ! e is in this buffer.  determine ip
   120 continue
   ip=ip+1
   jp=ip-nl*(j-1)
   indx=na*(jp-1)+1
   jp=ip-nl*(j-1)
   indx=na*(jp-1)+1
   en=buf(indx)
   if (en.eq.e) go to 145
   if (en.lt.e) go to 120
   ip=ip-1
   go to 145
   130 continue
   ip=1
   go to 150
   ! first e in this buffer is higher than e
   ! backspace and read next lower buffer again
   140 continue
   backspace ntape
   backspace ntape
   read(ntape) buf
   ip=ip-1
   go to 150
   145 continue
   ipn=mod(ip,nl)
   if (ipn.ne.1) go to 150
   backspace ntape
   if (ip.lt.1) ip=1
   150 continue
   return
   end subroutine scana

   real(kr) function sigfig(x,ndig,idig)
   !--------------------------------------------------------------------
   ! Adjust x to have ndig signficant figures.  If idig is not zero,
   ! shade x up or down by idig in the last significant figure.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x
   integer::ndig,idig
   ! internals
   real(kr)::xx,aa
   integer::ipwr,ii
   real(kr),parameter::bias=1.0000000000001e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::ten=10

   xx=0
   if (x.ne.zero) then
      aa=log10(abs(x))
      ipwr=int(aa)
      if (aa.lt.zero) ipwr=ipwr-1
      ipwr=ndig-1-ipwr
      ii=nint(x*ten**ipwr+ten**(ndig-11))
      if (ii.ge.10**ndig) then
         ii=ii/10
         ipwr=ipwr-1
      endif
      ii=ii+idig
      xx=ii*ten**(-ipwr)
   endif
   xx=xx*bias
   sigfig=xx
   return
   end function sigfig

   subroutine a10(x,hx)
   !-------------------------------------------------------------------
   ! convert x to a 10-column format as a string in hx to provide
   ! more digits in some njoy listings without taking too much space.
   ! this allows 4, 5, or 6 significant figures to be printed where we
   ! previously had four.  hx has the forms +1.23456+6, +1.2345-38,
   ! or -1.234+308.  based on subroutine a11 for endf formats.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::x
   character(10)::hx
   ! internals
   integer::n
   real(kr)::f,xx,ff
   character(1)::s
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::amil=.999999999e6_kr
   real(kr),parameter::up=.000000001e0_kr
   real(kr),parameter::top6=9.999995e0_kr
   real(kr),parameter::top5=9.99995e0_kr
   real(kr),parameter::top4=9.9995e0_kr

   !--check for zero as a special case
   if (x.ne.zero) go to 100
   f=0
   s='+'
   n=0
   go to 160

   !--construct six, five, and four sig-fig forms
  100 continue
   xx=x
   n=int(log10(abs(xx)))
   if (abs(xx).lt.one) go to 110
   ff=xx/ten**n
   s='+'
   if (iabs(n).lt.10.and.abs(ff).lt.top6) go to 120
   if (iabs(n).lt.100.and.iabs(n).ge.10.and.&
     abs(ff).lt.top5) go to 120
   if (iabs(n).ge.100.and.abs(ff).lt.top4) go to 120
   ff=ff/ten
   ff=ff+up
   n=n+1
   go to 120
  110 continue
   n=1-n
   ff=xx*ten**n
   s='-'
   if (iabs(n).lt.10.and.abs(ff).lt.top6) go to 120
   if (iabs(n).lt.100.and.iabs(n).ge.10.and.&
     abs(ff).lt.top5) go to 120
   if (iabs(n).ge.100.and.abs(ff).lt.top4) go to 120
   ff=ff/ten
   ff=ff+up
   n=n-1
   if (n.gt.0) go to 120
   s='+'
  120 continue
   f=ff
  160 continue
   if (iabs(n).lt.10) then
      write(hx,'(f8.5,a,i1)') f,s,n
   else if (iabs(n).lt.100) then
      write(hx,'(f7.4,a,i2)') f,s,n
   else
      write(hx,'(f6.3,a,i3)') f,s,n
   endif
   return
   end subroutine a10

end module util

module gaspm
   ! provides subroutine gaspr for NJOY2016
   use locale
   implicit none
   private
   public gaspr
contains

   subroutine gaspr
   !-------------------------------------------------------------------
   !
   ! Add gas production reactions (mt203-207) to the pendf tape.
   ! Any old gas sections on the input pendf tape are deleted.
   ! The directory is updated to show the new reactions.
   ! This module can be run anywhere in the pendf preparation
   ! sequence as long as it is somewhere after broadr.
   !
   ! If the input pendf tape omits mt103 to mt107, but it does
   ! have the corresponding charged-particle cross sections, they
   ! are processed and will appear in the appropriate mt20x section.
   !
   !---input specifications (free format)--------------------------
   !
   ! card 1
   !    nendf    unit for endf tape
   !    nin      unit for input pendf tape
   !    nout     unit for output pendf tape
   !
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use endf   ! provides endf routines and variables
   use util   ! provides timer,error,openz,sigfig
   ! internals
   integer::nscr1,iprint,nendf,npend,noutp,nb,nw
   integer::n6,nx,nsub,matd,mf6mt5,i,idone,mfi,mti,mfd,mtd
   integer::nk,lsix,l203,l204,l205,l206,l207
   integer::ik,izap,law,ll,ne,ie,nmu,imu,itemp,mfb
   integer::izg,izr,idis,lr,ngas,j,ip,ir,nsec
   integer::n203,n204,n205,n206,n207,jg,ii,k,nold
   integer::ni,nm,mtb,ifini,np,istart,iend,ib
   integer::mpmin,mpmax,mdmin,mdmax,mtmin,mtmax,m3min,m3max,m4min,m4max
   integer::maxg
   real(kr)::time,za,awr,zain,thrg,en,enext,y
   real(kr)::y203,y204,y205,y206,y207,yyy,xnext
   real(kr)::a(10000)
   real(kr)::b(6)
   real(kr),dimension(:),allocatable::egas
   real(kr),dimension(:,:),allocatable::sgas
   real(kr)::six(5000)
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::zero=0
   real(kr),parameter::hund=100

   nscr1=10
   ! set iprint nonzero for gas production printout on listing
   iprint=0

   !--read user input
   call timer(time)
   write(nsyso,'(/'' gaspr...'',&
     &''add gas production cross sections'',&
     &27x,f8.1,''s'')') time
   write(nsyse,'(/'' gaspr...'',60x,f8.1,''s'')') time
   read(nsysi,*) nendf,npend,noutp
   if (npend.lt.0) nscr1=-nscr1
   if (npend*noutp.lt.0) call error('gaspr',&
     'npend and noutp must both be binary',&
     'or both be coded')
   write(nsyso,'(/'' units:'',3i6)') nendf,npend,noutp
   call openz(nendf,0)
   call openz(npend,0)
   call openz(noutp,1)
   call openz(nscr1,1)

   !--check endf tape for mf6,mt5.
   !--also set flags for the absence or presence of charged-particle
   !--reactions and the endf version dependent partial cross section
   !--mt ranges.
   call repoz(nendf)
   call tpidio(nendf,0,0,a(1),nb,nw)
   call contio(nendf,0,0,a(1),nb,nw)
   za=c1h
   awr=c2h
   n6=n2h
   call contio(nendf,0,0,a(1),nb,nw)
   if (n1h.ne.0) then
      iverf=4
      nx=n6
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   call skiprz(nendf,-1)
   if (iverf.ge.5) call contio(nendf,0,0,a(1),nb,nw)
   nsub=10
   zain=1
   if (iverf.ge.6) then
      call contio(nendf,0,0,a(1),nb,nw)
      nsub=n1h
      zain=int(nsub/10)
   endif
   call hdatio(nendf,0,0,a(1),nb,nw)
   matd=math
   do while (nb.ne.0)
      call moreio(nendf,0,0,a(1),nb,nw)
   enddo
   if (iverf.ne.4) nx=n2h
   nw=nx
   call dictio(nendf,0,0,a(1),nb,nw)
   mf6mt5=0
   i=1
   idone=0
   if (iverf .ge. 6) then
       mpmin=600
       mpmax=649
       mdmin=650
       mdmax=699
       mtmin=700
       mtmax=749
       m3min=750
       m3max=799
       m4min=800
       m4max=849
   else
       mpmin=700
       mpmax=718
       mdmin=720
       mdmax=738
       mtmin=740
       mtmax=758
       m3min=760
       m3max=768
       m4min=780
       m4max=798
   endif
   do while (i.le.nw.and.idone.eq.0)
      mfi=nint(a(1+i+1))
      mti=nint(a(1+i+2))
      if (mfi.gt.6) then
         idone=1
      else
         if (mfi.eq.6.and.mti.eq.5) mf6mt5=1
         i=i+6
      endif
   enddo
   call repoz(nendf)
   if (mf6mt5.ne.0) then
      write(nsyso,'(/'' mf6,mt5 found'')')
      mfd=6
      mtd=5
      call findf(matd,mfd,mtd,nendf)
      call contio(nendf,0,0,a(1),nb,nw)
      nk=n1h
      lsix=1
      l203=0
      l204=0
      l205=0
      l206=0
      l207=0
      do ik=1,nk
         call tab1io(nendf,0,0,a(1),nb,nw)
         izap=nint(c1h)
         law=l2h
         ll=1+nw
         do while (nb.ne.0)
            call moreio(nendf,0,0,a(ll),nb,nw)
            ll=ll+nw
         enddo
         if (izap.eq.1001) then
            l203=lsix
            do i=1,nw
               six(lsix+i-1)=a(i)
            enddo
            lsix=lsix+nw
         else if (izap.eq.1002) then
            l204=lsix
            do i=1,nw
               six(lsix+i-1)=a(i)
            enddo
            lsix=lsix+nw
         else if (izap.eq.1003) then
            l205=lsix
            do i=1,nw
               six(lsix+i-1)=a(i)
            enddo
            lsix=lsix+nw
         else if (izap.eq.2003) then
            l206=lsix
            do i=1,nw
               six(lsix+i-1)=a(i)
            enddo
            lsix=lsix+nw
         else if (izap.eq.2004) then
            l207=lsix
            do i=1,nw
               six(lsix+i-1)=a(i)
            enddo
            lsix=lsix+nw
         endif
         if (law.eq.6) then
            call contio(nendf,0,0,a,nb,nw)
         else if (law.eq.1.or.law.eq.2.or.law.eq.5) then
            call tab2io(nendf,0,0,a,nb,nw)
            ne=n2h
            do ie=1,ne
               call listio(nendf,0,0,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nendf,0,0,a,nb,nw)
               enddo
            enddo
         else if (law.eq.7) then
            call tab2io(nendf,0,0,a,nb,nw)
            ne=n2h
            do ie=1,ne
               call tab2io(nendf,0,0,a,nb,nw)
               nmu=n2h
               do imu=1,nmu
                  call tab1io(nendf,0,0,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nendf,0,0,a,nb,nw)
                  enddo
               enddo
            enddo
         endif
      enddo
   endif

   !--loop over all temperatures on the pendf tape
   call repoz(npend)
   call repoz(noutp)
   call tpidio(npend,noutp,0,a(1),nb,nw)
   itemp=0
  225 continue
   itemp=itemp+1
   call contio(npend,0,0,b(1),nb,nw)
   if (mfh.eq.0) go to 550

   !--copy data through file3, include any partial
   !-charged-particle cross sections.
   call repoz(nscr1)
   call contio(0,nscr1,0,b(1),nb,nw)
   call tofend(npend,nscr1,0,a(1))
   call tofend(npend,nscr1,0,a(1))
   idone=0
   do while (idone.eq.0)
      call contio(npend,0,0,b(1),nb,nw)
      mfb=mfh
      mtb=mth
      if (mth.gt.m4max.or.mth.eq.0) then
         idone=1
      else
         call contio(0,nscr1,0,b(1),nb,nw)
         call tosend(npend,nscr1,0,a(1))
      endif
   enddo
   call contio(0,nscr1,0,b(1),nb,nw)

   !--reposition npend to the location where gas production
   !--cross sections would go.
   call repoz(npend)
   call tpidio(npend,0,0,a(1),nb,nw)
   if (itemp.gt.1) then
      do i=2,itemp
         call tomend(npend,0,0,a(1))
      enddo
   endif
   call tofend(npend,0,0,a(1))
   call tofend(npend,0,0,a(1))
   idone=0
   do while (idone.eq.0)
      call contio(npend,0,0,b(1),nb,nw)
      if (mth.gt.200.or.mth.eq.0) then
         idone=1
      else
         call tosend(npend,0,0,a(1))
      endif
   enddo

   !--check the reactions in file 3 for gas threshold
   call repoz(nscr1)
   call tofend(nscr1,0,0,a(1))
   call tofend(nscr1,0,0,a(1))
   thrg=emax
  240 continue
   call contio(nscr1,0,0,a(1),nb,nw)
   if (mth.gt.200.and.mth.lt.mpmin) go to 245
   if (mth.gt.m4max.or.mth.eq.0) go to 250
   izg=0
   izr=nint(za+zain)
   en=0
   call gety1(en,enext,idis,y,nscr1,a(1))
   lr=l2h
   if (mth.ge.1.and.mth.le.4) go to 245
   if (mth.eq.5.and.mf6mt5.eq.1) izg=1
   if (mth.ge.6.and.mth.le.10) go to 245
   if (mth.eq.11) izg=1
   if (mth.eq.11) izr=izr-1004
   if (mth.ge.12.and.mth.le.15) go to 245
   if (mth.eq.16) izr=izr-2
   if (mth.eq.17) izr=izr-3
   if (mth.ge.18.and.mth.le.21) go to 245
   if (mth.ge.22.and.mth.le.25) izg=1
   if (mth.eq.22) izr=izr-2005
   if (mth.eq.23) izr=izr-6013
   if (mth.eq.24) izr=izr-2006
   if (mth.eq.25) izr=izr-2007
   if (mth.ge.26.and.mth.le.27) go to 245
   if (mth.ge.28.and.mth.le.32) izg=1
   if (mth.eq.28) izr=izr-1002
   if (mth.eq.29) izr=izr-4009
   if (mth.eq.30) izr=izr-4010
   if (mth.eq.31) go to 245
   if (mth.ge.32.and.mth.le.36) izg=1
   if (mth.eq.32) izr=izr-1003
   if (mth.eq.33) izr=izr-1004
   if (mth.eq.34) izr=izr-2004
   if (mth.eq.35) izr=izr-5011
   if (mth.eq.36) izr=izr-5012
   if (mth.eq.37) izr=izr-4
   if (mth.ge.38.and.mth.le.40) go to 245
   if (mth.ge.41.and.mth.le.42) izg=1
   if (mth.eq.41) izr=izr-1003
   if (mth.eq.42) izr=izr-1004
   if (mth.eq.43) go to 245
   if (mth.ge.44.and.mth.le.45) izg=1
   if (mth.eq.44) izr=izr-2003
   if (mth.eq.45) izr=izr-3006
   if (mth.ge.46.and.mth.le.50) go to 245
   if (mth.ge.51.and.mth.le.91) then
      izr=izr-1
      if (lr.ge.22.and.lr.le.25) izg=1
      if (lr.eq.22) izr=izr-2004
      if (lr.eq.23) izr=izr-6012
      if (lr.eq.24) izr=izr-2005
      if (lr.eq.25) izr=izr-2006
      if (lr.ge.28.and.lr.le.30) izg=1
      if (lr.eq.28) izr=izr-1001
      if (lr.eq.29) izr=izr-4008
      if (lr.eq.30) izr=izr-4009
      if (lr.ge.32.and.lr.le.36) izg=1
      if (lr.eq.32) izr=izr-1002
      if (lr.eq.33) izr=izr-1003
      if (lr.eq.34) izr=izr-2003
      if (lr.eq.35) izr=izr-5010
      if (lr.eq.36) izr=izr-5011
   endif
   if (mth.ge.92.and.mth.le.101) go to 245
   if (mth.ge.103.and.mth.le.117) izg=1
   if (mth.eq.103) izr=izr-1001
   if (mth.eq.104) izr=izr-1002
   if (mth.eq.105) izr=izr-1003
   if (mth.eq.106) izr=izr-2003
   if (mth.eq.107) izr=izr-2004
   !--always skip levels for mt103-107
   if (mth.ge.mpmin.and.mth.le.mpmax) go to 245
   if (mth.ge.mdmin.and.mth.le.mdmax) go to 245
   if (mth.ge.mtmin.and.mth.le.mtmax) go to 245
   if (mth.ge.m3min.and.mth.le.m3max) go to 245
   if (mth.ge.m4min.and.mth.le.m4max) go to 245
   if (mth.eq.108) izr=izr-4008
   if (mth.eq.109) izr=izr-6012
   if (mth.eq.111) izr=izr-2002
   if (mth.eq.112) izr=izr-3005
   if (mth.eq.113) izr=izr-5011
   if (mth.eq.114) izr=izr-5010
   if (mth.eq.115) izr=izr-2003
   if (mth.eq.116) izr=izr-2004
   if (mth.eq.117) izr=izr-3006
   if (mth.ge.154.and.mth.le.159) izg=1
   if (mth.ge.162.and.mth.le.200) izg=1
   if (mth.eq.152) izr=izr-5
   if (mth.eq.153) izr=izr-6
   if (mth.eq.154) izr=izr-1005
   if (mth.eq.155) izr=izr-3007
   if (mth.eq.156) izr=izr-1005
   if (mth.eq.157) izr=izr-1005
   if (mth.eq.158) izr=izr-3007
   if (mth.eq.159) izr=izr-3007
   if (mth.eq.160) izr=izr-7
   if (mth.eq.161) izr=izr-8
   if (mth.eq.162) izr=izr-1006
   if (mth.eq.163) izr=izr-1007
   if (mth.eq.164) izr=izr-1008
   if (mth.eq.165) izr=izr-2008
   if (mth.eq.166) izr=izr-2009
   if (mth.eq.167) izr=izr-2010
   if (mth.eq.168) izr=izr-2011
   if (mth.eq.169) izr=izr-1006
   if (mth.eq.170) izr=izr-1007
   if (mth.eq.171) izr=izr-1008
   if (mth.eq.172) izr=izr-1006
   if (mth.eq.173) izr=izr-1007
   if (mth.eq.174) izr=izr-1008
   if (mth.eq.175) izr=izr-1009
   if (mth.eq.176) izr=izr-2005
   if (mth.eq.177) izr=izr-2006
   if (mth.eq.178) izr=izr-2007
   if (mth.eq.179) izr=izr-2005
   if (mth.eq.180) izr=izr-4011
   if (mth.eq.181) izr=izr-3008
   if (mth.eq.182) izr=izr-2005
   if (mth.eq.183) izr=izr-2004
   if (mth.eq.184) izr=izr-2005
   if (mth.eq.185) izr=izr-2006
   if (mth.eq.186) izr=izr-3005
   if (mth.eq.187) izr=izr-3006
   if (mth.eq.188) izr=izr-3007
   if (mth.eq.189) izr=izr-3008
   if (mth.eq.190) izr=izr-2004
   if (mth.eq.191) izr=izr-3004
   if (mth.eq.192) izr=izr-3005
   if (mth.eq.193) izr=izr-4007
   if (mth.eq.194) izr=izr-2006
   if (mth.eq.195) izr=izr-4012
   if (mth.eq.196) izr=izr-3009
   if (mth.eq.197) izr=izr-3003
   if (mth.eq.198) izr=izr-3004
   if (mth.eq.199) izr=izr-4009
   if (mth.eq.200) izr=izr-2007
   if (izr.eq.4008) izg=1
   if (izg.eq.0.and.&
     (izr.gt.2004.or.izr.le.0)) go to 245
   if (enext.lt.thrg) thrg=enext
  245 continue
   call tosend(nscr1,0,0,a(1))
   go to 240
  250 continue
   if (itemp.eq.1)&
      write(nsyso,'(/'' the gas production threshold is'',&
      &1pe12.4,'' ev'')') thrg

   !--read through the scratch tape
   !--collecting gas production in the process
   !--use the energy grid of mt1 starting at thrg
   call repoz(nscr1)
   call tofend(nscr1,0,0,a(1))
   call tofend(nscr1,0,0,a(1))
   call contio(nscr1,0,0,a(1),nb,nw)
   en=0
   call gety1(en,enext,idis,y,nscr1,a(1))
   maxg=nint(a(6))
    if (allocated(egas)) then
       deallocate(egas)
       deallocate(sgas)
    endif
   allocate (egas(maxg))
   allocate (sgas(5,maxg))
   enext=thrg
   i=0
   do while (enext.lt.emax)
      i=i+1
      if (i.gt.maxg) call error('gaspr',&
        'too many gas production energy points',' ')
      en=enext
      call gety1(en,enext,idis,y,nscr1,a(1))
      egas(i)=en
   enddo
   ngas=i
   if (itemp.eq.1) write(nsyso,'(/'' found'',i6,'' points'')') ngas
   call tosend(nscr1,0,0,a(1))
   if (itemp.eq.1) write(nsyso,&
     '(/'' pendf mt  mt203  mt204  mt205  mt206  mt207''/&
     &'' ________  _____  _____  _____  _____  _____'')')
   do i=1,ngas
      do j=1,5
         sgas(j,i)=0
      enddo
   enddo

   !--loop over other reactions and
   !--sum up gas production values
  270 continue
   call contio(nscr1,0,0,a(1),nb,nw)
   if (mth.gt.200.and.mth.lt.mpmin) go to 310
   if (mth.gt.m4max.or.mth.eq.0) go to 330
   if (mth.le.4) go to 310
   if (mth.ge.6.and.mth.le.10) go to 310
   if (mth.ge.12.and.mth.le.15) go to 310
   if (mth.ge.18.and.mth.le.21) go to 310
   if (mth.ge.38.and.mth.le.40) go to 310
   if (mth.eq.43) go to 310
   if (mth.ge.46.and.mth.le.50) go to 310
   if (mth.ge.92.and.mth.le.101) go to 310
   !--always skip levels for mt103-107
   if (mth.ge.mpmin.and.mth.le.mpmax) go to 310
   if (mth.ge.mdmin.and.mth.le.mdmax) go to 310
   if (mth.ge.mtmin.and.mth.le.mtmax) go to 310
   if (mth.ge.m3min.and.mth.le.m3max) go to 310
   if (mth.ge.m4min.and.mth.le.m4max) go to 310
   if (mth.eq.152.or.mth.eq.153.or.mth.eq.160.or.mth.eq.161)go to 310
   en=0
   call gety1(en,enext,idis,y,nscr1,a(1))
   lr=l2h
   izr=nint(za+zain)
   y203=0
   y204=0
   y205=0
   y206=0
   y207=0
   if (mth.eq.5.and.mf6mt5.eq.1) then
      if (l203.gt.0) y203=111
      if (l204.gt.0) y204=111
      if (l205.gt.0) y205=111
      if (l206.gt.0) y206=111
      if (l207.gt.0) y207=111
   else if (mth.eq.11) then
      izr=izr-1004
      y204=1
   else if (mth.eq.16) then
      izr=izr-2
   else if (mth.eq.17) then
      izr=izr-3
   else if (mth.eq.22) then
      izr=izr-2005
      y207=1
   else if (mth.eq.23) then
      izr=izr-6013
      y207=3
   else if (mth.eq.24) then
      izr=izr-2006
      y207=1
   else if (mth.eq.25) then
      izr=izr-2007
      y207=1
   else if (mth.eq.28) then
      izr=izr-1002
      y203=1
   else if (mth.eq.29) then
      izr=izr-4009
      y207=2
   else if (mth.eq.30) then
      izr=izr-4010
      y207=2
   else if (mth.eq.32) then
      izr=izr-1003
      y204=1
   else if (mth.eq.33) then
      izr=izr-1004
      y205=1
   else if (mth.eq.34) then
      izr=izr-2004
      y206=1
   else if (mth.eq.35) then
      izr=izr-5011
      y204=1
      y207=2
   else if (mth.eq.36) then
      izr=izr-5012
      y205=1
      y207=2
   else if (mth.eq.37) then
      izr=izr-4
   else if (mth.eq.41) then
      izr=izr-1003
      y203=1
   else if (mth.eq.42) then
      izr=izr-1004
      y203=1
   else if (mth.eq.44) then
      izr=izr-2003
      y203=2
   else if (mth.eq.45) then
      izr=izr-3006
      y203=1
      y207=1
   else if (mth.ge.51.and.mth.le.91) then
      izr=izr-1
      if (lr.eq.22) then
         izr=izr-2004
         y207=1
      else if (lr.eq.23) then
         izr=izr-6012
         y207=3
      else if (lr.eq.24) then
         izr=izr-2005
         y207=1
      else if (lr.eq.25) then
         izr=izr-2006
         y207=1
      else if (lr.eq.28) then
         izr=izr-1001
         y203=1
      else if (lr.eq.29) then
         izr=izr-4008
         y207=2
      else if (lr.eq.30) then
         izr=izr-4009
         y207=2
      else if (lr.eq.32) then
         izr=izr-1002
         y204=1
      else if (lr.eq.33) then
         izr=izr-1003
         y205=1
      else if (lr.eq.34) then
         izr=izr-2003
         y206=1
      else if (lr.eq.35) then
         izr=izr-5010
         y204=1
         y207=2
      else if (lr.eq.36) then
         izr=izr-5011
         y205=1
         y207=2
      else if (lr.eq.39) then
         izr=izr
      else if (lr.eq.40) then
         izr=izr
      endif
   else if (mth.eq.103) then
      izr=izr-1001
      y203=1
   else if (mth.eq.104) then
      izr=izr-1002
      y204=1
   else if (mth.eq.105) then
      izr=izr-1003
      y205=1
   else if (mth.eq.106) then
      izr=izr-2003
      y206=1
   else if (mth.eq.107) then
      izr=izr-2004
      y207=1
   else if (mth.eq.108) then
      izr=izr-4008
      y207=2
   else if (mth.eq.109) then
      izr=izr-6012
      y207=3
   else if (mth.eq.111) then
      izr=izr-2002
      y203=2
   else if (mth.eq.112) then
      izr=izr-3005
      y203=1
      y207=1
   else if (mth.eq.113) then
      izr=izr-5011
      y205=1
      y207=2
   else if (mth.eq.114) then
      izr=izr-5010
      y204=1
      y207=2
   else if (mth.eq.115) then
      izr=izr-2003
      y203=1
      y204=1
   else if (mth.eq.116) then
      izr=izr-2004
      y203=1
      y205=1
   else if (mth.eq.117) then
      izr=izr-3006
      y204=1
      y207=1
   else if (mth.eq.152) then
      izr=izr-5
   else if (mth.eq.153) then
      izr=izr-6
   else if (mth.eq.154) then
      izr=izr-1005
      y205=1
   else if (mth.eq.155) then
      izr=izr-3007
      y205=1
      y207=1
   else if (mth.eq.156) then
      izr=izr-1005
      y203=1
   else if (mth.eq.157) then
      izr=izr-1005
      y204=1
   else if (mth.eq.158) then
      izr=izr-3007
      y204=1
      y207=1
   else if (mth.eq.159) then
      izr=izr-3007
      y203=1
      y207=1
   else if (mth.eq.160) then
      izr=izr-7
   else if (mth.eq.161) then
      izr=izr-8
   else if (mth.eq.162) then
      izr=izr-1006
      y203=1
   else if (mth.eq.163) then
      izr=izr-1007
      y203=1
   else if (mth.eq.164) then
      izr=izr-1008
      y203=1
   else if (mth.eq.165) then
      izr=izr-2008
      y207=1
   else if (mth.eq.166) then
      izr=izr-2009
      y207=1
   else if (mth.eq.167) then
      izr=izr-2010
      y207=1
   else if (mth.eq.168) then
      izr=izr-2011
      y207=1
   else if (mth.eq.169) then
      izr=izr-1006
      y204=1
   else if (mth.eq.170) then
      izr=izr-1007
      y204=1
   else if (mth.eq.171) then
      izr=izr-1008
      y204=1
   else if (mth.eq.172) then
      izr=izr-1006
      y205=1
   else if (mth.eq.173) then
      izr=izr-1007
      y205=1
   else if (mth.eq.174) then
      izr=izr-1008
      y205=1
   else if (mth.eq.175) then
      izr=izr-1009
      y205=1
   else if (mth.eq.176) then
      izr=izr-2005
      y206=1
   else if (mth.eq.177) then
      izr=izr-2006
      y206=1
   else if (mth.eq.178) then
      izr=izr-2007
      y206=1
   else if (mth.eq.179) then
      izr=izr-2005
      y203=2
   else if (mth.eq.180) then
      izr=izr-4011
      y207=2
   else if (mth.eq.181) then
      izr=izr-3008
      y203=1
      y207=1
   else if (mth.eq.182) then
      izr=izr-2005
      y204=1
      y205=1
   else if (mth.eq.183) then
      izr=izr-2004
      y203=1
      y204=1
   else if (mth.eq.184) then
      izr=izr-2005
      y203=1
      y205=1
   else if (mth.eq.185) then
      izr=izr-2006
      y204=1
      y205=1
   else if (mth.eq.186) then
      izr=izr-3005
      y203=1
      y206=1
   else if (mth.eq.187) then
      izr=izr-3006
      y204=1
      y206=1
   else if (mth.eq.188) then
      izr=izr-3007
      y205=1
      y206=1
   else if (mth.eq.189) then
      izr=izr-3008
      y205=1
      y207=1
   else if (mth.eq.190) then
      izr=izr-2004
      y203=2
   else if (mth.eq.191) then
      izr=izr-3004
      y203=1
      y206=1
   else if (mth.eq.192) then
      izr=izr-3005
      y204=1
      y206=1
   else if (mth.eq.193) then
      izr=izr-4007
      y206=1
      y207=1
   else if (mth.eq.194) then
      izr=izr-2006
      y203=2
   else if (mth.eq.195) then
      izr=izr-4012
      y207=2
   else if (mth.eq.196) then
      izr=izr-3009
      y203=1
      y207=1
   else if (mth.eq.197) then
      izr=izr-3003
      y203=3
   else if (mth.eq.198) then
      izr=izr-3004
      y203=3
   else if (mth.eq.199) then
      izr=izr-4009
      y203=2
      y207=1
   else if (mth.eq.200) then
      izr=izr-2007
      y203=2
   endif
   if (izr.eq.1001) y203=y203+1
   if (izr.eq.1002) y204=y204+1
   if (izr.eq.1003) y205=y205+1
   if (izr.eq.2003) y206=y206+1
   if (izr.eq.2004) y207=y207+1
   if (izr.eq.4008) y207=y207+2
   if (y203.eq.zero.and.y204.eq.zero.and.y205.eq.zero&
     .and.y206.eq.zero.and.y207.eq.zero) go to 310
   enext=thrg
   if (itemp.eq.1)&
     write(nsyso,'(i8,5(4x,f3.1))') mth,y203,y204,y205,y206,y207
   i=0
   do while (i.lt.ngas)
      i=i+1
      en=egas(i)
      call gety1(en,enext,idis,y,nscr1,a(1))
      ip=2
      ir=1
      if (y203.gt.hund) then
         call terpa(yyy,egas(i),xnext,idis,six(l203),ip,ir)
         sgas(1,i)=sgas(1,i)+yyy*y
      else
         sgas(1,i)=sgas(1,i)+y203*y
      endif
      if (y204.gt.hund) then
         call terpa(yyy,egas(i),xnext,idis,six(l204),ip,ir)
         sgas(2,i)=sgas(2,i)+yyy*y
      else
         sgas(2,i)=sgas(2,i)+y204*y
      endif
      if (y205.gt.hund) then
         call terpa(yyy,egas(i),xnext,idis,six(l205),ip,ir)
         sgas(3,i)=sgas(3,i)+yyy*y
      else
         sgas(3,i)=sgas(3,i)+y205*y
      endif
      if (y206.gt.hund) then
         call terpa(yyy,egas(i),xnext,idis,six(l206),ip,ir)
         sgas(4,i)=sgas(4,i)+yyy*y
      else
         sgas(4,i)=sgas(4,i)+y206*y
      endif
      if (y207.gt.hund) then
         call terpa(yyy,egas(i),xnext,idis,six(l207),ip,ir)
         sgas(5,i)=sgas(5,i)+yyy*y
      else
         sgas(5,i)=sgas(5,i)+y207*y
      endif
   enddo
  310 continue
   call tosend(nscr1,0,0,a(1))
   go to 270
  330 continue
   if (itemp.eq.1)&
     write(nsyso,'(/'' *** means that the yield is '',&
     &''energy dependent'')')

   !--print out the gas-production results
   if (iprint.ne.0) then
      if (itemp.eq.1) then
         write(nsyso,'(/'' gas production versus energy'')')
         do i=1,ngas
           write(nsyso,'(1p,6e12.4)') egas(i),sgas(1,i),sgas(2,i),&
             sgas(3,i),sgas(4,i),sgas(5,i)
         enddo
      endif
   endif

   !--update the directory in file 1
   call repoz(nscr1)
   nsec=0
   n203=0
   n204=0
   n205=0
   n206=0
   n207=0
   do jg=1,5
      idone=0
      i=0
      do while (i.lt.ngas.and.idone.eq.0)
         i=i+1
         ii=i
         if (sgas(jg,i).ne.zero) idone=1
      enddo
      if (idone.eq.1) then
         ii=ii-1
         nsec=nsec+1
         if (jg.eq.1) n203=ngas-ii+1
         if (jg.eq.2) n204=ngas-ii+1
         if (jg.eq.3) n205=ngas-ii+1
         if (jg.eq.4) n206=ngas-ii+1
         if (jg.eq.5) n207=ngas-ii+1
      endif
   enddo
   call contio(nscr1,0,0,a(1),nb,nw)
   k=1+nw
   if (iverf.eq.4) nx=n2h
   if (iverf.ge.5) then
      call contio(nscr1,0,0,a(k),nb,nw)
      k=k+nw
   endif
   if (iverf.ge.6) then
      call contio(nscr1,0,0,a(k),nb,nw)
      k=k+nw
   endif
   call hdatio(nscr1,0,0,a(k),nb,nw)
   k=k+nw
   if (iverf.ne.4) nx=n2h
   do while (nb.ne.0)
      call moreio(nscr1,0,0,a(k),nb,nw)
      k=k+nw
   enddo
   nw=nx
   call dictio(nscr1,0,0,a(k),nb,nw)
   nold=0
   do i=1,nx
      j=k-1+6*(i-1)
      mfi=nint(a(j+3))
      mti=nint(a(j+4))
      if (mfi.eq.3.and.mti.ge.203.and.mti.le.207) nold=nold+1
   enddo
   if (nold.gt.0)&
     write(nsyso,'(/'' gas data on input pendf tape deleted'')')
   i=0
   idone=0
   do while (i.lt.nx.and.idone.eq.0)
      i=i+1
      j=k-1+6*(i-1)
      if (nint(a(j+3)).gt.3) idone=1
      if (nint(a(j+3)).eq.3.and.nint(a(j+4)).gt.200) idone=1
   enddo
   if (idone.eq.0) then
      j=k-1+6*nx
   else
      ni=6*(nsec-nold)
      nm=6*nx-j+k+5
      do i=1,nm
         a(6*nx+ni+k-i)=a(6*nx+k-i)
      enddo
   endif
   if (n203.ne.0) then
      a(j+1)=0
      a(j+2)=0
      a(j+3)=3
      a(j+4)=203
      a(j+5)=int((n203+2)/3)
      a(j+6)=1
      j=j+6
   endif
   if (n204.ne.0) then
      a(j+1)=0
      a(j+2)=0
      a(j+3)=3
      a(j+4)=204
      a(j+5)=int((n204+2)/3)
      a(j+6)=1
      j=j+6
   endif
   if (n205.ne.0) then
      a(j+1)=0
      a(j+2)=0
      a(j+3)=3
      a(j+4)=205
      a(j+5)=int((n205+2)/3)
      a(j+6)=1
      j=j+6
   endif
   if (n206.ne.0) then
      a(j+1)=0
      a(j+2)=0
      a(j+3)=3
      a(j+4)=206
      a(j+5)=int((n206+2)/3)
      a(j+6)=1
      j=j+6
   endif
   if (n207.ne.0) then
      a(j+1)=0
      a(j+2)=0
      a(j+3)=3
      a(j+4)=207
      a(j+5)=int((n207+2)/3)
      a(j+6)=1
      j=j+6
   endif
   nw=6
   k=1
   if (iverf.eq.4) a(6)=nx+nsec-nold
   call contio(0,noutp,0,a(k),nb,nw)
   k=k+nw
   if (iverf.ge.5) then
      call contio(0,noutp,0,a(k),nb,nw)
      k=k+nw
   endif
   if (iverf.ge.6) then
      call contio(0,noutp,0,a(k),nb,nw)
      k=k+nw
   endif
   if (iverf.ne.4) a(k+5)=nx+nsec-nold
   call hdatio(0,noutp,0,a(k),nb,nw)
   k=k+nw
   do while (nb.ne.0)
      call moreio(0,noutp,0,a(k),nb,nw)
      k=k+nw
   enddo
   nw=nx+nsec-nold
   nw=nx+nsec-nold
   call dictio(0,noutp,0,a(k),nb,nw)
   call tofend(nscr1,noutp,0,a(1))
   call tofend(nscr1,noutp,0,a(1))

   !--copy file 3 down to the gas production area
   idone=0
   do while (idone.eq.0)
      call contio(nscr1,0,0,b(1),nb,nw)
      mfb=mfh
      mtb=mth
      if (mth.gt.200.or.mth.eq.0) then
         idone=1
      else
         call contio(0,noutp,0,b(1),nb,nw)
         call tosend(nscr1,noutp,0,a(1))
      endif
   enddo

   !--write the gas production sections in file 3
   do jg=1,5
      i=0
      ifini=0
      do while (i.lt.ngas.and.ifini.eq.0)
         i=i+1
         ii=i
         if (sgas(jg,i).ne.zero) ifini=1
      enddo
      if (ifini.eq.1) then
         i=ii-1
         if (i.eq.0) i=1
         if (jg.eq.1) mth=203
         if (jg.eq.2) mth=204
         if (jg.eq.3) mth=205
         if (jg.eq.4) mth=206
         if (jg.eq.5) mth=207
         math=matd
         mfh=3
         a(1)=za
         a(2)=awr
         a(3)=0
         a(4)=0
         a(5)=0
         a(6)=0
         nw=6
         call contio(0,noutp,0,a(1),nb,nw)
         np=ngas-i+1
         a(1)=0
         a(2)=0
         a(3)=0
         a(4)=0
         a(5)=1
         a(6)=np
         a(7)=np
         a(8)=2
         k=8
         istart=i
         idone=0
         do while (idone.eq.0)
            iend=ngas
            if ((iend-istart).ge.npage/2) iend=istart+npage/2-1
            j=k-1
            ib=istart-1
            do while (ib.lt.iend)
               j=j+2
               ib=ib+1
               a(j)=egas(ib)
               a(j+1)=sigfig(sgas(jg,ib),7,0)
            enddo
            nw=j+1
            if (k.ne.0) then
               k=0
               call tab1io(0,noutp,0,a(1),nb,nw)
            else
               call moreio(0,noutp,0,a(1),nb,nw)
            endif
            if (nb.eq.0) then
               idone=1
            else
               istart=iend+1
            endif
         enddo
         call asend(noutp,0)
      endif
   enddo

   !--copy rest of this temperature to output file
   !--delete any gas sections on the input pend file
   mfh=mfb
   mth=mtb
   nw=6
  520 continue
   if (mfh.eq.0) go to 530
   if (mth.ge.203.and.mth.le.207) go to 525
   call contio(0,noutp,0,b(1),nb,nw)
   call tosend(npend,noutp,0,a(1))
   call contio(npend,0,0,b(1),nb,nw)
   go to 520
  525 continue
   call tosend(npend,0,0,a(1))
   call contio(npend,0,0,b(1),nb,nw)
   go to 520
  530 continue
   call contio(0,noutp,0,b(1),nb,nw)
   call tomend(npend,noutp,0,a(1))
   go to 225
  550 continue
   call contio(0,noutp,0,b(1),nb,nw)

   !--finished
   call closz(nendf)
   call closz(npend)
   call closz(noutp)
   call closz(nscr1)
   write(nsyso,'(/'' found'',i2,'' temperatures'')') itemp-1
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/1x,7(''**********''),&
     &''*******'')') time

   deallocate(egas)
   deallocate(sgas)

   return
   end subroutine gaspr

end module gaspm

module mixm
   ! provides subroutine mixr for NJOY2016
   use locale
   implicit none
   private
   public mixr

   ! global variables
   integer::ntape
   integer,parameter::nninmx=10
   integer,parameter::nmtmx=20
   integer,parameter::nmatmx=nninmx
   integer,dimension(nninmx)::jtape,nrt,npt,irt,ipt,ip1t,ip2t,nbt,nwt

contains

   subroutine mixr
   !-------------------------------------------------------------------
   !
   !  mixr
   !
   !  Construct a new pendf tape with a specified set of
   !  reactions that are specified linear combinations of the
   !  cross sections from the input tapes.  Mixr can also be
   !  used for endf tapes, but the input interpolation laws
   !  are ignored.  This module can be used to construct mixed
   !  reactions for plotting (for example, elemental cross
   !  sections).  The output file contains files 1 and 3 only.
   !  Linear-linear interpolation is assumed.
   !
   !  user input --
   !
   !  card 1  --  units
   !     nout      output unit for mixed cross sections
   !     nin1      first input unit (endf or pendf)
   !     nin2      second input unit
   !      ...      continue for nnin<=nninmx (=10) input units
   !
   !  card 2  --  reaction list
   !      mtn      list of nmt<=nmtmx (=20) mt numbers for
   !               the output reactions
   !
   !  card 3  --  material list
   !     matn,     list of nmat<=nmatmx (=nninmx=10) pairs (matn,wtn)
   !      wtn      of material numbers and associated weighting factors
   !
   !  card 4  --  temperature
   !     temp      temperature (use zero except for pendf tapes)
   !
   !  card 5  --  output material
   !     matd      material number
   !     za        za value
   !     awr       awr value
   !
   !  card 6  --  file 1 comment card
   !     des       description (66 char max)
   !
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides timer,openz,error,mess,closz,sigfig
   use endf ! provides endf routines and variables
   ! internals
   integer,parameter::mxlna=300000
   integer::nscr,nbuf,nc,i,nout,nnin,nmt,nmat,matd
   integer::ndes,ibuf,iscr,nb,nw,idone,nx,inow,imt
   integer::mtd,je,ne,jend,idis
   integer,parameter::lrp=-1
   integer::nsub
   real(kr)::temp,za,awr,t,test,enext,reset,enxt,e,sig
   real(kr)::time,y
   real(kr)::awi,emax
   character(66)::strng
   character(4)::str(17)
   integer,dimension(nninmx)::nin
   integer,dimension(nmtmx)::mtn
   integer,dimension(nmatmx)::matn,jscr
   real(kr),dimension(nmatmx)::wtn
   real(kr),dimension(mxlna)::a
   real(kr)::c(2)
   real(kr)::des(17)
   equivalence(str(1),des(1))
   real(kr),parameter::big=1.e10_kr

   !--initialize
   call timer(time)
   write(nsyso,&
     '(/'' mixr...calculation of mixed cross sections'',&
     &26x,f8.1,''s'')') time
   write(nsyse,'(/'' mixr...'',61x,f8.1,''s'')') time
   nscr=10
   nbuf=5000
   nc=2
   call openz(-nscr,0)

   !--read user input
   do i=1,nninmx
      nin(i)=0
   enddo
   read(nsysi,*) nout,(nin(i),i=1,nninmx)
   do i=1,nninmx
      if (nin(i).ne.0) nnin=i
   enddo
   do i=1,nmtmx
      mtn(i)=0
   enddo
   read(nsysi,*) (mtn(i),i=1,nmtmx)
   do i=1,nmtmx
      if (mtn(i).ne.0) nmt=i
   enddo
   do i=1,nmatmx
      matn(i)=0
   enddo
   read(nsysi,*) (matn(i),wtn(i),i=1,nmatmx)
   do i=1,nmatmx
      if (matn(i).ne.0) nmat=i
   enddo
   read(nsysi,*) temp
   read(nsysi,*) matd,za,awr
   strng=' '
   read(nsysi,*) strng
   read(strng,'(16a4,a2)') (str(i),i=1,17)
   ndes=17
   write(nsyso,&
     '(/'' unit for output tape ................. '',i10)') nout
   do i=1,nnin
      write(nsyso,&
        '( '' unit for input tape .................. '',i10)')&
        nin(i)
   enddo
   write(nsyso,&
     &'( '' mt numbers for output tape ........... '',/10x,20i6)')&
     (mtn(i),i=1,nmt)
   write(nsyso,'( '' mat,weight values for mixes .......... ''/&
     &(10x,i6,f10.5))') (matn(i),wtn(i),i=1,nmat)

   !--allocate storage
   ibuf=1
   iscr=ibuf+nbuf
   jscr(1)=iscr+npage+50
   do i=2,nmat
      jscr(i)=jscr(i-1)+npage+50
   enddo

   !--open the output and input units
   !--and locate the desired materials and temperature.
   call openz(nout,1)
   awi=1
   emax=20.e6_kr
   nsub=10
   do i=1,nmat
      call openz(nin(i),0)
      call tpidio(nin(i),0,0,a(iscr),nb,nw)
      idone=0
      do while (idone.eq.0)
         call contio(nin(i),0,0,a(iscr),nb,nw)
         if (math.lt.0) call error('mixr',&
           'mat and temp not found',' ')
         if (math.eq.matn(i)) then
            call contio(nin(i),0,0,a(iscr),nb,nw)
            if (n1h.ne.0) then
               iverf=4
            else if (n2h.eq.0) then
               iverf=5
            else
               iverf=6
            endif
            call skiprz(nin(i),-1)
            if (iverf.gt.4) call contio(nin(i),0,0,a(iscr),nb,nw)
            if (iverf.gt.5) then
               call contio(nin(i),0,0,a(iscr),nb,nw)
               if (a(iscr+1).gt.emax) emax=a(iscr+1)
               if (i.eq.1) then
                  awi=a(iscr)
                  if (awi.lt.0.1) nsub=0
                  if (awi.gt.0.9980.and.awi.lt.0.9990) nsub=10010
                  if (awi.gt.1.9950.and.awi.lt.1.9970) nsub=10020
                  if (awi.gt.2.9895.and.awi.lt.2.9897) nsub=10030
                  if (awi.gt.2.9890.and.awi.lt.2.9891) nsub=20030
                  if (awi.gt.3.9670.and.awi.lt.3.9680) nsub=20040
               endif
            endif
            call hdatio(nin(i),0,0,a(iscr),nb,nw)
            t=a(iscr)
            test=1
            if (abs(t-temp).lt.test) then
               idone=1
            else
               call tomend(nin(i),0,0,a(iscr))
            endif
         else
            call tomend(nin(i),0,0,a(iscr))
         endif
      enddo
      call findf(matn(i),3,0,nin(i))
   enddo

   !--write the tape id record and file 1 for the output tape
   math=1
   call afend(nout,0)
   math=matd
   mfh=1
   mth=451
   nx=nmt
   a(iscr)=za
   a(iscr+1)=awr
   a(iscr+2)=lrp
   a(iscr+3)=0
   a(iscr+4)=0
   a(iscr+5)=0
   if (iverf.le.4) a(iscr+5)=nx
   call contio(0,nout,0,a(iscr),nb,nw)
   if (iverf.gt.4) then
      a(iscr)=0
      a(iscr+1)=0
      a(iscr+2)=0
      a(iscr+3)=0
      a(iscr+4)=0
      a(iscr+5)=0
      if (iverf.eq.6) a(iscr+5)=6
      call contio(0,nout,0,a(iscr),nb,nw)
      if (iverf.ge.6) then
         a(iscr)=awi
         a(iscr+1)=emax
         a(iscr+2)=0
         a(iscr+3)=0
         a(iscr+4)=nsub
         a(iscr+5)=0
         call contio(0,nout,0,a(iscr),nb,nw)
      endif
   endif
   a(iscr)=temp
   a(iscr+1)=0
   a(iscr+2)=0
   if (iverf.ge.6) a(iscr+2)=1
   a(iscr+3)=0
   a(iscr+4)=ndes
   a(iscr+5)=0
   if (iverf.ge.5) a(iscr+5)=nx
   do i=1,ndes
      a(iscr+5+i)=des(i)
   enddo
   call hdatio(0,nout,0,a(iscr),nb,nw)
   inow=iscr
   do i=1,nmt
      a(inow)=0
      a(inow+1)=0
      a(inow+2)=3
      a(inow+3)=mtn(i)
      a(inow+4)=0
      a(inow+5)=0
      inow=inow+6
   enddo
   nw=nmt
   call dictio(0,nout,0,a(iscr),nb,nw)
   call afend(nout,0)

   !--loop over the desired reactions.
   do imt=1,nmt
      mtd=mtn(imt)

      !--find the section for mt on each input tape.
      enext=big
      reset=-1
      call gety(reset,enxt,idis,y,0,a(iscr))
      do i=1,nmat
         idone=0
         do while (idone.eq.0)
            call contio(nin(i),0,0,a(iscr),nb,nw)
            if (mfh.eq.0.or.mth.eq.mtd) then
               idone=1
            else
               call tosend(nin(i),0,0,a(iscr))
            endif
         enddo
         if (mth.eq.mtd) then
            e=0
            call gety(e,enxt,idis,y,nin(i),a(jscr(i)))
            if (enxt.lt.enext) enext=enxt
            write(nsyso,&
              '('' found section for mt='',i4,'' and mat='',i4)')&
              mtd,matn(i)
         else
            write(strng,&
              '(''mt='',i3,'' not present for mat='',i4)')&
              mtd,matn(i)
            call mess('mixr',strng,' ')
            call findf(matn(i),3,0,nin(i))
         endif
      enddo

      !--loop over the energies to get a union grid
      je=0
      do while (enext.lt.big)
         e=enext

         !--mix the cross sections at this energy
         enext=big
         sig=0
         do i=1,nmat
            call gety(e,enxt,idis,y,nin(i),a(jscr(i)))
            if (enxt.lt.enext) enext=enxt
            sig=sig+wtn(i)*y
         enddo

         !--save the mixed value on the scratch tape
         je=je+1
         if (enext.ge.big) je=-je
         c(1)=e
         c(2)=sig
         call loada(je,c,nc,nscr,a(ibuf),nbuf)

      !--continue the energy loop
      enddo
      ne=-je
      do i=1,nmat
         call tosend(nin(i),0,0,a(iscr))
      enddo

      !--write head record for this mt
      math=matd
      mfh=3
      mth=mtd
      a(iscr)=za
      a(iscr+1)=awr
      a(iscr+2)=0
      a(iscr+3)=0
      a(iscr+4)=0
      a(iscr+5)=0

      !--write tab1 record for this mt
      call contio(0,nout,0,a(iscr),nb,nw)
      a(iscr)=0
      a(iscr+1)=0
      a(iscr+2)=0
      a(iscr+3)=0
      a(iscr+4)=1
      a(iscr+5)=ne
      a(iscr+6)=ne
      a(iscr+7)=2
      inow=iscr+8
      nb=0
      jend=npage/2
      if (jend.gt.ne) jend=ne
      je=0
      idone=0
      do while (je.lt.ne.and.idone.eq.0)
         je=je+1
         call finda(je,c,nc,nscr,a(ibuf),nbuf)
         a(inow)=c(1)
         a(inow+1)=sigfig(c(2),7,0)
         inow=inow+2
         if (inow.gt.mxlna) then
            call error('mixr','mxlna array limit exceeded',' ')
         endif
         if (je.ge.jend) then
            if (nb.eq.0) then
               call tab1io(0,nout,0,a(iscr),nb,nw)
            else
               call moreio(0,nout,0,a(iscr),nb,nw)
            endif
            if (nb.eq.0) then
               idone=1
            else
               inow=iscr
               jend=jend+npage/2
               if (jend.gt.ne) jend=ne
            endif
         endif
      enddo
      call asend(nout,0)

   !--continue the reaction loop
   enddo

   !--finish off the output tape
   call afend(nout,0)
   call amend(nout,0)
   call atend(nout,0)

   !--close the units being used and return
   call closz(nout)
   do i=1,nmat
      call closz(nin(i))
   enddo
   call closz(-nscr)
   call timer(time)
   write(nsyso,'(/69x,f8.1,''s''/&
     &7(''**********''),''*******'')') time
   return
   end subroutine mixr

   subroutine gety(x,xnext,idis,y,itape,a)
   !-------------------------------------------------------------------
   ! Retrieve y(x) from an ENDF TAB1 structure using paged BCD or
   ! blocked binary formats.  Call with x=0 to read in first page
   ! or block of data and initialize pointers.  Routine assumes
   ! values will be called in ascending order.  Here, xnext is the
   ! first data grid point greater than x unless x is the last point.
   ! This version will keep track of pointers for up to nninmx units.
   ! Call with x=-1 to clear the pointers before each group of files.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides tab1io,moreio,terp1
   ! externals
   integer::idis,itape
   real(kr)::x,xnext,y,a(*)
   ! internals
   integer::nwtot,nr,np,ip1,ip2,ir,ip,i,ktape,ln
   integer::nbx,int,nb,nw,lt
   real(kr)::xn
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::zero=0
   save lt

   !--branch on value of x
   idis=0
   if (x.eq.zero) go to 100
   if (x.gt.zero) go to 115

   !--clear pointer storage
   ntape=0
   return

   !--read first page or block of data and initialize
  100 continue
   ntape=ntape+1
   jtape(ntape)=itape
   call tab1io(itape,0,0,a,nb,nw)
   nwtot=nw
   nr=nint(a(5))
   np=nint(a(6))
   lt=6+2*nr
   ip1=1
   ip2=(nw-lt)/2
   if (nb.eq.0) ip2=ip2+2
   ir=1
   ip=2
   xnext=a(lt+1)

   !--save pointers and return
   nrt(ntape)=nr
   npt(ntape)=np
   irt(ntape)=ir
   ipt(ntape)=ip
   ip1t(ntape)=ip1
   ip2t(ntape)=ip2
   nbt(ntape)=nb
   nwt(ntape)=nwtot
   return

   !--restore pointers
  115 continue
   if (ntape.eq.0)&
     call error('gety','not properly initialized',' ')
   do 120 i=1,ntape
   if (jtape(i).ne.itape) go to 120
   ktape=i
   nr=nrt(i)
   np=npt(i)
   ir=irt(i)
   ip=ipt(i)
   ip1=ip1t(i)
   ip2=ip2t(i)
   nb=nbt(i)
   nwtot=nwt(i)
   go to 125
  120 continue
   y=0
   xnext=big
   return

   !--is x in this panel
  125 continue
   ln=2*(ip-ip1)+lt
   if (x.lt.a(ln-1)) go to 135
   if (x.lt.a(ln+1)) go to 130
   if (ip.eq.np) go to 140

   !--no.  move up to next range.
   !--read in new page of data if needed.
   ip=ip+1
   nbx=nint(a(5+2*ir))
   if (ip.gt.nbx) ir=ir+1
   if (ip.lt.ip2) go to 125
   if (nb.eq.0) go to 130
   a(lt+1)=a(nwtot-3)
   a(lt+2)=a(nwtot-2)
   a(lt+3)=a(nwtot-1)
   a(lt+4)=a(nwtot)
   call moreio(itape,0,0,a(lt+5),nb,nw)
   nwtot=nw+lt+4
   ip1=ip-1
   ip2=ip1+nw/2+1
   if (nb.eq.0) ip2=ip2+2
   go to 125

   !--yes.  interpolate for desired value
  130 continue
   int=nint(a(6+2*ir))
   if (int.eq.1) idis=1
   call terp1(a(ln-1),a(ln),a(ln+1),a(ln+2),x,y,int)
   xnext=a(ln+1)
   if ((ln+3).gt.nwtot.and.nb.eq.0) return
   xn=a(ln+3)
   if (xn.eq.xnext) idis=1
   go to 150

   !--special branch for x outside range of table
  135 continue
   y=0
   xnext=a(ln-1)
   go to 150

   !--special branch for last point
  140 continue
   y=a(ln+2)
   xnext=big

   !--save pointers and return
  150 continue
   nrt(ktape)=nr
   npt(ktape)=np
   irt(ktape)=ir
   ipt(ktape)=ip
   ip1t(ktape)=ip1
   ip2t(ktape)=ip2
   nbt(ktape)=nb
   nwt(ktape)=nwtot
   return
   end subroutine gety

end module mixm

module ccccm
   ! provides subroutine ccccr for NJOY2016
   use locale
   implicit none
   private
   public ccccr

   ! equivalenced arrays for CCCC input and output
   integer,parameter:: isiza4=100000, isiza8=isiza4/2
   real(k4)::a(isiza4)      ! reals are 4-byte
   integer(k4)::ia(isiza4)  ! integers are 4-byte
   real(k8)::ha(isiza8)     ! Hollerith data are 8-byte
   character(8)::ta(isiza8) ! text equivalent to Hollerith
   integer::mult=2         ! used for counting 8-byte entries
   equivalence(a(1),ia(1),ha(1),ta(1))

   ! i/o units
   integer::nin,nisot,nbrks,ndlay,nscrt1,nscrt2,nscrt3

   ! common variables
   real(8)::huse(2)
   character(8)::tuse(2)
   equivalence(huse(1),tuse(1))
   integer::ivers

   ! cccc user and version values

   ! array for reading gendf data
   integer,parameter::maxe=8000
   real(kr),dimension(:),allocatable::e

   ! hollerith set id record
   character(6)::hsetid(12)

   ! common parameters
   integer::ngps,nggrup,niso,maxord,ifopt,nsblk,nscmax,ichix

   ! isotxs material identity and classification arrays
   integer::imat(200),kbr(200)
   character(6)::hisonm(200),habsid(200),hident(200),hmat(200)

   ! isotxs isotope data
   real(kr)::amass(200),efiss(200),ecapt(200),temp(200),&
     sigpot(200),adens(200)

   integer::iflags(15)
   integer::ltot,ltrn

   ! isotxs matrix parameters
   integer::irsize,ng2z,jlz,ieof,lord1,nsiza

   ! user input for brkoxs file
   integer::nti,nzi,nreact,nzt,ntj,nzj

   ! temperature and sigmazero areas for brkoxs data
   real(kr)::atem(20),ctem(20),ntat(20),item(20)
   real(kr)::asig(20),csig(20),ntap(20),isig(20)
   real(kr)::xspo,xspot(200)
   real(kr)::tzro

   ! brkoxs parameters
   integer::next,isopec,l1,l2,l13
   integer::jbl,jbh
   integer::mt2tem(10),ntfl
   integer::matd,nsb,lrsize

   ! tolerance for self-shielding factors in brkoxs data
   real(kr),parameter::sstol=.00001e0_kr

   ! delayed parameters
   integer::nisod,nfam

contains

   subroutine ccccr
   !--------------------------------------------------------------------
   !
   !  Produce CCCC-IV files from njoy intermediate cross section
   !  library.
   !
   !  Working from a groupr output tape, this module produces
   !  the following three standard interface files,
   !
   !           ISOTXS       BRKOXS       DLAYXS,
   !
   !  as specified by the committee for computer code coordination
   !  (CCCC), to facilitate the exchange of nuclear data for reactor
   !  calculations (Reference 1).
   !      In a given run, all three files can be produced using the
   !  same user-specified list of isotopes.  The code will ignore
   !  isotopes which are not present on the groupr tape (and in the
   !  case of DLAYXS, isotopes without delayed neutron data).
   !      The ISOTXS coding allows for NSBLK equal to one or ngroup.
   !  In addition, files with higher order matrices can be produced
   !  with a separate block for each l-order (ifopt=2) or with all
   !  orders in one block (ifopt=1).  This flexibility accommodates
   !  large group structures.  Fission vectors or fission
   !  matrices can be produced.
   !      In BRKOXS, the potential scattering cross section for all
   !  energy groups is equal to the user-input value (xspo).
   !  The elastic removal f-factor is supplied as the sixth reaction.
   !
   !  1. R.D.Odell. Standard Interface Files and Procedures
   !     for Reactor Physics Codes, Version IV,
   !     LANL report LA-6941-MS (Sept.77)
   !
   !
   !---input specifications (free format)---------------------------
   !
   !-ccccr-
   ! card 1 units
   !    nin      input unit for data from groupr
   !    nisot    output unit for isotxs (0 if isotxs not wanted)
   !    nbrks    output unit for brkoxs (0 if brkoxs not wanted)
   !    ndlay    output unit for dlayxs (0 if dlayxs not wanted)
   ! card 2 identification
   !    lprint    print flag (0/1=not print/printed)
   !    ivers     file version number (default=0)
   !    huse      user identification (12 characters)
   !              delimited by *, ended by /.
   !              (default=blank)
   ! card 3
   !    hsetid    hollerith identification of set (12 characters)
   !              delimited by *, ended by /.
   !              (default=blank)
   ! card 4 file control
   !    ngroup    number of neutron energy groups
   !    nggrup    number of gamma energy groups
   !    niso      number of isotopes desire
   !    maxord    maximum legendre order
   !    ifopt     matrix blocking option (1/2=blocking by
   !                               reaction/legendre order)
   ! card 5 isotope parameters (one card per isotope)
   !       (first four words are hollerith, up to six characters
   !       each, delimited by *)
   !    hisnm     hollerith isotope label
   !    habsid    hollerith absolute isotope label
   !    hident    identifier of data source library (endf)
   !    hmat      isotope identification
   !    imat      numerical isotope identifier (endf mat number)
   !    xspo      average potential scattering cross sect. (brkoxs)
   !
   !-cisotx- (only if nisot.gt.0)
   ! card 1 file control
   !    nsblok    subblocking option for scattering matrix
   !              (1 or ngrup sub-blocks allowed)
   !    maxup     maximum number of upscatter groups (always zero)
   !    maxdn     maximum number of downscatter groups
   !    ichix     fission chi representation
   !                   -1   vector (using groupr flux)
   !                    0   none
   !                   +1   vector (using input flux)
   !                .gt.1   matrix
   ! card 2 chi vector control (ichix=1 only)
   !    spec      ngroup flux values used to collapse the groupr
   !              fission matrix into a chi vector
   ! card 3 chi matrix control (ichix.gt.1 only)
   !    spec      ngroup values of spec(i)=k define the range of
   !              groups i to be averaged to obtain spectrum k.
   !              index k ranges from 1 to ichi.
   !              the model flux is used to weight each group i.
   ! card 4 isotope control (one card per isotope)
   !    kbr       isotope classification
   !    amass     gram atomic weight
   !    efiss     total thermal energy/fission
   !    ecapt     total thermal energy/capture
   !    temp      isotope temperature
   !    sigpot     average effective potential scattering
   !    adens     density of isotope in mixture
   !
   !-cbrkxs- (only if nbrks.gt.0)
   ! card 1 (2i6) file data
   !    nti       number of temperatures desired
   !              (-n means accept first n temperatures)
   !    nzi       number of sigpo values desire
   !              (-n means accept first n dilution factors)
   ! card 2 (not needed if nti.lt.0)
   !    atem(nti) values of desired temperatures
   ! card 3 (not needed if nzi.lt.0)
   !    asig(nzi) values of desired sigpo
   !
   !-cdlayx-- no input required
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides timer,openz,repoz,closz
   ! internals
   integer::lprint,i
   real(kr)::time
   character(72)::text
   character(12)::word

   !--initialize.
   call timer(time)
   write(nsyso,'(/'' ccccr...'',&
     &''produce cccc format output files'',28x,f8.1,''s'')')&
     time
   write(nsyse,'(/'' ccccr...'',60x,f8.1,''s'')') time
   allocate(e(maxe))
   next=1
   nscrt1=10
   nscrt2=11
   nscrt3=12
   call openz(-nscrt2,1)
   call openz(-nscrt3,1)

   !--user input for units to be used.
   nisot=0
   nbrks=0
   ndlay=0
   read(nsysi,*) nin,nisot,nbrks,ndlay
   write(nsyso,'(/&
     &'' input gendf unit ..................... '',i10/&
     &'' output isotxs unit ................... '',i10/&
     &'' output brkoxs unit ................... '',i10/&
     &'' output dlayxs unit ................... '',i10)')&
     nin,nisot,nbrks,ndlay
   if (nin.lt.0) nscrt1=-nscrt1
   call openz(nin,0)
   call openz(-nisot,1)
   call openz(-nbrks,1)
   call openz(-ndlay,1)
   call openz(nscrt1,1)

   !--user input for file identification
   ivers=0
   word=' '
   read(nsysi,*) lprint,ivers,word
   read(word,'(2a6)') tuse(1),tuse(2)

   !--read other user input
   text=' '
   read(nsysi,*) text
   read(text,'(12a6)') (hsetid(i),i=1,12)
   read(nsysi,*) ngps,nggrup,niso,maxord,ifopt
   do i=1,niso
      read(nsysi,*) hisonm(i),habsid(i),hident(i),&
        hmat(i),imat(i),xspot(i)
   enddo

   !--prepare isotxs file if desired
   if (nisot.ne.0) then
      call cisotx
      if (lprint.eq.1) call pisotx(nisot)
   endif

   !--prepare brkoxs file if desired
   if (nbrks.ne.0) then
      call cbrkxs
      if (lprint.eq.1) call pbrkxs(nbrks)
   endif

   !--prepare dlayxs file if desired
   if (ndlay.ne.0) then
      call cdlyxs(ndlay,nin)
      if (lprint.eq.1.and.nisod.ne.0) call pdlyxs(ndlay)
   endif

   !--finished
   deallocate(e)
   call repoz(-nisot)
   call repoz(-nbrks)
   call repoz(-ndlay)
   call repoz(nin)
   call closz(nin)
   call closz(-nisot)
   call closz(-nbrks)
   call closz(-ndlay)
   call closz(nscrt1)
   call closz(-nscrt2)
   call closz(-nscrt3)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/1x,&
     &7(''**********''),''*******'')') time
   return
   end subroutine ccccr

   subroutine cisotx
   !--------------------------------------------------------------------
   ! Write CCCC-IV ISOTXS interface file.  The n2n matrix is production
   ! based for version IV.  To get reaction based matrix as in
   ! version III, set n2niv to 0.
   !--------------------------------------------------------------------
   use util ! provides repoz
   ! internals
   integer::n4,irec,nwds,l1h,ngroup,ichist,nsblok,irec2,irec3
   integer::jlord,jband,jtemp,iso,lnext,ichi,ifis,ialf,inp,in2n,ind,int
   integer::ltot,ltrn,istrpd,inc,n,lordn,lord,kmax,k,ji,jl,ju,jj
   integer::l,ndex,mdex,j,n1,ibw,jm,isnk,isrce,jk
   integer::l1r,l1i,l13h,nwh,l13r,nwr,l13i,nwi,i
   character(6)::hname='isotxs'
   integer::n2niv=1

   n4=nisot

   !--read user input
   call ruinis

   !--create and write isotxs data sets on scratch tape
   call isxdat

   !--file identification
   irec=1
   nwds=3*mult+1
   l1h=(l1-1)/mult+1
   read(hname,'(a6)') ta(l1h)
   ha(l1h+1)=huse(1)
   ha(l1h+2)=huse(2)
   ia(3*mult+l1)=ivers
   call repoz(-n4)
   write(n4)(ha(l1h+i-1),i=1,3),ia(l1+3*mult)

   !--file control
   irec=2
   l2=l1+nwds
   nwds=8
   write(n4)(ia(l2+i-1),i=1,nwds)
   ngroup=ia(l2)
   niso=ia(l2+1)
   ichist=ia(l2+5)
   nscmax=ia(l2+6)
   nsblok=ia(l2+7)

   !--file data
   irec=3
   l13h=(l13-1)/mult
   nwh=12+niso
   l13r=l13-1+nwh*mult
   nwr=ngroup*(2+ichist*(2/(ichist+1)))+1
   l13i=l13r+nwr
   nwi=niso
   nwds=nwh*mult+nwr+nwi
   write(n4)(ha(l13h+i),i=1,nwh),(a(l13r+i),i=1,nwr),&
     (ia(l13i+i),i=1,nwi)

   !--set chi data
   ! no set chi data provided

   !--loop over isotopes
   irec2=0
   irec3=0
   call repoz(-nscrt3)
   call repoz(-nscrt2)
   jlord=l1
   jband=jlord+2*nscmax
   jtemp=jband+nscmax*ngroup
   do 110 iso=1,niso

   !--isotope control and group independent data
   irec=irec+1
   l1h=(l1-1)/mult+1
   nwh=3
   l1r=l1+mult*nwh
   nwr=6
   l1i=l1r+nwr
   nwi=11+2*nscmax+2*ngroup*nscmax
   nwds=mult*nwh+nwr+nwi
   irec3=irec3+1
   read(nscrt3)(ha(l1h+i-1),i=1,nwh),(a(l1r-1+i),i=1,nwr),&
     (ia(l1i+i-1),i=1,nwi)
   write(n4)(ha(l1h+i-1),i=1,nwh),(a(l1r-1+i),i=1,nwr),&
     (ia(l1i+i-1),i=1,nwi)
   lnext=l1+3*mult
   ichi=ia(lnext+7)
   ifis=ia(lnext+8)
   ialf=ia(lnext+9)
   inp=ia(lnext+10)
   in2n=ia(lnext+11)
   ind=ia(lnext+12)
   int=ia(lnext+13)
   ltot=ia(lnext+14)
   ltrn=ia(lnext+15)
   istrpd=ia(lnext+16)
   call stow(a(lnext+17),a(jlord),2*nscmax)
   call stow(a(lnext+17+2*nscmax),a(jband),nscmax*ngroup)

   !--principal cross sections
   irec=irec+1
   nwr=(1+ltrn+ltot+ialf+inp+in2n+ind+int+istrpd+2*ifis+&
     ichi*(2/(ichi+1)))*ngroup
   nwds=nwr
   irec2=irec2+1
   read(nscrt2)(a(jtemp+i-1),i=1,nwr)
   write(n4)(a(jtemp+i-1),i=1,nwr)

   !--isotope chi data
   if (ichi.gt.1) then
      nwr=ngroup*ichi
      nwi=ngroup
      nwds=nwr+nwi
      irec2=irec2+1
      read(nscrt2)(a(jtemp+i-1),i=1,nwr),(ia(jtemp+nwr+i-1),i=1,nwi)
      irec=irec+1
      write(n4)(a(jtemp+i-1),i=1,nwr),(ia(jtemp+nwr+i-1),i=1,nwi)
   endif

   !--scattering data
   inc=(ngroup-1)/nsblok+1
   do n=1,nscmax
      lordn=ia(jlord+nscmax+n-1)
      if (lordn.ne.0) then
         lord=maxord+1
         if (ifopt.eq.2) lord=1
         kmax=0
         k=jlord-1+2*nscmax+(n-1)*ngroup
         do ji=1,nsblok
            jl=(ji-1)*inc+1
            ju=ji*inc
            nwds=0
            do jj=jl,ju
               l=k+jj
               nwds=nwds+ia(l)
                  kmax=kmax+ia(l)
            enddo
            nwds=nwds*lord
            if (nwds.gt.0) then
               irec2=irec2+1
               read(nscrt2)(a(jtemp+i-1),i=1,nwds)
               if (lordn.ne.0) then
                  ndex=jtemp-1
                  mdex=jtemp-1
                  do j=jl,ju
                     n1=jlord-1+2*nscmax+(n-1)*ngroup+j
                     ibw=ia(n1)
                     if (ibw.ne.0) then
                        do jm=1,lordn
                           isnk=ndex+(jm-1)*ibw
                           isrce=mdex+(jm-1)*ibw
                           do jk=1,ibw
                              a(jk+isnk)=a(jk+isrce)
                           enddo
                           isnk=isnk+ibw
                        enddo
                        ndex=isnk
                     endif
                     mdex=mdex+ibw*lord
                  enddo
                  nwds=ndex-jtemp+1
                  if (nwds.gt.0) then
                     if (ia(jlord+n-1).ge.300.and.n2niv.gt.1) then
                        do j=1,nwds
                           jj=jtemp-1+j
                           a(jj)=a(jj)/2
                        enddo
                     endif
                     irec=irec+1
                     write(n4)(a(jtemp+i-1),i=1,nwds)
                  endif
               endif
            endif
         enddo
      endif
   enddo

   !--close isotope loop
  110 continue
   next=isopec
   return
   end subroutine cisotx

   subroutine ruinis
   !--------------------------------------------------------------------
   ! Reads user input pertinent to ISOTXS file
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! internals
   integer::maxup,maxdn,ichist,nwds,i,ndex,j

   !--isotope independent data
   read(nsysi,*) nsblk,maxup,maxdn,ichix
   ichist=0
   nscmax=4+4*maxord*(ifopt-1)
   nwds=ngps
   if (2*(nwds/2).ne.nwds) nwds=nwds+1
   isopec=next
   next=isopec+nwds
   if (ichix.gt.0) then
      read(nsysi,*) (a(isopec+i-1),i=1,ngps)
   endif
   nwds=3*mult+8+mult
   l1=next
   next=l1+nwds
   nwds=12*mult
   l13=next
   next=l13+nwds
   ndex=l1+3*mult
   ia(ndex+1)=ngps
   ia(ndex+2)=niso
   ia(ndex+3)=maxup
   ia(ndex+4)=maxdn
   ia(ndex+5)=maxord
   ia(ndex+6)=ichist
   ia(ndex+7)=nscmax
   ia(ndex+8)=nsblk
   j=(l13-1)/mult
   do i=1,12
      read(hsetid(i),'(a6)') ta(i+j)
   enddo

   !--isotope dependent data
   do i=1,niso
      read(nsysi,*) kbr(i),amass(i),efiss(i),ecapt(i),&
        temp(i),sigpot(i),adens(i)
   enddo
   return
   end subroutine ruinis

   subroutine isxdat
   !--------------------------------------------------------------------
   ! Processes all ISOTXS data and writes on scratch tapes.
   ! Data stored in a(i) as follows:
   !
   !    location                 variable                    length
   !    --------                 --------                    ------
   !      l1                    *isotxs*                       1
   !      l2                     huse(1)                       1
   !      l3                     huse(2)                       1
   !      l4                      ivers                        1
   !      l5                     ngroup                        1
   !      l6                     niso                          1
   !      l7                     maxup                         1
   !      l8                     maxdn                         1
   !      l9                     maxord                        1
   !      l10                    ichist                        1
   !      l11                    nscmax                        1
   !      l12                    nsblok                        1
   !      l13                    hsetid                       12
   !      l14                    hisonm                     niso
   !
   !      l16                     vel                     ngroup
   !      l17                    emax                     ngroup
   !      l18                    emin                          1
   !      l19                    loca                       niso
   !      l20            isotope dependent data               -
   !      l21            idsct,lord,jband,ijj                 -
   !      l22      principal x-sections or scatt. matrix      -
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides repoz,error
   use endf ! provides endf routines and variables
   ! internals
   integer::nwds,l14,l16,l17,nwords,l18,l19,l20,l21,l21a,l22
   integer::nb,nw,nz,nt,ntw,loc,iqd,nenpts,i,jiso,loca,irec2,irec3
   integer::j,iin,jj,nsz,ichid,l20m,loci,k,nl,lk,l,ijz,nlgt,isol
   integer::nwh,nwr,nwi,llh,llr,lli
   integer::nrct(4)
   integer::imusd(200)

   !--assign storage
   nwds=mult*niso
   l14=next
   next=l14+nwds
   l16=next
   next=l16+ngps
   l17=next
   next=l17+ngps
   nwords=1
   l18=next
   next=l18+nwords
   nwds=niso+1
   if (((l18+nwds)/mult)*mult.eq.(l18+niso)) nwds=niso
   l19=next
   next=l19+nwds
   nwds=3*mult+17
   l20=next
   next=l20+nwds
   nwds=2*nscmax*(1+ngps)
   l21=next
   next=l21+nwds
   nwds=ngps
   l21a=next
   next=l21a+nwds
   l22=next

   !--read header for first material
   call repoz(nin)
   call tpidio(nin,0,0,e(1),nb,nw)
  100 continue
   call contio(nin,0,0,e(1),nb,nw)
   if (mfh.eq.0.or.mth.eq.0) go to 100
   nz=l2h
   nt=n2h
   ntw=nt
   call listio(nin,0,0,e(1),nb,nw)
   ngps=l1h
   loc=l1+1+3*mult
   if (ngps.ne.ia(loc))&
     call error('isxdat','incompatible group structures.',' ')
   loc=1+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,e(loc),nb,nw)
      loc=loc+nw
   enddo
   iqd=1+6+ntw+nz+ngps
   ! rearrange group bounds, store at l17
   nenpts=ngps+1
   do i=1,nenpts
      a(i-1+l17)=e(-i+1+iqd)
   enddo

   !--begin isotope loop
   jiso=0
   loca=0
   ia(l19)=0
   do i=1,200
      imusd(i)=0
   enddo
   call repoz(nin)
   irec2=0
   irec3=0
   call repoz(-nscrt2)
   call repoz(-nscrt3)
   do 300 i=1,niso
   call tpidio(nin,0,0,e(1),nb,nw)
  120 continue
   call contio(nin,0,0,e(1),nb,nwds)
   if (math.eq.-1) go to 350
   if (math.eq.0) go to 120
   if (mfh.eq.0.or.mth.eq.0) go to 120
   if (mfh.gt.1) go to 130
   call tosend(nin,0,0,e(1))
   go to 120
  130 continue
   do 140 j=1,niso
   if (math.ne.imat(j)) go to 140
   if (imusd(j).eq.1) go to 140
   jiso=jiso+1
   iin=j
   imusd(j)=1
   jj=(l14-1)/mult+jiso
   read(hisonm(j),'(a6)') ta(jj)
   go to 160
  140 continue
   call tomend(nin,0,0,e(1))
   go to 120

   !--copy this material to a scratch tape
  160 continue
   nsz=l2h
   call repoz(nscrt1)
   nsh=1
   call contio(0,nscrt1,0,e(1),nb,nw)
   call tomend(nin,nscrt1,0,e(1))
   call atend(nscrt1,0)
   call repoz(nscrt1)

   !--process principal cross section file
   call prinxs(a(isopec),a(l16),a(l22),ia(l22),a(l21a),i,nsz,ichid,&
     irec2)

   !--write isotope independent data
   jj=(l20-1)/mult+1
   read(habsid(iin),'(a6)') ta(jj)
   read(hident(iin),'(a6)') ta(jj+1)
   read(hmat(iin),'(a6)') ta(jj+2)
   l20m=l20+3*mult-1
   a(l20m+1)=amass(iin)
   a(l20m+2)=efiss(iin)
   a(l20m+3)=ecapt(iin)
   a(l20m+4)=temp(iin)
   a(l20m+5)=sigpot(iin)
   a(l20m+6)=adens(iin)
   ia(l20m+7)=kbr(iin)
   ia(l20m+8)=ichid
   ia(l20m+9)=iflags(4)
   ia(l20m+10)=iflags(7)
   ia(l20m+11)=iflags(8)
   ia(l20m+12)=iflags(9)
   ia(l20m+13)=iflags(10)
   ia(l20m+14)=iflags(11)
   ia(l20m+15)=ltrn
   ia(l20m+16)=ltot
   ia(l20m+17)=0

   !--process scattering matrix file
   call isomtx(ia(l21),a(l22),l21,l22,loci,nsz,irec2)
   ia(l1+3*mult+8)=nsblk
   nrct(1)=200
   nrct(2)=100
   nrct(3)=300
   nrct(4)=000
   if (ifopt.ne.2) then
      do k=1,4
         ia(l21-1+k)=nrct(k)
      enddo
   else
      nl=maxord+1
      do k=1,4
         lk=l21-1+(k-1)*nl
         do l=1,nl
            ia(l+lk)=l-1+nrct(k)
         enddo
      enddo
   endif
   ijz=l21-1+nscmax*(2+ngps)
   do k=1,ngps
      lk=ijz+(k-1)*nscmax
      do l=1,nscmax
         ia(l+lk)=1
      enddo
   enddo
   ! calculate loca(i)
   if (i.ne.niso) then
      ia(l19+i)=loca+loci+2
      loca=ia(l19+i)
   endif

   !--write isotope-dependent data to nscrt3
   nlgt=l22-l20
   nwh=3
   nwr=6
   nwi=11+2*nscmax+2*ngps*nscmax
   nlgt=mult*nwh+nwr+nwi
   llh=(l20-1)/mult
   llr=l20+mult*nwh-1
   lli=llr+nwr
   irec3=irec3+1
   write(nscrt3)(ha(llh+j),j=1,nwh),(a(llr+j),j=1,nwr),&
     (ia(lli+j),j=1,nwi)

   !--all data read
  300 continue
   go to 360
  350 write(nsyso,'(/&
     &'' input tape does not contain all specified isotopes.'')')
  360 ia(l1+3*mult+2)=jiso

   !--thin out the file data (jiso not equal to niso)
   isol=niso-jiso
   do i=l16,l20
      a(i-isol)=a(i)
   enddo
   return
   end subroutine isxdat

   subroutine prinxs(spec,b,a,ia,cspc,iiso,nsz,ichid,irec2)
   !--------------------------------------------------------------------
   ! Creates principal cross section file.
   !--------------------------------------------------------------------
   use util ! provides repoz,error
   use endf ! provides endf routines and variables
   ! externals
   integer::iiso,nsz,ichid,irec2
   real(4)::spec(*),b(*),a(*),cspc(*)
   integer(4)::ia(*)
   ! internals
   integer::i,mt19,j,nptr,mchi,nwd,ig,nb,nwds,nl,nz,ng2,ig2lo
   integer::lz,loc,indx,mptr,ispec,jg2,locsg,ig2,jg,locch,loca
   integer::id,locn,locd,irct,ndex,mdex,jndx,jmdx
   real(kr)::flux,sig
   real(kr)::cnorm(20),dnorm(20)
   integer::iptr(12)
   integer,dimension(15),parameter::nsm=(/0,1,102,0,0,0,107,103,&
     16,104,105,6,7,8,9/)
   integer,dimension(11),parameter::nstx=(/0,1,102,0,0,0,107,103,&
     0,104,105/)
   integer,dimension(5),parameter::ntn=(/6,7,8,9,16/)
   real(kr),parameter::epsn=1.e-10_kr
   real(kr),parameter::zero=0

   ltot=1
   ltrn=1
   do i=1,20
      cnorm(i)=0
      dnorm(i)=0
   enddo
   do i=1,ngps
      cspc(i)=0
   enddo
   mt19=0

   !--write principal cross sections
   ! calculate position in a(i) where each mt file begins
   do i=1,12
      j=i-1
      iptr(i)=j*ngps+1
   enddo
   nptr=iptr(12)+ngps-1+ngps*nsz*(maxord+1)
   if (ichix.gt.1) mchi=nptr+1
   if (ichix.gt.1) nptr=nptr+ichix*ngps
   ! clear iflags(i),a(i)
   do i=1,nptr
      a(i)=0
   enddo
   do i=1,15
      iflags(i)=0
   enddo
   ichid=0
   ! read input data
   nwd=nsz*(maxord+1)*ngps
   call repoz(nscrt1)
   ig=ngps
  115 continue
   if (ig.lt.ngps) go to 120
   call contio(nscrt1,0,0,e(1),nb,nwds)
   nl=l1h
   nz=l2h
   if (math.eq.0) go to 240
   if (mfh.eq.0.or.mth.eq.0) go to 115
   if (mfh.gt.1) go to 120
   call tofend(nscrt1,0,0,e(1))
   go to 115
  120 continue
   call listio(nscrt1,0,0,e(1),nb,nwds)
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   lz=6
   loc=1+nwds
   do while (nb.ne.0)
      if (loc+302.gt.maxe) call error('prinxs',&
        'endf input size exceeded',' ')
      call moreio(nscrt1,0,0,e(loc),nb,nwds)
      loc=loc+nwds
   enddo
   if (mfh.ne.3) go to 205

   !--process mf=3 data
   ! read average velocities.
   if (mth.ne.259) go to 125
   if (iiso.ne.1) go to 115
   indx=lz+nl*nz+1
   mptr=ngps-ig+1
   ! assume reciprocal average velocities.
   b(mptr)=sigfig(100/e(indx),7,0)
   go to 115
  125 continue
   ! check mt numbers and set flags
   do 130 i=1,15
   if (mth.ne.nsm(i)) go to 130
   iflags(i)=1
   go to 140
  130 continue
   go to 190
   ! check for (n,2n) and sum
  140 continue
   do 150 i=1,5
   if (mth.eq.ntn(i)) go to 160
  150 continue
   go to 170
  160 continue
   mptr=iptr(9)-1+ngps-ig+1+nwd
   indx=lz+nl*nz+1
   a(mptr)=a(mptr)+e(indx)
   iflags(9)=1
   go to 115
   ! check for total, capture, (n,p), (n,d), (n,t), (n,alpha)
  170 continue
   do 180 i=1,11
   if (mth.ne.nstx(i)) go to 180
   mptr=iptr(i)-1+ngps-ig+1+nwd
   indx=lz+nl*nz+1
   a(mptr)=e(indx)
   go to 190
  180 continue
   ! store parameters for transport cross section
  190 continue
   if (mth.eq.1) then
      mptr=iptr(1)-1+ngps-ig+1+nwd
      indx=lz+nl*(nz+1)
      a(mptr)=e(indx)
      mptr=iptr(12)-1+ngps-ig+1+nwd
      indx=lz+nl
      a(mptr)=e(indx)
   ! fission cross section
   else if (mth.eq.18.or.mth.eq.19.or.mth.eq.20.or.mth.eq.21&
     .or.mth.eq.38) then
      if (mth.eq.19) mt19=1
      if (mth.eq.18) then
         iflags(4)=1
         iflags(5)=1
         if (ichix.ne.0) ichid=iabs(ichix)
         iflags(6)=ichid
         mptr=iptr(4)-1+ngps-ig+1+nwd
         indx=lz+nl*nz+1
         a(mptr)=e(indx)
      endif
   ! delay nu
   else if (mth.eq.455) then
      mptr=iptr(5)-1+ngps-ig+1+nwd
      a(mptr)=a(mptr)+e(lz+2)*e(lz+3)
      if (ichid.eq.1) then
         ispec=1
         if (ichix.lt.0) flux=e(lz+1)
         if (ichix.gt.0) flux=spec(ngps-ig+1)
      else
         ispec=nint(spec(ngps-ig+1))
         flux=e(lz+1)
      endif
      dnorm(ispec)=dnorm(ispec)+flux*e(lz+2)*e(lz+3)
   endif

   !--process mf=6 data
  205 continue
   if (mfh.ne.6) go to 230
   if (mth.eq.18.or.mth.eq.19.or.mth.eq.20.or.mth.eq.21&
     .or.mth.eq.38) go to 207
   ! transport cross section
   do j=2,ng2
      jg2=ngps+1-ig2lo-j+2
      if (nl.ge.2) then
         locsg=lz+nl*nz*(j-1)+2
         mptr=iptr(1)-1+ngps+1-ig+nwd
         a(mptr)=a(mptr)-e(locsg)
      endif
   enddo
   go to 230
   ! snutot and chi
  207 continue
   if (mt19.eq.0.and.mth.ne.18) go to 230
   if (mt19.eq.1.and.mth.eq.18) go to 230
   if (ig.ne.0) then
      do j=2,ng2
         jg2=ngps+1-ig2lo-j+2
         locsg=lz+nl*nz*(j-1)+1
         if (ig2lo.gt.0) then
            !-- matrix part
            mptr=iptr(5)-1+ngps-ig+1+nwd
            a(mptr)=a(mptr)+e(locsg)
            if (ichid.eq.1) then
               ispec=1
               if (ichix.lt.0) flux=e(lz+1)
               if (ichix.gt.0) flux=spec(ngps-ig+1)
               mptr=iptr(6)-1+jg2+nwd
            else
               ispec=nint(spec(ngps-ig+1))
               flux=a(lz+1)
               mptr=mchi+(jg2-1)*ichid+ispec-1
            endif
            a(mptr)=a(mptr)+e(locsg)*flux
            cnorm(ispec)=cnorm(ispec)+e(locsg)*flux
         else
            !--production part
            do i=1,ngps
               sig=e(locsg)*cspc(i)
               mptr=iptr(5)-1+ngps-ig+1+nwd
               a(mptr)=a(mptr)+sig
               if (ichid.eq.1) then
                  ispec=1
                  if (ichix.lt.0) flux=e(lz+1)
                  if (ichix.gt.0) flux=spec(ngps-ig+1)
                  mptr=iptr(6)-1+i+nwd
               else
                  ispec=nint(spec(i-1)*ichid)+ispec-1
                  flux=e(lz+1)
                  mptr=mchi+(i-1)*ichid+ispec-1
               endif
               a(mptr)=a(mptr)+sig*flux
               cnorm(ispec)=cnorm(ispec)+sig*flux
            enddo
         endif
      enddo
   else
      !--spectrum part
      do j=1,ng2
         jg2=ngps-ig2lo-j+2
         locsg=lz+nl*nz*(j-1)+1
         cspc(jg2)=e(locsg)
      enddo
   endif

   !--process mf=5 data
   ! complete accumulation of data for snutot and chiso
  230 continue
   if (mfh.eq.5.and.mth.eq.455) then
      do ig2=2,ng2
         jg=ngps+1-ig2lo-ig2+2
         do ispec=1,ichid
            if (ichid.eq.1) locch=iptr(6)-1+jg+nwd
            if (ichid.gt.1) locch=mchi+(jg-1)*ichid+ispec-1
            loca=lz+nl*(ig2-1)
            do id=1,nl
               a(locch)=e(id+loca)*dnorm(ispec)+a(locch)
               cnorm(ispec)=e(id+loca)*dnorm(ispec)+cnorm(ispec)
            enddo
         enddo
      enddo
   endif
   go to 115

   !--complete calculations of fission nu and chi
  240 continue
   if (iflags(4).ne.0) then
      do j=1,ngps
         !--fission nu
         locn=iptr(5)-1+j+nwd
         locd=iptr(4)-1+j+nwd
         if (a(locd).le.epsn) then
            a(locn)=0
         else
            a(locn)=a(locn)/a(locd)
         endif
         !--fission chi
         do ispec=1,ichid
            if (ichid.eq.1) locn=iptr(6)-1+j+nwd
            if (ichid.gt.1) locn=mchi+(j-1)*ichid+ispec-1
            if (cnorm(ispec).ne.zero) a(locn)=a(locn)/cnorm(ispec)
         enddo
      enddo
   endif

   !--collapse principal cross section file to eliminate reactions
   !--which have zero cross section
   irct=ltot+ltrn+1
   ndex=irct*ngps+1+nwd
   mdex=ndex
   do i=4,11
      if (iflags(i).eq.1) then
         jndx=ndex-1
         jmdx=mdex-1
         do j=1,ngps
            a(j+jndx)=a(j+jmdx)
         enddo
         irct=irct+1
         ndex=ndex+ngps
      endif
      mdex=mdex+ngps
   enddo
   nwds=irct*ngps

   !--write principal cross sections on scratch file
   ndex=nwd+1
   irec2=irec2+1
   write(nscrt2)(a(ndex+i-1),i=1,nwds)
   if (ichid.le.1) return

   !--write isotope chi data
   nwds=ngps*(ichid+1)
   irec2=irec2+1
   do i=1,ngps
      ia(nptr+i)=nint(spec(i))
   enddo
   write(nscrt2)(a(mchi+i-1),i=1,nwds)
   return
   end subroutine prinxs

   subroutine isomtx(ia,b,l21,l22,loci,nsz,irec2)
   !--------------------------------------------------------------------
   ! Supervises the changing of matrix format to standard 4C.
   !--------------------------------------------------------------------
   use util ! provides error,repoz
   use endf ! provides endf routines and variables
   ! externals
   integer::l21,l22,loci,nsz,irec2
   integer(4)::ia(*)
   real(4)::b(*)
   ! internals
   integer::nosiza,lrsize,nrmx,nrec,npass,iasiz,j,i,nj,nb,nwds
   integer::nl,m,mn,l

   !--assign storage

   ! nsiza--space available in b(i)
   ! irsize--length of one input record
   ! nosiza--space available in b(i) for output matrix
   ! lrsize--maximum length of output record
   ! nrmx--total number of records in matrix
   ! nrec--number of output records which fit in nosiza
   ! npass--number of tape passes necessary to fill entire matrix
   ! for ifopt=2 and nsblk=ngps, nrec and npass are not used

   !--set up sizes
   nsiza=isiza4-l22+1
   irsize=6+(ngps+1)*(maxord+1)*nsz
   if (irsize.lt.6*ngps) irsize=6*ngps
   if (irsize.gt.nsiza)&
     call error('isomtx','input record too large.',' ')
   nosiza=nsiza-irsize
   if (ifopt.ne.2) then
      lrsize=((maxord+1)*ngps*(ngps+1))/2
      if (nosiza.lt.lrsize) nsblk=ngps
      if (nsblk.eq.1) then
         nrmx=1
      else
         lrsize=ngps*(maxord+1)
         nrmx=ngps
      endif
   else
      lrsize=(ngps*(ngps+1))/2
      if (nosiza.lt.lrsize) nsblk=ngps
      if (nsblk.eq.1) then
         nrmx=(maxord+1)
      else
         nrmx=ngps*(maxord+1)
         lrsize=ngps
      endif
   endif
   nrec=nosiza/lrsize
   if (nrec.ge.nrmx) nrec=nrmx
   if (nrec.lt.1)&
     call error('isomtx','output record too large.',' ')
   npass=(nrmx+nrec-1)/nrec

   !--clear ia(i)
   iasiz=l22-l21
   do j=1,iasiz
      ia(j)=0
   enddo

   !--loop over data for inelastic, elastic, (n,2n) and total
   do 500 i=1,4
   lord1=0
   ng2z=0
   jlz=0
   ! loop through input tape
   do 400 nj=1,npass
   ! clear b(i)
   do j=1,nsiza
      b(j)=0
   enddo
   call repoz(nscrt1)
  220 continue
   call contio(nscrt1,0,0,e(1),nb,nwds)
   nl=l1h
   if (math.eq.0) go to 300
   if (mfh.eq.0.or.mth.eq.0) go to 220
   if (mfh.eq.6) go to 225
   call tosend(nscrt1,0,0,e(1))
   go to 220
  225 continue
   if (mfh.ne.6) go to 220
   ! check for end of block
   if (ng2z.ge.ngps) go to 405
   if (jlz.gt.maxord) go to 405
   ! check mt number
   go to (230,240,250,260),i
   ! inelastic
  230 if (mth.eq.2.or.mth.eq.16) go to 220
   if (mth.ge.6.and.mth.le.9) go to 220
   if (mth.ge.46.and.mth.le.49) go to 220
   if (mth.eq.18.or.mth.eq.19.or.mth.eq.20.or.mth.eq.21.or.mth.eq.38)&
    go to 220
   if (lord1.lt.1) lord1=1
   go to 270
   ! elastic
  240 continue
   if (mth.gt.2) go to 300
   lord1=1
   go to 270
   ! (n,2n)
  250 continue
   if (mth.gt.49) go to 300
   if (mth.lt.6) go to 220
   if (mth.gt.9.and.mth.lt.46.and.mth.ne.16) go to 220
   if (lord1.lt.1) lord1=1
   go to 270
   ! total
  260 continue
   if (mth.eq.18.or.mth.eq.19.or.mth.eq.20.or.mth.eq.21.or.mth.eq.38)&
    go to 220
   if (lord1.lt.1) lord1=1
   go to 270

   !--rearrange matrix elements
  270 continue
   ieof=0
   call shuffl(b,nl)
   if (ieof.eq.1) go to 300
   go to 220

   !--calculate bandwidths and write matrix elements to nscrt2
  300 continue
   call wrtmtx(ia(1),b(1),i,nrec,irec2)
  400 continue

   !--calculate lord(n)
  405 continue
   if (ifopt.ne.2) then
      ia(4+i)=lord1
   else if (lord1.ne.0) then
      do m=1,lord1
         mn=nscmax+(maxord+1)*(i-1)+m
         ia(mn)=1
      enddo
   endif
  500 continue

   !--calculate loci
   loci=0
   if (nsblk.eq.1) then
      do l=1,nscmax
         mn=nscmax+l
         if (ia(mn).ne.0) then
            loci=loci+1
         endif
      enddo
   else
      do l=1,nscmax
         do m=1,ngps
            mn=2*nscmax+(l-1)*ngps+m
            if (ia(mn).ne.0) then
               loci=loci+1
            endif
         enddo
      enddo
   endif
   return
   end subroutine isomtx

   subroutine shuffl(a,nl)
   !--------------------------------------------------------------------
   ! Reads one entire MT file and transfers data.
   !--------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nl
   real(4)::a(*)
   ! internals
   integer::nz,ig,nb,nw,ng2,ig2lo,loc,jg1,il,ik,niloc,jg2,noloc,inl

   nl=l1h
   nz=l2h
   ig=0
   do while (ig.lt.ngps)
      call listio(nscrt1,0,0,e,nb,nw)
      ng2=l1h
      ig2lo=l2h
      ig=n2h
      loc=1+nw
      do while (nb.ne.0)
         if (loc+302.gt.maxe) call error('shuffl',&
           'size of endf input array exceeded',' ')
         call moreio(nscrt1,0,0,e(loc),nb,nw)
         loc=loc+nw
      enddo
      !--calculate lord1
      if (nl.gt.lord1) then
         lord1=nl
         if (lord1.gt.maxord+1) lord1=maxord+1
      endif
      jg1=ngps+1-ig
      !--step through the input record
      do il=1,nl
         if (il.le.maxord+1) then
            do ik=2,ng2
               niloc=6+il+nz*nl*(ik-1)
               jg2=ngps+1-(ig2lo+ik-2)
               !--calculate noloc, the corresponding
               !--word in the output matrix
               !--ifopt=1
               if (ifopt.eq.1) then
                  noloc=irsize+(maxord+1)*(jg2*(jg2-1)-ng2z&
                    *(ng2z+1))/2+(il-1)*jg2+jg2-jg1+1
               !--ifopt=2     nsblk=1
               else if (nsblk.eq.1) then
                  noloc=irsize+(jg2-jg1)+(jg2*(jg2-1))/2+&
                    ((il-jlz-1)*ngps*(ngps+1))/2+1
               !--ifopt=2     nsblk=ngps
               else
                  inl=jlz+1
                  if (inl.ge.il) then
                     noloc=irsize+1+(jg2-jg1)+(jg2*(jg2-1)&
                       -ng2z*(ng2z+1))/2
                  else
                     noloc=irsize+1+(jg2-jg1)+(jg2*(jg2-1))/2+&
                       ((il-inl)*ngps*(ngps+1)-ng2z*(ng2z+1))/2
                  endif
               endif
               if (noloc.gt.irsize.and.noloc.le.nsiza) then
                  a(noloc)=a(noloc)+e(niloc)
               endif
            enddo
         endif
      enddo
   enddo
   return
   end subroutine shuffl

   subroutine wrtmtx(ia,a,i,nrec,irec2)
   !--------------------------------------------------------------------
   ! Calculates bandwidths and writes matrix elements to nscrt2.
   !--------------------------------------------------------------------
   ! externals
   integer::i,nrec,irec2
   integer(4)::ia(*)
   real(4)::a(*)
   ! internals
   integer::nzero,nupp,nrc,nlow,nrnge,inc,jg,jg2,ibw,nrd,noloca
   integer::jbloc,lord,ndex,mdex,jj,loc,jm,jk,lout,lin,nwds,inl
   integer::narc,ltst,ii
   real(kr),parameter::eps=1.e-10_kr

   nzero=irsize
   if (ifopt.eq.2) go to 225

   !--ifopt=2, nsblk=ngps (calculate only pzero bandwidths)
   nupp=nzero
   do 210 nrc=1,nrec
   if (nsblk.eq.1) go to 561
   nlow=nupp+1
   if ((ng2z+nrc).gt.nsblk) go to 210
   nrnge=(maxord+1)*(ng2z+nrc)
   go to 562
  561 continue

   !--ifopt=1, nsblk=1
   nlow=nzero+1
   nrnge=(ngps*(ngps+1)*(maxord+1))/2
  562 continue
   nupp=nlow+nrnge-1
   inc=(ngps-1)/nsblk+1
   do jg=1,inc
      jg2=ng2z+(nrc-1)+jg
      ibw=0
      do nrd=1,jg2
         noloca=nlow+(nrd-1)+((maxord+1)*jg*(jg-1))/2
         if (abs(a(noloca)).ge.eps) then
            ibw=nrd
         endif
      enddo
      jbloc=2*nscmax+jg2+(i-1)*ngps
      ia(jbloc)=ibw
   enddo

   !--thin and copy matrix records
   lord=maxord+1
   ndex=nlow-1
   mdex=ndex
   do jg=1,inc
      jj=ng2z+(nrc-1)+jg
      loc=2*nscmax+(i-1)*ngps+jj
      ibw=ia(loc)
      if (ibw.gt.0) then
         do jm=1,lord
            do jk=1,ibw
               lout=ndex+(jm-1)*ibw+jk
               lin=mdex+(jm-1)*jj+jk
               a(lout)=a(lin)
            enddo
         enddo
         ndex=lout
      endif
      mdex=mdex+jj*lord
   enddo
   nwds=ndex-nlow+1
   if (nwds.gt.0) then
      irec2=irec2+1
      write(nscrt2)(a(nlow+ii-1),ii=1,nwds)
   endif
  210 continue
   ng2z=ng2z+nrec
   jlz=0
   go to 300
  225 continue
   if (nsblk.gt.1) go to 250

   !--ifopt=2, nsblk=1
   do nrc=1,nrec
      nlow=nzero+1+((nrc-1)*ngps*(ngps+1))/2
      nrnge=(ngps*(ngps+1))/2
      nupp=nlow+nrnge-1
      do jg2=1,ngps
         ibw=0
         do nrd=1,jg2
            noloca=nlow-1+nrd+(jg2*(jg2-1))/2
            if (abs(a(noloca)).ge.eps) then
               ibw=nrd
            endif
         enddo
         jbloc=2*nscmax+(i-1)*ngps*(maxord+1)+(nrc+jlz-1)*ngps+jg2
         ia(jbloc)=ibw
      enddo

      !--thin and copy matrix records
      lord=1
      ndex=nlow-1
      mdex=ndex
      do jj=1,ngps
         loc=2*nscmax+(i-1)*ngps*(maxord+1)+(nrc+jlz-1)*ngps+jj
         ibw=ia(loc)
         if (ibw.gt.0) then
            jm=1
            do jk=1,ibw
               lout=ndex+(jm-1)*ibw+jk
               lin=mdex+(jm-1)*jj+jk
               a(lout)=a(lin)
            enddo
            ndex=lout
         endif
         mdex=mdex+jj*lord
      enddo
      nwds=ndex-nlow+1
      if (nwds.gt.0) then
         irec2=irec2+1
         write(nscrt2)(a(nlow+ii-1),ii=1,nwds)
      endif
   enddo
   ng2z=0
   jlz=jlz+nrec
   go to 300
  250 continue

   !--ifopt=2, nsblk=ngps
   inl=1
   nupp=nzero
   nrnge=ng2z+1
   narc=nrec*(maxord+1)
   do 290 nrc=1,narc
   jg2=nrc+ng2z-(inl-1)*ngps
   if (jg2.le.ngps) go to 260
   jg2=jg2-ngps
   inl=inl+1
   ! do not write beyond the end of the scattering matrix
   ltst=jlz+inl-maxord-1
   if (ltst.gt.0) jlz=maxord+1
   if (jlz.gt.maxord) go to 300
  260 continue
   nlow=nupp+1
   nrnge=jg2
   nupp=nlow+nrnge-1
   if (nupp.le.nsiza) go to 270
   jlz=jlz+inl-1
   ng2z=jg2-1
   if (ng2z.le.0) ng2z=ngps
   go to 300
  270 continue
   ibw=0
   do nrd=1,jg2
      noloca=nlow+nrd-1
      if (abs(a(noloca)).ge.eps) then
         ibw=nrd
      endif
   enddo
   jbloc=2*nscmax+(i-1)*ngps*(maxord+1)+(jlz+inl-1)*ngps+jg2
   ia(jbloc)=ibw

   !--thin and copy matrix records
   lord=1
   ndex=nlow-1
   mdex=ndex
   jj=jg2
   loc=2*nscmax+(i-1)*ngps*(maxord+1)+(jlz+inl-1)*ngps+jj
   ibw=ia(loc)
   if (ibw.gt.0) then
      jm=1
      do jk=1,ibw
         lout=ndex+(jm-1)*ibw+jk
         lin=mdex+(jm-1)*jj+jk
         a(lout)=a(lin)
      enddo
      ndex=lout
   endif
   mdex=mdex+jj*lord
   nwds=ndex-nlow+1
   if (nwds.gt.0) then
      irec2=irec2+1
      write(nscrt2)(a(nlow+ii-1),ii=1,nwds)
   endif
  290 continue
  300 continue
   return
   end subroutine wrtmtx

   subroutine pisotx(n4)
   !--------------------------------------------------------------------
   ! Controls printing of the ISOTXS file.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides error,a10,repoz
   ! externals
   integer::n4
   ! internals
   integer::i,irec1,nwds,iver,ngroup,niso,ichist,nscmax,nsblok
   integer::j,next,npt,jread,l,ichi,ifis,ialf,inp,in2n,ind,int
   integer::ltot,ltrn,istrpd,l1,l2,j1,iblk,jblk,mblk,k,nblk,n
   integer::ntype,idsct,lonow,lordn,kmax,inc,ii,lordn1,jl,ju,jj
   integer::ndn,jk,np,lll,ip,ip1,ip2,jk1ip,nwh,llr,nwr,lli,nwi,nn
   real(kr)::ad
   character(8)::hn,hu,hs,hblock
   integer::ird(10)
   character(6)::htype(20)
   character(10)::field(10)
   character(6)::htotal=' total'
   character(6)::helas='elastc'
   character(6)::hinel='inelas'
   character(6)::hn2n='   n2n'
   character(6)::hstrpl=' strpl'
   character(6)::hsttpl='stotpl'
   character(6)::hsngam=' sngam'
   character(6)::hsfis='  sfis'
   character(6)::hsnutt='snutot'
   character(6)::hchiso=' chiso'
   character(6)::hsnalf=' snalf'
   character(6)::hsnp='   snp'
   character(6)::hsn2n='  sn2n'
   character(6)::hsnd='   snd'
   character(6)::hsnt='   snt'
   character(6)::hingp='in gp '
   character(6)::houtgp='out gp'
   character(6)::hblank='      '
   character(6)::horder=' order'
   character(6)::hundl='------'
   integer::m1=1
   integer::izero=0
   do i=1,10
      ird(i)=1
   enddo
   irec1=0
   call repoz(-n4)

   !--file identification
   nwds=1+3*mult
   irec1=irec1+1
   read(n4)(ha(i),i=1,3),ia(nwds)
   hn=ta(1)
   hu=ta(2)
   hs=ta(3)
   iver=ia(nwds)
   write(nsyso,'(/'' ***file '',a6,'' -- version'',i3,&
     &'' -- unit'',i3,''***'')') hn,iver,n4
   write(nsyso,'('' **user identification**'',a6,3x,a6)') hu,hs

   !--file control
   irec1=irec1+1
   read(n4)(ia(i),i=1,8)
   ngroup=ia(1)
   niso=ia(2)
   ichist=ia(6)
   nscmax=ia(7)
   nsblok=ia(8)
   if (ird(1).eq.1) write(nsyso,'(/&
     &'' file control parameters''//&
     &''  ngroup    number of energy groups in set         '',i12/&
     &''  niso      number of isotopes in set              '',i12/&
     &''  maxup     maximum number of upscatter groups     '',i12/&
     &''  maxdn     maximum number of downscatter groups   '',i12/&
     &''  maxord    maximum scattering order               '',i12/&
     &''  ichist    set fission spectrum flag              '',i12/&
     &14x,''ichist=1'',7x,''set vector''/&
     &20x,''=ngroup, set matrix''/&
     &''  nscmax    maximum number of blocks of            '',i12/&
     &14x,''scattering data''/&
     &''  nsblok    blocking control for scattering data   '',i12)')&
     (ia(i),i=1,8)

   !--file data
   nwh=12+niso
   llr=nwh*mult
   nwr=1+ngroup*(2+ichist*(2/(ichist+1)))
   lli=llr+nwr
   nwi=niso
   nwds=mult*nwh+nwr+nwi
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pisotx','input record too large.',' ')
   read(n4)(ha(i),i=1,nwh),(a(llr+i),i=1,nwr),(ia(lli+i),i=1,nwi)
   if (ird(2).eq.1) then
      write(nsyso,'(/1x,12a6)') (ta(i),i=1,12)
      write(nsyso,'(/4x,''isotope'',4x,''name'')')
      do i=1,niso
         j=12+i
         write(nsyso,'(6x,i3,6x,a6)') i,ta(j)
      enddo
      next=(12+niso)*mult+1
      if (ichist.eq.1) then
         write(nsyso,'(/'' fission spectrum'')')
         call wot(a(next),ichist,ngroup,m1,hingp,houtgp,hblank,nsyso)
         next=next+ngroup*ichist
      endif
      write(nsyso,'(/11x,''neutron velocity'',9x,''upper energy''/&
        &'' group'',13x,''(cm/sec)'',17x,''(ev)''//)')
      write(nsyso,'(1x,i5,1p,2e21.6)')&
        (j,a(next-1+j),a(next-1+ngroup+j),j=1,ngroup)
      next=next+2*ngroup
      write(nsyso,'(27x,1p,e21.6)') a(next)
      next=next+1
      write(nsyso,'(/'' number of records to be skipped''//&
        &5x,''isotope'',2x,''number'')')
      do i=1,niso
         write(nsyso,'(i10,i8)') i,ia(next+i-1)
      enddo
   endif

   !--set chi data
   if (ichist.gt.1) then
      nwr=ngroup*ichist
      nwi=ngroup
      nwds=nwr+nwi
      npt=1
      llr=npt-1
      lli=llr+nwr
      irec1=irec1+1
      if (nwds.ge.isiza4)&
        call error('pisotx','input record too large.',' ')
      read(n4)(a(llr+i),i=1,nwr),(ia(lli+i),i=1,nwi)
      if (ird(3).eq.1) then
         write(nsyso,'(/'' set fission spectrum'')')
         call wot(a(1),ichist,ngroup,m1,hingp,houtgp,hblank,nsyso)
      endif
   endif

   !--isotope control and group independent data
   do 220 i=1,niso
   nwh=3
   llr=mult*nwh
   nwr=6
   lli=llr+nwr
   nwi=11+2*nscmax+2*ngroup*nscmax
   nwds=mult*nwh+nwr+nwi
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pisotx','input record too large.',' ')
   read(n4)(ha(j),j=1,nwh),(a(llr+j),j=1,nwr),(ia(lli+j),j=1,nwi)
   jread=1+nwds
   l=3*mult+7
   ichi=ia(l+1)
   ifis=ia(l+2)
   ialf=ia(l+3)
   inp=ia(l+4)
   in2n=ia(l+5)
   ind=ia(l+6)
   int=ia(l+7)
   ltot=ia(l+8)
   ltrn=ia(l+9)
   istrpd=ia(l+10)
   if (ird(4).eq.1) then
      write(nsyso,'(/'' isotope'',i3)') i
      l1=3*mult
      l2=l1+6
      write(nsyso,'(/&
        &'' isotope control parameters''//&
        &''  habsid  absolute isotope label'',26x,a6/&
        &''  hident  library identifier'',30x,a6/&
        &''  hmat    isotope identification'',26x,a6/&
        &''  amass   gram atomic weight'',24x,1p,e12.5/&
        &''  efiss   thermal energy/fission (w*sec/fiss)'',7x,e12.5/&
        &''  ecapt   thermal energy/capture (w*sec/capt)'',7x,e12.5/&
        &''  temp    isotope temperature (deg k)'',15x,e12.5/&
        &''  sigpot  ave. potential scattering (barns/atom)'',&
        &4x,e12.5/&
        &''  adens   reference atom density (a/b*cm)'',11x,e12.5/&
        &''  kbr     isotope classification'',20x,i12/&
        &''  ichi    fission spectrum flag'',&
        &'' (0/1/n=set chi/vector/matrix)'',i3)')&
        (ta(j),j=1,3),(a(l1+j),j=1,6),(ia(l2+j),j=1,2)
      l1=l2+2
      write(nsyso,'(&
        &''  ifis    (n,f) x-sec flag (0/1=no/yes)'',13x,i12/&
        &''  ialf    (n,a) x-sec flag (0/1=no/yes)'',13x,i12/&
        &''  inp     (n,p) x-sec flag (0/1=no/yes)'',13x,i12/&
        &''  in2n    (n,2n) x-sec flag (0/1=no/yes)'',12x,i12/&
        &''  ind     (n,d) x-sec flag (0/1=no/yes)'',13x,i12/&
        &''  int     (n,t) x-sec flag (0/1=no/yes)'',13x,i12/&
        &''  ltot    number of total x-sec moments'',13x,i12/&
        &''  ltrn    number of transport x-sec moments'',9x,i12/&
        &''  istrpd  number of transport x-sec directions'',i18/)')&
        (ia(l1+j),j=1,9)
      l1=l1+9
      write(nsyso,&
        '(1x,''block'',5x,''type'',4x,''ident'',3x,''orders''/)')
      do j=1,nscmax
         read(htotal,'(a6)') htype(j)
         if (ia(l1+j).ge.100) read(helas,'(a6)') htype(j)
         if (ia(l1+j).ge.200) read(hinel,'(a6)') htype(j)
         if (ia(l1+j).ge.300) read(hn2n,'(a6)') htype(j)
      enddo
      write(nsyso,'(1x,i5,3x,a6,2i9)')&
        (j,htype(j),ia(l1+j),ia(l1+nscmax+j),j=1,nscmax)
      j1=l1+2*nscmax
      write(nsyso,'(/&
        &'' scattering bandwidth and in-group'',&
        &'' scattering position'')')
      iblk=(nscmax+1)/10+1
      jblk=nscmax/iblk+1
      mblk=1
      do k=1,iblk
         nblk=mblk+jblk-1
         if (nblk.gt.nscmax) nblk=nscmax
         write(nsyso,'(/'' group/block'',3x,20i5)')&
           (j,j=mblk,nblk),(j,j=mblk,nblk)
         do n=1,ngroup
            write(nsyso,'(1x,i5,9x,20i5)')&
              n,(ia(j1+j*ngroup-ngroup+n),j=mblk,nblk),&
              (ia(j1+ngroup*nscmax+j*ngroup-ngroup+n),j=mblk,nblk)
         enddo
         mblk=nblk+1
      enddo
   endif

   !--principal cross sections
   nwds=(1+ltrn+ltot+ialf+inp+in2n+ind+int+istrpd+2*ifis+&
     ichi*(2/(ichi+1)))*ngroup
   irec1=irec1+1
   read(hstrpl,'(a6)') htype(1)
   read(hsttpl,'(a6)') htype(2)
   read(hsngam,'(a6)') htype(3)
   j=4
   if (ifis.gt.0) read(hsfis,'(a6)') htype(j)
   if (ifis.gt.0) read(hsnutt,'(a6)') htype(j+1)
   if (ifis.gt.0) j=j+2
   if (ichi.eq.1) read(hchiso,'(a6)') htype(j)
   if (ichi.eq.1) j=j+1
   if (ialf.eq.1) read(hsnalf,'(a6)') htype(j)
   if (ialf.eq.1) j=j+1
   if (inp.eq.1) read(hsnp,'(a6)') htype(j)
   if (inp.eq.1) j=j+1
   if (in2n.eq.1) read(hsn2n,'(a6)') htype(j)
   if (in2n.eq.1) j=j+1
   if (ind.eq.1) read(hsnd,'(a6)') htype(j)
   if (ind.eq.1) j=j+1
   if (int.eq.1) read(hsnt,'(a6)') htype(j)
   if (nwds.ge.isiza4)&
     call error('pisotx','input record too large.',' ')
   read(n4)(a(jread+k-1),k=1,nwds)
   if (ird(5).eq.1) then
      write(nsyso,'(/'' principal cross-sections'')')
      ntype=nwds/ngroup
      iblk=(ntype-1)/8+1
      jblk=ntype/iblk+1
      mblk=1
      do k=1,iblk
         nblk=mblk+jblk-1
         if (nblk.gt.ntype) nblk=ntype
         write(nsyso,'(/'' group'',9(3x,a8,''  ''))')&
           (htype(j),j=mblk,nblk)
         do n=1,ngroup
            write(nsyso,'(1x,i3,2x,1p,9e13.6)')&
              n,(a(jread-1+n+j*ngroup-ngroup),j=mblk,nblk)
         enddo
         mblk=nblk+1
      enddo
   endif

   !--isotope chi data
   if (ichi.gt.1) then
      nwr=ngroup*ichi
      nwi=ngroup
      nwds=nwr+nwi
      npt=jread
      llr=npt-1
      lli=llr+nwr
      irec1=irec1+1
      if (nwds.ge.isiza4)&
         call error('pisotx','input record too large.',' ')
      read(n4)(a(llr+i),nn=1,nwr),(ia(lli+nn),nn=1,nwi)
      if (ird(6).eq.1) then
         write(nsyso,'('' isotope fission spectrum'')')
         call wot(a(jread),ichi,ngroup,m1,hingp,houtgp,hblank,nsyso)
      endif
   endif

   !--scattering cross sections
   write(nsyso,'(/'' scattering matrices'')')
   do 221 n=1,nscmax
   k=n+3*mult+17
   idsct=ia(k)
   idsct=idsct/100
   lonow=ia(k)-100*idsct
   k=k+nscmax
   lordn=ia(k)
   idsct=idsct+1
   if (idsct.eq.1) then
      read(htotal,'(a6)') hblock
   else if (idsct.eq.2) then
      read(helas,'(a6)') hblock
   else if (idsct.eq.3) then
      read(hinel,'(a6)') hblock
   else
      read(hn2n,'(a6)') hblock
   endif
   if (lordn.ne.0) go to 160
   write(nsyso,'(/'' no data for '',a6,''  p'',i1)') hblock,lonow
   go to 221
  160 continue
   kmax=0
   k=3*mult+17+2*nscmax+(n-1)*ngroup
   inc=(ngroup-1)/nsblok+1
   npt=jread
   kmax=0
   if (lonow.eq.0) write(nsyso,&
     '(/'' matrix ** '',a6,'' **'')') hblock
   if (lonow.gt.0) write(nsyso,&
     '(/'' matrix ** '',a6,'' ** p'',i1)') hblock,lonow
   if (lordn.eq.1) write(nsyso,'(/&
     &''  final  initl    xsec vs initl group''/&
     &''  group  group'',5x,&
     &''-0'',10x,''-1'',10x,''-2'',10x,''-3'')')
   if (lordn.eq.1) write(nsyso,'(''  -----  -----  '',9(2a6))')&
     (hundl,hundl,ii=1,5)
   lordn1=lordn-1
   if (lordn.gt.1) write(nsyso,'(/&
     &''  final  initl    xsec vs legendre order''/&
     &''  group  group'',4x,9(a6,1x,i1,4x))')&
     (horder,ii,ii=izero,lordn1)
   if (lordn.gt.1) write(nsyso,'(''  -----  -----  '',9(2a6))')&
     (hundl,hundl,ii=1,lordn)
   do 180 j=1,nsblok
   jl=(j-1)*inc+1
   ju=j*inc
   nwds=0
   do jj=jl,ju
      l=k+jj
      nwds=nwds+ia(l)
      kmax=ia(l)+kmax
   enddo
   nwds=nwds*lordn
   if (nwds.eq.0) go to 180
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pisotx','input record too large.',' ')
   read(n4)(a(npt+ii-1),ii=1,nwds)
   if (ird(7).ne.1) go to 180
   ndn=npt
   do 175 jj=jl,ju
   l=k+jj
   nwds=lordn*ia(l)
   if (nwds.eq.0) go to 175
   jk=j+jj/jl-1
   np=ia(l)
   if (lordn.gt.1) go to 178
   lll=ndn-1
   ip=1
   ip1=ip
  171 continue
   if (a(lll+ip1).ne.0.) go to 172
   ip1=ip1+1
   if (ip1.gt.np) go to 176
   go to 171
  172 continue
   ip2=ip1+5
   if (ip2.gt.np) ip2=np
  173 continue
   if (a(lll+ip2).ne.0.) go to 174
   ip2=ip2-1
   if (ip2.eq.ip1) go to 174
   go to 173
  174 continue
   jk1ip=jk+1-ip1
   do ii=ip1,ip2
      ad=a(lll+ii)
      call a10(ad,field(ii-ip1+1))
   enddo
   if (ip.eq.1) write(nsyso,'(3x,i3,4x,i3,2x,1p,9a12)')&
     jk,jk1ip,(field(ii),ii=1,ip2-ip1+1)
   if (ip.gt.1) write(nsyso,'(10x,i3,2x,1p,9a12)')&
     jk1ip,(field(ii),ii=1,ip2-ip1+1)
   ip=ip+1
   ip1=ip2+1
   if (ip1.le.np) go to 171
  176 continue
   ndn=ndn+nwds
   go to 175
  178 continue
   ip1=1
   do 179 ip=1,np
   lll=ndn-1+ip-np
   do 181 ii=1,lordn
   if (a(np*ii+lll).ne.0.) go to 182
  181 continue
   go to 179
  182 continue
   jk1ip=jk+1-ip
   do ii=1,lordn
      ad=a(np*ii+lll)
      call a10(ad,field(ii))
   enddo
   if (ip1.eq.1) write(nsyso,'(3x,i3,4x,i3,2x,1p,9a12)')&
     jk,jk1ip,(field(ii),ii=1,lordn)
   if (ip1.gt.1) write(nsyso,'(10x,i3,2x,1p,9a12)')&
     jk1ip,(field(ii),ii=1,lordn)
   ip1=ip1+1
  179 continue
   ndn=ndn+nwds
  175 continue
  180 continue
  221 continue
  220 continue
   return
   end subroutine pisotx

   subroutine cbrkxs
   !--------------------------------------------------------------------
   ! Write a CCCC-IV BRKOXS interface file.
   !--------------------------------------------------------------------
   use util ! provides repoz
   ! internals
   integer::nwds,irec,l1h,ngps,nisosh,nsigpt,ntempt,nreact
   integer::iblk,l3,l4,irec3,i,loc,jbl,jbh,ntap,ntat,nblok
   integer::ml,mu,j,l3h,nwh,l3r,nwr,l3i,nwi,k
   character(6)::hname='brkoxs'

   !--set first pointer
   nwds=3*mult+1+6
   next=1
   l1=next
   next=l1+nwds
   next=next+1
   irec=0

   !--read user input
   call ruinbr

   !--create and write brkoxs data sets on scratch tapes
   call brkdat

   !--file identification
   nwds=3*mult+1
   l1h=(l1-1)/mult+1
   read(hname,'(a6)') ta(l1h)
   ha(l1h+1)=huse(1)
   ha(l1h+2)=huse(2)
   ia(3*mult+l1)=ivers
   irec=irec+1
   call repoz(-nbrks)
   write(nbrks)(ha(i),i=1,3),ia(nwds)

   !--file control
   l2=l1+3*mult+1
   ngps=ia(l2)
   nisosh=ia(l2+1)
   nsigpt=ia(l2+2)
   ntempt=ia(l2+3)
   nreact=ia(l2+4)
   iblk=ia(l2+5)
   irec=irec+1
   write(nbrks)(ia(l2-1+i),i=1,6)

   !--file data
   l3=l2+6
   l3=l3+1
   l3h=(l3-1)/mult
   nwh=mult*nisosh
   l3r=l3+mult*nwh-1
   nwr=nsigpt+ntempt+ngps+1
   l3i=l3r+nwr
   nwi=4*nisosh
   nwds=mult*nwh+nwr+nwi
   irec=irec+1
   write(nbrks)(ha(l3h+i),i=1,nwh),(a(l3r+i),i=1,nwr),&
     (ia(l3i+i),i=1,nwi)
   l4=l3+nwds

   !--loop over isotopes
   irec3=0
   call repoz(-nscrt3)
   do i=1,nisosh

      !--self-shielding factors
      loc=l3+mult*nisosh+nsigpt+ntempt+ngps+1+i-1
      jbl=ia(loc)
      jbh=ia(loc+nisosh)
      ntap=ia(loc+2*nisosh)
      ntat=ia(loc+3*nisosh)
      if (iblk.eq.0) then
         nblok=1
         ml=1
         mu=nreact
      else
         nblok=nreact
         ml=1
         mu=1
      endif
      nwds=ntap*ntat*(jbh-jbl+1)*(mu-ml+1)
      do j=1,nblok
         irec3=irec3+1
         read(nscrt3)(a(l4+k-1),k=1,nwds)
         irec=irec+1
         write(nbrks)(a(l4+k-1),k=1,nwds)
      enddo

      !--cross sections
      nwds=6*ngps
      irec3=irec3+1
      read(nscrt3)(a(l4+j-1),j=1,nwds)
      irec=irec+1
      write(nbrks)(a(l4+j-1),j=1,nwds)
   enddo
   next=l1
   return
   end subroutine cbrkxs

   subroutine ruinbr
   !--------------------------------------------------------------------
   ! Reads user input pertinent to the BRKOXS file.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! internals
   integer::i

   !--read sig0 and temperature data
   read(nsysi,*) nti,nzi
   nreact=6
   if (nti.gt.0) read(nsysi,*) (atem(i),i=1,nti)
   if (nzi.gt.0) read(nsysi,*) (asig(i),i=1,nzi)
   end subroutine ruinbr

   subroutine brkdat
   !--------------------------------------------------------------------
   ! Processes all BRKOXS data and writes on scratch tape.
   ! Data stored in a(i) as follows
   !
   ! location               variable                 length
   ! --------               --------                 ------
   !    l1                  *brkoxs*                  mult
   !                         huse(1)                  mult
   !                         huse(2)                  mult
   !                         ivers                       1
   !                         ngroup                      1
   !                         niso                        1
   !                         nsigpt                      1
   !                         ntempt                      1
   !                         nreact                      1
   !                         iblk                        1
   !                         dummy                       1
   !    l9                   hisonm              niso*mult
   !    l10                  emax                   ngroup
   !    l11                  emin                        1
   !    l12                   jbfl                    niso
   !    l13                   jbfh                    niso
   !    l14                  ntabp                    niso
   !    l15                  ntabt                    niso
   !    l16                    x                  niso*nzj
   !    l17                    tb                 niso*ntj
   !    l18               input record                  -
   !    l19      infinite dilution cross section 13*ngroup
   !    l20          self shielding factors             -
   !
   !--------------------------------------------------------------------
   use util ! provides repoz,error,mess
   use endf ! provides endf routines and variables
   ! internals
   integer::ntl,nzl,i,nwds,l9,l10,l11,nwords,l12,l14,l15,l16,l17,l18
   integer::nb,nw,nz,lz,nt,ntw,ngpn,loc,iqd,nenpts,l19,l20,nosize
   integer::iffile,inv,jiso,irec2,j,nrec,nlines,iin,nwl,k,lcsg0
   integer::l,itzro,jj,nwd,locsg0,locsg,mtc,nwon,nrnge,iv,noloc
   integer::ndex,nzf,jz,mdex,ntf,jt,irec3
   real(kr)::c,abe,test,amd
   integer::imusd(200),ntabt(200),ntabp(200)
   character(60)::strng
   real(kr),parameter::eps=1.e-04_kr
   real(kr),parameter::eps2=1.e-10_kr

   !--file data
   ia(l1+3*mult+1)=ngps
   ia(l1+3*mult+2)=niso
   ia(l1+3*mult+5)=nreact
   ntl=iabs(nti)
   nzl=iabs(nzi)
   do i=1,20
      item(i)=0
      isig(i)=0
   enddo

   !--assign pointers
   nwds=mult*niso
   l9=next
   l10=l9+nwds
   l11=l10+ngps
   nwords=1
   l12=l11+nwords
   l13=l12+niso
   l14=l13+niso
   l15=l14+niso
   l16=l15+niso
   nwds=niso*nzl
   l17=l16+nwds
   nwds=niso*ntl
   next=l17+nwds
   l18=next

   !--process header for first material
   call repoz(nin)
   call tpidio(nin,0,0,e(1),nb,nw)
  100 continue
   call contio(nin,0,0,e(1),nb,nw)
   if (mfh.eq.0.or.mth.eq.0) go to 100
   nz=l2h
   lz=6
   nt=n2h
   ntw=nt
   call listio(nin,0,0,e(1),nb,nw)
   ngpn=l1h
   loc=l1+3*mult+1
   if (ngpn.ne.ia(loc))&
     call error('brkdat','incompatible group structures.',' ')
   loc=1+nw
   do while (nb.ne.0)
      if (loc+302.gt.maxe) call error('brkdat',&
        'max size of endf record exceeded',' ')
      call moreio(nin,0,0,e(loc),nb,nw)
      loc=loc+nw
   enddo
   iqd=1+lz+ntw+nz+ngpn
   ! reorder group bounds, store in a(l10)
   nenpts=ngpn+1
   do i=1,nenpts
      a(i-1+l10)=e(-i+1+iqd)
   enddo

   !--more pointers
   irsize=200
   irsize=(maxord+1)*(ngpn+1)*7+100
   if (irsize.gt.2000) irsize=2000
   next=l18+irsize
   nwds=(13+nzl)*ngps
   l19=next
   next=l19+nwds
   l20=next

   !--determine sub blocking for self shielding file
   !--nosize--space available in a(i) for output file
   !--iffile--length of entire self shielding file
   !--nsblk--number of s-s records to be written on scratch tape
   !--lrsize--length of one s-s record
   nosize=isiza4-l20+1
   iffile=nreact*ngpn*ntl*nzl
   nsblk=1
   if (iffile.gt.nosize) nsblk=nreact
   lrsize=iffile/nsblk
   inv=nreact/nsblk
   if (nsblk.gt.1) ia(l1+3*mult+6)=1
   if (nsblk.eq.1) ia(l1+3*mult+6)=0

   !--begin isotope loop
   do i=1,200
      imusd(i)=0
   enddo
   ia(l1+3*mult+3)=0
   ia(l1+3*mult+4)=0
   jiso=0
   irec3=0
   call repoz(-nscrt3)
   do 370 i=1,niso
   call repoz(nin)
   irec2=0
   call repoz(-nscrt2)
   jbl=ngpn
   jbh=0
   do j=l18,isiza4
      a(j)=0
   enddo
   do j=1,10
      mt2tem(j)=0
   enddo
   ntfl=0
   ! find a desired mat on nin file tape
   call tpidio(nin,0,0,e(1),nb,nw)
  150 continue
   call contio(nin,0,0,e(1),nb,nw)
   if (mfh.eq.0.or.mth.eq.0) go to 150
   if (math.eq.-1) go to 180
   nrec=1
   nlines=1
   do 170 j=1,niso
   if (math.ne.imat(j)) go to 170
   if (imusd(j).eq.1) go to 170
   nt=n2h
   ntw=nt
   iin=j
   matd=imat(j)
   xspo=xspot(j)
   imusd(j)=1
   nzj=0
   nzt=l2h
   call listio(nin,0,0,e(1),nb,nw)
   nwl=nint(e(5))
   nlines=nlines+(nwl+5)/6
   nrec=nrec+1
   loc=1+nw
   do while (nb.ne.0)
      if (loc+302.gt.maxe) call error('brkdat',&
        'max size of endf record exceeded',' ')
      call moreio(nin,0,0,e(loc),nb,nw)
      nrec=nrec+1
      loc=loc+nw
   enddo
   ! check which values of sig0 are present
   do 165 k=1,nzt
   lcsg0=6+ntw+k
   if (nzi.lt.0) go to 160
   do 156 l=1,nzl
   c=abs(asig(l)-e(lcsg0))
   if (c.le.eps*asig(l)) go to 160
  156 continue
   go to 165
  160 continue
   nzj=nzj+1
   isig(nzj)=k
   csig(nzj)=e(lcsg0)
  165 continue
   go to 190
  170 continue
   call tomend(nin,0,0,e(1))
   go to 150
  180 continue
   call mess('brkdat','all available mats have been processed',' ')
   go to 450
  190 continue
   call repoz(nscrt1)
   nsh=1
   ! copy desired temperatures to nscrt1
   if (nin.gt.0) nrec=nlines+1
   call skiprz(nin,-nrec)
   ntj=0
   itzro=0
   do 250 k=1,ntl
  210 continue
   call contio(nin,0,0,e(1),nb,nw)
   if (math.ne.matd) go to 255
   call listio(nin,0,0,e(1),nb,nw)
   loc=1+nw
   do while (nb.ne.0)
      if (loc+302.gt.maxe) call error('brkdat',&
        'max size of endf record exceeded',' ')
      call moreio(nin,0,0,e(loc),nb,nw)
      loc=loc+nw
   enddo
   if (itzro.gt.0) go to 235
   tzro=c1h
   itzro=1
   call tofend(nin,0,0,e(1))
   call tomend(nin,nscrt1,0,e(1))
   if (nti.lt.0) go to 230
   do 225 l=1,ntl
   if (abs(atem(l)-tzro).le.eps*tzro) go to 230
  225 continue
   go to 210
  230 continue
   ntj=ntj+1
   ctem(ntj)=tzro
   item(ntj)=ntj
   go to 250
  235 continue
   if (nti.lt.0) go to 245
   do 240 l=1,ntl
   if (abs(atem(l)-c1h).le.eps*c1h) go to 245
  240 continue
   call tomend(nin,0,0,e(1))
   go to 210
  245 continue
   call tofend(nin,0,0,e(1))
   ntj=ntj+1
   ctem(ntj)=c1h
   item(ntj)=ntj
   call tomend(nin,nscrt1,0,e(1))
  250 continue
  255 continue
   call atend(nscrt1,0)
   if (ntj.gt.0) go to 260
   write(strng,'(''no temperatures for mat='',i4)') matd
   call mess('brkdat',strng,' ')
   go to 370
  260 continue
   jiso=jiso+1
   jj=(l9-1)/mult+jiso
   read(hisonm(iin),'(a6)') ta(jj)
   ia(l1+3*mult+2)=jiso
   next=l18+irsize
   nwd=(13+nzj)*ngpn
   l19=next
   next=l19+nwd
   l20=next
   do 340 nsb=1,nsblk
   call repoz(nscrt1)
  265 continue
   call contio(nscrt1,0,0,e(1),nb,nw)
   if (math.eq.-1) go to 270
   if (mfh.eq.0.or.mth.eq.0) go to 265

   !--process cross sections (mf=3)
   if (mfh.eq.3) call xsproc(a(l18),l18,l19,l20)

   !--process scattering matrix (mf=6)
   if (mfh.eq.6) call mxproc(a(l18),l18,l20)
   call tosend(nscrt1,0,0,e(1))
   go to 265
  270 continue

   !--calculate transport self-shielding factors
   if (nsblk.eq.1.or.nsb.eq.4) then
      do j=1,ngpn
         locsg0=l19-1+3*ngpn+j
         do k=1,ntj
            do l=1,nzj
               locsg=l20-1+(3/nsb)*ngpn*nzj*ntj+(j-1)*nzj*ntj&
                 +nzj*(k-1)+l
               if (a(locsg0).ge.eps2) then
                  a(locsg)=a(locsg)/a(locsg0)
               else
                  a(locsg)=1
               endif
            enddo
         enddo
      enddo
   endif

   !--check whether transport cross section properly calculated
   if (ntfl.ne.1) then
      mtc=0
      do k=1,10
         mtc=mtc+mt2tem(k)
      enddo
      if (mtc.ne.ntj) then
         call mess('brkdat',&
           'need elastic matrices at higher temperatures',' ')
      endif
   endif
   ! write data to scratch tape
   if (nsb.eq.1) then
      nwon=l19+7*ngpn
      nrnge=6*ngpn
      irec2=irec2+1
      write(nscrt2)(a(nwon+j-1),j=1,nrnge)
   endif
   do iv=1,inv
      do j=1,ngpn
         do k=1,ntj
            do l=1,nzj
               noloc=l20-1+(iv-1)*ngpn*nzj*ntj+(j-1)*ntj*nzj&
                 +(k-1)*nzj+l
               abe=abs(a(noloc))
               if (abe.lt.eps2) a(noloc)=1
               test=1
               test=test/100
               if (a(noloc).lt.test) a(noloc)=test
               if (abs(a(noloc)-1.0).ge.sstol) then
                  if (jbh.lt.j) jbh=j
                  if (jbl.gt.j) jbl=j
                  ntat(k)=1
                  ntap(l)=1
               endif
            enddo
         enddo
      enddo
   enddo
   ia(l12-1+i)=jbl
   ia(l13-1+i)=jbh
   ! write f-factors to nscrt2
   irec2=irec2+1
   write(nscrt2)(a(l20+j-1),j=1,lrsize)
  340 continue

   !--calculate isotope flags
   ntabt(i)=0
   do j=1,ntj
      if (ntat(j).ne.0) then
         ntabt(i)=ntabt(i)+1
         ndex=l17+(i-1)*ntl+ntabt(i)-1
         a(ndex)=ctem(j)
      endif
   enddo
   ntabp(i)=0
   do j=1,nzj
      if (ntap(j).ne.0) then
         ntabp(i)=ntabp(i)+1
         ndex=l16+(i-1)*nzl+ntabp(i)-1
         a(ndex)=csig(j)
      endif
   enddo
   ia(l14+i-1)=ntabp(i)
   ia(l15+i-1)=ntabt(i)

   !--thin data and write on scratch tape
   call thnwrt(a(l18),irec3)

   !--close isotope loop
  370 continue

   !--rearrange and thin file data

   !--build file data record
   nrnge=ngpn+1
   do i=1,nrnge
      a(l20+i-1)=a(l10+i-1)
      a(l10+i-1)=0
   enddo
   nrnge=4*niso
   do i=1,nrnge
      ndex=ngpn+i
      ia(l20+ndex)=ia(l10+ndex)
      ia(l10+ndex)=0
   enddo
   ! thin x and tb, and store in l10
   ndex=l10-1
   ia(l1+3*mult+3)=0
   do i=1,jiso
      nzf=ia(l20-1+ngpn+1+2*niso+i)
      do jz=1,nzf
         ndex=ndex+1
         mdex=l16+(i-1)*nzl+jz-1
         amd=a(mdex)
         a(ndex)=log10(amd)
         test=1
         test=test/100000
         if (abs(a(ndex)).lt.test) a(ndex)=0
         a(mdex)=0
         ia(l1+3*mult+3)=ia(l1+3*mult+3)+1
      enddo
   enddo
   ia(l1+3*mult+4)=0
   do i=1,jiso
      ntf=ia(l20-1+ngpn+1+3*niso+i)
      do jt=1,ntf
         ndex=ndex+1
         mdex=l17+(i-1)*ntl+jt-1
         a(ndex)=a(mdex)-273.16
         ia(l1+3*mult+4)=ia(l1+3*mult+4)+1
         a(mdex)=0
      enddo
   enddo
   ! move up remaining file data
   nrnge=ngpn+1
   do i=1,nrnge
      a(ndex+i)=a(l20+i-1)
      a(l20+i-1)=0
   enddo
   ndex=ndex+ngpn+1
   do i=1,4
      k=(i-1)*jiso
      l=ngpn+(i-1)*niso
      do j=1,jiso
         ia(j+k+ndex)=ia(j+l+l20)
         ia(j+l+l20)=0
      enddo
   enddo
  450 return
   end subroutine brkdat

   subroutine xsproc(a,l18,l19,l20)
   !--------------------------------------------------------------------
   ! Derives information needed from cross section file (MF=3)
   !--------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::l18,l19,l20
   real(4)::a(*)
   ! internals
   integer::inv,nl,nz,lz,nwon,nb,nw,jmt,ig,loc,noloc,i,isig2
   integer::none,j,itm,jg,imt,idum,locsg0,jz,locsg,locss
   character(60)::strng
   real(kr)::temp,abtm,sg0
   real(kr),parameter::eps=1.e-06_kr
   real(kr),parameter::zero=0

   inv=nreact/nsblk
   nl=l1h
   nz=l2h
   lz=6
   nwon=l19-l18+1

   !--read all records for this reaction
  120 continue
   call listio(nscrt1,0,0,e(1),nb,nw)
   temp=c1h
   abtm=abs(temp-tzro)-0.01e0_kr
   jmt=0
   ig=n2h
   loc=1+nw
   do while (nb.ne.0)
      if (loc+302.gt.maxe) call error('xsproc',&
         'max endf input record exceeded',' ')
      call moreio(nscrt1,0,0,e(loc),nb,nw)
      loc=loc+nw
   enddo

   !--store flux for this temperature
   if (mth.eq.1) then
      noloc=13*ngps+nzj*(ngps-ig)+irsize
      do i=1,nzj
         isig2=isig(i)*isig(i)
         a(i+noloc)=e(lz+isig2)
      enddo
   endif

   !--store infinite dilution cross sections in a(l19)
   ! total
   if (mth.ne.1) go to 140
   jmt=1
   if (nsb.ne.1) go to 200
   if (abtm.gt.eps*temp) go to 200
   a(nwon+ngps-ig)=e(lz+nl*nz+1)
   a(nwon+4*ngps-ig)=e(lz+nl*nz+nl)
   a(nwon+6*ngps-ig)=e(lz+nl*nz+nl)
   a(nwon+7*ngps-ig)=e(lz+nl)
   go to 200
   ! capture
  140 continue
   if (mth.ne.102) go to 150
   jmt=2
   if (nsb.ne.1) go to 200
   if (abtm.gt.eps*temp) go to 200
   a(nwon+2*ngps-ig)=e(lz+nl*nz+1)
   go to 200
   ! fission
  150 continue
    if (mth.ne.18.and.mth.ne.19.and.mth.ne.20.and.mth.ne.21&
      .and.mth.ne.38) go to 160
   if (mth.ne.18) go to 160
   jmt=3
   if (nsb.ne.1) go to 200
   if (abtm.gt.eps*temp) go to 200
   a(nwon+3*ngps-ig)=e(lz+nl*nz+1)
   go to 200
   ! elastic
  160 continue
   if (mth.ne.2) go to 180
   jmt=5
   if (nsb.ne.1) go to 200
   if (abtm.gt.eps*temp) go to 200
   a(nwon+5*ngps-ig)=e(lz+nl*nz+1)
   ! load geometric hard core scattering cross section into xspo
   a(nwon+8*ngps-ig)=xspo
   go to 200
   ! mubar
  180 continue
   if (mth.ne.251) go to 190
   if (nsb.ne.1) go to 195
   if (abtm.gt.eps*temp) go to 195
   a(nwon+11*ngps-ig)=e(lz+nl*nz+1)
   go to 195
   ! xi
  190 continue
   if (mth.ne.252) go to 192
   if (nsb.ne.1) go to 195
   if (abtm.gt.eps*temp) go to 195
   a(nwon+13*ngps-ig)=e(lz+nl*nz+1)
  192 continue
  195 continue
   if (ig.lt.ngps) go to 120

   !--calculate and store self-shielding factors
   !--(for transport cross section store sigma total)
  200 continue
   none=l20-l18+1
   do 330 j=1,ntj
   itm=j
   if (abs(temp-ctem(j)).le.eps*temp) go to 335
  330 continue
   go to 395
  335 jg=(ngps+1)-ig
   do 390 j=1,inv
   imt=j+nsb-1
   if (imt.eq.jmt) go to 340
   if (imt.eq.4.and.mth.eq.1) go to 345
   go to 390
  340 continue
   idum=1
      if (mth.eq.1.and.nl.eq.2) idum=2
      locsg0=(l19-l18)+(imt-1)*ngps+jg
      sg0=a(locsg0)
      go to 350
  345 idum=nl
      sg0=1
  350 do jz=1,nzj
      locsg=lz+nl*nz+nl*(isig(jz)-1)+idum
      if (e(locsg).ne.zero) then
         locss=(none-1)+(imt-nsb)*ntj*nzj*ngps+(jg-1)*nzj*ntj&
           +(itm-1)*nzj+jz
         if (sg0.eq.0.) then
            write(strng,'(''infinite f-factor '',3i6,1p,e12.3)')&
              mth,jg,jz,temp
            call mess('xsproc',strng,' ')
         endif
         if (sg0.ne.zero) then
            a(locss)=a(locss)+e(locsg)/sg0
         endif
      endif
   enddo
  390 continue
  395 continue
   if (ig.lt.ngps) go to 120
   return
   end subroutine xsproc

   subroutine mxproc(a,l18,l20)
   !--------------------------------------------------------------------
   ! Derives information needed from matrix file (MF=6)
   !--------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::l18,l20
   real(4)::a(*)
   ! internals
   integer::nl,nz,lz,nb,nw,ng2,ig2lo,ig,jg1,loc,j,niloc,jg2,noloc
   integer::inc,k,locsg,l,itemp,lrem
   real(kr)::temp,abtm
   real(kr),parameter::eps=1.e-6_kr

   nl=l1h
   nz=l2h
   lz=6

   !--process all records for this reaction
  120 continue
   call listio(nscrt1,0,0,e(1),nb,nw)
   temp=c1h
   abtm=abs(temp-tzro)-0.01e0_kr
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   jg1=ngps+1-ig
   loc=1+nw
   do while (nb.ne.0)
      if (loc+302.gt.maxe)&
        call error('mxproc','max endf size exceeded',' ')
      call moreio(nscrt1,0,0,e(loc),nb,nw)
      loc=loc+nw
   enddo
   if (mth.gt.91) go to 140
   if ((mth.ge.18.and.mth.le.21).or.mth.eq.38) go to 140
   if (abtm.gt.eps*temp) go to 200
   if (nsb.gt.1) go to 200

   !--complete the cross section block
   ! elastic xsec and elastic removal
   if (mth.ne.2) go to 160
   do j=2,ng2
      niloc=lz+1+nl*nz*(j-1)
      jg2=(ngps+1)-(ig2lo+j-2)
      noloc=irsize+9*ngps+jg1
      a(noloc)=a(noloc)+e(niloc)
      if (jg2.ne.jg1) then
         noloc=irsize+11*ngps+jg1
         a(noloc)=a(noloc)+e(niloc)
      endif
   enddo
   ! inelastic scattering cross section
   ! i. e., everything but elastic and n2n including multiplicity
  160 continue
   if (mth.eq.2) go to 180
   if (mth.eq.16) go to 180
   if (mth.ge.6.and.mth.le.9) go to 180
   if (mth.ge.46.and.mth.le.49) go to 180
   do j=2,ng2
      niloc=lz+1+nl*nz*(j-1)
      jg2=(ngps+1)-(ig2lo+j-2)
      noloc=irsize+8*ngps+jg1
      a(noloc)=a(noloc)+e(niloc)
   enddo
   ! transport xsec (total-p1 scattering)
  180 continue
   if (nl.lt.2) go to 200
   do j=2,ng2
      niloc=lz+1+nl*nz*(j-1)+1
      noloc=irsize+3*ngps+jg1
      a(noloc)=a(noloc)-e(niloc)
   enddo

   !--transport shielding factor
  200 continue
  if (nl.lt.2) go to 300
   inc=4
   if (nsblk.gt.1) inc=1
   if (inc+nsb.ne.5) go to 300
   if (abtm.gt.eps*temp) go to 250
   ! finite dilution for non-self-shielded reactions
   if (nz.gt.1.and.mth.eq.2) go to 250
   if (mth.eq.2) ntfl=1
   do j=1,nzj
      noloc=l20-l18+(inc-1)*ngps*nzj*ntj+(jg1-1)*nzj*ntj-nzj+j
      do k=2,ng2
         jg2=(ngps+1)-(ig2lo+k-2)
         locsg=lz+nl*nz*(k-1)+2
         do l=1,ntj
            a(nzj*l+noloc)=a(nzj*l+noloc)-e(locsg)
         enddo
      enddo
   enddo
   go to 300
   ! finite dilution for elastic scattering
  250 continue
   if (mth.ne.2.or.ntfl.eq.1.or.nz.eq.1) go to 300
   do 260 j=1,ntj
   itemp=j
   if (abs(temp-ctem(j)).le.eps*temp) go to 270
  260 continue
   go to 300
  270 continue
   if (mth.eq.2) mt2tem(itemp)=1
   do j=1,nzj
      noloc=l20-l18+(inc-1)*ngps*nzj*ntj+(jg1-1)*nzj*ntj&
        +(itemp-1)*nzj+j
      locsg=lz-nl*nz+nl*(isig(j)-1)+2
      do k=2,ng2
         a(noloc)=a(noloc)-e(nl*nz*k+locsg)
      enddo
   enddo

   !--elastic removal shielding factor
  300 continue
   if (mth.ne.2) go to 140
   inc=6
   if (nsblk.gt.1) inc=1
   if (inc+nsb.ne.7) go to 140
   do 310 j=1,ntj
   itemp=j
   if (abs(temp-ctem(j)).le.eps*temp) go to 320
  310 continue
   go to 140
  320 continue
   do j=1,nzj
      do k=2,ng2
         jg2=(ngps+1)-(ig2lo+k-2)
         if (jg2.ne.jg1) then
            locsg=lz+nl*nz*(k-1)+(isig(j)-1)*nl+1
            noloc=l20-l18+(inc-1)*ngps*nzj*ntj+(jg1-1)*nzj*ntj&
              +(itemp-1)*nzj+j
            lrem=irsize+11*ngps+jg1
            a(noloc)=a(noloc)+e(locsg)/a(lrem)
         endif
      enddo
   enddo

  140 continue
   if (ig.lt.ngps) go to 120
   return
   end subroutine mxproc

   subroutine thnwrt(a,irec3)
   !--------------------------------------------------------------------
   ! Thins data and writes on nscrt1 in proper order.
   !--------------------------------------------------------------------
   use util ! provides repoz
   ! externals
   integer::irec3
   real(4)::a(*)
   ! internals
   integer::irec2,nrnge,i,nlow,ndex,inv,ir,jg,jt,jz,mdex,nup,j

   !--read self-shielding factors
   irec2=0
   call repoz(-nscrt2)
   nrnge=6*ngps
   irec2=irec2+1
   read(nscrt2)(a(i),i=1,nrnge)
   do i=1,nsblk
      nlow=nrnge+ngps*ntj*nzj*(i-1)+1
      irec2=irec2+1
      read(nscrt2)(a(nlow+j-1),j=1,lrsize)

      !--thin data (to (jbh-jbl+1)*ntap*ntat)
      ndex=nrnge
      inv=nreact/nsblk
      do ir=1,inv
         do jg=1,ngps
            if (jg.ge.jbl.and.jg.le.jbh) then
               do jt=1,ntj
                  if (ntat(jt).ne.0) then
                     do jz=1,nzj
                        if (ntap(jz).ne.0) then
                           mdex=(ir-1)*ngps*ntj*nzj&
                             +(jg-1)*ntj*nzj+(jt-1)*nzj+jz+nrnge
                           ndex=ndex+1
                           !--set s-s factors equal to 1.0
                           !--if reaction is not present
                           if (a(mdex).eq.0.0) a(mdex)=1
                           a(ndex)=a(mdex)
                        endif
                     enddo
                  endif
               enddo
            endif
         enddo
      enddo
      !--write on nscrt3
      nlow=nrnge+1
      nup=ndex-nrnge
      irec3=irec3+1
      write(nscrt3)(a(nlow+j-1),j=1,nup)
   enddo

   !--write cross sections to nscrt3
   irec3=irec3+1
   write(nscrt3)(a(i),i=1,nrnge)
   return
   end subroutine thnwrt

   subroutine pbrkxs(n4)
   !--------------------------------------------------------------------
   ! Controls printing of the BRKOXS file.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides error,repoz
   ! externals
   integer::n4
   ! internals
   integer::irec1,i,nwds,iver,ngroup,nisosh,nsigpt,ntempt,nreact
   integer::iblk,next,nex1,ntp,j,ntt,nex2,nex3,nex4,jssf,k,nbint
   integer::nbtem,jbfli,jbfhi,ndiff,npro,j2,j3,j4,j5,j6,n
   integer::nwh,llr,nwr,lli,nwi
   character(8)::hn,hu,hs
   integer::ird(10)
   character(6),parameter::hgroup='index'
   character(6),parameter::htemp='temp'
   character(6),parameter::hsigo='sigo'

   irec1=0
   call repoz(-n4)
   do i=1,10
      ird(i)=1
   enddo

   !--file identification
   nwds=1+3*mult
   irec1=irec1+1
   read(n4)(ha(i),i=1,3),ia(nwds)
   hn=ta(1)
   hu=ta(2)
   hs=ta(3)
   iver=ia(nwds)
   write(nsyso,'(''1''/'' ***file '',a6,'' -- version'',i3,&
     &'' -- unit'',i3,''***'')') hn,iver,n4
   write(nsyso,'('' **user identification**'',a6,3x,a6)') hu,hs

   !--file control
   irec1=irec1+1
   read(n4)(ia(i),i=1,6)
   ngroup=ia(1)
   nisosh=ia(2)
   nsigpt=ia(3)
   ntempt=ia(4)
   nreact=ia(5)
   iblk=ia(6)
   if (ird(1).eq.1) write(nsyso,'(/&
     &'' file control parameters''//&
     &''  ngroup    number of energy groups in set         '',i12/&
     &''  nisosh    number of isotopes with self-''/&
     &''              shielding factors                    '',i12/&
     &''  nsigpt    total number of values of variable x''/&
     &14x,''which are given.  nsigpt is equal to''/&
     &''              the sum from 1 to nisosh of ntabp(i) '',i12/&
     &''  ntempt    total number of values of variable tb''/&
     &14x,''which are given.  ntempt is equal to''/&
     &''            the sum from 1 to nisosh of ntabt(i)   '',i12/&
     &''  nreact    number of reactions                    '',i12/&
     &''  iblk      blocking option                        '',i12)')&
     (ia(i),i=1,6)

   !--file data
   nwh=nisosh
   llr=mult*nwh
   nwr=nsigpt+ntempt+ngroup+1
   lli=llr+nwr
   nwi=4*nisosh
   nwds=mult*nwh+nwr+nwi
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pbrkxs','input record too large.',' ')
   read(n4)(ha(i),i=1,nwh),(a(llr+i),i=1,nwr),(ia(lli+i),i=1,nwi)
   if (ird(2).eq.1) then
      write(nsyso,'(/4x,''isotope'',4x,''name'')')
      write(nsyso,'(5x,i3,7x,a6)') (i,ta(i),i=1,nisosh)
      next=nisosh*mult+1
      write(nsyso,'(/&
        &'' ln(sigp0)/ln(10) values for all isotopes''/5x,&
        &''isotope'',6x,''1st value'',6x,''2nd value'',&
        &10x,''. . .'')')
      nex1=(mult+2)*nisosh+nsigpt+ntempt+ngroup+1
      do i=1,nisosh
         nex1=nex1+1
         ntp=next+ia(nex1)-1
         write(nsyso,'(7x,i3,1p,8e15.5)') i,(a(j),j=next,ntp)
         next=ntp+1
      enddo
      write(nsyso,'(/&
        &'' temperatures (deg c) for all isotopes''//'' isotope'',&
        &6x,''1st value'',6x,''2nd value'',10x,''. . .'')')
      do i=1,nisosh
         nex1=nex1+1
         ntt=next+ia(nex1)-1
         write(nsyso,'(7x,i3,1p,8e15.5)') i,(a(j),j=next,ntt)
         next=ntt+1
      enddo
      write(nsyso,'(/'' maximum energy bound''/3x,''group j'')')
      do i=1,ngroup
         write(nsyso,'(i10,1p,e13.5)') i,a(next+i-1)
      enddo
      next=next+ngroup
      write(nsyso,'(/&
        &'' minimum energy bound of set''//11x,1p,e12.5)') a(next)
      write(nsyso,'(/&
        &'' f-factor start and stop groups''/&
        &'' and number of sig0 and temperature values''//&
        &1x,''isotope'',11x,''jbfh'',11x,''jbfl'',10x,''ntabf'',&
        &10x,''ntabt'')')
      write(nsyso,'(1x,i7,4i15)')&
        (i,ia(next+i),ia(next+i+nisosh),ia(i+next+2*nisosh),&
        ia(next+i+3*nisosh),i=1,nisosh)
   endif
   next=nisosh*mult+nsigpt+ntempt+ngroup+1
   nex1=next+1
   nex2=nex1+nisosh
   nex3=nex2+nisosh
   nex4=nex3+nisosh

   !--self-shielding factors
   jssf=nex4+nisosh
   do 110 i=1,nisosh
   k=nex3-1+i
   nbint=ia(k)
   k=nex4-1+i
   nbtem=ia(k)
   k=nex1-1+i
   jbfli=ia(k)
   k=nex2-1+i
   jbfhi=ia(k)
   ndiff=jbfhi-jbfli+1
   npro=nbint*nbtem*ndiff
   if (iblk.gt.1) go to 82
   nwds=nreact*npro
   if (nwds.le.0) go to 100
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pbrkxs','input record too large.',' ')
   read(n4)(a(jssf+j-1),j=1,nwds)
   if (ird(3).ne.1) go to 100
   j2=jssf+npro
   j3=j2+npro
   j4=j3+npro
   j5=j4+npro
   j6=j5+npro
   go to 83
   82 nwds=npro
   if (nwds.le.0) go to 100
   j2=jssf
   j3=j2
   j4=j3
   j5=j4
   j6=j5
   irec1=irec1+1
   read(n4)(a(jssf+j-1),j=1,nwds)
   83 if (ird(3).eq.1) then
   write(nsyso,'(/&
        &'' total self-shielding factors'',10x,''isotope'',i3)') i
      call wot(a(jssf),nbint,nbtem,ndiff,hsigo,htemp,hgroup,nsyso)
   endif
   if (iblk.ne.0) then
      irec1=irec1+1
      read(n4)(a(j2+j-1),j=1,nwds)
   endif
   if (ird(3).eq.1) then
      write(nsyso,'(/&
        &'' capture self-shielding factors'',10x,''isotope'',i3)') i
      call wot(a(j2),nbint,nbtem,ndiff,hsigo,htemp,hgroup,nsyso)
   endif
   if (iblk.ne.0) then
      irec1=irec1+1
      read(n4)(a(j3+j-1),j=1,nwds)
   endif
   if (ird(3).eq.1) then
      write(nsyso,'(/&
        &'' fission self-shielding factors'',10x,''isotope'',i3)') i
      call wot(a(j3),nbint,nbtem,ndiff,hsigo,htemp,hgroup,nsyso)
   endif
   if (iblk.ne.0) then
      irec1=irec1+1
      read(n4)(a(j4+j-1),j=1,nwds)
   endif
   if (ird(3).eq.1) then
      write(nsyso,'(/&
        &'' transport self-shielding factors'',10x,''isotope'',i3)') i
      call wot(a(j4),nbint,nbtem,ndiff,hsigo,htemp,hgroup,nsyso)
   endif
   if (iblk.ne.0) then
      irec1=irec1+1
      read(n4)(a(j5+j-1),j=1,nwds)
   endif
   if (ird(3).eq.1) then
      write(nsyso,'(/&
        &'' elastic self-shielding factors'',10x,''isotope'',i3)') i
      call wot(a(j5),nbint,nbtem,ndiff,hsigo,htemp,hgroup,nsyso)
   endif
   if (nreact.lt.6) go to 100
   if (iblk.ne.0) then
      irec1=irec1+1
      read(n4)(a(j6+j-1),j=1,nwds)
   endif
   if (ird(3).eq.1) then
      write(nsyso,'(/&
        &'' removal self-shielding factors'',10x,''isotope'',i3)') i
      call wot(a(j6),nbint,nbtem,ndiff,hsigo,htemp,hgroup,nsyso)
   endif
100   continue

   !--cross sections
   nwds=6*ngroup
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pbrkxs','input record too large.',' ')
   read(n4)(a(jssf+n-1),n=1,nwds)
   if (ird(4).eq.1) then
      j2=jssf+ngroup
      j3=j2+ngroup
      j4=j3+ngroup
      j5=j4+ngroup
      j6=j5+ngroup
      write(nsyso,'(/&
        &'' group'',9x,''xspo'',9x,''xsin'',10x,''xse'',9x,''xsmu'',&
        &9x,''xsed'',9x,''xsxi'')')
      do n=1,ngroup
         write(nsyso,'(1x,i5,1p,6e13.6)')&
           n,(a(jssf-1+n+j*ngroup-ngroup),j=1,6)
      enddo
   endif

   !--continue loop over shielding factors
  110 continue
   return
   end subroutine pbrkxs

   subroutine cdlyxs(idlay,idlayt)
   !--------------------------------------------------------------------
   ! Write a CCCC-III DLAYXS interface file.
   !--------------------------------------------------------------------
   use util ! provides mess,repoz
   ! externals
   integer::idlay,idlayt
   ! internals
   integer::lzero,irec,nwds,lzeroh,l3,n,l4,nkfam
   integer::nwh,nwr,nwi,lli,l1h,llr,l1i,l1r,i
   character(6)::hname='dlayxs'

   !--read delayed neutron data
   lzero=next
   call dldata(idlayt)
   if (nisod.ne.0) then

      !--file identification
      irec=1
      nwds=1+3*mult
      lzeroh=(lzero-1)/mult+1
      read(hname,'(a6)') ta(lzeroh)
      ha(lzeroh+1)=huse(1)
      ha(lzeroh+2)=huse(2)
      ia(3*mult+lzero)=ivers
      call repoz(idlay)
      write(idlay)(ha(lzeroh+i-1),i=1,3),ia(lzeroh+nwds-1)

      !--file control
      irec=2
      nwds=4
      ia(lzero)=ngps
      ia(lzero+1)=nisod
      ia(lzero+2)=nfam
      ia(lzero+3)=nfam
      write(idlay)(ia(lzero+i-1),i=1,4)

      !--file data, decay constants, and emission spectra
      irec=3
      l1h=(l1-1)/mult
      nwh=nisod
      l1r=l1+mult*nwh-1
      nwr=(ngps+1)*(nfam+1)
      l1i=l1r+nwr
      nwi=2*nisod
      nwds=mult*nwh+nwr+nwi
      write(idlay)(ha(l1h+i),i=1,nwh),(a(l1r+i),i=1,nwr),&
        (ia(l1i+i),i=1,nwi)

      !--delayed neutron precursor yield data by isotope
      l3=l1+nwds
      do n=1,nisod
         irec=4
         l4=l1+nisod*mult+nfam+ngps*nfam+ngps
         nkfam=ia(l4+n)
         llr=l3-1
         nwr=ngps*nkfam
         lli=llr+nwr
         nwi=nkfam
         nwds=nwr+nwi
         write(idlay)(a(llr+i),i=1,nwr),(ia(lli+i),i=1,nwi)
         l3=l3+nwds
      enddo
      next=l1

   !--no delayed neutron data found
   else
      call mess('cdlyxs','no delayed neutron data found.',' ')
      next=l1
   endif
   return
   end subroutine cdlyxs

   subroutine dldata(nin)
   !--------------------------------------------------------------------
   ! Read delayed neutron data from input tape.
   ! Store all data in a according to the following assignments:
   !
   ! location  variable   length
   ! --------  --------   ------
   !   l1      isonm      nisod
   !   l2      flam       nfam
   !   l3      chid       ngroup*nfam
   !   l4      emax       ngroup
   !   l5      emin       1
   !   l6      nfami      nisod
   !   l7      loca       nisod
   !   l8      snudel     ngroup*nfam
   !            +numfam     +nfam
   !   l9      next available location
   !
   ! In this routine, "family" means an isotope and time group
   ! (there are typically nisod*ndg families, where ndg is the
   ! number of delayed neutron groups for this isotope).
   !--------------------------------------------------------------------
   use util ! provides repox,error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin
   ! internals
   integer::nisoo,nwds,lzero,l3,l4,l5,l6,l7,l8,l9,la,last
   integer::i,ipr,nb,nw,ig,ig1,nl,nz,ng,ng2,loc,ngn,ngp1,loca
   integer::ifam,nd,jj,locb,j,ndg
   integer::imusd(200)
   integer,parameter::ndmax=8
   real(kr)::fract(ndmax)
   character(8)::hisnm
   nisoo=niso

   !--get the number of delayed neutron groups for this nuclide
   !--from groupr's mf5, mt455 head record.
   call repoz(nin)
   call tpidio(nin,0,0,e(1),nb,nw)
   do while (mfh.lt.5)
      call contio(nin,0,0,e(1),nb,nw)
   enddo
   if (mth.eq.455) then
      ndg=nint(e(3))
   else if (mth.lt.455) then
      do while (mfh.eq.5.and.mth.lt.455)
         call contio(nin,0,0,e(1),nb,nw)
      enddo
      if (mfh.eq.5) then
         ! number of delayed neutron groups
         ndg=nint(e(3))
      else
         nisod=0
         return
      endif
   else
      nisod=0
      return
   endif
   if (ndg.eq.0) then
       nisod=0
       return
   elseif (ndg.gt.ndmax) then
       call mess ('dldata','too many delayed neutron groups',&
         'dlayxs request ignored')
       nisod=0
       return
   endif

   !--assign storage
   nfam=ndg*nisoo
   nwds=3*mult+mult
   lzero=next
   next=lzero+nwds+4
   nwds=nisoo*mult
   l1=next
   next=l1+nwds
   l2=next
   next=l2+nfam
   nwds=ngps*nfam
   l3=next
   next=l3+nwds
   l4=next
   next=l4+ngps
   l5=next
   next=l5+1
   l6=next
   next=l6+nisoo
   l7=next
   next=l7+nisoo
   nwds=ngps*nfam+nfam
   l8=next
   next=l8+nwds
   l9=next
   la=l9+5
   last=la+10*ngps

   if (last.gt.isiza4) call error('dldata',&
        'max4a for container a exceeded',' ')

   !--read through input tape for desired data
   do i=1,200
      imusd(i)=0
   enddo
   ipr=0
   nisod=0
   do i=l1,last
      a(i)=0
   enddo
   call repoz(nin)
   call tpidio(nin,0,0,e(1),nb,nw)
  110 call contio(nin,0,0,e(1),nb,nw)
   if (math.eq.-1) return
   if (mfh.eq.0) go to 110
   do 115 i=1,nisoo
   read(hisonm(i),'(a6)') hisnm
   if (math.ne.imat(i)) go to 115
   if (imusd(i).gt.0) go to 115
   imusd(i)=1
   go to 150
  115 continue
   call tomend(nin,0,0,e(1))
   go to 110
  130 if (ig.lt.ngps) go to 170
   call contio(nin,0,0,e(1),nb,nw)
   if (math.eq.0) go to 110
   if (mfh.eq.0.or.mth.eq.0) go to 130
  150 nl=l1h
   nz=l2h
   ng=n2h
  170 call listio(nin,0,0,e(1),nb,nw)
   ng2=l1h
   ig=n2h
   loc=1+nw
   do while (nb.ne.0)
      if (loc+302.gt.maxe) call error('dldata',&
        'max for endf input data exceeded',' ')
      call moreio(nin,0,0,e(loc),nb,nw)
      loc=loc+nw
   enddo
   if (mth.eq.451) go to 210
   if (mfh.eq.3.and.mth.eq.455) go to 310
   if (mfh.eq.5.and.mth.eq.455) go to 410
   go to 130

   !--process material header
  210 continue
   nisod=nisod+1
   if (ipr.gt.0) go to 130
   ngn=ng2
   if (ngn.ne.ngps)&
     call error('dldata','incompatible group structures.',' ')
   ngp1=ngn+1
   do i=1,ngp1
      loca=l4+ngn-i+1
      a(loca)=e(6+ng+nz+i)
   enddo
   ipr=1
   ig=ngps
   go to 130

   !--process delayed neutron yield records
  310 continue
   do i=1,ndg
      ifam=ndg*(nisod-1)+i
      loca=l8+ngn-ig+ngn*(ifam-1)+ndg*(nisod-1)
      a(loca)=e(8)
   enddo
   go to 130

   !--process delayed neutron spectra record
  410 nd=nl
   ! lowest energy group that holds delayed data
   ! subtraction of -1 because first position in gendf mf5mt455
   ! is decay constant of that precursor family
   ig1=l1h-1
   ! hisnm--isotope name
   jj=(l1-1)/mult+nisod
   ta(jj)=hisnm
   ! loca--number of records before desired isotope.
   ia(l7+nisod-1)=nisod-1
   ! nkfam--number of families for this isotope.
   loca=l6+nisod-1
   ia(loca)=nd
   ! flam--decay constants for these families.
   ifam=ndg*(nisod-1)-1+l2
   do i=1,nd
      a(i+ifam)=e(i+6)
   enddo
   ! chid--delayed neutron spectra for these families.
   do i=1,nd
      ifam=ndg*(nisod-1)+i
      loca=l3+ngn+ngn*(ifam-1)
      locb=6+i
      fract(i)=0
      do j=1,ig1
         a(loca-j)=e(nl*j+locb)
         fract(i)=e(nl*j+locb)+fract(i)
      enddo
   enddo
   ! snudel--yield of delayed neutrons for each family.
   do i=1,nd
      ifam=i+ndg*(nisod-1)
      loca=l8+ngn+ngn*(ifam-1)+ndg*(nisod-1)
   !--numfam--family number for each yield vector
      locb=l8-1+ndg*ngn*nisod+ndg*(nisod-1)+i
      ia(locb)=ifam
      do j=1,ngn
         a(loca-j)=fract(i)*a(loca-j)
      enddo
   enddo
   go to 130
   end subroutine dldata

   subroutine pdlyxs(idlay)
   !--------------------------------------------------------------------
   ! Print the CCCC DLAYXS file
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides error,repoz
   ! externals
   integer::idlay
   ! internals
   integer::n4,irec1,nwds,i4,ngroup,nisod,nfam,i,nsp,nint
   integer::k,nex1,nex2,jwd1,kk,jwd2,nwh,llr,lli,j
   character(6),parameter::h1=' group'
   character(6),parameter::h2='family'
   character(6),parameter::h3='isotop'
   character(6),parameter::h4='number'
   character(6),parameter::h5='vector'
   character(6),parameter::hblank='      '
   integer::m1=1
   integer::m4=4
   n4=idlay

   !--file identification
   irec1=1
   nwds=1+3*mult
   call repoz(n4)
   read(n4)(ha(i),i=1,3),ia(nwds)
   i4=1+3*mult
   write(nsyso,'(&
     &''1delayed neutron precursor data '',a6/&
     &'' user identification'',1x,2a6/&
     &'' file version number'',i6)')&
     ta(1),ta(2),ta(3),ia(i4)

   !--file control
   irec1=irec1+1
   read(n4)(ia(i),i=1,m4)
   ngroup=ia(1)
   nisod=ia(2)
   nfam=ia(3)
   write(nsyso,'(/&
     &'' file control parameters''//&
     &''  ngroup    number of neutron energy groups in set '',i12/&
     &''  nisod     number of isotopes in delayed          '',i12/&
     &''              neutron set                          ''/&
     &''  nfam      number of delayed neutron families     '',i12/&
     &''              in set                               ''/&
     &''  idum      dummy to make up 4-word record         '',i12)')&
     (ia(i),i=1,4)

   !--file data
   nsp=(nfam+1)*(ngroup+1)
   nint=2*nisod
   nwh=nisod
   llr=mult*nwh
   lli=llr+nsp
   nwds=nwh*mult+nsp+nint
   irec1=irec1+1
   if (nwds.ge.isiza4)&
     call error('pdlyxs','input record too large.',' ')
   read(n4)(ha(i),i=1,nwh),(a(llr+i),i=1,nsp),(ia(lli+i),i=1,nint)
   write(nsyso,'(/3x,''isotope'',5x,''name'')')
   next=nisod
   do i=1,next
      write(nsyso,'(5x,i3,7x,a6)') i,ta(i)
   enddo
   next=mult*nisod
   write(nsyso,'(/&
     &'' delayed neutron precursor decay constant for family n'',&
     &/6x,''family'',9x,''n'')')
   do i=1,nfam
      k=next+i
      write(nsyso,'(6x,i3,6x,1p,e12.5)') i,a(k)
   enddo
   next=next+nfam+1
   write(nsyso,'(/&
     &'' fraction of delayed neutrons emitted into neutron '',&
     &''energy group from precursor family'')')
   call wot(a(next),ngroup,nfam,m1,h1,h2,hblank,nsyso)
   next=next+ngroup*nfam
   write(nsyso,'(/&
     &'' maximum energy bound''/7x,''group'',5x,''j'')')
   do i=1,ngroup
      write(nsyso,'(i10,1p,e13.5)') i,a(next+i-1)
   enddo
   next=next+ngroup
   write(nsyso,'(/&
     &'' minimum energy bound of set''//11x,1p,e12.5)')&
     a(next)
   nex1=next+1
   write(nsyso,'(/&
     &'' number of families to which fission in isotope '',&
     &''contributes delayed neutron precursors'')')
   call woti(ia(nex1),nisod,m1,m1,h3,h4,hblank,nsyso)
   nex2= nex1+nisod
   write(nsyso,'(/&
     &'' number of records to be skipped to read data for '',&
     &''isotope'')')
   call woti(ia(nex2),nisod,m1,m1,h3,h4,hblank,nsyso)
   next=mult*nisod+(ngroup+1)*(nfam+1)

   !--delayed neutron procursor yield data
   jwd1=nwds+1
   do i=1,nisod
      k=next+i
      kk=ia(k)
      nsp=ngroup*kk
      nint=kk
      nwds=nsp+nint
      llr=jwd1-1
      lli=llr+nsp
      irec1=irec1+1
      if (nwds.ge.isiza4)&
        call error('pdlyxs','input record too large.',' ')
      read(n4)(a(llr+j),j=1,nsp),(ia(lli+j),j=1,nint)
      jwd2=jwd1+ngroup*kk
      write(nsyso,'(/&
        &''number of delayed neutron precursors produced in '',&
        &''family per fission in group'')')
      call wot(a(jwd1),ngroup,kk,m1,h1,h2,hblank,nsyso)
      write(nsyso,'(/&
        &'' family number of k-th yield vector'')')
      call woti(ia(jwd2),m1,kk,m1,h2,h5,hblank,nsyso)
   enddo
   return
   end subroutine pdlyxs

   subroutine wot(x,ii,jj,kk,top1,top2,top3,nou)
   !--------------------------------------------------------------------
   ! Prints a single one-, two-, or three-dimensional real array.
   !--------------------------------------------------------------------
   ! externals
   integer::ii,jj,kk,nou
   real(4)::x(ii,jj,kk)
   character(6)::top1,top2,top3
   ! internals
   integer::k,jo1,jo2,jo3,jk,j,nflag,i,n,im1
   real(kr)::ssum
   real(kr),parameter::zero=0

   do 110 k=1,kk
   jo2=0
   jo3=(jj+8)/9
   if (kk.gt.1) then
      write(nou,'('' '',6x,a6,i5)') top3,k
   endif
   do 100 jk=1,jo3
   jo1=jo2+1
   jo2=min0(jo1+8,jj)
   write(nou,'('' '',6x,a6,9(4x,a6,i3))')&
     top1,(top2,j,j=jo1,jo2)
   nflag=0
   do 90 i=1,ii
   ssum=0
   do j=jo1,jo2
      ssum=ssum+abs(x(i,j,k))
   enddo
   if (ssum.ne.zero) go to 30
   nflag=nflag+1
   if (i.lt.ii) go to 90
  30 if (nflag.eq.1) go to 60
   if (nflag.lt.1) go to 80
   n=i-nflag
   im1=i-1
   if (i.ge.ii.and.ssum.eq.zero) then
   n=n+1
   im1=i
   endif
   write(nou,'('' '',i7,'' to'',i4,1p,9e13.5)')&
     n,im1,(x(im1,j,k),j=jo1,jo2)
   go to 70
   60 if (ssum.le.zero) go to 80
   im1=i-1
   write(nou,'('' '',i10,4x,1p,9e13.5)')&
     im1,(x(im1,j,k),j=jo1,jo2)
   70 continue
   nflag=0
   if (ssum.le.zero) go to 90
   80 write(nou,'('' '',i10,4x,1p,9e13.5)')&
        i,(x(i,j,k),j=jo1,jo2)
   90 continue
  100 continue
  110 continue
   return
   end subroutine wot

   subroutine woti(ix,ii,jj,kk,top1,top2,top3,nou)
   !--------------------------------------------------------------------
   ! Prints a single one-, two-, or three-dimensional integer array.
   !--------------------------------------------------------------------
   ! externals
   integer::ii,jj,kk,nou
   integer(4)::ix(ii,jj,kk)
   character(6)::top1,top2,top3
   ! internals
   integer::i,j,k,jk,jo1,jo2,jo3

   do k=1,kk
      jo2=0
      jo3=(jj+24)/25
      if (kk.gt.1) then
         write(nou,'(/''0'',6x,a6,i5)') top3,k
      endif
      do jk=1,jo3
         jo1=jo2+1
         jo2=min0(jo1+24,jj)
         write(nou,'('' '',a6,''/'',a6,25i4)')&
           top1,top2,(j,j=jo1,jo2)
         do i=1,ii
            write(nou,'('' '',i6,7x,25i4)')&
              i,(ix(i,j,k),j=jo1,jo2)
         enddo
      enddo
   enddo
   return
   end subroutine woti

   subroutine stow(a,b,nwds)
   !--------------------------------------------------------------------
   ! Move data from one region of core to another.
   !--------------------------------------------------------------------
   ! externals
   integer::nwds
   real(4)::a(*),b(*)
   ! internals
   integer::n

   if (nwds.le.0) return
   do n=1,nwds
      b(n)=a(n)
   enddo
   return
   end subroutine stow

end module ccccm

module locale
   ! Provides localization parameters for NJOY2016.  Each site
   ! should change "lab" and "mx" for their location.  The
   ! "kind" parameter kr is for normal internal real numbers in NJOY.
   ! The default kind is assumed for normal internal integers (either
   ! 4 or 8 bytes should be OK for integers).  The CCCC files use
   ! 4-byte reals, 4-byte integers, and 8-byte Hollerith values,
   ! and k4 and k8 are provided for them.  These values are also used
   ! in subroutine timer when a C-type call is needed.  Caution: the
   ! settings for k4 and k8 may not be portable--some systems might
   ! use 1 and 2 instead of 4 and 8 for these two kinds.
   implicit none
   private
   character(8),public::lab='lanl t2'
   character(8),public::mx='        '
   integer,parameter,public::kr=selected_real_kind(12,300)
   integer,parameter,public::k4=4
   integer,parameter,public::k8=8
end module locale

module acepa
   ! provides ACE photo-atomic routines for acer
   use locale
   use acecm, only: xss,nxss
   implicit none
   private

   !--Public routines
   public acepho,phofix

   !--Private global variables

   ! ace header data for photoatomic format
   character(13)::hz
   character(10)::hd
   character(10)::hm
   real(kr)::aw0,tz

   ! parameters for photoatomic nsx block
   integer::len2,z,nes,nflo,nxsd(12)

   ! parameters for photoatomic jxs block
   integer::eszg,jinc,jcoh,jflo,lhnm,jxsd(27)

   ! parameter for scratch array
   integer,parameter::nwscr=50000

contains

   subroutine acepho(nin,nlax,nace,ndir,matd,mcnpx,iprint,itype,&
     suff,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Prepare ACE photo-atomic files.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util ! provides openz,mess,closz,dater
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nlax,nace,ndir,matd,mcnpx,iprint,itype
   real(kr)::suff
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::nb,nw,l,iza,idis,iinc,icoh,iabs,ipair,next
   integer::i,ip,ir,nr,np,iz
   real(kr)::e,enext,s,v,vnext,v2,en,heat,siginc,zaid,tot
   character(8)::hdt
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(21),parameter::vi=(/0.e0_kr,.005e0_kr,&
     .01e0_kr,.05e0_kr,.1e0_kr,.15e0_kr,.2e0_kr,.3e0_kr,.4e0_kr,&
     .5e0_kr,.6e0_kr,.7e0_kr,.8e0_kr,.9e0_kr,1.e0_kr,1.5e0_kr,&
     2.e0_kr,3.e0_kr,4.e0_kr,5.e0_kr,8.e0_kr/)
   real(kr),dimension(55),parameter::vc=(/0.e0_kr,.01e0_kr,&
     .02e0_kr,.03e0_kr,.04e0_kr,.05e0_kr,.06e0_kr,.08e0_kr,.10e0_kr,&
     .12e0_kr,.15e0_kr,.18e0_kr,.20e0_kr,.25e0_kr,.30e0_kr,.35e0_kr,&
     .40e0_kr,.45e0_kr,.50e0_kr,.55e0_kr,.60e0_kr,.70e0_kr,.80e0_kr,&
     .90e0_kr,1.0e0_kr,1.1e0_kr,1.2e0_kr,1.3e0_kr,1.4e0_kr,1.5e0_kr,&
     1.6e0_kr,1.7e0_kr,1.8e0_kr,1.9e0_kr,2.0e0_kr,2.2e0_kr,2.4e0_kr,&
     2.6e0_kr,2.8e0_kr,3.0e0_kr,3.2e0_kr,3.4e0_kr,3.6e0_kr,3.8e0_kr,&
     4.0e0_kr,4.2e0_kr,4.4e0_kr,4.6e0_kr,4.8e0_kr,5.0e0_kr,5.2e0_kr,&
     5.4e0_kr,5.6e0_kr,5.8e0_kr,6.0e0_kr/)
   real(kr),parameter::emin=1.e3_kr
   real(kr),parameter::emev=1.e6_kr
   real(kr),parameter::emax=1.01e11_kr
   real(kr),parameter::epair=1.022e0_kr
   real(kr),parameter::zero=0

   nxsd=0
   jxsd=0
   xss=0

   !--allocate scratch storage
   allocate(scr(nwscr))

   !--assign input file
   call openz(nin,0)

   !--determine what endf version is being used
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' using endf-'',i1,'' format'')') iverf

   !--locate and store energy grid of total cross section
   l=0
   call findf(matd,23,501,nin)
   call contio(nin,0,0,scr,nb,nw)
   iza=nint(scr(1))
   aw0=scr(2)
   e=0
   call gety1(e,enext,idis,s,nin,scr)
   enext=emin
   do while (enext.lt.emax)
      e=sigfig(enext,9,0)
      if (idis.ne.0) then
         e=sigfig(e,9,-1)
         call gety1(e,enext,idis,s,nin,scr)
         l=l+1
         xss(l)=e
         e=sigfig(e,9,+2)
      endif
      call gety1(e,enext,idis,s,nin,scr)
      l=l+1
      xss(l)=e
   enddo
   call tosend(nin,0,0,scr)
   nes=l

   !--define cross section locators
   eszg=1
   iinc=eszg+nes
   icoh=iinc+nes
   iabs=icoh+nes
   ipair=iabs+nes
   next=ipair+nes

   !--loop over photon reactions on file 23
   mfh=23
   do while (mfh.ne.0)
      call contio(nin,0,0,scr,nb,nw)
      l=0
      if (mfh.ne.0) then
         if (mth.eq.502) l=icoh
         if (mth.eq.504) l=iinc
         if (mth.eq.516) l=ipair
         if (iverf.lt.6.and.mth.eq.602) l=iabs
         if (iverf.ge.6.and.mth.eq.522) l=iabs
         if (l.ne.0) then
            e=0
            call gety1(e,enext,idis,s,nin,scr)
            do i=1,nes
               e=xss(eszg-1+i)
               call gety1(e,enext,idis,s,nin,scr)
               xss(l-1+i)=s
            enddo
         endif
         call tosend(nin,0,0,scr)
      endif
   enddo

   !--fix up energy units
   do i=1,nes
      xss(eszg-1+i)=xss(eszg-1+i)/emev
   enddo

   !--set number of fluorescence lines
   iz=matd/100
   if (iz.lt.12) then
      nflo=0
   else if (iz.lt.20) then
      nflo=2
   else if (iz.lt.31) then
      nflo=4
   else if (iz.lt.37) then
      nflo=5
   else
      nflo=6
   endif

   !--assign locators for the other data blocks
   jinc=next
   jcoh=jinc+21
   jflo=jcoh+110
   lhnm=jflo+4*nflo
   len2=lhnm+nes-1

   !--process the coherent form factors
   call findf(matd,27,502,nin)
   call contio(nin,0,0,scr,nb,nw)
   z=nint(scr(1)/1000)
   call tab1io(nin,0,0,scr,nb,nw)
   l=1+nw
   do while (nb.ne.0)
      if (l.gt.nwscr) call error('acepho',&
              'storage exceeded for the coherent form factors',' ')
      call moreio(nin,0,0,scr(l),nb,nw)
      l=l+nw
   enddo
   ip=2
   ir=1
   do i=1,55
      v=vc(i)
      call terpa(s,v,vnext,idis,scr,ip,ir)
      xss(jcoh+54+i)=s
   enddo
   nr=nint(scr(5))
   np=nint(scr(6))
   l=1+6+2*nr
   do i=1,np
      scr(l)=scr(l)**2
      scr(l+1)=scr(l+1)**2/z**2
      l=l+2
   enddo
   do i=1,55
      ir=1
      ip=2
      v2=vc(i)**2
      call intega (xss(jcoh-1+i),zero,v2,scr,ip,ir)
   enddo

   !--process the incoherent scattering function
   call findf(matd,27,504,nin)
   call contio(nin,0,0,scr,nb,nw)
   call tab1io(nin,0,0,scr,nb,nw)
   l=1+nw
   do while (nb.ne.0)
      if (l.gt.nwscr) call error('acepho',&
              'storage exceeded for the incoherent scattering function',' ')
      call moreio(nin,0,0,scr(l),nb,nw)
      l=l+nw
   enddo
   ip=2
   ir=1
   do i=1,21
      v=vi(i)
      call terpa (s,v,vnext,idis,scr,ip,ir)
      xss(jinc-1+i)=s
   enddo
   do i=1,nes
      call iheat(xss(i)*emev,en,idis,scr,heat,siginc)
      xss(lhnm-1+i)=xss(iinc-1+i)*heat/emev
   enddo

   !--process photoelectric data
   !--for fluorescence photons
   !--and contribution to heating
   do i=1,nes
      xss(lhnm-1+i)=xss(lhnm-1+i)+xss(eszg-1+i)*xss(iabs-1+i)
   enddo
   if (nlax.eq.0) then
      call mess('acepho','no atomic relaxation data',&
        'fluorescence data not processed')
   else if (nflo.gt.0) then
      call alax(nin,nlax,matd,xss(jflo),xss(eszg),xss(iabs),xss(lhnm),scr,nes)
   endif

   !--add in heating contribution from pair production
   do i=1,nes
      xss(lhnm-1+i)=xss(lhnm-1+i)+xss(ipair-1+i)*(xss(eszg-1+i)-epair)
   enddo

   !--convert heating to a per collision basis
   do i=1,nes
      tot=xss(iinc-1+i)+xss(icoh-1+i)+xss(iabs-1+i)+xss(ipair-1+i)
      xss(lhnm-1+i)=xss(lhnm-1+i)/tot
   enddo

   !--finished with photon data
   call closz(nin)
   deallocate(scr)
   zaid=iza+suff
   if (mcnpx.eq.0) then
      write(hz,'(f9.2,''p'')') zaid
   else
      write(hz,'(f10.3,''pp '')') zaid
   endif
   tz=0
   call dater(hdt)
   hd='  '//hdt
   write(hm,'(''   mat'',i4)') matd
   if (iprint.gt.0) call phoprt(hk)
   call phoout(itype,nace,ndir,mcnpx,hk,izn,awn)
   return
   end subroutine acepho

   subroutine phofix(itype,nin,nout,ndir,iprint,nplot,mcnpx,&
     suff,nxtra,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Print and or edit an ACE photoatomic file.
   !-------------------------------------------------------------------
   use util ! provides closz
   ! externals
   integer::itype,nin,nout,ndir,iprint,nplot,mcnpx,nxtra
   real(kr)::suff
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::l,j,n,max,iza,i
   real(kr)::zaid
   integer::izo(16)
   real(kr)::awo(16)
   character(70)::hko
   character(3)::ht
   character(9)::str
   real(kr),parameter::zero=0

   integer,parameter::ner=1

   !--read type 1 ace format file
   call openz(nin,0)
   if (itype.eq.1) then
      if (mcnpx.eq.0) then
         read(nin,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hko,hm
      else
         read(nin,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:13),aw0,tz,hd,hko,hm
      endif
      read (nin,'(4(i7,f11.0))') (izo(i),awo(i),i=1,16)
      read(nin,'(8i9)')&
        len2,z,nes,nflo,nxsd(1:12),&
        eszg,jinc,jcoh,jflo,lhnm,jxsd(1:27)
      n=(len2+3)/4
      l=0
      do i=1,n
         read (nin,'(4e20.0)') (xss(l+j),j=1,4)
         l=l+4
      enddo

   !--read type 2 ace format file
   else if (itype.eq.2) then
      if (mcnpx.eq.0) then
        read(nin) hz(1:10),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          len2,z,nes,nflo,nxsd(1:12),&
          eszg,jinc,jcoh,jflo,lhnm,jxsd(1:27)
      else
        read(nin) hz(1:13),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          len2,z,nes,nflo,nxsd(1:12),&
          eszg,jinc,jcoh,jflo,lhnm,jxsd(1:27)
      endif
      n=(len2+ner-1)/ner
      l=0
      do i=1,n
         max=len2-l
         if (max.gt.ner) max=ner
         read (nin) (xss(l+j),j=1,max)
         l=l+max
      enddo
      call closz(-nin)
   endif

   !--adjust zaid
   if (mcnpx.gt.0) then
       read(hz,'(f10.0,a3)') zaid,ht
   else
       read(hz,'(a9,a1)') str,ht
       if (ht(1:1).ne.'t') then
          read(hz,'(f9.0,a1)') zaid,ht
       endif
   endif
   if (suff.ge.zero.and.ht(1:1).ne.'t') then
      iza=nint(zaid)
      zaid=iza+suff
      if (mcnpx.gt.0) then
          write(hz,'(f10.3,a3)') zaid,ht
      else
          write(hz,'(f9.2,a1)') zaid,ht
      endif
   endif

   !--adjust comment and (iz,aw) list
   if (len_trim(hk).eq.0) then
      hk=hko
   endif
   if (nxtra.ne.0) then
      do i=1,nxtra
         izn(i)=izo(i)
         awn(i)=awo(i)
      enddo
   endif

   !--print, plot, and/or write the file.
   if (iprint.gt.0) call phoprt(hk)
   if (nout.gt.0) call phoout(itype,nout,ndir,mcnpx,hk,izn,awn)

   return
   end subroutine phofix

   subroutine iheat(e,enext,idis,a,heat,siginc)
   !-------------------------------------------------------------------
   ! Compute incoherent heating and cross section.
   !-------------------------------------------------------------------
   use endf ! provides terpa
   ! externals
   integer::idis
   real(kr)::e,enext,a(*),heat,siginc
   ! internals
   integer::ip,ir,idone,nq,iq
   real(kr)::zz,enow,enowi,enow2,pnow,xnow,xzz,q2m,snow,xnext
   real(kr)::arg,ebar,q2,unext,pnext,px,aq,bq,uq,wq,pnowi,unow
   real(kr)::rm2,rm,rt,dk,fact
   real(kr),dimension(6),parameter::qp6=(/-1.e0_kr,&
     -.76505532e0_kr,-.28523152e0_kr,.28523152e0_kr,.76505532e0_kr,&
     1.e0_kr/)
   real(kr),dimension(6),parameter::qw6=(/.06666667e0_kr,&
     .37847496e0_kr,.55485838e0_kr,.55485838e0_kr,.37847496e0_kr,&
     .06666667e0_kr/)
   real(kr),dimension(10),parameter::qp10=(/-1.e0_kr,&
      -.9195339082e0_kr,-.7387738651e0_kr,-.4779249498e0_kr,&
      -.1652789577e0_kr,.1652789577e0_kr,.4779249498e0_kr,&
      .7387738651e0_kr,.9195339082e0_kr,1.e0_kr/)
   real(kr),dimension(10),parameter::qw10=(/.0222222222e0_kr,&
     .1333059908e0_kr,.2248893420e0_kr,.2920426836e0_kr,&
     .3275397612e0_kr,.3275397612e0_kr,.2920426836e0_kr,&
     .2248893420e0_kr,.1333059908e0_kr,.0222222222e0_kr/)
   real(kr),parameter::c2=0.249467e0_kr
   real(kr),parameter::c3=1.95693e-6_kr
   real(kr),parameter::c4=0.0485262e0_kr
   real(kr),parameter::c5=20.60744e0_kr
   real(kr),parameter::rndoff=1.0000001e0_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::one=1

   !--photon incoherent scattering and heating.
   zz=a(2)
   enow=c3*e
   enowi=1/enow
   enow2=enow*enow
   pnow=enow
   xnow=0
   xzz=c5*sqrt(enow/500)
   q2m=(2*enow*(1+enow)/(1+2*enow))**2
   if (xzz.le.zz) then
      ip=2
      ir=1
      call terpa(snow,xnow,xnext,idis,a(1),ip,ir)
   else
      snow=zz
      xnext=big
   endif
   arg=0
   siginc=0
   ebar=0

   !--loop over panels defined by form factor breaks.
   !--also limit panels by the fractional energy change
   idone=0
   do while (idone.eq.0)
      do while (idone.eq.0)
         q2=(c4*xnext)**2
         unext=-1
         if (q2.gt.q2m) then
            idone=1
         else
            unext=1-((1-q2*enowi)-sqrt(1+q2))/(q2-enow2-2*enow)
            if (unext.lt.-one) unext=-1
            if (unext.lt.0.99999) then
               idone=1
            else
               xnow=xnext*rndoff
               call terpa(snow,xnow,xnext,idis,a(1),ip,ir)
            endif
         endif
      enddo
      idone=0
      pnext=enow/(1+2*enow)
      px=enow/(1+enow*(1-unext))
      if (px.gt.pnext) pnext=px
      if (pnext.lt.pnow/2) pnext=pnow/2
      if (pnext.gt.pnow/rndoff) pnext=pnow/rndoff
      aq=(pnext+pnow)/2
      bq=(pnext-pnow)/2
      nq=10
      do iq=1,nq
         if (nq.eq.6) then
            uq=aq+bq*qp6(iq)
            wq=-c2*bq*qw6(iq)
         else if (nq.eq.10) then
            uq=aq+bq*qp10(iq)
            wq=-c2*bq*qw10(iq)
         endif
         pnow=uq
         if (iq.gt.1) then
            pnowi=1/pnow
            unow=1+enowi-pnowi
            if (xzz.le.zz) then
               rm2=(1-unow)/2
               rm=sqrt(rm2)
               rt=1+2*enow*rm2
               xnow=c5*2*enow*rm*sqrt(rt+enow2*rm2)/rt
               xnow=xnow*rndoff
               call terpa(snow,xnow,xnext,idis,a(1),ip,ir)
            endif
            dk=unow-1
            fact=snow*(enow*pnowi+pnow*enowi+dk*(2+dk))/enow2
            arg=fact
         endif
         siginc=siginc+wq*arg
         ebar=ebar+wq*arg*pnow/c3
      enddo
      if (unow.lt.-.9999) idone=1
   enddo

   !--compute final results
   ebar=ebar/siginc
   heat=e-ebar
   enext=big
   nq=nq+2
   return
   end subroutine iheat

   subroutine alax(nin,nlax,matd,fluor,ener,abs,heat,a,nes)
   !-------------------------------------------------------------------
   ! Generate fluorescence data in the Cashwell-Everett format.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util ! provides closz,error
   use endf ! provides endf parameters and routines
   ! externals
   integer::nin,nlax,matd,nes
   real(kr)::fluor(*)
   real(kr),dimension(nes)::ener,abs,heat
   real(kr)::a(*)
   ! internals
   integer::loc(50)
   integer::iz,nw,nb,nss,ll,iss,ntr,idis,i,jj,n,mm
   real(kr)::e,en,sig,slo,shi,ek,rhok,sum1,sum2
   real(kr)::el2,pl2,el3,pl3,tot,y,phi,rholt,elav,denom
   real(kr)::wt,ylt,flt,sum11,sum12,sum21,sum22,phik
   real(kr)::enl(3),rhol(3),wtl(3)
   real(kr),parameter::dn=.9999e0_kr
   real(kr),parameter::up=1.0001e0_kr
   real(kr),parameter::emev=1.e6_kr

   !--charge for desired material
   iz=matd/100

   !--read in the atomic relaxation file for the desired material
   call repoz(nin)
   call openz(nlax,0)
   call tpidio(nlax,0,0,a,nb,nw)
  110 call contio(nlax,0,0,a,nb,nw)
   if (math.gt.0) go to 120
   call error('alax','mat not found',' ')
  120 if (math.eq.matd) go to 130
   call tomend(nlax,0,0,a)
   go to 110
  130 call tofend(nlax,0,0,a)
   call contio(nlax,0,0,a,nb,nw)
   nss=n1h
   ll=1
   do iss=1,nss
      loc(iss)=ll
      if (ll.gt.nwscr) call error('alax',&
              'storage exceeded for the atomic relaxation data',' ')
      call listio(nlax,0,0,a(ll),nb,nw)
      ntr=n2h
      ll=ll+nw
      do while (nb.ne.0)
         if (ll.gt.nwscr) call error('alax',&
                 'storage exceeded for the atomic relaxation data',' ')
         call moreio(nlax,0,0,a(ll),nb,nw)
         ll=ll+nw
      enddo
   enddo

   !--read in the photoionization cross section for the material
   call openz(nin,0)
   call tpidio(nin,0,0,a(ll),nb,nw)
  210 call contio(nin,0,0,a(ll),nb,nw)
   if (math.gt.0) go to 220
   call error('spect','mat not found',' ')
  220 if (math.eq.matd) go to 230
   call tomend(nin,0,0,a(ll))
   go to 210
  230 call tofend(nin,0,0,a(ll))
   call findf(matd,23,522,nin)
   call contio(nin,0,0,a(ll),nb,nw)
   e=0
   call gety1(e,en,idis,sig,nin,a(ll))

   !--for z>30, get the l1, l2, and l3 edges and jumps
   if (iz.gt.30) then
      do i=1,3
         jj=loc(5-i)
         enl(4-i)=a(jj+6)
         e=dn*enl(4-i)
         call gety1(e,en,idis,slo,nin,a(ll))
         e=up*enl(4-i)
         call gety1(e,en,idis,shi,nin,a(ll))
         rhol(4-i)=slo/shi
      enddo
   endif

   !--get the energy and jump of the k edge
   ek=a(7)
   e=dn*ek
   call gety1(e,en,idis,slo,nin,a(ll))
   e=up*ek
   call gety1(e,en,idis,shi,nin,a(ll))
   rhok=slo/shi

   !--case of 11<z<20
   if (iz.gt.11.and.iz.lt.20) then

      !--average all the transitions to the k shell
      n=nint(a(6))
      sum1=0
      sum2=0
      do i=1,n
         jj=8+6*i
         if (nint(a(jj)).eq.0) then
            sum1=sum1+a(jj+2)
            sum2=sum2+a(jj+1)*a(jj+2)
         endif
      enddo
      sum2=sum2/sum1

      !--subtract the photon energy from the heating
      do i=1,nes
         if (ener(i).gt.ek/emev) heat(i)=heat(i)-abs(i)*sum1*sum2/emev
      enddo

      !--store the results
      fluor(1)=ek/emev
      fluor(2)=ek/emev
      fluor(3)=rhok
      fluor(4)=1
      fluor(5)=0
      fluor(6)=(1-rhok)*sum1
      fluor(7)=0
      fluor(8)=sum2/emev

   !--case of z>19 and z<31
   else if (iz.gt.19.and.iz.lt.31) then

      !--extract l2, l3, and total for higher shells
      n=nint(a(6))
      sum1=0
      sum2=0
      do i=1,n
         jj=8+6*i
         if (nint(a(jj)).eq.0.and.nint(a(jj-1)).eq.3) then
            el2=a(jj+1)
            pl2=a(jj+2)
         else if (nint(a(jj)).eq.0.and.nint(a(jj-1)).eq.4) then
            el3=a(jj+1)
            pl3=a(jj+2)
         else if (nint(a(jj)).eq.0.and.nint(a(jj-1)).gt.4) then
            sum1=sum1+a(jj+2)
            sum2=sum2+a(jj+1)*a(jj+2)
         endif
      enddo
      sum2=sum2/sum1

      !--subtract the photon energy from the heating
      do i=1,nes
         if (ener(i).gt.ek/emev) heat(i)=heat(i)-abs(i)&
           *(sum1*sum2+el2*pl2+el3*pl3)/emev
      enddo

      !--store the results
      tot=(pl2+pl3+sum1)/(1-rhok)
      y=0
      phi=rhok
      fluor(1)=ek/emev
      fluor(5)=phi
      fluor(9)=y
      fluor(13)=0
      phi=phi+pl3/tot
      y=y+(1-rhok)*pl3
      fluor(2)=ek/emev
      fluor(6)=phi
      fluor(10)=y
      fluor(14)=el3/emev
      phi=phi+pl2/tot
      y=y+(1-rhok)*pl2
      fluor(3)=ek/emev
      fluor(7)=phi
      fluor(11)=y
      fluor(15)=el2/emev
      phi=1
      y=y+(1-rhok)*sum1
      fluor(4)=ek/emev
      fluor(8)=phi
      fluor(12)=y
      fluor(16)=sum2/emev

   !--all other z values
   else
      rholt=rhol(1)*rhol(2)*rhol(3)
      elav=(enl(1)+enl(2)+enl(3))/3
      wtl(1)=1/rhol(1)
      wtl(2)=wtl(1)/rhol(2)
      wtl(3)=wtl(2)/rhol(3)
      denom=wtl(3)-1
      wtl(3)=(wtl(3)-wtl(2))/denom
      wtl(2)=(wtl(2)-wtl(1))/denom
      wtl(1)=(wtl(1)-1)/denom

      !--compute the average yield and energy for l fluorescence
      sum1=0
      sum2=0
      do iss=2,4
         jj=loc(iss)
         n=nint(a(jj+5))
         wt=wtl(iss-1)
         do i=1,n
            if (nint(a(jj+7+6*i)).eq.0) then
               sum1=sum1+a(jj+9+6*i)*wt
               sum2=sum2+a(jj+8+6*i)*a(jj+9+6*i)*wt
            endif
         enddo
      enddo
      sum2=sum2/sum1
      ylt=sum1
      flt=sum2
      if (flt.gt.enl(1)) then
         write(nsyso,'('' L edge problem'')')
         write(nsyso,'(1x,3f10.4)') flt,enl(1),elav
      endif

      !--extract kalpha1, kalpha2, kbeta1, and kbeta2
      n=nint(a(6))
      sum11=0
      sum12=0
      sum21=0
      sum22=0
      do i=1,n
         jj=8+6*i
         if (nint(a(jj)).eq.0) then
            mm=nint(a(jj-1))
            if (mm.eq.3) then
               el2=a(jj+1)
               pl2=a(jj+2)
            else if (mm.eq.4) then
               el3=a(jj+1)
               pl3=a(jj+2)
            else if (mm.ge.5.and.mm.le.9) then
               sum11=sum11+a(jj+2)
               sum12=sum12+a(jj+1)*a(jj+2)
            else if (mm.ge.10.and.mm.le.16) then
               sum21=sum21+a(jj+2)
               sum22=sum22+a(jj+1)*a(jj+2)
            endif
         endif
      enddo
      if (iz.ge.37) then
         sum22=sum22/sum21
      else
         sum11=sum11+sum21
         sum12=sum12+sum22
         sum21=0
      endif
      sum12=sum12/sum11

      !--subtract the photon energy from the heating
      do i=1,nes
         if (ener(i).gt.elav/emev) heat(i)=heat(i)-abs(i)*ylt*flt/emev
         if (ener(i).gt.ek/emev) heat(i)=heat(i)&
           -abs(i)*(sum11*sum12+sum21*sum22+el2*pl2+el3*pl3)/emev
      enddo

      !--store the results
      n=5
      if (iz.gt.36) n=6
      fluor(1)=elav/emev
      fluor(1+n)=rholt
      fluor(1+2*n)=0
      fluor(1+3*n)=0
      y=(1-rholt)*ylt
      fluor(2)=elav/emev
      fluor(2+n)=1
      fluor(2+2*n)=y
      fluor(2+3*n)=flt/emev
      phi=1/rhok
      phik=phi-1
      tot=(pl2+pl3+sum11+sum21)/phik
      phi=1
      phi=phi+pl3/tot
      y=y+phik*pl3
      fluor(3)=ek/emev
      fluor(3+n)=phi
      fluor(3+2*n)=y
      fluor(3+3*n)=el3/emev
      phi=phi+pl2/tot
      y=y+phik*pl2
      fluor(4)=ek/emev
      fluor(4+n)=phi
      fluor(4+2*n)=y
      fluor(4+3*n)=el2/emev
      phi=phi+sum11/tot
      y=y+phik*sum11
      fluor(5)=ek/emev
      fluor(5+n)=phi
      fluor(5+2*n)=y
      fluor(5+3*n)=sum12/emev
      if (iz.ge.37) then
         phi=phi+sum21/tot
         y=y+phik*sum21
         fluor(6)=ek/emev
         fluor(6+n)=phi
         fluor(6+2*n)=y
         fluor(6+3*n)=sum22/emev
      endif

   endif
   return
   end subroutine alax

   subroutine phoprt(hk)
   !-------------------------------------------------------------------
   ! Print ACE photon interaction data from memory.
   !-------------------------------------------------------------------
   use endf   ! provides iverf
   use mainio ! provides nsyso
   ! externals
   character(70)::hk
   ! internals
   integer::ieg,iinc,icoh,iabs,ipair,ihtng,i,j
   real(kr)::x
   character(14)::col(6)
   character(14)::blank='             '
   real(kr),parameter::zero=0

   !--print information block
   write(nsyso,'(''1''////////&
     &38x,''zaid'',1x,a13/39x,''awr'',f10.3/&
     &6x,''***********************'',9x,''temp'',1p,e10.2/&
     &6x,''*                     *'',9x,''date'',a10/&
     &6x,''*     photo-atomic    *'',10x,''mat'',a10/&
     &6x,''*                     *''/&
     &6x,''*   ace format file   *'',9x,''len2'',i10/&
     &6x,''*                     *'',12x,''z'',i10/&
     &6x,''*     processed by    *'',10x,''nes'',i10/&
     &6x,''*                     *'',9x,''nflo'',i10/&
     &6x,''*        njoy         *''/&
     &6x,''*                     *'',9x,''eszg'',i10/&
     &6x,''***********************'',9x,''jinc'',i10/&
     &38x,''jcoh'',i10/38x,''jflo'',i10/38x,''lhnm'',i10/&
     &//6x,''hk--- '',a70///)')&
     hz,aw0,tz,hd,hm,len2,z,nes,nflo,eszg,jinc,&
     jcoh,jflo,lhnm,hk

   !--print eszg block
   ieg=eszg-1
   iinc=ieg+nes
   icoh=iinc+nes
   iabs=icoh+nes
   ipair=iabs+nes
   ihtng=lhnm-1

   !--if this is a stand-alone acer iopt=7 job then iverf retains
   !  its default -1 value and the values written as natural logs
   !  need to be converted back to real numbers prior to printing.

   do i=1,nes
      if (mod(i,57).eq.1) write(nsyso,'(''1''/&
        &''     i'',8x,''energy'',4x,''incoherent'',&
        &6x,''coherent'',4x,''photoelect'',5x,''pair prod'',&
        &7x,''heating''/2x,''----'',4x,''----------'',4x,&
        &''----------'',4x,''----------'',4x,''----------'',&
        &4x,''----------'',4x,''----------'')')
      col(1)=blank
      x=xss(ieg+i)
      if (iverf.eq.-1.and.x.ne.zero) x=exp(x)
      if (x.ne.zero) write(col(1),'(1p,e14.4)') x
      col(2)=blank
      x=xss(iinc+i)
      if (iverf.eq.-1.and.x.ne.zero) x=exp(x)
      if (x.ne.zero) write(col(2),'(1p,e14.4)') x
      col(3)=blank
      x=xss(icoh+i)
      if (iverf.eq.-1.and.x.ne.zero) x=exp(x)
      if (x.ne.zero) write(col(3),'(1p,e14.4)') x
      col(4)=blank
      x=xss(iabs+i)
      if (iverf.eq.-1.and.x.ne.zero) x=exp(x)
      if (x.ne.zero) write(col(4),'(1p,e14.4)') x
      col(5)=blank
      x=xss(ipair+i)
      if (iverf.eq.-1.and.x.ne.zero) x=exp(x)
      if (x.ne.zero) write(col(5),'(1p,e14.4)') x
      col(6)=blank
      x=xss(ihtng+i)
      if (x.ne.zero) write(col(6),'(1p,e14.4)') x
      write(nsyso,'(1x,i5,6a14)') i,col
   enddo
   write(nsyso,'(/&
     &'' the above numbers are stored as logs on the ace file'')')

   !--print the incoherent scattering function
   write(nsyso,'(//&
     &'' incoherent scattering function''/&
     &'' ------------------------------'')')
   write(nsyso,'(1x,1p,6e14.4)') (xss(jinc-1+i),i=1,21)

   !--print the coherent from factors
   write(nsyso,'(//&
     &'' coherent sampling integral''/&
     &'' --------------------------'')')
   write(nsyso,'(1x,1p,6e14.4)') (xss(jcoh-1+i),i=1,55)
   write(nsyso,'(//&
     &'' coherent scattering function''/&
     &'' ----------------------------'')')
   write(nsyso,'(1x,1p,6e14.4)') (xss(jcoh+54+i),i=1,55)

   !--print the fluorescence data
   if (nflo.gt.0) then
      write(nsyso,'(//&
        &'' fluorescence data''/&
        &'' -----------------'')')
      write(nsyso,'(/&
        &''          edge       phi         y           f''/&
        &''    ----------   -------   -------   ---------'')')
      do i=1,nflo
         write(nsyso,'(3x,f11.7,f10.4,f10.4,2x,f10.6)')&
           (xss(jflo+i-1+nflo*(j-1)),j=1,4)
      enddo
   endif
   return
   end subroutine phoprt

   subroutine phoout(itype,nout,ndir,mcnpx,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Write photo-atomic ACE data to output and directory files.
   !-------------------------------------------------------------------
   use endf  ! provides iverf
   use util  ! provides openz,closz,error
   use acecm ! provides write routines
   ! externals
   integer::itype,nout,ndir,mcnpx
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::l,n,i,ll,nn,nern,lrec

   integer::ner=1
   integer::nbw=1

   !--branch according to ace file type
   if (itype.eq.1) call openz(nout,1)
   if (itype.eq.2) call openz(-nout,1)

   !--type 1

   !--write type-1 header block
   if (itype.eq.1) then
      if (mcnpx.eq.0) then
         write(nout,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hk,hm
      else
         write(nout,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz,aw0,tz,hd,hk,hm
      endif
      write(nout,'(4(i7,f11.0))') (izn(i),awn(i),i=1,16)
      write(nout,'(8i9)')&
        len2,z,nes,nflo,nxsd(1:12),&
        eszg,jinc,jcoh,jflo,lhnm,jxsd(1:27)

      !--eszg block.
      !  convert to natural log, if not already done, prior to writing
      l=eszg
      n=5*nes
      do i=1,n
         if (xss(l).ne.0..and.iverf.ne.-1) xss(l)=log(xss(l))
         call typen(l,nout,2)
         l=l+1
      enddo

      !--form factor blocks
      n=21+2*55
      l=jinc
      do i=1,n
         call typen(l,nout,2)
         l=l+1
      enddo

      !--fluorescence data block
      l=jflo
      if (nflo.ne.0) then
         do i=1,4*nflo
            call typen(l,nout,2)
            l=l+1
         enddo
      endif

      !--heating block
      l=lhnm
      do i=1,nes
         call typen(l,nout,2)
         l=l+1
      enddo

      !--finished
      call typen(l,nout,3)
      nern=0
      lrec=0

   !--write ace file in type 2 format
   else
      if (mcnpx.eq.0) then
         write(nout) hz(1:10),aw0,tz,hd,hk,hm,(izn(i),awn(i),i=1,16),&
           len2,z,nes,nflo,nxsd(1:12),&
           eszg,jinc,jcoh,jflo,lhnm,jxsd(1:27)
      else
         write(nout) hz(1:13),aw0,tz,hd,hk,hm,(izn(i),awn(i),i=1,16),&
           len2,z,nes,nflo,nxsd(1:12),&
           eszg,jinc,jcoh,jflo,lhnm,jxsd(1:27)
      endif
      ll=0
      nn=len2
      do while (nn.gt.0)
         n=nn
         if (n.gt.ner) n=ner
         write(nout) (xss(ll+i),i=1,n)
         ll=ll+n
         nn=nn-n
      enddo
      nern=ner
      lrec=ner*nbw
   endif

   !--output directory for mcnp
   call openz(ndir,1)
   if (mcnpx.eq.0) then
      write(ndir,&
        '(a10,f12.6,'' filename route'',i2,'' 1 '',i8,2i6,1p,e10.3)')&
        hz(1:10),aw0,itype,len2,lrec,nern,tz
   else
      write(ndir,&
        '(a13,f12.6,'' filename route'',i2,'' 1 '',i8,2i6,1p,e10.3)')&
        hz(1:13),aw0,itype,len2,lrec,nern,tz
   endif
   call closz(ndir)
   return
   end subroutine phoout

end module acepa

module aceth
   ! provides thermal ace stuff
   use locale
   use acecm, only: xss,nxss
   implicit none
   private

   !--Public routines
   public acesix,thrfix

   !--Private global variables

   ! ace header parameters
   character(13)::hz
   character(10)::hd
   character(10)::hm
   real(kr)::aw0,tz

   ! ace nxs parameters for thermal data
   integer::len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd(8)

   ! ace jxs parameters for thermal data
   integer::itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd(23)

   ! body of the ace data
   integer::nei
   real(kr),dimension(5000)::wt
   integer,dimension(5000)::ndp

contains

   subroutine acesix(nin,nace,ndir,matd,tempd,tname,suff,&
     hk,izn,awn,&
     mti,nbin,mte,ielas,nmix,emax,iwt,iprint,mcnpx)
   !-------------------------------------------------------------------
   ! Convert thermal matrices in njoy MF6 format to various ACE
   ! thermal formats.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util ! provides openz,repoz,mess,error,closz
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nace,ndir,matd
   integer::mti,nbin,mte,mtec,mtei,ielas,nmix,iwt,iprint,mcnpx
   real(kr)::tempd,suff,emax
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   character(6)::tname
   ! internals
   integer::nw,nwscr,nb,indx,nwt,idis,law
   integer::ninmax,nea,j,idone,nee,i,neie,loc,iee,iea
   integer::ne,ie,nl,nep,is,nl1,l,isl,isn,k,itype,nang,nn
   real(kr)::fract,x
   real(kr)::temp,em,e,enext,clast,cnow,wtt,emin,sum
   real(kr)::grall,xl,yl,y,add,xn,yn,f,disc,sign,xbar,xlo,xhi
   real(kr)::area
   real(kr)::delta
   character(60)::strng
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::xs
   real(kr),dimension(:),allocatable::six
   real(kr),parameter::eps=1.e-5_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ttol=1

   integer::nout=10
   integer::nscr=11

   !--check for thermal data
   if (nace.eq.0.and.iprint.eq.0) then
      call closz(nscr)
      call closz(-nout)
      return
   endif

   !--process the thermal data
   nxsd=0
   jxsd=0
   xss=0
   ninmax=5000000
   call openz(nin,0)
   nscr=iabs(nscr)
   if (nin.lt.0) nscr=-nscr
   call openz(nscr,1)
   call repoz(nscr)
   nout=iabs(nout)
   call openz(-nout,1)
   call repoz(-nout)
   call repoz(nin)

   !--allocate storage
   nw=npage+50
   allocate(xs(nw))
   allocate(six(ninmax))
   nwscr=5000000
   allocate(scr(nwscr))

   !--determine what endf version is being used
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' using endf-'',i1,'' format'')') iverf

   !--find desired temperature on pendf tape
   call repoz(nin)
   call tpidio(nin,0,0,xs,nb,nw)
   temp=0
   delta=ttol
   do while (delta.ge.ttol)
      call contio(nin,0,0,xs,nb,nw)
      aw0=xs(2)
      if (iverf.ge.5) call contio(nin,0,0,xs,nb,nw)
      if (iverf.ge.6) call contio(nin,0,0,xs,nb,nw)
      call contio(nin,0,0,xs,nb,nw)
      temp=xs(1)
      delta=abs(temp-tempd)
      if (delta.ge.ttol) call tomend(nin,0,0,xs)
   enddo

   !--copy incoherent inelastic cross section to nscr
   call findf(matd,3,mti,nin)
   call contio(nin,0,nscr,xs,nb,nw)
   call tosend(nin,0,nscr,xs)

   !--determine mt numbers for coherent and incoherent elastic
   mtec=0
   mtei=0
   if (mte.ne.0) then
      if (ielas.eq.0.or.ielas.eq.2) then
         mtec=mte
         if (ielas.eq.2) mtei=mte+1
      else
         mtei=mte
      endif
   endif

   !--copy incoherent elastic if it is present
   !--coherent elastic (Bragg edges) needs additional processing
   if (mtei.ne.0) then
      call findf(matd,3,mtei,nin)
      call contio(nin,0,nscr,xs,nb,nw)
      call tosend(nin,0,nscr,xs)
   endif

   !--determine or check emax
   call repoz(nscr)
   call contio(nscr,0,0,scr,nb,nw)
   indx=1
   nwt=0
   call tab1io(nscr,0,0,scr(indx),nb,nw)
   indx=indx+nw
   nwt=nwt+nw
   do while (nb.ne.0)
      if (indx.gt.nwscr-npage) call error('aceth',&
        'exceeded scr storage',' ')
      call moreio(nscr,0,0,scr(indx),nb,nw)
      indx=indx+nw
      nwt=nwt+nw
   enddo
   em=scr(nwt-3)
   if (scr(nwt-2).lt.eps) em=scr(nwt-5)
   if (emax.gt.em) then
      write(strng,'(''emax reset to '',1p,e12.4)') em
      call mess('acesix',strng,' ')
   endif
   if (emax.gt.em) emax=em

   !--check for elastic data
   if (mte.eq.0) then
      ! size of the coherent and incoherent elastic blocks are all zero
      write(nout) 0,0
      write(nout) 0,0
   else

      !--process coherent reaction if requested
      if (mtec.ne.0) then
         call findf(matd,3,mtec,nin)
         call contio(nin,0,0,scr,nb,nw)
         e=0
         call gety1(e,enext,idis,x,nin,scr)

         !--locate bragg edges and compute cumulative probabilities
         loc=1
         j=0
         clast=0
         idone=0
         do while (idone.eq.0)
            e=enext
            call gety1(e,enext,idis,x,nin,scr)
            cnow=e*x
            if (enext.gt.emax.or.abs(enext-emax).le.eps) then
               idone=1
            else
               if ((cnow-clast).gt.(clast+1)/1000000) then
                  j=j+1
                  if (2*j.gt.ninmax) call error('acesix',&
                    'storage six exceeded for coherent reactions.',' ')
                  six(loc)=e
                  six(loc+1)=cnow
                  clast=cnow
                  loc=loc+2
               endif
            endif
         enddo

         !--write out coherent reaction record
         nee=j
         write(nout) nee,0
         write(nout) (six(i),i=1,2*nee)
      else
         write(nout) 0,0
      endif

      !--incoherent elastic
      if (mtei.ne.0) then
         call findf(matd,6,mtei,nin)
         call contio(nin,0,0,scr,nb,nw)
         call tab1io(nin,0,0,scr,nb,nw)
         call tab2io(nin,0,0,scr,nb,nw)
         nee=nint(scr(6))
         neie=0
         call repoz(nscr)
         call findf(matd,3,mtei,nscr)
         call contio(nscr,0,0,xs,nb,nw)
         e=0
         call gety1(e,enext,idis,x,nscr,xs)
         loc=1
         idone=0
         iee=0
         do while (iee.lt.nee.and.idone.eq.0)
            iee=iee+1
            indx=1
            call listio(nin,0,0,scr(indx),nb,nw)
            indx=indx+nw
            if (indx.gt.nwscr) call error('acesix',&
              'exceeded scr storage for incoherent elastic',' ')
            do while (nb.ne.0)
               if (indx.gt.nwscr-npage) call error('acesix',&
                 'exceeded scr storage for incoherent elastic',' ')
               call moreio(nin,0,0,scr(indx),nb,nw)
               indx=indx+nw
            enddo
            nea=nint(scr(6))-1
            e=scr(7)
            if (e.gt.emax.or.abs(e-emax).lt.eps) then
               idone=1
            else
               neie=neie+1
               call gety1(e,enext,idis,x,nscr,xs)
               if (loc.gt.ninmax-nea-1) call error('acesix',&
                 'exceeded six storage for incoherent elastic',' ')
               six(loc)=e
               six(loc+1)=x
               do iea=2,nea
                     six(iea+loc)=scr(iea+7)
               enddo
               loc=loc+1+nea
            endif
         enddo
         loc=loc-1
         nea=nea-1
         write(nout) neie,nea
         write(nout) (six(i),i=1,loc)
      else
         write(nout) 0,0
      endif
   endif

   !--find inelastic energy-angle distribution
   call findf(matd,6,mti,nin)
   call contio(nin,0,0,scr,nb,nw)
   call tab1io(nin,0,0,scr,nb,nw)
   law=l2h
   if (law.ne.1) call error('acesix',&
     'coded for E-E-mu ordering only.',' ')
   call tab2io(nin,0,0,scr,nb,nw)
   ne=nint(scr(6))
   call repoz(nscr)
   nei=0
   call contio(nscr,0,0,xs,nb,nw)
   e=0
   call gety1(e,enext,idis,x,nscr,xs)

   !--construct pattern of weights (constant or variable)
   !--if needed
   if (iwt.eq.0) then
      wtt=1
      wtt=wtt/10
      wtt=wtt/(nbin-3)
      do i=1,nbin
         wt(i)=10*wtt
         if (i.eq.1.or.i.eq.nbin) wt(i)=wtt
         if (i.eq.2.or.i.eq.nbin-1) wt(i)=4*wtt
      enddo
      write(nsyso,'(/&
        &'' relative weights for energy bins are  '',&
        &''1  4  10...10  4  1'')')
   else if (iwt.eq.1) then
      wtt=1
      wtt=wtt/nbin
      do i=1,nbin
         wt(i)=wtt
      enddo
      write(nsyso,'(/'' constant weighting for energy bins'')')
   else
      write(nsyso,'(/'' tabulated probability distribution''//&
        &'' original and modified number of secondary energies'')')
   endif

   !--loop over incident energies
   len2=0
   do 210 ie=1,ne
   call listio(nin,0,0,scr,nb,nw)
   e=scr(2)
   emin=1
   emin=emin/1000000
   emin=emin+emin/1000000
   if (ie.eq.1.and.e.lt.emin) e=emin
   if (e.gt.emax) go to 290
   if (abs(e-emax).lt.eps) go to 290
   nei=nei+1
   nl=nint(scr(6))
   nang=nl-2
   nep=nint(scr(5)/nl)
   indx=1+nw
   do while (nb.ne.0)
      if (indx.gt.nwscr-npage) call error('acesix',&
        &'exceeded scr storage for incoherent inelastic.',' ')
      call moreio(nin,0,0,scr(indx),nb,nw)
      indx=indx+nw
   enddo

   !--fix the angular distribution of the first and last points
   nn=2+nang
   isn=8
   do i=1,nang
      scr(isn+i)=scr(isn+i+nn)
   enddo
   isn=8+nl*(nep-1)
   do i=1,nang
      scr(isn+i)=scr(isn+i-nn)
   enddo

   !--get cross section
   call gety1(e,enext,idis,x,nscr,xs)
   six(1)=e
   six(2)=x
   loc=3
   is=1
   nl1=nl
   nn=0

   !--determine equal or variable probable energies
   if (iwt.le.1) then
      fract=wt(1)
   else
      fract=1
   endif
   sum=0
   grall=0
   xl=scr(is+6)
   yl=scr(is+7)
   i=0
   j=0
   l=2
  240 continue
   if (i.ge.nep) go to 285
   i=i+1
   x=scr(is+6+nl1*(i-1))
   y=scr(is+7+nl1*(i-1))
  250 continue
   add=(y+yl)*(x-xl)/2
   if (x.eq.xl) go to 280
   if (iwt.le.1.and.i.eq.nep.and.j.eq.nbin-1) then
      xn=x
      j=j+1
      go to 270
   endif
   if (iwt.gt.1.and.i.eq.nep) then
      xn=x
      fract=sum+add
      j=j+1
      go to 270
   endif
   if (iwt.gt.1) then
     if (sum+add.gt.eps/10) fract=sum+add
     !if (fract.gt.one/nbin) fract=one/nbin
   endif
   if (sum+add.ge.fract-fract/10000) go to 260
   sum=sum+add
   grall=grall+(yl-(y-yl)*xl/(x-xl))*(x*x-xl*xl)/2+&
     ((y-yl)/(x-xl))*(x**3-xl**3)/3
   go to 280
  260 continue
   j=j+1
   if (sum+add.lt.fract+fract/10000) then
      xn=x
   else if (abs(y-yl).gt.(y+yl)/100000) then
      f=(y-yl)/(x-xl)
      disc=(yl/f)**2+2*(fract-sum)/f
      if (disc.lt.zero) then
         write(strng,'(''disc='',1p,e12.4)') disc
         call mess('acesix',strng,'set to abs value and continue')
         disc=-disc
      endif
      sign=1
      if (f.lt.zero) sign=-1
      xn=xl-(yl/f)+sign*sqrt(disc)
      if (xn.le.xl.or.xn.gt.x) then
         call error('acesix','solution out of range1',' ')
      endif
   else
      xn=xl+(fract-sum)/yl
      if (xn.gt.x) then
         xn=x
      else
         if (xn.le.xl.or.xn.gt.x) then
            call error('acesix','solution out of range2',' ')
         endif
      endif
   endif
 270 continue
   yn=yl+(y-yl)*(xn-xl)/(x-xl)
   sum=sum+(yn+yl)*(xn-xl)/2
   grall=grall+(yl-(y-yl)*xl/(x-xl))*(xn*xn-xl*xl)/2+&
     ((y-yl)/(x-xl))*(xn**3-xl**3)/3
   xbar=grall/sum
   l=2
   do
      xlo=scr(7+nl1*(l-2))
      xhi=scr(7+nl1*(l-1))
      if (l.eq.nep) exit
      if (iwt.le.1) then
         if (xhi.ge.xbar) exit
      endif
      if (iwt.eq.2) then
         if (xhi.ge.xn) exit
      endif
      l=l+1
   enddo
   if (loc.gt.ninmax-nang) call error('acesix','exceeded storage in six',' ')
   nn=nn+1
   isl=is+7+nl1*(l-2)
   isn=is+7+nl1*(l-1)
   if (iwt.le.1) then
      six(loc)=xbar
   else
      six(loc)=xn
      loc=loc+1
      six(loc)=yn
      loc=loc+1
      six(loc)=fract
   endif
   do k=1,nang
      if (iwt.le.1) then
         six(k+loc)=scr(k+isl)&
           +(scr(k+isn)-scr(k+isl))*(xbar-xlo)/(xhi-xlo)
      else
         if (abs(xn-xhi).lt.eps) then
            six(k+loc)=scr(k+isn)
         else if (abs(xn-xlo).lt.eps) then
            six(k+loc)=scr(k+isl)
         else
            six(k+loc)=scr(k+isl)+&
             (scr(k+isn)-scr(k+isl))*(xn-xlo)/(xhi-xlo)
         endif
      endif
      if ((six(k+loc).lt.-1.0e0_kr).or.(six(k+loc).gt.1.0e0_kr)) then
         write(strng,'(''cosine '',f12.8,&
                     &'' outside [-1,1] range for e_in -> e_out '',&
                     &1p,e13.6,1x,e13.6,&
                     &'',  bin_mu= '',i4)') six(k+loc),e,xbar,k
         if (six(k+loc).lt.-1.0e0_kr) then
            six(k+loc) = -1.0e0_kr
            call mess('acesix',strng,'cosine set to -1.0')
         endif
         if (six(k+loc).gt.1.0e0_kr) then
            six(k+loc) = 1.0e0_kr
            call mess('acesix',strng,'cosine set to 1.0')
         endif
      endif
   enddo
   loc=loc+1+nang
   xl=xn
   yl=yn
   if (iwt.le.1) then
      fract=wt(j+1)
   else
      fract=1
   endif
   sum=0
   grall=0
   if (iwt.le.1.and.j.eq.nbin) go to 285
   if (xl.lt.x) go to 250
  280 continue
   xl=x
   yl=y
   go to 240
  285 continue

   !--check normalization for tabulated distribution
   if (iwt.gt.1) then
      area=0
      j=3
      do i=1,nn
         area=area+six(j+2)
         six(j+2)=area
         j=j+3+nang
      enddo
      j=3
      do i=1,nn
         six(j+1)=six(j+1)/area
         six(j+2)=six(j+2)/area
         j=j+3+nang
      enddo
      write(nsyso,'(6x,3i8)') ie,nep,nn
   endif

   !--write incoherent reaction record for this energy
   loc=loc-1
   len2=len2+loc-2
   ndp(ie)=loc
   write(nout) (six(i),i=1,loc)
  210 continue
  290 continue

   !--write ace format thermal tape
   call thrlod(nout,matd,tempd,tname,suff,izn,&
     nbin,nang,nmix,iwt,mcnpx)
   if (iprint.gt.0) call thrprt(hk)
   itype=1
   call throut(itype,nace,ndir,mcnpx,hk,izn,awn)

   !--finished with thermal data
   call closz(nscr)
   call closz(-nout)
   return
   end subroutine acesix

   subroutine thrfix(itype,nin,nout,ndir,iprint,nplot,mcnpx,suff,&
     nxtra,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Print and or edit an ACE thermal file.
   !-------------------------------------------------------------------
   use util  ! provides closz
   use acecm ! provides newsuff
   ! externals
   integer::itype,nin,nout,ndir,iprint,nplot,mcnpx,nxtra
   real(kr)::suff
   character(70)::hk
   integer::izn(16)
   real(kr)::awn(16)
   ! internals
   integer::l,j,n,max,i
   integer::indx,idiff,isuff,lenhz
   integer::izo(16)
   real(kr)::awo(16)
   character(70)::hko
   real(kr),parameter::zero=0

   integer,parameter::ner=1
   integer,parameter::nbw=1

   !--read type 1 ace format file
   call openz(nin,0)
   if (itype.eq.1) then
      if (mcnpx.eq.0) then
         read(nin,&
           '(a10,e12.0,e12.0,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hko,hm
      else
         read(nin,&
           '(a13,f12.0,e12.0,1x,a10/a70,a10)')&
           hz(1:13),aw0,tz,hd,hko,hm
      endif
      read (nin,'(4(i7,f11.0))') (izo(i),awo(i),i=1,16)
      read (nin,'(8i9)')&
        len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd,&
        itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd
      n=(len2+3)/4
      n=n-1
      l=0
      read (nin,'(4e20.0)') xss(1:len2)

   !--read type 2 ace format file
   else if (itype.eq.2) then
      if (mcnpx.eq.0) then
        read(nin) hz(1:10),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd,&
          itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd
      else
        read(nin) hz(1:13),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd,&
          itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd
      endif
      n=(len2+ner-1)/ner
      l=0
      do i=1,n
         max=len2-l
         if (max.gt.ner) max=ner
         read (nin) (xss(l+j),j=1,max)
         l=l+max
      enddo
      call closz(-nin)
   endif

   !--adjust zaid
   if (suff.ge. 0._kr) call newsuff(mcnpx,suff,hz)

   !--adjust comment and (iz,aw) list
   if (len_trim(hk).eq.0) then
      hk=hko
   endif
   if (nxtra.eq.0) then
      do i=1,16
         izn(i)=izo(i)
         awn(i)=awo(i)
      enddo
   endif

   !--print, plot, and/or write the file.
   if (iprint.gt.0) call thrprt(hk)
   if (nout.gt.0) call throut(itype,nout,ndir,mcnpx,hk,izn,awn)
   if (nplot.ne.0) call tplots(nplot,hk)

   return
   end subroutine thrfix

   subroutine thrlod(nin,matd,tempd,tname,suff,izn,&
     nbini,nang,nmix,iwt,mcnpx)
   !-------------------------------------------------------------------
   ! write a thermal output tape in ace format.
   !-------------------------------------------------------------------
   use physics ! provides bk
   use util ! provides date,repoz
   use mainio ! provides nsyso
   ! externals
   integer::nin,matd,nbini,nang,nmix,iwt,mcnpx
   real(kr)::tempd,suff
   integer::izn(16)
   character(6)::tname
   ! internals
   integer::nwscr,nw,i,loc,indx,j,k,jang,start,middle
   integer::nee,nea
   character(8)::hdt
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::emev=1.e6_kr

   !--initialize
   nwscr=5000000
   allocate(scr(nwscr))
   write(hm,'(''   mat'',i4)') matd
   tz=tempd*bk/emev
   if (mcnpx.eq.0) then
      write(hz,'(a6,f3.2,''t'')') tname,suff
   else
      write(hz,'(a6,f4.3,''nt '')') tname,suff
   endif
   call dater(hdt)
   hd='  '//hdt
   ncl=0
   idpni=3
   idpnc=0
   ifeng=0
   if (iwt.eq.0) ifeng=1
   if (iwt.eq.2) ifeng=2
   call repoz(-nin)

   !--assign pointers in xss array
   itie=1
   itix=itie+1+nei
   itxe=itix+nei
   itce=0
   itcx=0
   itca=0
   itcei=0
   itcxi=0
   itcai=0

   !--xss length
   if (ifeng.gt.1) len2=len2+2*nei
   len2=len2+itxe-1
   if (len2.gt.nxss) then
      write(nsyso,'(i10)') len2
      call error('thrlod','xss too small',' ')
   endif

   !--read first elastic block - coherent elastic
   nee=0
   nea=0
   read(nin) nee,nea

   !--assign pointers in xss array
   if (nee.gt.0) then

     !--set idpnc value
     idpnc=4

     !--assign pointers in xss array
     itce=len2+1
     itcx=itce+nee+1
     itca=0
     !--xss length
     len2=len2+2*nee+1
     if (len2.gt.nxss) then
        write(nsyso,'(i10)') len2
        call error('thrlod','xss too small',' ')
     endif

     !--nxs values
     ncl=-1

     !--fill xss array
     xss(itce)=nee
     nw=2*nee
     if (nw.gt.nwscr) call error('thrlod','scr exceeded',' ')
     read(nin) (scr(i),i=1,nw)
     do i=1,nee
        xss(i+itce)=scr(1+2*(i-1))/emev
        xss(i+nee+itce)=scr(2+2*(i-1))/emev/nmix
     enddo

   endif

   !--read second elastic block - incoherent elastic
   nee=0
   nea=0
   start=0
   middle=0
   read(nin) nee,nea

   !--assign pointers in xss array
   if (nee.gt.0) then

     if (idpnc.eq.0) then

        !--set idpnc value
        idpnc=3

        !--assign pointers in xss array
        itce=len2+1
        itcx=itce+nee+1
        itca=itcx+nee

        !--xss length
        len2=itca+nee*nea-1
        if (len2.gt.nxss) then
           write(nsyso,'(i10)') len2
           call error('thrlod','xss too small',' ')
        endif

        !--nxs values
        ncl=nea-1

        !--set indices
        start=itce
        middle=itca

     else

        !--set idpnc value
        idpnc=5

        !--assign pointers in xss array
        itcei=len2+1
        itcxi=itcei+nee+1
        itcai=itcxi+nee

        !--xss length
        len2=itcai+nee*nea-1
        if (len2.gt.nxss) then
           write(nsyso,'(i10)') len2
           call error('thrlod','xss too small',' ')
        endif

        !--nxs values
        ncli=nea-1

        !--set indices
        start=itcei
        middle=itcai

     endif

     !--fill xss array
     xss(start)=nee
     nw=nee*(2+nea)
     if (nw.gt.nwscr) call error('thrlod','scr exceeded',' ')
     read(nin) (scr(i),i=1,nw)
     loc=middle-1
     indx=1
     do i=1,nee
        xss(start+i)=scr(indx)/emev
        xss(start+nee+i)=scr(indx+1)/nmix
        do j=1,nea
           xss(j+loc)=scr(indx+1+j)
        enddo
        loc=loc+nea
        indx=indx+nea+2
     enddo

   endif

   !--process inelastic data
   nieb=nbini
   if (ifeng.le.1) then
      nil=nang-1
   else
      nil=nang+1
   endif
   xss(itie)=nei
   indx=itxe-1
   if (ifeng.gt.1) indx=indx+2*nei
   do i=1,nei
      nw=ndp(i)
      if (nw.gt.nwscr) call error('thrlod','scr exceeded',' ')
      read(nin) (scr(j),j=1,nw)
      nw=nw-2
      xss(itie+i)=scr(1)/emev
      xss(itie+nei+i)=scr(2)/nmix
      if (ifeng.gt.1) then
         xss(itxe-1+i)=indx
         xss(itxe-1+nei+i)=nw/(nang+3)
      endif
      k=0
      do while (k.lt.nw-1)
         k=k+1
         xss(indx+k)=scr(2+k)/emev
         if (ifeng.gt.1) then
            k=k+1
            xss(indx+k)=scr(2+k)*emev
            k=k+1
            xss(indx+k)=scr(2+k)
         endif
         do jang=1,nang
            k=k+1
            xss(indx+k)=scr(2+k)
         enddo
      enddo
      indx=indx+k
   enddo
   return
   end subroutine thrlod

   subroutine thrprt(hk)
   !-------------------------------------------------------------------
   ! Print thermal ACE data.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   ! externals
   character(70)::hk
   ! internals
   integer::nie,nee,neei,loc,nang,nbini,nln,lim,lim1,i,lines
   integer::j,k,nea,ncol,npg,ipg,indx,mcol,ifini,ne,start,middle
   integer::ind(4)
   real(kr)::b(4),c(4)
   character(10),parameter::labl1='bragg edge'
   character(7),parameter::labl2='e*cross'
   character(1),parameter::labl3='i'
   character(6),parameter::labl4='energy'
   character(7),parameter::labl5='section'
   character(10),parameter::dash4='    '
   character(10),parameter::dash10='          '

   !--print thermal header information
   nie=nint(xss(itie))
   nee=0
   neei=0
   if (itce.gt.0) nee=nint(xss(itce))
   if (itcei.gt.0) neei=nint(xss(itcei))
   write(nsyso,'(''1''///////&
     &38x,''zaid'',1x,a13/39x,''awr'',f10.3/&
     &38x,''temp'',1p,e10.2/38x,''date'',a10/39x,''mat'',a10/&
     &6x,''***********************''/&
     &6x,''*                     *'',9x,''len2'',i10/&
     &6x,''*       thermal       *'',8x,''idpni'',i10/&
     &6x,''*                     *'',10x,''nil'',i10/&
     &6x,''*   ace format file   *'',9x,''nieb'',i10/&
     &6x,''*                     *'',8x,''idpnc'',i10/&
     &6x,''*     processed by    *'',10x,''ncl'',i10/&
     &6x,''*                     *'',8x,''ifeng'',i10/&
     &6x,''*        njoy         *'',9x,''ncli'',i10/&
     &6x,''*                     *''/&
     &6x,''***********************'',9x,''itie'',i10/&
     &38x,''itix'',i10/38x,''itxe'',i10/38x,''itce'',i10/&
     &38x,''itcx'',i10/38x,''itca'',i10/37x,''itcei'',i10/&
     &37x,''itcxi'',i10/37x,''itcai'',i10//39x,''nie'',i10/&
     &39x,''nee'',i10/38x,''neei'',i10///&
     &6x,''hk---'',a70)')&
     hz,aw0,tz,hd,hm,len2,idpni,nil,nieb,idpnc,ncl,&
     ifeng,ncli,itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,nie,nee,neei,hk

   !--print inelastic data
   loc=itxe-1
   if (ifeng.gt.1) loc=loc+2*nie
   ne=nie
   do i=1,ne
      if (ifeng.le.1) then
         nang=nil+1
         nbini=nieb
      else
         nang=nil-1
         nbini=nint(xss(itxe-1+ne+i))
      endif
      nln=((nang+7)/8)*nbini
      if (ifeng.le.1) then
         lim=nang+1
         if (nang.gt.8) lim=9
      else
         lim=nang+3
        if (nang.gt.8) lim=11
      endif
      lim1=lim+1
      if (i.eq.1) then
         write(nsyso,'(/&
           &'' inelastic data - equally probable angles''/&
           &'' ----------------------------------------''/)')
         lines=4
      else
         if ((lines+nln+4).gt.58) then
            write(nsyso,'(''1'')')
            lines=1
         endif
      endif
       write(nsyso,'(/6x,''incident energy = '',1p,e13.6,8x,&
         &''cross section = '',e13.6)') xss(itie+i),xss(itie+ne+i)
       write(nsyso,'(5x,'' num of e-prime '',i5)') nbini
       if (ifeng.le.1) then
          write(nsyso,'(/&
            &9x,''exit energy'',5x,''cosines''/9x,''-----------'',&
            &4x,8(''------------''))')
       else
          write(nsyso,'(/&
            &9x,''exit energy'',8x,''pdf'',11x,''cdf'',10x,''cosines''/&
            &9x,''-----------'',4x,''-----------'',&
            &3x,''------------'',4x,8(''------------''))')
       endif
       lines=lines+4
       do j=1,nbini
         if (ifeng.le.1) then
            write(nsyso,'(7x,1p,e13.6,1x,0p,8f12.6)')&
              (xss(k+loc),k=1,lim)
            if (nang.gt.8) write(nsyso,'(21x,8f12.6)')&
              (xss(loc+k),k=lim1,nang+1)
         else
            write(nsyso,'(7x,1p,e13.6,e15.6,e15.6,1x,0p,8f12.6)')&
              (xss(k+loc),k=1,lim)
            if (nang.gt.8) write(nsyso,'(51x,8f12.6)')&
              (xss(loc+k),k=lim1,nang+3)
         endif
         if (ifeng.le.1) then
            loc=loc+nang+1
         else
            loc=loc+nang+3
         endif
      enddo
      lines=lines+nln
   enddo

   !--check for elastic data
   if (idpnc.eq.0) return

   if (idpnc.eq.4.or.idpnc.eq.5) then
      write(nsyso,'(''1''/&
        &'' coherent elastic data - bragg edges and cumulative '',&
        &''intensity''/&
        &'' ---------------------------------------------------'',&
        &''---------'')')
      ncol=(nee+49)/50
      npg=(ncol+3)/4
      ipg=0
      indx=itce+1
      do while (ipg.lt.npg)
         ipg=ipg+1
         if (ipg.gt.1) write(nsyso,'(''1'')')
         mcol=ncol
         if (mcol.gt.4) mcol=4
         ncol=ncol-mcol
         write(nsyso,'(/4(9x,a10,5x,a7,1x))') (labl1,labl2,j=1,mcol)
         write(nsyso,'(5x,3(a1,5x,a6,7x,a7,6x),a1,5x,a6,7x,a7)')&
           (labl3,labl4,labl5,j=1,mcol)
            write(nsyso,'(4(2x,a4,3x,a10,3x,a10))')&
           (dash4,dash10,dash10,j=1,mcol)
         ifini=0
         i=0
         do while (i.lt.50.and.ifini.eq.0)
            i=i+1
            ind(1)=indx-itce
            b(1)=xss(indx)
            c(1)=xss(indx+nee)
            if (mcol.gt.1) then
               ind(2)=indx+50-itce
               b(2)=xss(indx+50)
               c(2)=xss(indx+nee+50)
               if (mcol.gt.2) then
                  ind(3)=indx+100-itce
                  b(3)=xss(indx+100)
                  c(3)=xss(indx+nee+100)
                  if (mcol.gt.3) then
                     ind(4)=indx+150-itce
                     b(4)=xss(indx+150)
                     c(4)=xss(indx+nee+150)
                  endif
               endif
            endif
            write(nsyso,&
              '(i6,1p,2e13.4,i6,2e13.4,i6,2e13.4,i6,2e13.4)')&
              (ind(j),b(j),c(j),j=1,mcol)
            indx=indx+1
            if (ipg.ge.npg) then
               if (indx-itce.gt.nee) ifini=1
               if (ifini.ne.1) then
                  if ((indx-itce+(mcol-1)*50).gt.nee) mcol=mcol-1
                  if (mcol.eq.0) ifini=1
               endif
            endif
         enddo
         if (ifini.eq.0) indx=itce+1+200*ipg
      enddo
   endif

   !--print incoherent elastic data
   if (idpnc.eq.3.or.idpnc.eq.5) then
      start=itce
      middle=itca
      nea=ncl+1
      if (idpnc.eq.5) then
         start=itcei
         middle=itcai
         nea=ncli+1
      endif
      write(nsyso,'(''1''/&
        &'' incoherent elastic data - equally probable angles''/&
        &'' -------------------------------------------------''/)')
      write(nsyso,'(/&
        &9x,''incident'',9x,''cross''/&
        &4x,''i'',5x,''energy'',9x,''section'',25x,''angles'')')
      lines=7
      nln=(nea+8)/9
      lim=nea
      if (nea.gt.8) lim=8
      lim1=lim+1
      loc=middle-1
      do i=1,neei
         if ((lines+nln).gt.58) then
            write(nsyso,'(''1'')')
            write(nsyso,'(/&
              &9x,''incident'',9x,''cross''/&
              &4x,''i'',5x,''energy'',9x,''section'',25x,''angles'')')
            lines=4
         endif
         write(nsyso,'(/2x,i3,1x,1p,e12.4,3x,e12.4,3x,0p,8f10.4)')&
           i,xss(start+i),xss(start+neei+i),(xss(loc+j),j=1,lim)
         if (nea.gt.8) write(nsyso,'(36x,8f10.4)')&
           (xss(loc+j),j=lim1,nea)
         loc=loc+nea
         lines=lines+nln
      enddo
   endif
   return
   end subroutine thrprt

   subroutine tplots(nout,hk)
   !-------------------------------------------------------------------
   ! Do standard plots of a thermal ACE file.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util   ! provides openz
   ! externals
   integer::nout
   character(70)::hk
   ! internals
   integer::ipcol,iwcol,nie,nee,i,it,idone,nang,nbini,neei
   integer::loc,k,major,minor,j,ie,iskip
   real(kr)::xmin,xmax,ymin,ymax
   real(kr)::e,xnelas,xelas,xielas,e1,x1,e2,x2,tot
   real(kr)::xtag,ytag,xs,xn,ubar,ystep
   real(kr)::ell,bl,ei,ui,bi,ebar,eprime,sum,wt
   real(kr)::zmin,zmax,ep,epl,x,xl,p,pl,cdl,u,ul,un,skip
   character(1)::qu=''''
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::ten=10.e0_kr
   real(kr),parameter::scale=1.e6_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--black and white pages
   ipcol=0
   iwcol=0
   !--colored pages
   ipcol=2
   iwcol=3

   !--start the viewr input text
   call openz(nout,1)
   write(nout,'(''1 2 .30'',i3,''/'')') ipcol
   nie=nint(xss(itie))
   nee=0
   neei=0
   if (itce.gt.0) nee=nint(xss(itce))
   if (itcei.gt.0) neei=nint(xss(itcei))

   !--plot log-log total, inelastic, and elastic (if present)
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   do i=1,nie
      e=xss(itie+i)
      xnelas=xss(itie+nie+i)
      if (e.lt.xmin) xmin=e
      if (e.gt.xmax) xmax=e
      if (xnelas.lt.ymin) ymin=xnelas
      if (xnelas.gt.ymax) ymax=xnelas
      if (idpnc.ne.0) then
         j=0
         xelas=0
         xielas=0
         do while (j.lt.nee)
            j=j+1
            e1=xss(itce+j)
            x1=xss(itce+nee+j)
            if (idpnc.eq.4.or.idpnc.eq.5) x1=x1/e1
            e2=xss(itce+j+1)
            x2=xss(itce+nee+j+1)
            if (idpnc.eq.4.or.idpnc.eq.5) x2=x2/e2
            if (e.ge.e1.and.e.le.e2) then
               xelas=x1+(e-e1)*(x2-x1)/(e2-e1)
               if (xelas.lt.ymin) ymin=xelas
               if (xelas.gt.ymax) ymax=xelas
            endif
         enddo
         if (idpnc.eq.5) then
            j=0
            do while (j.lt.neei)
               j=j+1
               e1=xss(itcei+j)
               x1=xss(itcei+neei+j)
               e2=xss(itcei+j+1)
               x2=xss(itcei+neei+j+1)
               if (e.ge.e1.and.e.le.e2) then
                  xielas=x1+(e-e1)*(x2-x1)/(e2-e1)
                  if (xielas.lt.ymin) ymin=xielas
                  if (xielas.gt.ymax) ymax=xielas
               endif
            enddo
         endif
         if (xelas.gt.zero) then
            tot=xnelas+xelas+xielas
            if (tot.lt.ymin) ymin=tot
            if (tot.gt.ymax) ymax=tot
         endif
      endif
   enddo
   call ascll(xmin,xmax)
   if (ymin.lt.ymax/scale) ymin=ymax/scale
   call ascll(ymin,ymax)
   write(nout,'(''1'',i3,''/'')') iwcol
   it=1
   do i=1,70
      if (hk(i:i).ne.' ') it=i
   enddo
   write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
   write(nout,'(a,''<t>hermal cross sections'',a,''/'')') qu,qu
   xtag=2*xmin
   ytag=7*log10(ymin)/10+3*log10(ymax)/10
   ytag=ten**ytag
   write(nout,'(''4 0 2 1'',2e12.4,''/'')') xtag,ytag
   write(nout,'(1p,3e12.3,''/'')') xmin,xmax,one
   write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(1p,3e12.3,''/'')') ymin,ymax,one
   write(nout,'(a,''<c>ross section (barns)'',a,''/'')') qu,qu
   write(nout,'(''/'')')
   if (iwcol.eq.0) then
      write(nout,'(''0 0 1/'')')
   else
      write(nout,'(''0 0 0 1/'')')
   endif
   write(nout,'(a,''inelastic'',a,''/'')') qu,qu
   write(nout,'(''0/'')')
   do i=1,nie
      e=xss(itie+i)
      xs=xss(itie+nie+i)
      write(nout,'(1p,2e14.6,''/'')') e,xs
   enddo
   write(nout,'(''/'')')
   if (idpnc.ne.0) then
      write(nout,'(''2/'')')
      write(nout,'(''/'')')
      if (iwcol.eq.0) then
         write(nout,'(''0 0 1/'')')
      else
         write(nout,'(''0 0 0 2/'')')
      endif
      if (idpnc.eq.3) then
         write(nout,'(a,''incoherent elastic'',a,''/'')') qu,qu
      else
         write(nout,'(a,''coherent elastic'',a,''/'')') qu,qu
      endif
      write(nout,'(''0/'')')
      if (idpnc.eq.4.or.idpnc.eq.5) then
         e=xss(itce+1)
         xs=xss(itce+nee+1)/e
         xs=xs/100
         write(nout,'(1p,2e14.6,''/'')') e,xs
      endif
      do i=1,nee
         e=xss(itce+i)
         xs=xss(itce+nee+i)
         if (idpnc.eq.4.or.idpnc.eq.5) xs=xs/e
         write(nout,'(1p,2e14.6,''/'')') e,xs
         if ((idpnc.eq.4.or.idpnc.eq.5).and.i.lt.nee) then
            e=xss(itce+i+1)
            xs=xss(itce+nee+i)/e
            write(nout,'(1p,2e14.6,''/'')') e,xs
         endif
      enddo
      if (idpnc.eq.4.or.idpnc.eq.5) then
         do i=1,25
            e=e+e/10
            if (e.gt.xmax) exit
            xs=xss(itce+2*nee)/e
            write(nout,'(1p,2e14.6,''/'')') e,xs
         enddo
      endif
      write(nout,'(''/'')')
      if (idpnc.eq.5) then
        write(nout,'(''3/'')')
        write(nout,'(''/'')')
        write(nout,'(''0 0 0 3/'')')
        write(nout,'(a,''incoherent elastic'',a,''/'')') qu,qu
        write(nout,'(''0/'')')
        do i=1,neei
           e=xss(itcei+i)
           xs=xss(itcei+neei+i)
           write(nout,'(1p,2e14.6,''/'')') e,xs
        enddo
        write(nout,'(''/'')')
        write(nout,'(''4/'')')
      else
        write(nout,'(''3/'')')
      endif
      write(nout,'(''/'')')
      write(nout,'(''/'')')
      write(nout,'(a,''total'',a,''/'')') qu,qu
      write(nout,'(''0/'')')
      i=0
      idone=0
      e=0
      do while (idone.eq.0.and.i.lt.nee)
         i=i+1
         e=xss(itie+i)
         if (e.ge.xss(itce+1)) then
            idone=1
         else
            xn=xss(itie+nie+i)
            if (idpnc.eq.5) then
               j=0
               do while (j.lt.neei)
                  j=j+1
                  e1=xss(itcei+j)
                  x1=xss(itcei+neei+j)
                  e2=xss(itcei+j+1)
                  x2=xss(itcei+neei+j+1)
                  if (e.ge.e1.and.e.le.e2) xielas=x1+(e-e1)*(x2-x1)/(e2-e1)
               enddo
            endif
            tot=xn+xielas
            write(nout,'(1p,2e14.6,''/'')') e,tot
         endif
      enddo
      if (idpnc.eq.4.or.idpnc.eq.5) then
         e=xss(itce+1)
         j=0
         do while (j.lt.nie)
            j=j+1
            e1=xss(itie+j)
            x1=xss(itie+nie+j)
            e2=xss(itie+j+1)
            x2=xss(itie+nie+j+1)
            if (e.ge.e1.and.e.le.e2) xn=x1+(e-e1)*(x2-x1)/(e2-e1)
         enddo
         if (idpnc.eq.5) then
            j=0
            do while (j.lt.neei)
               j=j+1
               e1=xss(itcei+j)
               x1=xss(itcei+neei+j)
               e2=xss(itcei+j+1)
               x2=xss(itcei+neei+j+1)
               if (e.ge.e1.and.e.le.e2) xielas=x1+(e-e1)*(x2-x1)/(e2-e1)
            enddo
         endif
         tot=xn+xielas
         write(nout,'(1p,2e14.6,''/'')') e,tot
      endif
      do i=1,nee
         e=xss(itce+i)
         xs=xss(itce+nee+i)
         xn=0
         xielas=0
         if (idpnc.eq.4.or.idpnc.eq.5) xs=xs/e
         j=0
         do while (j.lt.nie)
            j=j+1
            e1=xss(itie+j)
            x1=xss(itie+nie+j)
            e2=xss(itie+j+1)
            x2=xss(itie+nie+j+1)
            if (e.ge.e1.and.e.le.e2) xn=x1+(e-e1)*(x2-x1)/(e2-e1)
         enddo
         if (idpnc.eq.5) then
            j=0
            do while (j.lt.neei)
               j=j+1
               e1=xss(itcei+j)
               x1=xss(itcei+neei+j)
               e2=xss(itcei+j+1)
               x2=xss(itcei+neei+j+1)
               if (e.ge.e1.and.e.le.e2) xielas=x1+(e-e1)*(x2-x1)/(e2-e1)
            enddo
         endif
         tot=xs+xn+xielas
         write(nout,'(1p,2e14.6,''/'')') e,tot
         if (i.lt.nee.and.(idpnc.eq.4.or.idpnc.eq.5)) then
            e=xss(itce+i+1)
            xs=xss(itce+nee+i)/e
            j=0
            do while (j.lt.nie)
               j=j+1
               e1=xss(itie+j)
               x1=xss(itie+nie+j)
               e2=xss(itie+j+1)
               x2=xss(itie+nie+j+1)
               if (e.ge.e1.and.e.le.e2) xn=x1+(e-e1)*(x2-x1)/(e2-e1)
            enddo
            if (idpnc.eq.5) then
               j=0
               do while (j.lt.neei)
                  j=j+1
                  e1=xss(itcei+j)
                  x1=xss(itcei+neei+j)
                  e2=xss(itcei+j+1)
                  x2=xss(itcei+neei+j+1)
                  if (e.ge.e1.and.e.le.e2) xielas=x1+(e-e1)*(x2-x1)/(e2-e1)
               enddo
            endif
            tot=xs+xn+xielas
            write(nout,'(1p,2e14.6,''/'')') e,tot
         endif
      enddo
      if (idpnc.eq.4.or.idpnc.eq.5) then
         do i=1,25
            e=e+e/10
            if (e.gt.xmax) exit
            xs=xss(itce+2*nee)/e
            j=0
            do while (j.lt.nie)
               j=j+1
               e1=xss(itie+j)
               x1=xss(itie+nie+j)
               e2=xss(itie+j+1)
               x2=xss(itie+nie+j+1)
               if (e.ge.e1.and.e.le.e2) xn=x1+(e-e1)*(x2-x1)/(e2-e1)
            enddo
            if (idpnc.eq.5) then
               j=0
               do while (j.lt.neei)
                  j=j+1
                  e1=xss(itcei+j)
                  x1=xss(itcei+neei+j)
                  e2=xss(itcei+j+1)
                  x2=xss(itcei+neei+j+1)
                  if (e.ge.e1.and.e.le.e2) xielas=x1+(e-e1)*(x2-x1)/(e2-e1)
               enddo
            endif
            tot=xs+xn+xielas
            write(nout,'(1p,2e14.6,''/'')') e,tot
         enddo
      endif
      if (idpnc.eq.5) then
        do i=1,neei
           if (e.lt.xss(itcei+i)) then
              e=xss(itcei+i)
              xielas=xss(itcei+neei+i)
              j=0
              do while (j.lt.nie)
                 j=j+1
                 e1=xss(itie+j)
                 x1=xss(itie+nie+j)
                 e2=xss(itie+j+1)
                 x2=xss(itie+nie+j+1)
                 if (e.ge.e1.and.e.le.e2) xn=x1+(e-e1)*(x2-x1)/(e2-e1)
              enddo
              tot=xn+xielas
              write(nout,'(1p,2e14.6,''/'')') e,tot
         endif
        enddo
      endif
      write(nout,'(''/'')')
   endif

   !--mubar plot
   nang=nil+1
   if (ifeng.gt.1) nang=nil-1
   nbini=nieb
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   loc=itxe-1
   if (ifeng.gt.1) loc=loc+2*nie
   do i=1,nie
      e=xss(itie+i)
      xnelas=xss(itie+nie+i)
      if (ifeng.gt.1) nbini=nint(xss(itxe-1+nie+i))
      ubar=0
      sum=0
      if (ifeng.le.1) then
         do j=1,nbini
            if (ifeng.eq.0) then
               wt=1
            else
               wt=10
               if (j.eq.1.or.j.eq.nbini) wt=1
               if (j.eq.2.or.j.eq.nbini-1) wt=4
            endif
            do k=2,nang+1
              ubar=ubar+wt*xss(loc+k)
              sum=sum+wt
            enddo
            loc=loc+nang+1
         enddo
      else
         cdl=0
         loc=loc+nang+3
         do j=2,nbini
            p=xss(loc+3)-cdl
            do k=1,nang
!              if ((xss(loc+3+k).lt.-1.0e0_kr).or.&
!                  (xss(loc+3+k).gt.1.0e0_kr)) then
!                 write(nsyso,'(/'' ---warning from tplots---'', &
!                       &'' cosine '',f12.8,'' outside [-1,1] range'')')&
!                       xss(loc+3+k)
!              endif
              ubar=ubar+xss(loc+3+k)*p/2
              ubar=ubar+xss(loc+3+k-nang-3)*p/2
              sum=sum+p
            enddo
            cdl=xss(loc+3)
            loc=loc+nang+3
         enddo
      endif
      ubar=ubar/sum
      if (e.lt.xmin) xmin=e
      if (e.gt.xmax) xmax=e
      if (ubar.lt.ymin) ymin=ubar
      if (ubar.gt.ymax) ymax=ubar
   enddo
   if (nee.gt.0) then
      ymin=-1
      ymax=1
   endif
   call ascll(xmin,xmax)
   call ascle(4,ymin,ymax,major,minor)
   ystep=(ymax-ymin)/major
   write(nout,'(''1'',i3,''/'')') iwcol
   it=1
   do i=1,70
      if (hk(i:i).ne.' ') it=i
   enddo
   write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
   write(nout,'(a,''<t>hermal mubar'',a,''/'')') qu,qu
   xtag=2*xmin
   ytag=7*ymin/10+3*ymax/10
   write(nout,'(''3 0 2 1'',2e12.4,''/'')') xtag,ytag
   write(nout,'(1p,3e12.3,''/'')') xmin,xmax,one
   write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
   write(nout,'(a,''<m>ubar'',a,''/'')') qu,qu
   write(nout,'(''/'')')
   if (iwcol.eq.0) then
      write(nout,'(''0 0 1/'')')
   else
      write(nout,'(''0 0 0 1/'')')
   endif
   write(nout,'(a,''inelastic'',a,''/'')') qu,qu
   write(nout,'(''0/'')')
   loc=itxe-1
   if (ifeng.gt.1) loc=loc+2*nie
   do i=1,nie
      e=xss(itie+i)
      xs=xss(itie+nie+i)
      if (ifeng.gt.1) nbini=nint(xss(itxe-1+nie+i))
      ubar=0
      sum=0
      if (ifeng.le.1) then
         do j=1,nbini
            if (ifeng.eq.0) then
               wt=1
            else
               wt=10
               if (j.eq.1.or.j.eq.nbini) wt=1
               if (j.eq.2.or.j.eq.nbini-1) wt=4
            endif
            do k=2,nang+1
              ubar=ubar+wt*xss(loc+k)
              sum=sum+wt
            enddo
            loc=loc+nang+1
         enddo
      else
         cdl=0
         loc=loc+nang+3
         do j=2,nbini
            p=xss(loc+3)-cdl
            do k=1,nang
              ubar=ubar+xss(loc+3+k)*p/2
              ubar=ubar+xss(loc+3+k-nang-3)*p/2
              sum=sum+p
            enddo
            cdl=xss(loc+3)
            loc=loc+nang+3
         enddo
      endif
      ubar=ubar/sum
      write(nout,'(1p,2e14.6,''/'')') e,ubar
   enddo
   write(nout,'(''/'')')
   if (nee.ne.0) then
      if (idpnc.eq.4.or.idpnc.eq.5) then
         write(nout,'(''2/'')')
         write(nout,'(''/'')')
         if (iwcol.eq.0) then
            write(nout,'(''0 0 1/'')')
         else
            write(nout,'(''0 0 0 2/'')')
         endif
         write(nout,'(a,''coherent elastic'',a,''/'')') qu,qu
         write(nout,'(''0/'')')
         e=xss(itce+1)
         ell=xss(itce+nee)
         do while (e.le.ell)
            idone=0
            i=0
            ubar=0
            sum=0
            bl=0
            do while (idone.eq.0.and.i.lt.nee)
               i=i+1
               ei=xss(itce+i)
               if (ei.gt.e) then
                  idone=1
               else
                  ui=1-2*ei/e
                  bi=(xss(itce+nee+i)-bl)
                  ubar=ubar+bi*ui/e
                  sum=sum+bi/e
               endif
               bl=xss(itce+nee+i)
            enddo
            ubar=ubar/sum
            write(nout,'(1p,2e14.6,''/'')') e,ubar
            e=e+e/50
         enddo
         write(nout,'(''/'')')
      endif
      if (idpnc.eq.3) then
         write(nout,'(''2/'')')
         write(nout,'(''/'')')
         if (iwcol.eq.0) then
            write(nout,'(''0 0 1/'')')
         else
            write(nout,'(''0 0 0 2/'')')
         endif
         write(nout,'(a,''incoherent elastic'',a,''/'')') qu,qu
         write(nout,'(''0/'')')
         loc=itca-1
         do i=1,nee
            e=xss(itce+i)
            ubar=0
            do j=1,ncl+1
               ubar=ubar+xss(loc+j)/(ncl+1)
            enddo
            write(nout,'(1p,2e14.6,''/'')') e,ubar
            loc=loc+ncl+1
         enddo
         write(nout,'(''/'')')
      endif
      if (idpnc.eq.5) then
         write(nout,'(''3/'')')
         write(nout,'(''/'')')
         if (iwcol.eq.0) then
            write(nout,'(''0 0 2/'')')
         else
            write(nout,'(''0 0 0 3/'')')
         endif
         write(nout,'(a,''incoherent elastic'',a,''/'')') qu,qu
         write(nout,'(''0/'')')
         loc=itcai-1
         do i=1,neei
            e=xss(itcei+i)
            ubar=0
            do j=1,ncli+1
               ubar=ubar+xss(loc+j)/(ncli+1)
            enddo
            write(nout,'(1p,2e14.6,''/'')') e,ubar
            loc=loc+ncli+1
         enddo
         write(nout,'(''/'')')
      endif
   endif

   !--ebar plot
   nang=nil+1
   if (ifeng.gt.1) nang=nil-1
   nbini=nieb
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   loc=itxe-1
   if (ifeng.gt.1) loc=loc+2*nie
   do i=1,nie
      e=xss(itie+i)
      xnelas=xss(itie+nie+i)
      if (ifeng.gt.1) nbini=nint(xss(itxe-1+nie+i))
      ebar=0
      sum=0
      if (ifeng.le.1) then
         do j=1,nbini
            eprime=xss(loc+1)
            if (ifeng.eq.0) then
               wt=1
            else
               wt=10
               if (j.eq.1.or.j.eq.nbini) wt=1
               if (j.eq.2.or.j.eq.nbini-1) wt=4
            endif
            ebar=ebar+wt*eprime
            sum=sum+wt
            loc=loc+nang+1
         enddo
      else
         cdl=0
         xl=0
         pl=0
         loc=loc+nang+3
         do j=2,nbini
            x=xss(loc+1)
            p=xss(loc+2)
            u=(pl-(p-pl)*xl/(x-xl))*(x**2-xl**2)/2&
              +((p-pl)/(x-xl))*(x**3-xl**3)/3
            ul=(x-xl)*(p+pl)/2
            u=u/ul
            un=xss(loc+3)-cdl
            ebar=ebar+u*un
            sum=sum+un
            xl=x
            pl=p
            cdl=xss(loc+3)
            loc=loc+nang+3
         enddo
      endif
      ebar=ebar/sum
      if (e.lt.xmin) xmin=e
      if (e.gt.xmax) xmax=e
      if (ebar.lt.ymin) ymin=ebar
      if (ebar.gt.ymax) ymax=ebar
   enddo
   call ascll(xmin,xmax)
   call ascll(ymin,ymax)
   if (ymin.lt.ymax/scale) ymin=ymax/scale
   write(nout,'(''1'',i3,''/'')') iwcol
   it=1
   do i=1,70
      if (hk(i:i).ne.' ') it=i
   enddo
   write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
   write(nout,'(a,''<t>hermal ebar'',a,''/'')') qu,qu
   xtag=2*xmin
   ytag=2*log10(ymin)/10+8*log10(ymax)/10
   ytag=ten**ytag
   write(nout,'(''4 0 2 1'',2e12.4,''/'')') xtag,ytag
   write(nout,'(1p,3e12.3,''/'')') xmin,xmax,one
   write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(1p,3e12.3,''/'')') ymin,ymax,one
   write(nout,'(a,''<e>bar (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(''/'')')
   if (iwcol.eq.0) then
      write(nout,'(''0 0 1/'')')
   else
      write(nout,'(''0 0 0 1/'')')
   endif
   write(nout,'(a,''inelastic'',a,''/'')') qu,qu
   write(nout,'(''0/'')')
   loc=itxe-1
   if (ifeng.gt.1) loc=loc+2*nie
   do i=1,nie
      e=xss(itie+i)
      xnelas=xss(itie+nie+i)
      if (ifeng.gt.1) nbini=nint(xss(itxe-1+nie+i))
      ebar=0
      sum=0
      if (ifeng.le.1) then
      do j=1,nbini
         eprime=xss(loc+1)
         if (ifeng.eq.0) then
            wt=1
         else
            wt=10
            if (j.eq.1.or.j.eq.nbini) wt=1
            if (j.eq.2.or.j.eq.nbini-1) wt=4
         endif
         ebar=ebar+wt*eprime
         sum=sum+wt
         loc=loc+nang+1
      enddo
      else
         cdl=0
         xl=0
         pl=0
         loc=loc+nang+3
         do j=2,nbini
            x=xss(loc+1)
            p=xss(loc+2)
            u=(pl-(p-pl)*xl/(x-xl))*(x**2-xl**2)/2&
              +((p-pl)/(x-xl))*(x**3-xl**3)/3
            ul=(x-xl)*(p+pl)/2
            u=u/ul
            un=xss(loc+3)-cdl
            ebar=ebar+u*un
            sum=sum+un
            xl=x
            pl=p
            cdl=xss(loc+3)
            loc=loc+nang+3
         enddo
      endif
      ebar=ebar/sum
      write(nout,'(1p,2e14.6,''/'')') e,ebar
   enddo
   write(nout,'(''/'')')
   if (ifeng.le.1) then
      write(nout,'(''99/'')')
      return
   endif

   !--3-d plots of thermal inelastic distributions
   !--when continuous probability distribution option is used

   ! plot energy distributions for low incident energies
   nang=nil-1
   loc=itxe-1
   loc=loc+2*nie
   zmin=1000
   zmax=0
   xmin=5/scale/100000
   xmax=.5/scale
   ymin=1/scale/100000
   ymax=2/scale/100
   do ie=1,nie
      e=xss(itie+ie)
      nbini=nint(xss(itxe-1+nie+ie))
      do j=1,nbini
         ep=xss(loc+1)
         if (e.ge.ymin.and.e.le.ymax.and.&
           ep.gt.xmin.and.ep.lt.xmax) then
            p=xss(loc+2)
            if (p.lt.zmin) zmin=p
            if (p.gt.zmax) zmax=p
         endif
         loc=loc+nang+3
      enddo
   enddo
   if (zmax.gt.zero) then
      zmin=zmax/1000
      call ascll(zmin,zmax)
      write(nout,'(''1'',i3,''/'')') iwcol
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''thermal inelastic'',a,''/'')') qu,qu
      write(nout,'(''-4 2/'')')
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,1.
      write(nout,'(a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,1.
      write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') zmin,zmax,1.
      write(nout,'(a,''<p>rob/<m>e<v>'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      write(nout,'(''10 -15 15 3.5 5.5 2.5/'')')
      write(nout,'(''1/'')')
      loc=itxe-1
      loc=loc+2*nie
      do ie=1,nie
         e=xss(itie+ie)
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(1p,e14.6,''/'')') e
         nbini=nint(xss(itxe-1+nie+ie))
         do j=1,nbini
            ep=xss(loc+1)
            p=xss(loc+2)
            if (p.lt.zmin) p=zmin
            if (e.ge.ymin.and.e.le.ymax.and.&
              ep.gt.xmin.and.ep.le.xmax) then
               write(nout,'(1p,2e14.6,''/'')') ep,p
            endif
            loc=loc+nang+3
         enddo
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(''/'')')
      enddo
      write(nout,'(''/'')')
   endif

   ! plot energy distributions for middle incident energies
   nang=nil-1
   loc=itxe-1
   loc=loc+2*nie
   zmin=1000
   zmax=0
   xmin=2/scale/1000
   xmax=5/scale/10
   ymin=2/scale/100
   ymax=2/scale/10
   do ie=1,nie
      e=xss(itie+ie)
      nbini=nint(xss(itxe-1+nie+ie))
      epl=0
      do j=1,nbini
         ep=xss(loc+1)
         if (e.ge.ymin.and.e.le.ymax.and.&
           ep.gt.xmin.and.ep.lt.xmax) then
            p=xss(loc+2)
            if (p.lt.zmin) zmin=p
            if (p.gt.zmax) zmax=p
         endif
         loc=loc+nang+3
      enddo
   enddo
   if (zmax.gt.zero) then
      zmin=zmax/500
      call ascll(zmin,zmax)
      write(nout,'(''1'',i3,''/'')') iwcol
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''thermal inelastic'',a,''/'')') qu,qu
      write(nout,'(''-4 2/'')')
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,1.
      write(nout,'(a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,1.
      write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') zmin,zmax,1.
      write(nout,'(a,''<p>rob/<m>e<v>'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      write(nout,'(''10 -15 15 3.5 5.5 2.5/'')')
      write(nout,'(''1/'')')
      loc=itxe-1
      loc=loc+2*nie
      do ie=1,nie
         e=xss(itie+ie)
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(1p,e14.6,''/'')') e
         nbini=nint(xss(itxe-1+nie+ie))
         do j=1,nbini
            ep=xss(loc+1)
            p=xss(loc+2)
            if (p.lt.zmin) p=zmin
            if (e.ge.ymin.and.e.le.ymax.and.&
              ep.gt.xmin.and.ep.le.xmax) then
               write(nout,'(1p,2e14.6,''/'')') ep,p
            endif
            loc=loc+nang+3
         enddo
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(''/'')')
      enddo
      write(nout,'(''/'')')
   endif

   ! plot energy distributions for higher incident energies
   nang=nil-1
   loc=itxe-1
   loc=loc+2*nie
   zmin=1000
   zmax=0
   xmin=2/scale/100
   xmax=2/scale
   ymin=2/scale/10
   ymax=2/scale
   do ie=1,nie
      e=xss(itie+ie)
      nbini=nint(xss(itxe-1+nie+ie))
      do j=1,nbini
         ep=xss(loc+1)
         if (e.ge.ymin.and.e.le.ymax.and.&
           ep.gt.xmin.and.ep.lt.xmax) then
            p=xss(loc+2)
            if (p.lt.zmin) zmin=p
            if (p.gt.zmax) zmax=p
         endif
         loc=loc+nang+3
      enddo
   enddo
   if (zmax.gt.zero) then
      zmin=zmax/500
      call ascll(zmin,zmax)
      write(nout,'(''1'',i3,''/'')') iwcol
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''thermal inelastic'',a,''/'')') qu,qu
      write(nout,'(''-4 2/'')')
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,1.
      write(nout,'(a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,1.
      write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') zmin,zmax,1.
      write(nout,'(a,''<p>rob/<m>e<v>'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      write(nout,'(''10 -15 15 3.5 5.5 2.5/'')')
      write(nout,'(''1/'')')
      loc=itxe-1
      loc=loc+2*nie
      do ie=1,nie
         e=xss(itie+ie)
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(1p,e14.6,''/'')') e
         nbini=nint(xss(itxe-1+nie+ie))
         do j=1,nbini
            ep=xss(loc+1)
            p=xss(loc+2)
            if (p.lt.zmin) p=zmin
            if (e.ge.ymin.and.e.le.ymax.and.&
              ep.gt.xmin.and.ep.le.xmax) then
               write(nout,'(1p,2e14.6,''/'')') ep,p
            endif
            loc=loc+nang+3
         enddo
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(''/'')')
      enddo
      write(nout,'(''/'')')
   endif

   ! plot energy distributions for highest incident energies
   nang=nil-1
   loc=itxe-1
   loc=loc+2*nie
   zmin=1000
   zmax=0
   xmin=1/scale/100
   xmax=10/scale
   ymin=2/scale
   ymax=10/scale
   do ie=1,nie
      e=xss(itie+ie)
      nbini=nint(xss(itxe-1+nie+ie))
      do j=1,nbini
         ep=xss(loc+1)
         if (e.ge.ymin.and.e.le.ymax.and.&
           ep.gt.xmin.and.ep.lt.xmax) then
            p=xss(loc+2)
            if (p.lt.zmin) zmin=p
            if (p.gt.zmax) zmax=p
         endif
         loc=loc+nang+3
      enddo
   enddo
   if (zmax.gt.zero) then
      zmin=zmax/500
      call ascll(zmin,zmax)
      write(nout,'(''1'',i3,''/'')') iwcol
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''thermal inelastic'',a,''/'')') qu,qu
      write(nout,'(''-4 2/'')')
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,1.
      write(nout,'(a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,1.
      write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') zmin,zmax,1.
      write(nout,'(a,''<p>rob/<m>e<v>'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      write(nout,'(''10 -15 15 3.5 5.5 2.5/'')')
      write(nout,'(''1/'')')
      loc=itxe-1
      loc=loc+2*nie
      do ie=1,nie
         e=xss(itie+ie)
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(1p,e14.6,''/'')') e
         nbini=nint(xss(itxe-1+nie+ie))
         do j=1,nbini
            ep=xss(loc+1)
            p=xss(loc+2)
            if (p.lt.zmin) p=zmin
            if (e.ge.ymin.and.e.le.ymax.and.&
              ep.gt.xmin.and.ep.le.xmax) then
               write(nout,'(1p,2e14.6,''/'')') ep,p
            endif
            loc=loc+nang+3
         enddo
         if (e.ge.ymin.and.e.le.ymax) write(nout,'(''/'')')
      enddo
      write(nout,'(''/'')')
   endif

   ! plot angle-energy distribution for several incident energies
   ie=19
   iskip=(nie-ie)/4
   do while (ie.lt.nie)
      nang=nil-1
      loc=nint(xss(itxe-1+ie))
      nbini=nint(xss(itxe-1+nie+ie))
      zmin=1
      zmin=zmin/100
      zmax=10
      ymin=10
      ymax=1/scale/10000000
      xmin=-1
      xmax=+1
      e=xss(itie+ie)
      epl=0
      loc=loc+nang+3
      do j=2,nbini-1
         ep=(xss(loc+1)+epl)/2
         if (xss(loc+1).gt.epl) then
            if (ep.lt.ymin) ymin=ep
            if (ep.gt.ymax) ymax=ep
            epl=xss(loc+1)
            ul=-1
            do k=1,nang
               u=xss(loc+3+k)
               if (k.lt.nang) then
                  un=(u+xss(loc+3+k+1))/2
               else
                  un=1
               endif
               if (k.eq.1.and.u-ul.gt.5*(un-u)) ul=u-3*(un-u)
               if (k.eq.nang.and.un-u.gt.5*(u-ul)) un=u+3*(u-ul)
               p=1
               p=p/nang
               if (un.ne.ul) p=p/(un-ul)
               ul=un
            enddo
         endif
         loc=loc+nang+3
      enddo
      call ascll(ymin,ymax)
      write(nout,'(''1'',i3,''/'')') iwcol
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''thermal inelastic for e='',1p,e10.3,'' MeV'',a,''/'')')&
        qu,xss(itie+ie),qu
      write(nout,'(''-2 2/'')')
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,.5
      write(nout,'(a,''<c>osine'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,1.
      write(nout,'(a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') zmin,zmax,1.
      write(nout,'(a,''<p>rob/cosine'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      write(nout,'(''10 -15 15 3.5 5.5 2.5/'')')
      write(nout,'(''1/'')')
      loc=nint(xss(itxe-1+ie))
      nbini=nint(xss(itxe-1+nie+ie))
      skip=1+log10(ymax/ymin)/60
      epl=0
      loc=loc+nang+3
      do j=2,nbini-1
         ep=(xss(loc+1)+epl)/2
         if (xss(loc+1).gt.epl) then
            if (j.eq.2.or.ep.gt.skip*epl) then
               write(nout,'(1p,e14.6,''/'')') ep
               ul=-1
               write(nout,'(1p,2e14.6,''/'')') -1.,zmin
               do k=1,nang
                  u=xss(loc+3+k)
                  if (k.lt.nang) then
                     un=(u+xss(loc+3+k+1))/2
                  else
                     un=1
                  endif
                  if (k.eq.1.and.u-ul.gt.5*(un-u)) ul=u-3*(un-u)
                  if (k.eq.nang.and.un-u.gt.5*(u-ul)) un=u+3*(u-ul)
                  p=1
                  p=p/nang
                  if (un.ne.ul) p=p/(un-ul)
                  if (k.eq.1) write(nout,'(1p,2e14.6,''/'')') ul,zmin
                  write(nout,'(1p,2e14.6,''/'')') u,p
                  if (k.eq.nang) write(nout,'(1p,2e14.6,''/'')') un,zmin
                  ul=un
               enddo
               write(nout,'(1p,2e14.6,''/'')') 1.,zmin
               write(nout,'(''/'')')
               epl=xss(loc+1)
            endif
         endif
         loc=loc+nang+3
      enddo
      write(nout,'(''/'')')
      ie=ie+iskip
   enddo

   write(nout,'(''99/'')')

   return
   end subroutine tplots

   subroutine ascle(m,z1,z2,major,minor)
   !-------------------------------------------------------------------
   ! Automatic scaling routine for a linear axis.
   ! Borrowed from Los Alamos SC4020 library (with modifications).
   ! On input------------
   !   m              minimum number of major divisions desired
   !   z1,z2          min and max values of data to be plotted
   ! On output-----------
   !   z1,z2          min and max limits of axis
   !   major          number of major division on axis
   !   minor          number of minor divisions on axis
   !--***************************************************************
   ! externals
   integer::m,major,minor
   real(kr)::z1,z2
   ! internals
   integer::iflag,k,nm,n1,n2
   real(kr)::zmin,zmax,fm,zbar,z,p,tenk,test,dz,fn
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::tentho=10000

   !--check input
   !--exit if parameters are unreasonable
   zmin=z1
   zmax=z2
   if (zmax.le.zmin.or.m.le.0.or.m.gt.20) then
      major=1
      minor=0
      z1=0
      z2=2*z2
      return
   endif

   !--find minimum span per interval
   fm=m
   if (zmax.eq.zero.or.zmin.eq.zero) then
      zmax=zmax-abs(zmax)/1000000
      zmin=zmin+abs(zmin)/1000000
   else
      zbar=zmax/zmin
      if (abs(zbar)/1000.ge.one) zmin=0
      if (abs(zbar)*1000.le.one) then
         zmax=0
         zmax=zmax-abs(zmax)/1000000
         zmin=zmin+abs(zmin)/1000000
      else
         if ((abs(zbar-1)-5*fm/100000).gt.zero) then
            zmax=zmax-abs(zmax)/1000000
            zmin=zmin+abs(zmin)/1000000
         else
            zbar=(zmax+zmin)/2
            z=26*fm*abs(zbar)/1000000
            zmax=zbar+z
            zmin=zbar-z
         endif
      endif
   endif
   p=(zmax-zmin)/fm

   !--determine k such that
   !--    10**k.le.p.lt.10**(k+1)
   iflag=0
   tenk=1
   k=0
   if (p.lt.one) then
      iflag=1
      p=1/p
   endif
   do while (p.ge.tentho)
      p=p/10000
      tenk=tenk*10000
      k=k+4
   enddo
   do while (p.ge.ten)
      p=p/10
      tenk=tenk*10
      k=k+1
   enddo
   if (iflag.ne.0) then
      p=10/p
      tenk=one/10/tenk
      k=k-1
   endif

   !--determine dz such that
   !--    dz = 1*10**k, or
   !--    dz = 2*10**k, or
   !--    dz = 5*10**k.
   test=2+one/100
   if (p.le.test) then
      test=2-one/100
      if (p.le.test) then
         p=1
         nm=5
      else
         p=2
         nm=4
      endif
   else
      test=5-one/100
      if (p.lt.test) then
         p=2
         nm=4
      else
         p=5
         nm=5
      endif
   endif
   dz=p*tenk

   !--find integers n1 and n2 such that
   !--    n1*dz.le.zmin.lt.(n1+1)*dz, and
   !--    (n2-1)*dz.lt.zmax.le.n2*dz
   !--the new zmin and zmax become
   !--    zmin = n1*dz
   !--    zmax = n2*dz
   n1=int(zmin/dz)
   fn=n1
   z=fn*dz
   if (z.gt.zmin) then
      z=z-dz
      n1=n1-1
   endif
   zmin=z
   z1=zmin
   n2=int(zmax/dz)
   fn=n2
   z=fn*dz
   if (z.lt.zmax) then
      n2=n2+1
      z=z+dz
   endif
   zmax=z
   z2=zmax

   !--the values of major and minor can be set
   major=n2-n1
   minor=nm*major
   return
   end subroutine ascle

   subroutine ascll(amin,amax)
   !-------------------------------------------------------------------
   ! Adjust axis limits for a log scale.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::amin,amax
   ! internals
   integer::itop,ibot
   real(kr)::top,bot
   real(kr),parameter::b1=0.e0_kr
   real(kr),parameter::b2=.301e0_kr
   real(kr),parameter::b3=.699e0_kr
   real(kr),parameter::b4=1.e0_kr
   real(kr),parameter::ohoh1=.001e0_kr

   real(kr),parameter::zero=0
   real(kr),parameter::ten=10

   top=log10(amax)
   itop=int(top)
   if (top.lt.zero) itop=itop-1
   amax=itop+1
   if (top.le.itop+b3+ohoh1) amax=itop+b3
   if (top.le.itop+b2+ohoh1) amax=itop+b2
   if (top.le.itop+b1+ohoh1) amax=itop+b1
   amax=ten**amax
   bot=log10(amin)
   ibot=int(bot)
   if (bot.lt.zero) ibot=ibot-1
   amin=ibot
   if (bot.ge.ibot+b2-ohoh1) amin=ibot+b2
   if (bot.ge.ibot+b3-ohoh1) amin=ibot+b3
   if (bot.ge.ibot+b4-ohoh1) amin=ibot+b4
   amin=ten**amin
   return
   end subroutine ascll

   subroutine throut(itype,nout,ndir,mcnpx,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Write thermal ACE data to output and directory files.
   !-------------------------------------------------------------------
   use util  ! provides openz,closz,error
   use acecm ! provides write routines
   ! externals
   integer::itype,nout,ndir,mcnpx
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::l,ne,n,nexe,nern,lrec,ll,nn,i,nprime
   integer::locator  ! locator index
   integer::ner=1
   integer::nbw=1

   !--open ace file
   if (itype.eq.1) call openz(nout,1)
   if (itype.eq.2) call openz(-nout,1)

   !--branch according to ace file type
   if (itype.eq.1) then

      !--write type-1 header block
      if (mcnpx.eq.0) then
         write(nout,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hk,hm
      else
         write(nout,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:13),aw0,tz,hd,hk,hm
      endif
      write(nout,'(4(i7,f11.0))') (izn(i),awn(i),i=1,16)
      write(nout,'(8i9)') &
        len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd,&
        itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd

      !--itie block
      l=1
      call advance_to_locator(nout,l,itie)
      ne=nint(xss(l))
      call write_integer(nout,l)            ! NE
      call write_real_list(nout,l,2*ne)     ! E (NE values), xs (NE values)

      !--itxe block
      call advance_to_locator(nout,l,itxe)
      if (ifeng.le.1) then                  ! equal probable cosine or discrete cosine distributions
         call write_real_list(nout,l,ne*nieb*(nil+2)) ! NE lists of NIEB*(NMU+1)=NIEB*(NIL+2) since NMU=NIL+1
      else
         locator=1
         call write_integer_list(nout,l,2*ne) ! L (NE values), Nprime (NE values)
         do i=1,ne
            call advance_to_locator(nout,l,nint(xss(itxe+locator-1))+1)
            nprime=nint(xss(itxe+ne+i-1))
            call write_real_list(nout,l,nprime*(nil+2)) ! NPRIME*(NMU+3)=NPRIME*(NIL+2) since NMU=NIL-1
            locator=locator+1
         enddo
      endif

      !--itce block
      if (itce.ne.0) then
         call advance_to_locator(nout,l,itce)
         ne=nint(xss(l))
         nexe=ne
         call write_integer(nout,l)            ! NE
         call write_real_list(nout,l,2*ne)     ! E (NE values), P (NE values)
      endif

      !--itca block
      if (itca.ne.0) then
         call advance_to_locator(nout,l,itca)
         n=nexe*(ncl+1)
         do i=1,n
            call typen(l,nout,2)
            l=l+1
         enddo
      endif

      !--itcei block
      if (itcei.ne.0) then
         call advance_to_locator(nout,l,itcei)
         ne=nint(xss(l))
         nexe=ne
         call write_integer(nout,l)            ! NE
         call write_real_list(nout,l,2*ne)     ! E (NE values), P (NE values)
      endif

      !--itcai block
      if (itcai.ne.0) then
         call advance_to_locator(nout,l,itcai)
         n=nexe*(ncli+1)
         do i=1,n
            call typen(l,nout,2)
            l=l+1
         enddo
      endif

      !--finished
      call typen(l,nout,3)
      nern=0
      lrec=0
      call closz(nout)

   !--write ace file in type 2 format
   else if (itype.eq.2) then
      if (mcnpx.eq.0) then
         write(nout) hz(1:10),aw0,tz,hd,hk,hm,&
            (izn(i),awn(i),i=1,16),&
           len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd,&
           itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd
      else
         write(nout) hz(1:13),aw0,tz,hd,hk,hm,&
            (izn(i),awn(i),i=1,16),&
           len2,idpni,nil,nieb,idpnc,ncl,ifeng,ncli,nxsd,&
           itie,itix,itxe,itce,itcx,itca,itcei,itcxi,itcai,jxsd
      endif
      ll=0
      nn=len2
      do while (nn.gt.0)
         n=nn
         if (n.gt.ner) n=ner
         write(nout) (xss(ll+i),i=1,n)
         ll=ll+n
         nn=nn-n
      enddo
      lrec=ner*nbw
      nern=ner
      call closz(-nout)
   endif
   call openz(ndir,1)
   if (mcnpx.eq.0) then
      write(ndir,&
        '(a10,f12.6,'' filename route'',i2,'' 1 '',i9,2i6,1p,e10.3)')&
        hz(1:10),aw0,itype,len2,lrec,nern,tz
   else
      write(ndir,&
        '(a13,f12.6,'' filename route'',i2,'' 1 '',i9,2i6,1p,e10.3)')&
        hz(1:13),aw0,itype,len2,lrec,nern,tz
   endif
   call closz(ndir)
   return
   end subroutine throut

end module aceth

module matxsm
   ! provides subroutine matxsr for NJOY2016
   use locale
   implicit none
   private
   public matxsr
   ! global variables

   ! equivalenced arrays for CCCC input and output
   integer::isiza=200000    ! container array size
   real(k4)::a(200000)      ! reals are 4-byte
   integer(k4)::ia(200000)  ! integers are 4-byte
   real(k8)::ha(100000)     ! Hollerith data are 8-byte
   character(8)::ta(100000) ! text equivalent to Hollerith
   integer::mult=2          ! used for counting 8-byte entries
   equivalence(a(1),ia(1),ha(1),ta(1))

   ! unit numbers
   integer::ngen1,ngen2,nmatx,nscrt1,nscrt2,nscrt3,nscrt4,&
     nscrt5,nscrt6,nscrt7,nscrt8,ngen3,ngen4,ngen5,ngen6,ngen7,ngen8

   ! pointers
   integer::next,icont,iholl,ifild,igrup

   ! file identification
   real(kr)::huse(2)
   character(8)::tuse(2)
   equivalence(huse(1),tuse(1))
   integer::ivers

   ! file control
   integer::ntype,npart,nholl,nmat,maxw,length

   ! file data
   character(8)::hprt(10),htype(10),hmatn(250)
   integer::ngrp(10),jinp(10),joutp(10),matno(250),matgg(250)

   ! group structure sizes
   integer::ning,noutg

   ! reaction names
   character(8)::hvps(3000),hmtx(3000)

   ! self-shielding parameters
   integer::iz,iglt

   ! matrix parameters
   integer::imcon,icdat,ijgll,imdat,ng2z,lord1,jconst
   integer::maxord,nsubmx
   integer::nritev,nritem
   integer::ntw

contains

   subroutine matxsr
   !-------------------------------------------------------------------
   !
   !  Produce MATXS interface file from NJOY intermediate cross
   !  section data from group or gaminr.
   !
   !  The matxs file uses a generalized, flexible format based on
   !  the CCCC interface conventions.  Working from groupr and/or
   !  gaminr output tapes, this module can process neutron,
   !  thermal, photon, and charged-particle data into a
   !  single output file.  This file can then be used by the
   !  TRANSX code to prepare data libraries for transport codes.
   !
   !  A MATXS file specification may be found following the
   !  input instructions.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1 units
   !   ngen1     input unit for data from groupr
   !   ngen2     input unit for data from gaminr
   !   nmatx     output unit for matxs
   !   ngen3     incident proton data from groupr (default=0)
   !   ngen4     incident deuteron data from groupr (default=0)
   !   ngen5     incident triton data from groupr (default=0)
   !   ngen6     incident he3 data from groupr (default=0)
   !   ngen7     incident alpha data from groupr (default=0)
   !   ngen8     photonuclear data from groupr (default=0)
   ! card 2 user identification
   !   ivers     file version number (default=0)
   !   huse      user id (up to 16 characters, delimited by *,
   !             ended by /) (default=blank)
   ! card 3 file control
   !   npart     number of particles for which group
   !                structures are given
   !   ntype     number of data types in set
   !   nholl     number of cards to be read for hollerith
   !             identification record.
   !   nmat      number of materials desired
   ! card 4 set hollerith identification
   !   hsetid    hollerith identification of set
   !             (each line can be up to 72 characters,
   !             delimited with *, ended by /)
   ! card 5 particle identifiers
   !   hpart     hollerith identifiers for particles
   !             (up to 8 characters each)
   ! card 6 energy groups
   !   ngrp      number of groups for each particle
   ! card 7 data type identifiers
   !   htype     hollerith identifiers for data types
   !             (up to 8 characters each)
   ! card 8 input particle ids
   !   jinp     input particle id for each data type
   ! card 9 output particle ids
   !   joutp    output particle id for each data type
   ! card 10 material data (one card per material)
   !   hmat      hollerith material identifier
   !             (up to 8 characters each)
   !   matno     integer material identifier
   !             (endf mat number)
   !   matgg     mat number for photoatomic data
   !             (default=100*(matno/100) as in endf-6)
   !
   !-------------------------------------------------------------------

!          Standardized CCCC format listing for MATXS file
!c
!c**********************************************************************
!c               proposed 09/09/77
!c                       (modified 09/80)
!c                       (nomenclature changed 06/88)
!c                       (modified for const sub-blocks 06/90)
!c                       (ordering changed 10/90)
!c     c                       (bcd format changed 12/21/91)
!c
!cf           matxs
!ce           material cross section file
!c
!cn                       this file contains cross section
!cn                       vectors and matrices for all
!cn                       particles, materials, and reactions;
!cn                       delayed neutron spectra by time group;
!cn                       and decay heat and photon spectra.
!c
!cn           formats given are for file exchange only
!c
!c**********************************************************************
!c
!c
!c----------------------------------------------------------------------
!cs          file structure
!cs
!cs              record type                       present if
!cs              ==============================    ===============
!cs              file identification                 always
!cs              file control                        always
!cs              set hollerith identification        always
!cs              file data                           always
!cs
!cs   *************(repeat for all particles)
!cs   *          group structures                    always
!cs   *************
!cs
!cs   *************(repeat for all materials)
!cs   *          material control                    always
!cs   *
!cs   * ***********(repeat for all submaterials)
!cs   * *        vector control                      n1db.gt.0
!cs   * *
!cs   * * *********(repeat for all vector blocks)
!cs   * * *      vector block                        n1db.gt.0
!cs   * * *********
!cs   * *
!cs   * * *********(repeat for all matrix blocks)
!cs   * * *      matrix control                      n2d.gt.0
!cs   * * *
!cs   * * * *******(repeat for all sub-blocks)
!cs   * * * *    matrix sub-block                    n2d.gt.0
!cs   * * * *******
!cs   * * *
!cs   * * *      constant sub-block                  jconst.gt.0
!cs   * * *
!cs   *************
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr           file identification
!c
!cl    hname,(huse(i),i=1,2),ivers
!c
!cw    1+3*mult
!c
!cb    format(4h 0v ,a8,1h*,2a8,1h*,i6)
!c
!cd    hname         hollerith file name  - matxs -  (a8)
!cd    huse          hollerith user identifiation    (a8)
!cd    ivers         file version number
!cd    mult          double precision parameter
!cd                       1- a8 word is single word
!cd                       2- a8 word is double precision word
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr           file control
!c
!cl    npart,ntype,nholl,nmat,maxw,length
!c
!cw    6
!c
!cb    format(6h 1d   ,6i6)
!c
!cd    npart       number of particles for which group
!cd                   structures are given
!cd    ntype       number of data types present in set
!cd    nholl       number of words in set hollerith
!cd                    identification record
!cd    nmat        number of materials on file
!cd    maxw        maximum record size for sub-blocking
!cd    length      length of file
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr           set hollerith identification
!c
!cl    (hsetid(i),i=1,nholl)
!c
!cw    nholl*mult
!c
!cb    format(4h 2d /(9a8))
!c
!cd    hsetid      hollerith identification of set (a8)
!cd                 (to be edited out 72 characters per line)
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          file data
!c
!cl    (hprt(j),j=1,npart),(htype(k),k=1,ntype),(hmatn(i),i=1,nmat),
!cl   1(ngrp(j),j=1,npart),(jinp(k),k=1,ntype,(joutp(k),k=1,ntype),
!cl   2(nsubm(i)i=1,nmat),(locm(i),i=1,nmat)
!c
!cw    (npart+ntype+nmat)*mult+2*ntype+npart+2*nmat
!c
!cb    format(4h 3d ,4x,8a8/(9a8))    hprt,htype,hmatn
!cb    format(12i6)                  ngrp,jinp,joutp,nsubm,locm
!c
!cd    hprt(j)     hollerith identification for particle j
!cd                     n         neutron
!cd                     g         gamma
!cd                     p         proton
!cd                     d         deuteron
!cd                     t         triton
!cd                     h         he-3 nucleus
!cd                     a         alpha (he-4 nucleus)
!cd                     b         beta
!cd                     r         residual or recoil
!cd                               (heavier than alpha)
!cd    htype(k)     hollerith identification for data type k
!cd                     nscat     neutron scattering
!cd                     ng        neutron induced gamma production
!cd                     gscat     gamma scattering (atomic)
!cd                     gg        gamma scattering (photonuclear)
!cd                     pn        proton induced neutron production
!cd                       .          .
!cd                       .          .
!cd                       .          .
!cd                     dkn       delayed neutron data
!cd                     dkhg      decay heat and gamma data
!cd                     dkb       decay beta data
!cd    hmatn(i)    hollerith identification for material i
!cd    ngrp(j)      number of energy groups for particle j
!cd    jinp(k)     type of incident particle associated with
!cd                   data type k.  for dk data types, jinp is 0.
!cd    joutp(k)    type of outgoing particle associated with
!cd                   data type k
!cd    nsubm(i)    number of submaterials for material i
!cd    locm(i)     location of material i
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          group structure
!c
!cl    (gpb(i),i=1,ngr),emin
!c
!cc    ngr=ngrp(j)
!c
!cw    ngrp(j)+1
!c
!cb    format(4h 4d ,8x,1p,5e12.5/(6e12.5))
!c
!cd    gpb(i)      maximum energy bound for group i for particle j
!cd    emin        minimum energy bound for particle j
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          material control
!c
!cl    hmat,amass,(temp(i),sigz(i),itype(i),n1d(i),n2d(i),
!cl   1locs(i),i=1,nsubm)
!c
!cw    mult+1+6*nsubm
!c
!cb    format(4h 5d ,a8,1p,2e12.5/(2e12.5,5i6))
!c
!cd    hmat        hollerith material identifier
!cd    amass       atomic weight ratio
!cd    temp        ambient temperature or other parameters for
!cd                    submaterial i
!cd    sigz        dilution factor or other parameters for
!cd                    submaterial i
!cd    itype       data type for submaterial i
!cd    n1d         number of vectors for submaterial i
!cd    n2d         number of matrix blocks for submaterial i
!cd    locs        location of submaterial i
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          vector control
!c
!cl    (hvps(i),i=1,n1d),(nfg(i),i=1,n1d),(nlg(i),i=1,n1d)
!c
!cw    (mult+2)*n1d
!c
!cb    format(4h 6d ,4x,8a8/(9a8))      hvps
!cb    format(12i6)                    iblk,nfg,nlg
!c
!cd    hvps(i)     hollerith identifier of vector
!cd                      nelas     neutron elastic scattering
!cd                      n2n       (n,2n)
!cd                      nnf       second chance fission
!cd                      gabs      gamma absorption
!cd                      p2n       protons in, 2 neutrons out
!cd                         .          .
!cd                         .          .
!cd                         .          .
!cd    nfg(i)      number of first group in band for vector i
!cd    nlg(i)      number of last group in band for vector i
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          vector block
!c
!cl    (vps(i),i=1,kmax)
!c
!cc    kmax=sum over group band for each vector in block j
!c
!cw    kmax
!c
!cb    format(4h 7d ,8x,1p,5e12.5/(6e12.5))
!c
!cd    vps(i)      data for group bands for vectors in block j.
!cd                block size is determined by taking all the group
!cd                bands that have a total length less than or equal
!cd                to maxw.
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr        scattering matrix control
!c
!cl    hmtx,lord,jconst,
!cl   1(jband(l),l=1,noutg(k)),(ijj(l),l=1,noutg(k))
!c
!cw    mult+2+2*noutg(k)
!c
!cb    format(4h 8d ,4x,a8/(12i6))      hmtx,lord,jconst,
!cb                                     jband,ijj
!c
!cd    hmtx        hollerith identification of block
!cd    lord        number of orders present
!cd    jconst      number of groups with constant spectrum
!cd    jband(l)    bandwidth for group l
!cd    ijj(l)      lowest group in band for group l
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          scattering sub-block
!c
!cl    (scat(k),k=1,kmax)
!c
!cc    kmax=lord times the sum over all jband in the group range of
!cc            this sub-block
!c
!cb    format(4h 9d ,8x,1p,5e12.5/(6e12.5))
!c
!cw    kmax
!c
!cd    scat(k)     matrix data given as bands of elements for initial
!cd                groups that lead to each final group.  the order
!cd                of the elements is as follows:  band for p0 of
!cd                group i, band for p1 of group i, ... , band for p0
!cd                of group i+1, band for p1 of group i+1, etc.  the
!cd                groups in each band are given in descending order.
!cd                the size of each sub-block is determined by the
!cd                total length of a group of bands that is less than
!cd                or equal to maxw.
!cd
!cd                if jconst.gt.0, the contributions from the jconst
!cd                low-energy groups are given separately.
!c
!c----------------------------------------------------------------------
!c
!c
!c----------------------------------------------------------------------
!cr          constant sub-block
!c
!cl    (spec(l),l=1,noutg(k)),(prod(l),l=l1,ning(k))
!c
!cc    l1=ning(k)-jconst+1
!c
!cw    noutg(k)+jconst
!c
!cb    format(4h10d ,8x,1p,5e12.5/(6e12.5))
!c
!cd    spec        normalized spectrum of final particles for initial
!cd                particles in groups l1 to ning(k)
!cd    prod        production cross section (e.g., nu*sigf) for
!cd                initial groups l1 through ning(k)
!cd
!cd         this option is normally used for the energy-independent
!cd         neutron and photon spectra from fission and radiative
!cd         capture usually seen at low energies.
!c
!c----------------------------------------------------------------------
!c

   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use util   ! provides timer,openz,closz
   ! internals
   real(kr)::time
   character(16)::word

   !--initialize.
   call timer(time)
   write(nsyso,'(/&
     &'' matxsr...produce a matxs format output file'',&
     &25x,f8.1,''s'')') time
   write(nsyse,'(/'' matxsr...'',59x,f8.1,''s'')') time

   !--read users input/output unit numbers.
   ngen1=0
   ngen2=0
   nmatx=0
   ngen3=0
   ngen4=0
   ngen5=0
   ngen6=0
   ngen7=0
   ngen8=0
   read(nsysi,*) ngen1,ngen2,nmatx,ngen3,ngen4,ngen5,ngen6,ngen7,ngen8
   write(nsyso,'(/&
     &'' input gendf unit ..................... '',i10/&
     &'' input gamout unit .................... '',i10/&
     &'' output matxs unit .................... '',i10)')&
     ngen1,ngen2,nmatx
   if (ngen3.ne.0) write(nsyso,'(&
     &'' incident proton unit ................. '',i10/&
     &'' incident deuteron unit ............... '',i10/&
     &'' incident triton unit ................. '',i10/&
     &'' incident he3 unit .................... '',i10/&
     &'' incident alpha unit .................. '',i10/&
     &'' photonuclear unit .................... '',i10)')&
     ngen3,ngen4,ngen5,ngen6,ngen7,ngen8
   nscrt1=10
   nscrt2=11
   nscrt3=12
   nscrt4=13
   nscrt5=14
   nscrt6=15
   nscrt7=16
   nscrt8=17
   call openz(ngen1,0)
   call openz(ngen2,0)
   call openz(ngen3,0)
   call openz(ngen4,0)
   call openz(ngen5,0)
   call openz(ngen6,0)
   call openz(ngen7,0)
   call openz(ngen8,0)
   call openz(nmatx,1)
   call openz(-nscrt2,1)
   call openz(-nscrt3,1)
   call openz(-nscrt6,1)

   !--user input for file identification
   ivers=0
   word=' '
   read(nsysi,*) ivers,word
   read(word,'(a8,a8)') tuse(1),tuse(2)
   write(nsyso,'(&
     &'' file version number .................. '',i10/&
     &'' user id .............................. '',2a8)')&
     ivers,tuse

   !--generate matxs file
   call cmatxs

   !--finished
   call closz(nmatx)
   call closz(ngen1)
   call closz(ngen2)
   call closz(ngen3)
   call closz(ngen4)
   call closz(ngen5)
   call closz(ngen6)
   call closz(ngen7)
   call closz(ngen8)
   call closz(-nscrt2)
   call closz(-nscrt3)
   call closz(-nscrt6)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/1x,7(''**********''),&
     &''*******'')') time
   return
   end subroutine matxsr

   subroutine cmatxs
   !-------------------------------------------------------------------
   ! Writes matxs interface file to nmatx.
   !------------------------------------------------------------------
   use util ! provides repoz
   ! internals
   integer::irec2,irec3,irec6,iscrt,iscrh,nwds,irec,i
   integer::ihholl,ndr,nir,ihfild,lout,loc,j,imatc,nsubj,ihmatc
   integer::ll,ij,itype,n1d,n2d,ivcon,nw,ihvcon,ivdat,l
   integer::nfg,nlg,nwmcr,nwdc,n,ihmcon,lord,m,jj,k
   character(6),parameter::hfile='matxs '
   nsubmx=100
   maxord=5
   maxw=5000

   !--read user input
   call ruinm

   !--initiate reformatting of data
   call mtxdat
   irec2=0
   irec3=0
   irec6=0
   call repoz(-nscrt2)
   call repoz(-nscrt3)
   call repoz(-nscrt6)

   !--point to scratch area
   iscrt=next
   iscrt=(iscrt/2)*2+1
   iscrh=(iscrt-1)/mult+1

   !--write file identification to nmatx
   nwds=3*mult+1
 ! read(hfile,'(a)') ha(iscrh)
   ha(iscrh+1)=huse(1)
   ha(iscrh+2)=huse(2)
   ia(iscrt+3*mult)=ivers
   irec=1
   if (nmatx.lt.0)&
     write(-nmatx)(ha(iscrh+i-1),i=1,3),ia(iscrt+3*mult)
   if (nmatx.gt.0) write(nmatx,'('' 0v '',a8,''*'',2a8,''*'',i6)')&
     hfile,tuse(1),tuse(2),ivers

   !--write file control record to nmatx
   nwds=6
   irec=2
   ia(icont+4)=maxw
   ia(icont+5)=length+5+npart
   if (nmatx.lt.0) write(-nmatx)(ia(icont+i-1),i=1,nwds)
   if (nmatx.gt.0) write(nmatx,'('' 1d   '',6i6)')&
     (ia(icont+i-1),i=1,nwds)

   !--write set hollerith id to nmatx
   nwds=mult*nholl
   irec=3
   ihholl=(iholl-1)/mult
   if (nmatx.lt.0) write(-nmatx) (ha(ihholl+i),i=1,nholl)
   if (nmatx.gt.0) write(nmatx,'('' 2d ''/(9a8))')&
     (ta(ihholl+i),i=1,nholl)

   !--write file data
   ndr=npart+ntype+nmat
   nir=npart+2*ntype+2*nmat
   nwds=ndr*mult+nir
   irec=4
   ihfild=(ifild-1)/mult
   if (nmatx.lt.0) write(-nmatx) (ha(ihfild+i),i=1,ndr),&
     (ia(ifild+ndr*mult+i-1),i=1,nir)
   if (nmatx.gt.0) then
      write(nmatx,'('' 3d '',4x,8a8/(9a8))') (ta(ihfild+i),i=1,ndr)
      write(nmatx,'(12i6)') (ia(ifild+ndr*mult+i-1),i=1,nir)
   endif

   !--write group structures
   lout=igrup
   do i=1,npart
      loc=ifild-1+(npart+ntype+nmat)*mult+i
      nwds=ia(loc)+1
      irec=irec+1
      if (nmatx.lt.0) write(-nmatx) (a(lout+j-1),j=1,nwds)
      if (nmatx.gt.0) write(nmatx,&
        '('' 4d '',1p,8x,5e12.5/(6e12.5))') (a(lout+j-1),j=1,nwds)
      lout=lout+nwds
   enddo

   !--loop over materials
   do j=1,nmat

      !--copy material control
      imatc=iscrt
      loc=ifild-1+(npart+ntype+nmat)*mult+npart+2*ntype+j
      nsubj=ia(loc)
      nwds=mult+1+6*nsubj
      irec6=irec6+1
      ihmatc=(imatc-1)/mult+1
      ll=imatc+mult
      read(nscrt6) ha(ihmatc),a(imatc+mult),&
        ((a(ll+6*(i-1)+k),k=1,2),(ia(ll+6*(i-1)+k),k=3,6),i=1,nsubj)
      irec=irec+1
      if (nmatx.lt.0) write(-nmatx) ha(ihmatc),a(imatc+mult),&
        ((a(ll+6*(i-1)+k),k=1,2),(ia(ll+6*(i-1)+k),k=3,6),i=1,nsubj)
      if (nmatx.gt.0) then
         write(nmatx,'('' 5d '',a8,1p,e12.5)')&
           ta(ihmatc),a(imatc+mult)
         do i=1,nsubj
            ll=imatc+mult+1+6*(i-1)
            write(nmatx,'(1p,2e12.5,4i6)') a(ll),a(ll+1),&
              ia(ll+2),ia(ll+3),ia(ll+4),ia(ll+5)
         enddo
      endif
      next=imatc+nwds+mult-1

      !--loop over all submaterials
      do ij=1,nsubj
         itype=ia(imatc+mult+6*(ij-1)+3)
         n1d=ia(imatc+mult+6*(ij-1)+4)
         n2d=ia(imatc+mult+6*(ij-1)+5)
         ning=ngrp(jinp(itype))
         noutg=ngrp(joutp(itype))
         if (n1d.ne.0) then

            !--copy vector control
            ivcon=next
            nwds=(mult+2)*n1d
            nw=2*n1d
            irec2=irec2+1
            ihvcon=(ivcon-1)/mult
            read(nscrt2)&
              (ha(ihvcon+i),i=1,n1d),(ia(ivcon+n1d*mult+i-1),i=1,nw)
            irec=irec+1
            if (nmatx.lt.0) then
               write(-nmatx)&
                 (ha(ihvcon+i),i=1,n1d),(ia(ivcon+n1d*mult+i-1),i=1,nw)
            else if (nmatx.gt.0) then
               write(nmatx,'('' 6d '',4x,8a8/(9a8))')&
                 (ta(ihvcon+i),i=1,n1d)
               write(nmatx,'(12i6)') (ia(ivcon+n1d*mult+i-1),i=1,nw)
            endif
            ivdat=ivcon+nwds

            !--copy vector partial blocks
            nwds=0
            do l=1,n1d
               loc=ivcon-1+mult*n1d+l
               nfg=ia(loc)
               nlg=ia(loc+n1d)
               nw=nlg-nfg+1
               if (nwds+nw.ge.maxw) then
                  irec3=irec3+1
                  read(nscrt3) (a(ivdat+i-1),i=1,nwds)
                  irec=irec+1
                  if (nmatx.lt.0) then
                     write(-nmatx) (a(ivdat+i-1),i=1,nwds)
                  else if (nmatx.gt.0) then
                     write(nmatx,&
                       '('' 7d '',8x,1p,5e12.5/(6e12.5))')&
                       (a(ivdat+i-1),i=1,nwds)
                  endif
                  nwds=0
               endif
               nwds=nwds+nw
            enddo
            if (nwds.gt.0) then
               irec3=irec3+1
               read(nscrt3) (a(ivdat+i-1),i=1,nwds)
               irec=irec+1
               if (nmatx.lt.0) then
                  write(-nmatx) (a(ivdat+i-1),i=1,nwds)
               else if (nmatx.gt.0) then
                  write(nmatx,&
                    '('' 7d '',8x,1p,5e12.5/(6e12.5))')&
                    (a(ivdat+i-1),i=1,nwds)
               endif
            endif
         endif

         !--loop over matrix blocks
         if (n2d.ne.0) then
            imcon=next
            nwmcr=mult+2+2*noutg
            icdat=imcon+nwmcr
            nwdc=noutg+ning
            imdat=icdat+nwdc
            do n=1,n2d

               !--copy matrix control record
               irec2=irec2+1
               ihmcon=(imcon-1)/mult+1
               nw=nwmcr-mult
               read(nscrt2) ha(ihmcon),(ia(imcon+mult+i-1),i=1,nw)
               irec=irec+1
               if (nmatx.lt.0) then
                  write(-nmatx) ha(ihmcon),(ia(imcon+mult+i-1),i=1,nw)
               else if (nmatx.gt.0) then
                  write(nmatx,'('' 8d '',4x,a8)') ta(ihmcon)
                  write(nmatx,'(12i6)') (ia(imcon+mult+i-1),i=1,nw)
               endif

               !--copy matrix sub-blocks
               loc=imcon+mult
               lord=ia(loc)
               loc=loc+1
               jconst=ia(loc)
               nwdc=noutg+jconst
               if (lord.ne.0) then
                  m=loc
                  nwds=0
                  do jj=1,noutg
                     l=m+jj
                     nw=ia(l)
                     if (nwds+nw*lord.ge.maxw.and.nwds.gt.0) then
                        irec3=irec3+1
                        read(nscrt3) (a(imdat+i-1),i=1,nwds)
                        irec=irec+1
                        if (nmatx.lt.0) then
                           write(-nmatx) (a(imdat+i-1),i=1,nwds)
                        else if (nmatx.gt.0) then
                           write(nmatx,&
                             '('' 9d '',8x,1p,5e12.5/(6e12.5))')&
                             (a(imdat+i-1),i=1,nwds)
                        endif
                        nwds=0
                     endif
                     nwds=nwds+nw*lord
                  enddo
                  if (nwds.gt.0) then
                     irec3=irec3+1
                     read(nscrt3) (a(imdat+i-1),i=1,nwds)
                     irec=irec+1
                     if (nmatx.lt.0) then
                        write(-nmatx) (a(imdat+i-1),i=1,nwds)
                     else if (nmatx.gt.0) then
                        write(nmatx,&
                          '('' 9d '',8x,1p,5e12.5/(6e12.5))')&
                          (a(imdat+i-1),i=1,nwds)
                     endif
                  endif
               endif
               if (jconst.gt.0) then
                  irec3=irec3+1
                  read(nscrt3) (a(icdat+i-1),i=1,nwdc)
                  irec=irec+1
                  if (nmatx.lt.0) then
                     write(-nmatx) (a(icdat+i-1),i=1,nwdc)
                  else if (nmatx.gt.0) then
                     write(nmatx,&
                       '(''10d '',8x,1p,5e12.5/(6e12.5))')&
                       (a(icdat+i-1),i=1,nwdc)
                  endif
               endif

            !--end of loop over matrix blocks
            enddo
         endif

      !--end of submaterial loop
      enddo

   !--end of material loop
   enddo
   return
   end subroutine cmatxs

   subroutine ruinm
   !-------------------------------------------------------------------
   ! Read user input.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! internals
   integer::lim,i,j,ifih,nwds,loc
   character(72)::text

   !--read file control parameters
   read(nsysi,*) npart,ntype,nholl,nmat
   write(nsyso,'(&
     &'' npart ................................ '',i10/&
     &'' ntype ................................ '',i10/&
     &'' nholl ................................ '',i10/&
     &'' nmat ................................. '',i10/&
     &'' maxw ................................. '',i10)')&
     npart,ntype,nholl,nmat,maxw

   !--load file identification record
   lim=9
   icont=1
   next=icont+6
   ia(icont)=npart
   ia(icont+1)=ntype
   ia(icont+2)=nholl*lim
   ia(icont+3)=nmat
   ia(icont+4)=0
   ia(icont+5)=0

   !--read and load hollerith set identification
   write(nsyso,&
     '(/'' set identification''/'' ------------------'')')
   lim=9
   iholl=next
   nwds=nholl*mult*lim
   next=iholl+nwds
   do i=1,nholl
      text=' '
      read(nsysi,*) text
      loc=(iholl-1)/mult+lim*(i-1)
      read(text,'(9a8)') (ta(loc+j),j=1,lim)
      write(nsyso,'(6x,9a8)') (ta(j+loc),j=1,lim)
   enddo
   nholl=nholl*lim

   !--read particle identifiers
   read(nsysi,*) (hprt(i),i=1,npart)
   write(nsyso,'(/&
     &'' names of particles ................... '',&
     &6x,5(a8,2x))')&
     (hprt(i),i=1,npart)

   !--read number of groups for each particle
   read(nsysi,*) (ngrp(i),i=1,npart)
   write(nsyso,'(&
     &'' no. groups for each particle ......... '',&
     &2x,12i10)')&
     (ngrp(i),i=1,npart)

   !--read hollerith names for data types
   read(nsysi,*) (htype(i),i=1,ntype)
   write(nsyso,'(&
     &'' names of data types .................. '',&
     &6x,12(a8,2x))')&
     (htype(i),i=1,ntype)

   !--read input and output particles for data types
   read(nsysi,*) (jinp(i),i=1,ntype)
   read(nsysi,*) (joutp(i),i=1,ntype)
   write(nsyso,'(&
     &'' input particles ...................... '',2x,12i10)')&
     &(jinp(i),i=1,ntype)
   write(nsyso,'(&
     &'' output particles ..................... '',2x,12i10)')&
     (joutp(i),i=1,ntype)

   !--read in material names and id numbers
   do i=1,nmat
      matgg(i)=0
      read(nsysi,*) hmatn(i),matno(i),matgg(i)
      if (matgg(i).eq.0) matgg(i)=100*(matno(i)/100)
   enddo

   !--set up file data record
   ifild=next
   nwds=(npart+ntype+nmat)*mult+2*ntype+2*nmat+npart
   nwds=((nwds+1)/2)*2
   next=ifild+nwds
   ifih=(ifild-1)/mult+1
   loc=ifih-1
   do i=1,npart
      read(hprt(i),'(a8)') ta(loc+i)
   enddo
   loc=loc+npart
   do i=1,ntype
      read(htype(i),'(a8)') ta(loc+i)
   enddo
   loc=loc+ntype
   do i=1,nmat
      read(hmatn(i),'(a8)') ta(loc+i)
   enddo
   loc=ifild-1+(npart+ntype+nmat)*mult
   do i=1,npart
      ia(loc+i)=ngrp(i)
   enddo
   do i=1,ntype
      ia(loc+npart+i)=jinp(i)
      ia(loc+npart+ntype+i)=joutp(i)
   enddo
   return
   end subroutine ruinm

   subroutine mtxdat
   !-------------------------------------------------------------------
   ! Processes matxs data and writes to scratch tapes.
   !-------------------------------------------------------------------
   use endf   ! provides endf routines and variables
   use util   ! provides error,repoz,openz,timer,closz
   use mainio ! provides nsyso
   ! internals
   integer::ngpb,i,nin,nb,nw,ng1,ng2,iqd,iqg,ndex
   integer::ip,imatc,loca,irec2,irec3,irec6,im,k,imloc
   integer::imatch,isubm,locs,imat,n2d,itemp,isigz
   integer::nsigz,ll,lz,nwds,nz,nqd,nqg,nwmc,j
   integer::ip1,ip2,nscr,nref,mfv,mfm,nsz,jmat
   integer::nnmat,iref,mz,nl,ng,max,ig,loc,n1d,ihmatc
   real(kr)::temp,awr,sec
   character(60)::strng
   integer,parameter::nbmax=2000
   real(kr)::b(nbmax)
   real(kr)::sigz(15)
   integer::noned(15),ntwod(15)
   character(8)::htyp
   character(1)::hp
   character(8),parameter::hnt='n     '
   character(8),parameter::hgm='g     '
   character(8),parameter::hprot='p     '
   character(8),parameter::hdeut='d     '
   character(8),parameter::htrit='t     '
   character(8),parameter::hhe3='h     '
   character(8),parameter::halph='a     '
   character(8),parameter::hgsct='gscat '
   character(8),parameter::hgg='gg '
   character(8),parameter::hnthr='ntherm'
   integer,parameter::mtt1=221
   integer,parameter::mtt2=250
   real(kr),parameter::eps=1.0e-06_kr
   lz=6

   !--assign storage for group structure records
   ngpb=0
   do i=1,npart
      ngpb=ngrp(i)+1+ngpb
   enddo
   nwds=((ngpb-1)/2+1)*2
   igrup=next
   next=igrup+nwds

   !--choose input file to read group structures
   !--for now, all particles are assumed to use the neutron structur
   !--this is a limitation of the current implementation in groupr
   nin=ngen1
   if (nin.eq.0) nin=ngen3
   if (nin.eq.0) nin=ngen4
   if (nin.eq.0) nin=ngen5
   if (nin.eq.0) nin=ngen6
   if (nin.eq.0) nin=ngen7
   if (nin.eq.0) nin=ngen8
   if (nin.eq.0) nin=ngen2
   if (nin.eq.0) call error('mtxdat','input error (nin=0)',' ')

   !--read head record and store groups bounds
   call repoz(nin)
   call tpidio(nin,0,0,b(1),nb,nw)
   mfh=0
   do while (mfh.eq.0.or.mth.eq.0)
      call contio(nin,0,0,b(1),nb,nw)
   enddo
   nz=l2h
   ntw=n2h
   call lst1io(nin,0,0,b(1),nb,nw,nbmax)
   ng1=l1h
   ng2=l2h
   iqd=1+6+ntw+nz
   iqg=iqd+ng1+1
   ndex=igrup
   nqd=ng1+1
   nqg=ng2+1
   do ip=1,npart
      if (ip.eq.1.or.hprt(ip).ne.hgm) then
         do i=1,nqd
            a(ndex+nqd-i)=b(iqd-1+i)
         enddo
         ndex=ndex+nqd
      else
         do i=1,nqg
            a(ndex+nqg-i)=b(iqg-1+i)
         enddo
         ndex=ndex+nqg
      endif
   enddo

   !--material loop
   nwmc=2*mult+6*nsubmx
   nwmc=(((nwmc-1)/2)+1)*2
   imatc=next
   next=imatc+nwmc
   loca=0
   length=0
   write(nsyso,'(/)')
   irec2=0
   irec3=0
   irec6=0
   do 700 im=1,nmat
   do k=1,nwmc
      a(k-1+imatc)=0.
   enddo
   imatch=(imatc-1)/mult+1
   read(hmatn(im),'(a8)') ta(imatch)
   isubm=0
   locs=0

   !--data type loop
   do 600 i=1,ntype
   imat=matno(im)
   if (htype(i).eq.hgsct) then
      imat=matgg(im)
      if (hmatn(im)(1:2).eq.'fm') imat=9920
   endif
   ning=ngrp(jinp(i))
   noutg=ngrp(joutp(i))

   !--choose input unit and data files for this data type
   htyp=htype(i)
   ip1=jinp(i)
   ip2=joutp(i)
   if (hprt(ip1).eq.hnt) nin=ngen1
   if (hprt(ip1).eq.hgm) nin=ngen8
   if (hprt(ip1).eq.hgm.and.htyp.eq.hgsct) nin=ngen2
   if (hprt(ip1).eq.hprot) nin=ngen3
   if (hprt(ip1).eq.hdeut) nin=ngen4
   if (hprt(ip1).eq.htrit) nin=ngen5
   if (hprt(ip1).eq.hhe3) nin=ngen6
   if (hprt(ip1).eq.halph) nin=ngen7
   call repoz(nin)
   nscr=nscrt1
   if (nin.lt.0) nscr=-nscrt1
   nref=nscrt5
   if (nin.lt.0) nref=-nscrt5
   call openz(nscr,1)
   call openz(nref,1)
   mfv=3
   if (ip1.ne.ip2) mfv=0
   if (hprt(ip2).eq.hgm.and.htyp.ne.hgg) mfv=13
   if (hprt(ip1).eq.hgm.and.htyp.eq.hgsct) mfv=23
   if (mfv.ne.0) mfm=mfv+3
   if (hprt(ip2).eq.hnt) mfm=6
   if (hprt(ip2).eq.hprot) mfm=21
   if (hprt(ip2).eq.hdeut) mfm=22
   if (hprt(ip2).eq.htrit) mfm=23
   if (hprt(ip2).eq.hhe3) mfm=24
   if (hprt(ip2).eq.halph) mfm=25
   if (hprt(ip2).eq.hgm.and.htyp.eq.hgg) mfm=16
   hp=hprt(ip1)(1:1)

   !--find the material
   call tpidio(nin,0,0,b(1),nb,nw)
   nsz=0
   jmat=0
   nnmat=0
   isigz=0
   nsigz=0
   call findg(imat,1,451,nin)

   !--read head record for material
   call contio(nin,0,0,b(1),nb,nw)
   ll=1+6
   if (i.eq.1) awr=c2h
   nz=l2h
   ntw=n2h
   nsh=1
   call lst1io(nin,0,0,b(ll),nb,nw,nbmax)
   temp=c1h
   nnmat=nnmat+1
   nsigz=nz
   do k=1,nsigz
      sigz(k)=b(k+lz+ntw-1+ll)
   enddo
   isigz=1
   if (imat.eq.jmat) go to 300
   itemp=1
   jmat=imat
   go to 320
  300 continue
   call contio(nin,0,0,b(1),nb,nw)
   if (math.ne.imat) go to 475
   itemp=itemp+1
   isigz=1
   if (mfh.ne.1.or.mth.ne.451) then
      call listio(nin,0,0,b(ll),nb,nw)
      temp=c1h
      do while (nb.ne.0)
         call moreio(nin,0,0,b(ll),nb,nw)
      enddo
   else
      ntw=n2h
      call lst1io(nin,0,0,b(ll),nb,nw,nbmax)
      temp=c1h
   endif

   !--copy this material to scratch files
  320 continue
   call repoz(nscr)
   iref=0
   if (itemp.eq.1.and.isigz.eq.1) iref=nref
   call repoz(iref)
   nsh=0
   nsc=0
   call amend(nscr,iref)
   iglt=1000
   do mz=1,nsigz
      noned(mz)=0
      ntwod(mz)=0
   enddo
  340 continue
   call contio(nin,0,0,b(1),nb,nw)
   if (math.le.0) go to 430
   if (mfh.eq.0.or.mth.eq.0) go to 340
   nl=l1h
   nz=l2h
   ng=n2h
   max=6+nl*nz*(ng+1)
   if (max.gt.nsz) nsz=max
   call listio(nin,0,0,b(ll),nb,nw)
   ng2=l1h
   ig=n2h
   if (ng2.ne.2.or.ig.ne.ng) go to 360
   loc=ll+6+nl*nz
   if (abs(b(loc)).ge.eps) go to 360
   go to 420
  360 continue
   if (ig.gt.1.and.ig.lt.iglt) iglt=ig
   if (htyp.eq.hnthr.and.(mth.lt.mtt1.or.mth.gt.mtt2)) go to 420
   if (htyp.ne.hnthr.and.(mth.ge.mtt1.and.mth.le.mtt2)) go to 420
   if (htyp.eq.hnthr.and.mfh.ge.90) go to 420
   if (mfv.eq.3.and.mfh.gt.90) go to 365
   if (mfh.ne.mfv.and.mfh.ne.(mfv+2).and.&
     mfh.ne.mfm.and.mfh.ne.(mfm+1)) go to 420
  365 continue
   do 410 mz=1,nsigz
   if (nz.lt.mz) go to 410
   if (mfh.gt.90) go to 380
   if (mfh.ne.mfv) go to 390
   if (mth.ne.1) go to 370
   ! flux and ntot for all l-orders
   noned(mz)=noned(mz)+2*nl
   go to 410
   ! flux and gtot
  370 continue
   if (mth.ne.501) go to 375
   noned(mz)=noned(mz)+2
   go to 410
  375 continue
   if (mfh.gt.90) go to 380
   if (mfh.ne.2.or.mfm.lt.21) go to 380
   noned(mz)=noned(mz)+3
   go to 410
   ! other vector partials
  380 continue
   noned(mz)=noned(mz)+1
   go to 410
   ! search for delayed fission neutrons
  390 continue
   if (mfh.ne.(mfv+2)) go to 400
   if (mth.eq.455) noned(mz)=noned(mz)+1
   go to 410
   ! matrices (2-d arrays)
  400 continue
   if (mfh.eq.mfm) ntwod(mz)=ntwod(mz)+1
   if (mfh.eq.17.and.mfm.eq.16) ntwod(mz)=ntwod(mz)+1
  410 continue
   call contio(0,nscr,iref,b(1),nb,nw)
   call listio(0,nscr,iref,b(ll),nb,nw)
   call tosend(nin,nscr,iref,b(1))
   go to 340
  420 continue
   call tosend(nin,0,0,b(1))
   go to 340
  430 continue
   call amend(nscr,iref)
   call atend(nscr,iref)
   if (noned(1).gt.0.or.ntwod(1).gt.0) go to 435

   !--no data found
   write(strng,&
     '(''no data for itype='',i2,'' mat='',i4,'' itemp='',i1)')&
     i,imat,itemp
   call mess('mtxdat',strng,' ')

   !--label what we are now doing
  435 continue
   if (itemp.eq.1) then
      call timer(sec)
      write(nsyso,'(10x,''doing '',a8,'' for '',a8,'' ... '',&
        &f7.1,''s'')') hmatn(im),htype(i),sec
   endif

   !--loop over sigzeroes for this mat and temperature
   do while (isigz.le.nsigz)
      call repoz(nscr)
      iref=nref
      if (isigz.eq.1.and.itemp.eq.1) iref=0
      call repoz(iref)
      iz=isigz
      n1d=noned(isigz)
      nritev=0
      n2d=ntwod(isigz)
      nritem=0
      if (n1d.ne.0.or.n2d.ne.0) then

         !--produce vector cross sections
         if (n1d.ne.0)&
           call vector(mfv,hp,n1d,nscr,iref,irec2,irec3)

         !--produce matrix cross sections
         if (n2d.ne.0)&
           call matrix(irec3,irec2,mfm,hp,n2d,nscr,nscrt2,iref)

         !--enter submaterial data into material control
         isubm=isubm+1
         if (isubm.gt.nsubmx)&
            call error('mtxdat','too many submaterials',' ')
         imloc=imatc+mult+6*(isubm-1)
         a(imloc+1)=temp
         a(imloc+2)=sigz(isigz)
         ia(imloc+3)=i
         ia(imloc+4)=n1d
         ia(imloc+5)=n2d
         ia(imloc+6)=locs
         locs=locs+nritev+nritem
      endif
      isigz=isigz+1
   enddo
   go to 300

   !--close the scratch files
  475 continue
   call closz(nref)
   call closz(nscr)

   !--continue data type loop
  600 continue

   !--write material control and continue material loop
   a(imatc+mult)=awr
   nw=mult+1+6*isubm
   irec6=irec6+1
   ihmatc=(imatc-1)/mult+1
   ll=imatc+mult
   write(nscrt6) ha(ihmatc),a(imatc+mult),&
     ((a(ll+6*(i-1)+j),j=1,2),(ia(ll+6*(i-1)+j),j=3,6),i=1,isubm)
   loc=ifild-1+(npart+ntype+nmat)*mult+npart+2*ntype+im
   ia(loc)=isubm
   loc=loc+nmat
   ia(loc)=loca
   loca=loca+1+locs
   length=length+1+locs

   !--continue material loop
  700 continue

   !--finished
   next=imatc
   return
   end subroutine mtxdat

   subroutine findg(mat,mf,mt,ntape)
   !-------------------------------------------------------------------
   ! Search a gendf tape for the desired section.
   !-------------------------------------------------------------------
   use util ! provides error,repoz,skiprz
   ! externals
   integer::mat,mf,mt,ntape
   ! internals
   integer::itend,nt,ifirst,mat1,mf1,mt1,math,mfh,mth
   character(60)::strng

   if (mat.le.0.or.mf.le.0.or.mt.le.0) call error('findg',&
     'mat or mf or mt le 0 not allowed',' ')
   itend=0
   nt=iabs(ntape)
   ifirst=0
   mat1=-10
   mf1=-10
   mt1=-10
  110 continue
   if (ntape.ge.0) then
      read(ntape,'(66x,i4,i2,i3)',end=160) math,mfh,mth
   else
      read(nt,end=160) math,mfh,mth
   endif
   if (ifirst.gt.0) go to 150
   if (math.eq.0.and.mfh.eq.0.and.mth.eq.0) go to 110
   mat1=math
   mf1=mfh
   mt1=mth
   ifirst=1
  150 continue
   if (math.eq.mat) go to 170
   if (math.eq.-1) go to 160
   if (itend.eq.0) go to 110
   if (math.eq.mat1.and.mfh.eq.mf1.and.mth.eq.mt1) go to 165
   go to 110
   ! at end of tape.  rewind and try beginning
  160 continue
   itend=itend+1
   if (itend.gt.1) go to 165
   call repoz(ntape)
   go to 110
   ! desired section not on tape
  165 continue
   write(strng,'(''mat='',i4,'' mf='',i2,'' mt='',i3,&
     &'' not on tape '',i3)') mat,mf,mt,ntape
   call error('findg',strng,' ')
   ! desired mat found.  check for mf and mt
  170 continue
   if (mfh.ne.mf.or.mth.ne.mt) go to 110
   ! desired section found.  backspace one record
   call skiprz(ntape,-1)
   return
   end subroutine findg

   subroutine hname(hreact,hp,mt,lr,izam)
   !-------------------------------------------------------------------
   ! Assigns hollerith names to reactions.  If lr flag is set,
   ! an additional identifier is placed in the last three
   ! (or six) characters.
   !-------------------------------------------------------------------
   use endf ! provides iverf
   ! externals
   integer::mt,lr,izam
   character::hreact*(*),hp*(*)
   ! internals
   integer::i,jmt,jlr,ii,mm,jj
   character(6)::strng,temp
   integer,parameter::num1=33
   integer,dimension(33),parameter::i1=(/&
     2,3,4,5,6,7,8,9,16,17,18,19,20,21,22,23,24,25,&
     26,28,29,30,32,33,34,35,36,37,38,41,42,44,45/)
   character(5),dimension(33),parameter::h1=(/&
     'elas ','nonel','inel ','x    ','2n1  ','2n2  ','2n3  ','2n4  ',&
     '2n   ','3n   ','ftot ','f    ','nf   ','2nf  ','na   ','n3a  ',&
     '2na  ','3na  ','2ni  ','np   ','n2a  ','2n2a ','nd   ','nt   ',&
     'nh   ','nd2a ','nt2a ','4n   ','3nf  ','2np  ','3np  ','n2p  ',&
     'npa  '/)
   integer,parameter::num2=16
   integer,dimension(16),parameter::i2=(/&
     101,102,103,104,105,106,107,108,109,111,112,113,114,115,116,117/)
   character(5),dimension(16),parameter::h2=(/&
     'abs  ','g    ','p    ','d    ','t    ','h    ','a    ',&
     '2a   ','h3a  ','2p   ','pa   ','t2a  ','d2a  ','pd   ','pt   ',&
     'da   '/)
   character(5),dimension(7),parameter::h3=(/&
     '.neut','.gam ','.h1  ','.h2  ','.h3  ','.he3 ','.he4 '/)
   integer,parameter::num4=246
   character(6),dimension(26),parameter::h4=(/&
     'free  ','hh2o  ','poly  ','poly$ ','hzrh  ','hzrh$ ',&
     'benz  ','dd2o  ','graph ','graph$','be    ','be$   ',&
     'bebeo ','bebeo$','zrzrh ','zrzrh$','obeo  ','obeo$ ',&
     'ouo2  ','ouo2$ ','uuo2  ','uuo2$ ','al    ','al$   ',&
     'fe    ','fe$   '/)
   integer,parameter::num5=10
   integer,dimension(10),parameter::i5=(/&
     251,252,253,259,301,443,444,452,455,456/)
   character(6),dimension(10),parameter::h5=(/&
     'mubar ','xi    ','gamma ','invel ','heat  ','kerma ','dame  ',&
     'nutot ','nudel ','nupmt '/)
   integer,parameter::num6=10
   integer,dimension(10),parameter::i6=(/&
     500,502,504,515,516,517,522,525,602,621/)
   character(6),dimension(10),parameter::h6=(/&
     'stop  ','gcoh  ','ginch ','gpaire','gpair ','gpairn',&
     'gabs  ','gheat ','gabs  ','gheat '/)
   integer,parameter::num7=19
   integer,dimension(19),parameter::ilr=(/&
     31,16,17,22,23,24,25,26,28,29,30,32,33,34,35,36,37,39,40/)
   character(3),dimension(19),parameter::hlr=(/&
     'g  ','n  ','nn ','a  ','aaa','na ','nna','ni ','p  ','aa ',&
     'naa','d  ','t  ','h  ','daa','taa','nnn','ic ','ee '/)

!!!!!!!!!!!!!!!!!!!!!!
   iverf=6
!!!!!!!!!!!!!!!!!!!!!!
   !--determine name from mt number or radionuclide
   if (izam.gt.0) go to 340

   !--neutron-emitting reactions
   if (mt.gt.49) go to 130
   do 110 i=1,num1
   jmt=i
   if (mt.eq.i1(i)) go to 120
  110 continue
   go to 300
  120 continue
   write(strng,'(a1,a5)') hp,h1(jmt)
   go to 350

   !--neutron-emitting levels
  130 continue
   if (mt.gt.91) go to 150
   if (mt.eq.91) go to 140
   if (mt.lt.60) write(strng,'(''n0'',i1)') mt-50
   if (mt.ge.60) write(strng,'(''n'',i2)') mt-50
   go to 310
  140 continue
   write(strng,'(''ncn'')')
   go to 310

   !--particle-emitting reactions
  150 continue
   if (mt.gt.150) go to 180
   do 160 i=1,num2
   jmt=i
   if (mt.eq.i2(i)) go to 170
  160 continue
   go to 300
  170 continue
   write(strng,'(a1,a5)') hp,h2(jmt)
   go to 350

   !--gas production
  180 continue
   if (mt.gt.207) go to 190
   if (mt.lt.201) go to 300
   write(strng,'(a6)') h3(mt-200)
   go to 350

   !--special njoy thermal mt numbers
  190 continue
   if (mt.gt.num4) go to 200
   if (mt.lt.221) go to 300
   write(strng,'(a6)') h4(mt-220)
   go to 350

   !--miscellaneous quantities
  200 continue
   if (mt.gt.499) go to 250
   do 210 i=1,num5
   jmt=i
   if (mt.eq.i5(i)) go to 220
  210 continue
   go to 300
  220 continue
   write(strng,'(a6)') h5(jmt)
   go to 350

   !--photon interactions
  250 continue
   if (iverf.le.5.and.mt.gt.699) go to 280
   if (iverf.ge.6.and.mt.gt.599) go to 290
   do 260 i=1,num6
   jmt=i
   if (mt.eq.i6(i)) go to 270
  260 continue
   go to 300
  270 continue
   write(strng,'(a6)') h6(jmt)
   go to 350

   !--particle-emitting levels (endf-5)
  280 continue
   if (mt.gt.799) go to 300
   if (mt.ge.700.and.mt.lt.710) write(strng,'(''p0'',i1)') mt-700
   if (mt.ge.710.and.mt.lt.719) write(strng,'(''p'',i2)') mt-700
   if (mt.eq.719) write(strng,'(''pcn'')')
   if (mt.ge.720.and.mt.lt.730) write(strng,'(''d0'',i1)') mt-720
   if (mt.ge.730.and.mt.lt.739) write(strng,'(''d'',i2)') mt-720
   if (mt.eq.739) write(strng,'(''dcn'')')
   if (mt.ge.740.and.mt.lt.750) write(strng,'(''t0'',i1)') mt-740
   if (mt.ge.750.and.mt.lt.759) write(strng,'(''t'',i2)') mt-740
   if (mt.eq.759) write(strng,'(''tcd'')')
   if (mt.ge.760.and.mt.lt.770) write(strng,'(''h0'',i1)') mt-760
   if (mt.ge.770.and.mt.lt.779) write(strng,'(''h'',i2)') mt-760
   if (mt.eq.779) write(strng,'(''hcn'')')
   if (mt.ge.780.and.mt.lt.790) write(strng,'(''a0'',i1)') mt-780
   if (mt.ge.790.and.mt.lt.799) write(strng,'(''a'',i2)') mt-780
   if (mt.eq.799) write(strng,'(''acn'')')
   go to 310

   !--particle-emitting levels (endf-6)
  290 continue
   if (mt.gt.891) go to 300
   if (mt.ge.600.and.mt.lt.610) write(strng,'(''p0'',i1)') mt-600
   if (mt.ge.610.and.mt.lt.649) write(strng,'(''p'',i2)') mt-600
   if (mt.eq.649) write(strng,'(''pcn'')')
   if (mt.ge.650.and.mt.lt.660) write(strng,'(''d0'',i1)') mt-650
   if (mt.ge.660.and.mt.lt.699) write(strng,'(''d'',i2)') mt-650
   if (mt.eq.699) write(strng,'(''dcn'')')
   if (mt.ge.700.and.mt.lt.710) write(strng,'(''t0'',i1)') mt-700
   if (mt.ge.710.and.mt.lt.749) write(strng,'(''t'',i2)') mt-700
   if (mt.eq.749) write(strng,'(''tcd'')')
   if (mt.ge.750.and.mt.lt.760) write(strng,'(''h0'',i1)') mt-750
   if (mt.ge.760.and.mt.lt.799) write(strng,'(''h'',i2)') mt-750
   if (mt.eq.799) write(strng,'(''hcn'')')
   if (mt.ge.800.and.mt.lt.810) write(strng,'(''a0'',i1)') mt-800
   if (mt.ge.810.and.mt.lt.849) write(strng,'(''a'',i2)') mt-800
   if (mt.eq.849) write(strng,'(''acn'')')
   if (mt.ge.875.and.mt.lt.885) write(strng,'(''2n0'',i1)') mt-875
   if (mt.ge.885.and.mt.lt.891) write(strng,'(''2n'',i2)') mt-875
   if (mt.eq.891) write(strng,'(''2ncn'')')
   go to 310

   !--encode mt number into name
  300 write(strng,'(''mt'',i3)') mt
   go to 350

   !--encode lr flag into name
  310 if (lr.eq.0) go to 350
   temp=strng(1:3)
   do 320 i=1,num7
   jlr=i
   if (lr.eq.ilr(i)) go to 330
  320 continue
   go to 350
  330 write(strng,'(a3,a3)') temp,hlr(jlr)
   go to 350

   !--radionuclide production
  340 ii=izam/10
   mm=izam-10*ii
   jj=ii+100*mm
   if (mt.eq.102.and.jj.ge.10000) write(strng,'(''c'',i5)') jj
   if (mt.eq.102.and.jj.lt.10000) write(strng,'(''c0'',i4)') jj
   if (mt.ne.102.and.jj.ge.10000) write(strng,'(''r'',i5)') jj
   if (mt.ne.102.and.jj.lt.10000) write(strng,'(''r0'',i4)') jj

   !--name is finished
  350 continue
   read(strng,'(a6)') hreact
   return
   end subroutine hname

   subroutine vector(mfd,hp,n1d,nscr,iref,irec2,irec3)
   !-------------------------------------------------------------------
   ! Loads vector control and vector cross sections onto
   ! scratch files.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides repoz,error
   ! externals
   integer::mfd,n1d,nscr,iref,irec2,irec3
   character::hp*(*)
   ! internals
   integer::k004,k016,k103,k104,k105,k106,k107,lz,n1i,nwds
   integer::ivcon,ivdat,i,ig,igr,igw,ig2lo,idref,il
   integer::izam,nl,nz,matr,mfr,mtr,loc,jg2,lout,lin
   integer::j,k,mdex,ivnow,nb,nw,ltot,ng2,n1j,nmove
   integer::ndex,nfg,nlg,nxsd,n,ihvcon
   integer,parameter::maxb=30000
   real(kr)::b(maxb)
   character(8)::hchid='chid'
   character(8)::hgtot='gtot0'
   character(8)::hgflx='gwt0'
   character(8)::hnt='n'
   character(8)::hga='g'
   real(kr),parameter::stol=1.e-3_kr
   real(kr),parameter::small=1.e-30_kr

   !--initialize.
   k004=0
   k016=0
   k103=0
   k104=0
   k105=0
   k106=0
   k107=0
   lz=6
   n1i=0
   nwds=(3+mult)*n1d
   nwds=((nwds-1)/2+1)*2
   ivcon=next
   next=ivcon+nwds
   nwds=ning*n1d
   ivdat=next
   next=ivdat+nwds
   do i=ivcon,isiza
      a(i)=0.0
   enddo

   !--read input data
   call repoz(nscr)
   call repoz(iref)
   call contio(nscr,0,0,b(1),nb,nw)
   if (iref.ne.0) call contio(iref,0,0,b(1),nb,nw)
   ig=ning

   !--set up next reaction
  115 continue
   if (ig.lt.ning) go to 155
   call contio(nscr,0,0,b(1),nb,nw)
   if (math.le.0) go to 400
   if (mfh.eq.0.or.mth.eq.0) go to 115
   if (mfh.eq.12) mfh=13
   if (mfh.le.1) go to 145
   izam=0
   if (mfh.gt.90) izam=nint(c2h)
   nl=l1h
   nz=l2h
   if (nz.lt.iz) go to 145
   ! delayed fission chi
   if (mfh.ne.(mfd+2)) go to 120
   n1i=n1i+1
   hvps(n1i)=hchid
   go to 140
  120 continue
   if (mfh.ne.mfd.and.mfh.le.90) go to 145
   if (mth.ne.1.and.mth.ne.501) go to 134
   ! flux and total cross section
   if (mth.eq.501) go to 130
   ltot=l1h
   do i=1,ltot
      write(hvps(i),'(a1,''wt'',i1)') hp,i-1
      write(hvps(i+ltot),'(a1,''tot'',i1)') hp,i-1
   enddo
   n1i=n1i+2*ltot
   go to 140
  130 continue
   hvps(1)=hgflx
   hvps(2)=hgtot
   n1i=n1i+2
   go to 140
  134 continue
   if (mth.eq.2.and.hp.ne.hnt) then
      write(hvps(1),'(a1,''wt0'')') hp
      write(hvps(2),'(a1,''tot0'')') hp
      n1i=n1i+2
   endif
   ! other vector partials (including delayed nu)
   n1i=n1i+1
   ! find the hollerith identifier
   call hname(hvps(n1i),hp,mth,n1h,izam)
  140 continue
   if (iref.eq.0) go to 150
   matr=math
   mfr=mfh
   mtr=mth
   call findg(matr,mfr,mtr,iref)
   call contio(iref,0,0,b(1),nb,nw)
   go to 150
  145 continue
   call tosend(nscr,0,0,b(1))
   go to 115
  150 continue
   ig=0
   igr=0
   igw=0

   !--read data for this group
  155 continue
   if (iref.eq.0.or.ig.le.igr) then
      call listio(nscr,0,0,b(1),nb,nw)
      if (mfh.eq.12) mfh=13
      ng2=l1h
      ig2lo=l2h
      ig=n2h
      loc=1+nw
      do while (nb.ne.0)
         if (loc+302.gt.maxb) call error('vector',&
           'exceeded input data array size',' ')
         call moreio(nscr,0,0,b(loc),nb,nw)
         if (mfh.eq.12) mfh=13
         loc=loc+nw
      enddo
   endif
   if (iref.ne.0.and.igr.le.ig) then
      idref=loc
      call listio(iref,0,0,b(idref),nb,nw)
      igr=n2h
      loc=loc+nw
      do while (nb.ne.0)
         if (loc+302.gt.maxb) call error('vector',&
           'exceeded input data array size',' ')
         call moreio(iref,0,0,b(loc),nb,nw)
         loc=loc+nw
      enddo
   endif
   if (mfh.eq.(mfd+2)) go to 200
   go to 300

   !--delayed fission spectrum(chi)
  200 continue
   ng2=l1h
   ig2lo=l2h
   do i=2,ng2
      jg2=noutg+1-ig2lo-i+2
      lout=ivdat-1+(n1i-1)*ning+jg2
      lin=lz+nl*(i-1)
      do j=1,nl
         a(lout)=b(j+lin)+a(lout)
      enddo
   enddo
   go to 115

   !--all other reactions
  300 continue
   if (mth.eq.1.or.mth.eq.501) go to 320
   if (mth.eq.2.and.hp.ne.hnt) go to 350
   if (iref.ne.0.and.ig.gt.igr) go to 310
   lout=ivdat+n1i*ning-ig
   lin=lz+nl*(nz+iz-1)+1
   a(lout)=b(lin)
   if (hp.eq.hnt) go to 310
   if (hp.eq.hga) go to 310
   if (mth.eq.500) go to 310
   if (mth.ge.201.and.mth.le.207) go to 310
   if (mth.eq.4) k004=1
   if (k004.eq.1.and.mth.ge.50.and.mth.le.91) go to 310
   if (mth.eq.103) k103=1
   if (k103.eq.1.and.mth.ge.600.and.mth.le.649) go to 310
   if (mth.eq.104) k104=1
   if (k104.eq.1.and.mth.ge.650.and.mth.le.699) go to 310
   if (mth.eq.105) k105=1
   if (k105.eq.1.and.mth.ge.700.and.mth.le.749) go to 310
   if (mth.eq.106) k106=1
   if (k106.eq.1.and.mth.ge.750.and.mth.le.799) go to 310
   if (mth.eq.107) k107=1
   if (k107.eq.1.and.mth.ge.800.and.mth.le.849) go to 310
   if (mth.eq.16) k016=1
   if (k016.eq.1.and.mth.ge.875.and.mth.le.891) go to 310
   lout=ivdat+2*ning-ig
   a(lout)=a(lout)+b(lin)
  310 continue
   if (iref.eq.0) go to 115
   if (igr.gt.ig) go to 115
   lout=ivdat+n1i*ning-igr
   lin=idref-1+lz+nl*nz+1
   a(lout)=a(lout)-b(lin)
   if (abs(a(lout)).lt.stol*b(lin)) a(lout)=0
   go to 115
   ! flux and total cross section
  320 continue
   do il=1,nl
      ! flux
      lout=ivdat+il*ning-ig
      lin=lz+nl*(iz-1)+il
      a(lout)=b(lin)
      ! total cross sections
      if (iref.eq.0.or.ig.le.igr) then
         lout=ivdat+(nl+il)*ning-ig
         lin=lz+nz*nl+nl*(iz-1)+il
         a(lout)=b(lin)
      endif
      if (iref.ne.0.and.igr.le.ig) then
         lout=ivdat+(nl+il)*ning-igr
         lin=idref-1+lz+nz*nl+il
         a(lout)=a(lout)-b(lin)
         if (abs(a(lout)).ge.stol*b(lin)) igw=1
         if (abs(a(lout)).lt.stol*b(lin).and.igw.gt.0) a(lout)=0
      endif
   enddo
   go to 115
   ! charged-particle elastic and flux
  350 continue
   lout=ivdat+ning-ig
   lin=lz+nl*(iz-1)+1
   a(lout)=b(lin)
   lout=lout+ning
   lin=lin+nl*nz
   a(lout)=b(lin)
   lout=lout+ning
   a(lout)=b(lin)
   go to 115
  400 continue

   !--add up separate contributions to production reactions
  410 continue
   do 430 i=1,n1d
   n1i=n1d-i+1
   do 420 j=1,n1i-1
   n1j=j
   if (hvps(n1j).eq.hvps(n1i)) go to 440
  420 continue
  430 continue
   go to 480
  440 continue
   do k=1,ning
      lout=ivdat+n1j*ning-k
      lin=ivdat+n1i*ning-k
      a(lout)=a(lout)+a(lin)
   enddo
   if (n1i.ne.n1d) then
      nmove=(n1d-n1i)*ning
      do k=1,nmove
         lout=ivdat+(n1i-1)*ning+k-1
         lin=ivdat+n1i*ning+k-1
         a(lout)=a(lin)
      enddo
      nmove=n1d-n1i
      do k=1,nmove
         hvps(n1i+k-1)=hvps(n1i+k)
      enddo
   endif
   n1d=n1d-1
   go to 410
  480 continue

   !--output the vector data to the scratch files
   ndex=ivdat
   mdex=ivdat
   do i=1,n1d

      !--calculate nfg and nlg
      nfg=ning+1
      nlg=0
      do k=1,ning
         nxsd=ndex-1+k
         if (abs(a(nxsd)).ge.small) then
            if (nfg.gt.k) nfg=k
            if (nlg.lt.k) nlg=k
         endif
      enddo

      !--if entire partial is zero, keep group 1 only
      if (nlg.eq.0) then
         nfg=1
         nlg=1
      endif

      !--crunch data using nfg and nlg
      do k=1,ning
         if (nfg.le.k.and.nlg.ge.k) then
            a(mdex)=a(ndex)
            mdex=mdex+1
         endif
         ndex=ndex+1
      enddo

      !--write vector control data
      n=(ivcon-1)/mult+i
      read(hvps(i),'(a8)') ta(n)
      ia(ivcon+n1d*mult-1+i)=nfg
      ia(ivcon+n1d*mult+n1d-1+i)=nlg
   enddo

   !--write vector blocks to nscrt3
   nwds=0
   ivnow=ivdat
   do i=1,n1d
      loc=ivcon-1+mult*n1d+i
      nw=ia(loc+n1d)-ia(loc)+1
      if (nwds+nw.ge.maxw) then
         irec3=irec3+1
         write(nscrt3) (a(ivnow+j-1),j=1,nwds)
         ivnow=ivnow+nwds
         nritev=nritev+1
         nwds=0
      endif
      nwds=nwds+nw
   enddo
   if (nwds.gt.0) then
      irec3=irec3+1
      write(nscrt3) (a(ivnow+j-1),j=1,nwds)
      ivnow=ivnow+nwds
      nritev=nritev+1
   endif

   !--write vector control record
   irec2=irec2+1
   nw=2*n1d
   ihvcon=(ivcon-1)/mult
   write(nscrt2)&
     (ha(ihvcon+i),i=1,n1d),(ia(ivcon+n1d*mult+i-1),i=1,nw)
   nritev=nritev+1

   !--vector production complete
   next=ivcon
   return
   end subroutine vector

   subroutine matrix(irec3,irec2,mfd,hp,n2d,nscr,nscr2,iref)
   !-------------------------------------------------------------------
   ! Produces matrix data and writes it to scratch tape.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides openz,repoz,closz
   ! externals
   integer::irec3,irec2,mfd,n2d,nscr,nscr2,iref
   character::hp*(*)
   ! internals
   integer::nscrr,irefr,nb,nw,i,j,irite,iskip,lr
   integer::nlord,njcon,lordn,ioff,ik,loca
   integer::nwmcr,nwm,nwdc,nwds,nhmtx,nz,ihmcon
   real(kr)::b(350)

   !--open scratch files for reaction data
   nscrr=nscrt4
   if (nscr.lt.0) nscrr=-nscrt4
   irefr=nscrt7
   if (iref.lt.0) irefr=-nscrt7
   if (iref.eq.0) irefr=0
   call openz(nscrr,1)
   call openz(irefr,1)

   !--set pointers for matrix control and matrix data blocks
   nwmcr=mult+2+2*noutg
   nwm=nwmcr
   imcon=next
   next=imcon+nwm
   nwdc=noutg+ning
   icdat=next
   next=icdat+nwdc
   nwds=2*noutg
   ijgll=next
   next=ijgll+nwds
   imdat=next
   nhmtx=(imcon-1)/mult+1

   !--loop over matrix partials
   call repoz(nscr)
   call repoz(iref)
   call contio(nscr,0,0,b(1),nb,nw)
   if (iref.ne.0) call contio(iref,0,0,b(1),nb,nw)
   nritem=0
   do i=1,n2d

      !--process this reaction
      do j=1,nwm
         a(j-1+imcon)=0
      enddo
      do j=1,nwdc
         a(icdat-1+j)=0
      enddo
      lord1=0
      ng2z=0
      irite=0
      jconst=0
      iskip=0
      do while (iskip.eq.0)
         if (iref.ne.0) call contio(iref,0,0,b(1),nb,nw)
         call contio(nscr,0,0,b(1),nb,nw)
         nz=l2h
         lr=n1h
         if (nz.ge.iz) then
            if (mfh.eq.mfd) iskip=1
            if (mfh.eq.17.and.mfd.eq.16) iskip=1
         endif
         if (iskip.eq.0) then
           if (iref.ne.0) call tosend(iref,0,0,b(1))
           call tosend(nscr,0,0,b(1))
         endif
      enddo
      call findf(math,mfh,mth,nscr)
      call repoz(nscrr)
      call repoz(irefr)
      call contio(nscr,nscrr,0,b(1),nb,nw)
      if (iref.ne.0) then
         call findf(math,mfh,mth,iref)
         call contio(iref,irefr,0,b(1),nb,nw)
      endif
      do j=imdat,isiza
         a(j)=0
      enddo

      !--find hollerith names
      call hname(hmtx(i),hp,mth,lr,0)

      !--read and copy this reaction
      !--while computing banding information
      call band(nscr,iref,ia(ijgll),ia(ijgll+noutg),nscrr,irefr)

      !--read reaction again from scratch file
      !--and shuffle the numbers into the bands
      call shufl(nscrr,irefr,ia(ijgll),ia(ijgll+noutg),&
        nscrt3,irec3,irite)

      !--calculate lord(n),  hmtx(n)
      read(hmtx(i),'(a8)') ta(nhmtx)
      nlord=imcon+mult
      njcon=nlord+1
      if (irite.ne.0) then
         ia(nlord)=lord1
         ia(njcon)=jconst
         call tosend(nscr,0,0,b(1))
         irec2=irec2+1
         ihmcon=(imcon-1)/mult+1
         nw=nwmcr-mult
         write(nscr2) ha(ihmcon),(ia(imcon+mult+j-1),j=1,nw)
         irite=irite+1
      else
         call tosend(nscr,0,0,b(1))
         if (lord1.eq.0) lord1=maxord+1
         ia(nlord)=lord1
         ia(njcon)=jconst
         ia(njcon+1)=1
         ia(njcon+1+noutg)=1
         ihmcon=(imcon-1)/mult+1
         nw=nwmcr-mult
         write(nscr2) ha(ihmcon),(ia(imcon+mult+j-1),j=1,nw)
         irite=irite+1
         lordn=maxord+1
         do j=1,lordn
            a(j-1+imdat)=0.
         enddo
         irec3=irec3+1
         write(nscrt3) (a(imdat+j-1),j=1,lordn)
         irite=irite+1
      endif

      !--write constant sub-block if present
      if (jconst.ne.0) then
         ioff=ning-jconst
         do ik=1,jconst
            loca=icdat-1+noutg+ik
            a(loca)=a(loca+ioff)
         enddo
         nwds=noutg+jconst
         irec3=irec3+1
         write(nscrt3) (a(icdat+j-1),j=1,nwds)
         irite=irite+1
      endif

      !--close loop over matrix partials
      nritem=nritem+irite
   enddo

   !--finished
   next=imcon
   call closz(nscrr)
   call closz(irefr)
   return
   end subroutine matrix

   subroutine band(nscr,iref,jg1lo,jg1hi,nscrr,irefr)
   !-------------------------------------------------------------------
   ! Reads one entire mt file, copies it to scratch files,
   ! and computes the banding parameters.
   !-------------------------------------------------------------------
   use endf ! provide endf routines and variables
   use util ! provides error
   ! externals
   integer::nscr,iref,nscrr,irefr
   integer(k4)::jg1lo(*),jg1hi(*)
   ! internals
   integer::i,irinp,ig,igr,ig2lo,idref,ig2lor,jg1,ik
   integer::nb,nw,ng2,loc,ng2r,jg2,n,nl
   integer,parameter::maxb=30000
   real(kr)::b(maxb)

   !--initialize banding data
   do i=1,noutg
      jg1lo(i)=ning+1
      jg1hi(i)=0
   enddo

   !--loop over records on input tape
   irinp=1
   igr=0
   nl=l1h
   maxord=nl-1

   !--main group loop
   ig=0
   do while (ig.lt.ning)
      call listio(nscr,nscrr,0,b(irinp),nb,nw)
      ng2=l1h
      ig2lo=l2h
      ig=n2h
      loc=irinp+nw
      do while (nb.ne.0)
         if (loc+302.gt.maxb) call error('band',&
           'input too large',' ')
         call moreio(nscr,nscrr,0,b(loc),nb,nw)
         loc=loc+nw
      enddo

      !--reference group loop
     120 continue
         if (iref.ne.0.and.ig.gt.igr) then
            idref=loc
            if (idref+302.gt.maxb) call error('band',&
              'input too large',' ')
            call listio(iref,irefr,0,b(idref),nb,nw)
            ng2r=l1h
            ig2lor=l2h
            igr=n2h
            loc=idref+nw
            do while (nb.ne.0)
               if (loc+302.gt.maxb) call error('band',&
                 'input too large',' ')
               call moreio(iref,irefr,0,b(loc),nb,nw)
               loc=loc+nw
            enddo
         endif

         !--analyze banding for matrix sub-blocks
         if (ig.ne.0.and.ig2lo.ne.0) then
            if (iref.eq.0.or.ig.le.igr) then
              jg1=ning+1-ig
              do ik=2,ng2
                 jg2=noutg+1-(ig2lo+ik-2)
                 if (jg1.lt.jg1lo(jg2)) jg1lo(jg2)=jg1
                 if (jg1.gt.jg1hi(jg2)) jg1hi(jg2)=jg1
               enddo
            endif
            if (iref.ne.0.and.igr.le.ig) then
               jg1=ning+1-igr
               do ik=2,ng2r
                  jg2=noutg+1-(ig2lor+ik-2)
                  if (jg1.lt.jg1lo(jg2)) jg1lo(jg2)=jg1
                  if (jg1.gt.jg1hi(jg2)) jg1hi(jg2)=jg1
               enddo
            endif
         endif
      if (iref.ne.0.and.igr.lt.ig) go to 120
   enddo

   !--load jband and ijj for the matrix control record
   loc=imcon+mult+1
   do i=1,noutg
      n=jg1hi(i)-jg1lo(i)+1
      if (n.lt.0) n=0
      ia(loc+i)=n
      ia(loc+noutg+i)=jg1hi(i)
   enddo
   return
   end subroutine band

   subroutine shufl(nscr,iref,jg1lo,jg1hi,nout3,irec3,irite)
   !-------------------------------------------------------------------
   ! Reads one entire mt file and rearranges data
   ! using the banding information computed by subroutine band.
   ! Make multiple passes through the files if necessary.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides repoz,error
   ! externals
   integer::nscr,iref,nout3,irec3,irite
   integer(k4)::jg1lo(*),jg1hi(*)
   ! internals
   integer::i0,num,nwds,nsb,i,idone,n,imax,irinp,nz
   integer::ig,igr,ig2lo,idref,ig2lor,ik,jg2,jg1,il
   integer::i1,imax1,nb,nw,lz,nl,ng2,loc,ng2r,niloc
   integer::kp,jp,np,noloc,j
   integer,parameter::maxb=30000
   real(kr)::b(maxb)

   !--loop over records on input tape
   ng2z=0
  100 continue
   i0=ng2z+1

   !--how many groups and sub blocks will fit?
   num=0
   nwds=0
   nsb=0
   i=i0-1
   idone=0
   do while (i.lt.noutg.and.idone.eq.0)
      i=i+1
      n=jg1hi(i)-jg1lo(i)+1
      if (n.lt.0) n=0
      n=n*(maxord+1)
      nwds=nwds+n
      if (imdat+nwds.gt.isiza) then
         idone=1
      else
         if (num+n.ge.maxw) then
            imax=i-1
            nsb=nsb+1
            num=0
         endif
         num=num+n
      endif
   enddo
   if (idone.eq.0) imax=noutg

   !--read the head record
   irinp=1
   call repoz(nscr)
   call repoz(iref)
   call contio(nscr,0,0,b(irinp),nb,nw)
   lz=6
   igr=0
   nl=l1h
   nz=l2h
   if (iref.ne.0) call contio(iref,0,0,b(irinp),nb,nw)

   !--read the group records
  110 call listio(nscr,0,0,b(irinp),nb,nw)
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   loc=irinp+nw
   do while (nb.ne.0)
      if (loc+302.ge.maxb) call error('shufl','input too large',' ')
      call moreio(nscr,0,0,b(loc),nb,nw)
      loc=loc+nw
   enddo
  120 if (iref.ne.0.and.ig.gt.igr) then
      idref=loc
      if (idref+302.ge.maxb) call error('shufl',&
        'input too large',' ')
      call listio(iref,0,0,b(idref),nb,nw)
      ng2r=l1h
      ig2lor=l2h
      igr=n2h
      loc=idref+nw
      do while (nb.ne.0)
         if (loc+302.ge.maxb) call error('shufl',&
           'input too large',' ')
         call moreio(iref,0,0,b(loc),nb,nw)
         loc=loc+nw
      enddo
   endif

   !--store constant sub-block if present
   if (ig.eq.0) go to 135
   if (ig2lo.eq.0) go to 140
   go to 145
  135 do ik=1,ng2
      jg2=noutg-ig2lo-ik+2
      a(icdat-1+jg2)=b(irinp+lz+ik-1)
   enddo
   go to 240
  140 jconst=ig
   jg1=ning+1-ig
   a(icdat-1+noutg+jg1)=b(irinp+lz+1)
   go to 240

   !--store matrix sub-blocks
  145 if (iref.eq.0.or.ig.le.igr) then
      jg1=ning+1-ig
      do ik=2,ng2
         niloc=irinp+lz+nl*nz*(ik-1)+nl*(iz-1)
         jg2=noutg+1-(ig2lo+ik-2)
         if (jg2.ge.i0.and.jg2.le.imax) then
            kp=jg1hi(jg2)
            jp=0
            i=i0-1
            idone=0
            do while (i.lt.noutg.and.idone.eq.0)
               i=i+1
               np=jg1hi(i)-jg1lo(i)+1
               if (np.lt.0) np=0
               if (i.eq.jg2) then
                  idone=1
               else
                  jp=jp+np
               endif
            enddo
            noloc=imdat+nl*jp+kp-jg1
            do il=1,nl
               a(noloc+np*(il-1))=b(niloc+il-1)
            enddo
         endif
      enddo
   endif
   if (iref.ne.0.and.igr.le.ig) then
      jg1=ning+1-igr
      do ik=2,ng2r
         niloc=idref+lz+nl*nz*(ik-1)
         jg2=noutg+1-(ig2lor+ik-2)
         if (jg2.ge.i0.and.jg2.le.imax) then
            kp=jg1hi(jg2)
            jp=0
            i=i0-1
            idone=0
            do while (i.lt.noutg.and.idone.eq.0)
               i=i+1
               np=jg1hi(i)-jg1lo(i)+1
               if (np.lt.0) np=0
               if (i.eq.jg2) then
                  idone=1
               else
                  jp=jp+np
               endif
            enddo
            noloc=imdat+nl*jp+kp-jg1
            do il=1,nl
               a(noloc+np*(il-1))=a(noloc+np*(il-1))-b(niloc+il-1)
            enddo
         endif
      enddo
   endif
  240 continue
   if (iref.ne.0.and.igr.lt.ig) go to 120
   if (ig.lt.ning) go to 110
   if (nl+1.gt.lord1) lord1=nl+1
   if (lord1.gt.maxord+1) lord1=maxord+1

   !--write out this range of sub-block data
   nwds=0
   i1=imdat
   imax1=imax+1
   do i=i0,imax1
      if (i.le.imax) then
         np=jg1hi(i)-jg1lo(i)+1
         if (np.lt.0) np=0
         np=np*nl
         if (nwds+np.lt.maxw) then
            nwds=nwds+np
         else
            if (nwds.eq.0) then
               nwds=nwds+np
            else
               irec3=irec3+1
               write(nout3) (a(i1+j-1),j=1,nwds)
               irite=irite+1
               i1=i1+nwds
               nwds=0
               nwds=nwds+np
            endif
         endif
      else
         if (nwds.eq.0) then
            nwds=nwds+np
         else
            irec3=irec3+1
            write(nout3) (a(i1+j-1),j=1,nwds)
            irite=irite+1
            i1=i1+nwds
            nwds=0
            nwds=nwds+np
         endif
      endif
   enddo
   ng2z=imax
   if (ng2z.lt.noutg) go to 100
   return
   end subroutine shufl

   subroutine lst1io(nin,nout,nscr,a,nb,nw,namax)
   !-------------------------------------------------------------------
   ! Convert a gendf file 1 mt 451 list record to opposite format.
   ! Routine lst1io processes the entire record.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::nin,nout,nscr,nb,nw,namax
   real(kr)::a(namax)
   ! internals
   integer::nb1,nw1,ng,nwh,nx,nwd,i,lim,l,nt,ns,iwd,mtw
   integer::j
   real(kr)::z(100)
   character(4)::tz(100)
   equivalence(z(1),tz(1))
   character(11)::field(6)
   character(40)::hfmt
   character(4)::blank='    '
   nwd=0

   !--input
   if (nin.eq.0) go to 200
   if (nin.lt.0) go to 140
   call contio(nin,0,0,a,nb1,nw1)
   nw=6+n1h
   ng=l1h
   if (ng.eq.0) ng=l2h
   if (ntw.eq.0) go to 130
   if (ntw.ge.14) go to 120
   nwh=(ntw*4+10)/11
   nx=nwh*11-ntw*4
   nwd=6-nwh
   if (nwd.le.0) go to 120
   if (nx.ne.0) write(hfmt,&
     &'(''('',i2,''a4,'',i2,''x,1p'',i1,''e11.0)'')')&
     ntw,nx,nwd
   if (nx.eq.0) write(hfmt,&
     '(''('',i2,''a4,'',''1p'',i1,''e11.0)'')')&
     ntw,nwd
   read(nin,hfmt) (tz(i),i=1,ntw),(a(i+nw1+ntw),i=1,nwd)
   do i=1,ntw
      a(i+nw1)=z(i)
   enddo
   nw1=nw1+ntw+nwd
   go to 130
  120 continue
   read(nin,'(16a4,a2)') (tz(i),i=1,ntw)
   do i=1,ntw
      a(i+nw1)=z(i)
   enddo
   nw1=nw1+ntw
  130 continue
   lim=nw-nw1
   read(nin,'(6e11.0)') (a(i+nw1),i=1,lim)
   go to 200
  140 continue
   call listio(nin,0,0,a,nb,nw)
   ng=l1h
   if (ng.eq.0) ng=l2h
   l=1
  150 continue
   if (nb.eq.0) go to 200
   l=l+nw
   call moreio(nin,0,0,a(l),nb,nw)
   if ((l-1+nw).gt.namax)&
     call error('lst1io','storage exceeded',' ')
   go to 150

   !--output
  200 continue
   c1h=a(1)
   c2h=a(2)
   l1h=nint(a(3))
   l2h=nint(a(4))
   n1h=nint(a(5))
   n2h=nint(a(6))
   nw=6+n1h
   nb=0
   if (nout.eq.0.and.nscr.eq.0) go to 400
   if (nout.le.0.and.nscr.le.0) go to 300
   nt=nout
   if (nout.le.0) nt=0
   ns=nscr
   if (nscr.le.0) ns=0
   call contio(0,nt,ns,a,nb1,nw1)
   nwh=(ntw*4+10)/11
   nx=nwh*11-ntw*4
   nwd=6-nwh
   if (ntw.ge.14) go to 240
   if (nwd.le.0) go to 240
   do iwd=1,nwd
      if (iwd+nw1+ntw.gt.nw) a(nwd+nw1+ntw)=0
      call a11(a(iwd+nw1+ntw),field(iwd))
   enddo
   if (nx.ne.0) write(hfmt,&
     '(''('',i1,''a4,'',i2,''x,'',i1,&
     &''(a11),i4,i2,i3,i5)'')')&
     ntw,nx,nwd
   if (nx.eq.0) write(hfmt,&
     &'(''('',i1,''a4,'',i1,''(a11),i4,i2,i3,i5)'')')&
     nwd,ntw
   if (nout.gt.0) then
      nsh=nsh+1
      do i=1,ntw
         z(i)=a(i+nw1)
      enddo
      write(nt,hfmt) (tz(i),i=1,ntw),(field(i),i=1,nwd),&
        math,mfh,mth,nsh
   endif
   if (nscr.le.0) go to 260
   nsc=nsc+1
   do i=1,ntw
      z(i)=a(i+nw1)
   enddo
   write(ns,hfmt) (tz(i),i=1,ntw),(field(i),i=1,nwd),&
     math,mfh,mth,nsc
  240 continue
   mtw=17-ntw
   if (nout.gt.0) then
      nsh=nsh+1
      do i=1,ntw
         z(i)=a(i+nw1)
      enddo
      if (ntw.eq.17) write(nt,'(16a4,a2,i4,i2,i3,i5)')&
        (tz(i),i=1,ntw),math,mfh,mth,nsh
      if (ntw.lt.17) write(nt,'(16a4,a2,i4,i2,i3,i5)')&
        (tz(i),i=1,ntw),('    ',i=1,mtw),math,mfh,mth,nsh
   endif
   if (nscr.gt.0) then
      nsc=nsc+1
      do i=1,ntw
         z(i)=a(i+nw1)
      enddo
      if (ntw.eq.17) write(ns,'(16a4,a2,i4,i2,i3,i5)')&
        (tz(i),i=1,ntw),math,mfh,mth,nsc
      if (ntw.lt.17) write(ns,'(16a4,a2,i4,i2,i3,i5)')&
        (tz(i),i=1,ntw),(blank,i=1,mtw),math,mfh,mth,nsc
   endif
  260 continue
   if (nwd.lt.0) nwd=0
   nw1=nw1+nwd+ntw
   lim=nw-nw1
   do i=1,lim,6
      do j=1,6
         if ((j+nw1).gt.nw) a(j+nw1)=0
         call a11(a(j+nw1),field(j))
      enddo
      if (nout.gt.0) then
         nsh=nsh+1
         write(nt,'(6(a11),i4,i2,i3,i5)')&
           (field(j),j=1,6),math,mfh,mth,nsh
      endif
      if (nscr.gt.0) then
         nsc=nsc+1
         write(ns,'(6(a11),i4,i2,i3,i5)')&
           (field(j),j=1,6),math,mfh,mth,nsc
      endif
      nw1=nw1+6
   enddo
   if (nout.ge.0.and.nscr.ge.0) go to 400
   nt=nout
   if (nout.ge.0) nt=0
   ns=nscr
   if (nscr.ge.0) ns=0
   go to 310
  300 continue
   nt=nout
   ns=nscr
  310 continue
   call listio(0,nt,ns,a,nb,nw)
   l=1
   do while (nb.ne.0)
      l=l+nw
      call moreio(0,nt,ns,a(l),nb,nw)
      if ((l-1+nw).gt.namax) call error('lst1io',&
        'storage exceeded',' ')
   enddo

   !--finished
  400 continue
   return
   end subroutine lst1io

end module matxsm

module acedo
   ! provides ace dosimetry formats for acer
   use locale
   use acecm, only: xss,nxss
   implicit none
   private

   !--Public routines
   public acedos,dosfix

   !--Private global variables

   ! incident particle
   real(kr)::awi
   integer::izai

   ! header info for dosimetry format
   character(13)::hz
   character(10)::hd
   character(10)::hm
   real(kr)::aw0,tz

   ! parameters for dosimetry nxs block
   integer::len2,za,nxs3,ntr,nxsd(12)

   ! parameters for dosimetry jxs block
   integer::lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(14),end,jxsd2(10)

contains

   subroutine acedos(matd,tempd,nin,nace,ndir,itype,iprint,mcnpx,&
     suff,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Load dosimetry data in ACE format.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util ! provides openz,closz,dater
   use endf ! provides endf routines and variables
   use physics ! provides bk
   ! externals
   integer::matd,nin,nace,ndir,itype,iprint,mcnpx
   real(kr)::tempd,suff
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::nwscr,nb,nw,j,l,nr,i,ne,k,nmax,jscr,intr
   integer::l1,nn,n,is,ns,lfs
   real(kr)::temp,awr,zaid
   character(8)::hdt
   real(kr),dimension(:),allocatable::scr,tmpscr
   real(kr),parameter::emev=1.e6_kr

   !--allocate main container array
   nxs3=0
   nxsd=0
   jxs2=0
   jxs4=0
   jxs5=0
   jxsd2=0
   xss=0

   !--allocate scratch storage
   nwscr=250000
   allocate(scr(nwscr))

   !--determine what endf version is being used
   call openz(nin,0)
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' using endf-'',i1,'' format'')') iverf

   !--find desired temperature on endf tape
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   temp=0
   do while (abs(temp-tempd).ge.tempd/100+1)
      call contio(nin,0,0,scr,nb,nw)
      if (math.lt.0)&
        call error('acedos','desired mat and temp not found.',' ')
      za=nint(scr(1))
      awr=scr(2)
      if (iverf.ge.5) call contio(nin,0,0,scr,nb,nw)
      if (iverf.eq.6) then
         call contio(nin,0,0,scr,nb,nw)
         awi=scr(1)
         izai=nint(scr(5)/10)
      else
         awi=0
         izai=1 !assume incident neutron if not a version 6 file
      endif

      call contio(nin,0,0,scr,nb,nw)
      temp=scr(1)
      if (abs(temp-tempd).ge.tempd/100+1) then
         call tomend(nin,0,0,scr)
      endif
   enddo

   !--locate first reaction in file 3 or file 10
   do while (mfh.ne.3 .and. mfh.ne.10)
      call tofend(nin,0,0,scr)
      call contio(nin,0,0,scr,nb,nw)
      if (mfh.gt.10 .or. math.le.0)&
         call error('acedos','no xs data for desired mat.',' ')
   enddo

   !--define locators for dosimetry data
   nmax=350
   lone=1
   mtr=lone
   lsig=mtr+nmax
   sigd=lsig+nmax
   l=sigd
   j=1
   if (mfh.gt.3) go to 110

   !--loop over file 3 reactions on nin
   do while (mfh.ne.0)
      xss(lsig-1+j)=l
      if (mfh.ne.0) then
         if (mth.ne.1) then
            xss(mtr-1+j)=mth
            if(allocated(tmpscr)) deallocate(tmpscr)
            allocate(tmpscr(npage+46))
            jscr=1
            call tab1io(nin,0,0,tmpscr(jscr),nb,nw)
            if (nb.gt.nwscr) then
               nwscr=nb+nw+1
               if(allocated(scr)) deallocate(scr)
               allocate(scr(nwscr))
            endif
            scr(1:nw)=tmpscr(1:nw)
            nr=nint(scr(5))
            ne=nint(scr(6))
            intr=nint(scr(8))
            jscr=jscr+nw
            if (jscr.gt.nwscr)&
               call error('acedos','scr array storage exceeded',' ')
            do while (nb.ne.0)
               call moreio(nin,0,0,scr(jscr),nb,nw)
               jscr=jscr+nw
               if (jscr.gt.nwscr)&
                  call error('acedos','scr array storage exceeded',' ')
            enddo
            if (nr.ne.1.or.intr.ne.2) then
               xss(l)=nr
               l=l+1
               do i=1,nr
                  xss(l+i-1)=scr(5+2*i)
                  xss(l+nr+i-1)=scr(6+2*i)
               enddo
               l=l+2*nr
            else
               xss(l)=0
               l=l+1
            endif
            xss(l)=ne
            k=7+2*nr
            l=l+1
            do i=1,ne
               xss(l)=scr(k)/emev
               xss(l+ne)=scr(k+1)
               l=l+1
               k=k+2
            enddo
            l=l+ne
            j=j+1
            if (j.gt.nmax) call error('acedos','too many reactions',&
                                      'need larger nmax')
         endif
         call tosend(nin,0,0,scr)
         call contio(nin,0,0,scr,nb,nw)
      endif
   enddo

   !--locate first reaction in file 10
   call contio(nin,0,0,scr,nb,nw)
   if (mfh.gt.10 .or. math.le.0) go to 120
   do while (mfh.ne.10)
      call tofend(nin,0,0,scr)
      call contio(nin,0,0,scr,nb,nw)
      if (mfh.gt.10 .or. math.le.0) go to 120
   end do
  110 continue
   !--loop over reactions on nin
      do while (mfh.ne.0)
         ns=max(1,n1h)
         xss(lsig-1+j)=l
         if (mfh.ne.0) then
            if (mth.ne.1) then
               do is=1,ns
                  if(allocated(tmpscr)) deallocate(tmpscr)
                  allocate(tmpscr(npage+46))
                  jscr=1
                  call tab1io(nin,0,0,tmpscr(jscr),nb,nw)
                  if (nb.gt.nwscr) then
                     nwscr=nb+nw+1
                     if(allocated(scr)) deallocate(scr)
                     allocate(scr(nwscr))
                  endif
                  scr(1:nw)=tmpscr(1:nw)
                  lfs=l2h
                  xss(mtr-1+j)=mth+1000*(10+lfs)
                  nr=nint(scr(5))
                  ne=nint(scr(6))
                  intr=nint(scr(8))
                  jscr=jscr+nw
                  if (jscr.gt.nwscr)&
                     call error('acedos','array storage exceeded',' ')
                  do while (nb.ne.0)
                     call moreio(nin,0,0,scr(jscr),nb,nw)
                     jscr=jscr+nw
                     if (jscr.gt.nwscr)&
                        call error('acedos','array storage exceeded',&
                                   ' ')
                  enddo
                  if (nr.ne.1.or.intr.ne.2) then
                     xss(l)=nr
                     l=l+1
                     do i=1,nr
                        xss(l+2*i-2)=scr(5+2*i)
                        xss(l+2*i-1)=scr(6+2*i)
                     enddo
                     l=l+2*nr
                  else
                     xss(l)=0
                     l=l+1
                  endif
                  xss(l)=ne
                  k=7+2*nr
                  l=l+1
                  do i=1,ne
                     xss(l)=scr(k)/emev
                     xss(l+ne)=scr(k+1)
                     l=l+1
                     k=k+2
                  enddo
                  l=l+ne
                  j=j+1
                  if (j.gt.nmax)&
                     call error('acedos','too many reactions',&
                                         'need larger nmax')
                  if (is.ne.ns) xss(lsig-1+j)=l
               enddo
            endif
            call tosend(nin,0,0,scr)
            call contio(nin,0,0,scr,nb,nw)
         endif
      enddo
  120 continue
   ntr=j-1

   !--squeeze out space in mtr and lsig
   l1=nint(xss(lsig))
   nn=l1+mtr-2
   do i=1,ntr
      xss(mtr+ntr-1+i)=xss(lsig-1+i)-nn
   enddo
   lsig=mtr+ntr
   n=l-sigd
   do i=1,n
      xss(mtr+2*ntr-1+i)=xss(sigd-1+i)
   enddo
   sigd=mtr+2*ntr
   len2=sigd+n-1
   end=len2

   !--dosimetry load is finished
   call closz(nin)
   deallocate(scr)
   zaid=za+suff
   if (mcnpx.eq.0) then
      write(hz,'(f9.2,''y'')') zaid
   else
      write(hz,'(f10.3,''ny '')') zaid
   endif
   tz=temp*bk/emev
   call dater(hdt)
   hd='  '//hdt
   write(hm,'(''   mat'',i4)') matd
   aw0=awr
   if (iprint.gt.0) call dosprt(hk)
   call dosout(itype,nace,ndir,mcnpx,hk,izn,awn)
   return
   end subroutine acedos

   subroutine dosfix(itype,nin,nout,ndir,iprint,nplot,mcnpx,&
     suff,nxtra,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Print and or edit an ACE dosimetry file.
   !-------------------------------------------------------------------
   use util ! provides closz
   ! externals
   integer::itype,nin,nout,ndir,iprint,nplot,mcnpx,nxtra
   real(kr)::suff
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::l,j,n,max,iza,i
   real(kr)::zaid
   integer::izo(16)
   real(kr)::awo(16)
   character(70)::hko
   character(3)::ht
   character(9)::str
   real(kr),parameter::zero=0

   integer,parameter::ner=1

   !--read type 1 ace format file
   call openz(nin,0)
   if (itype.eq.1) then
      if (mcnpx.eq.0) then
         read(nin,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hko,hm
      else
         read(nin,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:13),aw0,tz,hd,hko,hm
      endif
      read (nin,'(4(i7,f11.0))') (izo(i),awo(i),i=1,16)
      read(nin,'(8i9)')&
        len2,za,nxs3,ntr,nxsd(1:12),&
        lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(1:14),end,jxsd2(1:10)
      n=(len2+3)/4
      l=0
      do i=1,n
         read (nin,'(4e20.0)') (xss(l+j),j=1,4)
         l=l+4
      enddo

   !--read type 2 ace format file
   else if (itype.eq.2) then
      if (mcnpx.eq.0) then
        read(nin) hz(1:10),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          len2,za,nxs3,ntr,nxsd(1:12),&
          lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(14),end,jxsd2(10)
      else
        read(nin) hz(1:13),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          len2,za,nxs3,ntr,nxsd(1:12),&
          lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(14),end,jxsd2(10)
      endif
      n=(lone+ner-1)/ner
      l=0
      do i=1,n
         max=len2-l
         if (max.gt.ner) max=ner
         read (nin) (xss(l+j),j=1,max)
         l=l+max
      enddo
      call closz(-nin)
   endif

   !--adjust zaid
   if (mcnpx.gt.0) then
       read(hz,'(f10.0,a3)') zaid,ht
   else
       read(hz,'(a9,a1)') str,ht
       if (ht(1:1).ne.'t') then
          read(hz,'(f9.0,a1)') zaid,ht
       endif
   endif
   if (suff.ge.zero.and.ht(1:1).ne.'t') then
      iza=nint(zaid)
      zaid=iza+suff
      if (mcnpx.gt.0) then
          write(hz,'(f10.3,a3)') zaid,ht
      else
          write(hz,'(f9.2,a1)') zaid,ht
      endif
   endif

   !--adjust comment and (iz,aw) list
   if (len_trim(hk).eq.0) then
      hk=hko
   endif
   if (nxtra.ne.0) then
      do i=1,nxtra
         izn(i)=izo(i)
         awn(i)=awo(i)
      enddo
   endif

   !--print, plot, and/or write the file.
   if (iprint.gt.0) call dosprt(hk)
   if (nout.gt.0) call dosout(itype,nout,ndir,mcnpx,hk,izn,awn)

   return
   end subroutine dosfix

   subroutine dosprt(hk)
   !-------------------------------------------------------------------
   ! Print dosimetry cross sections from data in memory.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use acecm  ! provides mtname
   ! externals
   character(70)::hk
   ! internals
   integer::j,mt,l,nr,lim,i,ne,k,line
   real(kr)::e,s
   character(10)::name
   character(14)::col(6)

   !--print information block
   write(nsyso,'(''1''/////&
     &38x,''zaid'',1x,a13/&
     &6x,''***********************'',10x,''awr'',f10.3/&
     &6x,''*                     *'',9x,''temp'',1p,e10.2/&
     &6x,''*      dosimetry      *'',9x,''date'',a10/&
     &6x,''*                     *'',10x,''mat'',a10/&
     &6x,''*   ace format file   *''/&
     &6x,''*                     *'',9x,''len2'',i10/&
     &6x,''*     processed by    *'',11x,''za'',i10/&
     &6x,''*                     *''/&
     &6x,''*        njoy         *'',10x,''ntr'',i10/&
     &6x,''*                     *''/&
     &6x,''***********************'',9x,''lone'',i10/&
     &39x,''mtr'',i10/38x,''lsig'',i10/38x,''sigd'',i10///&
     &6x,''hk>>> '',a70)')&
     hz,aw0,tz,hd,hm,len2,za,ntr,lone,mtr,lsig,sigd,hk

   !--print sigd block
   do j=1,ntr
      mt=nint(xss(mtr-1+j))
      call mtname(mt,name,izai)
      l=nint(xss(lsig-1+j)+sigd-1)
      nr=nint(xss(l))
      l=l+1
      if (nr.ne.0) then
         lim=2*nr
         write(nsyso,'(''1''///&
           &'' reaction mt = '',i6,3x,a10/'' interpolation: '',12i6)')&
           mt,name,(nint(xss(l-1+i)),i=1,lim)
         l=l+2*nr
      else
         write(nsyso,'(''1''///&
           &'' reaction mt = '',i6,3x,a10/'' linear interpolation'')')&
           mt,name
      endif
      ne=nint(xss(l))
      l=l+1
      k=1
      line=1
      do i=1,ne
         e=xss(l)
         s=xss(l+ne)
         l=l+1
         write(col(k),'(1p,e14.4)') e
         write(col(k+1),'(1p,e14.4)') s
         k=k+2
         if (k.ge.7) then
            if (line.eq.1) write(nsyso,'(/&
              &1x,3(8x,''energy'',10x,''xsec'')/&
              &1x,3(8x,''------'',10x,''----''))')
            write(nsyso,'(1x,6a14)') col
            k=1
            line=line+1
         endif
      enddo
      k=k-1
      if (k.ne.0) then
         write(nsyso,'(1x,6a14)') (col(i),i=1,k)
      endif
   enddo
   return
   end subroutine dosprt

   subroutine dosout(itype,nout,ndir,mcnpx,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Write out the dosimetry file.
   !-------------------------------------------------------------------
   use util  ! provides openz,closz,error
   use acecm ! provides write routines
   ! externals
   integer::itype,nout,ndir,mcnpx
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::l,nr,n,j,ne,ll,nn,i,nern,lrec

   integer,parameter::ner=1
   integer,parameter::nbw=1

   !--process according to ace file type
   if (itype.eq.1) call openz(nout,1)
   if (itype.eq.2) call openz(-nout,1)

   !--type 1
   if (itype.eq.1) then

      !--write type-1 header block
      if (mcnpx.eq.0) then
         write(nout,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hk,hm
      else
         write(nout,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:13),aw0,tz,hd,hk,hm
      endif
      write(nout,'(4(i7,f11.0))') (izn(i),awn(i),i=1,16)
      write(nout,'(8i9)')&
        len2,za,nxs3,ntr,nxsd(1:12),&
        lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(1:14),end,jxsd2(1:10)

      !--mtr block
      l=mtr
      do i=1,ntr
         call typen(l,nout,1)
         l=l+1
      enddo

      !--lsig block
      l=lsig
      do i=1,ntr
         call typen(l,nout,1)
         l=l+1
      enddo

      !--sigd block
      l=sigd
      do i=1,ntr
         nr=nint(xss(l))
         call typen(l,nout,1)
         l=l+1
         if (nr.ne.0) then
            n=2*nr
            do j=1,n
               call typen(l,nout,1)
               l=l+1
            enddo
         endif
         ne=nint(xss(l))
         call typen(l,nout,1)
         l=l+1
         n=2*ne
         do j=1,n
            call typen(l,nout,2)
            l=l+1
         enddo
      enddo
      call typen(0,nout,3)
      call closz(nout)
      nern=0
      lrec=0

   !--write ace file in type 2 format
   else
      if (mcnpx.eq.0) then
         write(nout) hz(1:10),aw0,tz,hd,hk,hm,(izn(i),awn(i),i=1,16),&
           len2,za,nxs3,ntr,nxsd(1:12),&
           lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(1:14),end,jxsd2(1:10)
      else
         write(nout) hz(1:13),aw0,tz,hd,hk,hm,(izn(i),awn(i),i=1,16),&
           len2,za,nxs3,ntr,nxsd(1:12),&
           lone,jxs2,mtr,jxs4,jxs5,lsig,sigd,jxsd(1:14),end,jxsd2(1:10)
      endif
      ll=0
      nn=len2
      do while (nn.gt.0)
         n=nn
         if (n.gt.ner) n=ner
         write(nout) (xss(ll+i),i=1,n)
         ll=ll+n
         nn=nn-n
      enddo
      lrec=ner*nbw
      nern=ner
   endif

   !--output directory for mcnp
   call openz(ndir,1)
   if (mcnpx.eq.0) then
      write(ndir,&
        '(a10,f12.6,'' filename route'',i2,'' 1 '',i8,2i6,1p,e10.3)')&
        hz(1:10),aw0,itype,len2,lrec,nern,tz
   else
      write(ndir,&
        '(a13,f12.6,'' filename route'',i2,'' 1 '',i8,2i6,1p,e10.3)')&
        hz(1:13),aw0,itype,len2,lrec,nern,tz
   endif
   call closz(ndir)
   return
   end subroutine dosout

end module acedo

module mainio
   ! Fortran unit numbers for system I/O.  Users should only revert
   ! to the legacy values if these iso_fortran_env variable values
   ! cause conflicts with njoy scratch or user logical units.

   use iso_fortran_env,only: INPUT_UNIT, ERROR_UNIT, OUTPUT_UNIT
   implicit none
   private
   save

   integer,public::nsysi=INPUT_UNIT   !standard input,  legacy value=5
   integer,public::nsyso=ERROR_UNIT   !output file,     legacy value=7
   integer,public::nsyse=OUTPUT_UNIT  !terminal output, legacy value=6
end module mainio

module thermm
   ! provides thermr for NJOY2016
   use locale
   implicit none
   private
   public thermr

   ! global variables
   integer::nendf,nin,nout,nscr,nscr2
   integer::matde,nbin,iprint,ncds,matdp,natom,ntemp,&
     iinc,iform,ncdse
   real(kr)::za,awr,tol,emax
   real(kr)::sb,az,tevz,teff,sb2,az2,teff2
   real(kr)::cliq
   integer::lasym
   integer::lat
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::bufo,bufn

   ! array for user temperatures
   real(kr),dimension(:),allocatable::tempr

   ! array for thermal elastic data
   real(kr),dimension(:),allocatable::fl

   ! arrays for thermal inelastic cross section
   real(kr),dimension(:),allocatable::esi,xsi

   integer,parameter::nbuf=1000
   integer,parameter::nwscr=500000

contains

   subroutine thermr
   !-------------------------------------------------------------------
   !
   !  Generate neutron scattering cross sections and point-to-point
   !  scattering kernels in the thermal range.  The coding can
   !  generate incoherent inelastic cross sections and distributions
   !  for a free gas, incoherent inelastic cross sections and
   !  distributions from read-in S(alpha,beta,T) data, coherent
   !  elastic scattering cross sections for crystalline materials,
   !  and incoherent elastic cross sections and angular distributions
   !  for hydrogenous solids.
   !
   !  The pointwise scattering cross sections and distributions are
   !  added to an existing PENDF tape.  Cross sections are added in
   !  MF3 and distributions are written in MF6, both using mtref for
   !  inelastic and mtref+1 for elastic (if any).
   !
   !  Multiple scattering types (i.e., H free and H in H2O) can be
   !  written on one PENDF tape by using different values of mtref
   !  for each thermr run.  If data for one mtref is already on the
   !  tape, it will be replaced with the new cross sections.
   !
   !  The energy grid for coherent scattering is determined
   !  adaptively so as to represent the sharp Bragg edges to a
   !  specified tolerance using linear interpolation.  No angular
   !  information is provided for coherent scattering.  It can be
   !  deduced by subsequent processing from the Bragg edges in the
   !  cross section.
   !
   !  The incident energy grid for incoherent inelastic scattering
   !  is fixed in the code, although it is scaled to higher values
   !  for very large incident energies.  There are two options for
   !  representing the energy and angle distributions for secondary
   !  inelastic neutrons.
   !
   !  The standard approach is to generate an energy grid for the
   !  secondary energy distribution integrated over angle
   !  adaptively.  The angular distribution for each secondary
   !  energy is given using a set of equally probable emission
   !  cosines.  This is E-E'-mu ordering, and it is represented
   !  using a special format in MF6.
   !
   !  An alternate approach introduced in NJOY2010 produces E-mu-E'
   !  ordering using MF6/Law7.  A grid of mu values is generated
   !  adaptively for linear interpolation.  In addition, secondary
   !  energy grids are determined adaptively for each mu value.
   !
   !  The sections of File 6 produced by thermr have several
   !  special features.  The LIP flag is used to identify the
   !  various kinds of thermal data:  LIP=-1 means incoherent
   !  inelastic data, LIP=-2 means incoherent inelastic data, and
   !  LIP=-nbrag means coherent elastic data with nbrag Bragg
   !  edges.  For incoherent elastic or inelastic data using
   !  LAW=1, the angular data are equally probable cosines.
   !
   !  For ENDF 3 to 5 formats, the constants used for coherent
   !  elastic, incoherent elastic, and short-collision-time calcu-
   !  lations are obtained from internal data statements based on
   !  the original general atomic report on the evaluations
   !  (GA-8774 revised, ENDF-269, July 1978).
   !
   !  For ENDF-6 format libraries, these constants are included
   !  in the format.
   !
   !---input specifications (free format)--------------------------
   !
   !  card 1
   !     nendf      endf tape for mf7 data
   !     nin        old pendf tape
   !     nout       new pendf tape
   !  card 2
   !     matde      material desired on endf tape
   !     matdp      material desired on pendf tape
   !     nbin       number of equi-probable angles
   !     ntemp      number of temperatures (default = 1)
   !     iinc       inelastic options
   !                   0     none
   !                   1     compute as free gas
   !                   2     read s(a,b) and compute matrix
   !     icoh       elastic options
   !                   0     none
   !                   1     compute using ENDF6 format data
   !                   --------or for earlier formats
   !                   1     graphite
   !                   2     beryllium
   !                   3     beryllium oxide
   !                  11     polyethylene
   !                  12     h(zrh)
   !                  13     zr(zrh)
   !     iform      output format for inelastic distributions
   !                  0      E-E'-mu ordering (MF6 special)
   !                  1      E-mu-E' ordering (MF6/Law7)
   !     natom      number of principal atoms
   !     mtref      mt for inelastic reaction (221-250 only)
   !     iprint     print option (0=minimum, 1=maximum,
   !                2=max. normal + intermediate results)
   !                (default=0)
   !  card 3
   !     tempr      temperatures (kelvin)
   !  card 4
   !     tol        tolerance
   !     emax       maximum energy for thermal treatment
   !                (for temperatures greater than 3000,
   !                emax and the energy grid are scaled by
   !                temp/3000.  free gas only.)
   !
   !       nendf can be ENDF6 format (e.g., from leapr) while
   !       nin and nout are ENDF4 or 5 format, if desired.
   !
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use endf   ! provides endf routines and variables
   use util   ! provides timer,error,openz,repoz,loada,skiprz,closz
   ! locals
   integer::icoh,i,icopy,idis,nb,nw,iold,inew,indexc,indexi,mtref
   integer::iverp,itemp,nwb,it,ntape,nex,ne,np,isave
   integer::lthr
   real(kr)::e,enext,emaxs,time,sz2,t,templ,s,temp
   real(kr)::ex(2)
   real(kr),dimension(:),allocatable::eftemp,eftmp2
   real(kr),parameter::s1099=3.76e0_kr
   real(kr),parameter::a1099=15.86e0_kr
   real(kr),parameter::s1095=4.74e0_kr
   real(kr),parameter::a1095=11.90e0_kr
   real(kr),parameter::eps=1.e-4_kr
   real(kr),parameter::break=3000.e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::up=1.00001e0_kr
   real(kr),parameter::zero=0.e0_kr

   !--initialize
   call timer(time)
   write(nsyso,'(/&
     &'' thermr...compute thermal scattering cross sections '',&
     &''and distributions'',f8.1,''s'')') time
   write(nsyse,'(/'' thermr...'',59x,f8.1,''s'')') time
   sz2=0
   allocate(scr(nwscr))
   allocate(bufn(nbuf))
   allocate(bufo(nbuf))
   scr=0
   indexc=-1
   indexi=-1

   !--read user input.
   read(nsysi,*) nendf,nin,nout
   if (nin.eq.0) call error('thermr','nin=0.',' ')
   if (nin.lt.0.and.nout.gt.0)&
     call error('thermr','mode conversion not allowed.',' ')
   if (nin.gt.0.and.nout.lt.0)&
     call error('thermr','mode conversion not allowed.',' ')
   call openz(nendf,0)
   call openz(nin,0)
   call openz(nout,1)
   iprint=0
   ntemp=1
   read(nsysi,*) matde,matdp,nbin,ntemp,iinc,icoh,iform,natom,mtref,iprint
   if (mtref.lt.221.or.mtref.gt.250)&
     call error('thermr','illegal reference mt.',' ')
   allocate(tempr(ntemp))
   allocate(eftemp(ntemp))
   allocate(eftmp2(ntemp))
   read(nsysi,*) (tempr(i),i=1,ntemp)
   do i=1,ntemp
      eftemp(i)=0
      eftmp2(i)=0
      if (matde.eq.0) eftemp(i)=tempr(i)
   enddo
   read(nsysi,*) tol,emax

   !--check for endf-6 format data
   call tpidio(nendf,0,0,scr,nb,nw)
   call contio(nendf,0,0,scr,nb,nw)
   call contio(nendf,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   call skiprz(nendf,-1)

   !--set up internal data for older endf versions
   if (iverf.lt.6) then

      !--check for mixed s(a,b) cases (beo, benzine)
      !--supply appropriate parameters
      sz2=0
      az2=0
      if (matde.eq.1099) sz2=s1099
      if (matde.eq.1099) az2=a1099
      if (matde.eq.1095) sz2=s1095
      if (matde.eq.1095) az2=a1095
      sb2=sz2
      if (az2.ne.zero) sb2=sz2*((az2+1)/az2)**2

         !--default effective temperatures to standard values if
         !--available, otherwise set them to the material temperature
         if (matde.ne.0) then
            call gateff(tempr,eftemp,ntemp,matde)
            if (sz2.ne.zero) then
               call gatef2(tempr,eftmp2,ntemp,matde)
            endif
         endif
      endif

   !--write parameters.
   write(nsyso,'(/&
     &'' unit for endf tape ................... '',i10/&
     &'' unit for input pendf tape ............ '',i10/&
     &'' unit for output pendf tape ........... '',i10)')&
     nendf,nin,nout
   write(nsyso,'(/&
     &'' material to be processed (endf) ...... '',i10/&
     &'' material to be processed (pendf) ..... '',i10/&
     &'' number of angle bins ................. '',i10/&
     &'' number of temperatures ............... '',i10/&
     &'' inelastic option ..................... '',i10/&
     &'' elastic option ....................... '',i10/&
     &'' MF6 format option .................... '',i10/&
     &'' number of principal atoms ............ '',i10/&
     &'' reference mt ......................... '',i10/&
     &'' print option (0 min, 1 max) .......... '',i10)')&
     matde,matdp,nbin,ntemp,iinc,icoh,iform,natom,mtref,iprint
   write(nsyso,'(&
     &'' temperatures (kelvin) ................ '',1p,e10.4)')&
     tempr(1)
   if (ntemp.gt.1) write(nsyso,'(40x,1p,e10.4)')&
     (tempr(i),i=2,ntemp)
   write(nsyso,'(&
     &'' tolerance ............................ '',1p,e10.4/&
     &'' max energy for thermal treatment ..... '',e10.4)')&
     tol,emax
   if (iinc.eq.2.and.iverf.lt.6) then
      write(nsyso,'(/&
        &'' parameters for sct app.''/&
        &'' -----------------------'')')
      write(nsyso,'(&
        &'' effective temperatures ............... '',1p,e10.4)')&
        eftemp(1)
      if (ntemp.gt.1) write(nsyso,'(40x,1p,e10.4)')&
        (eftemp(i),i=2,ntemp)
      if (sz2.ne.zero) then
         write(nsyso,'(&
           &'' free xsec for second atom ............ '',1p,e10.4/&
           &'' mass ratio for second atom ........... '',1p,e10.4/&
           &'' eff. temps for second atom ........... '',1p,e10.4)')&
           sz2,az2,eftmp2(1)
         if (ntemp.gt.1) write(nsyso,'(40x,1p,e10.4)')&
           (eftmp2(i),i=2,ntemp)
      endif
   endif
   write(nsyso,'(/'' endf uses endf-'',i1,'' format'')') iverf

   !--verify if nendf != 0 for iinc == 2
   if (nendf.eq.0.and.iinc.eq.2) then
      call error('thermr','No ENDF tape given for iinc=2 (nendf is 0)',' ')
   endif

   !--initialize i/o units
   iold=10
   inew=11
   nscr=12
   if (nout.lt.0) nscr=-nscr
   nscr2=13
   if (nout.lt.0) nscr2=-nscr2
   call openz(-iold,1)
   call openz(-inew,1)
   call openz(nscr,1)
   call openz(nscr2,1)
   call repoz(nendf)
   call repoz(nout)
   call repoz(nin)
   call repoz(nscr2)

   !--copy through to desired material
   nsh=0
   call tpidio(nin,nout,0,scr,nb,nw)
  110 continue
   call contio(nin,0,0,scr,nb,nw)
   if (math.eq.matdp) go to 120
   if (math.lt.0)&
     call error('thermr','desired material not on pendf tape.',' ')
   call contio(0,nout,0,scr,nb,nw)
   call tomend(nin,nout,0,scr)
   go to 110
  120 continue
   call contio(nin,0,0,scr(7),nb,nw)
   if (n1h.ne.0) then
      iverp=4
   else if (n2h.eq.0) then
      iverp=5
   else
      iverp=6
   endif
   call skiprz(nin,-1)
   write(nsyso,'(/'' pendf uses endf-'',i1,'' format'')') iverp

   !--loop over desired temperatures
   itemp=1
   icopy=0
  130 continue
   call contio(0,0,nscr2,scr,nb,nw)
   if (math.ne.matdp)&
     call error('thermr','desired material not on pendf tape.',' ')
   nwb=0
   za=scr(1)
   awr=scr(2)
   az=scr(2)
   if (iverp.ge.5) call contio(nin,0,nscr2,scr,nb,nw)
   if (iverp.ge.6) call contio(nin,0,nscr2,scr,nb,nw)
   call hdatio(nin,0,nscr2,scr,nb,nw)
   t=scr(1)
   if (abs(t-tempr(itemp)).le.eps*tempr(itemp)) go to 180
   if (t.gt.tempr(itemp))&
     call error('thermr','desired temperature not on tape.',' ')

   !--check for skipped temperatures to be copied
   if (itemp.eq.1) icopy=icopy+1
   if (itemp.eq.1) go to 160
   templ=tempr(itemp-1)
   it=0
  150 continue
   it=it+1
   if (it.ge.itemp) go to 160
   if (abs(t-tempr(it)).le.eps*tempr(it)) go to 150
   if (abs(t-templ).le.eps*templ) go to 150
   if (t.lt.templ) go to 150
   icopy=icopy+1
   go to 150
  160 continue
   if (icopy.eq.0) call repoz(nscr2)
   ntape=nscr2
   if (icopy.eq.0) ntape=0
   call tomend(nin,0,ntape,scr)
   call contio(nin,0,0,scr,nb,nw)
   go to 130
  180 continue
   call findf(matdp,3,2,nin)

   !--save elastic cross section on scratch file.
   call contio(nin,0,0,scr,nb,nw)
   nex=2
   ne=0
   e=0
   call gety1(e,enext,idis,s,nin,scr)
   emaxs=emax
   if (t.gt.break) emax=emax*t/break
  200 continue
   e=enext
   call gety1(e,enext,idis,s,nin,scr)
   ex(1)=e
   ex(2)=s
   if (e.gt.emax*(1+small)) ex(2)=0
   ne=ne+1
   if (e.gt.emax*(1+small)) ne=-ne
   call loada(ne,ex,nex,inew,bufn,nbuf)
   if (ne.lt.0) go to 210
   if (enext.gt.emax*(1+small)) enext=emax
   if (abs(e-emax).lt.small*emax) enext=up*emax
   go to 200
  210 continue
   np=-ne
   emax=emaxs
   isave=iold
   iold=inew
   inew=isave
   call skiprz(nin,-1)

   !--set up for elastic calculation
   lthr=0
   if (iverf.ge.6.and.nendf.ne.0) then
      call findf(matde,7,0,nendf)
      call contio(nendf,0,0,scr,nb,nw)
      if (mth.eq.2) then
         lthr=l1h
         icoh=10*lthr
         temp=tempr(itemp)
         call rdelas(temp,lthr,nendf,nwb,indexc,indexi)
      endif
   endif

   !--compute incoherent cross sections
   if (iinc.ne.0) then
      temp=tempr(itemp)
      teff=eftemp(itemp)
      teff2=0
      if (sz2.gt.zero) teff2=eftmp2(itemp)
      if (iinc.eq.2) temp=t
      call calcem(temp,itemp,iold,inew,np,nex,mtref)
   endif

   !--compute thermal elastic cross sections
   if (icoh.gt.0.and.icoh.le.10) then        ! only coherent
      call coh(icoh,itemp,iold,inew,np,nex,mtref+1,indexc)
   else if (icoh.gt.10.and.icoh.le.20) then  ! only incoherent
      call iel(icoh,itemp,iold,inew,np,nex,mtref+1,indexi)
   else if (icoh.gt.20) then                 ! both coherent and incoherent
     call coh(10,itemp,iold,inew,np,nex,mtref+1,indexc)
     call iel(20,itemp,iold,inew,np,nex,mtref+2,indexi)
   endif

   !--write new pendf tape.
   call tpend(iold,itemp,np,nex,icoh,icopy,mtref)

   !--continue temperature loop
   if (allocated(fl)) deallocate(fl)
   if (itemp.eq.ntemp) go to 310
   itemp=itemp+1
   call repoz(nscr2)
   call contio(nin,0,0,scr,nb,nw)
   go to 130

   !--finished with all temperatures.
   !--copy rest of pendf tape and terminate job.
  310 continue
   call totend(nin,nout,0,scr)
   call repoz(nendf)
   call repoz(nin)
   call repoz(nout)
   call closz(nendf)
   call closz(nin)
   call closz(nout)
   call closz(-iold)
   call closz(-inew)
   call closz(nscr)
   call closz(nscr2)
   deallocate(scr)
   deallocate(bufn)
   deallocate(bufo)
   deallocate(tempr)
   deallocate(eftemp)
   deallocate(eftmp2)
   if (allocated(esi)) deallocate(esi)
   if (allocated(xsi)) deallocate(xsi)
   if (allocated(fl)) deallocate(fl)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine thermr

   subroutine rdelas(temp,lthr,nin,nwds,indexc,indexi)
   !-------------------------------------------------------------------
   ! Read in elastic data (coherent or incoherent or both) for the
   ! desired temperature from an ENDF6 format file.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::lthr,nin,nwds,indexc,indexi
   real(kr)::temp
   ! internals
   integer::l,np,nr,lt,nb,nw,k,i,j,ifound
   real(kr)::tnow
   real(kr),dimension(:),allocatable::a
   integer,parameter::na=1000000

   !--temp storage to read in data
   allocate(a(na))

   !--initialise
   ifound=0
   indexc=-1
   indexi=-1

   !--read the first table in MF7 MT2
   !  this is S(E) for the first temperature for coherent or mixed mode
   !  this is W'(T) for incoherent
   l=1
   call tab1io(nin,0,0,a(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,a(l),nb,nw)
      l=l+nw
      if (l.gt.na) call error('rdelas',&
        'too much elastic data','increase na')
   enddo

   !--get table parameters
   np=n2h
   nr=n1h
   lt=l1h

   !--current size of the array
   nwds=l-1

   !--read temperatures for coherent elastic or mixed mode
   if (lthr.ne.2) then

      !--set coherent data index
      indexc=1

      !--current temperature
      tnow=a(1)

      !--loop over the available temperatures and find the one we need
      do j=1,lt

         !--read list of S values for this temperature
         l=nwds+1
         call listio(nin,0,0,a(l),nb,nw)
         l=l+nw
         do while (nb.ne.0)
            call moreio(nin,0,0,a(l),nb,nw)
            l=l+nw
         enddo

         !--verify if this is the one we need and store S(E) if it is
         tnow=a(nwds+1)
         if (abs(tnow-temp).lt.temp/1000+5) then
            ifound=1
            l=nwds+6
            k=6+2*nr
            do i=1,np
               l=l+1
               k=k+2
               a(k)=a(l)
            enddo
         endif
      enddo
   endif

   !--set index for incoherent only
   if (lthr.eq.2) then

      !--set incoherent data index
      indexi=1

   !--read the W'(T) data for mixed mode
   else if (lthr.eq.3) then

      !--set incoherent data index
      indexi=nwds+1

      l=indexi
      call tab1io(nin,0,0,a(l),nb,nw)
      l=l+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,a(l),nb,nw)
         l=l+nw
         if (l.gt.na) call error('rdelas',&
           'too much elastic data','increase na')
      enddo
      nwds=l-1
   endif

   !--move data to global fl array
   !--lthr=1: fl is a single table of S(E) for coherent elastic
   !--lthr=2: fl is a single table of W'(T) for incoherent elastic
   !--lthr=3: fl is a table of S(E) and a table of W'(T) for mixed mode
   allocate(fl(nwds))
   do l=1,nwds
      fl(l)=a(l)
   enddo
   deallocate(a)
   return
   end subroutine rdelas

   subroutine gateff(temp,eftemp,ntemp,mat)
   !-------------------------------------------------------------------
   ! Default effective temperatures to values from General Atomic
   ! report, if available.
   !       1002      h(h2o)
   !       1004      d(d2o)
   !       1064      be
   !       1065      graphite
   !       1095      benzine (c6h6)
   !       1096      zr(zrh)
   !       1097      h(zrh)
   !       1099      beo
   !       1114      h(ch2)
   !-------------------------------------------------------------------
   ! externals
   integer::ntemp,mat
   real(kr)::temp(ntemp),eftemp(ntemp)
   ! internals
   integer::i,j,jmat
   real(kr)::diff,test
   integer::ntabl=67
   real(kr),dimension(3,67),parameter::tabl=reshape((/&
     1002.e0_kr,296.0e0_kr,1396.8e0_kr,&
     1002.e0_kr,350.0e0_kr,1411.6e0_kr,&
     1002.e0_kr,400.0e0_kr,1427.4e0_kr,&
     1002.e0_kr,450.0e0_kr,1444.9e0_kr,&
     1002.e0_kr,500.0e0_kr,1464.1e0_kr,&
     1002.e0_kr,600.0e0_kr,1506.8e0_kr,&
     1002.e0_kr,800.0e0_kr,1605.8e0_kr,&
     1002.e0_kr,1000.e0_kr,1719.8e0_kr,&
     1004.e0_kr,296.0e0_kr,940.91e0_kr,&
     1004.e0_kr,350.0e0_kr,961.62e0_kr,&
     1004.e0_kr,400.0e0_kr,982.93e0_kr,&
     1004.e0_kr,450.0e0_kr,1006.1e0_kr,&
     1004.e0_kr,500.0e0_kr,1030.9e0_kr,&
     1004.e0_kr,600.0e0_kr,1085.1e0_kr,&
     1004.e0_kr,800.0e0_kr,1209.0e0_kr,&
     1004.e0_kr,1000.e0_kr,1350.0e0_kr,&
     1064.e0_kr,296.0e0_kr,405.64e0_kr,&
     1064.e0_kr,400.e0_kr,484.22e0_kr,&
     1064.e0_kr,500.0e0_kr,568.53e0_kr,&
     1064.e0_kr,600.e0_kr,657.66e0_kr,&
     1064.e0_kr,700.e0_kr,749.69e0_kr,&
     1064.e0_kr,800.e0_kr,843.63e0_kr,&
     1064.e0_kr,1000.e0_kr,1035.e0_kr,&
     1064.e0_kr,1200.e0_kr,1229.3e0_kr,&
     1065.e0_kr,296.0e0_kr,713.39e0_kr,&
     1065.e0_kr,400.0e0_kr,754.68e0_kr,&
     1065.e0_kr,500.0e0_kr,806.67e0_kr,&
     1065.e0_kr,600.0e0_kr,868.38e0_kr,&
     1065.e0_kr,700.0e0_kr,937.64e0_kr,&
     1065.e0_kr,800.0e0_kr,1012.7e0_kr,&
     1065.e0_kr,1000.e0_kr,1174.9e0_kr,&
     1065.e0_kr,1200.e0_kr,1348.2e0_kr,&
     1065.e0_kr,1600.e0_kr,1712.9e0_kr,&
     1065.e0_kr,2000.e0_kr,2091.0e0_kr,&
     1095.e0_kr,296.0e0_kr,1165.9e0_kr,&
     1095.e0_kr,350.0e0_kr,1177.8e0_kr,&
     1095.e0_kr,400.0e0_kr,1191.4e0_kr,&
     1095.e0_kr,450.0e0_kr,1207.7e0_kr,&
     1095.e0_kr,500.0e0_kr,1226.0e0_kr,&
     1095.e0_kr,600.0e0_kr,1268.7e0_kr,&
     1095.e0_kr,800.0e0_kr,1373.4e0_kr,&
     1095.e0_kr,1000.e0_kr,1497.7e0_kr,&
     1096.e0_kr,296.0e0_kr,317.27e0_kr,&
     1096.e0_kr,400.0e0_kr,416.29e0_kr,&
     1096.e0_kr,500.0e0_kr,513.22e0_kr,&
     1096.e0_kr,600.0e0_kr,611.12e0_kr,&
     1096.e0_kr,700.0e0_kr,709.60e0_kr,&
     1096.e0_kr,800.0e0_kr,808.43e0_kr,&
     1096.e0_kr,1000.e0_kr,1006.8e0_kr,&
     1096.e0_kr,1200.e0_kr,1205.7e0_kr,&
     1097.e0_kr,296.0e0_kr,806.79e0_kr,&
     1097.e0_kr,400.0e0_kr,829.98e0_kr,&
     1097.e0_kr,500.0e0_kr,868.44e0_kr,&
     1097.e0_kr,600.0e0_kr,920.08e0_kr,&
     1097.e0_kr,700.0e0_kr,981.82e0_kr,&
     1097.e0_kr,800.0e0_kr,1051.1e0_kr,&
     1097.e0_kr,1000.e0_kr,1205.4e0_kr,&
     1097.e0_kr,1200.e0_kr,1373.4e0_kr,&
     1099.e0_kr,296.0e0_kr,596.4e0_kr,&
     1099.e0_kr,400.0e0_kr,643.9e0_kr,&
     1099.e0_kr,500.0e0_kr,704.6e0_kr,&
     1099.e0_kr,600.0e0_kr,775.3e0_kr,&
     1099.e0_kr,800.0e0_kr,935.4e0_kr,&
     1099.e0_kr,1000.e0_kr,1109.8e0_kr,&
     1099.e0_kr,1200.e0_kr,1292.3e0_kr,&
     1114.e0_kr,296.0e0_kr,1222.0e0_kr,&
     1114.e0_kr,350.0e0_kr,1239.0e0_kr/),(/3,67/))
   real(kr),parameter::zero=0

   do i=1,ntemp
      if (eftemp(i).eq.zero) then
         do j=1,ntabl
            jmat=nint(tabl(1,j))
            if (jmat.eq.mat) then
               test=5
               diff=tabl(2,j)-temp(i)
               if (abs(diff).le.test) then
                  eftemp(i)=tabl(3,j)
               endif
            endif
         enddo
         if (eftemp(i).eq.zero) eftemp(i)=temp(i)
      endif
   enddo
   return
   end subroutine gateff

   subroutine gatef2(temp,eftmp2,ntemp,mat)
   !-------------------------------------------------------------------
   ! Default effective temperatures for second atom in mixed
   ! moderators from GA report:
   !       1095      benzine (c6h6)
   !       1099      beo
   !-------------------------------------------------------------------
   ! externals
   integer::ntemp,mat
   real(kr)::temp(ntemp),eftmp2(ntemp)
   ! internals
   integer::i,j,jmat
   real(kr)::diff,test
   integer::ntabl=16
   real(kr),dimension(3,16),parameter::tabl=reshape((/&
     1095.e0_kr,296.0e0_kr,685.54e0_kr,1095.e0_kr,350.e0_kr,&
     712.02e0_kr,1095.e0_kr,400.e0_kr,738.97e0_kr,1095.e0_kr,&
     450.e0_kr,768.10e0_kr,1095.e0_kr,500.e0_kr,799.22e0_kr,&
     1095.e0_kr,600.e0_kr,866.63e0_kr,1095.e0_kr,800.e0_kr,&
     1017.3e0_kr, 1095.e0_kr,1000.e0_kr,1182.3e0_kr,&
     1099.e0_kr,296.0e0_kr,427.8e0_kr,1099.e0_kr,400.e0_kr,&
     502.8e0_kr,1099.e0_kr,500.e0_kr,584.3e0_kr,1099.e0_kr,&
     600.e0_kr,671.3e0_kr,1099.e0_kr,700.e0_kr,761.6e0_kr,&
     1099.e0_kr,800.e0_kr,854.2e0_kr,1099.e0_kr,1000.e0_kr,&
     1043.7e0_kr,1099.e0_kr,1200.e0_kr,1236.6e0_kr/),(/3,16/))
   real(kr),parameter::zero=0

   do i=1,ntemp
      if (eftmp2(i).eq.zero) then
         do j=1,ntabl
            jmat=nint(tabl(1,j))
            if (jmat.eq.mat) then
               test=5
               diff=tabl(2,j)-temp(i)
               if (abs(diff).le.test) then
                  eftmp2(i)=tabl(3,j)
               endif
            endif
         enddo
         if (eftmp2(i).eq.zero) eftmp2(i)=temp(i)
      endif
   enddo
   return
   end subroutine gatef2

   subroutine coh(lat,itemp,iold,inew,ne,nex,mtref,index)
   !-------------------------------------------------------------------
   ! Compute the coherent scattering cross sections for a crystalline
   ! material.  The cross section is computed on an energy grid
   ! chosen adaptively to represent the actual function within a
   ! given tolerance with linear-linear interpolation.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provieds error,finda,loada
   ! externals
   integer::lat,itemp,iold,inew,ne,nex,mtref,index
   ! internals
   integer::nl,imax,nx,nj,i,nlt,nlt1,nb,nw,nbragg
   integer::ix,j,iex,il,isave,ltt
   real(kr)::temp,e,enext,en,xm,ym,test
   integer,parameter::nlmax=6
   real(kr)::s(nlmax),ej(20),ex(20),x(5),y(5),z(5),b(12)
   real(kr),dimension(:,:),allocatable::stk
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::tolmin=1.e-6_kr
   real(kr),parameter::eps=3.e-5_kr

   !--initialize.
   nl=1
   temp=tempr(itemp)
   imax=20
   if (nl.gt.nlmax) call error('coh','too many legendre orders.',' ')
   nx=nl+1
   nj=nex+nl
   do i=1,nl
      ex(nex+i)=0
   enddo
   nlt=5
   if (ne.lt.nlt) nlt=ne
   nlt1=nlt-1
   allocate(stk(nx,imax))

   !--determine the energy grid adaptively and
   !--store the cross sections in a scratch file.
   nbragg=nl
   e=0
   call sigcoh(e,enext,s,nbragg,lat,temp,emax,natom,index)
   ix=1
   j=0
   iex=0
  100 continue
   iex=iex+1
   call finda(iex,ex,nex,iold,bufo,nbuf)
   if (ex(1).gt.enext*(1+small)) go to 105
   x(1)=ex(1)
   y(1)=ex(2)
   z(1)=ex(nex)
   j=j+1
   call loada(j,ex,nj,inew,bufn,nbuf)
   go to 100
  105 continue
   ix=ix+1
   x(ix)=ex(1)
   y(ix)=ex(2)
   z(ix)=ex(nex)
   if (ix.lt.nlt) go to 100
   ! prime stack with first bragg edge
   e=enext
   call sigcoh(e,enext,s,nl,lat,temp,emax,natom,index)
   stk(1,1)=e
   do il=1,nl
      stk(1+il,1)=s(il)
   enddo
   i=1
   ! add next bragg edge to stack
  120 continue
   e=enext
   call sigcoh(e,enext,s,nl,lat,temp,emax,natom,index)
   call upstk(e,s,nl,nx,i,stk)
   ! make sure input grid points are included
  125 continue
   do 130 ix=1,nlt
   if (x(ix).gt.stk(1,i)*(1+small)) go to 135
  130 continue
   go to 140
  135 continue
   if (x(ix).ge.stk(1,i-1)*(1-small)) go to 140
   e=x(ix)
   call sigcoh(e,en,s,nl,lat,temp,emax,natom,index)
   call upstk(e,s,nl,nx,i,stk)
   ! compare linear approximation to true function.
  140 continue
   if (i.eq.imax) go to 160
   xm=half*(stk(1,i-1)+stk(1,i))
   xm=sigfig(xm,7,0)
   if (stk(1,i-1)-stk(1,i).lt.eps*xm) go to 160
   call sigcoh(xm,en,s,nl,lat,temp,emax,natom,index)
   do 150 il=1,nl
   call terp1(stk(1,i),stk(1+il,i),&
     stk(1,i-1),stk(1+il,i-1),xm,ym,2)
   test=tol*abs(s(il))
   if (test.lt.tolmin) test=tolmin
   if (abs(s(il)-ym).gt.test) go to 210
  150 continue
   ! all components pass.  save top point in stack and continue.
  160 continue
   j=j+1
   ej(1)=stk(1,i)
  170 continue
   if (ej(1).le.x(3)*(1+small).or.iex.eq.ne) go to 190
   do ix=1,nlt1
      x(ix)=x(ix+1)
      y(ix)=y(ix+1)
      z(ix)=z(ix+1)
   enddo
   iex=iex+1
   call finda(iex,ex,nex,iold,bufo,nbuf)
   x(nlt)=ex(1)
   y(nlt)=ex(2)
   z(nlt)=ex(nex)
   if (iex.eq.ne) nlt=nlt-1
   if (iex.eq.ne) nlt1=nlt1-1
   go to 170
  190 continue
   ej(2)=terp(x,y,nlt,ej(1),nlt1)
   ej(nex)=terp(x,z,nlt,ej(1),nlt1)
   if (stk(1,i).gt.emax*(1+small)) ej(nex)=0
   do il=1,nl
      ej(nex+il)=stk(1+il,i)
      if (stk(1,i).gt.emax*(1+small)) ej(nex+il)=0
   enddo
   if (stk(1,i).gt.emax*(1+small)) go to 230
   call loada(j,ej,nj,inew,bufn,nbuf)
   i=i-1
   if (i.gt.1) go to 125
   go to 120
   ! test fails.  add point to stack and continue.
  210 continue
   call upstk(xm,s,nl,nx,i,stk)
   go to 125
   ! linearization complete.  save last point.
  230 continue
   ne=j
   j=-j
   call loada(j,ej,nj,inew,bufn,nbuf)
   isave=iold
   iold=inew
   inew=isave
   nex=nj
   ltt=7
   b(1)=za
   b(2)=awr
   b(3)=0
   b(4)=ltt ! temporary flag
   b(5)=0
   b(6)=0
   math=matdp
   mfh=6
   mth=mtref
   call contio(0,0,nscr,b,nb,nw)
   b(1)=1
   b(2)=1
   b(3)=-nbragg ! use lip field for nbragg
   b(4)=0 ! law=0 for coherent elastic data
   b(5)=1
   b(6)=2
   b(7)=2
   b(8)=2
   b(9)=1.e-5_kr
   b(10)=1
   b(11)=emax
   b(12)=1
   nw=12
   call tab1io(0,0,nscr,b,nb,nw)
   ncdse=3
   call asend(0,nscr)
   deallocate(stk)
   return
   end subroutine coh

   subroutine upstk(e,s,nl,nx,i,stk)
   !-------------------------------------------------------------------
   ! Update the linearization stack with energy e and cross
   ! sections s.  Here, i is the current index to the stack in stk,
   ! nl is the number of legendre orders in s, and nx is the
   ! cycle length in the stack.
   !-------------------------------------------------------------------
   ! externals
   integer::nl,nx,i
   real(kr)::e,s(nl),stk(nx,*)
   ! internals
   integer::j

   i=i+1
   stk(1,i)=stk(1,i-1)
   stk(1,i-1)=e
   do j=1,nl
      stk(1+j,i)=stk(1+j,i-1)
      stk(1+j,i-1)=s(j)
   enddo
   return
   end subroutine upstk

   subroutine sigcoh(e,enext,s,nl,lat,temp,emax,natom,index)
   !-------------------------------------------------------------------
   ! Compute the first nl Legendre components of the coherent scatter-
   ! ing at energy e from lattice type lat.  Here enext is the next
   ! Bragg edge.  Initialize if e=0.  A list of reciprocal lattice
   ! shells and weights is precomputed and stored for use at all e.
   ! Long, closely-spaced shells are grouped together to speed up the
   ! calculation.
   !       lat=1  graphite
   !       lat=2  be
   !       lat=3  beo
   !       lat=10 read from endf6
   ! nl returns no. of Bragg edges on initialization call.
   !-------------------------------------------------------------------
   use physics ! provides pi,amassn,amu,hbar,ev
   use util    ! provides error,sigfig
   use mathm   ! provides legndr
   ! externals
   integer::nl,lat,natom,index
   real(kr)::e,enext,s(*),temp,emax
   ! internals
   integer::nord,nw,k
   integer::i1m,i1,l1,i2m,i2,l2,i3m,i3,l3,nr,np
   integer::l,i,imax,jmin,j,il,lmax,last
   real(kr)::amne,econ,tsqx,a,c,amsc,scoh,wal2,wint,x
   real(kr)::w1,w2,w3,tsq,tau,w,f,st,sf,blast,re
   real(kr)::t2,ulim,phi,elim,u,twopis,c1,c2,recon,scon
   real(kr)::p(6)
   real(kr),dimension(:),allocatable::wrk
   integer,parameter::nd=10
   real(kr),dimension(10),parameter::dwf1=(/&
     2.1997e0_kr,2.7448e0_kr,3.2912e0_kr,3.8510e0_kr,4.4210e0_kr,&
     4.9969e0_kr,6.1624e0_kr,7.3387e0_kr,9.6287e0_kr,11.992e0_kr/)
   real(kr),dimension(10),parameter::dwf2=(/&
     3.16663e0_kr,3.88842e0_kr,4.62944e0_kr,5.40517e0_kr,6.19880e0_kr,&
     7.0042e0_kr,8.63665e0_kr,10.2865e0_kr,0.e0_kr,0.e0_kr/)
   real(kr),dimension(10),parameter::dwf3=(/&
     2.153e0_kr,2.6374e0_kr,3.1348e0_kr,3.6513e0_kr,4.1798e0_kr,&
     4.7164e0_kr,5.8052e0_kr,6.9068e0_kr,0.e0_kr,0.e0_kr/)
   real(kr),dimension(10),parameter::tmp=(/&
     296.e0_kr,400.e0_kr,500.e0_kr,600.e0_kr,700.e0_kr,800.e0_kr,&
     1000.e0_kr,1200.e0_kr,1600.e0_kr,2000.e0_kr/)
   real(kr),parameter::gr1=2.4573e-8_kr
   real(kr),parameter::gr2=6.700e-8_kr
   real(kr),parameter::gr3=12.011e0_kr
   real(kr),parameter::gr4=5.50e0_kr
   real(kr),parameter::be1=2.2856e-8_kr
   real(kr),parameter::be2=3.5832e-8_kr
   real(kr),parameter::be3=9.01e0_kr
   real(kr),parameter::be4=7.53e0_kr
   real(kr),parameter::beo1=2.695e-8_kr
   real(kr),parameter::beo2=4.39e-8_kr
   real(kr),parameter::beo3=12.5e0_kr
   real(kr),parameter::beo4=1.e0_kr
   real(kr),parameter::sqrt3=1.732050808e0_kr
   real(kr),parameter::cw=0.658173e-15_kr
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::eps=0.05e0_kr
   real(kr),parameter::zero=0
   save k,recon,scon

   !--initialize.
   if (e.gt.zero) go to 210
   twopis=(2*pi)**2
   amne=amassn*amu
   econ=ev*8*(amne/hbar)/hbar
   recon=1/econ
   tsqx=econ/20
   nord=2
   if (lat.eq.10) go to 200
   if (lat.eq.1) then
      ! graphite constants
      a=gr1
      c=gr2
      amsc=gr3
      scoh=gr4/natom
      wal2=terp(tmp,dwf1,nd,temp,nord)
   else if (lat.eq.2) then
      ! beryllium constants
      a=be1
      c=be2
      amsc=be3
      scoh=be4/natom
      wal2=terp(tmp,dwf2,nd,temp,nord)
   else if (lat.eq.3) then
      ! beryllium oxide constants
      a=beo1
      c=beo2
      amsc=beo3
      scoh=beo4/natom
      wal2=terp(tmp,dwf3,nd,temp,nord)
   else
      call error('sigcoh','illegal lat.',' ')
   endif
   c1=4/(3*a*a)
   c2=1/(c*c)
   scon=scoh*(4*pi)**2/(2*a*a*c*sqrt3*econ)
   wint=cw*amsc*wal2
   t2=hbar/(2*amu*amsc)
   ulim=econ*emax
   nw=1000000
   allocate(wrk(nw))

   !--compute and sort lattice factors.
   phi=ulim/twopis
   i1m=int(a*sqrt(phi))
   i1m=i1m+1
   k=0
   do 185 i1=1,i1m
   l1=i1-1
   i2m=int(half*(l1+sqrt(3*(a*a*phi-l1*l1))))
   i2m=i2m+1
   do 180 i2=i1,i2m
   l2=i2-1
   x=phi-c1*(l1*l1+l2*l2-l1*l2)
   i3m=0
   if (x.gt.zero) i3m=int(c*sqrt(x))
   i3m=i3m+1
   do 175 i3=1,i3m
   l3=i3-1
   w1=2
   if (l1.eq.l2) w1=1
   w2=2
   if (l1.eq.0.or.l2.eq.0) w2=1
   if (l1.eq.0.and.l2.eq.0) w2=half
   w3=2
   if (l3.eq.0) w3=1
   tsq=tausq(l1,l2,l3,c1,c2,twopis)
   if (tsq.le.zero.or.tsq.gt.ulim) go to 160
   tau=sqrt(tsq)
   w=exp(-tsq*t2*wint)*w1*w2*w3/tau
   f=w*form(lat,l1,l2,l3)
   if (k.gt.0.and.tsq.gt.tsqx) go to 150
   k=k+1
   if ((2*k).gt.nw) call error('sigcoh','storage exceeded.',' ')
   wrk(2*k-1)=tsq
   wrk(2*k)=f
   go to 160
  150 continue
   do 155 i=1,k
   if (tsq.lt.wrk(2*i-1).or.tsq.ge.(1+eps)*wrk(2*i-1)) go to 155
   wrk(2*i)=wrk(2*i)+f
   go to 160
  155 continue
   k=k+1
   if ((2*k).gt.nw) call error('sigcoh','storage exceeded.',' ')
   wrk(2*k-1)=tsq
   wrk(2*k)=f
  160 continue
   tsq=tausq(l1,-l2,l3,c1,c2,twopis)
   if (tsq.le.zero.or.tsq.gt.ulim) go to 175
   tau=sqrt(tsq)
   w=exp(-tsq*t2*wint)*w1*w2*w3/tau
   f=w*form(lat,l1,-l2,l3)
   if (k.gt.0.and.tsq.gt.tsqx) go to 165
   k=k+1
   if ((2*k).gt.nw) call error('sigcoh','storage exceeded.',' ')
   wrk(2*k-1)=tsq
   wrk(2*k)=f
   go to 175
  165 continue
   do 170 i=1,k
   if (tsq.lt.wrk(2*i-1).or.tsq.ge.(1+eps)*wrk(2*i-1)) go to 170
   wrk(2*i)=wrk(2*i)+f
   go to 175
  170 continue
   k=k+1
   if ((2*k).gt.nw) call error('sigcoh','storage exceeded.',' ')
   wrk(2*k-1)=tsq
   wrk(2*k)=f
  175 continue
  180 continue
  185 continue
   imax=k-1
   do i=1,imax
      jmin=i+1
      do j=jmin,k
         if (wrk(2*j-1).lt.wrk(2*i-1)) then
            st=wrk(2*i-1)
            sf=wrk(2*i)
            wrk(2*i-1)=wrk(2*j-1)
            wrk(2*i)=wrk(2*j)
            wrk(2*j-1)=st
            wrk(2*j)=sf
         endif
      enddo
   enddo
   k=k+1
   wrk(2*k-1)=ulim
   wrk(2*k)=wrk(2*k-2)
   nw=2*k
   enext=recon*wrk(1)
   enext=sigfig(enext,7,-1)
   ! copy data to global fl array
   allocate(fl(nw))
   do i=1,nw
      fl(i)=wrk(i)
   enddo
   deallocate(wrk)
   nl=k
   return

   !--bragg parameters already read from endf6
  200 continue
   !--fl(index) is the coherent S(E) table for the current temperature from ENDF6
   nr=int(fl(index+4))  ! number of interpolation regions
   np=int(fl(index+5))  ! number of points
   k=np
   nl=np
   blast=0
   scon=1
   enext=fl(index+2*nr+6)
   enext=sigfig(enext,7,-1)
   do i=1,nl
      l=index+2*(i-1)
      fl(l)=fl(l+2*nr+6)*econ
      fl(l+1)=fl(l+2*nr+7)-blast
      blast=fl(l+2*nr+7)
   enddo
   return

   !--compute cross sections at this energy
  210 continue
   re=1/e
   do il=1,nl
      s(il)=0
   enddo
   last=0
   do i=1,k
      tsq=fl(2*i-1)
      elim=tsq*recon
      if (elim.ge.e) exit
      f=fl(2*i)
      if (e.gt.emax) f=0
      u=1-2*elim*re
      lmax=nl-1
      call legndr(u,p,lmax)
      do il=1,nl
         s(il)=s(il)+f*p(il)
      enddo
      if (i.eq.k) last=1
   enddo
   do il=1,nl
      s(il)=s(il)*scon*re
   enddo
   if (last.eq.1) elim=emax
   if (elim.gt.emax) elim=emax
   enext=sigfig(elim,7,-1)
   if (e.gt.sigfig(enext,7,-1)) enext=sigfig(elim,7,+1)
   return

   contains

      real(kr) function tausq(m1,m2,m3,c1,c2,twopis)
      integer::m1,m2,m3
      real(kr)::c1,c2,twopis
      tausq=(c1*(m1*m1+m2*m2+m1*m2)+(m3*m3*c2))*twopis
      return
      end function tausq

   end subroutine sigcoh

   real(kr) function form(lat,l1,l2,l3)
   !-------------------------------------------------------------------
   ! Compute form factors for the specified lattice.
   !       lat=1  graphite
   !       lat=2  be
   !       lat=3  beo
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   integer::lat,l1,l2,l3
   ! internals
   integer::i
   real(kr),parameter::beo1=7.54e0_kr
   real(kr),parameter::beo2=4.24e0_kr
   real(kr),parameter::beo3=11.31e0_kr

   if (lat.eq.1) then
      ! graphite
      i=l3/2
      if ((2*i).ne.l3) then
         form=sin(pi*(l1-l2)/3)**2
      else
         form=(6+10*cos(2*pi*(l1-l2)/3))/4
      endif
   else if (lat.eq.2) then
      ! beryllium
      form=1+cos(2*pi*(2*l1+4*l2+3*l3)/6)
   else if (lat.eq.3) then
      ! beryllium oxide
      form=(1+cos(2*pi*(2*l1+4*l2+3*l3)/6))*(beo1+beo2+beo3*&
        cos(3*pi*l3/4))
   endif
   return
   end function form

   subroutine iel(mat,itemp,iold,inew,ne,nex,mtref,index)
   !-------------------------------------------------------------------
   ! Compute the elastic scattering from polyethylene or hydrogen
   ! in zirconium hydride using the incoherent approximation.
   ! The calcem energy grid is used.  If mat.eq.11 or 12, built-in
   ! parameters from the ENDF/B-III evaluations are used.
   ! If mat.eq.20, material parameters have been read from ENDF6.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use endf   ! provides endf routines and variables
   use util   ! provides error,finda,loada
   ! externals
   integer::mat,itemp,iold,inew,ne,nex,mtref,index
   ! internals
   integer::idis,iex,iet,iu,ix,nj,nr,np,ip,ir,ltt,nb,nw
   integer::n,nup,nup1,isave,nne
   real(kr)::dwa,c1,e,c2,u,rc2,temp,tt1,ttn,tnxt
   real(kr)::x1,r1x1,xsec,x2,unow
   real(kr)::ex(20),ej(20)
   real(kr),dimension(:),allocatable::xie
   integer,parameter::nupmax=10
   real(kr),dimension(8),parameter::tmp=(/296e0_kr,400.e0_kr,&
     500.e0_kr,600.e0_kr,700.e0_kr,800.e0_kr,1000.e0_kr,1200.e0_kr/)
   real(kr),dimension(8),parameter::dwh=(/8.4795e0_kr,9.0854e0_kr,&
     9.8196e0_kr,10.676e0_kr,11.625e0_kr,12.643e0_kr,14.822e0_kr,&
     17.125e0_kr/)
   real(kr),dimension(8),parameter::dwz=(/1.9957e0_kr,2.6546e0_kr,&
     3.2946e0_kr,3.9380e0_kr,4.5835e0_kr,5.2302e0_kr,6.5260e0_kr,&
     7.8236e0_kr/)
   real(kr),parameter::c11a=162.88e0_kr
   real(kr),parameter::c11b=296.e0_kr
   real(kr),parameter::c11c=34.957e0_kr
   real(kr),parameter::c11d=350.e0_kr
   real(kr),parameter::c11e=40.282e0_kr
   real(kr),parameter::c12a=81.44e0_kr
   real(kr),parameter::c13a=6.3366e0_kr
   real(kr),parameter::up=1.1e0_kr
   real(kr),parameter::dn=.9e0_kr

   !--initialize
   if (iprint.eq.2) write(nsyso,'(/'' iel''/)')
   temp=tempr(itemp)
   nj=nex+1

   !--select material parameters
   if (mat.eq.11) then
      sb=c11a
      dwa=c11c+(temp-c11b)*(c11e-c11c)/(c11d-c11b)
   else if (mat.eq.12) then
      dwa=terp(tmp,dwh,8,temp,3)
      sb=c12a
   else if (mat.eq.13) then
      dwa=terp(tmp,dwz,8,temp,3)
      sb=c13a
   else if (mat.eq.20) then
      !--fl(index) is the incoherent W'(T) table from ENDF6
      sb=fl(index)
      nr=int(fl(index+4))  ! number of interpolation regions
      np=int(fl(index+5))  ! number of points
      if (np.eq.1) then
         tt1=fl(index+2*nr+6)
         if (abs(temp-tt1).gt.temp/10) call error('iel',&
           'bad temperature for debye-waller factor',' ')
         dwa=fl(index+2*nr+7)
      else
         tt1=fl(index+2*nr+6)
         ttn=fl(index+2*nr+2*np+4)
         if (temp.lt.dn*tt1.or.temp.gt.up*ttn) call error('iel',&
           'bad temperature for debye-waller factor',' ')
         if (tt1.gt.temp) fl(index+2*nr+6)=temp
         if (ttn.lt.temp) fl(index+2*nr+2*np+4)=temp
         ip=2
         ir=1
         call terpa(dwa,temp,tnxt,idis,fl(index),ip,ir)
      endif
   else
      call error('iel','unknown material identifier.',' ')
   endif
   c1=sb/(2*natom)

   !--check on calcem energy grid
   nne=0
   do
     if (esi(nne+1).eq.0) exit
     nne=nne+1
   enddo
   allocate(xie(nne))

   !--write head and tab2 records for mf6
   !--in lanl format
   ltt=6
   math=matdp
   mfh=6
   mth=mtref
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=ltt ! temporary flag for incoherent inelastic data
   scr(5)=0
   scr(6)=0
   nw=6
   call contio(0,0,nscr,scr,nb,nw)
   scr(1)=1
   scr(2)=1
   scr(3)=-2 ! special flag for incoherent inelastic data
   scr(4)=1 ! law=1 for incoherent inelastic data
   scr(5)=1
   scr(6)=2
   scr(7)=2
   scr(8)=2
   scr(9)=1.e-5_kr
   scr(10)=1
   scr(11)=emax
   scr(12)=1
   nw=12
   call tab1io(0,0,nscr,scr,nb,nw)
   scr(1)=temp
   scr(2)=0
   scr(3)=3 ! LANG=3 is a special flag for equally probable cosines
   scr(5)=1
   scr(6)=nne
   scr(7)=nne
   scr(8)=2
   nw=8
   call tab2io(0,0,nscr,scr,nb,nw)
   n=nbin
   nup=n
   if (nup.gt.nupmax) nup=nupmax
   nup1=nup+1
   nw=n+8

   !--compute cross sections on calcem energy grid
   !--and equi-probable angles.
   do iex=1,nne
      e=esi(iex)
      c2=2*e*dwa
      u=-1
      rc2=1/c2
      x1=exp(-2*c2)
      r1x1=1/(1-x1)
      xsec=c1*rc2*(1-x1)
      scr(1)=0
      scr(2)=e
      scr(3)=0
      scr(4)=0
      scr(5)=n+2
      scr(6)=n+2
      scr(7)=e
      scr(8)=1
      do iu=1,n
         x2=exp(-c2*(1-u))
         unow=1+rc2*log((1-x1)/n+x2)
         scr(8+iu)=n*rc2*(exp(-c2*(1-unow))*(c2*unow-1)-&
           x2*(c2*u-1))*r1x1
         u=unow
      enddo
      xie(iex)=xsec
      if (iprint.eq.2) write(nsyso,'(4x,1p,2e12.4,0p,10f9.4)')&
        e,xsec,(scr(8+iu),iu=1,nup)
      if (iprint.eq.2.and.n.gt.nup)&
        write(nsyso,'(28x,10f9.4)') (scr(8+iu),iu=nup1,n)
      call listio(0,0,nscr,scr,nb,nw)
   enddo
   do iex=1,ne
      call finda(iex,ex,nex,iold,bufo,nbuf)
      do ix=1,nex
         ej(ix)=ex(ix)
      enddo
      ej(nj)=terp(esi,xie,nne,ex(1),3)
      if (iex.eq.ne) ej(nj)=0
      iet=iex
      if (iex.eq.ne) iet=-iet
      call loada(iet,ej,nj,inew,bufn,nbuf)
   enddo
   isave=iold
   iold=inew
   inew=isave
   nex=nj
   call asend(0,nscr)
   ncdse=5+ne*((n+11)/6)
   return
   end subroutine iel

   real(kr) function terp(x,y,nl,arg,il1)
   !-------------------------------------------------------------------
   ! This function does Lagrangian interpolation or
   ! extrapolation of ilth order on x and y for arg
   ! when the tables are either increasing or decreasing
   !      x          x array, independent variable
   !      y          y array, dependent variable
   !      nl         number of entries in tables of x and y
   !      arg        independent variable value
   !      il         order of interpolation
   !-------------------------------------------------------------------
   ! externals
   integer::nl,il1
   real(kr)::x(nl),y(nl),arg
   ! internals
   integer::il,l,iadd,il2,ilow,ihi,iusel,iuseh,ibeg,iend
   integer::last,n,m,i,in,ip,inp
   real(kr)::sum,p,pk
   real(kr),parameter::small=1.e-10_kr

   il=il1
   if (nl.gt.il) go to 120
   if (nl.eq.il) go to 110
   ! not enough entries in tables for this order interpolation
   il=nl
  110 continue
   l=1
   go to 260
  120 continue
   il2=il/2
   iadd=mod(il,2)
   ! check if tables in increasing or decreasing sequence
   if (x(1).le.x(nl)) then
      ! increasing sequence
      ilow=il2+1
      ihi=nl-il2-iadd
      iusel=1
      iuseh=nl-il+1
      ibeg=ilow+1
      iend=ihi-1
      last=iend-il2+1
      iadd=0
    else
       ! decreasing sequence
      ilow=nl-il2
      ihi=il2+iadd+1
      iusel=nl-il+1
      iuseh=1
      ibeg=ihi+1
      iend=ilow-1
      last=2
      iadd=1-iadd
   endif
   ! checks if arg is smaller than table values
   if (abs(arg-x(ilow)).lt.small*arg) go to 160
   if (arg.gt.x(ilow)) go to 170
   ! smaller than smallest table value
   l=iusel
   go to 260
  160 continue
   terp=y(ilow)
   go to 300
   ! checks if arg is greater than table values
  170 continue
    if (abs(x(ihi)-arg).lt.small*arg) go to 190
   if (x(ihi).gt.arg) go to 200
   ! arg greater than table value
   l=iuseh
   go to 260
  190 continue
   terp=y(ihi)
   go to 300
   ! searches x array to bracket arg
  200 continue
   do 230 n=ibeg,iend
   if (iusel.gt.1) go to 210
   m=n
   go to 220
  210 continue
   m=nl-n+1
  220 continue
   if (abs(x(m)-arg).lt.small*arg) go to 240
   if (x(m).gt.arg) go to 250
  230 continue
   l=last
   go to 260
   ! equals argument, return ok
  240 continue
   terp=y(m)
   go to 300
   ! eureka
  250 continue
   l=m-il2+iadd
  260 continue
   ! interpolation section
   sum=0
   do i=1,il
      p=1
      pk=1
      in=l+i-1
      do ip=1,il
         if (ip.ne.i) then
            inp=l+ip-1
            p=p*(arg-x(inp))
            pk=pk*(x(in)-x(inp))
         endif
      enddo
      sum=sum+p*y(in)/pk
   enddo
   terp=sum
  300 continue
   return
   end function terp

   subroutine calcem(temp,itemp,iold,inew,ne,nex,mtref)
   !-------------------------------------------------------------------
   ! Calculate incoherent inelastic scattering kernels from
   ! s(alpha,beta) in endf mf7 format or from analytic models
   ! of s(alpha,beta). The incident energy grid is fixed (see egrid).
   ! For iform=0, the secondary energy and scattering cosine grids
   ! are determined adaptively for linear interpolations.  A compact
   ! angle representation using equally probable cosines is generated.
   ! For iform=1, a fixed grid of mu values is used, and the secondary
   ! distribution is determined adaptively for linear interpolation
   ! for each mu.  In both cases, the results are written to a
   ! scratch tape for tpend.
   !-------------------------------------------------------------------
   use mainio  ! provides nsysi,nsyso,nsyse
   use endf    ! provides endf routines and variables
   use physics ! provides bk
   use util    ! provides error,repoz,sigfig
   use mathm   ! provides legndr
   ! externals
   integer::itemp,iold,inew,ne,nex,mtref
   real(kr)::temp
   ! internals
   character(len=60)::strng
   integer::nr,np,nwtab,nl,nlt,nlp,nlp1,nnl,jmax,nne
   integer::i,ia,nl1,ltt,loc,l,jscr,ilog
   integer::matd,itprnt,nb,nw,ni,nbeta,lt,it,nalpha
   integer::itrunc,ib,ip,ir,idis,ie,nmu,nep,istart,iend
   integer::jbeta,j,iskip,il,k,jnz,ll,jj,ii,nexn,ien,isave
    integer::nll
   real(kr)::smz,t1,t,tmax,test,tempt,tt1,ttn,tnxt,xm
   real(kr)::uu,uum,ym,test2,xlast,ulast,xs
   real(kr)::b,diff,enow,ep,sabmin,tev,ylast
   real(kr)::u,xl,yl,sum
   real(kr)::tone,elo
   integer,parameter::ngrid=118
   integer,parameter::nlmax=65
   integer,parameter::nemax=5000
   integer,parameter::mumax=300
   integer,parameter::imax=20
   real(kr)::ex(imax),x(imax),y(nlmax,imax),yt(nlmax)
   real(kr)::yy(imax),yu(2*nemax)
   real(kr)::ubar(ngrid)
   real(kr)::u2,u2last,u3,u3last,p2(ngrid),p3(ngrid),p(4)
   real(kr)::uj(mumax),sj(mumax)
   real(kr),dimension(:),allocatable::alpha,beta
   real(kr),dimension(:,:),allocatable::sab
   real(kr),dimension(ngrid),parameter::egrid=(/&
     1.e-5_kr,1.78e-5_kr,2.5e-5_kr,3.5e-5_kr,5.0e-5_kr,7.0e-5_kr,1.e-4_kr,&
     1.26e-4_kr,1.6e-4_kr,2.0e-4_kr,.000253e0_kr,.000297e0_kr,.000350e0_kr,&
     .00042e0_kr,.000506e0_kr,.000615e0_kr,.00075e0_kr,.00087e0_kr,&
     .001012e0_kr,.00123e0_kr,.0015e0_kr,.0018e0_kr,.00203e0_kr,.002277e0_kr,&
     .0026e0_kr,.003e0_kr,.0035e0_kr,.004048e0_kr,.0045e0_kr,.005e0_kr,&
     .0056e0_kr,.006325e0_kr,.0072e0_kr,.0081e0_kr,.009108e0_kr,.01e0_kr,&
     .01063e0_kr,.0115e0_kr,.012397e0_kr,.0133e0_kr,.01417e0_kr,.015e0_kr,&
     .016192e0_kr,.0182e0_kr,.0199e0_kr,.020493e0_kr,.0215e0_kr,.0228e0_kr,&
     .0253e0_kr,.028e0_kr,.030613e0_kr,.0338e0_kr,.0365e0_kr,.0395e0_kr,&
     .042757e0_kr,.0465e0_kr,.050e0_kr,.056925e0_kr,.0625e0_kr,.069e0_kr,&
     .075e0_kr,.081972e0_kr,.09e0_kr,.096e0_kr,.1035e0_kr,.111573e0_kr,&
     .120e0_kr,.128e0_kr,.1355e0_kr,.145728e0_kr,.160e0_kr,.172e0_kr,&
     .184437e0_kr,.20e0_kr,.2277e0_kr,.2510392e0_kr,.2705304e0_kr,&
     .2907501e0_kr,.3011332e0_kr,.3206421e0_kr,.3576813e0_kr,.39e0_kr,&
     .4170351e0_kr,.45e0_kr,.5032575e0_kr,.56e0_kr,.625e0_kr,&
     .70e0_kr,.78e0_kr,.86e0_kr,.95e0_kr,1.05e0_kr,1.16e0_kr,1.28e0_kr,&
     1.42e0_kr,1.55e0_kr,1.70e0_kr,1.855e0_kr,2.02e0_kr,2.18e0_kr,&
     2.36e0_kr,2.59e0_kr,2.855e0_kr,3.12e0_kr,3.42e0_kr,3.75e0_kr,&
     4.07e0_kr,4.46e0_kr,4.90e0_kr,5.35e0_kr,5.85e0_kr,6.40e0_kr,&
     7.00e0_kr,7.65e0_kr,8.40e0_kr,9.15e0_kr,9.85e0_kr,10.00e0_kr/)
   real(kr),parameter::unity=1.0e0_kr
   real(kr),parameter::sabflg=-225.e0_kr
   real(kr),parameter::eps=1.e-4_kr
   real(kr),parameter::tolmin=5.e-7_kr
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::break=3000.e0_kr
   real(kr),parameter::em9=1.e-9_kr
   real(kr),parameter::zero=0.e0_kr
   real(kr),parameter::tenth=0.1e0_kr
   real(kr),parameter::up=1.1e0_kr
   real(kr),parameter::dn=0.9e0_kr
   real(kr),parameter::uumin=0.00001e0_kr
   real(kr),parameter::yumin=2.e-7_kr
   integer,parameter::nlpmx=10
   save nwtab,sabmin,nl,nlt,nlp,nlp1,nl1,nnl,jmax,nne
   tevz=therm

   !--initialize if itemp=1.
   if (itemp.eq.1) then
      sabmin=exp(sabflg)
      nwtab=8
      nl=nbin+1
      if (nl.gt.nlmax)&
        call error('calcem','nl too large for binning.',' ')
      nlp=nl+1
      if (nlp.gt.nlpmx) nlp=nlpmx
      nlp1=nlp+1
      nl1=nl+1
      nnl=-nl
      jmax=(nwscr-50)/nl
      nne=0
      do i=1,ngrid
         if (egrid(i).gt.emax.and.nne.eq.0) nne=i
      enddo
      if (nne.eq.0) nne=ngrid
      allocate(esi(nne+1))
      allocate(xsi(nne+1))
      nlt=5
      if (nne.le.nlt) nlt=nne-1
   endif
   call repoz(nscr)
   nsc=0
   ncds=0
   if (iinc.eq.1) go to 200
   matd=matde
   itprnt=0

   !--bound atom scattering.
   !--read s(alpha,beta) from endf tape.
   !--initialize for desired material
   call findf(matd,7,4,nendf)
   call contio(nendf,0,0,scr,nb,nw)
   lasym=n1h

   ! lasym= 0 or 1 = traditional endf definitions.
   ! lasym= 2 or 3 = traditional lasym + 2
   !               = leapr's isabt=1 option was used.
   if (lasym.gt.1) call error ('calcem','isabt=1 pendf tape found',&
                         'thermr cannot process this format')

   lat=l2h
   call listio(nendf,0,0,scr,nb,nw)
   ilog=l1h
   ni=n1h
   ! parameters for principal atom
   smz=scr(7)/natom
   az=scr(9)
   sb=smz*((az+1)/az)**2
   ! sct parameters for other atoms
   if (iverf.ge.6) then
      sb2=0
      az2=0
      if (ni.gt.6) then
         if (scr(13).eq.zero) az2=scr(15)
         if (az2.ne.zero) sb2=scr(14)*((az2+1)/az2)**2
         sb2=sb2/scr(18)/natom
         if (ni.gt.12) then
            if (scr(19).eq.zero)&
              call error('calcem','only 2 sct atoms allowed.',' ')
         endif
      endif
   endif
   call tab2io(nendf,0,0,scr,nb,nw)
   nbeta=nint(scr(6))
   loc=1+nw
   ! read first tab1 record for alpha grid.
   call tab1io(nendf,0,0,scr(loc),nb,nw)
   t1=c1h
   b=c2h
   lt=l1h
   it=0
   nalpha=n2h
   l=loc+nw
   do while (nb.ne.0)
      call moreio(nendf,0,0,scr(l),nb,nw)
      l=l+nw
   enddo
   allocate(alpha(nalpha))
   l=loc+4+2*n1h
   do i=1,nalpha
      alpha(i)=scr(2*i+l)
   enddo
   allocate(beta(nbeta))
   allocate(sab(nalpha,nbeta))

   !--read s(alpha,beta) data into memory
   itrunc=0
   ib=1
   beta(ib)=b
  120 continue
   t=scr(loc)
   do while (abs(t-temp).gt.temp/500)
      if (t.gt.temp)&
        call error('calcem','desired temperature not found.',' ')
      it=it+1
      if (it.gt.lt)&
        call error('calcem','desired temperature not found.',' ')
      call listio(nendf,0,0,scr(loc),nb,nw)
      l=loc+nw
      do while (nb.ne.0)
         call moreio(nendf,0,0,scr(l),nb,nw)
         l=l+nw
      enddo
      t=scr(loc)
   enddo
   if (abs(t-temp).gt.eps.and.itprnt.eq.0) then
      itprnt=1
      diff=abs(t-temp)
      write(nsyso,'(/&
        &'' difference between temperatures desired and found is '',&
        &1p,e10.2)') diff
      write(nsyse,'(/&
        & '' difference between temperatures desired and found is '',&
        &1p,e10.2)') diff
   endif
   l=loc+6
   if (t.eq.t1) l=l+2*nint(scr(loc+4))+1
   do ia=1,nalpha
      if (ilog.eq.0) then
         if (scr(l).gt.sabmin) sab(ia,ib)=log(scr(l))
         if (scr(l).le.sabmin) then
            if (scr(l).gt.zero) itrunc=1
            sab(ia,ib)=sabflg
         endif
      else
         sab(ia,ib)=scr(l)
      endif
      if (t.eq.t1) l=l+1
      l=l+1
   enddo
   do while (it.lt.lt)
      it=it+1
      call listio(nendf,0,0,scr(loc),nb,nw)
      l=loc
      do while (nb.ne.0)
         l=l+nw
         call moreio(nendf,0,0,scr(l),nb,nw)
      enddo
   enddo
   if (ib.eq.nbeta) go to 180
   ib=ib+1
   call tab1io(nendf,0,0,scr(loc),nb,nw)
   l=loc
   do while (nb.ne.0)
      l=l+nw
      call moreio(nendf,0,0,scr(l),nb,nw)
   enddo
   b=scr(loc+1)
   beta(ib)=b
   it=0
   go to 120
  180 continue
   if (itrunc.eq.1) then
      tmax=2*(-sabflg-5)*bk*temp
      write(nsyso,'(/&
        &'' ***warning***'',&
        &''sab contains numbers that are too small'',&
        &'' to represent on this machine.''/&
        &'' results may be bad for transfers larger than '',&
        &f8.3,'' ev.'')') tmax
      write(nsyse,'(/&
        &'' ***warning***'',&
        &''sab contains numbers that are too small'',&
        &'' to represent on this machine.''/&
        &'' results may be bad for transfers larger than '',&
        &f8.3,'' ev.'')') tmax
   endif
   tmax=beta(nbeta)*bk*temp
   if (lat.eq.1) tmax=tmax*tevz/(bk*temp)
   test=5
   if (tmax.lt.test) then
      write(nsyso,'(/&
        &'' ***warning***'',&
        &''maximum value of beta limits the allowed energy transfer''/&
        &'' the sct approx. will be used for transfers larger than '',&
        &f6.3,'' ev.'')') tmax
      write(nsyse,'(/&
        &'' ***warning***'',&
        &''maximum value of beta limits the allowed energy transfer''/&
        &'' the sct approx. will be used for transfers larger than '',&
        &f6.3,'' ev.'')') tmax
   endif

   !--read effective temperatures for endf6
   if (iverf.lt.6) go to 300
   call tab1io(nendf,0,0,scr,nb,nw)
   nr=nint(scr(5))
   np=nint(scr(6))
   if (np.eq.1) then
      tempt=temp
      tt1=scr(7+2*nr)
      if (abs(tempt-tt1).gt.tempt/10) call error('calcem',&
        'bad temperature for teff',' ')
      teff=scr(8+2*nr)
   else
      ip=2
      ir=1
      tempt=temp
      tt1=scr(7+2*nr)
      ttn=scr(5+2*nr+2*np)
      if (tempt.lt.dn*tt1.or.tempt.gt.up*ttn) call error('calcem',&
        'bad temperature for teff',' ')
      if (tt1.gt.tempt) scr(7+2*nr)=tempt
      if (ttn.lt.tempt) scr(5+2*nr+2*np)=tempt
      call terpa(teff,tempt,tnxt,idis,scr,ip,ir)
   endif
   if (sb2.eq.zero) go to 300
   call tab1io(nendf,0,0,scr,nb,nw)
   nr=nint(scr(5))
   np=nint(scr(6))
   if (np.gt.1) go to 195
   tt1=scr(7+2*nr)
   if (abs(tempt-tt1).gt.tempt/10) call error('calcem',&
     'bad temperature for teff2',' ')
   teff2=scr(8+2*nr)
   go to 300
  195 ip=2
   ir=1
   tempt=temp
   tt1=scr(7+2*nr)
   ttn=scr(5+2*nr+2*np)
   if (tempt.lt.dn*tt1.or.tempt.gt.up*ttn) call error('calcem',&
     'bad temperature for teff2',' ')
   if (tt1.gt.tempt) scr(7+2*nr)=tempt
   if (ttn.lt.tempt) scr(5+2*nr+2*np)=tempt
   call terpa(teff2,tempt,tnxt,idis,scr,ip,ir)
   go to 300

   !--use free-gas s(alpha,beta).
  200 continue
   ! the beta grid is fixed to 45 beta values (previously only the first 9)
   ! following an issue with Fe56 and H1 from ENDF/B-VIII.0 - a better solution
   ! would be to contruct the grid adaptatively based on emax and tempr
   nalpha=1
   nbeta=45
   allocate(alpha(nalpha))
   allocate(beta(nbeta))
   allocate(sab(nalpha,nbeta))
   beta(1)=0
   beta(2)=tenth
   beta(3)=2
   beta(4)=4
   beta(5)=6
   beta(6)=8
   beta(7)=10
   beta(8)=15
   beta(9)=25
   beta(10)=30
   beta(11)=35
   beta(12)=40
   beta(13)=45
   beta(14)=50
   beta(15)=55
   beta(16)=60
   beta(17)=65
   beta(18)=70
   beta(19)=75
   beta(20)=80
   beta(21)=100
   beta(22)=120
   beta(23)=140
   beta(24)=160
   beta(25)=180
   beta(26)=200
   beta(27)=250
   beta(28)=300
   beta(29)=350
   beta(30)=400
   beta(31)=500
   beta(32)=600
   beta(33)=700
   beta(34)=800
   beta(35)=900
   beta(36)=1000
   beta(37)=1250
   beta(38)=1500
   beta(39)=1750
   beta(40)=2000
   beta(41)=2250
   beta(42)=2500
   beta(43)=2750
   beta(44)=3000
   beta(45)=3500
   t=temp
   smz=1
   sb=smz*((az+1)/az)**2
   lat=0

   !--compute kernel and write in special mf6 energy-angle format
  300 continue
   if (iform.eq.1) go to 510
   ltt=5
   math=matdp
   mfh=6
   mth=mtref
   tev=t*bk
   teff=teff*bk
   teff2=teff2*bk
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=ltt ! temporary flag for this format
   scr(5)=1
   scr(6)=0
   nw=6
   call contio(0,0,nscr,scr,nb,nw)
   ncds=ncds+1
   scr(1)=1
   scr(2)=1
   scr(3)=-1 ! LIP=-1 indicates incoherent inelastic data
   scr(4)=1 ! LAW=1 for incoherent inelastic data
   scr(5)=1
   scr(6)=2
   scr(7)=2
   scr(8)=2
   scr(9)=1.e-5_kr
   scr(10)=1
   scr(11)=emax
   scr(12)=1
   nw=12
   call tab1io(0,0,nscr,scr,nb,nw)
   ncds=ncds+2
   scr(1)=temp
   scr(2)=0
   scr(3)=3 ! lang=3 is a special code for equally probable cosines
   scr(4)=1
   scr(5)=1
   scr(6)=nne
   scr(7)=nne
   scr(8)=2
   nw=8
   call tab2io(0,0,nscr,scr,nb,nwtab)
   ncds=ncds+2
   cliq=0
   if (iinc.eq.1) go to 305
   if (sab(1,1).gt.sab(2,1))&
     cliq=(sab(1,1)-sab(1,2))*alpha(1)/beta(2)**2

   !--loop over given incident energy grid.
  305 continue
   ie=0
  310 continue
   ie=ie+1
   enow=egrid(ie)
   if (temp.gt.break) then
      tone=therm/bk
      elo=egrid(1)
      enow=elo*exp(log(enow/elo)*log((temp/tone)*egrid(ngrid)/elo)&
        /log(egrid(ngrid)/elo))
   endif
   enow=sigfig(enow,8,0)
   esi(ie)=enow
   xsi(ie)=0
   ubar(ie)=0
   p2(ie)=0
   p3(ie)=0
   ep=0
   x(1)=ep
   call sigl(enow,ep,nnl,tev,nalpha,alpha,nbeta,beta,&
     sab,yt,nlmax,tol)
   do il=1,nl
      y(il,1)=yt(il)
   enddo
   jbeta=-nbeta
   if (lasym.gt.0) jbeta=1
   j=0
   iskip=0

   !--set up next panel
  311 continue
   x(2)=x(1)
   do il=1,nl
      y(il,2)=y(il,1)
   enddo
  313 continue
   if (jbeta.eq.0) jbeta=1
   if (jbeta.le.0) then
      if (lat.eq.1) then
         ep=enow-beta(-jbeta)*tevz
      else
         ep=enow-beta(-jbeta)*tev
      endif
      if (ep.eq.enow) then
         ep=sigfig(enow,8,-1)
      else
         ep=sigfig(ep,8,0)
      endif
   else
      if (lat.eq.1) then
         ep=enow+beta(jbeta)*tevz
      else
         ep=enow+beta(jbeta)*tev
      endif
      if (ep.eq.enow) then
         ep=sigfig(enow,8,+1)
         iskip=1
      else
         ep=sigfig(ep,8,0)
      endif
   endif
   if (ep.gt.x(2)) go to 316
   jbeta=jbeta+1
   go to 313
  316 continue
   ep=sigfig(ep,8,0)
   x(1)=ep
   call sigl(enow,ep,nnl,tev,nalpha,alpha,nbeta,beta,&
     sab,yt,nlmax,tol)
   do il=1,nl
      y(il,1)=yt(il)
   enddo

   !--adaptive subdivision of panel
   i=2
   ! compare linear approximation to true function
  330 continue
   if (i.eq.imax) go to 360
   if (iskip.eq.1) then
      iskip=0
      go to 360
   endif
   if (half*(y(1,i-1)+y(1,i))*(x(i-1)-x(i)).lt.tolmin) go to 360
   xm=half*(x(i-1)+x(i))
   xm=sigfig(xm,8,0)
   if (xm.le.x(i).or.xm.ge.x(i-1)) go to 360
   call sigl(enow,xm,nnl,tev,nalpha,alpha,nbeta,beta,&
     sab,yt,nlmax,tol)
   uu=0
   uum=0
   do 350 k=1,nl
   call terp1(x(i),y(k,i),x(i-1),y(k,i-1),xm,ym,2)
   if (k.gt.1) uu=uu+yt(k)
   if (k.gt.1) uum=uum+ym
   test=tol*abs(yt(k))
   test2=test
   if (k.gt.1) test2=tol
   if (abs(yt(k)-ym).gt.test2) go to 410
  350 continue
   test=2*tol*abs(uu)+uumin
   if (abs(uu-uum).gt.test) go to 410
   ! point passes.  save top point in stack and continue.
  360 continue
   j=j+1
   if (j.ge.jmax) call error('calcem','storage exceeded.',' ')
   if (j.gt.1) xsi(ie)=xsi(ie)+(x(i)-xlast)*(y(1,i)+ylast)*half
   if (j.gt.1) then
      uu=0
      u2=0
      u3=0
      nll=3
      do il=2,nl
         call legndr(y(il,i),p,nll)
         uu=uu+p(2)
         u2=u2+p(3)
         u3=u3+p(4)
      enddo
      uu=uu/(nl-1)
      uu=uu*y(1,i)
      u2=u2/(nl-1)
      u3=u3/(nl-1)
      u2=u2*y(1,i)
      u3=u3*y(1,i)
      ubar(ie)=ubar(ie)+half*(x(i)-xlast)*(uu+ulast)
      p2(ie)=p2(ie)+half*(x(i)-xlast)*(u2+u2last)
      p3(ie)=p3(ie)+half*(x(i)-xlast)*(u3+u3last)
   endif
   if (j.ne.3.or.xsi(ie).ge.tolmin) go to 380
   j=2
  380 continue
   jscr=7+(j-1)*(nl+1)
   scr(jscr)=x(i)
   if (y(1,i).ge.em9) then
      scr(1+jscr)=sigfig(y(1,i),9,0)
   else
      scr(1+jscr)=sigfig(y(1,i),8,0)
   endif
   do il=2,nl
      scr(il+jscr)=sigfig(y(il,i),9,0)
      if (scr(il+jscr).gt.unity) then
         !--only warn for big miss, but always fix the overflow
         !  use this same unity+0.0005 value in aceth
         if (scr(il+jscr).gt.unity+0.0005_kr) then
            write(strng,'("1cos=",f7.4,", set to 1.&
                          &  enow,e''=",2(1pe12.5))')&
                            scr(il+jscr),enow,scr(jscr)
            call mess('calcem',strng,'')
         endif
         scr(il+jscr)=unity
      endif
      if (scr(il+jscr).lt.-unity) then
         !--only warn for big miss, but always fix the underflow
         if (scr(il+jscr).lt.-(unity+0.0005_kr)) then
            write(strng,'("1cos=",f7.4,", set to -1.&
                          &  enow,e''=",2(1pe12.5),i3)')&
                            scr(il+jscr),enow,scr(jscr)
            call mess('calcem',strng,'')
         endif
         scr(il+jscr)=-unity
      endif
   enddo
   xlast=x(i)
   ylast=y(1,i)
   if (ylast.ne.zero) jnz=j
   ulast=0
   u2last=0
   u3last=0
   nll=3
   do il=2,nl
      call legndr(y(il,i),p,nll)
      ulast=ulast+p(2)
      u2last=u2last+p(3)
      u3last=u3last+p(4)
   enddo
   ulast=ulast*y(1,i)/(nl-1)
   u2last=u2last*y(1,i)/(nl-1)
   u3last=u3last*y(1,i)/(nl-1)
   i=i-1
   if (i.ge.2) go to 330
   jbeta=jbeta+1
   if (jbeta.le.nbeta) go to 311
   do il=1,nl
      y(il,i)=0
   enddo
   go to 430
   ! test fails.  add point to stack and continue.
  410 continue
   i=i+1
   x(i)=x(i-1)
   x(i-1)=xm
   do il=1,nl
      y(il,i)=y(il,i-1)
      y(il,i-1)=yt(il)
   enddo
   go to 330
   ! linearization complete.  write out result.
  430 continue
   j=j+1
   xsi(ie)=xsi(ie)+(x(i)-xlast)*(y(1,i)+ylast)*half
   uu=0
   u2=0
   u3=0
   ubar(ie)=ubar(ie)+half*(x(i)-xlast)*(uu+ulast)
   p2(ie)=p2(ie)+half*(x(i)-xlast)*(u2+u2last)
   p3(ie)=p3(ie)+half*(x(i)-xlast)*(u3+u3last)
   xsi(ie)=sigfig(xsi(ie),9,0)
   scr(7+(nl+1)*(j-1))=x(i)
   jscr=7+(j-1)*(nl+1)
   if (y(1,i).ge.em9) then
      scr(1+jscr)=sigfig(y(1,i),9,0)
   else
      scr(1+jscr)=sigfig(y(1,i),8,0)
   endif
   do il=2,nl
      scr(il+jscr)=sigfig(y(il,i),9,0)
      if (scr(il+jscr).gt.unity) then
         !--only warn for big miss, but always fix the overflow
         if (scr(il+jscr).gt.unity+0.0005_kr) then
            write(strng,'("2cos",f7.4,", set to 1.&
                          &  enow,e''=",2(1pe12.5))')&
                            scr(il+jscr),enow,scr(jscr)
            call mess('calcem',strng,'')
         endif
         scr(il+jscr)=unity
      endif
      if (scr(il+jscr).lt.-unity) then
         !--only warn for big miss, but always fix the underflow
         if (scr(il+jscr).lt.-(unity+0.0005_kr)) then
            write(strng,'("2cos",f7.4,", set to -1.&
                          &  enow,e''=",2(1pe12.5),i3)')&
                            scr(il+jscr),enow,scr(jscr)
            call mess('calcem',strng,'')
         endif
         scr(il+jscr)=-unity
      endif
   enddo
   if (y(1,1).ne.zero) jnz=j
   if (jnz.lt.j) j=jnz+1
   if (iprint.eq.2) then
      ubar(ie)=ubar(ie)/xsi(ie)
      p2(ie)=p2(ie)/xsi(ie)
      p3(ie)=p3(ie)/xsi(ie)
      write(nsyso,'(/,1x,"incident energy =",1pe13.6,&
                   &  5x,"cross section =",1pe13.6,&
                   &  5x,"mubar,p2,p3 =",3(1pe12.4))')&
                          enow,xsi(ie),ubar(ie),p2(ie),p3(ie)
      write(nsyso,'(/,5x,"exit energy",11x,"pdf",7x,"cosines")')
      write(nsyso,'(  3x,"---------------",5x,"-----------",2x,88("-"))')
      ll=6
      do jj=1,j
         write(nsyso,'(2x,1pe15.8,5x,1pe12.5,0p,8f11.6)')&
           (scr(ll+ii),ii=1,nlp)
         if (nl1.gt.nlp) write(nsyso,'(34x,8f11.6)')&
           (scr(ll+ii),ii=nlp1,nl1)
         ll=ll+nl1
      enddo
   endif
   scr(1)=0
   scr(2)=enow
   scr(3)=0
   scr(4)=0
   scr(5)=(nl+1)*j
   scr(6)=nl+1
   ncds=ncds+1+(j*(nl+1)+5)/6
   call listio(0,0,nscr,scr,nb,nw)
   loc=1
   do while (nb.ne.0)
      loc=loc+nw
      call moreio(0,0,nscr,scr(loc),nb,nw)
   enddo
   if (ie.lt.nne) go to 310
   go to 610

   !--compute kernel and write in mf6/law7 angle-energy format
 510 continue
   ltt=4
   math=matdp
   mfh=6
   mth=mtref
   tev=t*bk
   teff=teff*bk
   teff2=teff2*bk
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=ltt ! temporary flag for this format
   scr(5)=1
   scr(6)=0
   call contio(0,0,nscr,scr,nb,nw)
   ncds=ncds+1
   scr(1)=1
   scr(2)=1
   scr(3)=0
   scr(4)=7
   scr(5)=1
   scr(6)=2
   scr(7)=2
   scr(8)=2
   scr(9)=1.e-5_kr
   scr(10)=1
   scr(11)=emax
   scr(12)=1
   nw=12
   call tab1io(0,0,nscr,scr,nb,nw)
   ncds=ncds+2
   scr(1)=0
   scr(2)=0
   scr(3)=0
   scr(4)=0
   scr(5)=1
   scr(6)=nne
   scr(7)=nne
   scr(8)=2
   nw=8
   call tab2io(0,0,nscr,scr,nb,nw)
   ncds=ncds+2
   cliq=0
   if (iinc.eq.1) go to 515
   if (sab(1,1).gt.sab(2,1))&
     cliq=(sab(1,1)-sab(1,2))*alpha(1)/beta(2)**2

   !--loop over given incident energy grid.
   !--the first pass computes the cross section and mu grid
  515 continue
   ie=0
  520 continue
   ie=ie+1
   enow=egrid(ie)
   if (ie.gt.1.and.temp.gt.break) enow=enow*temp/break
   enow=sigfig(enow,8,0)
   esi(ie)=enow
   j=0
   sum=0

   !--adaptive reconstruction of angular cross section
   u=-1
   x(2)=u
   call sigu(enow,u,tev,nalpha,alpha,nbeta,beta,sab,yu,nemax,tol)
   yy(2)=yu(1)
   xl=x(2)
   yl=yy(2)
   u=1
   x(1)=u
   call sigu(enow,u,tev,nalpha,alpha,nbeta,beta,sab,yu,nemax,tol)
   yy(1)=yu(1)
   i=2

   !--adaptive reconstruction
 530 continue
   if (i.eq.imax) go to 560
   xm=half*(x(i-1)+x(i))
   xm=sigfig(xm,7,0)
   if (xm.le.x(i).or.xm.ge.x(i-1)) go to 560
   call sigu(enow,xm,tev,nalpha,alpha,nbeta,beta,sab,yu,nemax,tol)
   if (x(i-1)-x(i).gt..25) go to 575
   ym=yy(i)+(xm-x(i))*(yy(i-1)-yy(i))/(x(i-1)-x(i))
   if (abs(yu(1)-ym).gt.2*tol*ym+tolmin) go to 575
   ! point passes.  save top point in stack and continue.
  560 continue
   j=j+1
   if (j.gt.mumax-1) call error('calcem','too many angles','see mumax')
   uj(j)=x(i)
   sj(j)=yy(i)
   if (j.gt.1) then
      sum=sum+half*(yy(i)+yl)*(x(i)-xl)
      xl=x(i)
      yl=yy(i)
   endif
   i=i-1
   if (i.ge.2) go to 530
   go to 580
   ! test fails.  add point to stack and continue.
  575 continue
   i=i+1
   x(i)=x(i-1)
   x(i-1)=xm
   yy(i)=yy(i-1)
   yy(i-1)=yu(1)
   go to 530
   ! linearization complete.  write out result.
  580 continue
   j=j+1
   uj(j)=x(1)
   sj(j)=yy(1)
   nmu=j
   ubar(ie)=0
   sum=sum+half*(yy(1)+yl)*(x(1)-xl)
   xsi(ie)=sum/2
   do i=2,nmu
      ubar(ie)=ubar(ie)+half*(uj(i)-uj(i-1))*(sj(i)+sj(i-1))*(uj(i)+uj(i-1))
   enddo
   ubar(ie)=half*ubar(ie)/sum
   if (iprint.eq.2) then
      write(nsyso,'(/i5,'' enow '',1p,e13.6,''   xsec '',e13.6,&
        &''   mubar  '',e13.6)') ie,enow,xsi(ie),ubar(ie)
      write(nsyso,'(''      num of mu '', i5)') nmu
      write(nsyso,'(/''            mu            theta      dsigma/dmu'')')
      do i=1,nmu
         write(nsyso,'(i5,1x,f15.8,1x,f12.4,1x,1p,e14.7)') i,uj(i),&
           acos(uj(i))*180.0/pi,sj(i)/2.0
      enddo
   endif

   !--now loop through the mu grid to write out the distributions
   mth=mtref
   scr(1)=0
   scr(2)=enow
   scr(3)=0
   scr(4)=0
   scr(5)=1
   scr(6)=nmu
   scr(7)=nmu
   scr(8)=2
   nw=8
   call tab2io(0,0,nscr,scr,nb,nw)
   ncds=ncds+1
   do il=1,nmu
      u=uj(il)
      call sigu(enow,u,tev,nalpha,alpha,nbeta,beta,sab,yu,nemax,tol)
      nep=nint(yu(2))
      j=0
      do i=1,nep
        j=nep-i
        if (yu(2*(nep-i)+4)/sum.gt.yumin) exit
      enddo
      nep=j
     if (iprint.eq.2) then
         write(nsyso,'(/'' mu = '',f15.8)') u
         write(nsyso,'('' (e-prime, pdf);  num of e-prime '', i5)') nep
         write(nsyso,*)
         !--test yu()/sum below: is this pdf normalized to 1.0 ?
         write(nsyso,'(1p,3(1x,e14.7,1x,e14.7,1x))')&
               (yu(2*i+1),yu(2*i+2)/sum,i=1,nep)
      endif
      scr(1)=0
      scr(2)=u
      scr(3)=0
      scr(4)=0
      scr(5)=1
      scr(6)=nep
      scr(7)=nep
      scr(8)=2
      k=8
      istart=1
     595 continue
      iend=nep
      if ((iend-istart).ge.npage/2) iend=istart+npage/2-1
      j=k-1
      ib=istart-1
     596 continue
      j=j+2
      ib=ib+1
      scr(j)=yu(1+2*ib)
      scr(j+1)=yu(2+2*ib)*2/sum
      if (ib.lt.iend) go to 596
      nw=j+1
      if (k.eq.0) go to 597
      k=0
      call tab1io(0,0,nscr,scr,nb,nw)
      if (nb.eq.0) go to 598
      istart=iend+1
      go to 595
    597 continue
      call moreio(0,0,nscr,scr,nb,nw)
      if (nb.eq.0) go to 598
      istart=iend+1
      go to 595
     598 continue
      ncds=ncds+1+(j*(nep+1)+5)/6
   enddo

   if (ie.lt.nne) go to 520

   !--calculate incoherent inelastic scattering cross sections
 610 continue
   do ie=1,20
      ex(ie)=0
   enddo
   nexn=nex
   if (nex.eq.2) nexn=3
   ie=0
   ien=1
   do while (ien.gt.0)
      ie=ie+1
      call finda(ie,ex,nex,iold,bufo,nbuf)
      if (iinc.eq.1) then
         ! use elastic cross section  for free atom scattering.
         ex(3)=ex(2)
      else
         ! use computed cross section for bound atoms.
         enow=ex(1)
         xs=terp(esi,xsi,nne,enow,nlt)
         if (ie.eq.ne) xs=0
         ex(3)=xs
      endif
      ien=ie
      if (ie.eq.ne) ien=-ien
      call loada(ien,ex,nexn,inew,bufn,nbuf)
   enddo
   esi(nne+1)=0
   isave=iold
   iold=inew
   inew=isave
   nex=nexn
   if (ie.eq.ne) xs=0

   !--calcem is finished.
   call asend(0,nscr)
   deallocate(alpha)
   deallocate(beta)
   deallocate(sab)
   return
   end subroutine calcem

   real(kr) function sig(e,ep,u,tev,nalpha,alpha,nbeta,beta,sab)
   !-------------------------------------------------------------------
   ! Compute the differential scattering cross section from e to
   ! ep through the angle with the cosine u from endf tabulated
   ! data or an analytic law.
   !-------------------------------------------------------------------
   use physics ! provides pi
   use util    ! provides error
   ! externals
   integer::nalpha,nbeta
   real(kr)::e,ep,u,tev,bbm
   real(kr)::alpha(nalpha),beta(nbeta),sab(nalpha,nbeta)
   ! internals
   integer::nb1,na1,i,ib,ia
   real(kr)::rtev,bb,a,sigc,b,c,bbb,s,s1,s2,s3,arg
   real(kr)::tfff,tfff2
   real(kr),parameter::sigmin=1.e-10_kr
   real(kr),parameter::sabflg=-225.e0_kr
   real(kr),parameter::amin=1.e-6_kr
   real(kr),parameter::test1=0.2e0_kr
   real(kr),parameter::test2=30.e0_kr
   real(kr),parameter::zero=0

   !--common factors.
   rtev=1/tev
   bb=(ep-e)*rtev
   a=(e+ep-2*u*sqrt(e*ep))/(az*tev)
   if (a.lt.amin) a=amin
   sigc=sqrt(ep/e)*rtev/2
   b=abs(bb)
   c=sqrt(4*pi)

   !--tabulated s(alpha,beta).
   if (iinc.ne.2) go to 200
   if (lat.eq.1) b=b*tev/tevz
   if (lat.eq.1) a=a*tev/tevz
   if (a.gt.alpha(nalpha)) go to 170
   if (lasym.eq.1) then
      bbm=bb
      if (lat.eq.1) bbm=bb*tev/tevz
      if (bbm.gt.beta(nbeta)) go to 170
      if (bbm.lt.beta(1)) go to 170
   else
      if (b.gt.beta(nbeta)) go to 170
   endif
   nb1=nbeta-1
   na1=nalpha-1
   bbb=b
   if (lasym.eq.1.and.bb.lt.zero) bbb=-b
   do i=1,nb1
      ib=i
      if (bbb.lt.beta(i+1)) exit
   enddo
   do i=1,na1
      ia=i
      if (a.lt.alpha(i+1)) exit
   enddo
   if (cliq.eq.zero.or.a.ge.alpha(1)) go to 150
   if (lasym.eq.1) go to 150
   if (b.gt.test1) go to 150
   s=sab(1,1)+log(alpha(1)/a)/2-cliq*b**2/a
   if (s.lt.sabflg) s=sabflg
   go to 160
  150 continue
   if (a*az.lt.test2.and.b.lt.test2) go to 155
   if (sab(ia,ib).le.sabflg) go to 170
   if (sab(ia+1,ib).le.sabflg) go to 170
   if (sab(ia,ib+1).le.sabflg) go to 170
   if (sab(ia+1,ib+1).le.sabflg) go to 170
  155 continue
   if (ia+1.eq.nalpha) ia=ia-1
   if (ib+1.eq.nbeta) ib=ib-1
   call terpq(alpha(ia),sab(ia,ib),alpha(ia+1),sab(ia+1,ib),&
     alpha(ia+2),sab(ia+2,ib),a,s1)
   call terpq(alpha(ia),sab(ia,ib+1),alpha(ia+1),sab(ia+1,ib+1),&
     alpha(ia+2),sab(ia+2,ib+1),a,s2)
   call terpq(alpha(ia),sab(ia,ib+2),alpha(ia+1),sab(ia+1,ib+2),&
     alpha(ia+2),sab(ia+2,ib+2),a,s3)
   call terpq(beta(ib),s1,beta(ib+1),s2,beta(ib+2),s3,bbb,s)
  160 continue
   sig=0
   if (s-bb/2.gt.sabflg) sig=exp(s-bb/2)
   sig=sigc*sb*sig
   if (sig.lt.sigmin) sig=0
   return

   !--short collision time for large beta or alpha
  170 continue
   if (lat.eq.1) b=b*tevz*rtev
   if (lat.eq.1) a=a*tevz*rtev
   tfff=teff
   tfff2=teff2
   !if (az.lt.3) then
   !   if (e.gt.10) then
   !      tfff=tev
   !      tfff2=tev
   !   else if (e.gt.2) then
   !      rat=(e-2)/8
   !      tfff= (1-rat)*teff+rat*tev
   !      tfff2= (1-rat)*teff2+rat*tev
   !   endif
   !endif
   s=0
   arg=(a-b)**2*tev/(4*a*tfff)+(b+bb)/2
   if (-arg.gt.sabflg) s=exp(-arg)/(c*sqrt(a*tfff*rtev))
   sig=sigc*sb*s
   if (sb2.gt.zero) then
      a=a*az/az2
      arg=(a-b)**2*tev/(4*a*tfff2)+(b+bb)/2
      s2=0
      if (-arg.gt.sabflg) s2=exp(-arg)/(c*sqrt(a*tfff2*rtev))
      sig=sig+sigc*sb2*s2
   endif
    if (abs(e-10).lt..01.and.abs(u-.99219).lt..0001) then
    endif
   if (sig.lt.sigmin) sig=0
   return

   !--free-gas scattering.
  200 continue
   if (iinc.ne.1) go to 300
   s=0
   arg=(a+bb)**2/(4*a)
   if (-arg.gt.sabflg) s=exp(-arg)/(c*sqrt(a))
   sig=sigc*sb*s
   if (sig.lt.sigmin) sig=0
   return

   !--other options not yet implemented.
  300 continue
   call error('sig','illegal option.',' ')
   sig=0
   return
   end function sig

   subroutine terpq(x1,y1,x2,y2,x3,y3,x,y)
   !-------------------------------------------------------------------
   ! Compute y(x) by quadratic interpolation,
   ! except use log-lin if x.lt.x1 and lin-lin if x.gt.x3.
   ! and use lin-lin if the function takes big steps (corners).
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   real(kr)::x1,y1,x2,y2,x3,y3,x,y
   ! internals
   real(kr)::b,c
   real(kr),parameter::sabflg=-225.e0_kr
   real(kr),parameter::step=2.e0_kr

   if (x.lt.x1) then
      if (y1.gt.y2) then
         y=y1
      else
         call terp1(x1,y1,x2,y2,x,y,3)
      endif
   else if (x.gt.x3) then
      if (y3.gt.y2) then
         y=y3
      else
         call terp1(x2,y2,x3,y3,x,y,2)
      endif
   else if (abs(y1-y2).gt.step.or.abs(y2-y3).gt.step) then
      if (x.lt.x2) then
         call terp1(x1,y1,x2,y2,x,y,2)
      else
         call terp1(x2,y2,x3,y3,x,y,2)
      endif
   else
      b=(y2-y1)*(x3-x1)/((x2-x1)*(x3-x2))
      b=b-(y3-y1)*(x2-x1)/((x3-x1)*(x3-x2))
      c=(y3-y1)/((x3-x1)*(x3-x2))
      c=c-(y2-y1)/((x2-x1)*(x3-x2))
      y=y1+b*(x-x1)+c*(x-x1)*(x-x1)
   endif
   if (y.lt.sabflg) y=sabflg
   return
   end subroutine terpq

   subroutine sigl(e,ep,nlin,tev,nalpha,alpha,nbeta,beta,sab,&
     s,nlmax,tolin)
   !-------------------------------------------------------------------
   ! Compute the cross section and legendre components or equally-
   ! probable angles for the scattering from e to ep.  Uses linear
   ! reconstruction of the angular distribution computed by sig.
   !-------------------------------------------------------------------
   use util  ! provides error,mess
   use mathm ! provide legndr
   ! externals
   integer::nlin,nalpha,nbeta,nlmax
   real(kr)::e,ep,tev,alpha(nalpha),beta(nbeta),sab(nalpha,nbeta)
   real(kr)::s(nlmax),tolin
   ! internals
   integer::nl,i,j,il
   real(kr)::b,seep,sum,xl,yl,ymax,xm,ym,test,test2
   real(kr)::rnbin,fract,gral,add,xil,xn,f,rf,disc,yn,xbar,rfract
   real(kr)::yt,tol,s1bb
   integer,parameter::imax=20
   real(kr)::x(imax),y(imax)
   real(kr)::p(nlin)
   character(60)::strng
   real(kr),parameter::zero=0
   real(kr),parameter::xtol=.00001e0_kr
   real(kr),parameter::ytol=.001e0_kr
   real(kr)::one=1
   real(kr),parameter::half=.5e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::sigmin=1.e-32_kr
   real(kr),parameter::eps=1.e-3_kr
   real(kr),parameter::shade=.99999999e0_kr

   !--constant factors
   b=(ep-e)/tev
   tol=half*tolin
   nl=nlin
   if (nl.lt.0) nl=-nl
   b=abs(b)
   if (lat.eq.1.and.iinc.eq.2) b=b*tev/tevz
   s1bb=sqrt(1+b*b)
   if (ep.ne.zero) seep=1/sqrt(e*ep)

   !--adaptive calculation of cross section
   i=3
   sum=0
   x(3)=-1
   xl=x(3)
   y(3)=sig(e,ep,x(3),tev,nalpha,alpha,nbeta,beta,sab)
   yl=y(3)
   if (ep.eq.zero) x(2)=0
   if (ep.ne.zero) x(2)=half*(e+ep-(s1bb-1)*az*tev)*seep
   if (abs(x(2)).gt.1-eps) x(2)=0.99e0_kr
   x(2)=sigfig(x(2),8,0)
   y(2)=sig(e,ep,x(2),tev,nalpha,alpha,nbeta,beta,sab)
   x(1)=+1
   y(1)=sig(e,ep,x(1),tev,nalpha,alpha,nbeta,beta,sab)
   ymax=y(2)
   if (y(1).gt.ymax) ymax=y(1)
   if (y(3).gt.ymax) ymax=y(3)
   if (ymax.lt.eps) ymax=eps
  110 continue
   if (i.eq.imax) go to 120
   xm=half*(x(i-1)+x(i))
   xm=sigfig(xm,8,0)
   ym=half*(y(i-1)+y(i))
   yt=sig(e,ep,xm,tev,nalpha,alpha,nbeta,beta,sab)
   test=tol*abs(yt)+tol*ymax/50
   test2=ym+ymax/100
   if (abs(yt-ym).le.test.and.abs(y(i-1)-y(i)).le.test2.and.&
     (x(i-1)-x(i)).lt.half) go to 120
   if (x(i-1)-x(i).lt.xtol) go to 120
   i=i+1
   x(i)=x(i-1)
   y(i)=y(i-1)
   x(i-1)=xm
   y(i-1)=yt
   go to 110
  120 continue
   sum=sum+half*(y(i)+yl)*(x(i)-xl)
   xl=x(i)
   yl=y(i)
   i=i-1
   if (i.gt.1) go to 110
   if (i.eq.1) go to 120
   s(1)=sum
   if (sum.gt.sigmin) go to 130
   do il=1,nl
      s(il)=0
   enddo
   return

   !--prime stack for equally-probable angles
  130 continue
   nbin=nl-1
   rnbin=one/nbin
   fract=sum*rnbin
   rfract=1/fract
   sum=0
   gral=0
   do il=2,nl
      s(il)=0
   enddo
   j=0

   !--adaptive linearization
   i=3
   x(3)=-1
   xl=x(3)
   y(3)=sig(e,ep,x(3),tev,nalpha,alpha,nbeta,beta,sab)
   if (ep.eq.zero) x(2)=0
   if (ep.ne.zero) x(2)=half*(e+ep-(s1bb-1)*az*tev)*seep
   if (abs(x(2)).gt.1-eps) x(2)=0.99e0_kr
   x(2)=sigfig(x(2),8,0)
   y(2)=sig(e,ep,x(2),tev,nalpha,alpha,nbeta,beta,sab)
   x(1)=+1
   y(1)=sig(e,ep,x(1),tev,nalpha,alpha,nbeta,beta,sab)
   ymax=y(1)
   if (y(2).gt.ymax) ymax=y(2)
   if (y(3).gt.ymax) ymax=y(3)
   if (ymax.lt.eps) ymax=eps
  150 continue
   if (i.eq.imax) go to 160
   xm=half*(x(i-1)+x(i))
   xm=sigfig(xm,8,0)
   ym=half*(y(i-1)+y(i))
   yt=sig(e,ep,xm,tev,nalpha,alpha,nbeta,beta,sab)
   test=tol*abs(yt)+tol*ymax/50
   test2=ym+ymax/100
   if (abs(yt-ym).le.test.and.abs(y(i-1)-y(i)).le.test2.and.&
     (x(i-1)-x(i)).lt.half) go to 160
   if (x(i-1)-x(i).lt.xtol) go to 160
   i=i+1
   x(i)=x(i-1)
   y(i)=y(i-1)
   x(i-1)=xm
   y(i-1)=yt
   go to 150

   !--check bins for this panel
  160 continue
   add=half*(y(i)+yl)*(x(i)-xl)
   if (x(i).eq.xl) go to 250
   xil=1/(x(i)-xl)
   if (i.eq.1.and.j.eq.nbin-1) go to 165
   if (sum+add.ge.fract*shade.and.j.lt.nbin-1) go to 170
   sum=sum+add
   gral=gral+half*(yl*x(i)-y(i)*xl)*(x(i)+xl)&
     +third*(y(i)-yl)*(x(i)**2+x(i)*xl+xl**2)
   go to 250
  165 continue
   xn=x(i)
   j=j+1
   go to 190
  170 continue
   j=j+1
   if (yl.lt.sigmin) go to 175
   test=(fract-sum)*(y(i)-yl)/((x(i)-xl)*yl**2)
   if (abs(test).gt.ytol) go to 175
   xn=xl+(fract-sum)/yl
   if (xn.gt.x(i)) go to 180
   if (xn.ge.xl.and.xn.le.x(i)) go to 190
   call error('sigl','no legal solution.',' ')
  175 continue
   f=(y(i)-yl)*xil
   rf=1/f
   disc=(yl*rf)**2+2*(fract-sum)*rf
   if (disc.lt.zero) then
      write(strng,'(''disc='',1p,e12.4)') disc
      call mess('sigl',strng,'set to abs value and continue')
      disc=abs(disc)
   endif
   if (f.gt.zero) xn=xl-(yl*rf)+sqrt(disc)
   if (f.lt.zero) xn=xl-(yl*rf)-sqrt(disc)
   if (xn.gt.xl.and.xn.le.x(i)) go to 190
   if (xn.gt.xl.and.xn.lt.(x(i)+ytol*(x(i)-xl))) go to 180
   call error('sigl','no legal solution (quadratic path).',' ')
  180 continue
   xn=x(i)
  190 continue
   yn=yl+(y(i)-yl)*(xn-xl)*xil
   gral=gral+(xn-xl)*(yl*half*(xn+xl)&
     +(y(i)-yl)*xil*(-xl*half*(xn+xl)&
     +third*(xn**2+xn*xl+xl**2)))
   xbar=gral*rfract

   !--compute legendre components
   if (nlin.ge.0) then
      call legndr(xbar,p,nl)
      do il=2,nl
         s(il)=s(il)+p(il)*rnbin
      enddo

   !--output equally probable angles
   else
      s(j+1)=xbar
   endif

   !--continue bin loop and linearization loop
   xl=xn
   yl=yn
   sum=0
   gral=0
   if (j.eq.nbin) go to 260
   if (xl.lt.x(i)) go to 160
  250 continue
   xl=x(i)
   yl=y(i)
   i=i-1
   if (i.gt.1) go to 150
   if (i.eq.1) go to 160
  260 continue
   return
   end subroutine sigl

   subroutine sigu(e,u,tev,nalpha,alpha,nbeta,beta,sab,&
     s,nemax,tolin)
   !-------------------------------------------------------------------
   ! Compute the secondary energy distribution scattering for cosine u.
   ! Uses linear reconstruction with the cross section from function sig.
   !-------------------------------------------------------------------
   use util ! provides sigfig
   ! externals
   integer::nalpha,nbeta,nemax
   real(kr)::e,u,tev,alpha(nalpha),beta(nbeta),sab(nalpha,nbeta)
   real(kr)::s(2*nemax),tolin
   ! internals
   integer::i,j,jbeta
   real(kr)::sum,xl,yl,xm,ym,test
   real(kr)::yt,tol
   real(kr)::root1,root2
   integer,parameter::imax=20
   real(kr)::x(imax),y(imax)
   real(kr),parameter::zero=0
   real(kr),parameter::half=.5e0_kr
   real(kr),parameter::tolmin=1.e-6_kr
   real(kr),parameter::bmax=20

   !--constant factors
   tol=tolin
   do i=1,2*nemax
      s(i)=0
   enddo

   root1=(u*sqrt(e)+sqrt(u*u*e+(az-1)*(az+1)*e))/(az+1)
   root2=(u*sqrt(e)-sqrt(u*u*e+(az-1)*(az+1)*e))/(az+1)

   !--adaptive calculation of cross section
   sum=0
   x(1)=0
   y(1)=sig(e,x(1),u,tev,nalpha,alpha,nbeta,beta,sab)
   jbeta=-nbeta
   if (lasym.gt.0) jbeta=1
   j=0
   xl=0
   yl=0

   !--set up next panel
  111 continue
   x(2)=x(1)
   y(2)=y(1)
  113 continue
   if (jbeta.eq.0) jbeta=1
   if (jbeta.le.0) then
      if (lat.eq.1) then
         x(1)=e-beta(-jbeta)*tevz
      else
         x(1)=e-beta(-jbeta)*tev
      endif
      x(1)=sigfig(x(1),8,0)
      if (x(1).eq.e) x(1)=sigfig(e,8,-1)
   else
      if (lat.eq.1) then
         x(1)=e+beta(jbeta)*tevz
      else
         x(1)=e+beta(jbeta)*tev
      endif
   endif
   if (x(1).gt.x(2)) go to 116
   jbeta=jbeta+1
   go to 113
  116 continue
   if (u.lt.zero.and.root1**2.gt.1.01*x(2).and.root1**2.lt.x(1)) then
      x(1)=root1**2
   endif
   x(1)=sigfig(x(1),8,0)
   y(1)=sig(e,x(1),u,tev,nalpha,alpha,nbeta,beta,sab)
   i=2

   !--compare linear approximation to true function
  150 continue
   if (i.eq.imax) go to 160
   if (i.gt.3.and.half*(y(i-1)+y(i))*(x(i-1)-x(i)).lt.tolmin) go to 160
   xm=half*(x(i-1)+x(i))
   xm=sigfig(xm,8,0)
   if (xm.le.x(i).or.xm.ge.x(i-1)) go to 160
   ym=half*(y(i-1)+y(i))
   yt=sig(e,xm,u,tev,nalpha,alpha,nbeta,beta,sab)
    if (abs(u-.99219).lt..0001) then
       if (abs(e-10).lt..01) then
       endif
    endif
   test=tol*abs(yt)
   if (abs(yt-ym).le.test) go to 160

   !--point fails
   i=i+1
   x(i)=x(i-1)
   y(i)=y(i-1)
   x(i-1)=xm
   y(i-1)=yt
   go to 150

   !--point passes
  160 continue
   j=j+1
   s(2*j+1)=x(i)
   s(2*j+2)=y(i)
   if (j.gt.1) sum=sum+(y(i)+yl)*(x(i)-xl)
   xl=x(i)
   yl=y(i)
   if (j.ge.nemax-1) go to 170
   if (jbeta.gt.0) then
     if (beta(jbeta).gt.bmax) go to 170
   endif

   !--continue bin loop and linearization loop
   i=i-1
   if (i.gt.1) go to 150
   jbeta=jbeta+1
   if (jbeta.le.nbeta) go to 111
   if (i.eq.1) go to 160
  170 continue
   s(1)=sum
   s(2)=j

   return
   end subroutine sigu

   subroutine tpend(iold,itemp,ne,nex,icoh,icopy,mtref)
   !-------------------------------------------------------------------
   ! Write the output pendf tape.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use endf   ! provides endf routines and variables
   use util   ! provides repoz,error,finda,timer,sigfig
   ! externals
   integer::iold,itemp,ne,nex,icoh,icopy,mtref
   ! internals
   integer::i,matd,jcopy,n6,iverp,mf2,mfd,mtd
   integer::lim,ix,j,mti,mfi,mf,mt,mfn,mtn,mat
   integer::istart,iend,k,ib,ifend,ie,ltt
   integer::nb,nw,indx,nx,nc,nxn,nne,nl1,nmu,imu
   real(kr)::temp,rxsec,yy,sec
   real(kr)::ex(20)
   real(kr),dimension(:),allocatable::dico,dicn,sav
   real(kr),parameter::em9=1.e-9_kr
   real(kr),parameter::etop=20.e6_kr
   real(kr),parameter::zero=0
   integer,parameter::nwscr=500000

   !--initialize.
   temp=tempr(itemp)
   do i=1,20
      ex(i)=0
   enddo
   matd=matdp
   call repoz(nscr)
   call repoz(nscr2)
   jcopy=0

   !--copy skipped temperatures, if any.
   if (icopy.gt.0) then
      do while (jcopy.lt.icopy)
         call contio(nscr2,nout,0,scr,nb,nw)
         call tomend(nscr2,nout,0,scr)
         jcopy=jcopy+1
      enddo
      icopy=0
   endif

   !--update directory
   call findf(matd,1,451,nin)
   indx=1
   call contio(nin,0,0,scr(indx),nb,nw)
   n6=n2h
   call contio(nin,0,0,scr(indx+6),nb,nw)
   if (n1h.ne.0) then
      iverp=4
      nx=n6
   else if (n2h.eq.0) then
      iverp=5
   else
      iverp=6
   endif
   call skiprz(nin,-1)
   indx=indx+nw
   if (iverp.ge.5) call contio(nin,0,0,scr(indx),nb,nw)
   if (iverp.ge.5) indx=indx+nw
   if (iverp.ge.6) call contio(nin,0,0,scr(indx),nb,nw)
   if (iverp.ge.6) indx=indx+nw
   call hdatio(nin,0,0,scr(indx),nb,nw)
   scr(indx)=temp
   if (iverp.ge.5) nx=nint(scr(indx+5))
   indx=indx+nw
   do while (nb.ne.0)
      if (indx.gt.nwscr) call error('tpend','storage exceeded.',' ')
      call moreio(nin,0,0,scr(indx),nb,nw)
      indx=indx+nw
   enddo
   nw=6*nx
   allocate(dico(nw))
   nw=6*nx
   if (iinc.gt.0) nw=nw+12
   if (icoh.gt.0) nw=nw+12
   if (icoh.gt.20) nw=nw+12
   allocate(dicn(nw))
   allocate(sav(6))
   nc=nx
   call dictio(nin,0,0,dico,nb,nc)
   do i=1,nw
      dicn(i)=0
   enddo
   mf2=0
   mfd=3
   mtd=mtref
   lim=6*(nx-1)
   ix=3
   nc=3+(ne+2)/3
   i=0
   j=0
  172 continue
   mti=0
   if (i.gt.lim) go to 176
   mfi=nint(dico(i+3))
   if (mfi.eq.2) mf2=1
   mti=nint(dico(i+4))
  173 continue
   if (mfi.gt.mfd) go to 176
   if (mfi.eq.mfd.and.mti.ge.mtd) go to 176
  174 continue
   dicn(j+3)=dico(i+3)
   dicn(j+4)=dico(i+4)
   dicn(j+5)=dico(i+5)
   i=i+6
   j=j+6
   go to 172
  176 continue
   if (mfd.gt.6) go to 190
   dicn(j+3)=mfd
   dicn(j+4)=mtd
   dicn(j+5)=nc
   j=j+6
   if (mtd.eq.mti) then
      i=i+6
      mfi=nint(dico(i+3))
      mti=nint(dico(i+4))
   endif
   if (ix.eq.nex) go to 180
   ix=ix+1
   mtd=mtd+1
   if (mfd.eq.6) nc=ncdse
   go to 176
  180 continue
   if (mfd.eq.6) go to 184
   if (iinc.eq.0) go to 184
   nc=ncds
   ix=3
   mfd=6
   mtd=mtref
   if (i.gt.lim) go to 176
   go to 173
  184 continue
   mfd=1000
   if (mtd.eq.mti) i=i+6
   if (i.le.lim) go to 174
  190 continue
   nxn=j/6
   mf=1
   mt=451
   if (iverp.lt.5) scr(6)=nxn
   call contio(0,nout,0,scr,nb,nw)
   indx=1+nw
   if (iverp.ge.5) call contio(0,nout,0,scr(indx),nb,nw)
   if (iverp.ge.5) indx=indx+nw
   if (iverp.ge.6) call contio(0,nout,0,scr(indx),nb,nw)
   if (iverp.ge.6) indx=indx+nw
   if (iverp.ge.5) scr(indx+5)=nxn
   call hdatio(0,nout,0,scr(indx),nb,nw)
   indx=indx+nw
   do while (nb.ne.0)
      if (indx.gt.1+nwscr-1)&
        call error('tpend','storage exceeded.',' ')
      call moreio(0,nout,0,scr(indx),nb,nw)
      indx=indx+nw
   enddo
   dicn(5)=dico(5)+nxn-nx
   call dictio(0,nout,0,dicn,nb,nxn)
   call tofend(nin,nout,0,scr)
   if (mf2.eq.1) call tofend(nin,nout,0,scr)

   !--copy rest of this mat and temperature from nin to nout,
   !--adding thermal scattering and matrix to nout.
   mfn=3
   mtn=mtref
  200 continue
   call contio(nin,0,0,sav,nb,nw)
   mat=math
   mf=mfh
   mt=mth
   if (math.ne.matd) go to 210
   if (mfh.eq.0) go to 200
   if (mfh.gt.mfn) go to 210
   if (mfh.eq.mfn.and.mth.ge.mtn) go to 210
   math=mat
   mfh=mf
   mth=mt
   call contio(0,nout,0,sav,nb,nw)
   call tosend(nin,nout,0,scr)
   go to 200

   !--file 3.
  210 continue
   ix=2
  215 continue
   ix=ix+1
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=0
   scr(5)=0
   scr(6)=0
   math=matd
   mfh=3
   mth=mtn
   call contio(0,nout,0,scr,nb,nw)
   scr(1)=temp
   scr(2)=0
   scr(5)=1
   scr(6)=ne+1
   scr(7)=ne+1
   scr(8)=2
   k=8
   istart=1
  220 continue
   iend=ne+1
   if ((iend-istart).ge.npage/2) iend=istart+npage/2-1
   j=k-1
   ib=istart-1
  222 continue
   j=j+2
   ib=ib+1
   if (ib.ge.ne+1) then
      ex(1)=etop
      ex(ix)=0
   else
      call finda(ib,ex,nex,iold,bufo,nbuf)
   endif
   scr(j)=sigfig(ex(1),7,0)
   if (ex(ix).ge.em9) then
      scr(j+1)=sigfig(ex(ix),7,0)
   else
      scr(j+1)=sigfig(ex(ix),6,0)
   endif
   if (ib.lt.iend) go to 222
   nw=j+1
   if (k.eq.0) go to 224
   k=0
   call tab1io(0,nout,0,scr,nb,nw)
   if (nb.eq.0) go to 230
   istart=iend+1
   go to 220
  224 continue
   call moreio(0,nout,0,scr,nb,nw)
   if (nb.eq.0) go to 230
   istart=iend+1
   go to 220
  230 continue
   call asend(nout,0)
   if (mf.ne.mfn.or.mt.ne.mtn) go to 235
   call tosend(nin,0,0,scr)
   call contio(nin,0,0,sav,nb,nw)
   mat=math
   mf=mfh
   mt=mth
  235 continue
   if (ix.eq.nex) go to 240
   mtn=mtn+1
   go to 215
  240 continue
   if (mf.eq.3) go to 245
   call afend(nout,0)
   go to 250
  245 continue
   math=mat
   mfh=mf
   mth=mt
   call contio(0,nout,0,sav,nb,nw)
   call tofend(nin,nout,0,scr)
   call contio(nin,0,0,sav,nb,nw)
   mat=math
   mf=mfh
   mt=mth

   !--file 6
  250 continue
   if (iinc.eq.0.and.icoh.eq.0) go to 295
   ifend=0
   mfn=6
   mtn=mtref
   ix=2
  252 continue
   if (mf.eq.0) go to 254
   if (mf.gt.mfn) go to 254
   if (mf.eq.mfn.and.mt.ge.mtn) go to 254
   math=mat
   mfh=mf
   mth=mt
   call contio(0,nout,0,sav,nb,nw)
   call tosend(nin,nout,0,scr)
   call contio(nin,0,0,sav,nb,nw)
   ifend=0
   if (mfh.eq.0.and.mth.eq.0) ifend=1
   mat=math
   mf=mfh
   mt=mth
   go to 252
  254 continue
   ix=ix+1
   call contio(nscr,0,0,scr,nb,nw)
   ltt=nint(scr(4))
   scr(4)=1
   scr(5)=1
   call contio(0,nout,0,scr,nb,nw)
   if (ltt.eq.6) then
      call tab1io(nscr,nout,0,scr,nb,nw)
      call tab2io(nscr,nout,0,scr,nb,nw)
      nne=n2h
      do ie=1,nne
         call listio(nscr,0,0,scr,nb,nw)
         scr(8)=1
         call listio(0,nout,0,scr,nb,nw)
      enddo
   else if (ltt.eq.5) then
      call tab1io(nscr,nout,0,scr,nb,nw)
      call tab2io(nscr,nout,0,scr,nb,nw)
      nne=n2h
      do ie=1,nne
         if (xsi(ie).eq.zero)&
           call error('tpend','cross section=0.',' ')
         rxsec=1/xsi(ie)
         indx=1
         call listio(nscr,0,0,scr(indx),nb,nw)
         indx=indx+nw
         do while (nb.ne.0)
            if (indx.gt.nwscr)&
              call error('tpend','storage exceeded.',' ')
            call moreio(nscr,0,0,scr(indx),nb,nw)
            indx=indx+nw
         enddo
         nl1=nint(scr(6))
         j=nint(scr(5))/nl1
         indx=8-nl1
         do i=1,j
            yy=scr(nl1*i+indx)*rxsec
            if (yy.ge.em9) then
               scr(nl1*i+indx)=sigfig(yy,7,0)
            else
               scr(nl1*i+indx)=sigfig(yy,6,0)
            endif
         enddo
         indx=1
         call listio(0,nout,0,scr(indx),nb,nw)
         do while (nb.ne.0)
            indx=indx+nw
            call moreio(0,nout,0,scr(indx),nb,nw)
         enddo
      enddo
   else if (ltt.eq.4) then
      call tab1io(nscr,nout,0,scr,nb,nw)
      call tab2io(nscr,nout,0,scr,nb,nw)
      nne=n2h
      do ie=1,nne
         call tab2io(nscr,nout,0,scr,nb,nw)
         nmu=n2h
         do imu=1,nmu
            indx=1
            call tab1io(nscr,nout,0,scr,nb,nw)
            do while (nb.ne.0)
               indx=indx+nw
               call moreio(nscr,nout,0,scr(indx),nb,nw)
            enddo
         enddo
      enddo
   endif
   call tosend(nscr,nout,0,scr)
   if (mf.ne.mfn.and.ix.eq.nex.and.ifend.eq.0) call afend(nout,0)
   if (mf.ne.mfn.or.mt.ne.mtn) go to 290
   call tosend(nin,0,0,scr)
   call contio(nin,0,0,sav,nb,nw)
   mat=math
   mf=mfh
   mt=mth
  290 continue
   if (ix.eq.nex) go to 295
   mtn=mtn+1
   go to 254

   !--finished with this temperature
  295 continue
   math=mat
   mfh=mf
   mth=mt
   call contio(0,nout,0,sav,nb,nw)
   if (mat.ne.0) call tomend(nin,nout,0,scr)
   deallocate(dicn)
   deallocate(dico)
   deallocate(sav)
   call timer(sec)
   write(nsyso,'(/&
     &'' wrote thermal data for temp ='',1p,e11.4,28x,0p,f8.1,''s'')')&
     temp,sec
   write(nsyse,'(/&
     &'' wrote thermal data for temp ='',1p,e11.4,28x,0p,f8.1,''s'')')&
     temp,sec
   return
   end subroutine tpend

end module thermm

module purm
   ! provides subroutine purr for NJOY2016
   use locale
   implicit none
   private
   public purr

   ! units
   integer::nendf,nin,nout

   ! control parameters
   integer::init
   integer::nunr,lssf,iinel,iabso
   integer::iprint,nermax,nladr,nmode

   ! arrays for the w function
   real(kr)::tr(41,27),ti(41,27),trs(41,27),tis(41,27)

   ! arrays for unresolved resonance parameter sections
   integer::nsect
   integer::isot(20),modet(20),ibaset(20)
   real(kr)::abnt(20),elt(20),eht(20)

   ! resonance data
   integer::nseq0,nro,naps,intunr
   integer,parameter::mxns0=100
   real(kr)::e,cth(mxns0),csz(mxns0),cc2p(mxns0),cs2p(mxns0),&
     cgn(mxns0),cgg(mxns0),cgf(mxns0),cgx(mxns0),cgt(mxns0),&
     dbar(mxns0),spot,dbarin,sigi(4)
   integer::ndfn(mxns0),ndff(mxns0),ndfx(mxns0)

   ! array for unresolved energy grid
   integer,parameter::meunr=150
   real(kr)::eunr(meunr)

   ! array for background cross sections
   real(kr),dimension(:),allocatable::sb

   ! probability table globals
   real(kr),dimension(:,:,:),allocatable::bval
   real(kr),dimension(:),allocatable::tmin,tmax,tsum

   ! storage array for unresolved resonance parameters
   integer,parameter::jx=10000
   real(kr),dimension(:),allocatable::arry

   ! optional plots
   integer ipl
   real(kr)::epl(200)
   real(kr),dimension(:,:,:),allocatable::sigpl

   ! random number generator
   integer::kk
   real(kr)::rr

   ! message flags
   integer::mflg1,mflg2

contains

   subroutine purr
   !-------------------------------------------------------------------
   !
   !  Probabalistic unresolved calculation of
   !  Bondarenko moments and probability tables
   !
   !-------------------------------------------------------------------
   !
   !  Purr constructs a series of resonance ladders that obey the
   !  distributions given in MT151 of the ENDF tape.  Each ladder
   !  is sampled randomly to produce contributions to a probability
   !  table and a set of bondarenko moments.  When the table is
   !  complete, Bondarenko moments are computed from the table to
   !  provide a convergence check.  All temperatures are computed
   !  simultaneously to preserve temperature correlations.  The
   !  Bondarenko tables are written on the pendf tape using MT152,
   !  and the probability tables are written using MT153.
   !  A conditional probability for heating is added to the table.
   !  If partial heating cross sections for elastic (302), fission
   !  (318), and capture (402) are available from heatr, full
   !  fluctuations will be provided for the total heating.
   !  Otherwise, the same value will be provided for each bin.
   !
   !---input data cards---------------------------------------------
   !
   ! card 1
   !   nendf   unit for endf tape
   !   nin     unit for input pendf tape
   !   nout    unit for output pendf tape
   ! card 2
   !   matd    material to be processed
   !           matd=0 terminates purr
   !   ntemp   no. of temperatures (default=1)
   !   nsigz   no of sigma zeros (default=1)
   !   nbin    no. of probability bins (15 or more)
   !   nladr   no. of resonance ladders
   !   iprint  print option (0=min, 1=max, def=1)
   !   nunx    no. of energy points desired (def=0=all)
   ! card 3
   !   temp    temperatures in kelvin (including zero)
   ! card 4
   !   sigz    sigma zero values (including infinity)
   !
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides timer,error,openz,repoz,closz,sigfig
   use endf ! provides endf routines and variables
   ! internals
   integer::lrp,nstep,ie,i,j,k,new152,new153,it,nx,newmat
   integer::matd,mfd,mtd,ix,is,n1,nsamp,nscr,maxscr,iscr,nb,nw
   integer::nunx,ntemp,nsigz,nbin,nwds,n,lstart,l
   integer::nwd,nc153,ncds,ihave,nc,nd,maxtst
   real(kr)::time,za,awr,ez,sigx,temz,h
   real(kr)::bkgz(4)
   character(60)::strng1,strng2
   real(kr),dimension(:),allocatable::a
   real(kr),dimension(:,:,:),allocatable::tabl
   real(kr),dimension(:,:),allocatable::tval
   real(kr),dimension(:),allocatable::er,gnr,gfr,ggr,gxr,gt
   real(kr),dimension(:),allocatable::es,xs
   real(kr),dimension(:,:),allocatable::fis,cap,els
   real(kr),dimension(:,:,:),allocatable::heat
   real(kr),dimension(:),allocatable::c,d
   real(kr),dimension(:),allocatable::temp,sigz
   real(kr),dimension(:,:,:),allocatable::sigu
   real(kr),parameter::tref=300.e0_kr
   real(kr),parameter::sigmin=1.e-5_kr
   real(kr),parameter::zero=0

   !--initialize
   ipl=0
   nmode=0
   nermax=1000
   nsamp=10000
   nsh=0
   call timer(time)
   write(nsyso,'(/'' purr...'',&
     &''probabalistic unresolved calculation'',&
     &25x,f8.1,''s'')') time
   write(nsyse,'(/'' purr...'',61x,f8.1,''s'')') time
   read(nsysi,*) nendf,nin,nout
   if ((nin.lt.0.and.nout.gt.0).or.(nin.gt.0.and.nout.lt.0))&
     call error('purr',&
     'mode conversion between nin and nout not allowed',' ')
   call openz(nendf,0)
   call openz(nin,0)
   call openz(nout,1)
   nscr=10
   call openz(-nscr,1)
   maxscr=20000
   allocate(a(maxscr))
   iscr=1
   write(nsyso,'(&
     &'' unit for input endf tape ............. '',i10/&
     &'' unit for input pendf tape ............ '',i10/&
     &'' unit for output pendf tape ........... '',i10)')&
     nendf,nin,nout
   call uwtab2
   call repoz(nin)
   call repoz(nendf)
   call repoz(nout)
   call tpidio(nin,nout,0,a(iscr),nb,nw)
   call tpidio(nendf,0,0,a(iscr),nb,nw)

   ! set random number sequence
   kk=-101
   ez=rann(kk)

   !--loop over requested materials
  110 continue
   iprint=1
   nunx=0
   ntemp=1
   nsigz=1
   init=0
   read(nsysi,*) matd,ntemp,nsigz,nbin,nladr,iprint,nunx
   if (matd.eq.0) go to 400
   call repoz(-nscr)
   if (allocated(temp)) then
      deallocate(temp)
      deallocate(sigz)
      deallocate(sigu)
      deallocate(sigpl)
   endif
   allocate(temp(ntemp))
   allocate(sigz(nsigz))
   allocate(sigu(5,nsigz,ntemp))
   allocate(sigpl(200,5,nsigz))
   read(nsysi,*) (temp(i),i=1,ntemp)
   read(nsysi,*) (sigz(i),i=1,nsigz)
   write(nsyso,'(&
     &'' temperatures ......................... '',1p,e10.3)')&
     temp(1)
   if (ntemp.gt.1) write(nsyso,'(40x,1p,e10.3)') (temp(i),i=2,ntemp)
   write(nsyso,'(&
     &'' sigma zero values .................... '',&
     &2x,''infinity'')')
   if (nsigz.gt.1) write(nsyso,'(40x,1p,e10.3)') (sigz(i),i=2,nsigz)
   write(nsyso,'(&
     &'' number of probability bins ........... '',i10/&
     &'' number of resonance ladders .......... '',i10/&
     &'' print option (0=min, 1=max) .......... '',i10/&
     &'' no. of energy points (0=all) ......... '',i10)')&
     nbin,nladr,iprint,nunx
   if (nbin.lt.15) call error('purr','nbin should be 15 or more',' ')

   !--allocate storage for ladders and tables
   allocate(arry(jx))
   if (allocated(tabl)) then
      deallocate(tabl)
      deallocate(tval)
      deallocate(fis)
      deallocate(cap)
      deallocate(els)
   endif
   allocate(tabl(nbin,5,ntemp))
   allocate(tval(nbin,ntemp))
   allocate(er(nermax))
   allocate(gnr(nermax))
   allocate(gfr(nermax))
   allocate(ggr(nermax))
   allocate(gxr(nermax))
   allocate(gt(nermax))
   allocate(es(nsamp))
   allocate(xs(nsamp))
   allocate(fis(ntemp,nsamp))
   allocate(cap(ntemp,nsamp))
   allocate(els(ntemp,nsamp))
   arry=0.
   xs=0

   !--process this material
   call timer(time)
   write(nsyso,'(/'' mat = '',i4,58x,f8.1,''s'')') matd,time
   write(nsyse,'(/'' mat = '',i4,58x,f8.1,''s'')') matd,time

   !--read resonance parameters from file 2 on endf tape.
   !--read background cross sections from file 3
   nunr=0
   call findf(matd,1,451,nendf)
   call contio(nendf,0,0,a(iscr),nb,nw)
   za=c1h
   awr=c2h
   lrp=l1h
   if (lrp.le.0) go to 370
   call contio(nendf,0,0,a(iscr),nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   call findf(matd,2,151,nendf)
   call contio(nendf,0,0,a(iscr),nb,nw)
   call rdf2un(a)
   if (nunr.eq.0) go to 380
   maxtst=max(12+nsigz+nunr*(1+5*nsigz),12+(1+6*nbin)*nunr)
   if (maxtst.gt.maxscr) then
      write(strng1,'(''maxscr is too small, increase to at least '',&
                     &i7,'' words'')')maxtst
      call error('purr',strng1,' ')
   endif
   call findf(matd,3,1,nendf)
   call rdf3un(a)

   !--read in the total and partial heating cross sections
   if (allocated(heat)) deallocate(heat)
   h=0
   allocate(heat(4,nunr,ntemp))
   heat(:,:,:)=zero
   ihave=0
   call rdheat(a,heat,eunr,temp,ntemp,nunr,ihave,matd)
   if (ihave.eq.0) call mess('purr',&
     'no heating found on pendf',&
     'ur heating set to zero')
   if (ihave.eq.1) call mess('purr',&
     'no partial heating xsecs found on pendf',&
     'ur heating will not selfshield')

   !--compute unresolved resonance cross-sections
   !--for all grid points, temperatures, and sigma zero values.
   if ((nunx.eq.0).or.(nunx.gt.nunr)) nunx=nunr
   if (nunx.eq.1) nunx=2
   nstep=nunr/(nunx-1)
   if (nstep.lt.1) nstep=1
   ie=1-nstep
   mflg1=0
   mflg2=0
   do while (ie.lt.nunr)
      ie=ie+nstep
      if (ie.gt.nunr) ie=nunr
      ez=eunr(ie)
      bkgz(1)=sb(ie)
      bkgz(2)=sb(nunr+ie)
      bkgz(3)=sb(nunr*2+ie)
      bkgz(4)=sb(nunr*3+ie)
      sigx=bkgz(1)-bkgz(2)-bkgz(3)-bkgz(4)
      if (sigx.lt.sigmin) sigx=0
      call unresx(ez,tref)
      call unrest(bkgz,sigz,sigu,tabl,tval,er,gnr,gfr,ggr,gxr,gt,&
        es,xs,cap,fis,els,temp,nsigz,ntemp,nbin,nsamp)

      !--purr can run for a long time ... keep the user informed
      call timer(time)
      write(nsyse,'(2x,i5," of ",i5,&
            &" loops done for all temps & sig0s.",19x,f8.1,"s")')&
            &ie,nunx,time

      !--write bondarenko data and probability table to scratch file.
      write(nscr) ez
      write(nscr) (((tabl(i,j,k),i=1,nbin),j=1,5),k=1,ntemp)
      write(nscr) (((sigu(i,j,k),i=1,5),j=1,nsigz),k=1,ntemp)
   enddo

   !--check for previous mt152 and mt153
   new152=1
   new153=1
   call findf(matd,2,151,nin)
   call tosend(nin,0,0,a(iscr))
   call contio(nin,0,0,a(iscr),nb,nw)
   if (mth.eq.152) then
      new152=0
      call tosend(nin,0,0,a(iscr))
      call contio(nin,0,0,a(iscr),nb,nw)
   endif
   if (mth.eq.153) new153=0
   call findf(matd,1,451,nin)

   !--write data to new pendf tape for all temperatures
   do 350 it=1,ntemp
   temz=temp(it)
   nx=0
   call contio(nin,0,0,a(iscr),nb,nw)
   if (iverf.lt.5) then
      nx=n2h
      if (nx.gt.0.and.new152.gt.0) a(iscr+5)=a(iscr+5)+1
      if (nx.gt.0.and.new153.gt.0) a(iscr+5)=a(iscr+5)+1
   endif
   call contio(0,nout,0,a(iscr),nb,nw)
   if (iverf.ge.5) call contio(nin,nout,0,a(iscr),nb,nw)
   if (iverf.ge.6) call contio(nin,nout,0,a(iscr),nb,nw)
   call hdatio(nin,0,0,a(iscr),nb,nw)
   a(iscr)=temz
   if (iverf.ge.5) then
      nx=n2h
      if (nx.gt.0.and.new152.gt.0) a(iscr+5)=a(iscr+5)+1
      if (nx.gt.0.and.new153.gt.0) a(iscr+5)=a(iscr+5)+1
   endif
   call hdatio(0,nout,0,a(iscr),nb,nw)
   do while (nb.ne.0)
      call moreio(nin,nout,0,a(iscr),nb,nw)
   enddo
   nw=nx
   if (nw.eq.0) go to 250
   nc=6*(nx+new152+new153)
   if (allocated(c)) deallocate(c)
   allocate(c(nc))
   nd=6*nx
   if (allocated(d)) deallocate(d)
   allocate(d(nd))
   call dictio(nin,0,0,d,nb,nw)
   j=0
   newmat=0
   ncds=nsigz+nunx*(1+5*nsigz)
   ncds=2+(ncds-1)/6
   nc153=(1+6*nbin)*nunx
   nc153=2+(nc153-1)/6
   do 240 i=1,nw,6
   if (newmat.gt.0) go to 220
   mfd=nint(d(i+2))
   mtd=nint(d(i+3))
   if (mfd.lt.2) go to 220
   if (mfd.eq.2.and.mtd.eq.151) go to 220
   if (mfd.eq.2.and.mtd.eq.152) go to 240
   if (mfd.eq.2.and.mtd.eq.153) go to 240
   newmat=1
   c(1+j)=0
   c(2+j)=0
   c(3+j)=2
   c(4+j)=152
   c(5+j)=ncds
   c(6+j)=0
   c(7+j)=0
   c(8+j)=0
   c(9+j)=2
   c(10+j)=153
   c(11+j)=nc153
   c(12+j)=0
   j=j+12
  220 continue
   do k=1,6
      c(j+k)=d(k+i-1)
   enddo
   j=j+6
  240 continue
   nwd=j/6
   call dictio(0,nout,0,c,nb,nwd)
   deallocate(c)
   deallocate(d)
   ! copy through file 2, mt 151
  250 continue
   call tofend(nin,nout,0,a(iscr))
   call tosend(nin,nout,0,a(iscr))
   call contio(nin,0,0,a(iscr),nb,nw)
   if (mth.eq.152) then
      call tosend(nin,0,0,a(iscr))
      call contio(nin,0,0,a(iscr),nb,nw)
   endif
   if (mth.eq.153) then
      call tosend(nin,0,0,a(iscr))
      call contio(nin,0,0,a(iscr),nb,nw)
   endif

   !--write new mt152 on output tape
   !--for bondarenko self-shielded cross sections
   math=matd
   mfh=2
   mth=152
   l=iscr
   a(l)=za
   a(l+1)=awr
   a(l+2)=lssf
   a(l+3)=0
   a(l+4)=0
   a(l+5)=intunr
   a(l+6)=temz
   a(l+7)=0
   a(l+8)=5
   a(l+9)=nsigz
   a(l+10)=nsigz+nunx*(1+5*nsigz)
   a(l+11)=nunx
   l=l+11
   do i=1,nsigz
      l=l+1
      a(l)=sigz(i)
   enddo
   call repoz(-nscr)
   ie=1-nstep
   do while (ie.lt.nunr)
      ie=ie+nstep
      if (ie.gt.nunr) ie=nunr
      read(nscr) ez
      read(nscr) (((tabl(i,j,k),i=1,nbin),j=1,5),k=1,ntemp)
      read(nscr) (((sigu(i,j,k),i=1,5),j=1,nsigz),k=1,ntemp)
      l=l+1
      a(l)=eunr(ie)
      do ix=1,5
         do is=1,nsigz
            l=l+1
            a(l)=sigfig(sigu(ix,is,it),7,0)
         enddo
      enddo
   enddo
   call contio(0,nout,0,a(iscr),nb,nw)
   lstart=iscr+6
   nwds=l-iscr-5
   nw=nwds
   if (nw.gt.npage+6) nw=npage+6
   call listio(0,nout,0,a(lstart),nb,nw)
  290 continue
   lstart=lstart+nw
   nwds=nwds-nw
   nw=nwds
   if (nw.gt.npage) nw=npage
   if (nb.eq.0) go to 300
   call moreio(0,nout,0,a(lstart),nb,nw)
   go to 290
  300 continue
   call asend(nout,0)

   !--write new mt153 on output tape
   !--for probability tables
   math=matd
   mfh=2
   mth=153
   n=iscr
   a(n)=za
   a(n+1)=awr
   a(n+2)=iinel
   a(n+3)=iabso
   a(n+4)=intunr
   a(n+5)=nbin
   a(n+6)=temz
   a(n+7)=0
   a(n+8)=lssf
   a(n+9)=0
   a(n+10)=(1+6*nbin)*nunx
   a(n+11)=nunx
   n=n+11
   call repoz(-nscr)
   ie=1-nstep
   do while (ie.lt.nunr)
      ie=ie+nstep
      if (ie.gt.nunr) ie=nunr
      read(nscr) ez
      read(nscr) (((tabl(i,j,k),i=1,nbin),j=1,5),k=1,ntemp)
      read(nscr) (((sigu(i,j,k),i=1,5),j=1,nsigz),k=1,ntemp)
      n=n+1
      a(n)=sigfig(eunr(ie),7,0)
      n1=n
      do i=1,5
         do j=1,nbin
            n=n+1
            a(n)=sigfig(tabl(j,i,it),7,0)
         enddo
      enddo
      do j=1,nbin
         n=n+1
         a(n)=0
      enddo
      do i=2,5
         do j=1,nbin
            l=n1+j+nbin*(i-1)
            if (lssf.eq.1) then
               if (sigu(i-1,1,1).ne.0) then
                  a(l)=a(l)/sigu(i-1,1,1)
               else
                  a(l)=1
               endif
            endif
            a(l)=sigfig(a(l),7,0)
         enddo
      enddo
      do j=1,nbin
         l=n1+j+5*nbin
         if (ihave.eq.1) then
            if (lssf.eq.1) then
               a(l)=1
            else
               a(l)=heat(1,ie,it)/sigu(1,1,1)
               endif
         else if (ihave.eq.2) then
            a(l)=a(l)+(heat(1,ie,it)-heat(2,ie,it)-heat(3,ie,it)-heat(4,ie,it))
            h=heat(2,ie,it)
            if (lssf.eq.1) then
               h=h*a(n1+j+2*nbin)
            else if (sigu(2,1,1).ne.zero) then
               h=h*a(n1+j+2*nbin)/sigu(2,1,1)
            endif
            a(l)=a(l)+h
            h=heat(3,ie,it)
            if (lssf.eq.1) then
               h=h*a(n1+j+3*nbin)
            else if (sigu(3,1,1).ne.zero) then
               h=h*a(n1+j+3*nbin)/sigu(3,1,1)
            endif
            a(l)=a(l)+h
            h=heat(4,ie,it)
            if (lssf.eq.1) then
               h=h*a(n1+j+4*nbin)
            elseif (sigu(4,1,1).ne.zero) then
               h=h*a(n1+j+4*nbin)/sigu(4,1,1)
            endif
            a(l)=a(l)+h
            if (a(n1+j+nbin).ne.zero) a(l)=a(l)/a(n1+j+nbin)
            if (lssf.eq.1) a(l)=a(l)/heat(1,ie,it)
         endif
      enddo
   enddo
   call contio(0,nout,0,a(iscr),nb,nw)
   lstart=iscr+6
   nwds=6*nbin*nunx
   nw=nwds
   if (nw.gt.npage+6) nw=npage+6
   call listio(0,nout,0,a(lstart),nb,nw)
  330 continue
   lstart=lstart+nw
   nwds=nwds-nw
   nw=nwds
   if (nw.gt.npage) nw=npage
   if (nb.eq.0) go to 340
   call moreio(0,nout,0,a(lstart),nb,nw)
   go to 330
  340 continue
   call asend(nout,0)
   ! write file end card for file 2
   call afend(nout,0)
   ! copy rest of material to output tape
   call contio(nin,nout,0,a(iscr),nb,nw)
   call tomend(nin,nout,0,a(iscr))
  350 continue

   !--write report of calculation
   call timer(time)
   write(nsyso,'(/'' generated cross sections at '',i3,&
     &'' points'',30x,f8.1,''s'')') nunx,time
   deallocate(sb)
   go to 110

   !--mat has no resonance parameters. copy as is to nout.
  370 continue
   write(strng1,&
     '(''mat'',i5,'' has no resonance parameters'')') matd
   write(strng2,'(''copy as is to nout'')')
   call mess('purr',strng1,strng2)
   go to 385

   !--mat has no unresolved.  copy as is to nout
  380 continue
   write(strng1,&
     '(''mat'',i5,'' has no unresolved parameters'')') matd
   write(strng2,'(''copy as is to nout'')')
   call mess('purr',strng1,strng2)
  385 continue
   call findf(matd,1,451,nin)
   it=0
  390 continue
   call contio(nin,0,0,a(iscr),nb,nw)
   if (math.ne.matd) go to 110
   call contio(0,nout,0,a(iscr),nb,nw)
   call tomend(nin,nout,0,a(iscr))
   it=it+1
   if (it.lt.ntemp) go to 390
   go to 110

   !--finished with purr
  400 continue
   !--print bondarenko cross sections for plotting
   !--uncomment the following lines to activate
    !do k=1,5
    !   do j=1,nsigz
    !      if (k.eq.1) write(nsyso,&
    !        '(/'' p0 total, sigz='',1p,e10.2)') sigz(j)
    !      if (k.eq.2) write(nsyso,&
    !        '(/'' elastic, sigz='',1p,e10.2)') sigz(j)
    !      if (k.eq.3) write(nsyso,&
    !        '(/'' fission, sigz='',1p,e10.2)') sigz(j)
    !      if (k.eq.4) write(nsyso,&
    !        '(/'' capture, sigz='',1p,e10.2)') sigz(j)
    !      if (k.eq.5) write(nsyso,&
    !        '(/'' p1 total, sigz='',1p,e10.2)') sigz(j)
    !      do i=1,ipl
    !         write(nsyso,'(1p,2e11.4)') epl(i),sigpl(i,k,j)
    !      enddo
    !   enddo
    !enddo

   deallocate(arry)
   deallocate(temp)
   deallocate(sigz)
   deallocate(sigu)
   deallocate(sigpl)
   if (allocated(bval)) then
      deallocate(bval)
      deallocate(tmin)
      deallocate(tmax)
      deallocate(tsum)
   endif
   if (allocated(tabl)) then
      deallocate(tabl)
      deallocate(tval)
      deallocate(er)
      deallocate(gnr)
      deallocate(gfr)
      deallocate(ggr)
      deallocate(gxr)
      deallocate(gt)
      deallocate(es)
      deallocate(xs)
      deallocate(fis)
      deallocate(cap)
      deallocate(els)
   endif
   if (allocated(heat)) deallocate(heat)
   if (allocated(c)) deallocate(c)
   if (allocated(d)) deallocate(d)

   call atend(nout,0)
   call repoz(nout)
   call closz(nendf)
   call closz(nin)
   call closz(nout)
   call closz(-nscr)
   call timer(time)
   write(nsyso,'(/69x,f8.1,''s''/&
     &7(''**********''),''*******'')') time
   return
   end subroutine purr

   subroutine rdf2un(a)
   !-------------------------------------------------------------------
   ! Read and/or copy unresolved resonance parameters from File 2.
   !-------------------------------------------------------------------
   use util ! provides error,mess,sigfig
   use endf ! provides endf routines and variables
   ! externals
   real(kr)::a(*)
   ! internals
   integer::indep,nis,inow,is,nb,nw,lfw,ner,ier,lru,lrf
   integer::nls,l,njs,j,mode,ll,jnow,n,i,ne,inow1,ir,k,jj
   integer::ist,loc,nwds,ione,itwo,ithree,ii,iovlp,iscr
   real(kr)::elr,ehr,abn,el,eh,et,spi,ay,awri,enow,elast,enext
   real(kr)::test,enut
   integer,parameter::ngridu=78
   real(kr),dimension(78)::egridu=(/&
     1.0e1_kr,1.25e1_kr,1.5e1_kr,1.7e1_kr,2.0e1_kr,2.5e1_kr,3.0e1_kr,&
     3.5e1_kr,4.0e1_kr,5.0e1_kr,6.0e1_kr,7.2e1_kr,8.5e1_kr,1.0e2_kr,&
     1.25e2_kr,1.5e2_kr,1.7e2_kr,2.0e2_kr,2.5e2_kr,3.0e2_kr,3.5e2_kr,&
     4.0e2_kr,5.0e2_kr,6.0e2_kr,7.2e2_kr,8.5e2_kr,1.0e3_kr,1.25e3_kr,&
     1.5e3_kr,1.7e3_kr,2.0e3_kr,2.5e3_kr,3.0e3_kr,3.5e3_kr,4.0e3_kr,&
     5.0e3_kr,6.0e3_kr,7.2e3_kr,8.5e3_kr,1.0e4_kr,1.25e4_kr,1.5e4_kr,&
     1.7e4_kr,2.0e4_kr,2.5e4_kr,3.0e4_kr,3.5e4_kr,4.0e4_kr,5.0e4_kr,&
     6.0e4_kr,7.2e4_kr,8.5e4_kr,1.0e5_kr,1.25e5_kr,1.5e5_kr,1.7e5_kr,&
     2.0e5_kr,2.5e5_kr,3.0e5_kr,3.5e5_kr,4.0e5_kr,5.0e5_kr,6.0e5_kr,&
     7.2e5_kr,8.5e5_kr,1.e6_kr,1.25e6_kr,1.5e6_kr,1.7e6_kr,2.0e6_kr,&
     2.5e6_kr,3.0e6_kr,3.5e6_kr,4.0e6_kr,5.0e6_kr,6.0e6_kr,7.2e6_kr,&
     8.5e6_kr/)
   real(kr),parameter::etop=5.e6_kr
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::wide=1.26e0_kr

   iscr=1
   indep=0
   elr=0
   ehr=etop
   nunr=1
   eunr(1)=etop

   !--head card read in calling program
   nis=n1h
   nsect=0
   inow=1

   !--loop over isotopes
   do 110 is=1,nis
   call contio(nendf,0,0,a(iscr),nb,nw)
   abn=c2h
   lfw=l2h
   ner=n1h
   ier=0

   !--loop over all energy ranges
  115 continue
   call contio(nendf,0,0,a(iscr),nb,nw)
   if (mth.eq.0) go to 300
   ier=ier+1
   el=sigfig(c1h,7,0)
   eh=sigfig(c2h,7,0)
   lru=l1h
   lrf=l2h
   nro=n1h
   naps=n2h
   if (lru.eq.2) go to 140
   if (eh.gt.elr) elr=eh

   !--read through this sub-section
   call contio(nendf,0,0,a(iscr),nb,nw)
   nls=n1h
   if (lrf.eq.4.or.lrf.eq.7) then
      call listio(nendf,0,0,a(iscr),nb,nw)
      do while (nb.ne.0)
         call moreio(nendf,0,0,a(iscr),nb,nw)
      enddo
   endif
   do l=1,nls
      if (lrf.ne.4) then
         call listio(nendf,0,0,a(iscr),nb,nw)
         do while (nb.ne.0)
            call moreio(nendf,0,0,a(iscr),nb,nw)
         enddo
         if (lrf.eq.7) then
            call listio(nendf,0,0,a(iscr),nb,nw)
            do while (nb.ne.0)
               call moreio(nendf,0,0,a(iscr),nb,nw)
            enddo
         endif
      else
         call contio(nendf,0,0,a(iscr),nb,nw)
         njs=n1h
         do j=1,njs
            call listio(nendf,0,0,a(iscr),nb,nw)
            do while (nb.ne.0)
               call moreio(nendf,0,0,a(iscr),nb,nw)
            enddo
         enddo
      endif
   enddo
   if (ier.eq.ner) go to 110
   go to 115

   !--read and copy unresolved resonance parameters
  140 continue
   nsect=nsect+1
   isot(nsect)=is
   abnt(nsect)=abn
   elt(nsect)=el
   eht(nsect)=eh
   mode=lrf+4*(lru-1)
   modet(nsect)=mode
   ibaset(nsect)=inow
   if (eh.lt.ehr) ehr=eh
   ! add el and eh to list of nodes
   ! shade nodes around discontinuities
   et=sigfig(el,7,-1)
   call ilist2(et,eunr,nunr)
   et=sigfig(el,7,+1)
   call ilist2(et,eunr,nunr)
   et=sigfig(eh,7,-1)
   call ilist2(et,eunr,nunr)
   et=sigfig(eh,7,+1)
   call ilist2(et,eunr,nunr)

   ! if present, read and store the energy-dependent
   ! scattering radius tab1 data.
   if (nro.eq.1) then
      call tab1io(nendf,0,0,arry(inow),nb,nw)
      jj=inow+nw
      do while (nb.ne.0)
         call moreio(nendf,0,0,arry(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.jx) then
            call error('rdf2un','storage in a exceeded',' ')
         endif
      enddo
      inow=jj
   endif

   !--branch to specified representation
   if (lrf.ne.2) then

      !--all parameters independent of energy
      if (lfw.ne.1) then
         call contio(nendf,0,0,a(iscr),nb,nw)
         spi=c1h
         ay=c2h
         lssf=l1h
         nls=n1h
         ! loop over l states
         do l=1,nls
            call listio(nendf,0,0,a(iscr),nb,nw)
            awri=c1h
            ll=l1h
            njs=n2h
            if (l.eq.1) then
               arry(inow)=awri
               arry(inow+1)=ay
               arry(inow+2)=spi
               arry(inow+3)=lfw
               arry(inow+4)=nls
               arry(inow+5)=0
               inow=inow+6
            endif
            arry(inow)=njs
            arry(inow+1)=ll
            inow=inow+2
            jnow=iscr+5
            do n=1,njs
               do i=1,5
                  arry(inow)=a(jnow+i)
                  inow=inow+1
               enddo
               jnow=jnow+6
            enddo
         enddo
         if (inow.gt.jx) call error('rdf2un','storage exceeded',' ')
         indep=1
         intunr=5

      !--fission widths energy dependent
      else
         call listio(nendf,0,0,a(iscr),nb,nw)
         spi=c1h
         ay=c2h
         lssf=l1h
         ne=n1h
         nls=n2h
         arry(inow+1)=ay
         arry(inow+2)=spi
         arry(inow+3)=lfw
         arry(inow+4)=nls
         arry(inow+5)=ne
         ! store fission width energy points
         inow1=inow+5
         do i=1,ne
            arry(inow1+i)=a(iscr+i+5)
            enow=a(iscr+i+5)
            arry(inow1+i)=enow
            ! use as energy nodes
            if (i.gt.1.and.i.lt.ne) then
               if (nunr.ge.meunr) call error('rdunf2',&
                 'too many ur energy points',' ')
               if (enow.ge.el.and.enow.le.eh) call ilist2(enow,eunr,nunr)
            endif
         enddo
         ! loop over l states
         do l=1,nls
            call contio(nendf,0,0,a(iscr),nb,nw)
            if (l.eq.1) then
               arry(inow)=c1h
               inow=inow+6+ne
            endif
            njs=n1h
            arry(inow)=njs
            arry(inow+1)=l1h
            inow=inow+2
            ! loop over j states
            do j=1,njs
               call listio(nendf,0,0,a(iscr),nb,nw)
               ne=n1h-6
               arry(inow)=l2h
               ! store parameters
               do ir=1,5
                  arry(inow+ir)=a(iscr+5+ir)
               enddo
               inow1=inow+5
               ! store fission widths
               do k=1,ne
                  arry(inow1+k)=a(iscr+11+k)
               enddo
               inow=inow+6+ne
            enddo
         enddo
         if (inow.gt.jx) call error('rdf2un','storage exceeded',' ')
         intunr=5
      endif

   !--all parameters energy dependent
   else
      ist=inow
      ! first cont record
      call contio(nendf,0,0,a(iscr),nb,nw)
      lssf=l1h
      nls=n1h
      arry(inow+1)=c2h
      arry(inow+2)=c1h
      arry(inow+3)=n1h
      inow=inow+4
      ! loop over l states
      do l=1,nls
         call contio(nendf,0,0,a(iscr),nb,nw)
         if (l.eq.1) arry(ist)=c1h
         njs=n1h
         arry(inow)=njs
         arry(inow+1)=l1h
         inow=inow+2
         ! loop over j states
         do j=1,njs
            call listio(nendf,0,0,a(iscr),nb,nw)
            loc=iscr+nw
            do while (nb.ne.0)
               call moreio(nendf,0,0,a(loc),nb,nw)
               loc=loc+nw
            enddo
            ne=n2h
            intunr=l1h
            arry(inow)=c1h
            arry(inow+1)=l1h
            arry(inow+2)=ne
            ! store numbers of degrees of freedom
            do k=3,6
               arry(inow+k)=a(iscr+5+k)
            enddo
            inow=inow+7
            jnow=iscr+11
            ! store parameters
            do n=1,ne
               do k=1,6
                  if (a(jnow+k).le.0.) a(jnow+k)=small
                  arry(inow+k-1)=a(jnow+k)
               enddo
               inow=inow+6
               if (n.ne.1.and.n.ne.ne) then
                  if (l.eq.1) then
                     if (j.eq.1) then
                        ! store energy as a node
                        enow=a(jnow+1)
                        if (nunr.ge.meunr) call error('rdunf2',&
                          'too many ur energy points',' ')
                        if (enow.ge.el.and.enow.le.eh)&
                          call ilist2(enow,eunr,nunr)
                     endif
                  endif
               endif
               jnow=jnow+6
            enddo
         enddo
      enddo
      if (inow.gt.jx) call error('rdf2un','storage exceeded',' ')
   endif
   if (ier.lt.ner) go to 115
  110 continue
  300 continue
   nwds=inow
   nunr=nunr-1
   if (nunr.eq.0) return

   !--remove first and last energy nodes
   !--flag resolved-unresolved overlap energies
   nunr=nunr+1
   i=1
   elast=eunr(2)
   ione=0
   do while (ione.eq.0)
      i=i+1
      enext=eunr(1+i)
      test=etop
      if (enext.ge.test) then
         ione=1
      else
         if (enext.ge.wide*elast.or.indep.ne.0) then
            et=elast
            itwo=0
            do while (itwo.eq.0)
               ithree=0
               ii=0
               do while (ii.lt.ngridu.and.ithree.eq.0)
                  ii=ii+1
                  enut=egridu(ii)
                  if (enut.gt.et+et/100) ithree=1
               enddo
               if (ithree.eq.0) enut=enext
               et=enut
               if (et.ge.enext) then
                  itwo=1
               else
                  if (nunr.ge.meunr) call error('rdunf2',&
                    'too many ur energy points',' ')
                  call ilist2(et,eunr,nunr)
                  i=i+1
               endif
            enddo
         endif
         elast=eunr(1+i)
      endif
   enddo
   iovlp=0
   nunr=nunr-2
   do i=2,nunr
      et=eunr(i)
      if (et.lt.elr) et=-et
      if (et.gt.ehr) et=-et
      if (et.lt.0.) iovlp=1
      eunr(i-1)=et
   enddo
   nunr=nunr-1
   if (iovlp.eq.1) call mess('rdf2un',&
     'resolved-unresolved overlap energies',&
     'marked with minus signs')
   return
   end subroutine rdf2un

   subroutine ilist2(e,elist,nlist)
   !-------------------------------------------------------------------
   ! Insert a new energy into a list of enegies in ascending order.
   ! Omit duplicate values.  Initial list must be primed with one
   ! energy larger than any others to be added.
   !-------------------------------------------------------------------
   ! externals
   integer::nlist
   real(kr)::e,elist(*)
   ! internals
   integer::jl,i,idone,j

   jl=0
   i=0
   idone=0
   do while (i.lt.nlist.and.idone.eq.0)
      i=i+1
      if (e.le.elist(i)) then
         if (e.ne.elist(i)) then
            jl=nlist-i+1
            do j=1,jl
               elist(nlist-j+2)=elist(nlist-j+1)
            enddo
            elist(i)=e
         endif
         idone=1
      endif
   enddo
   if (idone.eq.0) then
      jl=1
      elist(nlist+1)=e
   endif
   if (jl.gt.0) nlist=nlist+1
   return
   end subroutine ilist2

   subroutine rdf3un(a)
   !-------------------------------------------------------------------
   ! Read unresolved region background cross sections from File 3.
   ! Compute the background cross sections on the unresolved
   ! energy grid and store for use in unresx.  Also, analyze the
   ! competitive reactions, if any.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides mess
   use endf ! provides endf routines and variables
   ! externals
   real(kr)::a(*)
   ! internals
   integer::iscr,nthr,nb,nw,idis,ix,jthr,ibase,ie,icx,kthr,mtc,mtmax
   real(kr)::e,enext,bkg,sigx,ecomp,total
   real(kr),dimension(:),allocatable::thr
   character(60)::strng1,strng2
   integer,dimension(4),parameter::mtx=(/1,2,18,102/)
   real(kr),parameter::up=1.00001e0_kr
   real(kr),parameter::dn=.99999e0_kr
   real(kr),parameter::small=1.e-5_kr
   real(kr),parameter::tol=1.e-6_kr

   !--allocate storage
   iscr=1
   nthr=1000
   nw=2*nthr
   allocate(thr(nw))
   nw=nunr*4
   allocate(sb(nunr*4))

   !--initialise background array for total, elastic, fission and capture
   sb(1:nunr*4)=0

   !--loop over reactions
   !--saving resonance cross sections
   !--and reaction thresholds
   jthr=0
   ix=1
   ibase=1+nunr*(ix-1)-1
   mtmax=891 ! continuum n,2n
   call contio(nendf,0,0,a(iscr),nb,nw)
   do while (mfh.eq.3.and.mth.le.mtmax)
      if (mth.lt.6.or.(mth.gt.10.and.mth.lt.12).or. &
         & (mth.gt.15.and.mth.lt.43).or. &
         & (mth.gt.43.and.mth.lt.46).or. &
         & (mth.gt.49.and.mth.lt.92).or. &
         & (mth.gt.100.and.mth.lt.110).or. &
         & (mth.gt.110.and.mth.lt.118).or. &
         & (mth.gt.150.and.mth.le.200).or.mth.ge.600) then
         !--get reaction threshold and store data
         e=0
         call gety1(e,enext,idis,bkg,nendf,a(iscr))
         if (mth.ge.4) then
            jthr=jthr+1
            thr(1+2*(jthr-1))=mth
            thr(2+2*(jthr-1))=enext
         endif
         !--skip unresolved resonance reaction if required
         do while (mtx(ix).ne.102.and.mtx(ix).lt.mth)
            ix=ix+1
         enddo
         !--store data is this is one we need
         if (mth.eq.mtx(ix)) then
            ibase=1+nunr*(ix-1)-1
            do ie=1,nunr
               e=abs(eunr(ie))
               if (ie.eq.1) e=up*e
               if (ie.eq.nunr) e=dn*e
               call gety1(e,enext,idis,sb(ibase+ie),nendf,a(iscr))
            enddo
         endif
      endif
      call tosend(nendf,0,0,a(iscr))
      call contio(nendf,0,0,a(iscr),nb,nw)
   enddo

   !--output lssf flag
   write(nsyso,'('' evaluation lssf equal to'',i2)') lssf

   !--check for competitive reactions
   icx=0
   do ie=1,nunr
      sigx=sb(ie)-sb(nunr+ie)-sb(2*nunr+ie)-sb(3*nunr+ie)
      if (icx.eq.0.and.sigx.gt.small) icx=ie
   enddo
   iinel=-1 ! default is no competition
   iabso=-1 ! default is no competition
   if (icx.gt.0) then
      ecomp=eunr(icx)
      write(nsyso,'(/'' competition starts at'',1p,e12.4)') ecomp
      do kthr=1,jthr
         mtc=nint(thr(1+2*(kthr-1)))
         if (mtc.gt.4.and.mtc.ne.18.and.mtc.ne.19.and.mtc.ne.102) then
            if (up*thr(2+2*(kthr-1)).lt.eunr(nunr)) then
               write(nsyso,'(''   ur competes with mt'',i3)') mtc
               if (mtc.ge.51.and.mtc.le.91) then
                  if (iinel.lt.0) then
                     iinel=mtc ! use mtc as flag if it is the only one
                  else
                     iinel=4   ! more than one in competition, use mt4 instead
                  endif
               else
                  if (iabso.lt.0) then
                     iabso=mtc ! use mtc as flag if it is the only one
                  else
                     iabso=0   ! more than one in competition, use 0
                  endif
               endif
            endif
         endif
      enddo
      write(nsyso,'('' inelastic competition flag set to '',i3/&
        &'' absorption competition flag set to '',i3)') iinel,iabso
   endif

   !--sanity check for lssf=1, derive corresponding sb(i) array
   if (lssf.gt.0) then
      do ie=1,nunr
         total=sb(ie)
         sb(ie)=sb(ie)-sb(ie+nunr)-sb(ie+2*nunr)-sb(ie+3*nunr)
         if (sb(ie).gt.tol*total) then
            !--this can only happen if there is competition and above ecomp
            if (iinel.lt.0.and.iabso.lt.0) then
               write(strng1,&
                 '(''total xs greater than its components at e=''&
                 &,1p,e12.4)') eunr(ie)
               write(strng2,'(''check evaluation file'')')
               call mess('purr',strng1,strng2)
               sb(ie)=0
            elseif (eunr(ie).lt.ecomp) then
               write(strng1,&
                 '(''total xs greater than its components at e=''&
                 &,1p,e12.4)') eunr(ie)
               write(strng2,'(''check evaluation file below competition'')')
               call mess('purr',strng1,strng2)
               sb(ie)=0
            endif
         else
            !--either roundoff or total is smaller than its components
            if (sb(ie).lt.-tol*total) then
               write(strng1,&
                 '(''total xs less than its components at e=''&
                 &,1p,e12.4)') eunr(ie)
               write(strng2,'(''check evaluation file'')')
               call mess('purr',strng1,strng2)
            endif
            sb(ie)=0
         endif
         sb(ie+nunr)=0
         sb(ie+2*nunr)=0
         sb(ie+3*nunr)=0
      enddo
   endif

   return
   end subroutine rdf3un

   subroutine rdheat(a,heat,eunr,temp,ntemp,nunr,ihave,matd)
   !-------------------------------------------------------------------
   ! Read the total heating (MT=301) and partial heating cross
   ! sections for elastic (302), fission (318), and capture (402)
   ! from the pendf tape on the unresolved energy grid.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides repoz
   use endf ! provides endf routines and variables
   ! externals
   integer::ntemp,nunr,ihave,matd
   real(kr)::a(*),heat(4,nunr,ntemp),eunr(nunr),temp(ntemp)
   ! internals
   integer::iscr,nb,nw,itemp,idis,ix,ie
   real(kr)::enext,h
   iscr=1

   !--loop over the temperatures
   call repoz(nin)
   call tpidio(nin,0,0,a(iscr),nb,nw)
   itemp=0
   do while (itemp.lt.ntemp)
      itemp=itemp+1
      call findf(matd,3,1,nin)
      ihave=0
      mth=1
      do while (mth.ne.0)
         call contio(nin,0,0,a(iscr),nb,nw)
         if (mth.ne.0) then
            ix=0
            if (mth.eq.301) ix=1
            if (mth.eq.302) ix=2
            if (mth.eq.318) ix=3
            if (mth.eq.402) ix=4
            if (ix.gt.0) then
               e=0
               call gety1(e,enext,idis,h,nin,a(iscr))
               if (ix.eq.1) ihave=1
               if (ix.gt.1) ihave=2
               do ie=1,nunr
                  e=abs(eunr(ie))
                  call gety1(e,enext,idis,h,nin,a(iscr))
                  heat(ix,ie,itemp)=h
               enddo
            endif
            call tosend(nin,0,0,a(iscr))
         endif
      enddo
      call tomend(nin,0,0,a(iscr))
   enddo
   call repoz(nin)
   return
   end subroutine rdheat

   subroutine unresx(ee,tt)
   !-------------------------------------------------------------------
   ! Construct ladder parameters, infinite-dilution cross sections,
   ! and potential scattering for this energy.
   !-------------------------------------------------------------------
   use util    ! provides error
   use endf    ! provides terpa
   use physics ! provides pi,amassn,amu,hbar,ev
   ! externals
   real(kr)::ee,tt
   ! internals
   integer::i,isect,mode,inow,lfw,nls,ne,iest,l,njs,ll,j
   integer::ifst,int,lu,mu,nu,ip,ir,iro,idx
   real(kr)::cwaven,k,t,abn,ay,spi,awri,aaa,enx
   real(kr)::rat,aw,aa,e2,ab,rho,rhoc,amux,gxx,amuf,dx,aj
   real(kr)::amun,gnox,ggx,gfx,vl,ps,gj,gnx,tp,gs,gc,gf,temp
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::con1=2901.34e0_kr
   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--initialize
   e=abs(ee)
   t=tt
   spot=0
   dbarin=0
   nseq0=0
   sigi(1)=0
   sigi(2)=0
   sigi(3)=0
   sigi(4)=0
   lfw=0
   vl=0.
   ps=0.
   ne=0
   iest=0
   aa=0.

   !--find sections of resonance parameters which contribute
   do i=1,nsect
      isect=i
      abn=abnt(i)
      mode=modet(i)
      if ((e.ge.elt(i).and.e.le.eht(i)).and.&
        (mode.eq.5.or.mode.eq.6)) then

         !--retrieve starting location in storage for this section
         inow=ibaset(isect)

         !--retrieve nuclide information
         if (nro.eq.1) then
            iro=inow
            ip=2
            ir=1
            call terpa(ay,e,enx,idx,arry(iro),ip,ir)
            inow=inow+6+2*nint(arry(iro+4))+2*nint(arry(iro+5))
         else
            ay=arry(inow+1)
         endif
         awri=arry(inow)
         aaa=0
         if (naps.eq.2.and.nro.eq.1) aaa=arry(inow+1)
         spi=arry(inow+2)
         if (mode.ne.6) then
            lfw=nint(arry(inow+3))
            nls=nint(arry(inow+4))
            ne=nint(arry(inow+5))
            inow=inow+6
            ! save starting location for fission width energies
            if (lfw.ne.0) then
               iest=inow
               inow=inow+ne
            endif
         else
            nls=nint(arry(inow+3))
            inow=inow+4
         endif

         !--calculate nuclide dependent parameters
         rat=awri/(awri+1)
         aw=awri*amassn
         if (naps.eq.0) then
            aa=rc1*aw**third+rc2
         elseif (naps.eq.1) then
            aa=ay
         else if (naps.eq.2 .and. nro.eq.1) then
            aa=aaa
         else
            call error('unresx','illegal naps',' ')
         endif
         e2=sqrt(e)
         k=cwaven*rat*e2
         ab=4*pi/k**2
         rho=k*aa
         rhoc=k*ay

         !--loop over all sequences (l,j) in this section
         do l=1,nls
            njs=nint(arry(inow))
            ll=nint(arry(inow+1))
            inow=inow+2
            do j=1,njs

               !--retrieve parameters for this sequence
               if (mode.ne.6) then
                  amux=0
                  gxx=0
                  if (lfw.eq.0) then
                     amuf=0
                     dx=arry(inow)
                     aj=arry(inow+1)
                     amun=arry(inow+2)
                     gnox=arry(inow+3)
                     ggx=arry(inow+4)
                     gfx=0
                     inow=inow+5
                  else
                     amuf=arry(inow)
                     dx=arry(inow+1)
                     aj=arry(inow+2)
                     amun=arry(inow+3)
                     gnox=arry(inow+4)
                     ggx=arry(inow+5)
                     inow=inow+6
                     ! interpolate for fission width at this energy
                     ifst=inow
                     call intrf2(e,gfx,iest,ifst,ne,2,arry)
                     inow=inow+ne
                  endif
               else
                  aj=arry(inow)
                  int=nint(arry(inow+1))
                  ne=nint(arry(inow+2))
                  amux=arry(inow+3)
                  amun=arry(inow+4)
                  amuf=arry(inow+6)
                  inow=inow+7
                  ! interpolate for parameters at this energy
                  call intr2(e,dx,gxx,gnox,ggx,gfx,inow,ne,int,arry)
                  inow=inow+6*ne
               endif

               !--calculate penetrability and phase shifts
               call unfac2(ll,rho,rhoc,amun,vl,ps)
               gj=(2*aj+1)/(4*spi+2)
               gnx=gnox*vl*e2*amun

               !--compute potential scattering
               if (j.eq.1) then
                  spot=spot+abn*ab*(2*ll+1)*sin(ps)**2
               endif

               !--store ladder parameters
               dbarin=dbarin+1/dx
               lu=nint(amux)
               mu=nint(amuf)
               nu=nint(amun)
               gnx=gnx/nu
               if (mu.le.0) gfx=0
               if (lu.le.0) gxx=0
               nseq0=nseq0+1
               if (nseq0.gt.mxns0) call error('unresx',&
                 'too many sequences, increase mxns0',' ')
               csz(nseq0)=abn*ab*gj
               tp=t
               if (tp.eq.0) tp=1
               cth(nseq0)=sqrt(con1*awri/(e*tp))
               cc2p(nseq0)=cos(2*ps)
               cs2p(nseq0)=sin(2*ps)
               cgn(nseq0)=gnx
               cgg(nseq0)=ggx
               cgf(nseq0)=gfx
               cgx(nseq0)=gxx
               cgt(nseq0)=gnx+ggx+gfx+gxx
               ndfn(nseq0)=nu
               ndff(nseq0)=mu
               ndfx(nseq0)=lu
               dbar(nseq0)=dx

               !--compute infinite dilution cross sections
               call gnrx(gnx,gfx,ggx,nu,mu,lu,gs,gxx,1)
               call gnrx(gnx,gfx,ggx,nu,mu,lu,gc,gxx,2)
               call gnrx(gnx,gfx,ggx,nu,mu,lu,gf,gxx,3)
               temp=abn*pi*ab*gj*gnx/(2*dx)
               sigi(2)=sigi(2)+temp*(gs*gnx-2*sin(ps)**2)
               sigi(3)=sigi(3)+temp*gf*gfx
               sigi(4)=sigi(4)+temp*gc*ggx
            enddo
         enddo
      endif
   enddo

   return
   end subroutine unresx

   subroutine unfac2(l,rho,rhoc,amun,vl,ps)
   !-------------------------------------------------------------------
   ! Calculates the penetrability factor (vl) and phase shift (ps)
   !-------------------------------------------------------------------
   ! externals
   integer::l
   real(kr)::rho,rhoc,amun,vl,ps
   ! internals
   real(kr)::r2,r4

   if (l.eq.0) then
      vl=amun
      ps=rhoc
   else if (l.eq.1) then
      r2=rho*rho
      vl=amun*r2/(1+r2)
      ps=rhoc-atan(rhoc)
   else if (l.eq.2) then
      r2=rho*rho
      r4=r2*r2
      vl=amun*r4/(9+3*r2+r4)
      ps=rhoc-atan(3*rhoc/(3-rhoc*rhoc))
   endif
   return
   end subroutine unfac2

   subroutine intrf2(e,gfx,iest,ifst,ne,int,a)
   !-------------------------------------------------------------------
   ! Interpolates fission widths for unresolved representation 1.
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   integer::iest,ifst,ne,int
   real(kr)::e,gfx,a(*)
   ! internals
   integer::i,idone,i1,i2

   i=1
   idone=0
   i1=0
   i2=0
   do while (i.lt.ne.and.idone.eq.0)
      i=i+1
      i1=iest+i-1
      i2=ifst+i-1
      if (e.lt.a(i1)) idone=1
   enddo
   call terp1(a(i1-1),a(i2-1),a(i1),a(i2),e,gfx,int)
   return
   end subroutine intrf2

   subroutine intr2(e,dx,gxx,gnox,ggx,gfx,inow,ne,int,a)
   !-------------------------------------------------------------------
   ! Interpolates energy dependent unresolved resonance parameters.
   !-------------------------------------------------------------------
   use endf ! provides terp
   ! externals
   integer::inow,ne,int
   real(kr)::e,dx,gxx,gnox,ggx,gfx,a(*)
   ! internals
   integer::i1,i,idone,i2
   real(kr),parameter::small=1.e-8_kr

   i1=inow
   i2=0
   i=1
   idone=0
   do while (i.lt.ne.and.idone.eq.0)
      i=i+1
      i2=i1+6
      if (e.lt.a(i2)) then
         idone=1
      else
         if (i.lt.ne) i1=i2
      endif
   enddo
   call terp1(a(i1),a(i1+1),a(i2),a(i2+1),e,dx,int)
   call terp1(a(i1),a(i1+2),a(i2),a(i2+2),e,gxx,int)
   call terp1(a(i1),a(i1+3),a(i2),a(i2+3),e,gnox,int)
   call terp1(a(i1),a(i1+4),a(i2),a(i2+4),e,ggx,int)
   call terp1(a(i1),a(i1+5),a(i2),a(i2+5),e,gfx,int)
   if (gxx.lt.small) gxx=0
   if (gfx.lt.small) gfx=0
   return
   end subroutine intr2

   subroutine gnrx(galpha,gbeta,gamma,mu,nu,lamda,s,df,id)
   !-------------------------------------------------------------------
   ! Calculates fluctuation integrals for unresolved resonances
   ! using MC2-2 quadrature scheme.
   !-------------------------------------------------------------------
   ! externals
   integer::mu,nu,lamda,id
   real(kr)::galpha,gbeta,gamma,s,df
   ! internals
   integer::j,k,l
   real(kr)::xj,wj,xk,wk,xl,wl
   real(kr),dimension(10,4),parameter::qw=reshape((/&
     1.1120413e-1_kr,2.3546798e-1_kr,2.8440987e-1_kr,2.2419127e-1_kr,&
     .10967668e0_kr,.030493789e0_kr,.0042930874e0_kr,2.5827047e-4_kr,&
     4.9031965e-6_kr,1.4079206e-8_kr,.033773418e0_kr,.079932171e0_kr,&
     .12835937e0_kr,.17652616e0_kr,.21347043e0_kr,.21154965e0_kr,&
     .13365186e0_kr,.022630659e0_kr,1.6313638e-5_kr,2.745383e-31_kr,&
     3.3376214e-4_kr,.018506108e0_kr,.12309946e0_kr,.29918923e0_kr,&
     .33431475e0_kr,.17766657e0_kr,.042695894e0_kr,4.0760575e-3_kr,&
     1.1766115e-4_kr,5.0989546e-7_kr,1.7623788e-3_kr,.021517749e0_kr,&
     .080979849e0_kr,.18797998e0_kr,.30156335e0_kr,.29616091e0_kr,&
     .10775649e0_kr,2.5171914e-3_kr,8.9630388e-10_kr,0.e0_kr/),&
     (/10,4/))
   real(kr),dimension(10,4),parameter::qp=reshape((/&
     3.0013465e-3_kr,7.8592886e-2_kr,4.3282415e-1_kr,1.3345267e0_kr,&
     3.0481846e0_kr,5.8263198e0_kr,9.9452656e0_kr,1.5782128e+1_kr,&
     23.996824e0_kr,36.216208e0_kr,1.3219203e-2_kr,7.2349624e-2_kr,&
     .19089473e0_kr,.39528842e0_kr,.74083443e0_kr,1.3498293e0_kr,&
     2.5297983e0_kr,5.2384894e0_kr,13.821772e0_kr,75.647525e0_kr,&
     1.0004488e-3_kr,.026197629e0_kr,.14427472e0_kr,.44484223e0_kr,&
     1.0160615e0_kr,1.9421066e0_kr,3.3150885e0_kr,5.2607092e0_kr,&
     7.9989414e0_kr,12.072069e0_kr,.013219203e0_kr,.072349624e0_kr,&
     .19089473e0_kr,.39528842e0_kr,.74083443e0_kr,1.3498293e0_kr,&
     2.5297983e0_kr,5.2384894e0_kr,13.821772e0_kr,75.647525e0_kr/),&
     (/10,4/))
   real(kr),parameter::zero=0

   s=0
   if (galpha.le.zero) return
   if (gamma.le.zero) return
   if (gbeta.lt.zero) return
   if (gbeta.le.zero.and.df.lt.zero) return
   if (gbeta.le.zero) then
      if (df.le.zero) then
         do j=1,10
            xj=qp(j,mu)
            wj=qw(j,mu)
            if (id.eq.1) then
               s=s+wj*xj*xj/(galpha*xj+gamma)
            else if (id.eq.2) then
               s=s+wj*xj/(galpha*xj+gamma)
            endif
         enddo
      else
         do j=1,10
            xj=qp(j,mu)
            wj=qw(j,mu)
            do k=1,10
               xk=qp(k,lamda)
               wk=qw(k,lamda)
               if (id.eq.1) then
                  s=s+wj*wk*xj*xj/(galpha*xj+gamma+df*xk)
               else if (id.eq.2) then
                  s=s+wj*wk*xj/(galpha*xj+gamma+df*xk)
               endif
            enddo
         enddo
      endif
   else
      if (df.le.zero) then
         if (df.ge.zero) then
            do j=1,10
               xj=qp(j,mu)
               wj=qw(j,mu)
               do k=1,10
                  xk=qp(k,nu)
                  wk=qw(k,nu)
                  if (id.eq.1) then
                     s=s+wj*wk*xj*xj/(galpha*xj+gbeta*xk+gamma)
                  else if (id.eq.2) then
                     s=s+wj*wk*xj/(galpha*xj+gbeta*xk+gamma)
                  else if (id.eq.3) then
                     s=s+wj*wk*xj*xk/(galpha*xj+gbeta*xk+gamma)
                  endif
               enddo
            enddo
         endif
      else
         do j=1,10
            xj=qp(j,mu)
            wj=qw(j,mu)
            do k=1,10
               xk=qp(k,nu)
               wk=qw(k,nu)
               do l=1,10
                  xl=qp(l,lamda)
                  wl=qw(l,lamda)
                  if (id.eq.1) then
                     s=s+wj*wk*wl*xj*xj&
                       /(galpha*xj+gbeta*xk+gamma+df*xl)
                  else if (id.eq.2) then
                     s=s+wj*wk*wl*xj&
                       /(galpha*xj+gbeta*xk+gamma+df*xl)
                  else if (id.eq.3) then
                     s=s+wj*wk*wl*xj*xk&
                       /(galpha*xj+gbeta*xk+gamma+df*xl)
                  endif
               enddo
            enddo
         enddo
      endif
   endif
   end subroutine gnrx

   subroutine ladr2(nseqz,elow,ehigh,nr,er,gnr,gfr,ggr,gxr,gt)
   !-------------------------------------------------------------------
   ! Generate ladders of statistically chosen resonances from
   ! average resonance data from ENDF data.
   !-------------------------------------------------------------------
   use physics ! provides pi
   use util ! provides error
   ! externals
   integer::nseqz,nr
   real(kr)::elow,ehigh,gg,gf,gx,gn,xr,dn
   real(kr)::er(*),gnr(*),gfr(*),ggr(*),gxr(*),gt(*)
   ! internals
   integer::nr0,ir,idone,ndf,i,n
   real(kr)::dcon
   real(kr),dimension(20,4),parameter::chisq=reshape((/&
     1.31003e-3_kr,9.19501e-3_kr,.0250905e0_kr,.049254e0_kr,&
     .0820892e0_kr,.124169e0_kr,.176268e0_kr,.239417e0_kr,&
     .314977e0_kr,.404749e0_kr,.511145e0_kr,.637461e0_kr,&
     .788315e0_kr,.970419e0_kr,1.194e0_kr,1.47573e0_kr,&
     1.84547e0_kr,2.36522e0_kr,3.20371e0_kr,5.58201e0_kr,&
     .0508548e0_kr,.156167e0_kr,.267335e0_kr,.38505e0_kr,&
     .510131e0_kr,.643564e0_kr,.786543e0_kr,.940541e0_kr,&
     1.1074e0_kr,1.28947e0_kr,1.48981e0_kr,1.71249e0_kr,&
     1.96314e0_kr,2.24984e0_kr,2.58473e0_kr,2.98744e0_kr,&
     3.49278e0_kr,4.17238e0_kr,5.21888e0_kr,7.99146e0_kr,&
     .206832e0_kr,.470719e0_kr,.691933e0_kr,.901674e0_kr,&
     1.10868e0_kr,1.31765e0_kr,1.53193e0_kr,1.75444e0_kr,&
     1.98812e0_kr,2.23621e0_kr,2.50257e0_kr,2.79213e0_kr,&
     3.11143e0_kr,3.46967e0_kr,3.88053e0_kr,4.36586e0_kr,&
     4.96417e0_kr,5.75423e0_kr,6.94646e0_kr,10.0048e0_kr,&
     .459462e0_kr,.893735e0_kr,1.21753e0_kr,1.50872e0_kr,&
     1.78605e0_kr,2.05854e0_kr,2.33194e0_kr,2.61069e0_kr,&
     2.89878e0_kr,3.20032e0_kr,3.51995e0_kr,3.86331e0_kr,&
     4.23776e0_kr,4.65345e0_kr,5.12533e0_kr,5.67712e0_kr,&
     6.35044e0_kr,7.22996e0_kr,8.541e0_kr,11.8359e0_kr/),(/20,4/))
   real(kr),parameter::start=19.9999e0_kr
   real(kr),parameter::zero=0.e0_kr
     real(kr)::rnsum
     rnsum=0

   !--select resonance parameters
   !--until resonance energy is above ehi
   dcon=dbar(nseqz)*sqrt(4/pi)
   nr0=0
   ir=nr0
   idone=0
   do while (idone.eq.0)
      ir=ir+1
      if (ir.gt.nermax) call error('ladr2',&
        'too many resonances in ladder',' ')
      if (ir.ne.nr0+1) then
         ! select next resonance location from wigner distribution
         rr=rann(kk)
         er(ir)=er(ir-1)+dcon*sqrt(-log(rr))
      else
         ! choose starting point from uniform distribution
         rr=rann(kk)
         er(ir)=elow+dcon*rr
      endif

      !--select level widths
      i=nseqz
      gg=cgg(i)
      gf=cgf(i)
      gx=cgx(i)
      gn=cgn(i)
      ! choose neutron width for ndn degrees of freedom
      ndf=ndfn(i)
      if (ndf.gt.0) gn=gn/ndf
      n=int(1+start*rann(kk))
         rnsum=rnsum+n
      xr=chisq(n,ndf)
      gn=gn*xr
      ! choose fission width for ndf degrees of freedom
      if (cgf(i).ne.zero.and.ndff(i).ne.0) then
         ndf=ndff(i)
         if (ndf.gt.0) gf=gf/ndf
         n=int(1+start*rann(kk))
         xr=chisq(n,ndf)
         gf=gf*xr
      endif
      ! choose competitive width for ndx degrees of freedom
      if (cgx(i).ne.zero.and.ndfx(i).ne.0) then
         ndf=ndfx(i)
         if (ndf.gt.0) gx=gx/ndf
         dn=20
         dn=dn-dn/10000
         n=int(1+dn*rann(kk))
         xr=chisq(n,ndf)
         gx=gx*xr
      endif
      gt(ir)=gn+gf+gg+gx
      gnr(ir)=gn/gt(ir)
      gfr(ir)=gf/gt(ir)
      ggr(ir)=gg/gt(ir)
      gxr(ir)=gx/gt(ir)
      if (er(ir).gt.ehigh) idone=1
   enddo
   nr=ir-1
   return
   end subroutine ladr2

   subroutine unrest(bkg,sig0,sigf,tabl,tval,er,gnr,gfr,ggr,gxr,gt,&
     es,xs,cap,fis,els,temp,nsig0,ntemp,nbin,nsamp)
   !-------------------------------------------------------------------
   ! Probability tables and Bondarenko moments.
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use physics ! provides pi
   use util ! provides timer
   ! externals
   integer::nsig0,ntemp,nbin,nsamp
   real(kr)::bkg(4),sig0(nsig0),tval(nbin,ntemp)
   real(kr)::sigf(5,nsig0,ntemp),tabl(nbin,5,ntemp)
   real(kr)::er(*),gnr(*),gfr(*),ggr(*),gxr(*),gt(*)
   real(kr)::es(nsamp),xs(nsamp)
   real(kr)::cap(ntemp,nsamp),fis(ntemp,nsamp),els(ntemp,nsamp)
   real(kr)::temp(ntemp)
   ! internals
   integer::navoid,i,nres,nrest,iladr,ne,ie,itemp,k,nr,jr
   integer::i7,i0,it,i6,i1,i5,i2,is,i4,i3,jj,j,n,ii
   integer::ixx,l,mfl,nebin,ibin,izeroprob,ibadxs
   real(kr)::rpi,binmin,elow,dmin,erange,ehigh,emin,emax,espan
   real(kr)::dbart,sigx,ctx,chek1,chek2,chekn,delr,elo,ehi
   real(kr)::y,yy,szy,cc2,cs2,ccg,ccf,test,x,a1,rew,aimw
   real(kr)::a2,a3,temp1,temp2,a4,a5,f1,f2,a6,e1,e2,e3
   real(kr)::tempor,q,q2,hq,hq2,ax,aki,p,p2,hp,hp2,pq,tav
   real(kr)::tvar,eav,evar,fav,fvar,cav,cvar,totf,elsf,capf,fisf
   real(kr)::efact,cfact,ffact
   real(kr)::tot,tem,argt,arge,argf,argc,tnorm,enorm
   real(kr)::fnorm,cnorm,denom,den,ttt
   character(3),dimension(4),parameter::nmr=(/&
     'tot','els','fis','cap'/)
   character(60)::strng
   real(kr),parameter::c1=0.5641895835e0_kr
   real(kr),parameter::c2=0.2752551e0_kr
   real(kr),parameter::c3=2.724745e0_kr
   real(kr),parameter::c4=0.5124242e0_kr
   real(kr),parameter::c5=0.05176536e0_kr
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::ten=10.0e0_kr
   real(kr),parameter::d1=0.4613135e0_kr
   real(kr),parameter::d2=0.1901635e0_kr
   real(kr),parameter::d3=0.09999216e0_kr
   real(kr),parameter::d4=1.7844927e0_kr
   real(kr),parameter::d5=0.002883894e0_kr
   real(kr),parameter::d6=5.5253437e0_kr
   real(kr),parameter::fifty=50
   real(kr),parameter::con1=31.83e0_kr
   real(kr),parameter::con2=20.e0_kr
   real(kr),parameter::break1=.5e0_kr
   real(kr),parameter::break2=3.9e0_kr
   real(kr),parameter::tref=300.e0_kr
   real(kr),parameter::big=1.e6_kr
   real(kr),parameter::zero=0
   save navoid,binmin,elow
   rpi=sqrt(pi)
   izeroprob=0
   ibadxs=0
   ! data for optional bondarenko plots
   if (ipl.lt.200) ipl=ipl+1
   epl(ipl)=e

   !--initialize
   if (init.eq.0) then
      init=1
      navoid=300
      binmin=spot/10
      elow=10
      if (allocated(bval)) then
         deallocate(bval)
         deallocate(tmin)
         deallocate(tmax)
         deallocate(tsum)
      endif
      allocate(bval(8,nsig0,ntemp))
      allocate(tmin(ntemp))
      allocate(tmax(ntemp))
      allocate(tsum(ntemp))
   endif
   dmin=100000
   do i=1,nseq0
      if (dbar(i).lt.dmin) dmin=dbar(i)
   enddo
   erange=9*nermax*dmin/10
   nres=int(erange*dbarin)
   nrest=nres-2*navoid
   ehigh=elow+erange
   emin=elow+navoid/dbarin
   emax=ehigh-navoid/dbarin
   espan=emax-emin
   if ((nres.le.zero).or.(emax.lt.emin)) then
      call error('unrest','bad value for nres or emin>emax, increase dmin','')
   endif
   dbart=1/dbarin
   sigx=bkg(1)-bkg(2)-bkg(3)-bkg(4)
   do itemp=1,ntemp
      do i=nsig0,1,-1
         do j=1,8
            bval(j,i,itemp)=0
         enddo
      enddo
   enddo

   if (iprint.gt.0) then
      write(nsyso,'(/,1p,''e='',e11.4,&
        &2x,''spot='',e11.4,2x,''dbar='',e11.4,2x,''sigx='',e11.4/&
        &13x,''total'',5x,''elastic'',5x,''fission'',5x,&
        &''capture'')') e,spot,dbart,sigx
   endif

   !--loop over ladders
   !--use first pass to set prob table limits
   do 150 iladr=1,nladr
   ne=nsamp

   !--choose random energy grid
   do ie=1,ne
      rr=rann(kk)
      es(ie)=emin+espan*rr
      do itemp=1,ntemp
         cap(itemp,ie)=0
         fis(itemp,ie)=0
         els(itemp,ie)=spot
      enddo
   enddo
   call fsort(es,xs,ne,1)

   !--loop over sequences
   do 170 k=1,nseq0
   call ladr2(k,elow,ehigh,nr,er,gnr,gfr,ggr,gxr,gt)

   !--loop over temperatures
   do 180 itemp=1,ntemp
   ctx=cth(k)*sqrt(tref/temp(itemp))

   !--accumulate contributions to cross sections
   do 210 jr=1,nr
   chek1=con1*gt(jr)
   chek2=con2/ctx
   chekn=chek1
   if (chek2.gt.chek1) chekn=chek2
   delr=chek1+chekn
   elo=er(jr)-delr
   ehi=er(jr)+delr
   call fsrch(ehi,es,ne,i7,mfl)
   call fsrch(elo,es,i7,i0,mfl)
   if (i0.eq.i7) go to 210
   it=i7-i0+1
   y=ctx*gt(jr)/2
   yy=y*y
   szy=csz(k)*gnr(jr)*rpi*y
   cc2=szy*(cc2p(k)-1+gnr(jr))
   cs2=szy*cs2p(k)
   ccg=szy*ggr(jr)
   ccf=szy*gfr(jr)
   do ie=i0,i7
      xs(ie)=ctx*(es(ie)-er(jr))
   enddo

   !--accumulate cross sections using an
   !--appropriate approximation in each range

    !  asymptotic term for x.gt.100 or y.gt.100

   i6=i0-1
   test=100
   if (y.gt.test) go to 340
   call fsrch(-test,xs(i0),it,i1,mfl)
   if (i1.eq.1.and.mfl.eq.2) i1=0
   i1=i1+i0-1
   if (i1.lt.i0) i1=i0-1
   if (i1.le.i0) go to 240
   do ie=i0,i1
      x=xs(ie)
      test=x*x+yy
      a1=c1/test
      rew=y*a1
      aimw=x*a1
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i1.ge.i7) go to 370

     ! rational approximation for x.gt.6 or y.gt.6 but x and y .le.100

  240 continue
   i5=i1
   test=6
   if (y.gt.test) go to 330
   test=-6
   call fsrch(test,xs(i0),it,i2,mfl)
   if (i2.eq.1.and.mfl.eq.2) i2=0
   i2=i2+i0-1
   if (i2.lt.i1) i2=i1
   if (i2.le.i1) go to 250
   is=i1+1
   do ie=is,i2
      x=xs(ie)
      a1=x*x-yy
      a2=2*x*y
      a3=a2*a2
      temp1=a2*x
      temp2=a2*y
      a4=a1-c2
      a5=a1-c3
      f1=c4/(a4*a4+a3)
      f2=c5/(a5*a5+a3)
      rew=f1*(temp1-a4*y)+f2*(temp1-a5*y)
      aimw=f1*(a4*x+temp2)+f2*(a5*x+temp2)
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i2.ge.i7) go to 370

     ! rational approximation for x.gt.3.9 or y.gt.3.0 but x and y .le.6

  250 continue
   i4=i2
   test=3
   if (y.gt.test) go to 320
   test=-break2
   call fsrch(test,xs(i0),it,i3,mfl)
   if (i3.eq.1.and.mfl.eq.2) i3=0
   i3=i3+i0-1
   if (i3.lt.i2) i3=i2
   if (i3.le.i2) go to 260
   is=i2+1
   do ie=is,i3
      x=xs(ie)
      a1=x*x-yy
      a2=2*x*y
      a3=a2*a2
      temp1=a2*x
      temp2=a2*y
      a4=a1-d2
      a5=a1-d4
      a6=a1-d6
      e1=d1/(a4*a4+a3)
      e2=d3/(a5*a5+a3)
      e3=d5/(a6*a6+a3)
      rew=e1*(temp1-a4*y)+e2*(temp1-a5*y)+e3*(temp1-a6*y)
      aimw=e1*(a4*x+temp2)+e2*(a5*x+temp2)+e3*(a6*x+temp2)
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i3.ge.i7) go to 370

     ! six point table interpolation for 0.le.abs(x).le.3.9

  260 continue
   test=break2
   call fsrch(test,xs(i0),it,i4,mfl)
   if (i4.eq.1.and.mfl.eq.2) i4=0
   i4=i4+i0-1
   if (i4.lt.i3) i4=i3
   if (i4.le.i3) go to 320
   is=i3+1

     ! y.ge.0.5

   if (y.lt.break1) go to 310
   tempor=ten*y
   jj=int(tempor)
   j=jj-3
   n=j-1
   q=tempor-jj
   q2=q*q
   hq=half*q
   hq2=half*q2
   a1=hq2-hq
   do ie=is,i4
      x=xs(ie)
      ax=abs(x)
      aki=1
      if (x.lt.zero) aki=-1
      tempor=ten*ax
      ii=int(tempor)
      i=ii+2
      p=tempor-ii
      p2=p*p
      hp=half*p
      hp2=half*p2
      a2=hp2-hp
      pq=p*q
      a3=1+pq-p2-q2
      a4=hp2-pq+hp
      a5=hq2-pq+hq
      rew=a1*tr(i,n)+a2*tr(i-1,j)+a3*tr(i,j)+a4*tr(i+1,j)&
        +a5*tr(i,j+1)+pq*tr(i+1,j+1)
      aimw=a1*ti(i,n)+a2*ti(i-1,j)+a3*ti(i,j)+a4*ti(i+1,j)&
        +a5*ti(i,j+1)+pq*ti(i+1,j+1)
      aimw=aimw*aki
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i4.ge.i7) go to 370
   go to 320

     ! y.lt.0.5

  310 continue
   tempor=fifty*y
   jj=int(tempor)
   j=jj+2
   n=j-1
   q=tempor-jj
   q2=q*q
   hq=half*q
   hq2=half*q2
   a1=hq2-hq
   do ie=is,i4
      x=xs(ie)
      ax=abs(x)
      aki=1
      if (x.lt.zero) aki=-1
      tempor=ten*ax
      ii=int(tempor)
      i=ii+2
      p=tempor-ii
      p2=p*p
      hp=half*p
      hp2=half*p2
      a2=hp2-hp
      pq=p*q
      a3=1+pq-p2-q2
      a4=hp2-pq+hp
      a5=hq2-pq+hq
      rew=a1*trs(i,n)+a2*trs(i-1,j)+a3*trs(i,j)+a4*trs(i+1,j)+&
        a5*trs(i,j+1)+pq*trs(i+1,j+1)
      aimw=a1*tis(i,n)+a2*tis(i-1,j)+a3*tis(i,j)+a4*tis(i+1,j)+&
        a5*tis(i,j+1)+pq*tis(i+1,j+1)
      aimw=aimw*aki
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i4.ge.i7) go to 370

   ! rational approximation for x.gt.3.9 or y.gt.3.0 but x and y .le.6

  320 continue
   test=6
   call fsrch(test,xs(i0),it,i5,mfl)
   if (i5.eq.1.and.mfl.eq.2) i5=0
   i5=i5+i0-1
   if (i5.lt.i4) i5=i4
   if (i5.le.i4) go to 330
   is=i4+1
   do ie=is,i5
      x=xs(ie)
      a1=x*x-yy
      a2=2*x*y
      a3=a2*a2
      temp1=a2*x
      temp2=a2*y
      a4=a1-d2
      a5=a1-d4
      a6=a1-d6
      e1=d1/(a4*a4+a3)
      e2=d3/(a5*a5+a3)
      e3=d5/(a6*a6+a3)
      rew=e1*(temp1-a4*y)+e2*(temp1-a5*y)+e3*(temp1-a6*y)
      aimw=e1*(a4*x+temp2)+e2*(a5*x+temp2)+e3*(a6*x+temp2)
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i5.ge.i7) go to 370

   ! rational approximation for x.gt.6 or y.gt.6 but x and y .le.100

  330 continue
   test=100
   call fsrch(test,xs(i0),it,i6,mfl)
   if (i6.eq.1.and.mfl.eq.2) i6=0
   i6=i6+i0-1
   if (i6.lt.i5) i6=i5
   if (i6.le.i5) go to 340
   is=i5+1
   do ie=is,i6
      x=xs(ie)
      a1=x*x-yy
      a2=2*x*y
      a3=a2*a2
      temp1=a2*x
      temp2=a2*y
      a4=a1-c2
      a5=a1-c3
      f1=c4/(a4*a4+a3)
      f2=c5/(a5*a5+a3)
      rew=f1*(temp1-a4*y)+f2*(temp1-a5*y)
      aimw=f1*(a4*x+temp2)+f2*(a5*x+temp2)
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
   if (i6.ge.i7) go to 370

    ! asymptotic term for x.gt.100 or y.gt.100

  340 continue
   is=i6+1
   do ie=is,i7
      x=xs(ie)
      test=x*x+yy
      a1=c1/test
      rew=y*a1
      aimw=x*a1
      cap(itemp,ie)=cap(itemp,ie)+ccg*rew
      fis(itemp,ie)=fis(itemp,ie)+ccf*rew
      els(itemp,ie)=els(itemp,ie)+cc2*rew+cs2*aimw
   enddo
  370 continue

   !--close loops over resonances and sequences
  210 continue
  180 continue
  170 continue

   !--eliminate negative elastic cross sections; reset to 1 microbarn
   do itemp=1,ntemp
      do ie=1,ne
         if (els(itemp,ie).lt.-bkg(2)) els(itemp,ie)=-bkg(2)+1/big
      enddo
   enddo

   !--compute infinitely-dilute cross sections
   if (iladr.eq.1) then
      tav=0
      tvar=0
      eav=0
      evar=0
      fav=0
      fvar=0
      cav=0
      cvar=0
   endif
   totf=0
   elsf=0
   capf=0
   fisf=0
   do ie=1,ne
      totf=totf+els(1,ie)+fis(1,ie)+cap(1,ie)+bkg(1)
      elsf=elsf+els(1,ie)+bkg(2)
      capf=capf+cap(1,ie)+bkg(4)
      fisf=fisf+fis(1,ie)+bkg(3)
   enddo
   totf=totf/ne
   elsf=elsf/ne
   capf=capf/ne
   fisf=fisf/ne
   tav=tav+totf
   tvar=tvar+totf*totf
   eav=eav+elsf
   evar=evar+elsf*elsf
   fav=fav+fisf
   fvar=fvar+fisf*fisf
   cav=cav+capf
   cvar=cvar+capf*capf
   if (iprint.gt.0) write(nsyso,'(i6,1p,4e12.4)')&
     iladr,totf,elsf,fisf,capf

   !--renormalize reaction cross sections
   !--compute total cross section
   if (nmode.eq.1) then
      efact=(sigi(2)+bkg(2))/(elsf-spot)
      cfact=(sigi(4)+bkg(4))/capf
      ffact=1
      if (fisf.ne.zero) ffact=(sigi(3)+bkg(3))/fisf
      do ie=1,ne
         do itemp=1,ntemp
            els(itemp,ie)=spot+(els(itemp,ie)-spot)*efact
            cap(itemp,ie)=cap(itemp,ie)*cfact
            fis(itemp,ie)=fis(itemp,ie)*ffact
         enddo
      enddo
   endif

   !--loop over temperatures
   !--using a different total cross section bin structure for each
   do 140 itemp=1,ntemp

   !--choose probability table bounds
   !--and zero accumulators
   if (iladr.eq.1) then
      do ie=1,ne
         es(ie)=els(itemp,ie)+fis(itemp,ie)+cap(itemp,ie)+bkg(1)
      enddo
      call fsort(es,xs,ne,1)
      tmin(itemp)=es(1)
      tmax(itemp)=es(ne)
      nebin=int(nsamp/(nbin-10+1.76))
      ibin=nebin/200
      if (ibin.le.0) then
         if (mflg1.eq.0) then
            mflg1=1
            write(strng,'(''reset ibin=1, consider larger nsamp'',&
                         &'' or smaller nbin'')')
            call mess('purr',strng,'')
         endif
         ibin=1
      endif
      do i=1,nbin-1
         if (ibin.gt.nsamp) then
            if (mflg2.eq.0) then
               mflg2=1
               write(strng,'(''reset ibin=nsamp,'',&
                            &'' consider smaller nbin'')')
               call mess('purr',strng,'')
            endif
            ibin=nsamp
         endif
         tval(i,itemp)=es(ibin)
         if (i.gt.1) then
            if (tval(i,itemp).le.tval(i-1,itemp))&
              tval(i,itemp)=tval(i-1,itemp)+tval(i-1,itemp)/20
         endif
         if (i.eq.1) ibin=ibin+nebin/40
         if (i.eq.2) ibin=ibin+nebin/10
         if (i.eq.3) ibin=ibin+nebin/4
         if (i.eq.4) ibin=ibin+nebin/2
         if (i.gt.4.and.i.lt.nbin-5) ibin=ibin+nebin
         if (i.eq.nbin-5) ibin=ibin+nebin/2
         if (i.eq.nbin-4) ibin=ibin+nebin/4
         if (i.eq.nbin-3) ibin=ibin+nebin/10
         if (i.eq.nbin-2) ibin=ibin+nebin/40
         if (i.eq.nbin-1) ibin=ibin+nebin/200
      enddo
      tval(nbin,itemp)=big
      do i=1,nbin
         do j=1,5
            tabl(i,j,itemp)=0
         enddo
      enddo
      tsum(itemp)=0
   endif

   !--accumulate cross sections into tables
   do ie=1,ne
      tot=els(itemp,ie)+fis(itemp,ie)+cap(itemp,ie)+bkg(1)
      if (tot.lt.tmin(itemp)) tmin(itemp)=tot
      if (tot.gt.tmax(itemp)) tmax(itemp)=tot
      call fsrch(tot,tval(1,itemp),nbin,ii,mfl)
      if (mfl.ne.2.and.ii.lt.nbin) ii=ii+1
      if (ii.lt.1) ii=1
      tsum(itemp)=tsum(itemp)+1
      tabl(ii,1,itemp)=tabl(ii,1,itemp)+1
      tabl(ii,2,itemp)=tabl(ii,2,itemp)+tot
      tabl(ii,3,itemp)=tabl(ii,3,itemp)+els(itemp,ie)+bkg(2)
      tabl(ii,4,itemp)=tabl(ii,4,itemp)+fis(itemp,ie)+bkg(3)
      tabl(ii,5,itemp)=tabl(ii,5,itemp)+cap(itemp,ie)+bkg(4)
      do i=1,nsig0
         tem=sig0(i)/(sig0(i)+tot)
         bval(1,i,itemp)=bval(1,i,itemp)+tot*tem
         bval(2,i,itemp)=bval(2,i,itemp)+(els(itemp,ie)+bkg(2))*tem
         bval(3,i,itemp)=bval(3,i,itemp)+(fis(itemp,ie)+bkg(3))*tem
         bval(4,i,itemp)=bval(4,i,itemp)+(cap(itemp,ie)+bkg(4))*tem
         bval(5,i,itemp)=bval(5,i,itemp)+tot*tem*tem
         bval(6,i,itemp)=bval(6,i,itemp)+tem
         bval(7,i,itemp)=bval(7,i,itemp)+tem*tem
      enddo
   enddo

   !--close loop over temperatures
  140 continue

   !--close loop over ladders
  150 continue

   !--write overall average cross sections
   tav=tav/nladr
   argt=tvar/nladr-tav*tav
   if (argt.lt.zero) argt=0
   eav=eav/nladr
   arge=evar/nladr-eav*eav
   if (arge.lt.zero) arge=0
   fav=fav/nladr
   argf=fvar/nladr-fav*fav
   if (argf.lt.zero) argf=0
   cav=cav/nladr
   argc=cvar/nladr-cav*cav
   if (argc.lt.zero) argc=0
   tvar=100*sqrt(argt)/tav
   evar=100*sqrt(arge)/eav
   if (fav.ne.zero) fvar=100*sqrt(argf)/fav
   cvar=100*sqrt(argc)/cav
   sigi(1)=sigi(2)+sigi(3)+sigi(4)+spot+bkg(1)
   sigi(2)=sigi(2)+spot+bkg(2)
   sigi(3)=sigi(3)+bkg(3)
   sigi(4)=sigi(4)+bkg(4)
   if (iprint.gt.0) write(nsyso,'(&
     &''  bkgd'',1p,4e12.4/''  infd'',1p,4e12.4/&
     &''  aver'',1p,4e12.4/''  pcsd'',0p,4f12.2/&
     &''  nres'',i12)')&
     (bkg(i),i=1,4),(sigi(i),i=1,4),&
     tav,eav,fav,cav,tvar,evar,fvar,cvar,nrest

   !--compute and write bondarenko table
   if (iprint.gt.0) write(nsyso,'(/&
     &'' bondarenko cross sections by direct sampling''/&
     &9x,''temp'',6x,''sig0'',4x,''p0 total'',5x,&
     &''elastic'',5x,''fission'',5x,''capture'',4x,&
     &''p1 total'')')
   do i=1,nsig0
      do itemp=1,ntemp
         sigf(1,i,itemp)=bval(1,i,itemp)/bval(6,i,itemp)
         sigf(2,i,itemp)=bval(2,i,itemp)/bval(6,i,itemp)
         sigf(3,i,itemp)=bval(3,i,itemp)/bval(6,i,itemp)
         sigf(4,i,itemp)=bval(4,i,itemp)/bval(6,i,itemp)
         sigf(5,i,itemp)=bval(5,i,itemp)/bval(7,i,itemp)
      enddo
   enddo
   if (iprint.gt.0) then
      do itemp=1,ntemp
         do i=1,nsig0
            write(nsyso,'(3x,1p,2e10.3,5e12.4)')&
              temp(itemp),sig0(i),(sigf(j,i,itemp),j=1,5)
         enddo
      enddo
   endif

   !--normalize and write probability table
   if (iprint.gt.0) write(nsyso,'(/'' probability table'')')
   tnorm=sigi(1)-sigf(1,1,1)
   enorm=sigi(2)-sigf(2,1,1)
   fnorm=sigi(3)-sigf(3,1,1)
   cnorm=sigi(4)-sigf(4,1,1)
   tnorm=0
   enorm=0
   fnorm=0
   cnorm=0
   do i=1,nbin
      do itemp=1,ntemp
         tmin(itemp)=tmin(itemp)+tnorm
         tval(nbin,itemp)=tmax(itemp)
         denom=tabl(i,1,itemp)
         if (denom.eq.zero) denom=1
         tabl(i,1,itemp)=tabl(i,1,itemp)/tsum(itemp)
         tabl(i,2,itemp)=tabl(i,2,itemp)/denom
         tabl(i,3,itemp)=tabl(i,3,itemp)/denom
         tabl(i,4,itemp)=tabl(i,4,itemp)/denom
         tabl(i,5,itemp)=tabl(i,5,itemp)/denom
         tabl(i,2,itemp)=tabl(i,2,itemp)-tnorm
         tabl(i,3,itemp)=tabl(i,3,itemp)-enorm
         tabl(i,4,itemp)=tabl(i,4,itemp)-fnorm
         tabl(i,5,itemp)=tabl(i,5,itemp)-cnorm
         if (tabl(i,1,itemp).le.zero) izeroprob=izeroprob+1
         if (tabl(i,2,itemp).lt.zero) ibadxs=ibadxs+1
         if (tabl(i,3,itemp).lt.zero) ibadxs=ibadxs+1
         if (tabl(i,4,itemp).lt.zero) ibadxs=ibadxs+1
         if (tabl(i,5,itemp).lt.zero) ibadxs=ibadxs+1
      enddo
   enddo
   do itemp=1,ntemp
      do ixx=1,4
         if (ixx.eq.1) then
            write(nsyso,'('' tmin'',1p,e11.3,1p,10e11.3)')&
              temp(itemp),tmin(itemp)
            write(nsyso,'('' tmax'',1p,e11.3,1p,10e11.3/(16x,10e11.3))')&
              temp(itemp),(tval(i,itemp),i=1,nbin)
            write(nsyso,'('' prob'',1p,e11.3,1p,10e11.3/(16x,10e11.3))')&
              temp(itemp),(tabl(i,1,itemp),i=1,nbin)
         endif
         write(nsyso,'(1x,a,1x,1p,e11.3,10e11.3/(16x,10e11.3))')&
           nmr(ixx),temp(itemp),(tabl(i,ixx+1,itemp),i=1,nbin)
      enddo
   enddo
   if (izeroprob.gt.0) then
      write(strng,'(''ptable has '',i3,'' zero probability bins'')') izeroprob
      call mess('purr',strng,' ')
   endif
   if (ibadxs.gt.0) then
      write(strng,'(''ptable has '',i3,'' negative xs values'')') ibadxs
      call mess('purr',strng,' ')
   endif

   !--compute bondarenko cross sections from prob. table
   if (iprint.gt.0) write(nsyso,'(/&
     &'' bondarenko cross sections from probability table''/&
     &9x,''temp'',6x,''sig0'',4x,''p0 total'',5x,''elastic'',&
     &5x,''fission'',5x,''capture'',4x,''p1 total'')')
   do i=1,nsig0
      do j=1,7
         do itemp=1,ntemp
            bval(j,i,itemp)=0
         enddo
      enddo
      do itemp=1,ntemp
         do j=1,nbin
            if (tabl(j,1,itemp).ne.zero) then
               den=sig0(i)/(sig0(i)+tabl(j,2,itemp))
               ttt=tabl(j,1,itemp)
               bval(1,i,itemp)=bval(1,i,itemp)+ttt*tabl(j,2,itemp)*den
               bval(2,i,itemp)=bval(2,i,itemp)+ttt*tabl(j,3,itemp)*den
               bval(3,i,itemp)=bval(3,i,itemp)+ttt*tabl(j,4,itemp)*den
               bval(4,i,itemp)=bval(4,i,itemp)+ttt*tabl(j,5,itemp)*den
               bval(5,i,itemp)=bval(5,i,itemp)+ttt*tabl(j,2,itemp)*den*den
               bval(6,i,itemp)=bval(6,i,itemp)+ttt*den
               bval(7,i,itemp)=bval(7,i,itemp)+ttt*den*den
            endif
         enddo
         sigf(1,i,itemp)=bval(1,i,itemp)/bval(6,i,itemp)
         sigf(2,i,itemp)=bval(2,i,itemp)/bval(6,i,itemp)
         sigf(3,i,itemp)=bval(3,i,itemp)/bval(6,i,itemp)
         sigf(4,i,itemp)=bval(4,i,itemp)/bval(6,i,itemp)
         sigf(5,i,itemp)=bval(5,i,itemp)/bval(7,i,itemp)
      enddo
   enddo
   if (iprint.gt.0) then
      do itemp=1,ntemp
         do i=1,nsig0
            write(nsyso,'(3x,1p,2e10.3,5e12.4)')&
              temp(itemp),sig0(i),(sigf(j,i,itemp),j=1,5)
         enddo
      enddo
   endif

   !--renormalize probability table and bondarenko
   !--cross sections to the computed infinitely-dilute values
   do itemp=1,ntemp
      do i=2,5
         do j=1,nbin
            l=4*(itemp-1)
            if (sigf(i-1,1,itemp).ne.0)&
              tabl(j,i,itemp)=tabl(j,i,itemp)*sigi(i-1)/sigf(i-1,1,itemp)
         enddo
      enddo
   enddo
   do itemp=1,ntemp
      do i=nsig0,1,-1
         do j=1,5
            k=j
            if (j.eq.5) k=1
            if (sigf(j,1,itemp).ne.0)&
              sigf(j,i,itemp)=sigf(j,i,itemp)*sigi(k)/sigf(j,1,itemp)
            sigpl(ipl,j,i)=sigf(j,i,1)
         enddo
      enddo
   enddo
     !optional printout for plotting probability per barn with viewr
     !uncomment the following lines to activate
     !write(nsyso,'(/'' probability per barn versus total'')')
     !write(nsyso,'('' e='',1p,e12.4)') e
     !tnorm=0
     !do i=1,nbin
     !   denom=tval(i,1)-tnorm
     !   denom=tabl(i,1,1)/denom
     !   write(nsyso,'(1p,2e11.4,''/'')') tabl(i,2,1),denom
     !   tnorm=tval(i,1)
     !enddo
   return
   end subroutine unrest

   subroutine uwtab2
   !-------------------------------------------------------------------
   ! Subroutine wtable controls the calculation and writing of the
   ! coarse and fine, real and imaginary parts of the w table.
   !-------------------------------------------------------------------
   ! internals
   integer::i,j
   real(kr)::delx,dely,x,y,rew,aimw
   real(kr)::ax(41),ay(27)
   real(kr),parameter::tenth=.1e0_kr
   real(kr),parameter::oh2=.02e0_kr

   ax(1)=-tenth
   ax(2)=0
   delx=tenth
   do i=3,41
      ax(i)=ax(i-1)+delx
   enddo
   ay(1)=4*tenth
   ay(2)=5*tenth
   dely=tenth
   do j=3,27
      ay(j)=ay(j-1)+dely
   enddo
   do i=2,41
      x=ax(i)
      do j=1,27
         y=ay(j)
         call uw2(x,y,rew,aimw)
         tr(i,j)=rew
         ti(i,j)=aimw
      enddo
   enddo
   do j=1,27
      tr(1,j)=tr(3,j)
      ti(1,j)=-ti(3,j)
      ti(2,j)=0
   enddo
   ay(1)=-oh2
   ay(2)=0
   dely=oh2
   do j=3,27
      ay(j)=ay(j-1)+dely
   enddo
   do i=2,41
      x=ax(i)
      do j=1,27
         y=ay(j)
         call uw2(x,y,rew,aimw)
         trs(i,j)=rew
         tis(i,j)=aimw
      enddo
   enddo
   do j=1,27
      trs(1,j)=trs(3,j)
      tis(1,j)=-tis(3,j)
      tis(2,j)=0
   enddo
   return
   end subroutine uwtab2

   subroutine uw2(rez,aim1,rew,aimw)
   !-------------------------------------------------------------------
   ! Compute complex probability integral w.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   real(kr)::rez,aim1,rew,aimw
   ! internals
   integer::kw,k,jsig
   real(kr)::rpi,aimz,abrez,ai2,r2,rv,ak,el,h,b,a,tempm,temel
   real(kr)::g,c,d,am,aak,ajtemp,temp4,ajp,pr,pim,amagn,tempc,tempd
   real(kr)::temp1,temp2,aj,ajsig,sigp,expon,expc,exps,sig2p
   real(kr)::aj4sig,aj4sm1,temp3,tt4,temp7,ref,aimf
   real(kr),parameter::c1=1.1283792e0_kr
   real(kr),parameter::c2=1.5e0_kr
   real(kr),parameter::up=1.e15_kr
   real(kr),parameter::dn=1.e-15_kr
   real(kr),parameter::brk1=1.25e0_kr
   real(kr),parameter::brk2=5.0e0_kr
   real(kr),parameter::brk3=1.863636e0_kr
   real(kr),parameter::brk4=4.1e0_kr
   real(kr),parameter::brk5=1.71e0_kr
   real(kr),parameter::brk6=2.89e0_kr
   real(kr),parameter::brk7=1.18e0_kr
   real(kr),parameter::brk8=5.76e0_kr
   real(kr),parameter::brk9=1.5e0_kr
   real(kr),parameter::eps=1.e-7_kr
   real(kr),parameter::zero=0

   rpi=sqrt(pi)
   rew=0
   aimw=0
   aimz=abs(aim1)
   abrez=abs(rez)
   if (abrez+aimz.ne.zero) go to 20
   rew=1
   aimw=0
   return

  20 continue
   r2=rez*rez
   ai2=aimz*aimz
   if (abrez+brk1*aimz-brk2.gt.zero) go to 350
   if (abrez+brk3*aimz-brk4.gt.zero) go to 350
   if (r2+brk5*ai2-brk6.lt.zero) go to 340
   if (r2+brk7*ai2-brk8.ge.zero) go to 340
   if (aimz-brk9.ge.zero) go to 350
  340 continue
   kw=2
   aimz=aim1
   go to 420
  350 continue
   kw=1
   if (aim1.ge.zero) go to 370
   kw=2
   aimz=aim1
   go to 420
   ! wa is obtained from asymtotic series
  370 continue
   rv=2*(r2-ai2)
   ak=4*rez*aimz
   el=ak
   h=0
   b=0
   a=0
   tempm=0
   temel=0
   g=1
   c=-c1*aimz
   d=c1*rez
   am=rv-1
   aak=1
   k=0
  380 continue
   ajtemp=2*aak
   temp4=(1-ajtemp)*ajtemp
   ajp=rv-(4*aak+1)
   go to 480
  390 continue
   aak=aak+1
   k=k+1
   pr=rew
   pim=aimw
   amagn=tempm**2+temel**2
   rew=(tempc*tempm+tempd*temel)/amagn
   aimw=(tempm*tempd-temel*tempc)/amagn
   if (abs(rew-pr).ge.eps) go to 380
   if (rez.eq.zero) go to 550
   if (abs(aimw-pim).ge.eps) go to 380
   return
   ! wt is obtained from taylor series
  420 continue
   temp1=r2+ai2
   temp2=2*temp1*temp1
   aj=-(r2-ai2)/temp2
   ak=2*rez*aimz/temp2
   c=0
   b=0
   ajsig=0
   d=0
   jsig=0
   g=0
   h=0
   el=0
   a=1
   am=1
   sigp=c2
   expon=exp(temp2*aj)
   expc=expon*cos(temp2*ak)
   exps=-expon*sin(temp2*ak)
   sig2p=2*sigp
  430 continue
   aj4sig=4*ajsig
   aj4sm1=aj4sig-1
   temp3=1/(aj4sm1*(aj4sig+3))
   tt4=sig2p*(2*ajsig-1)
   temp4=tt4/(aj4sm1*(aj4sig+1)*(aj4sig-3)*aj4sm1)
   ajp=aj+temp3
   go to 480
  440 continue
   ajsig=ajsig+1
   jsig=jsig+1
   temp7=rpi*(am*am+el*el)
   ref=(aimz*(c*am+d*el)-rez*(am*d-c*el))/temp7/temp1
   aimf=(aimz*(am*d-c*el)+rez*(c*am+d*el))/temp7/temp1
   pr=rew
   pim=aimw
   rew=expc-ref
   aimw=exps-aimf
   if (abs(rew-pr).ge.eps) go to 470
   if (rez.eq.zero) go to 550
   if (abs(aimw-pim).ge.eps) go to 470
   return
  470 continue
   sig2p=2*ajsig
   go to 430
  480 continue
   tempc=ajp*c+temp4*a-ak*d
   tempd=ajp*d+temp4*b+ak*c
   temel=ajp*el+temp4*h+ak*am
   tempm=ajp*am+temp4*g-ak*el
   a=c
   b=d
   g=am
   h=el
   c=tempc
   d=tempd
   am=tempm
   el=temel
   if (abs(tempm)+abs(temel)-up.lt.zero) go to 500
   c=dn*c
   d=dn*d
   am=dn*am
   el=dn*el
   tempc=dn*tempc
   tempd=dn*tempd
   tempm=dn*tempm
   temel=dn*temel
   go to 520
  500 continue
   if (abs(tempm)+abs(temel)-dn.gt.zero) go to 520
   c=up*c
   d=up*d
   am=up*am
   el=up*el
   tempc=up*tempc
   tempd=up*tempd
   tempm=up*tempm
   temel=up*temel
  520 continue
   go to (390,440,530),kw
  530 return
  550 continue
   aimw=0
   return
   end subroutine uw2

   subroutine fsort(x,y,n,i)
   !-------------------------------------------------------------------
   ! Floating-point sort routine.
   ! Sort x and y into increasing x order.
   !-------------------------------------------------------------------
   ! externals
   integer::n,i
   real(kr)::x(n),y(n)
   ! internals
   integer::k,j
   real(kr)::xt,yt

   do  k=1,n-1
      do j=k+1,n
         if (x(k).gt.x(j)) then
            xt=x(k)
            yt=y(k)
            x(k)=x(j)
            y(k)=y(j)
            x(j)=xt
            y(j)=yt
         endif
      enddo
   enddo
   return
   end subroutine fsort

   subroutine fsrch(x,xarray,n,i,k)
   !-------------------------------------------------------------------
   ! Floating-point search routine.
   ! Search the xarray for x.ge.xarray(i) and x.lt.xarray(i+1).
   ! Return i=1 and k=2 if x is below the lower limit.
   ! Return i=n and k=3 if x is above the upper limit.
   !-------------------------------------------------------------------
   ! externals
   integer::n,i,k
   real(kr)::x,xarray(n)
   ! internals
   integer::i1,i2,idone

   if (x.lt.xarray(1)) then
      i=1
      k=2
      return
   endif
   if (x.gt.xarray(n)) then
      i=n
      k=3
      return
   endif
   i1=1
   i2=n
   idone=0
   do while (idone.eq.0)
      if (i1+1.eq.i2) then
         idone=1
      else
         if (x.ge.xarray((i1+i2)/2)) then
            i1=(i1+i2)/2
         else
            i2=(i1+i2)/2
         endif
      endif
   enddo
   i=i1
   k=1
   return
   end subroutine fsrch

   real(kr) function rann(idum)
   !-------------------------------------------------------------------
   ! Random number generator.
   ! Set idum negative to reset the seed.
   !-------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::idum
   ! internals
   integer,parameter::m=714025
   integer,parameter::ia=1366
   integer,parameter::ic=150889
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::rm=one/m
   integer::j,iy
   integer::ir(97)
   integer::iff=0
   save iff,iy,ir

   ! Do not allow zero
100 continue
   if (idum.lt.0.or.iff.eq.0) then
      iff=1
      idum=mod(ic-idum,m)
      do j=1,97
         idum=mod(ia*idum+ic,m)
         ir(j)=idum
      enddo
      idum=mod(ia*idum+ic,m)
      iy=idum
   endif
   j=1+(97*iy)/m
   if (j.gt.97.or.j.lt.1) call error('rann','failed',' ')
   iy=ir(j)
   rann=iy*rm
   idum=mod(ia*idum+ic,m)
   ir(j)=idum
   if (rann.eq.zero) go to 100
   return
   end function rann

end module purm

module resxsm
   ! provides subroutine resxsr for NJOY2016
   use locale
   implicit none
   private
   public resxsr

contains

   subroutine resxsr
   !-------------------------------------------------------------------
   !
   !  Construct a RESXS resonance cross section
   !  file from NJOY pendf cross sections.
   !
   !  User input:
   !
   !   card 1   units
   !      nout     output unit
   !
   !   card 2   control
   !      nmat     number of materials
   !      maxt     max. number of temperatures
   !      nholl    number of lines of descriptive comments
   !      efirst   lower energy limit (ev)
   !      elast    upper energy limit
   !      eps      thinning tolerance
   !
   !   card 3   user id
   !      huse     hollerith user identification (up to 16 chars)
   !      ivers    file version number
   !
   !   card 4   descriptive data (repeat nholl times)
   !      holl     line of hollerith data (72 chars max)
   !
   !   card 5   material specifications (repeat nmat times)
   !      hmat     hollerith name for material (up to 8 chars)
   !      mat      endf mat number for material
   !      unit     njoy unit number for pendf data
   !
   !  The RESXS format specification follows:
   !
!***********************************************************************
!               proposed 09/24/90                                      -
!                                                                      -
!f           resxs                                                     -
!e           resonance cross section file                              -
!                                                                      -
!n                       this file contains pointwise cross            -
!n                       sections for the epithermal resonance         -
!n                       range to be used for hyper-fine flux          -
!n                       calculations.  elastic, fission, and          -
!n                       capture cross sections are given vs           -
!n                       temperature.  linear interpolation is         -
!n                       assumed.                                      -
!                                                                      -
!n           formats given are for file exchange only                  -
!                                                                      -
!***********************************************************************
!
!
!-----------------------------------------------------------------------
!s          file structure                                             -
!s                                                                     -
!s              record type                       present if           -
!s              ==============================    ===============      -
!s              file identification                 always             -
!s              file control                        always             -
!s              set hollerith identification        always             -
!s              file data                           always             -
!s                                                                     -
!s   *************(repeat for all materials)                           -
!s   *          material control                    always             -
!s   *                                                                 -
!s   * ***********(repeat for all cross section blocks)                -
!s   * *        cross section block                 always             -
!s   * ***********                                                     -
!s   *************                                                     -
!                                                                      -
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!r           file identification                                       -
!                                                                      -
!l    hname,(huse(i),i=1,2),ivers                                      -
!                                                                      -
!w    1+3*mult                                                         -
!                                                                      -
!b    format(4h ov ,a8,1h*,2a8,1h*,i6)                                 -
!                                                                      -
!d    hname         hollerith file name  - resxs -  (a8)               -
!d    huse          hollerith user identifiation    (a8)               -
!d    ivers         file version number                                -
!d    mult          double precision parameter                         -
!d                       1- a8 word is single word                     -
!d                       2- a8 word is double precision word           -
!                                                                      -
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!r           file control                                              -
!                                                                      -
!l    efirst,elast,nholl,nmat,nblok
!                                                                      -
!w    5                                                                -
!                                                                      -
!b    format(4h 1d ,2i6)                                               -
!                                                                      -
!d    efirst      lowest energy on file (ev)                           -
!d    elast       highest enery on file (ev)                           -
!d    nholl       number of words in set hollerith                     -
!d                    identification record                            -
!d    nmat        number of materials on file                          -
!d    nblok       energy blocking factor                               -
!                                                                      -
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!r           set hollerith identification                              -
!                                                                      -
!l    (hsetid(i),i=1,nholl)                                            -
!                                                                      -
!w    nholl*mult                                                       -
!                                                                      -
!b    format(4h 2d ,8a8/(9a8))                                         -
!                                                                      -
!d    hsetid      hollerith identification of set (a8)                 -
!d                 (to be edited out 72 characters per line)           -
!                                                                      -
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!r          file data                                                  -
!                                                                      -
!l    (hmatn(i),i=1,nmat),(ntemp(i),i=1,nmat),(locm(i),i=1,nmat)       -
!                                                                      -
!w    (mult+2)*nmat                                                    -
!                                                                      -
!b    format(4h 3d ,8a8/(9a8))      hmatn                              -
!b    format(12i6)                  ntemp,locm                         -
!                                                                      -
!d    hmatn(i)    hollerith identification for material i              -
!d    ntemp(i)    number of temperatures for material i                -
!d    locm(i)     location of material i                               -
!                                                                      -
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!r          material control                                           -
!                                                                      -
!l    hmat,amass,(temp(i),i=1,ntemp),nreac,nener                       -
!                                                                      -
!w    mult+3+ntemp                                                     -
!                                                                      -
!b    format(4h 6d ,a8,1h*,1p1e12.5/(6e12.5))     hmat,temp            -
!b    format(2i6)                                 nener,blok           -
!                                                                      -
!d    hmat        hollerith material identifier                        -
!d    amass       atomic weight ratio                                  -
!d    temp        temperature values for this material                 -
!d    nreac       number of reactions for this material                -
!d                  (3 for fissionable, 2 for nonfissionable)          -
!d    nener       number of energies for this material                 -
!                                                                      -
!-----------------------------------------------------------------------
!
!
!-----------------------------------------------------------------------
!r          cross section block                                        -
!                                                                      -
!l    (xsb(i),i=1,imax)                                                -
!                                                                      -
!c    imax=3*ntemp*(number of energies in the block)                   -
!                                                                      -
!w    imax                                                             -
!                                                                      -
!b    format(4h 8d ,1p5e12.5/(6e12.5))                                 -
!                                                                      -
!d    xsb(i)      data for a block of nblok or fewer point energy      -
!d                values.  the data values given for each energy       -
!d                are nelas, nfis, and ng at temp(1), followed by      -
!d                nelas, nfis, and ng at temp(2), and so on.           -
!                                                                      -
!-----------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides openz,loada,finda
   ! internals
   integer::iscr,iscrh,nscr,inew,iold,irec
   integer::nout,nmat,maxt,nholl,ivers,i,j,k,im,matd
   integer::nin,nb,nw,ix,itemp,jx,idis,isave,ie,je
   integer::ne,n,lim,nwds,nn,jrec,krec,nwr,nreac,nener
   real(kr)::e,efirst,elast,eps,awr,enext,s,ei,test
   real(kr)::temp(10),sigs(31),sigi(31),sigl(31)
   character(8)::hmat(20)
   integer::mat(20),ninm(20),ntemp(20),locm(20)
   real(kr)::awrm(20)
   real(kr)::huse(2)
   character(8)::holl(9,10)
   real(kr)::stack(50,31)
   character(12)::uid
   character(72)::text
   real(kr)::edat(5000)
   real(k4)::a(10000)
   integer(k4)::ia(10000)
   real(k8)::ha(5000)
   equivalence (a(1),ia(1),ha(1))
   real(kr),dimension(:),allocatable::bufo,bufn
   character(6)::hfile='resxsr'
   character(6)::hblank='      '
   integer::mult=2
   integer::nbuf=5000
   integer::nx=31
   integer::nblok=5000

   !--assign storage pointers
   iscr=1
   iscrh=1
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))

   !--assign i/o units
   nscr=10
   inew=11
   iold=12
   call openz(-nscr,0)
   call openz(-inew,0)
   call openz(-iold,0)
   irec=0

   !--read user input
   read(nsysi,*) nout
   read(nsysi,*) nmat,maxt,nholl,efirst,elast,eps
   read(nsysi,*) uid,ivers
   read(uid,'(2a6)') huse(1),huse(2)
   do i=1,nholl
      text=' '
      read(nsysi,*) text
      read(text,'(9a8)') (holl(j,i),j=1,9)
   enddo
   do i=1,nmat
      read(nsysi,*) hmat(i),mat(i),ninm(i)
   enddo

   !--loop over desired materials
   do 400 im=1,nmat
   matd=mat(im)
   locm(im)=irec
   nin=ninm(im)
   call openz(nin,0)
   call tpidio(nin,0,0,edat,nb,nw)

   !--initialize loada/finda file
   do ix=1,nx
      sigs(ix)=0
   enddo
   sigs(1)=efirst
   call loada(1,sigs,nx,inew,bufn,nbuf)
   sigs(1)=elast
   call loada(-2,sigs,nx,inew,bufn,nbuf)

   !--loop over temperatures
   itemp=0
   jx=0
  110 continue
   call contio(nin,0,0,edat,nb,nw)
   if (math.ne.matd) go to 250
   if (itemp.eq.maxt) go to 250
   awr=c2h
   awrm(im)=awr
   call contio(nin,0,0,edat,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   call skiprz(nin,-1)
   if (iverf.eq.4) nx=n2h
   if (iverf.ge.5) call contio(nin,0,0,edat,nb,nw)
   if (iverf.ge.6) call contio(nin,0,0,edat,nb,nw)
   call hdatio(nin,0,0,edat,nb,nw)
   itemp=itemp+1
   ntemp(im)=itemp
   temp(itemp)=edat(1)
   write(nsyso,'('' found: '',a8,i5,1p,e12.4)')&
     hmat(im),math,temp(itemp)

   !--loop over resonance reactions
   call findf(matd,3,0,nin)
  120 continue
   call contio(nin,0,0,edat,nb,nw)
   if (mfh.eq.0) go to 210
   if (mth.eq.2.or.mth.eq.18.or.mth.eq.102) go to 130
   call tosend(nin,0,0,edat)
   go to 120
  130 continue
   jx=jx+1

   !--loop through the energy grid for this reaction
   !--and add the cross sections to the union set
   e=0
   call gety1(e,enext,idis,s,nin,edat)
   isave=iold
   iold=inew
   inew=isave
   ie=1
   call finda(ie,sigs,nx,iold,bufo,nbuf)
   e=sigs(1)
   call gety1(e,enext,idis,s,nin,edat)
   sigs(1+jx)=s
   je=1
   call loada(je,sigs,nx,inew,bufn,nbuf)
  150 continue
   ie=ie+1
   do ix=1,nx
      sigl(ix)=sigs(ix)
   enddo
   call finda(ie,sigi,nx,iold,bufo,nbuf)
   ei=sigi(1)
  160 continue
   e=ei
   if (e.gt.enext) e=enext
   call gety1(e,enext,idis,s,nin,edat)
   if (jx.eq.1) go to 180
   do ix=2,jx
      call terp1(sigl(1),sigl(ix),sigi(1),sigi(ix),e,sigs(ix),2)
   enddo
  180 continue
   sigs(1)=e
   sigs(1+jx)=s
   je=je+1
   if (e.gt.elast-elast/200000) go to 190
   call loada(je,sigs,nx,inew,bufn,nbuf)
   if (e.eq.ei) go to 150
   go to 160
  190 continue
   call loada(-je,sigs,nx,inew,bufn,nbuf)
   write(nsyso,'(''  mt='',i4,4x,''ne='',i6)') mth,je
   call tosend(nin,0,0,edat)
   go to 120

   !--continue temperature loop for this material
  210 continue
   call tomend(nin,0,0,edat)
   go to 110

   !--thin the cross sections for this material
  250 continue
   ne=je
   isave=inew
   inew=iold
   iold=isave
   ie=0
   je=0
   n=0
  260 continue
   ie=ie+1
   call finda(ie,sigs,nx,iold,bufo,nbuf)
   if (ie.eq.ne) go to 350
   n=n+1
   do j=1,nx
      stack(n,j)=sigs(j)
   enddo
   if (n.lt.3) go to 260
   lim=n-1
   do 290 i=2,lim
   do 280 j=2,nx
   call terp1(stack(1,1),stack(1,j),stack(n,1),stack(n,j),&
     stack(i,1),test,2)
   if (abs(test-stack(i,j)).gt.eps*stack(i,j)) go to 300
  280 continue
  290 continue
   go to 260
  300 continue
   do j=1,nx
      sigs(j)=stack(1,j)
   enddo
   je=je+1
   call loada(je,sigs,nx,inew,bufn,nbuf)
   do i=1,2
      do j=1,nx
         stack(i,j)=stack(lim+i-1,j)
      enddo
   enddo
   n=2
   go to 260
  350 continue
   je=je+1
   call loada(-je,sigs,nx,inew,bufn,nbuf)
   write(nsyso,'('' after thinning, ne='',i6)') je

   !--write the resxs material control record
   n=ntemp(im)
   nwds=mult+n+3
   irec=irec+1
   read(hmat(im),'(a6)') ha(iscrh)
   a(iscr+mult)=awrm(im)
   do i=1,n
      a(iscr+mult+i)=temp(i)
   enddo
   ia(iscr+mult+n+1)=jx/n
   ia(iscr+mult+n+2)=je
   write(nscr) ha(1),(a(mult+i),i=iscr,iscr+n),ia(nwds-1),ia(nwds)

   !--write the thinned cross-section blocks
   nn=1+jx
   nwds=0
   do i=1,je
      call finda(i,sigs,nx,inew,bufn,nbuf)
      if (nwds+nn.gt.nblok) then
         irec=irec+1
         write(nscr)(a(iscr-1+j),j=1,nwds)
         nwds=0
      endif
      do j=1,nn
         a(iscr-1+nwds+j)=sigs(j)
      enddo
      nwds=nwds+nn
   enddo
   if (nwds.ne.0) then
      irec=irec+1
      write(nscr)(a(iscr-1+i),i=1,nwds)
   endif

   !--continue the material loop
  400 continue

   !--write the output in resxs format
   !--start with the file identification record
   call openz(-nout,1)
   nwds=3*mult+1
   read(hfile,'(a6)') ha(iscrh)
   ha(iscrh+1)=huse(1)
   ha(iscrh+2)=huse(2)
   ia(iscr+3*mult)=ivers
   jrec=1
   call repoz(-nout)
   write(nout)(ha(i),i=1,3),ia(nwds)

   !--file control record
   nwds=5
   jrec=2
   a(iscr)=efirst
   a(iscr+1)=elast
   ia(iscr+2)=nholl
   ia(iscr+3)=nmat
   ia(iscr+4)=nblok
   write(nout)(a(i),i=1,2),(ia(2+i),i=1,3)

   !--set hollerith identification
   nwds=mult*nholl
   jrec=3
   do i=1,nwds
      read(hblank,'(a8)') ha(i)
   enddo
   write(nout)(ha(i),i=1,nholl)

   !--file data
   nwds=(mult+2)*nmat
   jrec=4
   do i=1,nmat
      read(hmat(i),'(a6)') ha(iscrh-1+i)
      ia(iscr-1+nmat*mult+i)=ntemp(i)
      ia(iscr-1+nmat*(mult+1)+i)=locm(i)
   enddo
   write(nout)(ha(i),i=1,nmat),(ia(mult*nmat+i),i=1,2*nmat)

   !--copy the material control and cross-section blocks
   !--from the scratch file to nout
   krec=0
   call repoz(-nscr)
   do i=1,nmat
      krec=krec+1
      nwr=1+ntemp(i)
      nwds=mult+ntemp(i)+3
      read(nscr) ha(1),(a(mult+j),j=1,nwr),ia(nwds-1),ia(nwds)
      jrec=jrec+1
      write(nout) ha(1),(a(mult+j),j=1,nwr),ia(nwds-1),ia(nwds)
      nreac=ia(iscr+mult+ntemp(i)+1)
      nener=ia(iscr+mult+ntemp(i)+2)
      nn=1+nreac*ntemp(i)
      nw=nener*nn
      nwds=(nblok/nn)*nn
      nb=nw/nwds
      if (nw.gt.nb*nwds) nb=nb+1
      do j=1,nb
         if (nw.lt.nwds) nwds=nw
         krec=krec+1
         read(nscr)(a(k),k=1,nwds)
         jrec=jrec+1
         write(nout)(a(k),k=1,nwds)
         nw=nw-nwds
      enddo
   enddo
   end subroutine resxsr

end module resxsm

module acepn
   ! provides photonuclear options for acer
   use locale
   use acecm, only: xss,nxss
   implicit none
   private

   !--Public routines
   public acephn,phnfix

   !--Private global variables

   ! ace file header information
   character(13)::hz
   character(10)::hd
   character(10)::hm
   real(kr)::aw0,tz

   ! parameters for photonuclear nxs block
   integer::lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,nxsd(4),tvn

   ! parameters for photonuclear jxs block
   integer::esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(21)

contains

   subroutine acephn(nendf,npend,nace,ndir,matd,tempd,iprint,mcnpx,&
     ityp,suff,hk,izn,awn,izaoption)
   !-------------------------------------------------------------------
   ! Prepare ACE photo-nuclear files.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use physics ! provides amassn,amu,ev,pi,clight
   use util  ! provides openz,closz,repoz,mess,error
   use mathm ! provides erfc
   use endf  ! provides endf routines and variables
   use acecm ! provides bachaa,eavl,ptleg2,pttab2
   ! externals
   integer::nendf,npend,nace,ndir,matd,iprint,mcnpx,ityp,izaoption
   real(kr)::tempd,suff
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::nin,nb,nw,nwscr,nx,mtx,ielas,mf4,mf6,mt452,mt456,mtxnu
   integer::mt103,mt104,mt105,mt106,mt107
   integer::i,mfd,mtd,l,mttot,idis,nex,nexc,ir,j,idone,nnex,n
   integer::nneut,nphot,nprot,ndeut,ntrit,nhe3,nhe4
   integer::k,ib,iaa,nk,ik,lly,izai,izap,law,jscr,nrr,npp
   integer::ll,lll,lep,ne,llh,lld,ie,np,ip,mtt,lct,ii
   integer::icapt,jj,itype,it,jp,nr,il,llht,iie,lang
   integer::iint,nn,kk,m,intt,last,lf,jnt,ja,jb,ipp,irr
   integer::lee,lle,nd,na,ncyc,ng,ig,nnr,nnp,mf,mt
   integer::ipt,ntrp,pxs,phn,mtrp,tyrp,lsigp,sigp,landp,andp,ldlwp,dlwp
   integer::izarec,nl,iil,nexn,nexd,ki,ilaw2mt5
   integer::nle
   integer::imu,intmu,nmu
   real(kr)::emc2,e,enext,s,y,ynext,heat,en,ep,g,h,epl
   real(kr)::tneut,tphot,tprot,tdeut,ttrit,the3,the4,thresh
   real(kr)::ss,tt,ubar,sum,renorm,ebar,hh,u,theta,x,anorm
   real(kr)::ee,amass,avadd,avlab,avll,test,rkal,akal
   real(kr)::eavi,avl,avcm,sign,dele,avav,zaid,gl,awp,awr,q,yld
   real(kr)::av,del
   real(kr)::awprec,awpp
   integer,parameter::mmax=1000
   integer::mfm(mmax),mtm(mmax),nr6(mmax)
   real(kr)::fnubar(300)
   character(8)::hdt
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::emev=1.e6_kr
   real(kr),parameter::etop=1.e10_kr
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::rmin=1.e-30_kr
   real(kr),parameter::eps=1.e-10_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   character(66)::text
   emc2=amassn*amu*clight*clight/ev/emev
   tvn=1
   ilaw2mt5=0
   yld=1.

   nxsd=0
   jxsd=0
   xss=0

   !--allocate scratch storage
   nwscr=50000
   allocate(scr(nwscr))

   !--assign input file
   nin=nendf
   call openz(nin,0)
   call openz(npend,0)

   !--determine what endf version is being used
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   awr=c2h
   call contio(nin,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' using endf-'',i1,'' format'')') iverf

   !--process dictionary from endf tape.
   call findf(matd,1,451,nin)
   i=1
   call contio(nin,0,0,scr,nb,nw)
   nx=n2h
   izai=0
   is=0
   if (iverf.ge.5) then
      i=i+6
      call contio(nin,0,0,scr(i),nb,nw)
      is=nint(scr(10)) ! endf-5 and endf-6 both store liso
   endif
   if (iverf.eq.6) then
      i=i+6
      call contio(nin,0,0,scr(i),nb,nw)
      izai=nint(scr(17))/10
      if (izai.ne.0) call error('acephn',&
         'endf input tape is not a photonuclear tape',' ')
   endif
   za=nint(scr(1))
   ia=mod(za,1000)
   iz=(za-ia)/1000
   print*,iz,ia,is,za
   call hdatio(nin,0,0,scr,nb,nw)
   if (iverf.ge.5) nx=n2h
   do while (nb.ne.0)
      call moreio(nin,0,0,scr,nb,nw)
   enddo
   nw=nx
   ntr=0
   mtx=0
   ielas=0
   mf4=0
   mf6=0
   mt103=0
   mt104=0
   mt105=0
   mt106=0
   mt107=0
   mt452=0
   mt456=0
   call dictio(nin,0,0,scr,nb,nw)
   do i=1,nw,6
      mfd=nint(scr(i+2))
      mtd=nint(scr(i+3))
      if (mfd.eq.1.and.mtd.eq.452) mt452=1
      if (mfd.eq.1.and.mtd.eq.456) mt456=1
      if (mfd.ge.3.and.mfd.lt.30.and.(mtd.eq.2.or.mtd.gt.4)) then
         if (mfd.eq.3) ntr=ntr+1
         if (mtd.eq.2) ielas=1
         if (mfd.eq.3.and.(mtd.ge.600.and.mtd.le.649)) mt103=1
         if (mfd.eq.3.and.(mtd.ge.650.and.mtd.le.699)) mt104=1
         if (mfd.eq.3.and.(mtd.ge.700.and.mtd.le.749)) mt105=1
         if (mfd.eq.3.and.(mtd.ge.750.and.mtd.le.799)) mt106=1
         if (mfd.eq.3.and.(mtd.ge.800.and.mtd.le.849)) mt107=1
         mtx=mtx+1
         if (mtx.gt.mmax) call error('acephn',&
           'too many reactions in mtr list',' ')
         if (mfd.eq.6.and.mtd.ge.201.and.mtd.le.207)&
           call error('acephn','mf=6/mt=201-207 not supported.',&
           'does not conform to endf format.')
         mfm(mtx)=mfd
         mtm(mtx)=mtd
         nr6(mtx)=0
         if (mfd.eq.4) mf4=1
         if (mfd.eq.6) mf6=1
      endif
   enddo

   !--save the nubar tabulation, if present
   mtxnu=0
   if (mt452.eq.1) then
      call findf(matd,1,452,nin)
      call contio(nin,0,0,scr,nb,nw)
      ! if polynomial representation is used, we will need to linearise
      ! for now: error out and wait for this to come up to actually implement it
      if (scr(4).eq.1) then
        call error('acephn','mf=1/mt=452 uses polynomial representation.',&
        'this is currently unsupported for photonuclear ACE files.')
      endif
      call tab1io(nin,0,0,fnubar,nb,nw)
      mtxnu=452
   endif
   if (mt456.eq.1) then
      call findf(matd,1,456,nin)
      call contio(nin,0,0,scr,nb,nw)
      ! if polynomial representation is used, we will need to linearise
      ! for now: error out and wait for this to come up to actually implement it
      if (scr(4).eq.1) then
        call error('acephn','mf=1/mt=456 uses polynomial representation.',&
        'this is currently unsupported for photonuclear ACE files.')
      endif
      call tab1io(nin,0,0,fnubar,nb,nw)
      mtxnu=456
   endif

   !--locate and store energy grid of total cross section
   !--using the pendf input
   nin=npend
   l=0
   call findf(matd,3,0,nin)
   call contio(nin,0,0,scr,nb,nw)
   mttot=mth
   e=0
   call gety1(e,enext,idis,s,nin,scr)
   do while (enext.lt.etop)
      e=enext
      call gety1(e,enext,idis,s,nin,scr)
      if (l.eq.0.and.s.ne.zero) then
         l=l+1
         xss(l)=sigfig(e,7,-1)
      endif
      l=l+1
      xss(l)=e
   enddo
   call tosend(nin,0,0,scr)
   nes=l

   !--mttot is 5 for a lanl photonuclear files, which
   !--use only uses mt=5 in file 3 and file 6.
   !--mttot is 1 or 3 for a photonuclear file that starts
   !--with a normal total or nonelastic cross sections and
   !--that can contain partial reaction cross sections.

   !--define cross section locators
   esz=1
   tot=esz+nes
   if (ielas.eq.1) then
      non=tot+nes
      els=non+nes
      thn=els+nes
   else
      non=tot
      els=0
      thn=tot+nes
   endif
   do i=1,nes
      xss(thn+i)=0
   enddo
   nex=thn+nes

   !--assign locators for the partial cross sections
   mtr=nex
   lqr=mtr+ntr
   lsig=lqr+ntr
   sig=lsig+ntr
   nex=sig
   ir=0

   !--read the reaction cross sections from file 3
   if (mttot.eq.5) call findf(matd,3,5,nin)
   mfh=3
   do while (mfh.ne.0)
      call contio(nin,0,0,scr,nb,nw)
      if (mfh.ne.0) then
         if (mth.eq.2.or.mth.gt.4) then
            if (mth.eq.103.and.mt103.ne.0) go to 99
            if (mth.eq.104.and.mt104.ne.0) go to 99
            if (mth.eq.105.and.mt105.ne.0) go to 99
            if (mth.eq.106.and.mt106.ne.0) go to 99
            if (mth.eq.107.and.mt107.ne.0) go to 99
            e=0
            call gety1(e,enext,idis,s,nin,scr)
            e=enext
            call gety1(e,enext,idis,s,nin,scr)
            if (s.ne.zero) e=sigfig(e,7,-1)

            !--locate energy index for reaction threshold
            j=nes
            idone=0
            do while (idone.eq.0)
               if (j.ge.1) then
                  if (e.le.(1+eps)*xss(esz+j-1)) then
                     j=j-1
                  else
                     idone=1
                  endif
               else
                  idone=1
               endif
            enddo
            j=j+1

            !--store reaction parameters
            ir=ir+1
            xss(mtr+ir-1)=mth
            xss(lqr+ir-1)=sigfig(scr(2)/emev,7,0)
            xss(lsig+ir-1)=nex-sig+1
            xss(nex)=j
            nnex=nex+1
            nex=nex+2
            n=0

            !--store cross sections
            !--compute total from the partials
            do i=j,nes
               e=xss(i)
               call gety1(e,enext,idis,s,nin,scr)
               s=sigfig(s,7,0)
               xss(tot+i-1)=xss(tot+i-1)+s
               if (mth.eq.2) xss(els+i-1)=s
               xss(nex)=s
               n=n+1
               nex=nex+1
            enddo
            xss(nnex)=n
   99       continue
         endif
         call tosend(nin,0,0,scr)
      endif
   enddo

   !--make one pass through the distributions to
   !--count the different particles produced,
   !--to determine the production thresholds, and
   !--to accumulate the heating from mf=6 recoils.
   nin=nendf
   nneut=0
   nphot=0
   nprot=0
   ndeut=0
   ntrit=0
   nhe3=0
   nhe4=0
   tneut=etop
   tphot=etop
   tprot=etop
   tdeut=etop
   ttrit=etop
   the3=etop
   the4=etop
   do while (math.gt.0)
      call contio(nin,0,0,scr,nb,nw)
      if (math.gt.0.and.mfh.ne.0) then

         !--file 4
         if (mfh.eq.4) then
            ! file 4 is only to be used for secondary neutrons so if a reaction
            ! is present in mf4, it describes secondary neutrons so every
            ! reaction is counted
            nneut=nneut+1
            mtt=0
            ir=0
            do while (mtt.ne.mth)
               ir=ir+1
               mtt=nint(xss(mtr+ir-1))
               q=xss(lqr+ir-1)
               k=nint(xss(lsig+ir-1))+sig-1
               n=nint(xss(k+1))
               iaa=nint(xss(k))
            enddo
            thresh=xss(esz+iaa-1)
            if (thresh.lt.tneut) tneut=thresh

         !--file 6
         else if (mfh.eq.6) then
            lct=nint(scr(4))
            nk=nint(scr(5))
            ik=0
            ! as long as there are reaction products in the mf6 entry
            do while (ik.lt.nk)
               ik=ik+1
               lly=1
               ! read the multiplicity
               call tab1io(nin,0,0,scr,nb,nw)
               jscr=1+nw
               do while (nb.ne.0)
                  call moreio(nin,0,0,scr(jscr),nb,nw)
                  jscr=jscr+nw
               enddo
               ! retrieve izap and the law
               izap=nint(scr(1))
               law=nint(scr(4))
               ! count particle producing reactions
               if (izap.eq.1) nneut=nneut+1
               if (izap.eq.0) nphot=nphot+1
               if (izap.eq.1001) nprot=nprot+1
               if (izap.eq.1002) ndeut=ndeut+1
               if (izap.eq.1003) ntrit=ntrit+1
               if (izap.eq.2003) nhe3=nhe3+1
               if (izap.eq.2004) nhe4=nhe4+1
               ! if this is fission, check if the multiplicity is equal to nubar
               ! issue a warning if this is not the case and replace the yield
               if (mth.eq.18.and.izap.eq.1.and.mtxnu.gt.0) then
                  ! check yield != nubar
                  if (scr(6+2*nint(scr(5))+2).ne.fnubar(6+2*nint(fnubar(5))+2)) then
                    write(text,'(''the multiplicity will be replaced with nubar from mf=1/mt='',i3,''.'')')mtxnu
                    call mess('acephn','mf=6/mt=18 neutron multiplicity not consistent with nubar.',text)
                  endif
                  call copynubar(scr,fnubar,jscr)
               endif
               mtt=0
               ir=0
               ! look for the corresponding reaction in the XSS array
               do while (mtt.ne.mth)
                  ir=ir+1
                  mtt=nint(xss(mtr+ir-1))
                  q=xss(lqr+ir-1)
                  k=nint(xss(lsig+ir-1))+sig-1
                  n=nint(xss(k+1))
                  iaa=nint(xss(k))
               enddo
               thresh=xss(esz+iaa-1)

               !--for particles
               !--check for production thresholds
               if (izap.le.2004) then
                  nrr=nint(scr(5))
                  npp=nint(scr(6))
                  y=0
                  i=0
                  ynext=0
                  do while (ynext.le.zero)
                     i=i+1
                     e=scr(5+2*nrr+2*i)
                     ynext=scr(6+2*nrr+2*i+2)
                  enddo
                  if (e.lt.thresh) e=thresh
                  if (izap.eq.1.and.e.lt.tneut) tneut=e
                  if (izap.eq.0.and.e.lt.tphot) tphot=e
                  if (izap.eq.1001.and.e.lt.tprot) tprot=e
                  if (izap.eq.1002.and.e.lt.tdeut) tdeut=e
                  if (izap.eq.1003.and.e.lt.ttrit) ttrit=e
                  if (izap.eq.2003.and.e.lt.the3) the3=e
                  if (izap.eq.2004.and.e.lt.the4) the4=e

                  !--skip to the next subsection
                  call skip6(nin,0,0,scr,law)

               !--for recoil nuclides
               !--compute the heating contributions
               !--for law=1 continuous distributions
               else if (law.eq.1) then
                  ll=jscr
                  call tab2io(nin,0,0,scr(ll),nb,nw)
                  lep=nint(scr(ll+3))
                  ne=nint(scr(ll+5))
                  llh=ll
                  scr(llh)=0
                  scr(llh+1)=0
                  scr(llh+2)=0
                  scr(llh+3)=0
                  scr(llh+4)=1
                  scr(llh+5)=ne
                  scr(llh+6)=ne
                  scr(llh+7)=2
                  lld=llh+8+2*ne
                  nrr=1
                  npp=2
                  do ie=1,ne
                     ll=lld
                     call listio(nin,0,0,scr(ll),nb,nw)
                     ll=ll+nw
                     do while (nb.ne.0)
                        call moreio(nin,0,0,scr(ll),nb,nw)
                        ll=ll+nw
                     enddo
                     e=c2h
                     heat=0
                     na=nint(scr(lld+3))
                     np=nint(scr(lld+5))
                     call terpa(y,e,en,idis,scr(lly),npp,nrr)
                     do ip=1,np
                        ep=scr(lld+6+(na+2)*(ip-1))
                        g=scr(lld+7+(na+2)*(ip-1))
                        if (ip.gt.1) then
                           heat=heat+(ep-epl)*gl*(ep+epl)/2
                        endif
                        epl=ep
                        gl=g
                     enddo
                     scr(llh+6+2*ie)=e
                     scr(llh+7+2*ie)=y*heat
                  enddo
                  mtt=0
                  ir=0
                  do while (mtt.ne.mth)
                     ir=ir+1
                     mtt=nint(xss(mtr+ir-1))
                     k=nint(xss(lsig+ir-1))+sig-1
                     n=nint(xss(k+1))
                     iaa=nint(xss(k))
                  enddo
                  nrr=1
                  npp=2
                  do ie=iaa,nes
                     e=xss(esz+ie-1)
                     call terpa(h,e,en,idis,scr(llh),npp,nrr)
                     h=(h/emev)*xss(2+k+ie-iaa)
                     if (xss(tot+ie-1).ne.zero) h=h/xss(tot+ie-1)
                     xss(thn+ie-1)=sigfig(xss(thn+ie-1)+h,7,0)
                  enddo
                  do ii=1,mtx
                     if (mfm(ii).eq.6.and.mtm(ii).eq.mth)&
                       nr6(ii)=nr6(ii)+1
                  enddo

               !--heating from discrete recoils
               !--back up to corresponding law=2 distribution
               else if (law.eq.4) then
                  mf=mfh
                  mt=mth
                  call findf(matd,mf,mt,nin)
                  call contio(nin,0,0,scr,nb,nw)
                  lly=1
                  call tab1io(nin,0,0,scr,nb,nw)
                  izap=nint(scr(1))
                  awp=scr(2)
                  law=nint(scr(4))
                  jscr=1+nw
                  do while (nb.ne.0)
                     call moreio(nin,0,0,scr(jscr),nb,nw)
                     jscr=jscr+nw
                  enddo
                  ll=jscr
                  call tab2io(nin,0,0,scr(ll),nb,nw)
                  lep=nint(scr(ll+3))
                  ne=nint(scr(ll+5))
                  llh=ll
                  scr(llh)=0
                  scr(llh+1)=0
                  scr(llh+2)=0
                  scr(llh+3)=0
                  scr(llh+4)=1
                  scr(llh+5)=ne
                  scr(llh+6)=ne
                  scr(llh+7)=2
                  lld=llh+8+2*ne
                  nrr=1
                  npp=2
                  do ie=1,ne
                     ll=lld
                     call listio(nin,0,0,scr(ll),nb,nw)
                     ll=ll+nw
                     do while (nb.ne.0)
                        call moreio(nin,0,0,scr(ll),nb,nw)
                        ll=ll+nw
                     enddo
                     e=c2h
                     scr(llh+6+2*ie)=e
                     scr(llh+7+2*ie)=awp*(e+q*emev)/(awr-awp)
                  enddo
                  mtt=0
                  ir=0
                  do while (mtt.ne.mth)
                     ir=ir+1
                     mtt=nint(xss(mtr+ir-1))
                     k=nint(xss(lsig+ir-1))+sig-1
                     n=nint(xss(k+1))
                     iaa=nint(xss(k))
                  enddo
                  nrr=1
                  npp=2
                  do ie=iaa,nes
                     e=xss(esz+ie-1)
                     call terpa(h,e,en,idis,scr(llh),npp,nrr)
                     h=(h/emev)*xss(2+k+ie-iaa)
                     if (xss(tot+ie-1).ne.zero) h=h/xss(tot+ie-1)
                     xss(thn+ie-1)=sigfig(xss(thn+ie-1)+h,7,0)
                  enddo
                  do ii=1,mtx
                     if (mfm(ii).eq.6.and.mtm(ii).eq.mth)&
                       nr6(ii)=nr6(ii)+1
                  enddo

                  ! read subsections until we're back at the right one
                  ir=1
                  do while (ir.lt.ik)
                     ir=ir+1
                     call tab1io(nin,0,0,scr,nb,nw)
                     law=nint(scr(4))
                     jscr=1+nw
                     do while (nb.ne.0)
                        call moreio(nin,0,0,scr(jscr),nb,nw)
                        jscr=jscr+nw
                     enddo
                     call skip6(nin,0,0,scr,law)
                  enddo

               !--unknown distribution
               else if (law.eq.0) then
                  write(text,'(''recoil'',i6,'' in MT'',I4)')izap,mth
                  call mess('acephn','no heating info for ',text)

               !--this law is not currently handled
               else
                  write(text,'(''particle '',i5,'' law'',I4)')izap,law
                  call mess('acephn','file 6 law not coded for ',text)
               endif
            enddo
         endif
         call tosend(nin,0,0,scr)
      endif
   enddo

   !--add in e+q heating for capture when recoil is not given.
   icapt=0
   do ii=1,mtx
      if (mfm(ii).eq.3.and.mtm(ii).eq.102) icapt=1
      if (mfm(ii).eq.6.and.mtm(ii).eq.102.and.nr6(ii).gt.0) icapt=0
   enddo
   do ii=1,ntr
      mt=int(xss(mtr+ii-1))
      if (mt.eq.102.and.icapt.eq.1) then
         k=nint(xss(lsig+ii-1))+sig-1
         j=nint(xss(k))
         do ie=j,nes
            e=xss(esz+ie-1)
            if (xss(tot+ie-1).ne.zero)&
              xss(thn+ie-1)=xss(thn+ie-1)&
              +(e/emev)*xss(2+k+ie-j)/xss(tot+ie-1)
         enddo
      endif
   enddo

   !--add in e+q heating for mf=6 sections with no recoil
   do ii=1,ntr
      mt=int(xss(mtr+ii-1))
      do jj=1,mtx
         if (mfm(jj).eq.6.and.mtm(jj).eq.mt.and.nr6(jj).eq.0) then
            q=xss(lqr+ii-1)
            k=nint(xss(lsig+ii-1))+sig-1
            j=nint(xss(k))
            do ie=j,nes
               e=xss(esz+ie-1)
               if (xss(tot+ie-1).ne.zero)&
                 xss(thn+ie-1)=xss(thn+ie-1)&
                 +(e/emev+q)*xss(2+k+ie-j)/xss(tot+ie-1)
            enddo
         endif
      enddo
   enddo

   !--fill in the ixs array block
   ntype=0
   npixs=2
   neixs=12
   if (nneut.gt.0) ntype=ntype+1
   if (nphot.gt.0) ntype=ntype+1
   if (nprot.gt.0) ntype=ntype+1
   if (ndeut.gt.0) ntype=ntype+1
   if (ntrit.gt.0) ntype=ntype+1
   if (nhe3.gt.0) ntype=ntype+1
   if (nhe4.gt.0) ntype=ntype+1
   ixsa=nex
   itype=0
   if (nneut.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=1
      xss(ixsa+neixs*(itype-1)+1)=nneut
   endif
   if (nphot.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=2
      xss(ixsa+neixs*(itype-1)+1)=nphot
   endif
   if (nprot.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=9
      xss(ixsa+neixs*(itype-1)+1)=nprot
   endif
   if (ndeut.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=31
      xss(ixsa+neixs*(itype-1)+1)=ndeut
   endif
   if (ntrit.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=32
      xss(ixsa+neixs*(itype-1)+1)=ntrit
   endif
   if (nhe3.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=33
      xss(ixsa+neixs*(itype-1)+1)=nhe3
   endif
   if (nhe4.gt.0) then
      itype=itype+1
      xss(ixsa+neixs*(itype-1))=34
      xss(ixsa+neixs*(itype-1)+1)=nhe4
   endif
   nex=ixsa+neixs*ntype
   ixs=nex

   !--loop over each of the ntype productions
   !--to build the production data.
   do itype=1,ntype
      ipt=nint(xss(ixsa+neixs*(itype-1)))
      ntrp=nint(xss(ixsa+neixs*(itype-1)+1))
      if (ipt.eq.1) ip=1
      if (ipt.eq.2) ip=0
      if (ipt.eq.9) ip=1001
      if (ipt.eq.31) ip=1002
      if (ipt.eq.32) ip=1003
      if (ipt.eq.33) ip=2003
      if (ipt.eq.34) ip=2004

      !--determine the threshold
      !--and assign some locators
      if (ip.eq.1) thresh=tneut
      if (ip.eq.0) thresh=tphot
      if (ip.eq.1001) thresh=tprot
      if (ip.eq.1002) thresh=tdeut
      if (ip.eq.1003) thresh=ttrit
      if (ip.eq.2003) thresh=the3
      if (ip.eq.2004) thresh=the4
      it=1
      do while (xss(esz+it-1).lt.thresh)
         it=it+1
      enddo
      if (it.gt.1) it=it-1
      pxs=nex
      xss(ixsa+neixs*(itype-1)+2)=pxs
      xss(pxs)=it
      xss(pxs+1)=nes-it+1
      phn=pxs+2+nes-it+1
      xss(ixsa+neixs*(itype-1)+3)=phn
      xss(phn)=it
      xss(phn+1)=nes-it+1
      mtrp=phn+2+nes-it+1
      xss(ixsa+neixs*(itype-1)+4)=mtrp
      tyrp=mtrp+ntrp
      xss(ixsa+neixs*(itype-1)+5)=tyrp
      lsigp=tyrp+ntrp
      xss(ixsa+neixs*(itype-1)+6)=lsigp
      sigp=lsigp+ntrp
      xss(ixsa+neixs*(itype-1)+7)=sigp
      nex=sigp

      !--find each contribution to this production.
      call repoz(nin)
      jp=0

      !--here for mf4/5 representations - i.e. neutrons only
      if (mf4.eq.1) then
         do i=1,mtx
            if (mfm(i).eq.4.and.ip.eq.1) then
               jp=jp+1
               mt=mtm(i)
               mtt=0
               ir=0
               do while (mtt.ne.mt)
                  ir=ir+1
                  mtt=nint(xss(mtr+ir-1))
                  q=xss(lqr+ir-1)
                  k=nint(xss(lsig+ir-1))+sig-1
                  n=nint(xss(k+1))
                  iaa=nint(xss(k))
               enddo
               xss(mtrp+jp-1)=mt
               xss(tyrp+jp-1)=1
               xss(lsigp+jp-1)=nex-sigp+1
               if (mt.eq.18) then
                  nrr=1
                  npp=2
                  do j=iaa,nes
                     e=xss(esz+j-1)
                     call terpa(y,e,en,idis,fnubar,npp,nrr)
                     ss=xss(2+k+j-iaa)
                     tt=xss(pxs+2+j-it)+y*ss
                     xss(pxs+2+j-it)=sigfig(tt,7,0)
                     if (xss(tot+j-1).ne.zero)&
                       xss(thn+j-1)=xss(thn+j-1)&
                       +ss*(e/emev+q)/xss(tot+j-1)
                  enddo
                  nr=nint(fnubar(5))
                  ne=nint(fnubar(6))
                  xss(nex)=12
                  xss(nex+1)=mt
                  xss(nex+2)=0
                  xss(nex+3)=ne
                  do j=1,ne
                     xss(nex+3+j)=sigfig(fnubar(5+2*nr+2*j)/emev,7,0)
                     xss(nex+3+ne+j)=sigfig(fnubar(6+2*nr+2*j),7,0)
                  enddo
                  nex=nex+4+2*ne
               else
                  y=1
                  if (mth.eq.11.or.mth.eq.16.or.mth.eq.24.or.&
                      mth.eq.30.or.mth.eq.41.or.mth.eq.154.or.&
                      mth.eq.159.or.mth.eq.176.or.mth.eq.190.or.&
                      (mth.ge.875.and.mth.le.891)) then
                     y=2
                  elseif (mth.eq.17.or.mth.eq.25.or.mth.eq.42.or.&
                          mth.eq.157.or.mth.eq.172.or.mth.eq.177.or.&
                          mth.eq.179.or.(mth.ge.181.and.mth.le.199)) then
                     y=3
                  elseif (mth.eq.37.or.mth.eq.156.or.mth.eq.165.or.&
                          mth.eq.169.or.mth.eq.173.or.mth.eq.178.or.&
                          (mth.ge.194.and.mth.le.196)) then
                     y=4
                  elseif (mth.eq.152.or.mth.eq.162.or.mth.eq.166.or.&
                          mth.eq.170.or.mth.eq.174.or.mth.eq.200) then
                     y=5
                  elseif (mth.eq.153.or.mth.eq.163.or.mth.eq.167.or.&
                          mth.eq.171.or.mth.eq.175) then
                     y=6
                  elseif (mth.eq.160.or.mth.eq.164.or.mth.eq.168) then
                     y=7
                  elseif (mth.eq.161) then
                     y=8
                  endif
                  do j=iaa,nes
                     e=xss(esz+j-1)
                     ss=xss(2+k+j-iaa)
                     tt=xss(pxs+2+j-it)+y*ss
                     xss(pxs+2+j-it)=sigfig(tt,7,0)
                     if (xss(tot+j-1).ne.zero)&
                       xss(thn+j-1)=xss(thn+j-1)&
                       +ss*(e/emev+q)/xss(tot+j-1)
                  enddo
                  xss(nex)=12
                  xss(nex+1)=mt
                  xss(nex+2)=0
                  xss(nex+3)=2
                  xss(nex+4)=sigfig(xss(esz+iaa-1)/emev,7,0)
                  xss(nex+5)=sigfig(xss(esz+nes-1)/emev,7,0)
                  xss(nex+6)=y
                  xss(nex+7)=y
                  nex=nex+8
               endif
            endif
         enddo
      endif

      !--here for mf6 representations
      if (mf6.ne.0) then
         call findf(matd,6,0,nin)
         mfh=6
         do while (mfh.gt.0)
            call contio(nin,0,0,scr,nb,nw)
            if (mfh.gt.0) then
               lct=nint(scr(4))
               nk=nint(scr(5))
               mtt=0
               ir=0
               do while (mtt.ne.mth)
                  ir=ir+1
                  mtt=nint(xss(mtr+ir-1))
                  q=xss(lqr+ir-1)
                  k=nint(xss(lsig+ir-1))+sig-1
                  n=nint(xss(k+1))
                  iaa=nint(xss(k))
               enddo
               ik=0
               do while (ik.lt.nk)
                  ik=ik+1
                  ! read the multiplicity
                  call tab1io(nin,0,0,scr,nb,nw)
                  jscr=1+nw
                  do while (nb.ne.0)
                     call moreio(nin,0,0,scr(jscr),nb,nw)
                     jscr=jscr+nw
                  enddo
                  ! retrieve izap and the law
                  izap=nint(scr(1))
                  law=nint(scr(4))

                  !--find the desired particle
                  if (izap.eq.ip) then

                     ! if this is fission, replace the yield with the nubar - as before
                     if (mth.eq.18.and.izap.eq.1.and.mtxnu.gt.0) then
                        call copynubar(scr,fnubar,jscr)
                     endif

                     jp=jp+1
                     xss(mtrp+jp-1)=mth
                     xss(lsigp+jp-1)=nex-sigp+1
                     if (lct.eq.1) then
                        xss(tyrp+jp-1)=1
                     else
                        xss(tyrp+jp-1)=-1
                     endif

                     !--accumulate yield times cross section
                     nrr=1
                     npp=2
                     do i=iaa,nes
                        e=xss(esz+i-1)
                        call terpa(y,e,en,idis,scr,npp,nrr)
                        ss=xss(2+k+i-iaa)
                        tt=xss(pxs+2+i-it)+y*ss
                        xss(pxs+2+i-it)=sigfig(tt,7,0)
                     enddo

                     ! the next piece of code assumes the yield is given
                     ! using one lin-lin interpolation region
                     ! for now: error out and wait for this to come up to actually implement it
                     nr=nint(scr(5))
                     if (nr.gt.1.and.nint(scr(8)).ne.2) then
                        write(text,'(''no linearised multiplicity for izap='',i4,'' in mf=6/mt='',i3,''.'')')izap,mth
                        call mess('acephn',text,'this is currently unsupported for photonuclear ACE files.')
                     endif

                     !--store the yield
                     xss(nex)=6
                     xss(nex+1)=mth
                     xss(nex+2)=0
                     ne=nint(scr(6))
                     xss(nex+3)=ne
                     do i=1,ne
                        xss(nex+3+i)=sigfig(scr(7+2*i)/emev,7,0)
                        xss(nex+3+i+ne)=sigfig(scr(8+2*i),7,0)
                     enddo
                     nex=nex+4+2*ne
                  endif
                  call skip6(nin,0,0,scr,law)
               enddo
            endif
         enddo
      endif

      !--assign the pointers for the angular data
      landp=nex
      xss(ixsa+neixs*(itype-1)+8)=landp
      andp=landp+ntrp
      xss(ixsa+neixs*(itype-1)+9)=andp
      nex=andp

      !--angular distributions
      do i=1,ntrp
         mt=nint(xss(mtrp+i-1))
         mtt=0
         ir=0
         do while (mtt.ne.mt)
            ir=ir+1
            mtt=nint(xss(mtr+ir-1))
            q=xss(lqr+ir-1)
            k=nint(xss(lsig+ir-1))+sig-1
            n=nint(xss(k+1))
            iaa=nint(xss(k))
         enddo
         jp=0
         do j=1,mtx

            !--for file 4,
            !--only neutron producing reactions are
            !--recognized, because file 5 is only
            !--able to represent neutron emission.
            !--just assume isotropy for these.
            if (mfm(j).eq.4.and.mtm(j).eq.mt) then
               jp=i
               xss(landp+jp-1)=0

            !--for file 6,
            !--check for subsections for this production
            !--with law=2.
            else if (mfm(j).eq.6.and.mtm(j).eq.mt) then
               call findf(matd,6,mt,nin)
               call contio(nin,0,0,scr,nb,nw)
               nk=nint(scr(5))
               ik=0
               do while (ik.lt.nk)
                  ik=ik+1
                  call tab1io(nin,0,0,scr,nb,nw)
                  izap=nint(scr(1))
                  awp=scr(2)
                  law=nint(scr(4))
                  jscr=1+nw
                  do while (nb.ne.0)
                     call moreio(nin,0,0,scr(jscr),nb,nw)
                     jscr=jscr+nw
                  enddo

                  !--special steps for two-body recoil
                  !--back up to the corresponding law=2 distr.
                  izarec=-1
                  awprec=-1
                  if (izap.eq.ip.and.law.eq.4) then
                     izarec=izap
                     awprec=awp
                     mf=6
                     call findf(matd,mf,mt,nin)
                     call contio(nin,0,0,scr,nb,nw)
                     call tab1io(nin,0,0,scr,nb,nw)
                     izap=nint(c1h)
                     awp=c2h
                     law=l2h
                     jscr=1+nw
                     do while (nb.ne.0)
                        call moreio(nin,0,0,scr(jscr),nb,nw)
                        jscr=jscr+nw
                     enddo
                  endif

                  !--law2 angular distribution
                  !--also used for law 4 two-body recoils
                  if ((izap.eq.ip.and.law.eq.2).or.&
                    (izarec.eq.ip.and.law.eq.2)) then
                     lld=jscr
                     jp=i
                     ll=jscr
                     call tab2io(nin,0,0,scr(ll),nb,nw)
                     xss(landp+jp-1)=nex-andp+1
                     ne=nint(scr(ll+5))
                     xss(nex)=ne
                     ie=nex
                     il=ie+ne          ! index before the locators for the outgoing distributions
                     nex=il+ne+1       ! first outgoing distribution
                     llht=lld
                     lld=llht+8+2*ne
                     scr(llht)=0
                     scr(llht+1)=0
                     scr(llht+2)=0
                     scr(llht+3)=0
                     scr(llht+4)=1
                     scr(llht+5)=ne
                     scr(llht+6)=ne
                     scr(llht+7)=2
                     if (izarec.eq.-1) then
                        awpp=awp
                     else
                        awpp=awprec
                     endif
                     do iie=1,ne
                        ll=lld
                        call listio(nin,0,0,scr(ll),nb,nw)
                        lang=nint(scr(lld+2))
                        if (lang.eq.0) then
                           if (izarec.ne.-1) then
                              nl=nint(scr(lld+5))
                              do iil=1,nl
                                 if (mod(iil,2).eq.1) then
                                    scr(lld+5+iil)=-scr(lld+5+iil)
                                 endif
                              enddo
                           endif
                           call ptleg2(scr(lld))
                        else
                           iint=lang-10
                           nn=nint(scr(lld+5))
                           do kk=1,nw-4
                              scr(lld+2+nw-kk)=scr(lld+nw-kk)
                           enddo
                           scr(lld+4)=1
                           scr(lld+5)=nn
                           scr(lld+6)=nn
                           scr(lld+7)=iint
                           call pttab2(scr(lld))
                        endif
                        xss(ie+iie)=sigfig(scr(lld+1)/emev,7,0) ! E(iie)
                        m=nint(scr(lld+4))
                        n=nint(scr(lld+5))
                        xss(il+iie)=nex-andp+1                  ! L(iie)
                        xss(il+iie)=-xss(il+iie)
                        intt=nint(scr(lld+7))
                        xss(nex)=intt                           ! intt
                        xss(nex+1)=n                            ! number outgoing energy values
                        if (nex+2+3*n.gt.nxss) call error('acephn',&
                          'insufficient storage for',&
                          ' angular distributions.')
                        do ii=1,n
                           xss(nex+1+ii)=&
                             sigfig(scr(lld+4+2*m+2*ii),7,0)    ! Eout(ii)
                           xss(nex+1+n+ii)=&
                             sigfig(scr(lld+5+2*m+2*ii),7,0)    ! PDF(ii)
                           if (xss(nex+1+n+ii).lt.rmin)&
                             xss(nex+1+n+ii)=0                  ! PDF(ii)
                           if (ii.eq.1) then
                              xss(nex+1+2*n+ii)=0               ! CDF(1)
                              ubar=0
                           endif
                           if (ii.gt.1.and.intt.eq.1) then
                              sum=xss(nex+1+2*n+ii-1)&
                                +xss(nex+1+n+ii-1)&
                                *(xss(nex+1+ii)-xss(nex+1+ii-1))
                              xss(nex+1+2*n+ii)=sum             ! CDF(ii)
                              ubar=ubar&
                                +xss(nex+1+n+ii-1)&
                                *(xss(nex+1+ii)-xss(nex+1+ii-1))&
                                +(xss(nex+1+ii)+xss(nex+1+ii-1))/2
                           endif
                           if (ii.gt.1.and.intt.eq.2) then
                              sum=xss(nex+1+2*n+ii-1)&
                               +(xss(nex+1+n+ii)+xss(nex+1+n+ii-1))&
                               *(xss(nex+1+ii)-xss(nex+1+ii-1))/2
                              xss(nex+1+2*n+ii)=sum             ! CDF(ii)
                              ubar=ubar&
                                +(xss(nex+1+n+ii)+xss(nex+1+n+ii-1))&
                                *(xss(nex+1+ii)-xss(nex+1+ii-1))&
                                *(xss(nex+1+ii)+xss(nex+1+ii-1))/4
                           endif
                        enddo
                        ! renormalize cummulative probabilities
                        renorm=one/xss(nex+1+3*n)
                        do ii=1,n
                           xss(nex+1+n+ii)=&
                             sigfig(renorm*xss(nex+1+n+ii),7,0)    ! PDF(ii)
                           xss(nex+1+2*n+ii)=&
                             sigfig(renorm*xss(nex+1+2*n+ii),9,0)  ! CDF(ii)
                        enddo
                        nex=nex+2+3*n       ! index for the next distribution
                        e=xss(ie+iie)       ! e from xss, thus MeV
                        scr(llht+6+2*iie)=e ! store it in scr, so energy in MeV
                        scr(llht+7+2*iie)=(awr-awpp)*(e+q)/awr
                     enddo
                     ! add in contribution to heating
                     nrr=1
                     npp=2
                     do ie=it,nes
                        e=xss(esz+ie-1)/emev
                        call terpa(h,e,en,idis,scr(llht),npp,nrr)
                        !--get the yield and modify heating
                        !--beware: e is already in MeV, scr(llht) has been
                        !--modified to be in MeV already (see above)
                        call terpa(yld,e*emev,en,idis,scr,npp,nrr)
                        h=yld*h ! just in case, multiply by yield
                        if (ilaw2mt5.eq.0.and.mt.eq.5.and.yld.ne.one) then
                           ilaw2mt5=1
                           write(text,'(''yield different from 1 for outgoing particle '',i5,''.'')')ip
                           if (izarec.eq.ip) then
                              call mess('acephn',&
                                        'law=2 (discrete two-body scattering) used in mt=5 recoil',&
                                        text)
                           else
                              call mess('acephn',&
                                        'law=2 (discrete two-body scattering) used in mt=5',&
                                        text)
                           endif
                        endif
                        ss=0
                        if (ie.ge.iaa) ss=xss(2+k+ie-iaa)
                        xss(phn+2+ie-it)=xss(phn+2+ie-it)+h*ss
                        if (xss(tot+ie-1).ne.zero)&
                          xss(thn+ie-1)=xss(thn+ie-1)&
                          +h*ss/xss(tot+ie-1)
                     enddo
                     ilaw2mt5=0
                  else
                     call skip6(nin,0,0,scr,law)
                  endif
               enddo
            endif
         enddo
      enddo

      !--assign the pointers for the distribution data
      ldlwp=nex
      xss(ixsa+neixs*(itype-1)+10)=ldlwp
      dlwp=ldlwp+ntrp
      xss(ixsa+neixs*(itype-1)+11)=dlwp
      nex=dlwp

      !--energy distributions from discrete levels in file 4.
      !--only neutron producing reactions are given here.
      do i=1,ntrp
         mt=nint(xss(mtrp+i-1))
         mtt=0
         ir=0
         do while (mtt.ne.mt)
            ir=ir+1
            mtt=nint(xss(mtr+ir-1))
            q=xss(lqr+ir-1)
            k=nint(xss(lsig+ir-1))+sig-1
            n=nint(xss(k+1))
            iaa=nint(xss(k))
         enddo
         jp=0
         do j=1,mtx
            if (mfm(j).eq.4.and.mtm(j).eq.mt&
              .and.mt.ge.50.and.mt.lt.91) jp=i
         enddo
         if (jp.gt.0) then
            ! distribution using law33
            xss(ldlwp+jp-1)=nex-dlwp+1
            last=nex
            xss(nex)=0
            xss(nex+1)=33
            nex=nex+3
            xss(nex)=0
            xss(nex+1)=2
            xss(nex+2)=sigfig(xss(esz+iaa-1)/emev,7,0)
            xss(nex+3)=sigfig(xss(esz+nes-1)/emev,7,0)
            xss(nex+4)=1
            xss(nex+5)=1
            nex=nex+2+2*2
            xss(last+2)=nex-dlwp+1
            ! amass=awr/awi
            ! aprime=awp/awi
            ! xss(nex)=sigfig((1+amass)*(-q)/amass,7,0)
            ! xss(nex+1)=&
            !  sigfig(amass*(amass+1-aprime)/(1+amass)**2,7,0)
            ! with awi = 0 for photons
            awp=1 ! MF4 is for outgoing neutrons
            xss(nex)=sigfig(-q,7,0)
            xss(nex+1)=sigfig((awr-awp)/awr,7,0)
            nex=nex+2
            ! neutron ebar for this reaction
            ! and local heating from recoil+photon
            ! neglecting photon momentum.
            do j=iaa,nes
               e=xss(esz+j-1)/emev
               ebar=awr*(e-abs(q))/(1+awr)
               hh=ebar*xss(2+k+j-iaa)
               xss(phn+2+j-it)=xss(phn+2+j-it)+hh
               hh=(e-abs(q))*xss(2+k+j-iaa)-hh
               if (xss(tot+j-1).ne.zero)&
                  xss(thn+j-1)=xss(thn+j-1)+hh/xss(tot+j-1)
            enddo
         endif
      enddo

      !--energy distributions from file 5.
      !--only neutron producing reactions are given here.
      do i=1,ntrp
         mt=nint(xss(mtrp+i-1))
         mtt=0
         ir=0
         do while (mtt.ne.mt)
            ir=ir+1
            mtt=nint(xss(mtr+ir-1))
            q=xss(lqr+ir-1)
            k=nint(xss(lsig+ir-1))+sig-1
            n=nint(xss(k+1))
            iaa=nint(xss(k))
         enddo
         jp=0
         do j=1,mtx
            if (mfm(j).eq.5.and.mtm(j).eq.mt) jp=i
         enddo
         if (jp.gt.0) then
            call findf(matd,5,mt,nin)
            call contio(nin,0,0,scr,nb,nw)
            nk=nint(scr(5))
            xss(ldlwp+jp-1)=nex-dlwp+1

            !--loop over subsections
            do ik=1,nk
               call tab1io(nin,0,0,scr,nb,nw)
               u=scr(1)
               lf=nint(scr(4))
               m=nint(scr(5))
               n=nint(scr(6))
               jnt=nint(scr(8))
               if (ik.gt.1) xss(last)=nex-dlwp+1
               last=nex
               xss(nex)=0
               xss(nex+1)=lf
               if (lf.eq.1) xss(nex+1)=4
               if (lf.eq.12) xss(nex+1)=4
               if (m.ne.1.or.jnt.ne.2) then
                  ja=nex+3
                  xss(ja)=m
                  jb=ja+m
                  do j=1,m
                     xss(ja+j)=scr(5+2*j)
                     xss(jb+j)=scr(6+2*j)
                  enddo
                  nex=jb+m+1
               else
                  xss(nex+3)=0
                  nex=nex+4
               endif
               xss(nex)=n
               l=5+2*m
               do j=1,n
                  xss(j+nex)=sigfig(scr(2*j+l)/emev,7,0)
                  xss(j+n+nex)=scr(2*j+1+l)
               enddo
               nex=nex+2*n+1
               xss(last+2)=nex-dlwp+1

               !--store data according to type
               if (lf.eq.1) then
                  call tab2io(nin,0,0,scr,nb,nw)
                  m=nint(scr(5))
                  n=nint(scr(6))
                  jnt=nint(scr(8))
                  jnt=mod(jnt,10)
                  if (jnt.gt.2) jnt=2
                  if (m.ne.1.or.jnt.ne.2) then
                     xss(nex)=m
                     do j=1,m
                        xss(j+nex)=scr(2*j+5)
                        jnt=nint(scr(2*j+6))
                        jnt=mod(jnt,10)
                        if (jnt.gt.2) jnt=2
                        xss(j+m+nex)=jnt
                     enddo
                     nex=nex+1+2*m
                  else
                     xss(nex)=0
                     nex=nex+1
                  endif
                  xss(nex)=n
                  nexn=nex+n
                  nexd=nexn+n+1
                  ne=n
                  do j=1,ne
                     call tab1io(nin,0,0,scr,nb,nw)
                     jscr=1
                     do while (nb.ne.0)
                        jscr=jscr+nw
                        call moreio(nin,0,0,scr(jscr),nb,nw)
                     enddo
                     e=c2h
                     xss(nex+j)=sigfig(e/emev,6,0)
                     xss(nexn+j)=nexd-dlwp+1
                     m=n1h
                     n=n2h
                     jnt=nint(scr(6+2*m))
                     xss(nexd)=jnt
                     xss(nexd+1)=n
                     nexd=nexd+1
                     xss(nexd+1+2*n)=0
                     do ki=1,n
                        ep=scr(5+2*m+2*ki)
                        ll=5+2*m+2*ki
                        xss(ki+nexd)=sigfig(scr(ll)/emev,7,0)
                        xss(ki+n+nexd)=sigfig(scr(ll+1)*emev,7,0)
                        if (xss(ki+n+nexd).lt.rmin) xss(ki+n+nexd)=0
                        if (ki.gt.1.and.jnt.eq.1) xss(ki+2*n+nexd)=&
                          xss(ki+2*n-1+nexd)+scr(ll-1)*(scr(ll)-scr(ll-2))
                        if (ki.gt.1.and.jnt.eq.2) xss(ki+2*n+nexd)=&
                          xss(ki+2*n-1+nexd)+((scr(ll-1)&
                          +scr(ll+1))/2)*(scr(ll)-scr(ll-2))
                     enddo
                     !renormalize
                     renorm=1
                     if (xss(3*n+nexd).ne.zero)&
                       renorm=1/xss(3*n+nexd)
                     do ki=1,n
                        xss(ki+n+nexd)=&
                          sigfig(xss(ki+n+nexd)*renorm,7,0)
                        xss(ki+2*n+nexd)=&
                          sigfig(xss(ki+2*n+nexd)*renorm,9,0)
                     enddo
                     nexd=nexd+3*n+1
                  enddo
                  nex=nexd
               else if (lf.eq.7.or.lf.eq.9) then
                  call tab1io(nin,0,0,scr,nb,nw)
                  m=nint(scr(5))
                  n=nint(scr(6))
                  jnt=nint(scr(8))
                  if (m.ne.1.or.jnt.ne.2) then
                     xss(nex)=m
                     do j=1,m
                        xss(j+nex)=scr(5+2*j)
                        xss(j+m+nex)=scr(6+2*j)
                     enddo
                     nex=nex+2*m+1
                  else
                     xss(nex)=0
                     nex=nex+1
                  endif
                  xss(nex)=n
                  do j=1,n
                     xss(j+nex)=sigfig(scr(5+2*j+2*m)/emev,7,0)
                     xss(j+n+nex)=sigfig(scr(6+2*j+2*m)/emev,7,0)
                  enddo
                  nex=nex+1+2*n
                  xss(nex)=u/emev
                  nex=nex+1
                  nrr=1
                  npp=2
                  do ie=iaa,nes
                     e=xss(esz+ie-1)
                     if (mth.eq.18) then
                        ipp=2
                        irr=1
                        call terpa(y,e,en,idis,fnubar,ipp,irr)
                     else
                        y=1
                        if (mth.eq.11.or.mth.eq.16.or.mth.eq.24.or.&
                            mth.eq.30.or.mth.eq.41.or.mth.eq.154.or.&
                            mth.eq.159.or.mth.eq.176.or.mth.eq.190.or.&
                            (mth.ge.875.and.mth.le.891)) then
                           y=2
                        elseif (mth.eq.17.or.mth.eq.25.or.mth.eq.42.or.&
                                mth.eq.157.or.mth.eq.172.or.mth.eq.177.or.&
                                mth.eq.179.or.(mth.ge.181.and.mth.le.199)) then
                           y=3
                        elseif (mth.eq.37.or.mth.eq.156.or.mth.eq.165.or.&
                                mth.eq.169.or.mth.eq.173.or.mth.eq.178.or.&
                                (mth.ge.194.and.mth.le.196)) then
                           y=4
                        elseif (mth.eq.152.or.mth.eq.162.or.mth.eq.166.or.&
                                mth.eq.170.or.mth.eq.174.or.mth.eq.200) then
                           y=5
                        elseif (mth.eq.153.or.mth.eq.163.or.mth.eq.167.or.&
                                mth.eq.171.or.mth.eq.175) then
                           y=6
                        elseif (mth.eq.160.or.mth.eq.164.or.mth.eq.168) then
                           y=7
                        elseif (mth.eq.161) then
                           y=8
                        endif
                     endif
                     call terpa(theta,e,en,idis,scr,npp,nrr)
                     x=0
                     if (theta.gt.zero) x=(e-u)/theta
                     ebar=0
                     if (lf.eq.7.and.x.gt.zero) then
                        anorm=sqrt(theta)**3*(sqrt(pi)*(1-erfc(x))/2&
                           -sqrt(x)*exp(-x))
                        ebar=3*theta/2-(sqrt(theta)**2&
                           *sqrt(x)**3*exp(-x))/anorm
                     else if (lf.eq.9.and.x.gt.zero) then
                        anorm=theta**2*(1-exp(-x)*(1+x))
                        ebar=2*theta-(theta**3*x**2*exp(-x))/anorm
                     endif
                     hh=y*(ebar/emev)*xss(2+k+ie-iaa)
                     xss(phn+2+ie-it)=xss(phn+2+ie-it)+hh
                     if (xss(tot+ie-1).ne.zero)&
                       xss(thn+ie-1)=xss(thn+ie-1)-hh/xss(tot+ie-1)
                  enddo
               else
                  call error('acephn','file 5 law not ready',' ')
               endif
            enddo
         endif
      enddo

      !--now check for file-6 distribution data
      !--find each subsection that contributes to this production
      if (mf6.ne.0) then
         jp=0
         do i=1,ntrp
            mt=nint(xss(mtrp+i-1))
            do j=1,mtx
               if (mfm(j).eq.6.and.mtm(j).eq.mt) jp=i
            enddo
            if (jp.ne.0) then
               call findf(matd,6,mt,nin)
               call contio(nin,0,0,scr,nb,nw)
               lct=nint(scr(4))
               nk=nint(scr(5))
               mtt=0
               ir=0
               do while (mtt.ne.mth)
                  ir=ir+1
                  mtt=nint(xss(mtr+ir-1))
                  q=xss(lqr+ir-1)
                  k=nint(xss(lsig+ir-1))+sig-1
                  n=nint(xss(k+1))
                  iaa=nint(xss(k))
               enddo
               ik=0
               do while (ik.lt.nk)
                  ik=ik+1
                  ! read the multiplicity
                  call tab1io(nin,0,0,scr,nb,nw)
                  jscr=1+nw
                  do while (nb.ne.0)
                     call moreio(nin,0,0,scr(jscr),nb,nw)
                     jscr=jscr+nw
                  enddo
                  ! retrieve izap, awp and the law
                  izap=nint(scr(1))
                  awp=scr(2)
                  law=nint(scr(4))

                  if (izap.ne.ip) then
                     call skip6(nin,0,0,scr,law)
                  else

                     ! if this is fission, replace the yield with the nubar - as before
                     if (mth.eq.18.and.izap.eq.1.and.mtxnu.gt.0) then
                        call copynubar(scr,fnubar,jscr)
                     endif

                     xss(ldlwp+jp-1)=nex-dlwp+1  ! locator, points to LNW
                     last=nex
                     xss(last)=0                 ! LNW
                     xss(last+1)=0               ! LAW set to 0
                     xss(last+2)=0               ! IDAT set to 0
                     nex=nex+3                   ! nex points to NR

                     !--we can only process law=1, 2, and 4 currently
                     if (law.ne.1.and.law.ne.2.and.law.ne.4) then
                        call mess('acephn','can only do law=1,',&
                          ' law=2, or law=4 currently')
                        call skip6(nin,0,0,scr,law)
                     else if (law.eq.1) then
                        ll=jscr
                        call tab2io(nin,0,0,scr(ll),nb,nw)
                        lang=nint(scr(ll+2))
                        lep=nint(scr(ll+3))
                        ne=nint(scr(ll+5))       ! number of incident energies
                        if (lang.eq.1) then      ! legendre polynomials to law=61
                           xss(last+1)=61        ! LAW
                        else if (lang.eq.2) then ! Kalbach-Mann to law=44
                           xss(last+1)=44        ! LAW
                        else
                           write(text,'(''lang='',i3,'' not supported for law='',i2)')lang,law
                           call error('acephn',text,'')
                        endif
                        xss(landp+jp-1)=-1     ! angular included in energy distribution
                        nr=0
                        xss(nex)=nr            ! NR set to 0
                        lee=nex                ! lee points to NR
                        nex=nex+2*nr+1
                        nle=2
                        xss(nex)=nle           ! number of energies, NE, default to 2
                        nex=nex+1+2*nle        ! leaving room for E(1:2), P(1:2).  nex points to LDAT(1)
                        xss(last+2)=nex-dlwp+1 ! IDAT
                        nr=0
                        xss(nex)=nr            ! LDAT(1) = NR set to 0
                        nex=nex+1+2*nr
                        xss(nex)=ne            ! LDAT(2) = NE set to number of incident energies
                        nex=nex+1
                        lle=nex                ! lle points to LDAT(3) = E(1)
                        nex=lle+2*ne           ! nex points to start of first distribution

                        ! scr(llh) up to scr(lld-1) is set up for heating
                        llh=ll
                        scr(llh)=0
                        scr(llh+1)=0
                        scr(llh+2)=0
                        scr(llh+3)=0
                        scr(llh+4)=1
                        scr(llh+5)=ne
                        scr(llh+6)=ne
                        scr(llh+7)=2
                        lld=llh+8+2*ne

                        ! go over each incident energy value
                        do ie=1,ne

                           ! read distribution, store starting at scr(lld)
                           ll=lld
                           call listio(nin,0,0,scr(ll),nb,nw)
                           ll=ll+nw
                           if (ll.gt.nwscr) call error('acephn',&
                               'scr array overflow in file 6 list',' ')
                           do while (nb.ne.0)
                              call moreio(nin,0,0,scr(ll),nb,nw)
                              ll=ll+nw
                              if (ll.gt.nwscr) call error('acephn',&
                                  'scr array overflow in file 6 list',' ')
                           enddo
                           nd=nint(scr(lld+2))
                           na=nint(scr(lld+3))
                           ng=nint(scr(lld+5))
                           ncyc=na+2

                           ! set energy range and probability for this law
                           ! only first and last incident energy needed
                           ! probability set to 1 all energies
                           if (ie.eq.1) then
                              xss(lee+2)=sigfig(scr(lld+1)/emev,7,0)
                              xss(lee+4)=1
                           else if (ie.eq.ne) then
                              xss(lee+3)=sigfig(scr(lld+1)/emev,7,0)
                              xss(lee+5)=1
                           endif

                           ! set incident energy and locator for the current distribution
                           xss(lle+ie-1)=sigfig(scr(lld+1)/emev,7,0) ! Ein(ie)
                           ee=xss(lle+ie-1)
                           xss(lle+ne+ie-1)=nex-dlwp+1  ! locator for distribution
                           xss(nex)=lep+10*nd           ! INTT for this secondary energy distribution
                           xss(nex+1)=ng                 ! NP
                           if (lang.eq.1) nexc=nex+2+4*ng ! only needed if law=61

                           amass=awp*emc2
                           avadd=ee/(awr*emc2)
                           avlab=0
                           avll=0

                           ! go over the outgoing energies
                           do ig=1,ng
                              ! outgoing energy
                              xss(nex+1+ig)=&
                                sigfig(scr(lld+6+ncyc*(ig-1))/emev,7,0)
                              ! pdf
                              if (ig.le.nd) then
                                xss(nex+1+ig+ng)=&
                                  sigfig(scr(lld+7+ncyc*(ig-1)),7,0)
                              else
                                xss(nex+1+ig+ng)=&
                                  sigfig(scr(lld+7+ncyc*(ig-1))*emev,7,0)
                              endif
                              test=xss(nex+1+ig+ng)
                              if (test.gt.zero.and.test.lt.small)&
                                xss(nex+1+ig+ng)=small
                              ! cdf
                              if (ig.eq.1) then
                                 ! initial value
                                 if (nd.eq.0) then
                                    xss(nex+1+ig+2*ng)=0
                                 else
                                    xss(nex+1+ig+2*ng)=&
                                                  scr(lld+7+ncyc*(ig-1))
                                 endif
                              elseif (ig.le.nd) then
                                 ! discrete photon
                                 xss(nex+1+ig+2*ng)=xss(nex+ig+2*ng)+&
                                                  scr(lld+7+ncyc*(ig-1))
                              elseif (ig.eq.nd+1) then
                                 ! start of continuum
                                 xss(nex+1+ig+2*ng)=xss(nex+ig+2*ng)
                              endif
                              if (ig.gt.nd+1) then
                                 ! continuum
                                 if (lep.eq.1) then
                                    ! histogram
                                    xss(nex+1+ig+2*ng)=xss(nex+ig+2*ng)&
                                       +scr(lld+7+ncyc*(ig-2))&
                                       *(scr(lld+6+ncyc*(ig-1))&
                                       -scr(lld+6+ncyc*(ig-2)))
                                 elseif (lep.eq.2) then
                                    ! lin-lin
                                    xss(nex+1+ig+2*ng)=xss(nex+ig+2*ng)&
                                       +((scr(lld+7+ncyc*(ig-2))&
                                       +scr(lld+7+ncyc*(ig-1)))/2)&
                                       *(scr(lld+6+ncyc*(ig-1))&
                                       -scr(lld+6+ncyc*(ig-2)))
                                 endif
                              endif
                              if (lang.eq.2) then
                                 ! kalbach-mann
                                 rkal=scr(lld+8+ncyc*(ig-1))
                                 ep=xss(nex+1+ig)
                                 akal=bachaa(izai,izap,za,ee,ep)
                                 xss(nex+1+ig+3*ng)=sigfig(rkal,7,0) ! r
                                 xss(nex+1+ig+4*ng)=sigfig(akal,7,0) ! a
                              else

                                 if (lang.eq.1) then
                                    xss(nex+1+ig+3*ng)=nexc-dlwp+1  !pointer to angdist table
                                    ! convert lang=1 list in scr to a normalized P(1) to P(NA) list for ptleg2
                                    scr(ll)=0
                                    scr(ll+1)=scr(lld+6+ncyc*(ig-1))        !EOUT(ig)
                                    scr(ll+2)=0
                                    scr(ll+3)=0
                                    scr(ll+4)=na                            !P(l) order (zero is allowed)
                                    scr(ll+5)=0
                                    do ib=1,na
                                       lll=lld+7+ncyc*(ig-1)
                                       scr(ll+5+ib)=0
                                       if (scr(lll).ne.zero) then
                                          scr(ll+5+ib)=scr(lll+ib)/scr(lll) !P(n)/P(0)
                                       endif
                                    enddo

                                    call ptleg2(scr(ll))  !P(l) list in, tab1 (mu,pdf) out

                                    intmu=2
                                    xss(nexc)=intmu
                                    nmu=nint(scr(ll+5))
                                    xss(nexc+1)=nmu
                                    do imu=1,nmu
                                       xss(nexc+1+imu)=sigfig(scr(ll+6+2*imu),7,0)
                                       xss(nexc+1+nmu+imu)=sigfig(scr(ll+7+2*imu),7,0)
                                       if (imu.eq.1) then
                                           xss(nexc+1+2*nmu+imu)=0
                                       else if (imu.eq.nmu) then
                                           xss(nexc+1+2*nmu+imu)=1
                                       else
                                          del=scr(ll+6+2*imu)-scr(ll+4+2*imu)
                                          av=(scr(ll+7+2*imu)+scr(ll+5+2*imu))/2
                                          xss(nexc+1+2*nmu+imu)=&
                                                               xss(nexc+1+2*nmu+imu-1)+del*av
                                          xss(nexc+1+2*nmu+imu)=&
                                                        sigfig(xss(nexc+1+2*nmu+imu),7,0)
                                       endif
                                    enddo
                                    nexc=nexc+2+3*nmu
                                 endif

                              endif
                              ! average lab energy
                              if (ig.ne.1) then
                                 eavi=xss(nex+1+ig)
                                 if (lang.ne.2.or.na.eq.0) then
                                    avl=eavi
                                 else
                                    avcm=sqrt(2*eavi/amass)
                                    sign=1
                                    avl=eavl(akal,amass,avcm,avadd,&
                                      rkal,sign)
                                 endif
                                 dele=xss(nex+1+ig)-xss(nex+ig)
                                 if (lep.eq.1) then
                                    avav=xss(nex+ig+ng)*(avll+avl)/2
                                 else
                                    avav=(xss(nex+ig+ng)*avll&
                                      +xss(nex+ig+1+ng)*avl)/2
                                 endif
                                 avlab=avlab+avav*dele
                                 avll=avl
                              endif
                           enddo  !end of loop over secondary energies
                           ! renormalize cummulative probabilities
                           renorm=one/xss(nex+1+3*ng)
                           do ig=1,ng
                              xss(nex+1+ng+ig)=&
                                sigfig(renorm*xss(nex+1+ng+ig),7,0)
                              xss(nex+1+2*ng+ig)=&
                                sigfig(renorm*xss(nex+1+2*ng+ig),9,0)
                           enddo
                           scr(llh+6+2*ie)=ee
                           scr(llh+7+2*ie)=avlab
                           if(lang.eq.1)then
                              nex=nexc
                           else
                              nex=nex+2+(2*na+3)*ng
                           endif
                        enddo  !end of loop over incident energies

                        !add in contribution to heating
                        !for this subsection
                        nrr=1
                        npp=2
                        do ie=iaa,nes
                           e=xss(esz+ie-1)
                           call terpa(y,e,en,idis,scr(lly),npp,nrr)
                           scr(lld+ie-iaa)=y*xss(2+k+ie-iaa)
                        enddo
                        it=nint(xss(pxs))
                        nrr=1
                        npp=2
                        do ie=iaa,nes
                           e=xss(esz+ie-1)/emev
                           call terpa(h,e,en,idis,scr(llh),npp,nrr)
                           hh=h*scr(lld+ie-iaa)
                           xss(phn+2+ie-it)=xss(phn+2+ie-it)+hh
                           do ii=1,mtx
                              if (mfm(ii).eq.6.and.mtm(ii).eq.mth&
                                .and.nr6(ii).eq.0.and.&
                                xss(tot+ie-1).ne.0)&
                                xss(thn+ie-1)=xss(thn+ie-1)&
                                -hh/xss(tot+ie-1)
                           enddo
                        enddo
                     else if (law.eq.2) then
                        ll=jscr
                        xss(last+1)=33
                        xss(nex)=0
                        xss(nex+1)=2
                        nnr=nint(scr(5))
                        nnp=nint(scr(6))
                        xss(nex+2)=sigfig(scr(7+2*nnr)/emev,7,0)
                        xss(nex+3)=&
                           sigfig(scr(5+2*nnr+2*nnp)/emev,7,0)
                        xss(nex+4)=1
                        xss(nex+5)=1
                        nex=nex+2+2*2
                        xss(last+2)=nex-dlwp+1
                        ! amass=awr/awi
                        ! aprime=awp/awi
                        ! xss(nex)=sigfig((1+amass)*(-q)/amass,7,0)
                        ! xss(nex+1)=&
                        !  sigfig(amass*(amass+1-aprime)/(1+amass)**2,7,0)
                        ! with awi = 0 for photons
                        xss(nex)=sigfig(-q,7,0)
                        xss(nex+1)=sigfig((awr-awp)/awr,7,0)
                        nex=nex+2
                        call tab2io(nin,0,0,scr(ll),nb,nw)
                        lep=nint(scr(ll+3))
                        ne=nint(scr(ll+5))
                        do ie=1,ne
                           ll=lld
                           call listio(nin,0,0,scr(ll),nb,nw)
                           ll=ll+nw
                           do while (nb.ne.0)
                              call moreio(nin,0,0,scr(ll),nb,nw)
                              ll=ll+nw
                           enddo
                        enddo
                     else if (law.eq.4) then
                        xss(last+1)=33
                        xss(nex)=0
                        xss(nex+1)=2
                        nnr=nint(scr(5))
                        nnp=nint(scr(6))
                        xss(nex+2)=sigfig(scr(7+2*nnr)/emev,7,0)
                        xss(nex+3)=&
                           sigfig(scr(5+2*nnr+2*nnp)/emev,7,0)
                        xss(nex+4)=1
                        xss(nex+5)=1
                        nex=nex+2+2*2
                        xss(last+2)=nex-dlwp+1
                        ! amass=awr/awi
                        ! aprime=awp/awi
                        ! xss(nex)=sigfig((1+amass)*(-q)/amass,7,0)
                        ! xss(nex+1)=&
                        !  sigfig(amass*(amass+1-aprime)/(1+amass)**2,7,0)
                        ! with awi = 0 for photons
                        xss(nex)=sigfig(-q,7,0)
                        xss(nex+1)=sigfig((awr-awp)/awr,7,0)
                        nex=nex+2
                     endif
                  endif
               enddo
            endif
         enddo

         !--divide the heating contribution by the total xsec
         !--and add it into the total heating, if appropriate
         do ie=it,nes
            if (xss(tot+ie-1).ne.zero) then
               xss(phn+2+ie-it)=xss(phn+2+ie-it)/xss(tot+ie-1)
            endif
            if (ip.gt.1) then
               xss(thn+ie-1)=xss(thn+ie-1)+xss(phn+2+ie-it)
            endif
            xss(phn+2+ie-it)=sigfig(xss(phn+2+ie-it),7,0)
         enddo
      endif

   !--continue the loop over types
   enddo
   lxs=nex-1

   !--convert main energy grid to mev
   do i=1,nes
      xss(esz+i-1)=sigfig(xss(esz+i-1)/emev,7,0)
      xss(thn+i-1)=sigfig(xss(thn+i-1),7,0)
   enddo
   call closz(nin)

   !--print and write the photonuclear file
   zaid=za+suff
   if (izaoption.eq.1.and.is.gt.0) then
      zaid=za+300+100*is+suff
   endif
   if (izaoption.eq.1.and.za.eq.95242) then
      if (is.eq.0) then
         zaid=za+400+suff
      elseif (is.eq.1) then
         zaid=za+suff
      endif
   endif
   if (mcnpx.eq.0) then
      write(hz,'(f9.2,''u'')') zaid
   else
      write(hz,'(f10.3,''pu '')') zaid
   endif
   aw0=awr
   tz=0
   call dater(hdt)
   hd='  '//hdt
   write(hm,'(''   mat'',i4)') matd
   if (iprint.gt.0) call phnprt(hk)
   call phnout(ityp,nace,ndir,mcnpx,hk,izn,awn)

   !--finished
   return
   end subroutine acephn

   subroutine phnfix(itype,nin,nout,ndir,iprint,nplot,mcnpx,suff,&
     nxtra,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Print and or edit an ACE photonuclear file.
   !-------------------------------------------------------------------
   use util ! provides closz
   ! externals
   integer::itype,nin,nout,ndir,iprint,nplot,mcnpx,nxtra
   real(kr)::suff
   character(70)::hk
   integer::izn(16)
   real(kr)::awn(16)
   ! internals
   integer::l,j,n,max,iza,i
   integer::izo(16)
   real(kr)::awo(16)
   character(70)::hko
   real(kr)::zaid
   character(3)::ht
   character(9)::str
   real(kr),parameter::zero=0

   integer,parameter::ner=1

   !--read type 1 ace format file
   call openz(nin,0)
   if (itype.eq.1) then
      if (mcnpx.eq.0) then
         read(nin,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hko,hm
      else
         read(nin,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:13),aw0,tz,hd,hko,hm
      endif
      read (nin,'(4(i7,f11.0))') (izo(i),awo(i),i=1,16)
      read (nin,'(8i9)') lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,&
        nxsd(1:4),tvn,esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(1:21)
      n=(lxs+3)/4
      l=0
      do i=1,n
         read (nin,'(4e20.0)') (xss(l+j),j=1,4)
         l=l+4
      enddo

   !--read type 2 ace format file
   else if (itype.eq.2) then
      if (mcnpx.eq.0) then
        read(nin) hz(1:10),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,nxsd(1:4),tvn,&
          esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(1:21)
      else
        read(nin) hz(1:13),aw0,tz,hd,hko,hm,(izo(i),awo(i),i=1,16),&
          lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,nxsd(1:4),tvn,&
          esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(1:21)
      endif
      n=(lxs+ner-1)/ner
      l=0
      do i=1,n
         max=lxs-l
         if (max.gt.ner) max=ner
         read (nin) (xss(l+j),j=1,max)
         l=l+max
      enddo
      call closz(-nin)
   endif

   !--adjust zaid
   if (mcnpx.gt.0) then
       read(hz,'(f10.0,a3)') zaid,ht
   else
       read(hz,'(a9,a1)') str,ht
       if (ht(1:1).ne.'t') then
          read(hz,'(f9.0,a1)') zaid,ht
       endif
   endif
   if (suff.ge.zero.and.ht(1:1).ne.'t') then
      iza=nint(zaid)
      zaid=iza+suff
      if (mcnpx.gt.0) then
          write(hz,'(f10.3,a3)') zaid,ht
      else
          write(hz,'(f9.2,a1)') zaid,ht
      endif
   endif

   !--adjust comment and (iz,aw) list
   if (len_trim(hk).eq.0) then
      hk=hko
   endif
   if (nxtra.ne.0) then
      do i=1,nxtra
         izn(i)=izo(i)
         awn(i)=awo(i)
      enddo
   endif

   !--print, plot, and/or write the file.
   if (iprint.gt.0) call phnprt(hk)
   if (nout.gt.0) call phnout(itype,nout,ndir,mcnpx,hk,izn,awn)
   if (nplot.ne.0) call phnplo(nplot,hk)

   return
   end subroutine phnfix

   subroutine phnprt(hk)
   !-------------------------------------------------------------------
   ! Print ACE photo-nuclear data from memory.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util ! provides error
   use acecm ! provides mtname
   ! externals
   character(70)::hk
   ! internals
   integer::i,k,iaa,ib,ic,i1,i3,list,l,na,nb,nc,j,n,nc2,nkk
   integer::m,ii,imt,naa,ie,mt,l1,l2,ne,ll,nbina,nbin1
   integer::intt,np,ln,law,l3,loci,nn,nd
   integer::ipt,ntrp,pxs,phn,mtrp,tyrp,lsigp,sigp,landp,andp,ldlwp,dlwp
   integer::ip,locj,intmu,nmu,imu
   real(kr)::e,xs,heat,e2
   integer::imn(8),imx(8),loc(8)
   character(10)::name,title(16)
   character(15)::kk(40)
   character(6)::blank='      '
   character(6)::ek='energy'
   character(12)::dashes='------------'

   !--print information block
   write(nsyso,'(''1''////////&
     &38x,''zaid'',1x,a13/39x,''awr'',f10.3/&
     &6x,''***********************'',9x,''temp'',1p,e10.2/&
     &6x,''*                     *'',9x,''date'',a10/&
     &6x,''*    photo-nuclear    *'',10x,''mat'',a10/&
     &6x,''*                     *''/&
     &6x,''*   ace format file   *'',10x,''lxs'',i10/&
     &6x,''*                     *'',11x,''za'',i10/&
     &6x,''*     processed by    *'',10x,''nes'',i10/&
     &6x,''*                     *'',10x,''ntr'',i10/&
     &6x,''*        njoy         *'',8x,''ntype'',i10/&
     &6x,''*                     *'',8x,''npixs'',i10/&
     &6x,''***********************'',8x,''neixs'',i10/&
     &41x,''z'',i10/41x,''a'',i10/41x,''s'',i10/&
     &39x,''tvn'',i10/39x,''esz'',i10/39x,''mtr'',i10/&
     &39x,''lqr'',i10/38x,''lsig'',i10/39x,''sig'',i10/&
     &//6x,''hk--- '',a70///)')&
     hz,aw0,tz,hd,hm,lxs,za,nes,ntr,ntype,npixs,neixs,iz,ia,is,tvn,&
     esz,mtr,lqr,lsig,sig,hk

   !--photonuclear reaction descriptions
   write(nsyso,'(//&
     &7x,''photonuclear reactions''/7x,''----------------------'')')
   write(nsyso,'(/&
     &7x,''reaction'',8x,''mt'',6x,''lsig'',6x,&
     &''           emin           emax              q''/&
     &7x,''--------'',8x,''--'',6x,''----'',6x,&
     &''   ------------   ------------   ------------'')')
   do i=1,ntr
      k=nint(xss(lsig+i-1)+sig-1)
      iaa=nint(xss(k))
      ib=iaa+nint(xss(k+1))-1
      ic=nint(xss(mtr+i-1))
      call mtname(ic,name,0)
      if (name(1:1).eq.'(') then
         name(2:2)='g'
      endif
      i1=nint(xss(mtr+i-1))
      i3=nint(xss(lsig+i-1))
      write(nsyso,'(7x,a10,i8,i10,6x,1p,3e15.6)')&
        name,i1,i3,xss(esz+iaa-1),xss(esz+ib-1),xss(lqr+i-1)
   enddo

   !--print principal cross sections
   do i=1,nes
      if (mod(i,57).eq.1) then
         write(nsyso,'(''1''/&
           &5x,''i'',5x,''energy'',11x,'' total  '',7x,&
           &''nonelastic'',5x,''elastic'',8x,''heating''/&
           &3x,''---'',3x,''--------------'',&
           &4(3x,''------------''))')
      endif
      if (els.eq.0.and.thn.eq.0) then
         write(nsyso,'(i6,1p,e17.8,2e15.6)') i,&
           xss(esz+i-1),xss(tot+i-1),xss(non+i-1)
      else if (els.eq.0) then
         write(nsyso,'(i6,1p,e17.8,2e15.6,15x,e15.6)') i,&
           xss(esz+i-1),xss(tot+i-1),xss(non+i-1),xss(thn+i-1)
      else if (thn.eq.0) then
         write(nsyso,'(i6,1p,e17.8,3e15.6)') i,&
           xss(esz+i-1),xss(tot+i-1),xss(non+i-1),xss(els+i-1)
      else
         write(nsyso,'(i6,1p,e17.8,4e15.6)') i,xss(esz+i-1),&
           xss(tot+i-1),xss(non+i-1),xss(els+i-1),xss(thn+i-1)
      endif
   enddo

   !--print reaction cross sections
   list=(ntr+5)/6
   if (list.ne.0) then
      do l=1,list
         na=(l-1)*6+1
         nb=min0(na+5,ntr)
         nc=nb-na+1
         iaa=nes
         ib=1
         j=1
         do n=na,nb
            k=nint(xss(lsig+n-1)+sig-1)
            imn(j)=nint(xss(k))
            iaa=min0(iaa,imn(j))
            k=k+1
            loc(j)=k
            imx(j)=imn(j)+nint(xss(k))-1
            ib=max0(ib,imx(j))
            k=iabs(nint(xss(mtr+n-1)))
            call mtname(k,title(j),0)
            if (title(j)(1:1).eq.'(') then
               title(j)(2:2)='g'
            endif
            j=j+1
         enddo
         nc2=nc
         nkk=nc
         do m=iaa,ib
            if (mod(m+1-iaa,57).eq.1) then
               write(nsyso,'(''1''/4x,''i'',5x,''energy'',11x,a10,&
                 &6(5x,a10))') (title(ii),ii=1,nc2)
               write(nsyso,'(3x,''---'',3x,''--------------'',&
                 &7(3x,a12))') (dashes,ii=1,nc2)
            endif
            do i=1,nc
               if (m.ge.imn(i).and.m.le.imx(i)) then
                  j=loc(i)+m-imn(i)+1
                  write(kk(i),'(1p,e15.6)') xss(j)
               else
                  write(kk(i),'(15x)')
               endif
            enddo
            write(nsyso,'(1x,i5,1p,e17.8,7a15)')&
              m,xss(esz+m-1),(kk(i),i=1,nkk)
         enddo
      enddo
   endif

   !--print particle production data
   do i=1,ntype
      ipt=nint(xss(ixsa+neixs*(i-1)))
      ntrp=nint(xss(ixsa+neixs*(i-1)+1))
      if (ipt.eq.1) write(nsyso,'(''1''//&
        &'' ********** neutron production **********'')')
      if (ipt.eq.2) write(nsyso,'(''1''//&
        &'' ********** photon production **********'')')
      if (ipt.eq.9) write(nsyso,'(''1''//&
        &'' ********** proton production **********'')')
      if (ipt.eq.31) write(nsyso,'(''1''//&
        &'' ********** deuteron production **********'')')
      if (ipt.eq.32) write(nsyso,'(''1''//&
        &'' ********** triton production **********'')')
      if (ipt.eq.33) write(nsyso,'(''1''//&
        &'' ********** he-3 production **********'')')
      if (ipt.eq.34) write(nsyso,'(''1''//&
        &'' ********** alpha production **********'')')

      !--print reaction information for this type
      pxs=nint(xss(ixsa+neixs*(i-1)+2))
      phn=nint(xss(ixsa+neixs*(i-1)+3))
      mtrp=nint(xss(ixsa+neixs*(i-1)+4))
      tyrp=nint(xss(ixsa+neixs*(i-1)+5))
      lsigp=nint(xss(ixsa+neixs*(i-1)+6))
      sigp=nint(xss(ixsa+neixs*(i-1)+7))
      landp=nint(xss(ixsa+neixs*(i-1)+8))
      andp=nint(xss(ixsa+neixs*(i-1)+9))
      ldlwp=nint(xss(ixsa+neixs*(i-1)+10))
      dlwp=nint(xss(ixsa+neixs*(i-1)+11))
      write(nsyso,'(/&
        &''   mtrp   tyrp   lsigp   landp   ldlwp''/&
        &''   ----   ----   -----   -----   -----'')')
      do imt=1,ntrp
         write(nsyso,'(i7,i7,i8,i8,i8,i9)') nint(xss(mtrp+imt-1)),&
           nint(xss(tyrp+imt-1)),nint(xss(lsigp+imt-1)),&
           nint(xss(landp+imt-1)),nint(xss(ldlwp+imt-1))
      enddo

      !--print production cross section and heating
      iaa=nint(xss(pxs))
      naa=nint(xss(pxs+1))
      write(nsyso,'(/'' production cross section''/&
        &4x,''ie'',9x,''energy'',13x,''xs'',8x,''heating''/&
        &2x,''----'',3(2x,''-------------''))')
      do ie=1,naa
         e=xss(esz+iaa+ie-2)
         xs=xss(pxs+1+ie)
         heat=xss(phn+1+ie)
         write(nsyso,'(i6,1p,3e15.6)') iaa+ie-1,e,xs,heat
      enddo

      !--print production distributions
      if (ipt.eq.1)&
        write(nsyso,'(''1''/'' neutron production distributions'')')
      if (ipt.eq.2)&
        write(nsyso,'(''1''/'' photon production distributions'')')
      if (ipt.eq.9)&
        write(nsyso,'(''1''/'' proton production distributions'')')
      if (ipt.eq.31)&
        write(nsyso,'(''1''/'' deuteron production distributions'')')
      if (ipt.eq.32)&
        write(nsyso,'(''1''/'' triton production distributions'')')
      if (ipt.eq.33)&
        write(nsyso,'(''1''/'' he-3 production distributions'')')
      if (ipt.eq.34)&
        write(nsyso,'(''1''/'' alpha production distributions'')')

      !--loop over mts contributing to this production
      do imt=1,ntrp
         mt=nint(xss(mtrp+imt-1))
         write(nsyso,'(/'' contributions from mt='',i3,&
           &'' ------->'')') mt
         l1=nint(xss(lsigp+imt-1))
         l2=sigp+l1-1
         ne=nint(xss(l2+3))
         write(nsyso,'(/''   yields:''//&
           &''              energy         yield''/&
           &6x,2(2x,''------------''))')
         do ii=1,ne
            write(nsyso,'(6x,1p,2e14.6)')&
              xss(l2+4+ii-1),xss(l2+4+ne+ii-1)
         enddo
         ll=nint(xss(landp+imt-1))

         !--angular distributions
         if (ll.gt.0) then
            write(nsyso,'(/''   angular distribution:'')')
            ll=ll+andp-1
            ne=nint(xss(ll))
            na=ll
            nb=na+ne

            !--check on elastic format
            k=nint(xss(nb+1))
            if (k.ge.0) then

               !--equally-probable bins format
               list=(ne+7)/8
               nbina=32
               nbin1=nbina+1
               do l=1,list
                  iaa=(l-1)*8+1
                  ib=min0(ne,iaa+7)
                  ic=ib-iaa+1
                  j=1
                  do m=iaa,ib
                     k=nint(xss(m+nb))
                     if (k.gt.0) k=k+andp
                     loc(j)=k
                     j=j+1
                  enddo
                  if (l.eq.1) then
                     write(nsyso,'(6x,''ne ='',i4)') ne
                     write(nsyso,'(1x)')
                  endif
                  write(nsyso,'(6x,8(4x,a6,a4))') (ek,blank,ii=1,ic)
                  write(nsyso,'(5x,1p,8e14.5)') (xss(i+na),ii=iaa,ib)
                  write(nsyso,'(/)')
                  nkk=ic
                  do j=1,nbin1
                     do m=1,ic
                        if (loc(m).ne.0) then
                           ii=loc(m)+j-1
                           write(kk(m),'(1p,e14.5)') xss(ii)
                        else
                           write(kk(m),'(14x)')
                        endif
                     enddo
                     write(nsyso,'(1x,i4,8a14)') j,(kk(ii),ii=1,nkk)
                  enddo
               enddo
            else

               !--cummulative-distribution format
               write(nsyso,'(6x,''ne ='',i4)') ne
               do ii=1,ne
                  e=xss(na+ii)
                  k=nint(abs(xss(nb+ii)))+andp-1
                  intt=nint(xss(k))
                  np=nint(xss(k+1))
                  k=k+1
                  write(nsyso,'(/5x,'' incident particle energy ='',&
                    &1p,e14.6,''    int ='',i2,''    np ='',i4)')&
                    e,intt,np
                  write(nsyso,'(/12x,''cosine'',13x,''pdf'',13x,&
                    &''cdf'',10x,''cosine'',13x,''pdf'',13x,''cdf''/&
                    &2x,6(4x,''------------''))')
                  do j=1,np,2
                     if (j.lt.np) then
                        write(nsyso,'(1p,2x,6e16.6)')&
                          xss(k+j),xss(k+np+j),xss(k+2*np+j),&
                          xss(k+j+1),xss(k+np+j+1),xss(k+2*np+j+1)
                     else
                        write(nsyso,'(1p,2x,3e16.6)')&
                          xss(k+j),xss(k+np+j),xss(k+2*np+j)
                     endif
                  enddo
               enddo
            endif
         endif

         !--energy and energy-angle distributions
         l1=nint(xss(ldlwp+imt-1))
         l2=dlwp+l1-1
         ln=1
         do while (ln.ne.0)
            ln=nint(xss(l2))
            law=nint(xss(l2+1))
            write(nsyso,&
              '(/''   distributions (law'',i2,''):'')') law
            l3=dlwp+nint(xss(l2+2))-1

            !--fractional probability for this law
            if (ln.ne.0.or.l2.ne.dlwp+l1-1) then
               l=l2+3
               write(nsyso,'(8x,''probability of law'')')
               j=nint(xss(l))
               write(nsyso,'(12x,''nr ='',i4)') j
               if (j.gt.0) then
                  write(nsyso,'(12x,''nbt(i=1,nr) = '',20i5)')&
                    (nint(xss(l+ii)),ii=1,j)
                  l=l+j
                  write(nsyso,'(12x,''int(i=1,nr) = '',20i5)')&
                    (nint(xss(l+ii)),ii=1,j)
                  l=l+j
               endif
               l=l+1
               j=nint(xss(l))
               write(nsyso,'(12x,''ne ='',i4)') j
               write(nsyso,&
                 &'(12x,''e(i=1,ne) =   '',1p,6e14.6/(12x,7e14.6))')&
                 (xss(l+ii),ii=1,j)
               l=l+j
               write(nsyso,&
                 '(12x,''p(i=1,ne) =   '',1p,6e14.6/(12x,7e14.6))')&
                 (xss(l+ii),ii=1,j)
               l=l+j+1
               write(nsyso,'(8x,''data for law'')')
            endif

            !--law=4
            if (law.eq.4) then
               ne=nint(xss(l3+1))
               l=l3+2+2*ne
               do ie=1,ne
                  e2=xss(l3+2+ie-1)
                  loci=nint(xss(l3+2+ne+ie-1))+dlwp-1
                  intt=mod(nint(xss(loci)),10)
                  nd=nint(xss(loci)/10)
                  nn=nint(xss(loci+1))
                  loci=loci+1
                  write(nsyso,'(/6x,&
                    &'' incident energy = '',1p,e14.6,&
                    &''   intt ='',i2,''    nd = '',i4,&
                    &''    np = '',i4//&
                    &1x,8x,''energy'',11x,''pdf'',11x,''cdf'',&
                    &8x,''energy'',11x,''pdf'',11x,''cdf''/&
                    &1x,6(2x,''------------''))') e2,intt,nd,nn
                  do j=1,nn,2
                     if (j.lt.nn) then
                        write(nsyso,'(1x,1p,6e14.6)')&
                          xss(j+loci),xss(j+nn+loci),&
                          xss(j+2*nn+loci),xss(j+1+loci),&
                          xss(j+1+nn+loci),xss(j+1+2*nn+loci)
                     else
                        write(nsyso,'(1x,1p,3e14.6)')&
                          xss(j+loci),xss(j+nn+loci),&
                          xss(j+2*nn+loci)
                     endif
                  enddo
                  l=l+3*nn
               enddo
               l2=l

            !--law=44
            else if (law.eq.44) then
               ne=nint(xss(l3+1))
               l=l3+2+2*ne
               do ie=1,ne
                  e2=xss(l3+2+ie-1)
                  loci=nint(xss(l3+2+ne+ie-1))+dlwp-1
                  intt=mod(nint(xss(loci)),10)
                  nd=nint(xss(loci)/10)
                  nd=0
                  nn=nint(xss(loci+1))
                  loci=loci+1
                  write(nsyso,'(/6x,&
                    &'' incident energy = '',1p,e14.6,&
                    &''   intt ='',i2,''    nd = '',i4,''    np = '',&
                    &i4,//,1x,8x,''energy'',11x,''pdf'',11x,''cdf'',&
                    &13x,''r'',13x,''a''/&
                    &1x,5(2x,''------------'')/(1x,1p,5e14.6))')&
                    e2,intt,nd,nn,(xss(j+loci),xss(j+nn+loci),&
                    xss(j+2*nn+loci),xss(j+3*nn+loci),&
                    xss(j+4*nn+loci),j=1,nn)
                  l=l+4*nn
               enddo
               l2=l

            !--law 61
            else if (law.eq.61) then
               ne=nint(xss(l3+1))
               l=l3+2+2*ne
               do ie=1,ne
                  e2=xss(l3+2+ie-1)
                  loci=nint(xss(l3+2+ne+ie-1))+dlwp-1
                  intt=mod(nint(xss(loci)),10)
                  nd=nint(xss(loci)/10)
                  nn=nint(xss(loci+1))
                  loci=loci+1
                  write(nsyso,'(/6x,'' incident energy = '',1p,e14.6,&
                    &''   intt ='',i2,''    nd = '',i4,''    np = '',&
                    &i4)') e2,intt,nd,nn
                  do ip=1,nn
                     write(nsyso,'(/&
                       &6x,'' secondary energy = '',1p,e14.6/&
                       &6x,''              pdf = '',e14.6/&
                       &6x,''              cdf = '',e14.6)')&
                       xss(ip+loci),xss(ip+nn+loci),xss(ip+2*nn+loci)
                     locj=nint(xss(ip+3*nn+loci)+dlwp-1)
                     if (locj.ne.0) then
                        intmu=nint(xss(locj))
                        nmu=nint(xss(locj+1))
                        write(nsyso,'(&
                          &6x,''            intmu = '',i8/&
                          &6x,''              nmu = '',i8/&
                          &''         cosine           pdf           cdf'',&
                          &''        cosine           pdf           cdf''/&
                          &''   ------------  ------------  ------------'',&
                          &''  ------------  ------------  ------------'')')&
                          intmu,nmu
                        do imu=1,nmu,2
                           if (imu.eq.nmu) then
                              write(nsyso,'(1x,1p,3e14.6)')&
                                xss(locj+1+imu),xss(locj+1+nmu+imu),&
                                xss(locj+1+2*nmu+imu)
                           else
                              write(nsyso,'(1x,1p,6e14.6)')&
                                xss(locj+1+imu),xss(locj+1+nmu+imu),&
                                xss(locj+1+2*nmu+imu),xss(locj+1+imu+1),&
                                xss(locj+1+nmu+imu+1),&
                                xss(locj+1+2*nmu+imu+1)
                           endif
                        enddo
                      else
                        write(nsyso,'('' angular distribution is isotropic'')')
                      endif
                  enddo
                  l=l+4*nn
               enddo
               l2=l

            !--law=7 or 9
            else if (law.eq.7.or.law.eq.9) then
               l=l3
               j=nint(xss(l))
               write(nsyso,'(12x,''nr ='',i4)') j
               if (j.ne.0) then
                  write(nsyso,'(12x,''nbt(i=1,nr) = '',20i5)')&
                    (nint(xss(l+ii)),ii=1,j)
                  l=l+j
                  write(nsyso,'(12x,''int(i=1,nr) = '',20i5)')&
                    (nint(xss(l+ii)),ii=1,j)
                  l=l+j
               endif
               l=l+1
               j=nint(xss(l))
               write(nsyso,'(12x,''ne ='',i4)') j
               write(nsyso,'(12x,&
                 &''e(i=1,ne) = '',16x,1p,5e14.6/(12x,7e14.6))')&
                 (xss(l+ii),ii=1,j)
               l=l+j
               write(nsyso,'(12x,''theta(i=1,ne) = '',12x,1p,5e14.6/&
                 &(12x,7e14.6))') (xss(l+ii),ii=1,j)
               l=l+j+1
               write(nsyso,'(12x,''u =  '',9x,1p,e14.6)') xss(l)
               l2=l+1

            !--law=33
            else if (law.eq.33) then
               write(nsyso,'(12x,''eout = c*(e-ec)   ec ='',1p,&
                 &e14.6,5x,''c ='',e14.6)') xss(l3),xss(l3+1)

            !--law not installed
            else
               call error('phnprt','law not installed',' ')
            endif

         !--continue loop over partial distributions, if any
         enddo

      !--continue loop over mts for this particle type
      enddo

   !--continue loop over productions
   enddo
   return
   end subroutine phnprt

   subroutine phnout(itype,nout,ndir,mcnpx,hk,izn,awn)
   !-------------------------------------------------------------------
   ! Write photo-nuclear ACE data to output and directory files
   !-------------------------------------------------------------------
   use util  ! provides openz,closz,error
   use acecm ! provides write routines
   ! externals
   integer::itype,nout,ndir,mcnpx
   integer::izn(16)
   real(kr)::awn(16)
   character(70)::hk
   ! internals
   integer::l,n,ne,ip,mftype,nr,nn,ll,k,np,nmu,nrr
   integer::lnw,law,nern,lrec,j,i
   integer::ipt, ntrp, pxs, phn, mtrp, tyrp, lsigp, sigp, landp, andp, ldlwp, dlwp ! IXS
   integer::rlocator  ! locator index for reaction data
   integer::plocator  ! locator index for the particle IXS array
   integer::ielocator ! locator index for incident energy data
   integer::oelocator ! locator index for outgoing energy data
   character(66)::text

   integer::ner=1
   integer::nbw=1

   !--open the output file
   if (itype.eq.1) call openz(nout,1)
   if (itype.eq.2) call openz(-nout,1)

   !--write type-1 header block
   if (itype.eq.1) then
      if (mcnpx.eq.0) then
         write(nout,&
           '(a10,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz(1:10),aw0,tz,hd,hk,hm
      else
         write(nout,&
           '(a13,f12.6,1x,1p,e11.4,1x,a10/a70,a10)')&
           hz,aw0,tz,hd,hk,hm
      endif
      write(nout,'(4(i7,f11.0))') (izn(i),awn(i),i=1,16)
      write(nout,'(8i9)')lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,&
        nxsd(1:4),tvn,esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(1:21)

      !--esz block
      l=1
      call advance_to_locator(nout,l,esz)
      call write_real_list(nout,l,2*nes)   ! energies and total cross section (2*nes values)

      !--els block
      if (els.ne.0) then
         call advance_to_locator(nout,l,els)
         call write_real_list(nout,l,nes)  ! elastic cross section (nes values)
      endif

      !--thn block
      if (thn.ne.0) then
         call advance_to_locator(nout,l,thn)
         call write_real_list(nout,l,nes)  ! non-elastic cross section (nes values)
      endif

      !--mtr block
      call advance_to_locator(nout,l,mtr)
      call write_integer_list(nout,l,ntr)

      !--lqr block
      call advance_to_locator(nout,l,lqr)
      call write_real_list(nout,l,ntr)

      !--lsig block
      call advance_to_locator(nout,l,lsig)
      rlocator=l
      call write_integer_list(nout,l,ntr)

      !--sig block
      call advance_to_locator(nout,l,sig)
      do i=1,ntr
         call advance_to_locator(nout,l,sig+nint(xss(rlocator))-1) ! sig=jxs(7)
         call write_integer(nout,l)
         ne=nint(xss(l))
         call write_integer(nout,l)
         call write_real_list(nout,l,ne)
         rlocator=rlocator+1
      enddo

      !--particle production blocks
      if (ntype.gt.0) then

         !--ixs arrays
         call advance_to_locator(nout,l,ixsa)
         plocator=l
         call write_integer_list(nout,l,neixs*ntype) ! IXS array (neixs values) for each IP

         !--loop over the ntype productions
         do ip=1,ntype

            ! IXS array entries
            ipt=nint(xss(plocator))
            ntrp=nint(xss(plocator+1))
            pxs=nint(xss(plocator+2))
            phn=nint(xss(plocator+3))
            mtrp=nint(xss(plocator+4))
            tyrp=nint(xss(plocator+5))
            lsigp=nint(xss(plocator+6))
            sigp=nint(xss(plocator+7))
            landp=nint(xss(plocator+8))
            andp=nint(xss(plocator+9))
            ldlwp=nint(xss(plocator+10))
            dlwp=nint(xss(plocator+11))

            !--pxs block
            call advance_to_locator(nout,l,pxs)
            call write_integer(nout,l)
            ne=nint(xss(l))
            call write_integer(nout,l)
            call write_real_list(nout,l,ne)

            !--phn block
            call advance_to_locator(nout,l,phn)
            call write_integer(nout,l)
            ne=nint(xss(l))
            call write_integer(nout,l)
            call write_real_list(nout,l,ne)

            !--mtrp block
            call advance_to_locator(nout,l,mtrp)
            call write_integer_list(nout,l,ntrp) ! MT (ntrp values)

            !--tyrp block
            call advance_to_locator(nout,l,tyrp)
            call write_integer_list(nout,l,ntrp) ! TYR (ntrp values)

            !--lsigp block
            call advance_to_locator(nout,l,lsigp)
            rlocator=l
            call write_integer_list(nout,l,ntrp) ! L (ntrp values)

            !--sigp block
            call advance_to_locator(nout,l,sigp)
            do i=1,ntrp
               call advance_to_locator(nout,l,sigp+nint(xss(rlocator))-1)

               mftype=nint(xss(l))
               call write_integer(nout,l)              ! MFTYPE
               if (mftype.eq.13) then                  ! MF=13
                  call write_integer(nout,l)           ! IE
                  ne=nint(xss(l))
                  call write_integer(nout,l)           ! NE
                  call write_real_list(nout,l,ne)      ! sigma (NE values)
               else
                  call write_integer(nout,l)           ! MTMULT
                  nr=nint(xss(l))
                  call write_integer(nout,l)           ! NR
                  if (nr.gt.0) then
                     call write_integer_list(nout,l,2*nr) ! NBT, INT (each NR values)
                  endif
                  ne=nint(xss(l))
                  call write_integer(nout,l)           ! NE
                  call write_real_list(nout,l,2*ne)    ! E, Y (each NE values)
               endif
               rlocator=rlocator+1
            enddo

            !--landp block
            call advance_to_locator(nout,l,landp)
            rlocator=l
            call write_integer_list(nout,l,ntrp)

            !--andp block
            call advance_to_locator(nout,l,andp)
            do i=1,ntrp
               nn=nint(xss(rlocator))                     ! relative locator position
               if (nn.gt.0) then
                  call advance_to_locator(nout,l,andp+nn-1)
                  ne=nint(xss(l))
                  call write_integer(nout,l)              ! NE
                  call write_real_list(nout,l,ne)         ! E (NE values)
                  ielocator=l
                  call write_integer_list(nout,l,ne)      ! L (NE values)
                  do j=1,ne
                     nn=nint(xss(ielocator))              ! relative locator position
                     call advance_to_locator(nout,l,andp+iabs(nn)-1)
                     if (nn.gt.0) then                    ! 32 equiprobable bins
                        call write_real_list(nout,l,33)
                     else if (nn.lt.0) then               ! tabulated angular
                        call write_integer(nout,l)        ! interpolation flag
                        np=nint(xss(l))
                        call write_integer(nout,l)        ! NP
                        call write_real_list(nout,l,3*np) ! CS, PDF, CDF (each NP values)
                     endif
                     ielocator=ielocator+1
                  enddo
               endif
               rlocator=rlocator+1
            enddo

            !--ldlwp block
            call advance_to_locator(nout,l,ldlwp)
            rlocator=l
            call write_integer_list(nout,l,ntrp)

            !--dlwp block
            call advance_to_locator(nout,l,dlwp)
            do i=1,ntrp
               nn=nint(xss(rlocator))                     ! relative locator position
               if (nn.gt.0) then
                  call advance_to_locator(nout,l,dlwp+nn-1)
                  lnw=1
                  do while (lnw.ne.0)
                     lnw=nint(xss(l))
                     call write_integer(nout,l)            ! LNW
                     law=nint(xss(l))
                     call write_integer(nout,l)            ! LAW
                     call write_integer(nout,l)            ! IDAT
                     nr=nint(xss(l))
                     call write_integer(nout,l)               ! NR
                     if (nr.gt.0) then
                        call write_integer_list(nout,l,2*nr)  ! NBT, INT (each NR values)
                     endif
                     ne=nint(xss(l))
                     call write_integer(nout,l)            ! NE
                     call write_real_list(nout,l,2*ne)     ! E and P (each NE values)

                     !--law 4
                     if (law.eq.4) then
                        nr=nint(xss(l))
                        call write_integer(nout,l)               ! NR
                        if (nr.gt.0) then
                           call write_integer_list(nout,l,2*nr)  ! NBT, INT (each NR values)
                        endif
                        ne=nint(xss(l))
                        call write_integer(nout,l)            ! NE
                        call write_real_list(nout,l,ne)       ! E (NE values)
                        ielocator=l
                        call write_integer_list(nout,l,ne)    ! L (NE values)
                        do j=1,ne
                           call advance_to_locator(nout,l,dlwp+nint(xss(ielocator))-1)
                           call write_integer(nout,l)         ! INTT
                           np=nint(xss(l))
                           call write_integer(nout,l)         ! NP
                           call write_real_list(nout,l,3*np)  ! Eout, PDF, CDF (each NP values)
                           ielocator=ielocator+1
                        enddo

                     !--law 44
                     else if (law.eq.44) then
                        nr=nint(xss(l))
                        call write_integer(nout,l)               ! NR
                        if (nr.gt.0) then
                           call write_integer_list(nout,l,2*nr) ! NBT, INT (each NR values)
                        endif
                        ne=nint(xss(l))
                        call write_integer(nout,l)            ! NE
                        call write_real_list(nout,l,ne)       ! E (NE values)
                        ielocator=l
                        call write_integer_list(nout,l,ne)    ! L (NE values)
                        do j=1,ne
                           call advance_to_locator(nout,l,dlwp+nint(xss(ielocator))-1)
                           call write_integer(nout,l)         ! INTT
                           np=nint(xss(l))
                           call write_integer(nout,l)         ! NP
                           call write_real_list(nout,l,5*np)  ! Eout, PDF, CDF, R, A (each NP values)
                           ielocator=ielocator+1
                        enddo

                     !--law 61
                     else if (law.eq.61) then
                        nrr=nint(xss(l))
                        call write_integer(nout,l)               ! NR
                        if (nrr.gt.0) then
                           call write_integer_list(nout,l,2*nrr) ! NBT, INT (each NR values)
                        endif
                        ne=nint(xss(l))
                        call write_integer(nout,l)            ! NE
                        call write_real_list(nout,l,ne)       ! E (NE values)
                        ielocator=l
                        call write_integer_list(nout,l,ne)    ! L (NE values)
                        do j=1,ne
                           call advance_to_locator(nout,l,dlwp+nint(xss(ielocator))-1)
                           call write_integer(nout,l)         ! INTT
                           np=nint(xss(l))
                           call write_integer(nout,l)         ! NP
                           call write_real_list(nout,l,3*np)  ! Eout, PDF, CDF (each NP values)
                           oelocator=l
                           call write_integer_list(nout,l,np) ! L (NP values)
                           do k=1,np
                              call advance_to_locator(nout,l,dlwp+nint(xss(oelocator))-1)
                              call write_integer(nout,l)         ! JJ
                              nmu=nint(xss(l))
                              call write_integer(nout,l)         ! NMU
                              call write_real_list(nout,l,3*nmu) ! Mu, PDF, CDF (each NMU values)
                              oelocator=oelocator+1
                           enddo
                           ielocator=ielocator+1
                        enddo

                     !--law 7 or 9
                     else if (law.eq.7.or.law.eq.9) then
                        nr=nint(xss(l))
                        call write_integer(nout,l)               ! NR
                        if (nr.gt.0) then
                           call write_integer_list(nout,l,2*nr) ! NBT, INT (each NR values)
                        endif
                        ne=nint(xss(l))
                        call write_integer(nout,l)            ! NE
                        call write_real_list(nout,l,2*ne)     ! E, theta (each NE values)
                        call write_real(nout,l)               ! U

                     !--law 33
                     else if (law.eq.33) then
                        call write_real(nout,l)
                        call write_real(nout,l)

                     ! unknown law
                     else
                        write(text,'(''Undefined law for dlwp block: '',i3)') law
                        call error('phnout',text,' ')
                     endif
                  enddo
               endif
               rlocator=rlocator+1
            enddo
            plocator=plocator+neixs
         !--continue loop over productions
         enddo
      endif
      call typen(0,nout,3)
      nern=0
      lrec=0
      call closz(nout)

   !--type-2 format
   else
      if (mcnpx.eq.0) then
         write(nout) hz(1:10),aw0,tz,hd,hk,hm,(izn(i),awn(i),i=1,16),&
           lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,nxsd(1:4),tvn,&
           esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(1:21)
      else
         write(nout) hz(1:13),aw0,tz,hd,hk,hm,(izn(i),awn(i),i=1,16),&
           lxs,za,nes,ntr,ntype,npixs,neixs,ignored,is,iz,ia,nxsd(1:4),tvn,&
           esz,tot,non,els,thn,mtr,lqr,lsig,sig,ixsa,ixs,jxsd(1:21)
      endif
      ll=0
      nn=lxs
      do while (nn.gt.0)
         n=nn
         if (n.gt.ner) n=ner
         write(nout) (xss(ll+i),i=1,n)
         ll=ll+n
         nn=nn-n
      enddo
      nern=ner
      lrec=ner*nbw
      call closz(nout)
   endif

   !--output directory for mcnp
   call openz(ndir,1)
   if (mcnpx.eq.0) then
      write(ndir,&
        '(a10,f12.6,'' filename route'',i2,'' 1 '',i8,2i6,1p,e10.3)')&
        hz(1:10),aw0,itype,lxs,lrec,nern,tz
   else
      write(ndir,&
        '(a13,f12.6,'' filename route'',i2,'' 1 '',i8,2i6,1p,e10.3)')&
        hz(1:13),aw0,itype,lxs,lrec,nern,tz
   endif
   call closz(ndir)
   return
   end subroutine phnout

   subroutine phnplo(nout,hk)
   !-------------------------------------------------------------------
   ! Do standard plots of an ACE photonuclear file.
   !-------------------------------------------------------------------
   use util ! provides openz
   use acecm ! provides mtname
   ! externals
   integer::nout
   character(70)::hk
   ! internals
   integer::ipcol,iwcol,i,major,minor,it,j,mt,k,n,iaa,naa
   integer::ii,idash,icolor,ie,imt,l1,l2,ne,na,law,nb
   integer::itwo,np,ic,intt,iflag,l3,loci,nn,nd,l
   integer::ipt,ntrp,pxs,phn,mtrp,tyrp,lsigp,sigp,landp,andp,ldlwp,dlwp
   real(kr)::xmin,xmax,ymin,ymax,zmin,zmax
   real(kr)::selas,xstep,ystep,xtag,ytag,test,elas,x,y
   real(kr)::e,stot,heat,snon,xs,break,cc,pp,rat,stepm
   real(kr)::elast,ylast,ep,pd
   character(10)::name
   character(1)::qu=''''
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::delta=.01e0_kr
   real(kr),parameter::up=1.01e0_kr
   real(kr),parameter::dn=0.99e0_kr
   real(kr),parameter::eps=1.e-5_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--default colors
   ipcol=2
   iwcol=3

   !--start the viewr input text
   call openz(nout,1)
   write(nout,'(''1 2 .30'',i3,''/'')') ipcol

   !--plot lin-lin total, nonelastic, and elastic (if any)
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   do i=1,nes
      e=xss(esz-1+i)
      stot=xss(esz+nes-1+i)
      if (e.lt.xmin) xmin=e
      if (e.gt.xmax) xmax=e
      if (stot.lt.ymin) ymin=stot
      if (stot.gt.ymax) ymax=stot
      if (els.ne.0) then
         snon=xss(non-1+i)
         if (snon.lt.ymin) ymin=snon
         if (snon.gt.ymax) ymax=snon
         selas=xss(els-1+i)
         if (selas.lt.ymin) ymin=selas
         if (selas.gt.ymax) ymax=selas
      endif
   enddo
   call ascle(4,xmin,xmax,major,minor)
   xstep=(xmax-xmin)/major
   call ascle(4,ymin,ymax,major,minor)
   ystep=(ymax-ymin)/major
   write(nout,'(''1'',i3,''/'')') iwcol
   it=1
   do i=1,70
      if (hk(i:i).ne.' ') it=i
   enddo
   write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
   write(nout,'(a,''<p>rincipal cross sections'',a,''/'')') qu,qu
   xtag=95*xmin/100+5*xmax/100
   test=30
   if (xmax.gt.test) xtag=35*xmin/100+65*xmax/100
   ytag=ymin/10+9*ymax/10
   write(nout,'(''1 0 2 1'',2e12.4,''/'')') xtag,ytag
   write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
   write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
   write(nout,'(a,''<c>ross section (barns)'',a,''/'')') qu,qu
   write(nout,'(''/'')')
   write(nout,'(''/'')')
   write(nout,'(a,''total'',a,''/'')') qu,qu
   write(nout,'(''0/'')')
   j=0
   do i=1,nes
      e=xss(esz-1+i)
      stot=xss(esz+nes-1+i)
      write(nout,'(1p,2e14.6,''/'')') e,stot
   enddo
   write(nout,'(''/'')')
   if (els.gt.0) then
      write(nout,'(''2/'')')
      write(nout,'(''/'')')
      write(nout,'(''0 0 1/'')')
      write(nout,'(a,''nonelastic'',a,''/'')') qu,qu
      write(nout,'(''0/'')')
      j=0
      do i=1,nes
         e=xss(esz-1+i)
         snon=xss(non-1+i)
         write(nout,'(1p,2e14.6,''/'')') e,snon
      enddo
      write(nout,'(''/'')')
      write(nout,'(''3/'')')
      write(nout,'(''/'')')
      write(nout,'(''0 0 2/'')')
      write(nout,'(a,''elastic'',a,''/'')') qu,qu
      write(nout,'(''0/'')')
      j=0
      do i=1,nes
         e=xss(esz-1+i)
         elas=xss(els-1+i)
         write(nout,'(1p,2e14.6,''/'')') e,elas
      enddo
      write(nout,'(''/'')')
   endif

   !--plot lin-lin partial cross sections
   if (ntr.gt.1) then
      xmin=big
      xmax=0
      ymin=big
      ymax=-big
      do i=1,ntr
         mt=nint(xss(mtr+i-1))
         k=nint(xss(lsig+i-1)+sig-1)
         n=nint(xss(k+1))
         iaa=nint(xss(k))
         do j=1,n
            x=xss(iaa+j-1)
            y=xss(k+2+j-1)
            if (y.ne.zero.or.j.le.1) then
               if (x.lt.xmin) xmin=x
               if (x.gt.xmax) xmax=x
               if (y.lt.ymin) ymin=y
               if (y.gt.ymax) ymax=y
            endif
         enddo
      enddo
      call ascle(4,xmin,xmax,major,minor)
      xstep=(xmax-xmin)/major
      call ascle(4,ymin,ymax,major,minor)
      ystep=(ymax-ymin)/major
      write(nout,'(''1'',i3,''/'')') iwcol
      it=1
      do i=1,70
         if (hk(i:i).ne.' ') it=i
      enddo
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''<p>artial cross sections'',a,''/'')') qu,qu
      xtag=95*xmin/100+5*xmax/100
      test=30
      if (xmax.gt.test) xtag=35*xmin/100+65*xmax/100
      ytag=ymin/10+9*ymax/10
      write(nout,'(''1 0 2 1'',2e12.4,''/'')') xtag,ytag
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
      write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
      write(nout,'(a,''<c>ross section (barns)'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      ii=1
      mt=nint(xss(mtr+ii-1))
      call mtname(mt,name,0)
      if (name(1:1).eq.'(') then
         name(2:2)='g'
      endif
      k=nint(xss(lsig+ii-1)+sig-1)
      n=nint(xss(k+1))
      iaa=nint(xss(k))
      write(nout,'(''0 0 0'',i2,''/'')') ii-1
      write(nout,'(a,a,a,''/'')') qu,name,qu
      write(nout,'(''0/'')')
      do j=1,n
         x=xss(iaa+j-1)
         y=xss(k+2+j-1)
         write(nout,'(1p,2e14.6,''/'')') x,y
      enddo
      write(nout,'(''/'')')
      do ii=2,ntr
         mt=nint(xss(mtr+ii-1))
         call mtname(mt,name,0)
         if (name(1:1).eq.'(') then
            name(2:2)='g'
         endif
         k=nint(xss(lsig+ii-1)+sig-1)
         n=nint(xss(k+1))
         iaa=nint(xss(k))
         write(nout,'(''2/'')')
         write(nout,'(''/'')')
         idash=0
         icolor=ii-1
         do while (icolor.ge.8)
            idash=idash+1
            icolor=icolor-8
         enddo
         write(nout,'(''0 0'',2i2,''/'')') idash,icolor
         write(nout,'(a,a,a,''/'')') qu,name,qu
         write(nout,'(''0/'')')
         do j=1,n
            x=xss(iaa+j-1)
            y=xss(k+2+j-1)
            write(nout,'(1p,2e14.6,''/'')') x,y
         enddo
         write(nout,'(''/'')')
      enddo
   endif

   !--plot lin-lin heating per reaction
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   do i=1,nes
      e=xss(esz-1+i)
      heat=xss(thn-1+i)
      if (e.lt.xmin) xmin=e
      if (e.gt.xmax) xmax=e
      if (heat.lt.ymin) ymin=heat
      if (heat.gt.ymax) ymax=heat
   enddo
   call ascle(4,xmin,xmax,major,minor)
   xstep=(xmax-xmin)/major
   call ascle(4,ymin,ymax,major,minor)
   ystep=(ymax-ymin)/major
   write(nout,'(''1'',i3,''/'')') iwcol
   it=1
   do i=1,70
      if (hk(i:i).ne.' ') it=i
   enddo
   write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
   write(nout,'(a,''<h>eating'',a,''/'')') qu,qu
   write(nout,'(''1 0 2 1/'')')
   write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
   write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
   write(nout,'(a,''<h>eating (<m>e<v>/reaction)'',a,''/'')') qu,qu
   write(nout,'(''/'')')
   write(nout,'(''/'')')
   write(nout,'(a,''heating'',a,''/'')') qu,qu
   write(nout,'(''0/'')')
   do i=1,nes
      e=xss(esz-1+i)
      heat=xss(thn-1+i)
      write(nout,'(1p,2e14.6,''/'')') e,heat
   enddo
   write(nout,'(''/'')')

   !--lin-lin plot of particle heating values
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   do i=1,ntype
      ipt=nint(xss(ixsa+12*(i-1)))
      ntrp=nint(xss(ixsa+12*(i-1)+1))
      pxs=nint(xss(ixsa+12*(i-1)+2))
      phn=nint(xss(ixsa+12*(i-1)+3))
      iaa=nint(xss(pxs))
      naa=nint(xss(pxs+1))
      do ie=1,naa
         e=xss(esz+iaa+ie-2)
         xs=xss(phn+1+ie)
         if (e.lt.xmin) xmin=e
         if (e.gt.xmax) xmax=e
         if (xs.lt.ymin) ymin=xs
         if (xs.gt.ymax) ymax=xs
      enddo
   enddo
   if (ymax.ne.zero) then
      call ascle(4,xmin,xmax,major,minor)
      xstep=(xmax-xmin)/major
      call ascle(4,ymin,ymax,major,minor)
      ystep=(ymax-ymin)/major
      write(nout,'(''1'',i3,''/'')') iwcol
      it=1
      do i=1,70
         if (hk(i:i).ne.' ') it=i
      enddo
      write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
      write(nout,'(a,''<p>article heating contributions'',&
        &a,''/'')') qu,qu
      xtag=95*xmin/100+5*xmax/100
      ytag=ymin/10+9*ymax/10
      write(nout,'(''1 0 2 1'',2e12.4,''/'')') xtag,ytag
      write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
      write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
      write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
      write(nout,'(a,''<m>e<v>/collision'',a,''/'')') qu,qu
      write(nout,'(''/'')')
      ii=1
      ipt=nint(xss(ixsa+12*(ii-1)))
      ntrp=nint(xss(ixsa+12*(ii-1)+1))
      pxs=nint(xss(ixsa+12*(ii-1)+2))
      phn=nint(xss(ixsa+12*(ii-1)+3))
      iaa=nint(xss(pxs))
      naa=nint(xss(pxs+1))
      write(nout,'(''0 0 0'',i2,''/'')') ii-1
      if (ipt.eq.1) write(nout,'(a,''neutrons'',a,''/'')') qu,qu
      if (ipt.eq.2) write(nout,'(a,''photons'',a,''/'')') qu,qu
      if (ipt.eq.9) write(nout,'(a,''protons'',a,''/'')') qu,qu
      if (ipt.eq.31) write(nout,'(a,''deuterons'',a,''/'')') qu,qu
      if (ipt.eq.32) write(nout,'(a,''tritons'',a,''/'')') qu,qu
      if (ipt.eq.33) write(nout,'(a,''he-3'',a,''/'')') qu,qu
      if (ipt.eq.34) write(nout,'(a,''alphas'',a,''/'')') qu,qu
      write(nout,'(''0/'')')
      j=0
      do i=1,naa
         e=xss(esz+iaa-2+i)
         xs=xss(phn+1+i)
         write(nout,'(1p,2e14.6,''/'')') e,xs
      enddo
      write(nout,'(''/'')')
      if (ntype.ne.1) then
         do ii=2,ntype
            ipt=nint(xss(ixsa+12*(ii-1)))
            ntrp=nint(xss(ixsa+12*(ii-1)+1))
            pxs=nint(xss(ixsa+12*(ii-1)+2))
            phn=nint(xss(ixsa+12*(ii-1)+3))
            iaa=nint(xss(pxs))
            naa=nint(xss(pxs+1))
            write(nout,'(''2/'')')
            write(nout,'(''/'')')
            write(nout,'(''0 0 0'',i2,''/'')') ii-1
            if (ipt.eq.1) write(nout,&
              '(a,''neutrons'',a,''/'')') qu,qu
            if (ipt.eq.2) write(nout,&
              '(a,''photons'',a,''/'')') qu,qu
            if (ipt.eq.9) write(nout,&
              '(a,''protons'',a,''/'')') qu,qu
            if (ipt.eq.31) write(nout,&
              '(a,''deuterons'',a,''/'')') qu,qu
            if (ipt.eq.32) write(nout,&
              '(a,''tritons'',a,''/'')') qu,qu
            if (ipt.eq.33) write(nout,&
              '(a,''he-3'',a,''/'')') qu,qu
            if (ipt.eq.34) write(nout,&
              '(a,''alphas'',a,''/'')') qu,qu
            write(nout,'(''0/'')')
            j=0
            do i=1,naa
               e=xss(esz+iaa-2+i)
               xs=xss(phn+1+i)
               write(nout,'(1p,2e14.6,''/'')') e,xs
            enddo
         write(nout,'(''/'')')
         enddo
      endif
   endif

   !--lin-lin plot of particle production cross sections
   xmin=big
   xmax=0
   ymin=big
   ymax=-big
   do i=1,ntype
      ipt=nint(xss(ixsa+12*(i-1)))
      ntrp=nint(xss(ixsa+12*(i-1)+1))
      pxs=nint(xss(ixsa+12*(i-1)+2))
      phn=nint(xss(ixsa+12*(i-1)+3))
      iaa=nint(xss(pxs))
      naa=nint(xss(pxs+1))
      do ie=1,naa
         e=xss(esz+iaa+ie-2)
         xs=xss(pxs+1+ie)
         if (ipt.eq.2) xs=xs/5
         if (e.lt.xmin) xmin=e
         if (e.gt.xmax) xmax=e
         if (xs.lt.ymin) ymin=xs
         if (xs.gt.ymax) ymax=xs
      enddo
   enddo
   call ascle(4,xmin,xmax,major,minor)
   xstep=(xmax-xmin)/major
   call ascle(4,ymin,ymax,major,minor)
   ystep=(ymax-ymin)/major
   write(nout,'(''1'',i3,''/'')') iwcol
   it=1
   do i=1,70
      if (hk(i:i).ne.' ') it=i
   enddo
   write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
   write(nout,'(a,''<p>article production cross sections'',&
     &a,''/'')') qu,qu
   xtag=95*xmin/100+5*xmax/100
   test=30
   if (xmax.gt.test) xtag=35*xmin/100+65*xmax/100
   ytag=ymin/10+9*ymax/10
   write(nout,'(''1 0 2 1'',2e12.4,''/'')') xtag,ytag
   write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
   write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
   write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
   write(nout,'(a,''<c>ross section (barns)'',a,''/'')') qu,qu
   write(nout,'(''/'')')
   ii=1
   ipt=nint(xss(ixsa+12*(ii-1)))
   ntrp=nint(xss(ixsa+12*(ii-1)+1))
   pxs=nint(xss(ixsa+12*(ii-1)+2))
   iaa=nint(xss(pxs))
   naa=nint(xss(pxs+1))
   write(nout,'(''0 0 0'',i2,''/'')') ii-1
   if (ipt.eq.1) write(nout,'(a,''neutrons'',a,''/'')') qu,qu
   if (ipt.eq.2) write(nout,'(a,''photons/5'',a,''/'')') qu,qu
   if (ipt.eq.9) write(nout,'(a,''protons'',a,''/'')') qu,qu
   if (ipt.eq.31) write(nout,'(a,''deuterons'',a,''/'')') qu,qu
   if (ipt.eq.32) write(nout,'(a,''tritons'',a,''/'')') qu,qu
   if (ipt.eq.33) write(nout,'(a,''he-3'',a,''/'')') qu,qu
   if (ipt.eq.34) write(nout,'(a,''alphas'',a,''/'')') qu,qu
   write(nout,'(''0/'')')
   j=0
   do i=1,naa
      e=xss(esz+iaa-2+i)
      xs=xss(pxs+1+i)
      if (ipt.eq.2) xs=xs/5
      write(nout,'(1p,2e14.6,''/'')') e,xs
   enddo
   write(nout,'(''/'')')
   if (ntype.ne.1) then
      do ii=2,ntype
         ipt=nint(xss(ixsa+12*(ii-1)))
         ntrp=nint(xss(ixsa+12*(ii-1)+1))
         pxs=nint(xss(ixsa+12*(ii-1)+2))
         iaa=nint(xss(pxs))
         naa=nint(xss(pxs+1))
         write(nout,'(''2/'')')
         write(nout,'(''/'')')
         write(nout,'(''0 0 0'',i2,''/'')') ii-1
         if (ipt.eq.1) write(nout,'(a,''neutrons'',a,''/'')') qu,qu
         if (ipt.eq.2) write(nout,'(a,''photons/5'',a,''/'')') qu,qu
         if (ipt.eq.9) write(nout,'(a,''protons'',a,''/'')') qu,qu
         if (ipt.eq.31) write(nout,'(a,''deuterons'',a,''/'')') qu,qu
         if (ipt.eq.32) write(nout,'(a,''tritons'',a,''/'')') qu,qu
         if (ipt.eq.33) write(nout,'(a,''he-3'',a,''/'')') qu,qu
         if (ipt.eq.34) write(nout,'(a,''alphas'',a,''/'')') qu,qu
         write(nout,'(''0/'')')
         j=0
         do i=1,naa
            e=xss(esz+iaa-2+i)
            xs=xss(pxs+1+i)
            if (ipt.eq.2) xs=xs/5
            write(nout,'(1p,2e14.6,''/'')') e,xs
         enddo
         write(nout,'(''/'')')
      enddo
   endif

   !--make 3-d plots of particle emission
   !--loop over each production type
   do i=1,ntype
      ipt=nint(xss(ixsa+12*(i-1)))
      ntrp=nint(xss(ixsa+12*(i-1)+1))
      pxs=nint(xss(ixsa+12*(i-1)+2))
      phn=nint(xss(ixsa+12*(i-1)+3))
      mtrp=nint(xss(ixsa+12*(i-1)+4))
      tyrp=nint(xss(ixsa+12*(i-1)+5))
      lsigp=nint(xss(ixsa+12*(i-1)+6))
      sigp=nint(xss(ixsa+12*(i-1)+7))
      landp=nint(xss(ixsa+12*(i-1)+8))
      andp=nint(xss(ixsa+12*(i-1)+9))
      ldlwp=nint(xss(ixsa+12*(i-1)+10))
      dlwp=nint(xss(ixsa+12*(i-1)+11))

      !--loop over the reactions contributing to this production
      do imt=1,ntrp
         mt=nint(xss(mtrp+imt-1))
         l1=nint(xss(lsigp+imt-1))
         l2=sigp+l1-1
         ne=nint(xss(l2+3))
         na=nint(xss(landp+imt-1))
         l1=nint(xss(ldlwp+imt-1))
         l2=dlwp+l1-1
         law=nint(xss(l2+1))
         call mtname(mt,name,0)
         if (name(1:1).eq.'(') then
            name(2:2)='g'
         endif

         !--check for an angular distribution
         if (na.gt.0) then
            na=na+andp-1
            ne=nint(xss(na))
            nb=na+ne
            k=nint(xss(nb+1))
            xmin=-1
            xmax=1
            xstep=1
            xstep=xstep/2
            ymin=xss(na+1)
            ymax=xss(na+ne)
            itwo=0
            if (ne.gt.4) then
               test=3
               if (ymax.gt.test*xss(na+ne-1)) ymax=xss(na+ne-1)
               test=50
               if (ymax.ge.test) then
                  break=20
                  if (ymin.lt.dn*break.and.ymax.gt.up*break) itwo=1
               endif
            endif
            do while (itwo.ge.0.and.itwo.le.2)
               if (itwo.eq.1) then
                  ymax=break
               else if (itwo.eq.2) then
                  ymin=break
                  ymax=xss(na+ne)
               endif
               call ascle(4,ymin,ymax,major,minor)
               ystep=(ymax-ymin)/major
               zmin=big
               zmax=0
               do ie=1,ne
                  e=xss(na+ie)
                  if (e.le.(1+eps)*ymax.and.e.ge.ymin) then
                     k=nint(abs(xss(nb+ie)))+andp-1
                     np=nint(xss(k+1))
                     k=k+1
                     do j=1,np
                        cc=xss(k+j)
                        pp=xss(k+np+j)
                        if (pp.lt.zmin) zmin=pp
                        if (pp.gt.zmax) zmax=pp
                     enddo
                  endif
               enddo
               rat=100000
               if (zmin.le.zero) zmin=zmax/rat
               if (zmax/zmin.gt.rat)  zmin=zmax/rat
               call ascll(zmin,zmax)
               if (zmin.eq.zmax) then
                   zmax=2*zmax
                   zmin=zmax/10
               endif
               do ic=1,70
                  if (hk(ic:ic).ne.' ') it=ic
               enddo
               write(nout,'(''1'',i3,''/'')') iwcol
               write(nout,&
                  '(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
               l=len_trim(name)
               if (ipt.eq.1) then
                  write(nout,&
                    &'(a,''angular distribution for '',a,&
                    &'' neutron'',a,''/'')') qu,name(1:l),qu
               else if (ipt.eq.9) then
                  write(nout,&
                    &'(a,''angular distribution for '',a,&
                    &'' proton'',a,''/'')') qu,name(1:l),qu
               else if (ipt.eq.31) then
                  write(nout,&
                    &'(a,''angular distribution for '',a,&
                    &'' deuteron'',a,''/'')') qu,name(1:l),qu
               else if (ipt.eq.32) then
                  write(nout,&
                    &'(a,''angular distribution for '',a,&
                    &'' triton'',a,''/'')') qu,name(1:l),qu
               else if (ipt.eq.33) then
                  write(nout,&
                    &'(a,''angular distribution for '',a,&
                    &'' 3he'',a,''/'')') qu,name(1:l),qu
               else if (ipt.eq.34) then
                  write(nout,&
                    &'(a,''angular distribution for '',a,&
                    &'' alpha'',a,''/'')') qu,name(1:l),qu
               endif
               write(nout,'(''-1 2/'')')
               write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
               write(nout,'(a,''<c>osine'',a,''/'')') qu,qu
               write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
               write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
               write(nout,'(1p,3e12.3,''/'')') zmin,zmax,one
               write(nout,'(a,''<p>rob/<C>os'',a,''/'')') qu,qu
               write(nout,'(''/'')')
               write(nout,'('' 15. -15. 15. -2.5 6.5 2.5/'')')
               write(nout,'(''1/'')')
               stepm=(ymax-ymin)/150
               elast=0
               do ie=1,ne
                  e=xss(na+ie)
                  iflag=0
                  if (e.gt.(1+eps)*ymax) iflag=1
                  if (e.lt.ymin) iflag=1
                  if (ie.gt.1.and.ie.lt.ne.and.ne.gt.150.and.&
                    e-elast.lt.stepm) iflag=1
                  if (iflag.eq.0) then
                     write(nout,'(1p,e14.6,''/'')') e
                     k=nint(abs(xss(nb+ie)))+andp-1
                     intt=nint(xss(k))
                     np=nint(xss(k+1))
                     k=k+1
                     ylast=zmin
                     do j=1,np
                        cc=xss(k+j)
                        pp=xss(k+np+j)
                        if (pp.lt.zmin) pp=zmin
                        if (intt.eq.1) write(nout,&
                           '(1p,2e14.6,''/'')') cc,ylast
                        write(nout,'(1p,2e14.6,''/'')') cc,pp
                        ylast=pp
                     enddo
                     write(nout,'(''/'')')
                     elast=e
                  endif
               enddo
               write(nout,'(''/'')')
               if (itwo.eq.0) itwo=3
               if (itwo.eq.2) itwo=3
               if (itwo.eq.1) itwo=2
            enddo
         endif

         !--make a 3d plot of the particle emission for this reaction
         if (law.eq.4.or.law.eq.44.or.law.eq.61) then
            l3=dlwp+nint(xss(l2+2))-1
            ne=nint(xss(l3+1))
            zmin=1000
            zmax=0
            ymin=xss(l3+2)
            ymax=xss(l3+2+ne-1)
            test=3
            if (ymax.gt.test*xss(l3+2+ne-2)) ymax=xss(l3+2+ne-2)
            do ie=2,ne
               e=xss(l3+2+ie-1)
               if (e.le.up*ymax) then
                  loci=nint(xss(l3+2+ne+ie-1))+dlwp-1
                  intt=nint(xss(loci))
                  nn=nint(xss(loci+1))
                  if (nn.gt.2) then
                     loci=loci+1
                     !--skip first two point that may be pseudo-threshold
                     do j=3,nn
                        ep=xss(loci+j)
                        pd=xss(loci+nn+j)
                        if (pd.lt.zmin) zmin=pd
                        if (pd.gt.zmax) zmax=pd
                     enddo
                  endif
               endif
            enddo
            if (zmax.eq.0) go to 100
            zmin=zmax/10000
            if (zmax.eq.0) cycle
            call ascll(zmin,zmax)
            xmin=1000
            xmax=0
            do ie=1,ne
               e=xss(l3+2+ie-1)
               if (e.le.up*ymax) then
                  loci=nint(xss(l3+2+ne+ie-1))+dlwp-1
                  intt=nint(xss(loci))
                  nn=nint(xss(loci+1))
                  loci=loci+1
                  do j=1,nn
                     ep=xss(loci+j)
                     pd=xss(loci+nn+j)
                     if (pd.ge.zmin.and.pd.le.zmax) then
                        if (ep.lt.xmin) xmin=ep
                        if (ep.gt.xmax) xmax=ep
                     endif
                  enddo
               endif
            enddo
            call ascle(2,xmin,xmax,major,minor)
            xstep=(xmax-xmin)/major
            call ascle(4,ymin,ymax,major,minor)
            ystep=(ymax-ymin)/major
            write(nout,'(''1'',i3,''/'')') iwcol
            it=1
            do j=1,70
               if (hk(j:j).ne.' ') it=j
            enddo
            l=len_trim(name)
            write(nout,'(a,''<'',a,''>'',a,''/'')') qu,hk(1:it),qu
            if (ipt.eq.1) write(nout,&
              '(a,''neutrons from '',a,a,''/'')') qu,name(1:l),qu
            if (ipt.eq.2) write(nout,&
              '(a,''photons from '',a,a,''/'')') qu,name(1:l),qu
            if (ipt.eq.9) write(nout,&
              '(a,''protons from '',a,a,''/'')') qu,name(1:l),qu
            if (ipt.eq.31) write(nout,&
              '(a,''deuterons from '',a,a,''/'')') qu,name(1:l),qu
            if (ipt.eq.32) write(nout,&
              '(a,''tritons from '',a,a,''/'')') qu,name(1:l),qu
            if (ipt.eq.33) write(nout,&
              '(a,''he3s from '',a,a,''/'')') qu,name(1:l),qu
            if (ipt.eq.34) write(nout,&
              '(a,''alphas from '',a,a,''/'')') qu,name(1:l),qu
            write(nout,'(''-1 2/'')')
            write(nout,'(1p,3e12.3,''/'')') xmin,xmax,xstep
            write(nout,'(a,''<s>ec. <e>nergy'',a,''/'')') qu,qu
            write(nout,'(1p,3e12.3,''/'')') ymin,ymax,ystep
            write(nout,'(a,''<e>nergy (<m>e<v>)'',a,''/'')') qu,qu
            write(nout,'(1p,3e12.3,''/'')') zmin,zmax,one
            write(nout,'(a,''<p>rob/<m>e<v>'',a,''/'')') qu,qu
            write(nout,'(''/'')')
            write(nout,'(''/'')')
            write(nout,'(''1/'')')
            do ie=1,ne
               e=xss(l3+2+ie-1)
               if (e.le.up*ymax) then
                  loci=nint(xss(l3+2+ne+ie-1))+dlwp-1
                  intt=nint(xss(loci))
                  nd=nint(xss(loci))/10
                  nn=nint(xss(loci+1))
                  if (nn.gt.2) then
                     write(nout,'(1p,e14.6,''/'')') e
                     loci=loci+1
                     ylast=zmin
                     k=0
                     do j=1,nn
                        ep=xss(loci+j)
                        if (ep.ge.xmin.and.ep.le.xmax) then
                           pd=xss(loci+nn+j)
                           if (j.le.nd) pd=100*pd
                           if (pd.lt.zmin) pd=zmin
                           if (pd.gt.zmax) pd=zmax
                           if (j.le.nd) write(nout,&
                             '(1p,2e14.6,''/'')') ep-delta,zmin
                           if (intt.eq.1.and.j.gt.nd) then
                              write(nout,'(1p,2e14.6,''/'')')&
                                ep,ylast
                           endif
                           write(nout,'(1p,2e14.6,''/'')') ep,pd
                           if (j.le.nd) write(nout,&
                             '(1p,2e14.6,''/'')') ep+delta,zmin
                           k=k+1
                           ylast=pd
                        endif
                     enddo
                     if (k.lt.2) then
                        write(nout,'(1p,2e14.6,''/'')') xmin,zmin
                        write(nout,'(1p,2e14.6,''/'')') xmax,zmin
                     endif
                     write(nout,'(''/'')')
                  endif
               endif
            enddo
            write(nout,'(''/'')')
         endif
  100    continue
      enddo
   enddo

   !--end the plotr input text
   write(nout,'(''99/'')')
   write(nout,'(''stop'')')
   return
   end subroutine phnplo

   subroutine ascle(m,z1,z2,major,minor)
   !-------------------------------------------------------------------
   ! Automatic scaling routine for a linear axis.
   ! Borrowed from Los Alamos SC4020 library (with modifications).
   ! On input------------
   !   m              minimum number of major divisions desired
   !   z1,z2          min and max values of data to be plotted
   ! On output-----------
   !   z1,z2          min and max limits of axis
   !   major          number of major division on axis
   !   minor          number of minor divisions on axis
   !--***************************************************************
   ! externals
   integer::m,major,minor
   real(kr)::z1,z2
   ! internals
   integer::iflag,k,nm,n1,n2
   real(kr)::zmin,zmax,fm,zbar,z,p,tenk,test,dz,fn
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::tentho=10000

   !--check input
   !--exit if parameters are unreasonable
   zmin=z1
   zmax=z2
   if (zmax.le.zmin.or.m.le.0.or.m.gt.20) then
      major=1
      minor=0
      z1=0
      z2=2*z2
      return
   endif

   !--find minimum span per interval
   fm=m
   if (zmax.eq.zero.or.zmin.eq.zero) then
      zmax=zmax-abs(zmax)/1000000
      zmin=zmin+abs(zmin)/1000000
   else
      zbar=zmax/zmin
      if (abs(zbar)/1000.ge.one) zmin=0
      if (abs(zbar)*1000.le.one) then
         zmax=0
         zmax=zmax-abs(zmax)/1000000
         zmin=zmin+abs(zmin)/1000000
      else
         if ((abs(zbar-1)-5*fm/100000).gt.zero) then
            zmax=zmax-abs(zmax)/1000000
            zmin=zmin+abs(zmin)/1000000
         else
            zbar=(zmax+zmin)/2
            z=26*fm*abs(zbar)/1000000
            zmax=zbar+z
            zmin=zbar-z
         endif
      endif
   endif
   p=(zmax-zmin)/fm

   !--determine k such that
   !--    10**k.le.p.lt.10**(k+1)
   iflag=0
   tenk=1
   k=0
   if (p.lt.one) then
      iflag=1
      p=1/p
   endif
   do while (p.ge.tentho)
      p=p/10000
      tenk=tenk*10000
      k=k+4
   enddo
   do while (p.ge.ten)
      p=p/10
      tenk=tenk*10
      k=k+1
   enddo
   if (iflag.ne.0) then
      p=10/p
      tenk=one/10/tenk
      k=k-1
   endif

   !--determine dz such that
   !--    dz = 1*10**k, or
   !--    dz = 2*10**k, or
   !--    dz = 5*10**k.
   test=2+one/100
   if (p.le.test) then
      test=2-one/100
      if (p.le.test) then
         p=1
         nm=5
      else
         p=2
         nm=4
      endif
   else
      test=5-one/100
      if (p.lt.test) then
         p=2
         nm=4
      else
         p=5
         nm=5
      endif
   endif
   dz=p*tenk

   !--find integers n1 and n2 such that
   !--    n1*dz.le.zmin.lt.(n1+1)*dz, and
   !--    (n2-1)*dz.lt.zmax.le.n2*dz
   !--the new zmin and zmax become
   !--    zmin = n1*dz
   !--    zmax = n2*dz
   n1=int(zmin/dz)
   fn=n1
   z=fn*dz
   if (z.gt.zmin) then
      z=z-dz
      n1=n1-1
   endif
   zmin=z
   z1=zmin
   n2=int(zmax/dz)
   fn=n2
   z=fn*dz
   if (z.lt.zmax) then
      n2=n2+1
      z=z+dz
   endif
   zmax=z
   z2=zmax

   !--the values of major and minor can be set
   major=n2-n1
   minor=nm*major
   return
   end subroutine ascle

   subroutine ascll(amin,amax)
   !-------------------------------------------------------------------
   ! Adjust axis limits for a log scale.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::amin,amax
   ! internals
   integer::itop,ibot
   real(kr)::top,bot
   real(kr),parameter::b1=0.e0_kr
   real(kr),parameter::b2=.301e0_kr
   real(kr),parameter::b3=.699e0_kr
   real(kr),parameter::b4=1.e0_kr
   real(kr),parameter::ohoh1=.001e0_kr

   real(kr),parameter::zero=0
   real(kr),parameter::ten=10

   top=log10(amax)
   itop=int(top)
   if (top.lt.zero) itop=itop-1
   amax=itop+1
   if (top.le.itop+b3+ohoh1) amax=itop+b3
   if (top.le.itop+b2+ohoh1) amax=itop+b2
   if (top.le.itop+b1+ohoh1) amax=itop+b1
   amax=ten**amax
   bot=log10(amin)
   ibot=int(bot)
   if (bot.lt.zero) ibot=ibot-1
   amin=ibot
   if (bot.ge.ibot+b2-ohoh1) amin=ibot+b2
   if (bot.ge.ibot+b3-ohoh1) amin=ibot+b3
   if (bot.ge.ibot+b4-ohoh1) amin=ibot+b4
   amin=ten**amin
   return
   end subroutine ascll

   subroutine copynubar(scr,fnubar,jscr)
   !-------------------------------------------------------------------
   ! Copy the content of the nubar table to the scr array
   !-------------------------------------------------------------------
   ! externals
   real(kr)::scr(*)
   real(kr)::fnubar(*)
   integer::jscr
   ! internals
   integer::ii,nrr,npp

   ! replace the yield with the nubar
   nrr=nint(fnubar(5))
   npp=nint(fnubar(6))
   scr(5)=nrr
   scr(6)=npp
   do ii=1,nrr
      scr(5+2*ii)=fnubar(5+2*ii)
      scr(6+2*ii)=fnubar(6+2*ii)
   enddo
   do ii=1,npp
      scr(5+2*nrr+2*ii)=fnubar(5+2*nrr+2*ii)
      scr(6+2*nrr+2*ii)=fnubar(6+2*nrr+2*ii)
   enddo

   ! set the scr array index to the appropriate value
   jscr=6+2*nrr+2*npp+1

   return
   end subroutine copynubar

end module acepn

module powm
   ! provides subroutine powr for NJOY2016
   use locale
   implicit none
   private
   public powr

   ! i/o units
   integer::ngendf,nout,nscr,kscr,mscr

   ! powr global variables
   integer::lib,ngnf,ngn,ngnd
   real(kr)::cflux(140)

   ! scratch area for reading endf files
   integer::nwscr=5000
   real(kr)::scr(5000)

   ! epri-cell library global variables
   real(kr)::tmpr(10),sigz(10)
   integer::ntp,nsigz,jwf
   integer::iwr,izref
   real(kr)::rtemp
   integer::matd,nid,nff,iwa,iwf,nfs
   real(kr)::xla(3),xld(3),xlol(3)

   ! epri-cpm library global variables
   integer::nfg,nrg,nfsg,ngref,newmat,iprint
   integer::nzmax,mode
   integer::if5,ntis,nfis,if4
   integer::nnina,nres
   integer::iu235,iu,ipu239,ipu,nfiss(2)
   real(kr)::rleth(19),reflth
   integer,dimension(:),allocatable::mat
   real(kr),dimension(:),allocatable::flux

   integer,dimension(:),allocatable::idnt
   integer,dimension(:),allocatable::ninat
   integer,dimension(:),allocatable::irest
   real(kr),dimension(:),allocatable::s0rf
   integer,dimension(:),allocatable::ip1tab
   integer,dimension(:),allocatable::norft
   integer,dimension(:),allocatable::mtit
   integer,dimension(:),allocatable::mtct
   real(kr),dimension(:),allocatable::awrt
   integer,dimension(:),allocatable::indf
   integer,dimension(:),allocatable::ntmp
   integer,dimension(:),allocatable::nszt
   real(kr),dimension(:),allocatable::glamt
   integer,dimension(:),allocatable::ipost
   integer,dimension(:),allocatable::iposrt
   real(kr),dimension(:),allocatable::egb
   real(kr),dimension(:),allocatable::sigpt
   real(kr),dimension(:),allocatable::uff,puff
   real(kr),dimension(:),allocatable::fiss
   real(kr),dimension(:),allocatable::yld
   integer,dimension(:),allocatable::idat,idbt
   real(kr),dimension(:),allocatable::elas
   real(kr),dimension(:),allocatable::tempt

contains

   subroutine powr
   !--------------------------------------------------------------------
   !
   !  Produce input for the EPRI-CELL codes GAMTAP (fast) and
   !  LIBRAR (thermal), and the EPRI-CPM code CLIB.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1
   !    ngendf  unit for input gout tape
   !    nout    unit for output tape
   ! card 2
   !    lib     library option (1=fast, 2=thermal, 3=cpm)
   !    iprint  print option (0=minimum, 1=maximum)
   !            (default=0)
   !    iclaps  group collapsing option (0=collapse from 185 group
   !            to desired group structure, 1=no collapse)
   !            (default=0)
   !
   !---for lib=1----------------------------------------------------
   !
   ! card 3
   !    matd    material to be processed
   !            if matd lt 0, read-in absorption data only for
   !            this material with mat=abs(matd) directly from
   !            input deck (see card 6)
   !   following three parameters irrelevant for matd lt 0
   !    rtemp   reference temperature (degrees kelvin)
   !            (default=300  k)
   !    iff     f-factor option
   !            (0/1=do not calculate f-factors/calculate if found)
   !            (default=1)
   !    nsgz    no. of sigma zeroes to process for this material
   !            (default=0=all found on input tape)
   !    izref   ref. sigzero for elastic matrix (default=1)
   ! cards 4 and 5 for normal run only (matd gt 0)
   ! card 4
   !    word    description of nuclide (up to 16 characters,
   !            delimited with *, ended with /)  (default=blank)
   ! card 5
   !    fsn     title of fission spectrum (up to 40 characters,
   !            delimited with *, ended with /0  (default=blank)
   !             delimited with *, ended with /)  (default=blank)
   ! card 6 for reading in absorption data only
   !    abs     ngnd absorption values (default values=0)
   ! repeat cards 3 through 6 for each material desired.
   ! terminate with matd=0/ (i.e., a 0/ card).
   !
   !---for lib=2----------------------------------------------------
   !
   ! card 3
   !    matd    material to be processed
   !    idtemp  temperature id (default=300  k)
   !    name    hollerith name of isotope (up to 10 characters,
   !            delimited with *, ended with /)  (default=blank)
   ! card 4     default for all values=0.
   !    itrc    transport correction option (0 no, 1 yes)
   !    mti     thermal inelastic mt
   !    mtc     thermal elastic mt
   ! card 5     default for all values=0.
   !    xi
   !    alpha
   !    mubar
   !    nu
   !    kappa fission
   !    kappa capture
   !    lambda
   !    sigma s   if 0, set to scattering cross section at group 35
   ! repeat cards 3 thru 5 for each material and temperature desired
   ! (maximum number of temperatures allowed is 7.)
   ! terminate with matd=0/ (i.e., a 0/ card).
   !
   !---for lib=3----------------------------------------------------
   !
   ! card 3
   !    nlib    number of library.
   !    idat    date library is written (i format).
   !    newmat  number of materials to be added.
   !    iopt    add option (0=mats will be read in,
   !                        1=use all mats found on ngendf).
   !    mode    0/1/2=replace isotope(2) in cpmlib/
   !                   add/create a new library (default=0)
   !    if5     file5 (burnup data) option
   !            0/1/2=do not process file5 burnup data/
   !                   process burnup data along with rest of data/
   !                   process burnup data only (default=0)
   !            (default=0)
   !    if4     file4 (cross section data) option
   !            0/1=do not process/process
   !            (default=1)
   ! card 4 for iopt=0 only
   !    mat     endf mat number of all desired materials.
   !            for materials not on gendf tape, use ident for mat.
   !            if mat lt 0, add 100 to output ident
   !            (for second isomer of an isotope)
   ! card 5
   !    nina    nina indicator.
   !            0/1/2/3=normal/
   !                  no file2 data, calculate absorption in file4/
   !                  no file2 data, read in absorption in file4/
   !                  read in all file2 and file4 data.
   !    ntemp   no. of temperatures to process for this material
   !            (default=0=all found on input tape)
   !    nsigz   no. of sigma zeroes to process for this material
   !            (default=0=all found on input tape)
   !    sgref   reference sigma zero
   !    following 2 parameters are for nina=0 or nina=3.
   !    ires    resonance absorber indicator (0/1=no/yes)
   !    sigp    potential cross section from endf.
   !    following 5 parameters are for ntapea=0 only
   !    mti     thermal inelastic mt
   !    mtc     thermal elastic mt
   !    ip1opt  0/1=calculate p1 matrices/
   !                correct p0 scattering matrix ingroups.
   !  ******if a p1 matrix is calculated for one of the isotopes
   !        having a p1 matrix on the old library, file 6 on the
   !        new library will be completely replaced.******
   !    inorf   0/1=include resonance fission if found/
   !                do not include
   !    following two parameters for mode=0 only
   !    pos     position of this isotope in cpmlib
   !    posr    (for ires=1) position of this isotope in resonance
   !            tabulation in cpmlib
   !  repeat card 5 for each nuclide.
   ! following three cards are for if5 gt 0 only
   ! card 6
   !    ntis    no. time-dependent isotopes
   !    nfis    no. fissionable burnup isotopes
   ! card 7
   !    identb  ident of each of the nfis isotopes
   ! card 8
   !    identa  ident of time-dependent isotope
   !    decay   decay constant (default=0.)
   !    yield   nfis yields (default=0.)
   !  repeat card 8 for each of the ntis isotopes.
   ! card 9 for if5=2 only
   !    aw      atomic weight
   !    indfis  fission indicator
   !    ntemp   no. temperatures on old library
   !  repeat card 9 for each of the ntis isotopes.
   ! card 10
   !    lambda  resonance group goldstein lambdas
   !  ******remember that the 69-group structure has 13 resonance
   !        groups while the collapsed 185-group structure has 15.
   !        use a slash at end of each line of card 10 input.******
   !  repeat card 10 for each nuclide having nina=0, nina=3, or
   !                     ires=1.
   ! cards 11 and 11a for nuclides having nina=3 only.
   ! card 11
   !    resnu    nrg nus values to go with the lambda values
   ! card 11a
   !    tot      nrg total xsec values to go with the lambda values
   !  read cards 11 and 11a for each nuclide having nina=3.
   ! cards 12 for nina gt 2 only
   !    aw      atomic weight
   !    temp    temperature
   !    fpa     ngnd absorption values (default=0.)
   ! cards 12a, 12b, 12c for nuclides having nina=3 only.
   ! card 12a
   !    nus      ngnd nus values
   !    fis      ngnd fission values
   !    xtr      ngnd transport values
   ! card 12b
   !    ia       group.  0 means no scattering from this group
   !    l1       lowest group to which scattering occurs
   !    l2       highest group to which scattering occurs
   ! card 12c  for ia gt 0 only
   !    scat     l2-l1+1 scattering values
   !  repeat card 12b and 12c for each group
   ! repeat cards 12 for each of the nina gt 2 nuclides
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides timer,mess,openz,repoz,error,closz
   ! internals
   integer::igprnt,iprnt,iclaps
   real(kr)::sec

   !--initialize.
   ngnf=185
   igprnt=0
   call timer(sec)
   write(nsyso,&
     '(/'' powr...produce input for epri-cell libraries'',&
     &23x,f8.1,''s'')') sec
   write(nsyse,'(/'' powr...'',61x,f8.1,''s'')') sec

   !--read and write common input.
   read(nsysi,*) ngendf,nout
   iprnt=0
   iclaps=0
   read(nsysi,*) lib,iprnt,iclaps
   if (nout.lt.0)&
     call mess('powr','nout must be positive.  changed.',' ')
   if (nout.lt.0) nout=-nout
   call openz(ngendf,0)
   call openz(nout,1)
   write(nsyso,'(/&
     &'' input gendf unit ..................... '',i10/&
     &'' output unit .......................... '',i10/&
     &'' library (1 fast, 2 thermal, 3 cpm) ... '',i10/&
     &'' print option (0 min, 1 max) .......... '',i10/&
     &'' grp collapsing option (0 yes, 1 no) .. '',i10)')&
     ngendf,nout,lib,iprnt,iclaps
   call repoz(nout)

   !--branch for desired library

   !--calculate fast neutrons.
   if (lib.eq.1) then
      call fast(iprnt,igprnt)

   !--thermal neutrons.
   else if (lib.eq.2) then
      call therm(iprnt,igprnt)

   !--cpm library.
   else if (lib.eq.3) then
      call cpm(iprnt,iclaps)

   !--illegal lib
   else
      call error('powr','illegal library requested.',' ')
   endif

   call repoz(ngendf)
   call repoz(nout)
   call closz(ngendf)
   call closz(nout)
   call timer(sec)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') sec
   return
   end subroutine powr

   integer function icgrp(ig)
   !--------------------------------------------------------------------
   ! For the group ig in the 185-group fine structure, return the
   ! coarse group for the fast, thermal, or CPM group structure.
   !--------------------------------------------------------------------
   ! externals
   integer::ig
   ! internals
   integer,dimension(186),parameter::igf=(/&
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,2,2,3,3,&
     4,4,4,4,4,4,4,4,4,5,5,5,6,6,6,6,7,7,7,7,7,7,7,8,8,9,9,10,10,&
     11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19,20,20,&
     21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,30,30,&
     31,31,32,32,33,33,34,34,35,35,36,36,37,37,38,38,39,39,40,40,&
     41,41,42,42,43,43,44,44,45,45,46,46,47,47,48,48,49,49,50,50,&
     51,51,52,52,53,53,54,54,55,55,56,56,57,57,58,58,59,59,60,60,&
     61,61,62,62,63,63,64,64,65,65,66,66,67,67,68,68,69,0,0,0,0,&
     0,0,0,0,0,0,0,0/)
   integer,dimension(186),parameter::igt=(/&
     0,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,19,20,&
     21,21,22,22,23,23,24,24,25,26,27,28,29,30,30,31,32,32,33,34,&
     35,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,&
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,&
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,&
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,&
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/)
   integer,dimension(186),parameter::igc=(/&
     1,2,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,20,21,22,22,&
     23,23,24,25,26,27,28,29,29,29,30,31,32,33,34,34,34,35,35,36,36,&
     36,37,37,37,37,38,39,39,40,41,41,42,42,42,42,43,43,44,44,44,45,&
     45,45,45,46,46,46,46,46,47,47,47,47,48,48,48,48,48,49,49,49,49,&
     49,49,49,50,50,50,50,50,50,50,51,51,51,51,51,52,52,52,53,53,53,&
     54,54,54,54,55,55,55,55,56,56,56,56,57,57,57,57,58,58,58,58,59,&
     59,59,59,60,60,60,60,61,61,61,61,62,62,62,62,63,63,63,63,64,64,&
     64,64,65,65,65,65,66,66,66,66,67,67,67,67,68,68,68,68,69,69,69,&
     69,70,0,0,0,0,0,0,0,0,0,0,0,0/)

   !--no collapsing is required
   if (ngn.eq.ngnd) then
      icgrp=ig
      return
   endif

   !--input group is zero
   if (ig.eq.0) then
      icgrp=0
      return
   endif

   !--fast
   if (lib.eq.1) then
      icgrp=igf(ig)

   !--thermal
   else if (lib.eq.2) then
      icgrp=igt(ig)

   !--cpm
   else if (lib.eq.3) then
      icgrp=igc(ig)
   endif
   return
   end function icgrp

   subroutine fast(iprint,igprnt)
   !--------------------------------------------------------------------
   ! Format multigroup cross sections from groupr for the
   ! EPRI-CELL-cell fast library maintenance code GAMTAP.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides openz,repoz,closz
   ! externals
   integer::iprint,igprnt
   ! internals
   integer::ifiss,ngmin,ngmax,iff,nsgz,iread,i,l,lim
   integer::ifs,limsf,limc,la,ld,istart,nwmisc,na
   real(kr)::xld1,xld2,xld3
   real(4)::fsn(10)
   real(kr)::z(70),word(4)
   character(12)::hid
   character(40)::fsp
   integer::locab0,locsf0,locchi,locnus,loce0,loce1,locin,loc2n
   integer::locabs,locsf,loc(10)
   equivalence (locab0,loc(1))
   equivalence (locsf0,loc(2))
   equivalence (locchi,loc(3))
   equivalence (locnus,loc(4))
   equivalence (loce0,loc(5))
   equivalence (loce1,loc(6))
   equivalence (locin,loc(7))
   equivalence (loc2n,loc(8))
   equivalence (locabs,loc(9))
   equivalence (locsf,loc(10))
   real(kr),dimension(:),allocatable::a
   integer::misc=1
   integer::izero=0
   real(kr),parameter::zero=0

   ! set up storage area for fast data
   na=10000
   allocate(a(na))

   ! set up i/o units
   nscr=10
   kscr=11
   call openz(nscr,1)
   call openz(kscr,1)
   call repoz(nscr)
   call repoz(kscr)

   ! extract the fast data
   ifiss=0
   ngnd=68
   ngmin=19
   ngmax=62
   write(nsyso,'(/'' ***epri-cell fast library***'')')
   nff=1
   matd=1
   do while (matd.gt.0)
      rtemp=300
      iff=1
      nsgz=0
      izref=1
      read(nsysi,*) matd,rtemp,iff,nsgz,izref
      if (matd.gt.0) then
         iread=0
         if (matd.lt.0) iread=1
         matd=iabs(matd)
         hid=' '
         read(nsysi,*) hid
         read(hid,'(4a4)') (word(i),i=1,4)
         if (iread.ne.1) then
            fsp=' '
            read(nsysi,*) fsp
            read(fsp,'(10a4)') (fsn(i),i=1,10)
         else
            nid=matd
            iwa=1
            iwr=0
            iwf=0
            do i=1,3
               xlol(i)=0
               xla(i)=0
            enddo
            xld1=0
            xld2=0
            xld3=0
            do i=1,ngnd
               z(i)=0
            enddo
            read(nsysi,*) (z(i),i=1,ngnd)
            write(nsyso,'(&
              &'' mat to be processed .................. '',i10)')&
              matd
            write(nsyso,'(/&
              &'' description of nuclide''/&
              &1x,9(''----''),''--''/6x,4a4)') (word(i),i=1,4)
            write(nsyso,&
              '(/'' absorption only for this material.  '',&
              &''nid=matd.'')')
         endif

         !--write out input parameters.
         if (iread.ne.1) then
            write(nsyso,'(&
              &'' mat to be processed .................. '',i10)')&
              matd
            write(nsyso,'(&
              &'' reference temperature ................ '',1p,e10.3/&
              &'' f-factor option (0 no, 1 yes) ........ '',i10)')&
              rtemp,iff
            if (nsgz.gt.0) write(nsyso,'(&
              &'' max. no. of sigma zeroes ............. '',i10)')&
              nsgz
            if (nsgz.eq.0) write(nsyso,'(&
              &'' max. no. of sigma zeroes ............. '',7x,&
              &''all'')')
            write(nsyso,'(&
              &'' index of reference sigma zero ........ '',i10)')&
              izref
            write(nsyso,'(/&
              &'' description of nuclide''/&
              &1x,9(''----''),''--''/6x,4a4)') (word(i),i=1,4)

            !--set up pointers for gam.
            call gamll(igprnt,iff,nsgz)

            !--format cross sections for gam.
            call gamxs(locab0,locsf0,locchi,locnus,loce0,loce1,locin,&
              loc2n,locabs,a,na)

            !--format shielding factors for gam.
            if (nff.gt.0.and.iwr.gt.0) call gamff(ngmin,ngmax,&
              locab0,locsf0,locabs,locsf,a,na)

            !--write nscr and print output, if desired.
            xld1=xld(1)+1
            xld2=xld(2)+1
            xld3=xld(3)+1
            if (nfs+iwf.ne.0) then
               ifiss=iwf+nfs
               write(kscr,'(i6,i2,10a4)') nid,izero,(fsn(i),i=1,10)
               if (ifiss.eq.1) write(nsyso,'(/&
                 &'' fission spectrum''/&
                 &'' ----------------'')')
               if (ifiss.gt.1) write(nsyso,'(/&
                 &'' fission spectra''/&
                 &'' ---------------'')')
               write(nsyso,'(6x,10a4,''total''/)') (fsn(i),i=1,10)
               l=locchi
               lim=l+ngnd-1
               write(kscr,'(1p,6e12.5)') (a(i),i=l,lim)
               write(nsyso,'(1p,6e12.4)') (a(i),i=l,lim)
               if (nfs.ne.0) then
                  do ifs=1,nfs
                     write(kscr,'(i6,i2,10a4)')&
                       nid,ifs,(fsn(i),i=1,10)
                     write(nsyso,'(/6x,10a4,''delayed'',i1/)')&
                       (fsn(i),i=1,10),ifs
                     l=l+ngnd
                     lim=lim+ngnd
                     write(nsyso,'(1p,6e12.4)') (a(i),i=l,lim)
                     write(kscr,'(1p,6e12.5)') (a(i),i=l,lim)
                  enddo
                  nfs=nfs+iwf
               endif
            endif
         endif

         !--write more nout and print output
         write(nscr,'(6i10)') nid,iwa,iwf,iwr
         write(nscr,'(20a4)') (word(i),i=1,4)
         write(nscr,'(36x,1p,3e12.5)') xlol(3),xla(3),xld3
         write(nscr,'(1p,6e12.5)')&
           xlol(1),xla(1),xld1,xlol(2),xla(2),xld2
         if (iwa.ne.0) then
            lim=locab0+ngnd-1
            if (iread.eq.0) write(nscr,'(1p,6e12.5)')&
              (a(i),i=locab0,lim)
            if (iread.gt.0) write(nscr,'(1p,6e12.5)')&
              (z(i),i=1,ngnd)
            if (iprint.ne.0) then
               write(nsyso,'(/&
                 &'' absorption cross section''/&
                 &'' ------------------------'')')
               if (iread.eq.0) write(nsyso,'(1p,6e12.4)')&
                 (a(i),i=locab0,lim)
               if (iread.gt.0) write(nsyso,'(1p,6e12.4)')&
                 (z(i),i=1,ngnd)
            endif
         endif
         if (iwf.ne.0) then
            limsf=locsf0+ngnd-1
            write(nscr,'(1p,6e12.5)') (a(i),i=locsf0,limsf)
            lim=locnus+ngnd-1
            write(nscr,'(1p,6e12.5)') (a(i),i=locnus,lim)
            if (iprint.ne.0) then
               write(nsyso,'(/&
                 &'' fission cross section''/&
                 &'' ---------------------'')')
               write(nsyso,'(1p,6e12.4)') (a(i),i=locsf0,limsf)
               write(nsyso,'(/&
                 &'' fission nu''/&
                 &'' ----------'')')
               write(nsyso,'(1p,6e12.4)') (a(i),i=locnus,lim)
               if (nfs.ne.0) then
                  limc=locchi-1+ngnd
                  write(nsyso,'(/&
                    &'' fission chi''/&
                    &'' -----------'')')
                  write(nsyso,'(1p,6e12.4)') (a(i),i=locchi,limc)
               endif
            endif
         endif
         if (xlol(3).ne.zero) then
            lim=loce0+nint(xlol(3))-1
            write(nscr,'(1p,6e12.5)') (a(i),i=loce0,lim)
            lim=loce1+nint(xlol(3))-1
            write(nscr,'(1p,6e12.5)') (a(i),i=loce1,lim)
            if (iprint.ne.0) then
               la=nint(xla(3))
               ld=nint(xld(3))
               write(nsyso,'(//&
                 &'' p0 elastic scattering matrix''/&
                 &'' ----------------------------'')')
               call pgam(a(loce0),ngnd,la,ld)
               write(nsyso,'(//&
                 &'' p1 elastic scattering matrix''/&
                 &'' ----------------------------'')')
               call pgam(a(loce1),ngnd,la,ld)
            endif
         endif
         if (xlol(1).ne.zero) then
            lim=locin+nint(xlol(1))-1
            write(nscr,'(1p,6e12.5)') (a(i),i=locin,lim)
            if (iprint.ne.0) then
               la=nint(xla(1))
               ld=nint(xld(1))
               write(nsyso,'(//&
                 &'' inelastic scattering matrix''/&
                 &'' ---------------------------'')')
               call pgam(a(locin),ngnd,la,ld)
            endif
         endif
         if (xlol(2).ne.zero) then
            lim=loc2n+nint(xlol(2))-1
            write(nscr,'(1p,6e12.5)') (a(i),i=loc2n,lim)
            if (iprint.ne.0) then
               la=nint(xla(2))
               ld=nint(xld(2))
               write(nsyso,'(//&
                 &'' n2n scattering matrix''/&
                 &'' ---------------------'')')
               call pgam(a(loc2n),ngnd,la,ld)
            endif
         endif
         if (nff.ne.0.and.iwr.ne.0) then
            write(nscr,'(4i6)') nsigz,ntp,misc,jwf
            write(nscr,'(1p,6e12.5)') (sigz(i),i=1,nsigz)
            write(nscr,'(1p,6e12.5)') (tmpr(i),i=1,ntp)
            istart=locabs+(ngmax-iwr)*nsigz*ntp
            lim=istart+iwr*nsigz*ntp-1
            write(nscr,'(1p,6e12.5)') (a(i),i=istart,lim)
            if (iprint.ne.0) then
               write(nsyso,'(//&
                 &'' absorption self-shielding factors''/&
                 &'' ---------------------------------'')')
               call pgamff(a(locabs),ntp,nsigz,iwr,sigz,tmpr,ngmax)
            endif
            if (jwf.ne.0) then
               istart=locsf+(ngmax-iwr)*nsigz*ntp
               lim=istart+iwr*nsigz*ntp-1
               write(nscr,'(1p,6e12.5)') (a(i),i=istart,lim)
               if (iprint.ne.0) then
                  write(nsyso,'(//&
                    &'' fission self-shielding factors''/&
                    &'' ------------------------------'')')
                  call pgamff(a(locsf),ntp,nsigz,iwr,sigz,tmpr,ngmax)
               endif
            endif
            ! write a dummy amisc array
            nwmisc=iwr*10
            write(nscr,'(1p,6e12.5)') (zero,i=1,nwmisc)
         endif
      endif
   enddo

   !--fast is finished.
   call repoz(nscr)
   call mergt(ifiss,kscr,nscr,nout,z)
   call closz(nscr)
   call closz(nscr)
   return
   end subroutine fast

   subroutine pgam(a,ng,la,ld)
   !--------------------------------------------------------------------
   ! Print out scattering matrices in packed GAM format.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! externals
   integer::ng,la,ld
   real(kr)::a(*)
   ! internals
   integer::ncol1,i,k,ig,n,i1,i2,j,nw,m,ig2
   integer::ncol=5

   ncol1=ncol-1
   write(nsyso,'(/&
     &'' initl final    cross section vs final group''/&
     &'' group group    +0'',4(10x,''+'',i1)/&
     &1x,7(''----------''),''--------'')')&
     (i,i=1,ncol1)
   k=0
   do ig=1,la
      n=ng-ig+1
      if (n.gt.(ld+1)) n=ld+1
      if (n.le.ld) n=n+1
      ! do not print leading and trailing zeroes
      i1=0
      i2=0
      do j=1,n
         if (i1.eq.0.and.a(k+j).ne.0) i1=j
         if (a(k+j).ne.0.) i2=j
      enddo
      if (i1.ne.0) then
         nw=i2-i1+1
         m=nw
         k=k+i1-1
         if (m.gt.ncol) m=ncol
         ig2=ig+i1-1
         write(nsyso,'(i5,i6,2x,1p,5e12.4)') ig,ig2,(a(k+i),i=1,m)
         do while (nw.gt.0)
            k=k+m
            nw=nw-m
            if (nw.gt.0) then
               ig2=ig2+ncol
               m=nw
               if (m.gt.ncol) m=ncol
               write(nsyso,'(5x,i6,2x,1p,5e12.4)') ig2,(a(k+i),i=1,m)
            endif
         enddo
      endif
      k=k+n-i2
   enddo
   return
   end subroutine pgam

   subroutine pgamff(a,ntp,nsigz,iwr,sigz,tmpr,ngmax)
   !--------------------------------------------------------------------
   ! Print out form factors in packed GAM format.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! externals
   integer::ntp,nsigz,iwr,ngmax
   real(kr)::sigz(*),tmpr(*),a(nsigz,ntp,*),f(7)
   ! internals
   integer::i,n,ig,is,it
   integer::jopt=1

   write(nsyso,'(5x,''temperatures (down)'',10f7.0)')&
     (tmpr(i),i=1,ntp)
   write(nsyso,'(5x,''sigzeroes (across)''/9x,1p,10e12.0)')&
     (sigz(i),i=1,nsigz)
   n=ngmax+1-iwr
   do ig=n,ngmax
      if (jopt.le.0) then
         write(nsyso,'(/'' group'',i2,3x,1p,10e12.4)')&
           ig,(a(is,1,ig),is=1,nsigz)
      else
         do is=1,nsigz
            f(is)=exp(-a(is,1,ig)/2)*sqrt(sigz(is))
         enddo
         write(nsyso,'(/'' group'',i2,3x,1p,10e12.4)')&
           ig,(f(is),is=1,nsigz)
      endif
      if (ntp.ne.1) then
         do it=2,ntp
            if (jopt.le.0) then
               write(nsyso,'(11x,1p,10e12.4)')&
                 (a(is,it,ig),is=1,nsigz)
            else
               do is=1,nsigz
                  f(is)=exp(-a(is,it,ig)/2)*sqrt(sigz(is))
               enddo
               write(nsyso,'(11x,1p,10e12.4)')&
                 (f(is),is=1,nsigz)
            endif
         enddo
      endif
   enddo
   return
   end subroutine pgamff

   subroutine mergt(ifiss,n1,n2,n3,a)
   !--------------------------------------------------------------------
   ! copy tape n1 if present and n2 to n3
   !--------------------------------------------------------------------
   use util ! provides repoz
   ! externals
   integer::ifiss,n1,n2,n3
   real(kr)::a(*)
   ! internals
   integer::i

   call repoz(n2)
   call repoz(n3)
   if (ifiss.gt.0) call repoz(n1)
   if (ifiss.eq.0) go to 130
  110 continue
   read(n1,10,end=130) (a(i),i=1,20)
   write(n3,10) (a(i),i=1,20)
   go to 110
  130 continue
   read(n2,10,end=150) (a(i),i=1,20)
   write(n3,10) (a(i),i=1,20)
   go to 130
  150 continue
   call repoz(n3)
   return
  10 format(20a4)
   end subroutine mergt

   subroutine gamll(igprnt,iff,nsgz)
   !--------------------------------------------------------------------
   ! Read through gendf tape and assign storage and pointers
   ! for GAM format.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides repoz,error
   ! externals
   integer::igprnt,iff,nsgz
   ! internals
   integer::nb,nw,ldin,ldp,ld2n,lz,iza,ntw,i1,i,ngnd1,ngn1
   integer::lastg,ig,jg,lain,la2n,lap,nl,l,igc,ig2lo,idone
   integer::ig2loc,lx
   real(kr)::temp
   character(60)::strng
   real(kr),dimension(:),allocatable::eg
   real(kr),parameter::eps=1.e-4_kr
   integer,parameter::ntpmax=5
   integer,parameter::nszmax=7

   !--read data for desired material.
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
  110 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.-1) then
      write(strng,'(''mat='',i4,'' not on tape '',i3)') matd,ngendf
      call error('gamll',strng,' ')
   endif
   if (math.eq.0.or.mfh.eq.0.or.mth.eq.0) go to 110
   if (math.eq.matd) go to 120
   call tomend(ngendf,0,0,scr)
   go to 110
  120 continue
   iwa=1
   iwf=0
   nfs=0
   iwr=0
   nsp=0
   ntp=-1
   jwf=0
   ldin=0
   ldp=0
   ld2n=0
   lz=6
   iza=nint(c1h)
   nid=iza*10
   go to 140
  130 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.ne.matd) go to 400
  140 continue
   nsigz=l2h
   if (nsigz.eq.1) iff=0
   if (nsigz.gt.1.and.iff.gt.0) iwr=1
   if (nsigz.gt.nsgz.and.nsgz.gt.0) nsigz=nsgz
   if (nsigz.gt.nszmax) then
      write(strng,'(i2,'' allowed'')') nszmax
      call error('gamll','reqested too many sigma zeroes',strng)
   endif
   ntw=n2h
   call listio(ngendf,0,0,scr,nb,nw)
   temp=c1h
   if (abs(temp-rtemp).le.eps) go to 160
   if (temp.gt.rtemp.and.ntp.lt.0)&
     call error('gamll','reference temp not on gendf tape.',' ')
   if (ntp.lt.0) go to 150
   ntp=ntp+1
   if (ntp.gt.ntpmax) then
      write(strng,'(i2,'' allowed'')') ntpmax
      call error('gamll','requested too many temperatures',strng)
   endif
   tmpr(ntp)=temp
   go to 220
  150 continue
   call tomend(ngendf,0,0,scr)
   go to 130
  160 continue
   ngn=l1h
   if (ngn.ne.ngnd.and.ngn.ne.ngnf)&
     call error('gamll',&
     'incorrect group structure or group type.',' ')
   if (igprnt.le.0) then
      i1=7+ntw+nsigz+ngn
      if (ngn.eq.ngnd) write(nsyso,'(/&
        &'' neutron group structure''/&
        &'' -----------------------'',(1p,6e12.4))')&
        scr(i1),(scr(i1-i),i=1,ngn)
      if (ngn.ne.ngnd) then
         ngnd1=ngnd+1
         ngn1=ngn+1
         allocate(eg(ngnd1))
         lastg=0
         i1=i1-ngn1
         do i=1,ngn1
            ig=icgrp(i)
            if (ig.ne.lastg) then
               if (ig.ne.0) then
                  jg=ngnd1-ig
                  eg(1+jg)=scr(i1+i)
               endif
               lastg=ig
            endif
         enddo
         write(nsyso,'(/&
           &'' neutron group structure''/&
           &'' -----------------------''/&
           &(1p,6e12.4))') (eg(i),i=1,ngnd1)
         deallocate(eg)
      endif
      igprnt=1
   endif
   ntp=0
   if (rtemp.gt.0) ntp=1
   if (rtemp.gt.0) tmpr(1)=temp
   do i=1,nsigz
      sigz(i)=scr(i+ntw+lz)
   enddo
   if (izref.eq.1) write(nsyso,'(/&
     &'' ref. sigma zero for elastic matrix = infinity'')')
   if (izref.ne.1) write(nsyso,'(/&
     &'' ref. sigma zero for elastic matrix ='',1p,e10.2)')&
     sigz(izref)
   lain=ngnd
   la2n=ngnd
   lap=ngnd
  220 continue
   call tosend(ngendf,0,0,scr)

   !--process relevant sections for this material.
  250 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0.and.nsigz.gt.1) go to 130
   if (math.ne.matd) go to 400
   if (mfh.eq.0.or.mth.eq.0) go to 250
   if (mfh.eq.3) go to 260
   if (mfh.eq.5) go to 270
   if (mfh.eq.6) go to 300
   call tosend(ngendf,0,0,scr)
   go to 250

   !--process cross section data (mf=3).
   !--check for presence of fission.
  260 continue
   if (mth.eq.18.or.mth.eq.19) iwf=1
   call tosend(ngendf,0,0,scr)
   go to 250

   !--check for presence of delayed neutron spectra (mf=5)
  270 continue
   if (mth.eq.455) then
      nl=l1h
      nfs=nfs+nl
   endif
   call tosend(ngendf,0,0,scr)
   go to 250

   !--process transfer matrix data (mf=6).
  300 continue
   call listio(ngendf,0,0,scr,nb,nw)
   l=1
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
   enddo
   ig=n2h
   igc=icgrp(ig)
   if (igc.eq.0.or.igc.gt.ngnd) go to 350
   ig2lo=l2h
   idone=0
   do while (idone.eq.0)
      ig2loc=icgrp(ig2lo)
      if (ig2loc.ne.0.and.ig2loc.le.ngnd) then
         idone=1
      else
         if (ig2lo.eq.ig) then
            idone=1
         else
            ig2lo=ig2lo+1
         endif
      endif
   enddo
   if (mth.lt.51.or.mth.gt.91) go to 360
   ! inelastic
   if (lain.gt.igc) lain=igc
   if (ldin.lt.(igc-ig2loc)) ldin=igc-ig2loc
  350 continue
   if (ig.lt.ngn) go to 300
   go to 250
  360 continue
   if (mth.ne.2) go to 370
   ! elastic
   if (lap.gt.igc) lap=igc
   if (ldp.lt.(igc-ig2loc)) ldp=igc-ig2loc
   if (ig.lt.ngn) go to 300
   go to 250
  370 continue
   if (mth.eq.16) go to 390
   if (mth.gt.5.and.mth.lt.10) go to 390
   if (mth.gt.45.and.mth.lt.50) go to 390
   call tosend(ngendf,0,0,scr)
   go to 250
  390 continue
   ! n2n
   if (la2n.gt.igc) la2n=igc
   if (ld2n.lt.(igc-ig2loc)) ld2n=igc-ig2loc
   go to 250

   !--set up storage pointers.
  400 continue
   xla(1)=0
   xla(2)=0
   xla(3)=0
   xlol(1)=0
   xlol(2)=0
   xlol(3)=0
   xld(1)=ldin
   xld(2)=ld2n
   xld(3)=ldp
   if (ldin.ne.0) then
      xla(1)=ngnd-lain+1
      lx=nint(xla(1))+nint(xld(1))-ngnd-1
      if (lx.lt.0) lx=0
      xlol(1)=xla(1)*(xld(1)+1)-(lx*(lx-1))/2
   endif
   if (ld2n.ne.0) then
      xla(2)=ngnd-la2n+1
      lx=nint(xla(2))+nint(xld(2))-ngnd-1
      if (lx.lt.0) lx=0
      xlol(2)=xla(2)*(xld(2)+1)-(lx*(lx-1))/2
   endif
   if (ldp.ne.0) then
      xla(3)=ngnd-lap+1
      lx=nint(xla(3))+nint(xld(3))-ngnd-1
      if (lx.lt.0) lx=0
      xlol(3)=xla(3)*(xld(3)+1)-(lx*(lx-1))/2
   endif
   return
   end subroutine gamll

   subroutine gamxs(locab0,locsf0,locchi,locnus,loce0,loce1,locin,&
     loc2n,locabs,a,nloc)
   !--------------------------------------------------------------------
   ! Read through ngendf tape again and accumulate desired
   ! cross sections and matrices in the array a.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides error,repoz,skiprz
   ! externals
   integer::locab0,locsf0,locchi,locnus,loce0,loce1,locin,loc2n,locabs
   real(kr)::a(*)
   integer::nloc
   ! externals
   integer::ngnd1,ldin,kdin,ld2n,kd2n,ldp,kdp,lz,mf3mt2,jgdnu
   integer::i,i318,i618,nb,nw,l,nl,nz,ng2,ig2lo,ig,igc
   integer::jg,loc,loca,k,locf,ig2,ig2c,jg2c,locc,nldla,il,na
   integer::locb,jgc,locd,jgt,jgp,lc,lim,loc1,loc2,iloc,locdla
   real(kr)::dnu,dnorm,cnorm,temp,test,flx,rnorm,fracd,tfound
   real(kr)::sumd(6)
   real(kr)::cspc(200)
   real(kr),parameter::eps=1.e-4_kr
   real(kr),parameter::zero=0

   !--initialize data pointers.
   ngnd1=ngnd+1
   ldin=nint(xld(1))
   kdin=ngnd1-ldin
   ld2n=nint(xld(2))
   kd2n=ngnd1-ld2n
   ldp=nint(xld(3))
   kdp=ngnd1-ldp
   lz=6
   mf3mt2=0
   dnu=0
   jgdnu=0
   dnorm=0
   cnorm=0
   iloc=1
   locab0=iloc
   locsf0=locab0+ngnd
   locchi=locsf0+ngnd
   locdla=locchi+ngnd
   locnus=locdla+ngnd*nfs
   loce0=locnus+ngnd
   loce1=loce0+nint(xlol(3))
   locin=loce1+nint(xlol(3))
   loc2n=locin+nint(xlol(1))
   locabs=loc2n+nint(xlol(2))
   na=locabs-1
   if ((na-iloc).gt.nloc)&
     call error('gamxs','storage exceeded.',' ')
   do i=iloc,na
      a(i)=0
   enddo
   do i=1,ngnd
      cflux(i)=0
      cflux(i+ngnd)=0
   enddo
   do i=1,ngn
      cspc(i)=0
   enddo
   i318=0
   i618=0
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
  120 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.matd) go to 130
   call tomend(ngendf,0,0,scr)
   go to 120

   !--process relevant sections for reference temperature.
  130 continue
   tfound=0
   if (mfh.ne.1) go to 150
   call tosend(ngendf,0,0,scr)
  140 continue
   l=1
   call contio(ngendf,0,0,scr(l),nb,nw)
   if (math.eq.0) go to 500
   if (mfh.eq.0.or.mth.eq.0) go to 140
   if (mfh.ne.1) go to 150
   call tosend(ngendf,0,0,scr(l))
   go to 140
  150 continue
   nl=l1h
   nz=l2h
   if (mfh.ne.3.or.mth.lt.2.or.mf3mt2.gt.0) go to 170
   mf3mt2=1
   do i=1,ngnd
      if (cflux(i).ne.zero) cflux(i)=1/cflux(i)
      if (cflux(ngnd+i).ne.zero) cflux(ngnd+i)=1/cflux(ngnd+i)
   enddo
  170 continue
   call listio(ngendf,0,0,scr(l),nb,nw)
   temp=c1h
   if (abs(temp-rtemp).gt.eps.and.tfound.eq.0) go to 210
   if (abs(temp-rtemp).le.eps) tfound=1
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   igc=1
   if (ig.gt.0) igc=icgrp(ig)
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if ((l+nw-1).gt.nwscr)&
        call error('gamxs','storage exceeded.',' ')
   enddo
   if (igc.eq.0.or.igc.gt.ngnd) go to 260
   jg=ngnd-igc+1
   l=1
   if (mth.eq.455) go to 330
   if (mfh.eq.3) go to 250
   if (mfh.eq.6) go to 300
  200 continue
   call tosend(ngendf,0,0,scr(l))
   go to 140
  210 continue
   call tomend(ngendf,0,0,scr(l))
   go to 140

   !--file 3 cross sections
  250 continue
   if (mth.ne.1) go to 270
   ! coarse group p0 flux
   cflux(jg)=cflux(jg)+scr(l+lz)
   if (nl.eq.1) go to 260
   ! coarse group p1 flux
   cflux(ngnd+jg)=cflux(ngnd+jg)+scr(l+lz+1)
  260 continue
   if (ig.lt.ngn) go to 170
   go to 140
  270 continue
   if (mth.lt.102.or.mth.gt.150) go to 280
   ! capture
   loc=locab0+jg-1
   loca=l+lz+nl*nz
   a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
   if (ig.lt.ngn) go to 170
   go to 140
  280 continue
   if ((mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 200
   ! fission
   if (mth.eq.18) i318=1
   if (mth.gt.18.and.i318.gt.0) go to 200
   loc=locsf0+jg-1
   loca=l+lz+nl*nz
   a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
   loc=locab0+jg-1
   a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
   if (ig.lt.ngn) go to 170
   go to 140

   !--file 6 matrices
  300 continue
   if (igc.eq.0.or.igc.gt.ngnd) go to 320
   if ((mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 370

   !--fission
   if (mth.eq.18) i618=1
   if (mth.gt.18.and.i618.gt.0) go to 200
   if (ig.ne.0) then
      do k=2,ng2
         loca=l+lz+nl*nz*(k-1)
         loc=locnus+jg-1
         if (ig2lo.ne.0) then
            ! matrix part
            a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
            locf=l+lz
            ig2=ig2lo+k-2
            ig2c=icgrp(ig2)
            if (ig2c.ne.0.and.ig2c.le.ngnd) then
               jg2c=ngnd-ig2c+1
               loc=locchi+jg2c-1
               a(loc)=a(loc)+scr(locf)*scr(loca)
               cnorm=cnorm+scr(locf)*scr(loca)
            endif
         else
            ! spectrum part
            do i=1,ngn
               a(loc)=a(loc)+cspc(i)*scr(loca)*scr(loca-1)*cflux(jg)
               ig2c=icgrp(i)
               if (ig2c.ne.0.and.ig2c.le.ngnd) then
                  jg2c=ngnd-ig2c-1
                  locc=locchi+jg2c-1
                  a(locc)=a(locc)+cspc(i)*scr(loca)*scr(loca-1)
                  cnorm=cnorm+scr(loca)*scr(loca-1)
               endif
            enddo
         endif
      enddo
   else
      ! save constant spectrum
      do k=1,ng2
         cspc(ig2lo+k-1)=scr(l+lz+nl*nz*(k-1))
      enddo
   endif
  320 continue
   if (ig.lt.ngn) go to 170
   go to 140
   ! delayed neutrons
  330 continue
   if (mfh.ne.5) then
      loc=locnus+jg-1
      loca=l+lz
      a(loc)=a(loc)+scr(loca+1)*scr(loca+2)*scr(l+lz)*cflux(jg)
      dnorm=dnorm+scr(loca)*scr(loca+1)*scr(loca+2)
      test=1
      test=test/10
      if (scr(loca+2).ge.test.and.dnu.eq.zero) jgdnu=jg
      if (scr(loca+2).ge.test.and.dnu.eq.zero) dnu=scr(loca+1)
   else
      nldla=nl
      if (nldla.ne.6) call error('gamxs',&
        'no. deleay groups not 6.',' ')
      do il=1,nl
         sumd(il)=0
      enddo
      locb=l+lz-1
      do k=2,ng2
         ig2=ig2lo+k-2
         ig2c=icgrp(ig2)
         if (ig2c.ne.0.and.ig2c.le.ngnd) then
            jgc=ngnd-ig2c+1
            loc=locchi+jgc-1
            loca=l+lz-1+nl*(k-1)
            locd=locdla+jgc-1
            do jgt=1,nl
               a(loc)=scr(jgt+loca)*dnorm+a(loc)
               a(ngnd*(jgt-1)+locd)=a(ngnd*(jgt-1)+locd)&
                 +scr(jgt+loca)*dnu
               if (jgc.eq.ngnd) a(ngnd*(jgt-1)+locd)=a(jgt+locb)
               if (jgc.lt.ngnd-1) sumd(jgt)=sumd(jgt)&
                 +scr(jgt+loca)*dnu
               cnorm=scr(jgt+loca)*dnorm+cnorm
            enddo
         endif
      enddo
   endif
   if (ig.lt.ngn) go to 170
   go to 140

   !--inelastic
  370 continue
   if (mth.lt.51.or.mth.gt.91) go to 410
   jgp=jg
   if (jg.gt.kdin) jgp=kdin
   lc=(ldin+1)*(jgp-1)
   if (jg.gt.kdin) then
      lim=jg-kdin
      do jgt=1,lim
         lc=lc+ldin+2-jgt
      enddo
   endif
   do k=2,ng2
      ig2=ig2lo+k-2
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         if (jg2c.lt.jg) jg2c=jg
         loca=l+lz+nl*nz*(k-1)
         loc=locin+lc+jg2c-jg
         a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
      endif
   enddo
   if (ig.lt.ngn) go to 170
   go to 140

   !--elastic
  410 continue
   if (mth.ne.2) go to 450
   jgp=jg
   if (jg.gt.kdp) jgp=kdp
   lc=(ldp+1)*(jgp-1)
   if (jg.gt.kdp) then
      lim=jg-kdp
      do jgt=1,lim
         lc=lc+ldp+2-jgt
      enddo
   endif
   do k=2,ng2
      ig2=ig2lo+k-2
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         if (jg2c.lt.jg) jg2c=jg
         loc=loce0+lc+jg2c-jg
         loca=l+lz+nl*(izref-1+nz*(k-1))
         a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
         if (nl.ne.1) then
            loca=loca+1
            loc=loce1+lc+jg2c-jg
            flx=cflux(ngnd+jg)
            if (cflux(ngnd+jg).eq.0.) flx=cflux(jg)
            a(loc)=a(loc)+3*scr(loca)*scr(l+lz+1)*flx
         endif
      endif
   enddo
   if (ig.lt.ngn) go to 170
   go to 140
  450 continue
   if (mth.eq.16) go to 460
   if (mth.lt.6.or.mth.gt.49) go to 200
   if (mth.gt.9.and.mth.lt.46) go to 200

   !--n2n
  460 continue
   jgp=jg
   if (jg.gt.kd2n) jgp=kd2n
   lc=(ld2n+1)*(jgp-1)
   if (jg.gt.kd2n) then
      lim=jg-kd2n
      do jgt=1,lim
         lc=lc+ld2n+2-jgt
      enddo
   endif
   do k=2,ng2
      ig2=ig2lo+k-2
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         if (jg2c.lt.jg) jg2c=jg
         loca=l+lz+nl*nz*(k-1)
         loc=loc2n+lc+jg2c-jg
         a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)/2
      endif
   enddo
   if (ig.lt.ngn) go to 170
   go to 140

   !--finished loading a.
   !--find nu from nu times sigma f.
  500 continue
   do ig=1,ngnd
      loc1=locsf0+ig-1
      if (a(loc1).ne.zero) then
         loc2=locnus+ig-1
         a(loc2)=a(loc2)/a(loc1)
      endif
   enddo

   !--normalize chi and delayed chi
   if (cnorm.ne.zero) then
      cnorm=1/cnorm
      do ig=1,ngnd
         a(ig-1+locchi)=a(ig-1+locchi)*cnorm
      enddo
      if (dnu.ne.zero) then
         rnorm=1/a(jgdnu-1+locnus)
         lim=ngnd-1
         do ig=1,lim
            locd=locdla-1+ig
            do il=1,nldla
               if (ig.lt.lim) then
                  a(ngnd*(il-1)+locd)=a(ngnd*(il-1)+locd)*rnorm
               else
                  a(ngnd*(il-1)+locd)=sumd(il)*rnorm
               endif
            enddo
         enddo
         fracd=dnu/a(jgdnu-1+locnus)
         write(nsyso,'(/&
           &'' nudlay ='',1p,e13.5/&
           &'' delayed fraction ='',e13.5/&
           &'' time constants''/1x,6e13.5/&
           &'' time group fractions''/1x,6e13.5)')&
           dnu,fracd,(a(ngnd*(il-1)+locdla+ngnd-1),il=1,nldla),&
           (a(ngnd*(il-1)+locdla+ngnd-2),il=1,nldla)
      endif
   endif

   !--for reference temperatures greater than zero...
   if (rtemp.gt.0) call skiprz(ngendf,-2)
   if (rtemp.gt.0) call findf(matd,1,451,ngendf)
   return
   end subroutine gamxs

   subroutine gamff(ngmin,ngmax,locab0,locsf0,locabs,locsf,a,nloc)
   !--------------------------------------------------------------------
   ! Calculate f-factors for absorption and fission.
   !--------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::ngmin,ngmax,locab0,locsf0,locabs,locsf,nloc
   real(kr)::a(*)
   ! internals
   integer::lz,i,itp,mf3mt1,i318,l,nb,nw,nl,nz,lim,ig,igc
   integer::jg,loc,loca,jz,iadd,iglo,na,iloc
   real(kr)::ab0,sf0
   real(kr),parameter::toler=.01e0_kr
   real(kr),parameter::zero=0

   !--initialize.
   iloc=1
   lz=6
   locsf=locabs+ngnd*ntp*nsigz
   na=locsf+ngnd*ntp*nsigz-1
   if ((na-iloc).gt.nloc)&
     call error('gamff','storage exceeded.',' ')
   do i=locabs,na
      a(i)=0
   enddo
   itp=1
   mf3mt1=1
   i318=0

   !--read through rest of temperatures for this mat,
   !--and store absorption and fission cross-sections.
  110 continue
   l=1
   call contio(ngendf,0,0,scr(l),nb,nw)
   if (math.gt.0) go to 120
   if (itp.eq.ntp) go to 300
   itp=itp+1
   i318=0
  120 continue
   if (mfh.eq.0.or.mth.eq.0) go to 110
   if (mfh.eq.3) go to 130
   call tosend(ngendf,0,0,scr(l))
   go to 110
  130 continue
   if (mf3mt1.le.0.and.mfh.eq.3.and.mth.ge.2) then
      mf3mt1=1
      do i=1,ngnd
         if (cflux(i).ne.zero) cflux(i)=1/cflux(i)
      enddo
   endif
   if (mth.gt.101.and.mth.lt.108) go to 160
   if ((mth.gt.17.and.mth.lt.22).or.mth.eq.38) go to 160
   if (mth.eq.1) go to 160
  150 continue
   call tosend(ngendf,0,0,scr(l))
   go to 110
  160 continue
   nl=l1h
   nz=l2h
   lim=nz
   if (nsigz.lt.nz) lim=nsigz
  170 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   ig=n2h
   igc=icgrp(ig)
   do while (nb.ne.0)
      l=l+nw
      if ((l+nw-1).gt.nwscr)&
        call error('gamff','storage exceeded.',' ')
      call moreio(ngendf,0,0,scr(l),nb,nw)
   enddo
   if (igc.eq.0.or.igc.gt.ngnd) go to 210
   jg=ngnd-igc+1
   if (mth.lt.102) go to 220
   ! capture
   loc=locabs-1+nsigz*((itp-1)+ntp*(jg-1))
   loca=l+lz+nl*(nz-1)
   do jz=1,lim
      a(jz+loc)=scr(nl*jz+loca)*scr(l+lz)*cflux(jg)+a(jz+loc)
   enddo
  210 continue
   if (ig.lt.ngn) go to 170
   go to 110
  220 continue
   if (mth.eq.1) go to 240
   ! fission
   if (mth.eq.18) i318=1
   if (mth.gt.18.and.i318.gt.0) go to 150
   jwf=1
   iadd=nsigz*((itp-1)+ntp*(jg-1))-1
   loca=l+lz+nl*(nz-1)
   do jz=1,lim
      a(jz+iadd+locsf)=a(jz+iadd+locsf)+scr(nl*jz+loca)*scr(l+lz)*&
        cflux(jg)
      a(jz+iadd+locabs)=a(jz+iadd+locabs)+scr(nl*jz+loca)*scr(l+lz)*&
        cflux(jg)
   enddo
   go to 210
   ! flux
  240 continue
   if (igc.le.1) then
      do i=1,ngnd
         cflux(i)=0
      enddo
      mf3mt1=0
   endif
   cflux(jg)=cflux(jg)+scr(l+lz)
   go to 210

   !--finished loading a.
   !--calculate f-factors.
  300 continue
   iglo=ngmin
   do ig=ngmin,ngmax
      ab0=a(locab0+ig-1)
      if (ab0.ne.zero) ab0=1/ab0
      sf0=a(locsf0+ig-1)
      if (sf0.ne.zero) sf0=1/sf0
      do jz=1,nsigz
         do itp=1,ntp
            iadd=jz-1+nsigz*((itp-1)+ntp*(ig-1))
            loc=locabs+iadd
            if (ab0.eq.zero) a(loc)=1
            if (ab0.ne.zero) a(loc)=a(loc)*ab0
            if (a(loc).le.zero) a(loc)=1
            if (abs(1-a(loc)).gt.toler.and.iglo.eq.ngmin) iglo=ig
            a(loc)=log(sigz(jz))-2*log(a(loc))
            if (jwf.ne.0) then
               loc=locsf+iadd
               if (sf0.eq.zero) a(loc)=1
               if (sf0.ne.zero) a(loc)=a(loc)*sf0
               if (a(loc).le.zero) a(loc)=1
               a(loc)=log(sigz(jz))-2*log(a(loc))
            endif
         enddo
      enddo
   enddo
   iwr=ngmax-iglo+1
   return
   end subroutine gamff

   subroutine therm(iprint,igprnt)
   !--------------------------------------------------------------------
   ! Read data for adding nuclides to thermal library from a gout tape.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides repoz,error
   ! externals
   integer::iprint,igprnt
   ! internals
   integer::il,lz,n,matd,itrc,mti,mtc,i,i318,mf3mt2
   integer::iflx0,iflx1,nb,nw,ifound,nl,nz,iza,nuclid,nsigz
   integer::ntw,itemp,idm,idma,idb,ida,idf,id1,id2,id3,nlm
   integer::ia,lim,ig,igc,ig2lo,ng2,loca,ig2,ig2c,loc
   integer::ndexc,ndexf,ngndsq,idtemp,ngnd1,nbm
   real(kr)::awr,amubar
   character(60)::strng
   character(12)::idname
   real(kr)::valu(20),aname(3),z(10)
   integer::igi(35),ngi(35)
      data valu/20*0.0d0/
   real(kr),dimension(:),allocatable::s0,s1
   real(kr),dimension(:),allocatable::xa,xf
   real(kr),dimension(:),allocatable::b,p
   real(kr),dimension(:),allocatable::grp
   real(kr),parameter::watt=1.e13_kr
   integer::id4=0
   integer::id5=0
   real(kr),parameter::zero=0

   ngnd=35
   write(nsyso,'(/'' ***epri-cell thermal library***/'')')

   !--allocate storage.
   allocate(s0(ngnd))
   allocate(s1(ngnd))
   allocate(xa(ngnd))
   allocate(xf(ngnd))
   ngndsq=ngnd*ngnd
   allocate(b(ngndsq))
   allocate(p(ngndsq))
   ngnd1=ngnd+1
   allocate(grp(ngnd1))
   il=1
   lz=6

   !--read and write user input.
   n=0
  100 continue
   idtemp=300
   idname=' '
   read(nsysi,*) matd,idtemp,idname
   if (matd.eq.0) go to 300
   read(idname,'(3a4)') aname(1),aname(2),aname(3)
   itrc=0
   mti=0
   mtc=0
   read(nsysi,*) itrc,mti,mtc
   do i=1,8
      z(i)=0
   enddo
   read(nsysi,*) (z(i),i=1,8)
   valu(2)=z(1)
   valu(3)=z(2)
   valu(4)=z(3)
   valu(5)=z(4)
   valu(6)=z(5)*watt
   valu(7)=z(6)*watt
   valu(8)=0
   valu(9)=z(7)
   valu(10)=z(8)
   n=n+1
   write(nsyso,'(//&
     &'' mat to be processed .................. '',i10/&
     &'' temperature id ....................... '',i10/&
     &'' isotope name ......................... '',2a4,a2)')&
     matd,idtemp,aname
   write(nsyso,'(&
     &'' transport corr. option (0 no, 1 yes) . '',i10/&
     &'' mt inelastic ......................... '',i10/&
     &'' mt elastic ........................... '',i10)')&
     itrc,mti,mtc
   write(nsyso,'(&
     &'' xi ................................... '',1p,e10.3/&
     &'' alpha ................................ '',e10.3/&
     &'' mubar ................................ '',e10.3/&
     &'' nu ................................... '',e10.3/&
     &'' kappa fission ........................ '',e10.3/&
     &'' kappa capture ........................ '',e10.3/&
     &'' lambda ............................... '',e10.3/&
     &'' sigma s .............................. '',e10.3)')&
     (z(i),i=1,8)

   !--read data for desired nuclide.
   i318=0
   mf3mt2=0
   do i=1,ngndsq
      b(i)=0
      p(i)=0
   enddo
   iflx0=0
   iflx1=0
   call repoz(ngendf)
   call contio(ngendf,0,0,scr,nb,nw)
   ifound=0
  115 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.lt.0) go to 220
   if (math.eq.0.or.mfh.eq.0.or.mth.eq.0) go to 115
   if (math.eq.matd) go to 120
   if (ifound.gt.0) go to 220
   call tomend(ngendf,0,0,scr)
   go to 115
  120 continue
   nl=l1h
      nz=l2h
   if (mfh.eq.3) go to 152
   if (mfh.eq.6.and.mth.eq.mti) go to 152
   if (mfh.eq.6.and.mth.eq.mtc.and.mtc.ne.0) go to 152
   if (mfh.eq.1) go to 130
   call tosend(ngendf,0,0,scr)
   go to 115
  130 continue
   iza=nint(c1h)
   nuclid=iza*10
   awr=c2h
   nsigz=l2h
   ntw=n2h
   call listio(ngendf,0,0,scr,nb,nw)
   itemp=nint(c1h)
   if (idtemp.eq.itemp) go to 132
   if (ifound.gt.0) go to 220
   call tomend(ngendf,0,0,scr)
   go to 115
  132 continue
   ifound=1
   idm=nuclid
   idma=idtemp
   idb=0
   ida=0
   idf=0
   id1=0
   id2=0
   id3=0
   id4=0
   id5=0
   nlm=0
   ia=1
   do while (nb.ne.0)
      ia=ia+nw
      call moreio(ngendf,0,0,scr(ia),nb,nw)
      if ((ia+nw-1).gt.nwscr)&
        call error('therm','storage exceeded.',' ')
   enddo
   valu(1)=awr
   write(nsyso,'(&
     &'' atomic weight ........................ '',1p,e10.3)')&
     valu(1)
   ngn=l1h
   if (ngn.ne.ngnd.and.ngn.ne.ngnf)&
     call error('therm','ngn is not equal to ngnd.',' ')
   if (igprnt.le.0) then
      ia=1+lz+ntw+nsigz
      lim=ngn+1
      if (ngn.eq.ngnd) then
         do i=1,lim
            grp(i)=scr(i-1+ia)
         enddo
      else
         do i=1,lim
            ig=icgrp(i)
            if (ig.ne.0) then
               grp(ig)=scr(ia+i-1)
            endif
         enddo
      endif
      write(nsyso,'(/&
        &''24h neutron group structure''/&
        &'' -----------------------''/&
        &(1p,6e12.4))') (grp(i),i=1,ngnd1)
      igprnt=1
   endif
   do i=1,ngnd
      cflux(i)=0
      cflux(i+ngnd)=0
      s0(i)=0
      s1(i)=0
      xa(i)=0
      xf(i)=0
   enddo
   go to 115
  152 continue
   call listio(ngendf,0,0,scr,nb,nw)
   ia=1
   do while (nb.ne.0)
      ia=ia+nw
      call moreio(ngendf,0,0,scr(ia),nb,nw)
      if ((ia+nw-1).gt.nwscr)&
         call error('therm','storage exceeded.',' ')
   enddo
   ig=n2h
   igc=icgrp(ig)
   if (mf3mt2.gt.0) go to 160
   if (iflx0.eq.0) go to 160
   if (mfh.eq.3.and.mth.eq.1) go to 160
   mf3mt2=1
   do i=1,ngnd
      if (cflux(i).ne.zero) cflux(i)=1/cflux(i)
      if (cflux(ngnd+i).ne.zero) cflux(ngnd+i)=1/cflux(ngnd+i)
   enddo
  160 continue
   if (mfh.eq.6) go to 185
   if (igc.eq.0.or.igc.gt.ngnd) go to 166
   if (mth.eq.1) go to 164
   if (mth.gt.1.and.iflx0.eq.0)&
     call error('therm','p0 flux not found.',' ')
   if (mth.eq.18) go to 170
   if (mth.eq.19.and.i318.eq.0) go to 170
   if (mth.ge.102.and.mth.le.150) go to 180
   call tosend(ngendf,0,0,scr)
   go to 115
   ! coarse group flux
   ! p0
  164 continue
   cflux(igc)=cflux(igc)+scr(1+lz)
   iflx0=1
   if (nl.gt.1) then
      ! p1
      cflux(ngnd+igc)=cflux(ngnd+igc)+scr(lz+2)
      iflx1=1
   endif
   go to 166
   ! fission
  170 continue
   idf=1
   if (mth.eq.18) i318=1
   xf(igc)=xf(igc)+scr(1+lz+nl*nz)*scr(1+lz)*cflux(igc)
   go to 166
   ! capture
  180 continue
   xa(igc)=xa(igc)+scr(1+lz+nl*nz)*scr(1+lz)*cflux(igc)
   go to 166
  166 continue
   if (ig.lt.ngn) go to 152
   go to 115
  185 continue
   ! scattering matrix
   if (ida.le.0) then
      write(nsyso,'(/&
        &'' scattering cross sections and mubar''/&
        &''        sig0        sig1       mubar''/&
        &'' -----------------------------------'')')
      ida=1
   endif
   ig2lo=l2h
   ng2=l1h
   if (nl.gt.nlm) nlm=nl
   ig=n2h
   igc=icgrp(ig)
   if (igc.ne.0.and.igc.le.ngnd) then
      do i=2,ng2
         loca=1+(il-1)+lz+nl*nz*(i-1)
         ig2=ig2lo+i-2
         ig2c=icgrp(ig2)
         if (ig2c.ne.0.and.ig2c.le.ngnd) then
            loc=ig2c+ngnd*(igc-1)
            p(loc)=p(loc)+scr(loca)*scr(1+lz)*cflux(igc)
            s0(igc)=s0(igc)+scr(loca)*scr(1+lz)*cflux(igc)
            if (nl.ne.1) then
               ndexc=ngnd+igc
               if (iflx1.eq.0) ndexc=igc
               ndexf=1+lz+1
               if (iflx1.eq.0) ndexf=1+lz
               s1(igc)=s1(igc)&
                 +scr(loca+1)*scr(ndexf)*cflux(ndexc)
            endif
         endif
      enddo
   endif
   if (ig.lt.ngn) go to 152
   go to 115

   !--prepare final matrix
  220 continue
   if (ifound.eq.0) then
      write(strng,'(''mat='',i4,'' temp '',i2,'' not found'')')&
         matd,idtemp
      call error('therm',strng,' ')
   endif
   if (ida.ne.0) then
      do ig=1,ngnd
         if (s0(ig).eq.zero) amubar=0
         if (s0(ig).ne.zero) amubar=s1(ig)/s0(ig)
         write(nsyso,'(1p,6e12.4)') s0(ig),s1(ig),amubar
      enddo
      ! convert to xsec per unit energy.
      do ig=1,ngnd
         do ig2=1,ngnd
            p(ig2+ngnd*(ig-1))=p(ig2+ngnd*(ig-1))&
              *(grp(1+ig)-grp(ig))/(grp(1+ig2)-grp(ig2))
         enddo
      enddo
      ! pack scattering matrix
      call packa(p,ngnd,b,nbm,igi,ngi)
      id3=nbm
   endif

   !--compute absorption and transport cross sections
   do i=1,ngnd
      if (idf.ne.0) xa(i)=xa(i)+xf(i)
      if (ida.ne.0) s1(i)=xa(i)+s0(i)-s1(i)
   enddo
   if (valu(10).eq.0.) valu(10)=s0(ngnd)

   !--write out data for this nuclide.
   if (itrc.eq.0) valu(4)=1-valu(4)
   if (itrc.eq.1) valu(4)=-1
   write(nout,'(2i10,10i5)')&
     idm,idma,idb,ida,idf,id1,id2,id3,id4,id5
   write(nout,'(2a4,a2,6f10.4)') aname,(valu(i),i=1,6)
   write(nout,'(7f10.4)') (valu(i),i=7,13)
   write(nout,'(7f10.4)') (valu(i),i=14,20)
   write(nout,'(1p,6e12.5)') (xa(i),i=1,ngnd)
   if (idf.eq.1) write(nout,'(1p,6e12.5)') (xf(i),i=1,ngnd)
   if (itrc.eq.1) write(nout,'(1p,6e12.5)') (s1(i),i=1,ngnd)
   if (ida.eq.1) write(nout,'(12i6)') (igi(i),i=1,ngnd)
   if (ida.eq.1) write(nout,'(12i6)') (ngi(i),i=1,ngnd)
   if (ida.eq.1) write(nout,'(1p,6e12.5)') (b(i),i=1,nbm)
   write(nsyso,'(/&
     &'' storage pointers''/'' ----------------''/&
     &6x,''idm'',8x,i9/&
     &6x,''idma'',7x,i9/&
     &6x,''idb'',8x,i9/&
     &6x,''ida'',8x,i9/&
     &6x,''idf'',8x,i9/&
     &6x,''id1'',8x,i9/&
     &6x,''id2'',8x,i9/&
     &6x,''id3'',8x,i9)')&
     idm,idma,idb,ida,idf,id1,id2,id3
   if (iprint.ne.0) then
      write(nsyso,'(/&
        &'' absorption cross section''/&
        &'' ------------------------'')')
      write(nsyso,'(1p,6e12.4)') (xa(i),i=1,ngnd)
      if (idf.ne.0) then
         write(nsyso,'(/&
           &'' fission cross section''/&
           &'' ---------------------'')')
         write(nsyso,'(1p,6e12.4)') (xf(i),i=1,ngnd)
      endif
      if (ida.ne.0) then
         if (itrc.eq.1) write(nsyso,'(//&
           &'' transport cross section''/&
           &'' -----------------------'')')
         if (itrc.eq.1) write(nsyso,'(1p,6e12.4)')&
           (s1(i),i=1,ngnd)
         write(nsyso, '(//&
           &'' scattering matrix''/&
           &'' -----------------'')')
         call tprnt(b,igi,ngi,ngnd)
      endif
   endif
   go to 100

   !--therm is finished.
  300 continue
   call repoz(nout)
   return
   end subroutine therm

   subroutine tprnt(a,igi,ngi,nix)
   !--------------------------------------------------------------------
   ! Matrix printing routine.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! externals
   integer::nix
   real(kr)::a(*)
   integer::igi(*),ngi(*)
   ! internals
   integer::ncol1,i,k,jlo,ng,lim,j
   integer::ncol=5

   ncol1=ncol-1
   write(nsyso,'(/&
     &''46h final initl    cross section vs initial group''/&
     &'' group group    +0'',4(10x,''+'',i1)/&
     &1x,7(''----------''),''--------''/)')&
     (i,i=1,ncol1)
   k=0
   do 100 i=1,nix
   jlo=igi(i)
   ng=ngi(i)
   lim=ng
   if (lim.gt.ncol) lim=ncol
   write(nsyso,'(i5,i6,2x,1p,5e12.4)')&
     i,jlo,(a(k+j),j=1,lim)
  110 continue
   k=k+lim
   if (lim.eq.ng) go to 100
   jlo=jlo+lim
   ng=ng-lim
   lim=ng
   if (lim.gt.ncol) lim=ncol
   write(nsyso,'(5x,i6,2x,1p,5e12.4)')&
     jlo,(a(k+j),j=1,lim)
   go to 110
  100 continue
   return
   end subroutine tprnt

   subroutine packa(tpa,igroup,a,k,igi,ng)
   !--------------------------------------------------------------------
   ! Pack a scattering matrix into banded form by removing
   ! unneeded zeroes.
   !--------------------------------------------------------------------
   ! externals
   integer::igroup
   real(kr)::tpa(igroup,igroup),a(*)
   integer::igi(*),ng(*)
   ! internals
   integer::k,i,idone,j,jj,jhi
   real(kr),parameter::small=1.e-6_kr

   k=0
   do i=1,igroup
      igi(i)=0
      ng(i)=0
      idone=0
      j=0
      do while (j.lt.igroup.and.idone.eq.0)
         j=j+1
         jj=igroup-j+1
         if (abs(tpa(i,jj)).ge.small) idone=1
      enddo
      jhi=jj
      do j=1,jhi
         if (abs(tpa(i,j)).ge.small.or.igi(i).ne.0) then
            if (abs(tpa(i,j)).ge.small.and.igi(i).eq.0) igi(i)=j
            k=k+1
            a(k)=tpa(i,j)
         endif
      enddo
      ng(i)=jhi-igi(i)+1
   enddo
   return
   end subroutine packa

   subroutine cpm(iprnt,iclaps)
   !--------------------------------------------------------------------
   ! Format multigroup cross sections from groupr for the EPRI-CPM
   ! library code CLIB.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides error,repoz
   ! externals
   integer::iprnt,iclaps
   ! internals
   integer::i,k,nina,ires,mti,mtc,ip1opt,norf,ipos,iz,iposr
   integer::nfis1,nfis2,j,nz,identa,index,izero,iscr,jscr
   integer::nw,nwflx,nn,nwglam,nlib,idatt,iopt,ntemp,nt
   integer::immax,lspace
   real(kr)::sgref,sigp
   integer::im(70)
   real(kr)::z(70)
   integer::km(70)
   real(kr),dimension(:),allocatable::scr2
   real(kr),dimension(:),allocatable::f1p
   integer,parameter::nrg69=13
   integer,parameter::nrg185=15
   real(kr),parameter::zero=0

   ngnd=69
   nfg=14
   nrg=nrg185
   if (iclaps.gt.0) nrg=nrg69
   nfsg=22
   ngref=60
   if (nrg.eq.nrg69) ngref=55
   nt=6
   nzmax=10
   iprint=iprnt
   ! arrays im and rleth are available for temporary storage
   immax=ngnd+1+nrg+1
   iscr=1

   !--read and write user input.
   write(nsyso,'(/'' ***epri-cpm library***'')')
   write(nsyse,'(/'' ***epri-cpm library***'')')
   mode=0
   if5=0
   if4=1
   read(nsysi,*) nlib,idatt,newmat,iopt,mode,if5,if4
   do i=1,newmat
      im(i)=0
   enddo
   if (iopt.ne.1) then
      if (newmat.gt.immax)&
        call error('cpm','exceeded storage in input array z.',' ')
      read(nsysi,*) (im(i),i=1,newmat)
   endif
   write(nsyso,'(&
     &'' number of library .................... '',i10/&
     &'' date ................................. '',i10/&
     &'' no. of materials to be added ......... '',i10/&
     &'' add option (0 only mats read, 1 all) . '',i10/&
     &'' mode (0 replace, 1 add, 2 create ) ... '',i10/&
     &'' burn option (0 no, 1 yes, 2 only) .... '',i10/&
     &'' xsec data option (0 no, 1 yes) ....... '',i10)')&
     nlib,idatt,newmat,iopt,mode,if5,if4
   if (iopt.eq.0) write(nsyso,&
     &'('' desired mats ......................... ''/&
     &(3x,12i6))') (im(i),i=1,newmat)
   if (iopt.eq.1) write(nsyso,&
     &'('' first '',i2,'' mat(s) on ngendf will be processed.'')')&
     newmat
   write(nsyso,'(/&
     &'' nina ntemp nsigz ref. sig0 ires pot. xsec '',&
     &''mti mtc ip1 norf pos posr''/&
     &'' ---- ----- ----- --------- ---- --------- '',&
     &''--- --- --- ---- --- ----'')')
   nres=0
   nnina=0
   k=0
   do i=1,newmat
      nina=0
      ntemp=0
      nsigz=0
      sgref=0
      ires=0
      sigp=0
      mti=0
      mtc=0
      ip1opt=0
      norf=0
      ipos=0
      iposr=0
      read(nsysi,*) nina,ntemp,nsigz,sgref,ires,sigp,mti,mtc,&
        ip1opt,norf,ipos,iposr
      if (nina.eq.0.or.nina.eq.3) nnina=nnina+1
      if (ires.eq.1) nres=nres+1
      if (nina.ne.0) ip1opt=1
      write(nsyso,'(i4,i5,i6,1p,e12.2,i4,e11.3,2i4,i4,2i5,i4)')&
        nina,ntemp,nsigz,sgref,ires,sigp,mti,mtc,&
        ip1opt,norf,ipos,iposr
      k=k+12
   enddo
   if (if5.ne.0) then
      ! file 5 input
      iz=newmat+1
      read(nsysi,*) ntis,nfis
      lspace=immax-newmat
      nfis1=nfis+1
      nfis2=nfis+2
      if (lspace.lt.nfis2) allocate(scr2(nfis2))
      allocate(idat(ntis))
      allocate(idbt(ntis))
      nw=ntis*nfis1
      allocate(yld(nw))
      do i=1,nw
         yld(i)=0
      enddo
      read(nsysi,*) (idbt(i),i=1,nfis)
      do i=1,nfis
         if (lspace.ge.nfis2) im(iz-1+i)=idbt(i)
         if (lspace.lt.nfis2) km(i)=idbt(i)
      enddo
      if (lspace.ge.nfis2) write(nsyso,'(&
        &'' no. time-dependent nuclides .......... '',i10/&
        &'' no. fissionable burnup nuclides ...... '',i10/&
        &'' fissionable burnup nuclide ids ....... ''//&
        &(16x,9i12))')&
        ntis,nfis,(im(iz-1+i),i=1,nfis)
      if (lspace.lt.nfis2) write(nsyso,'(&
        &'' no. time-dependent nuclides .......... '',i10/&
        &'' no. fissionable burnup nuclides ...... '',i10/&
        &'' fissionable burnup nuclide ids ....... ''//&
        &(16x,9i12))')&
        ntis,nfis,(km(i),i=1,nfis)
      write(nsyso,'(&
        &/''  ident    decay     yields''/&
        &'' ------'',2x,''----------'',2x,''------'')')
      do i=1,ntis
         do j=1,nfis2
            if (lspace.ge.nfis2) z(iz-1+j)=0
            if (lspace.lt.nfis2) scr2(i)=0
         enddo
         nz=nfis2
         if (lspace.ge.nfis2) read(nsysi,*) (z(iz+j-1),j=1,nz)
         if (lspace.lt.nfis2) read(nsysi,*) (scr2(j),j=1,nz)
         if (lspace.ge.nfis2) identa=nint(z(iz))
         if (lspace.lt.nfis2) identa=nint(scr2(1))
         idat(i)=identa
         index=1+(i-1)*nfis1
         izero=0
         do j=2,nz
            if (lspace.ge.nfis2) yld(index+j-2)=z(iz+j-1)
            if (lspace.lt.nfis2) yld(index+j-2)=scr2(j)
            if (j.gt.2.and.yld(index+j-2).ne.zero) izero=1
         enddo
         if (izero.gt.0) write(nsyso,'(i7,1p,10e12.4/(19x,9e12.4))')&
           identa,(yld(index+j-1),j=1,nfis1)
         if (izero.eq.0) write(nsyso,'(i7,1p,10e12.4/(19x,9e12.4))')&
           identa,yld(index)
      enddo
      if (if5.eq.1.and.lspace.lt.nfis2) deallocate(scr2)
      if (if5.ne.1) then
         nw=3*ntis
         allocate(f1p(nw))
         write(nsyso,'(&
           &3x,''ident'',5x,''aw'',5x,''indfis'',2x,''ntemp''/&
           &3x,''-----'',2x,''--------'',2x,''------'',2x,''-----'')')
         if (lspace.ge.nfis2) then
            do i=1,ntis
               index=1+(i-1)*3
               read(nsysi,*) (f1p(index+j-1),j=1,3)
               identa=idat(i)
               write(nsyso,'(3x,i6,f10.4,i6,i7)')&
                 identa,f1p(index),f1p(index+1),f1p(index+2)
            enddo
         else
            do i=1,ntis
               index=1+(i-1)*3
               read(nsysi,*) (f1p(index+j-1),j=1,3)
               identa=idat(i)
               write(nsyso,'(3x,i6,f10.4,i6,i7)')&
                 identa,f1p(index),f1p(index+1),f1p(index+2)
            enddo
            deallocate(scr2)
         endif
      endif
   endif
   write(nsyso,'(/)')

   !--allocate storage.
   allocate(mat(newmat))
   allocate(idnt(newmat))
   allocate(ninat(newmat))
   allocate(irest(newmat))
   allocate(s0rf(newmat))
   allocate(ip1tab(newmat))
   allocate(norft(newmat))
   allocate(mtit(newmat))
   allocate(mtct(newmat))
   allocate(awrt(newmat))
   allocate(indf(newmat))
   allocate(ntmp(newmat))
   allocate(nszt(newmat))
   nwflx=nrg*nt*nzmax
   if (nwflx.lt.ngnd*2) nwflx=ngnd*2
   allocate(flux(nwflx))
   allocate(sigpt(newmat))
   nn=nnina
   if (nn.eq.0) nn=nres
   nwglam=nn*nrg
   if (nwglam.gt.0) allocate(glamt(nwglam))
   if (mode.eq.0) then
      allocate(ipost(newmat))
      allocate(iposrt(newmat))
   endif
   if (nnina.ne.0.or.nres.ne.0) then
      jscr=iscr+k+1
      do i=1,nn
         do j=1,nrg
            glamt(i+nn*(j-1))=0
         enddo
         read(nsysi,*) (scr(jscr+k-1),k=1,nrg)
      enddo
   endif
   k=0
   do i=1,newmat
      mat(i)=im(i)
      ninat(i)=nint(scr(iscr+k))
      ntmp(i)=nint(scr(iscr+k+1))
      nszt(i)=nint(scr(iscr+k+2))
      s0rf(i)=scr(iscr+k+3)
      irest(i)=nint(scr(iscr+k+4))
      sigpt(i)=scr(iscr+k+5)
      mtit(i)=nint(scr(iscr+k+6))
      mtct(i)=nint(scr(iscr+k+7))
      ip1tab(i)=nint(scr(iscr+k+8))
      norft(i)=nint(scr(iscr+k+9))
      k=k+12
   enddo
   if (mode.le.0) then
      k=0
      do i=1,newmat
         ipost(i)=nint(scr(iscr+k+10))
         iposrt(i)=nint(scr(iscr+k+11))
         k=k+12
      enddo
   endif
   nscr=10
   kscr=11
   mscr=12
   call repoz(nout)
   call pinit(iopt)

   !--process data for resonance calculation.
   call sfile2

   !--process effective resonance integrals.
   call sfile3(ntemp,nt)

   !--process cross sections.
   call sfile4(ntemp,nt)

   !--process burnup data.
   if (if5.gt.0) call sf5out

   !--process p1 scattering matrix.
   call sfile6(ntemp)

   !--write output tape.
   if (nout.ne.0) call cpmout(nlib,idatt)

   !--cpm is finished.
   call repoz(nout)
   return
   end subroutine cpm

   subroutine pinit(iopt)
   !--------------------------------------------------------------------
   ! Store materials from ngendf.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides repoz,error,mess
   ! externals
   integer::iopt
   ! internals
   integer::ngnd1,nb,nw,matl,nmat,n2,i,nina,icont,mat1,irepoz
   integer::matd,iza,nz,ntw,i1,ngn1,lastg,ig,jg,i318,mess3,i618
   integer::mess6,il,ih,jgref
   real(kr)::aleth
   character(60)::strng

   ngnd1=ngnd+1
   allocate(egb(ngnd1))
   iu235=92235
   ipu239=94239
   iu=0
   nfiss(1)=0
   ipu=0
   nfiss(2)=0
   if (iopt.eq.1) write(nsyso,&
     '(/'' materials to be processed ............ '')')
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   matl=0
   nmat=0
   if (nnina.gt.0) go to 100
   n2=0
   do i=1,newmat
      nina=ninat(i)
      if (nina.eq.2) n2=n2+1
   enddo
   if (n2.eq.newmat) go to 110
  100 continue
   nmat=nmat+1
   if (nmat.gt.newmat) go to 180
   icont=0
   mat1=0
   irepoz=0
   idnt(nmat)=0
   if (mat(nmat).lt.0) idnt(nmat)=100
   if (idnt(nmat).gt.0) mat(nmat)=-mat(nmat)
   if (iopt.eq.0) matd=mat(nmat)
   nina=ninat(nmat)
   if (nina.lt.2) go to 110
   idnt(nmat)=matd+idnt(nmat)
   go to 100
  110 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 110
   if (math.lt.0) go to 170
   icont=icont+1
   if (iopt.eq.0.and.icont.eq.1) mat1=math
   if (math.eq.matl) go to 160
   matl=math
   if (iopt.eq.0.and.irepoz.gt.0.and.math.eq.mat1) go to 170
   if (iopt.eq.0.and.math.ne.matd) go to 160
   if (iopt.eq.1) mat(nmat)=math
   if (iopt.eq.1) write(nsyso,'(8x,i5)') math
   iza=nint(c1h)
   idnt(nmat)=iza+idnt(nmat)
   awrt(nmat)=c2h
   if (iza.eq.iu235) iu=1
   if (iza.eq.ipu239) ipu=1
   if (nmat.le.1) then
      nz=l2h
      ntw=n2h
      call listio(ngendf,0,0,scr,nb,nw)
      i1=7+ntw+nz
      ngn=l1h
      if (ngn.eq.ngnd) then
         do i=1,ngnd1
            egb(i)=scr(ngnd1-i+i1)
         enddo
      else
         ! calculate group bounds for collapsed structure
         if (ngn.ne.ngnf)&
           call error('init','wrong group structure.',' ')
         ngn1=ngn+1
         lastg=0
         do i=1,ngn1
            ig=icgrp(i)
            if (ig.ne.lastg.and.ig.ne.0) then
               jg=ngnd-ig+1
               egb(1+jg)=scr(i1+i-1)
            endif
         enddo
      endif
   endif
   ! check for presence of mf3, mt18 and mf6, mt18.
   i318=0
   mess3=0
   i618=0
   mess6=0
  125 continue
   call tosend(ngendf,0,0,scr)
  130 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 150
   if (math.eq.-1) go to 170
   if (math.ne.matd) go to 145
   if (mfh.eq.0.or.mth.eq.0) go to 130
   if (mfh.eq.3.and.mth.ge.18.and.mth.le.38) go to 135
   if (mfh.eq.6.and.mth.ge.18.and.mth.le.38) go to 140
   go to 125
  135 continue
   if (mth.gt.21.and.mth.lt.38) go to 125
   if (mth.eq.18) i318=1
   if (mth.eq.18) go to 125
   if (i318.eq.0) go to 125
   if (mess3.gt.0) go to 125
   write(strng,&
     '(''mat='',i4,'' mf='',i2,'' has both mt18 and mt'',i2)')&
      math,mfh,mth
   call mess('pinit',strng,'mt18 used in all subroutines')
   mess3=1
   if (mess3.gt.0.and.mess6.gt.0) go to 150
   go to 125
  140 continue
   if (mth.gt.21.and.mth.lt.38) go to 125
   if (mth.eq.18) i618=1
   if (mth.eq.18) go to 125
   if (i618.eq.0) go to 125
   if (mess6.gt.0) go to 125
   write(strng,&
     '(''mat='',i4,'' mf='',i2,'' has both mt18 and mt'',i2)')&
     math,mfh,mth
   call mess('pinit',strng,'mt18 used in all subroutines')
   mess6=1
   if (mess3.gt.0.and.mess6.gt.0) go to 150
   go to 125
  145 continue
   call skiprz(ngendf,-3)
   math=matd
  150 continue
   if (nmat.eq.newmat) go to 180
   if (math.eq.0) go to 100
   call tomend(ngendf,0,0,scr)
   go to 100
  160 continue
   call tomend(ngendf,0,0,scr)
   go to 110
  170 continue
   if (irepoz.gt.0.or.iopt.gt.0) go to 175
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   irepoz=1
   matl=0
   go to 110
  175 continue
   if (iopt.eq.0) then
      write(strng,'(''mat='',i4,'' not found on gendf'')') matd
      call error('pinit',strng,' ')
   endif
   nmat=nmat-1
   write(strng,'(''only '',i2,'' mats found on gendf'')') nmat
   call mess('pinit',strng,' ')
   newmat=nmat
  180 continue
   if (ngn.eq.ngnd) write(nsyso,&
     &'(/'' group structure''/'' ---------------''/&
     &(1p,6e12.4))') (egb(i),i=1,ngnd1)
   if (ngn.ne.ngnd) write(nsyso,'(/&
     &'' group structure (collapsed from '',i3,&
     &'' group structure)''/&
     &'' ----------------------------------------------------''/&
     &(1p,6e12.4))')&
     ngn,(egb(i),i=1,ngnd1)
   ! find lethargy factors for resonance groups
   il=nfg+1
   ih=nfg+nrg
   do i=il,ih
      aleth=log(egb(i)/egb(i+1))
      rleth(i-nfg)=1/aleth
   enddo
   ! find lethargy factor for ngref
   jgref=ngnd1-ngref
   aleth=log(egb(jgref)/egb(1+jgref))
   reflth=aleth
   if (mode.lt.2) deallocate(egb)
   return
   end subroutine pinit

   subroutine sfile2
   !--------------------------------------------------------------------
   ! Process data for resonance calculation.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides openz,repoz,error
   ! internals
   integer::nghi,nglo,nw,nmat,matd,nina,isg,mf3mt2
   integer::i318,i618,i,nl,nz,ntw,l,ng2,ig,igc,kg,jg,isgz
   integer::loc,loca,locf,jgc,j,jnina,nb,nwloc,iloc
   integer::loctot,locnus,locsf0
   real(kr)::sgref,sigz
   integer::lz=6
   real(kr),dimension(:),allocatable::a
   real(kr),parameter::eps=1.e-5_kr
   real(kr),parameter::dilinf=1.e10_kr
   real(kr),parameter::small=1.e-9_kr
   real(kr),parameter::eflag=1.e35_kr
   real(kr),parameter::zero=0

   !--allocate storage.
   call openz(-nscr,1)
   if (nnina.eq.0) go to 340
   write(nsyso,'(//)')
   write(nsyso,&
     '(/'' ***subfile 2***resonance data'')')
   nwloc=nrg*3
   allocate(a(nwloc))
   iloc=1
   loctot=iloc
   locnus=loctot+nrg
   locsf0=locnus+nrg
   nghi=ngnd-nfg
   nglo=nghi-nrg+1

   !--search for desired materials.
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   nmat=0
   jnina=0
  100 continue
   nmat=nmat+1
   matd=mat(nmat)
   nina=ninat(nmat)
   if (nina.eq.3) go to 315
   if (nina.gt.0) go to 320
   jnina=jnina+1
   sgref=s0rf(nmat)
   isg=0
   if (abs(sgref-dilinf).ge.sgref/100) isg=1
   mf3mt2=0
   i318=0
   i618=0
   do i=1,nwloc
      a(i-1+iloc)=0
   enddo
   do i=1,ngnd
      cflux(i)=0
      cflux(i+ngnd)=0
   enddo
  110 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.matd) go to 130
   if (math.eq.0) go to 110
   if (math.gt.0) go to 115
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   go to 110
  115 continue
   call tomend(ngendf,0,0,scr)
   go to 110

   !--search for required reactions.
  120 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 300
  130 continue
   nl=l1h
   nz=l2h
   ntw=n2h
   if (mfh.eq.0.or.mth.eq.0) go to 120
   if (math.ne.matd) go to 300
   if (mfh.ne.3.or.mth.lt.2.or.mf3mt2.gt.0) go to 140
   mf3mt2=1
   do i=1,ngnd
      if (cflux(i).ne.zero) cflux(i)=1/cflux(i)
      if (cflux(ngnd+i).ne.zero) cflux(ngnd+i)=1/cflux(ngnd+i)
   enddo
  140 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   if (mfh.eq.1) go to 165
   ng2=l1h
   ig=n2h
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if ((l+nw-1).gt.nwscr)&
        call error('sfile2','storage exceeded.',' ')
   enddo
   if (ig.eq.0) go to 140
   igc=icgrp(ig)
   if (igc.eq.0.or.igc.gt.ngnd) go to 250
   if (igc.lt.nglo.or.igc.gt.nghi) go to 250
   kg=ngnd-igc+1
   jg=kg-nfg
   l=1
   if (mth.eq.455) go to 240
   if (mfh.eq.3) go to 200
   if (mfh.eq.6) go to 220
   go to 170
  165 continue
   isgz=0
   do i=1,nz
      sigz=scr(6+ntw+i)
      if (abs(sigz-sgref).le.eps*sigz) isgz=i
   enddo
   if (isgz.eq.0)&
     call error('sfile2','reference sigma zero not found.',' ')
  170 continue
   call tosend(ngendf,0,0,scr)
   go to 120

   !--file 3 cross sections.
  200 continue
   if (mth.eq.18) i318=1
   if (mth.gt.18.and.i318.eq.1) go to 170
   if (mth.ne.1.and.mth.ne.2.and.&
     (mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 170
   ! fission
   if ((mth.ge.18.and.mth.le.21).or.mth.eq.38) then
      loc=locsf0+jg-1
      loca=l+lz+nl*nz
      locf=l+lz
      a(loc)=a(loc)+scr(loca)*scr(locf)*cflux(jg)
   ! elastic
   else if (mth.eq.2) then
      loc=loctot+jg-1
      loca=l+lz+nl*nz
      if (isg.gt.0.and.nz.ge.isgz) loca=l+lz+nl*(isgz-1+nz)
      locf=l+lz
      if (isg.gt.0.and.nz.ge.isgz) locf=l+lz+nl*(isgz-1)
      jgc=jg
      if (isg.gt.0.and.nz.ge.isgz) jgc=jg+ngnd
      a(loc)=a(loc)+scr(loca)*scr(locf)*cflux(jgc)
   ! total
   else if (mth.eq.1) then
      ! coarse group flux
      ! for infinite dilution
      cflux(jg)=cflux(jg)+scr(l+lz)
      if (isg.ne.0.and.nz.ge.isgz) then
         ! for reference sigma zero
         cflux(jg+ngnd)=cflux(jg+ngnd)+scr(l+lz+nl*(isgz-1))
      endif
   endif
   go to 250

   !--file 6 matrices.
  220 continue
   if ((mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 170
   if (mth.eq.18) i618=1
   if (mth.gt.18.and.i618.eq.1) go to 170
   ! fission
   loc=locnus+jg-1
   locf=l+lz
   loca=l+lz-nl*nz
   do i=2,ng2
      a(loc)=scr(nl*nz*i+loca)*scr(locf)*cflux(jg)+a(loc)
   enddo
   go to 250
  240 continue
   if (mfh.eq.5) go to 170
   ! delayed neutrons
   loc=locnus+jg-1
   loca=l+lz
   locf=l+lz
   a(loc)=a(loc)+scr(loca+1)*scr(loca+2)*scr(locf)*cflux(jg)
  250 continue
   if (ig.lt.ngn) go to 140
   go to 120

   !--desired data is loaded.
   !--find nu from nu times sigma f.
  300 continue
   do ig=1,nrg
      loc=locsf0+ig-1
      loca=locnus+ig-1
      if (a(loc).ne.zero) then
         a(loca)=a(loca)/a(loc)
      endif
      if (a(loca).lt.small) a(loca)=0
   enddo
   go to 319

   !--read in nus and tot for nuclides having nina=3
  315 continue
   read(nsysi,*) (a(locnus+j-1),j=1,nrg)
   read(nsysi,*) (a(loctot+j-1),j=1,nrg)

  319 continue
   call sf2out(nmat,jnina,loctot,locnus,a)
  320 continue
   if (nmat.lt.newmat) go to 100

   !--sfile2 is finished.
   if (iprint.eq.1) write(nsyso,'(/)')
  340 continue
   write(nscr) eflag
   return
   end subroutine sfile2

   subroutine sf2out(nmat,jnina,loctot,locnus,a)
   !--------------------------------------------------------------------
   ! Write subfile 2.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! externals
   integer::nmat,jnina,loctot,locnus
   real(kr)::glam
   real(kr)::a(*)
   ! internals
   integer::ident,i,ig
   real(kr)::sigp

   ident=idnt(nmat)
   if (iprint.eq.1) write(nsyso,&
     '(/'' nuclide '',i6/'' -------'')') ident
   if (iprint.eq.1) write(nsyso,&
     '(/''  group'',7x,''lambda'',8x,''sigp'',10x,''nu'',9x,&
     &''sigsctot''/1x,6(''----------''),''-'')')
   sigp=sigpt(nmat)
   do i=1,nrg
      ig=i+nfg
      glam=glamt(jnina+nnina*(i-1))
      write(nscr) glam,sigp,a(locnus-1+i),a(loctot-1+i)
      if (iprint.eq.1)&
        write(nsyso,'(i5,5x,1p,4e13.4)')&
        ig,glam,sigp,a(locnus-1+i),a(loctot-1+i)
   enddo
   return
   end subroutine sf2out

   subroutine sfile3(jtemp,nt)
   !--------------------------------------------------------------------
   ! Process effective resonance integrals.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides repoz,error
   ! externals
   integer::jtemp,nt
   ! internals
   integer::nn,nghi,nglo,nb,nw,il,nmat,irmat,jnina,matd,nina
   integer::inorf,jres,ntnmat,msigz,i,nwflx,jfiss,nl,nz,ntw,nwfa
   integer::l,nsigz,index,i318,i618,ig,jg,iadd,nwflxr
   integer::loca,locb,jz,locf,ng2,iterm,jtem,it,lim
   integer::indexl,ix,igc,kg,loc,locabs,locnus,locsf,nwloc,iloc
   integer::locs(7)
   real(kr)::temp
   equivalence (locabs,locs(1)),(locnus,locs(2)),(locsf,locs(3))
   real(kr)::xid,amda,sigp
   real(kr)::b(70)
   real(kr),dimension(:),allocatable::tempt,sigz
   real(kr),dimension(:),allocatable::flxr
   real(kr),dimension(:),allocatable::abs
   real(kr),dimension(:),allocatable::snu
   real(kr),dimension(:),allocatable::fa
   real(kr),dimension(:),allocatable::a
   integer::lz=6
   real(kr),parameter::eflag=1.e35_kr
   real(kr),parameter::zero=0

   !--allocate storage.
   if (nres.eq.0) go to 510
   write(nsyso,'(//)')
   write(nsyso,&
     '(/'' ***subfile 3***resonance integrals'')')
   nw=nt+1
   allocate(tempt(nw))
   nwloc=nzmax*nt*nrg*3
   allocate(a(nwloc))
   iloc=1
   lim=nwloc-1
   nwflxr=nzmax*nt
   allocate(flxr(nwflxr))
   allocate(sigz(nzmax))
   allocate(snu(nrg))
   allocate(abs(nt))
   nwfa=0
   if ((nzmax*nt).gt.(nrg+1)) then
      nwfa=nzmax*nt
      allocate(fa(nwfa))
   endif
   locabs=iloc
   locnus=locabs+nzmax*nt*nrg
   locsf=locnus+nzmax*nt*nrg
   nn=nnina
   if (nn.eq.0) nn=nres
   nghi=ngnd-nfg
   nglo=nghi-nrg+1

   !--search for desired materials.
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   il=1
   nmat=0
   irmat=0
   jnina=0
  110 continue
   nmat=nmat+1
   matd=mat(nmat)
   nina=ninat(nmat)
   if (nina.eq.0) jnina=jnina+1
   indf(nmat)=0
   inorf=norft(nmat)
   jres=irest(nmat)
   if (jres.le.0) go to 470
   if (nnina.eq.0) jnina=jnina+1
   ntnmat=ntmp(nmat)
   msigz=nszt(nmat)
   irmat=irmat+1
   do i=1,nwflxr
      flxr(i)=0
   enddo
   nwflx=nzmax*nt*nrg
   do i=1,nwflx
      flux(i)=0
   enddo
   do i=1,nwloc
      a(i-1+iloc)=0
   enddo
   do i=1,nrg
      snu(i)=0
   enddo
   jtemp=0
   jfiss=1
  120 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.matd) go to 130
   if (math.eq.0) go to 120
   if (math.gt.0) go to 125
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   go to 120
  125 continue
   call tomend(ngendf,0,0,scr)
   go to 120

   !--search for required reactions.
  130 continue
   xid=idnt(nmat)
  135 continue
   nl=l1h
   nz=l2h
   ntw=n2h
  140 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   if (mfh.ne.1) go to 160
   temp=c1h
   jtemp=jtemp+1
   tempt(jtemp)=temp
   nsigz=nz
   if (nz.gt.msigz.and.msigz.ne.0) nsigz=msigz
   do i=1,nsigz
      index=1+nsigz-i
      sigz(index)=scr(6+ntw+i)
   enddo
   abs(jtemp)=0
   i318=0
   i618=0
   go to 300
  160 continue
   if (mth.ge.18.and.mth.le.21.and.inorf.gt.0) go to 300
   if (mth.eq.38.and.inorf.gt.0) go to 300
   if (mfh.eq.6.and.jtemp.eq.1) go to 162
   if (mfh.ne.3) go to 300
   if (mth.eq.1) go to 162
   if (mth.eq.455.and.jtemp.eq.1) go to 162
   if (mth.lt.18.or.mth.gt.150) go to 300
   if (mth.gt.21.and.mth.lt.102.and.mth.ne.38) go to 300
   if (mth.eq.18) i318=1
   if (mth.gt.18.and.mth.lt.39.and.i318.gt.0) go to 300
  162 continue
   ig=n2h
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if ((l+nw-1).gt.nwscr)&
        call error('sfile3','storage exceeded.',' ')
   enddo
   if (ig.eq.0) go to 140
   igc=icgrp(ig)
   if (mth.eq.1.and.igc.eq.ngref) go to 172
   if (igc.lt.nglo.or.igc.gt.nghi) go to 185
  172 continue
   kg=ngnd-igc+1
   jg=kg-nfg
   lim=nsigz
   if (nsigz.gt.nz) lim=nz
   if (mfh.eq.6) go to 230
   if (mth.eq.1) go to 190
   if (mth.eq.455) go to 225
   if (mth.eq.18) go to 175
   if (mth.lt.102.and.i318.gt.0) go to 215
   ! absorption
  175 continue
   iadd=nsigz+nzmax*((jtemp-1)+nt*(jg-1))
   loca=l+lz+nl*(nz-1)
   locb=l+lz-nl
   do jz=1,lim
      a(iadd-jz+locabs)=a(iadd-jz+locabs)&
        +scr(nl*jz+loca)*scr(nl*jz+locb)/flux(iadd-jz+1)
   enddo
   if (mth.lt.102) go to 215
   abs(jtemp)=1
  185 continue
   if (ig.lt.ngn) go to 140
   go to 310
   ! flux
  190 continue
   if (igc.ne.ngref) go to 195
   if (ngref.gt.nghi.or.ngref.lt.nglo) go to 205
  195 continue
   loc=1+nsigz+nzmax*((jtemp-1)+nt*(jg-1))
   loca=l+lz-nl
   do jz=1,lim
      flux(loc-jz)=scr(nl*jz+loca)+flux(loc-jz)
   enddo
   if (igc.eq.ngref) go to 205
   go to 185
   ! reference group flux
  205 continue
   do jz=1,lim
      loca=l+lz+nl*(jz-1)
      loc=1+nsigz-jz+nzmax*(jtemp-1)
      flxr(loc)=flxr(loc)+scr(loca)
   enddo
   go to 185
   ! nu sigma f
  215 continue
   iadd=nsigz+nzmax*((jtemp-1)+nt*(jg-1))
   loca=l+lz+nl*(nz-1)
   locb=l+lz-nl
   do jz=1,lim
      a(iadd-jz+locsf)=a(iadd-jz+locsf)&
        +scr(nl*jz+loca)*scr(nl*jz+locb)/flux(iadd-jz+1)
   enddo
   jfiss=2
   go to 185
   ! delayed neutrons
  225 continue
   loca=l+lz
   locf=1+nsigz-1+nzmax*nt*(jg-1)
   snu(jg)=snu(jg)+scr(loca+1)*scr(loca+2)*scr(loca)/flux(locf)
   go to 185
   ! save nu from file 6
  230 continue
   if ((mth.lt.18.or.mth.gt.22).and.mth.ne.38) go to 300
   if (mth.eq.18) i618=1
   if (mth.eq.18) go to 235
   if (i618.eq.0) go to 235
   go to 300
  235 continue
   ng2=l1h
   loca=l+lz+(il-1)-nl*nz
   locf=1+nsigz-1+nzmax*nt*(jg-1)
   do i=2,ng2
      snu(jg)=snu(jg)+scr(nl*nz*i+loca)*scr(l+lz)/flux(locf)
   enddo
   go to 185
  300 continue
   call tosend(ngendf,0,0,scr)
  310 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.lt.0) go to 350
   if (math.eq.0.or.mfh.eq.0.or.mth.eq.0) go to 310
   if (math.ne.matd) go to 350
   if (mfh.eq.1) go to 360
   if (mfh.ne.3.and.mfh.ne.6) go to 300
   go to 135
  350 continue
   if (jtemp.gt.1.or.jfiss.eq.1) go to 400
   go to 370
  360 continue
   if (jtemp.gt.1.or.jfiss.eq.1) go to 130

   !--correct nu
  370 continue
   do jg=1,nrg
      iterm=nsigz-1+nzmax*nt*(jg-1)
      loca=locsf+iterm
      if (a(loca).eq.zero) snu(jg)=0
      if (a(loca).ne.zero) snu(jg)=snu(jg)/a(loca)
   enddo
   if (math.ne.matd) go to 400
   if (ntnmat.eq.0) go to 130
   if (jtemp.eq.ntnmat) go to 400
   go to 130

   !--desired data is loaded.
  400 continue
   if (jfiss.ne.1) then
      ! calculate nu times sigma f
      do jg=1,nrg
         do jz=1,nsigz
            iterm=jz-1+nzmax*nt*(jg-1)-nzmax
            do jtem=1,jtemp
               a(nzmax*jtem+iterm+locnus)=&
                 a(nzmax*jtem+iterm+locsf)*snu(jg)
            enddo
         enddo
      enddo
   endif
   ! check flux arrays for temperature dependence.
   do jz=1,nsigz
      do it=1,jtemp
         if (flxr(jz+nzmax*(it-1)).eq.0.) then
            flxr(jz+nzmax*(it-1))=flxr(jz+nzmax*(it-2))
         endif
      enddo
   enddo
   do jg=1,nrg
      do jz=1,nsigz
         do it=1,jtemp
            index=jz+nzmax*((it-1)+nt*(jg-1))
            if (flux(index).eq.zero) then
               indexl=jz+nzmax*((it-2)+nt*(jg-1))
               flux(index)=flux(indexl)
            endif
         enddo
      enddo
   enddo
   ! correct non-temperature dependent absorption if necessary
   if (jtemp.ne.1) then
      do it=2,jtemp
         if (abs(it).le.zero) then
            do jg=1,nrg
               loc=locabs+nzmax*((it-2)+nt*(jg-1))
               loca=loc+nzmax
               do jz=1,nsigz
                  a(jz+loca)=a(jz+loca)+a(jz+loc)
               enddo
            enddo
         endif
      enddo
   endif
   if ((nnina.gt.0.and.nina.gt.0).or.&
     (nnina.eq.0.and.jres.eq.0)) then
      ! convert njoy cross sections to cpm resonance integrals
      do jg=1,nrg
         amda=glamt(jnina+nnina*(jg-1))
         sigp=sigpt(nmat)
         do ix=1,2
            do it=1,jtemp
               loc=locs(ix)+nzmax*(it-1+nt*(jg-1))
               call cpmize(nsigz,sigz,a(loc),amda,sigp)
            enddo
         enddo
      enddo
      ! write out results
      if (nwfa.eq.0) call sf3out(xid,nmat,jtemp,nsigz,nt,jfiss,&
        tempt,sigz,flxr,locs,b,a)
      if (nwfa.gt.0) call sf3out(xid,nmat,jtemp,nsigz,nt,jfiss,&
        tempt,sigz,flxr,locs,fa,a)
      indf(nmat)=jfiss
   endif
  470 continue
   if (nmat.eq.newmat) go to 500
   if (irmat.eq.0) go to 110
   if (math.ne.matd) call skiprz(ngendf,-1)
   go to 110

   !--sfile3 is finished.
  500 continue
  510 continue
   deallocate(nszt)
   deallocate(norft)
   deallocate(sigpt)
   deallocate(glamt)
   write(nscr) eflag
   return
   end subroutine sfile3

   subroutine cpmize(nsigz,sigz,sign,amda,sigp)
   !--------------------------------------------------------------------
   ! Convert NJOY shielded cross sections to CPM resonance integrals
   ! using CPM values for intermediate-resonance lambda.
   !--------------------------------------------------------------------
   ! externals
   integer::nsigz
   real(kr)::sigz(*),sign(*),amda,sigp
   ! internals
   integer::iz,jl,jh,jz,kz
   real(kr)::sm,test,sn,temp,st
   real(kr)::sig(10)
   real(kr),parameter::zero=0

   do iz=1,nsigz
      sig(iz)=sign(iz)
   enddo
   do iz=1,nsigz
      sm=sigz(iz)
      test=1001
      if (sm.le.test) then
         sign(iz)=0
         sn=sm-amda*sigp
         if (sn.lt.zero) sn=0
         jl=iz-1
         if (jl.lt.1) jl=1
         jh=iz+1
         if (jh.gt.nsigz) jh=nsigz
         do jz=jl,jh
            temp=1
            sm=sigz(jz)
            do kz=jl,jh
               st=sigz(kz)
               if (kz.ne.jz) then
                  if (sn.ge.sigz(1)) then
                     temp=temp*log(sn/st)/log(sm/st)
                  else
                     temp=temp*(sn**2-st**2)/(sm**2-st**2)
                  endif
               endif
            enddo
            sign(iz)=sign(iz)+temp*sig(jz)
         enddo
      endif
   enddo
   do iz=1,nsigz
      sm=sigz(iz)
      sign(iz)=sm*sign(iz)/(sm+sign(iz))
   enddo
   return
   end subroutine cpmize

   subroutine sf3out(xid,nmat,ntemp,nsigz,nt,ifiss,temp,sigz,flxr,&
     locs,b,a)
   !--------------------------------------------------------------------
   ! Write subfile 3.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! externals
   integer::nmat,ntemp,nsigz,nt,ifiss,locs(*)
   real(kr)::xid,temp(*),sigz(*),flxr(*),b(*),a(*)
   ! internals
   integer::ncol1,lim,ident,n,i,jgref,m,ig,it,locf,locr,jz,jg
   integer::il,loc,nb,loca,ib
   real(kr)::c(10)
   character(4)::undl4='----'
   character(4)::undl1='-'
   integer::nmax=5
   integer::ncol=8

   ncol1=ncol+1
   lim=nsigz
   if (nsigz.gt.ncol) lim=ncol
   ident=idnt(nmat)
   n=nsigz
   if (n.gt.nmax) n=nmax
   write(nscr) xid
   write(nscr) ntemp,nsigz
   write(nscr) (temp(i),i=1,ntemp)
   write(nscr) (sigz(i),i=1,nsigz)
   write(nsyso,'(/'' xid '',f8.2/'' ---'')') xid
   write(nsyso,'(/&
     &'' ntemp '',i2,''  nsigp '',i2/&
     &'' ----- '',2x,''  -----''//&
     &'' temperatures (down)''/&
     &'' -------------------'')')&
     ntemp,nsigz
   write(nsyso,'(1x,1p,6e11.3)') (temp(i),i=1,ntemp)
   write(nsyso,'(/&
     &'' potential cross sections (across)''/&
     &'' ---------------------------------'')')
   write(nsyso,'(10x,1p,9e13.5)') (sigz(i),i=1,nsigz)
   jgref=ngnd-ngref+1
   m=n
   if (m.lt.4) m=4
   write(nsyso,'(/'' group'',6x,&
     &''flux per unit lethargy normalized at group '',i2,&
     &'' for nuclide '',i6/&
     &'' ----------'',6(3a4,a1))')&
        jgref,ident,(undl4,undl4,undl4,undl1,i=1,m)
   do ig=1,nrg
      do it=1,ntemp
         locf=nzmax*((it-1)+nt*(ig-1))
         locr=nzmax*(it-1)
         do jz=1,nsigz
            c(jz)=flux(jz+locf)*rleth(ig)*reflth/flxr(jz+locr)
         enddo
         jg=ig+nfg
         if (it.eq.1) write(nsyso,'(i5,5x,1p,9e13.5)')&
           jg,(c(i),i=1,lim)
         if (it.eq.1.and.nsigz.gt.ncol)&
           write(nsyso,'(10x,1p,9e13.5)') (c(i),i=ncol1,nsigz)
         if (it.gt.1) write(nsyso,'(10x,1p,9e13.5)')&
           (c(i),i=1,nsigz)
      enddo
   enddo
   do il=1,2
      loc=locs(il)
      if (iprint.eq.1.and.il.eq.1)&
        write(nsyso,&
        '(/'' group'',6x,''absorption for nuclide '',i6/&
        &'' ----------'',5(3a4,a1))')&
        ident,(undl4,undl4,undl4,undl1,i=1,n)
      if (il.ne.2.or.ifiss.ge.2) then
         if (iprint.eq.1.and.il.eq.2)&
           write(nsyso,&
           '(/'' group'',6x,''fission for nuclide '',i6/&
           &'' ----------'',5(3a4,a1))')&
           ident,(undl4,undl4,undl4,undl1,i=1,n)
         do ig=1,nrg
            nb=0
            jg=ig+nfg
            do it=1,ntemp
               loca=loc-1+nzmax*((it-1)+nt*(ig-1))
               do jz=1,nsigz
                  nb=nb+1
                  b(nb)=a(jz+loca)
                  c(jz)=b(nb)
               enddo
               if (iprint.ne.0) then
                  if (il.ne.2.or.ifiss.ne.1) then
                     if (it.eq.1) write(nsyso,'(/i5,5x,1p,9e13.5)')&
                        jg,(c(i),i=1,lim)
                     if (it.eq.1.and.nsigz.gt.ncol)&
                       write(nsyso,'(10x,1p,9e13.5)')&
                         (c(i),i=ncol1,nsigz)
                     if (it.gt.1) write(nsyso,'(10x,1p,9e13.5)')&
                       (c(i),i=1,lim)
                     if (it.gt.1.and.nsigz.gt.ncol)&
                       write(nsyso,'(10x,1p,9e13.5)')&
                       (c(i),i=ncol1,nsigz)
                  endif
               endif
            enddo
            write(nscr) (b(ib),ib=1,nb)
         enddo
      endif
   enddo
   return
   end subroutine sf3out

   subroutine sfile4(jtemp,nt)
   !--------------------------------------------------------------------
   ! Process cross sections.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides openz,error,skiprz,mess
   ! externals
   integer::jtemp,nt
   ! internals
   integer::il,lim,ngnd5,nb,nw,nmat,matd,ident,ip1opt,mti,mtc
   integer::ntemp,isg,mtabs1,mtabs2,i318,i618,mttot,mtel,mtex
   integer::i,isof,nina,mf3mt2,jfiss,nth1,nth,if6,nz,ia,ib
   integer::lone,ltwo,loc,k,ja,nl,ntw,l,idone,iz,jic,ng2,ig2lo
   integer::ig,igc,jg,loca,locf,jgc,jg2,jg2c,j,ig2,ig2c
   integer::max,min,index,lt,mult,nskip,in,ngndsq,nwloc,iloc
   integer::locab0,locsf0,locchi,locnus,locsg,locxtr,locxs
   real(kr)::sgref,cnorm,dnorm,temp
   character(60)::strng
   real(kr),dimension(:),allocatable::abs1,abs2,sn2n
   real(kr),dimension(:),allocatable::tot,xtr
   real(kr),dimension(:),allocatable::cspc
   integer,dimension(:),allocatable::l1,l2
   integer,dimension(:),allocatable::l1e,l2e
   real(kr),dimension(:),allocatable::snu
   real(kr),dimension(:),allocatable::a
   real(kr),parameter::dilinf=1.e10_kr
   real(kr),parameter::eflag=1.e35_kr
   integer::lz=6
   real(kr),parameter::zero=0

   !--allocate storage.
   if (if4.eq.0) go to 620
   call openz(-mscr,1)
   call repoz(-mscr)
   call openz(-kscr,1)
   call repoz(-kscr)
   if (nres.eq.0) write(nsyso,'(/)')
   if (nres.gt.0) write(nsyso,'(//)')
   write(nsyso,&
     '(/'' ***subfile 4***cross sections'')')
   allocate(fiss(newmat))
   if (iu.eq.1) allocate(uff(nfsg))
   if (ipu.eq.1) allocate(puff(nfsg))
   allocate(snu(ngnd))
   allocate(l1(ngnd))
   allocate(l2(ngnd))
   allocate(l1e(ngnd))
   allocate(l2e(ngnd))
   ngndsq=ngnd*ngnd
   allocate(elas(ngndsq))
   allocate(cspc(ngn))
   allocate(abs1(ngnd))
   allocate(abs2(ngnd))
   allocate(sn2n(ngnd))
   allocate(tot(ngnd))
   allocate(xtr(ngnd))
   nw=nt+1
   if (nres.eq.0) allocate(tempt(nw))
   nwloc=ngnd*6+ngndsq
   allocate(a(nwloc))
   iloc=1
   locab0=iloc
   locsf0=locab0+ngnd
   locchi=locsf0+ngnd
   locnus=locchi+ngnd
   locsg=locnus+ngnd
   locxtr=locsg+ngnd
   locxs=locxtr+ngnd
   nfiss(1)=0
   nfiss(2)=0
   il=1
   lim=locxs+ngndsq-1
   ngnd5=ngnd*5

   !--search for desired materials.
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   nmat=0
  120 continue
   nmat=nmat+1
   matd=mat(nmat)
   ident=idnt(nmat)
   ip1opt=ip1tab(nmat)
   mti=mtit(nmat)
   mtc=mtct(nmat)
   ntemp=ntmp(nmat)
   sgref=s0rf(nmat)
   isg=0
   if (abs(sgref-dilinf).ge.sgref/100) isg=1
   mtabs1=0
   mtabs2=0
   i318=0
   i618=0
   mttot=0
   mtel=0
   mtex=0
   do i=1,ngnd
      abs2(i)=0
      sn2n(i)=0
      a(i-1+locxtr)=0
      l1e(i)=ngnd
      l2e(i)=1
      l1(i)=ngnd
      l2(i)=1
   enddo
   isof=0
   if (ident.eq.iu235) isof=1
   if (ident.eq.ipu239) isof=2
   nina=ninat(nmat)
   mf3mt2=0
   cnorm=0
   dnorm=0
   jfiss=0
   jtemp=-1
   nth1=0
   nth=0
   if6=0
   do i=1,nwloc
      a(i-1+iloc)=0
   enddo
   if (nina.lt.2) go to 140
   ! read in absorption
   nz=ngnd+2
   read(nsysi,*) (scr(i),i=1,nz)
   awrt(nmat)=scr(1)
   tempt(1)=scr(2)
   do i=3,nz
      a(i-3+locab0)=scr(i)
   enddo
   if (nina.ge.3) then
      read(nsysi,*) (a(locsf0+i-1),i=1,ngnd)
      read(nsysi,*) (a(locnus+i-1),i=1,ngnd)
      read(nsysi,*) (a(locxtr+i-1),i=1,ngnd)
      do ia=1,ngnd
         nz=3
         read(nsysi,*) (scr(i),i=1,nz)
         ib=nint(scr(1))
         if (ib.ne.0) then
            l1(ia)=nint(scr(2))
            l2(ia)=nint(scr(3))
            lone=nint(scr(2))
            ltwo=nint(scr(3))
            nz=ltwo-lone+1
            read(nsysi,*) (scr(i),i=1,nz)
            loc=locxs+ib-1-ngnd
            k=0
            do ja=lone,ltwo
               k=k+1
               a(ngnd*ja+loc)=scr(k)
            enddo
         else
            l1(ia)=ngnd
            l2(ia)=1
         endif
      enddo
      jtemp=1
   else
      jtemp=-1
      matd=-1
   endif
   go to 500
  140 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.matd) go to 150
   if (math.eq.0) go to 140
   if (math.gt.0) go to 145
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   go to 140
  145 continue
   call tomend(ngendf,0,0,scr)
   go to 140

   !--search for required reactions.
  150 continue
   nl=l1h
   nz=l2h
   ntw=n2h
   if (mfh.eq.3.and.mth.ge.2.and.mf3mt2.le.0) then
      ! invert flux arrays
      mf3mt2=1
      do i=1,ngnd
         if (cflux(i).ne.zero) cflux(i)=1/cflux(i)
         if (cflux(ngnd+i).ne.zero) cflux(ngnd+i)=1/cflux(ngnd+i)
         loc=i
         if (flux(loc).ne.zero) flux(loc)=1/flux(loc)
         loc=loc+ngnd
         if (flux(loc).ne.zero) flux(loc)=1/flux(loc)
      enddo
   endif
  160 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   if (mfh.ne.1) go to 170
   temp=c1h
   ngn=l1h
   if (ngn.ne.ngnd.and.ngn.ne.ngnf)&
     call error('sfile4','storage exceeded.',' ')
   idone=0
   i=0
   do while (i.lt.nz.and.idone.eq.0)
      i=i+1
      iz=i
      if (abs(sgref-scr(l+5+ntw+i)).lt.sgref/100) idone=1
   enddo
   jtemp=jtemp+1
   jic=0
   if (jtemp.eq.0) go to 195
   if (ntemp.gt.0.and.jtemp.gt.ntemp) go to 320
   tempt(jtemp)=temp
   go to 195
  170 continue
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   igc=1
   if (ig.ne.0) igc=icgrp(ig)
   ! check for presence of sometimes temperature-dependent data
   if (jtemp.eq.0) go to 185
   if (mth.lt.102.or.mth.gt.150) go to 174
   if (mth.ne.102) go to 172
   if (mtabs1.gt.0) go to 185
   mtabs1=1
   do i=1,ngnd
      abs1(i)=0
   enddo
   go to 174
  172 continue
   if (mtabs2.gt.0) go to 185
   mtabs2=1
   do i=1,ngnd
   abs2(i)=0
   enddo
  174 continue
   if (mth.ne.2) go to 179
   if (mfh.ne.6) go to 185
   if (mtel.gt.0) go to 177
   mtel=1
   do i=1,ngnd
      l1e(i)=ngnd
      l2e(i)=1
   enddo
   do i=1,ngndsq
      elas(i)=0
   enddo
  177 continue
   if (mtex.gt.0) go to 185
   mtex=1
   do i=1,ngnd
      xtr(i)=0
   enddo
  179 continue
   if (mth.ne.1) go to 185
   if (mttot.gt.0) go to 185
   mttot=1
   do i=1,ngnd
      tot(i)=0
   enddo
  185 continue
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if ((l+nw-1).gt.nwscr)&
        call error('sfile4','storage exceeded.',' ')
   enddo
   if (igc.eq.0.or.igc.gt.ngnd) go to 218
   jg=ngnd-igc+1
   l=1
   if (mth.eq.455.and.jtemp.gt.0) go to 240
   if (mfh.eq.3) go to 205
   if (mfh.eq.6) go to 255
  195 continue
   call tosend(ngendf,0,0,scr(l))
  200 continue
   call contio(ngendf,0,0,scr(l),nb,nw)
   if (math.eq.0) go to 330
   if (math.eq.-1) go to 350
   if (math.ne.matd) go to 350
   if (mfh.eq.0.or.mth.eq.0) go to 200
   go to 150

   !--file 3 cross sections.
  205 continue
   if (jtemp.eq.0) go to 220
   if (mth.lt.102.or.mth.gt.150) go to 214
   ! absorption
   loca=l+lz+nl*nz
   if (isg.gt.0.and.nz.ge.iz) loca=l+lz+nl*(iz-1+nz)
   locf=l+lz
   if (isg.gt.0.and.nz.ge.iz) locf=l+lz+nl*(iz-1)
   jgc=jg
   if (isg.gt.0.and.nz.ge.iz) jgc=jg+ngnd
   if (mth.ne.102) then
      abs2(jg)=abs2(jg)+scr(loca)*scr(locf)*cflux(jgc)
   else
      abs1(jg)=abs1(jg)+scr(loca)*scr(locf)*cflux(jgc)
   endif
   if (ig.lt.ngn) go to 160
   if (nina.gt.0) call tomend(ngendf,0,0,scr)
   if (nina.gt.0) go to 400
   go to 200
  214 continue
   if (mth.eq.1) go to 220
   if (nina.gt.0) go to 195
   if (mth.eq.16) go to 220
   if ((mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 220
   if (mth.eq.18) i318=1
   if (mth.eq.18) go to 216
   if (i318.eq.0) go to 216
   go to 195
   ! fission
  216 continue
   loc=locsf0+jg-1
   loca=l+lz+nl*nz
   locf=l+lz
   a(loc)=a(loc)+scr(loca)*scr(locf)*cflux(jg)
   loc=locab0+jg-1
   if (isg.gt.0.and.nz.ge.iz) locf=l+lz+nl*(iz-1)
   jgc=jg
   if (isg.gt.0.and.nz.ge.iz) jgc=jg+ngnd
   a(loc)=a(loc)+scr(loca)*scr(locf)*cflux(jgc)
  218 continue
   if (ig.lt.ngn) go to 160
   go to 200
  220 continue
   if (mth.ne.1.and.jtemp.gt.0) go to 195
   if (mth.ne.1.and.jtemp.eq.0) go to 236
   if (ig.eq.1) then
      do i=1,ngnd
         cflux(i)=0
         cflux(i+ngnd)=0
         flux(i)=0
         flux(i+ngnd)=0
      enddo
      mf3mt2=0
   endif
   ! p1 flux
   ! for infinite dilution
   loc=jg
   loca=l+lz
   if (nl.gt.1) loca=loca+1
   flux(loc)=flux(loc)+scr(loca)
   if (isg.ne.0.and.nz.ge.iz) then
      ! for reference sigma zero
      loc=jg+ngnd
      loca=l+lz+nl*(iz-1)
      if (nl.gt.1) loca=loca+1
      flux(loc)=flux(loc)+scr(loca)
   endif
   ! p0 flux
   ! for infinite dilution
   loca=l+lz
   cflux(jg)=cflux(jg)+scr(loca)
   ! for reference sigma zero
   if (isg.eq.0.or.nz.lt.iz) go to 250
   cflux(jg+ngnd)=cflux(jg+ngnd)+scr(l+lz+nl*(iz-1))
   go to 250
   ! n2n
  236 continue
   if (jtemp.gt.0) go to 195
   if (mth.ne.16) go to 238
   loca=l+lz+nl*nz
   locf=l+lz
   sn2n(jg)=sn2n(jg)+scr(loca)*scr(locf)*cflux(jg)
   go to 250
  238 continue
   if (mth.ne.mti) go to 195
   if (igc.gt.nth1.and.scr(l+lz+nz*nl).ne.0.) nth1=igc
   nth=ngnd-nth1+1
   go to 250
  240 continue
   if (mth.ne.455) go to 195
   if (isof.eq.0) go to 195
   jfiss=1
   if (mfh.eq.5) go to 244
   ! delayed neutrons
   loc=locnus+jg-1
   loca=l+lz
   locf=l+lz
   a(loc)=a(loc)+scr(loca+1)*scr(loca+2)*scr(locf)*cflux(jg)
   dnorm=dnorm+scr(loca)*scr(loca+1)*scr(loca+2)
   if (ig.lt.ngn) go to 160
   go to 200
  244 continue
   if (isof.eq.0) go to 195
   do i=2,ng2
      jg2=ngn-ig2lo-i+3
      jg2c=icgrp(jg2)
      if (jg2c.ne.0.and.jg2c.le.ngnd) then
         loc=locchi+jg2c-1
         loca=l+lz-1+nl*(i-1)
         do j=1,nl
            a(loc)=scr(j+loca)*dnorm+a(loc)
            cnorm=scr(j+loca)*dnorm+cnorm
         enddo
      endif
   enddo
  250 continue
   if (ig.lt.ngn) go to 160
   go to 200

   !--file 6 matrices.
  255 continue
   if (jtemp.eq.0) go to 300
   if ((mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 270
   if (mth.eq.18) i618=1
   if (mth.eq.18) go to 260
   if (i618.eq.0) go to 260
   go to 195
   ! fission
  260 continue
   jfiss=1
   if (ig.ne.0) then
      locf=l+lz
      do i=2,ng2
         loca=l+lz+(il-1)+nl*nz*(i-1)
         loc=locnus+jg-1
         a(loc)=a(loc)+scr(loca)*scr(locf)*cflux(jg)
         if (isof.ne.0) then
            if (ig2lo.ne.0) then
               ! matrix part
               ig2=ig2lo+i-2
               ig2c=icgrp(ig2)
               if (ig2c.ne.0.and.ig2c.le.ngnd) then
                  jg2c=ngnd-ig2c+1
                  loc=locchi+jg2c-1
                  a(loc)=a(loc)+scr(loca)*scr(locf)
                  cnorm=cnorm+scr(loca)*scr(locf)
               endif
            else
               ! spectrum part
               do j=1,ngn
                  ig2=ig2lo+j-1
                  ig2c=icgrp(ig2)
                  if (ig2c.ne.0.and.ig2c.le.ngnd) then
                     jg2c=ngnd-ig2c+1
                     loc=locchi+jg2c+1
                     a(loc)=a(loc)+scr(loca)*scr(locf)*cspc(j)
                     cnorm=cnorm+scr(loca)*scr(locf)*cspc(j)
                  endif
               enddo
            endif
      endif
      enddo
   else
      ! save constant spectrum
      do i=1,ng2
         cspc(ig2lo+i-1)=scr(l+lz+i-1)
      enddo
   endif
   go to 295
   ! add temperature-dependent reactions to matrix.
  270 continue
   if (mth.ne.2.and.mth.ne.mti.and.mth.ne.mtc) go to 295
   if (mth.ne.2) jic=1
   max=0
   min=ngnd
   locf=l+lz
   if (isg.gt.0.and.nz.ge.iz) locf=l+lz+nl*(iz-1)
   jgc=jg
   if (isg.gt.0.and.nz.ge.iz) jgc=jg+ngnd
   if (mth.eq.2.and.jg.ge.nth) go to 295
   do i=2,ng2
      ig2=ig2lo+i-2
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         loca=l+lz+(il-1)+nl*nz*(i-1)
         if (isg.gt.0.and.nz.ge.iz) loca=loca+nl*(iz-1)
         if (scr(loca).ne.zero) then
            if (mth.ne.2) then
               loc=locxs+jg-1+ngnd*(jg2c-1)
               if ((jg2c-jg).ge.-1.or.scr(loca).ge.zero) then
                  a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
                  loc=locxtr+jg-1
                  a(loc)=a(loc)+scr(loca)*scr(l+lz)*cflux(jg)
                  if (jg2c.gt.max) max=jg2c
                  if (jg2c.lt.min) min=jg2c
               endif
               if (nl.ne.1) then
                  if (jg2c.ge.nth) then
                     if (igc.le.nth1) then
                        index=jg2c
                        loc=locxtr+jg2c-1
                        a(loc)=a(loc)&
                          -scr(loca+1)*scr(l+lz+1)*flux(index)
                        if (ip1opt.ne.0) then
                           loc=locxs+jg2c-1+ngnd*(jg2c-1)
                           a(loc)=a(loc)&
                             -scr(loca+1)*scr(l+lz+1)*flux(index)
                        endif
                     endif
                  endif
               endif
            else
               loc=jg+ngnd*(jg2c-1)
               elas(loc)=elas(loc)+scr(loca)*scr(locf)*cflux(jgc)
               if (jg2c.gt.max) max=jg2c
               if (jg2c.lt.min) min=jg2c
               xtr(jg)=xtr(jg)+scr(loca)*scr(locf)*cflux(jgc)
               if (nl.ne.1) then
                  index=jg2c
                  if (isg.gt.0.and.nz.ge.iz) index=index+ngnd
                  xtr(jg2c)=xtr(jg2c)&
                    -scr(loca+1)*scr(locf+1)*flux(index)
                  if (ip1opt.ne.0) then
                     loc=jg2c+ngnd*(jg2c-1)
                     elas(loc)=elas(loc)&
                       -scr(loca+1)*scr(locf+1)*flux(index)
                  endif
               endif
            endif
         endif
      endif
   enddo
   lt=l1(jg)
   if (min.lt.lt.and.mth.ne.2) l1(jg)=min
   lt=l1e(jg)
   if (min.lt.lt.and.mth.eq.2) l1e(jg)=min
   lt=l2(jg)
   if (max.gt.lt.and.mth.ne.2) l2(jg)=max
   lt=l2e(jg)
   if (max.gt.lt.and.mth.eq.2) l2e(jg)=max
  295 continue
   if (ig.lt.ngn) go to 160
   go to 200

   !--store non-temperature dependent matrix .
  300 continue
   if (jtemp.gt.0) go to 205
   if (mfh.ne.6) go to 195
   if (if6.le.0) then
      if (nth1.eq.0) nth1=ngnd-nfg-nrg
      nth=ngnd-nth1+1
      if6=1
   endif
   if (mth.ge.18.and.mth.le.21) go to 195
   if (mth.eq.38) go to 195
   if (mth.eq.2) go to 195
   if (mth.ge.201.and.mth.le.255) go to 195
   mult=1
   if (mth.eq.16) mult=2
   locf=l+lz
   max=0
   min=ngnd
   do i=2,ng2
      ig2=ig2lo+i-2
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         loca=l+lz+(il-1)+nl*nz*(i-1)
         loc=locxs+jg-1+ngnd*(jg2c-1)
         a(loc)=a(loc)+scr(loca)*scr(locf)*cflux(jg)
         loc=locxtr+jg-1
         a(loc)=a(loc)+(scr(loca)*mult)*scr(locf)*cflux(jg)
         if (jg2c.gt.max) max=jg2c
         if (jg2c.lt.min) min=jg2c
         if (nl.ne.1) then
            loc=locxtr+jg2c-1
            index=jg2c
            a(loc)=a(loc)-scr(loca+1)*scr(locf+1)*flux(index)
            if (ip1opt.ne.0) then
               loc=locxs+jg2c-1+ngnd*(jg2c-1)
               a(loc)=a(loc)-scr(loca+1)*scr(locf+1)*flux(index)
            endif
         endif
      endif
   enddo
   lt=l1(jg)
   if (min.lt.lt) l1(jg)=min
   lt=l2(jg)
   if (max.gt.lt) l2(jg)=max
   if (ig.lt.ngn) go to 160
   go to 200

   !--write non-temperature dependent matrix on scratch tape.
  320 continue
   jtemp=jtemp-1
  330 continue
   if (jtemp.gt.0) go to 360
   call repoz(-kscr)
   write(kscr) (l1(i),i=1,ngnd)
   write(kscr) (l2(i),i=1,ngnd)
   write(kscr) (a(locxtr+i-1),i=1,ngnd)
   write(kscr) (a(i),i=locxs,lim)
   nskip=-3
   call skiprz(ngendf,nskip)
   call findf(matd,1,451,ngendf)
   if (nth1.gt.0.and.nth.gt.0) go to 140
   if (nth1.eq.0) nth1=ngnd-nfg-nrg
   nth=ngnd-nth1+1
   go to 140

   !--desired data is loaded.
  350 continue
   matd=-1
   if (math.ne.0) call skiprz(ngendf,-3)
   go to 500
  360 continue
   if (jic.gt.0) go to 365
   jtemp=jtemp-1
   write(strng,'(''use only '',i2,'' temperatures for mat '',i4)')&
     jtemp,matd
   call mess('sfile4',strng,'mti missing from higher temperatures')
   go to 350
  365 continue
   if (jtemp.eq.1) then
      ! calculate nu at lowest temperature
      do i=1,ngnd
         if (a(locsf0+i-1).eq.zero) snu(i)=0
         if (a(locsf0+i-1).ne.zero) snu(i)&
           =a(locnus+i-1)/a(locsf0+i-1)
      enddo
   else
      ! calculate nu*sigma f at higher temperatures
      do i=1,ngnd
         a(i-1+locnus)=snu(i)*a(i-1+locsf0)
      enddo
   endif
   ! calculate total absorption
  400 continue
   do i=1,ngnd
      a(i-1+locab0)=a(i-1+locab0)+abs1(i)+abs2(i)-sn2n(i)
   enddo
   ! correct scattering matrix
   in=nth-1
   do i=1,in
      if (l1e(i).lt.l1(i)) l1(i)=l1e(i)
      if (l2e(i).gt.l2(i)) l2(i)=l2e(i)
   enddo
   do i=1,ngndsq
      a(i-1+locxs)=a(i-1+locxs)+elas(i)
   enddo
   ! correct transport
   do i=1,ngnd
      a(i-1+locxtr)=a(i-1+locxtr)+xtr(i)
   enddo
  500 continue
   call sf4out(matd,nmat,ntemp,jfiss,nina,&
     locab0,locsf0,locnus,locxtr,locxs,l1,l2,a)
   if (nina.ne.3) go to 505
   matd=-1
   nina=0
   go to 500
  505 continue
   if (matd.lt.0) go to 540
   mtabs1=0
   mtabs2=0
   mttot=0
   mtel=0
   mtex=0
   i318=0
   i618=0
   call repoz(-kscr)
   read(kscr) (l1(i),i=1,ngnd)
   read(kscr) (l2(i),i=1,ngnd)
   read(kscr) (a(locxtr+i-1),i=1,ngnd)
   read(kscr) (a(i),i=locxs,lim)
   fiss(nmat)=jfiss
   if (isof.ne.0.and.jtemp.le.1) then
      ! normalize chi
      if (cnorm.ne.zero) cnorm=1/cnorm
      do i=1,nfsg
         loc=locchi+i-1
         if (cnorm.ne.zero) a(loc)=a(loc)*cnorm
         if (nfiss(isof).ne.0.and.a(loc).ne.zero)&
           nfiss(isof)=nfiss(isof)+1
         if (nfiss(isof).eq.0.and.a(loc).ne.zero)&
           nfiss(isof)=1
         if (isof.eq.1) uff(i)=a(loc)
         if (isof.eq.2) puff(i)=a(loc)
      enddo
   endif
   do i=1,ngnd5
      a(i-1+iloc)=0
   enddo
   go to 200
  540 continue
   if (ntemp.eq.0) ntmp(nmat)=jtemp
   if (nmat.eq.newmat) go to 600
   go to 120

   !--sfile4 is finished.
  600 continue
   deallocate(tempt)
   deallocate(flux)
   ! re-invert coarse group p0 flux for infinite dilution
   do i=1,ngnd
      if (cflux(i).ne.zero) cflux(i)=1/cflux(i)
   enddo
  620 continue
   write(nscr) eflag
   return
   end subroutine sfile4

   subroutine sf4out(matd,nmat,ntemp,ifiss,nina,&
     locab0,locsf0,locnus,locxtr,locxs,l1,l2,a)
   !--------------------------------------------------------------------
   ! Write subfile 4 on nscr.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides repoz
   ! externals
   integer::matd,nmat,ntemp,ifiss,nina
   integer::locab0,locsf0,locnus,locxtr,locxs,l1(*),l2(*)
   real(kr)::a(*)
   ! internals
   integer::ncol1,ident,jtemp,lim,i,ktemp,nc,ic,ib,i1,ig
   integer::ia,lone,ltwo,nb,loc
   real(kr)::flag
   real(kr)::b(70)
   integer::ncol=5
   integer::matl=0
   integer::ifissl=0
   integer::ninal=0
   character(4)::hend='end '
   integer::izero=0
   real(kr),parameter::zero=0

   ncol1=ncol-1
   if (nina.eq.2) go to 120
   if (matd.eq.matl) go to 160
   if (matl.eq.0) go to 150
   ! material has been completed.  copy mscr to nscr.
   read(hend,'(a4)') flag
   write(mscr) flag
   ident=idnt(nmat)
   if (iprint.eq.1.and.nmat.gt.1) write(nsyso,'(//)')
   if (iprint.eq.1) write(nsyso,'(80i1)') ident
   call repoz(-mscr)
   jtemp=1
   write(nscr) (tempt(i),i=1,ntemp)
   if (iprint.ne.0) then
      write(nsyso,'(/&
        &'' temperatures''/&
        &'' ------------'')')
      write(nsyso,'(1p,6e12.4)') (tempt(i),i=1,ntemp)
   endif
  100 continue
   ktemp=nint(tempt(jtemp))
   nc=4
   ic=1
   if (iprint.eq.1) write(nsyso,'(/&
     &'' absorption for nuclide '',i6,'' at '',i4,'' deg k''/&
     &'' -------------------------------------------'')')&
     ident,ktemp
  105 continue
   read(mscr) (b(i),i=1,ngnd)
   write(nscr) (b(i),i=1,ngnd)
   if (iprint.eq.1.and.ic.eq.1) write(nsyso,'(1p,6e12.4)')&
     (b(i),i=1,ngnd)
   if (iprint.eq.1.and.ifissl.eq.1.and.ic.gt.1.and.ic.lt.nc)&
     write(nsyso,'(1p,6e12.4)') (b(i),i=1,ngnd)
   if (iprint.eq.1.and.ic.eq.nc) write(nsyso,'(1p,6e12.4)')&
     (b(i),i=1,ngnd)
   ic=ic+1
   if (ninal.eq.1) go to 135
   if (ic.gt.nc) go to 125
   if (iprint.eq.0) go to 115
   if (ifissl.eq.0.and.ic.gt.1.and.ic.lt.nc) go to 115
   if (ic.eq.1) go to 115
   if (ic.eq.2) then
      write(nsyso,'(/&
        &'' fission for nuclide '',i6,'' at '',i4,'' deg k''/&
        &'' ----------------------------------------'')')&
        ident,ktemp
   else if (ic.eq.3) then
      write(nsyso,'(/&
        &'' nu*fission for nuclide '',i6,'' at '',i4,'' deg k''/&
        &'' -------------------------------------------'')')&
        ident,ktemp
   else if (ic.eq.4) then
      write(nsyso,'(/&
        &'' transport corrected total for nuclide '',i6,'' at '',&
        &i4,'' deg k''/&
        &'' ----------------------------------------------'',&
        &''------------'')') ident,ktemp
   endif
  115 continue
   ib=0
   go to 105
  120 continue
   ident=idnt(nmat)
   ktemp=0
   write(nscr) tempt(1)
   write(nscr) (a(locab0-1+i),i=1,ngnd)
   if (iprint.eq.1) then
      if (nmat.gt.1) write(nsyso,'(//)')
      write(nsyso,'(/&
        &'' nuclide '',i6/&
        &'' -------'')')&
        ident
      write(nsyso,'(/&
        &'' temperatures''/&
        &'' ------------'')')
      write(nsyso,'(1p,6e12.4)') tempt(1)
      write(nsyso,'(/&
        &'' absorption for nuclide '',i6,'' at '',i4,'' deg k''/&
        &'' -------------------------------------------'')')&
        ident,ktemp
      write(nsyso,'(1p,6e12.4)') (a(locab0-1+i),i=1,ngnd)
   endif
   ifissl=0
   ninal=1
   go to 200
  125 continue
   if (iprint.eq.1) write(nsyso,'(/&
     &'' p0 scattering matrix for nuclide '',i6,'' at '',i4,&
     &'' deg k''/&
     &'' -----------------------------------------------------''//&
     &'' ia l1 l2    l1+0'',4(10x,''+'',i1)/&
     &1x,7(''----------''),''----'')')&
     ident,ktemp,(i,i=1,ncol1)
   i1=1
   do 130 ig=1,ngnd
   read(mscr) ia,lone,ltwo
   if (ia.eq.0) go to 135
   write(nscr) ia,lone,ltwo
   nb=ltwo-lone+1
   read(mscr) (b(i),i=1,nb)
   write(nscr) (b(i),i=1,nb)
   i1=1
   lim=nb
   if ((lim-i1+1).gt.ncol) lim=ncol
   write(nsyso,'(3i3,5x,1p,5e12.4)')&
     ia,lone,ltwo,(b(i),i=i1,lim)
   do while (lim.ne.nb)
      i1=lim+1
      lim=nb
      if ((lim-i1+1).gt.ncol) lim=i1+ncol-1
      write(nsyso,'(9x,i4,2x,1p,5e12.4)') (b(i),i=i1,lim)
   enddo
  130 continue
   read(mscr) ia
  135 continue
   jtemp=jtemp+1
   if (jtemp.le.ntemp) go to 100
  150 continue
   if (matd.lt.0) go to 200
   call repoz(-mscr)
   matl=matd
   ifissl=ifiss
   ninal=nina
   ! write data on mscr.
  160 continue
   lim=locab0+ngnd-1
   write(mscr) (a(i),i=locab0,lim)
   if (nina.le.0.or.nina.eq.3) then
      lim=locsf0+ngnd-1
      write(mscr) (a(i),i=locsf0,lim)
      lim=locnus+ngnd-1
      write(mscr) (a(i),i=locnus,lim)
      lim=locxtr+ngnd-1
      write(mscr) (a(i),i=locxtr,lim)
      do ia=1,ngnd
         lone=l1(ia)
         ltwo=l2(ia)
         if (lone.ne.ngnd.or.ltwo.ne.1) then
            ib=0
            do i=lone,ltwo
               loc=locxs+ia-1+ngnd*(i-1)
               ib=ib+1
               b(ib)=a(loc)
            enddo
            write(mscr) ia,lone,ltwo
            write(mscr) (b(i),i=1,ib)
         else
            write(mscr) ia,ia,ia
            write(mscr) zero
         endif
      enddo
      write(mscr) izero
   endif

   !--sf4out is finished.
  200 continue
   if (matd.lt.0) matl=0
   return
   end subroutine sf4out

   subroutine sf5out
   !--------------------------------------------------------------------
   ! Write subfile 5 burnup data.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   ! internals
   integer::nfis1,i,index,j
   integer::id(70)
   real(kr),parameter::eflag=1.e35_kr

   write(nsyso,'(/'' ***subfile 5***burnup data'')')

   nfis1=nfis+1
   do i=1,ntis
      id(i)=idat(i)
   enddo
   write(nscr) ntis,(id(i),i=1,ntis)
   do i=1,nfis
      id(i)=idbt(i)
   enddo
   write(nscr) nfis,(id(i),i=1,nfis)
   do i=1,ntis
      index=1+(i-1)*nfis1
      write(nscr) (yld(index+j-1),j=1,nfis1)
   enddo
   write(nscr) eflag
   deallocate(idat)
   deallocate(idbt)
   deallocate(yld)
   return
   end subroutine sf5out

   subroutine sfile6(ntemp)
   !--------------------------------------------------------------------
   ! Process P1 scattering matrix.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides repoz,error,closz
   use endf ! provides endf routines and variables
   ! externals
   integer::ntemp
   ! internals
   integer::nther,ngndsq,nw,nb,il,np1,nmat,ip1opt,nina
   integer::matd,mti,mtc,ntemps,mtelas,itd,i,nth1,nth,ip1
   integer::iza,nl,nz,l,ig2lo,ig,igc,jg,ig2,ig2c,jg2c
   integer::loca,loc,lt,l1t,l1tc,l2t,l2tc,nskip,ng2
   real(kr)::temp,flag
   character(60)::strng
   integer::ntp(6)
   real(kr)::tempr(7)
   integer::lz=6
   real(kr),dimension(:),allocatable::tempt
   integer,dimension(:),allocatable::ids
   integer,dimension(:),allocatable::l1,l2
   integer,dimension(:),allocatable::l1e,l2e
   real(kr),dimension(:),allocatable::s
   character(4)::hflag='end '
   real(kr),parameter::eflag=1.e35_kr

   !--allocate storage.
   if (if4.eq.0) go to 410
   write(nsyso,'(//)')
   write(nsyso,&
     '(/'' ***subfile 6***p1 matrices'')')
   if (nnina.eq.0) go to 400
   nther=ngnd-nfg-nrg
   allocate(ids(newmat))
   ngndsq=ngnd*ngnd
   allocate(s(ngndsq))
   nw=newmat*6
   allocate(tempt(nw))
   allocate(l1(ngnd))
   allocate(l2(ngnd))
   allocate(l1e(ngnd))
   allocate(l2e(ngnd))

   !--search for desired materials.
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   il=2
   np1=0
   nmat=0
  100 continue
   nmat=nmat+1
   ip1opt=ip1tab(nmat)
   if (ip1opt.gt.0) go to 320
   nina=ninat(nmat)
   if (nina.gt.0) go to 320
   matd=mat(nmat)
   mti=mtit(nmat)
   mtc=mtct(nmat)
   ntemps=ntmp(nmat)
   mtelas=0
   itd=0
   do i=1,ngndsq
      s(i)=0
   enddo
   do i=1,ngnd
      l1(i)=ngnd
      l2(i)=1
   enddo
   ntemp=-1
   nth1=0
   nth=nther
   ip1=0
   math=1
   do while (math.ne.matd)
      call contio(ngendf,0,0,scr,nb,nw)
      if (math.ne.matd) then
         if (math.lt.0) then
            call repoz(ngendf)
            call tpidio(ngendf,0,0,scr,nb,nw)
         else if (math.gt.0) then
            call tomend(ngendf,0,0,scr)
         endif
      endif
   enddo
   go to 130

   !--search for required reactions.
  125 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 200
   if (math.lt.0) go to 300
   if (math.ne.matd) go to 300
   if (mfh.eq.0.or.mth.eq.0) go to 125
   if (mfh.eq.1.and.ntemp.eq.ntemps) go to 300
   if (mfh.eq.1) go to 130
   go to 135
  130 continue
   iza=nint(c1h)
  135 continue
   nl=l1h
   if (nl.lt.il.and.mfh.ne.1) go to 155
   nz=l2h
  140 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   if (mfh.eq.1) then
      temp=c1h
      ntemp=ntemp+1
   endif
   if (mfh.eq.3) go to 160
   if (mfh.ne.6) go to 155
   if (mth.ne.2) go to 148
   if (mtelas.gt.0) go to 148
   mtelas=1
   do i=1,ngnd
      l1e(i)=ngnd
      l2e(i)=1
   enddo
   do i=1,ngndsq
      elas(i)=0
   enddo
  148 continue
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   igc=icgrp(ig)
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if ((l+nw-1).gt.nwscr)&
        call error('sfile6','storage exceeded.',' ')
   enddo
  155 continue
   call tosend(ngendf,0,0,scr)
   go to 125
  160 continue
   if (igc.eq.0.or.igc.gt.ngnd) go to 225
   jg=ngnd-igc+1
   l=1

   !--store non-temperature dependent scattering matrix
   if (ntemp.gt.0) go to 210
   if (mfh.eq.3) go to 230
   if (mth.ge.18.and.mth.le.21) go to 155
   if (mth.eq.38) go to 155
   if (mth.eq.2) go to 155
   if (mth.eq.mti.or.mth.eq.mtc) go to 180
   if (mth.ge.201.and.mth.le.250) go to 155
   do i=2,ng2
      ig2=ig2lo+i-3
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         loca=l+lz+(il-1)+nl*nz*(i-1)
         loc=1+jg-1+ngnd*(jg2c-1)
         s(loc)=s(loc)+scr(loca)
      endif
   enddo
   ip1=1
   lt=l1(jg)
   l1t=ngn-ig2lo-ng2+3
   l1tc=icgrp(l1t)
   if (l1tc.lt.lt.and.l1tc.ne.0.and.l1tc.le.ngnd) l1(jg)=l1tc
   lt=l2(jg)
   l2t=l1t+ng2-2
   l2tc=icgrp(l2t)
   if (l2tc.gt.lt.and.l2tc.ne.l1t.and.l2tc.gt.0.and.l2tc.le.ngnd)&
     l2(jg)=l2tc
   if (ig.lt.ngn) go to 140
   go to 125
  180 continue
   if (igc.gt.nth1.and.igc.lt.nth) nth1=igc
   if (igc.lt.nth) go to 140
   go to 155

   !--write non-temperature dependent matrix on scratch tape.
  200 continue
   if (ntemp.gt.0) go to 250
   call repoz(-kscr)
   write(kscr) (l1(i),i=1,ngnd)
   write(kscr) (l2(i),i=1,ngnd)
   write(kscr) (s(i),i=1,ngndsq)
   call repoz(-kscr)
   nskip=-3
   call skiprz(ngendf,nskip)
   call findf(matd,1,451,ngendf)
   nth=nth1
   go to 125

   !--add temperature-dependent reaction to matrix.
  210 continue
   if (mth.eq.2.or.mth.eq.mti.or.mth.eq.mtc) go to 215
   go to 155
  215 continue
   if (mth.eq.2.and.igc.le.nth) go to 140
   if (mth.eq.mti.and.igc.gt.nth) go to 155
   if (mth.eq.mtc.and.igc.gt.nth.and.mtc.ne.0) go to 155
   itd=1
   do i=2,ng2
      ig2=ig2lo+i-2
      ig2c=icgrp(ig2)
      if (ig2c.ne.0.and.ig2c.le.ngnd) then
         jg2c=ngnd-ig2c+1
         loca=l+lz+(il-1)+nl*nz*(i-1)
         loc=jg+ngnd*(jg2c-1)
         s(loc)=s(loc)+scr(loca)
         if (mth.eq.2) then
            loc=jg+ngnd*(jg2c-1)
            elas(loc)=elas(loc)+scr(loca)
         endif
      endif
   enddo
   ip1=1
   lt=l1(jg)
   l1t=ngn-ig2lo-ng2+3
   l1tc=icgrp(l1t)
   if (l1tc.lt.lt.and.l1tc.ne.0) l1(jg)=l1tc
   if (mth.eq.2) l1e(jg)=l1tc
   lt=l2(jg)
   l2t=l1t+ng2-2
   l2tc=icgrp(l2t)
   if (l2tc.gt.lt.and.l2tc.ne.l1t.and.l2tc.gt.0.and.l2tc.le.ngnd)&
     l2(jg)=l2tc
   if (mth.eq.2.and.l2tc.ne.l1t) l2e(jg)=l2tc
  225 continue
   if (ig.lt.ngn) go to 140
   go to 125

   !--coarse group flux
  230 continue
   if (mth.ne.1) go to 155
   cflux(jg)=cflux(jg)+scr(l+lz)
   if (ig.lt.ngn) go to 140
   go to 125

   !--desired data is loaded
  250 continue
   if (ip1.eq.0) then
      write(strng,&
        '(''no required p1 matrices found for mat '',i4)') matd
      call error('sfile6',strng,' ')
   endif
   if (mti.gt.0.and.itd.eq.0) then
      write(strng,&
        '(''no temperature-dependent reactions for mat '',i4)') matd
      call error('sfile6',strng,'check mti')
   endif
   if (mtelas.le.0) then
      do i=1,ngnd
         if (l1e(i).lt.l1(i)) l1(i)=l1e(i)
         if (l2e(1).gt.l2(i)) l2(i)=l2e(i)
      enddo
      do i=1,ngndsq
         s(i)=s(i)+elas(i)
      enddo
   endif
   call sf6out(math,np1,ntp,ids,tempt,l1,l2,s)
   tempr(ntemp)=temp
   call repoz(-kscr)
   read(kscr) (l1(i),i=1,ngnd)
   read(kscr) (l2(i),i=1,ngnd)
   read(kscr) (s(i),i=1,ngndsq)
   mtelas=0
   go to 125

   !--this material is finished.
  300 continue
   call skiprz(ngendf,-1)
   np1=np1+1
   ids(np1)=iza
   do i=1,ntemp
      tempt(np1+newmat*(i-1))=tempr(i)
   enddo
   ntp(np1)=ntemp
  320 continue
   if (nmat.lt.newmat) go to 100

   !--sfile6 is finished.
   call sf6out(-1,np1,ntp,ids,tempt,l1,l2,s)
  400 continue
   deallocate(mtit)
   deallocate(mtct)
   call closz(mscr)
   call closz(kscr)
  410 continue
   write(nscr) eflag
   read(hflag,'(a4)') flag
   write(nscr) flag
   return
   end subroutine sfile6

   subroutine sf6out(matd,np1,ntp,ids,temp,l1,l2,s)
   !--------------------------------------------------------------------
   ! Write subfile 6.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides error,repoz
   ! externals
   integer::matd,np1,ntp(*),ids(*),l1(*),l2(*)
   real(kr)::temp(*),s(*)
   ! internals
   integer::ncol1,ia,lone,ltwo,j,i,loc,ntemps,ip1,ident,it
   integer::ktemp,ig,nb,i1,lim
   character(60)::strng
   integer::k(70)
   real(kr)::b(70)
   integer::ncol=5
   integer::jtem=0

   !--store matrix on mscr.
   ncol1=ncol-1
   if (jtem.eq.0) call repoz(-mscr)
   jtem=jtem+1
   if (matd.gt.0) then
      do ia=1,ngnd
         lone=l1(ia)
         ltwo=l2(ia)
         if (ltwo.lt.lone) then
            write(strng,'(''for group '',i3,'' l1='',i2,&
              &'' is lt l2='',i2,'' at temp no. '',i2)')&
              ia,lone,ltwo,jtem
            call error('sf6out',strng,' ')
         endif
         j=0
         do i=lone,ltwo
            loc=ia+ngnd*(i-1)
            j=j+1
            b(j)=s(loc)
         enddo
         write(mscr) ia,lone,ltwo
         write(mscr) (b(i),i=1,j)
      enddo

   !--write subfile 6 on nscr.
   else
      if (np1.ne.0) then
         do i=1,np1
            k(i)=ids(i)
         enddo
         write(nscr) np1,(k(i),i=1,np1)
         if (iprint.ne.0) then
            write(nsyso,'(/&
                 &'' np1 '',i2/'' ---''//&
                 &'' nuclides''/'' --------''/&
                 &(11i7))')&
                 np1,(k(i),i=1,np1)
               write(nsyso,'(/&
                 &'' ntemp    temperatures''/&
                 &'' -----    ------------'')')
         endif
         do i=1,np1
            ntemps=ntp(i)
            do j=1,ntemps
               b(j)=temp(i+newmat*(j-1))
            enddo
            write(nscr) ntemps,(b(j),j=1,ntemps)
            if (iprint.eq.1) write(nsyso,&
              '(i5,5x,1p,5e12.4/(10x,5e12.4))')&
              ntemps,(b(j),j=1,ntemps)
         enddo
         call repoz(-mscr)
         do ip1=1,np1
            ident=ids(ip1)
            ntemps=ntp(ip1)
            do it=1,ntemps
               ktemp=nint(temp(ip1+newmat*(it-1)))
               if (iprint.eq.1) write(nsyso,'(/&
                 &'' p1 scattering matrix for nuclide '',i2,&
                 &'' ('',i6,'')'','' at '',i4,'' deg k''/&
                 &1x,5(''----------''),''--------''/&
                 &'' ia l1 l2    l1+0'',4(10x,''+'',i1)/&
                 &1x,7(''----------''),''----'')')&
                 ip1,ident,ktemp,(i,i=1,ncol1)
               do ig=1,ngnd
                  read(mscr) ia,lone,ltwo
                  write(nscr) ia,lone,ltwo
                  nb=ltwo-lone+1
                  read(mscr) (b(i),i=1,nb)
                  write(nscr) (b(i),i=1,nb)
                  if (iprint.ne.0) then
                     i1=1
                     lim=nb
                     if (lim.gt.ncol) lim=ncol
                     write(nsyso,'(3i3,5x,1p,5e12.4)')&
                       ia,lone,ltwo,(b(i),i=i1,lim)
                     do while (lim.ne.nb)
                        i1=lim+1
                        lim=nb
                        if ((lim-i1+1).gt.ncol) lim=i1+ncol-1
                        write(nsyso,'(14x,1p,5e12.4)')&
                          (b(i),i=i1,lim)
                     enddo
                  endif
               enddo
            enddo
         enddo
      endif
   endif
   return
   end subroutine sf6out

   subroutine cpmout(nlib,idat)
   !--------------------------------------------------------------------
   ! Write the input for CLIB on nout.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides times,repoz,closz,error
   use physics ! provides amassn
   ! external
   integer::nlib,idat
   ! internals
   integer::jfiss,new,ngnd1,i,ip,j,np1,inf2,mp1o,nina
   integer::ident,indfis,jres,nf,ntemps,ip1,ip1opt,ifile
   integer::imat,ig,kres,jnf2,nmat,iwrite,nx,nw
   integer::need,low,lim,ihi,lr,ipf,itemp,ind,input
   integer::ia,l1,l2,nti,nfi,nresot
   real(kr)::time,pri,aw,flag,xid,decay
   character(60)::strng
   real(kr)::b(70)
   integer::k(70)
   real(kr)::tempr(7)
   !--------------------------------------------------------------------
   !    the following data cards must be updated with changes
   !    in the old library.  meaning of variables follows -
   !      nold    no. of nuclides
   !      idnto   idents of nuclides
   !      nreso   no. of resonance nuclides
   !      idreso  idents of resonance nuclides
   !      nf2     no. nuclides with greater than 1 resonance tabulation
   !      nfr2    idents of nf2 nuclides
   !      np1o    no. of nuclides having p1 matrices
   !      idp1o   idents of nuclides having p1 matrices
   integer::nold=65
   integer,dimension(80),parameter::idnto=(/&
     1001,1002,5000,5010,6000,8000,8001,13000,14000,&
     24000,25000,26000,28000,29063,47000,48000,49000,64154,&
     64155,64156,64157,64158,66164,71176,36083,45103,45105,47109,&
     54131,54135,55133,55134,55135,60143,60145,61147,61148,&
     61248,62147,62149,62150,62151,62152,63153,63154,&
     63155,401,402,92234,92235,92236,92238,93237,94238,94239,&
     94240,94241,94242,95241,95242,95243,96242,96244,1,302,&
     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/)
   integer,parameter::nreso=4
   integer,dimension(20),parameter::idreso=(/&
     92235,92236,92238,94329,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/)
   integer::nf2=1
   integer,dimension(1),parameter::nfr2=(/92238/)
   integer,parameter::np1o=4
   integer,dimension(10),parameter::idp1o=(/&
     1001,8000,8001,1002,0,0,0,0,0,0/)
   !--------------------------------------------------------------------
   character(4),dimension(2)::fmt=(/'(6e1','2.0)'/)
   integer::iflgs(80)
      data iflgs/80*0/
   integer::izero=0
   integer::ione=1
   integer::ithree=3
   character(4)::hpri='pri '
   real(kr),parameter::zero=0.e0_kr
   real(kr),parameter::eps=1.e-5_kr
   real(kr)::eflag=1.e35_kr

   !--initialize.
   call timer(time)
   write(nsyso,'(/'' ***output***'',56x,f8.1,''s'')') time

   !--write input for subfile 1.
   read(hpri,'(a4)') pri
   write(nout,'(a3,3x,2i6)') pri,izero,izero
   write(nout,'(2a4)') fmt(1),fmt(2)
   write(nout,'(2a4)') fmt(1),fmt(2)
   write(nout,'(2a4)') fmt(1),fmt(2)
   write(nout,'(2a4)') fmt(1),fmt(2)
   if (mode.le.1) write(nout,'(12i6)') nold,izero
   if (mode.eq.2) write(nout,'(12i6)') izero,ione
   if (mode.le.1) write(nout,'(12i6)') ione
   jfiss=nfiss(1)
   if (nfiss(2).gt.jfiss) jfiss=nfiss(2)
   if (jfiss.eq.0) jfiss=22
   new=nold+newmat
   if (mode.eq.0)&
     write(nout,'(12i6)') nlib,idat,ngnd,nfg,nrg,jfiss,nold
   if (mode.eq.1)&
     write(nout,'(12i6)') nlib,idat,ngnd,nfg,nrg,jfiss,new
   if (mode.eq.2)&
     write(nout,'(12i6)') nlib,idat,ngnd,nfg,nrg,jfiss,newmat
   if (mode.eq.2) go to 100
   write(nout,'(12i6)') izero
   write(nout,'(12i6)') izero
   if (mode.eq.0) go to 102
   if (mode.eq.1) go to 106
  100 continue
   ngnd1=ngnd+1
   write(nout,'(1p,6e12.5)') (egb(i),i=1,ngnd1)
   write(nout,'(1p,6e12.5)') (cflux(i),i=1,ngnd)
   if (iu.eq.0.or.if4.eq.0) write(nout,'(1p,6e12.5)')&
        (zero,i=1,jfiss)
   if (iu.eq.1.and.if4.gt.0) write(nout,'(1p,6e12.5)')&
        (uff(i),i=1,jfiss)
   if (ipu.eq.0.or.if4.eq.0) write(nout,'(1p,6e12.5)')&
        (zero,i=1,jfiss)
   if (ipu.eq.1.and.if4.gt.0) write(nout,'(1p,6e12.5)')&
        (puff(i),i=1,jfiss)
   go to 108
  102 continue
   do i=1,newmat
      ip=ipost(i)
      iflgs(ip)=1
   enddo
   if (mode.eq.0) write(nout,'(80i1)') (iflgs(i),i=1,nold)
  106 continue
   if (mode.gt.0) write(nout,'(80i1)') (izero,j=1,nold)
  108 continue
   np1=0
   inf2=1
   mp1o=0
   do i=1,newmat
      if (mode.eq.0) ip=ipost(i)
      if (mode.gt.0) ip=0
      nina=ninat(i)
      aw=awrt(i)
      if (nina.lt.2) aw=aw*amassn
      if (nina.eq.2) nina=1
      if (nina.eq.3) nina=0
      ninat(i)=nina
      ident=idnt(i)
      if (mode.eq.0) ident=idnto(ip)
      do j=1,np1o
         if (ident.eq.idp1o(j)) mp1o=mp1o+1
      enddo
      indfis=indf(i)
      jres=irest(i)
      if (jres.gt.0.and.indfis.eq.0) indfis=1
      nf=0
      if (jres.gt.0) nf=1
      if (ident.eq.nfr2(inf2).and.mode.eq.0) nf=2
      if (inf2.lt.nf2.and.ident.eq.nfr2(inf2).and.mode.eq.0)&
        inf2=inf2+1
      ntemps=ntmp(i)
      ip1=0
      ip1opt=ip1tab(i)
      if (ip1opt.eq.0) ip1=1
      if (ip1.eq.1) np1=np1+1
      write(nout,'(f12.4,8i6)')&
        aw,ident,indfis,jres,nf,ntemps,nina,izero,ip1
   enddo

   !--write input for subfile 2.
   ifile=2
   if (mode.eq.0) write(nout,'(80i1)') (iflgs(i),i=1,nold)
   if (mode.eq.1) write(nout,'(80i1)') (izero,i=1,nold)
   call repoz(-nscr)
   if (nnina.ne.0) then
      do imat=1,nnina
         do ig=1,nrg
            read(nscr) (b(i),i=1,4)
            write(nout,'(1p,6e12.5)') (b(i),i=1,4)
         enddo
      enddo
   endif
   read(nscr) flag
   if (abs(flag-eflag).gt.eps) go to 910

   !--write input for subfile 3.
   ifile=3
   nresot=nreso-nf2
   if (mode.eq.1) go to 140
   if (mode.eq.2.and.nnina.eq.0) go to 170
   if (mode.eq.2) go to 145
   if (nres.gt.0) go to 145
  140 continue
   do i=1,nreso
      write(nout,'(i6/i6/i6)') izero,izero,izero
   enddo
   if (nres.eq.0) go to 170
  145 continue
   kres=1
   jnf2=0
   do 150 nmat=1,newmat
   jres=irest(nmat)
   if (jres.le.0) go to 150
   ident=idnt(nmat)
   iwrite=0
   if (mode.gt.0) go to 156
  152 continue
   if (ident.lt.idreso(kres)) go to 156
   if (ident.gt.idreso(kres)) go to 154
   iwrite=1
   inf2=0
   do while (inf2.lt.nf2)
      inf2=inf2+1
      if (ident.eq.nfr2(inf2)) write(nout,'(i6/i6/i6)')&
        izero,izero,izero
      if (ident.eq.nfr2(inf2)) jnf2=jnf2+1
   enddo
   if (kres.lt.nreso) kres=kres+1
   go to 156
  154 continue
   write(nout,'(i6/i6/i6)') izero,izero,izero
   inf2=0
   do while (inf2.lt.nf2)
      inf2=inf2+1
      if (idreso(kres).eq.nfr2(inf2)) write(nout,'(i6/i6/i6)')&
        izero,izero,izero
      if (idreso(kres).eq.nfr2(inf2)) jnf2=jnf2+1
   enddo
   if (kres.eq.nreso) go to 156
   kres=kres+1
   go to 152
  156 continue
   if (iwrite.gt.0) write(nout,'(i6)') ione
   read(nscr) xid
   inf2=0
   do while (inf2.lt.nf2)
      inf2=inf2+1
   enddo
   write(nout,'(1p,6e12.5)') xid
   if (iwrite.gt.0) write(nout,'(i6)') ione
   read(nscr) ntemps,nx
   write(nout,'(2i6)') ntemps,nx
   read(nscr) (b(i),i=1,ntemps)
   write(nout,'(1p,6e12.5)') (b(i),i=1,ntemps)
   read(nscr) (b(i),i=1,nx)
   write(nout,'(1p,6e12.5)') (b(i),i=1,nx)
   if (iwrite.gt.0) write(nout,'(i6)') ione
   nw=ntemps*nx
   indfis=indf(nmat)
  158 continue
   do j=1,nrg
      read(nscr) (b(i),i=1,nw)
      write(nout,'(1p,6e12.5)') (b(i),i=1,nw)
   enddo
   if (indfis.lt.2) go to 150
   indfis=1
   go to 158
  150 continue
   if (mode.gt.0) go to 170
   if (kres.ge.nresot) go to 170
   need=nreso-kres+nf2-jnf2
   do i=1,need
      write(nout,'(i6/i6/i6)') izero,izero,izero
   enddo
  170  continue
   read(nscr) flag
   if (abs(flag-eflag).gt.eps) go to 910

   !--write input for subfile 4.
   ifile=4
   if (if4.ne.0) then
      if (mode.ne.2) then
         write(nout,'(80i1)') (iflgs(i),i=1,nold)
         low=1
         lim=nold/8
         if (lim*8.lt.nold) lim=lim+1
         do i=1,lim
            ihi=low+7
            lr=low/8
            do j=1,80
               iflgs(j)=0
            enddo
            if (mode.ne.1) then
               do j=1,newmat
                  ip=ipost(j)
                  if (ip.ge.low.and.ip.le.ihi) then
                     ipf=(ip-lr*8-1)*10
                     iflgs(ipf+1)=1
                     iflgs(ipf+2)=1
                     iflgs(ipf+3)=1
                     iflgs(ipf+4)=1
                     iflgs(ipf+5)=1
                  endif
               enddo
            endif
            write(nout,'(80i1)') (iflgs(j),j=1,80)
            low=low+8
         enddo
      endif
      nmat=0
      do while (nmat.lt.newmat)
         nmat=nmat+1
         ntemps=ntmp(nmat)
         read(nscr) (tempr(i),i=1,ntemps)
         write(nout,'(8f10.0)') (tempr(i),i=1,ntemps)
         itemp=0
         nina=ninat(nmat)
         lim=4
         if (nina.gt.0) lim=1
         do while (itemp.lt.ntemps)
            write(nout,'(2i6)') ione,izero
            do i=1,lim
               read(nscr) (b(j),j=1,ngnd)
               write(nout,'(1p,6e12.5)') (b(j),j=1,ngnd)
            enddo
            if (nina.le.0) then
               ind=3
               input=0
               write(nout,'(2i6)') ind,input
               do j=1,ngnd
                  read(nscr) ia,l1,l2
                  write(nout,'(3i6)') ia,l1,l2
                  nw=l2-l1+1
                  read(nscr) (b(i),i=1,nw)
                  write(nout,'(1p,6e12.5)') (b(i),i=1,nw)
               enddo
            endif
            itemp=itemp+1
         enddo
      enddo
   endif
   read(nscr) flag
   if (abs(flag-eflag).gt.eps) go to 910

   !--write input for subfile 5.
   ifile=5
   if (if5.eq.0) write(nout,'(i6)') izero
   if (if5.gt.0) write(nout,'(i6)') ione
   if (if5.eq.0) go to 218
   read(nscr) nti,(k(i),i=1,nti)
   write(nout,'(i6/(12i6))') nti,(k(i),i=1,nti)
   read(nscr) nfi,(k(i),i=1,nfi)
   write(nout,'(i6/(12i6))') nfi,(k(i),i=1,nfi)
   do i=1,nti
      read(nscr) decay,(b(j),j=1,nfi)
      write(nout,'(1p,6e12.5)') decay
      write(nout,'(1p,6e12.5)') (b(j),j=1,nfi)
   enddo
   read(nscr) eflag
   if (abs(flag-eflag).gt.eps) go to 910

   !--write input for subfile 6.
  218 continue
   ifile=6
   if (if4.ne.0) then
      ind=0
      if (mp1o.gt.0) ind=1
      write(nout,'(3i6)') ind,ithree,input
      if (np1.ne.0) then
         if (mode.ne.2.and.ind.ne.1) then
            write(nout,'(i6)') ione
         endif
         read(nscr) np1,(k(i),i=1,np1)
         write(nout,'(7i6)') np1,(k(i),i=1,np1)
         ip1=0
         do while (ip1.lt.np1)
            ip1=ip1+1
            read(nscr) ntemps,(b(i),i=1,ntemps)
            ntmp(ip1)=ntemps
            write(nout,'(i6,1p,6e12.5)') ntemps,(b(i),i=1,ntemps)
         enddo
         ip1=0
         do while (ip1.lt.np1)
            ip1=ip1+1
            itemp=0
            ntemps=ntmp(ip1)
            do while (itemp.lt.ntemps)
               do j=1,ngnd
                  read(nscr) ia,l1,l2
                  write(nout,'(3i6)') ia,l1,l2
                  nw=l2-l1+1
                  read(nscr) (b(i),i=1,nw)
                  write(nout,'(1p,6e12.5)') (b(i),i=1,nw)
               enddo
               itemp=itemp+1
            enddo
         enddo
      else
         write(nout,'(i6)') izero
         write(nout,'(i6)') izero
      endif
   endif
   read(nscr) flag
   if (abs(flag-eflag).gt.eps) go to 910

   !--write end of input flag.
   read(nscr) flag
   write(nout,'(2a4)') flag

   !--cpmout is finished.
   call closz(nscr)
   return

   !--end flag not found on input tape
  910 continue
   write(strng,&
     '(''expected end flag not found on nscr for file '',i2)')&
     ifile
   call error('cpmout',strng,' ')
   end subroutine cpmout

end module powm

module physics
   ! Provides pi and physics constants taken from CODATA'2014 as
   ! given on the NIST site: 
   !      https://physics.nist.gov/cuu/Constants
   ! namely, bk (Boltzmann's constant),
   ! amassn (the neutron mass in amu), amu (the amu value itself),
   ! hbar (Planck's constant), ev (the conversion to eV), and
   ! clight (the speed of light).
   use locale ! provides kr
   implicit none
!
! Constants per ENDF-102, Appendix H (February 1, 2018) edition, also
! identified as SVN Commit:  Revision 215).  This is the manual version
! available from http://www.nndc.bnl.gov/csewg/docs/endf-manual.pdf in
! the Summer 2018.
!  - numerical values are given for pi, Boltzmann's constant, eV
!    speed of light, atomic mass unit in eV, Planck's constant and
!    the fine structure constant.
!  - other values are given in terms of the above.
   real(kr),parameter,public::pi=3.141592653589793238e0_kr     !
   real(kr),parameter,public::euler=0.57721566490153286e0_kr !
   real(kr),parameter,public::bk=8.617333262e-5_kr         !eV/degK
   real(kr),parameter,public::ev=1.602176634e-12_kr     !erg/eV
   real(kr),parameter,public::clight=2.99792458e10_kr   !cm/s
   real(kr),parameter,public::amu=931.49410242e6_kr*ev/&
                                        (clight*clight) !g/amu
   real(kr),parameter,public::hbar=6.582119569e-16_kr*ev !Planck/2pi, erg
   real(kr),parameter,public::finstri=1.e16_kr*hbar/(ev*ev*clight) !inv fine str
! ****************************************************************
! * Light particle masses (in amu), per ENDF-102, Appendix H:    *
! * - note, these are particle masses, not atomic masses.        *
! * - we use "a" to start the variable name due to the legacy    *
! *   fortran naming convention that would have considered a     *
! *   name of the form "massn" to be an integer variable.        *
! ****************************************************************
   real(kr),parameter,public::amassn=1.00866491595e0_kr !neutron
   real(kr),parameter,public::amassp=1.007276466621e0_kr !proton
   real(kr),parameter,public::amassd=2.013553212745e0_kr !deuteron
   real(kr),parameter,public::amasst=3.01550071621e0_kr  !triton
   real(kr),parameter,public::amassh=3.014932247175e0_kr !helion (3)
   real(kr),parameter,public::amassa=4.001506179127e0_kr  !alpha
   real(kr),parameter,public::amasse=5.48579909065e-4_kr  !electron
   real(kr),parameter,public::pnratio=amassp/amassn ! proton/neutron mass
   real(kr),parameter,public::dnratio=amassd/amassn ! deuteron/neutron mass
   real(kr),parameter,public::tnratio=amasst/amassn ! triton/neutron mass
   real(kr),parameter,public::hnratio=amassh/amassn ! helion/neutron mass
   real(kr),parameter,public::anratio=amassa/amassn ! alpha/neutron mass

   real(kr),parameter,public::epair=amasse*amu*clight*clight/ev
end module physics

module acecm
   ! provides some routines that are common to more than one
   ! of the submodules of acer; mtname, ptleg2, pttab2, bachaa,
   ! newsuff.
   use locale
   implicit none
   private

   ! main ace container array
   integer,parameter,public::nxss=50000000
   real(kr),dimension(:),allocatable,public::xss

   !--Public routines
   public mtname,ptleg2,pttab2,bachaa,eavl,newsuff
   public advance_to_locator
   public write_integer,write_real,write_integer_list,write_real_list
   public typen

contains

   subroutine mtname(mt,name,izai)
   !-------------------------------------------------------------------
   ! Return the reaction name for an ENDF MT number.
   !-------------------------------------------------------------------
   use endf ! provides iverf
   ! externals
   integer::mt,izai
   character(10)::name
   ! internals
   integer::i
   character(10),dimension(500),parameter::hndf=(/&
     'total     ','elastic   ','nonelastic','inelastic ','(n,x)     ',&
     '(n,1/2*1) ','(n,1/2*2) ','(n,1/2*3) ','(n,1/2*4) ','(n,x)     ',&
     '(n,2nd)   ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,2n)    ','(n,3n)    ','fission   ','(n,f)     ','(n,n*f)   ',&
     '(n,2nf)   ','(n,n*)a   ','(n,n*)3a  ','(n,2n)a   ','(n,3n)a   ',&
     '(n,2n)iso ','(n,abs)   ','(n,n*)p   ','(n,n*)2a  ','(n,2n)2a  ',&
     '(n,x)     ','(n,n*)d   ','(n,n*)t   ','(n,n*)he3 ','(n,n*)d2a ',&
     '(n,n*)t2a ','(n,4n)    ','(n,3nf)   ','(n,x)     ','(n,x)     ',&
     '(n,2np)   ','(n,3np)   ','(n,x)     ','(n,n2p)   ','(n,npa)   ',&
     '(n,2/2*1) ','(n,2/2*2) ','(n,2/2*3) ','(n,2/2*4) ','(n,n*0)   ',& !50
     '(n,n*1)   ','(n,n*2)   ','(n,n*3)   ','(n,n*4)   ','(n,n*5)   ',&
     '(n,n*6)   ','(n,n*7)   ','(n,n*8)   ','(n,n*9)   ','(n,n*10)  ',&
     '(n,n*11)  ','(n,n*12)  ','(n,n*13)  ','(n,n*14)  ','(n,n*15)  ',&
     '(n,n*16)  ','(n,n*17)  ','(n,n*18)  ','(n,n*19)  ','(n,n*20)  ',&
     '(n,n*21)  ','(n,n*22)  ','(n,n*23)  ','(n,n*24)  ','(n,n*25)  ',&
     '(n,n*26)  ','(n,n*27)  ','(n,n*28)  ','(n,n*29)  ','(n,n*30)  ',&
     '(n,n*31)  ','(n,n*32)  ','(n,n*33)  ','(n,n*34)  ','(n,n*35)  ',&
     '(n,n*36)  ','(n,n*37)  ','(n,n*38)  ','(n,n*39)  ','(n,n*40)  ',&
     '(n,n*c)   ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,n*)gma ','(n,x)     ',& !100
     '(n,parab) ','(n,gma)   ','(n,p)     ','(n,d)     ','(n,t)     ',&
     '(n,he3)   ','(n,a)     ','(n,2a)    ','(n,3a)    ','(n,x)     ',&
     '(n,2p)    ','(n,pa)    ','(n,t2a)   ','(n,d2a)   ','(n,pd)    ',&
     '(n,pt)    ','(n,da)    ','(n,x)     ','(n,x)     ','(n,dest)  ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',& !150
     '(n,x)     ','(n,5n)    ','(n,6n)    ','(n,2nt)   ','(n,ta)    ',&
     '(n,4np)   ','(n,3nd)   ','(n,nda)   ','(n,2npa)  ','(n,7n)    ',&
     '(n,8n)    ','(n,5np)   ','(n,6np)   ','(n,7np)   ','(n,4na)   ',&
     '(n,5na)   ','(n,6na)   ','(n,7na)   ','(n,4nd)   ','(n,5nd)   ',&
     '(n,6nd)   ','(n,3nt)   ','(n,4nt)   ','(n,5nt)   ','(n,6nt)   ',&
     '(n,2nhe3) ','(n,3nhe3) ','(n,4nhe3) ','(n,3n2p)  ','(n,3n2a)  ',&
     '(n,3npa)  ','(n,dt)    ','(n,npd)   ','(n,npt)   ','(n,ndt)   ',&
     '(n,nphe3) ','(n,ndhe3) ','(n,nthe3) ','(n,nta)   ','(n,2n2p)  ',&
     '(n,phe3)  ','(n,dhe3)  ','(n,he3a)  ','(n,4n2p)  ','(n,4n2a)  ',&
     '(n,4npa)  ','(n,3p)    ','(n,n3p)   ','(n,3n2pa) ','(n,5n2p)  ',& !200
     '(n,p*0)   ',&
     '(n,p*1)   ','(n,p*2)   ','(n,p*3)   ','(n,p*4)   ','(n,p*5)   ',&
     '(n,p*6)   ','(n,p*7)   ','(n,p*8)   ','(n,p*9)   ','(n,p*10)  ',&
     '(n,p*11)  ','(n,p*12)  ','(n,p*13)  ','(n,p*14)  ','(n,p*15)  ',&
     '(n,p*16)  ','(n,p*17)  ','(n,p*18)  ','(n,p*19)  ','(n,p*20)  ',&
     '(n,p*21)  ','(n,p*22)  ','(n,p*23)  ','(n,p*24)  ','(n,p*25)  ',&
     '(n,p*26)  ','(n,p*27)  ','(n,p*28)  ','(n,p*29)  ','(n,p*30)  ',&
     '(n,p*31)  ','(n,p*32)  ','(n,p*33)  ','(n,p*34)  ','(n,p*35)  ',&
     '(n,p*36)  ','(n,p*37)  ','(n,p*38)  ','(n,p*39)  ','(n,p*40)  ',&
     '(n,p*41)  ','(n,p*42)  ','(n,p*43)  ','(n,p*44)  ','(n,p*45)  ',&
     '(n,p*46)  ','(n,p*47)  ','(n,p*48)  ','(n,p*c)   ',             & !250
     '(n,d*0)   ',&
     '(n,d*1)   ','(n,d*2)   ','(n,d*3)   ','(n,d*4)   ','(n,d*5)   ',&
     '(n,d*6)   ','(n,d*7)   ','(n,d*8)   ','(n,d*9)   ','(n,d*10)  ',&
     '(n,d*11)  ','(n,d*12)  ','(n,d*13)  ','(n,d*14)  ','(n,d*15)  ',&
     '(n,d*16)  ','(n,d*17)  ','(n,d*18)  ','(n,d*19)  ','(n,d*20)  ',&
     '(n,d*21)  ','(n,d*22)  ','(n,d*23)  ','(n,d*24)  ','(n,d*25)  ',&
     '(n,d*26)  ','(n,d*27)  ','(n,d*28)  ','(n,d*29)  ','(n,d*30)  ',&
     '(n,d*31)  ','(n,d*32)  ','(n,d*33)  ','(n,d*34)  ','(n,d*35)  ',&
     '(n,d*36)  ','(n,d*37)  ','(n,d*38)  ','(n,d*39)  ','(n,d*40)  ',&
     '(n,d*41)  ','(n,d*42)  ','(n,d*43)  ','(n,d*44)  ','(n,d*45)  ',&
     '(n,d*46)  ','(n,d*47)  ','(n,d*48)  ','(n,d*c)   ',             & !300
     '(n,t*0)   ',&
     '(n,t*1)   ','(n,t*2)   ','(n,t*3)   ','(n,t*4)   ','(n,t*5)   ',&
     '(n,t*6)   ','(n,t*7)   ','(n,t*8)   ','(n,t*9)   ','(n,t*10)  ',&
     '(n,t*11)  ','(n,t*12)  ','(n,t*13)  ','(n,t*14)  ','(n,t*15)  ',&
     '(n,t*16)  ','(n,t*17)  ','(n,t*18)  ','(n,t*19)  ','(n,t*20)  ',&
     '(n,t*21)  ','(n,t*22)  ','(n,t*23)  ','(n,t*24)  ','(n,t*25)  ',&
     '(n,t*26)  ','(n,t*27)  ','(n,t*28)  ','(n,t*29)  ','(n,t*30)  ',&
     '(n,t*31)  ','(n,t*32)  ','(n,t*33)  ','(n,t*34)  ','(n,t*35)  ',&
     '(n,t*36)  ','(n,t*37)  ','(n,t*38)  ','(n,t*39)  ','(n,t*40)  ',&
     '(n,t*41)  ','(n,t*42)  ','(n,t*43)  ','(n,t*44)  ','(n,t*45)  ',&
     '(n,t*46)  ','(n,t*47)  ','(n,t*48)  ','(n,t*c)   ',             & !350
     '(n,he3*0) ',&
     '(n,he3*1) ','(n,he3*2) ','(n,he3*3) ','(n,he3*4) ','(n,he3*5) ',&
     '(n,he3*6) ','(n,he3*7) ','(n,he3*8) ','(n,he3*9) ','(n,he3*10)',&
     '(n,he3*11)','(n,he3*12)','(n,he3*13)','(n,he3*14)','(n,he3*15)',&
     '(n,he3*16)','(n,he3*17)','(n,he3*18)','(n,he3*19)','(n,he3*20)',&
     '(n,he3*21)','(n,he3*22)','(n,he3*23)','(n,he3*24)','(n,he3*25)',&
     '(n,he3*26)','(n,he3*27)','(n,he3*28)','(n,he3*29)','(n,he3*30)',&
     '(n,he3*31)','(n,he3*32)','(n,he3*33)','(n,he3*34)','(n,he3*35)',&
     '(n,he3*36)','(n,he3*37)','(n,he3*38)','(n,he3*39)','(n,he3*40)',&
     '(n,he3*41)','(n,he3*42)','(n,he3*43)','(n,he3*44)','(n,he3*45)',&
     '(n,he3*46)','(n,he3*47)','(n,he3*48)','(n,he3*c) ',             & !400
     '(n,a*0)   ',&
     '(n,a*1)   ','(n,a*2)   ','(n,a*3)   ','(n,a*4)   ','(n,a*5)   ',&
     '(n,a*6)   ','(n,a*7)   ','(n,a*8)   ','(n,a*9)   ','(n,a*10)  ',&
     '(n,a*11)  ','(n,a*12)  ','(n,a*13)  ','(n,a*14)  ','(n,a*15)  ',&
     '(n,a*16)  ','(n,a*17)  ','(n,a*18)  ','(n,a*19)  ','(n,a*20)  ',&
     '(n,a*21)  ','(n,a*22)  ','(n,a*23)  ','(n,a*24)  ','(n,a*25)  ',&
     '(n,a*26)  ','(n,a*27)  ','(n,a*28)  ','(n,a*29)  ','(n,a*30)  ',&
     '(n,a*31)  ','(n,a*32)  ','(n,a*33)  ','(n,a*34)  ','(n,a*35)  ',&
     '(n,a*36)  ','(n,a*37)  ','(n,a*38)  ','(n,a*39)  ','(n,a*40)  ',&
     '(n,a*41)  ','(n,a*42)  ','(n,a*43)  ','(n,a*44)  ','(n,a*45)  ',&
     '(n,a*46)  ','(n,a*47)  ','(n,a*48)  ','(n,a*c)   ',             & !450
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',& !475
     '(n,2n*0)  ',&
     '(n,2n*1)  ','(n,2n*2)  ','(n,2n*3)  ','(n,2n*4)  ','(n,2n*5)  ',&
     '(n,2n*6)  ','(n,2n*7)  ','(n,2n*8)  ','(n,2n*9)  ','(n,2n*10) ',&
     '(n,2n*11) ','(n,2n*12) ','(n,2n*13) ','(n,2n*14) ','(n,2n*15) ',&
     '(n,2n*c)  ',                                                    &
     '(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ','(n,x)     ',&
     '(n,x)     ','(n,x)     ','(n,x)     '/)
   character(10),parameter::h719='(n,p*c)x  '
   character(10),parameter::h739='(n,d*c)x  '
   character(10),parameter::h759='(n,t*c)x  '
   character(10),parameter::h779='(n,he3*c)x'
   character(10),parameter::h799='(n,a*c)x  '
   character(10),dimension(7),parameter::hndf9=(/'(n,xn)    ',&
     '(n,xgma)  ','(n,xp)    ','(n,xd)    ','(n,xt)    ',&
     '(n,xhe3)  ','(n,xa)    '/)
   character(10)::hndf10(1)='damage    '

   !-- default name value is blank unless reset below.
   name=''

   !--when iverf=-1 the endf version used to create this file is
   !  unknown.  we assume it comes from version 6 but if the file
   !  originated from version 5 or earlier the name assigned here
   !  might be incorrect.

   if (iverf.ge.6.or.iverf.eq.-1) then
      if (mt.ge.201.and.mt.le.207) then
         name=hndf9(mt-200)
      else if (mt.eq.444) then
         name=hndf10(1)
      else
         i=mt
         if (i.gt.999) i=i-1000*(i/1000)
         if (i.ge.600) i=i-399
         name=hndf(i)
      endif
   else
      if (mt.le.200) then
         name=hndf(mt)
      else if (mt.ge.201.and.mt.le.207) then
         name=hndf9(mt-200)
      else if (mt.eq.444) then
         name=hndf10(1)
      else if (mt.ge.700.and.mt.lt.718) then
         name=hndf(mt-499)
      else if (mt.eq.718) then
         name=hndf(250)
      else if (mt.eq.719) then
         name=h719
      else if (mt.ge.720.and.mt.lt.738) then
         name=hndf(mt-469)
      else if (mt.eq.738) then
         name=hndf(300)
      else if (mt.eq.739) then
         name=h739
      else if (mt.ge.740.and.mt.lt.758) then
         name=hndf(mt-439)
      else if (mt.eq.758) then
         name=hndf(350)
      else if (mt.eq.759) then
         name=h759
      else if (mt.ge.760.and.mt.lt.779) then
         name=hndf(mt-409)
      else if (mt.eq.778) then
         name=hndf(400)
      else if (mt.eq.779) then
         name=h779
      else if (mt.ge.780.and.mt.lt.798) then
         name=hndf(mt-379)
      else if (mt.eq.798) then
         name=hndf(450)
      else if (mt.eq.799) then
         name=h799
      endif
   endif

   !--alternate name when processing incident charged particle files
   if (izai.gt.1) then
      if (mt.eq.4) then
         name='(z,n)    '
      elseif (mt.eq.5) then
         name='(z,x)    '
      elseif ((izai.eq.1001.and.mt.eq.103).or.&
              (izai.eq.1002.and.mt.eq.104).or.&
              (izai.eq.1003.and.mt.eq.105).or.&
              (izai.eq.2003.and.mt.eq.106).or.&
              (izai.eq.2004.and.mt.eq.107)) then
         name=hndf(4)
      endif
   endif

   return
   end subroutine mtname

   subroutine ptleg2(a)
   !-------------------------------------------------------------------
   ! Used only for newfor=1.  Works on MF4 sections with Legendre
   ! coefficients or MF6/LAW=2 sections from File 6 with Legendre
   ! coefficients and converts them into tabulated distributions
   ! adjusted to have a cummulative sum of 1.
   !-------------------------------------------------------------------
   use util ! provides error,mess
   use mathm ! provides legndr
   use endf ! provides endf routines and variables
   ! externals
   real(kr)::a(*)
   ! internals
   integer::nord,j,negs,ii,i,idone,nn,jj,k
   integer,parameter::maxang=7000
   integer,parameter::imax=24
   integer,parameter::ipmax=65
   real(kr)::e,dy,dm,xm,ym,yt,test,xl,yl,check,dco,f,diff
   real(kr)::aco(maxang),cprob(maxang),cumm(maxang)
   real(kr)::x(imax),y(imax),p(ipmax),fl(ipmax)
   character(32)::strng
   real(kr),parameter::one=1.e0_kr
   real(kr),parameter::half=.5e0_kr
   real(kr),parameter::tenth=.1e0_kr
   real(kr),parameter::tol1=0.0002e0_kr
   real(kr),parameter::tol2=0.002e0_kr
   real(kr),parameter::pmin=1.e-10_kr
   real(kr),parameter::zero=0

   !--get the legendre coefficients
   e=a(2)
   nord=nint(a(5))
   if (nord+1.gt.ipmax) then
      write(strng,'(''nord='',i3,'' > ipmax='',i3,'', in mt '',i3)')&
                      nord,ipmax,mth
      call error('ptleg2',strng,'see ipmax')
   endif
   if (nord.ne.0) then
      do j=1,nord
         fl(j)=a(6+j)
      enddo
   else
      nord=1
      fl(1)=0
   endif

   !--use adaptive reconstruction of the angular distribution
   !--use tight tolerances to avoid misconvergences
   negs=0
   ii=0
   cumm(1)=0
   ! prime the adaptive stack
   i=2
   x(2)=-1
   y(2)=half
   call legndr(x(2),p,nord)
   do j=1,nord
      y(2)=y(2)+half*(2*j+1)*fl(j)*p(j+1)
   enddo
   x(1)=1
   y(1)=half
   call legndr(x(1),p,nord)
   do j=1,nord
      y(1)=y(1)+half*(2*j+1)*fl(j)*p(j+1)
   enddo
   ! carry out the adaptive reconstruction
   do while (i.gt.0)
      dy=0
      if (i.gt.1.and.i.lt.imax) then
         dm=x(i-1)-x(i)
         xm=half*(x(i-1)+x(i))
         xm=sigfig(xm,3,0)
         if (xm.gt.x(i).and.xm.lt.x(i-1)) then
            ym=half*(y(i-1)+y(i))
            yt=half
            call legndr(xm,p,nord)
            do j=1,nord
               yt=yt+half*(2*j+1)*fl(j)*p(j+1)
            enddo
            test=tol1*abs(yt)+one/1000000
            dy=abs(yt-ym)
            if (dm.gt.tenth) dy=2*test
            if (ym.ne.zero.and.yt/ym.gt.one*5) dy=2*test
            if (ym.ne.zero.and.yt/ym.lt.one/5) dy=2*test
         endif
      endif
      if (dy.gt.test) then
         ! not converged.
         ! add midpoint to stack and continue.
         i=i+1
         x(i)=x(i-1)
         y(i)=y(i-1)
         x(i-1)=xm
         y(i-1)=yt
      else
         ! converged.
         ! use top point in stack.
         ii=ii+1
         if (ii.gt.maxang) call error('ptleg2','too many angles',' ')
         aco(ii)=x(i)
         if (y(i).lt.pmin) then
            y(i)=pmin
            negs=negs+1
         endif
         cprob(ii)=y(i)
         if (ii.gt.1) cumm(ii)=cumm(ii-1)+half*(x(i)-xl)*(y(i)+yl)
         xl=x(i)
         yl=y(i)
         i=i-1
      endif
   enddo
   if (negs.gt.0) then
      write(strng,'(i4,'' for mt='',i3,'' e='',1p,e10.3)') negs,mth,e
      call mess('ptleg2','negative probs found',strng)
   endif
   nn=ii-1

   !--now thin the distribution to a coarser tolerance
   i=1
   ii=1
   aco(ii)=-1
   idone=0
   do while (i.lt.nn-1.and.idone.eq.0)
      check=0
      dco=0
      j=i+1
      do while (j.lt.nn+1.and.check.le.zero.and.dco.le.one)
         j=j+1
         jj=j-1
         dco=aco(j)-aco(i)
         if (dco.le.one) then
            k=i
            do while (k.lt.j-1.and.check.le.zero)
               k=k+1
               f=(aco(j)-aco(k))/dco
               test=f*cprob(i)+(1-f)*cprob(j)
               diff=one/10000000+tol2*cprob(k)
               check=abs(test-cprob(k))-diff
            enddo
         endif
      enddo
      if (check.gt.zero.or.dco.gt.one) then
         i=jj
         ii=ii+1
         aco(ii)=aco(i)
         cprob(ii)=cprob(i)
         if (ii.gt.1) cumm(ii)=cumm(ii-1)&
           +half*(aco(ii)-aco(ii-1))*(cprob(ii)+cprob(ii-1))
      else
         idone=1
      endif
   enddo
   i=nn+1
   ii=ii+1
   aco(ii)=aco(i)
   cprob(ii)=cprob(i)
   cumm(ii)=cumm(ii-1)+half*(aco(ii)-aco(ii-1))*(cprob(ii)+cprob(ii-1))

   !--load the new distribution in the output list
   a(5)=1
   a(6)=ii
   a(7)=ii
   a(8)=2
   do i=1,ii
      a(7+2*i)=aco(i)
      a(8+2*i)=cprob(i)/cumm(ii)
   enddo
   return
   end subroutine ptleg2

   subroutine pttab2(a)
   !-------------------------------------------------------------------
   ! Like pttab, but works on tabulated sections from File 4 or
   ! LAW2 in File 6 and checks the cummulative normalization.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::a(*)
   ! internals
   integer::nr,np,i
   real(kr)::cumm
   real(kr),allocatable::amu(:),pmu(:)

   !--check normalization
   nr=nint(a(5))
   np=nint(a(6))
   allocate(amu(np))
   allocate(pmu(np))
   cumm=0
   do i=1,np
      amu(i)=a(5+2*nr+2*i)
      pmu(i)=a(6+2*nr+2*i)
      if (i.gt.1) then
         cumm=cumm+(amu(i)-amu(i-1))*(pmu(i)+pmu(i-1))/2
      endif
   enddo

   !--write out the modified record
   a(5)=1
   a(6)=np
   a(7)=np
   a(8)=2
   do i=1,np
      a(7+2*i)=amu(i)
      a(8+2*i)=pmu(i)/cumm
   enddo
   deallocate(amu)
   deallocate(pmu)
   return
   end subroutine pttab2

   real(kr) function bachaa(iza1i,iza2,izat,e,ep)
   !-------------------------------------------------------------------
   ! Compute the Kalbach a parameter.
   !-------------------------------------------------------------------
   use physics ! provides amassn,amu,ev,clight
   use util ! provides error
   ! externals
   integer::iza1i,iza2,izat
   real(kr)::e,ep
   ! internals
   integer::iza1,iza,na
   real(kr)::emc2,aa,za,ac,zc,ab,zb,sa,sb,ecm,ea,eb,x1,x3
   real(kr)::fa,fb,bb,fact,test,nc,nb
   character(60)::strng
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::twoth=.666666667e0_kr
   real(kr),parameter::fourth=1.33333333e0_kr
   real(kr),parameter::c1=15.68e0_kr
   real(kr),parameter::c2=-28.07e0_kr
   real(kr),parameter::c3=-18.56e0_kr
   real(kr),parameter::c4=33.22e0_kr
   real(kr),parameter::c5=-0.717e0_kr
   real(kr),parameter::c6=1.211e0_kr
   real(kr),parameter::s2=2.22e0_kr
   real(kr),parameter::s3=8.48e0_kr
   real(kr),parameter::s4=7.72e0_kr
   real(kr),parameter::s5=28.3e0_kr
   real(kr),parameter::b1=0.04e0_kr
   real(kr),parameter::b2=1.8e-6_kr
   real(kr),parameter::b3=6.7e-7_kr
   real(kr),parameter::d1=9.3e0_kr
   real(kr),parameter::ea1=41.e0_kr
   real(kr),parameter::ea2=130.e0_kr
   real(kr),parameter::emev=1.e6_kr

   emc2=amassn*amu*clight*clight/ev/emev

   iza1=iza1i
   if (iza1i.eq.0) iza1=1
   iza=izat
   if (iza.eq.6000) iza=6012
   if (iza.eq.12000) iza=12024
   if (iza.eq.14000) iza=14028
   if (iza.eq.16000) iza=16032
   if (iza.eq.17000) iza=17035
   if (iza.eq.19000) iza=19039
   if (iza.eq.20000) iza=20040
   if (iza.eq.22000) iza=22048
   if (iza.eq.23000) iza=23051
   if (iza.eq.24000) iza=24052
   if (iza.eq.26000) iza=26056
   if (iza.eq.28000) iza=28058
   if (iza.eq.29000) iza=29063
   if (iza.eq.31000) iza=31069
   if (iza.eq.40000) iza=40090
   if (iza.eq.42000) iza=42096
   if (iza.eq.48000) iza=48112
   if (iza.eq.49000) iza=49115
   if (iza.eq.50000) iza=50120
   if (iza.eq.63000) iza=63151
   if (iza.eq.72000) iza=72178
   if (iza.eq.74000) iza=74184
   if (iza.eq.82000) iza=82208
   aa=mod(iza,1000)
   if (aa.eq.0.) then
      write(strng,'(''dominant isotope not known for '',i8)') iza
      call error('bachaa',strng,' ')
   endif
   za=int(iza/1000)
   ac=aa+mod(iza1,1000)
   zc=za+int(iza1/1000)
   ab=ac-mod(iza2,1000)
   zb=zc-int(iza2/1000)
   na=nint(aa-za)
   nb=nint(ab-zb)
   nc=nint(ac-zc)
   sa=c1*(ac-aa)&
     +c2*((nc-zc)**2/ac-(na-za)**2/aa)&
     +c3*(ac**twoth-aa**twoth)&
     +c4*((nc-zc)**2/ac**fourth-(na-za)**2/aa**fourth)&
     +c5*(zc**2/ac**third-za**2/aa**third)&
     +c6*(zc**2/ac-za**2/aa)
   if (iza1.eq.1002) sa=sa-s2
   if (iza1.eq.1003) sa=sa-s3
   if (iza1.eq.2003) sa=sa-s4
   if (iza1.eq.2004) sa=sa-s5
   sb=c1*(ac-ab)&
     +c2*((nc-zc)**2/ac-(nb-zb)**2/ab)&
     +c3*(ac**twoth-ab**twoth)&
     +c4*((nc-zc)**2/ac**fourth-(nb-zb)**2/ab**fourth)&
     +c5*(zc**2/ac**third-zb**2/ab**third)&
     +c6*(zc**2/ac-zb**2/ab)
   if (iza2.eq.1002) sb=sb-s2
   if (iza2.eq.1003) sb=sb-s3
   if (iza2.eq.2003) sb=sb-s4
   if (iza2.eq.2004) sb=sb-s5
   ecm=aa*e/ac
   ea=ecm+sa
   eb=ep*ac/ab+sb
   x1=eb
   if (ea.gt.ea2) x1=ea2*eb/ea
   x3=eb
   if (ea.gt.ea1) x3=ea1*eb/ea
   fa=1
   if (iza1.eq.2004) fa=0
   fb=1
   if (iza2.eq.1) fb=fb/2
   if (iza2.eq.2004) fb=2
   bb=b1*x1+b2*x1**3+b3*fa*fb*x3**4
   if (iza1i.eq.0) then
      fact=d1
      if (ep.ne.0.) fact=fact/sqrt(ep)
      test=1
      if (fact.lt.test) fact=test
      test=4
      if (fact.gt.test) fact=test
      bb=bb*sqrt(e/(2*emc2))*fact
   endif
   bachaa=bb
   return
   end function bachaa

   real(kr) function eavl(akal,amass,avcm,avadd,fmsd,sign)
   !-------------------------------------------------------------------
   ! Analytically calculates the average energy (lab) assuming
   ! Kalbach systematics for c.m. angular distribution.
   ! Note: sign=1. is for particles. sign=-1 = for recoils
   ! since theta-r=pi-theta-p, cos(theta-r)=-cos(theta-p), and
   ! Kalbach exponentials just have sign flipped for recoils.
   !--***************************************************************
   use physics ! provides pi
   ! externals
   real(kr)::akal,amass,avcm,avadd,fmsd,sign
   ! internals
   real(kr)::r,s

   ! writing the kalbach function in the following form
   ! p = f1 exp(a cos theta) + f2 exp(-a cos theta)
   ! f1=(1/(4*pi))*(akal/(exp(akal)-exp(-akal)))*(1+fmsd)
   ! f2=(1/(4*pi))*(akal/(exp(akal)-exp(-akal)))*(1-fmsd)
   ! if (akal.eq.0.) f1=(1/(4*pi))*(1+fmsd)/2
   ! if (akal.eq.0.) f2=(1/(4*pi))*(1-fmsd)/2
   ! the lab average energy is given by
   r=avcm*avcm+avadd*avadd
   s=2*avcm*avadd
   eavl=amass*(r/2+(fmsd*s*fi2(sign*akal)/(fi1(sign*akal)*2)))
   return
   end function eavl

   real(kr) function fi1(aa)
   !-------------------------------------------------------------------
   ! Solution of first type of integral for average energy.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::aa
   ! internals
   real(kr),parameter::zero=0

   if (aa.eq.zero) then
      fi1=2
   else
      fi1=(exp(aa)-exp(-aa))/aa
   endif
   return
   end function fi1

   real(kr) function fi2(aa)
   !-------------------------------------------------------------------
   ! Solution of second type of integral for average energy.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::aa
   ! internals
   real(kr),parameter::zero=0

   if (aa.eq.zero) then
      fi2=0
   else
      fi2=((exp(aa)+exp(-aa))/aa)-((exp(aa)-exp(-aa))/(aa*aa))
   endif
   return
   end function fi2

   subroutine newsuff(mcnpx,suff,hz)
   !
   !--update the zaid suffix
   !
   !  - In MCNP zaid's are given in a 10 element character variable, but
   !    legacy njoy coding puts this information in the leading ten elements
   !    of a 13 element character variable.  The zaid consists of three
   !    parts ...
   !    - a string of up to 6 characters and/or digits, followed by a period;
   !    - a two digit cross section identifier (the suffix);
   !    - a single character data class identifier (e.g., "c" for continuous
   !      energy, "t" for thermal scattering kernel, etc).
   !  - The information is right shifted within the string such that the
   !    single character class identifier occurs in the 10th element.
   !
   !  - In MCNPX an expanded format is defined, utilizing a 13 element
   !    character variable consisting of ...
   !    - a string of up to 6 characters and/or digits, followed by a period;
   !    - a three digit cross section identifier (the suffix);
   !    - a three character data class identifier (e.g., "nt " for incident
   !      neutron thermal scattering kernels, etc).
   !  - The information is right shifted within the string such that the three
   !    character class identifier occupies the 11th through 13th elements of
   !    the zaid identifier (and the 13th element is blank).
   !
   !  - If mcnpx>0, use the MCNPX format, otherwise use the MCNP format.
   !

   use util ! provides error,mess

   ! external variables ...
   character(len=13)::hz
   integer::mcnpx
   real(kr)::suff

   ! local variables ...
   integer::i
   integer::indx,idiff,lenhz

   lenhz=len_trim(hz)                                  !# of characters in the zaid
   indx=index(hz,".",.TRUE.)                           !locate the last .

   if (indx.lt.1 .or. indx.gt.7) then
      call mess('newsuff','zaid name is nonstandard, no change made','')
      return
   endif

   if (mcnpx.gt.0) then
      write(hz(indx+1:indx+3),'(i3.3)')nint(1000*suff) !insert the new suffix
   else
      write(hz(indx+1:indx+2),'(i2.2)')nint(100*suff)  !insert the new suffix
   endif

   indx=10
   if (mcnpx.gt.0) indx=12

   if (lenhz.lt.indx) then
      idiff=indx-lenhz
      do i=indx,indx-lenhz+1,-1            !push the string to the right so
         hz(i:i)=hz(i-idiff:i-idiff)       !class id goes in column 10 or 12,
      enddo                                !depending on mcnpx.
      hz(1:idiff)=" "                      !blank out any old leading elements.
   endif

   return
   end subroutine newsuff

   subroutine advance_to_locator(nout,l,locator)
   !-------------------------------------------------------------------
   ! Advance to the next locator position from the current position l.
   ! If the current position is not equal to the locator position, the
   ! function will advance l until it is equal to the locator position.
   ! It will write the values in the xss array while advancing to the
   ! new position.
   !-------------------------------------------------------------------
   use util
   ! externals
   integer::nout,l,locator
   ! internals
   character(66)::text
   if (l.lt.locator) then
      write(text,'(''expected xss index ('',i6,'') greater than '',&
                   &''current index ('',i6,'')'')') locator, l
      call mess('advance',text,'xss array was padded accordingly')
      do while (l.lt.locator)
         call typen(l,nout,1)
         l=l+1
      enddo
   else if (l.gt.locator) then
      write(text,'(''expected xss index ('',i6,'') less than '',&
                   &''current index ('',i6,'')'')') locator, l
      call error('advance',text,'this may be a serious problem')
   endif
   return
   end subroutine advance_to_locator

   subroutine write_integer(nout,l)
   !-------------------------------------------------------------------
   ! Write an integer value at the position l, and advance l to the
   ! next position
   !-------------------------------------------------------------------
   ! externals
   integer::nout,l
   call typen(l,nout,1)
   l=l+1
   return
   end subroutine write_integer

   subroutine write_real(nout,l)
   !-------------------------------------------------------------------
   ! Write a real value at the position l, and advance l to the
   ! next position
   !-------------------------------------------------------------------
   ! externals
   integer::nout,l
   call typen(l,nout,2)
   l=l+1
   return
   end subroutine write_real

   subroutine write_integer_list(nout,l,n)
   !-------------------------------------------------------------------
   ! Write n integer values from position l, and advance l to the
   ! next position
   !-------------------------------------------------------------------
   ! externals
   integer::nout,l,n
   ! internals
   integer::i
   do i=1,n
      call typen(l,nout,1)
      l=l+1
   enddo
   return
   end subroutine write_integer_list

   subroutine write_real_list(nout,l,n)
   !-------------------------------------------------------------------
   ! Write n real values from position l, and advance l to the
   ! next position
   !-------------------------------------------------------------------
   ! externals
   integer::nout,l,n
   ! internals
   integer::i
   do i=1,n
      call typen(l,nout,2)
      l=l+1
   enddo
   return
   end subroutine write_real_list

   subroutine typen(l,nout,iflag)
   !-------------------------------------------------------------------
   ! Write an integer or a real number to a Type-1 ACE file,
   ! using either a floating-point or an integer print style.
   ! Use iflag.eq.1 to write an integer (i20).
   ! Use iflag.eq.2 to write a real number (1pe20.11).
   ! Use iflag.eq.3 to write partial line at end of file.
   !-------------------------------------------------------------------
   ! externals
   integer::l,nout,iflag
   ! internals
   integer::i,j
   character(20)::hl(4)
   save hl,i

   if (iflag.eq.3.and.nout.gt.1.and.i.lt.4) then
      write(nout,'(4a20)') (hl(j),j=1,i)
   else
      i=mod(l-1,4)+1
      if (iflag.eq.1) write(hl(i),'(i20)') nint(xss(l))
      if (iflag.eq.2) write(hl(i),'(1p,e20.11)') xss(l)
      if (i.eq.4) write(nout,'(4a20)') (hl(j),j=1,i)
   endif
   return
   end subroutine typen

end module acecm

module wimsm
   ! provides subroutine wimsr for NJOY2016
   use locale
   implicit none
   private
   public wimsr
   ! global wimsr variables
   integer::iprint
   integer::iverw
   integer::ngnd,nfg,nrg,igref
   integer::mat
   integer::nfid
   real(kr)::rdfid
   integer::iburn
   integer::ntemp
   integer,parameter::ntmax=10
   real(kr)::tempr(ntmax)
   integer::nsigz
   real(kr)::sgref
   integer::ires
   real(kr)::sigp
   integer::mti,mtc
   integer::ip1opt
   integer::inorf
   integer::isof
   integer::ifprod
   integer::ngendf,nout,nscr0,nscr1,nscr2,nscr3,nscr4
   real(kr)::awr
   integer::iznum
   integer,parameter::nymax=100
   real(kr)::yield(nymax)
   integer::ifisp(nymax)
   integer::ifiss,nfiss
   integer::isg
   integer::ixs
   real(kr),dimension(:),allocatable::snu
   real(kr),dimension(:),allocatable::spot
   real(kr),dimension(:),allocatable::abs2
   real(kr),dimension(:),allocatable::uff
   real(kr),dimension(:),allocatable::glam
   real(kr),dimension(:),allocatable::p1flx
   real(kr),dimension(:),allocatable::flux
   real(kr),dimension(:),allocatable::egb
   integer,parameter::nwscr=30000
   real(kr),dimension(:),allocatable::scr
contains

   subroutine wimsr
   !--------------------------------------------------------------------
   !
   ! Format multigroup cross sections from groupr for WIMS.
   !
   !---input specifications (free format)----
   !
   ! card 1
   !    ngendf  unit for input gendf tape
   !    nout    unit for output wims tape
   !
   ! card 2
   !    iprint  print option
   !               0=minimum (default)
   !               1=regular
   !               2=1+intermediate results
   !    iverw   wims version
   !               4=wims-d (default)
   !               5=wims-e
   !    igroup  group option
   !               0=69 groups (default)
   !               9=user's choice
   !
   ! card 2a  (igroup.eq.9 only)
   !    ngnd    number of groups
   !    nfg     number of fast groups
   !    nrg     number of resonance groups
   !    igref   reference group (default is last fast group)
   !
   ! card 3
   !    mat     endf mat number of the material to be processed
   !    nfid    not used
   !    rdfid   identification of material for the wims library
   !    iburn   burnup data option
   !              -1=suppress printout of burnup data
   !               0=no burnup data is provided (default)
   !               1=burnup data is provided in cards 5 and 6
   !
   ! card  4
   !    ntemp   no. of temperatures to process for this material
   !            in the thermal energy range
   !               (0=all found on input tape)
   !    nsigz   no. of sigma zeroes to process for this material
   !               (0=all found on input tape)
   !    sgref   reference sigma zero
   !               (.ge. 1.e10 to select all cross sect. at inf.dil.*
   !                           but fully shielded elastic x-sect,
   !                .lt. 1.e10 to select all x-sect at inf.dil.
   !                =sig0      from the list on groupr input to
   !                           select all x-sect. at that sig0)
   !    ires    resonance absorber indicator
   !               0=no resonance tables
   !              >0=ires temperatures processed
   !    sigp    potential cross section from endf.
   !               (if zero, replace by the elastic cross section)
   !    mti     thermal inelastic mt (default=0=none)
   !    mtc     thermal elastic mt (default=0=none)
   !    ip1opt  include p1 matrices
   !               0=yes
   !               1=no, correct p0 ingroups (default)
   !    inorf   resonance fission (if found)
   !               0=include resonance fission (default)
   !               1=do not include
   !    isof    fission spectrum
   !               0=do not include fission spectrum (default)
   !               1=include fission spectrum
   !    ifprod  fission product flag
   !               0=not a fission product (default)
   !               1=fission product, no resonance tables
   !               2=fission product, resonance tables
   !    jp1     transport correction neutron current spectrum flag
   !               0=use p1-flux for transport correction (default)
   !              >0=read in jp1 values of the neutron current
   !                   spectrum from input
   !
   !   the following cards 5 and 6 are for iburn gt 0 only
   ! card  5
   !    ntis    no. of time-dependent isotopes
   !            for burnable materials ntis=2
   !            for fissile materials ntis>2 when fission product
   !            yields are given.
   !    efiss   energy released per fission
   !
   ! card  6a
   !    identa  ident of capture product isotope
   !    yield   yield of product identa from capture
   !
   ! card  6b
   !    identa  ident of decay product isotope (zero if stable)
   !    lambda  decay constant (s-1)
   !
   ! card  6c  (repeated ntis-2 times, if necessary)
   !    identa  ident of fission product isotope
   !    yield   fission yield of identa from burnup of mat
   !
   ! card  7
   !    lambda  resonance-group goldstein lambdas (13 for
   !            default 69-group structure, nrg otherwise).
   !
   ! card  8    (only when jp1>0)
   !    p1flx   current spectrum (jp1 entries read, the rest are
   !            set with the default p1-flux calculated by njoy).
   !--------------------------------------------------------------------
   use util ! provides timer,openz,repoz,error
   use mainio ! provides nsysi,nsyso,nsyse
   integer::igroup,jp1,jcc,ij,i,j,ntis
   real(kr)::sec,efiss

   call timer(sec)
   write(nsyso,&
     '(/'' wimsr...create data for wims'',40x,f8.1,''s'')') sec
   write(nsyse,'(/'' wimsr...'',60x,f8.1,''s'')') sec
   nscr0=10
   nscr1=11
   nscr2=12
   nscr3=13
   nscr4=14

   !--read and write user input.
   read(nsysi,*) ngendf,nout
   nout=iabs(nout)
   call openz(ngendf,0)
   iprint=0
   iverw=4
   igroup=0
   read(nsysi,*) iprint,iverw,igroup
   write(nsyso,'(/&
     &'' input gendf unit ..................... '',i10/&
     &'' output unit .......................... '',i10/&
     &'' print option ......................... '',i10/&
     &'' wims version ......................... '',i10/&
     &'' group structure ...................... '',i10)')&
     ngendf,nout,iprint,iverw,igroup
   if (igroup.eq.0) then
      ngnd=69
      nfg=14
      nrg=13
      igref=nfg
   else if (igroup.eq.9) then
      igref=0
      read(nsysi,*) ngnd,nfg,nrg,igref
      if (igref.eq.0) igref=nfg
   endif
   write(nsyso,'(/&
     &'' ngnd ................................. '',i10/&
     &'' nfg .................................. '',i10/&
     &'' nrg .................................. '',i10/&
     &'' igref ................................ '',i10)')&
     ngnd,nfg,nrg,igref
   ixs=1
   call openz(nout,1)
   call repoz(nout)
   allocate(scr(nwscr))

   !--input material data
   iburn=0
   read(nsysi,*) mat,nfid,rdfid,iburn
   nfid=nint(rdfid)
   write(nsyso,'(/&
     &'' endf mat number ...................... '',i10/&
     &'' wims material identifier ............. '',i10/&
     &'' wims resonance identifier ............ '',f12.1/&
     &'' burn data (0=no, 1=yes, def=0) ....... '',i10)')&
     mat,nfid,rdfid,iburn
   ip1opt=1
   inorf=0
   isof=0
   ifprod=0
   jp1=0
   read(nsysi,*) ntemp,nsigz,sgref,ires,sigp,mti,mtc,&
     ip1opt,inorf,isof,ifprod,jp1
   if (ifprod.gt.0) then
      ifprod=1
      if (ires.gt.0) ifprod=2
   endif
   write(nsyso,'(/&
     &'' no. temperatures (thermal)............ '',i10/&
     &'' no. sigma zeroes ..................... '',i10/&
     &'' reference sigma zero ................. '',1p,e10.2/&
     &'' resonance absorber (0=no, >0=no.temp.) '',i10/&
     &'' pot. scatt. cross section ............ '',0p,f10.2/&
     &'' thermal inelastic mt ................. '',i10/&
     &'' thermal elastic mt ................... '',i10/&
     &'' p1 matrix option (0=yes, 1=no) ....... '',i10/&
     &'' resonance fission option (0=yes, 1=no) '',i10/&
     &'' fission spectrum option (0=no, 1=yes)  '',i10/&
     &'' fission product indicator ............ '',i10/&
     &'' current spectrum indicator ........... '',i10)')&
     ntemp,nsigz,sgref,ires,sigp,mti,mtc,&
     ip1opt,inorf,isof,ifprod,jp1

   !--input burn data
   yield(1)=0
   ifisp(1)=nfid
   if (iburn.gt.0) then
      read(nsysi,*) ntis,efiss
      if (ntis.gt.nymax) call error('wimsr',&
        'too many time-dependent isotopes',' ')
      jcc=ntis*2+4
      yield(4)=efiss
      ifisp(4)=0
      ij=1
      do i=1,ntis
         if (i.eq.1.or.i.eq.3) ij=ij+1
         read(nsysi,*) ifisp(ij),yield(ij)
         ij=ij+1
      enddo
   endif

   !--input resonance lambdas
   allocate(glam(nrg))
   read(nsysi,*) (glam(j),j=1,nrg)

   !--input current spectrum
   allocate(p1flx(ngnd))
   do j=1,ngnd
      p1flx(j)=0
   enddo
   if (jp1.ge.1) then
      read(nsysi,*) (p1flx(j),j=1,jp1)
   endif

   !--read in the cross section data
   call wminit

   !--process cross sections.
   call xsecs

   !--process effective resonance integrals.
   call resint

   !--process p1 scattering matrix.
   call p1scat

   !--write output tape.
   if (iburn.eq.0) jcc=2
   if (nout.ne.0) call wimout(jcc)

   !--wimsr is finished.
   if (allocated(snu)) deallocate(snu)
   if (allocated(abs2)) deallocate(abs2)
   if (allocated(spot)) deallocate(spot)
   deallocate(flux)
   deallocate(uff)
   deallocate(egb)
   deallocate(p1flx)
   deallocate(glam)
   deallocate(scr)
   call repoz(nout)
   call closz(nout)
   call closz(nscr0)
   call closz(nscr1)
   call closz(nscr2)
   call closz(nscr3)
   call closz(nscr4)
   call timer(sec)
   write(nsyso,&
     '(69x,f8.1,''s''/1x,7(''**********''),''*******'')') sec
   return
   end subroutine wimsr

   subroutine wminit
   !--------------------------------------------------------------------
   ! Store materials from ngendf.
   !--------------------------------------------------------------------
   use util ! provides repoz,mess
   use endf ! provides endf routines and variables
   use mainio ! provides nsysi,nsyso,nsyse
   ! internals
   integer::ngnd1,nb,nw,iza,i,nz,ntw,i1,ngn
   integer::i318,mess3,i618,mess6,i252
   integer::jtemp,nwflx
   character(60)::strng

   !--read gendf tape for groups and flags
   ngnd1=ngnd+1
   allocate(egb(ngnd1))
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.ne.mat) call error('wminit',&
     'desired material is not on gendf tape',' ')
   iza=nint(c1h)
   iznum=iza/1000
   awr=c2h
   allocate(uff(ngnd))
   do i=1,ngnd
      uff(i)=0
   enddo
   nz=l2h
   ntw=n2h
   call listio(ngendf,0,0,scr,nb,nw)
   tempr(1)=c1h
   i1=7+ntw+nz
   ngn=l1h
   if (ngn.ne.ngnd) call error('wminit',&
     'incorrect group structure',' ')
   do i=1,ngnd1
      egb(i)=scr(ngnd1-i+i1)
   enddo
   ! check for presence of mf3, mt252, mf3, mt18 and mf6, mt18.
   i318=0
   mess3=0
   i618=0
   mess6=0
   i252=0
  125 continue
   call tosend(ngendf,0,0,scr)
  130 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 150
   if (mfh.eq.0.or.mth.eq.0) go to 130
   if (mfh.eq.3.and.mth.ge.18.and.mth.le.38) go to 135
   if (mfh.eq.6.and.mth.ge.18.and.mth.le.38) go to 140
   if (mfh.eq.3.and.mth.eq.252) i252=1
   go to 125
  135 continue
   if (mth.gt.21.and.mth.lt.38) go to 125
   if (mth.eq.18) i318=1
   if (mth.eq.18) go to 125
   if (i318.eq.0) go to 125
   if (mess3.gt.0) go to 125
   write(strng,'(''mat '',i4,'' mf '',i2,&
     &'' has both mt18 and mt'',i2)') math,mfh,mth
   call mess('wminit',strng,'mt18 will be used')
   mess3=1
   if (mess3.gt.0.and.mess6.gt.0) go to 150
   go to 125
  140 continue
   if (mth.gt.21.and.mth.lt.38) go to 125
   if (mth.eq.18) i618=1
   if (mth.eq.18) go to 125
   if (i618.eq.0) go to 125
   if (mess6.gt.0) go to 125
   write(strng,'(''mat '',i4,'' mf '',i2,&
     &'' has both mt18 and mt'',i2)') math,mfh,mth
   call mess('wminit',strng,'mt18 will be used')
   mess6=1
   if (mess3.gt.0.and.mess6.gt.0) go to 150
   go to 125
  150 continue
   if (i252.ne.1) then
     write(strng,'(''mat '',i4,'' has no mf3, mt252 '')') mat
     call mess('wminit',strng,&
       'isotropic c.m.scattering will be assumed')
   endif

   !--check the number of temperatures and sigma zeroes
   jtemp=1
   math=mat
   do while (math.eq.mat)
      call contio(ngendf,0,0,scr,nb,nw)
      if (math.eq.mat) then
         jtemp=jtemp+1
         call listio(ngendf,0,0,scr,nb,nw)
         tempr(jtemp)=c1h
         call tomend(ngendf,0,0,scr)
      endif
   enddo
   if (ntemp.eq.0) ntemp=jtemp
   if (ntemp.gt.jtemp) ntemp=jtemp
   if (ires.gt.0 .and. ntemp.lt.ires) ires=jtemp
   if (nsigz.eq.0) nsigz=nz
   if (nsigz.gt.nz) nsigz=nz
   write(nsyso,'(/'' processing'',i3,'' temperatures''/&
     &'' processing'',i3,'' sigma zeroes'')') ntemp,nsigz
   nwflx=ntemp*nsigz*nrg
   if(ires.gt.ntemp) nwflx=ires*nsigz*nrg
   allocate(flux(nwflx))

   !--print out group structure
   if (iprint.gt.0) write(nsyso,'(/&
     &'' group structure''/'' ---------------''/(1p,6e12.4))')&
     (egb(i),i=1,ngnd1)
   return
   end subroutine wminit

   subroutine resint
   !--------------------------------------------------------------------
   ! Process effective resonance integrals.
   !--------------------------------------------------------------------
   use util ! provides repoz,error
   use endf ! provides endf routines and variables
   use mainio ! provides nsysi,nsyso,nsyse
   ! internals
   integer::ntsr,nwflxr,nwelas,nwfa,nghi,nglo,nb,nw
   integer::i,jg,is,jtemp,jfiss,nl,nz,ntw,l,ig,kg,lim,iadd
   integer::loca,jz,loc,locn,jtem,iterm,ioff,it,index
   integer::indexl,iz
   real(kr)::xid,siglam,sigb,siga,sig
   real(kr),dimension(:),allocatable::sabs
   real(kr),dimension(:),allocatable::snux
   real(kr),dimension(:),allocatable::snsf
   real(kr),dimension(:),allocatable::flxr
   real(kr),dimension(:),allocatable::sigz
   real(kr),dimension(:),allocatable::abs
   real(kr),dimension(:),allocatable::elas
   real(kr),dimension(:),allocatable::fa
   integer,parameter::lz=6
   real(kr),parameter::zero=0

   !--allocate storage.
   if (ires.eq.0) go to 510
   write(nsyso,'(/'' ***resonance integrals***'')')
   ntsr=ires*nsigz*nrg
   allocate(sabs(ntsr))
   allocate(snux(ntsr))
   allocate(snsf(ntsr))
   nwflxr=ires*nsigz
   allocate(flxr(nwflxr))
   allocate(sigz(nsigz))
   allocate(abs(ires))
   nwelas=ires*nsigz*nrg
   allocate(elas(nwelas))
   nwfa=ires*nsigz
   allocate(fa(nwfa))
   nghi=ngnd-nfg
   nglo=nghi-nrg+1

   !--read gendf data
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   do i=1,nwflxr
      flxr(i)=0
   enddo
   do jg=1,nrg
      do is=1,nwflxr
         i=(jg-1)*nwflxr+is
         sabs(i)=abs2(nfg+jg)
         snux(i)=0
         snsf(i)=0
         elas(i)=0
         flux(i)=0
      enddo
   enddo
   jtemp=0
   jfiss=1

   !--loop over temperatures
  130 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.lt.0) go to 400
   nl=l1h
   nz=l2h
   ntw=n2h
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   jtemp=jtemp+1
   do i=1,nsigz
      sigz(nsigz-i+1)=scr(6+ntw+i)
   enddo
   abs(jtemp)=0
   call tosend(ngendf,0,0,scr(l))

   !--loop over reactions
  310 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 320
   if (mfh.eq.0) go to 310
   if (mth.eq.0) go to 310
   xid=mat
   nl=l1h
   nz=l2h
   ntw=n2h

   !--loop over groups for this reaction
  140 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   if (mth.ge.18.and.mth.le.21.and.inorf.gt.0) go to 300
   if (mth.eq.38.and.inorf.gt.0) go to 300
   if (mfh.ne.3) go to 300
   if (mth.eq.1) go to 162
   if (mth.eq.2) go to 162
   if (mth.lt.18.or.mth.gt.150) go to 300
   if (mth.gt.21.and.mth.lt.102.and.mth.ne.38) go to 300
  162 continue
   ig=n2h
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if (l+nw-1.gt.nwscr) call error('resint',&
        'storage exceeded',' ')
   enddo
   if (mth.eq.1.and.ig.eq.ngnd-igref+1) go to 172
   if (ig.ge.nglo.and.ig.le.nghi) go to 172
   go to 290
  172 continue
   kg=ngnd-ig+1
   jg=kg-nfg
   lim=nsigz
   if (nsigz.gt.nz) lim=nz
   if (mth.ne.1.and.mth.ne.2.and.mth.ne.18.and.mth.ne.102) go to 300

   !--absorption
   if (mth.eq.102) then
      iadd=nsigz+nsigz*(jtemp-1+ires*(jg-1))
      loca=l+lz+nl*(nz-1)
      do jz=1,lim
         sabs(iadd-jz+1)=sabs(iadd-jz+1)+scr(nl*jz+loca)
      enddo
      abs(jtemp)=1

   !--flux
   else if (mth.eq.1) then
      if (jg.ge.1.and.jg.le.nrg) then
         loc=1+nsigz+nsigz*(jtemp-1+ires*(jg-1))
         loca=l+lz-nl
         do jz=1,lim
            flux(loc-jz)=scr(nl*jz+loca)
         enddo
      endif
      ! reference group flux
      if (kg.eq.igref) then
         do jz=1,lim
            loca=l+lz+nl*(jz-1)
            loc=1+nsigz-jz+nsigz*(jtemp-1)
            flxr(loc)=scr(loca)
         enddo
      endif

   !--fission
   else if (mth.eq.18) then
      iadd=nsigz+nsigz*(jtemp-1+ires*(jg-1))
      loca=l+lz+nl*(nz-1)
      do jz=1,lim
         snsf(iadd-jz+1)=snsf(iadd-jz+1)+scr(nl*jz+loca)
      enddo
      jfiss=3
      do jz=1,lim
         sabs(iadd-jz+1)=sabs(iadd-jz+1)+scr(nl*jz+loca)
      enddo

   !--elastic
   else if (mth.eq.2) then
      iadd=nsigz+nsigz*(jtemp-1+ires*(jg-1))
      loca=l+lz+nl*(nz-1)
      do jz=1,lim
         elas(iadd-jz+1)=elas(iadd-jz+1)+scr(nl*jz+loca)
      enddo
   endif

   !--continue group loop
  290 continue
   if (ig.lt.ngnd) go to 140
  300 continue
   call tosend(ngendf,0,0,scr)

   !--continue loop over reactions
   go to 310

   !--continue loop over temperatures
  320 continue
   if (jtemp.ge.ires) go to 400
   go to 130

   !--desired data is loaded.
   !--calculate nu times sigma f
  400 continue
   if (jfiss.ne.1) then
      do jg=1,nrg
         locn=nfg+jg
         do jz=1,nsigz
            do jtem=1,ires
               iterm=jz-1+nsigz*ires*(jg-1)-nsigz
               ioff=nsigz*jtem+iterm
                  snux(ioff+1)=snsf(ioff+1)*snu(locn)
               enddo
         enddo
      enddo
   endif

   !--check flux arrays for temperature dependence.
   do jz=1,nsigz
      do it=1,ires
         if (flxr(jz+nsigz*(it-1)).eq.zero) then
            flxr(jz+nsigz*(it-1))=flxr(jz+nsigz*(it-2))
         endif
      enddo
   enddo
   do jg=1,nrg
      do jz=1,nsigz
         do it=1,ires
            index=1+jz-1+nsigz*(it-1+ires*(jg-1))
            if (flux(index).eq.zero) then
               indexl=1+jz-1+nsigz*(it-2+ires*(jg-1))
               flux(index)=flux(indexl)
            endif
         enddo
      enddo
   enddo

   !--correct non-temperature dependent absorption if necessary
   if (ires.ne.1) then
      do it=1,ires
         if (abs(it).le.zero) then
            do jg=1,nrg
               loc=1+nsigz*(it-2+ires*(jg-1))
               loca=loc+nsigz
               do jz=1,nsigz
                  sabs(jz+loca)=sabs(jz+loca)+sabs(jz+loc)
               enddo
            enddo
         endif
      enddo
   endif

   !--convert njoy cross sections to resonance integrals
   do jg=1,nrg
      siglam=spot(nfg+jg)*glam(jg)
      do it=1,ires
         loc=1+nsigz*(it-1+ires*(jg-1))
         do iz=1,nsigz
            sigb=sigz(iz)+siglam
            siga=sabs(loc+iz-1)
            sig=snux(loc+iz-1)
            sabs(loc+iz-1)=sigb*siga/(sigb+siga)
            snux(loc+iz-1)=sigb*sig/(sigb+siga)
         enddo
      enddo
   enddo

   !--write out results
   call rsiout(xid,jfiss,fa,sabs,snux,flxr,sigz,elas)

   !--resint is finished.
  510 continue
   return
   end subroutine resint

   subroutine rsiout(xid,ifiss,b,sabs,snux,flxr,sigz,elas)
   !--------------------------------------------------------------------
   ! Write resonance integrals.
   !--------------------------------------------------------------------
   use util ! provides openz,repoz
   use mainio ! provides nsysi,nsyso,nsyse
   ! externals
   real(kr)::xid
   integer::ifiss
   real(kr)::b(*),sabs(*),snux(*),flxr(*),sigz(*),elas(*)
   ! internals
   integer::nscr,ncol1,lim,ntnp,jg,loc,j,jtemp,n,m,i,ig
   integer::it,locf,locr,jz,il,nb,loca
   real(kr)::siglam,refflx
   real(kr)::c(15)
   character(13),parameter::undl='-------------'
   integer,parameter::nmax=5
   integer,parameter::ncol=8

   nscr=nscr1
   call openz(-nscr,1)
   call repoz(-nscr)
   ncol1=ncol+1
   lim=nsigz
   if (nsigz.gt.ncol) lim=ncol
   if (ifiss.eq.5) ifiss=3
   ntnp=ires*nsigz
   write(nscr) ntnp
   write(nscr) xid,ires,nsigz
   do jg=1,nrg
      siglam=spot(nfg+jg)*glam(jg)
      loc=1+ires*nsigz*(jg-1)
      write(nscr) (tempr(j),j=1,ires),&
        (sigz(j)+siglam,j=1,nsigz),&
        ((sabs(loc-1+nsigz*(jtemp-1)+j),j=1,nsigz),jtemp=1,ires)
      if (ifiss.eq.3) then
         loc=1+ires*nsigz*(jg-1)
         write(nscr) (tempr(j),j=1,ires),&
           (sigz(j)+siglam,j=1,nsigz),&
           ((snux(loc-1+nsigz*(jtemp-1)+j),j=1,nsigz),jtemp=1,ires)
      endif
      if (iverw.ne.4) then
         loc=1+ires*nsigz*(jg-1)
         write(nscr) (tempr(j),j=1,ires),&
           (sigz(j)+siglam,j=1,nsigz),&
           ((elas(loc-1+nsigz*(jtemp-1)+j),j=1,nsigz),jtemp=1,ires)
      endif
   enddo
   n=nsigz
   if (n.gt.nmax) n=nmax
   m=n
   if (m.lt.4) m=4
   write(nsyso,'(/&
     &'' temperatures (down)''/&
     &'' -------------------'')')
   write(nsyso,'(1x,1p,9e11.3)') (tempr(i),i=1,ires)
   write(nsyso,'(/&
     &'' potential cross sections (across)''/&
     &'' ---------------------------------'')')
   write(nsyso,'(1x,1p,9e11.3)') (sigz(i),i=1,nsigz)
   if (iprint.ge.2) then
      write(nsyso,'(/&
        &'' group'',6x,&
        &''flux per unit lethargy normalized at group '',i3/&
        &'' ----------'',6(a))')&
        igref,(undl,i=1,m)
      do ig=1,nrg
         do it=1,ires
            locf=1-1+nsigz*(it-1+ires*(ig-1))
            locr=1-1+nsigz*(it-1)
            do jz=1,nsigz
               refflx=flxr(jz+locr)/log(egb(igref)/egb(igref+1))
               c(jz)=flux(jz+locf)/log(egb(nfg+ig)/egb(nfg+ig+1))
               c(jz)=c(jz)/refflx
            enddo
            jg=ig+nfg
            if (it.eq.1) then
               write(nsyso,'(/i5,5x,1p,9e13.5)') jg,(c(i),i=1,lim)
            endif
            if (it.eq.1.and.nsigz.gt.ncol) then
               write(nsyso,'(10x,1p,9e13.5)') (c(i),i=ncol1,nsigz)
            endif
            if (it.gt.1) then
               write(nsyso,'(10x,1p,9e13.5)') (c(i),i=1,nsigz)
            endif
         enddo
      enddo
   endif

   if (iprint.eq.0) return
   il=1
   write(nsyso,'(/&
     &'' group'',6x,''absorption''/&
     &'' ----------'',5(a))')&
     (undl,i=1,n)
   if (il.ne.2.or.ifiss.ge.2) then
      do ig=1,nrg
         nb=0
         jg=ig+nfg
         do it=1,ires
            loca=nsigz*(it-1+ires*(ig-1))
            do jz=1,nsigz
               nb=nb+1
               b(nb)=sabs(jz+loca)
               c(jz)=b(nb)
            enddo
            if (il.ne.2.or.ifiss.ne.1) then
               if (it.eq.1) write(nsyso,'(/i5,5x,1p,9e13.5)')&
                 jg,(c(i),i=1,lim)
               if (it.eq.1.and.nsigz.gt.ncol)&
                 write(nsyso,'(10x,1p,9e13.5)')&
                 (c(i),i=ncol1,nsigz)
               if (it.gt.1) write(nsyso,'(10x,1p,9e13.5)')&
                 (c(i),i=1,lim)
               if (it.gt.1.and.nsigz.gt.ncol)&
                 write(nsyso,'(10x,1p,9e13.5)')&
                 (c(i),i=ncol1,nsigz)
            endif
         enddo
      enddo
   endif
   il=2
   if (il.ne.2.or.ifiss.ge.2) then
      write(nsyso,'(/&
        &'' group'',6x,''fission yield''/&
        &'' ----------'',5(a))')&
       (undl,i=1,n)
      do ig=1,nrg
         nb=0
         jg=ig+nfg
         do it=1,ires
            loca=nsigz*(it-1+ires*(ig-1))
            do jz=1,nsigz
               nb=nb+1
               b(nb)=snux(jz+loca)
               c(jz)=b(nb)
            enddo
            if (il.ne.2.or.ifiss.ne.1) then
               if (it.eq.1) write(nsyso,'(/i5,5x,1p,9e13.5)')&
                 jg,(c(i),i=1,lim)
               if (it.eq.1.and.nsigz.gt.ncol)&
                 write(nsyso,'(10x,1p,9e13.5)')&
                 (c(i),i=ncol1,nsigz)
               if (it.gt.1) write(nsyso,'(10x,1p,9e13.5)')&
                 (c(i),i=1,lim)
               if (it.gt.1.and.nsigz.gt.ncol)&
                 write(nsyso,'(10x,1p,9e13.5)')&
                 (c(i),i=ncol1,nsigz)
            endif
         enddo
      enddo
   endif

   if (iverw.eq.4) return
   write(nsyso,'(/&
     &'' group      shielded total scattering cross sections''/&
     &'' ----------'',5(a))')&
     (undl,i=1,n)
   do ig=1,nrg
      nb=0
      jg=ig+nfg
      do it=1,ires
         loca=1-1+nsigz*(it-1+ires*(ig-1))
         do jz=1,nsigz
            nb=nb+1
            b(nb)=elas(jz+loca)
            c(jz)=b(nb)
         enddo
         if (it.eq.1) then
            write(nsyso,'(/i5,5x,1p,9e13.5)') jg,(c(i),i=1,lim)
         endif
         if (it.eq.1.and.nsigz.gt.ncol) then
            write(nsyso,'(10x,1p,9e13.5)') (c(i),i=ncol1,nsigz)
         endif
         if (it.gt.1) then
            write(nsyso,'(10x,1p,9e13.5)') (c(i),i=1,lim)
         endif
         if (it.gt.1.and.nsigz.gt.ncol) then
            write(nsyso,'(10x,1p,9e13.5)') (c(i),i=ncol1,nsigz)
         endif
      enddo
   enddo
   return
   end subroutine rsiout

   subroutine xsecs
   !--------------------------------------------------------------------
   ! Process cross sections.
   !--------------------------------------------------------------------
   use util ! provides repoz,error,mess,skiprz
   use endf ! provides endf routines and variables
   use mainio ! provides nsysi,nsyso,nsyse
   character(60)::strng
   integer::ngndsq,il,ngr1,nb,nw,jtemp,i318,jfisd,jfist,jfspd
   integer::jfspt,jfspp,jfiss,i,mf3mt2,nth1,nth,if6,matd,jn2n
   integer::nz,ntw,l,idone,iz,jic,nl,ng2,ig2lo,ig,jg,loca,loc
   integer::jg2,locc,ll,max,min,ig2,lt,locf,k,in,nthr,loc1,loc2,jfis
   real(kr)::alf,xxi,cnorm,dnorm,p1nrm
   integer,dimension(:),allocatable::l1,l2
   integer,dimension(:),allocatable::l1e,l2e
   real(kr),dimension(:),allocatable::abs1
   real(kr),dimension(:),allocatable::xtr
   real(kr),dimension(:),allocatable::sn2n
   real(kr),dimension(:),allocatable::scat
   real(kr),dimension(:),allocatable::xi
   real(kr),dimension(:),allocatable::sdp
   real(kr),dimension(:),allocatable::cspc
   real(kr),dimension(:),allocatable::csp1
   real(kr),dimension(:),allocatable::snus
   real(kr),dimension(:),allocatable::chi
   real(kr),dimension(:),allocatable::sfi
   real(kr),dimension(:),allocatable::sf0
   real(kr),dimension(:),allocatable::ab0
   real(kr),dimension(:),allocatable::xs
   real(kr),parameter::dilinf=1.e10_kr
   integer,parameter::lz=6
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--allocate storage.
   if (ixs.eq.0) go to 630
   write(nsyso,'(/'' ***cross sections***'')')
   allocate(snu(ngnd))
   allocate(spot(ngnd))
   allocate(abs2(ngnd))
   allocate(l1(ngnd))
   allocate(l2(ngnd))
   allocate(l1e(ngnd))
   allocate(l2e(ngnd))
   ngndsq=ngnd*ngnd
   allocate(xs(ngndsq))
   allocate(ab0(ngnd))
   allocate(sf0(ngnd))
   allocate(sfi(ngnd))
   allocate(chi(ngnd))
   allocate(snus(ngnd))
   allocate(cspc(ngnd))
   allocate(xtr(ngnd))
   allocate(abs1(ngnd))
   allocate(sn2n(ngnd))
   allocate(scat(ngnd))
   allocate(xi(ngnd))
   allocate(sdp(ngnd))
   allocate(csp1(ngnd))
   nfiss=0
   il=1
   ngr1=nfg+nrg
   p1nrm=1

   !--read gendf data
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   isg=0
   if (sgref.lt.dilinf) isg=1
   jtemp=0
   i318=0
   jfisd=0
   jfist=0
   jfspd=0
   jfspt=0
   jfspp=0
   jfiss=0
   jn2n=0
   ! preset aver.log.decrement per collision assuming isotropic scatt.
   alf=(awr-1)/(awr+1)
   alf=alf*alf
   xxi=1+log(alf)*alf/(1-alf)

   !--loop over temperatures
  140 continue
   do i=1,ngnd
      csp1(i)=0
      spot(i)=sigp
      xi(i)=xxi
      abs2(i)=0
      sf0(i)=0
      sfi(i)=0
      snus(i)=0
      cspc(i)=0
      chi(i)=0
      scat(i)=0
      sn2n(i)=0
      l1e(i)=ngnd
      l2e(i)=1
      l1(i)=ngnd
      l2(i)=1
   enddo
   do i=1,ngndsq
      xs(i)=0
   enddo
   mf3mt2=0
   cnorm=0
   dnorm=0
   nth1=0
   nth=0
   if6=0
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.ne.mat) go to 540
   matd=mat
   nz=l2h
   ntw=n2h
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   idone=0
   i=0
   do while (i.lt.nz.and.idone.eq.0)
      i=i+1
      if (abs(sgref-scr(l+5+ntw+i)).le.sgref/100) then
         iz=i
         idone=1
      endif
   enddo
   if (idone.eq.0) then
      write(strng,&
        '(''ref. sig0'',1p,e10.3,'' not on the list'')') sgref
      call mess('xsecs ',strng,'first entry used as default')
      iz=1
      sgref=scr(l+5+ntw+iz)
   endif
   if(isg.gt.0) isg=iz
   jtemp=jtemp+1
   call tosend(ngendf,0,0,scr(l))
   jic=0

   !--loop over reactions
  150 continue
   call contio(ngendf,0,0,scr(l),nb,nw)
   if (math.eq.0) go to 370
   if (mfh.eq.0) go to 150
   if (mth.eq.0) go to 150
   nl=l1h
   nz=l2h
   if (mfh.eq.3.and.mth.ge.2.and.mf3mt2.le.0) mf3mt2=1

   !--loop over groups
  160 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if (l+nw-1.gt.nwscr) call error('xsecs',&
        'storage exceeded',' ')
   enddo
   jg=ngnd-ig+1
   l=1

   !--branch according to type of data
   if (mth.eq.452) go to 245
   if (mth.eq.455) go to 252
   if (mfh.ne.3) go to 192
   if (mth.ge.102.and.mth.le.150) go to 205
   if ((mth.ge.18.and.mth.le.21).or.mth.eq.38) go to 214
   if (mth.eq.1) go to 220
   if (mth.eq.2) go to 240
   if (mth.eq.16) jn2n=16
   if (mth.eq.16.or.mth.eq.24) go to 236
   if ((mth.ge.875.and.mth.le.891).and.(jn2n.ne.16)) go to 236
   if (mth.eq.17.or.mth.eq.25) go to 237
   if (mth.eq.252) go to 242
   if (mth.eq.mti) go to 238
  192 continue
   if (mfh.ne.6) go to 365
   if (mth.eq.2.or.mth.eq.mti.or.mth.eq.mtc) go to 270
   if ((mth.lt.18.or.mth.gt.21).and.mth.ne.38) go to 300
   go to 300

   !--absorption cross section
  205 continue
   loca=l+lz+nl*nz
   if (mth.eq.102) then
      if (isg.gt.0.and.nz.ge.iz) loca=l+lz+nl*(iz-1+nz)
      abs1(jg)=scr(loca)
   else
      abs2(jg)=abs2(jg)+scr(loca)
   endif
   go to 360

   !--fission cross section
  214 continue
   if (mth.eq.18) i318=1
   if (mth.eq.18) go to 216
   if (i318.eq.0) go to 216
   go to 365
  216 continue
   loca=l+lz+nl*nz
   sfi(jg)=sfi(jg)+scr(loca)
   if (isg.gt.0.and.nz.ge.iz) loca=l+lz+nl*(iz-1+nz)
   sf0(jg)=sf0(jg)+scr(loca)
   ab0(jg)=ab0(jg)+scr(loca)
   go to 360

   !--p1-flux for transport correction (if not read in from input)
   !--normalize the input current to the first common njoy p1-flux
  220 continue
   loca=l+lz+nl*(nz-1)
   if (isg.gt.0.and.nz.ge.iz) loca=l+lz+nl*(iz-1)
   if (nl.gt.1) loca=loca+1
   if (p1flx(jg).eq.0) then
     p1flx(jg)=scr(loca)
     p1nrm=1
   else
     if (p1nrm.eq.one) p1nrm=scr(loca)/p1flx(jg)
     p1flx(jg)=p1flx(jg)*p1nrm
   endif
   go to 360

   !--n2n cross section
  236 continue
   loca=l+lz+nl*nz
   sn2n(jg)=sn2n(jg)+scr(loca)
   go to 360

   !--n3n, n3n-alpha cross section
  237 continue
   loca=l+lz+nl*nz
   sn2n(jg)=sn2n(jg)+2*scr(loca)
   go to 360

   !--incoherent thermal scattering
  238 continue
   if (ig.gt.nth1.and.scr(l+lz+nz*nl).ne.zero) nth1=ig
   nth=ngnd-nth1+1
   go to 360

   !--elastic cross section
  240 continue
   go to 360

   !--log slowing down
  242 continue
   loca=l+lz+nl*nz
   xi(jg)=scr(loca)
   go to 360

   !--fission nu and chi from 3/452 and 5/452
  245 continue
   if (jtemp.gt.1) go to 365
   if (jfiss.eq.0) jfiss=1
   if (mfh.eq.5) go to 246
   ! total fission yield
   jfist=1
   loca=l+lz+1
   snu(jg)=scr(loca)
   go to 360
  246 continue
   if (isof.ne.0) then
      jfspt=1
      do i=2,ng2
         jg2=ngnd-ig2lo-i+3
         if (jg2.ge.1.and.jg2.le.ngnd) then
            loca=l+lz+nl*(i-1)
            uff(jg2)=scr(loca)
         endif
      enddo
   endif
   go to 365

   !--delayed fission contributions from 3/455 and 5/455
  252 continue
   if (jtemp.gt.1) go to 365
   if (mfh.ne.5) then
      jfisd=1
      loca=l+lz
      snus(jg)=snus(jg)+scr(loca+1)*scr(loca+2)
      dnorm=dnorm+scr(loca)*scr(loca+1)*scr(loca+2)
   else
      jfspd=1
      do i=2,ng2
         locc=1+ngnd-ig2lo-i+2
         do ll=1,nl
            loca=l+lz+ll-1+nl*(i-1)
            chi(locc)=chi(locc)+dnorm*scr(loca)
         enddo
      enddo
   endif
   go to 360

   !--temperature-dependent file 6 matrices
  270 continue
   if (mth.ne.2) jic=1
   max=0
   min=ngnd
   if (mth.eq.2.and.jg.ge.nth) go to 295
   if (mth.eq.2.and.jg.lt.nth) go to 301
   do i=2,ng2
      ig2=ig2lo+i-2
      if (ig2.ge.1.and.ig2.le.ngnd) then
         jg2=ngnd-ig2+1
         loca=l+lz+(il-1)+nl*nz*(i-1)
         if (isg.gt.0.and.nz.ge.iz) loca=loca+nl*(iz-1)
         if (scr(loca).ne.zero) then
            if (mth.ne.2) then
               loc=1+jg-1+ngnd*(jg2-1)
               if (jg2-jg.ge.-1.or.scr(loca).ge.zero) then
                  xs(loc)=xs(loc)+scr(loca)
                  scat(jg)=scat(jg)+scr(loca)
                  ! for the thermal groups
                  ! accumulate csp1,
                  ! the sum of the p1 components of scattering
                  ! from group i to group j for all j
                  if (jg.gt.ngr1) then
                    csp1(jg)=csp1(jg)+scr(loca+1)
                  endif
                  if (jg2.gt.max) max=jg2
                  if (jg2.lt.min) min=jg2
               endif
            endif
         endif
      endif
   enddo
   lt=l1(jg)
   if (min.lt.lt.and.mth.ne.2) l1(jg)=min
   lt=l1e(jg)
   if (min.lt.lt.and.mth.eq.2) l1e(jg)=min
   lt=l2(jg)
   if (max.gt.lt.and.mth.ne.2) l2(jg)=max
   lt=l2e(jg)
   if (max.gt.lt.and.mth.eq.2) l2e(jg)=max
  295 continue
   if (ig.lt.ngnd) go to 160
   go to 365

   !--temperature-independent file 6 matrices
  300 continue
   if (jtemp.gt.1) go to 360
  301 continue
   if (mfh.ne.6) go to 365
   if (if6.gt.0) go to 305
   if (nth1.eq.0) nth1=ngnd-nfg-nrg
   nth=ngnd-nth1+1
   if6=1
  305 continue
   if (mth.ge.18.and.mth.le.21) go to 315
   if (mth.eq.38) go to 315
   if (mth.eq.2.and.jg.ge.nth) go to 365
   if (mth.ge.221.and.mth.le.250) go to 365
   max=0
   min=ngnd
   do i=2,ng2
      ig2=ig2lo+i-2
      if (ig2.ge.1.and.ig2.le.ngnd) then
         jg2=ngnd-ig2+1
         loca=l+lz+(il-1)+nl*nz*(i-1)
         if (mth.eq.2) then
            loca=l+lz+(il-1)+nl*nz*(i-1)+(nz-1)*nl
            if (isg.gt.0.and.nz.ge.iz) then
               loca=l+lz+(il-1)+nl*nz*(i-1)+nl*(iz-1)
            endif
         endif
         loc=1+jg-1+ngnd*(jg2-1)
         xs(loc)=xs(loc)+scr(loca)
         scat(jg)=scat(jg)+scr(loca)
         if (jg2.gt.max) max=jg2
         if (jg2.lt.min) min=jg2
         if (nl.ne.1) then
            ! for fast and resonance groups
            ! accumulate csp1,
            ! the sum of the p1 components of scattering
            ! from group j to i for all j
            if (jg2.lt.nth) csp1(jg2)=&
              csp1(jg2)+scr(loca+1)*p1flx(jg)/p1flx(jg2)
         endif
      endif
   enddo
   lt=l1(jg)
   if (min.lt.lt) l1(jg)=min
   lt=l2(jg)
   if (max.gt.lt) l2(jg)=max
   go to 360

   !--process nu*sigf and chi from fission matrix
  315 continue
   if (jtemp.gt.1) go to 365
   if (ig.ne.0) then
      jfiss=2
      jfspp=1
      locf=l+lz
      do i=2,ng2
         loca=l+lz+nl*nz*(i-1)
         if (ig2lo.ne.0) then
            ! matrix part
            snus(jg)=snus(jg)+scr(loca)
            locc=1+ngnd-i-ig2lo+2
            chi(locc)=chi(locc)+scr(locf)*scr(loca)
         else
            ! production part
            do k=1,ngnd
               snus(jg)=snus(jg)+cspc(k)*scr(loca)
               locc=1+ngnd-k
               chi(locc)=chi(locc)+cspc(k)*scr(loca-1)*scr(loca)
            enddo
         endif
      enddo
   else
      ! spectrum part
      do i=1,ng2
         cspc(ig2lo+i-1)=scr(l+lz+nl*nz*(i-1))
      enddo
   endif

   !--continue loop over groups
  360 continue
   if (ig.lt.ngnd) go to 160
   go to 365

   !--continue loop over reactions
  365 continue
   call tosend(ngendf,0,0,scr(l))
   go to 150

   !--data is loaded for this temperature
  370 continue
   if (jtemp.le.1) then
      if (jfiss.ge.2) then
         if (jfisd.ge.1.or.jfist.le.0) then
            ! fix up nu if computed from matrix
            do i=1,ngnd
               if (sfi(i).ne.zero) then
                  snu(i)=snus(i)/sfi(i)
               endif
            enddo
            if (jfisd.ne.1) then
               write(strng,'(&
                 &''nu-bar calculated from fission matrix'')')
               call mess('xsecs',strng,&
                 'only prompt contribution available')
            endif
         endif
      endif
   endif
   if (jic.gt.0) go to 385
   jtemp=jtemp-1
   write(strng,&
     '(''use only '',i2,'' temps for mat '',i4)') jtemp,matd
   call mess('xsecs',strng,'mti missing from higher temps')
   matd=-1
   if (math.ne.0) call skiprz(ngendf,-3)
   go to 540
  385 continue
   if (jfiss.ne.0) then
      ! calculate nu*sigma f
      do i=1,ngnd
         snus(i)=snu(i)*sf0(i)
      enddo
   endif
   ! calculate total absorption
   do i=1,ngnd
      ab0(i)=sf0(i)&
        +abs1(i)+abs2(i)-sn2n(i)
   enddo
   ! correct scattering matrix
   in=nth-1
   do i=1,in
      if (l1e(i).lt.l1(i)) l1(i)=l1e(i)
      if (l2e(i).gt.l2(i)) l2(i)=l2e(i)
   enddo
   ! correct transport
   do i=1,ngnd
      if (ip1opt.gt.0)&
        xs(1+(i-1)*(1+ngnd))=xs(1+(i-1)*(1+ngnd))-csp1(i)
      xtr(i)=scat(i)+ab0(i)-csp1(i)
   enddo
   ! compute xx - slowing down power per unit lethargy
   do i=1,ngnd
      ! suppress upscattering from thermal into resonance groups
      nthr=nfg+nrg+1
      do jg=nthr,ngnd
         jg2=l1(jg)
         do while (jg2.lt.nthr)
            loc1=1+jg-1+ngnd*(jg2-1)
            loc2=1+jg-1+ngnd*(nthr-1)
            xs(loc2)=xs(loc2)+xs(loc1)
            xs(loc1)=0
            jg2=jg2+1
            l1(jg)=jg2
         enddo
      enddo
      sdp(i)=scat(i)*xi(i)/log(egb(i)/egb(i+1))
      ! replace constant potential with scattering cross section
      if (sigp.eq.zero) spot(i)=scat(i)
   enddo
   if (jtemp.eq.1) then
      jfis=0
      if (ires.gt.0) jfis=1
      if (jfis.ge.1.and.jfiss.gt.0) jfis=3
      if (jfis.gt.1.and.inorf.gt.0) jfis=2
      if (jfis.eq.0.and.jfiss.gt.0) jfis=4
   endif

   !--print out the results
   call xseco(jtemp,jfis,l1,l2,xs,sn2n,sdp,xtr,snus,sf0,ab0)
   i318=0
   ifiss=jfis
   if (isof.eq.0) go to 520
   if (jtemp.gt.1) go to 520
   if (jfiss.eq.0) go to 520
   ! normalize chi
   ! check for fission spectrum consistency
   if (jfspt.eq.0) then
      if (jfspd.ne.1.or.jfspp.ne.1) then
         write(strng,'(&
           &''spectrum calculated from fission matrix'')')
         call mess('xsecs ',strng, &
           'only prompt contribution available')
      endif
      do i=1,ngnd
         uff(i)=chi(i)
      enddo
   endif
   ! normalize the fission spectrum
   cnorm=0
   do i=1,ngr1
      if (uff(i).gt.zero) then
         cnorm=cnorm+uff(i)
         nfiss=i
      endif
   enddo
   if (cnorm.gt.zero) then
      cnorm=1/cnorm
      do i=1,nfiss
         uff(i)=uff(i)*cnorm
      enddo
   endif
  520 continue

   !--continue loop over temperatures
   if (jtemp.lt.ntemp) go to 140
   if (ntemp.eq.0) go to 140
  540 continue

   !--xsecs is finished.
   if (isof.ne.0.and.iprint.ne.0) then
      write(nsyso,'(/&
        &'' fission spectrum (groups 1 -'',i3,'')'',/&
        &'' --------------------------------'')')&
        nfiss
      write(nsyso,'(1p,6e12.4)') (uff(i),i=1,nfiss)
   endif

  630 return
   end subroutine xsecs

   subroutine xseco(itemp,ifiss,l1,l2,xs,sn2n,sdp,xtr,snus,sf0,ab0)
   !--------------------------------------------------------------------
   ! Write cross sections on nout and nsyso.
   !--------------------------------------------------------------------
   use util ! provides openz,error
   use mainio ! provides nsysi,nsyso,nsyse
   ! externals
   integer::itemp,ifiss
   integer::l1(*),l2(*)
   real(kr)::xs(*),sn2n(*),sdp(*),xtr(*),snus(*),sf0(*),ab0(*)
   ! internals
   integer::ngr0,ngr1,nnt,i,jtemp,p1nrm,k,ia,lone,ltwo
   integer::ks,loc,lim,j,ib,nt0
   integer,parameter::ncol=5
   real(kr),parameter::zero=0

   !--retrieve storage pointers
   ngr0=nfg+1
   ngr1=nfg+nrg
   nnt=ngr1

   !--temperature-independent data
   if (itemp.eq.1) then

      !--set up scratch units for xsec output
      call openz(-nscr2,1)
      call openz(-nscr3,1)

      !--write temperature-independent part
      !--what is the correct definition of xx?---
      if (iverw.eq.5) write(nscr2) (spot(i),i=ngr0,ngr1),&
        (sdp(i),i=ngr0,ngr1),(sn2n(i),i=1,nfg),&
        (xtr(i),i=1,nnt),&
        (ab0(i),i=1,nnt),(zero,i=ngr0,ngr1),&
        (glam(i),i=1,nrg)
      if (iverw.eq.4) write(nscr2) (spot(i),i=ngr0,ngr1),&
        (sdp(i),i=ngr0,ngr1),&
        (xtr(i),i=1,nnt),&
        (ab0(i),i=1,nnt),(zero,i=ngr0,ngr1),&
        (glam(i),i=1,nrg)
      if (iprint.ne.0) then
         jtemp=nint(tempr(1))
         p1nrm=1
         if (igref.le.nnt) p1nrm=1/p1flx(igref)
         write(nsyso,'(/&
           &'' neutron current spectrum  (groups 1-'',i3,'')''/&
           &'' ---------------------------------------'')') nnt
         write(nsyso,'(1p,6e12.4)') (p1nrm*p1flx(i),i=1,nnt)
         write(nsyso,'(/&
           &'' sigma potential (groups '',i3,''-'',i3,'')''/&
           &'' ------------------------------'')')&
           ngr0,ngr1
         write(nsyso,'(1p,6e12.4)') (spot(i),i=ngr0,ngr1)
         write(nsyso,'(/&
           &'' scattering power per unit lethargy (groups '',i3,&
           &''-'',i3,'')''/&
           &'' -------------------------------------------------'')')&
           ngr0,ngr1
         write(nsyso,'(1p,6e12.4)')(sdp(i),i=ngr0,ngr1)
         if (iverw.ne.4) then
            write(nsyso,'(/&
              &'' n,2n (groups 1-'',i3,'')''/&
              &''------------------'')')&
              nfg
            write(nsyso,'(1p,6e12.4)') (sn2n(i),i=1,nfg)
         endif
         write(nsyso,'(/&
           &'' transport corrected total (groups 1-'',i3,'')''/&
           &'' ---------------------------------------'')')&
           nnt
         write(nsyso,'(1p,6e12.4)') (xtr(i),i=1,nnt)
         write(nsyso,'(/&
           &'' absorption (groups 1-'',i3,'')''/&
           &'' ------------------------'')')&
           nnt
         write(nsyso,'(1p,6e12.4)') (ab0(i),i=1,nnt)
         write(nsyso,'(/&
           &'' goldstein-cohen intermediate resonance factors'',&
           &'' (groups '',i3,''-'',i3,'')''/&
           &1x,6(''----------''),''-'')')&
           ngr0,ngr1
         write(nsyso,'(1p,6e12.4)') (glam(i),i=1,nrg)
      endif
      if (ifiss.gt.1) then
         write(nscr2)&
           (snus(i),i=1,nnt),(sf0(i),i=1,nnt)
         if (iprint.ne.0) then
            write(nsyso,'(/&
              &'' nu*fission (groups 1-'',i3,'')''/&
              &'' ------------------------'')')&
              nnt
            write(nsyso,'(1p,6e12.4)') (snus(i),i=1,nnt)
            write(nsyso,'(/&
              &'' fission (groups 1-'',i3,'')''/&
              &'' ---------------------'')')&
              nnt
            write(nsyso,'(1p,6e12.4)') (sf0(i),i=1,nnt)
         endif
      endif
      k=0
      if (iprint.gt.0) write(nsyso,'(/&
        &'' nonthermal p0 scattering matrix''/&
        &'' -------------------------------'')')
      if (iprint.gt.0) write(nsyso,&
        &'('' initl'',3x,''final'',4x,&
        &''cross section vs final group''/&
        &'' group'',3x,''group'',4x,''+0'',4(10x,''+'',i1)/&
        &'' -----'',3x,''-----'',3x,5(''----------''),&
        &''---------'')') (i,i=1,4)
      do ia=1,nnt
         lone=l1(ia)
         ltwo=l2(ia)
         if (lone.ne.ngnd.or.ltwo.ne.1) then
            k=k+1
            ks=k+2
            scr(k)=ia-lone+1
            k=k+1
            scr(k)=ltwo-lone+1
            if (lone.ne.ltwo) then
               do i=lone,ltwo
                  loc=1+ia-1+ngnd*(i-1)
                  k=k+1
                  scr(k)=xs(loc)
               enddo
               if (iprint.ne.0) then
                  lim=k
                  if ((k-ks+1).gt.ncol) lim=ks+ncol-1
                  write(nsyso,'(1x,i4,4x,i4,2x,1p,5e12.4)')&
                    ia,lone,(scr(j),j=ks,lim)
                  ib=lone
                  do while (lim.ne.k)
                     ks=lim+1
                     lim=k
                     if ((k-ks+1).gt.ncol) lim=ks+ncol-1
                     ib=ib+ncol
                     write(nsyso,'(9x,i4,2x,1p,5e12.4)')&
                       ib,(scr(j),j=ks,lim)
                  enddo
               endif
            endif
         else
            k=k+1
            scr(k)=1
            k=k+1
            scr(k)=0
            if (iprint.ne.0) then
               write(nsyso,'(1x,i4,4x,i4,2x,1p,5e12.4)')&
                 ia,lone,zero
            endif
         endif
      enddo
      if (k.gt.nwscr) call error('xseco',&
        'scratch storage exceeded',' ')
      write(nscr2) k
      write(nscr2) (scr(i),i=1,k)
         if (iprint.ne.0) then
      write(nsyso,'(/&
        &'' thermal cross sections vs temperature '',&
        &''(groups '',i3,''-'',i3,'')''/&
        &1x,5(''----------''),''--'')')&
        nnt+1,ngnd
      endif
   endif

   !--write temperature-dependent part
   nt0=nnt+1
   jtemp=nint(tempr(itemp))
   if (itemp.eq.1) then
      write(nsyso,'(/'' temperatures''/'' ------------'')')
      write(nsyso,'(1p,6e12.4)') (tempr(i),i=1,ntemp)
   endif
   write(nscr3)&
     (xtr(i),i=nt0,ngnd),(ab0(i),i=nt0,ngnd)
   if (iprint.ne.0) then
      write(nsyso,'(/&
        &'' transport corrected total at '',i4,'' deg k''/&
        &1x,3(''----------''),''---------'')')&
        jtemp
      write(nsyso,'(1p,6e12.4)') (xtr(i),i=nt0,ngnd)
      write(nsyso,'(/&
        &'' absorption at '',i4,'' deg k''/&
        &'' ------------------------'')')&
        jtemp
      write(nsyso,'(1p,6e12.4)') (ab0(i),i=nt0,ngnd)
   endif
   if (ifiss.gt.1) then
      write(nscr3)&
        (snus(i),i=nt0,ngnd),(sf0(i),i=nt0,ngnd)
      if (iprint.ne.0) then
         write(nsyso,'(/&
           &'' nu*fission at '',i4,'' deg k''/&
           &'' ------------------------'')')&
           jtemp
         write(nsyso,'(1p,6e12.4)') (snus(i),i=nt0,ngnd)
         write(nsyso,'(/&
           &'' fission at '',i4,'' deg k''/&
           &'' ---------------------'')')&
           jtemp
         write(nsyso,'(1p,6e12.4)') (sf0(i),i=nt0,ngnd)
      endif
   endif
   k=0
   if (iprint.gt.0) write(nsyso,'(/&
     &'' thermal p0 scattering matrix at '',i4,'' deg k''/&
     &'' ------------------------------------------'')')&
     jtemp
   if (iprint.gt.0) write(nsyso,&
     '('' initl'',3x,''final'',4x,''cross section vs final group''/&
     &'' group'',3x,''group'',4x,''+0'',4(10x,''+'',i1)/&
     &'' -----'',3x,''-----'',3x,5(''----------''),''---------'')')&
     (i,i=1,4)
   do ia=nt0,ngnd
      lone=l1(ia)
      ltwo=l2(ia)
      if (lone.ne.ngnd.or.ltwo.ne.1) then
         k=k+1
         ks=k+2
         scr(k)=ia-lone+1
         k=k+1
         scr(k)=ltwo-lone+1
         if (lone.ne.ltwo) then
            do i=lone,ltwo
               loc=1+ia-1+ngnd*(i-1)
               k=k+1
               scr(k)=xs(loc)
            enddo
            if (iprint.ne.0) then
               lim=k
               if ((k-ks+1).gt.ncol) lim=ks+ncol-1
               write(nsyso,'(1x,i4,4x,i4,2x,1p,5e12.4)')&
                 ia,lone,(scr(j),j=ks,lim)
               ib=lone
               do while (lim.ne.k)
                  ks=lim+1
                  lim=k
                  if ((k-ks+1).gt.ncol) lim=ks+ncol-1
                  ib=ib+ncol
                  write(nsyso,'(9x,i4,2x,1p,5e12.4)')&
                    ib,(scr(j),j=ks,lim)
               enddo
            endif
         endif
      else
         k=k+1
         scr(k)=1
         k=k+1
         scr(k)=0
         if (iprint.ne.0) then
            write(nsyso,'(1x,i4,4x,i4,2x,1p,5e12.4)') ia,lone,zero
         endif
      endif
   enddo
   if (k.gt.nwscr) call error('xseco',&
     'scratch storage exceeded',' ')
   write(nscr3) k
   write(nscr3) (scr(i),i=1,k)

   !--xseco is finished.
   return
   end subroutine xseco

   subroutine p1scat
   !--------------------------------------------------------------------
   ! Process P1 scattering matrix.
   !--------------------------------------------------------------------
   use util ! provides openz,repoz,error
   use endf ! provides endf routines and variables,
   use mainio ! provides nsysi,nsyso,nsyse
   ! internals
   integer::nther,ngndsq,matd,nb,nw,il,mtelas,itd,i
   integer::jtemp,nth1,nth,ip1,nl,nz,l,ng2,ig2lo
   integer::ig,jg,ig2,jg2,jz,loca,loc,lt,l1t,l1tc
   integer::l2t,l2tc,nthr,loc1,loc2,nscr
   character(60)::strng
   integer,dimension(:),allocatable::l1,l2
   integer,dimension(:),allocatable::l1e,l2e
   real(kr),dimension(:),allocatable::elas
   real(kr),dimension(:),allocatable::sloc
   integer,parameter::lz=6

   !--allocate storage.
   if (ixs.eq.0) return
   if (ip1opt.eq.1) return
   write(nsyso,'(/'' ***p1 scattering matrices***'')')
   nther=ngnd-nfg-nrg
   allocate(l1(ngnd))
   allocate(l2(ngnd))
   allocate(l1e(ngnd))
   allocate(l2e(ngnd))
   ngndsq=ngnd*ngnd
   allocate(elas(ngndsq))
   allocate(sloc(ngndsq))
   call openz(-nscr4,1)
   nscr=nscr0
   call openz(-nscr,1)

   !--read gendf data
   matd=mat
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   il=2
   mtelas=0
   itd=0
   do i=1,ngndsq
      sloc(i)=0
   enddo
   do i=1,ngnd
      l1(i)=ngnd
      l2(i)=1
   enddo
   jtemp=-1
   nth1=0
   nth=nther
   ip1=0

   !--search for required reactions.
  125 continue
   call contio(ngendf,0,0,scr,nb,nw)
   if (math.eq.0) go to 200
   if (math.lt.0) go to 300
   if (math.ne.matd) go to 300
   if (mfh.eq.0.or.mth.eq.0) go to 125
   if (mfh.eq.1.and.jtemp.eq.ntemp) go to 300
   nl=l1h
   if (nl.lt.il.and.mfh.ne.1) go to 155
   nz=l2h

   !--loop over groups for this reaction
  140 continue
   l=1
   call listio(ngendf,0,0,scr(l),nb,nw)
   if (mfh.eq.1) jtemp=jtemp+1
   if (mfh.eq.3) go to 160
   if (mfh.ne.6) go to 155
   if (mth.eq.2.and.mtelas.eq.0) then
      mtelas=1
      do i=1,ngnd
         l1e(i)=ngnd
         l2e(i)=1
      enddo
      do i=1,ngndsq
         elas(i)=0
      enddo
   endif
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   do while (nb.ne.0)
      l=l+nw
      call moreio(ngendf,0,0,scr(l),nb,nw)
      if (l+nw-1.gt.nwscr) call error('p1scat',&
        'storage exceeded',' ')
   enddo
   go to 160
  155 continue
   call tosend(ngendf,0,0,scr)
   go to 125
  160 continue
   if (ig.eq.0.or.ig.gt.ngnd) go to 225
      jg=ngnd-ig+1
   l=1

   !--store non-temperature dependent scattering matrix
   if (jtemp.gt.0) go to 210
   if (mfh.eq.3) go to 230
   if (mth.ge.18.and.mth.le.21) go to 155
   if (mth.eq.38) go to 155
   if (mth.eq.2) go to 155
   if (mth.eq.mti.or.mth.eq.mtc) go to 180
   if (mth.ge.221.and.mth.le.250) go to 155
   do i=2,ng2
      ig2=ig2lo+i-2
      if (ig2.ne.0.and.ig2.le.ngnd) then
         jg2=ngnd-ig2+1
         jz=nz
         if(isg.gt.0 .and. isg.lt.nz) jz=isg
         loca=l+lz+(il-1)+nl*nz*(i-1)+(jz-1)*nl
         loc=1+jg-1+ngnd*(jg2-1)
         sloc(loc)=sloc(loc)+scr(loca)
      endif
   enddo
   ip1=1
   lt=l1(jg)
   l1t=ngnd-ig2lo-ng2+3
   l1tc=l1t
   if (l1tc.lt.lt.and.l1tc.ne.0.and.l1tc.le.ngnd) l1(jg)=l1tc
   lt=l2(jg)
   l2t=l1t+ng2-2
   l2tc=l2t
   if (l2tc.gt.lt.and.l2tc.ne.l1t.and.l2tc.gt.0.and.l2tc.le.ngnd)&
        l2(jg)=l2tc

   !--continue loop over groups
   if (ig.lt.ngnd) go to 140

   !--continue loop over reactions
   go to 125
  180 continue
   if (ig.gt.nth1.and.ig.le.nth) nth1=ig
   if (ig.lt.nth) go to 140
   go to 155

   !--write non-temperature dependent matrix on scratch tape.
  200 continue
   if (jtemp.gt.0) go to 250
   call repoz(-nscr)
   write(nscr) (l1(i),i=1,ngnd)
   write(nscr) (l2(i),i=1,ngnd)
   write(nscr) (sloc(i),i=1,ngndsq)
   call repoz(-nscr)
   call repoz(ngendf)
   call tpidio(ngendf,0,0,scr,nb,nw)
   call findf(matd,1,451,ngendf)
   nth=nth1
   go to 125

   !--add temperature-dependent reaction to matrix.
  210 continue
   if (mth.eq.2.or.mth.eq.mti.or.mth.eq.mtc) go to 215
   go to 155
  215 continue
   if (mth.eq.2.and.ig.le.nth) go to 140
   if (mth.eq.mti.and.ig.gt.nth) go to 155
   if (mth.eq.mtc.and.ig.gt.nth.and.mtc.ne.0) go to 155
   itd=1
   do i=2,ng2
      ig2=ig2lo+i-2
      if (ig2.ne.0.and.ig2.le.ngnd) then
         jg2=ngnd-ig2+1
         jz=nz
         if(isg.gt.0 .and. isg.lt.nz) jz=isg
         loca=l+lz+(il-1)+nl*nz*(i-1)+(jz-1)*nl
         loc=1+jg-1+ngnd*(jg2-1)
         sloc(loc)=sloc(loc)+scr(loca)
         if (mth.eq.2) then
            loc=1+jg-1+ngnd*(jg2-1)
            elas(loc)=elas(loc)+scr(loca)
         endif
      endif
   enddo
   ip1=1
   lt=l1(jg)
   l1t=ngnd-ig2lo-ng2+3
   l1tc=l1t
   if (l1tc.lt.lt.and.l1tc.ne.0) l1(jg)=l1tc
   if (mth.eq.2) l1e(jg)=l1tc
   lt=l2(jg)
   l2t=l1t+ng2-2
   l2tc=l2t
   if (l2tc.gt.lt.and.l2tc.ne.l1t.and.l2tc.gt.0.and.l2tc.le.ngnd)&
     l2(jg)=l2tc
   if (mth.eq.2.and.l2tc.ne.l1t) l2e(jg)=l2tc
  225 continue
   if (ig.lt.ngnd) go to 140
   go to 125

   !--coarse group flux
  230 continue
   if (mth.ne.1) go to 155
   if (ig.lt.ngnd) go to 140
   go to 125

   !--desired data is loaded
  250 continue
   if (ip1.eq.0) then
      write(strng,'(''no p1 matrices found for mat '',i4)') matd
      call error('p1scat',strng,' ')
   endif
   if (mti.gt.0.and.itd.eq.0) then
      write(strng,'(''no temperature-dependent reactions for mat '',&
        &i4)') matd
      call error('p1scat',strng,' ')
   endif
   if (mtelas.le.0) then
      do i=1,ngnd
         if (l1e(i).lt.l1(i)) l1(i)=l1e(i)
         if (l2e(i).gt.l2(i)) l2(i)=l2e(i)
      enddo
      do i=1,ngndsq
         sloc(i)=sloc(i)+elas(i)
      enddo
   endif

   !--suppress upscattering from thermal into resonance groups
   nthr=nfg+nrg+1
   do jg=nthr,ngnd
      jg2=l1(jg)
      do while (jg2.lt.nthr)
         loc1=1+jg-1+ngnd*(jg2-1)
         loc2=1+jg-1+ngnd*(nthr-1)
         sloc(loc2)=sloc(loc2)+sloc(loc1)
         sloc(loc1)=0
         jg2=jg2+1
         l1(jg)=jg2
      enddo
   enddo

   !--print to output and to scratch tape
   call p1sout(l1,l2,sloc,jtemp)
   call repoz(-nscr)
   read(nscr) (l1(i),i=1,ngnd)
   read(nscr) (l2(i),i=1,ngnd)
   read(nscr) (sloc(i),i=1,ngndsq)
   mtelas=0
   go to 125

   !--this material is finished.
  300 continue

   !--p1scat is finished.
   return
   end subroutine p1scat

   subroutine p1sout(l1,l2,sloc,it)
   !--------------------------------------------------------------------
   ! Write P1 scattering matrices.
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   ! externals
   integer::l1(*),l2(*),it
   real(kr)::sloc(*)
   ! internals
   integer::ncol1,ktemp,i,ig,lone,ltwo,j,loc,nb,i1,lim
   integer,parameter::ncol=5

   !--retrieve matrix pointers
   ncol1=ncol-1

   !--write p1 scattering matrix on nscr4
   ktemp=nint(tempr(it))
   if (iprint.gt.1) write(nsyso,'(/&
     &'' p1 scattering matrix at '',i4,'' deg k''/&
     &1x,5(''----------''),''--------''/&
     &'' ig l1 l2    l1+0'',4(10x,''+'',i1)/&
     &1x,7(''----------''),''----'')')&
     ktemp,(i,i=1,ncol1)
   do ig=1,ngnd
      lone=l1(ig)
      ltwo=l2(ig)
      j=0
      do i=lone,ltwo
         loc=1+ig-1+ngnd*(i-1)
         j=j+1
         scr(j)=sloc(loc)
      enddo
      nb=j
      write(nscr4) ig,lone,ltwo
      write(nscr4) (scr(i),i=1,nb)
      if (iprint.ne.0) then
         i1=1
         lim=nb
         if (lim.gt.ncol) lim=ncol
         write(nsyso,'(3i3,5x,1p,5e12.4)')&
           ig,lone,ltwo,(scr(i),i=i1,lim)
         do while (lim.ne.nb)
            i1=lim+1
            lim=nb
            if ((lim-i1+1).gt.ncol) lim=i1+ncol-1
            write(nsyso,'(14x,1p,5e12.4)') (scr(i),i=i1,lim)
         enddo
      endif
   enddo
   return
   end subroutine p1sout

   subroutine wimout(jcc)
   !--------------------------------------------------------------------
   ! Write the WIMS-format data on nout.
   !--------------------------------------------------------------------
   use util ! provides timer,repoz
   use mainio ! provides nsysi,nsyso,nsyse
   use physics ! provides amassn
   ! externals
   integer::jcc
   ! internals
   integer::ngr0,ngr1,nnt,ifis,nrestb,jfis,nw,ident,npos
   integer::jcc2,i,ndat,nt0,it,j,ntnp,jres,jsigz,irg,nump1
   integer::ig,lone,ltwo,nb
   real(kr)::time,awt,xid,rid
   integer,parameter::izero=0

   !--print timer message
   call timer(time)
   write(nsyso,'(/'' ***output***'',56x,f8.1,''s'')') time

   !--initialize.
   ngr0=nfg+1
   ngr1=nfg+nrg
   nnt=ngr1

   !--retrieve fission flag
   ifis=ifiss
   if (ifis.eq.0.or.ifis.eq.4) nrestb=0
   if (ifis.gt.0.and.ifis.lt.4) nrestb=1
   jfis=ifis
   if (ifprod.eq.1) jfis=-1
   if (ifprod.eq.2) jfis=-2
   nw=4*(ngr1-ngr0+1)+2*nnt
   if (iverw.eq.5) nw=nw+nfg

   !--write identifiers
   if (iverw.ne.4) write(nout,'(i15)') nfid
   ident=nfid
   npos=1
   if (iverw.ne.4) write(nout,'(2i15)') ident,npos

   !--write burnup data.
   if (iburn.ge.0) then
      if (iburn.eq.0.and.iverw.ne.4) write(nout,'(i15)') izero
      if (jcc.ge.8) ifisp(4)=jfis
      write(nout,'(2i15)') 999999999,3
      write(nout,'(i15)') jcc
      jcc2=jcc/2
      write(nout,'(3(1p,e15.8,i6))') (yield(i),ifisp(i),i=1,jcc2)
      write(nout,'(2i15)') 999999999,4
   endif

   !--write material identifier data
   awt=awr*amassn
   write(nout,'(i6,1p,e15.8,5i6)')&
     ident,awt,iznum,ifis,ntemp,nrestb,isof

   !--write temperature-independent data
   !--potential, scatter, transport, absorption, (unused), lambda
   call repoz(-nscr2)
   read(nscr2) (scr(i),i=1,nw)
   write(nout,'(1p,5e15.8)') (scr(i),i=1,nw)
   if (ifis.gt.1) then
      ! nu*fission, fission
      nw=2*nnt
      read(nscr2) (scr(i),i=1,nw)
      write(nout,'(1p,5e15.8)') (scr(i),i=1,nw)
   endif
   ! nonthermal scattering matrix
   read(nscr2) ndat
   write(nout,'(i15)') ndat
   if (ndat.gt.0) then
      read(nscr2) (scr(i),i=1,ndat)
      write(nout,'(1p,5e15.8)') (scr(i),i=1,ndat)
   endif

   !--write temperature-dependent data
   call repoz(-nscr3)
   write(nout,'(1p,5e15.8)') (tempr(i),i=1,ntemp)
   nt0=nnt+1
   do it=1,ntemp
      nw=2*(ngnd-nt0+1)
      ! transport, absorption
      read(nscr3) (scr(j),j=1,nw)
      write(nout,'(1p,5e15.8)') (scr(j),j=1,nw)
      if (ifis.gt.1) then
         ! nu*fission, fission
         read(nscr3) (scr(j),j=1,nw)
         write(nout,'(1p,5e15.8)') (scr(j),j=1,nw)
      endif
      ! thermal scattering matrix
      read(nscr3) ndat
      write(nout,'(i15)') ndat
      if (ndat.ne.0) then
         read(nscr3) (scr(j),j=1,ndat)
         write(nout,'(1p,5e15.8)') (scr(j),j=1,ndat)
      endif
   enddo
   if (iverw.eq.4) write(nout,'(''      999999999'')')

   !--write resonance data
   if (ires.ne.0) then
      call repoz(-nscr1)
      read(nscr1) ntnp
      read(nscr1) xid,jres,jsigz
      rid=rdfid
      do irg=1,nrg
         if (iverw.eq.4) write(nout,'(i15)') ntnp
         write(nout,'(1p,e15.8,2i6)') rid,jres,jsigz
         ! temperatures, sig pots, resonance integrals
         nw=jres+jsigz+ntnp
         read(nscr1) (scr(i+1),i=1,nw)
         write(nout,'(1p,5e15.8)') (scr(i+1),i=1,nw)
         if (ifis.eq.3) then
            ! temperatures, sig pots, fission resonance integrals
            if (iverw.eq.4) write(nout,'(i15)') ntnp
            write(nout,'(1p,e15.8,2i6)') rid,jres,jsigz
            read(nscr1) (scr(i+1),i=1,nw)
            write(nout,'(1p,5e15.8)') (scr(i+1),i=1,nw)
         endif
         if (iverw.eq.4) write(nout,'(''      999999999'')')
      enddo
      if (iverw.ne.4) then
         do irg=1,nrg
            write(nout,'(1p,e15.8,2i6)') rid,jres,jsigz
            nw=jres+jsigz+ntnp
            read(nscr1) (scr(i+1),i=1,nw)
            write(nout,'(1p,5e15.8)') (scr(i+1),i=1,nw)
         enddo
      endif
   endif

   !--write fission spectrum
   if (isof.ne.0) then
      write(nout,'(1p,5e15.8)') (uff(j),j=1,nfiss)
   endif

   !--write p1 data
   if (ip1opt.ne.1) then
      call repoz(-nscr4)
      do it=1,ntemp
         nump1=0
         do ig=1,ngnd
            read(nscr4) nw,lone,ltwo
            nb=ltwo-lone+1
            scr(1+nump1)=nw-lone+1
            scr(1+nump1+1)=nb
            nump1=nump1+2
            read(nscr4) (scr(nump1+j),j=1,nb)
            nump1=nump1+nb
         enddo
         write(nout,'(i15)') nump1
         write(nout,'(1p,5e15.8)') (scr(j),j=1,nump1)
      enddo
   endif

   !--wimout is finished.
   return
   end subroutine wimout

end module wimsm

module graph
   ! provides basic 2-D and 3-D graphing routines for Postscript
   use locale
   implicit none
   private

   !--Public routines
   public initp,window,endp,endw,init2,frame2,endfr,init3,vect3
   public axis2,axis3,xscale,yscale,xinvrs,yinvrs
   public trans3,grid2,grid3,curv2,curv3,poly2,text3,txtlen,dsym
   public gplot,gdone

   !--Private global variables
   integer::ipage,nps
   real(kr)::width,ht
   integer::ifont
   real(kr)::xpaper,ypaper
   integer::ifg,ibg
   integer::land
   !   wt     weight of tick marks
   !   wg     weight of grid lines
   !   wa     weight of axis lines
   !   tic    length of tic marks
   !   gap    space between axis and numbers
   !   hf     height fraction of fonts numbers
   !   hl     height of labels
   !   hn     height of numbers
   !   lfont  font for numbers and labels
   real(kr)::wt,wg,wa,tic,gap,hf,hl,hn
   integer::lfont
   real(kr)::fvx,dvx,fvy,dvy,fvz,dvz
   integer::logx,logy,logz
   real(kr)::xwll,ywll,www,wwh,wwr,tspace
   real(kr)::rs,ro,rp,ct,st,cp,sp,du,dv

   real(kr)::ushift,vshift,uwidth
   real(kr)::xmin,xmax,xstp,ymin,ymax,ystp,zmin,zmax,zstp

   ! font names
   character(25),dimension(3)::font=(/&
     'Times-Roman              ',&
     'Helvetica                ',&
     'Symbol                   '/)

   ! tables of font sizes -------------------------------------------

   real(kr),dimension(128,3)::cw

   ! times-roman 00-1f
   real(kr),dimension(32)::cw1=(/&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr/)
   ! times-roman 20-3f
   real(kr),dimension(32)::cw2=(/&
     .250e0_kr,.333e0_kr,.408e0_kr,.500e0_kr,.500e0_kr,.833e0_kr,&
     .778e0_kr,.250e0_kr,.333e0_kr,.333e0_kr,.500e0_kr,.564e0_kr,&
     .250e0_kr,.333e0_kr,.250e0_kr,.278e0_kr,.500e0_kr,.500e0_kr,&
     .500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,&
     .500e0_kr,.500e0_kr,.278e0_kr,.278e0_kr,.564e0_kr,.564e0_kr,&
     .564e0_kr,.444e0_kr/)
   ! times-roman 40-5f
   real(kr),dimension(32)::cw3=(/&
     .921e0_kr,.722e0_kr,.667e0_kr,.667e0_kr,.722e0_kr,.611e0_kr,&
     .556e0_kr,.722e0_kr,.722e0_kr,.333e0_kr,.389e0_kr,.722e0_kr,&
     .611e0_kr,.889e0_kr,.722e0_kr,.722e0_kr,.556e0_kr,.722e0_kr,&
     .667e0_kr,.556e0_kr,.611e0_kr,.722e0_kr,.722e0_kr,.944e0_kr,&
     .722e0_kr,.722e0_kr,.611e0_kr,.333e0_kr,.278e0_kr,.333e0_kr,&
     .469e0_kr,.500e0_kr/)
   ! times-roman 60-7f
   real(kr),dimension(32)::cw4=(/&
     .333e0_kr,.444e0_kr,.500e0_kr,.444e0_kr,.500e0_kr,.444e0_kr,&
     .333e0_kr,.500e0_kr,.500e0_kr,.278e0_kr,.278e0_kr,.500e0_kr,&
     .278e0_kr,.778e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,&
     .333e0_kr,.389e0_kr,.278e0_kr,.500e0_kr,.500e0_kr,.722e0_kr,&
     .500e0_kr,.500e0_kr,.444e0_kr,.480e0_kr,.200e0_kr,.480e0_kr,&
     .000e0_kr,.000e0_kr/)
   ! helvetica 00-1f
   real(kr),dimension(32)::cw5=(/&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr/)
   ! helvetica 20-3f
   real(kr),dimension(32)::cw6=(/&
     .278e0_kr,.278e0_kr,.355e0_kr,.556e0_kr,.556e0_kr,.889e0_kr,&
     .667e0_kr,.250e0_kr,.333e0_kr,.333e0_kr,.389e0_kr,.584e0_kr,&
     .278e0_kr,.333e0_kr,.278e0_kr,.278e0_kr,.556e0_kr,.556e0_kr,&
     .556e0_kr,.556e0_kr,.556e0_kr,.556e0_kr,.556e0_kr,.556e0_kr,&
     .556e0_kr,.556e0_kr,.278e0_kr,.278e0_kr,.584e0_kr,.584e0_kr,&
     .584e0_kr,.556e0_kr/)
   ! helvetica 40-5f
   real(kr),dimension(32)::cw7=(/&
     1.015e0_kr,.667e0_kr,.667e0_kr,.722e0_kr,.722e0_kr,.667e0_kr,&
     .611e0_kr,.778e0_kr,.722e0_kr,.278e0_kr,.500e0_kr,.667e0_kr,&
     .556e0_kr,.833e0_kr,.722e0_kr,.778e0_kr,.667e0_kr,.778e0_kr,&
     .722e0_kr,.667e0_kr,.611e0_kr,.722e0_kr,.667e0_kr,.944e0_kr,&
     .667e0_kr,.667e0_kr,.611e0_kr,.278e0_kr,.278e0_kr,.278e0_kr,&
     .469e0_kr,.556e0_kr/)
   ! helvetica 60-7f
   real(kr),dimension(32)::cw8=(/&
     .222e0_kr,.556e0_kr,.556e0_kr,.500e0_kr,.556e0_kr,.556e0_kr,&
     .278e0_kr,.556e0_kr,.556e0_kr,.222e0_kr,.222e0_kr,.500e0_kr,&
     .222e0_kr,.833e0_kr,.556e0_kr,.556e0_kr,.556e0_kr,.556e0_kr,&
     .333e0_kr,.500e0_kr,.278e0_kr,.556e0_kr,.500e0_kr,.722e0_kr,&
     .500e0_kr,.500e0_kr,.500e0_kr,.334e0_kr,.260e0_kr,.334e0_kr,&
     .000e0_kr,.000e0_kr/)
   ! symbol 00-1f
   real(kr),dimension(32)::cw9=(/&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr/)
   ! symbol 20-3f
   real(kr),dimension(32)::cw10=(/&
     .250e0_kr,.333e0_kr,.713e0_kr,.500e0_kr,.549e0_kr,.833e0_kr,&
     .778e0_kr,.250e0_kr,.333e0_kr,.333e0_kr,.500e0_kr,.549e0_kr,&
     .250e0_kr,.549e0_kr,.250e0_kr,.278e0_kr,.500e0_kr,.500e0_kr,&
     .500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,.500e0_kr,&
     .500e0_kr,.500e0_kr,.278e0_kr,.278e0_kr,.549e0_kr,.549e0_kr,&
     .549e0_kr,.444e0_kr/)
   ! symbol 40-5f
   real(kr),dimension(32)::cw11=(/&
     .549e0_kr,.696e0_kr,.660e0_kr,.710e0_kr,.612e0_kr,.652e0_kr,&
     .763e0_kr,.603e0_kr,.765e0_kr,.351e0_kr,.631e0_kr,.724e0_kr,&
     .686e0_kr,.918e0_kr,.739e0_kr,.750e0_kr,.768e0_kr,.741e0_kr,&
     .580e0_kr,.592e0_kr,.632e0_kr,.690e0_kr,.439e0_kr,.768e0_kr,&
     .645e0_kr,.795e0_kr,.650e0_kr,.333e0_kr,.863e0_kr,.333e0_kr,&
     .658e0_kr,.500e0_kr/)
   ! symbol 60-7f
   real(kr),dimension(32)::cw12=(/&
     .500e0_kr,.631e0_kr,.549e0_kr,.549e0_kr,.494e0_kr,.439e0_kr,&
     .521e0_kr,.411e0_kr,.603e0_kr,.329e0_kr,.603e0_kr,.549e0_kr,&
     .549e0_kr,.576e0_kr,.521e0_kr,.549e0_kr,.549e0_kr,.521e0_kr,&
     .549e0_kr,.603e0_kr,.439e0_kr,.576e0_kr,.713e0_kr,.686e0_kr,&
     .493e0_kr,.686e0_kr,.494e0_kr,.480e0_kr,.200e0_kr,.480e0_kr,&
     .000e0_kr,.000e0_kr/)

   ! color tables -------------------------------------------------

   ! light colors for backgrounds
   integer,dimension(3,8)::ibrgb=reshape((/&
     255,255,255,& ! white
     255,222,173,& ! navajo white
     255,235,205,& ! blanched almond
     250,235,215,& ! antique white
     255,255,198,& ! very pale yellow
     255,197,220,& ! very pale rose
     205,250,205,& ! very pale green
     172,233,250&  ! very pale blue
     /),(/3,8/))
   ! dark colors for foregrounds (curves)
   integer,dimension(3,9)::ifrgb=reshape((/&
       0,  0,  0,& ! black
     225,  0,  0,& ! red
       0,200,  0,& ! green
       0,  0,225,& ! blue
     225,  0,225,& ! magenta
       0,225,225,& ! cyan
     170,102, 35,& ! brown
     160, 32,240,& ! purple
     225, 80, 20&  ! orange
     /),(/3,9/))
   integer,dimension(3,40)::isrgb=reshape((/&
     205,255,205,& ! progressive shades of green
     175,235,175,&
     135,225,135,&
     110,210,110,&
      90,180, 90,&
      80,160, 80,&
      70,140, 70,&
      64,125, 64,&
      55,107, 55,&
      45, 90, 45,&
     255,206,206,& ! progressive shades of red
     235,195,195,&
     230,118,118,&
     215, 90, 90,&
     206, 60, 60,&
     200, 40, 30,&
     188, 39, 20,&
     175, 32, 32,&
     160,  0,  0,&
     135,  0,  0,&
     255,218,177,& ! progressive shades of brown
     243,195,142,&
     237,179,108,&
     225,159, 75,&
     215,140, 76,&
     200,131, 62,&
     175,117, 52,&
     160, 90, 33,&
     140, 72, 29,&
     121, 62, 25,&
     192,237,253,& ! progressive shades of blue
     135,164,229,&
     120,120,220,&
     100,100,210,&
      70, 70,200,&
      40, 40,195,&
      21, 21,182,&
      20, 20,170,&
      16, 16,140,&
       0,  0,125/),(/3,40/))

contains

   subroutine initp(iori,xpage,ypage,istyle,htt,wtt,ibord,ipcol)
   !--------------------------------------------------------------------
   ! Initialize the page.
   ! Sets up the the basic page size, orientation, font style,
   ! font height, normal line weight, and page background color.
   ! Draws page border if requested.
   ! Page coordinates are measured from the
   ! lower-left corner of the page in inches.
   !--------------------------------------------------------------------
   ! externals
   integer::iori,istyle,ibord,ipcol
   real(kr)::xpage,ypage,htt,wtt
   ! internals
   integer::n
   real(kr)::wbord,w,backgr
   real(kr)::x(5),y(5)

   ! load font tables
   do n=1,32
      cw(n,1)=cw1(n)
      cw(32+n,1)=cw2(n)
      cw(64+n,1)=cw3(n)
      cw(96+n,1)=cw4(n)
      cw(n,2)=cw5(n)
      cw(32+n,2)=cw6(n)
      cw(64+n,2)=cw7(n)
      cw(96+n,2)=cw8(n)
      cw(n,3)=cw9(n)
      cw(32+n,3)=cw10(n)
      cw(64+n,3)=cw11(n)
      cw(96+n,3)=cw12(n)
   enddo

   ! width of border line
   wbord=.005e0

   land=iori
   ifont=istyle
   width=wtt
   ht=htt
   ibg=1+ipcol
   ifg=1
   ro=1
   rs=1
   ct=0
   st=1
   cp=0
   sp=-1
   du=0
   dv=0
   xwll=0
   ywll=0
   www=0
   wwh=0
   wwr=0
   call newp
   n=5
   x(1)=0
   y(1)=0
   x(2)=xpage
   y(2)=0
   x(3)=xpage
   y(3)=ypage
   x(4)=0
   y(4)=ypage
   x(5)=x(1)
   y(5)=y(1)
   w=wbord
   if (ibg.eq.1) w=-1
   backgr=1
   call poly2(x,y,n,w,backgr)
   return
   end subroutine initp

   subroutine window(xll,yll,ww,wh,wr,t1,n1,t2,n2,ibord)
   !--------------------------------------------------------------------
   ! Set up a window on the page
   ! and write the titles (if any) in the upper left corner.
   ! Draw a window border if requested.
   ! Set up a clipping path at the window border.
   !--------------------------------------------------------------------
   ! externals
   integer::n1,n2,ibord
   real(kr)::xll,yll,ww,wh,wr
   character::t1*(*),t2*(*)
   ! internals
   real(kr)::wbord,w,ull,vll,uur,vur,x,y
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   ifg=1

   ! width of window border
   wbord=.005e0_kr

   !--load window transformation
   xwll=xll
   ywll=yll
   www=ww
   wwh=wh
   wwr=wr

   !--draw window border
   if (ibord.ne.0) then
      w=wbord
      call vect2(zero,zero,zero,wwh,w,0)
      call vect2(zero,wwh,www,wwh,w,0)
      call vect2(www,wwh,www,zero,w,0)
      call vect2(www,zero,zero,zero,w,0)
   endif

   !--set clipping to window border
   call transw(zero,zero,ull,vll)
   call transw(www,wwh,uur,vur)
   call gset(ull,vll,uur,vur)

   !--draw titles, if any.
   tspace=0
   if (n1.ne.0) then
      x=3*ht
      y=wwh-3*ht/2
      tspace=tspace+3*ht/2
      call text2(t1,n1,ifont,ht,x,y,one,zero,zero,one)
      if (n2.ne.0) then
         y=y-(ht+ht/5)
         tspace=tspace+3*ht/2
         call text2(t2,n2,ifont,ht,x,y,one,zero,zero,one)
      endif
   endif
   return
   end subroutine window

   subroutine endw
   !--------------------------------------------------------------------
   ! End a window by resetting the clipping path
   ! and restoring the default transformation.
   !--------------------------------------------------------------------
   call gend
   ro=1
   rs=1
   ct=0
   st=1
   cp=0
   sp=-1
   du=0
   dv=0
   www=0
   wwh=0
   wwr=0
   return
   end subroutine endw

   subroutine transw(x,y,u,v)
   !--------------------------------------------------------------------
   ! Coordinate transformation for the window.
   !--------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   real(kr)::x,y,u,v
   ! internals
   real(kr)::ct,st
   real(kr),parameter::zero=0

   if (www.eq.zero) then
      u=x
      v=y
   else
      ct=cos(2*pi*wwr/360)
      st=sin(2*pi*wwr/360)
      u=xwll+x*ct-y*st
      v=ywll+x*st+y*ct
   endif
   return
   end subroutine transw

   subroutine init2(uo,vo,xg,yg,iright,iwcol)
   !--------------------------------------------------------------------
   ! Initialize a 2-d plot by choosing an origen and axis
   ! lengths to nicely position the graph in the window.  Here
   !  u0,vo is the position of the lower-left corner of the
   !   axis system in window coordinates,
   !  xg,yg are the lengths of the axis is absolute units,
   !  iright>0 reserves space for a right-hand axis, and
   !  iwcol is the background color of the inside of the graph frame.
   !--------------------------------------------------------------------
   ! externals
   integer::iright,iwcol
   real(kr)::uo,vo,xg,yg
   ! internals
   integer::n
   real(kr)::wframe,ull,vll,uur,vur,w,backgr
   real(kr)::x(5),y(5)
   real(kr),parameter::zero=0

   ! width of frame border
   wframe=.005e0_kr

   !--adjust axis lengths to fit graph inside window
   uo=4*ht
   vo=4*ht
   xg=www-uo-2*ht
   if (iright.gt.0) xg=xg-2*ht
   yg=wwh-tspace-vo-ht
   if (tspace.eq.zero) yg=yg-ht

   !--set up axis parameters
   wt=width
   wg=wt/2
   wa=2*wt
   tic=ht/2
   gap=4*ht/10
   lfont=ifont
   hf=3
   hf=hf/4
   hl=ht
   hn=8*hl/10

   !--set up coordinate transformation (no perspective)
   ro=1
   rs=1
   ct=0
   st=1
   cp=0
   sp=-1
   du=uo
   dv=vo

   !--color in the background inside the graph frame.
   ibg=1+iwcol
   ifg=1
   call transw(uo,vo,ull,vll)
   call transw(uo+xg,vo+yg,uur,vur)
   n=5
   x(1)=ull
   y(1)=vll
   x(2)=uur
   y(2)=vll
   x(3)=uur
   y(3)=vur
   x(4)=ull
   y(4)=vur
   x(5)=x(1)
   y(5)=y(1)
   w=wframe
   backgr=1
   call poly2(x,y,n,w,backgr)
   return
   end subroutine init2

   subroutine frame2(xg,yg,grace,iccol)
   !--------------------------------------------------------------------
   ! Sets up a clipping path just outside the frame boundary
   ! and sets foreground color for this curve.
   !--------------------------------------------------------------------
   ! externals
   integer::iccol
   real(kr)::xg,yg,grace,xll,yll,xur,yur,ull,vll,uur,vur
   ! internals
   real(kr),parameter::zero=0

   ifg=1+iccol
   call trans3(-grace,-grace,zero,xll,yll)
   call trans3(xg+grace,yg+grace,zero,xur,yur)
   call transw(xll,yll,ull,vll)
   call transw(xur,yur,uur,vur)
   call gset(ull,vll,uur,vur)
   return
   end subroutine frame2

   subroutine endfr
   !--------------------------------------------------------------------
   ! End the 2D plotting frame by clearing the frame clipping path.
   !--------------------------------------------------------------------
   call gend
   end subroutine endfr

    subroutine init3(bx,by,bz,vx,vy,vz,iwcol)
   !--------------------------------------------------------------------
   ! Initialize a 3-d plot.
   !--------------------------------------------------------------------
   ! externals
   integer::iwcol
   real(kr)::bx,by,bz,vx,vy,vz
   ! internals
   real(kr)::umin,umax,vmin,vmax,yy,u,v,xx,dx,dy,su,sv,s
   real(kr),parameter::zero=0

   !--set color of 3d slices to the window color
   ibg=1+iwcol
   ifg=1

   !--set up axis parameters
   wt=width
   wg=wt/2
   wa=wt
   tic=ht/2
   gap=4*ht/10
   lfont=ifont
   hf=3
   hf=hf/4
   hl=ht
   hn=ht

   !--set up 3-d transformation
   ro=sqrt(vx**2+vy**2+vz**2)
   rp=sqrt(vx**2+vy**2)
   ct=rp/ro
   st=vz/ro
   cp=vx/rp
   sp=vy/rp
   rs=ro/sqrt(bx**2+by**2+bz**2)
   du=0
   dv=0

   !--adjust view scale and position to
   !--center the projection in the window
   umin=1000
   umax=-1000
   vmin=1000
   vmax=-1000
   yy=-5*ht
   if (bx.gt.zero) call trans3(zero,yy,zero,u,v)
   if (bx.lt.zero) call trans3(bx,yy,zero,u,v)
   if (u.lt.umin) umin=u
   if (u.gt.umax) umax=u
   if (v.lt.vmin) vmin=v
   if (v.gt.vmax) vmax=v
   if (bx.gt.zero) call trans3(zero,by,bz+ht,u,v)
   if (bx.lt.zero) call trans3(bx,by,bz+ht,u,v)
   if (u.lt.umin) umin=u
   if (u.gt.umax) umax=u
   if (v.lt.vmin) vmin=v
   if (v.gt.vmax) vmax=v
   xx=bx+2*ht
   yy=-7*ht/2
   if (bx.gt.zero) call trans3(xx,yy,zero,u,v)
   if (bx.lt.zero) call trans3(zero,yy,zero,u,v)
   if (u.lt.umin) umin=u
   if (u.gt.umax) umax=u
   if (v.lt.vmin) vmin=v
   if (v.gt.vmax) vmax=v
   dx=3*ht
   dy=2*ht
   if (bx.gt.zero) call trans3(bx+dx,by+dy,zero,u,v)
   if (bx.lt.zero) call trans3(dx,by+dy,zero,u,v)
   if (u.lt.umin) umin=u
   if (u.gt.umax) umax=u
   if (v.lt.vmin) vmin=v
   if (v.gt.vmax) vmax=v
   su=www/(umax-umin)
   sv=wwh/(vmax-vmin)
   s=su
   if (sv.lt.su) s=sv
   rs=s*rs
   du=(www-s*(umax-umin))/2-s*umin
   ! dv=(wwh-tspace-s*(vmax-vmin))/2-s*vmin
   dv=(wwh-s*(vmax-vmin))/2-s*vmin
   return
   end subroutine init3

   subroutine trans3(x,y,z,u,v)
   !--------------------------------------------------------------------
   ! Carry out the 3-d perspective transformation.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x,y,z,u,v,xo,s

   xo=ct*(cp*x+sp*y)+st*z
   s=rs/(ro-xo)
   u=s*(-sp*x+cp*y)+du
   v=s*(-st*(cp*x+sp*y)+ct*z)+dv
   return
   end subroutine trans3

   subroutine vect2(x1,y1,x2,y2,w,ivec)
   !--------------------------------------------------------------------
   ! Draw a 2d vector using the 3d vector call.
   !--------------------------------------------------------------------
   ! externals
   integer::ivec
   real(kr)::x1,y1,x2,y2,w
   ! internals
   real(kr),parameter::zero=0

   call vect3(x1,y1,zero,x2,y2,zero,w,ivec)
   return
   end subroutine vect2

   subroutine vect3(x1,y1,z1,x2,y2,z2,w,ivec)
   !--------------------------------------------------------------------
   ! Draw a 3d vector, where
   !  w is the thickness of the line.
   ! Set ivec.ne.0 to put an arrow head on the end.
   !--------------------------------------------------------------------
   ! externals
   integer::ivec
   real(kr)::x1,y1,z1,x2,y2,z2,w
   ! internals
   real(kr)::wu1,wv1,wu2,wv2,u1,u2,head,r,wx,wy,dx,dy,hx,hy,v1,v2
   ! size of vector arrowhead
   real(kr),parameter::ahead=.2e0_kr

   call trans3(x1,y1,z1,wu1,wv1)
   call trans3(x2,y2,z2,wu2,wv2)
   call transw(wu1,wv1,u1,v1)
   call transw(wu2,wv2,u2,v2)
   if (ivec.eq.0) then
      call moveh(u1,v1)
      call drawh(u2,v2,w,0)
   else
      head=ahead
      r=sqrt((u2-u1)**2+(v2-v1)**2)
      wx=w*(u2-u1)/r
      wy=w*(v2-v1)/r
      dx=head*(u2-u1)/r
      dy=head*(v2-v1)/r
      hx=dx/2
      hy=dy/2
      call moveh(u1,v1)
      call drawh(u2-wx,v2-wy,w,0)
      call moveh(u2-dx-hy,v2-dy+hx)
      call drawh(u2,v2,w,0)
      call drawh(u2-dx+hy,v2-dy-hx,w,0)
   endif
   return
   end subroutine vect3

   subroutine axis2(amin,amax,astp,label,nlabel,itic,nonum,&
     asize,xo,yo,xx,yx,xy,yy,numr)
   !--------------------------------------------------------------------
   ! Draw a 2-D axis using the 3-D axis routine.
   !--------------------------------------------------------------------
   ! externals
   integer::nlabel,itic,nonum,numr
   real(kr)::amin,amax,astp,asize,xo,yo,xx,yx,xy,yy
   character::label*(*)
   ! internals
   real(kr),parameter::zero=0

   call axis3(amin,amax,astp,label,nlabel,itic,nonum,asize,&
     xo,yo,zero,xx,yx,zero,xy,yy,zero,numr)
   return
   end subroutine axis2

   subroutine axis3(amin,amax,astp,label,nlabel,itic,nonum,&
     asize,xo,yo,zo,xx,yx,zx,xy,yy,zy,numr)
   !--------------------------------------------------------------------
   ! Draw an axis in 3-D perspective.
   ! ------
   ! amin is the left limit for the axis
   ! amax is the right limit for the axis
   ! astp is the step between axis numbering values
   !   (if astp=0., this is a log axis)
   ! nlabel=0 means no label or numbers
   ! nlabel>0 means label and numbers "above" axis
   ! nlabel<0 means label and number "below" axis
   ! itic=0 means no tick marks
   ! itic>0 means tick marks above axis
   ! itic<0 means tick marks below axis
   ! nonum=0 means all tick marks are numbered
   ! nonum=1 means all but first
   ! nonum=2 means all but last
   ! nonum=3 means neither end is numbered
   ! asize is the length of the axis in absolute units
   ! xo,yo,zo is the absolute location of the start of the axis
   ! xx,yx,zx is a unit vector in the direction of the axis
   ! xy,yy,zy is a unit vector for the character vertical direction
   !--------------------------------------------------------------------
   ! externals
   integer::nlabel,itic,nonum,numr
   real(kr)::amin,amax,astp,asize,xo,yo,zo,xx,yx,zx,xy,yy,zy
   character::label*(*)
   ! internals
   integer::n,nscale,iv,ifracs,i,imin,j,imax,iskip
   integer::k1,k,idone,k2,iii,lnum
   real(kr)::xe,ye,ze,shl,step,test,x,y,z,v,scale,vv
   real(kr)::ww,wwt,sh,xc,yc,zc,www,dd,origen,aend
   real(kr)::cycles,room,xt,yt,zt,xs,ys,zs,dx,dy,dz
   real(kr)::xl,yl,zl
      character num*20
   real(kr),dimension(8)::subs=(/.301e0_kr,.477e0_kr,.602e0_kr,&
     .699e0_kr,.778e0_kr,.845e0_kr,.903e0_kr,.954e0_kr/)
   real(kr),parameter::ds=.01e0_kr
   real(kr),parameter::sc1=.099e0_kr
   real(kr),parameter::sc2=.901e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::ten=10

   !--set color to black
   ifg=1

   !--draw the axis vector
   xe=xo+asize*xx
   ye=yo+asize*yx
   ze=zo+asize*zx
   call vect3(xo,yo,zo,xe,ye,ze,wa,0)
   shl=0

   !--draw the tic marks and numbers for a linear scale
   if (astp.ne.zero) then
      n=nint((amax-amin)/astp)
      step=asize/n
      n=n+1
      test=1
      test=test/1000
      if (abs(xx-1).lt.test) then
         fvx=amin
         dvx=(amax-amin)/asize
         logx=0
         xmin=xo
         xmax=xo+asize
         xstp=step
      else if (abs(yx-1).lt.test) then
         fvy=amin
         dvy=(amax-amin)/asize
         logy=0
         ymin=yo
         ymax=yo+asize
         ystp=step
      else if (abs(zx-1).lt.test) then
         fvz=amin
         dvz=(amax-amin)/asize
         logz=0
         zmin=zo
         zmax=zo+asize
         zstp=step
      endif
      x=xo
      y=yo
      z=zo
      v=amin
      nscale=0
      if (abs(astp).lt.sc1.or.abs(astp).gt.sc2) then
         nscale=nint(log10(abs(astp)))
         if (nscale.lt.0) nscale=nscale-2
         nscale=3*(nscale/3)
      endif
      scale=ten**nscale
      !test=1
      !test=test-test/100
      !if (abs(amax/scale).lt.test) then
      !   nscale=nscale-3
      !   scale=scale/1000
      !endif
      iv=nint(astp/scale)
      vv=astp/scale
      test=1
      test=test/100
      ifracs=0
      if (abs(vv-iv).gt.test) ifracs=1
      do i=1,n
         if (itic.lt.0) then
            call vect3(x,y,z,x-tic*xy,y-tic*yy,z-tic*zy,wt,0)
         else if (itic.gt.0) then
            call vect3(x,y,z,x+tic*xy,y+tic*yy,z+tic*zy,wt,0)
         endif
         if (nlabel.ne.0) then
            if (i.ne.1.or.(nonum.ne.1.and.nonum.ne.3)) then
               iv=nint(v/scale)
               vv=v/scale
               if (ifracs.eq.1) then
                  write(num,'(f6.1)') vv
               else
                  write(num,'(i5)') iv
               endif
               call stripv(num,lnum)
               ww=txtlen(num,lnum,lfont,hn)/2
               wwt=ww
               if (i.eq.1.and.itic.gt.0.and.nlabel.lt.0) wwt=ww/2
               if (i.eq.1.and.itic.lt.0.and.nlabel.gt.0) wwt=ww/2
               if (i.eq.n.and.itic.gt.0.and.nlabel.lt.0) wwt=3*ww/2
               if (i.eq.n.and.itic.lt.0.and.nlabel.gt.0) wwt=3*ww/2
               if (nlabel.lt.0) then
                  sh=gap+hf*hn
                  if (itic.lt.0) sh=sh+tic-gap/2
                  if (numr.eq.0) then
                     xc=x-sh*xy-wwt*xx
                     yc=y-sh*yy-wwt*yx
                     zc=z-sh*zy-wwt*zx
                     if (sh+hf*hn.gt.shl) shl=sh+hf*hn
                  else
                     xc=x-sh*xy-hf*hn*xx/2
                     yc=y-sh*yy-hf*hn*yx/2
                     zc=z-sh*zy-hf*hn*zx/2
                     test=sh+2*ww+hn/2
                     if (test.gt.shl) shl=test
                  endif
               else
                  sh=gap
                  if (itic.gt.0) sh=sh+tic-gap/2
                  if (numr.eq.0) then
                     xc=x+sh*xy-wwt*xx
                     yc=y+sh*yy-wwt*yx
                     zc=z+sh*zy-wwt*zx
                     test=sh+2*hf*hn
                     if (test.gt.shl) shl=test
                  else
                     xc=x+(sh+2*ww)*xy-hf*hn*xx/2
                     yc=y+(sh+2*ww)*yy-hf*hn*yx/2
                     zc=z+(sh+2*ww)*zy-hf*hn*zx/2
                     test=sh+2*ww+hn/2
                     if (test.gt.shl) shl=test
                  endif
               endif
               if (numr.eq.0) then
                  call text3(num,lnum,lfont,hn,&
                    xc,yc,zc,xx,yx,zx,xy,yy,zy)
               else
                  call text3(num,lnum,lfont,hn,&
                    xc,yc,zc,-xy,-yy,-zy,xx,yx,zx)
               endif
            endif
         endif
         x=x+step*xx
         y=y+step*yx
         z=z+step*zx
         v=v+astp
      enddo
      if (nscale.ne.0.and.nlabel.ne.0) then
         if (nonum.ne.2.and.nonum.ne.3) then
            if ((nscale.gt.-10.and.nscale.lt.0).or.nscale.ge.10) then
               write(num,'(''*10#EH.8<'',i2,''#HXEX<'')') nscale
               lnum=17
            else if (nscale.le.-10) then
               write(num,'(''*10#EH.8<'',i3,''#HXEX<'')') nscale
               lnum=18
            else
               write(num,'(''*10#EH.8<'',i1,''#HXEX<'')') nscale
               lnum=16
            endif
            www=txtlen(num,lnum,lfont,hn)
            if (nlabel.lt.0) then
               if (numr.eq.0) then
                  xc=xc-6*hn*xy/5
                  yc=yc-6*hn*yy/5
                  zc=zc-6*hn*zy/5
               else
                  xc=xc-6*hn*xx/5
                  yc=yc-6*hn*yx/5
                  zc=zc-6*hn*zx/5
               endif
            else
               if (numr.eq.0) then
                  xc=xc+6*hn*xy/5
                  yc=yc+6*hn*yy/5
                  zc=zc+6*hn*zy/5
               else
                  dd=hf*hn/2+6*hn/5
                  xc=x+(www+gap)*xy-dd*xx-step*xx
                  yc=y+(www+gap)*yy-dd*yx-step*yx
                  zc=z+(www+gap)*zy-dd*zx-step*zx
               endif
            endif
            if (numr.eq.0) then
               call text3(num,lnum,lfont,hn,&
                 xc,yc,zc,xx,yx,zx,xy,yy,zy)
            else
               call text3(num,lnum,lfont,hn,&
                 xc,yc,zc,-xy,-yy,-zy,xx,yx,zx)
            endif
         endif
      endif

   !--draw the tick marks and numbers for a log scale
   else
      origen=log10(amin)
      i=int(origen)
      if (origen.lt.zero) i=i-1
      v=origen-i
      if (v.lt.ds) then
         v=0
      else if (v.lt.subs(1)+ds) then
         v=subs(1)
      else if (v.lt.subs(4)+ds) then
         v=subs(4)
      else
         i=i+1
         v=0
      endif
      origen=i+v
      imin=i
      if (v.gt.zero) imin=i+1
      if ((imin.gt.-10.and.imin.lt.0).or.imin.ge.10) then
         write(num,'(''10#EH.8<'',i2,''#HXEX<'')') imin
         lnum=16
      else if (imin.le.-10) then
         write(num,'(''10#EH.8<'',i3,''#HXEX<'')') imin
         lnum=17
      else
         write(num,'(''10#EH.8<'',i1,''#HXEX<'')') imin
         lnum=15
      endif
      ww=txtlen(num,lnum,lfont,hn)
      www=ww
      aend=log10(amax)
      j=int(aend)
      if (aend.lt.zero) j=j-1
      v=aend-j
      if (v.lt.ds) then
         v=0
      else if (v.lt.subs(1)+ds) then
         v=subs(1)
      else if (v.lt.subs(4)+ds) then
         v=subs(4)
      else
         j=j+1
         v=0
      endif
      aend=j+v
      imax=j
      if (v.gt.0.) imax=imax-1
      if ((imax.gt.-10.and.imax.lt.0).or.imax.ge.10) then
         write(num,'(''10#EH.8<'',i2,''#HXEX<'')') imax
         lnum=16
      else if (imax.le.-10) then
         write(num,'(''10#EH.8<'',i3,''#HXEX<'')') imax
         lnum=17
      else
         write(num,'(''10#EH.8<'',i1,''#HXEX<'')') imax
         lnum=15
      endif
      ww=txtlen(num,lnum,lfont,hn)
      if (ww.gt.www) www=ww
      cycles=(aend-origen)/asize
      test=1
      test=test/10
      if (abs(xx*xy+yx*yy+zx*zy-1).lt.test) then
         room=6*hn/5
      else
         room=6*www/5
      endif
      iskip=int(room*abs(cycles))
      iskip=1+iskip
      test=1
      test=test/1000
      if (abs(xx-1).lt.test) then
         fvx=origen
         dvx=cycles
         logx=1
         xmin=xo
         xmax=xo+asize
      else if (abs(yx-1).lt.test) then
         fvy=origen
         dvy=cycles
         logy=1
         ymin=yo
         ymax=yo+asize
      else if (abs(zx-1).lt.test) then
         fvz=origen
         dvz=cycles
         logz=1
         zmin=zo
         zmax=zo+asize
      endif
      if (itic.lt.0) then
         xt=-tic*xy
         yt=-tic*yy
         zt=-tic*zy
      else
         xt=tic*xy
         yt=tic*yy
         zt=tic*zy
      endif
      i=int(origen)
      test=1
      test=test/10
      if (origen-i.gt.test) i=i+1
      v=ten**i
      x=xo+((i-origen)/cycles)*xx
      y=yo+((i-origen)/cycles)*yx
      z=zo+((i-origen)/cycles)*zx
      if (itic.ne.0) then
         test=1
         if (cycles.le.test) then
            k1=0
            test=1
            test=test/10
            if (abs(origen-i+1-subs(1)).lt.test) k1=1
            if (abs(origen-i+1-subs(4)).lt.test) k1=4
            if (k1.ne.0) then
               do k=k1,8
                  sh=(subs(k)-1)/cycles
                  xs=x+sh*xx
                  ys=y+sh*yx
                  zs=z+sh*zx
                  dx=xt/2
                  dy=yt/2
                  dz=zt/2
                  call vect3(xs,ys,zs,xs+dx,ys+dy,zs+dz,wt,0)
               enddo
            endif
         endif
      endif
      idone=0
      do while (idone.eq.0)
         if (itic.ne.0) then
            call vect3(x,y,z,x+xt,y+yt,z+zt,wt,0)
            test=1
            test=test/10
            if (abs(aend-i).ge.test) then
               test=1
               if (cycles.le.test) then
                  k2=8
                  test=1
                  test=test/10
                  if (abs(aend-i-subs(1)).lt.test) k2=1
                  if (abs(aend-i-subs(4)).lt.test) k2=4
                  do k=1,k2
                     sh=subs(k)/cycles
                     xs=x+sh*xx
                     ys=y+sh*yx
                     zs=z+sh*zx
                     dx=xt/2
                     dy=yt/2
                     dz=zt/2
                     call vect3(xs,ys,zs,xs+dx,ys+dy,zs+dz,wt,0)
                  enddo
               endif
            endif
         endif
         if (nlabel.ne.0) then
            test=1
            test=test/1000
            if (abs(i-origen).ge.test.or.&
              (nonum.ne.1.and.nonum.ne.3)) then
               if (log10(v).lt.aend.or.&
                 (nonum.ne.2.and.nonum.ne.3)) then
                  iii=int(i-origen)
                  if (mod(iii,iskip).eq.0) then
                     if ((i.gt.-10.and.i.lt.0).or.i.ge.10) then
                        write(num,'(''10#EH.8<'',i2,''#HXEX<'')') i
                        lnum=16
                     else if (i.le.-10) then
                        write(num,'(''10#EH.8<'',i3,''#HXEX<'')') i
                        lnum=17
                     else
                        write(num,'(''10#EH.8<'',i1,''#HXEX<'')') i
                        lnum=15
                     endif
                     ww=txtlen(num,lnum,lfont,hn)/2
                     if (i.eq.origen) then
                        if (itic.eq.0) then
                           ww=ww/2
                        else
                           if (itic.lt.0.and.nlabel.gt.0) then
                              ww=ww/2
                           else if (itic.gt.0.and.nlabel.lt.0) then
                              ww=ww/2
                           endif
                        endif
                     endif
                     if (nlabel.lt.0) then
                        sh=gap+hf*hn
                        if (itic.lt.0) sh=sh+tic-gap/2
                        if (numr.eq.0) then
                           xc=x-sh*xy-ww*xx
                           yc=y-sh*yy-ww*yx
                           zc=z-sh*zy-ww*zx
                           test=sh+hf*hn
                           if (test.gt.shl) shl=test
                        else
                           xc=x-sh*xy-hf*hn*xx/2
                           yc=y-sh*yy-hf*hn*yx/2
                           zc=z-sh*zy-hf*hn*zx/2
                           test=sh+www+hn/2
                           if (test.gt.shl) shl=test
                        endif
                     else
                        sh=gap
                        if (itic.gt.0) sh=sh+tic-gap/2
                        if (numr.eq.0) then
                           xc=x+sh*xy-ww*xx
                           yc=y+sh*yy-ww*yx
                           zc=z+sh*zy-ww*zx
                           test=sh+2*hf*hn
                           if (test.gt.shl) shl=test
                        else
                           xc=x+(sh+www)*xy-hf*hn*xx/2
                           yc=y+(sh+www)*yy-hf*hn*yx/2
                           zc=z+(sh+www)*zy-hf*hn*zx/2
                           test=sh+www+hn/2
                           if (test.gt.shl) shl=test
                        endif
                     endif
                     if (numr.eq.0) then
                        call text3(num,lnum,lfont,hn,&
                          xc,yc,zc,xx,yx,zx,xy,yy,zy)
                     else
                        call text3(num,lnum,lfont,hn,&
                          xc,yc,zc,-xy,-yy,-zy,xx,yx,zx)
                     endif
                  endif
               endif
            endif
         endif
         if (i.ge.j) then
            idone=1
         else
            x=x+(1/cycles)*xx
            y=y+(1/cycles)*yx
            z=z+(1/cycles)*zx
            i=i+1
            v=v*10
         endif
      enddo
   endif

   !--add the centered axis label
   if (nlabel.ne.0) then
      if (label.ne.'.') then
         ww=txtlen(label,iabs(nlabel),lfont,hl)
         ww=(asize-ww)/2
         if (nlabel.lt.0) then
            sh=shl+hf*hl
            xl=xo-sh*xy+ww*xx
            yl=yo-sh*yy+ww*yx
            zl=zo-sh*zy+ww*zx
         else
            sh=shl
            xl=xo+sh*xy+ww*xx
            yl=yo+sh*yy+ww*yx
            zl=zo+sh*zy+ww*zx
         endif
         call text3(label,iabs(nlabel),lfont,hl,&
           xl,yl,zl,xx,yx,zx,xy,yy,zy)
      endif
   endif
   return
   end subroutine axis3

   real(kr) function xscale(x)
   !--------------------------------------------------------------------
   ! Function to convert user x coordinate to axis coordinate.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x
   ! internals
   real(kr)::xn

   xn=x
   if (logx.eq.1) xn=log10(xn)
   xscale=(xn-fvx)/dvx
   return
   end function xscale

   real(kr) function yscale(y)
   !--------------------------------------------------------------------
   ! Function to convert user y coordinate to axis coordinate.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::y
   ! internals
   real(kr)::yn

   yn=y
   if (logy.eq.1) yn=log10(yn)
   yscale=(yn-fvy)/dvy
   return
   end function yscale

   real(kr) function zscale(z)
   !--------------------------------------------------------------------
   ! Function to convert user z coordinate to axis coordinate.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::z
   ! internals
   real(kr)::zn

   zn=z
   if (logz.eq.1) zn=log10(zn)
   zscale=(zn-fvz)/dvz
   return
   end function zscale

   real(kr) function xinvrs(x)
   !--------------------------------------------------------------------
   ! Function to convert x axis coordinates back to user coordinates.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x
   ! internals
   real(kr)::xn
   real(kr),parameter::ten=10

   xn=x*dvx+fvx
   xinvrs=xn
   if (logx.eq.1) xinvrs=ten**xn
   return
   end function xinvrs

   real(kr) function yinvrs(y)
   !--------------------------------------------------------------------
   ! Function to convert y axis coordinates back to user coordinates.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::y
   ! internals
   real(kr)::yn
   real(kr),parameter::ten=10

   yn=y*dvy+fvy
   yinvrs=yn
   if (logy.eq.1) yinvrs=ten**yn
   return
   end function yinvrs

   subroutine grid2(nx,ny)
   !--------------------------------------------------------------------
   ! Draw a 2D grid using the 3D grid call
   !--------------------------------------------------------------------
   ! externals
   integer::nx,ny

   zmin=0
   zmax=0
   call grid3(nx,ny,0)
   return
   end subroutine grid2

   subroutine grid3(nx,ny,nz)
   !--------------------------------------------------------------------
   ! Draw a grid with nx lines per x axis step, ny lines
   ! per y axis step, and nz lines per z axis step.
   ! One of these three values must be zero or -1 to
   ! indicate in which plane the grid is to be drawn. For example,
   ! nx=0 means grid plane is at xmin, and nx=-1 means plane at xmax.
   ! The values of nx, ny, and/or nz are ignored for log axes.
   !--------------------------------------------------------------------
   ! externals
   integer::nx,ny,nz
   ! internals
   integer::i,k,idone
   real(kr)::y1,y2,z1,z2,x1,x2,v,test,xt,yt,zt
   real(kr),dimension(9)::subs=(/.301e0_kr,.477e0_kr,.602e0_kr,&
     .699e0_kr,.778e0_kr,.845e0_kr,.903e0_kr,.954e0_kr,1.000e0_kr/)

   if (nx.gt.0) then
      if (nz.eq.0) then
         y1=ymin
         y2=ymax
         z1=zmin
         z2=zmin
      else if (nz.eq.-1) then
         y1=ymin
         y2=ymax
         z1=zmax
         z2=zmax
      else
         if (ny.eq.0) then
            y1=ymin
            y2=ymin
            z1=zmin
            z2=zmax
         else
            y1=ymax
            y2=ymax
            z1=zmin
            z2=zmax
         endif
      endif
      x1=xmin
      if (logx.eq.1) then
         v=fvx
         i=nint(v)
         k=0
         test=1
         test=test/10
         if (abs(v-i-subs(1)).lt.test) k=1
         if (abs(v-i-subs(4)).lt.test) k=4
         xt=x1
         if (k.gt.0) xt=x1-subs(k)/dvx
         k=k+1
      endif
      idone=0
      do while (idone.eq.0)
         if (logx.eq.0) then
            x1=x1+xstp/nx
         else
            x1=xt+subs(k)/dvx
            k=k+1
            if (k.gt.9) then
               xt=x1
               k=1
            endif
         endif
         test=1
         test=test/100
         if (abs(xmax-x1).lt.test) then
            idone=1
         else
            x2=x1
            call vect3(x1,y1,z1,x2,y2,z2,wg,0)
         endif
      enddo
   endif

   if (ny.gt.0) then
      if (nz.eq.0) then
         x1=xmin
         x2=xmax
         z1=zmin
         z2=zmin
      else if (nz.eq.-1) then
         x1=xmin
         x2=xmax
         z1=zmax
         z2=zmax
      else
         if (nx.eq.0) then
            x1=xmin
            x2=xmin
            z1=zmin
            z2=zmax
         else
            x1=xmax
            x2=xmax
            z1=zmin
            z2=zmax
         endif
      endif
      y1=ymin
      if (logy.eq.1) then
         v=fvy
         i=nint(v)
         k=0
         test=1
         test=test/10
         if (abs(v-i-subs(1)).lt.test) k=1
         if (abs(v-i-subs(4)).lt.test) k=4
         yt=y1
         if (k.gt.0) yt=y1-subs(k)/dvy
         k=k+1
      endif
      idone=0
      do while (idone.eq.0)
         if (logy.eq.0) then
            y1=y1+ystp/ny
         else
            y1=yt+subs(k)/dvy
            k=k+1
            if (k.gt.9) then
               yt=y1
               k=1
            endif
         endif
         test=1
         test=test/100
         if (abs(ymax-y1).lt.test) then
            idone=1
         else
            y2=y1
            call vect3(x1,y1,z1,x2,y2,z2,wg,0)
         endif
      enddo
   endif

   if (nz.gt.0) then
      if (nx.eq.0) then
         y1=ymin
         y2=ymax
         x1=xmin
         x2=xmin
      else if (nx.eq.-1) then
         y1=ymin
         y2=ymax
         x1=xmax
         x2=xmax
      else
         if (ny.eq.0) then
            y1=ymin
            y2=ymin
            x1=xmin
            x2=xmax
         else
            y1=ymax
            y2=ymax
            x1=xmin
            x2=xmax
         endif
      endif
      z1=zmin
      if (logz.eq.1) then
         v=fvz
         i=nint(v)
         k=0
         test=1
         test=test/10
         if (abs(v-i-subs(1)).lt.test) k=1
         if (abs(v-i-subs(4)).lt.test) k=4
         zt=z1
         if (k.gt.0) zt=z1-subs(k)/dvz
         k=k+1
      endif
      idone=0
      do while (idone.eq.0)
         if (logz.eq.0) then
            z1=z1+zstp/nz
         else
            z1=zt+subs(k)/dvz
            k=k+1
            if (k.gt.9) then
               zt=z1
               k=1
            endif
         endif
         test=1
         test=test/100
         if (abs(zmax-z1).lt.test) then
            idone=1
         else
            z2=z1
            call vect3(x1,y1,z1,x2,y2,z2,wg,0)
         endif
      enddo
   endif
   return
   end subroutine grid3

   subroutine curv2(x,y,n,idash,width,icon,isym,ssym,ishade)
   !--------------------------------------------------------------------
   ! Draw a 2-D curve.
   !--------------------------------------------------------------------
   ! externals
   integer::n,idash,icon,isym,ishade
   real(kr)::x(n),y(n),width,ssym
   ! internals
   integer::i
   real(kr)::w,wu1,wu2,wv1,wv2,xn,yn,zn,wu,wv,u,v,foregr
   real(kr),parameter::zero=0
   w=width

   !--draw curve, if requested.
   if (icon.ge.0) then
      wu1=100
      wu2=-100
      wv1=100
      wv2=-100
      xn=xscale(x(1))
      yn=yscale(y(1))
      zn=0
      call trans3(xn,yn,zn,wu,wv)
      if (wu.lt.wu1) wu1=wu
      if (wu.gt.wu2) wu2=wu
      if (wv.lt.wv1) wv1=wv
      if (wv.gt.wv2) wv2=wv
      call transw(wu,wv,u,v)
      call moveh(u,v)
      do i=2,n
         xn=xscale(x(i))
         yn=yscale(y(i))
         zn=0
         call trans3(xn,yn,zn,wu,wv)
         if (wu.lt.wu1) wu1=wu
         if (wu.gt.wu2) wu2=wu
         if (wv.lt.wv1) wv1=wv
         if (wv.gt.wv2) wv2=wv
         call transw(wu,wv,u,v)
         call drawh(u,v,w,idash)
      enddo

      !--fill the curve with a shading pattern
      foregr=0
      if (ishade.gt.0.and.ishade.le.10) then
         ifg=ishade+10
         call fillh(foregr)
         ifg=0
      else if (ishade.gt.40) then
         ifg=ishade
         call fillh(foregr)
         ifg=0
      endif

      !--fill the curve with a hatching pattern
      if (ishade.gt.10) call hatch(ishade,wu1,wv1,wu2,wv2)

      !--make curve invisible (used with shaded areas)
      if (width.eq.zero) call ncurve
   endif

   !--draw symbols, if requested.
   if (icon.ne.0) then
      do i=1,n
         if (mod(i,iabs(icon)).eq.0) then
            xn=xscale(x(i))
            yn=yscale(y(i))
            zn=0
            call trans3(xn,yn,zn,wu,wv)
            call transw(wu,wv,u,v)
            call dsym(u,v,isym,ssym)
         endif
      enddo
   endif
   return
   end subroutine curv2

   subroutine curv3(x,y,z,n,w)
   !--------------------------------------------------------------------
   ! Draw a 3D curve as a polygon with white fill.
   ! Later curves will hide earlier ones.
   !--------------------------------------------------------------------
   ! externals
   integer::n
   real(kr)::x(n+1),y(n+1),z(n+1),w
   ! internals
   integer::max,i
   real(kr)::xn,yn,zn,wu,wv,u,v,backgr

   !--add a segment on the baseline
   x(n+1)=x(1)
   y(n+1)=y(1)
   z(n+1)=z(1)
   max=n+1

   !--draw the polygon with white fill
   xn=xscale(x(1))
   yn=yscale(y(1))
   zn=zscale(z(1))
   call trans3(xn,yn,zn,wu,wv)
   call transw(wu,wv,u,v)
   call moveh(u,v)
   do i=2,max
      xn=xscale(x(i))
      yn=yscale(y(i))
      zn=zscale(z(i))
      call trans3(xn,yn,zn,wu,wv)
      call transw(wu,wv,u,v)
      call drawh(u,v,w,0)
   enddo
   backgr=1
   call fillh(backgr)
   return
   end subroutine curv3

   subroutine poly2(x,y,n,w,fill)
   !--------------------------------------------------------------------
   ! Draw a filled 2D polygon.
   ! If w<0, don't draw the outline.
   !--------------------------------------------------------------------
   ! externals
   integer::n
   real(kr)::x(n),y(n),w,fill
   ! internals
   integer::i

   call moveh(x(1),y(1))
   do i=2,n
      call drawh(x(i),y(i),w,0)
   enddo
   call fillh(fill)
   return
   end subroutine poly2

   subroutine poly3(x,y,z,n,w)
   !--------------------------------------------------------------------
   ! Draw a 3D polygon with hiding.
   !--------------------------------------------------------------------
   ! externals
   integer::n
   real(kr)::x(n),y(n),z(n),w
   ! internals
   integer::i
   real(kr)::u,v,wu,wv

   call trans3(x(1),y(1),z(1),wu,wv)
   call transw(wu,wv,u,v)
   call moveh(u,v)
   do i=2,n
      call trans3(x(i),y(i),z(i),wu,wv)
      call transw(wu,wv,u,v)
      call drawh(u,v,w,0)
   enddo
   return
   end subroutine poly3

   subroutine hatch(ihatch,wu1,wv1,wu2,wv2)
   !--------------------------------------------------------------------
   ! Fill the current path with hatching or cross hatching.
   !--------------------------------------------------------------------
   ! externals
   integer::ihatch
   real(kr)::wu1,wv1,wu2,wv2
   ! internals
   integer::iop
   real(kr)::dx,ww,x1,x2,y1,y2,u,v
   real(kr),parameter::w=.003e0_kr
   real(kr),parameter::oh2=.02e0_kr

   iop=(ihatch-1)/10
   dx=oh2*(10-ihatch+10*iop+1)
   ww=wv2-wv1
   call cclip
   if (iop.eq.1.or.iop.eq.3) then
      x1=wu1-dx*int(ww/dx)-dx
      y1=wv1
      y2=wv2
      do while (x1.lt.wu2+w)
         x1=x1+dx
         call transw(x1,y1,u,v)
         call moveh(u,v)
         x2=x1+ww
         call transw(x2,y2,u,v)
         call drawh(u,v,w,0)
      enddo
   endif
   if (iop.eq.2.or.iop.eq.3) then
      x1=wu2-dx*int((wu2-wu1+ww)/dx)-dx
      x2=wu2+w-1
      y1=wv1
      y2=wv2
      do while (x2.lt.wu2+w)
         x1=x1+dx
         call transw(x1,y1,u,v)
         call moveh(u,v)
         x2=x1-ww
         call transw(x2,y2,u,v)
         call drawh(u,v,w,0)
      enddo
   endif
   call nclip
   return
   end subroutine hatch

   subroutine text2(txt,ntxt,ifont,ht,xo,yo,xx,yx,xy,yy)
   !--------------------------------------------------------------------
   ! Draw a 2D text string using the 3d text call.
   !--------------------------------------------------------------------
   ! externals
   integer::ntxt,ifont
   character::txt*(*)
   real(kr)::ht,xo,yo,xx,yx,xy,yy
   ! internals
   real(kr),parameter::zero=0

   call text3(txt,ntxt,ifont,ht,xo,yo,zero,xx,yx,zero,xy,yy,zero)
   return
   end subroutine text2

   subroutine text3(txt,ntxt,ifont,ht,xo,yo,zo,xx,yx,zx,xy,yy,zy)
   !--------------------------------------------------------------------
   ! Draw a text string (including instructions) in 3D perspective.
   ! ifont and ht are the font and height for the characters.
   ! xo,yo,zo is the origen of the lower left corner of the text.
   ! xx,yx,zx is a unit vector in the character "x" direction.
   ! xy,yy,zy is a unit vector in the character "y" direction.
   !--------------------------------------------------------------------
   ! externals
   integer::ntxt,ifont
   character::txt*(*)
   real(kr)::ht,xo,yo,zo,xx,yx,zx,xy,yy,zy
   ! internals
   integer::icase,ialf,imode,jfont,i,j,ins,iskip,ii
   real(kr)::scale,x,y,z,delta,cbase,celev,dy,siz,wi
   real(kr)::xn,yn,zn,wu,wv,u,v,ux,vx,uy,vy
   character(1)::c,comm
   character(80)::temp

   scale=1
   x=xo
   y=yo
   z=zo
   delta=0

   cbase=0
   celev=0
   icase=0
   ialf=0
   imode=0
   jfont=ifont
   i=1
   j=0
   do while (i.le.ntxt)
      c=txt(i:i)
      if (imode.eq.1) then
         if ((lge(c,'0').and.lle(c,'9')).or.&
           c.eq.'.'.or.c.eq.'-') then
            j=j+1
            temp(j:j)=c
         else if (c.eq.'X') then
            j=j+1
            temp(j:j)=c
         else
            if (j.eq.0) then
               temp(1:1)='D'
               j=1
            endif
            if (comm.eq.'E') then
               if (temp(1:1).eq.'D') then
                  temp='.5'
                  j=2
               endif
               if (temp(1:1).eq.'X') then
                  celev=0
               else
                  dy=rget(temp,j)
                  if (dy.gt.0) then
                     celev=ht*dy
                  else
                     celev=-ht*dy
                  endif
               endif
               delta=celev
            else if (comm.eq.'L') then
               if (temp(1:1).eq.'D') then
                  temp='.5'
                  j=2
               endif
               if (temp(1:1).eq.'X') then
                  celev=0
               else
                  dy=rget(temp,j)
                  if (dy.gt.0) then
                     celev=-ht*dy
                  else
                     celev=ht*dy
                  endif
               endif
               delta=celev
            else if (comm.eq.'H') then
               if (temp(1:1).eq.'D') then
               temp='.7'
                  j=2
               endif
               if (temp(1:1).eq.'X') then
                  scale=1
               else
                  scale=rget(temp,j)
               endif
            else if (comm.eq.'O') then
               dy=rget(temp,j)
               cbase=cbase+dy
            else if (comm.eq.'F') then
               jfont=iget(temp,j)
            else if (comm.eq.'M') then
               ialf=iget(temp,j)
            endif
            comm=c
            j=0
            if (c.eq.'<'.or.c.eq.'>'.or.c.eq.'['.or.c.eq.']') then
               imode=0
               i=i-1
            endif
         endif
      else
         ins=0
         iskip=0
         if (c.eq.'#') then
            if (txt(i+1:i+1).eq.'#') then
               i=i+1
            else
               ins=1
            endif
         endif
         if (c.eq.'<') then
            if (txt(i+1:i+1).eq.'<') then
               i=i+1
            else
               jfont=ifont
               icase=1
               iskip=1
            endif
         endif
         if (c.eq.'>') then
            if (txt(i+1:i+1).eq.'>') then
               i=i+1
            else
               jfont=ifont
               icase=0
               iskip=1
            endif
         endif
         if (c.eq.'[') then
            if (txt(i+1:i+1).eq.'[') then
               i=i+1
            else
               jfont=3
               icase=1
               iskip=1
            endif
         endif
         if (c.eq.']') then
            if (txt(i+1:i+1).eq.']') then
               i=i+1
            else
               jfont=3
               icase=0
               iskip=1
            endif
         endif
         if (ins.eq.1) then
            imode=1
            comm=c
            j=0
         else if (iskip.eq.1) then
            iskip=0
         else
            if (icase.eq.1) then
               ii=ichar(c)
               if (ii.ge.96) ii=ii-32
               c=char(ii)
            endif
            siz=scale*ht
            wi=ssum(c,1,jfont,ialf,siz)
            xn=x+delta*xy
            yn=y+delta*yy
            zn=z+delta*zy
            call trans3(xn,yn,zn,wu,wv)
            call transw(wu,wv,u,v)
            call trans3(xn+xx,yn+yx,zn+zx,wu,wv)
            call transw(wu,wv,ux,vx)
            call trans3(xn+xy,yn+yy,zn+zy,wu,wv)
            call transw(wu,wv,uy,vy)
            ux=ux-u
            vx=vx-v
            uy=uy-u
            vy=vy-v
            call dchr(u,v,c,jfont,ialf,siz,ux,vx,uy,vy)
            x=x+wi*xx
            y=y+wi*yx
            z=z+wi*zx
         endif
      endif
      i=i+1
   enddo
   return
   end subroutine text3

   real(kr) function txtlen(txt,ntxt,ifont,ht)
   !--------------------------------------------------------------------
   ! Measure the length of a text string (with instructions), where
   ! ifont and ht give the font and size of the normal characters.
   !--------------------------------------------------------------------
   ! externals
   integer::ntxt,ifont
   character txt*(ntxt)
   real(kr)::ht
   ! internals
   integer::icase,ialf,imode,jfont,i,j,ins,iskip,ii,l
   real(kr)::siz,cbase,celev,scale,y
   character c*1,comm*1,num*4,temp*80

   siz=0
   cbase=0
   celev=0
   icase=0
   ialf=0
   scale=1
   imode=0
   iskip=0
   jfont=ifont
   i=1
   j=0
   do while (i.le.ntxt)
      c=txt(i:i)
      if (imode.eq.1) then
         if ((lge(c,'0').and.lle(c,'9')).or.c.eq.'.'.or.&
           c.eq.'-') then
            j=j+1
            temp(j:j)=c
         else if (c.eq.'X') then
            j=j+1
            temp(j:j)=c
         else
            if (j.eq.0) then
               temp(1:1)='D'
               j=1
            endif
            if (comm.eq.'E') then
               if (temp(1:1).eq.'D') then
                  temp='.5'
                  j=2
               endif
               if (temp(1:1).eq.'X') then
                  celev=0
               else
                  y=rget(temp,j)
                  if (y.gt.0) then
                     celev=ht*y
                  else
                     celev=-ht*y
                  endif
               endif
            else if (comm.eq.'L') then
               if (temp(1:1).eq.'D') then
                  temp='.5'
                  j=2
               endif
               if (temp(1:1).eq.'X') then
                  celev=0
               else
                  y=rget(temp,j)
                  if (y.gt.0) then
                     celev=-ht*y
                  else
                     celev=ht*y
                  endif
               endif
            else if (comm.eq.'H') then
               if (temp(1:1).eq.'D') then
               temp='.7'
                  j=2
               endif
               if (temp(1:1).eq.'X') then
                  scale=1
               else
                  scale=rget(temp,j)
               endif
            else if (comm.eq.'O') then
               y=rget(temp,j)
               cbase=cbase+y
            else if (comm.eq.'F') then
               jfont=iget(temp,j)
            else if (comm.eq.'M') then
               ialf=iget(temp,j)
            endif
            comm=c
            j=0
            if (c.eq.'<'.or.c.eq.'>'.or.c.eq.'['.or.c.eq.']') then
               imode=0
            endif
         endif
      else
         ins=0
         iskip=0
         if (i.lt.ntxt) then
            if (c.eq.'#') then
               if (txt(i+1:i+1).eq.'#') then
                  i=i+1
               else
                  ins=1
               endif
            endif
            if (c.eq.'<') then
               if (txt(i+1:i+1).eq.'<') then
                  i=i+1
               else
                  icase=1
                  jfont=ifont
                  iskip=1
               endif
            endif
            if (c.eq.'>') then
               if (txt(i+1:i+1).eq.'>') then
                  i=i+1
               else
                  icase=0
                  jfont=ifont
                  iskip=1
               endif
            endif
            if (c.eq.'[') then
               if (txt(i+1:i+1).eq.'[') then
                  i=i+1
               else
                  icase=1
                  jfont=3
                  iskip=1
               endif
            endif
            if (c.eq.']') then
               if (txt(i+1:i+1).eq.']') then
                  i=i+1
               else
                  icase=0
                  jfont=3
                  iskip=1
               endif
            endif
         endif
         if (ins.eq.1) then
            imode=1
            siz=siz+ssum(temp,l,jfont,ialf,scale)
            comm=c
            j=0
         else if (iskip.eq.1) then
            iskip=0
         else
            if (ialf.eq.0) then
               j=j+1
               if (icase.eq.1) then
                  ii=ichar(c)
                  if (ii.ge.96) ii=ii-32
                  c=char(ii)
               endif
               temp(j:j)=c
               if (c.ne.' ') l=j
            else
               j=j+1
               write(num,'(a1,o3.3)') char(92),ichar(c)+128
               temp(j:j+3)=num(1:4)
               j=j+3
               l=j
            endif
         endif
      endif
      i=i+1
   enddo
   if (j.gt.0) siz=siz+ssum(temp,l,jfont,ialf,scale)
   txtlen=siz*ht
   return
   end function txtlen

   function ssum(temp,l,ifont,ialf,scale)
   !--------------------------------------------------------------------
   ! Private routine for txtlen.  Sums text width.
   !--------------------------------------------------------------------
   ! externals
   integer::l,ifont,ialf
   real(kr)::scale
   character::temp*(l)
   ! internals
   integer::itabl,i
   real(kr)::ssum

   itabl=ifont
   ssum=0
   do i=1,l
      ssum=ssum+scale*charw(temp(i:i),itabl)
   enddo
   return
   end function ssum

   integer function iget(strng,n)
   !--------------------------------------------------------------------
   ! Decode an integer out of a string of length n.
   !--------------------------------------------------------------------
   ! externals
   integer::n
   character::strng*(*)
   ! internals
   integer::neg,ival,i,j
   character c*1
   character(10),parameter::digits='0123456789'

   neg=0
   ival=0
   do i=1,n
      c=strng(i:i)
      j=index(digits,c)
      if (j.gt.0) then
         ival=10*ival+j-1
      else if (c.eq.'-') then
         neg=1
      endif
   enddo
   if (neg.eq.1) ival=-ival
   iget=ival
   return
   end function iget

   real(kr) function rget(strng,n)
   !--------------------------------------------------------------------
   ! Decode a real out of a string of length n.
   !--------------------------------------------------------------------
   ! externals
   integer::n
   character::strng*(*)
   ! internals
   integer::neg,ival,ipwr,i,j
   real(kr)::val
   character(1)::c
   character(10),parameter::digits='0123456789'
   real(kr),parameter::ten=10

   neg=0
   ival=0
   ipwr=0
   do i=1,n
      c=strng(i:i)
      j=index(digits,c)
      if (j.gt.0) then
         ival=10*ival+j-1
         if (ipwr.ne.0) ipwr=ipwr+1
      else if (c.eq.'.') then
         ipwr=1
      else if (c.eq.'-') then
         neg=1
      endif
   enddo
   val=ival
   if (ipwr.ne.0) val=val*ten**(1-ipwr)
   if (neg.eq.1) val=-val
   rget=val
   return
   end function rget

!----------------------------------------------------------------------
!
! Postscript dependent routines for the plotting package
!
!----------------------------------------------------------------------

   subroutine gplot(lori,xpage,ypage,nnps)
   !--------------------------------------------------------------------
   ! Initialize plotting.
   ! Set up for US letter size paper (xpaper=8.5in, ypaper=11.0in).
   ! See separate setting for xpaper and ypaper at the start of viewr.
   ! There are also default settings for the page size in plotr.
   !--------------------------------------------------------------------
   use util ! provides openz
   ! externals
   integer::lori,nnps
   real(kr)::xpage,ypage
   ! internals
   integer::i1,i2,i3,i4

   xpaper=8.5e0_kr
   ypaper=11.0e0_kr

   ipage=0
   nps=nnps
   call openz(nps,1)
   write(nps,'(''%!PS-Adobe-'')')
   if (lori.eq.0) then
      i1=int((xpaper-xpage)*72/2)
      i2=int((ypaper-ypage)*72/2)
      i3=int(i1+xpage*72)
      i4=int(i2+ypage*72)
      ushift=i1
      vshift=i2
      uwidth=xpage*72
   else
      i1=int((ypaper-xpage)*72/2)
      i2=int((xpaper-ypage)*72/2)
      i3=int(i1+ypage*72)
      i4=int(i2+xpage*72)
      ushift=i2
      vshift=i1
      uwidth=ypage*72
   endif
   write(nps,'(''%%BoundingBox: '',4i5)') i1,i2,i3,i4
   write(nps,'(''%%Pages: (atend)'')')
   if (lori.eq.1) write(nps,'(''%%Orientation: Landscape'')')
   if (lori.eq.0) write(nps,'(''%%Orientation: Portrait'')')
   write(nps,'(''2 setlinecap'')')
   return
   end subroutine gplot

   subroutine gdone
   !--------------------------------------------------------------------
   ! Finalize plotting.
   !--------------------------------------------------------------------
   use util ! provides closz

   write(nps,'(''%gdone'')')
   if (ipage.lt.10) then
      write(nps,'(''%%Trailer'',/,''%%Pages: '',i1)') ipage
   else if (ipage.lt.100)then
      write(nps,'(''%%Trailer'',/,''%%Pages: '',i2)') ipage
   else
      write(nps,'(''%%Trailer'',/,''%%Pages: '',i3)') ipage
   endif
   write(nps,'(''%%EOF'')')
   call closz(nps)
   return
   end subroutine gdone

   subroutine gset(ull,vll,uur,vur)
   !--------------------------------------------------------------------
   ! Set up a clipping path.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::ull,vll,uur,vur
   ! internals
   real(kr)::w
   real(kr),parameter::width=.005e0_kr

   write(nps,'(''%gset'')')
   call moveh(ull,vll)
   w=width
   call drawh(uur,vll,w,0)
   call drawh(uur,vur,w,0)
   call drawh(ull,vur,w,0)
   call drawh(ull,vll,w,0)
   write(nps,'('' gsave clip newpath'')')
   return
   end subroutine gset

   subroutine gend
   !--------------------------------------------------------------------
   ! End a clipping path.
   !--------------------------------------------------------------------
   write(nps,'(''stroke grestore newpath''/''%gend'')')
   return
   end subroutine gend

   subroutine newp
   !--------------------------------------------------------------------
   ! Start a plotting page.
   !--------------------------------------------------------------------
   ipage=ipage+1
   write(nps,'(''%%Page:'',i4,i4)') ipage,ipage
   return
   end subroutine newp

   subroutine endp
   !--------------------------------------------------------------------
   ! End a plotting page.
   !--------------------------------------------------------------------
   write(nps,'(''stroke''/''showpage''/''%endp'')')
   return
   end subroutine endp

   subroutine moveh(x,y)
   !--------------------------------------------------------------------
   ! Low-level move routine for Postscript
   ! with portrait-landscape rotation.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x,y
   ! internals
   real(kr)::u1,v1,rgb,r,g,b,test

   if (land.eq.1) then
      u1=uwidth-72*y+ushift
      v1=72*x+vshift
   else
      u1=72*x+ushift
      v1=72*y+vshift
   endif
   write(nps,'(''stroke''/''newpath'')')
   rgb=255
   r=ifrgb(1,ifg)/rgb
   g=ifrgb(2,ifg)/rgb
   b=ifrgb(3,ifg)/rgb
   write(nps,'(3f6.3,'' setrgbcolor'')') r,g,b
   test=2000
   if (u1.gt.test) u1=2000
   test=-1000
   if (u1.lt.test) u1=-1000
   test=2000
   if (v1.gt.test) v1=2000
   test=-1000
   if (v1.lt.test) v1=-1000
   write(nps,'(2f9.2,'' moveto'')') u1,v1
   return
   end subroutine moveh

   subroutine drawh(x,y,w,idash)
   !--------------------------------------------------------------------
   ! Low-level draw routine for Postscript
   ! with portrait-landscape rotation
   ! and line-type control.
   ! If w is negative, don't draw the line.
   !--------------------------------------------------------------------
   ! externals
   integer::idash
   real(kr)::x,y,w
   ! internals
   real(kr)::u,v,test
   real(kr)::wlast=0.e0_kr
   integer::ldash=-1
   real(kr),parameter::zero=0

   if (w.lt.zero) then
      wlast=w
      ldash=idash
      return
   endif
   if (w.ne.wlast) then
      write(nps,'(f8.3,'' setlinewidth'')') 72*w
      wlast=w
   endif
   if (idash.ne.ldash) then
      if (idash.eq.0) then
         write(nps,'(''[] 0 setdash'')')
      else if (idash.eq.1) then
         write(nps,'(''['',2f9.2,''] 0 setdash'')')&
           72*w*5,72*w*3
      else if (idash.eq.2) then
         write(nps,'(''['',4f9.2,''] 0 setdash'')')&
           72*w*6,72*w*3,72*w*3,72*w*3
      else if (idash.eq.3) then
         write(nps,'(''['',4f9.2,''] 0 setdash'')')&
           72*w*6,72*w*3,72*w*1,72*w*3
      else if (idash.eq.4) then
         write(nps,'(''['',2f9.2,''] 0 setdash'')')&
           72*w*1,72*w*3
      endif
      ldash=idash
   endif
   if (land.eq.1) then
      u=uwidth-72*y+ushift
      v=72*x+vshift
   else
      u=72*x+ushift
      v=72*y+vshift
   endif
   test=2000
   if (u.gt.test) u=2000
   test=-1000
   if (u.lt.test) u=-1000
   test=2000
   if (v.gt.test) v=2000
   test=-1000
   if (v.lt.test) v=-1000
   write(nps,'(2f9.2,'' lineto'')') u,v
   return
   end subroutine drawh

   subroutine fillh(color)
   !--------------------------------------------------------------------
   ! Fill current path with background (1.) or foreground (0.) color.
   ! This may be a discrete color, or one of a progression of
   ! grays or shading colors used to show values.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::color
   ! internals
   real(kr)::rgb,cmin,cmax,r,g,b,ten

   rgb=255
   cmin=1
   cmin=cmin/100
   cmax=1
   cmax=1-cmax/100
   if (color.gt.cmax) then
      r=ibrgb(1,ibg)/rgb
      g=ibrgb(2,ibg)/rgb
      b=ibrgb(3,ibg)/rgb
   else if (color.lt.cmin.and.ifg.le.10) then
      ! curve colors
      r=ifrgb(1,ifg)/rgb
      g=ifrgb(2,ifg)/rgb
      b=ifrgb(3,ifg)/rgb
   else if (color.lt.cmin.and.ifg.le.20) then
      ! shades of gray
      ten=10
      r=(20-ifg)/ten
      g=(20-ifg)/ten
      b=(20-ifg)/ten
   else if (color.lt.cmin.and.ifg.gt.20) then
      ! filling in shades of curve colors
      r=isrgb(1,ifg-40)/rgb
      g=isrgb(2,ifg-40)/rgb
      b=isrgb(3,ifg-40)/rgb
   endif
   write(nps,'(''gsave'',3f6.3,'' setrgbcolor fill grestore'')') r,g,b
   return
   end subroutine fillh

   subroutine cclip
   !--------------------------------------------------------------------
   ! Set up a clipping path on the current path.
   !--------------------------------------------------------------------
   write(nps,'(''%cclip''/''gsave clip newpath'')')
   return
   end subroutine cclip

   subroutine nclip
   !--------------------------------------------------------------------
   ! Terminate clipping path on the current path.
   !--------------------------------------------------------------------
   write(nps,'(''stroke grestore''/''%nclip'')')
   return
   end subroutine nclip

   subroutine ncurve
   !--------------------------------------------------------------------
   ! Cancel current curve path for shaded regions without borders.
   !--------------------------------------------------------------------
   write(nps,'(''newpath'')')
   return
   end subroutine ncurve

   subroutine dsym(x,y,isym,size)
   !--------------------------------------------------------------------
   ! Low-level symbol routine using Postscript.
   !--------------------------------------------------------------------
   ! externals
   integer::isym
   real(kr)::x,y,size
   ! internals
   real(kr)::foregr,backgr,sz
   real(kr)::xx(10),yy(10)
   ! character stroke width
   real(kr),parameter::w=0.01e0_kr
   real(kr),parameter::rr=1.128e0_kr
   real(kr),parameter::c8=.414e0_kr
   real(kr),parameter::cd=1.4e0_kr
   real(kr),parameter::cx=.82e0_kr
   real(kr),parameter::t1=1.75e0_kr
   real(kr),parameter::t2=1.52e0_kr
   real(kr),parameter::t3=.88e0_kr
   sz=6*size/10
   foregr=0
   backgr=1

   !--square
   if (isym.eq.0) then
      xx(1)=x-sz
      yy(1)=y+sz
      xx(2)=x+sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y-sz
      xx(4)=x-sz
      yy(4)=y-sz
      xx(5)=x-sz
      yy(5)=y+sz
      call poly2(xx,yy,5,w,backgr)

   !--octagon
   else if (isym.eq.1) then
      xx(1)=x-c8*sz
      yy(1)=y+sz
      xx(2)=x+c8*sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y+c8*sz
      xx(4)=x+sz
      yy(4)=y-c8*sz
      xx(5)=x+c8*sz
      yy(5)=y-sz
      xx(6)=x-c8*sz
      yy(6)=y-sz
      xx(7)=x-sz
      yy(7)=y-c8*sz
      xx(8)=x-sz
      yy(8)=y+c8*sz
      xx(9)=x-c8*sz
      yy(9)=y+sz
      call poly2(xx,yy,9,w,backgr)

   !--triangle
   else if (isym.eq.2) then
      xx(1)=x-t2*sz
      yy(1)=y-t3*sz
      xx(2)=x
      yy(2)=y+t1*sz
      xx(3)=x+t2*sz
      yy(3)=yy(1)
      xx(4)=xx(1)
      yy(4)=yy(1)
      call poly2(xx,yy,4,w,backgr)

   !--cross
   else if (isym.eq.3) then
      call moveh(x,y+sz)
      call drawh(x,y-sz,w,0)
      call moveh(x-sz,y)
      call drawh(x+sz,y,w,0)

   !--ex
   else if (isym.eq.4) then
      call moveh(x-sz,y+sz)
      call drawh(x+sz,y-sz,w,0)
      call moveh(x-sz,y-sz)
      call drawh(x+sz,y+sz,w,0)

   !--diamond
   else if (isym.eq.5) then
      xx(1)=x-cd*sz
      yy(1)=y
      xx(2)=x
      yy(2)=y+cd*sz
      xx(3)=x+cd*sz
      yy(3)=y
      xx(4)=x
      yy(4)=y-cd*sz
      xx(5)=xx(1)
      yy(5)=yy(1)
      call poly2(xx,yy,5,w,backgr)

   !--inverted triangle
   else if (isym.eq.6) then
      xx(1)=x-t2*sz
      yy(1)=y+t3*sz
      xx(2)=x
      yy(2)=y-t1*sz
      xx(3)=x+t2*sz
      yy(3)=yy(1)
      xx(4)=xx(1)
      yy(4)=yy(1)
      call poly2(xx,yy,4,w,backgr)

   !--exed square
   else if (isym.eq.7) then
      xx(1)=x-sz
      yy(1)=y+sz
      xx(2)=x+sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y-sz
      xx(4)=x-sz
      yy(4)=y-sz
      xx(5)=x-sz
      yy(5)=y+sz
      call poly2(xx,yy,5,w,backgr)
      call moveh(x-sz,y+sz)
      call drawh(x+sz,y-sz,w,0)
      call moveh(x-sz,y-sz)
      call drawh(x+sz,y+sz,w,0)

   !--crossed ex
   else if (isym.eq.8) then
      call moveh(x-sz,y+sz)
      call drawh(x+sz,y-sz,w,0)
      call moveh(x-sz,y-sz)
      call drawh(x+sz,y+sz,w,0)
      call moveh(x-sz,y)
      call drawh(x+sz,y,w,0)
      call moveh(x,y+sz)
      call drawh(x,y-sz,w,0)

   !--crossed diamond
   else if (isym.eq.9) then
      xx(1)=x-cd*sz
      yy(1)=y
      xx(2)=x
      yy(2)=y+cd*sz
      xx(3)=x+cd*sz
      yy(3)=y
      xx(4)=x
      yy(4)=y-cd*sz
      xx(5)=xx(1)
      yy(5)=yy(1)
      call poly2(xx,yy,5,w,backgr)
      call moveh(x,y+cd*sz)
      call drawh(x,y-cd*sz,w,0)
      call moveh(x-cd*sz,y)
      call drawh(x+cd*sz,y,w,0)

   !--crossed octagon
   else if (isym.eq.10) then
      xx(1)=x-c8*sz
      yy(1)=y+sz
      xx(2)=x+c8*sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y+c8*sz
      xx(4)=x+sz
      yy(4)=y-c8*sz
      xx(5)=x+c8*sz
      yy(5)=y-sz
      xx(6)=x-c8*sz
      yy(6)=y-sz
      xx(7)=x-sz
      yy(7)=y-c8*sz
      xx(8)=x-sz
      yy(8)=y+c8*sz
      xx(9)=x-c8*sz
      yy(9)=y+sz
      call poly2(xx,yy,9,w,backgr)
      call moveh(x,y+sz)
      call drawh(x,y-sz,w,0)
      call moveh(x-sz,y)
      call drawh(x+sz,y,w,0)

   !--double triangle
   else if (isym.eq.11) then
      xx(1)=x-t2*sz
      yy(1)=y-t3*sz
      xx(2)=x
      yy(2)=y+t1*sz
      xx(3)=x+t2*sz
      yy(3)=yy(1)
      xx(4)=xx(1)
      yy(4)=yy(1)
      call poly2(xx,yy,4,w,backgr)
      xx(1)=x-t2*sz
      yy(1)=y+t3*sz
      xx(2)=x
      yy(2)=y-t1*sz
      xx(3)=x+t2*sz
      yy(3)=yy(1)
      xx(4)=xx(1)
      yy(4)=yy(1)
      call poly2(xx,yy,4,w,backgr)

   !--crossed square
   else if (isym.eq.12) then
      xx(1)=x-sz
      yy(1)=y+sz
      xx(2)=x+sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y-sz
      xx(4)=x-sz
      yy(4)=y-sz
      xx(5)=x-sz
      yy(5)=y+sz
      call poly2(xx,yy,5,w,backgr)
      call moveh(x,y+sz)
      call drawh(x,y-sz,w,0)
      call moveh(x-sz,y)
      call drawh(x+sz,y,w,0)

   !--exed octagon
   else if (isym.eq.13) then
      xx(1)=x-c8*sz
      yy(1)=y+sz
      xx(2)=x+c8*sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y+c8*sz
      xx(4)=x+sz
      yy(4)=y-c8*sz
      xx(5)=x+c8*sz
      yy(5)=y-sz
      xx(6)=x-c8*sz
      yy(6)=y-sz
      xx(7)=x-sz
      yy(7)=y-c8*sz
      xx(8)=x-sz
      yy(8)=y+c8*sz
      xx(9)=x-c8*sz
      yy(9)=y+sz
      call poly2(xx,yy,9,w,backgr)
      call moveh(x-sz,y+sz)
      call drawh(x+sz,y-sz,w,0)
      call moveh(x-sz,y-sz)
      call drawh(x+sz,y+sz,w,0)

   !--triangle and square
   else if (isym.eq.14) then
      xx(1)=x-sz
      yy(1)=y+sz
      xx(2)=x+sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y-sz
      xx(4)=x-sz
      yy(4)=y-sz
      xx(5)=x-sz
      yy(5)=y+sz
      call poly2(xx,yy,5,w,backgr)
      call moveh(x-sz,y-sz)
      call drawh(x,y+sz,w,0)
      call drawh(x+sz,y-sz,w,0)

   !--filled circle
   else if (isym.eq.15) then
      call circle(x,y,rr*sz,w)
      call fillh(foregr)

   !--circle
   else if (isym.eq.16) then
      call circle(x,y,rr*sz,w)
      call fillh(backgr)

   !--open square
   else if (isym.eq.17) then
      xx(1)=x-sz
      yy(1)=y+sz
      xx(2)=x+sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y-sz
      xx(4)=x-sz
      yy(4)=y-sz
      xx(5)=x-sz
      yy(5)=y+sz
      call poly2(xx,yy,5,w,backgr)

   !--filled square
   else if (isym.eq.18) then
      xx(1)=x-sz
      yy(1)=y+sz
      xx(2)=x+sz
      yy(2)=y+sz
      xx(3)=x+sz
      yy(3)=y-sz
      xx(4)=x-sz
      yy(4)=y-sz
      xx(5)=x-sz
      yy(5)=y+sz
      call poly2(xx,yy,5,w,foregr)

   !--filled diamond
   else if (isym.eq.19) then
      xx(1)=x-cd*sz
      yy(1)=y
      xx(2)=x
      yy(2)=y+cd*sz
      xx(3)=x+cd*sz
      yy(3)=y
      xx(4)=x
      yy(4)=y-cd*sz
      xx(5)=xx(1)
      yy(5)=yy(1)
      call poly2(xx,yy,5,w,foregr)

   !--filled triangle
   else if (isym.eq.20) then
      xx(1)=x-t2*sz
      yy(1)=y-t3*sz
      xx(2)=x
      yy(2)=y+t1*sz
      xx(3)=x+t2*sz
      yy(3)=yy(1)
      xx(4)=xx(1)
      yy(4)=yy(1)
      call poly2(xx,yy,4,w,foregr)

   !--filled inverted triangle
   else if (isym.eq.21) then
      xx(1)=x-t2*sz
      yy(1)=y+t3*sz
      xx(2)=x
      yy(2)=y-t1*sz
      xx(3)=x+t2*sz
      yy(3)=yy(1)
      xx(4)=xx(1)
      yy(4)=yy(1)
      call poly2(xx,yy,4,w,foregr)

   !--crossed circle
   else if (isym.eq.22) then
      call circle(x,y,rr*sz,w)
      call fillh(backgr)
      call moveh(x,y+rr*sz)
      call drawh(x,y-rr*sz,w,0)
      call moveh(x-rr*sz,y)
      call drawh(x+rr*sz,y,w,0)

   !--exed circle
   else if (isym.eq.23) then
      call circle(x,y,rr*sz,w)
      call fillh(backgr)
      call moveh(x-cx*sz,y+cx*sz)
      call drawh(x+cx*sz,y-cx*sz,w,0)
      call moveh(x-cx*sz,y-cx*sz)
      call drawh(x+cx*sz,y+cx*sz,w,0)

   !--exed diamond
   else if (isym.eq.24) then
      xx(1)=x-cd*sz
      yy(1)=y
      xx(2)=x
      yy(2)=y+cd*sz
      xx(3)=x+cd*sz
      yy(3)=y
      xx(4)=x
      yy(4)=y-cd*sz
      xx(5)=xx(1)
      yy(5)=yy(1)
      call poly2(xx,yy,5,w,backgr)
      call moveh(x-cd*sz/2,y+cd*sz/2)
      call drawh(x+cd*sz/2,y-cd*sz/2,w,0)
      call moveh(x-cd*sz/2,y-cd*sz/2)
      call drawh(x+cd*sz/2,y+cd*sz/2,w,0)

   !--default (circle)
   else
      call circle(x,y,rr*sz,w)
      call fillh(backgr)
   endif

   return
   end subroutine dsym

   subroutine circle(x,y,r,w)
   !--------------------------------------------------------------------
   ! Draw a circle.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x,y,r,w
   ! internals
   real(kr)::u1,v1,rr,test

   if (land.eq.1) then
      u1=uwidth-72*y+ushift
      v1=72*x+vshift
      rr=72*r
   else
      u1=72*x+ushift
      rr=72*r
      v1=72*y+vshift
   endif
   write(nps,'(''stroke'')')
   write(nps,'(''newpath'')')
   test=2000
   if (u1.gt.test) u1=2000
   test=-1000
   if (u1.lt.test) u1=-1000
   test=2000
   if (v1.gt.test) v1=2000
   test=-1000
   if (v1.lt.test) v1=-1000
   write(nps,'(1x,3f9.2,'' 0 360 arc'')') u1,v1,rr
   return
   end subroutine circle

   subroutine dchr(x,y,c,ifont,ialf,ht,xx,yx,xy,yy)
   !--------------------------------------------------------------------
   ! Low-level routine to draw a character in perspective
   ! using Postscript.
   !--------------------------------------------------------------------
   ! externals
   integer::ifont,ialf
   real(kr)::x,y,ht,xx,yx,xy,yy
   character(1)::c
   ! internals
   integer::lname
   real(kr)::u,v,ux,vx,uy,vy,test
   character(25)::name

   if (land.eq.1) then
      u=uwidth-72*y+ushift
      v=72*x+vshift
      ux=-72*yx
      vx=72*xx
      uy=-72*yy
      vy=72*xy
   else
      u=72*x+ushift
      v=72*y+vshift
      ux=72*xx
      vx=72*yx
      uy=72*xy
      vy=72*yy
   endif
   test=2000
   if (u.gt.test) u=2000
   test=-1000
   if (u.lt.test) u=-1000
   test=2000
   if (v.gt.test) v=2000
   test=-1000
   if (v.lt.test) v=-1000
   write(nps,'(2f9.2,'' moveto'')') u,v
   name=font(ifont)
   call stripv(name,lname)
   write(nps,'(''/'',a,'' findfont ['',4f7.2,&
     &'' 0. 0.] makefont setfont'')') name(1:lname),&
     ht*ux,ht*vx,ht*uy,ht*vy
   if (ialf.eq.0) then
      if (c.eq.'('.or.c.eq.')') then
         write(nps,'(''('',a1,a1,'') show'')') '\\',c
      else
         write(nps,'(''('',a1,'') show'')') c
      endif
   else
      write(nps,'(a1,o3.3,'') show'')') char(92),ichar(c)+128
   endif
   return
   end subroutine dchr

   real(kr) function charw(char,itable)
   !--------------------------------------------------------------------
   ! Return character widths for built-in fonts.
   !--------------------------------------------------------------------
   ! externals
   integer::itable
   character(1)::char
   ! internals
   integer::i
   i=1+ichar(char)
   ! i=1+int(char)
   charw=cw(i,itable)
   return
   end function charw

   subroutine stripv(str,length)
   !--------------------------------------------------------------------
   ! Strip leading and trailing blanks.  Count the remainder.
   !--------------------------------------------------------------------
   ! externals
   integer::length
   character::str*(*)
   ! internals
   integer::n,j,k,i,ic

   n=len(str)
   j=0
   k=0
   do i=1,n
      ic=ichar(str(i:i))
      ! ic=int(str(i:i))
      if (ic.gt.32.and.ic.lt.127) then
         if (j.eq.0) j=i
         k=i
      endif
   enddo
   length=0
   if (j.eq.0) return
   length=k-j+1
   if (j.eq.1) return
   k=j
   do i=1,length
      str(i:i)=str(k:k)
      k=k+1
   enddo
   return
   end subroutine stripv

end module graph

module unresm
   ! module to provide unresr for NJOY2016
   use locale
   implicit none
   private
   public unresr

   !global variables for unresr
   integer::nendf,nin,nout,nscr
   integer,parameter::nmtx=5
   integer::nunr,matd,nsigz,mtx(nmtx),npnts(nmtx)
   integer::intunr,lssf,nro,naps
   integer::isot(20),modet(20),ibaset(20),nsect
   real(kr)::abnt(20),elt(20),eht(20)
   real(kr)::tr(62,62),ti(62,62)
   real(kr),dimension(:),allocatable::tempu

contains

   subroutine unresr
   !--------------------------------------------------------------------
   !
   ! compute unresolved resonance cross-sections
   !
   ! The method of ETOX is used to compute self-shielded
   ! unresolved resonance cross-sections on the energy grid of
   ! the unresolved parameters.  Subsequent interpolation is
   ! to be on the cross-sections and not on the parameters.
   ! Additional energy grid points are added at quarter lethargy
   ! intervals if only three or fewer grid points are found.
   ! The accurate Hwang quadrature set is used for the integrals.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1
   !   nendf   unit for endf tape
   !   nin     unit for input pendf tape
   !   nout    unit for output pendf tape
   ! card 2
   !   matd    material to be processed
   !   ntemp   no. of temperatures (default=1)
   !   nsigz   no. of sigma zeroes (default=1)
   !   iprint  print option (0=min, 1=max) (default=0)
   ! card 3
   !   temp    temperatures in Kelvin (including zero)
   ! card 4
   !   sigz    sigma zero values (including infinity)
   !       cards 2, 3, 4 must be input for each material desired
   !       matd=0/ terminates execution of unresr.
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf   ! provides endf routines and variables
   use util   ! provides timer,error,openz,repoz,closz
   ! locals
   integer::i,it,nb,nw,iprint,ntemp,lrp,l,ie
   integer::ix,is,j,new,nx,nc,nd,newmat,ncds,mfd,mtd
   integer::k,nwd,lstart,nwds
   real(kr)::time,temz,za,awr,ez
   real(kr)::bkgz(4)
   character(60)::strng1,strng2
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::c,d
   real(kr),dimension(:),allocatable::eunr
   real(kr),dimension(:,:),allocatable::sb
   real(kr),dimension(:),allocatable::arry
   real(kr),dimension(:),allocatable::b
   real(kr),dimension(:),allocatable::temp
   real(kr),dimension(:),allocatable::sigz
   real(kr),dimension(:,:),allocatable::sigu
   integer,parameter::maxscr=1000
   integer,parameter::maxeunr=150
   integer,parameter::maxarry=10000

   !--initialize
   nscr=10
   nsh=0
   mtx(1)=1
   mtx(2)=2
   mtx(3)=18
   mtx(4)=19
   mtx(5)=102
   call timer(time)
   read(nsysi,*) nendf,nin,nout
   if (nin.lt.0.and.nout.gt.0) call error('unresr',&
      'mode conversion between nin and nout not allowed.',' ')
   if (nin.gt.0.and.nout.lt.0) call error('unresr',&
      'mode conversion between nin and nout not allowed.',' ')
   if (nin.lt.0) nscr=-nscr
   call openz(nendf,0)
   call openz(nin,0)
   call openz(nout,1)
   call openz(nscr,1)
   write(nsyso,'(/'' unresr...'',&
     &''calculation of unresolved resonance cross sections'',&
     &9x,f8.1,''s'')') time
   write(nsyse,'(/'' unresr...'',59x,f8.1,''s'')')  time
   allocate(scr(maxscr))
   write(nsyso,'(/&
     &'' unit for input endf tape ............. '',i10/&
     &'' unit for input pendf tape ............ '',i10/&
     &'' unit for output pendf tape ........... '',i10)')&
     nendf,nin,nout
   call uwtab
   call repoz(nin)
   call repoz(nendf)
   call repoz(nout)
   call tpidio(nin,nout,0,scr,nb,nw)
   call tpidio(nendf,0,0,scr,nb,nw)

   !--loop over requested materials
  110 continue
   iprint=0
   ntemp=1
   nsigz=1
   read(nsysi,*) matd,ntemp,nsigz,iprint
   if (matd.eq.0) go to 400
   if (allocated(temp)) then
      deallocate(temp)
      deallocate(sigz)
      deallocate(sigu)
   endif
   allocate(temp(ntemp))
   allocate(sigz(nsigz))
   allocate(sigu(5,nsigz))
   read(nsysi,*) (temp(i),i=1,ntemp)
   read(nsysi,*) (sigz(i),i=1,nsigz)
   write(nsyso,'(/&
     &'' temperatures ......................... '',1p,e10.3/&
     &(40x,e10.3))') (temp(i),i=1,ntemp)
   write(nsyso,'(&
     &'' sigma zero values .................... '',1p,e10.3/&
     &(40x,e10.3))') (sigz(i),i=1,nsigz)
   write(nsyso,'(&
     &'' print option (0 min., 1 max.) ........ '',i10)') iprint

   !--loop over requested temperatures
   do 320 it=1,ntemp
   temz=temp(it)
   call timer(time)
   write(nsyso,'(/&
     &'' mat = '',i4,3x,'' temp = '',1p,e10.3,37x,0p,f8.1,''s'')')&
     matd,temz,time

   !--read resonance parameters from file 2 on endf tape.
   !--read background cross sections from file 3
   do i=1,nmtx
      npnts(i)=0
   enddo
   if (it.gt.1) go to 130
   nunr=0
   call findf(matd,1,451,nendf)
   call contio(nendf,0,0,scr,nb,nw)
   lrp=l1h
   if (lrp.eq.0) go to 340
   call contio(nendf,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   call findf(matd,2,151,nendf)
   call contio(nendf,0,0,scr,nb,nw)
   za=c1h
   awr=c2h
   allocate(eunr(maxeunr))
   allocate(arry(maxarry))
   call rdunf2(eunr,scr,arry,maxarry)
   if (nunr.eq.0) go to 350
   if (lssf.gt.0) go to 130
   call findf(matd,3,1,nendf)
   allocate(sb(nunr,4))
   call rdunf3(eunr,sb,nunr,scr)
  130 continue
   nb=12+nsigz+nunr*(1+5*nsigz)
   allocate(b(nb))
   l=1
   b(l)=za
   b(l+1)=awr
   b(l+2)=lssf
   b(l+3)=0
   b(l+4)=0
   b(l+5)=intunr
   b(l+6)=temz
   b(l+7)=0
   b(l+8)=5
   b(l+9)=nsigz
   b(l+10)=nsigz+nunr*(1+5*nsigz)
   b(l+11)=nunr
   l=l+11
   ! store sigz into next nsigz location of a.
   do i=1,nsigz
      l=l+1
      b(l)=sigz(i)
   enddo

   !--compute unresolved resonance cross-sections
   !--for all grid points and values of sigma zero.
   do ie=1,nunr
      ez=eunr(ie)
      l=l+1
      b(l)=ez
      if (lssf.le.0) then
         bkgz(1)=sb(ie,1)
         bkgz(2)=sb(ie,2)
         bkgz(3)=sb(ie,3)
         bkgz(4)=sb(ie,4)
      else
         bkgz(1)=0
         bkgz(2)=0
         bkgz(3)=0
         bkgz(4)=0
      endif
      if (iprint.eq.1) write(nsyso,&
        '('' energy ='',1p,e12.4)') ez
      call unresl(ez,temz,sigz,nsigz,bkgz,sigu,arry)
      do ix=1,5
         do is=1,nsigz
            l=l+1
            b(l)=sigfig(sigu(ix,is),7,0)
         enddo
         if (l.gt.nb)&
           call error('unresr','storage exceeded.',' ')
         if (iprint.eq.1) write(nsyso,'(1x,1p,8e11.3)')&
           (sigu(ix,j),j=1,nsigz)
      enddo
   enddo
   if (nin.eq.0) go to 310
   if (nout.eq.0) go to 310

   !--check for previous mt152
   new=1
   call findf(matd,2,151,nin)
   call tosend(nin,0,0,scr)
   call contio(nin,0,0,scr,nb,nw)
   if (mth.eq.152) new=0
   call findf(matd,1,451,nin)

   !--write new pendf tape
   call contio(nin,0,0,scr,nb,nw)
   if (iverf.lt.5) then
      nx=n2h
      if (nx.gt.0.and.new.gt.0) scr(6)=scr(6)+1
   endif
   call contio(0,nout,0,scr,nb,nw)
   if (iverf.ge.5) call contio(nin,nout,0,scr,nb,nw)
   if (iverf.eq.6) call contio(nin,nout,0,scr,nb,nw)
   call hdatio(nin,0,0,scr,nb,nw)
   scr(1)=temz
   if (iverf.ge.5) then
      nx=n2h
      if (nx.gt.0.and.new.gt.0) scr(6)=scr(6)+1
   endif
   call hdatio(0,nout,0,scr,nb,nw)
   do while (nb.ne.0)
      call moreio(nin,nout,0,scr,nb,nw)
   enddo
   nw=nx
   if (nw.ne.0) then
      nc=6*nx+6
      allocate(c(nc))
      nd=6*nx
      allocate(d(nd))
      call dictio(nin,0,0,d,nb,nw)
      j=0
      newmat=0
      ncds=2+(nint(b(11))-1)/6
      ix=1
      do i=1,nw,6
         mfd=nint(d(i+2))
         mtd=nint(d(i+3))
         if (mfd.gt.2.or.mtd.eq.152) then
            if (newmat.le.0) then
               newmat=1
               c(j+1)=0
               c(j+2)=0
               c(j+3)=2
               c(j+4)=152
               c(j+5)=ncds
               c(j+6)=0
               if (new.gt.0) j=j+6
            endif
         endif
         do k=1,6
            c(k+j)=d(k+i-1)
         enddo
         j=j+6
      enddo
      nwd=j/6
      call dictio(0,nout,0,c,nb,nwd)
      deallocate(d)
      deallocate(c)
   endif
   ! copy through file 2, mt 151
   call tofend(nin,nout,0,scr)
   call tosend(nin,nout,0,scr)
   if (new.eq.0) call tosend(nin,0,0,scr)
   ! write new mt on output tape
   math=matd
   mfh=2
   mth=152
   call contio(0,nout,0,b,nb,nw)
   lstart=7
   nwds=l-6
   nw=nwds
   if (nw.gt.npage+6) nw=npage+6
   call listio(0,nout,0,b(lstart),nb,nw)
  210 continue
   lstart=lstart+nw
   nwds=nwds-nw
   nw=nwds
   if (nw.gt.npage) nw=npage
   if (nb.eq.0) go to 220
   call moreio(0,nout,0,b(lstart),nb,nw)
   go to 210
  220 continue
   call asend(nout,0)
   ! copy file end card and rest of material
   call tomend(nin,nout,0,scr)

   !--write report of calculation
  310 continue
   call timer(time)
   write(nsyso,'('' generated cross sections at '',i3,&
     &'' points'',30x,f8.1,''s'')') nunr,time
   deallocate(b)
  320 continue
   if (lssf.le.0) deallocate(sb)
   deallocate(arry)
   deallocate(eunr)
   go to 110

   !--mat has no resonance parameters. copy as is to nout.
  340 continue
   write(strng1,&
     '(''mat'',i5,'' has no resonance parameters'')') matd
   write(strng2,'(''copy as is to nout'')')
   call mess('unresr',strng1,strng2)
   go to 355

   !--mat has no unresolved.  copy as is to nout
  350 continue
   write(strng1,&
     '(''mat'',i5,'' has no unresolved parameters'')') matd
   write(strng2,'(''copy as is to nout'')')
   call mess('unresr',strng1,strng2)
  355 continue
   call findf(matd,1,451,nin)
    it=0
  360 continue
   call contio(nin,0,0,scr,nb,nw)
   if (math.ne.matd) go to 110
   call contio(0,nout,0,scr,nb,nw)
   call tomend(nin,nout,0,scr)
   it=it+1
   if (it.lt.ntemp) go to 360
   if (allocated(eunr)) deallocate(eunr)
   if (allocated(arry)) deallocate(arry)
   go to 110

   !--finished with unresr.
  400 continue
   call atend(nout,0)
   call repoz(nout)
   call repoz(nin)
   call repoz(nendf)
   call closz(nendf)
   call closz(nin)
   call closz(nout)
   call closz(nscr)
   if (allocated(temp)) then
      deallocate(temp)
      deallocate(sigz)
      deallocate(sigu)
   endif
   if (allocated(tempu)) deallocate(tempu)
   call timer(time)
   write(nsyso,'(/69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine unresr

   subroutine rdunf2(eunr,scr,arry,jx)
   !--------------------------------------------------------------------
   ! Read and/or copy unresolved resonance parameters from file 2.
   !--------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error,mess,sigfig
   ! externals
   integer::jx
   real(kr)::eunr(*)
   real(kr)::scr(*)
   real(kr)::arry(*)

   ! internals
   integer::indep,nis,inow,is,nb,nw,lfw,ner,ier,lru,lrf,nls,l
   integer::njs,j,mode,ll,jnow,n,i,ne,inow1,ir,k,ist,loc
   integer::ii,jj,iovlp,lim
   real(kr)::elr,ehr,abn,el,eh,et,spi,ay,awri,enow,elast,enext
   real(kr)::enut,en
   character(60)::strng
   integer,parameter::ngridu=78
   real(kr),dimension(78)::egridu=(/&
     1.0e1_kr,1.25e1_kr,1.5e1_kr,1.7e1_kr,2.0e1_kr,2.5e1_kr,3.0e1_kr,&
     3.5e1_kr,4.0e1_kr,5.0e1_kr,6.0e1_kr,7.2e1_kr,8.5e1_kr,1.0e2_kr,&
     1.25e2_kr,1.5e2_kr,1.7e2_kr,2.0e2_kr,2.5e2_kr,3.0e2_kr,3.5e2_kr,&
     4.0e2_kr,5.0e2_kr,6.0e2_kr,7.2e2_kr,8.5e2_kr,1.0e3_kr,1.25e3_kr,&
     1.5e3_kr,1.7e3_kr,2.0e3_kr,2.5e3_kr,3.0e3_kr,3.5e3_kr,4.0e3_kr,&
     5.0e3_kr,6.0e3_kr,7.2e3_kr,8.5e3_kr,1.0e4_kr,1.25e4_kr,1.5e4_kr,&
     1.7e4_kr,2.0e4_kr,2.5e4_kr,3.0e4_kr,3.5e4_kr,4.0e4_kr,5.0e4_kr,&
     6.0e4_kr,7.2e4_kr,8.5e4_kr,1.0e5_kr,1.25e5_kr,1.5e5_kr,1.7e5_kr,&
     2.0e5_kr,2.5e5_kr,3.0e5_kr,3.5e5_kr,4.0e5_kr,5.0e5_kr,6.0e5_kr,&
     7.2e5_kr,8.5e5_kr,1.e6_kr,1.25e6_kr,1.5e6_kr,1.7e6_kr,2.0e6_kr,&
     2.5e6_kr,3.0e6_kr,3.5e6_kr,4.0e6_kr,5.0e6_kr,6.0e6_kr,7.2e6_kr,&
     8.5e6_kr/)
   real(kr),parameter::wide=1.26e0_kr
   integer,parameter::n150=150
   real(kr),parameter::onemev=1.e6_kr
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::step=1.01e0_kr
   real(kr),parameter::zero=0

   !--initialize
   indep=0
   elr=0
   ehr=onemev
   nunr=1
   eunr(1)=onemev

   !--head card read in calling program
   nis=n1h
   nsect=0
   inow=1

   !--loop over isotopes
   do 300 is=1,nis
   call contio(nendf,0,0,scr,nb,nw)
   abn=c2h
   lfw=l2h
   ner=n1h
   ier=0

   !--loop over all energy ranges
  110 continue
   call contio(nendf,0,0,scr,nb,nw)
   ier=ier+1
   el=sigfig(c1h,7,0)
   eh=sigfig(c2h,7,0)
   lru=l1h
   lrf=l2h
   nro=n1h
   naps=n2h
   if (lru.eq.2) go to 140
   if (eh.gt.elr) elr=eh

   !--read through this sub-section
   call contio(nendf,0,0,scr,nb,nw)
   nls=n1h
   if (lrf.eq.4.or.lrf.eq.7) then
      call listio(nendf,0,0,scr,nb,nw)
      do while (nb.ne.0)
         call moreio(nendf,0,0,scr,nb,nw)
      enddo
   endif
   do l=1,nls
      if (lrf.ne.4) then
         call listio(nendf,0,0,scr,nb,nw)
         do while (nb.ne.0)
            call moreio(nendf,0,0,scr,nb,nw)
         enddo
         if (lrf.eq.7) then
            call listio(nendf,0,0,scr,nb,nw)
            do while (nb.ne.0)
               call moreio(nendf,0,0,scr,nb,nw)
            enddo
         endif
      else
         call contio(nendf,0,0,scr,nb,nw)
            njs=n1h
         do j=1,njs
            call listio(nendf,0,0,scr,nb,nw)
            do while (nb.ne.0)
            call moreio(nendf,0,0,scr,nb,nw)
            enddo
         enddo
      endif
   enddo
   if (ier.lt.ner) go to 110
   go to 300

   !--read and copy unresolved resonance parameters
  140 continue
   nsect=nsect+1
   isot(nsect)=is
   abnt(nsect)=abn
   elt(nsect)=el
   eht(nsect)=eh
   mode=lrf+4*(lru-1)
   modet(nsect)=mode
   ibaset(nsect)=inow
   if (eh.lt.ehr) ehr=eh
   ! add el and eh to list of nodes
   ! shade nodes around discontinuities
   et=sigfig(el,7,-1)
   call ilist(et,eunr,nunr)
   et=sigfig(el,7,+1)
   call ilist(et,eunr,nunr)
   et=sigfig(eh,7,-1)
   call ilist(et,eunr,nunr)
   et=sigfig(eh,7,+1)
   call ilist(et,eunr,nunr)

   ! if present, read and store the energy-dependent
   ! scattering radius tab1 data.
   if (nro.eq.1) then
      call tab1io(nendf,0,0,arry(inow),nb,nw)
      jj=inow+nw
      do while (nb.ne.0)
         call moreio(nendf,0,0,arry(jj),nb,nw)
         jj=jj+nw
         if (jj.gt.jx) then
            call error('rdunf2','storage in a exceeded',' ')
         endif
      enddo
      inow=jj
   endif

   !--branch to specified representation
   if (lrf.eq.2) go to 250
   intunr=2
   if (lfw.eq.1) go to 190

   !--all parameters independent of energy
   call contio(nendf,0,0,scr,nb,nw)
   spi=c1h
   ay=c2h
   lssf=l1h
   nls=n1h
   ! loop over l states
   do l=1,nls
      call listio(nendf,0,0,scr,nb,nw)
      awri=c1h
      ll=l1h
      njs=n2h
      if (l.eq.1) then
         arry(inow)=awri
         arry(inow+1)=ay
         arry(inow+2)=spi
         arry(inow+3)=lfw
         arry(inow+4)=nls
         arry(inow+5)=0
         inow=inow+6
      endif
      arry(inow)=njs
      arry(inow+1)=ll
      inow=inow+2
      jnow=6
      do n=1,njs
         do i=1,5
            arry(inow)=scr(jnow+i)
            inow=inow+1
         enddo
         jnow=jnow+6
      enddo
   enddo
   if (inow.gt.jx) call error('rdunf2','storage exceeded.',' ')
   indep=1
   go to 290

   !--fission widths energy dependent
  190 continue
   call listio(nendf,0,0,scr,nb,nw)
   spi=c1h
   ay=c2h
   lssf=l1h
   ne=n1h
   nls=n2h
   arry(inow+1)=ay
   arry(inow+2)=spi
   arry(inow+3)=lfw
   arry(inow+4)=nls
   arry(inow+5)=ne
   ! store fission width energy points
   inow1=inow+5
   do i=1,ne
      enow=sigfig(scr(i+6),7,0)
      arry(inow1+i)=enow
      ! add to list of energy nodes
      if (i.gt.1.and.i.le.ne) then
         call ilist(enow,eunr,nunr)
      endif
   enddo
   if (enow.lt.eh) then
      write(strng,&
        '(''between'',1p,e12.4,'' and'',1p,e12.4,'' eV'')') enow, eh
      call error('rdunf2','energy dependent data undefined',strng) 
   endif
   ! loop over l states
   do l=1,nls
      call contio(nendf,0,0,scr,nb,nw)
      if (l.eq.1) then
         arry(inow)=c1h
         inow=inow+6+ne
      endif
      njs=n1h
      arry(inow)=njs
      arry(inow+1)=l1h
      inow=inow+2
      ! loop over j states
      do j=1,njs
         call listio(nendf,0,0,scr,nb,nw)
         ne=n1h-6
         arry(inow)=l2h
         ! store parameters
         do ir=1,5
            arry(inow+ir)=scr(6+ir)
         enddo
         inow1=inow+5
         ! store fission widths
         do k=1,ne
            arry(k+inow1)=scr(k+12)
         enddo
         inow=inow+6+ne
      enddo
   enddo
   if (inow.gt.jx) call error('rdunf2','storage exceeded.',' ')
   go to 290

   !--all parameters energy dependent
  250 continue
   ist=inow
   ! first cont record
   call contio(nendf,0,0,scr,nb,nw)
   lssf=l1h
   nls=n1h
   arry(inow+1)=c2h
   arry(inow+2)=c1h
   arry(inow+3)=n1h
   inow=inow+4
   ! loop over l states
   do l=1,nls
      call contio(nendf,0,0,scr,nb,nw)
      if (l.eq.1) arry(ist)=c1h
      njs=n1h
      arry(inow)=njs
      arry(inow+1)=l1h
      inow=inow+2
      ! loop over j states
      do j=1,njs
         call listio(nendf,0,0,scr,nb,nw)
         loc=1+nw
         do while (nb.ne.0)
            call moreio(nendf,0,0,scr(loc),nb,nw)
            loc=loc+nw
         enddo
         ne=n2h
         arry(inow)=c1h
         arry(inow+1)=l1h
         intunr=l1h
         arry(inow+2)=ne
         ! store numbers of degrees of freedom
         do k=3,6
            arry(k+inow)=scr(k+6)
         enddo
         inow=inow+7
         jnow=12
         ! store parameters
         do n=1,ne
            do k=1,6
               if (scr(jnow+k).le.zero) scr(jnow+k)=small
               arry(inow+k-1)=scr(jnow+k)
            enddo
            inow=inow+6
            ! add to list of energy nodes
            enow=sigfig(scr(jnow+1),7,0)
            if (n.ne.1.and.n.ne.ne.and.l.eq.1.and.j.eq.1) then
               call ilist(enow,eunr,nunr)
            endif
            jnow=jnow+6
         enddo
         if (enow.lt.eh) then
            write(strng,&
              '(''between'',1p,e12.4,'' and'',1p,e12.4,'' eV'')') enow, eh
            call error('rdunf2','energy dependent data undefined',strng) 
         endif
      enddo
   enddo
   if (inow.gt.jx) call error('rdunf2','storage exceeded.',' ')

   !--continue loop over isotopes and energy ranges
  290 continue
   if (ier.lt.ner) go to 110
  300 continue
   nunr=nunr-1
   if (nunr.eq.0) return

   !--add extra nodes if needed
   !--remove first and last energy nodes
   !--flag resolved-unresolved overlap energies
   nunr=nunr+1
   i=1
   elast=eunr(2)
  350 continue
   i=i+1
   enext=eunr(i+1)
   if (enext.ge.onemev) go to 380
   if (enext.lt.wide*elast.and.indep.eq.0) go to 370
   et=elast
  360 continue
   do 362 ii=1,ngridu
   enut=egridu(ii)
   if (enut.gt.step*et) go to 363
  362 continue
   enut=enext
  363 continue
   et=enut
   if (et.ge.enext) go to 370
   call ilist(et,eunr,nunr)
   i=i+1
   go to 360
  370 continue
   elast=eunr(i+1)
   go to 350
  380 continue
   iovlp=0
   lim=nunr-1
   nunr=0
   en=0
   do i=2,lim
      et=eunr(i)
      if (et.ge.en) then
         if (et.lt.elr) et=-et
         if (et.lt.zero) iovlp=1
         nunr=nunr+1
         eunr(nunr)=et
         en=sigfig(abs(et),7,2)
      endif
   enddo
   nunr=nunr-1
   if (iovlp.eq.1) call mess('rdunf2',&
     'resolved-unresolved overlap energies',&
     'marked with minus signs.')
   if (eunr(nunr).gt.ehr) then
      write(strng,&
        '(''unresolved-smooth overlap above e='',1p,e12.4)') ehr
      call mess('rdunf2',strng,' ')
   endif
   return
   end subroutine rdunf2

   subroutine ilist(e,elist,nlist)
   !--------------------------------------------------------------------
   ! Insert a new energy into a list of enegies in ascending order.
   ! Omit duplicate values.  Initial list must be primed with one
   ! energy larger than any others to be added.
   !--------------------------------------------------------------------
   ! externals
   integer::nlist
   real(kr)::e,elist(*)
   ! internals
   integer::jl,i,j

   jl=0
   do 110 i=1,nlist
   if (e.gt.elist(i)) go to 110
   if (e.eq.elist(i)) go to 130
   jl=nlist-i+1
   do j=1,jl
      elist(nlist-j+2)=elist(nlist-j+1)
   enddo
   elist(i)=e
   go to 130
  110 continue
   jl=1
   elist(nlist+1)=e
  130 continue
   if (jl.gt.0) nlist=nlist+1
   return
   end subroutine ilist

   subroutine rdunf3(eunr,sb,nunr,scr)
   !--------------------------------------------------------------------
   ! Read unresolved region background cross sections from file 3.
   ! Compute the background cross sections on the unresolved
   ! energy grid and store for use in unresl.
   !--------------------------------------------------------------------
   use endf ! provides contio,gety1

   ! external
   integer::nunr
   real(kr)::eunr(nunr),sb(nunr,4),scr(*)
   ! internals
   integer::nb,nw,ix,kx,ie,idis,np
   real(kr)::sig,e,enext,bkg
   real(kr),parameter::up=1.00001e0_kr
   real(kr),parameter::dn=0.99999e0_kr

   ix=1
  100 continue
   call contio(nendf,0,0,scr,nb,nw)
  105 continue
   kx=ix
   if (mtx(ix).gt.18) kx=ix-1
   if (mth.lt.mtx(ix)) go to 120
   if (mth.eq.mtx(ix)) go to 130
   do ie=1,nunr
      sb(ie,kx)=0
   enddo
   go to 160
  120 continue
   call tosend(nendf,0,0,scr)
   go to 100
  130 continue
   if (mtx(ix).eq.19) go to 150
   e=0
   call gety1(e,enext,idis,bkg,nendf,scr)
   np=nint(scr(6))
   npnts(ix)=np
   do ie=1,nunr
      e=abs(eunr(ie))
      if (ie.eq.1) e=up*e
      if (ie.eq.nunr) e=dn*e
      call gety1(e,enext,idis,sig,nendf,scr)
      sb(ie,kx)=sig
   enddo
   call tosend(nendf,0,0,scr)
   go to 160
  150 continue
   npnts(ix)=npnts(ix-1)
  160 continue
   ix=ix+1
   if (ix.gt.nmtx) go to 170
   if (mtx(ix).eq.mth) go to 105
   if (mtx(ix).gt.mth) go to 100
   go to 160
  170 continue
   return
   end subroutine rdunf3

   subroutine unresl(ee,tt,sig0,nsig0,sigbkg,sigu,arry)
   !--------------------------------------------------------------------
   ! Computes effective cross-sections in the
   ! unresolved region using the etox method.
   !--------------------------------------------------------------------
   use physics ! provides pi,bk,amassn,amu,hbar,ev
   use util    ! provides error
   use endf    ! provides terpa
   ! externals
   integer::nsig0
   real(kr)::ee,tt,sig0(*),sigbkg(4),sigu(5,*),arry(*)
   ! internals
   integer,parameter::mxks=100
   integer::ntempu,ispot,is,ks,i,isect,mode,inow,nls,lfw
   integer::ne,iest,itp,l,njs,ll,j,ifst,intl,int,is0,kx
   integer::mu,nu,lu,nqf,nqn,nqx,kf,kn,kl,iro,ip,ir,idx
   integer::kkx,ns,knm1,ksp
   real(kr)::k,cwaven,c2,ac,e,spot,sint,abn,awri,ay,spi
   real(kr)::rat,aw,aa,e2,ab,rho,rhoc,vl,ps,aaa
   real(kr)::amux,gxx,amuf,dx,aj,amun,gnox,ggx,gfx,gj,gnx,d
   real(kr)::sigbt,s0u,sti,beta,xj,xk,ttj,yj,yk,ttt
   real(kr)::fact,term,term1,sigtr,enx
   real(kr)::del(3),yy(3),gg(5)
   real(kr),dimension(:,:,:),allocatable,save::sigf
   real(kr),dimension(:,:,:),allocatable,save::tj,tk,tl,t
   real(kr),dimension(:),allocatable,save::abns,sigm
   integer,parameter::nqp=10
   real(kr),dimension(10,4)::qw=reshape((/&
     1.1120413e-1_kr,2.3546798e-1_kr,2.8440987e-1_kr,&
     2.2419127e-1_kr,0.10967668e0_kr,.030493789e0_kr,&
     0.0042930874e0_kr,2.5827047e-4_kr,4.9031965e-6_kr,&
     1.4079206e-8_kr,0.033773418e0_kr,0.079932171e0_kr,&
     0.12835937e0_kr,0.17652616e0_kr,0.21347043e0_kr,&
     0.21154965e0_kr,0.13365186e0_kr,0.022630659e0_kr,&
     1.6313638e-5_kr,2.745383e-31_kr,3.3376214e-4_kr,&
     0.018506108e0_kr,0.12309946e0_kr,0.29918923e0_kr,&
     0.33431475e0_kr,0.17766657e0_kr,0.042695894e0_kr,&
     4.0760575e-3_kr,1.1766115e-4_kr,5.0989546e-7_kr,&
     1.7623788e-3_kr,0.021517749e0_kr,0.080979849e0_kr,&
     0.18797998e0_kr,0.30156335e0_kr,0.29616091e0_kr,&
     0.10775649e0_kr,2.5171914e-3_kr,8.9630388e-10_kr,&
     0.e0_kr/),(/10,4/))
   real(kr),dimension(10,4)::qp=reshape((/&
     3.0013465e-3_kr,7.8592886e-2_kr,4.3282415e-1_kr,&
     1.3345267e0_kr,3.0481846e0_kr,5.8263198e0_kr,&
     9.9452656e0_kr,1.5782128e1_kr,23.996824e0_kr,&
     36.216208e0_kr,1.3219203e-2_kr,7.2349624e-2_kr,&
     0.19089473e0_kr,0.39528842e0_kr,0.74083443e0_kr,&
     1.3498293e0_kr,2.5297983e0_kr,5.2384894e0_kr,&
     13.821772e0_kr,75.647525e0_kr,1.0004488e-3_kr,&
     0.026197629e0_kr,0.14427472e0_kr,0.44484223e0_kr,&
     1.0160615e0_kr,1.9421066e0_kr,3.3150885e0_kr,&
     5.2607092e0_kr,7.9989414e0_kr,12.072069e0_kr,&
     0.013219203e0_kr,0.072349624e0_kr,0.19089473e0_kr,&
     0.39528842e0_kr,0.74083443e0_kr,1.3498293e0_kr,&
     2.5297983e0_kr,5.2384894e0_kr,13.821772e0_kr,&
     75.647525e0_kr/),(/10,4/))
   real(kr),parameter::rc1=.123e0_kr
   real(kr),parameter::rc2=.08e0_kr
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1.e0_kr
   real(kr),parameter::small=1.e-8_kr
   logical::noissue=.true.
   character(60)::strng1,strng2

   cwaven=sqrt(2*amassn*amu*ev)*1.e-12_kr/hbar

   !--initialize
   c2=bk
   ac=1
   e=abs(ee)
   ntempu=1
   if (allocated(tempu)) deallocate(tempu)
   allocate(tempu(ntempu))
   tempu(1)=tt
   if (tempu(1).lt.one) tempu(1)=one

   !--make a pass to compute the potential scattering cross section
   !--then a second pass to compute unresolved cross sections
   ispot=0
   spot=0
   sint=0
   if (allocated(sigf)) then
      deallocate(sigf)
      deallocate(sigm)
      deallocate(abns)
      deallocate(tj)
      deallocate(tk)
      deallocate(tl)
      deallocate(t)
   endif
   allocate(sigf(ntempu,nsig0,5))
   allocate(sigm(nsig0))
   allocate(t(4,nsig0,ntempu))
   go to 200
  110 continue
   !--use current value of ks to allocate remaining arrays
   allocate(abns(ks))
   allocate(tj(ks,nsig0,ntempu))
   allocate(tk(ks,nsig0,ntempu))
   allocate(tl(3*ks+1,nsig0,ntempu))
   sigbt=sigbkg(1)+spot+sint
   do is=1,nsig0
      sigm(is)=sigbt+sig0(is)
      if (sigm(is).lt.zero) then
         call mess('unresl', 'Negative background xs in urr may cause issues',&
                         &'Check the evaluation')
      endif
   enddo
   ispot=1

   !--find sections of resonance parameters which contribute
  200 continue
   ks=0
   do 210 i=1,nsect
   isect=i
   abn=abnt(i)
   if (e.lt.elt(i).or.e.gt.eht(i)) go to 210
   mode=modet(i)
   if (mode.lt.5.or.mode.gt.6) go to 210
   inow=ibaset(isect)

   !--retrieve nuclide information
   if (nro.eq.1) then
      iro=inow
      ip=2
      ir=1
      call terpa(ay,e,enx,idx,arry(iro),ip,ir)
      inow=inow+6+2*nint(arry(iro+4))+2*nint(arry(iro+5))
   else
      ay=arry(inow+1)
   endif
   awri=arry(inow)
   aaa=0
   if (naps.eq.2.and.nro.eq.1) aaa=arry(inow+1)
   spi=arry(inow+2)
   if (mode.eq.6) then
      nls=nint(arry(inow+3))
      inow=inow+4
   else
      lfw=nint(arry(inow+3))
      nls=nint(arry(inow+4))
      ne=nint(arry(inow+5))
      inow=inow+6
      if (lfw.ne.0) then
         ! save starting location for fission width energies
         iest=inow
         inow=inow+ne
      endif
   endif

   !--calculate nuclide dependent parameters
   rat=awri/(awri+1)
   aw=awri*amassn
   if (naps.eq.0) then
      aa=rc1*aw**third+rc2
   else if (naps.eq.1) then
      aa=ay
   else if (naps.eq.2.and.nro.eq.1) then
      aa=aaa
   else
      call error('unresl','illegal naps',' ')
   endif
   e2=sqrt(e)
   k=cwaven*rat*e2
   ab=4*pi/k**2
   rho=k*aa
   rhoc=k*ay
   do itp=1,ntempu
      del(itp)=2*e2*sqrt(tempu(itp)*c2/awri)
   enddo

   !--loop over all sequences(l,j) in this section
   do 240 l=1,nls
   njs=nint(arry(inow))
   ll=nint(arry(inow+1))

   !--calculate penetrability and phase shifts
   call uunfac(ll,rho,rhoc,one,vl,ps)
   inow=inow+2
   do 250 j=1,njs

   !--retrieve parameters for this sequence
   ks=ks+1
   if (ks.gt.mxks) call error('unresl',&
                   'storage exceeded, increase mxks',' ')
   if (ispot.ne.0) abns(ks)=abn
   if (mode.ne.6) then
      amux=0
      gxx=0
      if (lfw.eq.0) then
         amuf=0
         dx=arry(inow)
         aj=arry(inow+1)
         amun=arry(inow+2)
         gnox=arry(inow+3)
         ggx=arry(inow+4)
         gfx=0
         inow=inow+5
      else
         amuf=arry(inow)
         dx=arry(inow+1)
         aj=arry(inow+2)
         amun=arry(inow+3)
         gnox=arry(inow+4)
         ggx=arry(inow+5)
         inow=inow+6
         ifst=inow
         intl=2
         call intrf(e,gfx,iest,ifst,ne,intl,arry)
         inow=inow+ne
      endif
   else
      aj=arry(inow)
      int=nint(arry(inow+1))
      int=2
      ne=nint(arry(inow+2))
      amux=arry(inow+3)
      amun=arry(inow+4)
      amuf=arry(inow+6)
      inow=inow+7
      call intr(e,dx,gxx,gnox,ggx,gfx,inow,ne,int,arry)
      inow=inow+6*ne
   endif
   gj=(2*aj+1)/(4*spi+2)
   gnx=gnox*vl*e2*amun

   !--compute potential scattering and interference correction
   if (ispot.ne.1) then
      if (j.eq.1) spot=spot+abn*ab*(2*ll+1)*sin(ps)**2
      sint=sint-abn*ab*pi*gj*gnx*sin(ps)**2/dx

   !--compute etox statistical averages for this sequence
   else
      do is0=1,nsig0
         do itp=1,ntempu
            tk(ks,is0,itp)=0
            do kx=1,4
               t(kx,is0,itp)=0
            enddo
         enddo
      enddo
      d=dx
      mu=nint(amuf)
      if (gfx.le.small) mu=0
      nu=nint(amun)
      lu=nint(amux)
      if (gxx.lt.small) lu=0
      gg(2)=ggx
      if (mu.eq.0) nqf=1
      if (mu.gt.0) nqf=nqp
      if (nu.eq.0) nqn=1
      if (nu.gt.0) nqn=nqp
      if (lu.eq.0) nqx=1
      if (lu.gt.0) nqx=nqp
      do kf=1,nqf
         if (mu.eq.0) gg(1)=gfx
         if (mu.gt.0) gg(1)=qp(kf,mu)*gfx
         do kn=1,nqn
            if (nu.eq.0) gg(3)=gnx
            if (nu.gt.0) gg(3)=qp(kn,nu)*gnx
            do kl=1,nqx
               if (lu.eq.0) gg(4)=gxx
               if (lu.gt.0) gg(4)=qp(kl,lu)*gxx
               gg(5)=gg(1)+gg(2)+gg(3)+gg(4)
               s0u=ab*gj*gg(3)/gg(5)
               do itp=1,ntempu
                  sti=gg(5)/del(itp)
                  do is0=1,nsig0
                     beta=sigm(is0)/s0u
                     if (beta.lt.zero.and.abs(beta).lt.one.and.noissue) then
                        call mess('unresl','Square root of negative number detected',&
                             &'Probably caused by negative background xs in urr')
                        noissue=.false.
                     endif
                     call ajku(beta,sti,xj,xk)
                     if (mu.gt.0) xj=xj*qw(kf,mu)
                     if (mu.gt.0) xk=xk*qw(kf,mu)
                     if (nu.gt.0) xj=xj*qw(kn,nu)
                     if (nu.gt.0) xk=xk*qw(kn,nu)
                     if (lu.gt.0) xj=xj*qw(kl,lu)
                     if (lu.gt.0) xk=xk*qw(kl,lu)
                     do kx=1,4
                        t(kx,is0,itp)=t(kx,is0,itp)+xj*gg(kx)
                     enddo
                     tk(ks,is0,itp)=tk(ks,is0,itp)+xk*gg(5)
                  enddo
               enddo
            enddo
         enddo
      enddo
      do itp=1,ntempu
         do is0=1,nsig0
            tk(ks,is0,itp)=ac*tk(ks,is0,itp)/d
            ttj=0
            do kx=1,4
               ttj=ttj+t(kx,is0,itp)
               kkx=kx+(ks-1)*3
               tl(kkx,is0,itp)=ac*t(kx,is0,itp)/d
            enddo
            tj(ks,is0,itp)=ac*ttj/d
         enddo
      enddo
   endif
  250 continue
  240 continue
  210 continue
   if (ispot.eq.0) go to 110

   !--compute average cross-sections by summing over sequences
   ns=ks
   do itp=1,ntempu
      do is0=1,nsig0
         yy(1)=0
         yy(2)=0
         yy(3)=0
         yj=0
         yk=0
         do ks=1,ns
            xk=0
            xj=0
            do ksp=1,ns
               if (ksp.ne.ks) then
                  xj=xj+tj(ksp,is0,itp)*abns(ksp)
                  xk=xk+tk(ksp,is0,itp)*abns(ksp)
               endif
            enddo
            do kx=1,3
               knm1=kx+(ks-1)*3
               yy(kx)=yy(kx)+tl(knm1,is0,itp)*(one-xj)*abns(ks)
            enddo
            ttt=tj(ks,is0,itp)*(one-xj)*abns(ks)
            yj=yj+ttt
            yk=yk+(tk(ks,is0,itp)&
              -tj(ks,is0,itp))*(one-xk)*abns(ks)+ttt
         enddo
         sigf(itp,is0,4)=0
         do i=1,3
            sigf(itp,is0,i)=sigm(is0)*yy(i)/(one-yj)
            sigf(itp,is0,4)=sigf(itp,is0,4)+sigf(itp,is0,i)
         enddo
         fact=sig0(is0)
         term=(one-yj)/(one-yk)
         term1=fact*(yk-yj)/(1-yk)
         fact=sigbt
         sigtr=fact*term+term1
         sigf(itp,is0,5)=sigtr
      enddo
   enddo

   !--output cross section in desired order.
   do is=1,nsig0
      sigu(1,is)=sigf(1,is,4)+sigbt
      sigu(2,is)=sigf(1,is,3)+sigbkg(2)+spot+sint
      sigu(3,is)=sigf(1,is,1)+sigbkg(3)
      sigu(4,is)=sigf(1,is,2)+sigbkg(4)
      sigu(5,is)=sigf(1,is,5)
   enddo
   if (allocated(sigf)) then
      deallocate(sigf)
      deallocate(sigm)
      deallocate(abns)
      deallocate(tj)
      deallocate(tk)
      deallocate(tl)
      deallocate(t)
   endif
   return
   end subroutine unresl

   subroutine uunfac(l,rho,rhoc,amun,vl,ps)
   !-------------------------------------------------------------------
   ! Calculates the penetrability factor (vl) and phase shift (ps).
   !-------------------------------------------------------------------
   ! externals
   integer::l
   real(kr)::rho,rhoc,amun,vl,ps
   ! locals
   real(kr)::r2,r4

   r2=rho*rho
   if (l.eq.0) then
      vl=amun
      ps=rhoc
   else if (l.eq.1) then
      vl=amun*r2/(1+r2)
      vl=amun*r2/(1+r2)
      ps=rhoc-atan(rhoc)
   else
      r4=r2*r2
      vl=amun*r4/(9+3*r2+r4)
      ps=rhoc-atan(3*rhoc/(3-rhoc*rhoc))
   endif
   return
   end subroutine uunfac

   subroutine intrf(e,gfx,iest,ifst,ne,int,a)
   !-------------------------------------------------------------------
   ! Interpolates fission widths for unresolved representation 1.
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   integer::iest,ifst,ne,int
   real(kr)::e,gfx
   real(kr)::a(*)
   ! internals
   integer::i,i1,i2

   do i=2,ne
      i1=iest+i-1
      i2=ifst+i-1
      if (e.ge.a(i1-1).and.e.le.a(i1)) then
        call terp1(a(i1-1),a(i2-1),a(i1),a(i2),e,gfx,int)
      endif
   enddo
   return
   end subroutine intrf

   subroutine intr(e,dx,gxx,gnox,ggx,gfx,inow,ne,int,a)
   !-------------------------------------------------------------------
   ! Interpolates energy dependent unresolved resonance parameters.
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   integer::inow,ne,int
   real(kr)::e,dx,gxx,gnox,ggx,gfx
   real(kr)::a(*)
   ! internals
   integer::i1,i,i2
   real(kr),parameter::small=1.e-8_kr

   i1=inow
   do i=2,ne
      i2=i1+6
      if (e.ge.a(i1).and.e.le.a(i2)) then
         call terp1(a(i1),a(i1+1),a(i2),a(i2+1),e,dx,int)
         call terp1(a(i1),a(i1+2),a(i2),a(i2+2),e,gxx,int)
         call terp1(a(i1),a(i1+3),a(i2),a(i2+3),e,gnox,int)
         call terp1(a(i1),a(i1+4),a(i2),a(i2+4),e,ggx,int)
         call terp1(a(i1),a(i1+5),a(i2),a(i2+5),e,gfx,int)
      endif
      if (i.lt.ne) i1=i2
   enddo
   if (gxx.lt.small) gxx=0
   if (gfx.lt.small) gfx=0
   return
   end subroutine intr

   subroutine quikw(ax,y,rew,aimw,ki)
   !-------------------------------------------------------------------
   ! Used to calculate chi and xi line shape functions.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   integer::ki
   real(kr)::ax,y,rew,aimw
   ! internals
   integer::ii,jj,i,j,n
   real(kr)::rpi,aki,x,test,p,q,p2,q2,pq,hp,hq,hq2,hp2
   real(kr)::a1,a2,a3,a4,a5,d1,d2

   real(kr),parameter::break1=36.e0_kr
   real(kr),parameter::break2=144.e0_kr
   real(kr),parameter::break3=10000.e0_kr
   real(kr),parameter::c1=.2752551e0_kr
   real(kr),parameter::c2=2.724745e0_kr
   real(kr),parameter::c3=.5124242e0_kr
   real(kr),parameter::c4=.05176536e0_kr
   real(kr),parameter::c5=1.1283792e0_kr
   real(kr),parameter::zero=0

   rpi=sqrt(pi)
   aki=1
   if (ax.lt.zero) aki=-1
   x=abs(ax)
   test=x*x+y*y
   if (test.lt.break1) then
      ii=int(x*10)
      jj=int(y*10)
      i=ii+2
      j=jj+2
      n=j-1
      p=10*x-ii
      q=10*y-jj
      p2=p*p
      q2=q*q
      pq=p*q
      hp=p/2
      hq=q/2
      hq2=q2/2
      hp2=p2/2
      a1=hq2-hq
      a2=hp2-hp
      a3=1+pq-p2-q2
      a4=hp2-pq+hp
      a5=hq2-pq+hq
      rew=a1*tr(i,n)+a2*tr(i-1,j)+a3*tr(i,j)+a4*tr(i+1,j)&
        +a5*tr(i,j+1)+pq*tr(i+1,j+1)
      if (ki.gt.0) then
         aimw=a1*ti(i,n)+a2*ti(i-1,j)+a3*ti(i,j)+a4*ti(i+1,j)&
           +a5*ti(i,j+1)+pq*ti(i+1,j+1)
         aimw=aimw*aki
      endif
   else if (test.lt.break2) then
      a1=x**2-y**2
      a2=2*x*y
      a3=a2**2
      a4=a1-c1
      a5=a1-c2
      d1=c3/(a4**2+a3)
      d2=c4/(a5**2+a3)
      rew=d1*(a2*x-a4*y)+d2*(a2*x-a5*y)
      if (ki.gt.0) then
         aimw=d1*(a4*x+a2*y)+d2*(a5*x+a2*y)
         aimw=aimw*aki
      endif
   else if (test.lt.break3) then
      a1=(x**2-y**2)*2
      a2=4*x*y
      a4=a1-1
      d1=c5/(a4**2+a2**2)
      rew=d1*(a2*x-a4*y)
      if (ki.gt.0) then
         aimw=d1*(a4*x+a2*y)
         aimw=aimw*aki
      endif
   else
      a1=1/(rpi*test)
      rew=y*a1
      if (ki.gt.0) aimw=x*a1*aki
   endif
   return
   end subroutine quikw

   subroutine ajku(b,st,aj,ak)
   !-------------------------------------------------------------------
   ! Calculates j and k integrals.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   real(kr)::b,st,aj,ak
   ! internals
   integer::n,ki
   real(kr)::pi2,sqpi,term,ep,y,z,yk,zk,b1,a,a2,c,remj,remk
   real(kr)::x1,z1,x2,z2,x3,z3,x4,z4
   real(kr)::y1,ax,rew,aimw
   real(kr),dimension(8)::xg=(/.095012510e0_kr,.28160355e0_kr,&
     .45801678e0_kr,.61787624e0_kr,.75540441e0_kr,.8656312e0_kr,&
     .94457502e0_kr,.98940093e0_kr/)
   real(kr),dimension(8)::wg=(/.18945061e0_kr,.18260342e0_kr,&
     .16915652e0_kr,.14959600e0_kr,.12462897e0_kr,.09515851e0_kr,&
     .06225352e0_kr,.02715246e0_kr/)
   real(kr),parameter::eps=.0002e0_kr
   real(kr),parameter::zero=0

   pi2=pi/2
   sqpi=sqrt(pi)
   if ((-st/2).lt.log(tiny(1._kr))) then
      term=0
   else
      term=exp(-st/2)
   endif
   ep=(1-term)/eps-b
   if (ep.le.zero) then
      aj=pi2/b
      ak=2*aj
   else
      y=0
      z=0
      yk=0
      zk=0
      y1=st/2
      ki=0
      b1=b/(sqpi*y1)
      a=sqrt((1+b)/b)
      a2=a*a
      c=200/(a*st)
      remj=(pi2-atan(c))/(b*a)
      remk=((1+a2)*remj-(1-a2)*c/((c*c+1)*b*a))/(2*a2)
      do n=1,8
         ax=5*xg(n)+5
         call quikw(ax,y1,rew,aimw,ki)
         x1=1/(1+b1/rew)
         z1=x1*x1/rew
         ax=-5*xg(n)+5
         call quikw(ax,y1,rew,aimw,ki)
         x2=1/(1+b1/rew)
         z2=x2*x2/rew
         ax=45*xg(n)+55
         call quikw(ax,y1,rew,aimw,ki)
         x3=1/(1+b1/rew)
         z3=x3*x3/rew
         ax=-45*xg(n)+55
         call quikw(ax,y1,rew,aimw,ki)
         x4=1/(1+b1/rew)
         z4=x4*x4/rew
         y=y+wg(n)*(x3+x4)
         yk=yk+wg(n)*(z3+z4)
         z=z+wg(n)*(x1+x2)
         zk=zk+wg(n)*(z1+z2)
      enddo
      aj=5*(z+9*y)/y1+remj
      ak=aj+5*b1*(zk+9*yk)/y1+remk
   endif
   return
   end subroutine ajku

   subroutine uwtab
   !-------------------------------------------------------------------
   ! Generate table of complex probability integral w.
   !-------------------------------------------------------------------
   ! internals
   integer::nx,ny,nx1,ny1,i,j
   real(kr)::x0,y0,dx,dy,xi,yj,rwt,aimt
   real(kr)::x(62),y(62)
   real(kr),parameter::tenth=0.1e0_kr

   x0=-tenth
   y0=-tenth
   dx=tenth
   dy=tenth
   nx=62
   ny=62
   y(1)=y0
   nx1=nx-1
   ny1=ny-1
   do i=1,ny1
      y(i+1)=i*dy+y0
   enddo
   x(1)=x0
   do i=1,nx1
      x(i+1)=i*dx+x0
   enddo
   do i=1,nx
      do j=1,ny
         xi=x(i)
         yj=y(j)
         call uw(xi,yj,rwt,aimt)
         tr(i,j)=rwt
         ti(i,j)=aimt
      enddo
   enddo
   return
   end subroutine uwtab

   subroutine uw(rez,aim1,rew,aimw)
   !-------------------------------------------------------------------
   ! Compute complex probability integral w.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   real(kr)::rez,aim1,rew,aimw
   ! internals
   integer::kw,k,jsig
   real(kr)::rpi,aimz,abrez,aimf
   real(kr)::r2,ai2,rv,ak,el,h,b,a,tempm,temel,g,c,d
   real(kr)::am,aak,ajtemp,temp4,ajp,pr,pim,amagn
   real(kr)::temp1,temp2,aj,ajsig,sigp,expon,expc,exps
   real(kr)::sig2p,aj4sig,aj4sm1,temp3,tt4,temp7,ref
   real(kr)::tempc,tempd
   real(kr),parameter::c1=1.1283792e0_kr
   real(kr),parameter::c2=1.5e0_kr
   real(kr),parameter::up=1.e15_kr
   real(kr),parameter::dn=1.e-15_kr
   real(kr),parameter::brk1=1.25e0_kr
   real(kr),parameter::brk2=5.0e0_kr
   real(kr),parameter::brk3=1.863636e0_kr
   real(kr),parameter::brk4=4.1e0_kr
   real(kr),parameter::brk5=1.71e0_kr
   real(kr),parameter::brk6=2.89e0_kr
   real(kr),parameter::brk7=1.18e0_kr
   real(kr),parameter::brk8=5.76e0_kr
   real(kr),parameter::brk9=1.5e0_kr
   real(kr),parameter::eps=1.e-7_kr
   real(kr),parameter::zero=0

   rpi=sqrt(pi)
   rew=0
   aimw=0
   aimz=abs(aim1)
   abrez=abs(rez)
   if (abrez+aimz.ne.zero) go to 20
   rew=1
   aimw=0
   return

  20 continue
   r2=rez*rez
   ai2=aimz*aimz
   if (abrez+brk1*aimz-brk2.gt.zero) go to 350
   if (abrez+brk3*aimz-brk4.gt.zero) go to 350
   if (r2+brk5*ai2-brk6.lt.zero) go to 340
   if (r2+brk7*ai2-brk8.ge.zero) go to 340
   if (aimz-brk9.ge.zero) go to 350

  340 continue
   kw=2
   aimz=aim1
   go to 420
  350 continue
   kw=1
   if (aim1.ge.zero) go to 370
   kw=2
   aimz=aim1
   go to 420
   ! wa is obtained from asymtotic series
  370 continue
   rv=2*(r2-ai2)
   ak=4*rez*aimz
   el=ak
   h=0
   b=0
   a=0
   tempm=0
   temel=0
   g=1
   c=-c1*aimz
   d=c1*rez
   am=rv-1
   aak=1
   k=0
  380 continue
   ajtemp=2*aak
   temp4=(1-ajtemp)*ajtemp
   ajp=rv-(4*aak+1)
   go to 480
  390 continue
   aak=aak+1
   k=k+1
   pr=rew
   pim=aimw
   amagn=tempm**2+temel**2
   rew=(tempc*tempm+tempd*temel)/amagn
   aimw=(tempm*tempd-temel*tempc)/amagn
   if (abs(rew-pr).ge.eps) go to 380
   if (abs(aimw-pim).ge.eps) go to 380
   return
   ! wt is obtained from taylor series
  420 continue
   temp1=r2+ai2
   temp2=2*temp1*temp1
   aj=-(r2-ai2)/temp2
   ak=2*rez*aimz/temp2
   c=0
   b=0
   ajsig=0
   d=0
   jsig=0
   g=0
   h=0
   el=0
   a=1
   am=1
   sigp=c2
   expon=exp(temp2*aj)
   expc=expon*cos(temp2*ak)
   exps=-expon*sin(temp2*ak)
   sig2p=2*sigp
  430 continue
   aj4sig=4*ajsig
   aj4sm1=aj4sig-1
   temp3=1/(aj4sm1*(aj4sig+3))
   tt4=sig2p*(2*ajsig-1)
   temp4=tt4/(aj4sm1*(aj4sig+1)*(aj4sig-3)*aj4sm1)
   ajp=aj+temp3
   go to 480
  440 continue
   ajsig=ajsig+1
   jsig=jsig+1
   temp7=rpi*(am*am+el*el)
   ref=(aimz*(c*am+d*el)-rez*(am*d-c*el))/temp7/temp1
   aimf=(aimz*(am*d-c*el)+rez*(c*am+d*el))/temp7/temp1
   pr=rew
   pim=aimw
   rew=expc-ref
   aimw=exps-aimf
   if (abs(rew-pr).ge.eps) go to 470
   if (abs(aimw-pim).ge.eps) go to 470
   return
  470 continue
   sig2p=2*ajsig
   go to 430
  480 continue
   tempc=ajp*c+temp4*a-ak*d
   tempd=ajp*d+temp4*b+ak*c
   temel=ajp*el+temp4*h+ak*am
   tempm=ajp*am+temp4*g-ak*el
   a=c
   b=d
   g=am
   h=el
   c=tempc
   d=tempd
   am=tempm
   el=temel
   if ((abs(tempm)+abs(temel)-up).lt.zero) go to 500
   c=dn*c
   d=dn*d
   am=dn*am
   el=dn*el
   tempc=dn*tempc
   tempd=dn*tempd
   tempm=dn*tempm
   temel=dn*temel
   go to 520
  500 continue
   if ((abs(tempm)+abs(temel)-dn).gt.zero) go to 520
   c=up*c
   d=up*d
   am=up*am
   el=up*el
   tempc=up*tempc
   tempd=up*tempd
   tempm=up*tempm
   temel=up*temel
  520 continue
   go to (390,440,530),kw
  530 continue
   return
   end subroutine uw

end module unresm

module gaminm
   ! provides subroutine gaminr for NJOY2016
   use locale
   implicit none
   private
   public gaminr

   ! global variables
   integer::igg,ngg
   integer,parameter::ngmax=400
   real(kr)::egg(ngmax)
   integer::iwt
   integer,parameter::iwmax=200
   real(kr)::wght(iwmax)
   integer::matb,lord
   integer::nendf,npend
   integer::ngam1,ngam2,ntw
   character(17)::title(17)
   integer::matd,mfd,mtd
   integer::ig2pp
   integer::iprint

contains

   subroutine gaminr
   !------------------------------------------------------------------
   !
   ! compute multigroup photon cross sections
   !
   ! Produce multigroup photon interaction cross sections
   ! and heating kerma factors using ENDF cross sections
   ! and coherent and incoherent form factors.  Initial energy
   ! quadrature techiques are identical to those used in groupr.
   ! Secondary energy-angle quadrature is performed using Gaussian
   ! integration.
   !
   !---input specifications (free format)---------------------------
   !
   ! card1
   !    nendf   unit for endf tape
   !    npend   unit for pendf tape
   !    ngam1   unit for input ngam tape (default=0)
   !    ngam2   unit for output ngam tape (default=0)
   ! card2
   !    matb    material to be processed
   !            input materials in ascending order
   !    igg     gamma group structure option
   !    iwt     weight function option
   !    lord    legendre order
   !    iprint  print option (0/1=minimum/maximum) (default=1)
   ! card3
   !    title   run label up to 80 characters (delimited by ',
   !            ended with /)
   ! card4      (igg=1 only)
   !    ngg     number of groups
   !    egg     ngg+1 group bounds (ev)
   ! card5      (iwt=1 only)
   !    wght    weight function as tab1 record
   ! card6
   !    mfd     file to be processed
   !    mtd     section to be processed
   !    mtname  description of section to be processed
   !            repeat for all reactions desired
   !            mfd=0/ terminates this material
   !            mfd=-1/ is a flag to process all sections present
   !            for this material  (termination is automatic)
   ! card7
   !    matd    next mat number to be processed
   !            terminate gaminr run with matd=0.
   !
   !---options for input variables----------------------------------
   !
   !        igg     meaning
   !        ---     -------
   !         0      none
   !         1      arbitrary structure (read in)
   !         2      csewg 94-group structure
   !         3      lanl 12-group structure
   !         4      steiner 21-group gamma-ray structure
   !         5      straker 22-group structure
   !         6      lanl 48-group structure
   !         7      lanl 24-group structure
   !         8      vitamin-c 36-group structure
   !         9      vitamin-e 38-group structure
   !         10      vitamin-j 42-group structure
   !
   !        iwt     meaning
   !        ---     -------
   !         1      read in
   !         2      constant
   !         3      1/e + rolloffs
   !
   !------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use endf   ! provides endf routines and variables
   use util   ! provides timer,repoz,skiprz,closz
   use physics ! provides electron mass
   integer::nw,nb,nwds,nggp1,np,loc,nleft,icnt,mflg,nl
   integer::idis,ng2,iglo,nq,ig1,ig,ig2lo,it,iz,il
   integer::idone,igzero,j,ibase,i,lim,l
   integer::ntoth,ii,jj
   real(kr)::time,zref,znow,za,awr,e,en,elo,ehi,enext
   real(kr)::thresh
   character(4)::mtname(15)
   integer::ng2s(ngmax+1),ig2s(ngmax+1)
   real(kr)::z(10,10)
   character(66)::text
   character(4)::tt(17)
   real(kr)::rt(17)
   equivalence(tt(1),rt(1))
   integer,dimension(9),parameter::mflst=(/&
     23,23,26,23,26,23,26,23,23/)
   integer,dimension(9),parameter::mtlst=(/&
     501,502,502,504,504,516,516,602,621/)
   integer,dimension(9),parameter::mtlst6=(/&
     501,502,502,504,504,516,516,522,525/)
   character(4),dimension(9)::nmlst=(/&
     'totl','coht','coht','inch','inch','pair','pair','abst','heat'/)
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::sdat
   real(kr),dimension(:),allocatable::pff
   real(kr),dimension(:),allocatable::toth
   real(kr),dimension(:,:),allocatable::ff
   real(kr),dimension(:,:,:),allocatable::akn
   real(kr),dimension(:,:,:),allocatable::ans
   real(kr),parameter::ekn=12.4e3_kr
   real(kr),parameter::emax=1.e12_kr
   real(kr),parameter::zero=0
   integer,parameter::ncnt=9
   integer,parameter::nwpff=5000
   integer::nz=1

   !--write heading and read user input
   call timer(time)
   write(nsyso,'(/&
     &'' gaminr...produce photon interaction cross sections'',&
     &18x,f8.1,''s'')') time
   write(nsyse,'(/'' gaminr...'',59x,f8.1,''s'')') time
   call ruing

   !--allocate storage arrays
   nw=npage+50
   allocate(scr(nw))
   allocate(sdat(nw))
   allocate(pff(nwpff))
   ntoth=ngg*2
   allocate(toth(ntoth))
   zref=101
   znow=0
   allocate(akn(lord+1,ngg+3,ngg))
   call repoz(nendf)

   !--determine endf format being used
   call repoz(nendf)
   call tpidio(nendf,0,0,scr,nb,nw)
   call contio(nendf,0,0,scr,nb,nw)
   call contio(nendf,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' using endf-'',i1,'' format'')') iverf
   call repoz(nendf)
   call repoz(npend)
   call tpidio(nendf,0,0,scr,nb,nw)
   call tpidio(npend,0,0,scr,nb,nwds)

   !--locate position for new material on old gamout tape.
   call repoz(ngam1)
   call repoz(ngam2)
   nsh=0
   if (ngam1.eq.0) call tpidio(0,ngam2,0,scr,nb,nwds)
   if (ngam1.eq.0.or.ngam2.eq.0) go to 150
   call tpidio(ngam1,ngam2,0,scr,nb,nwds)
  110 continue
   call contio(ngam1,0,0,scr,nb,nw)
   if (math.eq.-1) go to 140
   if (math.eq.1) go to 110
   if (math.eq.matb) go to 130
   if (math.gt.matb) go to 140
   call contio(0,ngam2,0,scr,nb,nw)
   call tomend(ngam1,ngam2,0,scr)
   go to 110
  130 continue
   call tomend(ngam1,0,0,scr)
   go to 150
  140 continue
   call skiprz(ngam1,-1)
  150 continue

   !--search for desired material on pendf tape
  160 continue
   call findf(matb,1,451,npend)
   call contio(npend,0,0,scr,nb,nw)
   za=c1h
   awr=c2h
   if (iverf.ge.5) call contio(npend,0,0,scr,nb,nw)
   if (iverf.ge.6) call contio(npend,0,0,scr,nb,nw)
   call hdatio(npend,0,0,scr,nb,nw)
   do i=1,17
      rt(i)=scr(6+i)
   enddo
   write(nsyso,'(/&
     &'' processing mat '',i4/1x,66(''-'')/1x,17a4)')&
     matb,(tt(i),i=1,17)

   !--write head record for this material on gamout tape.
   if (ngam2.ne.0) then
      nsh=1
      math=matb
      mfh=1
      mth=451
      scr(1)=za
      scr(2)=awr
      scr(3)=0
      scr(4)=nz
      scr(5)=-1
      scr(6)=ntw
      call contio(0,ngam2,0,scr,nb,nw)
      scr(1)=0
      scr(2)=0
      scr(3)=ngg
      scr(4)=0
      scr(5)=0
      scr(6)=0
      nw=6
      do i=1,ntw
         nw=nw+1
         tt(i)=title(i)
         scr(nw)=rt(i)
      enddo
      nw=nw+1
      scr(nw)=emax
      nggp1=ngg+1
      do i=1,nggp1
         nw=nw+1
         if (egg(i).lt.epair) ig2pp=i
         scr(nw)=egg(i)
      enddo
      nw=nw+1
      scr(nw)=0
      np=nw-6
      scr(5)=np
      loc=1
      nw=np
      if (nw.gt.npage) nw=npage
      nw=nw+6
      call listio(0,ngam2,0,scr(loc),nb,nw)
      nleft=np-nw+6
      do while (nb.ne.0)
         loc=loc+nw
         nw=nleft
         if (nw.gt.npage) nw=npage
         call moreio(0,ngam2,0,scr(loc),nb,nw)
      enddo
      call afend(ngam2,0)
   endif

   !--main entry point for loop over reactions
   !--initialize and write appropriate heading.
   !--write head record on output tape.
   matd=matb
   do i=1,ntoth
      toth(i)=0
   enddo
   icnt=0
   mflg=0
  220 continue
   if (mflg.eq.-1) go to 250
   text=' '
   read(nsysi,*) mfd,mtd,text
   mflg=mfd
   if (mflg.eq.-1) go to 250
   if (mfd.eq.0) go to 420
   read(text,'(15a4)') (mtname(i),i=1,15)
   go to 270
  250 continue
   icnt=icnt+1
   if (icnt.gt.ncnt) go to 420
   text=' '
   read(text,'(15a4)') (mtname(i),i=1,15)
   mfd=mflst(icnt)
   mtd=mtlst(icnt)
   if (iverf.ge.6) mtd=mtlst6(icnt)
   read(nmlst(icnt),'(a4)') mtname(1)
  270 continue
   call timer(time)

   ! special branch for total heating assigned to mt=621.
   ! for version 6 format, heating is mt=525
   if (mtd.eq.621) go to 400
   if (mtd.eq.525) go to 400

   ! branch for normal reactions
   nl=1
   if (mfd.eq.26) nl=lord+1
   if (mtd.eq.516) nl=1
   nz=1
   if (allocated(ans)) deallocate(ans)
   allocate(ans(nl,nz,ngg+3))
   allocate(ff(nl,ngg+3))
   e=0
   call gtsig(e,thresh,idis,z,sdat)
   call gtflx(e,en,idis,z,nl,nz)
   call gtff(e,en,idis,ff,nl,ng2,iglo,nq,pff,nwpff)
   ig1=0
   ig=0
   if (mfd.eq.26.and.mtd.eq.504) then
      znow=nint(za/1000)
      if (znow.le.zref) then
         zref=znow
         znow=-znow
      endif
   endif

   !--loop over initial energy groups
  300 continue
   ig=ig+1
   elo=egg(ig)
   ehi=egg(ig+1)
   if (znow.gt.zero.and.elo.ge.znow*ekn) go to 325
   ig2lo=0
   ng2=2
   if (ehi.le.thresh) go to 380
   enext=ehi
   do it=1,ngg+3
      do iz=1,nz
         do il=1,nl
            ans(il,iz,it)=0
         enddo
      enddo
   enddo
   idone=0
   do while (idone.eq.0)
      call gpanel(elo,enext,ans,ff,nl,nz,ng2,ig2lo,sdat,pff,nwpff)
      if (enext.eq.ehi) then
         idone=1
      else
         elo=enext
         enext=ehi
      endif
   enddo
   go to 330
  325 continue
   do i=1,3+ngg
      do j=1,nl
         ans(j,1,i)=akn(j,i,ig)
         if (i.gt.1) ans(j,1,i)=ans(j,1,i)*znow
      enddo
   enddo
   ng2=ng2s(ig)
   ig2lo=ig2s(ig)
  330 continue

   !--print results for this initial energy group
   if (ig1.eq.0) then
      ig1=1
      write(nsyso,'(/'' group constants'',53x,f8.1,''s'')') time
      write(nsyso,'('' for mf'',i2,'' and mt'',i3,1x,15a4)')&
        mfd,mtd,(mtname(i),i=1,15)
      math=matb
      mfh=mfd
      mth=mtd
      scr(1)=za
      scr(2)=awr
      scr(3)=nl
      scr(4)=nz
      scr(5)=0
      scr(6)=ngg
      call contio(0,ngam2,0,scr,nb,nwds)
      call dspla(-1,ans,nl,nz,ng2,ig2lo,igzero)
   endif
   if (znow.lt.zero) then
      do i=1,3+ngg
         do j=1,nl
            akn(j,i,ig)=ans(j,1,i)
            if (i.gt.1) akn(j,i,ig)=akn(j,i,ig)/abs(znow)
         enddo
      enddo
      ng2s(ig)=ng2
      ig2s(ig)=ig2lo
   endif
   call dspla(ig,ans,nl,nz,ng2,ig2lo,igzero)

   !--accumulate total heating.
   if (ng2.ne.2.and.mtd.ne.502) then
      l=1+2*(ig-1)
      toth(l)=ans(1,1,1)
      toth(l+1)=toth(l+1)+ans(1,1,ng2)*ans(1,1,1)
      ng2=ng2-1
      if (mtd.eq.504) ng2=ng2-1
   endif

   !--write results on output tape
   nw=nl*nz*ng2
   lim=nw
   if (ngam2.ne.0.and.(igzero.ne.0.or.ig.eq.ngg)) then
      math=matb
      mfh=mfd
      mth=mtd
      scr(1)=0
      scr(2)=0
      scr(3)=ng2
      scr(4)=ig2lo
      scr(5)=nw
      scr(6)=ig
      j=6
      ibase=6
      do i=1,lim
         j=j+1
         jj=(i-1)/nl
         ii=i-nl*jj
         jj=jj+1
         scr(j)=ans(ii,1,jj)
         if (j.ge.(npage+ibase).or.i.eq.lim) then
            if (ibase.ne.0) then
               call listio(0,ngam2,0,scr,nb,j)
               ibase=0
               j=0
            else
               call moreio(0,ngam2,0,scr,nb,j)
               j=0
            endif
         endif
      enddo
      if (ig.eq.ngg) call asend(ngam2,0)
   endif

   !--continue the loop over groups
  380 continue
   if (ig.lt.ngg) go to 300
   if (ig1.eq.0) write(nsyso,'(/&
     &'' threshold above highest energy bound for mt='',i3)') mtd
   znow=0

   !--loop over other desired reactions
   deallocate(ff)
   deallocate(ans)
   go to 220

   !--edit out total heating.
  400 continue
   ig=0
   ig1=0
   nl=1
   do while (ig.lt.ngg)
      ig=ig+1
      ng2=2
      ig2lo=1
      allocate(ans(1,1,2))
      l=1+2*(ig-1)
      ans(1,1,1)=toth(l)
      ans(1,1,2)=toth(l+1)
      if (ig1.eq.0) then
         ig1=1
         write(nsyso,'(/'' group constants'',53x,f8.1,''s'')') time
         write(nsyso,'('' for mf'',i2,'' and mt'',i3,1x,15a4)')&
           mfd,mtd,(mtname(i),i=1,15)
         math=matb
         mfh=mfd
         mth=mtd
         scr(1)=za
         scr(2)=awr
         scr(3)=nl
         scr(4)=nz
         scr(5)=0
         scr(6)=ngg
         call contio(0,ngam2,0,scr,nb,nwds)
         call dspla(-1,ans,nl,nz,ng2,ig2lo,igzero)
      endif
      call dspla(ig,ans,nl,nz,ng2,ig2lo,igzero)
      nw=nl*nz*ng2
      lim=nw
      if (ngam2.ne.0.and.(igzero.ne.0.or.ig.eq.ngg)) then
         math=matb
         mfh=mfd
         mth=mtd
         scr(1)=0
         scr(2)=0
         scr(3)=ng2
         scr(4)=ig2lo
         scr(5)=nw
         scr(6)=ig
         j=6
         ibase=6
         do i=1,lim
            j=j+1
            jj=(i-1)/nl
            ii=i-nl*jj
            jj=jj+1
            scr(j)=ans(ii,1,jj)
            if (j.ge.(npage+ibase).or.i.eq.lim) then
               if (ibase.ne.0) then
                  call listio(0,ngam2,0,scr,nb,j)
                  ibase=0
                  j=0
               else
                  call moreio(0,ngam2,0,scr,nb,j)
                  j=0
               endif
            endif
         enddo
         if (ig.eq.ngg) call asend(ngam2,0)
      endif
      deallocate(ans)
   enddo
   go to 220

   !--loop over desired materials.
  420 continue
   call amend(ngam2,0)
   matb=0
   read(nsysi,*) matb
   if (matb.eq.0) go to 500
   if (ngam1.eq.0) go to 160
   go to 110

   !--gaminr is complete.
  500 continue
   if (ngam1.eq.0) call atend(ngam2,0)
   if (ngam1.ne.0) call totend(ngam1,ngam2,0,scr)
   call repoz(ngam1)
   call repoz(ngam2)
   call repoz(nendf)
   call repoz(npend)
   call closz(ngam1)
   call closz(ngam2)
   call closz(nendf)
   call closz(npend)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/1x,77(''*''))') time
   return
   end subroutine gaminr

   subroutine ruing
   !------------------------------------------------------------------
   ! Read user input for group averaging.
   !------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util   ! provides openz
   ! internals
   integer::i
   character(66)::text

   !--read and display user input
   ngam1=0
   ngam2=0
   read(nsysi,*) nendf,npend,ngam1,ngam2
   call openz(nendf,0)
   call openz(npend,0)
   call openz(ngam1,0)
   call openz(ngam2,1)
   iprint=1
   read(nsysi,*) matb,igg,iwt,lord,iprint
   read(nsysi,*) text
   read(text,'(16a4,a2)') (title(i),i=1,17)
   write(nsyso,'(/&
     &'' unit for endf tape ................... '',i10/&
     &'' unit for pendf tape .................. '',i10/&
     &'' unit for input gamout tape ........... '',i10/&
     &'' unit for output gamout tape .......... '',i10)')&
     nendf,npend,ngam1,ngam2
   write(nsyso,'(&
     &'' mat to be processed .................. '',i10/&
     &'' gamma group option ................... '',i10/&
     &'' weight function option ............... '',i10/&
     &'' legendre order ....................... '',i10/&
     &'' print option (0 min, 1 max) .......... '',i10)')&
     matb,igg,iwt,lord,iprint
   write(nsyso,'(/'' run title''/1x,38(''-'')/&
     &6x,16a4,a2)') (title(i),i=1,17)
   write(nsyso,'('' '')')
   if (ngam2.gt.0) then
      ntw=1
      title(1)=''
   endif
   call genggp
   call gnwtf
   return
   end subroutine ruing

   subroutine genggp
   !------------------------------------------------------------------
   ! Generate requested gamma group structure or read in from
   ! the system input file in the form of an ENDF/B list record.
   !
   !    igg     meaning
   !    ---     --------------------------------------
   !     0      none
   !     1      arbitrary structure (read in)
   !     2      csewg 94-group structure
   !     3      lanl 12-group structure
   !     4      steiner 21-group gamma-ray structure (ornl-tm-2564)
   !     5      straker 22-group structure
   !     6      lanl 48-group structure
   !     7      lanl 24-group structure
   !     8      vitamin-c 36-group structure
   !     9      vitamin-e 38-group structure (r. roussin, feb 86)
   !    10      vitamin-j 42-group structure
   !
   !------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util   ! provides error
   ! internals
   integer::ig,ngm,i,ngp
   real(kr),dimension(95),parameter::eg2=(/&
     .005e0_kr,.01e0_kr,.015e0_kr,.02e0_kr,.03e0_kr,.035e0_kr,&
     .04e0_kr,.045e0_kr,.055e0_kr,.06e0_kr,.065e0_kr,.075e0_kr,&
     .08e0_kr,.09e0_kr,.1e0_kr,.12e0_kr,.14e0_kr,.15e0_kr,.16e0_kr,&
     .19e0_kr,.22e0_kr,.26e0_kr,.3e0_kr,.325e0_kr,.35e0_kr,&
     .375e0_kr,.4e0_kr,.425e0_kr,.45e0_kr,.5e0_kr,.525e0_kr,&
     .55e0_kr,.575e0_kr,.6e0_kr,.625e0_kr,.65e0_kr,.675e0_kr,&
     .7e0_kr,.75e0_kr,.8e0_kr,.825e0_kr,.865e0_kr,.9e0_kr,1.e0_kr,&
     1.125e0_kr,1.2e0_kr,1.25e0_kr,1.33e0_kr,1.42e0_kr,1.5e0_kr,&
     1.6e0_kr,1.66e0_kr,1.75e0_kr,1.875e0_kr,2.e0_kr,2.166e0_kr,&
     2.333e0_kr,2.5e0_kr,2.666e0_kr,2.833e0_kr,3.e0_kr,3.166e0_kr,&
     3.333e0_kr,3.5e0_kr,3.65e0_kr,3.8e0_kr,3.9e0_kr,4.e0_kr,&
     4.2e0_kr,4.4e0_kr,4.5e0_kr,4.7e0_kr,5.e0_kr,5.2e0_kr,5.4e0_kr,&
     5.5e0_kr,5.75e0_kr,6.e0_kr,6.25e0_kr,6.5e0_kr,6.75e0_kr,&
     7.e0_kr,7.25e0_kr,7.5e0_kr,7.75e0_kr,8.e0_kr,8.5e0_kr,9.e0_kr,&
     9.5e0_kr,10.e0_kr,10.6e0_kr,11.e0_kr,12.e0_kr,14.e0_kr,20.e0_kr/)
   real(kr),dimension(13),parameter::eg3=(/&
     .01e0_kr,.10e0_kr,.50e0_kr,1.0e0_kr,2.0e0_kr,3.0e0_kr,4.0e0_kr,&
     5.0e0_kr,6.0e0_kr,7.0e0_kr,8.0e0_kr,9.0e0_kr,20.0e0_kr/)
   real(kr),dimension(22),parameter::eg4=(/&
     .01e0_kr,.1e0_kr,.2e0_kr,.4e0_kr,1.e0_kr,1.5e0_kr,2.e0_kr,&
     2.5e0_kr,3.e0_kr,3.5e0_kr,4.e0_kr,4.5e0_kr,5.e0_kr,5.5e0_kr,&
     6.e0_kr,6.5e0_kr,7.e0_kr,7.5e0_kr,8.e0_kr,10.e0_kr,12.e0_kr,&
     14.e0_kr/)
   real(kr),dimension(23),parameter::eg5=(/&
     .01e0_kr,.03e0_kr,.06e0_kr,.10e0_kr,.15e0_kr,.30e0_kr,.45e0_kr,&
     .60e0_kr,.80e0_kr,1.0e0_kr,1.33e0_kr,1.66e0_kr,2.0e0_kr,&
     2.5e0_kr,3.0e0_kr,3.5e0_kr,4.0e0_kr,5.0e0_kr,6.0e0_kr,7.0e0_kr,&
     8.0e0_kr,10.0e0_kr,14.0e0_kr/)
   real(kr),dimension(49),parameter::eg6=(/&
     .001e0_kr,.01e0_kr,.02e0_kr,.03e0_kr,.045e0_kr,.06e0_kr,&
     .08e0_kr,.1e0_kr,.15e0_kr,.2e0_kr,.3e0_kr,.4e0_kr,.45e0_kr,&
     .5e0_kr,.525e0_kr,.6e0_kr,.7e0_kr,.8e0_kr,.9e0_kr,1.e0_kr,&
     1.125e0_kr,1.2e0_kr,1.33e0_kr,1.5e0_kr,1.66e0_kr,1.875e0_kr,&
     2.e0_kr,2.333e0_kr,2.5e0_kr,2.666e0_kr,3.e0_kr,3.5e0_kr,&
     4.e0_kr,4.5e0_kr,5.e0_kr,5.5e0_kr,6.e0_kr,6.5e0_kr,7.e0_kr,&
     7.5e0_kr,8.e0_kr,9.e0_kr,10.e0_kr,12.e0_kr,14.e0_kr,17.e0_kr,&
     20.e0_kr,30.e0_kr,50.e0_kr/)
   real(kr),dimension(25),parameter::eg7=(/&
     1.e4_kr,3.e4_kr,6.e4_kr,1.e5_kr,2.e5_kr,3.e5_kr,5.e5_kr,&
     5.25e5_kr,7.5e5_kr,1.e6_kr,1.33e6_kr,1.66e6_kr,2.e6_kr,2.5e6_kr,&
     3.e6_kr,4.e6_kr,5.e6_kr,6.e6_kr,7.e6_kr,8.e6_kr,9.e6_kr,1.e7_kr,&
     1.2e7_kr,1.7e7_kr,3.e7_kr/)
   real(kr),dimension(39),parameter::eg8=(/&
     .01e0_kr,.02e0_kr,.03e0_kr,.045e0_kr,.06e0_kr,.07e0_kr,&
     .075e0_kr,.10e0_kr,.15e0_kr,.20e0_kr,.30e0_kr,.40e0_kr,.45e0_kr,&
     .510e0_kr,.512e0_kr,.60e0_kr,.70e0_kr,.80e0_kr,1.0e0_kr,&
     1.33e0_kr,1.50e0_kr,1.66e0_kr,2.0e0_kr,2.5e0_kr,3.0e0_kr,&
     3.5e0_kr,4.0e0_kr,4.5e0_kr,5.0e0_kr,5.5e0_kr,6.0e0_kr,6.5e0_kr,&
     7.0e0_kr,7.5e0_kr,8.0e0_kr,10.e0_kr,12.e0_kr,14.e0_kr,20.e0_kr/)
   real(kr),dimension(43),parameter::eg10=(/&
     1.0e3_kr,1.0e4_kr,2.0e4_kr,3.0e4_kr,4.5e4_kr,6.0e4_kr,7.0e4_kr,&
     7.5e4_kr,1.0e5_kr,1.50e5_kr,2.00e5_kr,3.00e5_kr,4.00e5_kr,&
     4.50e5_kr,5.10e5_kr,5.12e5_kr,6.00e5_kr,7.00e5_kr,8.00e5_kr,&
     1.00e6_kr,1.33e6_kr,1.34e6_kr,1.50e6_kr,1.66e6_kr,2.00e6_kr,&
     2.50e6_kr,3.00e6_kr,3.50e6_kr,4.00e6_kr,4.50e6_kr,5.00e6_kr,&
     5.50e6_kr,6.00e6_kr,6.50e6_kr,7.00e6_kr,7.50e6_kr,8.00e6_kr,&
     1.00e7_kr,1.20e7_kr,1.40e7_kr,2.00e7_kr,3.00e7_kr,5.00e7_kr/)
   real(kr),parameter::mev=1.e6_kr

   !--select structure
   ngg=0
   egg(1)=0
   if (igg.eq.0) return

   !--group structure is read in.
   if (igg.eq.1) then
      read(nsysi,*) ngg
      ngp=ngg+1
      if (ngp.gt.ngmax) call error('genggp','too many groups.',' ')
      read(nsysi,*) (egg(i),i=1,ngp)

   !--csewg 94 group structure
   else if (igg.eq.2) then
      ngg=94
      do ig=1,95
         egg(ig)=eg2(ig)*mev
      enddo

   !--lanl 12 group structure
   else if (igg.eq.3) then
      ngg=12
      do ig=1,13
         egg(ig)=eg3(ig)*mev
      enddo

   !--steiner 21-group gamma structure (ornl-tm-2564)
   else if (igg.eq.4) then
      ngg=21
      do ig=1,22
         egg(ig)=eg4(ig)*mev
      enddo

   !--straker 22 group structure
   else if (igg.eq.5) then
      ngg=22
      do ig=1,23
         egg(ig)=eg5(ig)*mev
      enddo

   !--lanl 48-group structure
   else if (igg.eq.6) then
      ngg=48
      do ig=1,49
         egg(ig)=eg6(ig)*mev
      enddo

   !--lanl 24-group structure
   else if (igg.eq.7) then
      ngg=24
      do ig=1,25
         egg(ig)=eg7(ig)
      enddo

   !--vitamin-series 36- and 38-group structures
   else if (igg.eq.8.or.igg.eq.9) then
      ngg=38
      if (igg.eq.8) ngg=36
      ngm=ngg+1
      do ig=1,ngm
         egg(ig)=eg8(ig)*mev
      enddo
      if (igg.ne.9) then
         ! remove group bounds eg8(7) and eg8(39) if igg=8
         do ig=7,ngm
            egg(ig)=eg8(ig+1)*mev
         enddo
      endif

   !--vitamin-j 42-group structure
   else if (igg.eq.10) then
      ngg=42
      do ig=1,43
         egg(ig)=eg10(ig)
      enddo

   !--illegal value for igg
   else
      call error('genggp','illegal group structure.',' ')
   endif

   !--display group structure
   if (igg.eq.1) write(nsyso,'(/&
     &'' gamma group structure......read in'')')
   if (igg.eq.2) write(nsyso,'(/&
     &'' gamma group structure......csewg 94 group'')')
   if (igg.eq.3) write(nsyso,'(/&
     &'' gamma group structure......lanl 12 group'')')
   if (igg.eq.4) write(nsyso,'(/&
     &'' gamma group structure......steiner 21-group'')')
   if (igg.eq.5) write(nsyso,'(/&
     &'' gamma group structure......straker 22 group'')')
   if (igg.eq.6) write(nsyso,'(/&
     &'' gamma group structure......lanl 48-group'')')
   if (igg.eq.7) write(nsyso,'(/&
     &'' gamma group structure......lanl 24-group'')')
   if (igg.eq.8) write(nsyso,'(/&
     &'' gamma group structure......vitamin-c 36-group'')')
   if (igg.eq.9) write(nsyso,'(/&
     &'' gamma group structure......vitamin-e 38-group'')')
   if (igg.eq.10) write(nsyso,'(/&
     &'' gamma group structure......vitamin-j 42-group'')')
   do ig=1,ngg
      write(nsyso,'(1x,i5,2x,1p,e12.5,''  - '',e12.5)')&
        ig,egg(ig),egg(ig+1)
   enddo
   return
   end subroutine genggp

   subroutine gnwtf
   !------------------------------------------------------------------
   ! Set up calculation of weight functions or read in arbitary
   ! function in the form of an ENDF TAB1 record or
   ! read in parameters for an analytic weight function.
   !
   !    iwt     meaning
   !    ---     -------
   !     1      read in
   !     2      constant
   !     3      1/e + rolloffs
   !
   !------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util   ! provides error
   ! internals
   integer::i
   real(kr),dimension(16),parameter::wt1=(/&
     0.e0_kr,0.e0_kr,0.e0_kr,0.e0_kr,1.e0_kr,4.e0_kr,4.e0_kr,&
     5.e0_kr,1.e3_kr,1.e-4_kr,1.e5_kr,1.e0_kr,1.e7_kr,1.e-2_kr,&
     3.e7_kr,1.e-4_kr/)

   !--branch on weight function option

   !--arbitary
   if (iwt.eq.1) then
      write(nsyso,'(/'' weight function......read in'')')
      read(nsysi,*) (wght(i),i=1,iwmax)

   !--constant
   else if (iwt.eq.2) then
      write(nsyso,'(/'' weight function......constant for all l'')')

   !--1/e with high and low energy rolloffs
   else if (iwt.eq.3) then
      write(nsyso,'(/'' weight function......1/e with rolloffs'')')
      do i=1,16
         wght(i)=wt1(i)
      enddo

   !--illegal value for iwt
   else
      call error('gnwtf','illegal iwt',' ')
   endif
   return
   end subroutine gnwtf

   subroutine gtflx(e,enext,idis,flux,nl,nz)
   !------------------------------------------------------------------
   ! Retrieve or compute required legendre component of the
   ! weight function constructed or read in by genwtf.
   !------------------------------------------------------------------
   use endf ! provides terpa
   ! externals
   integer::idis,nl,nz
   real(kr)::e,enext,flux(10,10)
   ! internals
   integer::ip,ir,il
   real(kr)::wtf,enxt
   real(kr),parameter::emax=1.e12_kr
   real(kr),parameter::step=1.05e0_kr
   real(kr),parameter::zero=0
   save ip,ir

   !--initialize
   idis=0
   if (e.eq.zero) then
      ip=2
      ir=1
      enext=emax

   !--branch to desired method
   else

      !--tabulated
      if (iwt.ne.2) then
         call terpa(wtf,e,enext,idis,wght,ip,ir)
         do il=1,nl
            flux(1,il)=wtf
         enddo
         enxt=step*e
         if (enext.gt.enxt) idis=0
         if (enext.gt.enxt) enext=enxt

     !--constant for all orders
      else
         do il=1,nl
            flux(1,il)=1
         enddo
         enext=emax
         idis=0
      endif
   endif
   return
   end subroutine gtflx

   subroutine gpanel(elo,ehi,ans,ff,nl,nz,ng,iglo,sdat,pff,nwpff)
   !------------------------------------------------------------------
   ! Perform generalized group constant integrals for one panel.
   ! The upper boundry of the panel is chosen to be the smallest
   ! of ehi, the next cross section point, the next flux point,
   ! and the next feed function point.  Use Lobatto quadrature
   ! with order two larger than that used for the feed function.
   !------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nl,nz,ng,iglo,nwpff
   real(kr)::elo,ehi,ans(nl,nz,*),ff(nl,*),sdat(*),pff(nwpff)
   ! internals
   integer::idiscf,ng1,ig1,nq,iz,il,iq,nqp,ig,igt
   real(kr)::en,ehigh,aq,bq,eq,wq,t1,a,b,rr,enext
   real(kr)::sig(10,10),slst(10,10),flux(10,10),flst(10,10)
   real(kr),dimension(2),parameter::qp2=(/-1.e0_kr,1.e0_kr/)
   real(kr),dimension(2),parameter::qw2=(/1.e0_kr,1.e0_kr/)
   real(kr),dimension(6),parameter::qp6=(/&
     -1.e0_kr,-.76505532e0_kr,-.28523152e0_kr,.28523152e0_kr,&
     .76505532e0_kr,1.e0_kr/)
   real(kr),dimension(6),parameter::qw6=(/&
     .06666667e0_kr,.37847496e0_kr,.55485838e0_kr,.55485838e0_kr,&
     .37847496e0_kr,.06666667e0_kr/)
   real(kr),dimension(10),parameter::qp10=(/&
     -1.e0_kr,-.9195339082e0_kr,-.7387738651e0_kr,-.4779249498e0_kr,&
     -.1652789577e0_kr,.1652789577e0_kr,.4779249498e0_kr,&
     .7387738651e0_kr,.9195339082e0_kr,1.e0_kr/)
   real(kr),dimension(10),parameter::qw10=(/&
     .0222222222e0_kr,.1333059908e0_kr,.2248893420e0_kr,&
     .2920426836e0_kr,.3275397612e0_kr,.3275397612e0_kr,&
     .2920426836e0_kr,.2248893420e0_kr,.1333059908e0_kr,&
     .0222222222e0_kr/)
   real(kr),parameter::rndoff=1.000002e0_kr
   real(kr),parameter::delta=0.999995e0_kr
   integer::idisc=0
   real(kr)::elast=0
   save nq,enext,elast,slst,flst,idisc,ng1,ig1

   !--retrieve factors in integrands at lower boundry.
   if (elo.gt.ehi) call error('gpanel','elo gt ehi.',' ')
   if (elo.ne.elast) then
      if (elo*rndoff.lt.ehi) elo=elo*rndoff
      elast=elo
      call gtsig(elo,enext,idisc,slst,sdat)
      call gtflx(elo,en,idiscf,flst,nl,nz)
      if (en.eq.enext.and.idiscf.gt.idisc) idisc=idiscf
      if (en.lt.enext) idisc=idiscf
      if (en.lt.enext) enext=en
      call gtff(elo,en,idiscf,ff,nl,ng1,ig1,nq,pff,nwpff)
      if (en.eq.enext.and.idiscf.gt.idisc) idisc=idiscf
      if (en.lt.enext) idisc=idiscf
      if (en.lt.enext) enext=en
      nq=nq+2
      if (nq.gt.10) nq=10
   endif

   !--retrieve cross section and flux at upper boundry.
   if (enext.lt.delta*ehi) then
      ehi=enext
      ehigh=ehi
      if (idisc.gt.0.and.ehi*delta.gt.elo) ehigh=ehi*delta
   else
      ehigh=delta*ehi
   endif
   call gtsig(ehigh,enext,idisc,sig,sdat)
   call gtflx(ehigh,en,idiscf,flux,nl,nz)
   if (en.eq.enext.and.idiscf.gt.idisc) idisc=idiscf
   if (en.lt.enext) idisc=idiscf
   if (en.lt.enext) enext=en

   !--compute group fluxes assuming flux is linear over panel.
   aq=(ehigh+elo)/2
   bq=(ehigh-elo)/2
   do iz=1,nz
      do il=1,nl
         ans(il,iz,1)=ans(il,iz,1)+(flux(iz,il)+flst(iz,il))*bq
      enddo
   enddo

   !--integrate over panel using lobatto quadrature.
   do iq=1,nq
      if (nq.eq.2) then
         eq=aq+bq*qp2(iq)
         wq=bq*qw2(iq)
      else if (nq.eq.6) then
         eq=aq+bq*qp6(iq)
         wq=bq*qw6(iq)
      else if (nq.eq.10) then
         eq=aq+bq*qp10(iq)
         wq=bq*qw10(iq)
      endif
      t1=(eq-elo)/(ehi-elo)

      !--retrieve the feed function at the quadrature point.
      !--first point was last point of previous panel.
      if (iq.gt.1) then
         if (eq.gt.ehigh) eq=ehigh
         call gtff(eq,en,idiscf,ff,nl,ng1,ig1,nqp,pff,nwpff)
      endif

      !--accumulate the ng*nl*nz integrals simultaneously.
      !--assuming that the reaction rate is linear across the panel.
      if (iglo.eq.0) iglo=ig1
      do iz=1,nz
         do il=1,nl
            a=sig(iz,1)*flux(iz,il)
            b=slst(iz,1)*flst(iz,il)
            rr=b+(a-b)*t1
            rr=rr*wq
            do ig=1,ng1
               igt=ig1+ig-iglo+1
               if (igt.gt.1) then
                  ans(il,iz,igt)=ans(il,iz,igt)+rr*ff(il,ig)
                  if (igt.gt.ng) ng=igt
               endif
            enddo
         enddo
      enddo
   enddo

   !--save cross section and flux for next panel.
   !--determine next point and quadrature order from last ff.
   elast=ehigh
   do iz=1,nz
      slst(iz,1)=sig(iz,1)
      do il=1,nl
         flst(iz,il)=flux(iz,il)
      enddo
   enddo
   if (en.eq.enext.and.idiscf.gt.idisc) idisc=idiscf
   if (en.lt.enext) idisc=idiscf
   if (en.lt.enext) enext=en
   if (enext.le.ehi) enext=rndoff*ehi
   nq=nqp+2
   if (nq.gt.10) nq=10
   return
   end subroutine gpanel

   subroutine dspla(ig,ans,nl,nz,ng2,ig2lo,igzero)
   !------------------------------------------------------------------
   ! Display generalized group constants generated by panel.
   !------------------------------------------------------------------
   use mainio ! provides nsyso
   use util ! provides a10
   ! externals
   integer::ig,nl,nz,ng2,ig2lo,igzero
   real(kr)::ans(nl,nz,*)
   ! internals
   integer::i,ig2,igt,max,il
   real(kr)::result(20)
   character(10)::field(20)
   real(kr),parameter::small=1.e-9_kr
   real(kr),parameter::zero=0

   !--write appropriate heading.
   igzero=0
   if (ig.lt.0) then
      if (iprint.eq.1) then
         write(nsyso,'('' '')')
         if (mfd.ne.26) then
            if (mtd.eq.501.or.mtd.eq.502.or.mtd.eq.504)&
              write(nsyso,'(&
              &'' gamma  sigma  ''/'' group  (barns)'')')
            if (mtd.eq.516) write(nsyso,'(&
              &'' gamma  sigma  ''/'' group  (barns)'')')
            if (mtd.eq.602) write(nsyso,'(&
              &'' gamma  sigma      heating''/&
              &'' group  (barns)    (ev-barns)'')')
            if (mtd.eq.621) write(nsyso,'(&
              &'' gamma  heating''/&
              &'' group  (ev-barns)'')')
            if (mtd.eq.522) write(nsyso,'(&
              &'' gamma  sigma      heating''/&
              &'' group  (barns)    (ev-barns)'')')
            if (mtd.eq.525) write(nsyso,'(&
              &'' gamma  heating''/&
              &'' group  (ev-barns)'')')
         else
            if (mtd.eq.502.or.mtd.eq.504) write(nsyso,'(&
              &'' initl  final  cross sections vs''/&
              &'' group  group  legendre order   '')')
            if (mtd.eq.516) write(nsyso,'(&
              &'' initl  final  cross sections vs''/&
              &'' group  group  legendre order   '')')
         endif
      endif
      return
   endif

   !--write out results in appropriate format.
   !--cross sections and heating values.
   if (mfd.eq.23) then
      do i=2,ng2
         result(i-1)=0
         if (ans(1,1,1).ne.zero.and.abs(ans(1,1,i)).ge.small) then
            result(i-1)=ans(1,1,i)/ans(1,1,1)
            ans(1,1,i)=result(i-1)
            if (ans(1,1,i).ge.small) igzero=1
         endif
      enddo
      if (result(1).ne.zero.and.iprint.eq.1) then
         do i=2,ng2
            call a10(result(i-1),field(i-1))
         enddo
         write(nsyso,'(1x,i3,2x,1p,2a11)') ig,(field(i-1),i=2,ng2)
      endif

   !--scattering matrices.
   else if (mfd.eq.26) then
      do ig2=2,ng2
         igt=ig2lo+ig2-2
         if (mtd.eq.516.and.ig2.gt.2) then
            result(1)=ans(1,1,ig2)/ans(1,1,1)
            ans(1,1,ig2)=result(1)
            if (ans( 1,1,ig2).ge.small) igzero=1
            if (iprint.eq.1) then
               write(nsyso,'(1x,i3,3x,''heat'',2x,1p,e11.3)')&
                 ig,result(1)
            endif
         else if (igt.le.ig) then
            max=nl
            if (max.gt.6) max=6
            do il=1,max
               result(il)=ans(il,1,ig2)/ans(il,1,1)
               ans(il,1,ig2)=result(il)
               if (ans(il,1,ig2).ge.small) igzero=1
               call a10(result(il),field(il))
            enddo
            if (iprint.eq.1)&
              write(nsyso,'(1x,i3,4x,i3,2x,1p,6a11)')&
              ig,igt,(field(i),i=1,max)
            if (nl.gt.6) then
               do il=7,nl
                  result(il)=ans(il,1,ig2)/ans(il,1,1)
                  ans(il,1,ig2)=result(il)
                  if (ans(il,1,ig2).ge.small) igzero=1
                  call a10(result(il),field(il))
               enddo
               if (iprint.eq.1)&
                 write(nsyso,'(13x,1p,6a11)') (field(i),i=7,nl)
            endif
         else
            result(1)=ans(1,1,ig2)/ans(1,1,1)
            ans(1,1,ig2)=result(1)
            if (ans( 1,1,ig2).ge.small) igzero=1
            call a10(result(1),field(1))
            if (iprint.eq.1) then
               if (igt.eq.ig+1) write(nsyso,'(&
                 &1x,i3,3x,''xsec'',2x,1p,a11)') ig,field(1)
               if (igt.eq.ig+2) write(nsyso,'(&
                 &1x,i3,3x,''heat'',2x,1p,a11)') ig,field(1)
            endif
         endif
      enddo
   endif
   return
   end subroutine dspla

   subroutine gtsig(e,enext,idis,sig,sdat)
   !------------------------------------------------------------------
   ! Retrieve the reaction cross-section defined by mfd and mtd.
   !------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::idis
   real(kr)::e,enext,sig(10,10),sdat(*)
   ! internals
   integer::nb,nw,mf,mt
   real(kr)::s
   real(kr),parameter::zero=0

   !--initialize
   if (e.eq.zero) then
      mf=23
      mt=mtd
      call findf(matd,mf,mt,npend)
      call contio(npend,0,0,sdat,nb,nw)
      call gety1(e,enext,idis,s,npend,sdat)

   !--normal entry
   else
      call gety1(e,enext,idis,s,npend,sdat)
      sig(1,1)=s
   endif
   return
   end subroutine gtsig

   subroutine gtff(e,enext,idisc,ff,nl,ng,iglo,nq,pff,nwpff)
   !------------------------------------------------------------------
   ! Compute feed function or yield for desired reaction type.
   !------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   use mathm ! provides legndr
   use physics ! provides electron mass
   ! externals
   integer::idisc,nl,ng,iglo,nq,nwpff
   real(kr)::e,enext,ff(nl,*),pff(nwpff)
   ! internals
   integer::igp,il,ip,idis,idone,ig,ifini,i,ir,iq,l
   integer::lim,j,nb,nw
   real(kr)::c1e,aq,bq,fact,enow,enowi,enow2,ebar,dk,zz
   real(kr)::pnow,pnext,pnowi,xnow,unow,snow,xlim,stest,wq,test
   real(kr)::xnext,xq,xzz
   real(kr)::sigcoh,q2m,siginc,q2,unext,px,uq,rm2,rm,rt
   real(kr)::arg(12),pl(12)
   save zz

   real(kr),dimension(6),parameter::qp6=(/&
      -1.e0_kr,-.76505532e0_kr,-.28523152e0_kr,.28523152e0_kr,&
     .76505532e0_kr,1.e0_kr/)
   real(kr),dimension(6),parameter::qw6=(/&
     .06666667e0_kr,.37847496e0_kr,.55485838e0_kr,.55485838e0_kr,&
     .37847496e0_kr,.06666667e0_kr/)
   real(kr),dimension(10),parameter::qp10=(/&
     -1.e0_kr,-.9195339082e0_kr,-.7387738651e0_kr,-.4779249498e0_kr,&
     -.1652789577e0_kr,.1652789577e0_kr,.4779249498e0_kr,&
     .7387738651e0_kr,.9195339082e0_kr,1.e0_kr/)
   real(kr),dimension(10),parameter::qw10=(/&
     .0222222222e0_kr,.1333059908e0_kr,.2248893420e0_kr,&
     .2920426836e0_kr,.3275397612e0_kr,.3275397612e0_kr,&
     .2920426836e0_kr,.2248893420e0_kr,.1333059908e0_kr,&
     .0222222222e0_kr/)
   real(kr),parameter::c1=57.03156e-6_kr
   real(kr),parameter::c2=0.249467e0_kr
   real(kr),parameter::c3=1.95693e-6_kr
   real(kr),parameter::c4=0.0485262e0_kr
   real(kr),parameter::c5=20.60744e0_kr
   real(kr),parameter::toler=1.e-6_kr
   real(kr),parameter::rndoff=1.0000001e0_kr
   real(kr),parameter::emax=1.e12_kr
   real(kr),parameter::two=2.e0_kr
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::close=.99999e0_kr
   real(kr),parameter::zero=0

   !--photon interaction cross sections and heating.
   if (mfd.eq.23) then
      nq=0
      iglo=1
      ng=0
      if (mtd.eq.501.or.mtd.eq.502.or.mtd.eq.504) ng=1
      if (mtd.eq.516) ng=1
      if (mtd.eq.602) ng=2
      if (mtd.eq.522) ng=2
      if (ng.eq.0)&
        call error('gtff','illegal reaction for cross section.',' ')
      enext=emax
      idisc=0
      if (e.eq.zero) return
      ff(1,1)=1
      if (mtd.eq.602) ff(1,2)=e
      if (mtd.eq.522) ff(1,2)=e
      return

   !--photon scattering cross sections.
   !--initialize.
   else if (mfd.eq.26) then
      if (e.eq.zero.or.mtd.ne.502) then
         if (e.eq.zero.or.mtd.ne.504) then
            if (mtd.ne.516) then
               call findf(matd,27,mtd,nendf)
               l=1
               call contio(nendf,0,0,pff(l),nb,nw)
               call tab1io(nendf,0,0,pff(l),nb,nw)
               zz=pff(l+1)
               l=l+nw
               do while (nb.ne.0)
                  if (l.gt.nwpff) call error('gtff',&
                    'insufficient storage for form factor.',' ')
                  call moreio(nendf,0,0,pff(l),nb,nw)
                  l=l+nw
               enddo
               ng=1
               if (mtd.eq.504) ng=ngg+2
               enext=emax
               idisc=0
               return
            endif
         endif
      endif

      !--photon coherent scattering.
      !--compute all legendre components at this energy.
      if (mtd.eq.502) then
         igp=1
         do while (e.ge.egg(igp+1))
            igp=igp+1
         enddo
         do il=1,nl
            ff(il,1)=0
         enddo
         ng=1
         iglo=igp
         xnow=0
         unow=1
         ip=2
         ir=1
         call terpa(snow,xnow,xnext,idis,pff,ip,ir)
         fact=2*c2/(c1*c1*e*e)
         xlim=sqrt(two)*c1*e
         c1e=1/(c1*e)**2
         do il=1,nl
            arg(il)=2*snow**2
         enddo
         stest=toler*snow

         !--loop over panels of coherent form factor.
         idone=0
         do while (idone.eq.0)
            aq=(xnext+xnow)/2
            bq=(xnext-xnow)/2
            nq=6
            if (nl.gt.4) nq=10
            do iq=1,nq
               if (nq.eq.6) then
                  xq=aq+bq*qp6(iq)
                  wq=bq*qw6(iq)
               else
                  xq=aq+bq*qp10(iq)
                  wq=bq*qw10(iq)
               endif
               xnow=xq*rndoff
               if (iq.gt.1) then
                  unow=1-c1e*xnow*xnow
                  test=-1
                  if (unow.lt.test) unow=-1
                  call terpa(snow,xnow,xnext,idis,pff,ip,ir)
                  call legndr(unow,pl,nl)
                  do il=1,nl
                     arg(il)=(1+unow*unow)*snow*snow*pl(il)
                  enddo
               endif
               do il=1,nl
                  ff(il,1)=ff(il,1)+wq*fact*xnow*arg(il)
               enddo
            enddo
            test=-1
            if (unow.le.test) then
               idone=1
            else
               if (xnow.ge.xlim) then
                  idone=1
               else
                  if (snow.lt.stest) then
                     idone=1
                  else
                     if (xnext.gt.xlim) xnext=xlim
                  endif
               endif
            endif
         enddo
         sigcoh=ff(1,1)
         do il=1,nl
            ff(il,1)=ff(il,1)/sigcoh
         enddo
         enext=egg(igp+1)
         idisc=1
         nq=0
         return

      !--photon incoherent scattering and heating.
      !--compute for all legendre orders and all sink groups.
      else if (mtd.eq.504) then
         igp=1
         do while (e.ge.egg(igp+1))
            igp=igp+1
         enddo
         enow=c3*e
         enowi=1/enow
         enow2=enow*enow
         pnow=enow
         xnow=0
         xzz=c5*sqrt(enow/500)
         q2m=(2*enow*(1+enow)/(1+2*enow))**2
         if (xzz.le.zz) then
            ip=2
            ir=1
            call terpa(snow,xnow,xnext,idis,pff,ip,ir)
         else
            snow=zz
            xnext=emax
         endif
         do il=1,nl
            arg(il)=0
            lim=igp+2
            do ig=1,lim
               ff(il,ig)=0
            enddo
         enddo
         ig=igp
         siginc=0
         ebar=0
         if (e.eq.egg(igp)) igp=igp-1

         !--loop over panels defined by group and form factor breaks.
         ifini=0
         do while (ifini.eq.0)
            idone=0
            do while (idone.eq.0)
               q2=(c4*xnext)**2
               unext=-1
               if (q2.gt.q2m) then
                  idone=1
               else
                  unext=1-((1-q2*enowi)-sqrt(1+q2))/(q2-enow2-2*enow)
                  test=-1
                  if (unext.lt.test) unext=-1
                  if (unext.lt.close) then
                     idone=1
                  else
                     xnow=xnext*rndoff
                     call terpa(snow,xnow,xnext,idis,pff,ip,ir)
                  endif
               endif
            enddo
            pnext=enow/(1+2*enow)
            if (igp.gt.0) pnext=c3*egg(igp)
            px=enow/(1+enow*(1-unext))
            if (px.gt.pnext) pnext=px
            if (pnext.gt.pnow/rndoff) pnext=pnow/rndoff
            aq=(pnext+pnow)/2
            bq=(pnext-pnow)/2
            nq=6
            if (nl.gt.6) nq=10
            do iq=1,nq
               if (nq.eq.6) then
                  uq=aq+bq*qp6(iq)
                  wq=-c2*bq*qw6(iq)
               else
                  uq=aq+bq*qp10(iq)
                  wq=-c2*bq*qw10(iq)
               endif
               pnow=uq
               if (iq.ne.1) then
                  pnowi=1/pnow
                  unow=1+enowi-pnowi
                  test=1
                  if (unow.gt.test) unow=1
                  if (xzz.le.zz) then
                     rm2=(1-unow)/2
                     rm=sqrt(rm2)
                     rt=1+2*enow*rm2
                     xnow=c5*2*enow*rm*sqrt(rt+enow2*rm2)/rt
                     xnow=xnow*rndoff
                     call terpa(snow,xnow,xnext,idis,pff,ip,ir)
                  endif
                  call legndr(unow,pl,nl)
                  dk=unow-1
                  fact=snow*(enow*pnowi+pnow*enowi+dk*(2+dk))/enow2
                  do il=1,nl
                     arg(il)=fact*pl(il)
                  enddo
               endif
               if (igp.ne.0) then
                  do il=1,nl
                     ff(il,igp)=ff(il,igp)+wq*arg(il)
                  enddo
               endif
               siginc=siginc+wq*arg(1)
               ebar=ebar+wq*arg(1)*pnow/c3
            enddo
            if (unow.lt.-close) then
               ifini=1
            else
               if (igp.gt.0) then
                  if (pnext.le.c3*egg(igp)) igp=igp-1
               endif
            endif
         enddo

         !--strip sink groups with zero cross section.
         if (igp.le.0) igp=1
         iglo=igp
         ng=ig-igp+1
         do i=1,ng
            j=iglo+i-1
            do il=1,nl
               ff(il,i)=ff(il,j)
            enddo
         enddo
         ebar=ebar/siginc
         ff(1,ng+1)=siginc
         ff(1,ng+2)=(e-ebar)*siginc
         ng=ng+2
         do il=1,nl
            do i=1,ng
               ff(il,i)=ff(il,i)/siginc
            enddo
         enddo

         !--determine next critical point for incoherent scattering.
         if (c3*e.ge.half) then
            enext=emax
         else
            idone=0
            i=0
            do while (i.lt.ngg.and.idone.eq.0)
               i=i+1
               if (c3*egg(i).ge.test) then
                  idone=1
               else
                  enext=egg(i)/(1-2*c3*egg(i))
                  if (enext.gt.e) idone=2
               endif
            enddo
            if (idone.lt.2) enext=emax
         endif
         if (egg(ig+1).lt.enext) enext=egg(ig+1)
         idisc=1
         nq=nq+2
         return

      !--pair production matrix
      else if (mtd.eq.516) then
         enext=emax
         idisc=0
         if (e.gt.zero) then
            igp=1
            do while (e.ge.egg(igp+1))
               igp=igp+1
            enddo
            do il=1,nl
               ff(il,1)=0
            enddo
            ng=2
            iglo=ig2pp
            nq=0
            ff(1,1)=2
            ff(1,2)=e-2.0*epair
         endif
         return
      endif

   !--bad file type
   else
      call error('gtff','illegal file type.',' ')
   endif
   return
   end subroutine gtff

end module gaminm

module broadm
   ! Module to provide broadr for NJOY2016
   use locale
   implicit none
   private
   public broadr

   ! global variables for broadr
   integer::nunr,intunr,nsig0,ncyc
   real(kr)::e1,eumax
   real(kr)::alpha,tempk,tempef,errthn,errmax,errint,thnmax
   integer::klow,khigh,mlow,mhigh,nlow,nhigh,n2in,&
     n2out,n2left,mpage,nreac,ntx
   real(kr)::f(5),aa,x,y,oy,xx,yy ! variables for funk
   real(kr)::h(5),alast,s1,s2 ! variables for hunk

   integer,parameter::ntt=160
   integer,parameter::nbuf=1000
   real(kr),dimension(ntt)::qmtr,emtr

contains

   subroutine broadr
   !-------------------------------------------------------------------
   !
   ! Doppler broaden and thin neutron point cross sections
   !
   ! A modified version of the kernel broadening method developed
   ! for SIGMA1 (D.E.Cullen, LLNL) is used.  Cross sections for low
   ! threshold reactions are unionized on the grid of the total
   ! cross section, then broadened and thinned in parallel.
   ! High threshold reactions are not broadened.  the total and
   ! nonelastic are reconstructed to equal the sum of parts.
   !
   ! The output energy grid for broadened cross sections is
   ! constructed adaptively (as in reconr) so that the results
   ! represent the true function within the given tolerance.
   ! Energy values are either removed from the original grid, or
   ! new values are added between the original points.  Thus, a
   ! given energy range can have more or fewer points than the
   ! original energy grid.
   !
   ! For high temperatures and low energies where the original
   ! SIGMA1 breaks down, a new direct expansion of the Doppler
   ! integral is used.
   !
   ! If the temperature is close to 293.6 K (.0253 eV), broadr
   ! computes and displays thermal cross sections, Maxwellian
   ! integrals (one-group thermal cross sections), g-factors,
   ! integral ratios (eta, alpha), the K1 integral and the
   ! corresponding 1/v-equivalent, and resonance integrals.
   !
   ! The results are written out in pendf format with each
   ! temperature represented as a different MAT.  Dictionaries
   ! are corrected to reflect the effects of thinning.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1
   !    nendf    input endf tape (for thermal nubar only)
   !    nin      input pendf tape
   !    nout     output pendf tape
   ! card 2
   !    mat1     material to broadened and thinned
   !    ntemp2   number of final temperatures (default=1)
   !    istart   restart (0 no, 1 yes, default 0)
   !    istrap   bootstrap (0 no, 1 yes, default 0
   !    temp1    starting temperature from nin (default=0K)
   ! card 3
   !    errthn   fractional tolerance for thinning
   !    thnmax   max.energy for broadening and thinning
   !             (default = 0, but see comments below)
   !    errmax   fractional tolerance used when integral criterion
   !             is satisfied (same usage as in reconr)
   !             (errmax.ge.errthn, default=10*errthn)
   !    errint   parameter to control integral thinning
   !             (usage as in reconr) (default=errthn/20000)
   !             set very small to turn off integral thinning.
   !      (A good choice for the convergence parameters
   !       errthn, errmax, and errint is the same set of
   !       values used in reconr)
   ! card 4
   !    temp2    final temperatures (deg Kelvin)
   ! card 5
   !    mat1     next MAT number to be processed with these
   !             parameters.  Terminate with mat1=0.
   !
   !---input options------------------------------------------------
   !
   ! The output tape will contain the ntemp2 final temperatures
   ! specified.  It is necessary to have temp1.le.temp2(1).
   ! if temp2.eq.temp1, the data will be thinned only.
   !
   ! restart    Continue broadening an existing pendf tape.  All
   !            temperatures are copied through temp1.  Additional
   !            final temperatures are added by starting with the
   !            data at temp1.
   !
   ! bootstrap  If bootstrap is not requested, each final tempera-
   !            ture is generated by broadening directly from
   !            temp1 to temp2.  If bootstrap is requested, each
   !            final temperature is broadened from the preceding
   !            temperature.  This option is faster due to the
   !            thinning in the previous step.  However, errors
   !            accumulate.
   !
   ! thnmax     A possible upper limit for broadening and thinning.
   !            Beginning with NJOY2012.75, if the default thnmax
   !            value is used (default thnmax = 0):
   !            - (i) and there is a resolved resonance region we
   !              Doppler broaden to the top of that region.  any
   !              threshold reactions below this upper limit are also
   !              broadened, but any non-zero cross section for energies
   !              below the reaction threshold are zeroed.
   !            - (ii) and there is no resolved resonance region but
   !              there is an unresolved resonance region we Doppler
   !              broaden to the beginning of the urr.
   !            - (iii) and there are no resolved or unresolved
   !              resonance parameters, we broaden to the lessor of
   !              6.5 MeV or the first threshold energy.
   !
   !            As before, a negative value for thnmax forces the
   !            Doppler broadening upper limit to be abs(thnmax)
   !            irrespective of the other conditions.
   !
   !            Caution:  The magnitude of thnmax must be chosen to
   !            keep the number of broadenable reactions less than or
   !            equal to the maximum of ntt (160).
   !
   !-------------------------------------------------------------------
   use mainio  ! provides nsysi,nsyso,nsyse
   use util    ! provides openz,timer,error,mess,repoz,closz,loada,finda
   use endf    ! provides endf routines and variables
   use physics ! provides bk,pi
   ! internals
   integer::nwscr,nscr1,iold,inew,nendf,nin,nout,no
   integer::namax,istart,istrap,nb,nw,lnu,nwt,i,l1,iflag
   integer::mat1,ntemp2,idis,idnx,mt4br,kt,k,isave,it
   integer::ndim,nset,j,nxc,mf,mt,jjj,nwunr,nx,ncds
   integer::mt4i,llf,llc,ir,ip,ireac,nbo,nwo,nnn,j1
   integer::mt103,mt104,mt105,mt106,mt107,mpmin,mpmax
   integer::mdmin,mdmax,mtmin,mtmax,m3min,m3max,m4min,m4max
   integer::lrf,lrp,lru
   integer::loop
   integer::n,npp,itmp
   real(kr)::time,temp1,diff,test,thnmx,emin,temp,awr,enext
   real(kr)::sig,en,sun,tempin,break,enow,eone,tev,picon
   real(kr)::fint,cint,alint,etint,v1int,ssf,slf,ssc,slc
   real(kr)::elast,flast,fnul,sf,sc,ss,fnu,xnext,eresh
   real(kr)::ftev,ctev,fnow,ee
   real(kr)::tt(ntt+1)
   real(kr)::emax
   integer::mtr(ntt),mti(ntt)
   integer,dimension(:),allocatable::nppmt
   real(kr),dimension(:),allocatable::bufo,bufn
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::nutot
   real(kr),dimension(:),allocatable::unr
   real(kr),dimension(:),allocatable::b
   real(kr),dimension(:),allocatable::e
   real(kr),dimension(:),allocatable::temp2
   real(kr),dimension(:,:),allocatable::s
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::fact=.99999e0_kr
   real(kr),parameter::onemev=1.e6_kr
   real(kr),parameter::e6pt5=6.5e6_kr
   real(kr),parameter::tbreak=0.5e0_kr
   real(kr),parameter::big=9.e9_kr
   real(kr),parameter::step=1.01e0_kr
   real(kr),parameter::zero=0

   namax=15000000
   nwscr=2500
   nunr=0

   !--initialize and assign i/o units.
   nscr1=10
   iold=12
   inew=13
   call openz(-iold,1)
   call openz(-inew,1)

   !--read and display user input.
   call timer(time)
   write(nsyso,'(/&
     &'' broadr...doppler broadening of endf data'',&
     &28x,f8.1,''s'')') time
   write(nsyse,'(/'' broadr...'',59x,f8.1,''s'')') time
   read(nsysi,*) nendf,nin,nout
   if (nin.lt.0.and.nout.gt.0)&
      call error('broadr','nin and nout must be same mode.',' ')
   if (nin.gt.0.and.nout.lt.0)&
      call error('broadr','nin and nout must be same mode.',' ')
   if (nin.lt.0.and.nout.le.0) nscr1=-nscr1
   call openz(nin,0)
   call openz(nendf,0)
   call openz(nout,1)
   call openz(nscr1,1)
   istart=0
   istrap=0
   temp1=0
   ntemp2=1
   read(nsysi,*) mat1,ntemp2,istart,istrap,temp1
   thnmx=e6pt5
   errmax=0
   errint=0
   read(nsysi,*) errthn,thnmx,errmax,errint
   if (errmax.eq.zero) errmax=10*errthn
   if (errint.eq.zero) errint=errthn/20000
   allocate(temp2(ntemp2))
   read(nsysi,*) (temp2(i),i=1,ntemp2)
   thnmx=sigfig(thnmx,7,0)
   write(nsyso,'(/&
     &'' unit for input endf tape ............. '',i10/&
     &'' unit for input pendf tape ............ '',i10/&
     &'' unit for output pendf tape ........... '',i10/&
     &'' material to be processed ............. '',i10/&
     &'' number of final temperatures ......... '',i10/&
     &'' restart (0 no, 1 yes) ................ '',i10/&
     &'' bootstrap (0 no, 1 yes) .............. '',i10/&
     &'' starting material temperature ........ '',f10.1,''k''/&
     &'' thinning tolerance ................... '',f10.3/&
     &'' max. energy .......................... '',1p,e10.3/&
     &'' errmax for thinning .................. '',1p,e10.3/&
     &'' errint for thinning .................. '',1p,e10.3)')&
     nendf,nin,nout,mat1,ntemp2,istart,istrap,&
     temp1,errthn,thnmx,errmax,errint
   write(nsyso,'(&
     &'' final temperatures ................... '',1p,e10.3/&
     &(40x,e10.3))') (temp2(i),i=1,ntemp2)

   !--allocate storage.
   allocate(scr(nwscr))
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))

   loop=0
  110 continue
   !--search input endf tape for some parameters ...
   !  - maximum file energy, emax.
   !  - total nu-bar (mf1/mt452).
   !  - resonance flag, lru (from mf2/mt151).
   call repoz(nendf)
   call tpidio(nendf,0,0,scr,nb,nw)
   call findf(mat1,1,0,nendf)
   !--read input file emax and make sure thnmx is legal
   emax=20.e6_kr !assumed maximum energy
   call contio(nendf,0,0,scr,nb,nw) !first record
   lrp=l1h
   call contio(nendf,0,0,scr,nb,nw) !second record
   if (n1h.eq.0.and.n2h.ne.0) then
      call contio(nendf,0,0,scr,nb,nw)
      if (c2h.gt.zero) emax=c2h
   endif
   if (abs(thnmx).gt.emax) then
       thnmx=0.9999_kr*emax
       call mess('broadr','reset thnmx to just less than input file''s emax','')
   endif
   !--jump to the end of mf1/mt451
   call tosend(nendf,0,0,scr)
   !--read input file nu-bar, if present
   lnu=0
  101 continue
   call contio(nendf,0,0,scr,nb,nw)
   if (mfh.ne.1) go to 107
   if (mth.ne.452) go to 106
   lnu=l2h
   if (lnu.eq.2) go to 103
   call listio(nendf,0,0,scr,nb,nw)
   nw=6+n1h
   allocate(nutot(nw))
   do i=1,nw
      nutot(i)=scr(i)
   enddo
   go to 107
  103 continue
   call tab1io(nendf,0,0,scr,nb,nw)
   nwt=6+2*n1h+2*n2h
   allocate(nutot(nwt))
   l1=1
  104 continue
   do i=1,nw
      nutot(l1+i-1)=scr(i)
   enddo
   if (nb.eq.0) go to 107
   l1=l1+nw
   call moreio(nendf,0,0,nutot(l1),nb,nw)
   go to 104
  106 continue
   call tosend(nendf,0,0,scr)
   go to 101
  107 continue
   !--read the (lru) resonance flag
   lrf=0
   npp=0
   if (lrp.eq.0) then
      lru=0
   else
      if (mfh.le.1) then
         if (mfh.eq. 1) call tofend(nendf,0,0,scr)
         call contio(nendf,0,0,scr,nb,nw)
      endif
      if (mfh.eq.2) then
         call contio(nendf,0,0,scr,nb,nw)
         call contio(nendf,0,0,scr,nb,nw)
         lru=l1h
         lrf=l2h
         !--make a list of the lrf7 mt's
         if (lru.eq.1.and.lrf.eq.7) then
            call contio(nendf,0,0,scr,nb,nw)
            call listio(nendf,0,0,scr,nb,nw)
            npp=l1h
            if (allocated(nppmt)) deallocate(nppmt)
            allocate(nppmt(npp))
            do i=1,npp
               nppmt(i)=nint(scr(16+12*(i-1)))
            enddo
            !--sort the nppmt list into ascending order
            if (npp.ge.2) then
               do i=1,npp-1
                  do j=i+1,npp
                     if (nppmt(j).lt.nppmt(i)) then
                        itmp=nppmt(i)
                        nppmt(i)=nppmt(j)
                        nppmt(j)=itmp
                     endif
                  enddo
               enddo
            endif
         endif
      endif
   endif

   !--search for desired mat1 at temp1 on input tape.
   !--if restart is requested, copy all t.le.temp1 to output tape.
   if (loop.eq.0) then
      nsh=0
      call repoz(nin)
      call repoz(nout)
      call tpidio(nin,nout,0,scr,nb,nw)
   endif
  115 continue
   call contio(nin,0,0,scr,nb,nw)
   if (math.eq.-1) go to 120
   if (math.eq.mat1) go to 130
   call tomend(nin,0,0,scr)
   go to 115
  120 continue
   call mess('broadr','desired mat and temp not on tape',' ')
   go to 400
  130 continue
   no=0
   nsc=0
   thnmax=thnmx
   eresh=thnmax
   emin=1
   if (thnmax.lt.zero) emin=-thnmax
   call repoz(nscr1)
   if (istart.eq.1) no=nout
   call contio(0,no,nscr1,scr,nb,nw)
   nx=n2h
   call contio(nin,0,0,scr,nb,nw)
   if (n1h.ne.0) then
      iverf=4
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   write(nsyso,'(/'' files are in endf-'',i1,'' format'')') iverf
   call skiprz(nin,-1)
   if (iverf.ge.5) call contio(nin,no,nscr1,scr,nb,nw)
   if (iverf.ge.6) call contio(nin,no,nscr1,scr,nb,nw)
   call hdatio(nin,no,nscr1,scr,nb,nw)
   temp=scr(1)
   if (iverf.ne.4) nx=n2h
   if (no.ne.0) write(nsyso,'(/&
     &'' output '',1p,e12.4,''k from restart'')') temp
   do while (nb.ne.0)
      call moreio(nin,no,nscr1,scr,nb,nw)
   enddo
   call dictio(nin,no,nscr1,scr,nb,nx)
   nwunr=1
   do i=1,nx,6
      mf=nint(scr(i+2))
      mt=nint(scr(i+3))
      ncds=nint(scr(i+4))
      if (mf.eq.2.and.mt.eq.152) then
         nwunr=6*ncds
      endif
   enddo
   call tofend(nin,no,nscr1,scr)
   if (allocated(unr)) deallocate(unr)
   allocate(unr(nwunr))
   call contio(nin,no,nscr1,scr,nb,nw)
   if (mfh.eq.2) then
      call contio(nin,no,nscr1,scr,nb,nw)
      call contio(nin,no,nscr1,scr,nb,nw)
      eresh=c2h
      call tosend(nin,no,nscr1,scr)
      call contio(nin,no,nscr1,scr,nb,nw)
      if (mfh.ne.0) then
         if (mth.eq.152) call stounx(nin,no,nscr1,unr,thnmax)
         call tofend(nin,no,nscr1,scr)
      endif
      call contio(nin,no,nscr1,scr,nb,nw)
   endif
   call tomend(nin,no,nscr1,scr)
   diff=abs(temp-temp1)
   test=1+temp1/1000
   if (diff.gt.test) go to 115

   if (lrp.eq.0) then
      write(nsyso,'(/'' non-resonance nuclide, input pendf limit'',5x,&
                   &''= '',1pe14.5,'' eV.'')')eresh
   elseif (lrp.eq.1.and.lru.eq.1) then
      write(nsyso,'(/'' resolved resonance range upper limit'',9x,&
                   &''= '',1pe14.5,'' eV.'')')eresh
   elseif (lrp.eq.1.and.lru.eq.2) then
      write(nsyso,'(/'' unresolved resonance range lower limit'',7x,&
                   &''= '',1pe14.5,'' eV.'')')eresh
   endif
   if (eresh.gt.e6pt5) then
      eresh=e6pt5
      write(nsyso,'('' - reset to '',1pe14.5,'' eV.'')')e6pt5
   endif
   if (thnmx.eq.0) then
      thnmax=eresh
   elseif (thnmx.gt.0) then
      thnmax=min(thnmx,eresh)
   endif
   if (lrp.eq.1) emin=eresh

   !--copy low threshold reactions from nscr1 to
   !--scratch storage using the grid of mt1.
   call repoz(nscr1)
   call tofend(nscr1,0,0,scr)
   call contio(nscr1,0,0,scr,nb,nw)
   call contio(nscr1,0,0,scr,nb,nw)
   call contio(nscr1,0,0,scr,nb,nw)
   if (c2h.lt.thnmax) thnmax=c2h
   call tofend(nscr1,0,0,scr)
   call contio(nscr1,0,0,scr,nb,nw)
   awr=c2h
   enow=0
   call gety1(enow,enext,idis,sig,nscr1,scr)
   nreac=0
   ntx=1
   n2in=0
   idnx=0
   mt4br=0
   mt103=0
   mt104=0
   mt105=0
   mt106=0
   mt107=0
   if (iverf.ge.6) then
       mpmin=600
       mpmax=649
       mdmin=650
       mdmax=699
       mtmin=700
       mtmax=749
       m3min=750
       m3max=799
       m4min=800
       m4max=849
   else
       mpmin=700
       mpmax=718
       mdmin=720
       mdmax=738
       mtmin=740
       mtmax=758
       m3min=760
       m3max=768
       m4min=780
       m4max=798
   endif
   enow=enext
   do while (enext.lt.big)
      n2in=n2in+1
      if (idnx.gt.0.and.enext*fact.gt.enow) enext=enext*fact
      enow=enext
      call gety1(enow,enext,idis,sig,nscr1,scr)
      call getunx(mth,enow,en,sun,unr)
      if (en.gt.zero) sig=sig-sun
      tt(1)=enow
      kt=n2in
      if (enext.ge.big) kt=-kt
      call loada(kt,tt,ntx,iold,bufo,nbuf)
      if (idis.gt.0) idnx=1-idnx
      if (idis.eq.0) idnx=0
   enddo
   call tosend(nscr1,0,0,scr)
   n=1
  160 continue
   call contio(nscr1,0,0,scr,nb,nw)
   if (mfh.eq.0) go to 190
   if (iverf.lt.6) then
      if (mth.gt.150) go to 165
   else
      if (mth.gt.200.and.mth.lt.600) go to 165
      if (mth.gt.850) go to 165
   endif
   if (mth.eq.3) go to 165
   if (mth.eq.4) go to 165
   if (mth.ge.46.and.mth.le.49) go to 165
   if (mth.eq.19) go to 165
   enow=0
   call gety1(enow,enext,idis,sig,nscr1,scr)
   if (mth.eq.18) go to 170
   if (allocated(nppmt)) then
      if (n.le.npp) then
        if(mth.eq.nppmt(n)) then
           n=n+1
           go to 170
        endif
      endif
   endif
   if (enext.le.emin) go to 170
   if (lrp.eq.1.and.enext.lt.eresh) go to 170
   if (lrp.eq.0) then
      if (fact*enext.lt.thnmax) thnmax=fact*enext
   endif
  165 continue
   call tosend(nscr1,0,0,scr)
   go to 160
  170 continue
   nreac=nreac+1
   if (nreac.ge.ntt)&
      call error('broadr','too many low-threshold reactions.',' ')
   ntx=nreac+1
   mtr(nreac)=mth
   if (mth.ge.51.and.mth.le.91) mt4br=1
   if (mth.eq.103) mt103=1
   if (mth.eq.104) mt104=1
   if (mth.eq.105) mt105=1
   if (mth.eq.106) mt106=1
   if (mth.eq.107) mt107=1
   mti(nreac)=0
   kt=1
   k=0
   do while (kt.gt.0)
      k=k+1
      call finda(k,tt,nreac,iold,bufo,nbuf)
      enow=tt(1)
      call gety1(enow,enext,idis,sig,nscr1,scr)
      call getunx(mth,enow,en,sun,unr)
      if (en.gt.zero) sig=sig-sun
      tt(1+nreac)=sig
      kt=k
      if (k.eq.n2in) kt=-k
      call loada(kt,tt,ntx,inew,bufn,nbuf)
   enddo
   call tosend(nscr1,0,0,scr)
   isave=iold
   iold=inew
   inew=isave
   go to 160
  190 continue
   if (thnmax.eq.zero.and.thnmx.eq.0) thnmax=e6pt5
   if (allocated(nppmt)) deallocate(nppmt)
   if (thnmax.lt.zero) thnmax=-thnmax
   write(nsyso,'(/&
     &'' final maximum energy for broadening/thinning = '',1pe14.5,&
     &'' eV'')')thnmax
   tempin=temp1
   if (nreac.gt.0) go to 200
   call mess('broadr','no broadenable reactions',' ')
   it=0
  195 continue
   it=it+1
   tempk=temp2(it)
   write(nsyso,'('' copied mat'',i4,'' from'',1p,e12.4,&
     &'' to'',e12.4,'' k'')') mat1,tempin,tempk
   go to 215

   !--assign storage for paging cross sections.
  200 continue
   nw=npage+50
   allocate(b(nw))
   mpage=namax/(4*(nreac+1))
   ndim=3*mpage
   allocate(e(ndim))
   allocate(s(nreac,ndim))

   !--get q-values and lab system threshold energy
   !  for the mt's to be broadened.
   call repoz(nscr1)
   do i=1,nreac
      call findf(mat1,3,mtr(i),nscr1)
      call contio(nscr1,0,0,scr,nb,nw)
      call contio(nscr1,0,0,scr,nb,nw)
      qmtr(i)=scr(2)
      if (qmtr(i).eq.0) then
         emtr(i)=0
      else
         emtr(i)=-qmtr(i)*(awr+1)/awr
      endif
   enddo

   !--doppler broaden and thin these reactions.
   it=0
   tempin=temp1
  210 continue
   it=it+1
   tempk=temp2(it)
   tempef=tempk-tempin
   if (tempef.gt.zero) alpha=awr/(bk*tempef)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s'')') time
   break=9999
   if (ntemp2.gt.1.and.tempk.lt.break) then
      write(nsyse,'(f11.1,'' deg'',54x,f8.1,''s'')') tempk,time
   else if (ntemp2.gt.1) then
      write(nsyse,'(1p,e11.3,'' deg ('',e9.3,'' eV)'',39x,&
        &0p,f8.1,''s'')') tempk,bk*tempk,time
   endif
   call bfile3(iold,inew,bufo,bufn,e,s,nreac)
   write(nsyso,'(/'' broadened mat'',i4,'' from'',1p,e12.4,&
     &'' to'',e12.4,'' k''/9x,''points in='',i7,&
     &''  points out='',i7/9x,''mt'',16i4,(/11x,16i4))')&
     mat1,tempin,tempk,n2in,n2out,(mtr(i),i=1,nreac)
   nset=0
   j=0
   do while (nset.lt.nreac)
      j=j+1
      call finda(j,tt,ntx,inew,bufn,nbuf)
      nset=0
      do k=1,nreac
         if (j.eq.1) mti(k)=0
         if (mti(k).eq.0.and.tt(1+k).gt.zero) mti(k)=j
         if (mti(k).gt.0) nset=nset+1
      enddo
   enddo

   !--correct dictionary to reflect thinning.
  215 continue
   call repoz(nscr1)
   call contio(nscr1,nout,0,scr,nb,nw)
   nxc=n2h
   if (iverf.ge.5) call contio(nscr1,nout,0,scr,nb,nw)
   if (iverf.eq.6) call contio(nscr1,nout,0,scr,nb,nw)
   call hdatio(nscr1,0,0,scr,nb,nw)
   if (iverf.ne.4) nxc=n2h
   scr(1)=tempk
   call hdatio(0,nout,0,scr,nb,nw)
   do while (nb.ne.0)
      call moreio(nscr1,nout,0,scr,nb,nw)
   enddo
   nw=nxc
   if (nxc*6.gt.nwscr) call error('broadr','storage exceeded.',' ')
   call dictio(nscr1,0,0,scr,nb,nw)
   if (nreac.ne.0) then
      do i=1,nw,6
         mf=nint(scr(i+2))
         if (mf.eq.3) then
            mt=nint(scr(i+3))
            if (mt.eq.1.or.mt.eq.3.or.mt.eq.19) then
               scr(i+4)=3+int((n2out+2)/3)
            endif
            if (mt.eq.4.and.mt4br.ne.0) then
               do j=1,nreac
                  jjj=mti(j)
                  if (jjj.gt.1) jjj=jjj-1
                  if (mtr(j).eq.51) mt4i=jjj
               enddo
               scr(i+4)=3+int((n2out-mt4i+3)/3)
            endif
            do j=1,nreac
               jjj=mti(j)
               if (jjj.gt.1) jjj=jjj-1
               if (mt.eq.mtr(j)) scr(i+4)=3+int((n2out-jjj+3)/3)
            enddo
         endif
      enddo
   endif
   nw=nxc
   call dictio(0,nout,0,scr,nb,nw)
   call tofend(nscr1,nout,0,scr)

   !--write out thermal quantities if t is close to 293.6 Kelvin.
   eone=tbreak
   tev=tempk*bk
   if (abs(tev-therm).gt.therm/1000) go to 240
   write(nsyso,'(/''    thermal quantities at'',f6.1,'' K ='',&
     &f7.4,'' eV''/&
     &''    -----------------------------------------'')')&
     tempk,tev
   picon=2/sqrt(pi)
   llf=0
   llc=0
   sc=0
   sf=0
   do j=1,nreac
      if (mtr(j).eq.18) llf=j+1
      if (mtr(j).eq.102) llc=j+1
   enddo
   fint=0
   cint=0
   alint=0
   etint=0
   v1int=0
   ssf=0
   slf=0
   ssc=0
   slc=0
   elast=0
   flast=0
   fnul=0
   j=0
  220 continue
   j=j+1
   call finda(j,tt,ntx,inew,bufn,nbuf)
  225 continue
   enow=tt(1)
   if (enow.gt.step*elast.and.elast.gt.zero) then
      enow=step*elast
      if (llf.gt.0) sf=slf+(tt(llf)-slf)*(enow-elast)/(tt(1)-elast)
      if (llc.gt.0) sc=slc+(tt(llc)-slc)*(enow-elast)/(tt(1)-elast)
   else
      if (llf.gt.0) sf=tt(llf)
      if (llc.gt.0) sc=tt(llc)
   endif
   ! thermal cross sections at 0.0253 eV
   ctev=0
   if (elast.lt.therm.and.enow.ge.therm) then
      if (llf.gt.0) then
         ss=slf+(therm-elast)*(sf-slf)/(enow-elast)
         write(nsyso,'(&
           &''           thermal fission xsec:'',1p,e12.4)') ss
         if (lnu.eq.1) then
            fnu=nutot(7)
         else
            ir=1
            ip=2
            call terpa(fnu,therm,xnext,idis,nutot,ip,ir)
         endif
         write(nsyso,'(&
           &''          thermal fission nubar:'',1p,e12.4)') fnu
      endif
      if (llc.gt.0) then
         ss=slc+(therm-elast)*(sc-slc)/(enow-elast)
         write(nsyso,'(&
           &''           thermal capture xsec:'',1p,e12.4)') ss
      endif
   endif
   ! thermal cross sections at tev
   ctev=zero
   if (elast.lt.tev.and.enow.ge.tev) then
      if (llf.gt.0) then
         ss=slf+(tev-elast)*(sf-slf)/(enow-elast)
         ftev=ss
         if (lnu.eq.1) then
            fnu=nutot(7)
         else
            ir=1
            ip=2
            call terpa(fnu,tev,xnext,idis,nutot,ip,ir)
         endif
      endif
      if (llc.gt.0) then
         ss=slc+(tev-elast)*(sc-slc)/(enow-elast)
         ctev=ss
      endif
   endif
   ! fission nubar at this energy
   fnu=0
   if (llf.gt.0) then
      if (lnu.eq.1) then
         fnu=nutot(7)
      else
         ir=1
         ip=2
         call terpa(fnu,enow,xnext,idis,nutot,ip,ir)
      endif
   endif
   ! thermal integrals
   break=1
   if (enow.lt.break) then
      fnow=enow*exp(-enow/tev)
      if (llc.gt.0) then
         if (j.gt.1) then
            cint=cint+(fnow*sc+flast*slc)*(enow-elast)/2
         endif
      endif
      if (llf.gt.0) then
         if (j.gt.1) then
            fint=fint+(fnow*sf+flast*slf)*(enow-elast)/2
            if (sf.gt.zero.and.slf.gt.zero)&
              alint=alint+(fnow*sc/sf+flast*slc/slf)&
              *(enow-elast)/2
            if ((slf+slc).ne.0.and.(sf+sc).ne.0)&
              etint=etint+(fnow*fnu*sf/(sf+sc)&
              +flast*fnul*slf/(slf+slc))*(enow-elast)/2
            v1int=v1int+(fnow*(fnu*sf-sf-sc)&
              +flast*(fnul*slf-slf-slc))*(enow-elast)/2
         endif
      endif
      flast=fnow
   endif
   ! resonance integrals
   if (elast.lt.eone.and.enow.ge.eone) then
      if (llf.gt.0) then
         ss=slf+(eone-elast)*(sf-slf)/(enow-elast)
         ssf=(sf/enow+ss/elast)*(enow-eone)/2
      endif
      if (llc.gt.0) then
         ss=slc+(eone-elast)*(sc-slc)/(enow-elast)
         ssc=(sc/enow+ss/elast)*(enow-eone)/2
      endif
   endif
   if (elast.ge.eone) then
      if (llf.gt.0) ssf=ssf+(sf/enow+slf/elast)*(enow-elast)/2
      if (llc.gt.0) ssc=ssc+(sc/enow+slc/elast)*(enow-elast)/2
   endif
   ! continue the energy loop
   elast=enow
   fnul=fnu
   if (llf.gt.0) slf=sf
   if (llc.gt.0) slc=sc
   if (enow.lt.tt(1)) go to 225
   if (j.ge.n2out) go to 230
   go to 220
   ! print out the results
  230 continue
   cint=cint/tev**2
   write(nsyso,'(&
     &''       thermal capture integral:'',1p,e12.4)') cint
   if (ctev.ne.zero) write(nsyso,'(&
     &''       thermal capture g-factor:'',1p,e12.4)')&
     picon*cint/ctev
   write(nsyso,'(&
     &''     capture resonance integral:'',1p,e12.4)') ssc
   if (llf.gt.0) then
      fint=fint/tev**2
      alint=alint/tev**2
      etint=etint/tev**2
      v1int=v1int/tev**2
      write(nsyso,'(&
        &''       thermal fission integral:'',1p,e12.4)') fint
      if (ftev.ne.zero) write(nsyso,'(&
        &''       thermal fission g-factor:'',1p,e12.4)')&
        picon*fint/ftev
      write(nsyso,'(&
        &''         thermal alpha integral:'',1p,e12.4)') alint
      write(nsyso,'(&
        &''           thermal eta integral:'',1p,e12.4)') etint
      write(nsyso,'(&
        &''            thermal k1 integral:'',1p,e12.4)') v1int
      write(nsyso,'(&
        &''                  equivalent k1:'',1p,e12.4)')&
      picon*v1int
      write(nsyso,'(&
        &''     fission resonance integral:'',1p,e12.4)') ssf
   endif
   write(nsyso,&
     '(''    -----------------------------------------'')')
  240 continue

   !--output the broadened cross sections in endf format.
  245 continue
   call contio(nscr1,nout,0,scr,nb,nw)
   if (mfh.eq.0) go to 320
   if (mfh.eq.3) go to 250
   if (mfh.eq.2.and.mth.eq.152) go to 247
   call tosend(nscr1,nout,0,scr)
   call contio(nscr1,nout,0,scr,nb,nw)
   if (mfh.eq.0) go to 245
   ! update unresolved temperature
  247 continue
   call listio(nscr1,0,0,scr,nb,nw)
   scr(1)=tempk
   call listio(0,nout,0,scr,nb,nw)
   call tofend(nscr1,nout,0,scr)
   go to 245
  250 continue
   ireac=0
   if (nreac.eq.0) go to 260
   if (mth.eq.1) go to 275
   if (mth.eq.3) go to 275
   if (mth.eq.4.and.mt4br.eq.1) go to 275
   if (mth.ge.46.and.mth.le.49) go to 275
   if (mth.eq.19) go to 275
   do i=1,nreac
      if (mth.eq.mtr(i)) ireac=i
   enddo
  260 continue
   if (ireac.gt.0) go to 275
   ! this section wasnt broadened or thinned.
   ! copy it to output.
   call tab1io(nscr1,0,0,scr,nb,nw)
   nbo=nb
   nwo=nw
   call tab1io(0,nout,0,scr,nbo,nwo)
   do while (nb.ne.0)
      call moreio(nscr1,nout,0,scr,nb,nw)
   enddo
   go to 310
   ! this section was broadened and thinned.
   ! construct a new tab1 structure for the reaction.
   ! use the original total cross section above thnmax.
   ! use the original non-elastic cross section above thnmax.
  275 continue
   ee=0
   call gety1(ee,enext,idis,sig,nscr1,b)
   jjj=1
   do j=1,nreac
      if (mth.eq.mtr(j)) jjj=mti(j)
      if (mth.eq.4.and.mtr(j).eq.51) jjj=mti(j)
      if (mth.eq.4.and.jjj.eq.1.and.mtr(j).eq.91) jjj=mti(j)
   enddo
   if (jjj.gt.1) jjj=jjj-1
   nnn=n2out-jjj+1
   scr(1)=c1h
   scr(2)=c2h
   scr(3)=l1h
   scr(4)=l2h
   scr(5)=1
   scr(6)=nnn
   scr(7)=nnn
   scr(8)=2
   k=8
   j1=npage/2
   j=0
  305 continue
   j=j+1
   call finda(j,tt,ntx,inew,bufn,nbuf)
   if (j.lt.jjj) go to 305
   k=k+1
   scr(k)=tt(1)
   k=k+1
   if (ireac.ne.0) then
      scr(k)=tt(1+ireac)
      call getunx(mth,scr(k-1),en,sun,unr)
      if (en.gt.zero) scr(k)=scr(k)+sun
   else
      if (tt(1).gt.thnmax) then
         call gety1(tt(1),enext,idis,scr(k),nscr1,b)
      else
         scr(k)=0
         do i=1,nreac
            iflag=0
            if (mth.eq.3) then
              if (mtr(i).eq.2) iflag=1
            endif
            if (mth.eq.4) then
              if(mtr(i).lt.51.or.mtr(i).gt.91) iflag=1
            endif
            if (mth.eq.19) then
              if (mtr(i).ne.18) iflag=1
            endif
            if (mth.ge.46.and.mth.le.49) then
              if (mtr(i).ne.mth-40) iflag=1
            endif
            if (mth.ge.201) iflag=1
            ! Don't include partial xs if its sum is already available
            if (mt103.eq.1) then
              if (mtr(i).ge.mpmin.and.mtr(i).le.mpmax) iflag=1
            endif
            if (mt104.eq.1) then
              if (mtr(i).ge.mdmin.and.mtr(i).le.mdmax) iflag=1
            endif
            if (mt105.eq.1) then
              if (mtr(i).ge.mtmin.and.mtr(i).le.mtmax) iflag=1
            endif
            if (mt106.eq.1) then
              if (mtr(i).ge.m3min.and.mtr(i).le.m3max) iflag=1
            endif
            if (mt107.eq.1) then
              if (mtr(i).ge.m4min.and.mtr(i).le.m4max) iflag=1
            endif
            if (iflag.eq.0) scr(k)=scr(k)+tt(1+i)
         enddo
         call getunx(1,tt(1),en,sun,unr)
         if (en.gt.zero) scr(k)=scr(k)+sun
      endif
   endif
   scr(k)=sigfig(scr(k),7,0)
   if (j-jjj+1.gt.j1) go to 300
   if (j-jjj+1.lt.j1.and.j.ne.n2out) go to 305
   nw=k
   call tab1io(0,nout,0,scr,nb,nw)
   k=0
   if (j.lt.n2out) go to 305
   go to 310
  300 continue
   if (k.ne.npage.and.j.ne.n2out) go to 305
   nw=k
   call moreio(0,nout,0,scr,nb,nw)
   k=0
   if (j.lt.n2out) go to 305
  310 continue
   call tosend(nscr1,0,0,scr)
   call asend(nout,0)
   go to 245
  320 continue
   call tomend(nscr1,nout,0,scr)

   !--loop over requested final temperatures.  if bootstrap was
   !--requested, interchange the old and new scratch units.
   if (it.eq.ntemp2) go to 400
   if (istrap.ne.0) then
      isave=iold
      iold=inew
      inew=isave
      n2in=n2out
      tempin=tempk
   endif
   if (nreac.eq.0) go to 195
   go to 210

   !--loop over desired materials.
  400 continue
   read(nsysi,*) mat1
   if (mat1.eq.0) go to 410
   if (nreac.gt.0) then
      deallocate(b)
      deallocate(e)
      deallocate(s)
   endif
   if (nwunr.gt.0) deallocate(unr)
   if (lnu.gt.0) deallocate(nutot)
   if (allocated(nutot)) deallocate(nutot)
   loop=loop+1
   go to 110

   !--broadr is finished
  410 continue
   deallocate(temp2)
   call atend(nout,0)
   call repoz(nout)
   call repoz(nin)
   call closz(nin)
   call closz(nendf)
   call closz(nout)
   call closz(-iold)
   call closz(-inew)
   call closz(nscr1)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine broadr

   subroutine stounx(nin,nout,nscr,unr,thnmax)
   !-------------------------------------------------------------------
   ! Store unresolved cross sections from MF2/MT152 (if present)
   ! for later retrieval using getunx.  The energy range is chosen
   ! for retrieval in the region of resolved-unresolved overlap only.
   !-------------------------------------------------------------------
   use util ! provides mess
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   real(kr)::thnmax,unr(*)
   ! internals
   integer::l,nx,k,j,np,nb,nw,i
   real(kr)::e
   real(kr),parameter::zero=0

   !--read in the data
   nunr=0
   intunr=n2h
   l=1
   call listio(nin,0,0,unr(l),nb,nw)
   nx=nint(unr(l+2))
   nsig0=nint(unr(l+3))
   ncyc=1+nx*nsig0
   nunr=n2h
   do while (nb.ne.0)
      l=l+nw
      call moreio(nin,0,0,unr(l),nb,nw)
   enddo

   !--squeeze out sigmazero data if present
   if (nsig0.gt.1) then
      call mess('stounx','sigma zero data removed from unresolved',&
        &'regenerate it if needed.')
      l=8
      k=l+nsig0-1
      do i=1,nunr
         unr(l)=unr(k)
         l=l+1
         k=k+nsig0
         do j=1,nx
            unr(l)=unr(k)
            l=l+1
            k=k+nsig0
         enddo
      enddo
      nsig0=1
      ncyc=1+nx*nsig0
      np=6+nsig0+nunr*(1+nx)
      unr(4)=nsig0
      unr(6)=np
   endif

   !--write mt152 to output files
   l=1
   call listio(0,nout,nscr,unr(l),nb,nw)
   do while (nb.ne.0)
      l=l+nw
      call moreio(0,nout,nscr,unr(l),nb,nw)
   enddo
   l=7+nsig0
   do i=1,nunr
      e=unr(l)
      if (i.eq.1) e1=abs(e)
      if (i.eq.1.or.e.lt.zero) eumax=abs(e)
      if (e.lt.zero) unr(l)=-e
      l=l+ncyc
   enddo
   if (thnmax.gt.0.and.eumax.lt.thnmax) thnmax=eumax
   if (eumax.gt.e1) return

   !--no overlap.  unresolved not needed.
   nunr=0
   return
   end subroutine stounx

   subroutine getunx(mt,e,enext,sun,unr)
   !-------------------------------------------------------------------
   ! Retrieve infinitely dilute unresolved cross section from MT152
   ! data (if present).  enext=-1 means that there is no unresolved
   ! data at this energy.
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   integer::mt,i
   real(kr)::e,enext,sun,unr(*)
   ! internals
   integer::ix,ibase,lim,loc,loc1
   real(kr),parameter::up=1.00001e0_kr

   enext=-1
   sun=0
   if (nunr.eq.0) return
   if (e.lt.e1) return
   if (e.gt.eumax) return
   ix=0
   if (mt.eq.1) ix=1
   if (mt.eq.2) ix=2
   if (mt.eq.18.or.mt.eq.19) ix=3
   if (mt.eq.102) ix=4
   if (ix.eq.0) return
   ibase=7+nsig0
   lim=nunr-1
   do i=1,lim
      loc=ibase+(i-1)*ncyc
      loc1=loc+ncyc
      if (e.ge.unr(loc).and.e.lt.unr(loc1))&
         call terp1(unr(loc),unr(loc+ix),unr(loc1),unr(loc1+ix),&
           e,sun,intunr)
   enddo
   if (sun.eq.0) then
      sun=unr(loc1+ix)
      enext=eumax*up
   else
      enext=unr(loc1+1)
   endif
   return
   end subroutine getunx

   subroutine bfile3(iold,inew,bufo,bufn,e,s,nx)
   !-------------------------------------------------------------------
   ! This routine manages the paging of cross section data.  At
   ! any time, there are three pages of data in memory.  Doppler
   ! broadening or thinning is performed for energies on the
   ! middle page.  When the range of energies on this page is
   ! exceeded, The top two pages are moved down, and new data
   ! is read into the top page.  This process continues until
   ! the energy thnmax is reached.  The rest of the data are
   ! simply copied.
   !-------------------------------------------------------------------
   use util ! provides finda
   ! externals
   integer::iold,inew,nx
   real(kr)::bufo(*),bufn(*),e(*),s(nx,*)
   ! internals
   integer::nj,l,k,i,nw,kk
   real(kr)::tt(ntt+1)
   real(kr),parameter::zero=0

   !--set broadening indices to middle page
   n2left=n2in
   nlow=mpage+1
   nhigh=2*mpage
   if (n2left.lt.mpage) nhigh=nlow+n2left-1
   ! set index to loaded points at beginning of middle page
   klow=nlow
   ! set indices to load middle and last pages
   mlow=nlow
   mhigh=3*mpage
   ! set output index for first point
   nj=0
   l=0

   !--load desired points
  110 continue
   if (n2left.lt.mhigh-mlow+1) mhigh=mlow+n2left-1
   do k=mlow,mhigh
      l=l+1
      call finda(l,tt,ntx,iold,bufo,nbuf)
      e(k)=tt(1)
      do i=1,nreac
         s(i,k)=tt(i+1)
      enddo
   enddo
   ! set index to loaded points to last point loaded
   khigh=mhigh
   ! calculate no. of points left to read
   n2left=n2left-(mhigh-mlow+1)

   !--broaden or thin points in middle page
  120 continue
   if (tempef.gt.zero) then
      call broadn(nj,inew,bufn,e,s,nreac)
   else
      call thinb(nj,inew,bufn,e,s,nreac)
   endif

   !--has last point been broadened or thinned.
   if (nj.lt.0) go to 150

   !--shift remaining unbroadened points one page forward
   nw=khigh-nlow+1
   kk=nw
   do k=1,nw
      e(k)=e(nlow+k-1)
      do i=1,nreac
         s(i,k)=s(i,nlow+k-1)
      enddo
   enddo
   ! set index to loaded points to beginning of table
   klow=1
   ! set index to next available location for loading
   mlow=kk+1

   ! are there any more points to read
   if (n2left.gt.0) go to 110
   ! no.  set index to last loaded point
   khigh=kk
   ! set index to broaden all remaining points
   nhigh=khigh
   mhigh=khigh
   go to 120

   !--finished...entire table broadened
  150 continue
   n2out=-nj
   return
   end subroutine bfile3

   subroutine broadn(j,inew,bufn,e,s,nx)
   !-------------------------------------------------------------------
   ! Given a cross section that is described by a table of
   ! x/s vs. e and linear-linear interpolation between points,
   ! this routine will exactly doppler broaden the cross
   ! section for the range of energies on the middle page.
   ! Paging parameters:
   !  klow  =index to first point loaded in core.
   !  khigh =index to last point loaded in core.
   !  nlow  =index to first point to broaden.
   !  nhigh =index to last point to broaden.
   !  mlow  =index to first point just loaded.
   !  mhigh =index to last point just loaded.
   !  e     =table of energies corresponding to s.
   !  s     =table of cross sections at initial temperature.
   !  alpha =doppler width (awr/(bk*tempef))
   ! On entry, the points just loaded (mlow to mhigh) are converted
   ! to velocity-like terms.  An iterative method is then used to
   ! compute the broadened cross sections for the range of energies
   ! in the middle page (nlow to nhigh) using the original data
   ! from all pages (klow to khigh).  As each new energy and set of
   ! broadened cross sections is found, it is written to scratch
   ! storage (j,inew,bufn).  After energy has reached thnmax,
   ! the rest of the current page is copied to scratch storage.
   ! The routine will broaden and thin up to ntt reactions
   ! simultaneously on a unionized and linearized grid which
   ! will represent the broadened function to the specified accuracy.
   ! In any given energy range, this grid may be finer or coarser
   ! than the original grid.  The final grid will usually have
   ! fewer points than the input grid due to the smoothing effect
   ! of Doppler broadening.  However, in some cases, points will
   ! be added to regions near sharp breaks or discontinuities,
   ! and the final grid may have more points than the input grid.
   !-------------------------------------------------------------------
   use util ! provides sigfig,loada
   ! externals
   integer::j,inew,nx
   real(kr)::bufn(*),e(*),s(nx,*)
   ! internals
   integer::n,k,klast,i,is,km,ndig
   real(kr)::et,dn,test,em,xm,dx,errt,errm,f,dy,est,si,xt,stot
   real(kr)::tt1old
   integer,parameter::nstack=12
   integer::ks(nstack),js(nstack)
   real(kr)::es(nstack),ss(ntt,nstack)
   real(kr)::tt(ntt+1),sn(ntt),dl(ntt)
   integer::nmax=10
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::one=1.e0_kr
   real(kr),parameter::estp=4.1e0_kr
   real(kr),parameter::half=.5e0_kr
   real(kr),parameter::small=1.e-9_kr
   real(kr),parameter::step=2.01e0_kr
   real(kr),parameter::rmax=3.0e0_kr
   real(kr),parameter::errmin=1.e-15_kr
   real(kr),parameter::trange=.4999e0_kr
   real(kr),parameter::ssmall=1.e-6_kr
   real(kr),parameter::tenth=1.e-1_kr
   real(kr),parameter::zero=0
   save ks,es,js,ss,tt,sn,dl

   !--convert energies just loaded to velocity-like terms
   if (mhigh.ge.mlow) then
      do n=mlow,mhigh
         e(n)=sqrt(alpha*e(n))
      enddo
   endif
   k=nlow
   klast=nlow-1

   !--set up first node in stack
   tt1old=zero
   if (klow.eq.1) go to 110
   klast=k
   ks(2)=k
   et=e(k)**2/alpha
   es(2)=sigfig(et,7,0)
   xt=sqrt(alpha*es(2))
   do i=1,nreac
      dn=s(i,k+1)-s(i,k)
      if (abs(dn).lt.abs(s(i,k))/1000) dn=0
      dl(i)=1
      if (dn.lt.zero) dl(i)=-1
   enddo
   call bsigma(k,xt,ss(1,2),e,s,nx)
   js(2)=0
   do i=1,nreac
      if (abs(ss(i,2)-s(i,k)).gt.errthn*s(i,k)) js(2)=1
   enddo
   k=k+1
   go to 120
  110 continue
   if (es(1).gt.thnmax) go to 190

   !--locate next node for stack
  120 continue
   et=e(k)**2/alpha
   if (et.ge.thnmax) go to 130
   if (k.ge.nhigh) go to 130
   test=sigfig(et,7,0)
   if (abs(es(2)-test).lt.small*test) go to 126
   if (k.gt.klast+nmax) go to 130
   if (et.gt.step*es(2)) go to 130
   test=sigfig(et,3,0)
   if (abs(et-test).lt.small*test) go to 130
   if (abs(et-therm).lt.small*therm) go to 130
   do 125 i=1,nreac
   dn=s(i,k+1)-s(i,k)
   if (abs(dn).lt.abs(s(i,k))/1000) dn=0
   if (dn.ge.zero) then
      dn=1
   else
      dn=-1
   endif
   if (dn.ne.dl(i)) go to 130
  125 continue
  126 continue
   k=k+1
   go to 120
  130 continue
   es(1)=sigfig(et,7,0)
   xt=sqrt(alpha*es(1))
   call bsigma(k,xt,ss(1,1),e,s,nx)
   ks(1)=k
   js(1)=0
   do i=1,nreac
      if (abs(ss(i,1)-s(i,k)).gt.errthn*s(i,k)) js(1)=1
   enddo

   !--add points between nodes if needed
   is=2
  140 continue
   if (is.ge.nstack) go to 150
   if (ks(is-1).eq.ks(is)+1) then
     if (js(is-1).eq.0) then
       if(js(is).eq.0) go to 150
     endif
   endif
   ! compare true function to linear approximation
   em=half*(es(is-1)+es(is))
   ndig=9
   if (em.gt.tenth.and.em.lt.one) ndig=8
   if (em.gt.sigfig(es(is),7,+1)) then
     if(em.lt.sigfig(es(is-1),7,-1)) then
       em=sigfig(em,7,0)
     endif
   else
      em=sigfig(em,ndig,0)
   endif
   km=0
   if (em.lt.sigfig(es(is),ndig,+1).or.&
     em.gt.sigfig(es(is-1),ndig,-1)) go to 150
   errt=errthn
   if (es(is-1).lt.trange) errt=errt/5
   errm=errmax
   if (es(is-1).lt.trange) errm=errm/5
   xm=sqrt(alpha*em)
   call bsigma(klast,xm,sn,e,s,nx)
   dx=es(is-1)-es(is)
   f=(em-es(is))/dx
   test=one-one/100
   if (f.gt.test) go to 170
   stot=zero
   do i=1,nreac
      stot=stot+sn(i)
   enddo
   do 145 i=1,nreac
   if (stot.lt. errmin) go to 145
   if (abs(sn(i)/stot).lt.ssmall) go to 145
   if (ss(i,is-1).gt.rmax*ss(i,is)) go to 170
   if (ss(i,is-1).lt.ss(i,is)/rmax) go to 170
   si=f*ss(i,is-1)+(1-f)*ss(i,is)
   dy=abs(sn(i)-si)
   if (dy.le.errt*abs(sn(i))+errmin) go to 145
   if (dy.gt.errm*abs(sn(i))+errmin) go to 170
   if (dy*dx/2.gt.errint*em) go to 170
  145 continue
   ! don't allow a big increase in the step size
   ! it may be a misconvergence
   est=estp*(es(is)-tt(1))
   if (j.gt.3.and.dx.gt.est) go to 170
   ! converged. store top point of stack.
  150 Continue
   tt(1)=es(is)
   do i=1,nreac
      if (tt(1).gt.emtr(i).and.tt1old.ge.emtr(i)) then
         tt(1+i)=ss(i,is)
      else
         tt(1+i)=0
      endif
   enddo
   tt1old=tt(1)
   j=j+1
   call loada(j,tt,ntx,inew,bufn,nbuf)
   is=is-1
   if (is.gt.1) go to 140
   ! stack exhausted.  get new node.
   es(2)=es(1)
   ks(2)=ks(1)
   js(2)=js(1)
   do i=1,nreac
      ss(i,2)=ss(i,1)
      dn=s(i,k+1)-s(i,k)
      if (abs(dn).lt.abs(s(i,k))/1000) dn=0
      if (dn.ge.zero) then
         dl(i)=1
      else
         dl(i)=-1
      endif
   enddo
   if (k.ge.nhigh) go to 180
   if (es(1).gt.thnmax) go to 190
   klast=k
   k=k+1
   go to 120
   ! not converged.  add midpoint to stack and continue.
  170 continue
   is=is+1
   es(is)=es(is-1)
   es(is-1)=em
   ks(is)=ks(is-1)
   ks(is-1)=km
   js(is)=js(is-1)
   js(is-1)=0
   if (km.eq.0) js(is-1)=1
   do i=1,nreac
      ss(i,is)=ss(i,is-1)
      ss(i,is-1)=sn(i)
      if (km.ne.0) then
         if (abs(sn(i)-s(i,km)).gt.errthn*s(i,km)+errmin) js(is-1)=1
      endif
   enddo
   go to 140
   ! finished with this page.
  180 continue
   ks(2)=nlow-1
   if (nhigh.lt.khigh) return
   ! copy energies above thnmax to output
   ! flag last point with minus.
  190 continue
   j=j+1
   et=e(k)**2/alpha
   tt(1)=et
   do i=1,nreac
      tt(1+i)=s(i,k)
   enddo
   if (k.eq.nhigh.and.khigh.eq.nhigh) j=-j
   call loada(j,tt,ntx,inew,bufn,nbuf)
   k=k+1
   if (k.le.nhigh) go to 190
   ks(2)=nlow-1
   return
   end subroutine broadn

   subroutine bsigma(kn,en,sn,e,s,nx)
   !-------------------------------------------------------------------
   ! Given tables of energies (e) and cross sections (s) with linear
   ! interpolation between points, this routine will exactly Doppler
   ! broaden the cross sections for an energy (en) in the middle
   ! page of the table.  If there is not sufficient data in the
   ! side pages to perform the doppler integral, an error message
   ! will be issued, and the calculation should be redone with a
   ! smaller temperature change.
   !-------------------------------------------------------------------
   use util ! provides mess
   use physics ! get global physics constants
   ! externals
   integer::kn,nx
   real(kr)::en
   real(kr)::sn(nx),e(*),s(nx,*)
   ! internals
   integer::khm1,i,k,ll,l
   real(kr)::aamin,denom,slope,factor,xp,xm
   real(kr)::sbt(ntt)
   character(60)::strng
   real(kr),dimension(5),parameter::fzero=(/0.5e0_kr,&
     1.e0_kr/(2.e0_kr*sqrt(pi)),0.25e0_kr,&
     1.e0_kr/(2.e0_kr*sqrt(pi)),0.375e0_kr/)
   real(kr),parameter::one=1.e0_kr
   real(kr),parameter::two=2.e0_kr
   real(kr),parameter::atop=4.e0_kr
   real(kr),parameter::sigmin=1.e-15_kr
   aamin=atop
   aa=0

   !--initialize integral
   khm1=khigh-1
   do i=1,nreac
      sbt(i)=0
   enddo

   !--search for panel containing en
   k=kn
   if (e(k+1).ge.e(k)) then
      do while (en.ge.e(k+1))
         k=k+1
      enddo
   endif

   !--compute desired cross sections
   y=en
   oy=-one/y
   yy=y*y
   ! initialize f functions to zero distance values
   do ll=1,5
      f(ll)=fzero(ll)
   enddo
   alast=0

   !--loop over intervals below current point
   l=k+1
   do 150 ll=klow,k
   l=l-1
   x=e(l)
   xp=e(l+1)
   xx=xp*xp
   if (xx.le.x*x) go to 150
   aa=y-x
   call hunky
   denom=one/(xx-x*x)
   do i=1,nreac
      slope=(s(i,l+1)-s(i,l))*denom
      sbt(i)=sbt(i)+s(i,l+1)*s1+slope*s2
   enddo
   if (aa.gt.atop) go to 170
  150 continue
   if (aa.lt.aamin.and.nlow.ne.klow) aamin=aa
   ! continue cross sections as 1/v to x=0.
   x=0
   xx=0
   aa=y
   call hunky
   do i=1,nreac
      sbt(i)=sbt(i)-s(i,klow)*e(klow)*(oy**2*h(2)+oy*h(1))
   enddo

   !--reinitialize f functions to zero distance values
  170 continue
   do ll=1,5
      f(ll)=fzero(ll)
   enddo
   alast=0
   ! reverse sign of 1/y to use same s1 and s2 functions
   oy=-oy
   ! no intervals above the last point
   if (k.eq.khigh) go to 200

   !--loop over intervals above current one
   do 190 l=k,khm1
   x=e(l+1)
   xm=e(l)
   xx=xm*xm
   if (xx.ge.x*x) go to 190
   aa=x-y
   call hunky
   denom=one/(x*x-xx)
   do i=1,nreac
      slope=(s(i,l+1)-s(i,l))*denom
      sbt(i)=sbt(i)+s(i,l)*s1+slope*s2
   enddo
   if (aa.gt.atop) go to 210
  190 continue
   if (aa.lt.aamin.and.nhigh.ne.khigh) aamin=aa
   ! continue cross sections as constant to x=infinity
  200 continue
   factor=(f(3)*oy+two*f(2))*oy+f(1)
   do i=1,nreac
      sbt(i)=sbt(i)+s(i,khigh)*factor
   enddo

   !--add low energy term, if applicable
  210 continue
   y=-y
   aa=-y
   if (aa.gt.atop) go to 230
   ! extend cross section to x=0.0 as 1/v.
   call funky
   alast=aa
   oy=-oy
   aa=e(klow)-y
   xx=0
   call hunky
   do i=1,nreac
      sbt(i)=sbt(i)-s(i,klow)*e(klow)*(oy**2*h(2)+oy*h(1))
   enddo
   if (aa.gt.atop) go to 230
   ! loop over other intervals
   do 220 l=klow,khm1
   x=e(l+1)
   aa=x-y
   xx=e(l)**2
   if (xx.eq.x*x) go to 220
   call hunky
   denom=one/(x*x-xx)
   do i=1,nreac
      slope=(s(i,l+1)-s(i,l))*denom
      sbt(i)=sbt(i)-s(i,l)*s1-slope*s2
   enddo
   if (aa.gt.atop) go to 230
  220 continue
   ! extend cross section to x=infinity as constant
   factor=(f(3)*oy+two*f(2))*oy+f(1)
   do i=1,nreac
      sbt(i)=sbt(i)-s(i,khigh)*factor
   enddo

   !--return broadened values
  230 continue
   do i=1,nreac
      if (sbt(i).lt.sigmin) sbt(i)=0
      sn(i)=sbt(i)
   enddo

   !--print truncation warning
   if (aamin.lt.atop) then
      write(strng,'(''broadening truncated at a='',f3.1)') aamin
      call mess('bsigma',strng,' ')
   endif
   return
   end subroutine bsigma

   subroutine thinb(j,inew,bufn,e,s,nx)
   !-------------------------------------------------------------------
   ! Given a set of nx cross sections versus energy (e and s)
   ! and linear-linear interpolation between points, this
   ! routine will remove all extraneous points that lie within a
   ! given accuracy of the function based upon interpolation
   ! from surrounding points.  Since all reactions are
   ! thinned simultaneously, the union grid is preserved.
   !-------------------------------------------------------------------
   use util ! provides loada
   ! externals
   integer::j,inew,nx
   real(kr)::e(*),s(nx,*),bufn(*)
   ! internals
   integer::nmin,ilow,i,n,nm1,k
   real(kr)::denom,slope,sp
   real(kr)::tt(ntt+1)
   real(kr),parameter::stpmax=1.24e0_kr
   real(kr),parameter::eps=1.e-5_kr
   real(kr),parameter::zero=0
   nmin=nlow+2
   ilow=nlow+1

   !--keep first point
   if (klow.ne.1) then
      j=j+1
      tt(1)=e(nlow)
      do i=1,nreac
         tt(1+i)=s(i,nlow)
      enddo
      call loada(j,tt,ntx,inew,bufn,nbuf)
   endif

   !--loop over all other points
   do 150 n=nmin,nhigh
   ! define index to last candidate for thinning
   nm1=n-1
   denom=e(n)-tt(1)
   if (denom.eq.zero) go to 150
   denom=1/denom
   do 130 i=1,nreac
   slope=(s(i,n)-tt(1+i))*denom
   ! test allowable error at all intervening points
   do 120 k=ilow,nm1
   if (e(k).ge.stpmax*tt(1)) go to 140
   sp=tt(1+i)+slope*(e(k)-tt(1))
   if (abs(sp-s(i,k)).gt.errthn*s(i,k)) go to 140
   if (e(k)*(1.+eps).gt.thnmax) go to 140
  120 continue
  130 continue
   ! all intervening points can be thinned
   ! extend interval to thin by one more point
   go to 150
   ! at least one point in interval fails test
   ! save last point within the interval
  140 continue
   j=j+1
   tt(1)=e(nm1)
   do i=1,nreac
      tt(1+i)=s(i,nm1)
   enddo
   if (tt(1)*(1.+eps).ge.thnmax) go to 180
   call loada(j,tt,ntx,inew,bufn,nbuf)
   ! reset lower limit of interval that can be thinned
   ilow=n
  150 continue

   !--finished with this page.
   return

   !--copy energies above thnmax to scratch storage.
  160 continue
   j=j+1
   tt(1)=e(nm1)
   do i=1,nreac
      tt(i+1)=s(i,nm1)
   enddo
  180 continue
   if (nm1.eq.nhigh.and.khigh.eq.nhigh) j=-j
   call loada(j,tt,ntx,inew,bufn,nbuf)
   nm1=nm1+1
   if (nm1.le.nhigh) go to 160
   return
   end subroutine thinb

   subroutine hunky
   !-------------------------------------------------------------------
   ! This routine is designed to define functions that appear
   ! in Doppler broadening calculations.
   !  h(n,a)=integral (b to a) z**n*exp(-z*z)*dz/sqrt(pi)
   !  for n=0 to 4
   ! These h(n,a,b) functions are defined as the difference
   ! between f(n,a) functions (see routine funky).
   !  h(n,a,b)=f(n,a)-f(n,b)
   ! unless this expression losses significance in which case
   ! hnabb is calculated by a Taylor expansion of the defining
   ! integral.
   !-------------------------------------------------------------------
   ! internals
   integer::k,n
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::toler=1.e-5_kr
   real(kr),parameter::two=2.e0_kr
   real(kr),parameter::four=4.e0_kr
   real(kr),parameter::six=6.e0_kr

   ! initialize h functions to current f functions
   do k=1,5
      h(k)=f(k)
   enddo
   ! compute new f functions
   call funky
   ! subtract new f functions to obtain integral over interval
   do k=1,5
      h(k)=h(k)-f(k)
      if (abs(h(k)).le.small*abs(f(k))) h(k) = 0.0_kr
      if (abs(h(k)).le.toler*abs(f(k)).and.aa.ne.alast) then
         n=k-1
         h(k)=hnabb(n,alast,aa)
      endif
   enddo
   alast=aa
   ! compute contributions from two integral terms
   s1=(h(3)*oy+two*h(2))*oy+h(1)
   s2=((h(5)+(six*yy-xx)*h(3))*oy+(four*h(4)&
     +(four*yy-two*xx)*h(2)))*oy+(yy-xx)*h(1)
   return
   end subroutine hunky

   subroutine funky
   !-------------------------------------------------------------------
   ! This routine is designed to define functions that appear
   ! in Doppler broadening calculations:
   !  f(n,a)=integral(a to infinity) z**n*exp(-z*z)*dz/sqrt(pi)
   !  for n=0 to 4
   ! The resulting expression is analytic.
   !-------------------------------------------------------------------
   use mathm   ! provides erfc
   use physics ! provides pi
   ! internals
   real(kr)::resqpi,a,asq,expo
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::two=2.e0_kr
   real(kr),parameter::three=3.e0_kr
   real(kr),parameter::alim=10.e0_kr

   resqpi=1/sqrt(pi)
   a=aa
   asq=a*a
   expo=0
   if (a.lt.alim) expo=exp(-asq)
   f(1)=0
   if (a.lt.alim) f(1)=half*erfc(a)
   expo=expo*resqpi
   f(2)=half*expo
   expo=expo*a
   f(3)=half*(f(1)+expo)
   expo=expo*a
   f(4)=half*(two*f(2)+expo)
   expo=expo*a
   f(5)=half*(three*f(3)+expo)
   return
   end subroutine funky

   real(kr) function hnabb(n,aa,bb)
   !-------------------------------------------------------------------
   ! For b.ge.a, calculates hn(a,b) by a direct taylor series
   ! expansion of the defining integral.  This is appropriate
   ! for b-a small.
   !-------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   integer::n
   real(kr)::aa,bb
   ! internals
   integer::mflag,k,kd,kstar,j,kk,jalpha,m,kdstar
   real(kr)::sign,a,b,h,x,xx,asq,con,xk,s,fact,qmn,beta,xn1,xn2,test
   real(kr)::resqpi,term
   real(kr)::cm(50),cmstar(50)
   real(kr),parameter::aerr=1.e30_kr
   real(kr),parameter::rerr=1.e-8_kr
   real(kr),dimension(5),parameter::pow2=(/1.4142135623731e0_kr,&
     2.0e0_kr,2.8284271247462e0_kr,4.0e0_kr,5.6568542494924e0_kr/)
   real(kr),parameter::explim=100.e0_kr
   real(kr),parameter::zero=0

   resqpi=1/sqrt(pi)

   !--transform limits so that b ge a
   !--select relative sign of result
   sign=1
   if (bb.lt.aa) then
      a=abs(bb)
      b=abs(aa)
      sign=-sign
   else
      a=abs(aa)
      b=abs(bb)
   endif
   if (bb.lt.zero) then
     if (mod(n,2).ne.0) sign=-sign
   endif
   h=(b-a)*pow2(1)
   x=pow2(1)*a
   xx=x*x
   asq=a*a
   con=0
   if (asq.lt.explim) con=exp(-asq)*resqpi/pow2(n+1)
   mflag=0
   k=n
   kd=0
   cm(1)=1
   xk=1
   if (k.ne.0) then
      xk=x**k
   endif
   s=h*xk
   fact=h
   do 130 m=2,50
   fact=fact*h/m
   kstar=k
   kdstar=kd+1
   do j=1,kdstar
      cmstar(j)=cm(j)
   enddo
   k=n-m+1
   if (k.lt.0) then
      kk=mod(k,2)
      k=0
      if (kk.ne.0) k=1
   endif
   kd=(n+m-1-k)/2
   cm(kd+1)=-cmstar(kdstar)
   qmn=cm(kd+1)
   if (kd.ne.0) then
      do j=1,kd
         jalpha=(2*j+k-1-kstar)/2
         beta=0
         if (jalpha.ne.0) then
            beta=cmstar(jalpha)
         endif
         cm(j)=(2*j+k-1)*cmstar(jalpha+1)-beta
      enddo
      do j=1,kd
         qmn=qmn*xx+cm(kd+1-j)
      enddo
   endif
   xk=1
   if (k.ne.0) then
      xk=x**k
   endif
   term=fact*xk*qmn
   s=s+term
   xn1=n+1
   xn2=abs(h*x)
   if (m.lt.max(xn1,xn2)) go to 130
   test=aerr+rerr*abs(s)
   if (abs(term).gt.test) go to 200
   if (mflag.eq.1) go to 210
   mflag=1
   go to 130
  200 continue
   mflag=0
  130 continue
  210 continue
   hnabb=con*s*sign
   return
   end function hnabb

end module broadm

module heatm
   ! provides heatr for NJOY2016
   use locale
   implicit none
   private
   public heatr

   ! global variables

   ! units for heatr
   integer::nendf,nin,nout,nplot

   ! heatr global parameters
   integer,parameter::nbuf=1000
   integer,parameter::nqamax=30
   integer,parameter::ilmax=200
   integer,parameter::maxmf6=320

   ! global variables
   integer::matd,mgam,npk,mtp(28),nqa,mta(nqamax),mt303,mt19
   integer::ne,kchk,iprint,lqs(nqamax)
   real(kr),dimension(:),allocatable::qbar
   real(kr)::qa(nqamax),efirst,elast,za,awr,elist(ilmax)
   real(kr)::break
   real(kr)::qdel,etabmax
   integer::mt103,mt104,mt105,mt106,mt107,mt16
   integer::miss4(250),nmiss4
   integer::i6,mt6(maxmf6),i6g,mt6no(maxmf6)
   integer::i6p,mt6yp(maxmf6)
   integer::jp,jpn,jpp
   real(kr)::q,zat,awrt,zap,awp
   integer::lct
   integer::idame
   real(kr)::ebot,etop
   integer::mt458,nply,lfc,ifc1,ifc2,ifc3,ifc4,ifc5,ifc6
   real(kr),dimension(:),allocatable::c458,cpoly,hpoly,afr,anp,agp
   real(kr)::emc2,tm,rtm

   ! target
   integer::izat

   ! projectile
   integer::izap

contains

   subroutine heatr
   !-------------------------------------------------------------------
   !
   ! Compute heating kerma (kinetic energy release in material)
   ! and radiation damage energy production.
   !
   ! The prompt kerma is computed pointwise on the grid of the
   ! total cross section from the input pendf tape and written
   ! onto the output PENDF tape at infinite dilution using the
   ! 300 series of MT numbers.  All temperatures on the input PENDF
   ! tape for the desired material are processed.  The dictionary
   ! is revised.  Reaction Q values are obtained from the ENDF
   ! tape unless the user enters his own value.  Partial kermas
   ! can be requested for self-shielding calculations or other
   ! purposes.  The code uses the energy balance method where
   ! photon files are available and deposits all photon energy
   ! locally when files are not available.  This assures
   ! consistency between neutron heating and energy deposition by
   ! subsequent photon interactions.  An exception is made for
   ! capture where recoil is computed by momentum conservation.
   ! Photon files are used to estimate the average photon momentum
   ! when available.  A diagnostic message is printed if the
   ! momentum calculation leads to a significant error in
   ! energy conservation.
   !
   ! If desired, the energy-balance kerma factors can be compared
   ! with conservative kinematic limits (set iprint=2).
   ! A plot file for viewr can be automatically prepared.
   !
   ! Damage energy is computed using the Lindhard electronic
   ! screening damage function with a displacement threshold
   ! from a table of default values for important elements
   ! or a value provided by the user.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1
   !    nendf    unit for endf tape
   !    nin      unit for input pendf tape
   !    nout     unit for output pendf tape
   !    nplot    unit for graphical check output
   ! card 2
   !    matd     material to be processed
   !    npk      number of partial kermas desired (default=0)
   !    nqa      number of user q values (default=0)
   !    ntemp    number of temperatures to process
   !             (default=0, meaning all on pendf)
   !    local    0/1=gamma rays transported/deposited locally
   !             (default=0)
   !    iprint   print (0 min, 1 max, 2 check) (default=0)
   !    ed       displacement energy for damage
   !             (default from built-in table)
   ! card 3      for npk gt 0 only
   !    mtk      mt numbers for partial kermas desired
   !             total (mt301) will be provided automatically.
   !             partial kerma for reaction mt is mt+300
   !             and may not be properly defined unless
   !             a gamma file for mt is on endf tape.
   !             special values allowed--
   !               303   non-elastic (all but mt2)
   !               304   inelastic (mt51 thru 91)
   !               318   fission (mt18 or mt19, 20, 21, 38)
   !               401   disappearance (mt102 thru 120)
   !               442   total photon ev-barns
   !               443   total kinematic kerma (high limit)
   !             damage energy production values--
   !               444   total
   !               445   elastic (mt2)
   !               446   inelastic (mt51 thru 91)
   !               447   disappearance (mt102 thru 120)
   !          cards 4 and 5 for nqa gt 0 only
   ! card 4
   !    mta      mt numbers for users q values
   ! card 5
   !    qa       user specified q values (ev)
   !               (if qa.ge.99.e6, read in variable qbar
   !                  for this reaction)
   ! card 5a     variable qbar (for reactions with qa flag only)
   !    qbar      tab1 record giving qbar versus e (1000 words max)
   !
   !-------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util   ! provides timer,openz,error,mess,repoz,closz
   use endf   ! provides endf routines and variables
   use physics ! provides amassn,amu,ev,clight
   ! internals
   integer::ntemp,local,npkk,i,nz,j,isave,iz,loc,nzq,nz0
   integer::nscr,nend4,nend6,iold,inew,itemp,idone,nb,nw
   real(kr)::time,flag
   integer,parameter::npkmax=28
   integer::mtk(2+npkmax)
   real(kr)::z(17)
   real(kr),dimension(:),allocatable::tmp
   real(kr),parameter::qtest=99.e6_kr
   real(kr),parameter::qflag=-1.e-9_kr
   real(kr),parameter::zero=0
   integer,parameter::maxqbar=10000

   !--start
   call timer(time)
   write(nsyso,&
     '(/'' heatr...prompt kerma'',48x,f8.1,''s'')') time
   write(nsyse,'(/'' heatr...'',60x,f8.1,''s'')') time

   !--read user input.
   nplot=0
   read(nsysi,*) nendf,nin,nout,nplot
   call openz(nendf,0)
   call openz(nin,0)
   call openz(nout,1)
   if (nplot.ne.0) call openz(nplot,1)
   npk=0
   nqa=0
   ntemp=0
   local=0
   iprint=0
   break=0
   read(nsysi,*) matd,npk,nqa,ntemp,local,iprint,break
   kchk=0
   if (iprint.eq.2) kchk=1
   if (iprint.eq.2) iprint=1
   npkk=npk+3
   if (kchk.eq.1) npkk=3*npk+7
   if (npkk.gt.npkmax) call error('heatr',&
     'requested too many kerma mt-s (6+mt301 allowed).',' ')
   if (nqa.gt.nqamax)&
     call error('heatr','requested too many q values.',' ')
   if (npk.gt.0) then
      read(nsysi,*) (mtk(i),i=1,npk)
   endif
   allocate(tmp(maxqbar))
   loc=1
   if (nqa.ne.0) then
      read(nsysi,*) (mta(i),i=1,nqa)
      read(nsysi,*) (qa(i),i=1,nqa)
      do i=1,nqa
         lqs(i)=0
         if (qa(i).ge.qtest) then
            lqs(i)=loc
            nz=1000
            flag=qflag
            do j=1,nz
               tmp(loc+j-1)=flag
            enddo
            read(nsysi,*) (tmp(loc+j-1),j=1,nz)
            nz0=0
            do j=1,nz
               if (tmp(loc+j-1).gt.flag) nz0=j
            enddo
            loc=loc+nz0
            if (loc.gt.maxqbar) call error('heatr',&
              'too much energy-dependent q data',' ')
         endif
      enddo
   endif
   nzq=loc-1
   if (nzq.gt.0) then
      allocate(qbar(nzq))
      do i=1,nzq
         qbar(i)=tmp(i)
      enddo
   endif
   deallocate(tmp)
   if ((nin.lt.0.and.nout.gt.0).or.(nin.gt.0.and.nout.lt.0))&
     call error('heatr',&
     'mode conversion not allowed between nin and nout.',' ')

   !--check the partial kermas
   if (npk.gt.0) then
      isave=0
      do i=1,npk
         if (mtk(i).eq.443.and.kchk.eq.0) kchk=2
         if (mtk(i).eq.301) isave=i
      enddo
      if (isave.gt.0) then
         call mess('heatr','mt301 always calculated',&
           '--you do not need to ask for it.')
         npk=npk-1
         if (isave.le.npk) then
            do i=isave,npk
               mtk(i)=mtk(i+1)
            enddo
         endif
      endif
      do i=1,npk
         mtp(npk+3-i)=mtk(i)
      enddo
   endif
   mtp(1)=0
   mtp(2)=301
   npk=npk+2
   ! there are always at least 2 elements in the npk array,
   ! (1)=energy, (2)=mt301 (total)
   if (npk.gt.3) call horder(mtp,npk)

   !--list all input parameters
   write(nsyso,'(/&
     &'' input endf unit ...................... '',i10/&
     &'' input pendf unit ..................... '',i10/&
     &'' output pendf unit .................... '',i10)')&
     nendf,nin,nout
   write(nsyso,'(&
     &'' mat to be processed .................. '',i10)') matd
   write(nsyso,'(&
     &'' no. temperatures (0=all) ............. '',i10/&
     &'' gamma heat (0 nonlocal, 1 local) ..... '',i10/&
     &'' print option (0 min, 1 more, 2 chk) .. '',i10)')&
     ntemp,local,iprint
   if (break.eq.zero) then
      write(nsyso,'(&
        &'' damage displacement energy ...........    default'')')
   else
      write(nsyso,'(&
        &'' damage displacement energy ........... '',f10.1,&
        &'' ev'')') break
   endif
   if (ntemp.eq.0) ntemp=100
   if (npk.ge.3) write(nsyso,'(&
     &'' partial kerma mt-s desired ........... '',i10)') mtp(3)
   if (npk.ge.4) write(nsyso,'(40x,i10)')(mtp(i),i=4,npk)
   if (nqa.ne.0) then
      write(nsyso,'(&
        &'' auxiliary reactions .................. '',i10)') mta(1)
      if (nqa.gt.1) write(nsyso,'(40x,i10)') (mta(i),i=2,nqa)
      write(nsyso,'(&
        &'' auxiliary q values ................... '',1p,e12.4)') qa(1)
      if (nqa.gt.1) write(nsyso,'(40x,1p,e12.4)') (qa(i),i=2,nqa)
      if (nzq.ne.0) then
         do i=1,nqa
            if (qa(i).ge.qtest) then
               nsh=0
               math=1
               mfh=1
               mth=mta(i)
               write(nsyso,'('' input q ----'')')
               call tab1io(0,nsyso,0,qbar,nb,nw)
            endif
         enddo
      endif
   endif

   !--assign scratch units
   nscr=10
   if (nendf.lt.0) nscr=-nscr
   nend4=13
   if (nendf.lt.0) nend4=-nend4
   nend6=14
   if (nendf.lt.0) nend6=-nend6
   iold=11
   inew=12
   call openz(-iold,1)
   call openz(-inew,1)
   call openz(nscr,1)
   call openz(nend4,1)
   call openz(nend6,1)

   !--process input pendf tape
   call repoz(nin)
   call repoz(nout)
   nsh=0
   call tpidio(nin,nout,0,z,nb,nw)
   call findf(matd,1,451,nin)
   itemp=0

   !--loop over desired temperatures for this mat
   idone=0
   do while (idone.eq.0)
      call contio(nin,0,0,z,nb,nw)
      if (math.ne.matd) then
         idone=1
      else
         itemp=itemp+1
         if (itemp.gt.ntemp) then
            idone=1
         else
            za=c1h
            awr=c2h
            emc2=amassn*amu*clight*clight/ev
            tm=emc2*(awr+1)
            rtm=1/tm

            !--check on default damage displacement energy
            if (break.eq.zero) then
               iz=nint(za/1000)
               if (iz.eq.4) then
                  break=31
               else if (iz.eq.6) then
                  break=31
               else if (iz.eq.12) then
                  break=25
               else if (iz.eq.13) then
                  break=27
               else if (iz.eq.14) then
                  break=25
               else if (iz.eq.20) then
                  break=40
               else if (iz.ge.22.and.iz.le.29) then
                  break=40
               else if (iz.eq.40) then
                  break=40
               else if (iz.eq.41) then
                  break=40
               else if (iz.eq.42) then
                  break=60
               else if (iz.eq.47) then
                  break=60
               else if (iz.eq.73) then
                  break=90
               else if (iz.eq.74) then
                  break=90
               else if (iz.eq.79) then
                  break=30
               else if (iz.eq.82) then
                  break=25
               else
                  break=25
               endif
               write(nsyso,'(/'' default damage energy ='',f5.1,&
                 &'' ev'')') break
            endif

            !--analyze dictionary and read energy grids.
            call hinit(iold,nend4,nend6,nscr)

            !--calculate heating from neutron files.
            call timer(time)
            write(nsyso,'(&
              &61x,''temp'',i2,2x,f8.1,''s'')') itemp,time
            call nheat(iold,inew,nscr,nend4,nend6,local)

            !--correct for gamma production.
            if (mgam.gt.0.and.mgam.ne.10.and.local.eq.0) then
               call timer(time)
               write(nsyso,'(&
                 &61x,''temp'',i2,2x,f8.1,''s'')') itemp,time
               call gheat(iold,inew,nscr)
            endif

            !--write kermas on pendf tape.
            call hout(iold)
         endif
      endif
   enddo

   !--heatr is finished.
   if (allocated(c458)) deallocate(c458)
   if (allocated(cpoly)) deallocate(cpoly)
   if (allocated(hpoly)) deallocate(hpoly)
   if (allocated(afr)) deallocate(afr)
   if (allocated(anp)) deallocate(anp)
   if (allocated(agp)) deallocate(agp)
   call atend(nout,0)
   call repoz(nout)
   call repoz(nin)
   call repoz(nendf)
   call closz(nin)
   call closz(nout)
   call closz(nendf)
   call closz(-iold)
   call closz(-inew)
   call closz(nscr)
   call closz(nend4)
   call closz(nend6)
   call timer(time)
   write(nsyso,'(/69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine heatr

   subroutine horder(iarray,n)
   !-------------------------------------------------------------------
   ! Arrange the n elements of iarray in ascending order.
   !-------------------------------------------------------------------
   ! externals
   integer::n,iarray(n)
   ! internals
   integer::i,j,isave

   do i=1,n
      do j=i,n
         if (iarray(i).gt.iarray(j)) then
            isave=iarray(i)
            iarray(i)=iarray(j)
            iarray(j)=isave
         endif
      enddo
   enddo
   return
   end subroutine horder

   subroutine hinit(iold,nend4,nend6,nscr)
   !-------------------------------------------------------------------
   ! Analyze dictionary and set necessary flags.
   ! Read energy grid of total cross section.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util   ! provides repoz,error,mess,loada
   use endf   ! provides endf routines and variables
   ! externals
   integer::iold,nend4,nend6,nscr
   ! internals
   integer::ifiss,i519,nb,nw,n6,nx,i,ifini,ii6,lf,n,nk,nfc,ifc
   integer::mfd,mtd,j,idone,mf4,mt4,ie,nmu,imu,npkk,idis
   integer::ielem,ik,nr,idnx,nen,law
   integer::lrel,nmod
   integer::i6t,nl,l
   real(kr)::zar,awrr,e,enext,y,yld,test,efix
   real(kr)::c(30)
   character(60)::strng
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::bufo
   real(kr),parameter::fact=.99999e0_kr
   real(kr),parameter::rup=1.000000001e0_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::zero=0
   real(kr),parameter::mevev=1.e-6_kr
   real(kr),parameter::tol=1.e-5_kr

   !--analyze dictionary
   lrel=0
   nmod=0
   i6=0
   mt103=0
   mt104=0
   mt105=0
   mt106=0
   mt107=0
   mt16=0
   nmiss4=0
   mgam=0
   ifiss=0
   mt19=0
   i519=0
   mt458=0
   qdel=0
   jp=0
   jpn=0
   jpp=0
   etop=20000000
   ebot=1
   ebot=ebot/100000
   etabmax=-1.0
   call repoz(nendf)
   call tpidio(nendf,0,0,c(1),nb,nw)
   call findf(matd,1,451,nendf)
   call contio(nendf,0,0,c(1),nb,nw)
   n6=n2h
   call contio(nendf,0,0,c(1),nb,nw)
   nx=0
   if (n1h.ne.0) then
      iverf=4
      nx=n6
   else if (n2h.eq.0) then
      iverf=5
   else
      iverf=6
   endif
   call skiprz(nendf,-1)
   if (iverf.ge.5) call contio(nendf,0,0,c(1),nb,nw)
   if (iverf.eq.6) call contio(nendf,0,0,c(1),nb,nw)
   if (iverf.eq.6) then
      if (c2h.gt.etop) etop=c2h
      lrel=l1h
      nmod=n2h
   endif
   allocate(scr(npage+50))
   call hdatio(nendf,0,0,scr,nb,nw)
   do while (nb.ne.0)
      call moreio(nendf,0,0,scr,nb,nw)
   enddo
   if (iverf.ge.5) nx=n2h
   deallocate(scr)
   nw=6*nx
   if (nw.lt.npage+50) nw=npage+50
   allocate(scr(nw))
   nw=nx
   if (nw.ne.0) then
      call dictio(nendf,0,0,scr,nb,nw)
      i=1
      ifini=0
      do while (i.le.nw.and.ifini.eq.0)
         mfd=nint(scr(i+2))
         mtd=nint(scr(i+3))
         if (mfd.ne.2) then
            if (mfd.eq.12.and.mtd.ne.460) mgam=1
            if (mfd.eq.13) mgam=1
            if (mfd.ge.13) then
               ifini=1
            else
               if (mfd.le.3) then
                  if (mfd.eq.1.and.mtd.eq.458) mt458=1
                  if (mtd.eq.19) mt19=1
                  if (mtd.eq.18.or.mtd.eq.19) ifiss=1
                  if (iverf.ge.6) then
                     if (mtd.ge.600.and.mtd.lt.650) mt103=1
                     if (mtd.ge.650.and.mtd.lt.700) mt104=1
                     if (mtd.ge.700.and.mtd.lt.750) mt105=1
                     if (mtd.ge.750.and.mtd.lt.800) mt106=1
                     if (mtd.ge.800.and.mtd.lt.850) mt107=1
                     if (mtd.ge.875.and.mtd.lt.891) mt16=1
                     if (mtd.ge.600.and.mtd.le.850) then
                        j=i
                        idone=0
                        do while (j.le.nw.and.idone.eq.0)
                           mf4=nint(scr(j+2))
                           mt4=nint(scr(j+3))
                           if (mf4.eq.4.and.mt4.eq.mtd) then
                              idone=1
                           else
                              if (mf4.eq.6.and.mt4.eq.mtd) then
                                 idone=1
                              else
                                 j=j+6
                              endif
                           endif
                        enddo
                        if (idone.eq.0) then
                           write(strng,'(&
                             &''mf4 and 6 missing, '',&
                             &''isotropy assumed for mt '',i3)') mtd
                           call mess('hinit',strng,' ')
                           nmiss4=nmiss4+1
                           miss4(nmiss4)=mtd
                        endif
                     endif
                  else
                     if (mtd.ge.700.and.mtd.lt.720) mt103=1
                     if (mtd.ge.720.and.mtd.lt.740) mt104=1
                     if (mtd.ge.740.and.mtd.lt.760) mt105=1
                     if (mtd.ge.760.and.mtd.lt.780) mt106=1
                     if (mtd.ge.780.and.mtd.lt.800) mt107=1
                     if (mtd.ge.700.and.mtd.le.800) then
                        j=i
                        idone=0
                        do while (j.le.nw.and.idone.eq.0)
                           mf4=nint(scr(j+2))
                           mt4=nint(scr(j+3))
                           if (mf4.eq.4.and.mt4.eq.mtd) then
                              idone=1
                           else
                              if (mf4.eq.6.and.mt4.eq.mtd) then
                                 idone=1
                              else
                                 j=j+6
                              endif
                           endif
                        enddo
                        if (idone.eq.0) then
                           write(strng,'(&
                             &''mf4 and 6 missing, '',&
                             &''isotropy assumed for mt '',i3)') mtd
                           call mess('hinit',strng,' ')
                           nmiss4=nmiss4+1
                           miss4(nmiss4)=mtd
                        endif
                     endif
                  endif
               else
                  if (mfd.eq.5) then
                     if (mtd.eq.19) i519=1
                  else if (mfd.eq.6) then
                     i6=i6+1
                     if (i6.gt.maxmf6) call error('hinit',&
                       'too many mf6 reactions',' ')
                     mt6(i6)=mtd
                  endif
               endif
            endif
         endif
         i=i+6
      enddo
   endif
   if (mt19.eq.1.and.i519.eq.0) mt19=2
   if (mt19.eq.1) call mess('hinit','mt18 is redundant',&
     '19, 20, 21, ... will be used.')
   if (mt19.eq.2) call mess('hinit','mt19 has no spectrum',&
     'mt18 spectrum will be used.')

   !--calculate q change for fissionables in mt 458
   if (ifiss.ne.0) then
      deallocate(scr)
      nw=10000
      allocate(scr(nw))
      if (allocated(c458)) deallocate(c458)
      if (allocated(cpoly)) deallocate(cpoly)
      if (allocated(hpoly)) deallocate(hpoly)
      if (allocated(afr)) deallocate(afr)
      if (allocated(anp)) deallocate(anp)
      if (allocated(agp)) deallocate(agp)
      if (mt458.eq.1) then
         call findf(matd,1,458,nendf)
         call contio(nendf,0,0,scr,nb,nw)
         lfc=nint(scr(4))
         nfc=nint(scr(6))
         ifc1=0
         ifc2=0
         ifc3=0
         ifc4=0
         ifc5=0
         ifc6=0
         l=1
         call listio(nendf,0,0,scr(l),nb,nw)
         l=l+nw
         do while (nb.ne.0)
            call moreio(nendf,0,0,scr(l),nb,nw)
            l=l+nw
         enddo
         nply=nint(scr(4))
         if (lfc.eq.0) then
            allocate(cpoly(0:nply))
            allocate(hpoly(0:nply))
            cpoly=0
            hpoly=0
         endif
         allocate(c458(nint(scr(5))))
         ! save polynomial coefficients ... c0 & c1 terms are ok,
         ! but for endf/b-vii.1, c2 and higher are mistakenly given
         ! as if the energy will be given in MeV and therefore need
         ! correction.
         write(nsyso,'(/,&
           &'' fission energy components''/)')
         c458(1:18)=scr(7:24)    ! scr is a list record
         if (lfc.eq.0) then      ! thermal point or polynomial
            qdel=c458(5)+c458(9)+c458(11) ! delayed fission Q at 0 eV
            if (nply.ge.1) then
               c458(19:36)=scr(25:42)
               if (nply.gt.1) then
                  do n=2,nply
                     if (nmod.ne.7.or.lrel.ne.1) then ! endf/b-vii.1 correction
                        efix=1
                     else
                        efix=mevev**(n-1)
                     endif
                     c458(1+18*n:18+18*n)=scr(7+18*n:24+18*n)*efix
                  enddo
               endif
               write(nsyso,'(&
                 &''   fission products: polynomial of order '',i2/&
                 &''   prompt neutrons : polynomial of order '',i2/&
                 &''   prompt gammas   : polynomial of order '',i2)')&
                 nply,nply,nply
            else
               write(nsyso,'(&
                 &''   fission products: thermal point''/&
                 &''   prompt neutrons : thermal point''/&
                 &''   prompt gammas   : thermal point'')')
            endif
            do  i=0,nply
               cpoly(i)=c458(1+i*18)+c458(3+i*18)+c458(7+i*18)
               hpoly(i)=c458(1+i*18)+c458(7+i*18)
            enddo
         else if (lfc.eq.1) then ! tabulated components
            qdel=0
            do i=1,nfc
               l=1
               call tab1io(nendf,0,0,scr(l),nb,nw)
               do while (nb.ne.0)
                  l=l+nw
                  call moreio(nendf,0,0,scr(l),nb,nw)
               enddo
               ifc=l2h
               nl=6+2*n1h+2*n2h
               if (etabmax.lt.0) then
                  etabmax=scr(nl-1)
               else
                  if ((abs(etabmax-scr(nl-1))/etabmax).gt.tol) then
                     write(strng,'(''upper energy mismatch for ifc='',i2,&
                        &'' in mt=458.'')')ifc
                     call error('hinit',strng,' ')
                  endif
               endif
               if (ifc.eq.1) then      ! EFR is tabulated
                  ifc1=1
                  allocate(afr(1:nl))
                  afr(1:nl)=scr(1:nl)
               else if (ifc.eq.2) then ! ENP is tabulated
                  ifc2=1
                  allocate(anp(1:nl))
                  anp(1:nl)=scr(1:nl)
               else if (ifc.eq.3) then ! END is tabulated
                  ifc3=1
                  qdel=qdel+scr(6+2*n1h+2)
               else if (ifc.eq.4) then ! EGP is tabulated
                  ifc4=1
                  allocate(agp(1:nl))
                  agp(1:nl)=scr(1:nl)
               else if (ifc.eq.5) then ! EGD is tabulated
                  ifc5=1
                  qdel=qdel+scr(6+2*n1h+2)
               else if (ifc.eq.6) then ! EB is tabulated
                  ifc6=1
                  qdel=qdel+scr(6+2*n1h+2)
               endif
            enddo
            if (ifc3.eq.0) qdel=qdel+c458(5)
            if (ifc5.eq.0) qdel=qdel+c458(9)
            if (ifc6.eq.0) qdel=qdel+c458(11)
            if (ifc1.eq.1) then
               write(nsyso,'(''   fission products: tabulated values'')')
            else
               write(nsyso,'(''   fission products: thermal point'')')
            endif
            if (ifc2.eq.1) then
               write(nsyso,'(''   prompt neutrons : tabulated values'')')
            else
               write(nsyso,'(''   prompt neutrons : thermal point'')')
            endif
            if (ifc4.eq.1) then
               write(nsyso,'(''   prompt gammas   : tabulated values'')')
            else
               write(nsyso,'(''   prompt gammas   : thermal point'')')
            endif
            if (etabmax.lt.0) then
               write(strng,'(''no tabulated fission q components found'',&
                  &'' in mt=458.'')')
               call error('nheat',strng,' ')
            endif
         else
            call error('hinit','bad LFC in mt=458.',' ')
         endif
      else
         lfc=0
         nply=0
         allocate(cpoly(0:nply))
         cpoly=0
         call mess('hinit','mt458 is missing for this mat',' ')
      endif
   endif

   !--prepare a scratch tape for file 6
   !--check for missing recoil subsections
   !--and check for photon data
   i6p=0
   mt6yp=0
   if (i6.gt.0) then
      call repoz(nend6)
      nsp=1
      math=1
      call afend(nend6,0)
      call findf(matd,6,0,nendf)
      ii6=0
   endif
   mfh=6
   do while (mfh.eq.6)
      call contio(nendf,0,0,scr,nb,nw)
      if (mth.eq.18) then
         jp=l1h
         jpn=mod(jp,10)
         jpp=jp-10*jpn
      endif
      if (mth.ne.18 .or. (mth.eq.18 .and. jp.eq.0)) then
         call contio(0,nend6,0,scr,nb,nw)
      else
         !--delete mt=18 from mt6 array and skip this section (for now)
         i6t=i6
         do i=1,i6t
            if (mt6(i).lt.18) cycle
            if (mt6(i).eq.18) i6=i6-1
            if (mt6(i).gt.18 .and. i6.ne.i6t) mt6(i-1)=mt6(i)
         enddo
         call tosend(nendf,0,0,scr)
         cycle
      endif
      if (mfh.ne.0) then
         if (mth.ne.0) then
            nk=n1h
            ii6=ii6+1
            mt6no(ii6)=0
            zar=c1h+1
            awrr=c2h+1
            ielem=mod(nint(c1h),1000)
            do ik=1,nk
               l=1
               call tab1io(nendf,nend6,0,scr(l),nb,nw)
               l=l+nw
               do while (nb.ne.0)
                  call moreio(nendf,nend6,0,scr(l),nb,nw)
                  l=l+nw
               enddo
               nr=n1h
               zap=c1h
               law=l2h
               if (nint(zap).eq.0) then
                  i6p=i6p+1
                  mt6yp(i6p)=mth
               endif
               lf=l1h
               if (mth.eq.5) zar=0
               if (mth.ne.5) then
                  yld=scr(6+2*nr+2)
                  zar=zar-zap*yld
                  awrr=awrr-c2h*yld
                  if (zap.eq.zero.and.(ik.gt.1.or.nk.eq.1)) then
                     if (nk.ne.1.or.zap.ne.zero) then
                        if (zar.ne.zero) then
                           test=3000
                           if (ielem.ne.0.or.abs(zar).ge.test) then
                              write(strng,'(''mf6, mt'',i3,&
                                &'' does not give recoil za='',i6)')&
                                mth,nint(zar)
                              if (mth.eq.102) then
                                 call mess('hinit',strng,&
                                   'photon momentum recoil used.')
                              else if (mth.ne.10) then
                                 call mess('hinit',strng,&
                                   'one-particle recoil approx. used.')
                              endif
                              mt6no(ii6)=ik-1
                              zar=0
                           endif
                        endif
                     endif
                  endif
               endif
               if (mth.eq.102.and.zap.gt.0.and.lf.eq.0) then
                  write(strng,'(''mf6, mt'',i3,&
                   &'' has recoil with no spectrum'')') mth
                  call mess('hinit',strng,&
                                  'photon momentum recoil used.')
                  mt6no(ii6)=nk
               endif
               if (zap.eq.zero) mgam=10+mod(mgam,10)
               if (law.eq.6) then
                  call contio(nendf,nend6,0,scr,nb,nw)
               else if (law.eq.1.or.law.eq.2.or.law.eq.5) then
                  call tab2io(nendf,nend6,0,scr,nb,nw)
                  ne=n2h
                  do ie=1,ne
                     call listio(nendf,nend6,0,scr,nb,nw)
                     do while (nb.ne.0)
                        call moreio(nendf,nend6,0,scr,nb,nw)
                     enddo
                  enddo
               else if (law.eq.7) then
                  call tab2io(nendf,nend6,0,scr,nb,nw)
                  ne=n2h
                  do ie=1,ne
                     call tab2io(nendf,nend6,0,scr,nb,nw)
                     nmu=n2h
                     do imu=1,nmu
                        call tab1io(nendf,nend6,0,scr,nb,nw)
                        do while (nb.ne.0)
                           call moreio(nendf,nend6,0,scr,nb,nw)
                        enddo
                     enddo
                  enddo
               else if (law.lt.0) then
                  call skip6(nendf,nend6,0,scr,law)
               endif
            enddo
            if (zar.ne.zero) then
               test=3000
               if (ielem.ne.0.or.abs(zar).ge.test) then
                  write(strng,'(''mf6, mt'',i3,&
                    &'' does not give recoil za='',i6)') mth,nint(zar)
                  if (mth.eq.102) then
                     call mess('hinit',strng,&
                       'photon momentum recoil used.')
                  else if (mth.ne.10) then
                     call mess('hinit',strng,&
                       'one-particle recoil approx. used.')
                  endif
                  mt6no(ii6)=nk
               endif
            endif
         endif
      endif
   enddo
   call amend(nend6,0)
   call atend(nend6,0)
   call repoz(nend6)
   if (mgam.eq.0) write(nsyso,'(/&
     &'' no photon production files...'',&
     &''all photon energy will be deposited locally.'')')

   !--copy endf tape to nscr for use in conbar and gheat
   !--and to nend4 for use in disbar
   !--convert photon transition probability arrays if present
   call repoz(nendf)
   call repoz(nend4)
   call repoz(nscr)
   nsp=1
   nsc=1
   math=1
   call afend(nend4,nscr)
   call findf(matd,1,451,nendf)
   call hconvr(nendf,nend4,nscr)
   call amend(nend4,nscr)
   call atend(nend4,nscr)
   call repoz(nend4)
   call repoz(nscr)
   call repoz(nendf)

   !--store energy grid of the total cross section.
   call findf(matd,3,1,nin)
   npkk=npk
   if (kchk.eq.1) npkk=3*npk-2
   if (mgam.gt.0) npkk=npkk+3
   if (mgam.eq.0.and.i6.gt.0) npkk=npkk+1
   do i=1,npkk
      c(i)=0
   enddo
   call contio(nin,0,0,scr,nb,nw)
   e=0
   call gety1(e,enext,idis,y,nin,scr)
   enext=enext*rup
   efirst=enext
   idnx=0
   allocate(bufo(nbuf))
   ne=0
   nen=1
   do while (nen.gt.0)
      ne=ne+1
      test=enext*fact
      if (idnx.gt.0.and.test.gt.e) enext=test
      e=enext
      call gety1(e,enext,idis,y,nin,scr)
      nen=ne
      if (enext.gt.big-big/100) nen=-nen
      c(1)=e
      call loada(nen,c,npkk,iold,bufo,nbuf)
      if (idis.gt.0.and.idnx.gt.0) idnx=0
      if (idis.gt.0.and.idnx.eq.0) idnx=1
      if (idis.eq.0) idnx=0
   enddo
   elast=e
   call tosend(nin,0,0,scr)
   deallocate(bufo)
   deallocate(scr)
   mt303=0
   if (npk.lt.3) return
   do i=3,npk
      if (mtp(i).eq.303) mt303=i
   enddo
   return
   end subroutine hinit

   subroutine nheat(iold,inew,nscr,nend4,nend6,local)
   !-------------------------------------------------------------------
   ! Calculate contributions to heating from neutron files.
   !-------------------------------------------------------------------
   use mainio ! provides nsyso
   use util   ! provides error,mess,loada,finda,skiprz,sigfig
   use endf   ! provides endf routines and variables
   ! externals
   integer::iold,inew,nscr,nend4,nend6,local
   ! internals
   integer::nb,nw,npkk,ipk,n6,j6,irec,jrec,last6,new6
   integer::lr,icon,mtd,i,iimt,nmt,na,nwa,nwm,idis
   integer::ipx,irx,ilist,nn,iii,lq0,idx,ii,indxx
   integer::ipfr,irfr,ipnp,irnp,ipgp,irgp
   integer::npkt,intt,isave,npkkk,nwmax,iflag
   real(kr)::awfac,aw1fac,e,thresh,y,t,qendf,pnue
   real(kr)::qs,q0,h0,ebar,dame,yld,qsave
   real(kr)::elst,yld0,xxx,test,enext,enx,ebal6,h
   real(kr)::ebarp,yldp,yp,hp,damep,ebal6p,hmin,hmax,tt
   real(kr)::qfr,qnp,qgp
   real(kr)::c(30)
   integer::imt(30)
   character(60)::strng,strng1,strng2
   real(kr),dimension(:),allocatable::b
   real(kr),dimension(:),allocatable::a
   real(kr),dimension(:),allocatable::d
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::bufo,bufn
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::efis=15.e6_kr
   real(kr),parameter::fq1=8.07e6_kr
   real(kr),parameter::fq2=1.307e0_kr
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::qtest=99.e6_kr
   real(kr),parameter::smin=1.e-9_kr
   real(kr),parameter::break1=1.e6_kr
   real(kr),parameter::break2=2.e6_kr
   real(kr),parameter::break3=5.e6_kr
   real(kr),parameter::break4=20.e6_kr
   real(kr),parameter::step1=.2e6_kr
   real(kr),parameter::step2=.5e6_kr
   real(kr),parameter::step3=1.e6_kr
   real(kr),parameter::step4=5.e6_kr
   real(kr),parameter::up=1.1e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::tol=1.e-5_kr

   !--allocate storage
   allocate(b(npage+50))
   nwmax=250000
   allocate(d(nwmax))
   na=500000
   allocate(a(na))
   allocate(scr(npage+50))
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))
   awfac=1/awr
   aw1fac=1/(awr+1)
   npkk=npk
   if (kchk.eq.1) npkk=3*npk-2
   if (mgam.gt.0) npkk=npkk+3
   if (mgam.eq.0.and.i6.gt.0) npkk=npkk+1
   npkkk=0
   do ipk=3,npk
      if (mtp(ipk).eq.442) npkkk=ipk
   enddo
   ! check for requested dame energy calculation
   idame=0
   ipk=2
   do while (idame.eq.0.and.ipk.lt.npk)
      ipk=ipk+1
      if (mtp(ipk).ge.444) idame=1
   enddo
   n6=0
   j6=0
   i6g=0
   irec=0
   jrec=0
   last6=0
   new6=0
   qsave=0
   pnue=0

   !--loop over non-redundant mt-s in file 3.
  105 continue
   call contio(nin,0,0,scr,nb,nw)
   if (mfh.eq.0) go to 300
   if (mth.eq.0) go to 105
   if (mth.eq.3.or.mth.eq.4) go to 110
   if (mth.eq.10) go to 110
   if (mth.eq.26.or.mth.eq.27) go to 110
   if (mth.eq.18.and.mt19.eq.1) go to 110
   if (mth.ge.19.and.mth.le.21.and.mt19.eq.2) go to 110
   if (mth.eq.38.and.mt19.eq.2) go to 110
   if (mth.eq.101) go to 110
   if (mth.eq.103.and.mt103.gt.0) go to 110
   if (mth.eq.104.and.mt104.gt.0) go to 110
   if (mth.eq.105.and.mt105.gt.0) go to 110
   if (mth.eq.106.and.mt106.gt.0) go to 110
   if (mth.eq.107.and.mt107.gt.0) go to 110
   if (mth.eq.16.and.mt16.gt.0) go to 110
   if (iverf.le.5.and.mth.eq.719) go to 110
   if (iverf.le.5.and.mth.eq.739) go to 110
   if (iverf.le.5.and.mth.eq.759) go to 110
   if (iverf.le.5.and.mth.eq.779) go to 110
   if (iverf.le.5.and.mth.eq.799) go to 110
   if (mth.gt.120.and.mth.lt.152) go to 110
   if (mth.gt.200.and.mth.lt.600) go to 110
   zat=c1h
   awrt=c2h
   izat=nint(zat)
   go to 120
  110 continue
   call tosend(nin,0,0,scr)
   go to 105

   !--compute heating from this section.
  120 continue
   e=0
   call gety1(e,thresh,idis,y,nin,b)
   thresh=sigfig(thresh,7,0)
   t=c1h
   q=c2h
   qendf=q
   lr=l2h
   qs=0
   q0=0
   h0=0
   icon=0
   ebar=0
   dame=0
   mtd=mth

   !--check for an endf-6 file 6
   if (j6.gt.0) go to 123
   do i=1,i6
      if (mtd.eq.mt6(i)) go to 121
   enddo
   go to 124
  121 continue
   call findf(matd,6,mtd,nend6)
   call contio(nend6,0,0,scr,nb,nw)
   n6=nint(scr(5))
   lct=nint(scr(4))
   jp=nint(scr(3))
   jpn=mod(jp,10)
   jpp=jp-10*jpn
   if (mth.eq.18 .and. jpn.ne.0) then
      call tosend(nend6,0,0,scr)
      go to 105
   endif
   i6g=i6g+1
  123 continue
   j6=j6+1
   if (irec.gt.0.and.mt6no(i6g).gt.0) j6=j6-1
   last6=0
   if (j6.eq.n6.and.irec.gt.0) last6=1
   if (j6.eq.n6.and.mt6no(i6g).eq.0) last6=1
   new6=0
   if (j6.eq.1.and.irec.eq.0) new6=1
  124 continue

   !--adjust fission q to e(in)=0 prompt value
   if ((mth.ge.18.and.mth.le.21).or.mth.eq.38) then
      if (mt458.eq.1) then
         qendf=c458(15)
         q=qendf-qdel
         write(strng1,&
              &'(''changed q from '',1p,e14.6,'' to '',1p,e14.6)')&
              qendf,q
         write(strng2,'(''for mt '',i3,'' by taking out delayed components'')') mth
         call mess('nheat',strng1,strng2)
      else
         q=qendf
         cpoly(0)=q
      endif
   endif

   !--choose appropriate ground state q value.
   !--initialize heating routines.
   !--define neutron yield for this reaction.
   iimt=0
   if (nqa.eq.0) go to 140
   do 130 i=1,nqa
      if (mta(i).ne.mth) go to 130
      qs=qa(i)
      iimt=i
      go to 140
  130 continue
  140 continue
   if (j6.gt.0) go to 175
   if (mth.gt.15.and.mth.lt.51) go to 150
   if (mth.gt.100) go to 170
   icon=1
   q0=0
   if (lr.ne.0.and.lr.ne.31) q0=t
   if (iimt.ne.0) q0=qs
   if (mth.eq.91) go to 160
   yld=1
   ! accomodate neutron producing pseudo-levels
   if (lr.eq.16.or.lr.eq.21.or.lr.eq.24.or.lr.eq.26.or.lr.eq.30) yld=2
   if (lr.eq.17.or.lr.eq.25.or.lr.eq.38) yld=3
   if (lr.eq.37) yld=4
   nwa=na
   call disbar(e,ebar,dame,q,za,awr,nend4,matd,mtd,a,nwa)
   go to 180
  150 continue
   q0=q
   if (iimt.ne.0) q0=qs
  160 continue
   icon=2
   nwm=nwmax
   nwa=na
   call conbar(e,ebar,dame,nendf,nscr,matd,mtd,a,nwa,d,nwm,yld,q)
   go to 180
  170 continue
   if (iverf.le.5.and.mth.ge.700.and.mth.le.799) go to 171
   if (iverf.ge.6.and.mth.ge.600.and.mth.le.849) go to 171
   q0=q
   if (idame.gt.0) call capdam(e,dame,q,za,awr,mtd)
   go to 180
  171 continue
   if (iverf.le.5.and.mth.eq.718) go to 174
   if (iverf.le.5.and.mth.eq.738) go to 174
   if (iverf.le.5.and.mth.eq.758) go to 174
   if (iverf.le.5.and.mth.eq.778) go to 174
   if (iverf.le.5.and.mth.eq.798) go to 174
   if (iverf.ge.6.and.mth.eq.649) go to 174
   if (iverf.ge.6.and.mth.eq.699) go to 174
   if (iverf.ge.6.and.mth.eq.749) go to 174
   if (iverf.ge.6.and.mth.eq.799) go to 174
   if (iverf.ge.6.and.mth.eq.849) go to 174
   ! discrete charged-particle levels
   icon=1
   if (iverf.le.5.and.mth.eq.700) qsave=q
   if (iverf.le.5.and.mth.eq.720) qsave=q
   if (iverf.le.5.and.mth.eq.740) qsave=q
   if (iverf.le.5.and.mth.eq.760) qsave=q
   if (iverf.le.5.and.mth.eq.780) qsave=q
   if (iverf.le.5) q0=qsave
   if (iverf.ge.6) q0=t
   yld=1
   nwa=na
   call disbar(e,ebar,dame,q,za,awr,nend4,matd,mtd,a,nwa)
   go to 180
   ! continuum charged-particle emission
  174 continue
   yld=1
   if (iverf.le.5) q0=qsave
   if (iverf.ge.6) q0=t
   if (idame.gt.0) call capdam(e,dame,q,za,awr,mtd)
   go to 180
   ! file 6 reactions
  175 continue
   nwm=nwmax
   nwa=na
   call sixbar(e,ebar,yld,dame,nend6,a,nwa,nscr,d,nwm,n6,j6,irec,jrec,iflag)
   if (ebar.lt.zero) go to 291
   icon=-1
   q0=t
   if (iimt.ne.0) q0=qs
   if ((mtd.ge.18.and.mtd.le.21).or.mtd.eq.38) q0=q
  180 continue
   nmt=0
   if (npk.gt.2) call indx(npk,mtp,mt19,mtd,imt,nmt)
   if (icon.lt.0) go to 179
   if (iprint.ne.1) go to 182
   if (qs.ge.qtest) go to 181
   if ((mtd.ge.18.and.mtd.le.21).or.mtd.eq.38) go to 183
   if (icon.lt.0) go to 179
   if (idame.eq.0) write(nsyso,'(/&
     &'' neutron heating for mt'',i3,''   q0 ='',1p,e12.4,5x,&
     &''q ='',e12.4/14x,''e'',10x,''ebar'',9x,''yield'',10x,&
     &''xsec'',7x,''heating'')') mtd,q0,qendf
   if (idame.gt.0) write(nsyso,'(/&
     &'' neutron heating for mt'',i3,''   q0 ='',1p,e12.4,5x,&
     &''q ='',e12.4/14x,''e'',10x,''ebar'',9x,''yield'',10x,&
     &''xsec'',7x,''heating'',8x,''damage'')') mtd,q0,qendf
   go to 182
  183 continue
   if (idame.eq.0) write(nsyso,'(/&
     &'' neutron heating for mt'',i3,&
     &''   q0= variable fission q''/&
     &14x,''e'',12x,''q0'',10x,''ebar'',9x,''yield'',10x,&
     &''xsec'',7x,''heating'')') mtd
   if (idame.gt.0) write(nsyso,'(/&
     &'' neutron heating for mt'',i3,&
     &''   q0= variable fission q''/&
     &14x,''e'',12x,''q0'',10x,''ebar'',9x,''yield'',10x,&
     &''xsec'',7x,''heating'',8x,''damage'')') mtd
   if (irec.gt.0.and.icon.lt.0) izap=100
   go to 182
  181 continue
   if (idame.eq.0) write(nsyso,'(/&
     &'' neutron heating for mt'',i3,''   q0= variable'',5x,&
     &''q ='',e12.4/14x,''e'',10x,''qbar'',10x,''ebar'',9x,&
     &''yield'',10x,''xsec'',7x,''heating'')') mtd,qendf
   if (idame.gt.0) write(nsyso,'(/&
     &'' neutron heating for mt'',i3,''   q0= variable'',5x,&
     &''q ='',e12.4/14x,''e'',10x,''qbar'',10x,''ebar'',9x,&
     &''yield'',10x,''xsec'',7x,''heating'',8x,''damage'')')&
     &mtd,qendf
   go to 182
  179 continue
   izap=nint(zap)
   if (irec.gt.0) then
      if (mod(izat,1000).eq.0) then
         izap=1000*(izat/1000-izap/1000)
      else
         izap=nint(zat+1-zap)
      endif
   endif
   if (iprint.ne.1) go to 182
   if (qs.ge.qtest) go to 178
   if (idame.eq.0) write(nsyso,'(/&
     &'' file six heating for mt'',i3,'', particle ='',i6,&
     &5x,''q = '',1p,e12.4/14x,''e'',10x,''ebar'',9x,&
     &''yield'',10x,''xsec'',7x,''heating'')') mtd,izap,q0
   if (idame.gt.0) write(nsyso,'(/&
     &'' file six heating for mt'',i3,'', particle ='',i6,&
     &5x,''q = '',1p,e12.4/14x,''e'',10x,''ebar'',9x,&
     &''yield'',10x,''xsec'',7x,''heating'',8x,''damage'')')&
     mtd,izap,q0
   go to 182
  178 continue
   if (idame.eq.0) write(nsyso,'(/&
     &'' file six heating for mt'',i3,'', particle ='',i6,&
     &5x,''q0 = variable''/&
     &14x,''e'',10x,''qbar'',10x,''ebar'',9x,''yield'',10x,&
     &''xsec'',7x,''heating'')') mtd,izap
   if (idame.gt.0) write(nsyso,'(/&
     &'' file six heating for mt'',i3,'', particle ='',i6,&
     &5x,''q0 = variable''/&
     &14x,''e'',10x,''qbar'',10x,''ebar'',9x,''yield'',10x,&
     &''xsec'',7x,''heating'',8x,''damage'')') mtd,izap
  182 continue
   ipx=2
   irx=1
   ipfr=2
   irfr=1
   ipnp=2
   irnp=1
   ipgp=2
   irgp=1
   elst=0
   ilist=1
   if (icon.eq.0) yld=0
   yld0=0

   !--compute heating for energies in union grid.
   nn=0
  190 continue
   nn=nn+1
   call finda(nn,c,npkk,iold,bufo,nbuf)
   e=c(1)
   e=sigfig(e,9,0)
   if (new6.eq.1) c(npkk)=0
   if (mtd.ne.2) go to 193
   if (e.lt.elst.and.nn.lt.ne) go to 193
   if (ilist.gt.ilmax) call error('nheat','storage exceeded.',' ')
   elist(ilist)=e
   elist(ilist+1)=big
   if (e.lt.break1) then
      iii=int(log10(e*(1+small))+small)
      if (log10(e*(1+small)).lt.zero) iii=iii-1
      xxx=ten**iii
      if (2*xxx.gt.e*(1+small).and.e.ge.one*(1-small)) then
         elst=2*xxx
      else if (5*xxx.gt.e*(1+small).and.e.ge.one*(1-small)) then
         elst=5*xxx
      else
         elst=10*xxx
      endif
   else
      test=break4
      test=sigfig(test,9,1)
      if (e.ge.test) elst=step4*int(e/step4+up)
      if (e.lt.test) elst=step3*int(e/step3+up)
      test=break3
      test=sigfig(test,9,1)
      if (e.lt.test) elst=step2*int(e/step2+up)
      test=break2
      test=sigfig(test,9,1)
      if (e.lt.test) elst=step1*int(e/step1+up)
   endif
   elst=elst-elst/10000000
  193 continue
   if (e.lt.thresh) go to 290
   call gety1(e,enext,idis,y,nin,b) ! y is the reaction cross section
   ! check for energy-dependent q
   if (iimt.gt.0) then
      if (qa(iimt).ge.qtest) then
         lq0=lqs(iimt)
         call terpa(q0,e,enx,idx,qbar(lq0),ipx,irx)
         q=q0
      endif
   endif
   if (icon.eq.1) call disbar(e,ebar,dame,q,za,awr,&
     nend4,matd,mtd,a,nwa)
   if (icon.eq.2) call conbar(e,ebar,dame,nendf,nscr,matd,mtd,&
     a,nwa,d,nwm,yld,q)
   if (icon.eq.0.and.idame.gt.0) call capdam(e,dame,q,za,awr,mtd)
   if (icon.lt.0)&
     call sixbar(e,ebar,yld,dame,nend6,a,nwa,nscr,d,nwm,n6,j6,irec,jrec,iflag)
   if (yld0.eq.zero) yld0=yld
   ! correct fission q for current incident energy
   if ((mtd.ge.18.and.mtd.le.21).or.mtd.eq.38) then
      if (lfc.eq.0) then     ! thermal point or polynomial
         if (nply.eq.0) then
            q0=cpoly(0)-(yld-yld0)*fq1+fq2*e
            if (mt458.eq.1) then
               h0=hpoly(0)
            else
               h0=q0-ebar*yld
            endif
         else
            q0=cpoly(nply)
            h0=hpoly(nply)
            do i=nply-1,0,-1
               q0=q0*e+cpoly(i)
               h0=h0*e+hpoly(i)
            enddo
         endif
         pnue=q0-h0
      else                   ! tabulated
         if (etabmax.lt.e.and.((abs(etabmax-e)/etabmax).gt.tol)) then
            write(strng,'(''upper energy tabulated fission q components'',&
               &'' is too low.'')')
            call error('nheat',strng,' ')
         endif
         if (ifc1.eq.1) then
            call terpa(qfr,e,enx,idx,afr,ipfr,irfr)
         else
            qfr=c458(1)
         endif
         if (ifc2.eq.1) then
            call terpa(qnp,e,enx,idx,anp,ipnp,irnp)
         else
            qnp=c458(3)-(yld-yld0)*fq1+fq2*e
         endif
         if (ifc4.eq.1) then
            call terpa(qgp,e,enx,idx,agp,ipgp,irgp)
         else
            qgp=c458(7)
         endif
         pnue=qnp
         h0=qfr+qgp
         q0=h0+pnue
      endif
      q0=q0-e
   endif
   if (icon.ge.0) then
      ebal6=0
      dame=dame*y
      if ((mtd.lt.18.or.mtd.gt.21).and.mtd.ne.38) then
         h=(e+q0-ebar*yld)*y
      else
         h=h0*y
      endif
   else
      if ((mtd.lt.18.or.mtd.gt.21).and.mtd.ne.38) then
         h=ebar*yld*y
      else
         h=h0*y
      endif
      dame=dame*y
      c(npkk)=c(npkk)+h
      if (izap.eq.0) c(npkk-1)=c(npkk-1)+h
      if (izap.eq.0.and.npkkk.gt.0) c(npkkk)=c(npkkk)+h
      if (izap.eq.1) h=0
      if (izap.eq.0.and.local.eq.0) h=0
      if (izap.le.1) dame=0
      ebal6=0
      if (last6.eq.1.and.mth.ne.5.and.mth.ne.102)&
        ebal6=(e+q0)*y-c(npkk)
      if ((mtd.ge.18.and.mtd.le.21).or.mtd.eq.38) ebal6=0
   endif
   if (mtd.ge.46.and.mtd.le.49) then
      ! treat second neutron from sequential (n,2n), mt=46-49.
      if (qs.ge.zero) call error('nheat',&
        'binding energy for sequential n2n needed.',' ')
      h=(qs-ebar)*y
   endif

   !--accumulate total and partial heating factors.
   c(2)=c(2)+h+ebal6
   if ((mtd.ge.18.and.mtd.le.21).or.mtd.eq.38) ebar=pnue/yld
   ebarp=sigfig(ebar,9,0)
   yldp=sigfig(yld,9,0)
   yp=sigfig(y,9,0)
   hp=sigfig(h,9,0)
   damep=sigfig(dame,9,0)
   ebal6p=sigfig(ebal6,9,0)
   if (iprint.ne.1.or.abs(e-elist(ilist)).gt.small*e&
     .or.y.le.smin) go to 199
   if (qs.ge.qtest) go to 198
   if ((mtd.ge.18.and.mtd.le.21).or.mtd.eq.38) go to 198
   if (idame.eq.0) then
      write(nsyso,'(1x,1p,7e14.4)') e,ebarp,yldp,yp,hp
   else
      write(nsyso,'(1x,1p,7e14.4)') e,ebarp,yldp,yp,hp,damep
   endif
   go to 199
  198 continue
   if (idame.eq.0) then
      write(nsyso,'(1x,1p,7e14.4)') e,q0,ebarp,yldp,yp,hp
   else
      write(nsyso,'(1x,1p,7e14.4)') e,q0,ebarp,yldp,yp,hp,damep
   endif
  199 continue
   if (abs(ebal6).ge.100*y) then
      if (iprint.eq.1.and.abs(e-elist(ilist)).le.small*e&
        .and.y.gt.smin) then
         if (qs.lt.qtest) then
            write(nsyso,'(53x,''ebal'',1p,e14.4)') ebal6p
         else
            write(nsyso,'(67x,''ebal'',1p,e14.4)') ebal6p
         endif
      endif
   endif
   if (nmt.ne.0) then
      ! partial kermas
      do ii=1,nmt
         indxx=imt(ii)
         if (mtp(indxx).ge.444) c(indxx)=c(indxx)+dame
         if (mtp(indxx).lt.442) c(indxx)=c(indxx)+h+ebal6
      enddo
   endif

   !--compute kinematic limits on heating, if desired.
   if (kchk.eq.0) go to 290
   if (icon.lt.0) go to 275
   if (mtd.ne.2) go to 215
   hmin=h
   hmax=hmin
   go to 285
  215 continue
   if (mtd.ne.102) go to 220
   hmin=y*e*aw1fac
   tt=q+awr*e*aw1fac
   hmax=hmin+y*tt*tt*rtm/2
   go to 285
  220 continue
   if (mtd.ge.51.and.mtd.lt.91) go to 221
   if (iverf.le.5.and.mtd.ge.700.and.mtd.lt.718) go to 221
   if (iverf.le.5.and.mtd.ge.720.and.mtd.lt.738) go to 221
   if (iverf.le.5.and.mtd.ge.740.and.mtd.lt.758) go to 221
   if (iverf.le.5.and.mtd.ge.760.and.mtd.lt.778) go to 221
   if (iverf.le.5.and.mtd.ge.780.and.mtd.lt.798) go to 221
   if (iverf.ge.6.and.mtd.ge.600.and.mtd.lt.649) go to 221
   if (iverf.ge.6.and.mtd.ge.650.and.mtd.lt.699) go to 221
   if (iverf.ge.6.and.mtd.ge.700.and.mtd.lt.749) go to 221
   if (iverf.ge.6.and.mtd.ge.750.and.mtd.lt.799) go to 221
   if (iverf.ge.6.and.mtd.ge.800.and.mtd.lt.849) go to 221
   go to 230
  221 continue
   hmin=(e+q-ebar*yld)*y
   hmin=(e+q-ebar*yld)*y
   hmax=hmin
   if (lr.ne.0.and.lr.ne.31) hmax=(e+q0-ebar*yld)*y
   go to 285
  230 continue
   if (mtd.ne.91) go to 240
   hmin=y*(e+ebar)*awfac
   hmax=hmin
   if (lr.ne.0.and.lr.ne.31) hmax=(e+q0-ebar)*y
   go to 285
  240 continue
   if (mtd.lt.103) go to 250
   hmin=y*e*awfac
   hmax=h
   go to 285
  250 continue
   if (mtd.ne.18.and.mtd.ne.20.and.mtd.ne.21.and.mtd.ne.38) go to 260
   hmin=y*(e+q0-ebar*yld/2-efis)
   hmax=h
   go to 285
  260 continue
   test=10
   if (mtd.ne.16.or.awr.lt.test) go to 265
   hmin=0
   hmax=y*(e+ebar)/(awr-1)
   if (hmax.gt.h) hmax=h
   go to 285
  265 continue
   test=10
   if (mtd.ne.17.or.awr.lt.test) go to 270
   hmin=0
   hmax=y*(e+2*ebar)/(awr-2)
   if (hmax.gt.h) hmax=h
   go to 285
  270 continue
   hmin=0
   hmax=h
   go to 285
  275 continue
   hmin=h
   hmax=h
  285 continue
   npkt=npk-1
   if (kchk.ne.1) go to 283
   c(2+npkt)=c(2+npkt)+hmin
   c(2+2*npkt)=c(2+2*npkt)+hmax
  283 continue
   if (nmt.eq.0) go to 290
   do 286 ii=1,nmt
   indxx=imt(ii)
   if (mtp(indxx).eq.442) go to 286
   if (mtp(indxx).eq.443) go to 284
   if (mtp(indxx).ge.444) go to 286
   if (kchk.ne.1) go to 286
   c(indxx+npkt)=c(indxx+npkt)+hmin
   c(indxx+2*npkt)=c(indxx+2*npkt)+hmax
   go to 286
  284 continue
   c(indxx)=c(indxx)+hmax
  286 continue

   !--store results on scratch and go to next energy.
  290 continue
   intt=nn
   if (intt.eq.ne) intt=-intt
   call loada(intt,c,npkk,inew,bufn,nbuf)
   if (e.eq.elist(ilist)) ilist=ilist+1
   if (nn.lt.ne) go to 190

   !--for file 6, loop over subsections
   isave=iold
   iold=inew
   inew=isave
  291 continue
   if (j6.ge.n6) then
      ! make sure we're at the end of section (will not be so if
      ! there was no particle distribution for the last subsection
      ! in this section).
      if (ebar.lt.zero) then
         call tosend(nin,0,0,b)
         call skiprz(nin,-1)
      endif
      go to 296
   endif
   call skiprz(nin,-2)
   call findf(matd,3,mtd,nin)
   go to 297
  296 continue
   if (j6.eq.0) go to 297
   if (irec.gt.0.and.mt6no(i6g).gt.0) go to 293
   if (iprint.eq.1.and.i6g.gt.0.and.izap.ne.0.and.iflag.eq.0)&
     write(nsyso,'(/''   no explicit file 6 photon production for mt'',i3)')&
     mtd
   if (mt6no(i6g).ne.0) then
      if (mth.ne.102 ) write(nsyso,'(/&
        &''   generating recoil with one-particle approx.'')')
      if (mth.eq.102 ) write(nsyso,'(/&
        &''   generating recoil from photon momentum.'')')
      irec=mt6no(i6g)
      call skiprz(nin,-2)
      call findf(matd,3,mtd,nin)
      go to 297
   endif
  293 continue
   irec=0
   jrec=0
   j6=0
   n6=0
  297 continue
   go to 105

   !--nheat is finished.
  300 continue
   deallocate(b)
   deallocate(d)
   deallocate(a)
   deallocate(scr)
   deallocate(bufn)
   deallocate(bufo)
   call skiprz(nin,-4)
   return
   end subroutine nheat

   subroutine indx(npk,mtp,mt19,mt,imt,nmt)
   !-------------------------------------------------------------------
   ! Find the index of a given MT in the stored desired MT array.
   ! Heating identifiers
   !     300 + MT for reaction
   ! Special values allowed are
   !     303=nonelastic (all but MT2)
   !     304=inelastic (MTs1-91)
   !     318=fission (MT18 or MT19-21 and MT38)
   !     401=disappearance (MT102-120)
   !     442=total photon ev-barns in kerma
   !     443=kinematic kerma
   ! Damage energy identifiers
   !     444=total
   !     445=elastic
   !     446=inelastic (MT51-MT91)
   !     447=total capture (MT102-MT120)
   !-------------------------------------------------------------------
   use endf ! provides iverf
   ! externals
   integer::npk,mtp(*),mt19,mt,imt(*),nmt
   ! internals
   integer::i,mtpi,iflag

   nmt=0
   if (npk.lt.3) return
   do i=3,npk
      mtpi=mtp(i)
      iflag=0
      if (mtpi.eq.442) iflag=1
      if (mtpi.eq.443) iflag=1
      if (mtpi.eq.444) iflag=1
      if (mtpi.eq.445.and.mt.eq.2) iflag=1
      if (mtpi.eq.446.and.mt.ge.51.and.mt.le.91) iflag=1
      if (mtpi.eq.447.and.mt.ge.102.and.mt.le.120) iflag=1
      if (iverf.lt.6) then
         if (mtpi.eq.447.and.mt.ge.700.and.mt.le.799) iflag=1
      else
         if (mtpi.eq.447.and.mt.ge.600.and.mt.le.849) iflag=1
      endif
      if (mtpi.eq.303.and.mt.ne.2.and.mt.ne.3) iflag=1
      if (mtpi.eq.304.and.mt.ge.51.and.mt.le.91) iflag=1
      if (mtpi.eq.318) then
         if (mt19.eq.0.and.mt.eq.18) iflag=1
         if (mt19.eq.1.and.(mt.eq.19.or.&
           mt.eq.20.or.mt.eq.21.or.mt.eq.38)) iflag=1
         if (mt19.eq.2.and.mt.eq.18) iflag=1
      endif
      if (mtpi.eq.401) then
         if (mt.ge.102.and.mt.le.120) iflag=1
         if (iverf.lt.6.and.mt.ge.700.and.mt.lt.800) iflag=1
         if (iverf.ge.6.and.mt.ge.600.and.mt.lt.850) iflag=1
      endif
      if (iverf.lt.6) then
         if (mtpi.eq.403.and.mt.ge.700.and.mt.le.719) iflag=1
         if (mtpi.eq.404.and.mt.ge.720.and.mt.le.739) iflag=1
         if (mtpi.eq.405.and.mt.ge.740.and.mt.le.759) iflag=1
         if (mtpi.eq.406.and.mt.ge.760.and.mt.le.779) iflag=1
         if (mtpi.eq.407.and.mt.ge.780.and.mt.le.799) iflag=1
      else
         if (mtpi.eq.403.and.mt.ge.600.and.mt.le.649) iflag=1
         if (mtpi.eq.404.and.mt.ge.650.and.mt.le.699) iflag=1
         if (mtpi.eq.405.and.mt.ge.700.and.mt.le.749) iflag=1
         if (mtpi.eq.406.and.mt.ge.750.and.mt.le.799) iflag=1
         if (mtpi.eq.407.and.mt.ge.800.and.mt.le.849) iflag=1
      endif
      if (mtpi.eq.mt+300) iflag=1
      if (iflag.eq.1) then
         nmt=nmt+1
         imt(nmt)=i
      endif
   enddo
   return
   end subroutine indx

   subroutine capdam(ee,dame,q,za,awr,mtd)
   !-------------------------------------------------------------------
   ! Compute damage energy for capture reactions.
   !-------------------------------------------------------------------
   use endf    ! provides iverf,terp1
   ! externals
   integer::mtd
   real(kr)::ee,dame,q,za,awr
   ! internals
   integer::iq,iz
   real(kr)::e,zx,ax,denom,z,en,aw1fac
   real(kr)::damn,daml,el,er,ea,ec,et
   real(kr),dimension(4),parameter::qp=(/&
      -.86114e0_kr,-.33998e0_kr,.33998e0_kr,.86114e0_kr/)
   real(kr),dimension(4),parameter::qw=(/&
     .34785e0_kr,.65215e0_kr,.65215e0_kr,.34785e0_kr/)
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::econ=1.029e6_kr
   real(kr),parameter::eps=1.e-10_kr
   real(kr),parameter::step=1.1e0_kr
   integer,parameter::nq=4
   real(kr),parameter::zero=0
   save en,damn,el,daml
   save zx,ax,denom,z,aw1fac

   !--initialize
   e=ee
   if (e.eq.zero) then
      zx=0
      if (mtd.gt.102) zx=1
      if (mtd.eq.106.or.mtd.eq.107) zx=2
      if (iverf.le.5.and.(mtd.eq.778.or.mtd.eq.798)) zx=2
      ax=0
      if (mtd.gt.102) ax=1
      if (mtd.eq.104) ax=2
      if (iverf.le.5.and.mtd.eq.738) ax=2
      if (mtd.eq.105.or.mtd.eq.106) ax=3
      if (iverf.le.5.and.(mtd.eq.758.or.mtd.eq.778)) ax=3
      if (mtd.eq.107) ax=4
      if (iverf.le.5.and.mtd.eq.798) ax=4
      denom=1/awr**third
      if (ax.ne.zero) denom=1/(ax**third+awr**third)
      iz=nint(za/1000)
      z=iz
      en=0
      damn=df(en,z-zx,awr+1-ax,z,awr)
      dame=0
      aw1fac=1/(awr+1)
      return
   endif

   !--normal entry
   !--if energy not in current range,
   !--construct new interpolation range.
   if (ee.ge.en*(1-eps)) then
      el=en
      daml=damn
      e=step*el
      if (e.lt.ee*(1-eps)) e=(1-eps)*ee
      dame=0
      if (mtd.eq.102) then
         ! capture followed by gamma emission
         er=e*aw1fac
         ea=awr*er+q
         er=er+ea*ea*rtm/2
         dame=df(er,z,awr+1,z,awr)
      else if (ax.ne.zero) then
         ! capture followed by particle emission
         ec=econ*zx*z*denom
         ea=q+awr*e*aw1fac
         if (ea.ge.zero) then
            et=(awr+1-ax)*e*aw1fac
            if (ea.gt.ec*(1+eps)) ea=ec
            do iq=1,nq
               er=(et-2*sqrt(et*ax*ea)*qp(iq)+ax*ea)*aw1fac
               dame=dame+qw(iq)*df(er,z-zx,awr+1-ax,z,awr)/2
            enddo
         endif
      endif
      en=e
      damn=dame
   endif

   !--interpolate for damage energy
   call terp1(el,daml,en,damn,ee,dame,2)
   return
   end subroutine capdam

   subroutine disbar(ee,ebar,dame,q,za,awr,ntape,matd,mtd,a,nwa)
   !-------------------------------------------------------------------
   ! Compute ebar and damage energy for discrete scattering.
   !-------------------------------------------------------------------
   use endf ! provides iverf,terp1
   use mathm ! provides legndr
   use physics !get global physics and light particle mass constants
   ! externals
   integer::ntape,matd,mtd,nwa
   real(kr)::ee,ebar,dame,q,za,awr,a(*)
   ! internals
   integer::imiss,i,mfd,nld,lcd,idis,iz,iq,il
   real(kr)::e,thresh,awp,afact,arat,en,cn,el,cl,z
   real(kr)::daml,damn,enx,enext,u,f,e2,ce,r,b,g,test,wbar
   real(kr)::fl(65),p(65)
   integer,parameter::nq=64
   real(kr),dimension(64),parameter::qp=(/&
     -9.99305042E-01_kr,-9.96340117E-01_kr,-9.91013371E-01_kr,&
     -9.83336254E-01_kr,-9.73326828E-01_kr,-9.61008800E-01_kr,&
     -9.46411375E-01_kr,-9.29569172E-01_kr,-9.10522137E-01_kr,&
     -8.89315446E-01_kr,-8.65999398E-01_kr,-8.40629296E-01_kr,&
     -8.13265315E-01_kr,-7.83972359E-01_kr,-7.52819907E-01_kr,&
     -7.19881850E-01_kr,-6.85236313E-01_kr,-6.48965471E-01_kr,&
     -6.11155355E-01_kr,-5.71895646E-01_kr,-5.31279464E-01_kr,&
     -4.89403146E-01_kr,-4.46366017E-01_kr,-4.02270158E-01_kr,&
     -3.57220158E-01_kr,-3.11322872E-01_kr,-2.64687162E-01_kr,&
     -2.17423644E-01_kr,-1.69644420E-01_kr,-1.21462819E-01_kr,&
     -7.29931218E-02_kr,-2.43502927E-02_kr, 2.43502927E-02_kr,&
      7.29931218E-02_kr, 1.21462819E-01_kr, 1.69644420E-01_kr,&
      2.17423644E-01_kr, 2.64687162E-01_kr, 3.11322872E-01_kr,&
      3.57220158E-01_kr, 4.02270158E-01_kr, 4.46366017E-01_kr,&
      4.89403146E-01_kr, 5.31279464E-01_kr, 5.71895646E-01_kr,&
      6.11155355E-01_kr, 6.48965471E-01_kr, 6.85236313E-01_kr,&
      7.19881850E-01_kr, 7.52819907E-01_kr, 7.83972359E-01_kr,&
      8.13265315E-01_kr, 8.40629296E-01_kr, 8.65999398E-01_kr,&
      8.89315446E-01_kr, 9.10522137E-01_kr, 9.29569172E-01_kr,&
      9.46411375E-01_kr, 9.61008800E-01_kr, 9.73326828E-01_kr,&
      9.83336254E-01_kr, 9.91013371E-01_kr, 9.96340117E-01_kr,&
      9.99305042E-01_kr/)
   real(kr),dimension(64),parameter::qw=(/&
      1.78328072E-03_kr, 4.14703326E-03_kr, 6.50445797E-03_kr,&
      8.84675983E-03_kr, 1.11681395E-02_kr, 1.34630479E-02_kr,&
      1.57260305E-02_kr, 1.79517158E-02_kr, 2.01348232E-02_kr,&
      2.22701738E-02_kr, 2.43527026E-02_kr, 2.63774697E-02_kr,&
      2.83396726E-02_kr, 3.02346571E-02_kr, 3.20579284E-02_kr,&
      3.38051618E-02_kr, 3.54722133E-02_kr, 3.70551285E-02_kr,&
      3.85501532E-02_kr, 3.99537411E-02_kr, 4.12625632E-02_kr,&
      4.24735151E-02_kr, 4.35837245E-02_kr, 4.45905582E-02_kr,&
      4.54916279E-02_kr, 4.62847966E-02_kr, 4.69681828E-02_kr,&
      4.75401657E-02_kr, 4.79993886E-02_kr, 4.83447622E-02_kr,&
      4.85754674E-02_kr, 4.86909570E-02_kr, 4.86909570E-02_kr,&
      4.85754674E-02_kr, 4.83447622E-02_kr, 4.79993886E-02_kr,&
      4.75401657E-02_kr, 4.69681828E-02_kr, 4.62847966E-02_kr,&
      4.54916279E-02_kr, 4.45905582E-02_kr, 4.35837245E-02_kr,&
      4.24735151E-02_kr, 4.12625632E-02_kr, 3.99537411E-02_kr,&
      3.85501532E-02_kr, 3.70551285E-02_kr, 3.54722133E-02_kr,&
      3.38051618E-02_kr, 3.20579284E-02_kr, 3.02346571E-02_kr,&
      2.83396726E-02_kr, 2.63774697E-02_kr, 2.43527026E-02_kr,&
      2.22701738E-02_kr, 2.01348232E-02_kr, 1.79517158E-02_kr,&
      1.57260305E-02_kr, 1.34630479E-02_kr, 1.11681395E-02_kr,&
      8.84675983E-03_kr, 6.50445797E-03_kr, 4.14703326E-03_kr,&
      1.78328072E-03_kr/)
   real(kr),parameter::edis=25.e0_kr
   real(kr),parameter::step=1.1e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::zero=0
   save imiss,thresh,awp,afact,arat
   save en,cn,el,cl,z,daml,damn,enx,enext

   !--initialize if e=0.
   e=ee
   if (e.eq.zero) then
      imiss=0
      do i=1,nmiss4
         if (miss4(i).eq.mtd) imiss=1
      enddo
      if (imiss.ne.1) then
         mfd=4
         nld=60
         lcd=2
         call hgtfle(e,enext,idis,fl,nld,lcd,matd,mfd,mtd,&
           ntape,a,nwa)
      else
         nld=1
         enext=etop
      endif
      thresh=((awr+1)/awr)*(-q)
      awp=1
      if (iverf.le.5.and.mtd.ge.700.and.mtd.lt.718) awp=pnratio
      if (iverf.le.5.and.mtd.ge.720.and.mtd.lt.738) awp=dnratio
      if (iverf.le.5.and.mtd.ge.740.and.mtd.lt.758) awp=tnratio
      if (iverf.le.5.and.mtd.ge.760.and.mtd.lt.778) awp=hnratio
      if (iverf.le.5.and.mtd.ge.780.and.mtd.lt.798) awp=anratio
      if (iverf.ge.6.and.mtd.ge.600.and.mtd.lt.649) awp=pnratio
      if (iverf.ge.6.and.mtd.ge.650.and.mtd.lt.699) awp=dnratio
      if (iverf.ge.6.and.mtd.ge.700.and.mtd.lt.749) awp=tnratio
      if (iverf.ge.6.and.mtd.ge.750.and.mtd.lt.799) awp=hnratio
      if (iverf.ge.6.and.mtd.ge.800.and.mtd.lt.849) awp=anratio
      afact=awp/((awr+1)**2)
      arat=awp/(awr+1-awp)
      en=0
      cn=0
      el=0
      cl=0
      enx=0
      if (idame.ne.0) then
         iz=nint(za/1000)
         z=iz
         damn=df(e,z,awr,z,awr)
         daml=damn
         if (mtd.eq.2) then
            daml=0
            enx=edis*arat/(4*afact)
            damn=0
         endif
      endif
      return
   endif

   !--normal entry.
   if (ee.le.en*(1+small)) go to 130
   el=en
   cl=cn
   if (idame.ne.0) daml=damn
   e=step*el
   if (enext.lt.e*(1-small)) e=enext
   if (ee.gt.e*(1+small)) e=ee
   r=1
   if (mtd.ne.2) then
      if (thresh.ge.e*(1-small)) then
         r=0
      else
         r=sqrt(1-thresh/e)
      endif
   endif
   if (imiss.ne.1) then
      mfd=4
      nld=60
      lcd=2
      call hgtfle(e,enext,idis,fl,nld,lcd,matd,mfd,mtd,ntape,a,nwa)
   else
      nld=1
      fl(1)=1
      fl(2)=0
   endif
   en=e
   b=r*sqrt(awr/arat)
   g=b*arat
   cn=0
   test=1
   test=test/1000000
   if (abs(awp-1).gt.test) go to 120

   !--compute ebar
   wbar=fl(2)
   if (wbar.gt.qp(64)) wbar=qp(64)
   cn=(1+2*b*wbar+b*b)*afact
   if (idame.eq.0) go to 130
   if (e.lt.enx*(1-small)) go to 130

   !--angle integration by gauss-legendre method.
  120 continue
   dame=0
   do iq=1,nq
      u=qp(iq)
      call legndr(u,p,nld)
      f=0
      do il=1,nld
         f=f+(2*il-1)*fl(il)*p(il)/2
      enddo
      e2=e*(1-2*g*u+g*g)*afact/arat
      dame=dame+qw(iq)*f*df(e2,z,awr,z,awr)
   enddo
   if (dame.lt.zero) dame=zero
   damn=dame

   !--interpolate for results.
  130 continue
   call terp1(el,cl,en,cn,ee,ce,2)
   ebar=ee*ce
   if (idame.gt.0) then
      call terp1(el,daml,en,damn,ee,dame,2)
   endif
   return
   end subroutine disbar

   real(kr) function df(e,zr,ar,zl,al)
   !-------------------------------------------------------------------
   ! Damage function using the Lindhard partition of
   ! energy between atomic and electronic motion.
   ! Call with e=0 for each reaction to precompute the constants.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::e,zr,ar,zl,al
   ! internals
   real(kr)::el,rel,denom,fl,ep,dam
   real(kr),parameter::twothd=.666666667e0_kr
   real(kr),parameter::threeq=.75e0_kr
   real(kr),parameter::sixth=.166666667e0_kr
   real(kr),parameter::onep5=1.5e0_kr
   real(kr),parameter::c1=30.724e0_kr
   real(kr),parameter::c2=.0793e0_kr
   real(kr),parameter::c3=3.4008e0_kr
   real(kr),parameter::c4=.40244e0_kr
   real(kr),parameter::zero=0
   save rel,fl

   if (zr.eq.zero) then
      df=0
   else if (e.le.zero) then
      el=c1*zr*zl*sqrt(zr**twothd+zl**twothd)*(ar+al)/al
      rel=1/el
      denom=(zr**twothd+zl**twothd)**threeq*ar**onep5*sqrt(al)
      fl=c2*zr**twothd*sqrt(zl)*(ar+al)**onep5/denom
      df=0
   else if (e.lt.break) then
      df=0
   else
      ep=e*rel
      dam=e/(1+fl*(c3*ep**sixth+c4*ep**threeq+ep))
      df=dam
   endif
   return
   end function df

   subroutine conbar(e,ebar,dame,nin,nscr,matd,mtd,&
     c,ncmax,b,nbmax,yld,q)
   !-------------------------------------------------------------------
   ! Calculate neutron ebar and damage energy
   ! for continuum scattering reactions.
   ! Damage for (n,np), (n,na), etc., is currently treated like
   ! damage for (n,p), (n,a), etc.  neutron recoil is ignored.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nscr,matd,mtd,ncmax,nbmax
   real(kr)::e,ebar,dame,c(ncmax),b(nbmax),yld,q
   ! internals
   integer::l,mf1,mt1,mfd,idis,nb,nw,iz,il,ik,nktot
   integer::ip,ir,idisc,nr,np,ll,nnr,inn,ie,idone,ii,mtt
   integer::lf,nne,lnow,iraw,ne
   real(kr)::enext,t1,t2,ehi,fhi,dhi,pe,eihi,etp,f,d,s
   real(kr)::awr,awfac,aw1fac,z,za
   integer,parameter::nkmax=12
   integer::loc(nkmax)
   real(kr)::d1(nkmax),d2(nkmax),e1(nkmax),e2(nkmax)
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::step=1.5e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::zero=0
   save nktot,awr,awfac,aw1fac,z,za,mtt
   save loc,d1,d2,e1,e2,mf1,mt1

   !--initialize if e=0.
   if (e.eq.zero) then
      l=1
      if ((mtd.lt.18.or.mtd.gt.21).and.mtd.ne.38) then
         yld=1
         if (mtd.eq.16.or.mtd.eq.30) yld=2
         if (mtd.eq.24.or.mtd.eq.26) yld=2
         if (mtd.eq.11.or.mtd.eq.41) yld=2
         if (mtd.eq.17.or.mtd.eq.25) yld=3
         if (mtd.eq.38.or.mtd.eq.42) yld=3
         if (mtd.eq.37) yld=4
      else
         mf1=1
         mt1=452
         if (nply.gt.0) mt1=456
         ! delayed neutrons are treated the same as fast neutrons.
         ! this will cause a slight overestimate of en for fission.
         ! ... but when nply.ne.0, use prompt neutron data only
         call hgtyld(e,enext,idis,yld,matd,mf1,mt1,nscr,b,nbmax)
      endif
      mfd=5
      call findf(matd,mfd,mtd,nin)
      call contio(nin,0,0,c(l),nb,nw)
      nktot=nint(c(5))
      if (nktot.gt.nkmax) call error('conbar','nktot gt nkmax.',' ')
      awr=c(2)
      awfac=1/awr
      aw1fac=1/(awr+1)
      iz=nint(c(1)/1000)
      z=iz
      ! treat damage for (n,np) as (n,p),etc.
      za=c(1)
      mtt=0
      if (mtd.eq.22) mtt=107
      if (mtd.eq.28) mtt=103
      if (mtd.eq.32) mtt=104
      if (mtd.eq.33) mtt=105
      if (mtd.eq.34) mtt=106
      if (mtt.gt.0) call capdam(e,dame,q,za,awr,mtt)
      ne=0
      il=1
      ik=0
      do while (ik.lt.nktot)
         ik=ik+1
         d2(ik)=0
         e2(ik)=0
         loc(ik)=il
         l=il
         call tab1io(nin,0,0,c(l),nb,nw)
         l=l+nw
         do while (nb.ne.0)
            call moreio(nin,0,0,c(l),nb,nw)
            l=l+nw
         enddo
         lf=nint(c(il+3))
         il=l

         !--analytic subsection.
         if (lf.gt.1) then
            if (lf.eq.3) then
               t1=(awr*awr+1)*aw1fac*aw1fac
               t2=awr*aw1fac
            else
               call tab1io(nin,0,0,c(l),nb,nw)
               l=l+nw
               do while (nb.ne.0)
                  if (l.gt.ncmax) call error('conbar',&
                    'insufficient storage for raw endf data.',' ')
                  call moreio(nin,0,0,c(l),nb,nw)
                  l=l+nw
               enddo
               il=l
               if (lf.eq.5.or.lf.eq.11) then
                  call tab1io(nin,0,0,c(l),nb,nw)
                  l=l+nw
                  do while (nb.ne.0)
                     if (l.gt.ncmax) call error('conbar',&
                       'insufficient storage for raw endf data.',' ')
                     call moreio(nin,0,0,c(l),nb,nw)
                     l=l+nw
                  enddo
                  il=l
               endif
            endif

         !--tabulated subsection
         else
            call tab2io(nin,0,0,c(l),nb,nw)
            ne=nint(c(l+5))
            l=l+nw
            nne=0
            lnow=l
            iraw=lnow+3*ne

            !--read spectrum for each incident energy
            !--compute heating and damage contributions
            do while (nne.lt.ne)
               l=iraw
               call tab1io(nin,0,0,c(l),nb,nw)
               l=l+nw
               do while (nb.ne.0)
                  if (l.gt.ncmax) call error('conbar',&
                    'insufficient storage for raw endf data.',' ')
                  call moreio(nin,0,0,c(l),nb,nw)
                  l=l+nw
               enddo
               nne=nne+1
               ehi=c(iraw+1)
               call tabbar(fhi,c(iraw),lf)
               dhi=0
               if (idame.ne.0) then
                  if (mtt.ne.0) then
                     call capdam(ehi,dhi,q,za,awr,mtt)
                  else
                     call tabdam(ehi,dhi,z,awr,awfac,c(iraw))
                  endif
               endif
               c(lnow+3*(nne-1))=ehi
               c(lnow+3*(nne-1)+1)=fhi
               c(lnow+3*(nne-1)+2)=dhi
            enddo
            il=lnow+3*ne
         endif
      enddo
      return
   endif

   !--normal entry.
   enext=emax
   idis=0
   ebar=0
   dame=0

   !--get energy dependent yld.
   if (mtd.eq.18.or.mtd.eq.19.or.mtd.eq.20.or.mtd.eq.21.or.mtd.eq.38) then
      mf1=1
      call hgtyld(e,enext,idis,yld,matd,mf1,mt1,nscr,b,nbmax)
   endif

   !--loop over subsections.
   do ik=1,nktot
      lnow=loc(ik)
      lf=nint(c(lnow+3))

      !--interpolate for fractional probability.
      ip=2
      ir=1
      call terpa(pe,e,eihi,idisc,c(lnow),ip,ir)
      if (abs(eihi-enext).lt.small*enext.and.idisc.gt.idis) idis=idisc
      if (eihi.lt.enext*(1-small)) idis=idisc
      if (eihi.lt.enext*(1-small)) enext=eihi
      nr=nint(c(lnow+4))
      np=nint(c(lnow+5))
      ll=lnow+6+2*nr+2*(np-1)
      etp=c(ll)
      if (pe.gt.zero) then

         !--tabulated subsection.
         !--interpolate for results
         if (lf.eq.1) then
            lnow=lnow+6+2*nr+2*np
            ne=nint(c(lnow+5))
            nnr=nint(c(lnow+4))
            inn=2
            lnow=lnow+6+2*nnr
            ie=0
            idone=0
            do while (ie.lt.ne.and.idone.eq.0)
               ie=ie+1
               if (c(lnow+3*ie).ge.e*(1-small)) then
                  ii=lnow+3*(ie-1)
                  idone=1
               endif
            enddo
            if (idone.eq.0) ii=lnow+3*(ne-1)
            call terp1(c(ii),c(ii+1),c(ii+3),c(ii+4),e,f,inn)
            ebar=ebar+f*pe
            if (idame.ne.0) then
               call terp1(c(ii),c(ii+2),c(ii+3),c(ii+5),e,d,inn)
               dame=dame+d*pe
            endif

         !--analytic subsection.
         else
            call anabar(s,e,c(lnow),t1,t2)
            ebar=ebar+s*pe
            if (idame.ne.0) then
               if (mtt.ne.0) then
                  call capdam(e,dame,q,za,awr,mtt)
               else
                  if (e.ge.e2(ik)*(1-small)) then
                     idone=0
                     do while (idone.eq.0)
                        d1(ik)=d2(ik)
                        e1(ik)=e2(ik)
                        e2(ik)=step*e1(ik)
                        if (e2(ik).gt.etp*(1+small)) e2(ik)=etp
                        if (e1(ik).eq.zero) e2(ik)=e
                        call anadam(e2(ik),d2(ik),z,awr,c(lnow))
                        if (abs(e2(ik)-etp).lt.small*etp) then
                           idone=1
                        else
                           if (e1(ik).ne.zero.and.&
                             e.le.e2(ik)*(1+small)) idone=1
                        endif
                     enddo
                  endif
                  call terp1(e1(ik),d1(ik),e2(ik),d2(ik),e,d,2)
                  dame=dame+d*pe
               endif
            endif
         endif
      endif
   enddo
   end subroutine conbar

   subroutine hgtyld(e,enext,idis,yld,mat,mf,mt,itape,a,na)
   !-------------------------------------------------------------------
   ! Retrieve or compute yield for requested mat,mf,mt on itape.
   ! If mt=455, retrieve delayed neutron time constants.
   ! Initialize if e=0.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::idis,mat,mf,mt,itape,na
   real(kr)::e,enext,yld,a(*)
   ! internals
   integer::nb,nw,lnu,lnd,loc,ip,ir,nr,i,nc
   real(kr)::term
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::zero=0
   save lnu,ip,ir

   !--initialize.
   if (e.eq.zero) then
      call findf(mat,mf,mt,itape)
      call contio(itape,0,0,a,nb,nw)
      lnu=nint(a(4))
      if (mth.eq.455) then
         loc=1
         call listio(itape,0,0,a(loc),nb,nw)
         loc=loc+nw
         do while (nb.ne.0)
            call moreio(itape,0,0,a(loc),nb,nw)
            loc=loc+nw
         enddo
         lnd=nint(a(5))
         if (lnd.ne.6.and.lnd.ne.8)&
           call error('hgtyld','illegal lnd, must be 6 or 8',' ')
         loc=1
         call tab1io(itape,0,0,a(loc),nb,nw)
         loc=loc+nw
         if (loc.gt.na) call error('hgtyld','storage exceeded.',' ')
         do while (nb.ne.0)
            call moreio(itape,0,0,a(loc),nb,nw)
            loc=loc+nw
            if (loc.gt.na) call error('hgtyld','storage exceeded.',' ')
         enddo
         na=loc-1
         ip=2
         ir=1
         nr=nint(a(5))
         enext=a(7+2*nr)
      else
         lnd=0
         loc=1
         if (lnu.ne.1) then
            call tab1io(itape,0,0,a(loc),nb,nw)
            loc=loc+nw
            if (loc.gt.na) call error('hgtyld','storage exceeded.',' ')
            do while (nb.ne.0)
               call moreio(itape,0,0,a(loc),nb,nw)
               loc=loc+nw
               if (loc.gt.na) call error('hgtyld','storage exceeded.',' ')
            enddo
            na=loc-1
            ip=2
            ir=1
            nr=nint(a(5))
            enext=a(7+2*nr)
         else
            loc=1
            call listio(itape,0,0,a(loc),nb,nw)
            loc=loc+nw
            na=nw
            do while (nb.ne.0)
               call moreio(itape,0,0,a(loc),nb,nw)
               loc=loc+nw
               na=na+nw
            enddo
            enext=emax
         endif
      endif
      idis=0
      return
   endif

   !--tabulated data.
   if (lnu.ne.1) then
      call terpa(yld,e,enext,idis,a,ip,ir)

   !--polynomial data.
   else
      yld=a(7)
      term=1
      nc=nint(a(5))
      do i=2,nc
         term=term*e
         yld=yld+a(i+6)*term
      enddo
      enext=emax
      idis=0
   endif
   return
   end subroutine hgtyld

   subroutine anabar(s,e,a,t1,t2)
   !-------------------------------------------------------------------
   ! Compute mean energy for an analytic section of File 5.
   !-------------------------------------------------------------------
   use physics ! provides pi
   use endf    ! provides terpa
   ! externals
   real(kr)::s,e,a(*),t1,t2
   ! internals
   integer::lf,nr,np,lnext,ip,ir,idis,nrn,npn,lnxt
   real(kr)::u,theta,enext,b1,b2,b3,expa,test,b,rpi2
   real(kr),parameter::thrhaf=1.5e0_kr
   real(kr),parameter::zero=0
   rpi2=sqrt(pi)/2

   !--retrieve common factors.
   s=0
   u=a(1)
   if (e.le.u) return
   lf=nint(a(4))
   nr=nint(a(5))
   np=nint(a(6))
   lnext=7+2*nr+2*np
   ip=2
   ir=1
   call terpa(theta,e,enext,idis,a(lnext),ip,ir)

   !--law 3--discrete energy spectrum.
   if (lf.eq.3) then
      s=e*t1-t2*theta

   !--law 5--general evaporation spectrum.
   else if (lf.eq.5) then
      nrn=nint(a(lnext+4))
      npn=nint(a(lnext+5))
      lnxt=lnext+2*nrn+2*npn+6
      call tabbar(s,a(lnxt),lf)
      s=s*theta

   !--law 7--simple fission spectrum.
   else if (lf.eq.7) then
      if (theta.ne.zero) then
         b1=(e-u)/theta
         b2=sqrt(b1)
         b3=exp(-b1)
         expa=exp(-b2*b2)
         s=theta*(thrhaf-b1*b2*b3/(rpi2*(1-expa*rerfc(b2))-b2*b3))
      endif

   !--law 9--evaporation spectrum.
   else if (lf.eq.9) then
      if (theta.ne.zero) then
         b1=(e-u)/theta
         b2=sqrt(b1)
         b3=exp(-b1)
         test=1
         test=test/1000
         if (b1.ge.test) then
            s=theta*(2-b1*b1*b3/(1-(b1+1)*b3))
         else
            s=4*(e-u)/3
         endif
      endif

   !--law 11--energy-dependent watt spectrum.
   else if (lf.eq.11) then
      nrn=nint(a(lnext+4))
      npn=nint(a(lnext+5))
      lnxt=lnext+6+2*nrn+2*npn
      ip=2
      ir=1
      call terpa(b,e,enext,idis,a(lnxt),ip,ir)
      s=theta*(thrhaf+theta*b/4)

   !--law 12--energy dependent fission neutron spectrum (madland-nix)
   else if (lf.eq.12) then
          s=((a(lnext)+a(lnext+1))/2)+(4*theta/3)
   endif
   return

   contains
      real(kr) function r(z)
      real(kr)::z
      real(kr),parameter::a0=.3275911e0_kr
      r=1/(1+a0*abs(z))
      return
      end function r

      real(kr) function rerfc(z)
      real(kr)::z
      real(kr),parameter::a1=.254829592e0_kr
      real(kr),parameter::a2=-.284496736e0_kr
      real(kr),parameter::a3=1.421413741e0_kr
      real(kr),parameter::a4=-1.453152027e0_kr
      real(kr),parameter::a5=1.061405429e0_kr
      rerfc=r(z)*(a1+r(z)*(a2+r(z)*(a3+r(z)*(a4+a5*r(z)))))
      return
      end function rerfc

   end subroutine anabar

   subroutine anadam(e,d,z,awr,a)
   !-------------------------------------------------------------------
   ! Compute damage energy for an analytic section of File 5
   !-------------------------------------------------------------------
   use endf ! provides terpa
   ! externals
   real(kr)::e,d,z,awr,a(*)
   ! internals
   integer::nr,np,lf,lnext,ip,ir,idis,i,iq,j,iflag
   real(kr)::u,awfac,test,theta,enext,ep,er,xlast,ylast,xm,ym,yt
   integer,parameter::imax=10
   real(kr)::x(imax),y(imax)
   integer,parameter::nq=4
   real(kr),dimension(nq),parameter::qp=(/&
     -.86114e0_kr,-.33998e0_kr,.33998e0_kr,.86114e0_kr/)
   real(kr),dimension(nq),parameter::qw=(/&
     .34785e0_kr,.65215e0_kr,.65215e0_kr,.34785e0_kr/)
   real(kr),parameter::eps=.05e0_kr
   real(kr),parameter::delta=1.e-7_kr

   !--retrieve spectrum temperature
   d=0
   u=a(1)
   nr=nint(a(5))
   np=nint(a(6))
   lf=nint(a(4))
   awfac=1/awr
   if (lf.ne.9) return
   if (e.le.u) return
   if ((e-u).lt.delta*e) return
   test=10
   if ((e-u).lt.test) return
   lnext=7+2*nr+2*np
   ip=2
   ir=1
   call terpa(theta,e,enext,idis,a(lnext),ip,ir)

   !--adaptive energy integration
   !--gauss-legendre angle integration
   i=4
   do while (i.gt.1)
      i=i-1
      if (i.eq.3) ep=1
      if (i.eq.2) ep=(e-u)/2
      if (i.eq.2.and.theta.lt.e-u) ep=theta
      if (i.eq.1) ep=e-u
      x(i)=ep
      y(i)=0
      do iq=1,nq
         er=(e-2*sqrt(e*ep)*qp(iq)+ep)*awfac
         y(i)=y(i)+qw(iq)*df(er,z,awr,z,awr)/2
      enddo
      y(i)=y(i)*sed(e,ep,theta,u)
   enddo
   i=3
   j=0
   xlast=0
   ylast=0
   do while (i.gt.1)
      ! test for convergence
      iflag=0
      if (i.gt.1.and.i.lt.imax) then
         xm=(x(i-1)+x(i))/2
         ym=(y(i-1)+y(i))/2
         yt=0
         do iq=1,nq
            er=(e-2*sqrt(e*xm)*qp(iq)+xm)*awfac
            yt=yt+qw(iq)*df(er,z,awr,z,awr)/2
         enddo
         yt=yt*sed(e,xm,theta,u)
         if (abs(yt-ym).gt.eps*yt) iflag=1
      endif
      ! fails test.
      ! add midpoint to stack and continue.
      if (iflag.eq.1) then
         i=i+1
         x(i)=x(i-1)
         x(i-1)=xm
         y(i)=y(i-1)
         y(i-1)=yt
      ! passes test.
      ! use top point off the stack.
      else
         j=j+1
         if (j.gt.1) d=d+(x(i)-xlast)*(y(i)+ylast)/2
         xlast=x(i)
         ylast=y(i)
         i=i-1
      endif
   enddo
   return
   end subroutine anadam

   real(kr) function sed(e,ep,theta,u)
   !-------------------------------------------------------------------
   ! Secondary energy distribution function for anadam.
   ! A Taylor expansion is used for small values to avoid overflow.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::e,ep,theta,u
   ! internals
   real(kr)::xeu,aeu,test

   xeu=(e-u)/theta
   aeu=abs(xeu)
   test=1
   test=test/10000
   if (aeu.ge.test) then
      sed=ep*exp(-ep/theta)/(theta*theta*(1-exp(-xeu)*(1+xeu)))
   else
      sed=ep*exp(-ep/theta)/(theta*theta*xeu*xeu*(1-xeu)/2)
   endif
   return
   end function sed

  subroutine tabbar(f,a,law)
   !-------------------------------------------------------------------
   ! Compute mean energy for a tabulated section of File 5.
   ! (If law<0, the mean energy of a subsection of File 6
   ! can be computed using abs(law) as the interpolation law).
   !-------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::law
   real(kr)::f,a(*)
   ! internals
   integer::nr,np,ibase,ir,nbt,inn,ncyc,i
   real(kr)::xh,xhsq,yh,xl,xlsq,delxsq,yl,b
   real(kr)::alxl,alxh,alyl,alyh

   !--initialize.
   nbt=0
   if (law.gt.0.and.law.ne.1.and.law.ne.5)&
     call error('tabbar','coded for lf=1 and lf=5 only.',' ')
   if (law.ge.0) then
      f=0
      nr=nint(a(5))
      np=nint(a(6))
      ibase=6+2*nr
      ir=1
      nbt=nint(a(7))
      inn=nint(a(8))
      ncyc=2
   else
      f=0
      np=nint(a(6))
      inn=iabs(law)
      ncyc=nint(a(4))+2
      ibase=6
   endif
   xh=a(ibase+1)
   xhsq=xh*xh
   yh=a(ibase+2)

   !--accumulate contributions to integral.
   do i=2,np
      xl=xh
      xh=a(ibase+ncyc*(i-1)+1)
      xlsq=xhsq
      xhsq=xh*xh
      delxsq=xhsq-xlsq
      yl=yh
      yh=a(ibase+ncyc*(i-1)+2)
      if (law.gt.0.and.i.gt.nbt) then
         ir=ir+1
         nbt=nint(a(6+2*ir-1))
         inn=nint(a(6+2*ir))
      endif
      if (xl.ne.xh) then

         !--y is a constant.
         if (inn.eq.1) then
            f=f+yl*delxsq/2

         !--y is linear in x.
         else if (inn.eq.2) then
            b=(yh-yl)/(xh-xl)
            f=f+((yl-xl*b)*delxsq/2+b*(xh*xhsq-xl*xlsq)/3)

         !--y is linear in ln(x)
         else if (inn.eq.3) then
            alxl=log(xl)
            alxh=log(xh)
            b=(yh-yl)/(alxh-alxl)
            f=f+(yl-b*alxl+b/2)*delxsq/2+b*(xhsq*alxh-xlsq*alxl)/2

         !--ln(y) is linear in x
         else if (inn.eq.4) then
            alyl=log(yl)
            alyh=log(yh)
            b=(alyh-alyl)/(xh-xl)
            f=f+(yh*(b*xh-1)-yl*(b*xl-1))/b**2

         !--ln(y) is linear in ln(x)
         else if (inn.eq.5) then
            alxl=log(xl)
            alxh=log(xh)
            alyl=log(yl)
            alyh=log(yh)
            b=(alyh-alyl)/(alxh-alxl)
            f=f+yl*xlsq*((xh/xl)**(b+2)-1)/(b+2)
         endif
      endif
   enddo
   return
   end subroutine tabbar

   subroutine tabdam(e,d,z,awr,awfac,a)
   !-------------------------------------------------------------------
   ! Compute damage energy for a tabulated section of File 5.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::e,d,z,awr,awfac,a(*)
   ! internals
   integer::nr,np,ibase,i,iq
   real(kr)::xh,yh,fl,xl,f,er
   integer,parameter::nq=4
   real(kr),dimension(nq),parameter::qp=(/&
     -.86114e0_kr,-.33998e0_kr,.33998e0_kr,.86114e0_kr/)
   real(kr),dimension(nq),parameter::qw=(/&
     .34785e0_kr,.65215e0_kr,.65215e0_kr,.34785e0_kr/)
   real(kr),parameter::zero=0

   !--initialize
   if (e.eq.zero) then
      d=df(e,z,awr,z,awr)
      return
   endif

   !--trapazoidal energy integration
   !--gauss-legendre angle integration
   d=0
   nr=nint(a(5))
   np=nint(a(6))
   ibase=6+2*nr
   xh=a(ibase+1)
   yh=a(ibase+2)
   fl=0
   do i=1,np
      xl=xh
      xh=a(ibase+2*i-1)
      yh=a(ibase+2*i)
      f=0
      do iq=1,nq
         er=(e-2*sqrt(e*xh)*qp(iq)+xh)*awfac
         f=f+qw(iq)*df(er,z,awr,z,awr)/2
      enddo
      f=f*yh
      if (i.gt.1) d=d+(xh-xl)*(f+fl)/2
      fl=f
   enddo
   return
   end subroutine tabdam

   subroutine sixbar(e,ebar,yld,dame,nin,c,ncmax,nscr,b,nbmax,&
     n2,j6,irec,jrec,iflag)
   !-------------------------------------------------------------------
   ! Calculate charged-particle ebar and damage energy
   ! for reactions represented using ENDF-6 File 6.
   ! If recoil subsection is not given, attempt to compute
   ! from the distribution for the heavy emitted particle.
   ! For normal particles, irec is zero.  For recoil cases,
   ! irec is the index of the section for the driving particle.
   !-------------------------------------------------------------------
   use util ! provides skiprz,mess
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,n2,j6,irec,jrec,ncmax,nbmax,nscr,iflag
   real(kr)::e,ebar,yld,dame
   real(kr)::c(ncmax),b(nbmax)
   ! internals
   integer::matd,mfd,mtd,l,nb,nw,ik,nnt,nmu,imu,mf1,mt1,idis
   integer::ip,ir,idisc,iraw,nne,ne,law,lang,lep,intl
   real(kr)::disc102,zp,zt,ap,at,ztt,pe,eihi,f,d,s,enext
   real(kr)::elo,ehi,flo,fhi,dlo,dhi
   character(60)::strng
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::zero=0
   save iraw,nne,ne,law,lang,lep,intl
   save elo,ehi,flo,fhi,dlo,dhi
   save disc102,zp,ap,zt,at

   !--initialize for this subsection when e=0.
   if (e.gt.zero) go to 300
   if (irec.eq.0) go to 110
   if (jrec.gt.0) irec=jrec

   !--for recoils, back up to the driving particle,
   !--or restore position after doing recoil.
  100 continue
   matd=math
   mfd=6
   mtd=mth
   call skiprz(nin,-2)
   call findf(matd,mfd,mtd,nin)
   l=1
   call contio(nin,0,0,c(l),nb,nw)
   ik=0
   do while (ik.lt.irec-1)
      ik=ik+1
      call tab1io(nin,0,0,c(l),nb,nw)
      l=l+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,c(l),nb,nw)
         l=l+nw
      enddo
      law=l2h
      call skip6(nin,0,0,c(l),law)
   enddo
   if (jrec.eq.irec) then
      irec=0
      jrec=0
   endif

   !--start reading in the desired subsection
  110 continue
   l=1
   call tab1io(nin,0,0,c(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,c(l),nb,nw)
      l=l+nw
   enddo
   zap=c1h
   awp=c2h
   law=l2h

   !--error for awp=0. for non photons
   if (zap.ne.0.and.awp.eq.0) then
     write(strng,'(''awp is zero for for mt'',i3,'' particle '',i5)')&
       mth,nint(zap)
     call error('sixbar',strng,' ')
   endif

   iflag=0
   disc102=0
   if (zap.eq.zero) then
      iflag=1
      disc102=awp
      awp=0
   endif
   ebar=0
   yld=0
   if (law.gt.0) go to 150

   !--warning for law=0.
   write(strng,'(''no distribution for mt'',i3,'' particle '',i5)')&
     mth,nint(zap)
   call mess('sixbar',strng,' ')
   ebar=-2
   return

   !--watch for 2-body recoils
  150 continue
   if (law.ne.4) go to 210
   irec=j6-1
   jrec=j6+1
   go to 100

   !--continue processing this subsection
  210 continue
   zp=int(zap/1000)
   zt=int(zat/1000)
   if (irec.gt.0) zp=zt-zp
   ap=awp
   if (irec.gt.0) ap=awr+1-awp
   at=awr
   if (zap.eq.zero) then
       ap=awr+1
       zp=zt
   endif
   dame=df(e,zp,ap,zt,at)
   if (disc102.gt.zero) go to 295
   if (law.ne.3.and.law.ne.6) then
      call tab2io(nin,0,0,c(l),nb,nw)
      lang=nint(c(l+2))
      lep=nint(c(l+3))
      ne=n2h
      nnt=l+6
      intl=nint(c(nnt+1))
      intl=2
      l=l+nw
   endif
   nne=0
   iraw=l
   if (law.eq.3) go to 230
   if (law.eq.6) go to 240
   if (law.eq.7) go to 250

   !--laws 1, 2, and 5.
   call listio(nin,0,0,c(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,c(l),nb,nw)
      l=l+nw
   enddo
   nne=nne+1
   elo=c(iraw+1)
   ehi=0
   dhi=0
   fhi=0
   go to 290

   !--law 3 -- isotropic distribution
  230 continue
   ehi=emax
   lang=0
   return

   !--law 6 -- phase-space distribution
  240 continue
   call contio(nin,0,0,c(l),nb,nw)
   lang=0
   lep=2
   l=l+nw
   ehi=emax
   dhi=0
   fhi=0
   return

   !--law 7 -- laboratory angle-energy law
  250 continue
   call tab2io(nin,0,0,c(l),nb,nw)
   nmu=n2h
   l=l+nw
   do imu=1,nmu
      call tab1io(nin,0,0,c(l),nb,nw)
      l=l+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,c(l),nb,nw)
         l=l+nw
      enddo
   enddo
   nne=nne+1
   elo=c(iraw+1)
   ehi=0
   dhi=0
   fhi=0

   !--compute low values of ebar and dame
  290 continue
   if (mth.ne.102.or.(zap.eq.0.and.irec.eq.0)) then
      call getsix(elo,flo,dlo,c(iraw),law,lang,lep,irec)
   else
      ztt=int(zat/1000)
      call tabsq6(flo,dlo,c(iraw),law,ztt,awrt,elo,c(1))
   endif
   if ((mth.ge.18.and.mth.le.21).or.mth.eq.38) then
      matd=math
      mf1=1
      mt1=452
      if (nply.gt.0) mt1=456
      ! delayed neutrons are treated the same as fast neutrons.
      ! this will cause a slight overestimate of en for fission.
      ! ... but when nply.ne.0, use prompt neutron data only.
      call hgtyld(e,enext,idis,yld,matd,mf1,mt1,nscr,b,nbmax)
   endif
   return

  295 continue
   yld=1
   call skip6(nin,0,0,c(l),law)
   return

   !--normal entry
  300 continue
      if (disc102.gt.zero) go to 430

   !--interpolate for particle yield
   ip=2
   ir=1
   call terpa(pe,e,eihi,idisc,c(1),ip,ir)
   if (irec.gt.0) pe=1

   !--is desired energy in current panel
  305 continue
   if (e.lt.ehi*(1-small)) go to 400
   if (nne.eq.1) go to 310
   if (nne.eq.ne.and.e.le.ehi*(1+small)) go to 400
   if (nne.eq.ne) go to 450

   !--no. slide high-energy data into low-energy positions
   !--and read in new high energy data.
   elo=ehi
   flo=fhi
   dlo=dhi

   !--read in new data for high energy
   !--laws 1, 2, and 5.
  310 continue
   if (law.eq.1.or.law.eq.2.or.law.eq.5) then
      l=iraw
      call listio(nin,0,0,c(l),nb,nw)
      l=l+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,c(l),nb,nw)
         l=l+nw
      enddo
      nne=nne+1
      ehi=c(iraw+1)

   !--law 6.
   else if (law.eq.6) then
      l=iraw
         call contio(nin,0,0,c(l),nb,nw)

   !--law 7.
   else if (law.eq.7) then
      l=iraw
      call tab2io(nin,0,0,c(l),nb,nw)
      nmu=n2h
      l=l+nw
      do imu=1,nmu
         call tab1io(nin,0,0,c(l),nb,nw)
         l=l+nw
         do while (nb.ne.0)
            call moreio(nin,0,0,c(l),nb,nw)
            l=l+nw
         enddo
      enddo
      ehi=c(iraw+1)
      nne=nne+1
   endif

   !--compute high values of ebar and dame
   if (mth.ne.102.or.(zap.eq.0.and.irec.eq.0)) then
      call getsix(ehi,fhi,dhi,c(iraw),law,lang,lep,irec)
   else
      ztt=int(zat/1000)
      call tabsq6(fhi,dhi,c(iraw),law,ztt,awrt,ehi,c(1))
   endif
   go to 305

   !--yes.  compute result.
  400 continue
   if (law.ne.3.and.law.ne.6) go to 420
   c(iraw+1)=e
   call getsix(e,f,d,c(iraw),law,lang,lep,irec)
   ebar=f
   yld=pe
   dame=pe*d
   return

   !--yes. interpolate for results
  420 continue
   if (nne.eq.1) go to 450
   call terp1(elo,flo,ehi,fhi,e,s,intl)
   ebar=s
   yld=pe
   if ((mth.ge.18.and.mth.le.21).or.mth.eq.38) then
      matd=math
      mf1=1
      mt1=452
      call hgtyld(e,enext,idis,yld,matd,mf1,mt1,nscr,b,nbmax)
   endif
   call terp1(elo,dlo,ehi,dhi,e,d,intl)
   dame=pe*d
   return

   !--discrete relativistic capture gamma
  430 call hgam102(e,ebar,dame,disc102,c,irec,zp,ap,zt,at)
   yld=1
   return

   !--return zeros outside range of table
  450 continue
   ebar=0
   dame=0
   return
   end subroutine sixbar

   subroutine getsix(e,ebar,dame,c,law,lang,lep,irec)
   !-------------------------------------------------------------------
   ! Compute ebar and dame for one particular incident energy
   ! using data in ENDF-6 File 6 format.  For irec.eq.0, return the
   ! numbers for the emitted particle.  For irec.gt.0, return the
   ! numbers for the recoil due to a single emission of the particle.
   !-------------------------------------------------------------------
   use mathm ! provides legndr
   ! externals
   integer::law,lang,lep,irec
   real(kr)::e,ebar,dame,c(*)
   ! internals
   integer::nl,l,i,nd,na,nep,ncyc,iq,ia,nld,il,nmu,imu
   integer::nr,np,next,ibase,iint
   real(kr)::zp,zt,ap,at,summ,epnext,el,fl,dy,da,xm
   real(kr)::epn,ym,test,en,f,f1,h,d,xl,yl,xx,yy
   real(kr)::x2,zpp,ztt,b,er,t1,t2,thresh,beta
   real(kr)::afact,arec,u,e2,ul,fn,dl,hl,f2
   real(kr)::x(10),y(10,2)
   real(kr)::term(2)
   real(kr)::p(65)
   integer,parameter::nq=64
   real(kr),dimension(64),parameter::qp=(/&
     -9.99305042E-01_kr,-9.96340117E-01_kr,-9.91013371E-01_kr,&
     -9.83336254E-01_kr,-9.73326828E-01_kr,-9.61008800E-01_kr,&
     -9.46411375E-01_kr,-9.29569172E-01_kr,-9.10522137E-01_kr,&
     -8.89315446E-01_kr,-8.65999398E-01_kr,-8.40629296E-01_kr,&
     -8.13265315E-01_kr,-7.83972359E-01_kr,-7.52819907E-01_kr,&
     -7.19881850E-01_kr,-6.85236313E-01_kr,-6.48965471E-01_kr,&
     -6.11155355E-01_kr,-5.71895646E-01_kr,-5.31279464E-01_kr,&
     -4.89403146E-01_kr,-4.46366017E-01_kr,-4.02270158E-01_kr,&
     -3.57220158E-01_kr,-3.11322872E-01_kr,-2.64687162E-01_kr,&
     -2.17423644E-01_kr,-1.69644420E-01_kr,-1.21462819E-01_kr,&
     -7.29931218E-02_kr,-2.43502927E-02_kr, 2.43502927E-02_kr,&
      7.29931218E-02_kr, 1.21462819E-01_kr, 1.69644420E-01_kr,&
      2.17423644E-01_kr, 2.64687162E-01_kr, 3.11322872E-01_kr,&
      3.57220158E-01_kr, 4.02270158E-01_kr, 4.46366017E-01_kr,&
      4.89403146E-01_kr, 5.31279464E-01_kr, 5.71895646E-01_kr,&
      6.11155355E-01_kr, 6.48965471E-01_kr, 6.85236313E-01_kr,&
      7.19881850E-01_kr, 7.52819907E-01_kr, 7.83972359E-01_kr,&
      8.13265315E-01_kr, 8.40629296E-01_kr, 8.65999398E-01_kr,&
      8.89315446E-01_kr, 9.10522137E-01_kr, 9.29569172E-01_kr,&
      9.46411375E-01_kr, 9.61008800E-01_kr, 9.73326828E-01_kr,&
      9.83336254E-01_kr, 9.91013371E-01_kr, 9.96340117E-01_kr,&
      9.99305042E-01_kr/)
   real(kr),dimension(64),parameter::qw=(/&
      1.78328072E-03_kr, 4.14703326E-03_kr, 6.50445797E-03_kr,&
      8.84675983E-03_kr, 1.11681395E-02_kr, 1.34630479E-02_kr,&
      1.57260305E-02_kr, 1.79517158E-02_kr, 2.01348232E-02_kr,&
      2.22701738E-02_kr, 2.43527026E-02_kr, 2.63774697E-02_kr,&
      2.83396726E-02_kr, 3.02346571E-02_kr, 3.20579284E-02_kr,&
      3.38051618E-02_kr, 3.54722133E-02_kr, 3.70551285E-02_kr,&
      3.85501532E-02_kr, 3.99537411E-02_kr, 4.12625632E-02_kr,&
      4.24735151E-02_kr, 4.35837245E-02_kr, 4.45905582E-02_kr,&
      4.54916279E-02_kr, 4.62847966E-02_kr, 4.69681828E-02_kr,&
      4.75401657E-02_kr, 4.79993886E-02_kr, 4.83447622E-02_kr,&
      4.85754674E-02_kr, 4.86909570E-02_kr, 4.86909570E-02_kr,&
      4.85754674E-02_kr, 4.83447622E-02_kr, 4.79993886E-02_kr,&
      4.75401657E-02_kr, 4.69681828E-02_kr, 4.62847966E-02_kr,&
      4.54916279E-02_kr, 4.45905582E-02_kr, 4.35837245E-02_kr,&
      4.24735151E-02_kr, 4.12625632E-02_kr, 3.99537411E-02_kr,&
      3.85501532E-02_kr, 3.70551285E-02_kr, 3.54722133E-02_kr,&
      3.38051618E-02_kr, 3.20579284E-02_kr, 3.02346571E-02_kr,&
      2.83396726E-02_kr, 2.63774697E-02_kr, 2.43527026E-02_kr,&
      2.22701738E-02_kr, 2.01348232E-02_kr, 1.79517158E-02_kr,&
      1.57260305E-02_kr, 1.34630479E-02_kr, 1.11681395E-02_kr,&
      8.84675983E-03_kr, 6.50445797E-03_kr, 4.14703326E-03_kr,&
      1.78328072E-03_kr/)
   real(kr),parameter::tol=0.02e0_kr
   real(kr),parameter::small=1.e-8_kr
   real(kr),parameter::emax=1.e10_kr
   integer,parameter::imax=10
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--branch to appropriate law
   zp=int(zap/1000)
   zt=int(zat/1000)
   if (irec.gt.0) zp=zt-zp
   ap=awp
   if (irec.gt.0) ap=awrt+1-awp
   at=awrt
   if (law.eq.7) go to 510
   if (law.eq.1.and.lct.eq.1) go to 400
   if (law.eq.1.and.lct.eq.3.and.zap.gt.2004) go to 400
   if (law.eq.1.and.zap.eq.0.) go to 400
   if (law.eq.2.or.law.eq.3) go to 450
   if (law.eq.6) lang=0

   !--law 1 in the cm system.
   !--adaptive integration over lab energy.
   nl=1
   if (irec.gt.0) nl=2
   summ=0
   ebar=0
   dame=0
   x(2)=0
   call h6cm(x(2),epnext,term,nl,lang,lep,c)
   do l=1,nl
      y(2,l)=term(l)
   enddo
   el=x(2)*y(2,1)
   fl=0
  120 continue
   x(1)=epnext
   call h6cm(x(1),epnext,term,nl,lang,lep,c)
   do l=1,nl
      y(1,l)=term(l)
   enddo
   i=2
   dy=(y(1,1)+y(2,1))/10000
  140 continue
   if (i.eq.imax) go to 190
   da=(x(i-1)-x(i))*(y(i-1,1)+y(i,1))/2
   if (da.lt.small) go to 190
   xm=(x(i-1)+x(i))/2
   if (xm.ge.x(i-1).or.xm.le.x(i)) go to 190
   epn=x(i)
   call h6cm(xm,epn,term,nl,lang,lep,c)
   ym=(y(i-1,1)+y(i,1))/2
   test=2*tol*abs(ym)+2*dy
   if (abs(term(1)-ym).gt.test) go to 160
   go to 190
   ! fails test
  160 continue
   i=i+1
   x(i)=x(i-1)
   do l=1,nl
      y(i,l)=y(i-1,l)
   enddo
   x(i-1)=xm
   do l=1,nl
      y(i-1,l)=term(l)
   enddo
   go to 140
   ! passes test
  190 continue
   if (i.eq.1) go to 220
   summ=summ+(x(i-1)-x(i))*(y(i-1,1)+y(i,1))/2
   if (irec.le.0) then
      en=y(i-1,1)*x(i-1)
      ebar=ebar+(x(i-1)-x(i))*(en+el)/2
      f=y(i-1,1)*df(x(i-1),zp,ap,zt,at)
      dame=dame+(x(i-1)-x(i))*(f+fl)/2
   else
      f1=0
      if (y(i-1,1).ne.zero) f1=y(i-1,2)/y(i-1,1)
      en=(e-2*sqrt(e*awp*x(i-1))*f1+awp*x(i-1))/(awrt+1-awp)
      f=y(i-1,1)*df(en,zp,ap,zt,at)
      en=en*y(i-1,1)
      ebar=ebar+(x(i-1)-x(i))*(en+el)/2
      dame=dame+(x(i-1)-x(i))*(f+fl)/2
   endif
   el=en
   fl=f
   i=i-1
   if (i.gt.1) go to 140
   test=emax-emax/100
   if (epnext.ge.test) go to 190
   x(2)=x(1)
   do l=1,nl
      y(2,l)=y(1,l)
   enddo
   go to 120
  220 continue
   return

   !--law 1 for lab system.
   !--trapazoidal energy integration, and
   !--gauss-legendre angle integration, if needed.
  400 continue
   ebar=0
   dame=0
   nd=nint(c(3))
   na=nint(c(4))
   nep=nint(c(6))
   ncyc=na+2
   h=0
   d=0
   xl=0
   yl=0
   el=0
   fl=0
   do i=1,nep
      l=7+ncyc*(i-1)
      xx=abs(c(l))
      yy=c(l+1)
      x2=xx
      if (irec.eq.0) then
         en=yy*xx
         zpp=int(zap/1000)
         ztt=int(zat/1000)
         f2=df(xx,zpp,awp,ztt,awrt)
         f=yy*f2
      else
         en=0
         f=0
         do iq=1,nq
            b=0
            call legndr(qp(iq),p,na)
            do ia=1,na+1
               b=b+(2*ia-1)*c(l+ia)*p(ia)/2
            enddo
            if (yy.ne.zero) b=b/yy
            er=(e-2*sqrt(e*awp*xx)*qp(iq)+awp*xx)/(awrt+1-awp)
            en=en+qw(iq)*b*er
            f=f+qw(iq)*b*df(er,zp,ap,zt,at)
         enddo
         x2=en
         en=en*yy
         f2=f
         f=f*yy
      endif
      if (i.le.nd) then
         h=h+en
         d=d+f
      else if (i.eq.nd+1) then
         xl=xx
         yl=yy
         el=en
         fl=f
      else
         if (lep.eq.1) t1=x2*yl+el
         if (lep.gt.1) t1=en+el
         h=h+(xx-xl)*t1/2
         if (lep.eq.1) t2=f2*yl+fl
         if (lep.gt.1) t2=f+fl
         d=d+(xx-xl)*t2/2
         xl=xx
         yl=yy
         el=en
         fl=f
      endif
   enddo
   ebar=h
   dame=d
   return

   !--laws 2 and 3.
   !--discrete-level scattering
  450 continue
   ebar=0
   dame=0
   lang=0
   if (law.eq.2) lang=nint(c(3))
   nld=0
   if (law.eq.2) nld=nint(c(6))
   thresh=((awrt+1)/awrt)*(-q)
   if (e.lt.thresh) return
   beta=sqrt(awrt*(awrt+1-awp)*(1-thresh/e)/awp)
   afact=awp/(1+awrt)**2
   arec=awp/(awrt+1-awp)
   if (lang.eq.0) then
      ! legendre coefficients
      ! uses gauss-legendre integration for damage
      f1=0
      if (law.ne.3) f1=c(7)
      if (irec.gt.0) then
         f1=-f1
         beta=arec*beta
         afact=afact/arec
      endif
      ebar=afact*e*(1+2*beta*f1+beta*beta)
      if (idame.eq.0) return
      do iq=1,nq
         u=qp(iq)
         if (irec.gt.0) u=-u
         f=one/2
         if (law.ne.3) then
            call legndr(u,p,nld)
            do il=1,nld
               f=f+(2*il+1)*c(6+il)*p(il+1)/2
            enddo
         endif
         e2=afact*e*(1+2*beta*u+beta*beta)
         dame=dame+qw(iq)*f*df(e2,zp,ap,zt,at)
      enddo
   else
      ! tabulated distribution
      ! uses trapazoidal integration for heat and damage
      nmu=nint(c(6))
      if (irec.gt.0) then
         beta=arec*beta
         afact=afact/arec
      endif
      el=0
      fl=0
      ul=0
      do imu=1,nmu
         l=6+2*imu-1
         if (irec.gt.0) l=6+2*nmu-2*imu+1
         u=c(l)
         if (irec.gt.0) u=-u
         yy=c(l+1)
         e2=afact*e*(1+2*beta*u+beta*beta)
         en=yy*e2
         fn=yy*df(e2,zp,ap,zt,at)
         if (imu.gt.1) then
            ebar=ebar+(u-ul)*(en+el)/2
            dame=dame+(u-ul)*(fn+fl)/2
         endif
         ul=u
         el=en
         fl=fn
      enddo
   endif
   return

   !--law 7.
   !--trapazoidal integration over energy for each angle
   !--then trapazoidal integration over angle
  510 continue
   ebar=0
   dame=0
   dl=0
   hl=0
   ul=0
   nmu=nint(c(6))
   l=7+2*nint(c(5))
   do imu=1,nmu
      u=c(l+1)
      nr=nint(c(l+4))
      np=nint(c(l+5))
      iint=nint(c(l+7))
      next=l+6+2*nr+2*np
      ibase=l+5+2*nr
      h=0
      d=0
      do i=1,np
         xx=c(ibase+2*i-1)
         yy=c(ibase+2*i)
         en=yy*xx
         if (irec.gt.0) then
            xx=(e-2*sqrt(e*awp*xx)*u+awp*xx)/(awrt+1-awp)
         endif
         if (i.gt.1) then
            if (iint.eq.1) then
               h=h+(xx-xl)*el
            else
               h=h+(xx-xl)*(en+el)/2
            endif
         endif
         f=yy*df(xx,zp,ap,zt,at)
         if (i.gt.1) then
            if (iint.eq.1) then
               d=d+(xx-xl)*fl
            else
               d=d+(xx-xl)*(f+fl)/2
            endif
         endif
         xl=xx
         el=en
         fl=f
      enddo
      l=next
      if (imu.gt.1) ebar=ebar+(u-ul)*(h+hl)/2
      if (imu.gt.1) dame=dame+(u-ul)*(d+dl)/2
      ul=u
      hl=h
      dl=d
   enddo
   return
   end subroutine getsix

   subroutine h6cm(ep,epnext,term,nl,lang,lep,cnow)
   !-------------------------------------------------------------------
   ! Compute the Legendre coefficients for the double-differential
   ! cross section for secondary energy ep (in the lab system)
   ! using the ENDF-6 File 6 data in the cm system located
   ! in the array cnow.  Call with ep=0 to initialize.
   ! Thereafter, ep can be requested in any order.
   !-------------------------------------------------------------------
   use mathm ! provides legndr
   ! externals
   integer::nl,lang,lep
   real(kr)::ep,epnext,term(*),cnow(*)
   ! internals
   integer::i,na,l,j,ll,ndnow,npnow,ncnow
   real(kr)::aprime,epnn,epm,epn,w,t,epx,xx,cc,c,umin,dm
   real(kr)::umax,un,u,yy,test,epp,s,dx,ym,epnxt
   real(kr)::wlo,whi,f,eps,xc,elmax,e,epmax
   real(kr)::da
   integer,parameter::imax=10
   integer,parameter::mxlg=65
   real(kr)::p(mxlg)
   real(kr)::x(imax),y(imax,mxlg),yt(mxlg)
   real(kr),parameter::tol=0.02e0_kr
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::step=0.05e0_kr
   real(kr),parameter::check=.99999e0_kr
   real(kr),parameter::rdn=.999995e0_kr
   real(kr),parameter::rup=1.000005e0_kr
   real(kr),parameter::tiny=1.e-9_kr
   real(kr),parameter::dn=.999999e0_kr
   real(kr),parameter::up=1.000001e0_kr
   real(kr),parameter::thou=1.e-3_kr
   real(kr),parameter::amil=1.e-6_kr
   real(kr),parameter::one=1.e0_kr
   real(kr),parameter::onep5=1.5e0_kr
   real(kr),parameter::du=.0001e0_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::zero=0
   save na,eps,xc,ndnow,npnow,ncnow,elmax,e,epmax

   !--initialize.
   if (ep.gt.zero) go to 200
   e=cnow(2)
   ndnow=nint(cnow(3))
   npnow=nint(cnow(6))
   ncnow=nint(cnow(5))/npnow
   aprime=awp
   xc=aprime/(awrt+1)**2
   epnext=emax
   elmax=0
   epnn=emax
   epmax=0
   epm=0
   epn=0
   w=0
   if (npnow.ne.ndnow) then
      if (lang.gt.0) then
         t=h6ddx(ep,epn,epm,w,cnow,lang,lep)
      else
         t=h6psp(ep,epn,epm,w,e,cnow)
      endif
      if (epn.lt.epnn*(1-small)) epnn=epn
      if (epm.gt.epmax*(1+small)) epmax=epm
      elmax=e*(sqrt(epmax/e)+sqrt(xc))**2
      elmax=up*elmax
      epn=step*elmax
      if(epmax*up.lt.xc*e) epn=e*(sqrt(epmax/e)-sqrt(xc))**2
      if (epn.lt.epnext) epnext=epn
      eps=tiny/elmax
      epnext=dn*epnext
   endif
   if (ndnow.ne.0) then
      i=0
      t=h6dis(i,epn,epm,w,cnow,lang)
      do i=1,ndnow
         t=h6dis(i,epn,epm,w,cnow,lang)
         if (epn.lt.epnn*(1-small)) epnn=epn
         if (epn.gt.epmax*(1+small)) epmax=epn
         epx=dn*e*(sqrt(epn/e)-sqrt(xc))**2
         if (epx.lt.epnext*(1-small)) epnext=epx
         epx=up*e*(sqrt(epn/e)+sqrt(xc))**2
         if (epx.gt.elmax*(1+small)) elmax=epx
      enddo
   endif
   na=nl-1
   do l=1,nl
      term(l)=0
   enddo
   return

   !--normal entry.
  200 continue
   do l=1,nl
      term(l)=0
   enddo
   if (ndnow.eq.npnow) go to 330
   xx=ep/e
   cc=xc/xx
   c=sqrt(cc)
   umin=(1+cc-epmax/ep)/(2*c)
   if (umin.lt.check) go to 215
   if (c.le.one) go to 420
   if (c.gt.one) go to 320
  215 continue
   if (umin.lt.-one) umin=-one
   dm=(1-umin)/1000+amil
   if (dm.lt.thou/5) dm=thou/5
   epnn=emax

   !--for the continuum part of the distribution,
   !--integrate over the trajectory ep=constant
   !--using adaptive integration on lab cosine.
   umax=1
   un=umax
   x(2)=un
  220 continue
   if (x(2).le.umin) go to 310
   j=2
   do while (j.eq.2)
      u=un
      yy=1+cc-2*c*u
      test=amil
      if (yy.lt.test) then
         yy=amil
         c=u-thou
         cc=c*c
      endif
      epp=yy*ep
      w=(u-c)/sqrt(yy)
      if (lang.gt.0) then
         s=h6ddx(epp,epn,epm,w,cnow,lang,lep)
      else
         s=h6psp(epp,epn,epm,w,e,cnow)
      endif
      if (u.eq.umax.and.epn.lt.epnn) epnn=epn
      call legndr(u,p,na)
      j=1
      if (u.eq.umax) j=2
      x(j)=u
      do l=1,nl
         y(j,l)=p(l)*s/sqrt(yy)
      enddo
      un=u-(epn-epp)/(2*c*ep)
      if (un.gt.u-du) un=u-du
      if (un.lt.umin+du/10) un=umin
   enddo
   i=2
  240 continue
   if (i.eq.imax) go to 290
   dx=x(i)-x(i-1)
   if (dx.lt.dm) go to 290
   da=dx*(y(i,1)+y(i-1,1))/2
   if (da.lt.eps) go to 290
   u=(x(i-1)+x(i))/2
   yy=1+cc-2*c*u
   epp=yy*ep
   w=(u-c)/sqrt(yy)
   if (lang.gt.0) s=h6ddx(epp,epn,epm,w,cnow,lang,lep)
   if (lang.eq.0) s=h6psp(epp,epn,epm,w,e,cnow)
   call legndr(u,p,na)
   do l=1,nl
      yt(l)=p(l)*s/sqrt(yy)
   enddo
   do 250 l=1,nl
   ym=(y(i-1,l)+y(i,l))/2
   if (abs(yt(l)-ym).gt.l*tol*abs(ym)+eps) go to 260
  250 continue
   go to 290
   ! fails test
  260 continue
   i=i+1
   x(i)=x(i-1)
   do l=1,nl
      y(i,l)=y(i-1,l)
   enddo
   x(i-1)=u
   do l=1,nl
      y(i-1,l)=yt(l)
   enddo
   go to 240
   ! passes test
  290 continue
   do l=1,nl
      term(l)=term(l)+(x(i)-x(i-1))*(y(i,l)+y(i-1,l))/2
   enddo
   i=i-1
   if (i.gt.1) go to 240
   x(2)=x(1)
   do l=1,nl
      y(2,l)=y(1,l)
   enddo
   if (i.eq.1) go to 220
  310 continue
   epnxt=e*(sqrt(epnn/e)-sqrt(xc))**2
   if (epnxt.le.ep*(1+small)) epnxt=e*(sqrt(epnn/e)+sqrt(xc))**2
   if (epnxt.le.ep*(1+small)) epnxt=onep5*ep
   if (epnxt.gt.elmax*(1+small).and.elmax.gt.ep*(1+small))epnxt=elmax
   go to 400
  320 continue
   epnxt=(epnext+elmax)/2
   go to 400

   !--check for contributions from delta functions
  330 continue
   if (ndnow.eq.0) go to 400
   epnxt=emax
   do i=1,ndnow
      ll=7+ncnow*(i-1)
      epp=cnow(ll)
      w=(ep-epp-xc*e)/(2*sqrt(xc*e)*sqrt(epp))
      u=(xc*e+ep-epp)/(2*sqrt(xc*e)*sqrt(ep))
      wlo=-1
      whi=1
      if (w.ge.wlo.and.w.le.whi) then
         call legndr(u,p,na)
         f=h6dis(i,epn,epm,w,cnow,lang)
         f=f/(2*sqrt(xc*e*epp))
         epn=e*(sqrt(epp/e)+sqrt(xc))**2
         if (ep.lt.check*epn) then
            epn=rdn*epn
         else
            epn=rup*epn
         endif
         if (epn.lt.epnxt) epnxt=epn
         do l=1,nl
            term(l)=term(l)+f*p(l)
         enddo
      else if (w.lt.wlo) then
         epn=e*(sqrt(epp/e)-sqrt(xc))**2
         if (ep.lt.check*epn) then
            epn=rdn*epn
         else
            epn=rup*epn
         endif
         if (epn.lt.epnxt) epnxt=epn
      endif
   enddo

   !--select epnext
  400 continue
   epnext=epnxt
   return
  420 continue
   epnext=emax
   return
   end subroutine h6cm

   real(kr) function h6ddx(ep,epnext,epmax,w,cnow,lang,lep)
   !-------------------------------------------------------------------
   ! Retrieve the double differential cross section for
   ! secondary energy ep and cosine w (in the cm system) from a
   ! subsection in ENDF-6 File 6 format stored in cnow.  Call with
   ! ep=0 to initialize for each new e. Thereafter, ep can be
   ! requested in any order.  Only the continuum part is
   ! returned.  Delta functions, if given, must be handled
   ! separately.
   !-------------------------------------------------------------------
   use mathm ! provides legndr
   use util  ! provides error
   use endf  ! provides terp1
   ! externals
   integer::lang,lep
   real(kr)::ep,epnext,epmax,w,cnow(*)
   ! internals
   integer::ndnow,npnow,ncnow,mnow,inow,lnow,nl,na,l,lll
   integer::iza2,inn,ii,jj,ia,illdef
   real(kr)::enow,efirst,eplast,t,tt,s,r,aa,tii,tjj
   real(kr)::x1,x2,y1,y2
   integer,parameter::nlmax=65
   real(kr)::p(nlmax)
   real(kr),parameter::up=1.00001e0_kr
   real(kr),parameter::dn=.99999e0_kr
   real(kr),parameter::off=.999995e0_kr
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::zero=0
   save efirst,enow,nl,inow,mnow,lnow,ncnow,na,illdef

   !--initialize
   if (ep.eq.zero) then
      enow=cnow(2)
      ndnow=nint(cnow(3))
      npnow=nint(cnow(6))
      ncnow=nint(cnow(5))/npnow
      mnow=7+(npnow-1)*ncnow
      inow=7+ncnow*ndnow
      lnow=inow
      if (cnow(lnow).le.zero) lnow=lnow+ncnow
      epnext=cnow(lnow)
      epmax=cnow(mnow)
      nl=ncnow-1
      if (nl.gt.nlmax) call error('h6ddx',&
        'too many legendre terms',' ')
      na=nl-1
      efirst=0
      h6ddx=0
      illdef=0
      return
   endif

   !--check for desired interpolation range
   if (ep.lt.efirst*(1-small)) go to 200
   if (ep.gt.cnow(mnow)) go to 190
  130 continue
   epnext=cnow(lnow)
   if (ep.lt.off*epnext) go to 140
   if (lnow.ge.mnow) go to 135
   lnow=lnow+ncnow
   go to 130
  135 continue
   go to 150
  140 continue
   if (lnow.le.ncnow) go to 200
   eplast=cnow(lnow-ncnow)
   if (ep.ge.off*eplast) go to 150
   if (lnow.le.inow+ncnow) go to 150
   lnow=lnow-ncnow
   go to 130
  150 continue
   go to 210

   !--return zero above table
  190 continue
   t=0
   epnext=emax
   go to 350

   !--use analytic form below efirst.
  200 continue
   t=0
   go to 350

   !--legendre coefficients
  210 continue
   if (lang.eq.1) then
      call legndr(w,p,na)
      t=0
      do l=1,nl
         tt=0
         if (l.le.ncnow-1&
             .and.ep.ge.cnow(inow)*(1-small)&
             .and.ep.le.cnow(mnow)*(1+small)) then
            lll=lnow+l
            x1=cnow(lnow-ncnow)
            x2=cnow(lnow)
            if (x1.eq.x2.and.lep.gt.1) then
               x2=sigfig(x2,6,1)
               if (illdef.eq.0) then
                  illdef=1
               endif
            endif
            y1=cnow(lll-ncnow)
            y2=cnow(lll)
            call terp1(x1,y1,x2,y2,ep,tt,lep)
         endif
         t=t+p(l)*(2*l-1)*tt/2
      enddo
      if (t.lt.zero) t=0

   !--kalbach systematics
   else if (lang.eq.2) then
      s=0
      r=0
      if (ep.ge.cnow(inow)*(1-small).and.&
          ep.le.cnow(mnow)*(1+small)) then
         x1=cnow(lnow-ncnow)
         x2=cnow(lnow)
         if (x1.eq.x2.and.lep.gt.1) then
            x2=sigfig(x2,6,1)
            if (illdef.eq.0) then
               illdef=1
            endif
         endif
         y1=cnow(lnow-ncnow+1)
         y2=cnow(lnow+1)
         call terp1(x1,y1,x2,y2,ep,s,lep)
         y1=cnow(lnow-ncnow+2)
         y2=cnow(lnow+2)
         call terp1(x1,y1,x2,y2,ep,r,lep)
      endif
      iza2=nint(zap)
      aa=bacha(izap,iza2,izat,enow,ep)
      t=aa*(cosh(aa*w)+r*sinh(aa*w))/(2*sinh(aa))
      t=t*s
      if (t.lt.zero) t=0

   !--tabulated angular distribution
   else if (lang.ge.11.and.lang.le.15) then
      inn=lang-10
      ii=lnow-ncnow
      jj=lnow
      x1=cnow(ii)
      x2=cnow(jj)
      if (x1.eq.x2.and.lep.gt.1) then
         x2=sigfig(x2,6,1)
         if (illdef.eq.0) then
            illdef=1
         endif
      endif
      y1=cnow(ii+1)
      y2=cnow(jj+1)
      call terp1(x1,y1,x2,y2,ep,s,lep)
      tii=0
      do ia=1,na,2
         if (w.ge.cnow(ii+1+ia).and.w.le.cnow(ii+3+ia)) then
            call terp1(cnow(ii+1+ia),cnow(ii+2+ia),cnow(ii+3+ia),&
              cnow(ii+4+ia),w,tii,inn)
         endif
      enddo
      tjj=0
      do ia=1,na,2
         if (w.ge.cnow(jj+1+ia).and.w.le.cnow(jj+3+ia)) then
            call terp1(cnow(jj+1+ia),cnow(jj+2+ia),cnow(jj+3+ia),&
              cnow(jj+4+ia),w,tjj,inn)
         endif
      enddo
      call terp1(x1,tii,x2,tjj,ep,t,lep)
      t=t*s

   !--bad value for lang
   else
      call error('h6ddx','illegal lang.',' ')
   endif

   !--return final value
  350 continue
   h6ddx=t
   if (lep.gt.1) return
   if (epnext.eq.emax) return
   if (ep.lt.dn*dn*epnext) then
      epnext=dn*epnext
   else
      epnext=up*epnext
   endif
   return
   end function h6ddx

   real(kr) function h6dis(i,epnext,epmax,w,cnow,lang)
   !-------------------------------------------------------------------
   ! retrieve the double differential cross section for
   ! discrete-energy i and cosine w (in the cm system) from a
   ! subsection in endf-6 file 6 format stored in cnow.  call with
   ! i=0 to initialize for each new e. thereafter, i can be
   ! requested in any order.
   !-------------------------------------------------------------------
   use util  ! provides error
   use mathm ! provides legndr
   use endf  ! provides terp1
   ! externals
   integer::i,lang
   real(kr)::epnext,epmax,w,cnow(*)
   ! internals
   integer::ndnow,npnow,ncnow,inow,lnow,mnow,nl,na,l,iza2,inn,ia
   integer,parameter::mxlg=65
   real(kr)::enow,t,s,r,aa
   real(kr)::p(mxlg)
   real(kr),parameter::zero=0
   save nl,inow,lnow,mnow,ncnow,na,enow

   !--initialize
   if (i.eq.0) then
      enow=cnow(2)
      ndnow=nint(cnow(3))
      npnow=nint(cnow(6))
      ncnow=nint(cnow(5))/npnow
      inow=7
      lnow=inow
      mnow=lnow+(ndnow-1)*ncnow
      epnext=cnow(lnow)
      epmax=cnow(mnow)
      nl=ncnow-1
      na=nl-1
      h6dis=0
      return
   endif

   !--select desired discrete line
   inow=7+(i-1)*ncnow
   epnext=cnow(inow)
   t=0.

   !--legendre coefficients
   if (lang.eq.1) then
      call legndr(w,p,na)
      t=0
      do l=1,nl
         if (l.le.ncnow-1) then
            t=t+(2*l-1)*p(l)*cnow(inow+1+l)/2
         endif
      enddo
      t=t*cnow(inow+1)
      if (t.lt.zero) t=0

   !--kalbach systematics
   else if (lang.eq.2) then
      s=cnow(inow+1)
      r=cnow(inow+2)
      iza2=nint(zap)
      aa=bacha(izap,iza2,izat,enow,epnext)
      t=aa*(cosh(aa*w)+r*sinh(aa*w))/(2*sinh(aa))
      t=t*s
      if (t.lt.zero) t=0

   !--tabulated angular distribution
   else if (lang.ge.11.and.lang.le.15) then
      inn=lang-10
      t=0
      do ia=1,na-2,2
         if (w.ge.cnow(inow+1+ia).and.w.le.cnow(inow+3+ia)) then
            call terp1(cnow(inow+1+ia),cnow(inow+2+ia),&
              cnow(inow+3+ia),cnow(inow+4+ia),w,t,inn)
         endif
      enddo
      t=t*cnow(inow+1)

   !--illegal lang
   else
      call error('h6dis','illegal lang.',' ')
   endif

   !--return final value
   h6dis=t
   return
   end function h6dis

   real(kr) function bacha(iza1i,iza2,izat,e,ep)
   !-------------------------------------------------------------------
   ! Compute the Kalbach a parameter.
   !-------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::iza1i,iza2,izat
   real(kr)::e,ep
   ! internals
   integer::iza1,iza
   real(kr)::aa,za,ac,zc,ab,zb,nc,nb,na,sa,sb
   real(kr)::ecm,ea,eb,x1,x3,fa,fb
   character(60)::strng
   real(kr),parameter::third=.333333333e0_kr
   real(kr),parameter::twoth=.666666667e0_kr
   real(kr),parameter::fourth=1.33333333e0_kr
   real(kr),parameter::c1=15.68e0_kr
   real(kr),parameter::c2=-28.07e0_kr
   real(kr),parameter::c3=-18.56e0_kr
   real(kr),parameter::c4=33.22e0_kr
   real(kr),parameter::c5=-0.717e0_kr
   real(kr),parameter::c6=1.211e0_kr
   real(kr),parameter::s2=2.22e0_kr
   real(kr),parameter::s3=8.48e0_kr
   real(kr),parameter::s4=7.72e0_kr
   real(kr),parameter::s5=28.3e0_kr
   real(kr),parameter::brk1=130.e0_kr
   real(kr),parameter::brk2=41.e0_kr
   real(kr),parameter::half=0.5e0_kr
   real(kr),parameter::b1=0.04e0_kr
   real(kr),parameter::b2=1.8e-6_kr
   real(kr),parameter::b3=6.7e-7_kr
   real(kr),parameter::tomev=1.e-6_kr
   real(kr),parameter::zero=0

   iza1=iza1i
   if (iza1i.eq.0) iza1=1
   iza=izat
   if (iza.eq.6000) iza=6012
   if (iza.eq.12000) iza=12024
   if (iza.eq.14000) iza=14028
   if (iza.eq.16000) iza=16032
   if (iza.eq.17000) iza=17035
   if (iza.eq.19000) iza=19039
   if (iza.eq.20000) iza=20040
   if (iza.eq.22000) iza=22048
   if (iza.eq.23000) iza=23051
   if (iza.eq.24000) iza=24052
   if (iza.eq.26000) iza=26056
   if (iza.eq.28000) iza=28058
   if (iza.eq.29000) iza=29063
   if (iza.eq.31000) iza=31069
   if (iza.eq.40000) iza=40090
   if (iza.eq.42000) iza=42096
   if (iza.eq.48000) iza=48112
   if (iza.eq.49000) iza=49115
   if (iza.eq.50000) iza=50120
   if (iza.eq.63000) iza=63151
   if (iza.eq.72000) iza=72178
   if (iza.eq.74000) iza=74184
   if (iza.eq.82000) iza=82208
   aa=mod(iza,1000)
   if (aa.eq.zero) then
      write(strng,'(''dominant isotope not known for '',i8)') iza
      call error('bacha',strng,' ')
   endif
   za=int(iza/1000)
   ac=aa+mod(iza1,1000)
   zc=za+int(iza1/1000)
   ab=ac-mod(iza2,1000)
   zb=zc-int(iza2/1000)
   na=nint(aa-za)
   nb=nint(ab-zb)
   nc=nint(ac-zc)
   sa=c1*(ac-aa)&
     +c2*((nc-zc)**2/ac-(na-za)**2/aa)&
     +c3*(ac**twoth-aa**twoth)&
     +c4*((nc-zc)**2/ac**fourth-(na-za)**2/aa**fourth)&
     +c5*(zc**2/ac**third-za**2/aa**third)&
     +c6*(zc**2/ac-za**2/aa)
   if (iza1.eq.1002) sa=sa-s2
   if (iza1.eq.1003) sa=sa-s3
   if (iza1.eq.2003) sa=sa-s4
   if (iza1.eq.2004) sa=sa-s5
   sb=c1*(ac-ab)&
     +c2*((nc-zc)**2/ac-(nb-zb)**2/ab)&
     +c3*(ac**twoth-ab**twoth)&
     +c4*((nc-zc)**2/ac**fourth-(nb-zb)**2/ab**fourth)&
     +c5*(zc**2/ac**third-zb**2/ab**third)&
     +c6*(zc**2/ac-zb**2/ab)
   if (iza2.eq.1002) sb=sb-s2
   if (iza2.eq.1003) sb=sb-s3
   if (iza2.eq.2003) sb=sb-s4
   if (iza2.eq.2004) sb=sb-s5
   ecm=aa*e/ac
   ea=ecm*tomev+sa
   eb=tomev*ep*ac/ab+sb
   x1=eb
   if (ea.gt.brk1) x1=brk1*eb/ea
   x3=eb
   if (ea.gt.brk2) x3=brk2*eb/ea
   fa=1
   if (iza1.eq.2004) fa=0
   fb=1
   if (iza2.eq.1) fb=half
   if (iza2.eq.2004) fb=2
   bacha=b1*x1+b2*x1**3+b3*fa*fb*x3**4
   return
   end function bacha

   real(kr) function h6psp(ep,epnext,epmax,w,e,c)
   !-------------------------------------------------------------------
   ! Compute the double differential cross section for this incident
   ! energy (in the lab system), and secondary energy ep and cosine
   ! w (in the CM system) using the n-body phase-space formula.
   ! Call with ep=0 to initialize the retrieval routine for each
   ! new e.  Thereafter, ep can be requested in any order.
   !-------------------------------------------------------------------
   use endf ! provides contio
   use util ! provides error
   ! externals
   real(kr)::ep,epnext,epmax,w,e,c(*)
   ! internals
   integer::npsx
   real(kr)::apsx,f1,f2,test,s,cn,ex,eimax
   real(kr),parameter::c3=1.2732e0_kr
   real(kr),parameter::c4=3.2813e0_kr
   real(kr),parameter::c5=5.8205e0_kr
   real(kr),parameter::thrhaf=1.5e0_kr
   real(kr),parameter::sevhaf=3.5e0_kr
   real(kr),parameter::step=0.05e0_kr
   real(kr),parameter::rndup=1.000001e0_kr
   real(kr),parameter::emax=1.e10_kr
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::zero=0
   save cn,ex,eimax

   !--initialize
   if (ep.eq.zero) then
      apsx=c(1)
      npsx=nint(c(6))
      f1=(apsx-awp)/apsx
      f2=awrt/(awrt+1)
      ex=thrhaf*npsx-4
      eimax=f1*(f2*e+q)
      if (eimax.le.zero) eimax=1
      if (npsx.eq.3) then
         cn=c3/eimax**2
      else if (npsx.eq.4) then
         cn=c4/eimax**sevhaf
      else if (npsx.eq.5) then
         cn=c5/eimax**5
      else
         call error('h6psp','3, 4, or 5 particles only.',' ')
      endif
      h6psp=0
      epnext=step*eimax
      test=1
      if (eimax.eq.test) epnext=emax
      epmax=eimax
      return
   endif

   !--compute cross section
   s=0
   if (ep.lt.eimax*(1-small)) s=cn*sqrt(ep)*(eimax-ep)**ex
   h6psp=s
   epnext=ep+step*eimax
   if (epnext.gt.eimax*(1+small)) epnext=rndup*eimax
   if (ep.ge.eimax*(1-small)) epnext=emax
   return
   end function h6psp

   subroutine tabsq6(g,h,a,law,z,awr,e,yld)
   !-------------------------------------------------------------------
   ! Compute average of photon recoil energy from capture and
   ! corresponding damage energy for File 6 capture photons
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   integer::law
   real(kr)::g,h,a(*),z,awr,e,yld(*)
   ! internals
   integer::nd,np,ncyc,ibase,inn,nc,i,j,ip,ir,idis
   real(kr)::ein,rein,x,y,xr,awc,xh,yh,xl,yl,dx,s,yield,enext
   integer,parameter::nq=4
   real(kr),dimension(nq),parameter::qp=(/&
     -.86114e0_kr,-.33998e0_kr,.33998e0_kr,.86114e0_kr/)
   real(kr),dimension(nq),parameter::qw=(/&
     .34785e0_kr,.65215e0_kr,.65215e0_kr,.34785e0_kr/)

   !--initialize
   ein=2*tm
   rein=1/ein
   g=0
   h=0
   s=0
   nd=nint(a(3))
   np=nint(a(6))
   ncyc=nint(a(5))/np
   ibase=6
   inn=2

   !--interpolate the photon yield
   ip=2
   ir=1
   call terpa(yield,e,enext,idis,yld(1),ip,ir)

   !--accumulate contributions from discrete levels
   if (nd.ne.0) then
      do i=1,nd
         x=a(ibase+ncyc*(i-1)+1)
         y=a(ibase+ncyc*(i-1)+2)
         xr=x*x*rein
         g=g+xr*y
         awc=awr+1
         h=h+df(xr,z,awc,z,awr)*y
         s=s+y
      enddo
   endif

   !--accumulate contributions from continuum
   if (np.gt.nd) then
      nc=np-nd
      ibase=ibase+ncyc*nd
      xh=a(ibase+1)
      yh=a(ibase+2)
      do i=2,nc
         xl=xh
         xh=a(ibase+ncyc*(i-1)+1)
         yl=yh
         yh=a(ibase+ncyc*(i-1)+2)
         if (xl.ne.xh) then
            dx=xh-xl
            do j=1,nq
               x=xl+(1+qp(j))*dx/2
               call terp1(xl,yl,xh,yh,x,y,inn)
               xr=x*x*rein
               g=g+qw(j)*xr*dx*y
               h=h+qw(j)*df(xr,z,awr+1,z,awr)*dx*y
               s=s+qw(j)*dx*y
            enddo
         endif
      enddo
   endif

   !--finished
   g=yield*g/s
   h=yield*h/s
   return
   end subroutine tabsq6

   subroutine hgtfle(e,enext,idis,fle,nle,lcd,matd,mfd,mtd,nin,c,nc)
   !-------------------------------------------------------------------
   ! Retrieve or compute Legendre coefficients at e.
   ! Return isotropic distribution below first point.
   !-------------------------------------------------------------------
   use util ! provides error,mess
   use endf ! provides endf routines
   ! externals
   integer::idis,nle,lcd,matd,mfd,mtd,nin,nc
   real(kr)::e,enext,fle(*),c(nc)
   ! internals
   integer::nb,iso,lvt,ltt,ltt3,lttn,nwc,i,nlmax,il,l
   integer::iraw,ir,nne,ne,inn,innt,lct,nlo,nhi
   real(kr)::test,awr,elo,ehi
   character(60)::strng
   real(kr)::flo(65),fhi(65)
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::zero=0
   save iso,iraw,ir,nne,ne,inn
   save elo,ehi,nlo,nhi,flo,fhi,ltt,ltt3,lttn
   save lct,awr

   !--initialize
   idis=0
   if (e.gt.zero) go to 110
   iso=0
   call findf(matd,mfd,mtd,nin)
   call contio(nin,0,0,c,nb,nwc)
   awr=c(2)
   lvt=nint(c(3))
   ltt=nint(c(4))
   ltt3=ltt
   if (ltt.eq.3) then
      ltt=1
      lttn=1
   endif
   if (lvt.eq.0) then
      call contio(nin,0,0,c,nb,nwc)
   else
      call listio(nin,0,0,c,nb,nwc)
      do while (nb.ne.0)
         call moreio(nin,0,0,c(7),nb,nwc)
      enddo
   endif
   iso=nint(c(3))
   lct=nint(c(4))
   ! check for lab distribution for two-body scattering.
   test=10
   if (lct.eq.1.and.awr.ge.test) then
      if (mtd.ge.51.and.mtd.le.90) then
         write(strng,&
           '(''lab distribution changed to cm for mt '',i3)') mtd
         call mess('hgtfle',strng,' ')
         lct=2
      endif
   endif
   if (iso.ne.1) then
      call tab2io(nin,0,0,c(1),nb,nwc)
      ne=nint(c(6))
      ! read in raw data at first incident energy point
      ! retrieve or compute legendre coefficients.
      iraw=1+nwc
      if (ltt.eq.1) call listio(nin,0,0,c(iraw),nb,nwc)
      if (ltt.eq.2) call tab1io(nin,0,0,c(iraw),nb,nwc)
      if (nb.ne.0) then
         l=iraw
         do while (nb.ne.0)
           l=l+nwc
           call moreio(nin,0,0,c(l),nb,nwc)
         enddo
      endif
      elo=c(iraw+1)
      nlo=nle
      call hgetco(flo,nlo,lcd,c(iraw),lct,ltt,awr,idis)
      if (ltt.eq.1) call listio(nin,0,0,c(iraw),nb,nwc)
      if (ltt.eq.2) call tab1io(nin,0,0,c(iraw),nb,nwc)
      if (nb.ne.0) then
         l=iraw
         do while (nb.ne.0)
           l=l+nwc
           call moreio(nin,0,0,c(l),nb,nwc)
         enddo
      endif
      ehi=c(iraw+1)
      nhi=nle
      call hgetco(fhi,nhi,lcd,c(iraw),lct,ltt,awr,idis)
      ! check for total isotropy.
      if (ne.eq.2.and.nlo.eq.1.and.nhi.eq.1) iso=1
   endif
   if (iso.eq.1) then
      nle=1
      enext=etop
   else
      enext=elo
   endif
   nne=2
   ir=1
   inn=nint(c(6+2*ir))
   return

   !--normal entry
   !--is desired energy in current panel
  110 continue
   if (nle.eq.1) go to 150
   if (iso.eq.1) go to 150
   if (e.lt.ehi*(1-small)) go to 130
   if (nne.eq.ne.and.e.lt.ehi+ehi/100) go to 130

   !--no.  slide raw high energy data into low energy positions.
  120 continue
   do i=1,nhi
      flo(i)=fhi(i)
   enddo
   nlo=nhi
   elo=ehi

   !--read in new raw data at high energy.
   if (nne.eq.ne.and.ltt3.eq.3.and.lttn.eq.1) then
      call tab2io(nin,0,0,c(1),nb,nwc)
      ne=nint(c(6))
      nne=0
      ir=1
      ltt=2
      lttn=2
   else if (nne.eq.ne) then
      call error('hgtfle','desired energy above highest given.',' ')
   endif
   if (ltt.eq.1) call listio(nin,0,0,c(iraw),nb,nwc)
   if (ltt.eq.2) call tab1io(nin,0,0,c(iraw),nb,nwc)
   if (nb.ne.0) then
      l=iraw
      do while (nb.ne.0)
        l=l+nwc
        call moreio(nin,0,0,c(l),nb,nwc)
      enddo
   endif
   ehi=c(iraw+1)
   nhi=nle
   call hgetco(fhi,nhi,lcd,c(iraw),lct,ltt,awr,idis)
   nne=nne+1
   if (nne.gt.nint(c(5+2*ir))) ir=ir+1
   inn=nint(c(6+2*ir))
   if (ehi.le.e*(1+small).and.nne.lt.ne) go to 120

   !--yes.  interpolate for coefficients at desired energy.
  130 continue
   if (e.lt.elo*(1-small)) go to 140
   nlmax=nlo
   if (nlmax.lt.nhi) nlmax=nhi
   do i=1,nle
      if (i.le.nlmax) then
         innt=inn
         if (innt.eq.4.or.innt.eq.5) then
            if (flo(i)*fhi(i).le.zero) innt=innt-2
         endif
         call terp1(elo,flo(i),ehi,fhi(i),e,fle(i),innt)
      else
         fle(i)=0
      endif
   enddo
   nle=nlmax
   enext=ehi
   if (inn.eq.1) idis=1
   return

   !--return isotropic distribution below first point.
  140 continue
   fle(1)=1
   do il=2,nle
      fle(il)=0
   enddo
   nle=1
   enext=ehi
   idis=1
   return

   !--isotropic distribution or request.
  150 continue
   fle(1)=1
   if (nle.gt.1) then
      do il=2,nle
         fle(il)=0
      enddo
      nle=1
   endif
   enext=etop
   idis=0
   return
   end subroutine hgtfle

   subroutine hgetco(fl,nl,lcd,c,lct,ltt,awr,idis)
   !-------------------------------------------------------------------
   ! Retrieve or compute Legendre coefficients using raw data in
   ! ENDF format.  Conversion between reference systems and
   ! conversion of tabulated data to coefficients is performed by
   ! direct Gaussian quadrature of order 64. Significance of the
   ! results is reduced to reflect precision of calculation.
   !      nl   on entry, maximum number of coefficients desired
   !      nl   on return, number of coefficients required
   !      lcd  system desired (1 for lab, 2 for cm)
   !      lct  system of raw data
   !      ltt  format of raw data (1 for coefficients, 2 for tabulated)
   !      awr  atomic weight ratio
   !-------------------------------------------------------------------
   use util  ! provides error
   use mathm ! provides legndr
   use endf  ! provides terpa
   ! externals
   integer::nl,lcd,lct,ltt,idis
   real(kr)::fl(*),c(*),awr
   ! internals
   integer::l,np,il,ipc,irc,iq,ip,nlz,j
   real(kr)::x,y,xnext,xn
   real(kr)::p(65)
   real(kr),dimension(64),parameter::qp=(/&
     -9.99305042E-01_kr,-9.96340117E-01_kr,-9.91013371E-01_kr,&
     -9.83336254E-01_kr,-9.73326828E-01_kr,-9.61008800E-01_kr,&
     -9.46411375E-01_kr,-9.29569172E-01_kr,-9.10522137E-01_kr,&
     -8.89315446E-01_kr,-8.65999398E-01_kr,-8.40629296E-01_kr,&
     -8.13265315E-01_kr,-7.83972359E-01_kr,-7.52819907E-01_kr,&
     -7.19881850E-01_kr,-6.85236313E-01_kr,-6.48965471E-01_kr,&
     -6.11155355E-01_kr,-5.71895646E-01_kr,-5.31279464E-01_kr,&
     -4.89403146E-01_kr,-4.46366017E-01_kr,-4.02270158E-01_kr,&
     -3.57220158E-01_kr,-3.11322872E-01_kr,-2.64687162E-01_kr,&
     -2.17423644E-01_kr,-1.69644420E-01_kr,-1.21462819E-01_kr,&
     -7.29931218E-02_kr,-2.43502927E-02_kr, 2.43502927E-02_kr,&
      7.29931218E-02_kr, 1.21462819E-01_kr, 1.69644420E-01_kr,&
      2.17423644E-01_kr, 2.64687162E-01_kr, 3.11322872E-01_kr,&
      3.57220158E-01_kr, 4.02270158E-01_kr, 4.46366017E-01_kr,&
      4.89403146E-01_kr, 5.31279464E-01_kr, 5.71895646E-01_kr,&
      6.11155355E-01_kr, 6.48965471E-01_kr, 6.85236313E-01_kr,&
      7.19881850E-01_kr, 7.52819907E-01_kr, 7.83972359E-01_kr,&
      8.13265315E-01_kr, 8.40629296E-01_kr, 8.65999398E-01_kr,&
      8.89315446E-01_kr, 9.10522137E-01_kr, 9.29569172E-01_kr,&
      9.46411375E-01_kr, 9.61008800E-01_kr, 9.73326828E-01_kr,&
      9.83336254E-01_kr, 9.91013371E-01_kr, 9.96340117E-01_kr,&
      9.99305042E-01_kr/)
   real(kr),dimension(64),parameter::qw=(/&
      1.78328072E-03_kr, 4.14703326E-03_kr, 6.50445797E-03_kr,&
      8.84675983E-03_kr, 1.11681395E-02_kr, 1.34630479E-02_kr,&
      1.57260305E-02_kr, 1.79517158E-02_kr, 2.01348232E-02_kr,&
      2.22701738E-02_kr, 2.43527026E-02_kr, 2.63774697E-02_kr,&
      2.83396726E-02_kr, 3.02346571E-02_kr, 3.20579284E-02_kr,&
      3.38051618E-02_kr, 3.54722133E-02_kr, 3.70551285E-02_kr,&
      3.85501532E-02_kr, 3.99537411E-02_kr, 4.12625632E-02_kr,&
      4.24735151E-02_kr, 4.35837245E-02_kr, 4.45905582E-02_kr,&
      4.54916279E-02_kr, 4.62847966E-02_kr, 4.69681828E-02_kr,&
      4.75401657E-02_kr, 4.79993886E-02_kr, 4.83447622E-02_kr,&
      4.85754674E-02_kr, 4.86909570E-02_kr, 4.86909570E-02_kr,&
      4.85754674E-02_kr, 4.83447622E-02_kr, 4.79993886E-02_kr,&
      4.75401657E-02_kr, 4.69681828E-02_kr, 4.62847966E-02_kr,&
      4.54916279E-02_kr, 4.45905582E-02_kr, 4.35837245E-02_kr,&
      4.24735151E-02_kr, 4.12625632E-02_kr, 3.99537411E-02_kr,&
      3.85501532E-02_kr, 3.70551285E-02_kr, 3.54722133E-02_kr,&
      3.38051618E-02_kr, 3.20579284E-02_kr, 3.02346571E-02_kr,&
      2.83396726E-02_kr, 2.63774697E-02_kr, 2.43527026E-02_kr,&
      2.22701738E-02_kr, 2.01348232E-02_kr, 1.79517158E-02_kr,&
      1.57260305E-02_kr, 1.34630479E-02_kr, 1.11681395E-02_kr,&
      8.84675983E-03_kr, 6.50445797E-03_kr, 4.14703326E-03_kr,&
      1.78328072E-03_kr/)
   real(kr),parameter::toler=1.e-6_kr
   real(kr),parameter::rtoler=1.e6_kr
   real(kr),parameter::half=0.5e0_kr
   integer,parameter::nqp=64
   integer,parameter::nlmax=65
   real(kr),parameter::zero=0

   !--determine representation
   l=nl-1
   if (nl.gt.nlmax)&
     call error('hgetco','limited to 64 legendre coefficients.',' ')
   if (ltt.eq.2) go to 110
   if (lcd.eq.1.and.lct.ne.1) go to 110
   if (lcd.eq.2.and.lct.lt.2) go to 110

   !--retrieve coefficients from raw data
   np=nint(c(5))+1
   fl(1)=1
   do il=2,nl
      if (il.le.np) then
         fl(il)=c(il+5)
      else
         fl(il)=0
      endif
   enddo
   if (np.lt.nl) nl=np
   return

   !--integrate for fl in desired system
  110 continue
   fl(1)=1
   do il=2,nl
      fl(il)=0
   enddo
   ipc=2
   irc=1
   do iq=1,nqp
      x=qp(iq)

      !--compute scattering probability
      if (ltt.ne.2) then
         ! from coefficients
         np=nint(c(5))
         call legndr(x,p,np)
         y=half
         do ip=1,np
            y=(2*ip+1)*p(ip+1)*c(ip+6)/2+y
         enddo
      else
         ! from tabular data
         call terpa(y,x,xnext,idis,c,ipc,irc)
      endif

      !--multiply scattering probability by legendre polynomials
      !--in desired system and accumulate
      xn=x
      if (lcd.eq.2.and.lct.eq.1)&
        call error('hgetco','lab to cm conversion not coded.',' ')
      if (lcd.eq.1.and.lct.ge.2)&
        xn=(1+awr*x)/sqrt(1+awr*awr+2*awr*x)
      call legndr(xn,p,l)
      y=y*qw(iq)
      do il=2,nl
         fl(il)=fl(il)+y*p(il)
      enddo
   enddo

   !--reduce number of significant figures
   !--and count number of coefficients required
   nlz=1
   do il=2,nl
      j=nint(fl(il)*rtoler)
      fl(il)=j*toler
      if (abs(fl(il)).gt.zero) nlz=il
   enddo
   nl=nlz
   return
   end subroutine hgetco

   subroutine hconvr(nin,nout,nscr)
   !-------------------------------------------------------------------
   ! Convert photon transition probability arrays (LO=2), if any,
   ! to photon yields (LO=1).  Add MT456 if necessary.
   ! copy all other sections in this material.
   !-------------------------------------------------------------------
   use util ! provides error,mess
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nout,nscr
   ! internals
   integer::l2flg,imax,lmax,i,istor,nb,nw,j,lg,mt0,mt0old,n,jm1
   integer::kk,k,ii,kp1,l,ja,jb,lm1,ip1,mtl,no455,lnu
   integer::mf,mt,l1,l2,n1,n2,nnu,idone,imax2
   integer::i10,maths,mtnow,mtmess,mttst,nn
   integer::m1,m2,nmf3,nmf12
   integer,parameter::nqmx=450
   real(kr)::g,ei,p,ysum,eja,ejb,yy,tsave
   character(60)::strng
   integer::ngam(300)
   integer::mtq(nqmx)
   real(kr)::eeq(nqmx)
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::e,eg,es,y,aa,r
   real(kr),dimension(:),allocatable::nu,tmpnu
   real(kr),parameter::zero=0

   !--initialize
   mt0=0
   mt0old=0
   l2flg=0
!   imax=49
   imax=50
   lmax=500
   do i=1,imax
      ngam(i)=0
   enddo
   istor=0
   allocate(scr(npage+50))
   nsh=0
   nsc=0

   !--check for consistancy between mf3 mt's and, if present, mf12
   !  mt's.  if any discrete inelastic levels are defined, we expect
   !  to a sequential list of mt values from 51 to a maximum of 90.
   !  Furthermore, for version 6 formatted endf files there may be
   !  sequential mt values from 600 to a maximum of 648, 650 to a
   !  maximum of 698, 700 to a maximum of 748, 750 to a maximum of
   !  798 and 800 to a maximum of 848 and 876 to 891 for outgoing
   !  protons, deuterons, tritons, 3He, alpha particles and the (n,2n)
   !  reaction, respectively.  The allowed mt interval for version 5
   !  formatted files differs, and is accounted for in the coding that
   !  follows.  The absence of an expected mf3 mt section is flagged
   !  as an error condition; the absence of an expected mf12 mt section
   !  is noted in a message since, while unusual, may be normal.
   mtq=0
   eeq=0
   mtnow=0
   mtmess=0
   i10=0
   nmf3=0
   nmf12=0
  10 continue
   call contio(nin,0,0,scr,nb,nw)
   if (i10.eq.0) then
      i10=1
      maths=math
   endif
   if (math.eq.0) go to 20
   if (mfh.lt.3 .or. (mfh.gt.3.and.mfh.lt.12)) then
       call tofend(nin,0,0,scr)
       go to 10
   endif
   if (mfh.gt.12) go to 20
   if (mfh.eq.3) then
      if (mth.eq.51.or.                                                &
          (iverf.ge.6.and.(mth.eq.601.or.mth.eq.651.or.mth.eq.701.or.  &
                           mth.eq.751.or.mth.eq.801.or.mth.eq.876)).or.&
          (iverf.le.5.and.(mth.eq.701.or.mth.eq.721.or.mth.eq.741.or.  &
                           mth.eq.761.or.mth.eq.781))) then
         mtnow=mth
      elseif ((mth.gt.51.and.mth.lt.91).or.                 &
              (iverf.ge.6.and.mth.gt.601.and.mth.lt.648).or.&
              (iverf.ge.6.and.mth.gt.651.and.mth.lt.698).or.&
              (iverf.ge.6.and.mth.gt.701.and.mth.lt.748).or.&
              (iverf.ge.6.and.mth.gt.751.and.mth.lt.798).or.&
              (iverf.ge.6.and.mth.gt.801.and.mth.lt.848).or.&
              (iverf.ge.6.and.mth.gt.876.and.mth.lt.890).or.&
              (iverf.le.5.and.mth.gt.701.and.mth.lt.718).or.&
              (iverf.le.5.and.mth.gt.721.and.mth.lt.738).or.&
              (iverf.le.5.and.mth.gt.741.and.mth.lt.758).or.&
              (iverf.le.5.and.mth.gt.761.and.mth.lt.778).or.&
              (iverf.le.5.and.mth.gt.781.and.mth.lt.798)) then
         if (mtnow+1.ne.mth) then
            mtmess=1
            write(strng,'(''mf3, mt'',i2,'' is missing'')')mth-1
            call mess('hconvr',strng,'')
         endif
         mtnow=mth
      endif
      call contio(nin,0,0,scr,nb,nw)
      nmf3=nmf3+1
      mtq(nmf3)=mth
      eeq(nmf3)=scr(2)
      call tosend(nin,0,0,scr)
      go to 10
   elseif (mfh.eq.12) then
      if (mth.eq.51.or.                                                &
          (iverf.ge.6.and.(mth.eq.601.or.mth.eq.651.or.mth.eq.701.or.  &
                           mth.eq.751.or.mth.eq.801.or.mth.eq.876)).or.&
          (iverf.le.5.and.(mth.eq.701.or.mth.eq.721.or.mth.eq.741.or.  &
                           mth.eq.761.or.mth.eq.781))) then
         mtnow=mth
      elseif ((mth.gt.51.and.mth.lt.91).or.                 &
              (iverf.ge.6.and.mth.gt.601.and.mth.lt.648).or.&
              (iverf.ge.6.and.mth.gt.651.and.mth.lt.698).or.&
              (iverf.ge.6.and.mth.gt.701.and.mth.lt.748).or.&
              (iverf.ge.6.and.mth.gt.751.and.mth.lt.798).or.&
              (iverf.ge.6.and.mth.gt.801.and.mth.lt.848).or.&
              (iverf.ge.6.and.mth.gt.876.and.mth.lt.890).or.&
              (iverf.le.5.and.mth.gt.701.and.mth.lt.718).or.&
              (iverf.le.5.and.mth.gt.721.and.mth.lt.738).or.&
              (iverf.le.5.and.mth.gt.741.and.mth.lt.758).or.&
              (iverf.le.5.and.mth.gt.761.and.mth.lt.778).or.&
              (iverf.le.5.and.mth.gt.781.and.mth.lt.798)) then
         if (mtnow+1.ne.mth) then
            write(strng,'(''mf12, mt'',i2,'' may be missing'')')mth-1
            call mess('hconvr',strng,&
                               'discrete photon data may be incomplete')
         endif
         mtnow=mth
      endif
      nmf12=nmf12+1
      call tosend(nin,0,0,scr)
      go to 10
   endif
   if (mtmess.ne.0) then
      call error('hconvr',&
                 'missing mf3 mt''s, probable endf error','')
   endif

   !--mt checks are done, rewind the endf tape and position
   !  at the first record for this material
  20 continue
   call repoz(nin)
   call findf(maths,1,451,nin)

   !--loop over all sections of this material
  110 continue
   call contio(nin,0,0,scr,nb,nw)
   if (mfh.eq.0.and.math.ne.0) go to 130
   if (mfh.eq.1) go to 550
   if (mfh.eq.12.and.mth.ne.460) go to 120
   if (math.eq.1149.and.mfh.eq.13.and.mth.ge.51.and.iverf.lt.5)&
     go to 140
   if (math.eq.1150.and.mfh.eq.13.and.mth.le.54.and.iverf.lt.5)&
     go to 140
   if (mfh.eq.14.and.l2flg.eq.1) go to 500
   call contio(0,nout,nscr,scr,nb,nw)
   if (math.eq.0) go to 600
   call tosend(nin,nout,nscr,scr)
   go to 110
  120 continue
   if (l1h.eq.2) go to 150
   call contio(0,nout,nscr,scr,nb,nw)
   call tosend(nin,nout,nscr,scr)
   go to 110
  130 continue
   call contio(0,nout,nscr,scr,nb,nw)
   go to 110
  140 continue
   call tosend(nin,0,0,scr)
   write(strng,'(''gamma prod patch made for mt '',i3)') mth
   call mess('hconvr',strng,' ')
   go to 110

   !--allocate storage
  150 continue
   if (istor.eq.0) then
      istor=1
      imax2=imax*imax
      allocate(e(imax))
      allocate(eg(lmax))
      allocate(es(lmax))
      allocate(y(lmax))
      allocate(aa(imax2))
      allocate(r(imax2))
      e(1)=0
      do i=1,imax2
         r(i)=0
         aa(i)=0
      enddo
      do i=1,imax
         r(imax*(i-1)+i)=1
      enddo
   endif

   !--convert transition probability array to yields
   za=c1h
   awr=c2h
   lg=l2h
   g=1
   l2flg=1
   l=1
   call listio(nin,0,0,scr(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,scr(l),nb,nw)
      l=l+nw
   enddo

   !--set base value for mt0
   if (mth.ge.51.and.mth.le.91.and.mt0.ne.49) mt0=49
   if (iverf.ge.6) then
      if (mth.ge.601.and.mth.le.649.and.mt0.ne.599) mt0=599
      if (mth.ge.651.and.mth.le.699.and.mt0.ne.649) mt0=649
      if (mth.ge.701.and.mth.le.749.and.mt0.ne.699) mt0=699
      if (mth.ge.751.and.mth.le.799.and.mt0.ne.749) mt0=749
      if (mth.ge.801.and.mth.le.849.and.mt0.ne.799) mt0=799
      if (mth.ge.876.and.mth.le.891.and.mt0.ne.874) mt0=874
   elseif (iverf.le.5) then
      if (mth.ge.701.and.mth.le.719.and.mt0.ne.699) mt0=699
      if (mth.ge.721.and.mth.le.739.and.mt0.ne.719) mt0=719
      if (mth.ge.741.and.mth.le.759.and.mt0.ne.739) mt0=739
      if (mth.ge.761.and.mth.le.779.and.mt0.ne.759) mt0=759
      if (mth.ge.781.and.mth.le.799.and.mt0.ne.779) mt0=779
   endif

   !--load the e(_) array with mf3 -q.  Will overwrite with mf12
   !  mt data when possible (which should be always but if there
   !  is a missing mf12 mt, we're covered).
   if (mt0.ne.mt0old) then
      e=0
      mt0old=mt0
      m1=mt0+2
      if (mt0.eq.49) then
         m2=91
      elseif (iverf.ge.6.and.mt0.ne.874) then
         m2=m1+48
      elseif (iverf.ge.6.and.mt0.eq.874) then
         m2=m1+15
      elseif (iverf.le.5) then
         m2=m1+17
      endif
      nn=1
      mttst=-1
      do while (mttst.lt.m2.and.nn.le.nmf3)
         mttst=mtq(nn)
         if (mttst.ge.m1.and.mttst.le.m2) e(mttst-mt0)=-eeq(nn)
         nn=nn+1
      enddo
   endif
   j=mth-mt0
   e(j)=scr(1)
   n=n2h
   jm1=j-1
   do kk=1,jm1
      k=jm1-kk+1
      ii=0
      idone=0
      do while (ii.lt.n.and.idone.eq.0)
         ii=ii+1
         i=ii
         ei=scr(6+(lg+1)*i-lg)
         if (ei.eq.zero.and.e(k).eq.zero) then
            idone=1
         elseif (ei.ne.zero) then
            if (abs(ei-e(k))/ei.le.0.0001_kr) idone=1
         endif
      enddo
      if (idone.eq.0) then
         aa((k-1)*imax+j)=0
         r((k-1)*imax+j)=0
      else
         p=scr(7+(lg+1)*i-lg)
         g=1
         if (lg.eq.2) g=scr(6+(lg+1)*i)
         aa((k-1)*imax+j)=p*g
         r((k-1)*imax+j)=p
      endif
      if (k.ne.jm1) then
         kp1=k+1
         do ii=kp1,jm1
            r((k-1)*imax+j)=r((k-1)*imax+j)&
              +r((ii-1)*imax+j)*aa((k-1)*imax+ii)
         enddo
      endif
   enddo
   l=0
   ysum=0
   do i=2,j
      ja=j+2-i
      eja=e(ja)
      do ii=1,jm1
         jb=j-ii
         ejb=e(jb)
         yy=aa((jb-1)*imax+ja)*r((ja-1)*imax+j)
         if (yy.gt.zero) then
            l=l+1
            if (l.gt.lmax) then
               call error('hconvr','too many lo=2 gammas',' ')
            endif
            eg(l)=eja-ejb
            es(l)=eja
            y(l)=yy
            ysum=ysum+y(l)
         endif
      enddo
   enddo
   e(1)=0

   !--arrange gamma energies in descending order
   if (l.gt.1) then
      lm1=l-1
      do i=1,lm1
         ip1=i+1
         do ii=ip1,l
            if (eg(i).lt.eg(ii)) then
               tsave=eg(i)
               eg(i)=eg(ii)
               eg(ii)=tsave
               tsave=y(i)
               y(i)=y(ii)
               y(ii)=tsave
               tsave=es(i)
               es(i)=es(ii)
               es(ii)=tsave
            endif
         enddo
      enddo
   endif

   !--output computed yields in endf lo=1 format
   scr(1)=za
   scr(2)=awr
   scr(3)=1
   scr(4)=0
   scr(5)=l
   scr(6)=0
   mtl=49
   if (iverf.le.5.and.mth.ge.700) mtl=649
   if (iverf.ge.6.and.mth.ge.600) mtl=549
   ngam(mth-mtl)=l
   call contio(0,nout,nscr,scr,nb,nw)
   ! output tab1 sum record
   if (l.gt.1) then
      scr(1)=0
      scr(2)=0
      scr(3)=0
      scr(5)=1
      scr(6)=2
      scr(7)=2
      scr(8)=2
      scr(9)=ebot
      scr(10)=ysum
      scr(11)=etop
      scr(12)=ysum
      nw=12
      call tab1io(0,nout,nscr,scr,nb,nw)
   endif
   ! output rest of tab1 records
   do i=1,l
      scr(1)=eg(i)
      scr(2)=es(i)
      scr(3)=0
      scr(4)=2
      scr(5)=1
      scr(6)=2
      scr(7)=2
      scr(8)=2
      scr(9)=ebot
      scr(10)=y(i)
      scr(11)=etop
      scr(12)=y(i)
      nw=12
      call tab1io(0,nout,nscr,scr,nb,nw)
   enddo

   !--copy send record and loop over remaining sections.
   call contio(nin,nout,nscr,scr,nb,nw)
   go to 110

   !--angular distributions
  500 continue
   if (mth.ge.51.and.mth.le.90) then
      scr(3)=1
      scr(4)=0
      scr(6)=0
      scr(5)=ngam(mth-50)
      call contio(0,nout,nscr,scr,nb,nw)
      call tosend(nin,0,0,scr)
      call asend(nout,nscr)
   else
      call contio(0,nout,nscr,scr,nb,nw)
      call tosend(nin,nout,nscr,scr)
   endif
   go to 110

   !--file1.  add 456=452 if necessary.
  550 continue
   call contio(0,nout,nscr,scr,nb,nw)
   call tosend(nin,nout,nscr,scr)
   no455=0
   call contio(nin,nout,nscr,scr,nb,nw)
   if (mfh.eq.0) go to 110
   if (mth.ne.452) go to 595
!   nnu=9999
!   allocate(nu(nnu))
   if(allocated(tmpnu))deallocate(tmpnu)
   allocate(tmpnu(npage+46))
   l=1
   lnu=l2h
!   if (lnu.eq.1) call listio(nin,nout,nscr,nu(l),nb,nw)
!   if (lnu.eq.2) call tab1io(nin,nout,nscr,nu(l),nb,nw)
   if (lnu.eq.1) then
      call listio(nin,nout,nscr,tmpnu(l),nb,nw)
   elseif (lnu.eq.2) then
      call tab1io(nin,nout,nscr,tmpnu(l),nb,nw)
   endif
   nnu=nb+nw+1
   if (allocated(nu))deallocate(nu)
   allocate(nu(nnu))
   nu(1:nw)=tmpnu(1:nw)
   do while (nb.ne.0)
      l=l+nw
      if (l.gt.nnu) call error('hconvr',&
        'exceeded storage for nubar',' ')
      call moreio(nin,nout,nscr,nu(l),nb,nw)
   enddo
   call tosend(nin,nout,nscr,scr)
  565 continue
   call contio(nin,0,0,scr,nb,nw)
   if (mth.eq.456) go to 590
   if (mth.eq.0.and.no455.eq.0) go to 570
   if (mfh.eq.0) go to 590
   if (mth.eq.455) no455=1
   if (mth.gt.456.and.no455.eq.0) go to 570
   call contio(0,nout,nscr,scr,nb,nw)
   call tosend(nin,nout,nscr,scr)
   go to 565
  570 continue
   if (no455.eq.1) go to 590
   mf=mfh
   mt=mth
   l1=l1h
   l2=l2h
   n1=n1h
   n2=n2h
   mfh=1
   mth=456
   scr(3)=0
   scr(4)=lnu
   scr(5)=0
   scr(6)=0
   l=1
   call contio(0,nout,nscr,scr,nb,nw)
   if (lnu.eq.1) call listio(0,nout,nscr,nu(l),nb,nw)
   if (lnu.eq.2) call tab1io(0,nout,nscr,nu(l),nb,nw)
   do while (nb.ne.0)
      l=l+nw
      if (l.gt.nnu) call error('hconvr',&
        'exceeded storage for nubar',' ')
      call moreio(0,nout,nscr,nu(l),nb,nw)
   enddo
   call asend(nout,nscr)
   mfh=mf
   mth=mt
   scr(3)=l1
   scr(4)=l2
   scr(5)=n1
   scr(6)=n2
  590 continue
   call contio(0,nout,nscr,scr,nb,nw)
   deallocate(nu)
   if (mfh.eq.0) go to 110
  595 continue
   call tofend(nin,nout,nscr,scr)
   go to 110

   !--conver is finished.
  600 continue
   if (istor.gt.0) then
      deallocate(e)
      deallocate(eg)
      deallocate(es)
      deallocate(y)
      deallocate(aa)
      deallocate(r)
   endif
   deallocate(scr)
   return
   end subroutine hconvr

   subroutine hgam102(e,ebar,dame,disc102,c,irec,zp,ap,zt,at)
   !-------------------------------------------------------------------
   ! Process the relativistic discrete gamma or its recoil as
   ! given in mf6/mt102 for ENDF/B-VII neutron + H-1.
   !-------------------------------------------------------------------
   ! externals
   integer::irec
   real(kr)::e,ebar,dame,disc102,zp,ap,zt,at
   real(kr)::c(*)
   ! internals
   real(kr)::er,eg2

   if (irec.eq.0) then
      ebar=disc102+e*awr/(1+awr)
      dame=0
   else
      !--include recoil energy plus photon "kick" energy
      er=e/(awr+1)
      eg2=disc102*disc102*rtm/2
      ebar=er+eg2
      dame=df(ebar,zp,ap,zt,at)
   endif
   return
   end subroutine hgam102

   subroutine gheat(iold,inew,nscr)
   !-------------------------------------------------------------------
   ! Subtract energy carried away by gammas.
   !-------------------------------------------------------------------
   use util ! provides error,mess,loada,finda,sigfig
   use mainio ! provides nsyso
   use endf ! provides endf routines and variables
   ! externals
   integer::iold,inew,nscr
   ! internals
   integer::nb,nw,mfd,mgam,nk,ik,mfc,mtc,npkk,npkt
   integer::lo,mfx,mtx,mtd,jdis,ilist,nwd,lp,lqx,idis
   integer::i,ipx,irx,nmt,mty,idx,ii,indxx,it,isave,jerr,nd
   real(kr)::afact,aw1fac,z,e,dame
   real(kr)::cerr,enxt,el,elow,ehigh,test,thresh
   real(kr)::egkr,ebar,egam,edam,damn,enext,enx,egk
   real(kr)::h,hk,cfix,eava,ebarp,xp,yp,hp,egamp,edamp
   real(kr)::damep,hx,hxp,subtot,elo,ehi,x,y
   real(kr)::c(30)
   integer::imt(30)
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::b
   real(kr),dimension(:),allocatable::d
   real(kr),dimension(:),allocatable::bufo,bufn
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::smin=1.e-9_kr
   real(kr),parameter::qtest=99.e6_kr
   real(kr),parameter::zero=0
   integer::mf6flg
   character(len=70)::strng1,strng2

   !--allocate buffers for loada/finda
   allocate(bufo(nbuf))
   allocate(bufn(nbuf))

   !--find first section of mf12 or mf13
   allocate(scr(npage+50))
   mfd=3
   afact=awr/(awr+1)
   aw1fac=1/(awr+1)
   z=nint(za/1000)
   e=0
   dame=df(e,z,awr,z,awr)
   mgam=2
   hk=0
  100 continue
   call contio(nscr,0,0,scr,nb,nw)
   if (mfh.eq.12) mgam=1
   if (mfh.ge.12) go to 102
   call tofend(nscr,0,0,scr)
   go to 100
  102 continue
   mfc=mfh
   mtc=mth
   call findf(matd,mfc,mtc,nscr)
   npkk=npk
   if (kchk.eq.1) npkk=3*npk-2
   if (mgam.gt.0) npkk=npkk+3
   npkt=npk-1

   !--sum all reactions found in mf12 and mf13.
   !--reconstruct redundant cross sections if needed.
   allocate(b(npage+50))
   nd=10000
   allocate(d(nd))
   if (mgam.eq.2) go to 210
  105 continue
   call contio(nscr,0,0,scr,nb,nw)
   if (mfh.gt.13) go to 250
   if (mfh.eq.0) go to 220
   if (mth.eq.0) go to 105
   if (mfh.eq.12.and.mth.eq.460) then
      call tosend(nscr,0,0,scr)
      go to 105
   endif
   ! skip over this mf/mt if photon data were already found in mf6
   if (i6p.gt.0) then
      mf6flg=0
      do i=1,i6p
         if (mt6yp(i).ne.mth) cycle
         mf6flg=1
         exit
      enddo
      if (mf6flg.ne.0) then
         write(strng1,'(''skipping mf'',i2,''/mt = '',i3)')mfh,mth
         write(strng2,'(''photons were already processed in mf6'')')
         call mess('gheat ',strng1,strng2)
         call tosend(nscr,0,0,scr)
         go to 105
      endif
   endif
   lo=l1h
   if (lo.eq.2) call error('gheat','lo=2 not coded.',' ')
   mfx=mfh
   mtd=mth
   mtx=mth
   if (mth.eq.3) mtd=1
   if (iprint.eq.1.and.mfh.eq.12.and.idame.gt.0.and.mtd.eq.102)&
     write(nsyso,'(/&
       &'' photon energy (from yields) mf'',i2,'', mt'',i3/&
       &14x,''e'',6x,''ebar/err'',10x,''egam'',10x,''edam'',10x,&
       &''xsec'',9x,''yield'',7x,''heating'',8x,''damage'')')&
       mfh,mth
   if (iprint.eq.1.and.mfh.eq.12.and.(idame.eq.0.or.mtd.ne.102))&
     write(nsyso,'(/&
       &'' photon energy (from yields) mf'',i2,'', mt'',i3/&
       &14x,''e'',10x,''ebar'',10x,''xsec'',9x,''yield'',&
       &8x,''energy'',7x,''heating'')') mfh,mth
   if (iprint.eq.1.and.mfh.eq.13) write(nsyso,'(/&
     &'' photon energy (from xsecs) mf'',i2,'', mt'',i3/&
     &14x,''e'',10x,''ebar'',10x,''xsec'',8x,''energy'',7x,&
     &''heating'')') mfh,mth
  110 continue
   nk=n1h
   ik=0
   cerr=0
   ! check for leading or trailing zeroes to locate ranges
   ! where this partial is not defined
   e=0
   call gety1(e,enxt,jdis,y,nscr,scr)
   e=enxt
   el=sigfig(e,7,0)
   elow=big
   ehigh=0
   test=big-big/100
   do while (e.lt.test)
      call gety1(e,enxt,jdis,y,nscr,scr)
      if (y.gt.zero.and.e.lt.elow) elow=el
      if (y.gt.zero) ehigh=0
      if (ehigh.eq.zero.and.y.eq.zero) ehigh=sigfig(e,7,0)
      el=sigfig(e,7,0)
      e=enxt
   enddo
   if (ehigh.eq.zero) ehigh=sigfig(e,7,0)
   if (nk.eq.1) then
      call findf(matd,mfx,mtx,nscr)
      call contio(nscr,0,0,scr,nb,nw)
   endif
  130 continue
   e=0
   call gety1(e,thresh,jdis,y,nscr,scr)
   ilist=1
   egkr=c1h
   nwd=nd
   if (egkr.eq.zero)&
     call gambar(e,ebar,egam,edam,nendf,matd,mtx,d,nwd)
   lp=l1h
   ik=ik+1
   if (iprint.eq.1.and.egkr.eq.zero) write(nsyso,&
     '(i6,''  continuum gammas'')') ik
   if (iprint.eq.1.and.egkr.gt.zero) write(nsyso,&
     '(i6,1p,e13.4,'' ev gamma'')') ik,egkr
   lqx=0
   if (mfd.eq.13) go to 150
   call findf(matd,mfd,mtd,nin)
   call contio(nin,0,0,b,nb,nw)
   call gety2(e,enxt,idis,x,nin,b)
   if (mth.eq.102) then
      q=c2h
      if (nqa.gt.0) then
         do i=1,nqa
            if (mta(i).eq.mth) then
               q=qa(i)
               if (q.ge.qtest) lqx=lqs(i)
            endif
         enddo
      endif
      call capdam(e,damn,q,za,awr,mth)
      call disgam(e,egam,edam,z,awr)
      ipx=2
      irx=1
   endif
   if (enxt.gt.thresh) thresh=enxt

   !--loop over all energies in grid
  150 continue
   if (ik.gt.1) go to 160
   nmt=0
   if (npk.lt.3) go to 160
   mty=mtx
   if (mty.eq.3) mty=1
   if (mty.eq.4) mty=51
   if (mty.eq.18.and.mt19.eq.1) mty=19
   call indx(npk,mtp,mt19,mty,imt,nmt)
  160 continue
   i=0
  190 continue
   i=i+1
   call finda(i,c,npkk,iold,bufo,nbuf)
   e=sigfig(c(1),9,0)
   if (e.lt.elow*(1-small).or.e.gt.ehigh*(1+small)) go to 180
   call gety1(e,enext,jdis,y,nscr,scr)
   x=zero
   if (mfd.eq.3) then
      call gety2(e,enext,idis,x,nin,b)
      if (x.eq.zero) go to 195
   endif
   if (lqx.ne.0) call terpa(q,e,enx,idx,qbar(lqx),ipx,irx)
   egk=egkr
   if (lp.eq.2) egk=egkr+e*afact
   ebar=egk
   dame=0
   if (ik.eq.1) c(npkk)=0
   if (egkr.eq.zero)&
     call gambar(e,ebar,egam,edam,nendf,matd,mtx,d,nwd)
   if (mfd.eq.13) go to 170
   if (mth.ne.102) go to 164
   ! photon recoil correction
   if (egkr.ne.zero) call disgam(egkr,egam,edam,z,awr)
   h=egam*x*y
   hk=h
   c(npkk-1)=c(npkk-1)+x*y*ebar
   c(npkk)=c(npkk)+y*ebar
   dame=edam*x*y
   if (ik.eq.nk) then
      if (idame.gt.0) then
         call capdam(e,damn,q,za,awr,mth)
         dame=dame-damn*x
      endif
      hk=hk-x*rtm*(q+e*awr*aw1fac)**2/2
      cfix=(e+q-e*aw1fac)*x
      h=h-cfix
      c(npkk-2)=cfix-x*c(npkk)
      eava=afact*e+q
      cerr=100*(c(npkk)-eava)/eava
   endif
   ebarp=sigfig(ebar,9,0)
   xp=sigfig(x,9,0)
   yp=sigfig(y,9,0)
   hp=sigfig(h,9,0)
   egamp=sigfig(egam,9,0)
   edamp=sigfig(edam,9,0)
   damep=sigfig(dame,9,0)
   cerr=sigfig(cerr,4,0)
   if (iprint.ne.1.or.abs(e-elist(ilist)).gt.small*e&
     .or.y.le.smin) go to 166
   if (idame.eq.0) then
      write(nsyso,'(1x,1p,8e14.4)') e,ebarp,xp,yp,hp
   else
      write(nsyso,'(1x,1p,8e14.4)')&
        e,ebarp,egamp,edamp,xp,yp,hp,damep
   endif
   if (ik.eq.nk) write(nsyso,&
     '(1x,1p,e14.4,0p,f10.1,'' pc'')') e,cerr
   go to 166
   ! other mf12 reactions
  164 continue
   if (mtd.ne.2.and.mtd.ne.460) h=-y*x*ebar
   if (mtd.eq.2) h=y*x*ebar
   c(npkk-1)=c(npkk-1)-h
   c(npkk)=c(npkk)+h
  166 continue
   hx=h
   c(2)=c(2)+h
   if (nmt.gt.0) then
      do ii=1,nmt
         indxx=imt(ii)
         if (mtp(indxx).ge.444) c(indxx)=c(indxx)+dame
         if (mtp(indxx).lt.442) c(indxx)=c(indxx)+h
         if (mtp(indxx).eq.442) c(indxx)=c(indxx)-h
         if (mtp(indxx).eq.443.and.mth.eq.102) c(indxx)=c(indxx)+hk
      enddo
   endif
   if (iprint.eq.0.or.e.ne.elist(ilist)) go to 180
   if (mth.eq.102) go to 180
   if (ik.lt.nk.and.y.lt.smin) go to 180
   if (nk.eq.1.and.y.lt.smin) go to 180
   test=-1
   test=test/10000
   if (nk.gt.1.and.ik.eq.nk.and.c(npkk).gt.test) go to 180
   ebarp=sigfig(ebar,9,0)
   xp=sigfig(x,9,0)
   yp=sigfig(y,9,0)
   hxp=sigfig(hx,9,0)
   hp=sigfig(h,9,0)
   write(nsyso,'(1x,1p,8e14.4)') e,ebarp,xp,yp,-hxp,hp
   if (ik.eq.nk.and.nk.gt.1) then
      subtot=-c(npkk)
      subtot=sigfig(subtot,9,0)
      write(nsyso,'(48x,''subtot   '',1p,e14.4)') subtot
   endif
   go to 180
   ! mf13 reactions
  170 continue
   h=-y*ebar
   c(npkk-1)=c(npkk-1)-h
   c(npkk)=c(npkk)+h
   hx=h
   c(2)=c(2)+h
   if (nmt.gt.0) then
      do ii=1,nmt
         indxx=imt(ii)
         if (mtp(indxx).lt.442) c(indxx)=c(indxx)+h
         if (mtp(indxx).eq.442) c(indxx)=c(indxx)-h
      enddo
   endif
   if (iprint.eq.0.or.abs(e-elist(ilist)).gt.small*e) go to 180
   if (ik.lt.nk.and.y.lt.smin) go to 180
   if (nk.eq.1.and.y.lt.smin) go to 180
   test=-1
   test=test/10000
   if (nk.gt.1.and.ik.eq.nk.and.c(npkk).gt.test) go to 180
   ebarp=sigfig(ebar,9,0)
   yp=sigfig(y,9,0)
   hxp=sigfig(hx,9,0)
   hp=sigfig(h,9,0)
   write(nsyso,'(1x,1p,8e14.4)') e,ebarp,yp,-hxp,hp
   if (ik.eq.nk.and.nk.gt.1) then
      subtot=-c(npkk)
      subtot=sigfig(subtot,9,0)
      write(nsyso,'(48x,''subtot   '',1p,e14.4)') subtot
   endif
  180 continue
  195 continue
   it=i
   if (i.eq.ne) it=-it
   call loada(it,c,npkk,inew,bufn,nbuf)
   if (abs(e-elist(ilist)).lt.small*e) ilist=ilist+1
   if (i.lt.ne) go to 190

   !--loop over all subsections and reactions.
   isave=iold
   iold=inew
   inew=isave
   if (ik.lt.nk) go to 130
   if (mfd.eq.13) go to 105
   if (mtx.eq.3.and.mtd.eq.1) go to 200
   go to 105
  200 continue
   mtd=2
   call findf(matd,mfx,mtx,nscr)
   call contio(nscr,0,0,scr,nb,nw)
   go to 110
  210 continue
   call mess('gheat','no file 12 for this material.',' ')
   call findf(matd,13,0,nscr)

   !--finished with present file.
  220 continue
   if (mfd.eq.13) go to 250
   mfd=13
   mtd=0
   go to 105
  250 continue
   if (kchk.ne.1) go to 300
   if (mt303.eq.0) go to 300

   !--print kinematic test for total photon production
   ilist=1
   write(nsyso,'(/'' photon energy production check''/&
     &14x,''e'',6x,''ev-barns'',11x,''min'',11x,''max'')')
   do i=1,ne
      call finda(i,c,npkk,iold,bufo,nbuf)
      e=sigfig(c(1),9,0)
      if (abs(e-elist(ilist)).le.small*e) then
         ilist=ilist+1
         elo=c(npkk-1)+c(mt303)-c(mt303+2*npkt)+c(npkk-2)
         ehi=c(npkk-1)+c(mt303)-c(mt303+npkt)+c(npkk-2)
         jerr=0
         if (c(npkk-1).gt.ehi+ehi/10) jerr=+1
         if (c(npkk-1).lt.elo-elo/10) jerr=-1
         if (jerr.eq.0) write(nsyso,'(1x,1p,8e14.4)')&
           e,c(npkk-1),elo,ehi
         if (jerr.gt.0) write(nsyso,'(1x,1p,4e14.4,''   ++++'')')&
           e,c(npkk-1),elo,ehi
         if (jerr.lt.0) write(nsyso,'(1x,1p,4e14.4,''   ----'')')&
           e,c(npkk-1),elo,ehi
      endif
   enddo
  300 continue
   deallocate(d)
   deallocate(b)
   deallocate(scr)
   deallocate(bufn)
   deallocate(bufo)
   return
   end subroutine gheat

   subroutine gambar(e,ebar,esqb,esqd,nin,matd,mtd,a,nwamax)
   !-------------------------------------------------------------------
   ! Calculate ebar for continuous spectra and the photon
   ! recoil correction for capture.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,matd,mtd,nwamax
   real(kr)::e,ebar,esqb,esqd,a(*)
   ! internals
   integer::nb,nw,mfd,l,iz,lf,iend,j,il
   integer::jstart,jend,istart,ilo,ihi,nnt,ne,nne,inn,nbt
   real(kr)::z,awr,elo,ehi,flo,fhi,glo,ghi,hlo,hhi,sen
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::up=1.000001e0_kr
   real(kr),parameter::zero=0
   save lf,z,awr
   save jstart,jend,istart,ilo,ihi,nnt,ne,nne,inn,nbt
   save elo,ehi,flo,fhi,glo,ghi,hlo,hhi

   !--initialize if e=0.
   if (e.gt.zero) go to 110
   mfd=15
   call findf(matd,mfd,mtd,nin)
   l=1
   call contio(nin,0,0,a(l),nb,nw)
   iz=nint(c1h/1000)
   z=iz
   awr=c2h
   call tab1io(nin,0,0,a(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      if (l.gt.nwamax) call error('gambar',&
        'storage exceeded in a.',' ')
      call moreio(nin,0,0,a(l),nb,nw)
      l=l+nw
   enddo
   lf=1

   !--read in first incident energy point.
   l=1
   call tab2io(nin,0,0,a(l),nb,nw)
   ne=nint(a(l+5))
   nnt=l+6
   nbt=nint(a(nnt))
   inn=nint(a(nnt+1))
   inn=2
   istart=l+nw
   l=istart
   call tab1io(nin,0,0,a(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      if (l.gt.nwamax) call error('gambar',&
        'storage exceeded in a.',' ')
      call moreio(nin,0,0,a(l),nb,nw)
      l=l+nw
   enddo
   iend=l-1
   jstart=iend+1
   jend=0
   ehi=a(istart+1)
   elo=ehi
   nne=1
   ilo=0
   ihi=0
   fhi=0
   ghi=0
   hhi=0
   return

   !--normal entry.  is desired energy in current panel.
  110 continue
   if (e.lt.ehi*(1-small)) go to 140
   if (nne.eq.1) go to 130
   if (nne.eq.ne) go to 160

   !--no.  slide high energy data into low energy positions.
  120 continue
   j=-1
   do il=jstart,jend
      j=j+1
      a(j+istart)=a(il)
   enddo
   iend=istart+j
   jstart=iend+1
   elo=ehi
   flo=fhi
   if (mtd.eq.102) glo=ghi
   if (mtd.eq.102) hlo=hhi
   ilo=ihi

   !--read new high energy data record.
  130 continue
   if (nne.eq.ne)&
     call error('gambar','requested energy gt highest given.',' ')
   l=jstart
   call tab1io(nin,0,0,a(l),nb,nw)
   l=l+nw
   do while (nb.ne.0)
      if (l.gt.nwamax) call error('gambar',&
        'storage exceeded in a.',' ')
      call moreio(nin,0,0,a(l),nb,nw)
      l=l+nw
   enddo
   jend=l-1
   nne=nne+1
   ihi=0
   ehi=a(jstart+1)
   if (ehi.lt.e*(1-small).and.nne.lt.ne) go to 120

   !--integrate at high and low energies.
   if (ilo.le.0) then
      call tabbar(flo,a(istart),lf)
      if (mtd.eq.102) call tabsqr(glo,hlo,a(istart),lf,z,awr)
   endif
   call tabbar(fhi,a(jstart),lf)
   if (mtd.eq.102) call tabsqr(ghi,hhi,a(jstart),lf,z,awr)
   ihi=1

   !--yes.  interpolate for mean energy.
  140 continue
   if (nne.eq.1) go to 150
   if (nne.gt.nbt) then
      nnt=nnt+2
      nbt=nint(a(nnt))
      inn=nint(a(nnt+1))
      inn=2
   endif
   if (elo.eq.ehi) then
       elo=sigfig(elo,7,-1)
       ehi=sigfig(ehi,7,+1)
   endif
   call terp1(elo,flo,ehi,fhi,e,sen,inn)
   if (mtd.eq.102) call terp1(elo,glo,ehi,ghi,e,esqb,inn)
   if (mtd.eq.102) call terp1(elo,hlo,ehi,hhi,e,esqd,inn)
   ebar=sen
   return

   !--return zero below threshold.
  150 continue
   ebar=0
   esqb=0
   esqd=0
   return

   !--return zero or fhi above table.
  160 continue
   if (inn.ne.1.and.e.ge.up*ehi) then
      ebar=0
      esqb=0
      esqd=0
   else
      ebar=fhi
      esqb=ghi
      esqd=hhi
   endif
   return
   end subroutine gambar

   subroutine tabsqr(g,h,a,law,z,awr)
   !-------------------------------------------------------------------
   ! Compute average of photon recoil energy from capture and
   ! corresponding damage energy for a tabulated section of File 15.
   !-------------------------------------------------------------------
   use endf ! provides terp1
   ! externals
   integer::law
   real(kr)::g,h,a(*),z,awr
   ! internals
   integer::nr,np,ibase,ir,nbt,inn,i,j
   real(kr)::ein,rein,xl,yl,xh,yh,dx,x,y,xr,s
   integer,parameter::nq=4
   real(kr),dimension(nq),parameter::qp=(/&
     -.86114e0_kr,-.33998e0_kr,.33998e0_kr,.86114e0_kr/)
   real(kr),dimension(nq),parameter::qw=(/&
     .34785e0_kr,.65215e0_kr,.65215e0_kr,.34785e0_kr/)

   !--initialize
   ein=2*tm
   rein=1/ein
   g=0
   h=0
   s=0
   nr=nint(a(5))
   np=nint(a(6))
   ibase=6+2*nr
   ir=1
   nbt=nint(a(7))
   inn=nint(a(8))
   xh=a(ibase+1)
   yh=a(ibase+2)

   !--accumulate contributions to integrals
   do i=2,np
      xl=xh
      xh=a(ibase+2*i-1)
      yl=yh
      yh=a(ibase+2*i)
      if (i.gt.nbt) then
         ir=ir+1
         nbt=nint(a(6+2*ir-1))
         inn=nint(a(6+2*ir))
      endif
      if (xl.ne.xh) then
         dx=xh-xl
         do j=1,nq
            x=xl+(1+qp(j))*dx/2
            call terp1(xl,yl,xh,yh,x,y,inn)
            xr=x*x*rein
            g=g+qw(j)*xr*dx*y
            h=h+qw(j)*df(xr,z,awr+1,z,awr)*dx*y
            s=s+qw(j)*dx*y
         enddo
      endif
   enddo
   g=g/s
   h=h/s
   return
   end subroutine tabsqr

   subroutine disgam(e,egam,edam,z,awr)
   !-------------------------------------------------------------------
   ! Compute recoil and damage energy of discrete capture photons.
   !-------------------------------------------------------------------
   ! externals
   real(kr)::e,egam,edam,z,awr
   ! internals
   real(kr),parameter::zero=0

   if (e.eq.zero) then
      return
   else
      egam=e*e*rtm/2
      edam=df(egam,z,awr+1,z,awr)
   endif
   return
   end subroutine disgam

   subroutine hout(iold)
   !-------------------------------------------------------------------
   ! Write the output tape with corrected dictionary and
   ! desired MT-s added.
   !-------------------------------------------------------------------
   use util ! provides openz,repoz,closz,error,sigfig
   use mainio ! provides nsyso
   use endf ! provides endf routines and variables
   ! externals
   integer::iold
   ! internals
   integer::nscr,npkk,npkt,npkd,npktd,i,ilist,inpk,nb,nw
   integer::nxn,k,mfi,mti,mtn,ia,nn
   integer::idict,idict1,nx,inow,nwd,n,ilo,ihi,j,ibase
   integer::iowr,mfnin,mtnin,mfnscr,mtnscr,inow6
   real(kr)::x,y,xlast,ylo,yhi,thin,rat,elo,test,e
   real(kr)::c(30)
   integer::ncds(30)
   character(4)::klo(9),khi(9)
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::b
   real(kr),dimension(:),allocatable::buf
   character(60)::strng
   character(4)::iblank='    '
   character(4)::idown='low '
   character(4)::iup='high'
   character(1),parameter::qu=''''
   real(kr),parameter::small=1.e-10_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::emax=20.e6_kr
   real(kr),parameter::ecut=.01e6_kr
   real(kr),parameter::zero=0
   real(kr),parameter::ten=10
   integer,parameter::nwscr=10000

   ! allocate scratch storage for endf records and buffer
   allocate(scr(nwscr))
   allocate(buf(nbuf))

   !--construct tab1 records for the kerma factors
   n=0
   nscr=15
   if (nout.lt.0) nscr=-nscr
   call openz(nscr,1)
   call repoz(nscr)
   if (iprint.eq.1) write(nsyso,&
     '(/'' final kerma factors''/14x,''e'',8(11x,i3))')&
     (mtp(i),i=2,npk)
   npkk=npk
   if (kchk.eq.1) npkk=3*npk-2
   if (mgam.gt.0) npkk=npkk+3
   if (mgam.eq.0.and.i6.gt.0) npkk=npkk+1
   npkt=npk-1
   npkd=npk
   npktd=npkt
   do i=2,npk
      if (mtp(i).ge.442) then
         npkd=npkd-1
         npktd=npktd-1
      endif
   enddo
   ilist=1
   nsc=0
   math=matd
   mfh=3
   inpk=1
  105 continue
   inpk=inpk+1
   mth=mtp(inpk)
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=0
   scr(5)=0
   scr(6)=0
   call contio(0,0,nscr,scr,nb,nw)
   nn=0
   scr(1)=0
   scr(2)=0
   scr(5)=1
   scr(6)=0
   scr(7)=0
   scr(8)=2
   ibase=8
   i=0
   nw=0
  110 continue
   nn=nn+1
   if (nn.gt.ne) go to 125
   call finda(nn,c,npkk,iold,buf,nbuf)
   do j=1,npkk
      if (c(j).gt.big) then
         c(j)=sigfig(c(j),6,0)
      else
         c(j)=sigfig(c(j),7,0)
      endif
   enddo
   e=sigfig(c(1),9,0)
   if (iprint.eq.1.and.abs(e-elist(ilist)).le.small*e) then
      ihi=0
      ilo=0
      if (kchk.eq.1) then
         ihi=0
         ilo=0
         do j=2,npkd
            read(iblank,'(a4)') klo(j)
            test=c(j+npkt)-c(j+npkt)/10
            if (c(j).lt.test) then
               read(idown,'(a4)') klo(j)
               ilo=1
            endif
            read(iblank,'(a4)') khi(j)
            test=c(j+2*npkt)+c(j+2*npkt)/10
            if (c(j).gt.test) then
               read(iup,'(a4)') khi(j)
               ihi=1
            endif
         enddo
      endif
      if (ilo.eq.1) write(nsyso,'('' '')')
      if (kchk.eq.1) write(nsyso,'(15x,8(6x,a4,4x))')&
        (klo(j),j=2,npkd)
      if (kchk.eq.1) write(nsyso,'(12x,''min'',1p,8e14.4)')&
        (c(npk+j),j=1,npktd)
      write(nsyso,'(1x,1p,9e14.4)') (c(j),j=1,npk)
      if (kchk.eq.1) write(nsyso,'(12x,''max'',1p,8e14.4)')&
        (c(npk+npkt+j),j=1,npktd)
      if (ihi.eq.1) write(nsyso,'(15x,8(6x,a4,4x))')&
        (khi(j),j=2,npkd)
   endif
   if (e.ge.elist(ilist)) ilist=ilist+1
   if (i.gt.0) go to 118
   if (c(inpk).eq.zero.and.i.eq.0.and.ibase.eq.8) go to 110
   if (nw.gt.0) go to 118
   n=ne-nn+1
   scr(6)=n
   scr(7)=n
  118 continue
   i=i+2
   scr(ibase+i-1)=c(1)
   scr(ibase+i)=c(inpk)
   if (i.lt.npage.and.nn.ne.ne) go to 110
   if (ibase.eq.0) go to 120
   call tab1io(0,0,nscr,scr,nb,nw)
   if (nn.eq.ne) go to 130
   ibase=0
   i=0
   go to 110
  120 continue
   call moreio(0,0,nscr,scr,nb,nw)
   if (nn.eq.ne) go to 130
   i=0
   go to 110
   ! all zeroes for this mt
  125 continue
   scr(6)=2
   scr(7)=2
   scr(9)=efirst
   scr(10)=0
   scr(11)=elast
   scr(12)=0
   nw=12
   call tab1io(0,0,nscr,scr,nb,nw)
   n=2
  130 continue
   call asend(0,nscr)
   ncds(inpk)=3+(n+2)/3
   if (inpk.lt.npk) go to 105
   call afend(0,nscr)
   call repoz(nscr)

   !--update dictionary in file 1
   call findf(matd,1,451,nin)
   call contio(nin,0,0,scr,nb,nw)
   nx=n2h
   inow=7
   if (iverf.ge.5) then
      call contio(nin,0,0,scr(inow),nb,nw)
      inow=inow+6
      if (iverf.eq.6) then
         call contio(nin,0,0,scr(inow),nb,nw)
         inow=inow+6
      endif
   endif
   call hdatio(nin,0,0,scr(inow),nb,nw)
   nwd=nint(scr(inow+4))
   if (iverf.ge.5) nx=nint(scr(inow+5))
   inow=inow+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,scr(inow),nb,nw)
      inow=inow+nw
   enddo
   nw=nx
   idict=inow
   idict1=idict-1
   call dictio(nin,0,0,scr(idict),nb,nw)
   nw=inow+nw
   nw=6*(nx+20)
   if (nw.lt.npage+50) nw=npage+50
   allocate(b(nw))
   inpk=2
   mtn=mtp(inpk)
   j=0

   !--loop over existing dictionary records
   do i=1,nx
      iowr=0
      ia=6*(i-1)
      mfi=nint(scr(idict1+ia+3))
      mti=nint(scr(idict1+ia+4))
      !--insert heating mt dictionary data (or overwrite
      !  original dictionary data with revised data).
      do while ((mfi.eq.3 .and. mtn.le.mti) .or.&
                (mfi.gt.3 .and. inpk.le.npk))
         if (mfi.eq.3 .and. mtn.eq.mti) iowr=1
         b(j+1)=0
         b(j+2)=0
         b(j+3)=3
         b(j+4)=mtp(inpk)
         b(j+5)=ncds(inpk)
         b(j+6)=0
         j=j+6
         inpk=inpk+1
         if (inpk.le.npk) then
            mtn=mtp(inpk)
         else
            mtn=10000
         endif
      enddo
      !--insert original dictionary data (unless the heating
      !  mt entry above was an overwrite of existing data).
      if (mfi.ne.3 .or. (mfi.eq.3 .and. iowr.eq.0)) then
         b(j+1)=0
         b(j+2)=0
         b(j+3)=mfi
         b(j+4)=mti
         b(j+5)=scr(idict1+ia+5)
         b(j+6)=scr(idict1+ia+6)
         j=j+6
      endif
   enddo
   !--insert rest of heating mt dictionary data, if any.
   do i=inpk,npk
      b(j+1)=0
      b(j+2)=0
      b(j+3)=3
      b(j+4)=mtp(i)
      b(j+5)=ncds(i)
      b(j+6)=0
      j=j+6
   enddo
   mth=451
   nxn=j/6
   inow=1
   if (iverf.le.4) scr(inow+5)=nxn
   call contio(0,nout,0,scr(inow),nb,nw)
   inow=inow+6
   if (iverf.eq.6) call contio(0,nout,0,scr(inow),nb,nw)
   if (iverf.eq.6) inow=inow+6
   if (iverf.gt.4) then
      call contio(0,nout,0,scr(inow),nb,nw)
      inow=inow+6
      scr(inow+5)=nxn
   endif
   nw=6+nwd
   call hdatio(0,nout,0,scr(inow),nb,nw)
   inow=inow+nw
   do while (nb.ne.0)
      call moreio(0,nout,0,scr(inow),nb,nw)
      inow=inow+nw
   enddo
   nw=nxn
   call dictio(0,nout,0,b,nb,nw)
   call tofend(nin,nout,0,scr)
   call tofend(nin,nout,0,scr)

   !--add new reactions to file 3.
   call contio(nin,0,0,scr,nb,nw)
   if (mfh.ne.3 .or. mth.eq.0) then
      write(strng,'("nin out of order.  read mfh,mth = ",2i5)')mfh,mth
      call error('hout',strng,' ')
   endif
   mfnin=mfh
   mtnin=mth
   inow=7
   call contio(nscr,0,0,scr(inow),nb,nw)
   if (mfh.ne.3 .or. mth.eq.0) then
      write(strng,'("nscr out of order.  read mfh,mth = ",2i5)')mfh,mth
      call error('hout',strng,' ')
   endif
   mfnscr=mfh
   mtnscr=mth
   inow6=inow+6
   do while (mfnin.eq.3 .and. mfnscr.eq.3)
      if (mtnin.lt.mtnscr) then
         mfh=mfnin
         mth=mtnin
         call contio(0,nout,0,scr,nb,nw)
         call tosend(nin,nout,0,scr(inow6))
         call contio(nin,0,0,scr,nb,nw)
         mfnin=mfh
         mtnin=mth
      elseif (mtnin.eq.mtnscr) then
         mfh=mfnscr
         mth=mtnscr
         call contio(0,nout,0,scr(inow),nb,nw)
         call tosend(nscr,nout,0,scr(inow6))
         call tosend(nin,0,0,scr(inow6))
         call contio(nin,0,0,scr,nb,nw)
         mfnin=mfh
         mtnin=mth
         call contio(nscr,0,0,scr(inow),nb,nw)
         mfnscr=mfh
         mtnscr=mth
      else
         do while (mtnin.ge.mtnscr .and. mfnscr.eq.3)
            mfh=mfnscr
            mth=mtnscr
            call contio(0,nout,0,scr(inow),nb,nw)
            call tosend(nscr,nout,0,scr(inow6))
            call contio(nscr,0,0,scr(inow),nb,nw)
            mfnscr=mfh
            mtnscr=mth
         enddo
      endif
   enddo
   if (mfnin.eq.3 .and. mfnscr.eq.0) then
      mfh=mfnin
      mth=mtnin
      call contio(0,nout,0,scr,nb,nw)
   elseif (mfnin.eq.0 .and. mfnscr.eq.3) then
      mfh=mfnscr
      mth=mtnscr
      call contio(0,nout,0,scr(inow),nb,nw)
      call tofend(nscr,nout,0,scr(inow6))
   elseif (mfnin.eq.0 .and. mfnscr.eq.0) then
      mfh=mfnin
      mth=mtnin
      call contio(0,nout,0,scr,nb,nw)
   endif
   call tomend(nin,nout,0,scr)
   deallocate(b)
   deallocate(scr)
   call closz(nscr)

   !--plot heating, photon energy production, and kinematic limits
   if (nplot.eq.0) go to 500
   write(nplot,'(''/'')')

   !--total heating
   !--log-log
   elo=1
   elo=elo/1000
   rat=emax/elo
   thin=ten**(log10(rat)/2500)
   ylo=big
   yhi=-big
   xlast=elo
   do i=1,ne
      call finda(i,c,npkk,iold,buf,nbuf)
      x=c(1)
      if (x.ge.thin*xlast) then
         if (c(2).gt.yhi) yhi=c(2)
         if (c(2).lt.ylo) ylo=c(2)
         if (c(2+npkt).gt.yhi) yhi=c(2+npkt)
         if (c(2+npkt).lt.ylo) ylo=c(2+npkt)
         if (c(2+2*npkt).gt.yhi) yhi=c(2+2*npkt)
         if (c(2+2*npkt).lt.ylo) ylo=c(2+2*npkt)
         xlast=x
      endif
   enddo
   if (ylo.le.zero) ylo=small
   if (yhi.le.zero) yhi=small
   do k=1,3
      if (k.eq.1) then
         write(nplot,'(''1/'')')
         write(nplot,'(a,''Energy-Balance Check'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''4 0 2 1/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(a,''<h>eating (e<v>-barns)'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<u>pper limit'',a,''/'')') qu,qu
      else if (k.eq.2) then
         write(nplot,'(''2/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<e>nergy-balance heating'',a,''/'')') qu,qu
      else
         write(nplot,'(''3/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<l>ower limit'',a,''/'')') qu,qu
      endif
      write(nplot,'(''0/'')')
      xlast=elo
      j=0
      do i=1,ne
         call finda(i,c,npkk,iold,buf,nbuf)
         x=c(1)
         if (k.eq.1) y=c(2+2*npkt)
         if (k.eq.2) y=c(2)
         if (k.eq.3) y=c(2+npkt)
         if (x.ge.thin*xlast.and.j.lt.2500) then
            j=j+1
            if (y.le.zero) y=small
            write(nplot,'(1p,2e14.6,''/'')') x,y
            xlast=x
         endif
      enddo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,ylo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,yhi
      write(nplot,'(''/ end'')')
   enddo

   !--total heating
   !--lin-lin
   thin=emax/2500
   ylo=big
   yhi=-big
   xlast=ecut
   do i=1,ne
      call finda(i,c,npkk,iold,buf,nbuf)
      x=c(1)
      if (x.ge.xlast+thin) then
         if (c(2).gt.yhi) yhi=c(2)
         if (c(2).lt.ylo) ylo=c(2)
         if (c(2+npkt).gt.yhi) yhi=c(2+npkt)
         if (c(2+npkt).lt.ylo) ylo=c(2+npkt)
         if (c(2+2*npkt).gt.yhi) yhi=c(2+2*npkt)
         if (c(2+2*npkt).lt.ylo) ylo=c(2+2*npkt)
         xlast=x
      endif
   enddo
   do k=1,3
      if (k.eq.1) then
         write(nplot,'(''1/'')')
         write(nplot,'(a,''Energy-Balance Check'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''1 0 2 1/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(a,''<h>eating (e<v>-barns)'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<u>pper limit>'',a,''/'')') qu,qu
      else if (k.eq.2) then
         write(nplot,'(''2/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<e>nergy-balance heating'',a,''/'')') qu,qu
      else
         write(nplot,'(''3/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<l>ower limit'',a,''/'')')qu,qu
      endif
      write(nplot,'(''0/'')')
      xlast=ecut
      j=0
      do i=1,ne
         call finda(i,c,npkk,iold,buf,nbuf)
         x=c(1)
         if (k.eq.1) y=c(2+2*npkt)
         if (k.eq.2) y=c(2)
         if (k.eq.3) y=c(2+npkt)
         if (x.ge.xlast+thin.and.j.lt.2500) then
            j=j+1
            write(nplot,'(1p,2e14.6,''/'')') x,y
            xlast=x
         endif
      enddo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,ylo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,yhi
      write(nplot,'(''/ end'')')
   enddo

   !--photon energy production
   !--log-log
   if (mt303.eq.0) go to 490
   elo=1
   elo=elo/1000
   rat=emax/elo
   thin=ten**(log10(rat)/2500)
   ylo=big
   yhi=-big
   xlast=elo
   do i=1,ne
      call finda(i,c,npkk,iold,buf,nbuf)
      x=c(1)
      if (x.ge.thin*xlast) then
         y=c(npkk-1)+c(mt303)-c(mt303+npkt)+c(npkk-2)
         if (y.gt.yhi) yhi=y
         if (y.lt.ylo) ylo=y
         y=c(npkk-1)
         if (y.gt.yhi) yhi=y
         if (y.lt.ylo) ylo=y
         y=c(npkk-1)+c(mt303)-c(mt303+2*npkt)+c(npkk-2)
         if (y.gt.yhi) yhi=y
         if (y.lt.ylo) ylo=y
         xlast=x
      endif
   enddo
   if (ylo.le.zero) ylo=small
   if (yhi.le.zero) yhi=small
   do k=1,3
      if (k.eq.1) then
         write(nplot,'(''1/'')')
         write(nplot,'(a,''Energy-Balance Check'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''4 0 2 1/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(a,''<p>hoton energy prod (e<v>-barns)'',&
           &a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<u>pper limit'',a,''/'')') qu,qu
      else if (k.eq.2) then
         write(nplot,'(''2/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<p>hoton energy production'',a,''/'')')&
           qu,qu
      else
         write(nplot,'(''3/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<l>ower limit'',a,''/'')') qu,qu
      endif
      write(nplot,'(''0/'')')
      xlast=elo
      j=0
      do i=1,ne
         call finda(i,c,npkk,iold,buf,nbuf)
         x=c(1)
         if (k.eq.1) y=c(npkk-1)+c(mt303)-c(mt303+npkt)+c(npkk-2)
         if (k.eq.2) y=c(npkk-1)
         if (k.eq.3) y=c(npkk-1)+c(mt303)-c(mt303+2*npkt)+c(npkk-2)
         if (x.ge.thin*xlast.and.j.lt.2500) then
            j=j+1
            if (y.le.zero) y=small
            write(nplot,'(1p,2e14.6,''/'')') x,y
            xlast=x
         endif
      enddo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,ylo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,yhi
      write(nplot,'(''/ end'')')
   enddo

   !--photon energy production
   !--lin-lin
   thin=emax/2500
   ylo=big
   yhi=-big
   xlast=ecut
   do i=1,ne
      call finda(i,c,npkk,iold,buf,nbuf)
      x=c(1)
      if (x.ge.xlast+thin) then
         y=c(npkk-1)+c(mt303)-c(mt303+npkt)+c(npkk-2)
         if (y.gt.yhi) yhi=y
         if (y.lt.ylo) ylo=y
         y=c(npkk-1)
         if (y.gt.yhi) yhi=y
         if (y.lt.ylo) ylo=y
         y=c(npkk-1)+c(mt303)-c(mt303+2*npkt)+c(npkk-2)
         if (y.gt.yhi) yhi=y
         if (y.lt.ylo) ylo=y
         xlast=x
      endif
   enddo
   do k=1,3
      if (k.eq.1) then
         write(nplot,'(''1/'')')
         write(nplot,'(a,''Energy-Balance Check'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''1 0 2 1/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<e>nergy (e<v>)'',a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(a,''<p>hoton energy prod (e<v>-barns)'',&
           &a,''/'')') qu,qu
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<u>pper limit'',a,''/'')') qu,qu
      else if (k.eq.2) then
         write(nplot,'(''2/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''/'')')
         write(nplot,'(a,''<p>hoton energy production'',a,''/'')')&
           qu,qu
      else
         write(nplot,'(''3/'')')
         write(nplot,'(''/'')')
         write(nplot,'(''0 0 4/'')')
         write(nplot,'(a,''<l>ower limit'',a,''/'')') qu,qu
      endif
      write(nplot,'(''0/'')')
      xlast=ecut
      j=0
      do i=1,ne
         call finda(i,c,npkk,iold,buf,nbuf)
         x=c(1)
         if (k.eq.1) y=c(npkk-1)+c(mt303)-c(mt303+npkt)+c(npkk-2)
         if (k.eq.2) y=c(npkk-1)
         if (k.eq.3) y=c(npkk-1)+c(mt303)-c(mt303+2*npkt)+c(npkk-2)
         if (x.ge.xlast+thin.and.j.lt.2500) then
            j=j+1
            write(nplot,'(1p,2e14.6,''/'')') x,y
            xlast=x
         endif
      enddo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,ylo
      if (k.eq.1) write(nplot,'(1p,2e14.6,''/'')') x,yhi
      write(nplot,'(''/ end'')')
   enddo

   !--plotting finished
  490 continue
   write(nplot,'(''99/'')')
   call closz(nplot)
  500 continue
   deallocate(buf)
   return
   end subroutine hout

end module heatm

module endf
   ! Routines for handling ENDF formats.
   use locale
   implicit none
   private

   !--Public routines
   public contio,listio,tab1io,tab2io,moreio
   public tpidio,hdatio,dictio,intgio
   public tosend,tofend,tomend,totend
   public asend,afend,amend,atend
   public skip6,findf
   public terp1,terpa,intega
   public gety1,gety2
   public gral
   public a11

   !--Public variables
   integer,public::npage=306
   integer,public::iverf=-1
   real(kr),public::c1h,c2h
   integer,public::l1h,l2h,n1h,n2h,math,mfh,mth,nsh,nsp,nsc
   real(kr),public::thr6

   !--Private global variables
   integer::nah
   real(kr)::ah(6)
   integer::ihol
   character(4)::hol(17)
   real(kr)::rhol(17)
   equivalence(hol(1),rhol(1))
   integer::nr
   integer::nbt(20),jnt(20)

contains

   subroutine contio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF coded and blocked binary tapes.
   ! Read, write, and/or convert one control record.
   ! Positive units are coded, negative ones are blocked binary.
   ! If any unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr,i
   character(11)::field(2)

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(i),i=1,6)
   else if (nin.gt.0) then
      read(nin,'(6e11.0,i4,i2,i3,i5)') (a(i),i=1,6),math,mfh,mth,nsp
   endif

   !--output
   nb=0
   nw=6
   c1h=a(1)
   c2h=a(2)
   l1h=nint(a(3))
   l2h=nint(a(4))
   n1h=nint(a(5))
   n2h=nint(a(6))
   a(3)=l1h
   a(4)=l2h
   a(5)=n1h
   a(6)=n2h
   if (nout.eq.0.and.nscr.eq.0) return
   inout=iabs(nout)
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,6)
      inout=0
   endif
   inscr=iabs(nscr)
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,6)
      inscr=0
   endif
   if (nout.le.0.and.nscr.le.0) return

   !--special path to write blanks on *end* cards
   if (math.eq.-1) call atend(inout,inscr)
   if (math.eq.-1) return
   if (math.eq.0) call amend(inout,inscr)
   if (math.eq.0) return
   if (mfh.eq.0) call afend(inout,inscr)
   if (mfh.eq.0) return
   if (mth.eq.0) call asend(inout,inscr)
   if (mth.eq.0) return

   !--format the output
   call a11(c1h,field(1))
   call a11(c2h,field(2))
   if (nscr.gt.0) then
      write(nscr,'(2a11,4i11,i4,i2,i3,i5)') field(1),field(2),&
        l1h,l2h,n1h,n2h,math,mfh,mth,nsc
      nsc=nsc+1
      if (nsc.gt.99999) nsc=1
   endif
   if (nout.gt.0) then
      write(nout,'(2a11,4i11,i4,i2,i3,i5)') field(1),field(2),&
        l1h,l2h,n1h,n2h,math,mfh,mth,nsh
      nsh=nsh+1
      if (nsh.gt.99999) nsh=1
   endif
   return
   end subroutine contio

   subroutine listio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF coded and blocked binary tapes.
   ! Read, write, and/or convert the first page or record of a
   ! LIST structure.  If any unit is zero, it is not used.
   ! Positive units are coded, negative ones are blocked binary.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::i,j,k,l,iend
   integer::nbx,nwx

   ihol=0

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      c1h=a(1)
      c2h=a(2)
      l1h=nint(a(3))
      l2h=nint(a(4))
      n1h=nint(a(5))
      n2h=nint(a(6))
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h
      a(6)=n2h
   else if (nin.gt.0) then
      call contio(nin,0,0,a,nb,nw)
      nb=6+n1h
      iend=npage
      if (n1h.lt.npage) iend=n1h
      nw=iend+nw
      k=6
      do i=1,iend,6
         call lineio(nin,0,0)
         l=n1h-k+6
         if (l.ne.0) then
            if (l.gt.6) l=6
            do j=1,l
               k=k+1
               a(k)=ah(j)
            enddo
         endif
      enddo
      a(1)=c1h
      a(2)=c2h
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h
      a(6)=n2h
   endif

   !--output
   n1h=nint(a(5))
   if (nin.eq.0.and.n1h.le.npage) nw=6+n1h
   if (nin.eq.0.and.n1h.gt.npage) nw=6+npage
   nb=6+n1h-nw
   if (nout.eq.0.and.nscr.eq.0) return
   c1h=a(1)
   c2h=a(2)
   l1h=nint(a(3))
   l2h=nint(a(4))
   n2h=nint(a(6))
   inout=iabs(nout)
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inout=0
   endif
   inscr=iabs(nscr)
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inscr=0
   endif
   call contio(0,inout,inscr,a,nbx,nwx)
   k=6
   iend=nw-6
   do i=1,iend,6
      l=iend-k+6
      if (l.ne.0) then
         if (l.gt.6) l=6
         do j=1,l
            k=k+1
            ah(j)=a(k)
         enddo
         nah=l
         call lineio(0,inout,inscr)
      endif
   enddo
   return
   end subroutine listio

   subroutine tab1io(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd and blocked binary tapes.
   ! Read, write, and/or convert the first page or record of a
   ! TAB1 structure.  If any unit is zero, it is not used.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   character(len=60)::strng
   integer::inin,inout,inscr
   integer::i,j,k,l,m,lim,kp1,nbx,nwx

   ihol=0

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin)math,mfh,mth,nb,nw,(a(i),i=1,nw)
      c1h=a(1)
      c2h=a(2)
      l1h=nint(a(3))
      l2h=nint(a(4))
      n1h=nint(a(5))
      n2h=nint(a(6))
      if (n1h.le.0) then
         write(strng,'(" illegal TAB1, nr<=0 for mf/mt = ",i2,"/",i3)')&
                      mfh,mth
         call error('endf',strng,'')
      endif
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h
      a(6)=n2h
      do i=1,n1h
         nbt(i)=nint(a(2*i+5))
         jnt(i)=nint(a(2*i+6))
      enddo
   else if (nin.gt.0) then
      call contio(nin,0,0,a,nb,nw)
      if (n1h.le.0) then
         write(strng,'(" illegal TAB1, nr<=0 for mf/mt = ",i2,"/",i3)')&
                      mfh,mth
         call error('endf',strng,'')
      endif
      nb=6+2*n1h+2*n2h
      call tablio(nin,0,0)
      k=6
      do i=1,nr
         k=k+1
         a(k)=nbt(i)
         k=k+1
         a(k)=jnt(i)
      enddo
      lim=npage
      if ((2*n2h).lt.npage) lim=2*n2h
      j=0
      do i=1,lim,6
         call lineio(nin,0,0)
         l=6
         if ((j+6).gt.lim) l=lim-j
         do m=1,l
            j=j+1
            a(k+j)=ah(m)
         enddo
      enddo
      a(1)=c1h
      a(2)=c2h
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h
      a(6)=n2h
      nw=k+j
   endif
   if (nin.ne.0) then
      if (nbt(n1h).ne.n2h) then
         write(strng,'(" illegal TAB1, nbt(nr)/=np for mf/mt = ",&
                     &i2,"/",i3)')mfh,mth
         call error('endf',strng,'')
      endif
   endif

   !--output
   n1h=nint(a(5))
   n2h=nint(a(6))
   if (nin.eq.0.and.2*n2h.le.npage) nw=6+2*n1h+2*n2h
   if (nin.eq.0.and.2*n2h.gt.npage) nw=6+2*n1h+npage
   nb=6+2*n1h+2*n2h-nw
   if (nout.eq.0.and.nscr.eq.0) return
   c1h=a(1)
   c2h=a(2)
   l1h=nint(a(3))
   l2h=nint(a(4))
   do i=1,n1h
      nbt(i)=nint(a(2*i+5))
      jnt(i)=nint(a(2*i+6))
   enddo
   inout=iabs(nout)
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inout=0
   endif
   inscr=iabs(nscr)
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inscr=0
   endif
   if (nout.le.0.and.nscr.le.0) return
   call contio(0,inout,inscr,a,nbx,nwx)
   do i=1,n1h
      nbt(i)=nint(a(2*i+5))
      jnt(i)=nint(a(2*i+6))
   enddo
   nr=n1h
   call tablio(0,inout,inscr)
   k=6+2*nr
   kp1=k+1
   do i=kp1,nw,6
      l=6
      if ((k+6).gt.nw) l=nw-k
      do j=1,l
         k=k+1
         ah(j)=a(k)
      enddo
      nah=l
      call lineio(0,inout,inscr)
   enddo
   return
   end subroutine tab1io

   subroutine tab2io(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd and blocked binary tapes.
   ! Read, write, and/or convert a TAB2 structure.
   ! If any unit is zero, it is not used.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::i,k,nbx,nwx

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      c1h=a(1)
      c2h=a(2)
      l1h=nint(a(3))
      l2h=nint(a(4))
      n1h=nint(a(5))
      n2h=nint(a(6))
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h
      a(6)=n2h
   else if (nin.gt.0) then
      call contio(nin,0,0,a,nb,nw)
      call tablio(nin,0,0)
      a(1)=c1h
      a(2)=c2h
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h
      a(6)=n2h
      k=6
      do i=1,n1h
         k=k+1
         a(k)=nbt(i)
         k=k+1
         a(k)=jnt(i)
      enddo
      nw=nw+2*n1h
   endif

   !--output
   nb=0
   if (nout.eq.0.and.nscr.eq.0) return
   c1h=a(1)
   c2h=a(2)
   l1h=nint(a(3))
   l2h=nint(a(4))
   n1h=nint(a(5))
   n2h=nint(a(6))
   do i=1,n1h
      nbt(i)=nint(a(2*i+5))
      jnt(i)=nint(a(2*i+6))
   enddo
   inout=iabs(nout)
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inout=0
   endif
   inscr=iabs(nscr)
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inscr=0
   endif
   if (nout.le.0.and.nscr.le.0) return
   call contio(0,inout,inscr,a,nbx,nwx)
   do i=1,n1h
      nbt(i)=nint(a(2*i+5))
      jnt(i)=nint(a(2*i+6))
   enddo
   nr=n1h
   call tablio(0,inout,inscr)
   return
   end subroutine tab2io

   subroutine moreio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd and blocked binary tapes.
   ! Read, write, and/or convert the next page or record from a
   ! TAB1 or LIST structure.  If any unit is zero, it is not used.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::i,j,k,l

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(i),i=1,nw)
   else if (nin.gt.0) then
      nw=nb
      if (nw.gt.npage) nw=npage
      nb=nb-nw
      k=0
      if (ihol.ne.1) then
         ! normal data
         do i=1,nw,6
            call lineio(nin,0,0)
            l=6
            if ((k+6).gt.nw) l=nw-k
            do j=1,l
               k=k+1
               a(k)=ah(j)
            enddo
         enddo
      else
         ! hollerith descriptive data
         do i=1,nw,17
            call hollio(nin,0,0)
            do j=1,17
               k=k+1
               a(k)=rhol(j)
            enddo
         enddo
      endif
   endif

   !--output
   inout=iabs(nout)
   inscr=iabs(nscr)
   if (nin.eq.0) nw=nb
   if (nw.gt.npage) nw=npage
   if (nin.eq.0) nb=nb-nw
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inout=0
   endif
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inscr=0
   endif
   if (nout.le.0.and.nscr.le.0) return
   if (ihol.ne.1) then
      ! normal data
      k=0
      do i=1,nw,6
         l=6
         if ((l+k).gt.nw) l=nw-k
         do j=1,l
            k=k+1
            ah(j)=a(k)
         enddo
         nah=l
         call lineio(0,inout,inscr)
      enddo
   else
      ! hollerith descriptive data
      k=0
      do i=1,nw,17
         do j=1,17
            k=k+1
            rhol(j)=a(k)
         enddo
         call hollio(0,inout,inscr)
      enddo
   endif
   return
   end subroutine moreio

   subroutine tpidio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd and binary tapes.  Read, write,
   ! and/or convert the tape identification record to/from a.  If any
   ! unit is zero, it is not used.  Positive units are bcd, and
   ! negative units are binary.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   real(kr)::rb(17)
   character(4)::hb(17)
   equivalence (rb(1),hb(1))
   integer::inin,inout,inscr,i

   !--input.
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(i),i=1,17)
   else if (nin.gt.0) then
      read(nin,'(16a4,a2,i4,i2,i3,i5)') (hb(i),i=1,17),math,mfh,mth
      nw=17
      do i=1,17
         a(i)=rb(i)
      enddo
   endif

   !--output
   nb=0
   inout=iabs(nout)
   inscr=iabs(nscr)
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,17)
   endif
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,17)
   endif
   if (nout.le.0.and.nscr.le.0) return
   if (nout.gt.0) then
      do i=1,17
         rb(i)=a(i)
      enddo
      write(nout,'(16a4,a2,i4,i2,i3,i5)') (hb(i),i=1,17),math,mfh,mth,nsh
      nsh=nsh+1
   endif
   if (nscr.gt.0) then
      do i=1,17
         rb(i)=a(i)
      enddo
      write(nscr,'(16a4,a2,i4,i2,i3,i5)') (hb(i),i=1,17),math,mfh,mth,nsc
      nsc=nsc+1
   endif
   return
   end subroutine tpidio

   subroutine hdatio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd and binary tapes.  Read, write,
   ! and/or convert the Hollerith descriptive data to/from a.
   ! If any unit is zero, it is not used.  Positive units are bcd,
   ! and negative units are binary.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::i,j,k,iend
   integer::ncds,nbx,nwx

   ihol=1

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      c1h=a(1)
      c2h=a(2)
      l1h=nint(a(3))
      l2h=nint(a(4))
      n1h=nint(a(5))/17
      n2h=nint(a(6))
      a(3)=l1h
      a(4)=l2h
      a(5)=n1h*17
      a(6)=n2h
   else if (nin.gt.0) then
      call contio(nin,0,0,a,nb,nw)
      a(5)=a(5)*17
      nb=6+nint(a(5))
      iend=nint(a(5))
      if (iend.gt.npage) iend=npage
      k=6
      do i=1,iend,17
         call hollio(nin,0,0)
         do j=1,17
            k=k+1
            a(k)=rhol(j)
         enddo
      enddo
      nw=k
   endif

   !--output
   n1h=nint(a(5))/17
   if (nin.eq.0.and.a(5).le.npage) nw=6+nint(a(5))
   if (nin.eq.0.and.a(5).gt.npage) nw=6+npage
   nb=6+nint(a(5))-nw
   inout=iabs(nout)
   inscr=iabs(nscr)
   a(5)=n1h*17
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inout=0
   endif
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(i),i=1,nw)
      inscr=0
   endif
   if (nout.le.0.and.nscr.le.0) return
   a(5)=n1h
   ncds=(nw-6)/17
   call contio(0,inout,inscr,a,nbx,nwx)
   j=6
   do i=1,ncds
      do k=1,17
         j=j+1
         rhol(k)=a(j)
      enddo
      call hollio(0,inout,inscr)
   enddo
   return
   end subroutine hdatio

   subroutine dictio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd and binary tapes.  Read, write,
   ! and/or convert the material dictionary to/from a.  Any unit
   ! which is zero is not used.  Positive units are bcd and
   ! negative units are binary.  On entry, nw is the number of records
   ! in the dictionary.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::nx,i,j,k,n
   nx=nw

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      k=0
      do j=1,nx
         read(inin) math,mfh,mth,nb,nw,(a(i+k),i=1,6)
         k=k+6
      enddo
      nw=k
   else if (nin.gt.0) then
      k=0
      do j=1,nx
         read(nin,'(6e11.0,i4,i2,i3,i5)')&
           (a(i+k),i=1,6),math,mfh,mth,nsp
         k=k+6
      enddo
      nw=k
   endif

   !--output
   nb=0
   if (nout.eq.0.and.nscr.eq.0) return
   inout=iabs(nout)
   inscr=iabs(nscr)
   n=6
   k=0
   do j=1,nx
      l1h=nint(a(k+3))
      l2h=nint(a(k+4))
      n1h=nint(a(k+5))
      n2h=nint(a(k+6))
      a(k+3)=l1h
      a(k+4)=l2h
      a(k+5)=n1h
      a(k+6)=n2h
      if (nout.lt.0) then
         write(inout) math,mfh,mth,nb,n,(a(i+k),i=1,n)
      endif
      if (nout.gt.0) then
         write(nout,'(22x,4i11,i4,i2,i3,i5)')&
           l1h,l2h,n1h,n2h,math,mfh,mth,nsh
         nsh=nsh+1
         if (nsh.gt.99999) nsh=1
      endif
      if (nscr.lt.0) then
         write(inscr) math,mfh,mth,nb,n,(a(i+k),i=1,n)
      endif
      if (nscr.gt.0) then
         write(nscr,'(22x,4i11,i4,i2,i3,i5)')&
           l1h,l2h,n1h,n2h,math,mfh,mth,nsc
         nsc=nsc+1
         if (nsc.gt.99999) nsc=1
      endif
      k=k+6
   enddo
   nw=k
   return
   end subroutine dictio

   subroutine intgio(nin,nout,nscr,a,nb,nw)
   !--------------------------------------------------------------------
   ! utility routine for endf/b coded and blocked binary tapes.
   ! read, write, and/or convert one intg record.
   ! positive units are coded, negative ones are blocked binary.
   ! if any unit is zero, it is not used. Parameter nw determines
   ! the number of entries read or written, as well as the format
   ! for formatted files; nw is an input quantity.  If 0<nw<7 then
   ! nw is interpreted as ndigit and the corresponding array length
   ! is set internally by redefining nw. Parameter nb is always zero.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nin,nout,nscr,nb,nw
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::j
   integer::ia(20)
   integer,dimension(6),parameter::nwdig=(/0,20,15,13,11,10/)

   !--check number of digits
   nb=0
   if (nw.gt.0.and.nw.le.6) nw=nwdig(nw)

   !--input
   if (nin.lt.0) then
      inin=iabs(nin)
      read(inin) math,mfh,mth,nb,nw,(a(j),j=1,nw)
   else if (nin.gt.0) then
      if (nw.eq.20) then
        read(nin,'(2i5,1x,18i3,1x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.15) then
        read(nin,'(2i5,1x,13i4,3x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.13) then
        read(nin,'(2i5,1x,11i5,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.11) then
        read(nin,'(2i5,1x,9i6,1x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.10) then
        read(nin,'(2i5,1x,8i7,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else
        call error('intgio','1invalid nw',' ')
      end if
      do j=1,nw
         a(j)=ia(j)
      enddo
   endif

   !--output
   if (nout.eq.0.and.nscr.eq.0) return
   inout=iabs(nout)
   if (nout.lt.0) then
      write(inout) math,mfh,mth,nb,nw,(a(j),j=1,nw)
      inout=0
   endif
   inscr=iabs(nscr)
   if (nscr.lt.0) then
      write(inscr) math,mfh,mth,nb,nw,(a(j),j=1,nw)
      inscr=0
   endif

   !--format the output
   do j=1,nw
     ia(j)=nint(a(j))
   end do
   if (nscr.gt.0) then
      if (nw.eq.20) then
        write(nscr,'(2i5,1x,18i3,1x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.15) then
        write(nscr,'(2i5,1x,13i4,3x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.13) then
        write(nscr,'(2i5,1x,11i5,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.11) then
        write(nscr,'(2i5,1x,9i6,1x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.10) then
        write(nscr,'(2i5,1x,8i7,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else
        call error('intgio','2invalid nw',' ')
      end if
      nsc=nsc+1
      if (nsc.gt.99999) nsc=0
   endif
   if (nout.gt.0) then
      if (nw.eq.20) then
        write(nout,'(2i5,1x,18i3,1x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.15) then
        write(nout,'(2i5,1x,13i4,3x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.13) then
        write(nout,'(2i5,1x,11i5,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.11) then
        write(nout,'(2i5,1x,9i6,1x,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else if (nw.eq.10) then
        write(nout,'(2i5,1x,8i7,i4,i2,i3,i5)')&
          (ia(j),j=1,nw),math,mfh,mth,nsp
      else
        call error('intgio','3invalid nw',' ')
      end if
      nsh=nsh+1
      if (nsh.gt.99999) nsh=0
   endif
   return
   end subroutine intgio

   subroutine lineio(nin,nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for bcd ENDF tapes.
   ! Read and/or write one line of floating point data from nin
   ! to nout and nscr.  If any unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr
   ! internals
   integer::k
   character(11)::field(6)

   !--input
   if (nin.gt.0) then
      read(nin,'(6e11.0,i4,i2,i3,i5)') ah,math,mfh,mth,nsp
      nah=6
   endif

   !--output
   if (nout.ne.0) then
      do k=1,6
         field(k)='           '
         if (k.le.nah) then
            call a11(ah(k),field(k))
         endif
      enddo
      write(nout,'(6a11,i4,i2,i3,i5)') (field(k),k=1,6),math,mfh,mth,nsh
      nsh=nsh+1
      if (nsh.gt.99999) nsh=1
   endif
   if (nscr.ne.0) then
      do k=1,6
         field(k)='           '
         if (k.le.nah) then
            call a11(ah(k),field(k))
         endif
      enddo
      write(nscr,'(6a11,i4,i2,i3,i5)') (field(k),k=1,6),math,mfh,mth,nsc
      nsc=nsc+1
      if (nsc.gt.99999) nsc=1
   endif
   return
   end subroutine lineio

   subroutine a11(x,hx)
   !--------------------------------------------------------------------
   ! Convert x to ENDF 11-column format as a string in hx.  Normally,
   ! hx has the forms +1.234567+6, +1.23456-38, or -1.2345+308.
   ! If ix=1 and x is between 1.0 and 1.e7, the 9 significant-figure
   ! extended precision forms +1.23456789, +12.3456789, ...,
   ! +123456.789 in f format are allowed as sometimes needed for
   ! resonance shapes.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x
   character(11)::hx
   ! internals
   character(1)::s
   real(kr)::ff,xx,f
   integer::n
   real(kr),parameter::zero=0
   real(kr),parameter::tenth=0.1e0_kr
   real(kr),parameter::onem=.999999999e0_kr
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::tmil=.999999999e7_kr
   real(kr),parameter::up=.000000001e0_kr
   real(kr),parameter::top7=9.9999995e0_kr
   real(kr),parameter::top6=9.999995e0_kr
   real(kr),parameter::top5=9.99995e0_kr
   real(kr),parameter::top9=9.999999995e0_kr
   real(kr),parameter::bot9=9.99999995e0_kr

   !--check for zero as a special case
   if (x.ne.zero) go to 100
      f=0
      s='+'
      n=0
      go to 160
   100 if (x.gt.tenth.and.x.lt.tmil) go to 130

   !--normal seven, six, and five sig-fig forms
   xx=x
   n=int(log10(abs(xx)))
   if (abs(xx).lt.one) go to 110
      ff=xx/ten**n
      s='+'
      if (iabs(n).lt.10.and.abs(ff).lt.top7) go to 120
      if (iabs(n).lt.100.and.iabs(n).ge.10.and.&
        abs(ff).lt.top6) go to 120
      if (iabs(n).ge.100.and.abs(ff).lt.top5) go to 120
      ff=ff/ten
      ff=ff+up
      n=n+1
      go to 120
   110 n=1-n
      ff=xx*ten**n
      s='-'
      if (iabs(n).lt.10.and.abs(ff).lt.top7) go to 120
      if (iabs(n).lt.100.and.iabs(n).ge.10.and.&
        abs(ff).lt.top6) go to 120
      if (iabs(n).ge.100.and.abs(ff).lt.top5) go to 120
      ff=ff/ten
      ff=ff+up
      n=n-1
      if (n.gt.0) go to 120
      s='+'
   120 f=ff
   160 if (iabs(n).lt.10) then
         write(hx,'(f9.6,a,i1)') f,s,n
      else if (iabs(n).lt.100) then
         write(hx,'(f8.5,a,i2)') f,s,n
      else
         write(hx,'(f7.4,a,i3)') f,s,n
      endif
      return

   !--extended nine sig-fig form
  130 n=int(log10(abs(x)))
      if (abs(x).lt.onem) go to 140
      f=x/ten**n
      s='+'
      if (iabs(n).lt.10.and.abs(f).lt.top9) go to 150
      if (iabs(n).ge.10.and.abs(f).lt.bot9) go to 150
      f=f/ten
      n=n+1
      go to 150
  140 f=x
      s='-'
      n=-1
  150 continue
   if (n.le.0) write(hx,'(f11.8)') f
   if (n.eq.1) write(hx,'(1p,f11.7)') f
   if (n.eq.2) write(hx,'(2p,f11.6)') f
   if (n.eq.3) write(hx,'(3p,f11.5)') f
   if (n.eq.4) write(hx,'(4p,f11.4)') f
   if (n.eq.5) write(hx,'(5p,f11.3)') f
   if (n.eq.6) write(hx,'(6p,f11.2)') f
   if (n.eq.-1) n=1
   if (f.gt.onem.and.hx(10:11).eq.'00') write(hx,'(f9.6,a,i1)') f,s,n
   if (f.gt.tenth.and.f.lt.onem.and.hx(11:11).eq.'0')&
     write(hx,'(1p,f9.6,a,i1)') f,s,n
   return
   end subroutine a11

   subroutine tablio(nin,nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for bcd ENDF tapes.
   ! Read and/or write the interpolation table for a TAB1 or TAB2
   ! record.  If any unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr
   ! internals
   integer::i,j,ip2,ipend,nterm

   if (nin.ne.0) nr=n1h
   do i=1,nr,3
      ip2=i+2
      ipend=ip2
      if (ip2.gt.nr) ipend=nr
      nterm=ipend-i+1
      if (nin.ne.0) then
         read(nin,'(6i11,i4,i2,i3,i5)')&
           (nbt(j),jnt(j),j=i,ip2),math,mfh,mth,nsp
      endif
      if (nout.ne.0) then
         if (nterm.eq.1) then
            write(nout,'(2i11,44x,i4,i2,i3,i5)')&
              (nbt(j),jnt(j),j=i,ipend),math,mfh,mth,nsh
         else if (nterm.eq.2) then
            write(nout,'(4i11,22x,i4,i2,i3,i5)')&
              (nbt(j),jnt(j),j=i,ipend),math,mfh,mth,nsh
         else if (nterm.eq.3) then
            write(nout,'(6i11,i4,i2,i3,i5)')&
              (nbt(j),jnt(j),j=i,ipend),math,mfh,mth,nsh
         endif
         nsh=nsh+1
         if (nsh.gt.99999) nsh=1
      endif
      if (nscr.ne.0) then
         if (nterm.eq.1) then
            write(nscr,'(2i11,44x,i4,i2,i3,i5)')&
              (nbt(j),jnt(j),j=i,ipend),math,mfh,mth,nsc
         else if (nterm.eq.2) then
            write(nscr,'(4i11,22x,i4,i2,i3,i5)')&
              (nbt(j),jnt(j),j=i,ipend),math,mfh,mth,nsc
         else if (nterm.eq.3) then
            write(nscr,'(6i11,i4,i2,i3,i5)')&
              (nbt(j),jnt(j),j=i,ipend),math,mfh,mth,nsc
         endif
         nsc=nsc+1
         if (nsc.gt.99999) nsc=1
      endif
   enddo
   return
   end subroutine tablio

   subroutine hollio(nin,nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for bcd ENDF tapes.
   ! Read and/or write one line of Hollerith information from
   ! nin to nout and nscr.  If any unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr

   !--input
   if (nin.ne.0) then
      read(nin,'(16a4,a2,i4,i2,i3,i5)') hol,math,mfh,mth,nsp
   endif

   !--output
   if (nout.ne.0) then
      write(nout,'(16a4,a2,i4,i2,i3,i5)') hol,math,mfh,mth,nsh
      if (nsh.gt.99999) nsh=1
      nsh=nsh+1
   endif
   if (nscr.ne.0) then
      write(nscr,'(16a4,a2,i4,i2,i3,i5)') hol,math,mfh,mth,nsc
      if (nsc.gt.99999) nsc=1
      nsc=nsc+1
   endif
   return
   end subroutine hollio

   subroutine tosend(nin,nout,nscr,a)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or blocked binary tapes.
   ! Skip or copy through the SEND card.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   use util ! provide error
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::mat,mf,mt,ns,i,nb,nw
   character(4)::t(17)

   !--mode conversion not allowed
   if (nin.gt.0.and.(nout.lt.0.or.nscr.lt.0))&
     call error('tosend','mode conversion not allowed.',' ')
   if (nin.lt.0.and.(nout.gt.0.or.nscr.gt.0))&
     call error('tosend','mode conversion not allowed.',' ')

   !--bcd/binary input/output until send is read
   mt=1
   do while (mt.gt.0)
      if (nin.gt.0) then
         read(nin,'(16a4,a2,i4,i2,i3,i5)') (t(i),i=1,17),mat,mf,mt,ns
         if (nscr.ne.0) then
            write(nscr,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsc
            nsc=nsc+1
            if (nsc.gt.99999) nsc=1
         endif
         if (nout.ne.0) then
            write(nout,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsh
            nsh=nsh+1
            if (nsh.gt.99999) nsh=1
         endif
      else
         inin=iabs(nin)
         read(inin)mat,mf,mt,nb,nw,(a(i),i=1,nw)
         if (nscr.ne.0) then
            inscr=iabs(nscr)
            write(inscr)mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
         if (nout.ne.0) then
            inout=iabs(nout)
            write(inout)mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
      endif
   enddo
   return
   end subroutine tosend

   subroutine tofend(nin,nout,nscr,a)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or blocked binary tapes.
   ! Skip or copy through the FEND card.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::mat,mf,mt,ns,i,nb,nw
   character(4)::t(17)

   !--mode conversion not allowed
   if (nin.gt.0.and.(nout.lt.0.or.nscr.lt.0))&
     call error('tofend','mode conversion not allowed.',' ')
   if (nin.lt.0.and.(nout.gt.0.or.nscr.gt.0))&
     call error('tofend','mode conversion not allowed.',' ')

   !--bcd/binary input/output until fend is read
   mf=1
   do while (mf.gt.0)
      if (nin.gt.0) then
         read(nin,'(16a4,a2,i4,i2,i3,i5)') (t(i),i=1,17),mat,mf,mt,ns
         if (nscr.ne.0) then
            write(nscr,'(16a4,a2,i4,i2,i3,i5)')&
             (t(i),i=1,17),mat,mf,mt,nsc
            nsc=nsc+1
            if (nsc.gt.99999) nsc=1
         endif
         if (nout.ne.0) then
            write(nout,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsh
            nsh=nsh+1
            if (nsh.gt.99999) nsh=1
         endif
      else
         inin=iabs(nin)
         read(inin) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         if (nscr.ne.0) then
            inscr=iabs(nscr)
            write(inscr) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
         if (nout.ne.0) then
            inout=iabs(nout)
            write(inout) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
      endif
   enddo
   return
   end subroutine tofend

   subroutine tomend(nin,nout,nscr,a)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or blocked binary tapes.
   ! Skip or copy through the MEND card.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::mat,mf,mt,ns,i,nb,nw
   character(4)::t(17)

   !--mode conversion not allowed
   if (nin.gt.0.and.(nout.lt.0.or.nscr.lt.0))&
     call error('tomend','mode conversion not allowed.',' ')
   if (nin.lt.0.and.(nout.gt.0.or.nscr.gt.0))&
     call error('tomend','mode conversion not allowed.',' ')

   !--bcd/binary input/output until mend is read
   mat=1
   do while (mat.gt.0)
      if (nin.gt.0) then
         read(nin,'(16a4,a2,i4,i2,i3,i5)') (t(i),i=1,17),mat,mf,mt,ns
         if (nscr.ne.0) then
            write(nscr,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsc
            nsc=nsc+1
            if (nsc.gt.99999) nsc=1
         endif
         if (nout.ne.0) then
            write(nout,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsh
            nsh=nsh+1
            if (nsh.gt.99999) nsh=1
         endif
      else
         inin=iabs(nin)
         read(inin) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         if (nscr.ne.0) then
            inscr=iabs(nscr)
            write(inscr) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
         if (nout.ne.0) then
            inout=iabs(nout)
            write(inout) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
      endif
   enddo
   return
   end subroutine tomend

   subroutine totend(nin,nout,nscr,a)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or blocked binary tapes.
   ! Skip or copy through the TEND card.
   ! Positive units are bcd, negative ones are blocked binary.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nin,nout,nscr
   real(kr)::a(*)
   ! internals
   integer::inin,inout,inscr
   integer::mat,mf,mt,ns,i,nb,nw
   character(4)::t(17)

   !--mode conversion not allowed
   if (nin.gt.0.and.(nout.lt.0.or.nscr.lt.0))&
     call error('totend','mode conversion not allowed.',' ')
   if (nin.lt.0.and.(nout.gt.0.or.nscr.gt.0))&
     call error('totend','mode conversion not allowed.',' ')

   !--bcd/binary input/output until tend is read
   mat=1
   do while (mat.gt.-1)
      if (nin.gt.0) then
         read(nin,'(16a4,a2,i4,i2,i3,i5)') (t(i),i=1,17),mat,mf,mt,ns
         if (nscr.ne.0) then
            write(nscr,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsc
            nsc=nsc+1
            if (nsc.gt.99999) nsc=1
         endif
         if (nout.ne.0) then
            write(nout,'(16a4,a2,i4,i2,i3,i5)')&
              (t(i),i=1,17),mat,mf,mt,nsh
            nsh=nsh+1
            if (nsh.gt.99999) nsh=1
         endif
      else
         inin=iabs(nin)
         read(inin) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         if (nscr.ne.0) then
            inscr=iabs(nscr)
            write(inscr) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
         if (nout.ne.0) then
            inout=iabs(nout)
            write(inout) mat,mf,mt,nb,nw,(a(i),i=1,nw)
         endif
      endif
   enddo
   return
   end subroutine totend

   subroutine asend(nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or blocked binary tapes.
   ! Write a SEND card with blanks.
   ! If a unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nout,nscr
   ! internals
   integer::inout,inscr
   integer::nb,nw
   real(kr)::z

   nb=0
   nw=6
   z=0
   mth=0
   if (nout.gt.0) then
      nsh=99999
      write(nout,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsh
      nsh=1
   endif
   if (nout.lt.0) then
      inout=iabs(nout)
      write(inout)math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   if (nscr.gt.0) then
      nsc=99999
      write(nscr,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsc
      nsc=1
   endif
   if (nscr.lt.0) then
      inscr=iabs(nscr)
      write(inscr)math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   return
   end subroutine asend

   subroutine afend(nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or block binary tapes.
   ! Write a FEND card with blanks.
   ! If a unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nout,nscr
   ! internals
   integer::inout,inscr
   integer::nb,nw
   real(kr)::z

   nb=0
   nw=6
   z=0
   mfh=0
   mth=0
   if (nout.gt.0) then
      nsh=0
      write(nout,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsh
      nsh=nsh+1
   endif
   if (nout.lt.0) then
      inout=iabs(nout)
      write(inout) math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   if (nscr.gt.0) then
      nsc=0
      write(nscr,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsc
      nsc=nsc+1
   endif
   if (nscr.lt.0) then
      inscr=iabs(nscr)
      write(inscr) math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   return
   end subroutine afend

   subroutine amend(nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or block binary tapes.
   ! Write a MEND card with blanks.
   ! If a unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nout,nscr
   ! internals
   integer::inout,inscr
   integer::nb,nw
   real(kr)::z

   nb=0
   nw=6
   z=0
   math=0
   mfh=0
   mth=0
   if (nout.gt.0) then
      nsh=0
      write(nout,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsh
      nsh=nsh+1
   endif
   if (nout.lt.0) then
      inout=iabs(nout)
      write(inout) math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   if (nscr.gt.0) then
      nsc=0
      write(nscr,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsc
      nsc=nsc+1
   endif
   if (nscr.lt.0) then
      inscr=iabs(nscr)
      write(inscr) math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   return
   end subroutine amend

   subroutine atend(nout,nscr)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF bcd or block binary tapes.
   ! Write a TEND card with blanks.
   ! If a unit is zero, it is not used.
   !--------------------------------------------------------------------
   ! externals
   integer::nout,nscr
   ! internals
   integer::inout,inscr
   integer::nb,nw
   real(kr)::z

   nb=0
   nw=6
   z=0
   math=-1
   mfh=0
   mth=0
   if (nout.gt.0) then
      nsh=0
      write(nout,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsh
      nsh=nsh+1
   endif
   if (nout.lt.0) then
      inout=iabs(nout)
      write(inout) math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   if (nscr.gt.0) then
      nsc=0
      write(nscr,'(66x,i4,i2,i3,i5)') math,mfh,mth,nsc
      nsc=nsc+1
   endif
   if (nscr.lt.0) then
      inscr=iabs(nscr)
      write(inscr) math,mfh,mth,nb,nw,z,z,z,z,z,z
   endif
   return
   end subroutine atend

   subroutine skip6(nin,nout,nscr,a,law)
   !--------------------------------------------------------------------
   ! Utility routine for ENDF File 6.
   ! Skip the next subsection in the current section (MT).
   !--------------------------------------------------------------------
   ! externals
   integer::nin,nout,nscr,law
   real(kr)::a(*)
   ! internals
   integer::ne,ie,nmu,imu,nb,nw

   ! negative laws, law 0, 3 and 4 have no law dependent structure so no
   ! need to skip over it
   if (law.eq.6) then
      call contio(nin,nout,nscr,a(1),nb,nw)
   else if (law.eq.1.or.law.eq.2.or.law.eq.5) then
      call tab2io(nin,nout,nscr,a(1),nb,nw)
      ne=n2h
      do ie=1,ne
         call listio(nin,nout,nscr,a(1),nb,nw)
         do while (nb.ne.0)
            call moreio(nin,nout,nscr,a(1),nb,nw)
         enddo
      enddo
   else if (law.eq.7) then
      call tab2io(nin,nout,nscr,a(1),nb,nw)
      ne=n2h
      do ie=1,ne
         call tab2io(nin,nout,nscr,a(1),nb,nw)
         nmu=n2h
         do imu=1,nmu
            call tab1io(nin,nout,nscr,a(1),nb,nw)
            do while (nb.ne.0)
               call moreio(nin,nout,nscr,a(1),nb,nw)
            enddo
         enddo
      enddo
   endif
   return
   end subroutine skip6

   subroutine findf(mat,mf,mt,ntape)
   !--------------------------------------------------------------------
   ! Find specified section on an ENDF format tape.
   ! If ntape lt 0, it is assumed to be in binary mode.
   ! If mt=0, find the first section in MAT,MF.
   ! If mf=0, find the first file in MAT.
   ! Routine searches up or down and leaves tape positioned
   ! to read the *head* card for the section requested.
   !--------------------------------------------------------------------
   use util ! provides skiprz,error
   ! externals
   integer::mat,mf,mt,ntape
   ! internals
   integer::math,mfh,mth,matl,mfl,itape,igo
   character strng*60

   !---read first card and determine whether to read up or down.
   itape=iabs(ntape)
   100 continue
   if (ntape.gt.0) then
      read(itape,'(66x,i4,i2,i3)') math,mfh,mth
   else
      read(itape)math,mfh,mth
   endif

   !--test for mat
   if (math.eq.0) go to 100
   if (math.eq.mat) go to 120
   igo=+1
   if (math.eq.-1) igo=-1
   if (math.gt.mat) igo=-1
   go to 200

   !--test for file
   120 continue
   if (mf.eq.0) go to 300
   if (mfh.eq.mf) go to 130
   if (mfh.eq.0) go to 100
   igo=+1
   if (mfh.gt.mf) igo=-1
   go to 200

   !--test for section
   130 continue
   if (mt.eq.0) go to 300
   if (mth.eq.mt) go to 300
   if (mth.eq.0) call skiprz(ntape,-2)
   if (mth.eq.0) go to 100
   igo=+1
   if (mth.gt.mt) igo=-1
   go to 200

   !--search up or down for section
   200 continue
   if (igo.lt.0) call skiprz(ntape,-2)
   if (igo.lt.0) matl=math
   if (igo.lt.0) mfl=mfh
   if (ntape.gt.0) then
      read(itape,'(66x,i4,i2,i3)') math,mfh,mth
   else
      read(itape)math,mfh,mth
   endif

   !--test for mat
   if (math.eq.mat) go to 230
   if (igo.lt.0) go to 220
   if (math.gt.mat.or.math.eq.-1) go to 400
   go to 200
   220 continue
   if (math.lt.mat.and.math.ne.0) go to 400
   if (math.eq.matl.and.mfl.eq.0.and.mfh.eq.0) igo=+1
   go to 200

   !--test for file
   230 continue
   if (mf.eq.0) go to 300
   if (mfh.eq.mf) go to 240
   if (mfh.eq.0) go to 200
   if (igo.lt.0.and.mfh.lt.mf) go to 400
   if (igo.gt.0.and.mfh.gt.mf) go to 400
   go to 200

   !--test for section
   240 continue
   if (mt.eq.0) go to 300
   if (mth.eq.mt) go to 300
   if (mth.eq.0) go to 200
   go to 200

   !--desired section has been found
   !--backspace to card before head card
   300 continue
   call skiprz(ntape,-2)
   if (ntape.gt.0) then
      read(itape,'(66x,i4,i2,i3)') math,mfh,mth
   else
      read(itape)math,mfh,mth
   endif
   if (mth.gt.0) go to 300
   if (mt.eq.0.and.mfh.gt.0) go to 300
   if (mf.eq.0.and.math.eq.mat) go to 300
   return

   !--desired section is not on itape.  write message.
   400 continue
   write(strng,'('' mat'',i4,'' mf'',i2,'' mt'',i3,&
     &'' not on tape '',i3)') mat,mf,mt,itape
   call error('findf',strng,' ')
   return
   end subroutine findf

   subroutine terp1(x1,y1,x2,y2,x,y,i)
   !--------------------------------------------------------------------
   ! Interpolate one point, where
   ! (x1,y1) and (x2,y2) are the end points of the line,
   ! (x,y) is the interpolated point,
   ! i is the interpolation code, and
   ! thr6 is the kinematic threshold for i=6 (thr6.ge.0.).
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x1,y1,x2,y2,x,y
   integer::i
   ! internals
   real(kr)::a,b,t
   real(kr),parameter::zero=0

   !--make sure x2 .ne. x1
   if (x2.eq.x1) then
      y=y1
      return
   endif

   !--y is constant
   if (i.eq.1.or.y2.eq.y1.or.x.eq.x1) then
      y=y1

   !--y is linear in x
   else if (i.eq.2) then
      y=y1+(x-x1)*(y2-y1)/(x2-x1)

   !--y is linear in ln(x)
   else if (i.eq.3) then
      y=y1+log(x/x1)*(y2-y1)/log(x2/x1)

   !--ln(y) is linear in x
   else if (i.eq.4) then
      y=y1*exp((x-x1)*log(y2/y1)/(x2-x1))

   !--ln(y) is linear in ln(x)
   else if (i.eq.5) then
      if (y1.eq.zero) then
         y=y1
      else
         y=y1*exp(log(x/x1)*log(y2/y1)/log(x2/x1))
      endif

   !--coulomb penetrability law (charged particles only)
   else if (i.eq.6) then
      if (y1.eq.zero) then
         y=y1
      else
         t=sqrt(x1-thr6)
         b=log((x2*y2)/(x1*y1))
         b=b/(1/t-1/sqrt(x2-thr6))
         a=exp(b/t)*x1*y1
         y=(a/x)*exp(-b/sqrt(x-thr6))
      endif
   endif
   return
   end subroutine terp1

   subroutine intega(f,x1,x2,a,ip,ir)
   !--------------------------------------------------------------------
   ! Integrate from x1 to x2 in the TAB1 record packed in a.
   ! Assume function is zero outside the range of the table.
   ! The contribution of each panel in the data is computed
   ! analytically in function gral.  On entry, ip and ir are
   ! starting estimates for the first data point greater than
   ! x1 and the corresponding interpolation range.  Initialize
   ! them to 2 and 1 before first call.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::f,x1,x2
   real(kr)::a(*)
   integer::ip,ir
   ! internals
   integer::nr,np,jr,jp,int,it
   real(kr)::xlo,xhi

   !--initialize integral.  set up limits and pointers
   f=0
   nr=nint(a(5))
   np=nint(a(6))
   if (ip.gt.np) ip=np
   if (ir.gt.nr) ir=nr
   jr=5+2*ir
   jp=5+2*nr+2*ip

   !--locate first data point greater than x1
   110 continue
   if (x1.lt.a(jp)) go to 120
   if (ip.eq.np) go to 170
   ! move up
   jp=jp+2
   ip=ip+1
   it=nint(a(jr))
   if (ip.le.it) go to 110
   jr=jr+2
   ir=ir+1
   go to 110
   120 continue
   if (x1.ge.a(jp-2)) go to 130
   if (ip.gt.2) go to 125
   if (x2.le.a(jp-2)) go to 170
   xlo=a(jp-2)
   go to 150
   125 continue
   ! move down
   jp=jp-2
   ip=ip-1
   if (ir.eq.1) go to 110
   it=nint(a(jr-2))
   if (ip.gt.it) go to 110
   jr=jr-2
   ir=ir-1
   go to 110

   !--accumulate contributions to integral
   130 continue
   xlo=x1
   150 continue
   xhi=a(jp)
   if (xhi.gt.x2) xhi=x2
   int=nint(a(jr+1))
   f=f+gral(a(jp-2),a(jp-1),a(jp),a(jp+1),xlo,xhi,int)
   if (xhi.eq.x2) go to 170
   if (ip.eq.np) go to 170
   xlo=xhi
   jp=jp+2
   ip=ip+1
   it=nint(a(jr))
   if (ip.le.it) go to 150
   jr=jr+2
   ir=ir+1
   go to 150

   !--integral is complete
   170 continue
   return
   end subroutine intega

   subroutine terpa(y,x,xnext,idis,a,ip,ir)
   !--------------------------------------------------------------------
   ! Interpolate for y(x) in the TAB1 record packed in a.  Return zero
   ! if x is outside the range of the table.   Here xnext is the next
   ! data grid point greater than x.  On entry, ip and ir are starting
   ! estimates for the first data point greater than x and the
   ! corresponding interpolation range.  Initialize them to 2 and 1
   ! before first call to routine.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::y,x,xnext
   real(kr)::a(*)
   integer::idis,ip,ir
   integer::nr,np,jr,jp,int,it
   real(kr),parameter::shade=1.00001e0_kr
   real(kr),parameter::xbig=1.e12_kr
   real(kr),parameter::zero=0

   !--set up limits and pointers
   nr=nint(a(5))
   np=nint(a(6))
   if (ir.gt.nr) ir=nr
   if (ip.gt.np) ip=np
   jr=5+2*ir
   jp=5+2*nr+2*ip
   idis=0

   !--locate interpolation interval and law for x
   110 continue
   if (x.lt.a(jp)) go to 120
   if (ip.eq.np) go to 150
   ! move up
   jp=jp+2
   ip=ip+1
   it=nint(a(jr))
   if (ip.le.it) go to 110
   jr=jr+2
   ir=ir+1
   go to 110
   120 continue
   if (x.gt.a(jp-2)) go to 130
   if (x.eq.a(jp-2)) go to 140
   if (ip.eq.2) go to 170
   ! move down
   jp=jp-2
   ip=ip-1
   if (ir.eq.1) go to 110
   it=nint(a(jr-2))
   if (ip.gt.it) go to 110
   jr=jr-2
   ir=ir-1
   go to 110

   !--interpolate for y in this interval
   130 continue
   int=nint(a(jr+1))
   call terp1(a(jp-2),a(jp-1),a(jp),a(jp+1),x,y,int)
   xnext=a(jp)
   if (int.eq.1) idis=1
   if (ip.eq.np) return
   if (a(jp+2).eq.xnext) idis=1
   return
   140 continue
   y=a(jp-1)
   int=nint(a(jr+1))
   xnext=a(jp)
   if (int.eq.1) idis=1
   if (ip.eq.np) return
   if (a(jp+2).eq.xnext) idis=1
   return

   !--special branch for last point and above
   150 continue
   if (x.lt.shade*a(jp)) go to 160
   y=0
   xnext=xbig
   return
   160 continue
   y=a(jp+1)
   xnext=xbig
   if (y.gt.zero) xnext=shade*shade*a(jp)
   return

   !--special branch for x below first point
   170 continue
   y=0
   xnext=a(jp-2)
   idis=1
   return
   end subroutine terpa

   real(kr) function gral(xl,yl,xh,yh,x1,x2,int)
   !--------------------------------------------------------------------
   ! Compute the integral from x1 to x2 of the function described
   ! by the endpoints (xl,yl) and (xh,yh) and the ENDF interpolation \
   ! scheme int.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   real(kr)::xl,yl,xh,yh,x1,x2
   integer::int
   ! internals
   real(kr)::a,b,z
   real(kr),parameter::break=0.1e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--trivial case.
   gral=0
   if (x2.eq.x1) return

   !--process according to interpolation scheme.
   if (x2.lt.x1) call error('gral','x2 lt x1.',' ')

   !--y is constant
   if (int.eq.1) then
      gral=(x2-x1)*yl

   !--y is linear in x.
   else if (int.eq.2) then
      b=(yh-yl)/(xh-xl)
      a=yl-b*xl
      gral=(x2-x1)*(a+b*(x2+x1)/2)

   !--y is linear in ln(x)
   else if (int.eq.3) then
      if ((xl.le.zero).or.(xh.le.zero)) then
         ! default to linear-linear
         b=(yh-yl)/(xh-xl)
         a=yl-b*xl
         gral=(x2-x1)*(a+b*(x2+x1)/2)
      else
         b=(yh-yl)/log(xh/xl)
         z=(x2-x1)/x1
         if (abs(z).le.break) then
            gral=(x2-x1)*(yl+b*log(x1/xl))+b*x1*z*z*(1+&
              z*(-one/3+z*(one/6-z/10)))/2
         else
            gral=(x2-x1)*(yl+b*log(x1/xl))+b*x1*(1+&
              (x2/x1)*(log(x2/x1)-1))
         endif
      endif

   !--ln(y) linear in x.
   else if (int.eq.4) then
      if ((yl.lt.zero).or.(yh.lt.zero)) then
         ! default to linear-linear
         b=(yh-yl)/(xh-xl)
         a=yl-b*xl
         gral=(x2-x1)*(a+b*(x2+x1)/2)
      else
         b=log(yh/yl)/(xh-xl)
         a=log(yl)-b*xl
         z=(x2-x1)*b
         if (abs(z).le.break) then
            gral=exp(a+b*x1)*(x2-x1)*(1+z*(one/2+z/6))
         else
            gral=exp(a+b*x1)*(exp(z)-1)/b
         endif
      endif

   !--ln(y) is linear in ln(x).
   else if (int.eq.5) then
      if ((xl.le.zero).or.(xh.le.zero)) then
         ! default to ln(y) linear in x
         if ((yl.lt.zero).or.(yh.lt.zero)) then
            ! default to linear-linear
            b=(yh-yl)/(xh-xl)
            a=yl-b*xl
            gral=(x2-x1)*(a+b*(x2+x1)/2)
         else
            b=log(yh/yl)/(xh-xl)
            a=log(yl)-b*xl
            z=(x2-x1)*b
            if (abs(z).le.break) then
               gral=exp(a+b*x1)*(x2-x1)*(1+z*(one/2+z/6))
            else
               gral=exp(a+b*x1)*(exp(z)-1)/b
            endif
         endif
      else if ((yl.lt.zero).or.(yh.lt.zero)) then
         ! default to y is linear in ln(x)
         if ((xl.le.zero).or.(xh.le.zero)) then
            ! default to linear-linear
            b=(yh-yl)/(xh-xl)
            a=yl-b*xl
            gral=(x2-x1)*(a+b*(x2+x1)/2)
         else
            b=(yh-yl)/log(xh/xl)
            z=(x2-x1)/x1
            if (abs(z).le.break) then
               gral=(x2-x1)*(yl+b*log(x1/xl))+b*x1*z*z*(1+&
                 z*(-one/3+z*(one/6-z/10)))/2
            else
               gral=(x2-x1)*(yl+b*log(x1/xl))+b*x1*(1+&
                 (x2/x1)*(log(x2/x1)-1))
            endif
         endif
      else
         b=log(yh/yl)/log(xh/xl)
         z=(b+1)*log(x2/x1)
         if (abs(z).le.break) then
            gral=yl*x1*((x1/xl)**b)*log(x2/x1)*(1+z*(one/2+z/6))
         else
            gral=yl*x1*((x1/xl)**b)*(((x2/x1)**(b+1))-1)/(b+1)
         endif
      endif
   endif
   return
   end function gral

   subroutine gety1(x,xnext,idis,y1,itape,a)
   !--------------------------------------------------------------------
   ! Retrieve y1(x) from an ENDF TAB1 structure using paged bcd or
   ! blocked binary formats.  Call with x=0 to read in first page
   ! or block of data and initialize pointers.  Routine assumes values
   ! will be called in ascending order.  On return, xnext is the
   ! first data grid point greater than x unless x is the last point.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x,xnext,y1
   real(kr)::a(*)
   integer::idis,itape
   ! internals
   integer::nw,loc,ln,int
   integer::nwtot,nr,np,lt,ip1,ip2,ip,ir,nb,nbt
   real(kr)::xlast,ylast,xn
   save nwtot,nr,np,lt,ip1,ip2,ip,ir,nb,nbt,xlast,ylast
   real(kr),parameter::down=.999999e0_kr
   real(kr),parameter::xbig=1.e12_kr
   real(kr),parameter::zero=0

   !--read first page or block of data and initialize
   idis=0
   if (x.gt.zero) go to 110
   call tab1io(itape,0,0,a,nb,nw)
   nwtot=nw
   nr=nint(a(5))
   np=nint(a(6))
   lt=6+2*nr
   ip1=1
   ip2=(nw-lt)/2
   if (nb.eq.0) ip2=ip2+2
   ir=1
   ip=1
   ! check for zero extension as in mf13.
   100 continue
   loc=lt+2*(ip-ip1)+1
   xlast=a(loc)
   ylast=a(loc+1)
   xnext=xlast
   y1=ylast
   if (ylast.ne.zero) xlast=down*xlast
   if (ylast.ne.zero) return
   if (ip.ge.np-1) return
   if (a(loc+3).ne.zero.and.ip.gt.1) xnext=down*xnext
   if (a(loc+3).ne.zero) return
   ip=ip+1
   nbt=nint(a(5+2*ir))
   if (ip.gt.nbt) ir=ir+1
   if ((ip+2).le.ip2) go to 100
   a(lt+1)=a(nwtot-3)
   a(lt+2)=a(nwtot-2)
   a(lt+3)=a(nwtot-1)
   a(lt+4)=a(nwtot)
   call moreio(itape,0,0,a(lt+5),nb,nw)
   nwtot=nw+lt+4
   ip1=ip
   ip2=ip1+nw/2+1
   if (nb.eq.0) ip2=ip2+2
   go to 100

   !--is x in this panel
   110 continue
   if (x.lt.xlast) go to 200
   ln=2*(ip-ip1)+lt
   if (x.lt.a(ln+1)) go to 120
   if (ip.eq.np) go to 300

   !--no.  move up to next range.
   !--read in new page of data if needed.
   xlast=a(ln+1)
   ylast=a(ln+2)
   ip=ip+1
   nbt=nint(a(5+2*ir))
   if (ip.gt.nbt) ir=ir+1
   if ((ip+2).le.ip2) go to 110
   if (nb.eq.0) go to 120
   a(lt+1)=a(nwtot-3)
   a(lt+2)=a(nwtot-2)
   a(lt+3)=a(nwtot-1)
   a(lt+4)=a(nwtot)
   call moreio(itape,0,0,a(lt+5),nb,nw)
   nwtot=nw+lt+4
   ip1=ip
   ip2=ip1+nw/2+1
   if (nb.eq.0) ip2=ip2+2
   go to 110

   !--yes.  interpolate for desired value
   120 continue
   int=nint(a(2*ir+6))
   if (int.eq.1) idis=1
   call terp1(xlast,ylast,a(ln+1),a(ln+2),x,y1,int)
   xnext=a(ln+1)
   if ((ln+3).gt.nwtot.and.nb.eq.0) return
   xn=a(ln+3)
   if (xn.eq.xnext) idis=1
   return

   !--special branch for x outside range of table
   200 continue
   y1=0
   xnext=xlast
   return

   !--special branch for last point
   300 continue
   y1=a(ln+2)
   xlast=xbig
   xnext=xbig
   return
   end subroutine gety1

   subroutine gety2(x,xnext,idis,y2,itape,a)
   !--------------------------------------------------------------------
   ! Retrieve y2(x) from an ENDF TAB1 structure using paged bcd or
   ! blocked binary formats.  Call with x=0 to read in first page
   ! or block of data and initialize pointers.  Routine assumes
   ! values will be called in ascending order.  On return, xnext is
   ! the first data grid point greater than x unless x is the last
   ! point.  This subroutine is similar to gety1, for use when
   ! two y quantities must be retrieved simultaneously.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x,xnext,y2
   real(kr)::a(*)
   integer::idis,itape
   ! internals
   integer::nw,ln,int
   integer::nwtot,nr,np,lt,ip1,ip2,ip,ir,nb,nbt
   real(kr)::xlast,ylast,xn
   save nwtot,nr,np,lt,ip1,ip2,ip,ir,nb,nbt,xlast,ylast
   real(kr),parameter::down=.999999e0_kr
   real(kr),parameter::zero=0
   real(kr),parameter::xbig=1.e12_kr

   !--read first page or block of data and initialize
   idis=0
   if (x.gt.zero) go to 110
   call tab1io(itape,0,0,a,nb,nw)
   nwtot=nw
   nr=nint(a(5))
   np=nint(a(6))
   lt=6+2*nr
   ip1=1
   ip2=(nw-lt)/2
   if (nb.eq.0) ip2=ip2+2
   ir=1
   ip=1
   xlast=a(lt+1)
   ylast=a(lt+2)
   xnext=xlast
   y2=ylast
   if (ylast.ne.zero) xlast=down*xlast
   return

   !--is x in this panel
   110 continue
   if (x.lt.xlast) go to 200
   ln=2*(ip-ip1)+lt
   if (x.lt.a(ln+1)) go to 120
   if (ip.eq.np) go to 300

   !--no.  move up to next range.
   !--read in new page of data if needed.
   xlast=a(ln+1)
   ylast=a(ln+2)
   ip=ip+1
   nbt=nint(a(5+2*ir))
   if (ip.gt.nbt) ir=ir+1
   if ((ip+2).le.ip2) go to 110
   if (nb.eq.0) go to 120
   a(lt+1)=a(nwtot-3)
   a(lt+2)=a(nwtot-2)
   a(lt+3)=a(nwtot-1)
   a(lt+4)=a(nwtot)
   call moreio(itape,0,0,a(lt+5),nb,nw)
   nwtot=nw+lt+4
   ip1=ip
   ip2=ip1+nw/2+1
   if (nb.eq.0) ip2=ip2+2
   go to 110

   !--yes.  interpolate for desired value
   120 continue
   int=nint(a(2*ir+6))
   if (int.eq.1) idis=1
   call terp1(xlast,ylast,a(ln+1),a(ln+2),x,y2,int)
   xnext=a(ln+1)
   if ((ln+3).gt.nwtot.and.nb.eq.0) return
   xn=a(ln+3)
   if (xn.eq.xnext) idis=1
   return

   !--special branch for x outside range of table
   200 continue
   y2=0
   xnext=xlast
   return

   !--special branch for last point
   300 continue
   y2=a(ln+2)
   xlast=xbig
   xnext=xbig
   return
   end subroutine gety2

end module endf

module version
   ! Gives the NJOY version identifier and the corresponding date.
   ! These values are updated during the NJOY revision-control process.
   implicit none
   private
   character(8),public::vers='2016.78'
   character(8),public::vday='03Feb25'
end module version

module covm
   ! provides subroutine covr for NJOY2016
   use locale
   implicit none
   private
   public covr

   ! global variables

   ! user's input
   integer::nin,nout
   integer::nplot
   integer::icolor
   real(kr)::epmin
   real(kr)::einc
   integer::irelco
   integer::ncase
   integer::noleg
   integer::nstart
   integer::ndiv
   integer::matype
   character(12)::hlibid
   character(21)::hdescr
   integer::mat,mt,mat1,mt1
   integer::mfflg,mf3,mf5,mf35

   ! other common variables

   integer,parameter::ncasemx=100
   integer::nscr,nscr1,nscr2
   integer::nrow,ncol,itype,nvf,ncf
   integer::ixmin,ixmax
   integer::izero,ismall
   integer::ishade
   integer::nlev
   integer::nexp
   integer::iza,iza1,izap
   integer::nwscr,max,nwcf,nwig
   real(kr),dimension(:),allocatable::scr
   real(kr),dimension(:),allocatable::xlev
   real(kr),dimension(:),allocatable::cf
   real(kr),dimension(:),allocatable::x,y
   real(kr),dimension(:),allocatable::xx,xy
   real(kr),dimension(:),allocatable::rsdx,rsdy
   integer,dimension(:),allocatable::imtx,imtx1,imatx1

contains

   subroutine covr
   !--------------------------------------------------------------------
   !
   ! Plot covariance data from errorr or make a condensed library.
   !
   ! In the plot option, covr plots a matrix of correlation
   ! coefficients and an associated pair of standard deviation
   ! vectors, i.e.,a covariance matrix.  The correlation
   ! matrix is plotted as a shaded contour plot and the vectors
   ! are plotted as semi-log plots, one rotated by 90 degrees.
   ! The log energy grids for the vector plots are identical
   ! to the grids for the matrix plot.  This version plots
   ! through viewr.
   !
   ! In the library option, covr produces a condensed bcd
   ! covariance library in the boxer format.  This format is
   ! efficient for matrices of simple blocks.
   !
   !---input specifications (free format)---------------------------
   !
   !  card 1
   !     nin            input tape unit
   !     nout           output tape unit
   !                    (default=0=none)
   !     nplot          viewr output unit
   !                    (default=0=none)
   !
   !   ---cards 2, 2', 2a, and 3a for nout.le.0 only (plot option)
   !
   !  card 2
   !     icolor         select color or monochrome style
   !                      0=monochrome (uses cross hatching)
   !                      1=color background and contours
   !                      2=color background and contours plus
   !                        card 2' follows.
   !                      (default=0)
   !  card 2' (only when icolor=2)
   !     nlev,(tlev(i),i=1,nlev)
   !                    defines the number of correlation matrix
   !                    intervals and their boundaries.  Zero is
   !                    assumed as the lower limit of the first
   !                    boundary, but the User must specify unity
   !                    as the upper limit of the last boundary.
   !                    nlev is a positive integer .le. 9.
   !                    default values (when icolor=1) are:
   !                      6,0.001,0.1,0.2,0.3,0.6,1.0
   !  card 2a
   !     epmin          lowest energy of interest (default=0.)
   !  card 3a
   !     irelco         type of covariances present on nin
   !                    0/1=absolute/relative covariances
   !                    (default=1)
   !     ncase          no. cases to be run (maximum=60)
   !                    (default=1)
   !     noleg          plot legend option
   !                    -1/0/1=legend for first subcase only/
   !                    legend for all plots/no legends
   !                    (default=0)
   !     nstart         sequential figure number
   !                    0/n=not needed/first figure is figure n.
   !                    (default=1)
   !     ndiv           no. of subdivisions of each of the
   !                    gray shades (default=1)
   !
   !   ---cards 2b, 3b, and 3c for nout gt 0 (library option) only--
   !
   !  card 2b
   !     matype         output library matrix option
   !                    3/4=covariances/correlations
   !                    (default=3)
   !     ncase          no. cases to be run (maximum=ncasemx=100)
   !                    (default=1)
   !  card 3b
   !     hlibid         up to 6 characters for identification
   !  card 3c
   !     hdescr         up to 21 characters of descriptive
   !                    information
   !
   !   ---cards 4 for both options---
   !
   !  card 4
   !     mat            desired mat number
   !     mt             desired mt number
   !     mat1           desired mat1 number
   !     mt1            desired mt1 number
   !                    (default for mt, mat1 and mt1 are 0,0,0
   !                    meaning process all mts for this mat
   !                    with mat1=mat)
   !                    (neg. values for mt, mat1, and mt1 mean
   !                    process all mts for this mat, except for
   !                    the mt-numbers -mt, -mat1, and -mt1.  in
   !                    general, -n will strip both mt=1 and mt=n.
   !                    -4 will strip mt=1, mt=3, and mt=4, and
   !                    -62, for example, will strip mt=1, mt=62,
   !                    mt=63, ... up to and incl. mt=90.)
   !          repeat card 4 ncase times
   !
   ! note---if more than one material appears on the input tape,
   ! the mat numbers must be in ascending order.
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use util ! provides timer,openz,error,repoz,mess
   use endf ! provides endf routines and variables
   ! internals
   integer,parameter::nlevmx=9
   integer::iomit,nfigmx,ncamx,ne,i,nfig,nwlev,ilev,j,n,nb,nw
   integer::nwy,ixpn
   real(kr)::sec,da,tlow,tx
   character(60)::strng
   character(6)::hinpid
   real(kr),dimension(:),allocatable::xig,yig
   real(kr),dimension(nlevmx)::tlev=(/.001e0_kr,.1e0_kr,.2e0_kr,&
             .3e0_kr,.6e0_kr,1.0e0_kr,0.0e0_kr,0.0e0_kr,0.0e0_kr/)
   integer::imat(ncasemx),imt(ncasemx),imat1(ncasemx),imt1(ncasemx)
   real(kr),parameter::rdn=0.999998e0_kr
   character(5),dimension(3)::hreas=(/'null ','small','empty'/)
   integer,parameter::ntics3=600

   !--initialize
   call timer(sec)
   write(nsyso,'(/&
     &'' covr...process covariance data'',38x,f8.1,''s'')') sec
   write(nsyse,'(/'' covr...'',61x,f8.1,''s'')') sec
   nfigmx=ncasemx
   max=1+nfigmx*(nfigmx+1)/2
   mf3=3
   mf5=5
   ncamx=ncasemx
   iomit=0

   !--read and write out user input
   nout=0
   nplot=0
   read(nsysi,*) nin,nout,nplot
   call openz(nin,0)
   call openz(nout,1)
   if (nout.le.0) then
      nscr1=11
      nscr2=0
      call openz(nscr1,1)
      call repoz(-nscr1)
      write(nscr1,'(/&
        &'' the following plots were omitted or were plotted but '',&
        &''empty'',21x/4x,''mat'',5x,''mt'',3x,''mat1'',4x,''mt1'',3x,&
        &''reason'',43x/3x,''----'',4x,''---'',3x,''----'',4x,&
        &''---'',3x,''------'',43x)')
      ! input for plot option
      icolor=0
      read(nsysi,*) icolor
      nlev=6
      if (icolor.eq.2) then
         read(nsysi,*)nlev,(tlev(i),i=1,nlev)
         if (nlev.gt.nlevmx) then
           write(strng,'('' nlev>'',i2,'' not allowed'')')nlevmx
            call error('covr',strng,' ')
         endif
         do i=2,nlev
            if (tlev(i).le.tlev(i-1)) then
               call error('covr',&
                          'tlev array must sequentially increase',&
                          ' ')
            endif
         enddo
         if (tlev(nlev).ne.1) then
            write(strng,'(''reset tlev('',i2,'') from '',1pe11.4,&
                          &'' to 1.0'')')nlev,tlev(nlev)
            call mess('covr',strng,' ')
            tlev(nlev)=1
         endif
      endif
      epmin=0
      read(nsysi,*) epmin
      epmin=epmin*rdn
      irelco=1
      ncase=1
      noleg=0
      nstart=1
      ndiv=1
      read(nsysi,*) irelco,ncase,noleg,nstart,ndiv
      if (ndiv.eq.0) ndiv=1
      if (ncase.gt.ncamx)&
        call error('covr','requested too many cases.',' ')
   else
      ! input for library option
      nscr1=11
      nscr2=12
      call openz(-nscr1,1)
      call openz(-nscr2,1)
      call repoz(-nscr1)
      call repoz(-nscr2)
      ! do not translate abs. covariances to rel. in library option,
      ! thus allowing stand. devs. and covariances to track the
      ! errorr output.
      irelco=1
      matype=3
      ncase=1
      read(nsysi,*) matype,ncase
      if (matype.ne.4) matype=3
      if (ncase.le.0) ncase=1
      if (ncase.gt.ncamx)&
        call error('covr','requested too many cases.',' ')
      read(nsysi,*) hinpid
      hdescr=' '
      read(nsysi,*) hdescr
   endif
   do i=1,ncase
      imt(i)=0
      imat1(i)=0
      imt1(i)=0
      read(nsysi,*) imat(i),imt(i),imat1(i),imt1(i)
   enddo
   if (nout.eq.0) write(nsyso,'(/&
     &'' unit for input covariance tape ....... '',i10/&
     &'' unit for output covariance tape ...... '',i10/&
     &'' unit for plot output ................. '',i10/&
     &'' icolor ............................... '',i10/&
     &'' rel. cov. option (0=abs/1=rel) ....... '',i10/&
     &'' ncase ................................ '',i10/&
     &'' legend option (-1=first/0=all/1=none)  '',i10/&
     &'' starting fig. no. (0=omit fig. nos.) . '',i10/&
     &'' no. subdivisions of each shade ....... '',i10/&
     &'' minimum energy to be plotted ......... '',1p,e10.3)')&
     nin,nout,nplot,icolor,irelco,ncase,noleg,nstart,ndiv,epmin
   if (nout.gt.0) write(nsyso,'(/&
     &'' unit for input covariance tape ....... '',i10/&
     &'' unit for output covariance tape ...... '',i10/&
     &'' output matrix option (3=cov./4=corr.)  '',i10/&
     &'' no. cases to run ..................... '',i10/&
     &'' library identification ............... ''/6x,a6/&
     &'' library description .................. ''/6x,a21)')&
     nin,nout,matype,ncase,hinpid,hdescr
   write(nsyso,'(/12x,''mat'',6x,''mt'',6x,''mat1'',6x,''mt1''/&
     &11x,''----'',5x,''---'',6x,''----'',6x,''---''/&
     &(11x,i4,5x,i3,6x,i4,6x,i3))')&
     (imat(i),imt(i),imat1(i),imt1(i),i=1,ncase)

   !--initialize parameters for plots
   if (nout.le.0) then
      nfig=nstart-1
      ! set up shade levels
      nwlev=nlev*ndiv
      allocate(xlev(nwlev))
      ilev=0
      tlow=0
      do i=1,nlev
         tx=(tlev(i)-tlow)/ndiv
         do j=1,ndiv
            ilev=ilev+1
            xlev(ilev)=tlow+tx*j
         enddo
         tlow=tlev(i)
      enddo
      da=1
      da=da/1000
      xlev(ilev)=xlev(ilev)+da
      nlev=ilev
   endif
   call repoz(nin)
   nscr=10
   nsc=0
   if (nin.lt.0) nscr=-nscr
   call openz(nscr,1)
   nwscr=npage*2+50

   !--read the first two records to verify that this is a legal tape
   !--set the mf35 flag and determine the number of groups for scr
   allocate(scr(17))
   call tpidio(nin,0,0,scr,nb,nw)
   call contio(nin,0,0,scr,nb,nw)
   if (mfh.ne.1.or.mth.ne.451) call error('covr','illegal input tape',' ')
   mfflg=nint(scr(5))
   if (mfflg.eq.-11.or.mfflg.eq.-14) then
      mf35=mf3
   else if (mfflg.eq.-12) then
      mf35=mf5
   else
      call error('covr','illegal errorr output tape for covr',' ')
   endif
   call contio(nin,0,0,scr,nb,nw)
   nwscr=l1h+7
   if (nwscr.lt.17) nwscr=17
   deallocate(scr)
   allocate(scr(nwscr))
   call repoz(nin)
   call openz(nplot,1)
   if (nplot.ne.0) write(nplot,'(''1 2 .22'',i3,''/'')') icolor

   !--loop over cases
   do 130 n=1,ncase
   mat=imat(n)

   ! copy this mat from nin to nscr
   call repoz(nin)
   call repoz(nscr)
   call tpidio(nin,0,nscr,scr,nb,nw)
   call finds(mat,0,0,nin)
   call contio(nin,0,nscr,scr,nb,nw)
   iverf=l1h
   iza=nint(scr(1))
   iza1=iza
   call tomend(nin,0,nscr,scr)
   allocate(imtx(max))
   allocate(imtx1(max))
   allocate(imatx1(max))
   nexp=1
   imtx(1)=imt(n)
   imatx1(1)=imat1(n)
   imtx1(1)=imt1(n)
   if (imat1(n).ne.imat(n).and.imat1(n).gt.0) then
      ! if needed, also copy mat1 from nin to nscr
      call finds(imat1(n),0,0,nin)
      call contio(nin,0,nscr,scr,nb,nw)
      iza1=nint(scr(1))
      call tomend(nin,0,nscr,scr)
   endif
   call atend(0,nscr)
   call repoz(nscr)

   !--expand the mt-mt1 list
   if (imt(n).le.0) call expndo(nscr)

   !--loop over mt-mt1 pairs
   do 191 ne=1,nexp
   mt=imtx(ne)
   mat1=imatx1(ne)
   if (mat1.le.0) mat1=mat
   mt1=imtx1(ne)
   if (mt1.eq.0) mt1=mt
   write(nsyso,'(/&
     &'' reaction-pairs processed '',i4,2x,i3,3x,i4,2x,i3)')&
     mat,mt,mat1,mt1

   !--read through input errorr file, calculating relative standard
   !--deviations and correlation coefficients
   call corr(nscr,mat,mt,mat1,mt1,izap)
   if (nout.gt.0) go to 210
   if (ismall.gt.0) go to 155
  150 continue
   iomit=iomit+1
   ! document null and small matrices on nscr1, then skip plot
   write(nscr1,'(4i7,3x,a5,44x)') mat,mt,mat1,mt1,hreas(izero+1)
   go to 190
  155 continue
   nwcf=ixmax*ixmax
   nwig=2*(2*(ixmax+1)+ntics3)
   allocate(xig(nwig))
   nwy=nwig
   if (nwig.lt.nwcf) nwy=nwcf
   allocate(yig(nwy))
   ! cf storage is in the middle.  move it to the top
   do i=1,nwcf
      yig(i)=cf(i)
   enddo
   deallocate(cf)
   call truncg(epmin,x,y,xx,xy,ixmin,ixmax)
   ! cf storage goes into highest part
   allocate(cf(nwcf))
   do i=1,nwcf
      cf(i)=yig(i)
      yig(i)=0
   enddo
   if (izero.eq.0) go to 190
   ixpn=ixmax-ixmin+1
   ishade=0
   call plotit(x(ixmin:),y(ixmin:),xig,yig,ixpn,ixmax,&
     rsdx(ixmin:),rsdy(ixmin:),xlev,noleg,ne,izap)
   if (ishade.eq.0) izero=2
   if (ishade.eq.0) go to 150
   if (nfig-nstart+1.lt.nfigmx) go to 190
   write(strng,'(''mat='',i4,'' mt='',i3,'' mat1='',i4,'' mt1='',i3,&
     &'' nfig='',i3)') mat,mt,mat1,mt1,nfig
   call mess('covr','have plotted all that fit.',strng)
   go to 310

   !--process library option
  210 continue
   deallocate(y)
   deallocate(xy)
   if (izero.ne.0) go to 220
   write(nsyso,'(/&
     &3x,''null covariance matrix.  output suppressed.'')')
   go to 190
  220 continue
   if (ne.le.1) then
      if (matype.eq.3) write(hlibid,'(a6,''-a-'',i3)') hinpid,ixmax
      if (matype.eq.4) write(hlibid,'(a6,''-b-'',i3)') hinpid,ixmax
   endif
   nrow=ixmax+1
   ncol=1
   nvf=10
   ncf=3
   itype=0
   ! for first sub-case of first case, write the group structure
   if (n.eq.1.and.ne.eq.1) call press(0,nout,x,nrow,ncol)
   nrow=ixmax
   if (mat1.eq.mat.and.mt1.eq.mt) then
      itype=1
      call press(0,nout,xx,ixmax,1)
      itype=2
      call press(0,nout,rsdx,ixmax,1)
   endif
   ncol=nrow
   if (mat1.eq.mat.and.mt1.eq.mt) ncol=0
   nvf=7
   if (matype.eq.3) nvf=10
   ncf=6
   if (ixmax.le.100) ncf=5
   if (ixmax.le.30) ncf=4
   itype=matype
   call press(0,nout,cf,2,ixmax)
  190 continue
   if (allocated(x))deallocate(x)
   if (allocated(y))deallocate(y)
   if (allocated(rsdx)) deallocate(rsdx)
   if (allocated(rsdy)) deallocate(rsdy)
   if (allocated(xig)) deallocate(xig)
   if (allocated(yig)) deallocate(yig)
   if (allocated(xx)) deallocate(xx)
   if (allocated(xy)) deallocate(xy)
   if (allocated(cf)) deallocate(cf)
  191 continue
   deallocate(imtx)
   deallocate(imtx1)
   deallocate(imatx1)
  130 continue
   if (nout.eq.0) go to 310
   nscr1=-nscr1
   nscr2=-nscr2
   go to 330

   !--plot the table of contents
  310 continue
   write(nplot,'(''99/'')')

   !--copy the statistics file to output
   if (iomit.ne.0) then
      write(nsyso,'(/)')
      call copyst(nscr1,nsyso)
   endif

   !--finished
  330 continue
   if (allocated(scr)) deallocate(scr)
   if (allocated(xlev)) deallocate(xlev)
   call repoz(nin)
   call repoz(nout)
   call closz(nin)
   call closz(nout)
   call closz(nplot)
   call closz(nscr)
   call closz(nscr1)
   call closz(nscr2)
   call timer(sec)
   write(nsyso,'(69x,f8.1,''s''/&
     &1x,7(''**********''),''****'')') sec
   return
   end subroutine covr

   subroutine expndo(nin)
   !--------------------------------------------------------------------
   ! Expand the MT-MT1 list to include all possible combinations
   ! in ENDF order.  Obtain the set of MT-numbers present by
   ! examining the cross section file on unit nin.
   !--------------------------------------------------------------------
   use util ! provides error,mess,repoz
   use endf ! provides endf routines and variables
   ! externals
   integer::nin
   ! internals
   integer::nlstm,nb,nw,nmt,l,mtn,istr,im,jm
   character(60)::strng
   integer::mstrip(3)
   integer,dimension(:),allocatable::lstm

   nlstm=ncasemx
   allocate(lstm(nlstm))
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   nmt=0
   mstrip(1)=-imtx(1)
   mstrip(2)=-imatx1(1)
   mstrip(3)=-imtx1(1)
   call finds(mat,mf35,0,nin)
  130 continue
   call listio(nin,0,0,scr,nb,nw)
   if (mfh.ne.mf35) go to 160
   l=1
   mtn=mth
   do while (nb.ne.0)
      l=l+nw
      if (l.gt.nwscr)&
        call error('expndo','storage exceeded.',' ')
      call moreio(nin,0,0,scr(l),nb,nw)
   enddo
   ! read send card
   call contio(nin,0,0,scr,nb,nw)
   do 155 istr=1,3
   if (mstrip(istr).eq.0) go to 155
   if (mtn.eq.1) go to 180
   if (mtn.eq.mstrip(istr)) go to 180
   if (mtn.eq.3.and.mstrip(istr).eq.4) go to 180
   if (mstrip(istr).lt.51.or.mstrip(istr).gt.90) go to 155
   if (mtn.gt.mstrip(istr).and.mtn.le.90) go to 180
  155 continue
   nmt=nmt+1
   lstm(nmt)=mtn
   go to 130
  160 continue
   nexp=0
   do im=1,nmt
      do jm=im,nmt
         nexp=nexp+1
         if (nexp.gt.max) then
            call error('expndo','storage exceeded.',' ')
         endif
         imtx(nexp)=lstm(im)
         imatx1(nexp)=0
         imtx1(nexp)=lstm(jm)
      enddo
   enddo
   deallocate(lstm)
   return
  180 continue
   write(strng,'(''mt='',i3,'' stripped from list.'')') mtn
   call mess('expndo',strng,' ')
   go to 130
   end subroutine expndo

   subroutine corr(nin,mat,mt,mat1,mt1,izap)
   !--------------------------------------------------------------------
   ! Convert relative covariances to standard deviations
   ! and correlations.
   !--------------------------------------------------------------------
   use util ! provides error,repoz
   ! externals
   integer::nin,mat,mt,mat1,mt1,izap
   ! internals
   integer::icall,ixtest,ixp,i,ig,ii,j,nswap
   real(kr)::epmn,xcycle
   character(60)::strng
   real(kr),parameter::zp4=0.4e0_kr
   real(kr),parameter::xsize=4.25e0_kr
   real(kr),parameter::epmn0=0.499999e-4_kr
   real(kr),parameter::zero=0

   ismall=0

   !--for cross-reaction matrices, check to see if the matrix
   !--is null before proceeding with the correlation calculation
   icall=0
   if (mat.ne.mat1.or.mt.ne.mt1) then
      call covard(nin,mat,mt,mat1,mt1,izap,icall)
      icall=1
      if (izero.eq.0) return
   endif

  110 continue
   call covard(nin,mat1,mt1,mat1,mt1,izap,icall)
   ixtest=ixmax
   if (icall.eq.0) icall=1
   allocate(rsdx(ixmax))
   allocate(rsdy(ixmax))
   icall=iabs(icall)
   go to (130,165,190),icall

  130 continue
   ixp=ixmax+1
   do i=1,ixp
      x(i)=y(i)
   enddo
   if (nout.le.0) then
      epmn=epmn0
      xcycle=0
      do while (xcycle.lt.zp4)
         epmn=epmn*2
         xcycle=xsize/log10(x(1+ixmax)/epmn)
      enddo
      ! have found epmin value that satifies criterion
      if (epmn.gt.epmin) then
         epmin=epmn
         write(strng,&
           '(''epmin reset to'',1p,e12.4,'', xcycle='',1p,e12.4)')&
           epmin,xcycle
         call mess('corr',strng,' ')
      endif
      do i=1,ixmax
         if (cf(ixmax*(i-1)+i).gt.0) then
            rsdy(i)=sqrt(cf(ixmax*(i-1)+i))
         else
            rsdy(i)=0
         endif
         rsdx(i)=rsdy(i)
      enddo
   else
      call repoz(-nscr2)
      do i=1,ixmax
         read(nscr2) ig,(cf(ii),ii=1,ixmax)
         rsdy(i)=sqrt(cf(i))
         rsdx(i)=rsdy(i)
      enddo
   endif
   if (mat.eq.mat1.and.mt.eq.mt1) go to 190
   icall=icall+1
   call covard(nin,mat,mt,mat,mt,izap,icall)
   if (icall.lt.0) go to 110

  165 continue
   if (nout.le.0) then
      do i=1,ixmax
         rsdx(i)=sqrt(cf(ixmax*(i-1)+i))
      enddo
   else
      call repoz(-nscr2)
      do i=1,ixmax
         read(nscr2) ig,(cf(ii),ii=1,ixmax)
         rsdx(i)=sqrt(cf(i))
      enddo
   endif
   icall=icall+1
   call covard(nin,mat,mt,mat1,mt1,izap,icall)
   if (icall.lt.0) go to 110

  190 continue
   if (izero.ne.0) then
      if (nout.le.0) then
         do i=1,ixmax
            do j=1,ixmax
               if (cf(ixmax*(i-1)+j).ne.zero.and.&
                 rsdx(i)*rsdy(j).ne.zero) then
                  cf(ixmax*(i-1)+j)=cf(ixmax*(i-1)+j)/&
                    (rsdx(i)*rsdy(j))
                  ! test for the presence of any significant (i.e.,
                  ! plotable) values of the correlation coefficient
                  if (abs(cf(ixmax*(i-1)+j)).ge.xlev(1)) ismall=1
               else
                  cf(ixmax*(i-1)+j)=0
               endif
            enddo
         enddo
      else
         call repoz(-nscr2)
         call repoz(-nscr1)
         if (matype.ne.3) then
            do i=1,ixmax
               read(nscr2) ig,(cf(ii),ii=1,ixmax)
               do j=1,ixmax
                  if (cf(j).ne.zero.and.&
                    rsdx(i)*rsdy(j).ne.zero) then
                     cf(j)=cf(j)/(rsdx(i)*rsdy(j))
                  else
                     cf(j)=0
                  endif
               enddo
               write(nscr1) ig,(cf(ii),ii=1,ixmax)
            enddo
            call repoz(-nscr2)
         else
            nswap=nscr1
            nscr1=nscr2
            nscr2=nswap
         endif
      endif
   endif

   ! finished
   if (ixmax.ne.ixtest)&
     call error('corr','group structures do not agree.',' ')
   return
   end subroutine corr

   subroutine covard(nin,mat,mt,mat1,mt1,izap,icall)
   !--------------------------------------------------------------------
   ! Read covariance data in the ENDF-like format output by
   ! njoy/errorr and transform it into engineering format,
   ! that is, with full matrices (zeroes included).
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use util ! provides repoz,finds,error,mess
   use endf ! provides ENDF routines and variables
   ! externals
   integer::nin,mat,mt,mat1,mt1,izap,icall
   ! internals
   integer::nb,nw,l,i,k,nmt,imt,k1,mat1x,mtx,kgp,kl,lgp1
   integer::j1,j2,kj,j,ir,ipflag,ind,kk,n,mf3x,ixp,ixpo
   character(60)::strng,strng2
   integer::igprnt=0
   real(kr),parameter::zero=0
   save ixpo,igprnt

   if (icall.le.1) ixpo=0
   call repoz(nin)
   call tpidio(nin,0,0,scr,nb,nw)
   call finds(mat,1,451,nin)
   if (nout.gt.0) call repoz(-nscr1)
   if (nout.gt.0) call repoz(-nscr2)

   !--read group structure
   call contio(nin,0,0,scr,nb,nw)
   call listio(nin,0,0,scr,nb,nw)
   ixmax=l1h
   ixp=n1h
   if (icall.eq.0) go to 120
   if (icall.eq.1) go to 130
   if (ixpo.eq.0.and.ixp.eq.igprnt) go to 120
   if (ixp.le.ixpo) go to 130
   deallocate(x)
   deallocate(y)
   deallocate(cf)
   deallocate(xx)
   deallocate(xy)
   icall=-icall
  120 continue
   allocate(x(ixp))
   allocate(y(ixp))
   allocate(xx(ixmax))
   allocate(xy(ixmax))
   nwcf=ixmax*(ixmax+3)
   if (nout.gt.0) nwcf=ixmax*2
   allocate(cf(nwcf))
  130 continue
   l=1
   do while (nb.ne.0)
      l=l+nw
      if (l.gt.nwscr)&
        call error('covard','storage exceeded.',' ')
      call moreio(nin,0,0,scr(l),nb,nw)
   enddo
   do i=1,ixp
      y(i)=scr(i+6)
   enddo
   if (igprnt.ne.ixp) write(nsyso,'(/&
     &'' group structure''/'' ---------------''/&
     &(1x,1p,6e12.4))') (y(i),i=1,ixp)
   igprnt=ixp
   ixpo=ixp

   !--read cross sections for mt and mt1
   k=1
   call finds(mat,mf35,mt,nin)
  200 continue
   call listio(nin,0,0,scr,nb,nw)
   if (mf35.eq.5) einc=scr(2)
   l=1
   do while (nb.ne.0)
      l=l+nw
      if (l.gt.nwscr)&
        call error('covard','storage exceeded.',' ')
      call moreio(nin,0,0,scr(l),nb,nw)
   enddo
   if (k.gt.1) go to 240
   do i=1,ixmax
      xx(i)=scr(i+6)
   enddo
   if (mth.ne.mt1) go to 260
  240 continue
   do i=1,ixmax
      xy(i)=scr(i+6)
   enddo
  260 continue
   if (k.gt.1) go to 270
   if (mat.eq.mat1.and.mt.eq.mt1) go to 270
   call finds(mat1,mf35,mt1,nin)
   k=k+1
   go to 200
  270 continue
   do i=1,nwcf
      cf(i)=0
   enddo

   !--read covariances.
   mf3x=33
   if (mfflg.eq.-14) mf3x=40
   if (mf35.eq.5) mf3x=35
   if (mt.eq.251) mf3x=34
   call finds(mat,mf3x,mt,nin)
   call contio(nin,0,0,scr,nb,nw)
   nmt=n2h
   if (nmt.eq.0) go to 450
   imt=0
   k1=0
   ! search for desired subsection of this mt
   do
      imt=imt+1
      if (imt.gt.nmt) then
         write(strng,'(''did not find file '',i2,'' subsection'')')mf3x
         write(strng2,'(''for mt='',i3,'' mat='',i4)') mt1,mat1
         call error('covard',strng,strng2)
      endif
      izap=0
      if (mfflg.eq.-14) then
         if (mat.eq.mat1.and.mt.eq.mt1) then
            izap=nint(c2h)
         endif
      endif
      call contio(nin,0,0,scr,nb,nw)
      mat1x=l1h
      if (mf3x.eq.34) mat1x=math
      if (mat1x.eq.0) mat1x=math
      mtx=l2h
      if (mf3x.eq.34) mtx=l1h
      kgp=n2h
      if (mat1x.eq.mat1.and.mtx.eq.mt1) exit
      do
         call listio(nin,0,0,scr,nb,nw)
         kl=n2h
         do while (nb.ne.0)
            call moreio(nin,0,0,scr,nb,nw)
         enddo
         if (kl.ge.kgp) exit
      enddo
   enddo
   do
      call listio(nin,0,0,scr,nb,nw)
      lgp1=l2h
      kl=n2h
      l=1
      do while (nb.ne.0)
         l=l+nw
         if (l.gt.nwscr)&
           call error('covard','storage exceeded.',' ')
         call moreio(nin,0,0,scr(l),nb,nw)
      enddo
      j1=7
      j2=l+nw-1
      if (nout.le.0) then
         kj=0
         do j=j1,j2
            kj=kj+1
            cf(ixmax*(kl-1)+lgp1-1+kj)=scr(j)
         enddo
      else
         nw=j2-j1+1
         write(nscr1) kl,lgp1,nw,(scr(j),j=j1,j2)
         if (k1.eq.0) k1=kl
      endif
      if (kl.ge.kgp) exit
   enddo
   if (nout.eq.0) go to 410
   call repoz(-nscr1)
   kl=k1
   ir=0

   !--eliminate spurious covariances in regions of zero xsec,
   !--convert absolute covariances to relative,
   !--and test for a null covariance matrix
  410 continue
   ipflag=0
   izero=0
   do 420 k=1,ixmax
   if (nout.eq.0) ind=ixmax*(k-1)
   if (nout.eq.0) go to 425
   ind=0
   do kk=1,ixmax
      cf(kk)=0
   enddo
   if (k.lt.kl) go to 425
   if (ir.eq.0) read(nscr1) kl,lgp1,nw,(scr(i),i=1,nw)
   ir=ir+1
   if (k.lt.kl) go to 425
   ir=0
   do kk=1,nw
      cf(lgp1+kk-1)=scr(kk)
   enddo
  425 continue
   do 428 n=1,ixmax
   if (xx(k)*xy(n).ne.zero) go to 430
   if (cf(ind+n).eq.zero) go to 428
   cf(ind+n)=0
   ipflag=ipflag+1
   if (ipflag.eq.1) then
      write(strng,&
        '(''mt='',i3,'' ig='',i3,'' mt1='',i3,'' ig1='',i3)')&
        mt,k,mt1,n
      call mess('covard',&
        'due to zero xsec, covariance zeroed for',strng)
   endif
   if (ipflag.eq.2) call mess('covard','additional warnings suppressed',' ')
   go to 428
  430 continue
   if (irelco.ne.1) cf(ind+n)=cf(ind+n)/(xx(k)*xy(n))
   if (cf(ind+n).ne.zero) izero=1
  428 continue
   if (nout.ne.0) then
      write(nscr2) k,(cf(kk),kk=1,ixmax)
   endif
  420 continue
  450 return
   end subroutine covard

   subroutine truncg(epmin,x,y,xx,xy,ixmin,ixmax)
   !--------------------------------------------------------------------
   ! Truncate the lower end of the MT and MT1 energy group
   ! structures to eliminate zero cross section regions from plots.
   ! Define ethresh to be the lower of either the actual threshold
   ! or 1 MeV (emin).  Then the plots will be truncated at ethresh
   ! or epmin, whichever is higher.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::ixmin,ixmax
   real(kr)::epmin,x(*),y(*),xx(*),xy(*)
   ! internals
   integer::i,iymin,ielo
   real(kr)::rlimx,rlimy,ethrx,ethry,elo
   real(kr),parameter::emin=0.9999e6_kr
   real(kr),parameter::xslim=1.e-4_kr
   real(kr),parameter::zero=0
   real(kr),parameter::ten=10.e0_kr

   !--define alternative limit as average/xslim
   rlimx=0
   rlimy=0
   ethrx=x(1)
   ethry=y(1)
   do i=2,ixmax
      rlimx=rlimx+xx(i-1)*(x(i)-x(i-1))
      rlimy=rlimy+xy(i-1)*(y(i)-y(i-1))
      if (xx(i-1).le.zero) ethrx=x(i)
      if (xy(i-1).le.zero) ethry=y(i)
   enddo
   if (rlimx.ne.zero.and.rlimy.ne.zero) then
      rlimx=xslim*rlimx/(y(ixmax)-ethry)
      rlimy=xslim*rlimy/(x(ixmax)-ethrx)
   endif
   ixmin=1
   do i=1,ixmax
      if (x(1+i).gt.epmin) then
         if (xx(i).ge.xslim.or.xx(i).ge.rlimx) go to 120
         if (x(1+i).gt.emin) go to 120
      endif
      ixmin=i+1
   enddo
   call error('truncg','bad data.',' ')
  120 continue
   iymin=1
   do i=1,ixmax
      if (y(1+i).gt.epmin) then
         if (xy(i).ge.xslim.or.xy(i).ge.rlimy) go to 140
         if (y(1+i).gt.emin) go to 140
      endif
      iymin=i+1
   enddo
   call error('truncg','bad data.',' ')
  140 continue
   if (iymin.lt.ixmin) ixmin=iymin

   ! limit bin width of thermal groupr to one decade
   if (ixmin.eq.1) then
      if (10*x(1).lt.x(2).and.10*y(1).lt.y(2)) then
         elo=log10(x(2)/10)
         ielo=nint(elo)
         if (x(1).lt.ten**ielo) x(1)=ten**ielo
         elo=log10(y(2)/10)
         ielo=nint(elo)
         if (y(1).lt.ten**ielo) y(1)=ten**ielo
      endif
   endif
   if (x(ixmin).lt.epmin) x(ixmin)=epmin
   if (y(ixmin).lt.epmin) y(ixmin)=epmin

   ! finished
   return
   end subroutine truncg

   subroutine plotit(x,y,xig,yig,ixn,ixmax,rsdx,rsdy,xlev,noleg,ne,izap)
   !--------------------------------------------------------------------
   ! Make desired plots.
   !--------------------------------------------------------------------
   ! externals
   integer::ixn,ixmax,noleg,ne,izap
   real(kr)::x(*),y(*),xig(*),yig(*),rsdx(*),rsdy(*),xlev(*)
   ! internals
   integer::i,ii,j,jj,npts,mtflg,iwarn
   real(kr)::xmin,xmax,ymin,ymax,t,t1,xpos,ypos,wa,yyy
   real(kr)::ydec,yymin,yrange,de,xmin1
   character(80)::strng
   character(1)::qu=''''
   real(kr),parameter::two=2
   real(kr),parameter::five=5
   real(kr),parameter::ten=10
   real(kr),parameter::dx1=1.e0_kr
   real(kr),parameter::dy1=.75e0_kr
   real(kr),parameter::dx2=-.25e0_kr
   real(kr),parameter::dy2=.5e0_kr
   real(kr),parameter::dx3=-.75e0_kr
   real(kr),parameter::dy3=1.9e0_kr
   real(kr),parameter::dy4=.75e0_kr
   real(kr),parameter::yyym=59.999e0_kr
   real(kr),parameter::xsize=5.00e0_kr
   real(kr),parameter::ysize=3.38e0_kr
   real(kr),parameter::yrtest=10
   real(kr),parameter::ylogmn=0.1001e0_kr
   real(kr),parameter::ylogmx=99.9e0_kr
   real(kr),parameter::zero=0

   !--check if mat=mat1 and mt=mt1
   !--if true, move nu-bar, few-group cross section or spectrum/eV into rsdx
   mtflg=0
   if (mat.eq.mat1.and.mt.eq.mt1) then
      mtflg=1
      if (mf35.ne.5) then
         do i=1,ixn
            rsdx(i)=xx(i+(ixmax-ixn))
         enddo
      else
         do i=1,ixn
            de=y(i+1)-y(i)
            rsdx(i)=xx(i+(ixmax-ixn))/de
         enddo
      endif
   endif

   !--determine first rsdx array index with non-zero data
   ii=1
   do while (ii.le.ixn.and.rsdx(ii).le.zero)
      ii=ii+1
   enddo
   !if (ii.gt.1) ii=ii-1

   !--determine first rsdy array index with non-zero data
   jj=1
   do while (jj.le.ixn.and.rsdy(jj).le.zero)
      jj=jj+1
   enddo
   !if (jj.gt.1) jj=jj-1

   !--only plot from higher energy group
   !  (makes correlation matrix appear square)
   if (jj.gt.ii)ii=jj
   j=0
   xig(1)=x(ii)
   yig(1)=0
   ymin=1.0e20_kr
   ymax=-1.0e20_kr
   do i=ii,ixn
      j=j+1
      xig(2*j)=x(i)
      yig(2*j)=rsdx(i)
      if (rsdx(i).gt.zero.and.rsdx(i).lt.ymin) ymin=rsdx(i)
      if (rsdx(i).gt.ymax) ymax=rsdx(i)
      xig(2*j+1)=x(i+1)
      yig(2*j+1)=rsdx(i)
   enddo
   if (ymin.ne.zero) then
      yrange=ymax/ymin
   else
      yrange=0
   endif
   ydec=log10(ymin)
   if (ydec.lt.zero) ydec=ydec-1
   yymin=ten**int(ydec)
   npts=2*j+2
   xig(npts)=x(ixn+1)
   yig(npts)=0
   xmin=xig(1)
   xmin1=xmin
   t=log10(xmin)
   if (t.lt.zero) then
      t1=t-0.99999e0_kr
   else
      t1=t+0.00001e0_kr
   endif
   i=int(t1)
   xmin=ten**i
   if (t-i.gt.log10(two)) xmin=two*ten**i
   if (t-i.gt.log10(five)) xmin=five*ten**i
   xmax=xig(npts)
   t=log10(xmax)
   t=t-t/200
   i=int(t)
   xmax=ten**(i+1)
   if (t-i.lt.log10(five)) xmax=five*ten**i
   if (t-i.lt.log10(two)) xmax=two*ten**i
   xpos=ysize-dy1
   ypos=xsize-dx1
   wa=0
   write(nplot,'(''1 0 1. 1.'',5f8.3,''/'')')&
     xpos,ypos,xsize,ysize,wa
   call smilab(iza,mat,mt,izap,mtflg,strng)
   write(nplot,'(a,a,a,''/'')') qu,strng,qu
   write(nplot,'(''/'')')
   if (yrange.gt.yrtest) then
      write(nplot,'(''4/'')')
   else
      write(nplot,'(''3/'')')
   endif
   write(nplot,'(1p,2e12.4,''/'')') xmin,xmax
   write(nplot,'(a,''.'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   write(nplot,'(a,''.'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   write(nplot,'(''0 0 0 3 2/'')')
   write(nplot,'(''0'')')

   !--Write (e,std.dev.), or if the mtflg flag is set, write
   !--(e,few-group-nu-bar) or (e,few-group-xsec), to the plot file.
   !--If plotting the relative standard deviation,
   !--restrict the axis limits to 0.1% to 100% for a log scale
   !--or less than 60% for a linear scale.
   !--For few-group data, there is no axis limitation.
   !--Also set a flag to warn the user when data are modified
   !--to fit on the plot (but don't get confused by zero data).
   iwarn=0
   do i=1,npts
      if (mtflg.eq.0) then
         yyy=100*yig(i)
         if (yrange.gt.yrtest.and.yyy.lt.ylogmn) then
            if (yyy.ne.zero) iwarn=1
            yyy=ylogmn
         endif
         if (yrange.gt.yrtest.and.yyy.gt.ylogmx) then
            iwarn=1
            yyy=ylogmx
         else if (yrange.le.yrtest.and.yyy.gt.yyym) then
            iwarn=1
            yyy=yyym
         endif
      else
         yyy=yig(i)
         if (yrange.gt.yrtest) then
            if (yyy.le.yymin) then
               if (yyy.ne.0) iwarn=1
               yyy=1.0001e0_kr*yymin
            endif
         endif
      endif
      write(nplot,'(1p,2e13.4,''/'')') xig(i),yyy
   enddo
   write(nplot,'(''/'')')

   j=0
   xig(1)=y(ii)
   yig(1)=0
   ymin=1.e20_kr
   ymax=-1.e20_kr
   do i=ii,ixn
      j=j+1
      xig(2*j)=y(i)
      yig(2*j)=rsdy(i)
      if (rsdy(i).gt.zero .and. rsdy(i).lt.ymin) ymin=rsdy(i)
      if (rsdy(i).gt.ymax) ymax=rsdy(i)
      xig(2*j+1)=y(i+1)
      yig(2*j+1)=rsdy(i)
   enddo
   if (ymin.ne.zero) then
      yrange=ymax/ymin
   else
      yrange=0
   endif
   npts=2*j+2
   xig(npts)=y(ixn+1)
   yig(npts)=0
   ymin=xig(1)
   ! set uncertainty plot lower limit to match the cross
   ! section plot so get a square correlation matrix.
   if (mtflg.eq.1) ymin=xmin1
   t=log10(ymin)
   if (t.lt.zero) then
      t1=t-0.99999e0_kr
   else
      t1=t+0.00001e0_kr
   endif
   i=int(t1)
   if (t-i.gt.zero) ymin=ten**i
   if (t-i.gt.log10(two)) ymin=two*ten**i
   if (t-i.gt.log10(five)) ymin=five*ten**i
   ymax=xig(npts)
   t=log10(ymax)
   t=t-t/200
   i=int(t)
   ymax=ten**(i+1)
   if (t-i.lt.log10(five)) ymax=five*ten**i
   if (t-i.lt.log10(two)) ymax=two*ten**i
   xpos=ysize+dy2
   ypos=dx2
   wa=90
   write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')&
     xpos,ypos,xsize,ysize,wa
   call smilab(iza1,mat1,mt1,izap,0,strng)
   write(nplot,'(a,a,a,''/'')') qu,strng,qu
   write(nplot,'(''/'')')
   if (yrange.gt.yrtest) then
      write(nplot,'(''4/'')')
   else
      write(nplot,'(''3/'')')
   endif
   write(nplot,'(1p,2e12.4,''/'')') ymin,ymax
   write(nplot,'(a,''.'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   write(nplot,'(a,''.'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   write(nplot,'(''0 0 0 3 2/'')')
   write(nplot,'(''0'')')

   !--Write (e, std.dev.) to the plot file.  Restrict the axis limits
   !--to 0.1% to 100% for a log scale or less than 60% for a linear scale.
   do i=1,npts
      yyy=100*yig(i)
      if (yrange.gt.yrtest.and.yyy.lt.ylogmn) then
         if (yyy.ne.zero) iwarn=1
         yyy=ylogmn
      endif
      if (yrange.gt.yrtest.and.yyy.gt.ylogmx) then
         iwarn=1
         yyy=ylogmx
      else if (yrange.le.yrtest.and.yyy.gt.yyym) then
         iwarn=1
         yyy=yyym
      endif
      write(nplot,'(1p,2e13.4,''/'')') xig(i),yyy
   enddo
   write(nplot,'(''/'')')

   !--write the text describing the axes
   xpos=dy3
   ypos=xsize+dx3
   wa=90
   write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')&
     xpos,ypos,ysize,1.,wa
   if (mtflg.eq.0) then
      write(nplot,'(a,''#H.75<o>rdinate scale is %'',a,''/'')') qu,qu
      write(nplot,'(a,''#H.75<>relative standard deviation.'',a,''/'')') qu,qu
   else if (mt.eq.251) then
      write(nplot,'(a,''#H.75<o>rdinate scales are % relative'',a,''/'')') qu,qu
      write(nplot,'(a,''#H.75<>standard deviation and mu-bar.'',a,''/'')') qu,qu
   else if (mt.ge.452.and.mt.le.456) then
      write(nplot,'(a,''#H.75<o>rdinate scales are % relative'',a,''/'')') qu,qu
      write(nplot,'(a,''#H.75<>standard deviation and nu-bar.'',a,''/'')') qu,qu
   else if (mf35.eq.5) then
      write(nplot,'(a,''#H.75<o>rdinate scales are % standard'',a,''/'')') qu,qu
      write(nplot,'(a,''#H.75<>deviation and spectrum/eV.'',a,''/'')') qu,qu
   else
      write(nplot,'(a,''#H.75<o>rdinate scales are % relative'',a,''/'')') qu,qu
      write(nplot,'(a,''#H.75<>standard deviation and barns.'',a,''/'')') qu,qu
   endif
   write(nplot,'(''0/'')')
   xpos=xpos+dy4
   write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')&
     xpos,ypos,ysize,1.,wa
   write(nplot,'(a,''#H.75<a>bscissa scales are energy (e<v>).'',&
     &a,''/'')') qu,qu
   write(nplot,'(''/'')')
   if (iwarn.ne.0) then
       xpos=xpos+0.45e0_kr
       write(nplot,'(''0/'')')
       write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')xpos,ypos,ysize,1.,wa
       write(nplot,'(a,''#H.75<w>arning:  some uncertainty'',a,''/'')') qu,qu
       write(nplot,'(a,''#H.75<>data were suppressed.'',a,''/'')') qu,qu
   endif
   write(nplot,'(''0/'')')

   !--plot the correlation matrix as a shaded contour plot
   call matshd(xig,yig,x,y,ixn,xmin,xmax,ymin,ymax)

   if (allocated(xx)) deallocate(xx)
   if (allocated(xy)) deallocate(xy)

   return
   end subroutine plotit

   subroutine matshd(xig,yig,x,y,ixnow,xmin,xmax,ymin,ymax)
   !--------------------------------------------------------------------
   ! Define regions with similar correlations
   ! and shade them accordingly
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::ixnow
   real(kr)::xig(*),yig(*),x(*),y(*)
   real(kr)::xmin,xmax,ymin,ymax,cof
   ! internals
   integer::ipat,inext,jnext,nwlcf,ii,i,jj,j
   integer::il,jl,ilevel,jfirst,jlast,i1,i2,istart,ilim
   integer::iloc,ilast,ifirst,iloop,jpat,none,ntwo,ixmx,jxmx
   real(kr)::xpos,ypos,wa,tlow,thi,cofm,cofa
   character(60)::strn1,strng
   character(1)::qu=''''
   integer,dimension(:),allocatable::ixmip,ixmap,ilcf
   real(kr),parameter::xsize=5.0e0_kr
   real(kr),parameter::ysize=3.38e0_kr
   real(kr),parameter::dx1=-.25e0_kr
   real(kr),parameter::dy1=-.75e0_kr
   real(kr),parameter::dx2=.75e0_kr
   real(kr),parameter::dy2=.60e0_kr
   real(kr),parameter::dx3=.625e0_kr
   real(kr),parameter::dy3=1.75e0_kr
   real(kr),parameter::dy4=1.375e0_kr
   real(kr),parameter::eps=1.e-6_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::two=2

   !--initialize pattern search.
   ipat=0
   inext=0
   jnext=1
   allocate(ixmip(ixnow))
   allocate(ixmap(ixnow))
   nwlcf=ixnow*ixnow
   allocate(ilcf(nwlcf))
   ii=0
   none=0
   ntwo=0
   cofm=0
   do i=ixmin,ixmax
      ii=ii+1
      jj=0
      do j=ixmin,ixmax
         jj=jj+1
         cof=cf(ixmax*(i-1)+j)
         cofa=abs(cof)-eps
         if (cofa.gt.abs(cofm)) then
            cofm=cof
            ixmx=i
            jxmx=j
         endif
         if (cofa.gt.two) then
            ntwo=ntwo+1
         else if (cofa.gt.one) then
            none=none+1
         endif
         if (cof.gt. one) cof= one
         if (cof.lt.-one) cof=-one
         ilcf(ixnow*(ii-1)+jj)=level(cof,xlev,nlev)
      enddo
   enddo
   if (none.gt.0) then
      write(strn1,'(''processing of mat/mt'',i5,''/'',i3,&
        &'' vs. mat1/mt1'',i5,''/'',i3)') mat,mt,mat1,mt1
      write(strng,'(''largest coefficient='',1p,e13.5&
        &,'' at index'',2i4)') cofm,ixmx,jxmx
      call mess('matshd',strn1,strng)
      write(strng,'(i4,'' coefficients > 1'')') none
      call mess('matshd',strng,'reset and continue.')
   endif
   if (ntwo.gt.0) then
      write(strng,'(i4,'' coefficients > 2'')') ntwo
      call  mess('matshd',strng,'reset and continue')
   endif
   deallocate(cf)

   !--loop over patterns
  200 continue
   ipat=ipat+1
   if (ipat.gt.99999) call error('matshd','ipat gt 99999.',' ')

   !--find next un-allocated square
  210 continue
   inext=inext+1
   if (inext.gt.ixnow) jnext=jnext+1
   if (jnext.gt.ixnow) go to 400
   if (inext.gt.ixnow) inext=1
   if (ilcf(ixnow*(inext-1)+jnext).eq.0) go to 210
   il=inext
   jl=jnext
   ilevel=ilcf(ixnow*(il-1)+jl)
   ilcf(ixnow*(il-1)+jl)=0

   !--find the extent of this pattern in its first row
   ixmip(jl)=il
   ixmap(jl)=il
   jfirst=jl
   jlast=jl
  220 continue
   il=il+1
   if (il.gt.ixnow) go to 230
   if (ilcf(ixnow*(il-1)+jl).ne.ilevel) go to 230
   ilcf(ixnow*(il-1)+jl)=0
   ixmap(jl)=il
   inext=il
   go to 220
  230 continue
   jl=jl+1
   if (jl.gt.ixnow) go to 290
   i1=ixmip(jl-1)
   i2=ixmap(jl-1)
   do 240 i=i1,i2
   if (ilcf(ixnow*(i-1)+jl).ne.ilevel) go to 240

   !--starter square found for this row
   jlast=jl
   ixmip(jl)=i
   ixmap(jl)=i
   istart=i
   ilcf(ixnow*(i-1)+jl)=0
   go to 250
  240 continue

   !--no starter is found.  this is the end of current pattern.
   go to 290

   !--find maximum left extent of pattern in this row
  250 continue
   if (istart.ne.1) then
      ilim=istart-1
      do i=1,ilim
         if (ilcf(ixnow*(istart-i-1)+jl).ne.ilevel) exit
         ixmip(jl)=istart-i
         ilcf(ixnow*(istart-i-1)+jl)=0
      enddo
   endif

   !--now find maximum right extent of pattern in this row
   if (istart.ne.ixnow) then
      ilim=ixnow-istart
      do i=1,ilim
         if (ilcf(ixnow*(istart+i-1)+jl).ne.ilevel) exit
         ixmap(jl)=istart+i
         ilcf(ixnow*(istart+i-1)+jl)=0
      enddo
   endif
   go to 230

   !--determine the boundary curve (xig,yig) for this pattern
  290 continue
   iloc=0
   jl=jfirst-1
   do
      jl=jl+1
      iloc=iloc+1
      if (iloc.gt.nwig) call error('matshd','storage exceeded.',' ')
      ilast=ixmap(jl)
      xig(iloc)=x(ilast+1)
      yig(iloc)=y(jl)
      iloc=iloc+1
      if (iloc.gt.nwig) call error('matshd','storage exceeded.',' ')
      xig(iloc)=x(ilast+1)
      yig(iloc)=y(jl+1)
      if (jl.ge.jlast) exit
   enddo
   jl=jlast+1
   do
      jl=jl-1
      iloc=iloc+1
      if (iloc.gt.nwig) call error('matshd','storage exceeded.',' ')
      ifirst=ixmip(jl)
      xig(iloc)=x(ifirst)
      yig(iloc)=y(jl+1)
      iloc=iloc+1
      if (iloc.gt.nwig) call error('matshd','storage exceeded.',' ')
      xig(iloc)=x(ifirst)
      yig(iloc)=y(jl)
      if (jl.le.jfirst) exit
   enddo

   !--finished with pattern contour logic
   !--ready to draw the pattern
   if (ipat.eq.1) then
      xpos=ysize+dy1
      ypos=dx1
      wa=0
      write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')&
        xpos,ypos,xsize,xsize,wa
      write(nplot,'(''/'')')
      write(nplot,'(''/'')')
      write(nplot,'(''4 0 0/'')')
      write(nplot,'(1p,2e12.4,''/'')') xmin,xmax
      write(nplot,'(''/'')')
      write(nplot,'(1p,2e12.4,''/'')') ymin,ymax
      write(nplot,'(''/'')')
   else
      write(nplot,'(''2/'')')
   endif
   write(nplot,'(''/'')')
   call patlev(jpat,ilevel)
   if (jpat.ne.0) ishade=ishade+1
   write(nplot,'(''0 0 0 0 0'',i3,''/'')') jpat
   write(nplot,'(''0'')')
   do i=1,iloc
      write(nplot,'(1p,2e13.4,''/'')') xig(i),yig(i)
   enddo
   write(nplot,'(''/'')')
   go to 200

   !--draw the legend for the contour plot
  400 continue
   xpos=ysize-dx2+xsize+dy2
   ypos=dx2
   wa=90
   write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')&
     xpos,ypos,xpos,1.,wa
   write(nplot,'(a,''<c>orrelation <m>atrix'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   write(nplot,'(''0/'')')
   xpos=xpos+dy3
   ypos=dx3
   write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')')&
     xpos,ypos,1.75,2.50,wa
   write(nplot,'(''/'')')
   write(nplot,'(''/'')')
   write(nplot,'(''1 0 0/'')')
   write(nplot,'(1p,3e12.4,''/'')') 0.,1.,1.
   write(nplot,'(''/'')')
   write(nplot,'(1p,3e12.4,''/'')') 0.,1.,.2
   write(nplot,'(a,''.'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   ! positive part
   tlow=0
   do ilevel=1,nlev
      call patlev(jpat,ilevel)
      ! switch orientation for positive part of legend on b-w plots
      if (icolor.eq.0.and.jpat.ne.0) jpat=jpat+10
      write(nplot,'(''0 0 0 0 0'',i3,''/'')') jpat
      write(nplot,'(''0'')')
      thi=xlev(ilevel)
      write(nplot,'(''0. '',f6.3,''/'')') tlow
      write(nplot,'(''1. '',f6.3,''/'')') tlow
      write(nplot,'(''1. '',f6.3,''/'')') thi
      write(nplot,'(''0. '',f6.3,''/'')') thi
      write(nplot,'(''0. '',f6.3,''/'')') tlow
      write(nplot,'(''/'')')
      if (ilevel.lt.nlev) write(nplot,'(''2/'')')
      if (ilevel.lt.nlev) write(nplot,'(''/'')')
      tlow=thi
   enddo
   ypos=ypos+dy4
   write(nplot,'(''-1 0 1. 1.'',5f8.3,''/'')') xpos,ypos,1.75,2.50,wa
   write(nplot,'(''/'')')
   write(nplot,'(''/'')')
   write(nplot,'(''1 0 0/'')')
   write(nplot,'(1p,3e12.4,''/'')') 0.,1.,1.
   write(nplot,'(''/'')')
   write(nplot,'(1p,3e12.4,''/'')') 0.,-1.,-.2
   write(nplot,'(a,''.'',a,''/'')') qu,qu
   write(nplot,'(''/'')')
   ! negative part
   tlow=0
   do iloop=1,nlev
      ilevel=-iloop
      call patlev(jpat,ilevel)
      write(nplot,'(''0 0 0 0 0'',i3,''/'')') jpat
      write(nplot,'(''0'')')
      thi=-xlev(iloop)
      write(nplot,'(''0. '',f6.3,''/'')') tlow
      write(nplot,'(''1. '',f6.3,''/'')') tlow
      write(nplot,'(''1. '',f6.3,''/'')') thi
      write(nplot,'(''0. '',f6.3,''/'')') thi
      write(nplot,'(''0. '',f6.3,''/'')') tlow
      write(nplot,'(''/'')')
      if (iloop.lt.nlev) write(nplot,'(''2/'')')
      if (iloop.lt.nlev) write(nplot,'(''/'')')
      tlow=thi
   enddo

   !--finished
   deallocate(ixmip)
   deallocate(ixmap)
   deallocate(ilcf)
   return
   end subroutine matshd

   integer function level(c,xlev,nlev)
   !--------------------------------------------------------------------
   ! Index the intensity c on scale xlev.
   !--------------------------------------------------------------------
   ! externals
   integer::nlev
   real(kr)::c,xlev(*)
   ! internals
   integer::i,ilev
   real(kr),parameter::zero=0

   do i=1,nlev
      ilev=i
      if (abs(c).lt.xlev(i)) exit
   enddo
   if (c.lt.zero) ilev=-ilev
   level=ilev
   return
   end function level

   subroutine patlev(jpat,ilevel)
   !--------------------------------------------------------------------
   ! Convert the correlation level to a color or b-w shading pattern
   ! following the conventions of viewr.
   !--------------------------------------------------------------------
   ! externals
   integer::jpat,ilevel
   ! internals
   real(kr)::scale,t

   jpat=0
   if (icolor.eq.0) then
      if (ilevel.gt.1) jpat=20-(nlev-ilevel)*2/ndiv
      if (ilevel.lt.-1) jpat=40-(nlev+ilevel)*2/ndiv
   else
      scale=10./(nlev-1)
      if (ilevel.gt.1) then
         t=float(nlev-ilevel)
         jpat=50-nint(scale*t)
      endif
      if (ilevel.lt.-1) then
         t=float(nlev+ilevel)
         jpat=60-nint(scale*t)
      endif
   endif
   return
   end subroutine patlev

   subroutine smilab(iza,mat,mt,izap,mtflg,strng)
   !--------------------------------------------------------------------
   ! Prepare a label for the semi-log plots.
   !--------------------------------------------------------------------
   ! externals
   integer::iza,mat,mt,izap,mtflg
   character strng*(*)
   ! internals
   integer::l1,l2,lstr3
   character str1*14,str2*36,str3*39,str4*16

   l1=6
   if (mt.ge.452.and.mt.le.456.and.mtflg.eq.0) then
       write(str1,'(''[d]n/n'')')
   else if (mt.ge.452.and.mt.le.456.and.mtflg.ne.0) then
       write(str1,'(''    ]n'')')
   else if (mt.eq.251.and.mtflg.ne.0) then
       write(str1,'(''    ]m'')')
   else if (mtflg.ne.0.and.mf35.eq.5) then
       write(str1,'(''Grp-average ]f'')')
       l1=14
   else if (mtflg.eq.0.and.mf35.eq.5) then
       write(str1,'(''[d]f/f'')')
   else if (mtflg.eq.0.and.mt.eq.251) then
          write(str1,'(''[d]m/m'')')
   else if (mtflg.ne.0) then
       write(str1,'(''    ]s'')')
   else
       write(str1,'(''[d]s/s'')')
   endif

   if (mtflg.ne.0.and.mf35.eq.5.and.einc.gt.9.999e4_kr) then
      write(str2,'(''>(<e>#LH>in#HXLX>='',f5.2,&
        &'' <m>e<v>), '')') einc/1.e6
      l2=34
   else if (mtflg.ne.0.and.mf35.eq.5.and.einc.le.9.999e4_kr) then
      write(str2,'(''>(<e>#LH>in#HXLX>= '',1pe9.2,&
        &'' e<v>), '')') einc
      l2=35
   else
      write(str2,'(''> vs. <e> for '')')
      l2=14
   endif
   call matmes(iza,mat,mt,str3,lstr3)
   if (mfflg.ne.-14) then
      strng=str1(1:l1)//str2(1:l2)//str3(1:lstr3)
   elseif (mfflg.eq.-14.and.izap.eq.0) then
      strng=str1(1:l1)//str2(1:l2)//str3(1:lstr3)//', MF40'
   else
      write(str4,'('', izap = '',i7)')izap
      strng=str1(1:l1)//str2(1:l2)//str3(1:lstr3)//str4
   endif

   return
   end subroutine smilab

   subroutine matmes(iza,mat,mt,strng,lstrng)
   !--------------------------------------------------------------------
   ! Generate a reaction name in nuclear physics notation.
   !--------------------------------------------------------------------
   ! externals
   integer::iza,mat,mt,lstrng
   character strng*(*)
   ! internals
   integer::iz,ia,iname,niso,nmat,nnam,inamel,ivl,inamer
   character lnamel*16,lnamer*8,lname*4
   character liso*12,lmat*16,lnam*20

   iz=iza/1000
   ia=iza-iz*1000
   call elem(iz,lname,iname)
   if (ia.gt.0.and.ia.lt.10) then
      write(liso,'(''#EH<'',i1,''#HXEX'')') ia
      niso=10
   else if (ia.ge.10.and.ia.lt.100) then
      write(liso,'(''#EH<'',i2,''#HXEX'')') ia
      niso=11
   else if (ia.ge.100) then
      write(liso,'(''#EH<'',i3,''#HXEX'')') ia
      niso=12
   endif
   if (ia.eq.0) then
      lmat=lname(1:iname)
      nmat=iname
   else
      lmat=liso(1:niso)//lname(1:iname)
      nmat=niso+iname
   endif
   call mtno(mt,lnamel,inamel,ivl,lnamer,inamer)
   if (ivl.le.0) then
      lnam=lnamer
      nnam=inamer
   else if (ivl.lt.10) then
      write(lnam,'(''#L.25H.75<'',i1,''#HXLX<)'')') ivl
      nnam=18
   else if (ivl.lt.100) then
      write(lnam,'(''#L.25H.75<'',i2,''#HXLX<)'')') ivl
      nnam=19
   endif
   strng=lmat(1:nmat)//lnamel(1:inamel)//lnam(1:nnam)
   lstrng=nmat+inamel+nnam
   return
   end subroutine matmes

   subroutine elem(iz,lname,iname)
   !--------------------------------------------------------------------
   ! Convert a 'Z' value into a character element name.
   !--------------------------------------------------------------------
   ! externals
   integer::iz,iname
   character(4)::lname
   ! internals
   character(4),dimension(103)::ename=(/&
     '<h> ','<h>e','<l>i','<b>e','<b> ','<c> ','<n> ','<o> ','<f> ',&
     '<n>e','<n>a','<m>g','<a>l','<s>i','<p> ','<s> ','<c>l','<a>r',&
     '<k> ','<c>a','<s>c','<t>i','<v> ','<c>r','<m>n','<f>e','<c>o',&
     '<n>i','<c>u','<z>n','<g>a','<g>e','<a>s','<s>e','<b>r','<k>r',&
     '<r>b','<s>r','<y> ','<z>r','<n>b','<m>o','<t>c','<r>u','<r>h',&
     '<p>d','<a>g','<c>d','<i>n','<s>n','<s>b','<t>e','<i> ','<x>e',&
     '<c>s','<b>a','<l>a','<c>e','<p>r','<n>d','<p>m','<s>m','<e>u',&
     '<g>d','<t>b','<d>y','<h>o','<e>r','<t>m','<y>b','<l>u','<h>f',&
     '<t>a','<w> ','<r>e','<o>s','<i>r','<p>t','<a>u','<h>g','<t>l',&
     '<p>b','<b>i','<p>o','<a>t','<r>n','<f>r','<r>a','<a>c','<t>h',&
     '<p>a','<u> ','<n>p','<p>u','<a>m','<c>m','<b>k','<c>f','<e>s',&
     '<f>m','<m>d','<n>o','<l>w'/)

   lname=ename(iz)
   iname=4
   if (lname(4:4).eq.' ') iname=3
   return
   end subroutine elem

   subroutine mtno(mt,lnamel,inamel,ivl,lnamer,inamer)
   !--------------------------------------------------------------------
   ! Convert an MT-number to a Hollerith name.
   ! At present, only those MT-numbers associated with File-31
   ! or File-33 data in ENDF/B-5 are recognized.  For other MTs,
   ! the MT-number is used in place of a reaction name.
   !--------------------------------------------------------------------
   use endf ! provides iverf
   ! externals
   integer::mt,inamel,ivl,inamer
   character(16)::lnamel
   character(8)::lnamer
   ! internals
   integer::j,jloc,idone
   integer,dimension(33)::ira1=(/&
     1,2,3,4,16,17,18,22,28,37,51,91,102,103,104,105,106,107,111,&
     207,780,781,452,455,456,25,24,32,33,41,112,115,116/)
   integer,dimension(33)::ira2=(/&
     5,4,7,6,3,3,2,5,3,3,1,6,4,2,2,2,6,4,3,5,5,5,5,5,5,6,6,3,3,4,5,3,3/)
   character(8),dimension(33)::hira=(/&
     'tot.)   ','el.)    ','nonel.) ','inel.)  ','2n)     ',&
     '3n)     ','f)      ','n]a<)   ','np)     ','4n)     ',&
     ')       ','cont.)  ',']g<)    ','p)      ','d)      ',&
     't)      ','<h>e3)  ',']a<)    ','2p      ','<h>e)   ',&
     ']a<0)   ',']a<1)   ',' ]n<)   ',' ]n<)   ',' ]n<)   ',&
     '3n]a<)  ','2n]a<)  ','nd)     ','nt)     ','2np)    ',&
     'p]a<)   ','pd)     ','pt)     '/)
   character(8)::blank='        '
   character(8)::nmea1='(n,     '
   character(8)::nmeh1='(mt     '
   character(8)::nmed1='(total  '
   character(8)::nmeb1='(n,n    '
   character(8)::nmep1='(n,p    '
   character(8)::nmez1='(n,d    '
   character(8)::nmet1='(n,t    '
   character(8)::nmex1='(n,h    '
   character(8)::nmey1='(n,a    '
   character(8)::nmee1='(delayed'
   character(8)::nmef1='(prompt '
   character(8)::nmeg1='(spectr.'
   lnamel=blank

   !--set the left name of this reaction
   if (mt.gt.50.and.mt.lt.92) then
      lnamel=nmeb1
      inamel=4
   else if (mt.ge.600.and.mt.lt.650.and.iverf.gt.5) then
      lnamel=nmep1
      inamel=4
   else if (mt.ge.650.and.mt.lt.700.and.iverf.gt.5) then
      lnamel=nmez1
      inamel=4
   else if (mt.ge.700.and.mt.lt.750.and.iverf.gt.5) then
      lnamel=nmet1
      inamel=4
   else if (mt.ge.750.and.mt.lt.800.and.iverf.gt.5) then
      lnamel=nmex1
      inamel=4
   else if (mt.ge.800.and.mt.lt.850.and.iverf.gt.5) then
      lnamel=nmey1
      inamel=4
   else if (mt.eq.452) then
      lnamel=nmed1
      inamel=6
   else if (mt.eq.455) then
      lnamel=nmee1
      inamel=8
   else if (mt.eq.456) then
      lnamel=nmef1
      inamel=7
   else if (mt.eq.251) then
      lnamel=nmeh1
      inamel=3
   else if (mt.eq.261) then
      lnamel=nmeg1
      inamel=8
   else
      lnamel=nmea1
      inamel=3
   endif
   jloc=11

   !--set the discrete level number
   ivl=-1
   if (mt.gt.50.and.mt.lt.91) ivl=mt-50
   if (mt.ge.600.and.mt.lt.650.and.iverf.gt.5) ivl=mt-600
   if (mt.ge.650.and.mt.lt.700.and.iverf.gt.5) ivl=mt-650
   if (mt.ge.700.and.mt.lt.750.and.iverf.gt.5) ivl=mt-700
   if (mt.ge.750.and.mt.lt.800.and.iverf.gt.5) ivl=mt-750
   if (mt.ge.800.and.mt.lt.850.and.iverf.gt.5) ivl=mt-800

   !--set the right name of this reaction
   j=0
   idone=0
   do while (j.lt.33.and.idone.eq.0)
      j=j+1
      jloc=j
      if (ira1(j).eq.mt) idone=1
      if (ivl.ge.0.and.ivl.le.99.and.ira1(j).eq.51) idone=1
   enddo
   if (idone.eq.0) then
      write(nmeh1(4:6),'(i3)') mt
      lnamel=nmeh1
      inamel=6
      jloc=11
   endif
   lnamer=hira(jloc)
   inamer=ira2(jloc)
   return
   end subroutine mtno

   subroutine copyst(nin,nout)
   !--------------------------------------------------------------------
   ! Copy nin to nout.
   !--------------------------------------------------------------------
   use util ! provides repoz
   ! externals
   integer::nin,nout
   ! internals
   integer::i
   character(4)::a(20)

   call repoz(nin)
  110 continue
   read(nin,'(20a4)',end=130) (a(i),i=1,20)
   write(nout,'(20a4)') (a(i),i=1,20)
   go to 110
  130 continue
   return
   end subroutine copyst

   subroutine finds(mat,mf,mt,ntape)
   !--------------------------------------------------------------------
   ! Search through the errorr tape ntape for the desired section.
   ! If MF=0, find the first occurrence of that MAT.
   ! If MT=0, find the first section of that MAT with the file MF.
   !--------------------------------------------------------------------
   use util ! provides error,repoz,skiprz
   ! externals
   integer::mat,mf,mt,ntape
   ! internals
   integer::nt,mat1,mf1,mt1,irew,i,math,mfh,mth
   character(60)::strng

   !--initialize
   nt=iabs(ntape)
   mat1=-2
   mf1=-2
   mt1=-2
   irew=0
   i=0

   !--read through ntape
  110 continue
   if (ntape.ge.0) then
      read(ntape,'(66x,i4,i2,i3)') math,mfh,mth
   else
      read(nt) math,mfh,mth
   endif
   if (math.eq.-1) go to 160
   if (math.eq.0.or.mfh.eq.0.or.mth.eq.0) go to 110
   if (mat1.ne.-2) go to 140
   mat1=math
   mf1=mfh
   mt1=mth
  140 continue
   i=i+1
   if (math.ne.mat) go to 150
   if (mf.eq.0) go to 210
   if (mfh.ne.mf) go to 150
   if (mth.eq.mt.or.mt.eq.0) go to 210
  150 continue
   if (irew.eq.0) go to 110
   if (mat1.ne.math.or.mf1.ne.mfh.or.mt1.ne.mth) go to 110
  160 continue
   if (irew.gt.0) then
      write(strng,&
        '(''mat '',i4,'' mf '',i2,'' mt '',i3,'' not on tape '',i3)')&
        mat,mf,mt,ntape
      call error('finds',strng,' ')
   endif
   irew=irew+1
   call repoz(ntape)
   go to 110

   !--finished
  210 continue
   call skiprz(ntape,-1)
   ! check to see we are at beginning of section
   if (i.gt.1) return
  220 continue
   if (ntape.ge.0) then
      read(ntape,'(66x,i4,i2,i3)') math,mfh,mth
   else
      read(nt) math,mfh,mth
   endif
   if (math.eq.1) return
   if (mat.ne.math) go to 250
   if (mf.eq.0.or.mfh.eq.mf) go to 260
  250 continue
   call skiprz(ntape,-2)
   go to 220
  260 continue
   if (mt.eq.0.or.mth.eq.mt) go to 270
   go to 220
  270 continue
   i=i+1
   go to 210
   end subroutine finds

   subroutine press(nscr,nout,xa,nr,nc)
   !--------------------------------------------------------------------
   ! Convert the data matrix xa(i,j) to the compressed "boxer" format
   ! and write the result to unit nout.
   !
   ! Definitions:
   !
   !   nrow      number of rows in matrix xa,
   !   ncol      number of columns in xa,
   !                =1 if xa is a vector.
   !                =0 if xa is a symmetric matrix, represented in the
   !                   *press* format by just the upper right triangle
   !                   (i.e., data begins at the diagonal).
   !   i         row index of matrix xa(i,j), normally the energy group
   !                of the reaction (mat,mt).
   !   j         column index of xa(i,j), normally the energy group of
   !                the reaction (mat1,mt1).
   !   xval(iv)  data value array in the *press* format (iv=1,nval).
   !   nvmax     maximum allowable value of nval.
   !   icon(ic)  control parameter array in the *press* format
   !                (ic=1,ncon).
   !   ncmax     maximum allowable value of ncon.
   !   nvf       format-type for xval(iv).
   !   ncf       format-type for icon(ic).
   !   itype     data type
   !                =0 for energy-group boundaries
   !                =1 for cross sections
   !                =2 for relative standard deviations
   !                =3 for relative covariance matrix
   !                =4 for correlation matrix
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso,nsyse
   use util ! provides error,repoz,mess,sigfig
   ! externals
   integer::nscr,nout,nr,nc
   real(kr)::xa(nr,nc)
   ! internals
   integer::ndimx,ndig,lvmax,lcmax,i,istart
   integer::lv,lc,ivopt,icopt,iv,ic,nsym,ig,j
   integer::ii,jj,jlow,im1,im1ind,iind,icd
   integer::leng,nval,ncon,nrowm
   real(kr)::xvtest,crit,test,xctest
   real(kr)::xval(880)
   integer::icon(900)
   character(60)::strng
   character(12)::ivft,icft
   integer,parameter::nvmax=880
   integer,parameter::ncmax=900
   real(kr),parameter::eps=1.e-10_kr
   real(kr),parameter::zero=0

   ndimx=max0(nr,nc)+1
   if (nrow.gt.ndimx.or.ncol.gt.ndimx)&
     call error('press','storage exceeded.',' ')

   !--output
   if (nout.eq.0) go to 510
   ! set formats
   call setfor(ivft,icft,nvf,ncf)
   ! initialize
   ndig=nvf-6
   if (nvf.lt.9) ndig=nvf-3
   lvmax=10**(ncf-1)-1
   lcmax=10**ncf-1
   i=0
   istart=1
   call repoz(-nscr1)
  480 continue
   lv=0
   lc=0
   ivopt=1
   icopt=1
   iv=0
   ic=0
   nsym=0
   if (ncol.eq.0) nsym=1
   if (ncol.eq.0) ncol=nrow
   if (nrow.eq.ncol) then
      read(nscr1) ig,(scr(j),j=1,ncol)
      do j=1,ncol
         xa(2,j)=sigfig(scr(j),ndig,0)
      enddo
      xvtest=xa(2,1)
      if (nsym.eq.1) xvtest=xa(2,i+1)
   else
      do ii=1,nrow
         do jj=1,ncol
            xa(ii,jj)=sigfig(xa(ii,jj),ndig,0)
         enddo
      enddo
      xvtest=xa(istart,1)
   endif

   !--build xval and icon from a matrix xa(i,j)
   ! begin loop over rows
  470 continue
   i=i+1
   jlow=1
   im1=i-1
   im1ind=im1
   iind=i
   if (ncol.ne.nrow) go to 250
   im1ind=1
   iind=2
   if (nsym.eq.1) jlow=i
   if (i.eq.istart) go to 250
   do j=1,ncol
      xa(1,j)=xa(2,j)
   enddo
   do while (ig.lt.i)
      read(nscr1) ig,(scr(j),j=1,ncol)
   enddo
   do j=1,ncol
      xa(iind,j)=sigfig(scr(j),ndig,0)
   enddo
   ! check for symmetry in the matrix
   if (nsym.ne.1) go to 250
   ! begin loop over columns
   if (xa(im1ind,i).eq.zero) go to 250
   crit=(xa(im1ind,i)-xa(iind,im1))/xa(im1ind,i)
   test=1
   test=test/1000
   if (abs(crit).gt.test) then
      write(strng,&
        '(''i'',i3,'' j'',i3,'' xa(i,j)='',1p,e12.4,'' xa(j,i)='',&
       &1p,e12.4)') ii,im1,xa(im1ind,ii),xa(iind,im1)
      call error('press','matrix not symmetric',strng)
   endif
   test=1
   test=test/1000000
   if (abs(crit).lt.test) go to 250
   write(strng,&
     '(''i'',i3,'' j'',i3,'' xa(i,j)='',1p,e12.4,'' xa(j,i)='',&
     &1p,e12.4)') ii,im1,xa(im1ind,ii),xa(iind,im1)
   call mess('press','matrix not symmetric',strng)
  250 continue
   do 210 j=jlow,ncol

   !--begin pattern-search logic
  310 continue
   if (ivopt.ne.0) then
      test=eps*abs(xvtest)
      if (abs(xa(iind,j)-xvtest).le.test.and.lv.ne.lvmax) then
         ! passes repeated-value test
         lv=lv+1
         icd=0
      else
         ! fails test
         ivopt=0
      endif
   endif
   if (icopt.ne.0) then
      ! test carry-down option
      xctest=0
      if (i.gt.istart) xctest=xa(im1ind,j)
      test=eps*abs(xctest)
      if (abs(xa(iind,j)-xctest).le.test.and.lc.ne.lcmax) then
         ! passes carry-down test
         lc=lc+1
         icd=1
      else
         ! fails test
         icopt=0
      endif
   endif
   if (icopt.ne.0.or.ivopt.ne.0) go to 210

   !--have found end of data pattern.  store data and re-initialize
   ic=ic+1
   if (icd.ne.0) then
      ! carry-down option
      icon(ic)=lc
   else
      ! repeated-value option
      icon(ic)=-lv
      iv=iv+1
      xval(iv)=xvtest
   endif
   lv=0
   lc=0
   ivopt=1
   icopt=1
   xvtest=xa(iind,j)
   go to 310
  210 continue
   ! if container is nearly full, discontinue pattern searches,
   ! write out the data processed up to this point, and then
   ! begin building a new xval and icon array (ie., a new page).
   leng=ncol+1
   if (nsym.eq.1) leng=ncol+1-i
   if (iv+leng.gt.nvmax.or.ic+leng.gt.ncmax) go to 440
   if (i.lt.nrow) go to 470
   ! store last pattern
  440 ic=ic+1
   if (icd.ne.0) then
      icon(ic)=lc
   else
      icon(ic)=-lv
      iv=iv+1
      xval(iv)=xvtest
   endif
   nval=iv
   ncon=ic
   nrowm=nrow-i
   if (nsym.eq.1) ncol=0

   !--finished building xval and icon.  write results
   if (istart.eq.1) write(nout,&
     '(i1,1x,a12,1x,a21,2(i5,i4),2(i4,i3),3i4)')&
     itype,hlibid,hdescr,mat,mt,mat1,&
     mt1,nval,nvf,ncon,ncf,nrowm,nrow,ncol
   if (istart.gt.1) write(nout,&
     '(i1,1x,34(''-''),2(i5,i4),2(i4,i3),3i4)')&
     itype,mat,mt,mat1,mt1,nval,nvf,ncon,ncf,nrowm,nrow,ncol
   if (nval.gt.0) write(nout,ivft) (xval(iv),iv=1,nval)
   if (ncon.gt.0) write(nout,icft) (icon(ic),ic=1,ncon)
   if (nrowm.eq.0) go to 500
   ! write new page
   istart=i+1
   go to 480
  500 continue
   if (itype.gt.2) then
      write(nsyso,'(/3x,''matrix data written.'')')
   endif
  510 continue
   return
   end subroutine press

   subroutine setfor(ivft,icft,nvf,ncf)
   !--------------------------------------------------------------------
   ! Set formats for input and output.
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::nvf,ncf
   character(12)::ivft,icft
   ! internals
   character(60)::strng
   character(12),dimension(14)::ift=(/&
     '(80i1)      ','(40i2)      ','(26i3)      ','(20i4)      ',&
     '(16i5)      ','(13i6)      ','(11f7.4)    ','(10f8.5)    ',&
     '(1p8e9.2)   ','(1p8e10.3)  ','(1p7e11.4)  ','(1p6e12.5)  ',&
     '(1p6e13.6)  ','(1p5e14.7)  '/)

   if (nvf.lt.7.or.nvf.gt.14.or.ncf.lt.1.or.ncf.gt.6) then
      write(strng,&
        '(''nvf (='',i3,'') or ncf (='',i3,'' is illegal.'')')&
        nvf,ncf
      call error('setfor',strng,' ')
   endif

   !--set formats
   ivft=ift(nvf)
   icft=ift(ncf)
   return
   end subroutine setfor

end module covm

module plotm
   ! provides subroutine plotr for NJOY2016
   use locale
   implicit none
   private
   public plotr

contains

   subroutine plotr
   !--------------------------------------------------------------------
   !
   ! plot cross sections
   !
   ! Handles ENDF data, PENDF or GENDF data at specified temper-
   ! atures, or experimental input data.  Several plots can be
   ! given on each set of axes, with both left and right scales.
   ! Also, several graphs can be given on each page or display.
   ! Error bars may be included for input data.  Flexible titles
   ! and legend blocks are allowed.  All standard combinations of
   ! log and linear axes are supported, either grids or tick marks
   ! can be requested, and scales can be chosen automatically
   ! or set by the user.  In some cases, the x axis is thinned.
   ! In other cases, extra points are added so that, for example,
   ! linear-linear data plots correctly on a log-log graph.
   ! A limited capability for 3-d plots of angle and energy
   ! is included, and the ENDF-6 File 6 format is supported.
   ! Percent difference and ratio plots can be requested.
   !
   ! Plotr writes plot commands on an output file for later use
   ! by the viewr module or an external graphics program.
   !
   !---input--------------------------------------------------------
   !
   !  card 0
   !     nplt          unit for output plot commands
   !     nplt0         unit for input plot commands
   !                     default=0=none
   !                     output plot commands are appended
   !                     to the input plot commands, if any.
   !  card 1
   !     lori          page orientation (def=1)
   !                    0  portrait (7.5x10in)
   !                    1  landscape (10x7.5in)
   !     istyle        character style (def=2)
   !                     1 = roman
   !                     2 = swiss
   !     size          character size option
   !                     pos = height in page units
   !                     neg = height as fraction of subplot size
   !                     (default=0.30)
   !     ipcol         page color (def=white)
   !                    0=white
   !                    1=navajo white
   !                    2=blanched almond
   !                    3=antique white
   !                    4=very pale yellow
   !                    5=very pale rose
   !                    6=very pale green
   !                    7=very pale blue
   !
   ! -----repeat cards 2 through 13 for each curve-----
   !
   !  card 2
   !     iplot         plot index
   !                     99 = terminate plotting job
   !                      1 = new axes, new page
   !                     -1 = new axes, existing page
   !                      n = nth additional plot on existing axes
   !                     -n = start a new set of curves using
   !                          the alternate y axis
   !                     default = 1
   !     iwcol         window color (def=white)
   !                    color list same as for ipcol above
   !     factx         factor for energies (default=1.)
   !     facty         factor for cross-sections (default=1.)
   !     xll,yll       lower-left corner of plot area
   !     ww,wh,wr      window width, height, and rotation angle
   !                   (plot area defaults to one plot per page)
   !
   ! -----cards 3 thru 7 for iplot = 1 or -1 only-----
   !
   !  card 3
   !     t1            first line of title
   !                   60 characters allowed.
   !                   default=none
   !
   !  card 3a
   !     t2            second line of title
   !                   60 characters allowed.
   !                   default=none
   !
   !  card 4
   !     itype         type for primary axes
   !                     1 = linear x - linear y
   !                     2 = linear x - log y
   !                     3 = log x - linear y
   !                     4 = log x - log y
   !                     set negative for 3d axes
   !                     default=4
   !     jtype         type for alternate y axis or z axis
   !                     0 = none
   !                     1 = linear
   !                     2 = log
   !                     default=0
   !     igrid         grid and tic mark control
   !                     0 = no grid lines or tic marks
   !                     1 = grid lines
   !                     2 = tic marks on outside
   !                     3 = tic marks on inside
   !                     default=2
   !     ileg          option to write a legend.
   !                     0 = none
   !                     1 = write a legend block with upper left
   !                         corner at xtag,ytag (see below)
   !                     2 = use tag labels on each curve with
   !                         a vector from the tag to the curve
   !                     default=0
   !     xtag          x coordinate of upper left corner
   !                   of legend block
   !     ytag          y coord of upper left corner
   !                   default=upper left corner of plot
   !
   !  card 5
   !     el            lowest energy to be plotted
   !     eh            highest energy to be plotted
   !     xstep         x axis step
   !                   default = automatic scales
   !                   (default all 3, or none)
   !                   (the actual value of xstep is
   !                       ignored for log scales)
   !
   !  card 5a
   !     xlabl         label for x axis
   !                   60 characters allowed.
   !                    default="energy (ev)"
   !
   !  card 6
   !     yl            lowest value of y axis.
   !     yh            highest value of y axis.
   !     ystep         step for y ayis (linear scales only)
   !                   default = automatic scales
   !                   (default all 3, or none)
   !                   (the actual value of ystep is
   !                       ignored for log scales)
   !
   !  card 6a
   !     ylabl         label for y axis
   !                   60 characters allowed.
   !                    default="cross section (barns)"
   !
   !  card 7   (jtype.gt.0 only)
   !     rbot          lowest value of secondary y axis or z axis
   !     rtop          highest value of secondary y axis or z axis
   !     rstep         step for secondary y axis or z axis
   !                   default for last three = automatic
   !
   !  card 7a  (jtype.gt.0 only)
   !     rl            label for alternate y axis or z axis
   !                   60 characters allowed.
   !                   default=blank
   !
   !  -----cards 8 thru 9 are always given-----
   !
   !  card 8
   !     iverf         version of endf tape
   !                     set to zero for data on input file
   !                       and ignore rest of parameters on card
   !                     set to 1 for gendf data
   !     nin           input tape
   !                   can change for every curve if desired.
   !     matd          desired material
   !     mfd           desired file
   !     mtd           desired section
   !                    mtd=0 means loop over all reactions in mfd
   !                    (usually one page per mt, but for mf=3,
   !                    resonance reactions may have several pages)
   !     temper        temperature for endf data (degK, default=0.)
   !     nth,ntp,nkh   see below (defaults=1)
   !
   !       special meanings for nth,ntp,nkh for file 3 or 5 data
   !            nth   number of subsection to plot
   !              (works for isomer prod, delayed n, etc.)
   !            ntp   special features
   !                  1 for regular plots (default)
   !                  2 for percent difference plots
   !                     read a second "card 8" for percent diff
   !                     of second curve with respect to first
   !                  3 for ratio plots
   !                     read a second "card 8" for ratio
   !                     of second curve to first
   !            nkh   not used
   !
   !       special meanings for nth for file 4 Legendre data
   !            nth   index for Legendre coefficient (p1, p2, ...)
   !
   !       special meanings for nth,ntp,nkh for file 6 data
   !            nth   index for  incident energy
   !            ntp   number of dep. variable in cyle to plot
   !                  (or angle number for law 7)
   !            nkh   number of outgoing particle to plot
   !
   !       special meanings for nth,ntp,nkh for gendf mf=3 data
   !            nth=0 for flux per unit lethargy
   !            nth=1 for cross section (default)
   !            ntp=1 for infinite dilution (default)
   !            ntp=2 for next lowest sigma-zero values, etc.
   !                  set ntp negative for self-shielding factor
   !            ntp=21,22,...
   !                  like 1,2,... except read another source
   !                  and compute percent difference
   !            ntp=41,42,...
   !                  like 1,2,... except read another source
   !                  and compute ratio
   !            ntp=-21,-22,...
   !                  like -1,-2,... except read another source
   !                  and compute percent difference
   !            ntp=-41,-42,...
   !                  like -1,-2,... except read another source
   !                  and compute ratio
   !            nkh=1 for p0 weighting (default)
   !            nkh=2 for p1 weighting (total only)
   !
   !       special meaning for nth for gendf mf=6 data
   !            nth=1 plot 2-d spectrum for group 1
   !            nth=2 plot 2-d spectrum for group 2
   !              etc.
   !        no special flags are needed for mf=6 3d plots
   !
   !      special meanings for nth and ntp for mf7 plots
   !           nth is index for indep. variable (alpha or beta)
   !           ntp=1 selects alpha as indep. variable (default)
   !           ntp=2 selects beta as indep. variable
   !           nkh=1 selects normal s(alpha,beta)
   !           nkh=2 selects script s(alpha,-beta)
   !           nkh=3 selects script s(alpha,beta)
   !
   !      additional guidance for ratio (ntp=3 on card 8) plotting of
   !      mf=3 endf or pendf data:
   !       - if both cross sections are zero, the ratio is defined to be
   !         unity.
   !       - if ntp=3 and mtd=0, then mtd2 is set to zero regardless of
   !         its value on card 8a.
   !       - if mtd=0 and y-axis limits (card 6) were specified, then
   !         those limits will apply to all plots.  For selected mt's
   !         both linear-linear and log-linear plots will be produced.
   !       - if mtd=0 and y-axis limits (card 6) are not given, then
   !         y-axis limits are determined internally.  For selected mt's
   !         both linear-linear and log-log plots will be produced.
   !
   ! -----cards 9 and 10 for 2d plots only-----
   !
   !  card 9
   !     icon          symbol and connection option
   !                     0 = points connected, no symbols
   !                    -i = points not connected, symbol at every
   !                         ith point
   !                     i = points connected, symbol at every ith
   !                         points
   !                     default=0
   !     isym          no. of symbol to be used
   !                     0 = square
   !                     1 = octagon
   !                     2 = triangle
   !                     3 = cross
   !                     4 = ex
   !                     5 = diamond
   !                     6 = inverted triangle
   !                     7 = exed square
   !                     8 = crossed ex
   !                     9 = crossed diamond
   !                     10 = crossed octagon
   !                     11 = double triangle
   !                     12 = crossed square
   !                     13 = exed octagon
   !                     14 = triangle and square
   !                     15 = filled circle
   !                     16 = open circle
   !                     17 = open square
   !                     18 = filled square
   !                     default=0
   !     idash         type of line to plot
   !                     0 = solid
   !                     1 = dashed
   !                     2 = chain dash
   !                     3 = chain dot
   !                     4 = dot
   !                     default=0
   !     iccol         curve color (def=black)
   !                     0=black
   !                     1=red
   !                     2=green
   !                     3=blue
   !                     4=magenta
   !                     5=cyan
   !                     6=brown
   !                     7=purple
   !     ithick        thickness of curve (def=1)
   !                     0 = invisible (for shaded areas)
   !     ishade        shade pattern
   !                     0 = none
   !                     1 to 10 = 10% to 100% gray
   !                     11 to 20 = 45 deg right hatching
   !                     21 to 30 = 45 deg left hatching
   !                     31 to 40 = 45 deg cross hatching
   !                     41 to 50 = shades of green
   !                     51 to 60 = shades of red
   !                     61 to 70 = shades of brown
   !                     71 to 80 = shades of blue
   !                     default=0
   !
   !  card 10  ---ileg.ne.0 only---
   !     aleg          title for curve tag or legend block
   !                   60 characters allowed.
   !                   default=blank
   !
   !  card 10a  ---ileg.eq.2 only---
   !     xtag          x position of tag title
   !     ytag          y position of tag title
   !     xpoint        x coordinate of vector point
   !                    (.le.0 to omit vector)
   !
   ! -----card 11 for 3d plots only-----
   !
   !  card 11
   !     xv,yv,zv      abs. coords of view point
   !                   defaults=15.,-15.,15.
   !     x3,y3,z3      abs. sides of work box volume
   !                   defaults=2.5,6.5,2.5
   !
   !         set x3 or y3 negative to flip the order of the
   !         axis on that side of the work box.
   !
   !  -----cards 12 thru 13 for iverf = 0 only-----
   !
   !  card 12
   !     nform          format code for input data
   !                    0 = free format input with
   !                    optional x and y error bars
   !
   !  card 13   ---nform = 0 only---
   !     xdata          dependent value
   !                    terminate with empty card (/)
   !     ydata          independent value
   !     yerr1          lower y error limit
   !                    no y error bar if zero
   !     yerr2          upper y error limit
   !                    if zero, equals yerr1
   !     xerr1          x left error limit
   !                    no x error bar if zero
   !     xerr2          x right error limit
   !                    if zero, equals xerr1
   !
   !
   ! all curves contain at least 10 points per decade (see delta).
   ! code can plot curves containing fewer than 10000 points (see
   ! max) without thinning.  curves with more points are thinned
   ! based on a minimum spacing determined from max and the
   ! length of the x axis.
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use endf ! provides endf routines and variables
   use util ! provides times,openz,error,closz,repoz,mess
   ! internals
   integer::nplt,nplt0,ninl,lori,istyle,ipcol,i3d,iplot
   integer::iwcol,ierrb,n1,i,n2,itype,jtype,igrid,ileg
   integer::nz,nx,ny,nr,matd,mfd,mtd,nth,ntp,nkh
   integer::iauto,ipass,icon,isym,idash,iccol,ithick,ishade
   integer::nb,nw,idone,ik,mmf,lf,lep,net,iet,nmu,imu
   integer::ith,lat,lasym,lln,nbeta,int2,ibeta,lt,l,l2,nt,np
   integer::ll,ithere,nin,nleg,n,nnn,idis,ir,ip
   integer::jnoth,iii,jj,nlast,major,minor,nsk,law,ne,ie
   integer::ltt,loc,nsigz,ntw,ngn,ngg,jbase,locngn,locngg
   integer::nl,ig1,ig,ng2,ig2lo,nwa,jnow,j,nform,iyauto,mthx
   integer::nin2,matd2,mtd2,nth2,ntp2,nkh2,iverf2,mfd2,loc2,lttt
   real(kr)::xpaper,ypaper,xmarg,ymarg,dsize,dxv,dyv,dzv,dx3,dy3,dz3
   real(kr)::time,size,xpage,ypage,factx,facty,xll,yll,ww,wh,wr
   real(kr)::xtag,ytag,xlf,xstep,xleft,xright,yb,yt,ystep,yystep
   real(kr)::ybot,ytop,rbot,rtop,rstep,xpoint
   real(kr)::xv,yv,zv,x3,y3,z3,elt,eht,tem,tnow,test,beta,s
   real(kr)::xh,temper,enow,yf,enext,ee1,ee2,thin,elast,etmax
   real(kr)::st1,st2,st3,st4,stmax,stmin,ststp,temp,dleth,dener
   real(kr)::sigig,flag,factx1,facty1,temper2,reset,enxt,zz,z2,itypx
   real(kr)::z(15)
   integer,parameter::mmax=20000   !same in plotr and viewr
   integer,parameter::nwamax=45000
   integer,parameter::maxaa=200000
   real(kr),dimension(nwamax)::a
   real(kr),dimension(maxaa)::aa
   real(kr),dimension(mmax)::x,y,b,dxm,dxp,dym,dyp
   equivalence (x(1),aa(1)),(y(1),aa(mmax+1)),(b(1),aa(2*mmax+1))
   equivalence (dxm(1),aa(3*mmax+1)),(dxp(1),aa(4*mmax+1))
   equivalence (dym(1),aa(5*mmax+1)),(dyp(1),aa(6*mmax+1))
   character(60)::t1,t2,xl,yl,rl
   character(60)::aleg
   character(60)::strng
   character(10)::name
   character(60)::text
   character(14)::xlabld='<e>nergy (e<v)'
   character(23)::ylabld='<c>ross section (barns)'
   character(1)::qu=''''
   real(kr),parameter::eps=1.e-7_kr
   real(kr),parameter::delta=1.26e0_kr
   real(kr),parameter::etop=1.e10_kr
   real(kr),parameter::tiny=1.e-33_kr
   real(kr),parameter::elow=1.e-5_kr
   real(kr),parameter::therm=296.e0_kr
   real(kr),parameter::sabmin=1.e-32_kr
   real(kr),parameter::big=9.e9_kr
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::zero=0
   real(kr),parameter::ten=10

   ! default paper size is US letter size.
   ! default character size is 0.30 in.
   ! see similar statements in viewr.
   xpaper=8.5e0_kr
   ypaper=11.0e0_kr
   xmarg=1.0e0_kr
   ymarg=1.0e0_kr
   dsize=.30e0_kr

   ! default viewpoint and workbox
   dxv=15.e0_kr
   dyv=-15.e0_kr
   dzv=15.e0_kr
   dx3=2.5e0_kr
   dy3=6.5e0_kr
   dz3=2.5e0_kr

   !--initialize plotting
   read(nsysi,*) nplt,nplt0
   call openz(nplt,1)
   call timer(time)
   write(nsyso,&
     '(/'' plotr...plot endf, pendf, gendf, or input data'',&
     &22x,f8.1,''s'')') time
   write(nsyse,'(/'' plotr...'',60x,f8.1,''s'')') time
   ninl=0
   lori=1
   istyle=2
   size=dsize
   ipcol=0
   read(nsysi,*) lori,istyle,size,ipcol
   write(nsyso,'(/&
     &'' lori ................................. '',i10/&
     &'' istyle ............................... '',i10/&
     &'' size ................................. '',f10.3/&
     &'' ipcol ................................ '',i10)')&
     lori,istyle,size,ipcol
   write(nplt,'(2i2,f8.3,i8,'' /'')') lori, istyle,size,ipcol
   !  default page size is paper size with 0.5in margins all around
   if (lori.eq.0) then
      xpage=xpaper-xmarg
      ypage=ypaper-ymarg
   else
      xpage=ypaper-xmarg
      ypage=xpaper-ymarg
   endif

   !--loop over plots
   i3d=0
  110 continue
   iplot=1
   iwcol=0
   factx=1
   facty=1
   xll=0
   yll=0
   ww=xpage
   wh=ypage
   wr=0
   read(nsysi,*) iplot,iwcol,factx,facty,xll,yll,ww,wh,wr
   if (iplot.eq.99) go to 700
   write(nsyso,'(/&
     &'' -------------------------------------------------''//&
     &'' iplot ................................ '',i10/&
     &'' iwcol ................................ '',i10/&
     &'' factx ................................ '',1p,e10.2/&
     &'' facty ................................ '',e10.2,0p/&
     &'' xll .................................. '',f10.3/&
     &'' yll .................................. '',f10.3/&
     &'' ww ................................... '',f10.3/&
     &'' wh ................................... '',f10.3/&
     &'' wr ................................... '',f10.3)')&
     iplot,iwcol,factx,facty,xll,yll,ww,wh,wr
   ierrb=0

   !--if this is first plot on these axes
   !--read in title lines
   if (iabs(iplot).eq.1) then
      text=' '
      read(nsysi,*) text
      n1=0
      do i=1,60
         if (text(i:i).ne.' ') n1=i
      enddo
      t1=' '
      if (n1.gt.0) t1=text(1:n1)
      text=' '
      read(nsysi,*) text
      n2=0
      do i=1,60
         if (text(i:i).ne.' ') n2=i
      enddo
      t2=' '
      if (n2.gt.0) t2=text(1:n2)
      write(nsyso,'(/12x,a/12x,a)') t1,t2

      !--set up plot type and grids
      itype=4
      jtype=0
      igrid=2
      ileg=0
      xtag=0
      ytag=0
      read(nsysi,*) itype,jtype,igrid,ileg,xtag,ytag
      write(nsyso,'(/&
        &'' itype ................................ '',i10/&
        &'' jtype ................................ '',i10/&
        &'' igrid ................................ '',i10/&
        &'' ileg ................................. '',i10)')&
        itype,jtype,igrid,ileg
      if (ileg.eq.1) write(nsyso,'(/&
        &'' xtag ................................. '',1p,e10.2/&
        &'' ytag ................................. '',1p,e10.2)')&
        xtag,ytag
      i3d=0
      if (itype.le.0) then
         i3d=1
         itype=-itype
      endif

      !--read in x-axis limits and label
      xlf=0
      xh=0
      xstep=0
      read(nsysi,*) xlf,xh,xstep
      if (xlf.eq.zero.and.xh.eq.zero) then
         nz=0
      else
         nz=2
         if (xstep.ne.zero) nz=3
      endif
      if (itype.gt.2.and.nz.ge.2) xstep=1
      if (nz.gt.0.and.xstep.eq.zero)&
        call error('plotr','error in axis input',' ')
      xleft=xlf
      xright=xh
      text=' '
      read(nsysi,*) text
      nx=0
      do i=1,60
         if (text(i:i).ne.' ') nx=i
      enddo
      xl=' '
      if (nx.gt.0) xl=text(1:nx)
      write(nsyso,'(/&
        &'' xlo .................................. '',1p,e10.2/&
        &'' xhi .................................. '',1p,e10.2/&
        &'' xstep ................................ '',1p,e10.2/&
        &'' xlabel ... '',a)')&
        xleft,xright,xstep,xl

      !--read in y-axis limits and label
      yb=0
      yt=0
      yystep=0
      iyauto=0
      read(nsysi,*) yb,yt,yystep
      ystep=yystep
      if (yb.eq.zero.and.yt.eq.zero) then
         nz=0
      else
         nz=2
         if (ystep.ne.zero) nz=3
      endif
      if ((itype.eq.2.or.itype.eq.4).and.nz.ge.2) ystep=1
      if (nz.gt.0.and.ystep.eq.zero)&
        call error('plotr','error in axis input',' ')
      ybot=yb
      ytop=yt
      text=' '
      read(nsysi,*) text
      ny=0
      do i=1,60
         if (text(i:i).ne.' ') ny=i
      enddo
      yl=' '
      if (ny.gt.0) yl=text(1:ny)
      write(nsyso,'(/&
        &'' ylo .................................. '',1p,e10.2/&
        &'' yhi .................................. '',1p,e10.2/&
        &'' ystep ................................ '',1p,e10.2/&
        &'' ylabel ... '',a)')&
        ybot,ytop,ystep,yl

      !--read in data for alternate y axis or z axis
      if (jtype.ne.0) then
         rbot=0
         rtop=0
         rstep=0
         read(nsysi,*) rbot,rtop,rstep
         if (rbot.eq.zero.and.rtop.eq.zero) then
            nz=0
         else
            nz=2
            if (rstep.ne.zero) nz=3
         endif
         if (rtop.lt.rbot)&
           call error('plotr','error in axis input',' ')
         if (nz.gt.2.and.rstep.eq.zero)&
           call error('plotr','error in axis input',' ')
         text=' '
         read(nsysi,*) text
         nr=0
         do i=1,60
            if (text(i:i).ne.' ') nr=i
         enddo
         rl=' '
         if (nr.gt.0) rl=text(1:nr)
         write(nsyso,'(/&
           &'' rlo .................................. '',1p,e10.2/&
           &'' rhi .................................. '',1p,e10.2/&
           &'' rstep ................................ '',1p,e10.2/&
           &'' rlabel ... '',a)')&
           rbot,rtop,rstep,rl
      endif
   endif

   !--read data source for next curve
   iverf=0
   nin=0
   matd=0
   mfd=0
   mtd=0
   temper=0
   nth=1
   ntp=1
   nkh=1
   nin2=0
   read(nsysi,*) iverf,nin,matd,mfd,mtd,temper,nth,ntp,nkh
   if (iverf.gt.0) then
      if (nin.ne.ninl) call closz(ninl)
      if (nin.ne.ninl) call openz(nin,0)
      ninl=nin
      write(nsyso,'(/&
        &'' iverf ................................ '',i10/&
        &'' nin .................................. '',i10/&
        &'' matd ................................. '',i10/&
        &'' mfd .................................. '',i10/&
        &'' mtd .................................. '',i10/&
        &'' temp ................................. '',1p,e10.2/&
        &'' nth .................................. '',i10/&
        &'' ntp .................................. '',i10/&
        &'' nkh .................................. '',i10)')&
        iverf,nin,matd,mfd,mtd,temper,nth,ntp,nkh
      iauto=0
      if (mtd.eq.0) iauto=1
      ipass=0
      if ((iverf.gt.1.and.mfd.eq.3.and.ntp.gt.1).or.&
        (iverf.eq.1.and.abs(ntp).gt.20)) then
         matd2=0
         mfd2=0
         mtd2=0
         temper2=0
         nth2=1
         ntp2=1
         nkh2=1
         read(nsysi,*)&
           iverf2,nin2,matd2,mfd2,mtd2,temper2,nth2,ntp2,nkh2
         call openz(nin2,0)
         if (ntp.eq.3.and.mtd.eq.0) mtd2=mtd
         write(nsyso,'(/&
           &'' iverf2 ............................... '',i10/&
           &'' nin2 ................................. '',i10/&
           &'' matd2 ................................ '',i10/&
           &'' mfd2 ................................. '',i10/&
           &'' mtd2 ................................. '',i10/&
           &'' temp2 ................................ '',1p,e10.2/&
           &'' nth2 ................................. '',i10/&
           &'' ntp2 ................................. '',i10/&
           &'' nkh2 ................................. '',i10)')&
           iverf2,nin2,matd2,mfd2,mtd2,temper2,nth2,ntp2,nkh2
      endif
   endif

   !--read plotting parameters for next 2d curve
   if (i3d.eq.0) then
      icon=0
      isym=0
      idash=0
      iccol=0
      ithick=1
      ishade=0
      read(nsysi,*) icon,isym,idash,iccol,ithick,ishade
      write(nsyso,'(/&
        &'' icon ................................. '',i10/&
        &'' isym ................................. '',i10/&
        &'' idash ................................ '',i10/&
        &'' iccol ................................ '',i10/&
        &'' ithick ............................... '',i10/&
        &'' ishade ............................... '',i10)')&
        icon,isym,idash,iccol,ithick,ishade

      !--read in legend or tag title lines
      if (ileg.ne.0) then
         text=' '
         read(nsysi,*) text
         nleg=0
         do i=1,60
            if (text(i:i).ne.' ') nleg=i
         enddo
         aleg=' '
         if (nleg.gt.0) aleg=text(1:nleg)
         if (ileg.eq.1) write(nsyso,'(/'' legend ... '',a)') aleg
         if (ileg.eq.2) then
            xtag=0
            ytag=0
            xpoint=0
            read(nsysi,*) xtag,ytag,xpoint
            write(nsyso,'(/&
              &'' tag ...... '',a/&
              &'' xtag ................................. '',1p,e10.2/&
              &'' ytag ................................. '',1p,e10.2/&
              &'' xpoint ............................... '',1p,e10.2&
              &)') aleg,xtag,ytag,xpoint
         endif
      endif

   !--read parameters for plotting 3d surface
   else
      xv=dxv
      yv=dyv
      zv=dzv
      x3=dx3
      y3=dy3
      z3=dz3
      read(nsysi,*) xv,yv,zv,x3,y3,z3
      write(nsyso,'(/&
        &'' 3d viewpoint ......................... '',f10.3/&
        &''                                        '',f10.3/&
        &''                                        '',f10.3/&
        &'' 3d workbox ........................... '',f10.3/&
        &''                                        '',f10.3/&
        &''                                        '',f10.3)')&
        xv,yv,zv,x3,y3,z3
   endif

   !--branch to appropriate data type
   if (iverf.eq.0) go to 500
   if (iverf.eq.1) go to 400

   !--endf or pendf data
   !--locate desired tabulation
   call repoz(nin)
   call tpidio(nin,0,0,a,nb,nw)
   if (nin2.ne.0) then
       call repoz(nin2)
       call tpidio(nin2,0,0,a,nb,nw)
   endif
   elt=xleft/factx
   eht=xright/factx
   idone=0
   do while (idone.eq.0)
      call contio(nin,0,0,a,nb,nw)
      if (math.lt.0) then
         write(strng,&
           '(''1desired mat and temp not found '',i4,f10.1)')&
            matd,temper
         call error('plotr',strng,' ')
      endif
      if (math.eq.matd) then
         if (mfd.eq.7) then
            idone=1
         else
            if (iverf.ge.5) call contio(nin,0,0,a,nb,nw)
            if (iverf.ge.6) call contio(nin,0,0,a,nb,nw)
            call contio(nin,0,0,a,nb,nw)
            tem=a(1)
            if (abs(tem-temper).le.temper/1000) idone=1
         endif
      endif
      if (idone.eq.0) call tomend(nin,0,0,a)
   enddo
   if (nin2.eq.0) go to 320
   idone=0
   do while (idone.eq.0)
      call contio(nin2,0,0,a,nb,nw)
      if (math.lt.0) then
         write(strng,&
           '(''desired mat2 and temp2 not found '',i4,f10.1)')&
            matd2,temper2
         call error('plotr',strng,' ')
      endif
      if (math.eq.matd2) then
         if (mfd2.eq.7) then
            idone=1
         else
            if (iverf2.ge.5) call contio(nin2,0,0,a,nb,nw)
            if (iverf2.ge.6) call contio(nin2,0,0,a,nb,nw)
            call contio(nin2,0,0,a,nb,nw)
            tem=a(1)
            if (abs(tem-temper2).le.temper2/1000) idone=1
         endif
      endif
      if (idone.eq.0) call tomend(nin2,0,0,a)
   enddo

   !--auto reaction loop goes through here.
  320 continue
   call findf(matd,mfd,mtd,nin)
   if (nin2.ne.0) call findf(matd2,mfd2,mtd2,nin2)
  321 continue
   call contio(nin,0,0,a,nb,nw)
   mthx=mth
   if (nin2.ne.0) then
      call contio(nin2,0,0,a,nb,nw)
      mtd2=mth
      do while (mthx.lt.mtd2.and.mfh.gt.0)
         call tosend(nin,0,0,a)
         call contio(nin,0,0,a,nb,nw)
         mthx=mth
      enddo
      do while (mtd2.lt.mthx.and.mfh.gt.0)
         call tosend(nin2,0,0,a)
         call contio(nin2,0,0,a,nb,nw)
         mtd2=mth
      enddo
   endif
   if (mfh.eq.0.and.iauto.eq.1) go to 110
   mtd=mthx
   if (nin2.ne.0) mtd2=mth
   if (iauto.gt.0.and.ipass.eq.0) eht=0
   if (iauto.gt.0) then
      elt=0
      xleft=0
      xright=0
      xstep=0
      ybot=0
      ytop=0
      ystep=0
      iyauto=0
      if (ntp.eq.3.and.yb.ne.zero) ybot=yb
      if (ntp.eq.3.and.yt.ne.zero) ytop=yt
      if (ntp.eq.3.and.yystep.ne.zero) ystep=yystep
      if (ybot.ne.0.and.ytop.ne.0) iyauto=1
   endif
   ik=1
   mmf=3
   if (i3d.eq.1) go to 2300

   !--endf or pendf 2d plots
   if (mfd.eq.3) go to 1409
   if (mfd.eq.4) then
      mmf=mfd
      go to 1409
   endif
   if (mfd.eq.7) go to 1410

   !--curves from file5, file15, or file6
   if (mfd.eq.5.or.mfd.eq.15.or.mfd.eq.6) then
      lttt=l2h
      mmf=mfd
      idone=0
      do while (idone.eq.0)
         !if (mtd.lt.221.or.mtd.ge.250) then
         if (lttt.ne.5) then
            call tab1io(nin,0,0,a,nb,nw)
            lf=l2h
            if (mfd.ne.6.and.lf.ne.1)&
              call error('plotr','lf=1 only for mf5 or mf15.',' ')
            if (mfd.eq.6.and.lf.ne.1.and.lf.ne.7)&
              call error('plotr','lf=1 or 7 only for file6.',' ')
            if (lf.eq.7) mmf=1
         endif
         call tab2io(nin,0,0,a,nb,nw)
         lep=l2h
         !if (mtd.ge.221.and.mtd.lt.250) lep=2
         if (lttt.eq.5) lep=2
         if (ik.eq.nkh) then
            idone=1
         else
            net=n2h
            iet=1
            do while (iet.lt.net)
               if (lf.ne.7) then
                   if (mfd.ne.6) call tab1io(nin,0,0,a,nb,nw)
                  if (mfd.eq.6) call listio(nin,0,0,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,0,0,a,nb,nw)
                  enddo
               else
                  call tab2io(nin,0,0,a,nb,nw)
                  nmu=n2h
                  do imu=1,nmu
                     call tab1io(nin,0,0,a,nb,nw)
                     do while (nb.ne.0)
                        call moreio(nin,0,0,a,nb,nw)
                     enddo
                  enddo
               endif
               iet=iet+1
            enddo
            ik=ik+1
         endif
      enddo
   endif
   ith=1
   do while (ith.ne.nth)
      if (lf.ne.7) then
         if (mfd.ne.6) call tab1io(nin,0,0,a,nb,nw)
         if (mfd.eq.6) call listio(nin,0,0,a,nb,nw)
         do while (nb.ne.0)
            call moreio(nin,0,0,a,nb,nw)
         enddo
      else
         call tab2io(nin,0,0,a,nb,nw)
         nmu=n2h
         do imu=1,nmu
            call tab1io(nin,0,0,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,0,0,a,nb,nw)
            enddo
         enddo
      endif
      ith=ith+1
   enddo
   if (lf.eq.7) then
      call tab2io(nin,0,0,a,nb,nw)
      nmu=n2h
      imu=1
      idone=0
      do while (idone.eq.0)
         if (imu.eq.ntp) then
            idone=1
         else
            call tab1io(nin,0,0,a,nb,nw)
            do while (nb.ne.0)
               call moreio(nin,0,0,a,nb,nw)
            enddo
            imu=imu+1
         endif
      enddo
   endif
   go to 1409

   !--curves from file7
 1410 continue
   mmf=7
   lat=l2h
   lasym=n1h
   call listio(nin,0,0,a,nb,nw)
   lln=l1h
   call tab2io(nin,0,0,a,nb,nw)
   nbeta=n2h
   int2=nint(a(8))
   if (ntp.gt.1) go to 1440
   ibeta=1
   idone=0
   do while (idone.eq.0)
      if (ibeta.eq.nth) then
         idone=1
      else
         call tab1io(nin,0,0,a,nb,nw)
         lt=l1h
         do while (nb.ne.0)
            call moreio(nin,0,0,a,nb,nw)
         enddo
         if (lt.ne.0) then
            do i=1,lt
               call listio(nin,0,0,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,0,0,a,nb,nw)
               enddo
            enddo
         endif
         ibeta=ibeta+1
         if (ibeta.gt.nbeta) call error('plotr',&
           'illegal nth for mf7',' ')
      endif
   enddo
   l=1
   l2=1
   call tab1io(nin,0,0,a(l),nb,nw)
   tnow=c1h
   lt=l1h
   nt=0
   nr=n1h
   np=n2h
   l=l+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,a(l),nb,nw)
   enddo
   idone=0
   do while (idone.eq.0)
      test=1
      test=test/10+tnow/100
      if (abs(temper-tnow).lt.test) then
         idone=1
      else
         ll=l
         call listio(nin,0,0,a(l),nb,nw)
         tnow=c1h
         np=n1h
         l=l+nw
         do while (nb.ne.0)
            call moreio(nin,0,0,a(l),nb,nw)
            l=l+nw
         enddo
         do i=1,np
            a(6+2*nr+2*i)=a(ll+5+i)
         enddo
         l=ll
         nt=nt+1
         if (nt.gt.lt) call error('plotr',&
           'temperature not found',' ')
      endif
   enddo
   beta=a(2)
   if (lat.eq.1) beta=beta*therm/temper
   do i=1,np
      s=a(6+2*nr+2*i)
      if (lln.eq.1) s=exp(s)
      if (nkh.eq.2) s=s*exp(beta/2)
      if (nkh.eq.3) s=s*exp(-beta/2)
      if (s.lt.sabmin) s=sabmin
      a(6+2*nr+2*i)=s
   enddo
   if (lln.ne.0) then
      do i=1,nr
         a(5+2*i)=a(5+2*i)+1
      enddo
   endif
   go to 1409
 1440 continue
   l2=npage+50
   a(l2)=0
   a(l2+1)=0
   a(l2+2)=0
   a(l2+3)=0
   a(l2+4)=1
   a(l2+5)=nbeta
   a(l2+6)=nbeta
   if (lln.eq.1) int2=int2+1
   a(l2+7)=int2
   do ibeta=1,nbeta
      l=1
      ithere=0
      call tab1io(nin,0,0,a(l),nb,nw)
      tnow=c1h
      lt=l1h
      nt=0
      nr=n1h
      l=l+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,a(l),nb,nw)
         l=l+nw
      enddo
      do while (nt.le.lt)
         if (nt.ne.0) then
            ll=l
            call listio(nin,0,0,a(l),nb,nw)
            tnow=c1h
            np=n1h
            l=l+nw
            do while (nb.ne.0)
               call moreio(nin,0,0,a(l),nb,nw)
               l=l+nw
            enddo
            l=ll
         endif
         if (abs(temper-tnow).lt..01) then
            a(l2+6+2*ibeta)=a(2)
            if (lasym.gt.0) x(ibeta)=a(2)*factx
            if (nt.eq.0) yf=a(6+2*nr+2*nth)
            if (nt.gt.0) yf=a(ll+5+nth)
            if (lln.eq.1) yf=exp(yf)
            beta=a(2)
            if (lat.eq.1) beta=beta*therm/temper
            if (nkh.eq.2) yf=yf*exp(beta/2)
            if (nkh.eq.3) yf=yf*exp(-beta/2)
            if (yf.lt.sabmin) yf=sabmin
            a(l2+7+2*ibeta)=yf
            if (lasym.gt.0) y(ibeta)=yf*facty
            ithere=1
         endif
         nt=nt+1
      enddo
      if (ithere.eq.0)&
        call error('plotr', 'temperature not found',' ')
   enddo
   if (lasym.eq.0) go to 1409
   n=nbeta
   go to 610

 1409 continue
   nnn=0
   enow=0
   if (mmf.eq.4) then
      call gety4(enow,enext,idis,yf,nth,nin,a)
   else if (mmf.eq.6) then
      call gety6(ntp,enow,enext,idis,yf,nin,a,lep,lf,b,1)
      enext=enext-enext/10000
   else if (mmf.eq.7) then
      ir=1
      ip=2
      call terpa(yf,zero,enext,idis,a(l2),ip,ir)
   else if (nin2.ne.0) then
      enext=big
      reset=-1
      loc2=50+npage
      call getz(reset,enxt,idis,zz,0,a)
      call getz(enow,enxt,idis,zz,nin,a)
      if (enxt.lt.enext) enext=enxt
      call getz(enow,enxt,idis,zz,nin2,a(loc2))
      nnn=nint(a(loc2+5))
      if (enxt.lt.enext) enext=enxt
   else
      call gety1(enow,enext,idis,yf,nin,a)
      nnn=nint(a(6))
   endif
   if (enext.lt.elt) enext=elt
   if (enext.eq.zero) enext=elow
   jnoth=0
   if (enext.lt.1.e3) jnoth=1
   ipass=ipass+1
   ee1=0
   ee2=0

   !--if necessary, find last point in frame
   if (eht.gt.zero) go to 335
   iii=0
   idone=0
   do while (idone.eq.0)
      enow=enext
      iii=iii+1
      if (mmf.eq.4) then
         call gety4(enow,enext,idis,yf,nth,nin,a)
      else if (mmf.eq.6) then
         call gety6(ntp,enow,enext,idis,yf,nin,a,lep,lf,b,1)
      else if (mmf.eq.7) then
         ir=1
         ip=2
         call terpa(yf,enow,enext,idis,a(l2),ip,ir)
      else if (nin2.ne.0) then
         call getz(enow,enext,idis,zz,nin2,a(loc2))
         if (jnoth.eq.1.and.nnn.gt.3000) then
            if (iii.eq.300) ee1=enow
            if (iii.eq.nnn-500) ee2=enow
         endif
      else
         call gety1(enow,enext,idis,yf,nin,a)
         if (jnoth.eq.1.and.nnn.gt.3000) then
            if (iii.eq.300) ee1=enow
            if (iii.eq.nnn-500) ee2=enow
         endif
      endif
      eht=enow
      if (enext.ge.etop-etop/1000) idone=1
   enddo
   go to 320

   !--find first point in frame
   !--and set up thinning/thickening logic
  335 continue
   enow=enext
   if (ee1.gt.tiny) then
       jj=int(log10(ee1))
       ee1=ten**jj
   endif
   if (ee2.gt.tiny) then
      jj=int(log10(ee2))
      ee2=ten**jj
   endif
   if (iauto.gt.0) then
      itype=1
      if (jnoth.eq.1.and.ipass.gt.2) itype=4
      if (ipass.gt.2.and.ee1.eq.zero) ipass=5
      if (jnoth.eq.1.and.ee1.gt.zero.and.ipass.eq.4) then
         elt=ee1
         eht=ee1*100
         if (eht.gt.ee2) eht=ee2
         xleft=elt
         xright=eht
         xstep=1
         if (eht.eq.ee2) ipass=5
      endif
      if (jnoth.eq.1.and.ee1.gt.zero.and.ipass.eq.5) then
         elt=ee1*100
         eht=ee2
         xleft=elt
         xright=eht
         xstep=1
      endif
      if (itype.eq.4.and.ntp.eq.3.and.iyauto.ne.0) itype=3
   endif
   if (elt.eq.zero) elt=enext
   if (elt.gt.enow) enow=elt
   if (itype.ne.3.and.itype.ne.4) then
      thin=(eht-elt)/(mmax-500)
   else
      thin=ten**(log10(eht/elt)/(mmax-500))
   endif
   if (mmf.eq.4) then
      call gety4(enow,enext,idis,yf,nth,nin,a)
   else if (mmf.eq.6) then
      call gety6(ntp,enow,enext,idis,yf,nin,a,lep,lf,b,1)
   else if (mmf.eq.7) then
      ir=1
      ip=2
      call terpa(yf,enow,enext,idis,a(l2),ip,ir)
   else if (nin2.ne.0) then
      enext=big
      call getz(enow,enxt,idis,zz,nin,a)
      if (enxt.lt.enext) enext=enxt
      call getz(enow,enxt,idis,z2,nin2,a(loc2))
      if (enxt.lt.enext) enext=enxt
      if (ntp.eq.2) then
         yf=100*(z2-zz)+small
         if (zz.ne.zero) yf=yf/zz
      else if (ntp.eq.3) then
         yf=z2
         if (zz.ne.zero) yf=yf/zz
         if (z2.eq.zero.and.zz.eq.zero) yf=1
      endif
   else
      call gety1(enow,enext,idis,yf,nin,a)
   endif
   itypx=itype
   if (iplot.lt.-1) then
      if (jtype.eq.1) then
         if (itype.eq.2) itypx=1
         if (itype.eq.4) itypx=3
      else
         if (itype.eq.1) itypx=2
         if (itype.eq.3) itypx=4
      endif
   endif
   if (itypx.eq.2.or.itypx.eq.4) then
      test=ten**(-15)
      if (yf.le.test) yf=test
      if (enext.gt.delta*enow) enext=delta*enow
   endif
   n=1
   x(n)=enow*factx
   y(n)=yf*facty
   elast=enow
   nlast=n
   test=enext-enext/10000
   if (idis.ne.0.and.test.gt.enow) enext=test

   !--retrieve rest of points in frame
   !--thin or thicken as necessary
  360 continue
   if (enext.le.eht) go to 370
   if (abs(enow-eht).le.eps) go to 390
   if (enext.gt.eht.and.enow.lt.eht) enext=eht
   if (enext.eq.eht) go to 370
   go to 390
  370 continue
   enow=enext
   if (mmf.eq.4) then
      call gety4(enow,enext,idis,yf,nth,nin,a)
   else if (mmf.eq.6) then
      call gety6(ntp,enow,enext,idis,yf,nin,a,lep,lf,b,1)
   else if (mmf.eq.7) then
      ir=1
      ip=2
      call terpa(yf,enow,enext,idis,a(l2),ip,ir)
   else if (nin2.ne.0) then
      enext=big
      call getz(enow,enxt,idis,zz,nin,a)
      if (enxt.lt.enext) enext=enxt
      call getz(enow,enxt,idis,z2,nin2,a(loc2))
      if (enxt.lt.enext) enext=enxt
      if (ntp.eq.2) then
         yf=100*(z2-zz)+small
         if (zz.ne.zero) yf=yf/zz
      else if (ntp.eq.3) then
         yf=z2
         if (zz.ne.zero) yf=yf/zz
         if (z2.eq.zero.and.zz.eq.zero) yf=1
      endif
   else
      call gety1(enow,enext,idis,yf,nin,a)
   endif
   test=etop-etop/100
   if (enext.gt.test.and.yf.gt.zero) enext=enow+enow/10000
   if (enext.gt.test.and.eht.gt.enext) eht=enow
   test=enow+enow/1000
   if (idis.ne.0.and.enext.gt.test) enext=enext-enext/10000
   if (itypx.eq.3.or.itypx.eq.4) go to 375
   if (idis.gt.0) go to 380
   if (itypx.eq.1) then
      if (yf.eq.zero.and.y(n).gt.zero) go to 380
      if (yf.gt.zero.and.y(n).eq.zero) go to 380
   else
      test=ten**(-15)
      if (yf.le.test) yf=test
      if (yf.eq.test.and.y(n).gt.test) go to 380
      if (yf.gt.test.and.y(n).eq.test) go to 380
   endif
   if (enext.ge.enow+thin) go to 380
   if (enow.lt.elast+thin) go to 370
   go to 380
  375 if (idis.gt.0) go to 380
   if (itypx.eq.3) then
      if (yf.eq.zero.and.y(n).gt.zero) go to 380
      if (yf.gt.zero.and.y(n).eq.zero) go to 380
   else
      test=ten**(-15)
      if (yf.le.test) yf=test
      if (yf.eq.test.and.y(n).gt.test) go to 380
      if (yf.gt.test.and.y(n).eq.test) go to 380
   endif
   if (enext.ge.thin*elast) go to 380
   if (enow.lt.thin*elast) go to 370
  380 continue
   n=n+1
   if (n.gt.mmax) call error('plotr','storage exceeded1',' ')
   x(n)=enow*factx
   y(n)=yf*facty
   if (enext.gt.delta*enow) enext=delta*enow
   if (itypx.ne.3.and.itypx.ne.4) then
      if (enext.lt.enow+thin) enext=enow+thin
   else
      if (delta.lt.thin) enext=thin*enow
   endif
   elast=enow
   if (yf.ne.zero.and.itypx.ne.2.and.itypx.ne.4) nlast=n
   test=ten**(-15)
   if (yf.ne.test.and.itype.ne.1.and.itype.ne.3) nlast=n
   go to 360
  390 continue
   if (nlast.lt.n) n=nlast+1
   call tosend(nin,0,0,a)
   if (nin2.ne.0) call tosend(nin2,0,0,a)

   !--for automatic linear plots of non-threshold reactions,
   !--readjust the vertical scale to make high-energy data show up
   if (iauto.ne.0) then
      if (itype.le.2.and.iyauto.eq.0) then
         test=1
         if (x(1)/factx.le.test) then
            etmax=x(n-1)
            st1=0
            st2=0
            st3=0
            st4=y(n-1)
            do i=1,n
               if (x(i).gt.etmax/5.and.y(i).gt.st1) st1=y(i)
               if (x(i).gt.etmax/3.and.y(i).gt.st2) st2=y(i)
               if (x(i).gt.etmax/2.and.y(i).gt.st3) st3=y(i)
            enddo
            stmax=st1+st1/10
            if (stmax.gt.50*st4) stmax=st2+st2/10
            if (stmax.lt.st3) stmax=st3
            stmin=0
            call ascale(4,stmin,stmax,major,minor)
            ststp=stmax/major
            ybot=0
            ytop=stmax
            ystep=ststp
         endif
      endif
   endif
   go to 610

   !--endf or pendf 3d plots
   !--skip to desired subsection
  2300 continue
   law=0
   if (mfd.eq.4) go to 2410
   if (mfd.eq.5) go to 2510
   if (mfd.eq.7) go to 2610
   if (mfd.eq.6.and.mtd.ge.221.and.mtd.le.250) go to 2520
   nsk=nkh-1
   if (nsk.ne.0) then
      do i=1,nsk
         call tab1io(nin,0,0,a,nb,nw)
         law=l2h
         call tab2io(nin,0,0,a,nb,nw)
         ne=n2h
         do ie=1,ne
            if (law.ne.7) then
               call listio(nin,0,0,a,nb,nw)
               do while (nb.ne.0)
                  call moreio(nin,0,0,a,nb,nw)
               enddo
            else
               call tab2io(nin,0,0,a,nb,nw)
               nmu=n2h
               do imu=1,nmu
                  call tab1io(nin,0,0,a,nb,nw)
                  do while (nb.ne.0)
                     call moreio(nin,0,0,a,nb,nw)
                  enddo
               enddo
            endif
         enddo
      enddo
   endif
   call tab1io(nin,0,0,a,nb,nw)
   law=l2h
   if (law.eq.0) go to 2380
   if (law.eq.1) go to 2520
   if (law.eq.2) go to 2415
   if (law.eq.3) go to 2380
   if (law.eq.4) go to 2380
   if (law.eq.7) go to 2520
   call error('plotr','illegal mf6 law.',' ')

   !--no distribution
  2380 continue
   write(strng,'(''for mf6/mt'',i3)') mtd
   call mess('plotr','no distribution, no plot',strng)
   call tosend(nin,0,0,a)
   if (iauto.gt.0) go to 321
   go to 110

   !--mf4 and mf6 angular distributions
  2410 continue
   ltt=l2h
   call listio(nin,0,0,a,nb,nw)
   do while (nb.ne.0)
      call moreio(nin,0,0,a,nb,nw)
   enddo
  2415 continue
   call ad3d(nin,nplt,iplot,iauto,mfd,mtd,ltt,itype,jtype,igrid,&
     xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep,&
     t1,t2,xl,yl,rl,nx,ny,nr,&
     xv,yv,zv,x3,y3,z3,&
     xll,yll,ww,wh,wr,iwcol,&
     aa,maxaa,a,nwamax)
   if (iauto.gt.0) go to 321
   go to 110

   !--mf5 or mf6 energy distribution plots
  2510 continue
   call tab1io(nin,0,0,a,nb,nw)
   lf=l2h
   if (lf.eq.1) go to 2520
   call mess('plotr','can only plot mf5/lf1',' ')
   call tosend(nin,0,0,a)
   if (iauto.gt.0) go to 321
   go to 110
  2520 continue
   call ed3d(nin,nplt,iplot,iauto,mfd,mtd,law,itype,jtype,igrid,&
      xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep,&
      t1,t2,xl,yl,rl,nx,ny,nr,&
      xv,yv,zv,x3,y3,z3,&
      xll,yll,ww,wh,wr,iwcol,&
      aa,maxaa,a,nwamax)
   if (iauto.gt.0) go to 321
   go to 110

   !--mf7 s(alapha,beta) 3d plots
  2610 continue
   call error('plotr', '3d mf7 plots not available',' ')
   go to 110

   !--gendf data
   !--locate desired material and temperature
  400 continue
   call repoz(nin)
   call tpidio(nin,0,0,a,nb,nw)
   if (nin2.ne.0) then
      call repoz(nin2)
      call tpidio(nin2,0,0,a,nb,nw)
   endif
   jnoth=0
  410 continue
   call contio(nin,0,0,a,nb,nw)
   if (math.eq.matd) go to 430
   if (math.lt.0) then
      write(strng,'(''2desired mat and temp not found '',i4,f10.1)')&
        matd,temper
      call error('plotr',strng,' ')
    endif
   if (mfh.eq.0) go to 410
   call tomend(nin,0,0,a)
   go to 410
  430 continue
   loc=7
   call listio(nin,0,0,a(loc),nb,nw)
   temp=a(7)
   test=1
   test=test/1000
   if (abs(temp-temper).lt.test) go to 440
   call tomend(nin,0,0,a)
   go to 410
  440 continue
   do while (nb.ne.0)
      loc=loc+nw
      call moreio(nin,0,0,a(loc),nb,nw)
   enddo
   if (nin2.eq.0) go to 444
  441 continue
   loc=loc+nw
   loc2=loc
   call contio(nin2,0,0,a(loc),nb,nw)
   if (math.eq.matd2) go to 442
   if (math.lt.0) then
      write(strng,'(''3desired mat and temp not found '',i4,f10.1)')&
        matd,temper
      call error('plotr',strng,' ')
    endif
   if (mfh.eq.0) go to 441
   call tomend(nin2,0,0,a(loc))
   go to 441
  442 continue
   loc=loc+6
   call listio(nin2,0,0,a(loc),nb,nw)
   temp=a(loc)
   test=1
   test=test/1000
   if (abs(temp-temper).lt.test) go to 443
   call tomend(nin2,0,0,a(loc))
   go to 441
  443 continue
   do while (nb.ne.0)
      loc=loc+nw
      call moreio(nin2,0,0,a(loc),nb,nw)
   enddo
  444 continue
   nsigz=nint(a(4))
   ntw=nint(a(6))
   ngn=nint(a(9))
   ngg=nint(a(10))
   jbase=12
   jbase=jbase+ntw
   jbase=jbase+nsigz
   locngn=jbase+1
   jbase=jbase+ngn+1
   locngg=jbase+1
   jbase=jbase+ngg+1
   jbase=jbase+1
   if (i3d.eq.1) go to 3400
   nl=0
   nz=0

   !--locate desired list records
   ig1=0
   ig=ngn
  455 continue
   if (ig.lt.ngn) go to 465
   call contio(nin,0,0,a(jbase),nb,nw)
   if (nin2.ne.0) call contio(nin2,0,0,a(jbase+6),nb,nw)
   if (math.eq.0) go to 610
   if (mfh.gt.mfd) go to 610
   if (mfh.eq.0.or.mth.eq.0) go to 455
   nl=l1h
   nz=l2h
  465 continue
   call listio(nin,0,0,a(jbase),nb,nw)
   ng2=l1h
   ig2lo=l2h
   ig=n2h
   nwa=jbase+nw
   do while (nb.ne.0)
      call moreio(nin,0,0,a(nwa),nb,nw)
      nwa=nwa+nw
      if (nw+npage+12.gt.nwamax)&
          call error('plotr','storage exceeded2',' ')
   enddo
   if (nin2.eq.0) go to 467
   loc2=nwa+nw
   nwa=loc2
   call listio(nin2,0,0,a(nwa),nb,nw)
   nwa=nwa+nw
   do while (nb.ne.0)
      call moreio(nin2,0,0,a(nwa),nb,nw)
      nwa=nwa+nw
      if (nw+npage+12.gt.nwamax)&
          call error('plotr','storage exceeded3',' ')
   enddo
  467 continue

   !--process desired records
   if (mth.ne.mtd) go to 455
   if (mfd.eq.6.and.mfh.eq.3) go to 495
   if (mfh.ne.mfd) go to 455
   if (mfh.eq.6) go to 490
   if (mfh.ne.3) go to 455
   if (ig1.eq.0) ig1=ig
   jnow=2*(ig-ig1)
   x(jnow+1)=a(locngn+ig-1)*factx
   x(jnow+2)=a(locngn+ig)*factx
   if (ntp.gt.0) then
      if (ntp.lt.20) then
         s=a(jbase+6+nth*nl*nz+(nkh-1)+nl*(ntp-1))
      else if (ntp.lt.40) then
         s=0
         if (a(jbase+6+nth*nl*nz+(nkh-1)+nl*(ntp-21)).ne.zero) then
            s=100*(a(loc2+6+nth*nl*nz+(nkh-1)+nl*(ntp-21))&
              -a(jbase+6+nth*nl*nz+(nkh-1)+nl*(ntp-21)))/&
              a(jbase+6+nth*nl*nz+(nkh-1)+nl*(ntp-21))
         endif
      else
         s=0
         if (a(jbase+6+nth*nl*nz+(nkh-1)+nl*(ntp-41)).ne.zero) then
            s=a(loc2+6+nth*nl*nz+(nkh-1)+nl*(ntp-41))/&
              a(jbase+6+nth*nl*nz+(nkh-1)+nl*(ntp-41))
         endif
      endif
   else
      if (ntp.gt.-20) then
         s=0
         if (a(jbase+6+nth*nl*nz+(nkh-1)).ne.zero) then
            s=a(jbase+6+nth*nl*nz+(nkh-1)+nl*(-ntp-1))/&
              a(jbase+6+nth*nl*nz+(nkh-1))
         endif
      else if (ntp.gt.-40) then
         s=0
         if (a(loc2+6+nth*nl*nz+(nkh-1)).ne.zero) then
            s=100*((a(loc2+6+nth*nl*nz+(nkh-1)+nl*(-ntp-21))/&
              a(loc2+6+nth*nl*nz+(nkh-1)))&
              -(a(jbase+6+nth*nl*nz+(nkh-1)+nl*(-ntp-21))/&
              a(jbase+6+nth*nl*nz+(nkh-1))))/&
              (a(jbase+6+nth*nl*nz+(nkh-1)+nl*(-ntp-21))/&
              a(jbase+6+nth*nl*nz+(nkh-1)))
         endif
      else
         s=0
         if (a(loc2+6+nth*nl*nz+(nkh-1)).ne.zero) then
            s=(a(loc2+6+nth*nl*nz+(nkh-1)+nl*(-ntp-41))/&
              a(loc2+6+nth*nl*nz+(nkh-1)))/&
              (a(jbase+6+nth*nl*nz+(nkh-1)+nl*(-ntp-41))/&
              a(jbase+6+nth*nl*nz+(nkh-1)))
         endif
      endif
   endif
   if (nth.eq.0) then
      dleth=log(a(locngn+ig)/a(locngn+ig-1))
      s=s/dleth
   endif
   y(jnow+1)=s*facty
   y(jnow+2)=s*facty
   if (s.ne.zero) n=jnow+2
   go to 455
  490 continue
   if (ig.eq.nth) then
      do j=2,ng2
         jj=ig2lo+j-2
         jnow=2*(j-2)
         x(jnow+1)=a(locngn+jj-1)*factx
         x(jnow+2)=a(locngn+jj)*factx
         s=a(jbase+6+nl*nz*(j-1))
         dener=a(locngn+jj)-a(locngn+jj-1)
         s=s/dener
         s=s/sigig
         y(jnow+1)=s*facty
         y(jnow+2)=s*facty
         if (s.ne.zero) n=jnow+2
      enddo
   endif
   go to 455
  495 continue
   if (ig.ne.nth) go to 455
   sigig=a(jbase+6+nl*nz)
   go to 455

   !--gendf 3d plots
  3400 continue
   call contio(nin,0,0,a(jbase),nb,nw)
   if (mfh.eq.0.or.mth.eq.0) go to 3400
   if (math.le.0) then
      call mess('plotr',&
        'desired gendf matrix not found',' ')
      go to 110
   end if
   if (mfh.eq.mfd.and.mth.eq.mtd) go to 3410
   call tosend(nin,0,0,a(jbase))
   go to 3400
  3410 continue
   call gg3d(nin,nplt,iplot,iauto,mfd,mtd,itype,jtype,igrid,&
     xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep,&
     t1,t2,xl,yl,rl,nx,ny,nr,&
     xv,yv,zv,x3,y3,z3,&
     xll,yll,ww,wh,wr,iwcol,&
     ngn,ngg,locngn,locngg,jbase,&
     aa,maxaa,a,nwamax)
   if (iauto.gt.0) go to 321
   go to 110

   !--experimental data
  500 continue
   read(nsysi,*) nform
   write(nsyso,'(/&
     &'' data nform ........................... '',i10)')&
     nform

   !--for format zero
   !--loop thru input lines until an empty card is found
   i=0
   ierrb=0
   idone=0
   do while (idone.eq.0)
      i=i+1
      nz=6
      flag=-99
      z(1)=flag
      z(2)=flag
      z(3)=0
      z(4)=0
      z(5)=0
      z(6)=0
      read(nsysi,*) (z(j),j=1,6)
      if (z(1).eq.flag.and.z(2).eq.flag) then
         idone=1
      else
         x(i)=z(1)*factx
         y(i)=z(2)*facty
         dym(i)=z(3)*facty
         dyp(i)=z(4)*facty
         if (dyp(i).eq.zero) dyp(i)=dym(i)
         dxm(i)=z(5)*factx
         dxp(i)=z(6)*factx
         if (dxp(i).eq.zero) dxp(i)=dxm(i)
         if (dym(i).ne.zero) ierrb=1
         if (dxm(i).ne.zero) ierrb=2
         if (dym(i).ne.zero.and.dxm(i).ne.zero) ierrb=3
      endif
   enddo
   n=i-1

   !--do plot
  610 continue
   factx1=1
   facty1=1
   write(nplt,'(i4,i8,7f7.2,''/ 2d plot'')') iplot,iwcol,&
     factx1,facty1,xll,yll,ww,wh,wr
   if (iabs(iplot).le.1) then
      if (nx.eq.0) xl=xlabld
      if (ny.eq.0) yl=ylabld
      write(nplt,'(1x,a,a,a,''/'')') qu,t1,qu
      if (iauto.gt.0) call rname(mtd,name)
      if (iauto.gt.0) write(t2,'(''mf='',i2,''  mt='',i3,2x,a)')&
        mfd,mtd,name
      write(nplt,'(1x,a,a,a,''/'')') qu,t2,qu
      write(nplt,'(4i6,1p,2e13.4,''/'')') itype,jtype,igrid,ileg,&
        xtag,ytag
      if (xstep.eq.zero) then
         write(nplt,'(''/'')')
      else
         write(nplt,'(1p,3e13.4,''/'')') xleft,xright,xstep
      endif
      write(nplt,'(1x,a,a,a,''/'')') qu,xl,qu
      if (ystep.eq.zero) then
         write(nplt,'(''/'')')
      else
         write(nplt,'(1p,3e13.4,''/'')') ybot,ytop,ystep
      endif
      write(nplt,'(1x,a,a,a,''/'')') qu,yl,qu
      if (jtype.gt.0) then
         if (rstep.eq.zero) then
            write(nplt,'(''/'')')
         else
            write(nplt,'(1p,3e13.4,''/'')') rbot,rtop,rstep
         endif
         write(nplt,'(1x,a,a,a,''/'')') qu,rl,qu
      endif
   endif
   write(nplt,'(''/'')')
   write(nplt,'(5i6,i8,''/'')') icon,isym,idash,iccol,ithick,ishade
   if (ileg.ne.0) write(nplt,'(1x,a,a,a,''/'')') qu,aleg,qu
   if (ileg.eq.2) write(nplt,'(1p,3e13.4,''/'')') xtag,ytag,xpoint
   write(nplt,'('' 0/'')')
   do i=1,n
      if (ierrb.eq.0) then
         write(nplt,'(1p,2e16.8,''/'')') x(i),y(i)
      else
         write(nplt,'(1p,6e16.8,''/'')') x(i),y(i),&
           dym(i),dyp(i),dxm(i),dxp(i)
      endif
   enddo
   write(nplt,'('' /'')')
   if (jnoth.eq.0) ipass=0
   if (jnoth.eq.1.and.ipass.eq.5) ipass=0
   if (iauto.gt.0.and.ipass.gt.0) go to 320
   if (iauto.gt.0) go to 321

   !--loop back for next curve
   go to 110

   !--plotr is finished
  700 continue
   write(nplt,'('' 99/'')')
   call closz(nplt)
   call closz(nin)
   call timer(time)
   write(nsyso,'(/69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine plotr

   subroutine ad3d(nin,nplt,iplot,iauto,mfd,mtd,ltt,itype,jtype,igrid,&
     xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep,&
     t1,t2,xl,yl,rl,nx,ny,nr,&
     xv,yv,zv,x3,y3,z3,&
     xll,yll,ww,wh,wr,iwcol,&
     aa,maxaa,a,nwamax)
   !-------------------------------------------------------------------
   ! Plot a 3D perspective view of an angular distribution from
   ! the TAB2 structure in File 4 or File 6.
   !-------------------------------------------------------------------
   use util ! provides mess
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nplt,iplot,iauto,mfd,mtd,ltt
   integer::itype,jtype,igrid,nx,ny,nr,iwcol,maxaa,nwamax
   real(kr)::xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep
   character(60)::t1,t2,xl,yl,rl
   real(kr)::xv,yv,zv,x3,y3,z3
   real(kr)::xll,yll,ww,wh,wr
   real(kr)::aa(*),a(*)
   ! internals
   integer::nb,nw,ne,locn,nmu,nmum,i,lang,nthind,ie,nl,intmu
   integer::loc,k,imu,il,nmax
   real(kr)::xmin,xmax,xstp,base,dmu,emin,emax,estep,varlim
   real(kr)::en,amu,sum,pl,pn,g,h,var,factx1,facty1
   real(kr)::ey3(200)
   character(10)::name
   character(60)::strng
   character(1)::qu=''''
   character(14)::xlabld='<e>nergy (e<v)'
   character(6)::prob='<p>rob'
   character(8)::cosine='<c>osine'
   integer,parameter::maxxy=200
   integer,parameter::maxx3=400
   real(kr),parameter::big=1.e8_kr
   real(kr),parameter::emev=1.e6_kr
   real(kr),parameter::zero=0

   call tab2io(nin,0,0,a,nb,nw)
   ne=n2h
   xmin=ybot
   xmax=ytop
   xstp=ystep
   if (xmax.eq.zero) xmax=big
   locn=0
   base=1
   base=base/100
   nmu=101
   nmum=nmu+2
   dmu=2
   dmu=dmu/(nmu-1)
   i=0
   emin=0
   emax=0
   lang=0
   estep=emev/5
   varlim=8
   varlim=varlim/100
   nthind=0
   do ie=1,ne
      if (mfh.ne.4.or.ltt.ne.2) then
         call listio(nin,0,0,a,nb,nw)
         lang=l1h
         nl=n1h
      else
         call tab1io(nin,0,0,a,nb,nw)
         intmu=4
         loc=nw+1
         do while (nb.ne.0)
            call moreio(nin,0,0,a(loc),nb,nw)
            loc=loc+nw
         enddo
      endif
      k=nw-3
      en=c2h
      if (en.ge.xmin-xmin/1000.and.en.le.xmax+xmax/1000) then
         if (locn+3*nmum.le.maxaa) then
            if (i+3.le.maxx3.and.i.lt.maxxy) then
               if (i.eq.0) emin=en
               emax=en
               i=i+1
               ey3(i)=en
               aa(locn+1)=base
               locn=locn+1
               do imu=1,nmu
                  amu=1-dmu*(imu-1)
                  if ((mfh.eq.4.and.ltt.eq.2).or.&
                    (mfh.eq.6.and.lang.gt.2)) then
                     do while (amu.lt.a(k))
                        k=k-2
                     enddo
                     call terp1(a(k),a(k+1),a(k+2),a(k+3),&
                       amu,sum,intmu)
                  else
                     pl=1
                     pn=amu
                     sum=1
                     sum=sum/2
                     do il=1,nl
                        sum=sum+(2*il+1)*pn*a(6+il)/2
                        g=amu*pn
                        h=g-pl
                        pl=pn
                        pn=h+g-h/(il+1)
                     enddo
                  endif
                  if (sum.lt.base) sum=base
                  aa(locn+imu)=sum
               enddo
               locn=locn+nmu
               aa(locn+1)=base
               locn=locn+1
               nmax=i
               ! check for possible thinning
               if (i.ne.1.and.ie.ne.ne) then
                  if (ey3(i).le.ey3(i-1)+estep) then
                     var=0
                     do imu=1,nmu
                        var=var+(aa(locn-imu-nmum)-aa(locn-imu))**2
                     enddo
                     if (var.le.varlim) then
                        nthind=nthind+1
                        locn=locn-nmum
                        i=i-1
                        nmax=nmax-1
                     endif
                  endif
               endif
            endif
         endif
      endif
   enddo
   if (nthind.gt.0) then
      write(strng,'(''for mt='',i3)') mtd
      call mess('ad3d','mf4 incident energy grid thinned',strng)
   endif
   call tosend(nin,0,0,a)
   if (locn+3*nmum.gt.maxaa.or.i+3.gt.maxx3)&
     call mess('ad3d',&
     'too much 3d angular distribution data',&
     'energy range truncated')
   if (i.ge.maxxy) call mess('ad3d',&
     'too many 3d angular distribution energies',&
     'energy range truncated')
   if (nx.eq.0) xl=cosine
   if (ny.eq.0) yl=xlabld
   if (nr.eq.0) rl=prob
   factx1=1
   facty1=1
   write(nplt,'(i4,i8,7f7.2,''/ 3d plot'')') iplot,iwcol,&
     factx1,facty1,xll,yll,ww,wh,wr
   write(nplt,'(1x,a,a,a,''/'')') qu,t1,qu
   if (iauto.gt.0) call rname(mtd,name)
   if (iauto.gt.0) write(t2,'(''mf='',i2,''  mt='',i3,2x,a)')&
     mfd,mtd,name
   write(nplt,'(1x,a,a,a,''/'')') qu,t2,qu
   write(nplt,'(3i6,''/'')') -itype,jtype,igrid
   if (xstep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') xleft,xright,xstep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,xl,qu
   if (ystep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') ybot,ytop,ystep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,yl,qu
   if (rstep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') rbot,rtop,rstep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,rl,qu
   write(nplt,'(''/'')')
   write(nplt,'(6f9.3,''/'')') xv,yv,zv,-x3,y3,z3
   write(nplt,'('' 1/'')')
   locn=0
   do i=1,nmax
      write(nplt,'(1p,e13.4,''/'')') ey3(i)
      write(nplt,'(1p,2e13.4,''/'')') 1.,aa(locn+1)
      locn=locn+1
      do imu=1,nmu
         amu=1-dmu*(imu-1)
         write(nplt,'(1p,2e13.4,''/'')') amu,aa(locn+imu)
      enddo
      locn=locn+nmu
      write(nplt,'(1p,2e13.4,''/'')') -1.,aa(locn+1)
      locn=locn+1
      write(nplt,'('' /'')')
   enddo
   write(nplt,'('' /'')')
   return
   end subroutine ad3d

   subroutine ed3d(nin,nplt,iplot,iauto,mfd,mtd,law,itype,jtype,igrid,&
      xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep,&
      t1,t2,xl,yl,rl,nx,ny,nr,&
      xv,yv,zv,x3,y3,z3,&
      xll,yll,ww,wh,wr,iwcol,&
      aa,maxaa,a,nwamax)
   !-------------------------------------------------------------------
   ! Plot a 3D perspective picture of a tabulated energy
   ! distribution from the TAB2 structure in File 5 or File 6.
   !-------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides mess
   ! externals
   integer::nin,nplt,iplot,iauto,mfd,mtd,law
   integer::itype,jtype,igrid,nx,ny,nr,iwcol,maxaa,nwamax
   real(kr)::xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep
   real(kr)::xv,yv,zv,x3,y3,z3
   real(kr)::xll,yll,ww,wh,wr
   character(60)::t1,t2,xl,yl,rl
   real(kr)::aa(*),a(*)
   ! internals
   integer::nb,nw,ne,i1,ne2,ne2m,locn,ie,idis,i2,nmax,ii1,ii2,i
   real(kr)::base,xmin,xmax,xstp,emin,emax,ymin,ymax,ystp
   real(kr)::e2,en,f2,ei,factx1,facty1,bigg,zmmm,zmin,zmax
   real(kr)::ex3(200),ey3(200)
   character(10)::name
   character(14)::xlabld='<e>nergy (e<v)'
   character(13)::sece='<s>ec. energy'
   character(10)::probp='<p>rob/e<v'
   character(1)::qu=''''
   integer,parameter::maxxy=200
   integer,parameter::maxx3=400
   integer::nw7max=6000
   real(kr),parameter::eps=1.e-7_kr
   real(kr),parameter::big=1.e8_kr
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::emev=1.e6_kr
   real(kr),parameter::elow=1.e-5_kr
   real(kr),parameter::etop=1.e10_kr
   real(kr),parameter::zero=0
   real(kr),parameter::ten=10

   !--this tab1io call should be commented out in the unlikely
   !  event that an njoy99/thermr, or earlier, file is being processed.
   if (mfd.eq.6.and.mtd.ge.221.and.mtd.le.250) &
                                            call tab1io(nin,0,0,a,nb,nw)
   !
   call tab2io(nin,0,0,a,nb,nw)
   ne=n2h
   i1=0
   base=small
   xmin=ybot
   xmax=ytop
   if (xmax.eq.0) xmax=big
   xstp=ystep
   emin=0
   emax=etop
   ymin=xleft
   ymax=xright
   if (mth.lt.221.or.mth.gt.250) then
      if (ymax.eq.zero) ymax=20*emev
      if (ymin.eq.zero) ymin=1
   else
      if (ymax.eq.zero) ymax=10
      if (ymin.eq.zero) ymin=eps
   endif
   ystp=xstep
   if (itype.eq.2.or.itype.eq.4) then
      ymin=log10(ymin)
      ymax=log10(ymax)
   endif
   ne2=198
   ne2m=ne2+2
   locn=0
   if (law.eq.7) locn=locn+nw7max
   zmax=small
   do ie=1,ne
      e2=0
      if (mfd.eq.5) call gety1(e2,en,idis,f2,nin,a)
      if (mfd.eq.6)&
        call gety6(1,e2,en,idis,f2,nin,a,2,law,aa,nw7max)
      ei=a(2)
      if (i1.lt.maxxy) then
         if (ei.ge.xmin-xmin/1000.and.ei.le.xmax+xmax/1000) then
            if (locn+3*ne2m.le.maxaa.and.i1+3.le.maxx3) then
               if (i1.eq.0) emin=ei
               i1=i1+1
               ex3(i1)=ei
               if (y3.gt.zero) ey3(1)=ymin
               if (y3.lt.zero) ey3(1)=ymax
               aa(locn+1)=base
               locn=locn+1
               do i2=1,ne2
                  e2=ymin+(ymax-ymin)*(i2-1)/(ne2-1)
                  if (itype.eq.2.or.itype.eq.4) e2=ten**e2
                  if (e2.eq.zero) e2=elow
                  if (mfd.eq.5) call gety1(e2,en,idis,f2,nin,a)
                  if (mfd.eq.6) then
                     call gety6(1,e2,en,idis,f2,nin,a,2,&
                        law,aa,nw7max)
                  endif
                  if (f2.lt.base) f2=base
                  if (f2.gt.zmax) zmax=f2
                  aa(locn+i2)=f2
               enddo
               locn=locn+ne2
               aa(locn+1)=base
               locn=locn+1
               nmax=i1
            endif
         endif
      endif
      bigg=big
      if (mfd.eq.5) call gety1(bigg,en,idis,f2,nin,a)
      if (mfd.eq.6)&
        call gety6(1,bigg,en,idis,f2,nin,a,2,law,aa,nw7max)
   enddo
   call tosend(nin,0,0,a)
   if (locn+3*ne2m.gt.maxaa.or.i1+3.gt.maxx3)&
     call mess('ed3d',&
     'too much energy distribution data',&
     'energy range truncated')
   ! fix up z axis
   zmax=log10(zmax)
   zmmm=33
   zmmm=zmmm/10
   zmin=zmax-zmmm
   i=int(zmin)
   if (float(i).gt.zmin) i=i-1
   zmin=ten**i
   ! set up axis labels
   if (ny.eq.0) yl=xlabld
   if (nx.eq.0) xl=sece
   if (nr.eq.0) rl=probp
   factx1=1
   facty1=1
   write(nplt,'(i4,i8,7f7.2,''/ 3d plot'')') iplot,iwcol,&
     factx1,facty1,xll,yll,ww,wh,wr
   write(nplt,'(1x,a,a,a,''/'')') qu,t1,qu
   if (iauto.gt.0) call rname(mtd,name)
   if (iauto.gt.0) write(t2,'(''mf='',i2,''  mt='',i3,2x,a)')&
     mfd,mtd,name
   write(nplt,'(1x,a,a,a,''/'')') qu,t2,qu
   write(nplt,'(3i6,''/'')') -itype,jtype,igrid
   if (xstep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') xleft,xright,xstep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,xl,qu
   if (ystep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') ybot,ytop,ystep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,yl,qu
   if (rstep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') rbot,rtop,rstep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,rl,qu
   write(nplt,'(''/'')')
   write(nplt,'(6f9.3)') xv,yv,zv,x3,y3,z3
   write(nplt,'('' 1/'')')
   locn=0
   if (law.eq.7) locn=locn+nw7max
   do i1=1,nmax
      write(nplt,'(1p,e13.4,''/'')') ex3(i1)
      ii1=0
      ii2=0
      do i2=1,ne2m
         if (ii1.eq.0.and.aa(locn+i2).ge.zmin) ii1=i2
         if (aa(locn+i2).ge.zmin) ii2=i2
         if (aa(locn+i2).lt.zmin) aa(locn+i2)=zmin
      enddo
      if (ii1.eq.0) ii1=2
      if (ii2.eq.0) ii2=2
      if (ii1.gt.1) ii1=ii1-1
      if (ii2.lt.ne2m) ii2=ii2+1
      do i2=ii1,ii2
         e2=ymin+(ymax-ymin)*(i2-2)/(ne2-1)
         if (i2.eq.1) e2=ymin
         if (i2.eq.ne2m) e2=ymax
         if (itype.eq.2.or.itype.eq.4) e2=ten**e2
         if (e2.eq.zero) e2=elow
         write(nplt,'(1p,2e13.4,''/'')') e2,aa(locn+i2)
      enddo
      locn=locn+ne2m
      write(nplt,'('' /'')')
   enddo
   write(nplt,'('' /'')')
   return
   end subroutine ed3d

   subroutine gg3d(nin,nplt,iplot,iauto,mfd,mtd,itype,jtype,igrid,&
     xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep,&
     t1,t2,xl,yl,rl,nx,ny,nr,&
     xv,yv,zv,x3,y3,z3,&
     xll,yll,ww,wh,wr,iwcol,&
     ngn,ngg,locngn,locngg,jbase,&
     aa,maxaa,a,nwamax)
   !-------------------------------------------------------------------
   ! Plot a 3D perspective view of a group-to-group matrix.
   !-------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::nin,nplt,mfd,mtd,iplot,iauto
   integer::itype,jtype,igrid,nx,ny,nr,iwcol,maxaa,nwamax
   real(kr)::xleft,xright,xstep,ybot,ytop,ystep,rbot,rtop,rstep
   character(60)::t1,t2,xl,yl,rl
   real(kr)::xv,yv,zv,x3,y3,z3
   real(kr)::xll,yll,ww,wh,wr
   integer::ngn,ngg,locngn,locngg,jbase
   real(kr)::aa(*),a(*)
   ! internals
   integer::ng1,nl,nz,ngl,locn,ig,nb,nw,l,ng2,ig2lo,ngm
   integer::j2,i2,k2,j,ig2,nmax,i,i1,major,minor
   real(kr)::xmin,xmax,xstp,emin,emax,ymin,ymax,ystp
   real(kr)::zmin,zmax,zmmm
   real(kr)::e2,eglo,eghi,f2,factx1,facty1
   real(kr)::ex3(200),ey3(200)
   character(10)::name
   character(1)::qu=''''
   character(13)::sece='<s>ec. energy'
   integer::nsece=13
   character(10)::probp='<p>rob/e<v'
   integer::nprobp=10
   integer::maxx3=400
   integer::maxy3=400
   real(kr),parameter::small=1.e-12_kr
   real(kr),parameter::elow=1.e-5_kr
   real(kr),parameter::etop=1.e10_kr
   real(kr),parameter::zero=0

   ng1=0
   nl=nint(a(jbase+2))
   nz=nint(a(jbase+3))
   ngl=nint(a(jbase+5))
   xmin=xleft
   xmax=xright
   if (xmax.eq.zero) xmax=a(locngn+ngl)
   if (xmin.eq.zero) xmin=a(locngn)
   xstp=xstep
   emin=0
   emax=etop
   ymin=ybot
   ymax=ytop
   if (mfd.eq.16) then
      if (ymax.eq.zero) ymax=a(locngg+ngg)
      if (ymin.eq.zero) ymin=a(locngg)
   else
      if (ymax.eq.zero) ymax=a(locngn+ngn)
      if (ymin.eq.zero) ymin=a(locngn)
   endif
   ystp=ystep
   locn=0
   zmax=-12
   ig=1
   do while (ig.lt.ngl)
      ng1=ng1+1
      call listio(nin,0,0,a(jbase),nb,nw)
      l=jbase
      l=l+nw
      do while (nb.ne.0)
         call moreio(nin,0,0,a(l),nb,nw)
         l=l+nw
      enddo
      ng2=nint(a(jbase+2))
      ig2lo=nint(a(jbase+3))
      ig=nint(a(jbase+5))
      if (ng1+2.gt.maxx3) call error('gg3d',&
        'too many incident groups for 3d gendf plot',' ')
      ex3(ng1)=a(locngn+ig-1)
      if (ng1.eq.1) emin=ex3(ng1)
      ngm=ngn+1
      if (mfd.eq.16) ngm=ngg+1
      if (locn+2*ngm+4.gt.maxaa) call error('gg3d',&
        'too many data for 3d gendf plot',' ')
      ey3(1)=ymin
      ey3(2)=ey3(1)
      j2=2
      do i2=1,ngm
         e2=a(locngn+i2-1)
         if (mfd.eq.16) e2=a(locngg+i2-1)
         if (e2.gt.ymin.and.e2.lt.ymax) then
            if (j2+4.gt.maxy3) call error('gg3d',&
              'too many secondary groups for 3d gendf plot',' ')
            ey3(j2+1)=e2
            ey3(j2+2)=e2
            j2=j2+2
         endif
      enddo
      ey3(j2+1)=ymax
      ey3(j2+2)=ymax
      j2=j2+2
      do i2=1,j2
         aa(locn+i2)=-12
         aa(locn+j2+i2)=-12
      enddo
      locn=locn+j2
      ng1=ng1+1
      ex3(ng1)=a(locngn+ig-1)
      k2=1
      do j=2,ng2
         ig2=ig2lo+j-2
         eglo=a(locngn+ig2-1)
         if (mfd.eq.16) eglo=a(locngg+ig2-1)
         eghi=a(locngn+ig2)
         if (mfd.eq.16) eghi=a(locngg+ig2)
         if (eghi.gt.ymin.and.eglo.le.ymax) then
            f2=a(jbase+6+nl*nz*(j-1))/(eghi-eglo)
            if (f2.lt.small) f2=small
            f2=log10(f2)
            if (f2.gt.zmax) zmax=f2
            k2=k2+1
            aa(locn+k2)=f2
            k2=k2+1
            aa(locn+k2)=f2
         endif
      enddo
      k2=k2+1
      locn=locn+j2
   enddo
   ng1=ng1+1
   ex3(ng1)=a(locngn+ig)
   ng1=ng1+1
   ex3(ng1)=a(locngn+ig)+a(locngn+ig)/1000
   do i2=1,j2
      aa(locn+i2)=aa(locn+i2-2*j2)
      aa(locn+i2+j2)=aa(locn+i2-j2)
   enddo
   locn=locn+2*j2
   nmax=ng1
   emax=ex3(ng1)
   ! fix up z axis
   i=int(zmax)
   if (i.lt.zmax) i=i+1
   zmax=i
   zmmm=33
   zmmm=zmmm/10
   zmin=zmax-zmmm
   i=int(zmin)
   if (i.gt.zmin) i=i-1
   zmin=i
   do i1=1,nmax
      do i2=1,j2
         l=i2+j2*(i1-1)
         if (aa(l).lt.zmin) aa(l)=zmin
      enddo
   enddo
   rbot=zmin
   rtop=zmax
   rstep=1
   ! fix up x axis
   if (itype.eq.3.or.itype.eq.4) then
      if (xmin.eq.zero) xmin=elow
      xmin=log10(emin)
      xmax=log10(emax)
      xstp=1
      do i1=1,nmax
         ex3(i1)=log10(ex3(i1))
      enddo
   endif
   if (xstp.eq.zero) then
      xmin=emin
      xmax=emax
      call ascale(4,xmin,xmax,major,minor)
      xstp=(xmax-xmin)/major
   endif
   xleft=xmin
   xright=xmax
   xstep=xstp
   ! fix up y axis
   if (itype.eq.2.or.itype.eq.4) then
      ymin=log10(ymin)
      ymax=log10(ymax)
      ystp=1
      do i2=1,j2
         ey3(i2)=log10(ey3(i2))
      enddo
   endif
   if (ystp.eq.zero) then
      call ascale(2,ymin,ymax,major,minor)
      ystp=(ymax-ymin)/major
   endif
   call tosend(nin,0,0,a)
   ybot=ymin
   ytop=ymax
   ystep=ystp
   ! set up axis labels
   rl=probp
   nr=nprobp
   jtype=2
   yl=sece
   ny=nsece
   factx1=1
   facty1=1
   write(nplt,'(i4,i8,7f7.2,''/ 3d plot'')') iplot,iwcol,&
     factx1,facty1,xll,yll,ww,wh,wr
   write(nplt,'(1x,a,a,a,''/'')') qu,t1,qu
   if (iauto.gt.0) call rname(mtd,name)
   if (iauto.gt.0) write(t2,'(''mf='',i2,''  mt='',i3,2x,a)')&
     mfd,mtd,name
   write(nplt,'(1x,a,a,a,''/'')') qu,t2,qu
   write(nplt,'(3i6,''/'')') -itype,jtype,igrid
   if (xstep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') xleft,xright,xstep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,xl,qu
   if (ystep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') ybot,ytop,ystep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,yl,qu
   if (rstep.eq.zero) then
      write(nplt,'(''/'')')
   else
      write(nplt,'(1p,3e13.4,''/'')') rbot,rtop,rstep
   endif
   write(nplt,'(1x,a,a,a,''/'')') qu,rl,qu
   write(nplt,'(''/'')')
   write(nplt,'(6f9.3,''/'')') xv,yv,zv,-x3,y3,z3
   write(nplt,'('' 1/'')')
   return
   end subroutine gg3d

   subroutine ascale(m,z1,z2,major,minor)
   !--------------------------------------------------------------------
   ! Automatic scaling routine for a linear axis
   ! borrowed from Los Alamos SC4020 library (with modifications).
   ! on input------------
   !   m              minimum number of major divisions desired
   !   z1,z2          min and max values of data to be plotted
   ! on output-----------
   !   z1,z2          min and max limits of axis
   !   major          number of major division on axis
   !   minor          number of minor divisions on axis
   !--------------------------------------------------------------------
   ! externals
   integer::m,major,minor
   real(kr)::z1,z2
   ! internals
   integer::iflag,n1,n2,k,nm
   real(kr)::zmin,zmax,fm,zbar,z,p,tenk,test,dz,fn
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::tentho=10000

   !--check input
   !--exit if parameters are unreasonable
   zmin=z1
   zmax=z2
   if (zmax.le.zmin.or.m.le.0.or.m.gt.20) then
      major=1
      minor=0
      z1=0
      z2=2*z2
      return
   endif

   !--find minimum span per interval
   fm=m
   if (zmax.eq.zero.or.zmin.eq.zero) then
      zmax=zmax-abs(zmax)/1000000
      zmin=zmin+abs(zmin)/1000000
   else
      zbar=zmax/zmin
      if (abs(zbar)/1000.ge.one) zmin=0
      if (abs(zbar)*1000.le.one) then
         zmax=0
         zmax=zmax-abs(zmax)/1000000
         zmin=zmin+abs(zmin)/1000000
      else
         if ((abs(zbar-1)-5*fm/100000).gt.zero) then
            zmax=zmax-abs(zmax)/1000000
            zmin=zmin+abs(zmin)/1000000
         else
            zbar=(zmax+zmin)/2
            z=26*fm*abs(zbar)/1000000
            zmax=zbar+z
            zmin=zbar-z
         endif
      endif
   endif
   p=(zmax-zmin)/fm

   !--determine k such that
   !--    10**k.le.p.lt.10**(k+1)
   iflag=0
   tenk=1
   k=0
   if (p.lt.one) then
      iflag=1
      p=1/p
   endif
   do while (p.ge.tentho)
      p=p/10000
      tenk=tenk*10000
      k=k+4
   enddo
   do while (p.ge.ten)
      p=p/10
      tenk=tenk*10
      k=k+1
   enddo
   if (iflag.ne.0) then
      p=10/p
      tenk=one/10/tenk
      k=k-1
   endif

   !--determine dz such that
   !--    dz = 1*10**k, or
   !--    dz = 2*10**k, or
   !--    dz = 5*10**k.
   test=2+one/100
   if (p.le.test) then
      test=2-one/100
      if (p.le.test) then
         p=1
         nm=5
      else
         p=2
         nm=4
      endif
   else
      test=5-one/100
      if (p.lt.test) then
         p=2
         nm=4
      else
         p=5
         nm=5
      endif
   endif
   dz=p*tenk

   !--find integers n1 and n2 such that
   !--    n1*dz.le.zmin.lt.(n1+1)*dz, and
   !--    (n2-1)*dz.lt.zmax.le.n2*dz
   !--the new zmin and zmax become
   !--    zmin = n1*dz
   !--    zmax = n2*dz
   n1=int(zmin/dz)
   fn=n1
   z=fn*dz
   if (z.gt.zmin) then
      z=z-dz
      n1=n1-1
   endif
   zmin=z
   z1=zmin
   n2=int(zmax/dz)
   fn=n2
   z=fn*dz
   if (z.lt.zmax) then
      n2=n2+1
      z=z+dz
   endif
   zmax=z
   z2=zmax

   !--the values of major and minor can be set
   major=n2-n1
   minor=nm*major
   return
   end subroutine ascale

   subroutine getz(x,xnext,idis,z,itape,a)
   !--------------------------------------------------------------------
   ! Retrieve z(x) from an ENDF/B TAB1 structure using paged bcd or
   ! blocked binary formats.  Call with x=0 to read in first page
   ! or block of data and initialize pointers.  Routine assumes
   ! values will be called in ascending order.  Xnext is the first
   ! data grid point greater than x unless x is the last point.
   ! This version will keep track of pointers for up to 10 units.
   ! Call with x=-1 to clear the pointers before each group of files.
   ! Based on gety from mixr.
   !--------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   real(kr)::x,xnext,z
   real(kr)::a(*)
   integer::idis,itape
   ! internals
   integer::ntape,jtape(10),nrt(10),npt(10),irt(10),ipt(10)
   integer::ip1t(10),ip2t(10),nbt(10),nwt(10)
   save ntape,jtape,nrt,npt,irt,ipt,ip1t,ip2t,nbt,nwt
   integer::lt
   save lt
   integer::nb,nw,nwtot,nr,np,ip1,ip2,ir,ip,i,ktape,ln,nbx,int
   real(kr)::xn
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::zero=0

   !--branch on value of x
   idis=0
   if (x.eq.zero) go to 100
   if (x.gt.zero) go to 115

   !--clear pointer storage
   ntape=0
   return

   !--read first page or block of data and initialize
  100 ntape=ntape+1
   jtape(ntape)=itape
   call tab1io(itape,0,0,a,nb,nw)
   nwtot=nw
   nr=nint(a(5))
   np=nint(a(6))
   lt=6+2*nr
   ip1=1
   ip2=(nw-lt)/2
   if (nb.eq.0) ip2=ip2+2
   ir=1
   ip=2
   xnext=a(lt+1)

   !--save pointers and return
   nrt(ntape)=nr
   npt(ntape)=np
   irt(ntape)=ir
   ipt(ntape)=ip
   ip1t(ntape)=ip1
   ip2t(ntape)=ip2
   nbt(ntape)=nb
   nwt(ntape)=nwtot
   return

   !--restore pointers
  115 if (ntape.eq.0)&
     call error('getz','not properly initialized',' ')
   do 120 i=1,ntape
   if (jtape(i).ne.itape) go to 120
   ktape=i
   nr=nrt(i)
   np=npt(i)
   ir=irt(i)
   ip=ipt(i)
   ip1=ip1t(i)
   ip2=ip2t(i)
   nb=nbt(i)
   nwtot=nwt(i)
   go to 125
  120 continue
   z=0
   xnext=big
   return

   !--is x in this panel
  125 ln=2*(ip-ip1)+lt
   if (x.lt.a(ln-1)) go to 135
   if (x.lt.a(ln+1)) go to 130
   if (ip.eq.np) go to 140

   !--no.  move up to next range.
   !--read in new page of data if needed.
   ip=ip+1
   nbx=nint(a(5+2*ir))
   if (ip.gt.nbx) ir=ir+1
   if (ip.lt.ip2) go to 125
   if (nb.eq.0) go to 130
   a(lt+1)=a(nwtot-3)
   a(lt+2)=a(nwtot-2)
   a(lt+3)=a(nwtot-1)
   a(lt+4)=a(nwtot)
   call moreio(itape,0,0,a(lt+5),nb,nw)
   nwtot=nw+lt+4
   ip1=ip-1
   ip2=ip1+nw/2+1
   if (nb.eq.0) ip2=ip2+2
   go to 125

   !--yes.  interpolate for desired value
  130 int=nint(a(6+2*ir))
   if (int.eq.1) idis=1
   call terp1(a(ln-1),a(ln),a(ln+1),a(ln+2),x,z,int)
   xnext=a(ln+1)
   if ((ln+3).gt.nwtot.and.nb.eq.0) return
   xn=a(ln+3)
   if (xn.eq.xnext) idis=1
   go to 150

   !--special branch for x outside range of table
  135 z=0
   xnext=a(ln-1)
   go to 150

   !--special branch for last point
  140 z=a(ln+2)
   xnext=big

   !--save pointers and return
  150 nrt(ktape)=nr
   npt(ktape)=np
   irt(ktape)=ir
   ipt(ktape)=ip
   ip1t(ktape)=ip1
   ip2t(ktape)=ip2
   nbt(ktape)=nb
   nwt(ktape)=nwtot
   return
   end subroutine getz

   subroutine gety4(x,xnext,idis,y4,nth,nin,a)
   !--------------------------------------------------------------------
   ! Retrieve y4(x) for a MF4 list structure.
   ! Call with x=0 to initialize.
   !--------------------------------------------------------------------
   use util ! provides error
   use endf ! provides endf routines and variables
   ! externals
   integer::idis,nth,nin
   real(kr)::x,xnext,y4,a(*)
   ! internals
   integer::np,ip,nal,na,int,nb,nw,ltt,li
   real(kr)::xlast,ylast,xnow,ynow
   real(kr),parameter::big=1.e10_kr
   save xlast,ylast,np,ip,na,nal

   !--read first point and initialize
   if (x.eq.0) then
      ltt=nint(a(4))
      call contio(nin,0,0,a,nb,nw)
      li=nint(a(4))
      if (ltt.ne.1.and.ltt.ne.3.or.li.eq.1) call error('gety4',&
        'only Legendre coefficient representations supported',' ')
      call tab2io(nin,0,0,a,nb,nw)
      np=nint(a(6))
      int=nint(a(8))
      call listio(nin,0,0,a,nb,nw)
      na=nint(a(5))
      xlast=a(2)
      ylast=0
      nal=na
      if (nth.le.na) ylast=a(6+nth)
      ip=2
      xnext=xlast
   endif

   !--is x is in this panel?
  110 continue
   if (x.lt.xlast) go to 130
   if (x.lt.a(2)) go to 120
   if (ip.eq.np) go to 140

   !--no.  move up to next range.
   xlast=a(2)
   ylast=0
   if (nth.le.na) ylast=a(6+nth)
   nal=na
   ip=ip+1
   call listio(nin,0,0,a,nb,nw)
   na=nint(a(5))
   go to 110

   !--yes. interpolate.
  120 continue
   int=2
   xnow=a(2)
   ynow=0
   if (nth.le.na) ynow=a(6+nth)
   call terp1(xlast,ylast,xnow,ynow,x,y4,int)
   xnext=xnow
   return

   !--special branch for x outside range of table
  130 y4=0
   xnext=xlast
   return

   !--special branch for last point
  140 y4=a(6+nth)
   xlast=big
   xnext=big

   return
   end subroutine gety4

   subroutine gety6(i6,x,xnext,idis,y6,itape,a,lep,law,aa,maa)
   !--------------------------------------------------------------------
   ! Retrieve y6(x) from an MF6 LIST structure using paged BCD or
   ! blocked binary formats.  Call with x=0 to read in first page
   ! or block of data and initialize pointers.  Routine assumes
   ! values will be called in ascending order.  Here, next is the first
   ! data grid point greater than x unless x is the last point, and
   ! i6 is the index to the dependent variable in the cycle
   ! of na+2 values per secondary energy (i6 is usually 1).
   ! For law7, the angle-energy data is converted to a simple energy
   ! distribution and stored in a to be handled in the normal way.
   !--------------------------------------------------------------------
   use endf ! provides endf routines and variables
   ! externals
   integer::i6,idis,itape,lep,law,maa
   real(kr)::x,xnext,y6,a(*),aa(*)
   ! internals
   integer::nb,nw,na,nwp,ln,nc,i,int,nwtot,nep,ncyc,lt,ip1,ip2,ip
   real(kr)::xlast,ylast,xn
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::zero=0
   save xlast,nwtot,nep,ncyc,lt,ip1,ip2,ip,nb

   !--read first page or block of data and initialize.
   idis=0
   if (x.eq.zero) then
      if (law.eq.7) call fixl7(itape,aa,maa,a,nb,nw)
      if (law.ne.7) call listio(itape,0,0,a,nb,nw)
      nwtot=nw
      if (mth.lt.221.or.mth.gt.250) then
         na=l2h
         nwp=n1h
         nep=n2h
         ncyc=na+2
      else
         ncyc=n2h
         nwp=n1h
         nep=nwp/ncyc
      endif
      lt=7
      xlast=a(lt)
      ylast=a(lt+i6)
      ip1=1
      ip2=(nw-6)/ncyc
      ip=2
      xnext=a(lt)
      return
   endif

   !--is x in this panel
  110 if (x.lt.xlast) go to 130
   ln=ncyc*(ip-ip1)+lt
   if (x.lt.a(ln)) go to 120
   if (ip.eq.nep) go to 140

   !--no.  move up to next range.
   !--read in new page of data if needed.
   xlast=a(ln)
   ylast=a(ln+i6)
   ip=ip+1
   if ((ip+2).le.ip2) go to 110
   if (nb.eq.0) go to 120
   nc=nwtot-ln+1
   do i=1,nc
      a(lt+i-1)=a(nwtot-nc+i)
   enddo
   call moreio(itape,0,0,a(lt+nc),nb,nw)
   nwtot=nw+lt+nc-1
   ip1=ip
   ip2=ip1+nw/ncyc+1
   if (nb.eq.0) ip2=ip2+2
   go to 110

   !--yes.  interpolate for desired value
  120 int=lep
   if (int.eq.1) idis=1
   call terp1(xlast,ylast,a(ln),a(ln+i6),x,y6,int)
   xnext=a(ln)
   if ((ln+ncyc).gt.nwtot.and.nb.eq.0) return
   xn=a(ln+ncyc)
   if (xn.eq.xnext) idis=1
   return

   !--special branch for x outside range of table
  130 y6=0
   xnext=xlast
   return

   !--special branch for last point
  140 y6=a(ln+i6)
   xlast=big
   xnext=big
   return
   end subroutine gety6

   subroutine fixl7(itape,aa,maa,a,nb,nw)
   !--------------------------------------------------------------------
   ! Convert the TAB2/TAB1 angle-energy structure of File6, law7 to
   ! a simple energy distribution in file6, law1 form for plotting.
   !--------------------------------------------------------------------
   use endf ! provides endf routines and variables
   use util ! provides error
   ! externals
   integer::itape,maa,nb,nw
   real(kr)::aa(*),a(*)
   ! internals
   integer::nmu,imu,ir,loc,ne,loca,nm,loc1,loc2,ip,ie,idis
   real(kr)::ei,emin,emax,de,e,u1,u2,f1,f2,en
   real(kr)::egrid(200)
   real(kr),parameter::etop=1.e10_kr
   real(kr),parameter::span=1.e6_kr

   !--set up angle loop
   call tab2io(itape,0,0,aa,nb,nw)
   ei=aa(2)
   nmu=nint(aa(6))

   !--read all angles for this energy, finding limits
   emin=etop
   emax=0
   loc=1+nmu
   do imu=1,nmu
      aa(imu)=loc
      call tab1io(itape,0,0,aa(loc),nb,nw)
      ir=nint(aa(loc+4))
      if (aa(loc+6+2*ir).lt.emin) emin=aa(loc+6+2*ir)
      loc=loc+nw
      do while (nb.ne.0)
         if (loc.gt.maa) call error('fixl7',&
           'not enough storage to convert file 7',' ')
         call moreio(itape,0,0,aa(loc),nb,nw)
         loc=loc+nw
      enddo
      if (aa(loc-2).gt.emax) emax=aa(loc-2)
   enddo
   if (emin.lt.emax/span) emin=emax/span

   !--set up a secondary energy grid
   !--and do a trapazoidal angle integration for each grid point
   de=(emax-emin)/150
   ne=1
   e=emin
   egrid(ne)=e
   do while (e.lt.emax)
      ne=ne+1
      if (e.lt.emin+10*de) then
         e=e+e/4
         if (e.gt.emin+10*de) e=emin+10*de
      else
         e=e+de
      endif
      egrid(ne)=e
   enddo
   egrid(ne)=emax
   loca=6
   nm=nmu-1
   do imu=1,nm
      loc1=nint(aa(imu))
      loc2=nint(aa(imu+1))
      u1=aa(loc1+1)
      u2=aa(loc2+1)
      ip=2
      ir=1
      do ie=1,ne
         e=egrid(ie)
         call terpa(f1,e,en,idis,aa(loc1),ip,ir)
         call terpa(f2,e,en,idis,aa(loc2),ip,ir)
         if (imu.ne.1) then
            a(loca+2*ie)=a(loca+2*ie)+(u2-u1)*(f1+f2)/2
         else
            a(loca-1+2*ie)=e
            a(loca+2*ie)=(u2-u1)*(f1+f2)/2
         endif
      enddo
   enddo
   a(1)=0
   a(2)=ei
   a(3)=0
   a(4)=0
   a(5)=2*ne
   a(6)=ne

   !--finished
   nw=6+2*ne
   nb=0
   return
   end subroutine fixl7

   subroutine rname(mt,name)
   !--------------------------------------------------------------------
   ! Return the reaction name for an ENDF MT number.
   !--------------------------------------------------------------------
   use endf ! provides iverf
   ! externals
   integer::mt
   character(10)::name
   ! internals
   integer::i
   character(10),dimension(415)::hndf=(/&
     'total     ', 'elastic   ', 'nonelastic', 'inelastic ', '(n,x)     ',&
     '(n,2n_1f) ', '(n,2n_2f) ', '(n,2n_3f) ', '(n,2n_4f) ', '(n,x)     ',&
     '(n,2nd)   ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,2n)    ', '(n,3n)    ', 'fission   ', '(n,f)     ', "(n,n''f)  ",&
     '(n,2nf)   ', "(n,n''a)  ", "(n,n'')3a ", '(n,2n)a   ', '(n,3n)a   ',&
     '(n,2n)iso ', '(n,abs)   ', "(n,n''p)  ", "(n,n''a)  ", '(n,2n)2a  ',&
     '(n,x)     ', "(n,n''d)  ", "(n,n''t)  ", "(n,n''he3)", "(n,n'')d2a",&
     "(n,n'')t2a", '(n,4n)    ', '(n,3nf)   ', '(n,x)     ', '(n,x)     ',&
     '(n,2np)   ', '(n,3np)   ', '(n,n2p)   ', '(n,npa)   ', '(n,x)     ',&
     '(n,2n_1s) ', '(n,2n_2s) ', '(n,2n_3s) ', '(n,2n_4s) ', '(n,x)     ',&
     '(n,n_1)   ', '(n,n_2)   ', '(n,n_3)   ', '(n,n_4)   ', '(n,n_5)   ',&
     '(n,n_6)   ', '(n,n_7)   ', '(n,n_8)   ', '(n,n_9)   ', '(n,n_10)  ',&
     '(n,n_11)  ', '(n,n_12)  ', '(n,n_13)  ', '(n,n_14)  ', '(n,n_15)  ',&
     '(n,n_16)  ', '(n,n_17)  ', '(n,n_18)  ', '(n,n_19)  ', '(n,n_20)  ',&
     '(n,n_21)  ', '(n,n_22)  ', '(n,n_23)  ', '(n,n_24)  ', '(n,n_25)  ',&
     '(n,n_26)  ', '(n,n_27)  ', '(n,n_28)  ', '(n,n_29)  ', '(n,n_30)  ',&
     '(n,n_31)  ', '(n,n_32)  ', '(n,n_33)  ', '(n,n_34)  ', '(n,n_35)  ',&
     '(n,n_36)  ', '(n,n_37)  ', '(n,n_38)  ', '(n,n_39)  ', '(n,n_40)  ',&
     '(n,n_c)   ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', "(n,n'')g  ", '(n,x)     ',&
     '(n,parab) ', '(n,g)     ', '(n,p)     ', '(n,d)     ', '(n,t)     ',&
     '(n,he3)   ', '(n,a)     ', '(n,2a)    ', '(n,3a)    ', '(n,x)     ',&
     '(n,2p)    ', '(n,pa)    ', '(n,t2a)   ', '(n,d2a)   ', '(n,pd)    ',&
     '(n,pt)    ', '(n,da)    ', '(n,x)     ', '(n,x)     ', '(n,dest)  ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ',&
     '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,x)     ', '(n,p_0)   ',&
     '(n,p_1)   ', '(n,p_2)   ', '(n,p_3)   ', '(n,p_4)   ', '(n,p_5)   ',&
     '(n,p_6)   ', '(n,p_7)   ', '(n,p_8)   ', '(n,p_9)   ', '(n,p_10)  ',&
     '(n,p_11)  ', '(n,p_12)  ', '(n,p_13)  ', '(n,p_14)  ', '(n,p_15)  ',&
     '(n,p_16)  ', '(n,p_17)  ', '(n,p_18)  ', '(n,p_19)  ', '(n,p_20)  ',&
     '(n,p_21)  ', '(n,p_22)  ', '(n,p_23)  ', '(n,p_24)  ', '(n,p_25)  ',&
     '(n,p_26)  ', '(n,p_27)  ', '(n,p_28)  ', '(n,p_29)  ', '(n,p_30)  ',&
     '(n,p_31)  ', '(n,p_32)  ', '(n,p_33)  ', '(n,p_34)  ', '(n,p_35)  ',&
     '(n,p_36)  ', '(n,p_37)  ', '(n,p_38)  ', '(n,p_39)  ', '(n,p_40)  ',&
     '(n,p_41)  ', '(n,p_42)  ', '(n,p_43)  ', '(n,p_44)  ', '(n,p_45)  ',&
     '(n,p_46)  ', '(n,p_47)  ', '(n,p_48)  ', '(n,p_c)   ', '(n,d_0)   ',&
     '(n,d_1)   ', '(n,d_2)   ', '(n,d_3)   ', '(n,d_4)   ', '(n,d_5)   ',&
     '(n,d_6)   ', '(n,d_7)   ', '(n,d_8)   ', '(n,d_9)   ', '(n,d_10)  ',&
     '(n,d_11)  ', '(n,d_12)  ', '(n,d_13)  ', '(n,d_14)  ', '(n,d_15)  ',&
     '(n,d_16)  ', '(n,d_17)  ', '(n,d_18)  ', '(n,d_19)  ', '(n,d_20)  ',&
     '(n,d_21)  ', '(n,d_22)  ', '(n,d_23)  ', '(n,d_24)  ', '(n,d_25)  ',&
     '(n,d_26)  ', '(n,d_27)  ', '(n,d_28)  ', '(n,d_29)  ', '(n,d_30)  ',&
     '(n,d_31)  ', '(n,d_32)  ', '(n,d_33)  ', '(n,d_34)  ', '(n,d_35)  ',&
     '(n,d_36)  ', '(n,d_37)  ', '(n,d_38)  ', '(n,d_39)  ', '(n,d_40)  ',&
     '(n,d_41)  ', '(n,d_42)  ', '(n,d_43)  ', '(n,d_44)  ', '(n,d_45)  ',&
     '(n,d_46)  ', '(n,d_47)  ', '(n,d_48)  ', '(n,d_c)   ', '(n,t_0)   ',&
     '(n,t_1)   ', '(n,t_2)   ', '(n,t_3)   ', '(n,t_4)   ', '(n,t_5)   ',&
     '(n,t_6)   ', '(n,t_7)   ', '(n,t_8)   ', '(n,t_9)   ', '(n,t_10)  ',&
     '(n,t_11)  ', '(n,t_12)  ', '(n,t_13)  ', '(n,t_14)  ', '(n,t_15)  ',&
     '(n,t_16)  ', '(n,t_17)  ', '(n,t_18)  ', '(n,t_19)  ', '(n,t_20)  ',&
     '(n,t_21)  ', '(n,t_22)  ', '(n,t_23)  ', '(n,t_24)  ', '(n,t_25)  ',&
     '(n,t_26)  ', '(n,t_27)  ', '(n,t_28)  ', '(n,t_29)  ', '(n,t_30)  ',&
     '(n,t_31)  ', '(n,t_32)  ', '(n,t_33)  ', '(n,t_34)  ', '(n,t_35)  ',&
     '(n,t_36)  ', '(n,t_37)  ', '(n,t_38)  ', '(n,t_39)  ', '(n,t_40)  ',&
     '(n,t_41)  ', '(n,t_42)  ', '(n,t_43)  ', '(n,t_44)  ', '(n,t_45)  ',&
     '(n,t_46)  ', '(n,t_47)  ', '(n,t_48)  ', '(n,t_c)   ', '(n,he3_0) ',&
     '(n,he3_1) ', '(n,he3_2) ', '(n,he3_3) ', '(n,he3_4) ', '(n,he3_5) ',&
     '(n,he3_6) ', '(n,he3_7) ', '(n,he3_8) ', '(n,he3_9) ', '(n,he3_10)',&
     '(n,he3_11)', '(n,he3_12)', '(n,he3_13)', '(n,he3_14)', '(n,he3_15)',&
     '(n,he3_16)', '(n,he3_17)', '(n,he3_18)', '(n,he3_19)', '(n,he3_20)',&
     '(n,he3_21)', '(n,he3_22)', '(n,he3_23)', '(n,he3_24)', '(n,he3_25)',&
     '(n,he3_26)', '(n,he3_27)', '(n,he3_28)', '(n,he3_29)', '(n,he3_30)',&
     '(n,he3_31)', '(n,he3_32)', '(n,he3_33)', '(n,he3_34)', '(n,he3_35)',&
     '(n,he3_36)', '(n,he3_37)', '(n,he3_38)', '(n,he3_39)', '(n,he3_40)',&
     '(n,he3_41)', '(n,he3_42)', '(n,he3_43)', '(n,he3_44)', '(n,he3_45)',&
     '(n,he3_46)', '(n,he3_47)', '(n,he3_48)', '(n,he3_c) ', '(n,a_0)   ',&
     '(n,a_1)   ', '(n,a_2)   ', '(n,a_3)   ', '(n,a_4)   ', '(n,a_5)   ',&
     '(n,a_6)   ', '(n,a_7)   ', '(n,a_8)   ', '(n,a_9)   ', '(n,a_10)  ',&
     '(n,a_11)  ', '(n,a_12)  ', '(n,a_13)  ', '(n,a_14)  ', '(n,a_15)  ',&
     '(n,a_16)  ', '(n,a_17)  ', '(n,a_18)  ', '(n,a_19)  ', '(n,a_20)  ',&
     '(n,a_21)  ', '(n,a_22)  ', '(n,a_23)  ', '(n,a_24)  ', '(n,a_25)  ',&
     '(n,a_26)  ', '(n,a_27)  ', '(n,a_28)  ', '(n,a_29)  ', '(n,a_30)  ',&
     '(n,a_31)  ', '(n,a_32)  ', '(n,a_33)  ', '(n,a_34)  ', '(n,a_35)  ',&
     '(n,a_36)  ', '(n,a_37)  ', '(n,a_38)  ', '(n,a_39)  ', '(n,a_40)  ',&
     '(n,a_41)  ', '(n,a_42)  ', '(n,a_43)  ', '(n,a_44)  ', '(n,a_45)  ',&
     '(n,a_46)  ', '(n,a_47)  ', '(n,a_48)  ', '(n,a_c)   ',&
     'free gas  ', 'H(H2O)    ', 'poly      ', '          ',&
     'H(ZrH) inc', 'H(ZrH) coh', 'benzine   ', 'D(D2O)    ',&
     'graph inc ', 'graph coh ', 'Be inc    ', 'Be coh    ',&
     'BeO inc   ', 'BeO coh   ', 'Zr(ZrH)inc', 'Zr(ZrH)coh'/)
   character(10)::h719='(n,p_c)x  '
   character(10)::h739='(n,d_c)x  '
   character(10)::h759='(n,t_c)x  '
   character(10)::h779='(n,he3_c)x'
   character(10)::h799='(n,a_c)x  '
   character(10),dimension(7)::hndf9=(/&
     '(n,xn)    ', '(n,xg)    ', '(n,xp)    ', '(n,xd)    ',&
     '(n,xt)    ', '(n,xhe3)  ','(n,xa)    '/)
   character(10)::h301='heating   '
   character(10)::h443='kerma     '
   character(10)::h444='damage    '
   character(10)::h251='mubar     '
   character(10)::h252='xi        '
   character(10)::h253='gamma     '

   if (iverf.ge.6) then
      i=mt
      if (i.ge.201.and.i.le.207) i=i+200
      if (i.ge.600) i=i-450
      name=hndf(i)
      if (mt.ge.221.and.mt.le.236) name=hndf(408+mt-221)
      if (mt.eq.251) name=h251
      if (mt.eq.252) name=h252
      if (mt.eq.253) name=h253
      if (mt.eq.301) name=h301
      if (mt.eq.443) name=h443
      if (mt.eq.444) name=h444
   else
      if (mt.lt.150) then
         name=hndf(mt)
      else if (mt.ge.201.and.mt.le.207) then
         name=hndf(mt+200)
      else if (mt.ge.221.and.mt.le.236) then
         name=hndf(408+mt-221)
      else if (mt.ge.700.and.mt.lt.718) then
         name=hndf(mt-550)
      else if (mt.eq.718) then
         name=hndf(199)
      else if (mt.eq.719) then
         name=h719
      else if (mt.ge.720.and.mt.lt.738) then
         name=hndf(mt-520)
      else if (mt.eq.738) then
         name=hndf(249)
      else if (mt.eq.739) then
         name=h739
      else if (mt.ge.740.and.mt.lt.758) then
         name=hndf(mt-490)
      else if (mt.eq.758) then
         name=hndf(299)
      else if (mt.eq.759) then
         name=h759
      else if (mt.ge.760.and.mt.lt.779) then
         name=hndf(mt-460)
      else if (mt.eq.778) then
         name=hndf(349)
      else if (mt.eq.779) then
         name=h779
      else if (mt.ge.780.and.mt.lt.798) then
         name=hndf(mt-430)
      else if (mt.eq.798) then
         name=hndf(399)
      else if (mt.eq.799) then
         name=h799
      else if (mt.eq.301) then
         name=h301
      else if (mt.eq.443) then
         name=h444
      else if (mt.eq.444) then
         name=h443
      else if (mt.eq.251) then
         name=h251
      else if (mt.eq.252) then
         name=h252
      else if (mt.eq.253) then
         name=h253
      else
         name='unknown   '
      endif
   endif
   return
   end subroutine rname

end module plotm

module acem
   ! provides acer for NJOY2016
     use locale
     implicit none

contains

   subroutine acer
   !--------------------------------------------------------------------
   !
   ! Prepare a data library for MCNP,
   ! the Los Alamos continuous energy Monte Carlo code.
   !
   !    --- continuous (fast) data ---
   !
   ! Reaction cross sections are reconstructed on the grid of the
   ! total cross section from the input pendf tape (assumed to be
   ! linearized and unionized).  Redundant reactions (except for
   ! MT1, MT452, and reactions needed for photon yields) are
   ! removed.  MT18 is considered redundant if MT19 is present.
   ! Angular distributions are converted into either 32 equally
   ! probable bins, or into cummulative probability distributions.
   ! Tabulated energy distributions are converted into "law 4"
   ! probability distributions.  Analytic secondary-energy
   ! distributions are converted into their ACE formats.
   ! Coupled energy-angle distributions (File 6) are converted
   ! into ACE laws.  The old format supports law44 for tabulated
   ! data with Kalbach systematics, law67 for angle-energy data,
   ! and law66 for phase space.  The newer format adds law61 with
   ! with cummulative angle distributions for Legendre or tabulated
   ! distributions (see newfor).  All photon production cross
   ! sections are combined on the cross section energy grid.
   ! If provided, multigroup photon production data is summed
   ! and converted into a set of equally probable emission
   ! energies for each input group.  Detailed photon production
   ! data can be generated directly from Files 12, 13, 14, 15,
   ! and 16 from the input ENDF tapes and written out using the
   ! "law 4" cummulative energy distribution format.
   !
   !    --- thermal data ---
   !
   ! The data from the pendf tape as prepared by the thermr
   ! module is read in.  Inelastic and incoherent elastic cross
   ! sections are stored directly.  Coherent elastic cross
   ! sections are converted to a cummulative "stair step" form
   ! and stored.  The angular representation for incoherent
   ! elastic is stored directly.  None is needed for coherent
   ! elastic.  The incoherent inelastic energy distributions
   ! are converted into probability bins with the equally
   ! probable angles left unchanged.  The bins can have equal
   ! probabilities or variable probabilities.  In the latter
   ! case, outlying bins with smaller probabilities are provided
   ! to extend the sampling to rare events.  A new tabulated option
   ! uses a continuous tabulated probability distribution (pdf/cdf)
   ! (requires a MCNP5.1.50 or later) and provides extended
   ! plotting.
   !
   !    --- dosimetry data ---
   !
   ! ENDF cross sections for dosimetry reactions are simply
   ! stored in ACE format without changing the energy grid.
   ! The endf interpolation law is also provided.
   !
   !    --- photoatomic data ---
   !
   ! Photon interaction cross sections are stored on the grid of
   ! the total cross section.  The coherent form factor is
   ! stored together with an integral over the form factor that
   ! is used in sampling for coherent scattering.  The
   ! incoherent scattering function is simply stored.  Photon
   ! heating is calculated from the incoherent scattering data,
   ! the pair production data, and the photoelectric absorption
   ! data.  The input photoatomic data file is mounted on nendf.
   ! Fluorescence data can be generated from an atomic relaxation
   ! data file in ENDF format mounted on npend.
   !
   !    --- photonuclear data ---
   !
   ! Photonuclear data are processed from new evaluations now
   ! available in ENDF format using a new ACE format developed
   ! for MCNP and MCNPX.
   !
   !    --- particle production ---
   !
   ! With the new format (see newfor), for charged particles, and
   ! for photonuclear data, new sections are written describing the
   ! distributions of light particles produced that are different
   ! from the incident particle.
   !
   !    --- incident charged particles ---
   !
   ! Incident charged particles are automatically recognized from
   ! the input tape.
   !
   !    --- mcnpx format ---
   !
   ! MCNPX format is given to support a proposed extension of
   ! the zaid indentifier that uses three digits and two letters
   ! to the right of the decimal.  This will increase flexibility
   ! for handling exotic particles and provide more space for
   ! different data versions.  To request MCNPX format, set the
   ! value of iopt negative.
   !
   !    --- output ---
   !
   ! The ACE output file can be Type 1 (formatted) or Type 2
   ! (f77 binary).  Type 3 is no longer used.  A line of file
   ! directory information is also written.  It must normally
   ! be edited to tell the system the path to the file.  ACER
   ! can also be used to print, edit, or convert the mode of
   ! existing ACE-format files.
   !
   !---input specifications (free format)---------------------------
   !
   ! card 1
   !    nendf    unit for input endf tape
   !    npend    unit for input pendf tape
   !    ngend    unit for input multigroup photon data
   !    nace     unit for output ace tape
   !    ndir     unit for output mcnp directory
   ! card 2
   !    iopt     type of acer run option
   !               1   fast data
   !               2   thermal data
   !               3   dosimetry data
   !               4   photo-atomic data
   !               5   photo-nuclear data
   !               7   read type 1 ace files to print or edit
   !               8   read type 2 ace files to print or edit
   !                set iopt negative for mcnpx format
   !    iprint   print control (0 min, 1 max, default=1)
   !    itype    ace output type (1, 2, or 3, default=1)
   !    suff     id suffix for zaid (default=.00)
   !    nxtra    number of iz,aw pairs to read in (default=0)
   !    izaopt   the zaid option
   !               0   use za in the zaid regardless of the metastable state
   !                   of the nuclide (default)
   !               1   use the metastable zaid rules (MCNP 6.3 or lower):
   !                     - use za for ground state nuclides
   !                     - use za + 300 + s * 100 for metastable
   !                       nuclides
   !                   Am242 and Am242m are exceptions to this rule, for
   !                   these we use 95642 and 95242 respectively
   !             this option only affects fast and photonuclear files when
   !             they are created by acer (iopt = 1 and iopt = 5)
   ! card 3
   !    hk       descriptive character string (70 char max)
   !             delimited by quotes
   ! card 4 (nxtra.gt.0 only)
   !    iz,aw    nxtra pairs of iz and aw
   !
   !    --- fast data (iopt=1 only) ---
   !
   ! card 5
   !    matd     material to be processed
   !    tempd    temperature desired (kelvin) (default=300)
   ! card 6
   !    newfor   use new cumulative angle distributions,
   !               law 61, and outgoing particle distributions.
   !               (0=no, 1=yes, default=1)
   !    iopp     detailed photons (0=no, 1=yes, default=1)
   !    ismooth  switch on/off smoothing operation (1/0, default=1=on)
   !               set ismooth to 1 to cause extension of mf6 cm
   !               distributions to lower energies using a sqrt(E)
   !               shape, to extend delayed neutron distributions as
   !               sqrt(E) to lower energies, and to add additional
   !               points above 10 Mev to some fission spectra assuming
   !               an exponential shape.  otherwise, use ismooth=0.
   !               NOTE:  ismooth=0 is the default value in njoy99.
   ! card 7
   !  type of thinning is determined by sign of thin(1)
   !  (pos. or zero/neg.=energy skip/integral fraction)
   !  (all entries defaulted=no thinning)
   !    thin(1)  e1 energy below which to use all energies (ev)
   !             or iwtt weighting option (1=flat,2=1/e)
   !             (1/e actually has weight=10 when e lt .1)
   !    thin(2)  e2 energy above which to use all energies
   !             or target number of points
   !    thin(3)  iskf skip factor--use every iskf-th energy
   !             between e1 and e2, or rsigz reference sigma zero
   !
   !   --- thermal data (iopt=2 only) ---
   !
   ! card 8
   !    matd     material to be processed
   !    tempd    temperature desired (kelvin) (default=300)
   !    tname    thermal zaid name ( 6 char max, def=za)
   !    nza      number of moderator component za values (default=3, max=16)
   ! card 8a
   !    iza      moderator component za values (up to a maximum of 16 values,
   !             must be terminated by /)
   ! card 9
   !    mti      mt for thermal incoherent data
   !    nbint    number of bins for incoherent scattering
   !    mte      mt for thermal elastic data
   !    ielas    0/1/2=coherent elastic/incoherent elastic/mixed elastic
   !    nmix     number of atom types in mixed moderator
   !             (default=1, not mixed)
   !             (example, 2 for beo or c6h6)
   !    emax     maximum energy for thermal treatment (ev)
   !             (default=1000.=determined from mf3, mti)
   !    iwt      weighting option
   !             0/1/2=variable/constant/tabulated (default=variable)
   !
   !   --- dosimetry data (iopt=3 only) ---
   !
   ! card 10
   !    matd     material to be processed
   !    tempd    temperature desired (kelvin) (default=300)
   !
   !   --- photo-atomic data (iopt=4 only) ---
   !
   ! card 11
   !    matd     material to be processed
   !             photoatomic data on nendf
   !             atomic relaxation data on npend
   !
   !   --- photo-nuclear data (iopt=5 only) ---
   !
   ! card 11
   !    matd     material to be processed
   !
   !   --- print or edit existing files (iopt=7-9) ---
   !
   !    No additional input cards are required.  Mount the old
   !    ace tape on "npend".  The code can modify zaid, hk,
   !    the (iz,aw) list, and the type of the file.  Use suff<0
   !    to leave the old zaid unchanged.  Use just "/" on
   !    card 3 to leave the comment field hk unchanged.  Use
   !    nxtra=0 to leave the old iz,aw list unchanged.  The
   !    code can modify zaid, hk, and type of file.
   !
   !    Exhaustive consistency checks are automatically made on
   !    the input file.  If ngend.ne.0, a set of standard ACE plots
   !    are prepared on unit ngend as plotr input instructions.
   !
   !--------------------------------------------------------------------
   use mainio ! provides nsysi,nsyso
   use util ! provides timer,error
   use acefc ! provides acetop,acefix
   use aceth ! provides acesix,thrfix
   use acepa ! provides acepho,phofix
   use acepn ! provides acephn,phnfix
   use acedo ! provides acedos,dosfix
   use acecm ! provides the xss array

   ! internals
   integer::nendf,npend,ngend,nace,ndir
   integer::iopt,iprint,itype,nxtra,nza,izaoption
   integer::matd
   real(kr)::tempd
   integer::newfor,iopp,ismooth
   real(kr)::thin(4)
   integer::iskf,iwtt,npts
   real(kr)::suff
   character(70)::hk=' '
   integer::izn(16)
   real(kr)::awn(16)
   character(6)::tname,tscr
   integer::mti,nbint,mte,ielas,nmix,iwt
   real(kr)::emax
   real(kr)::time,zaid
   character(13)::hz
   character(3)::ht
   character(9)::str
   integer::mcnpx
   integer::i,nch
   real(kr)::z(3)
   real(kr),parameter::eps=1.e-5_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   real(kr),parameter::two=2

   !--start
   call timer(time)
   write(nsyso,'(/&
     &'' acer...monte carlo neutron and photon data'',&
     &26x,f8.1,''s'')') time
   write(nsyse,'(/'' acer...'',61x,f8.1,''s'')') time

   !--read general user input
   read(nsysi,*) nendf,npend,ngend,nace,ndir
   write(nsyso,'(/&
     &'' input endf unit ...................... '',i10/&
     &'' input pendf unit ..................... '',i10/&
     &'' input gendf unit ..................... '',i10/&
     &'' output ace format unit ............... '',i10/&
     &'' output directory unit ................ '',i10)')&
     nendf,npend,ngend,nace,ndir
   iprint=1
   itype=1
   suff=0
   nxtra=0
   izaoption=0
   read(nsysi,*) iopt,iprint,itype,suff,nxtra,izaoption
   mcnpx=0
   if (iopt.lt.0) then
      mcnpx=1
      iopt=-iopt
   endif
   read(nsysi,*) hk
   do i=1,16
      izn(i)=0
      awn(i)=0
   enddo
   if (nxtra.gt.0) then
      read(nsysi,*) (izn(i),awn(i),i=1,nxtra)
   endif
   write(nsyso,'(/&
     &'' run type option ...................... '',i10/&
     &'' print option (0 min, 1 max) .......... '',i10/&
     &'' type of ace file ..................... '',i10)')&
     iopt,iprint,itype
   if (mcnpx.eq.1) write(nsyso,'(''    mcnpx format requested'')')

   !--read input for fast data option
   if (iopt.eq.1) then
      tempd=300
      read(nsysi,*) matd,tempd
      write(nsyso,'(&
        &'' mat to be processed .................. '',i10/&
        &'' temperature .......................... '',1p,e10.3)')&
        matd,tempd
      iopp=1
      newfor=1
      ismooth=1
      read(nsysi,*) newfor,iopp,ismooth
      write(nsyso,'(&
        &'' new formats .......................... '',i10/&
        &'' photon option ........................ '',i10/&
        &'' smoothing option ..................... '',i10)')&
        newfor,iopp,ismooth
      if (newfor.ne.0.and.newfor.ne.1) then
         call error('acer','illegal newfor.',' ')
      endif
      if (iopp.ne.0.and.iopp.ne.1) then
         call error('acer','illegal iopp.',' ')
      endif
      if (ismooth.ne.0.and.ismooth.ne.1) then
         call error('acer','illegal ismooth.',' ')
      endif
      if (izaoption.ne.0.and.izaoption.ne.1) then
         call error('acer','illegal izaopt.',' ')
      endif
      if (iopp.eq.0) write(nsyso,&
        '(/'' photons will not be processed'')')
      if (ismooth.eq.0) write(nsyso,&
        '(/'' smoothing operation will not be performed'')')
      if (izaoption.eq.1) write(nsyso,&
        '(/'' zaids will be formatted using the metastable za rules'')')
      mte=0
      z(1)=0
      z(2)=0
      z(3)=0
      read(nsysi,*) (z(i),i=1,3)
      thin(1)=abs(z(1))
      thin(2)=z(2)
      thin(3)=z(3)
      thin(4)=0
      if (z(1).ge.zero.and.thin(2).gt.thin(1)) thin(4)=1
      if (z(1).lt.zero) thin(4)=2
      if (thin(4).eq.one) iskf=nint(thin(3))
      if (thin(4).eq.one) write(nsyso,'(&
        &'' energy at which to start thinning .... '',1p,e10.2/&
        &'' energy at which to stop thinning ..... '',e10.2/&
        &'' skip factor .......................... '',i10)')&
        thin(1),thin(2),iskf
      if (thin(4).eq.two) iwtt=nint(thin(1))
      if (thin(4).eq.two) npts=nint(thin(2))
      if (thin(4).eq.two) write(nsyso,'(&
        &'' thinning wt option (1 flat, 2 1/e) ... '',i10/&
        &'' target no. of points ................. '',i10/&
        &'' reference sigma zero ................. '',1p,e10.2)')&
        iwtt,npts,thin(3)

   !--read input for thermal data option
   else if (iopt.eq.2) then
      tempd=300
      tscr=' '
      nza=3
      read(nsysi,*) matd,tempd,tscr,nza
      nch=0
      do i=1,6
         if (tscr(i:i).ne.' ') nch=i
      enddo
      tname='      '
      if (nch.gt.0) tname(7-nch:6)=tscr(1:nch)
      write(nsyso,'(&
        &'' mat to be processed .................. '',i10/&
        &'' temperature .......................... '',1p,e10.3/&
        &'' thermal name ......................... '',4x,a6)')&
        matd,tempd,tname
      if (nza.lt.1.or.nza.gt.16) then
         call error('acer','between 1 and 16 za value must be given.',' ')
      endif
      do i=1,nza
         izn(i)=0
      enddo
      read(nsysi,*) (izn(i),i=1,nza)
      do i=nza,1,-1
         if (izn(i).ne.zero) then
            nza=i
            exit
         endif
      enddo
      write(nsyso,'(&
        &'' number moderator component za values . '',i10/&
        &'' iza   ................................ '',i10/&
        &(40x,i10))') nza,(izn(i),i=1,nza)
      do i=1,nza
         if (izn(i).le.zero) then
            call error('acer','found invalid za numbers in izn.',' ')
         endif
      enddo
      mti=0
      nbint=0
      mte=0
      ielas=0
      nmix=1
      emax=1000
      iwt=0
      read(nsysi,*) mti,nbint,mte,ielas,nmix,emax,iwt
      if (emax.lt.eps) emax=1000
      if (nbint.eq.0) nbint=16
      write(nsyso,'(&
        &'' mt incoherent ........................ '',i10/&
        &'' bins for incoherent scattering ....... '',i10/&
        &'' mt elastic ........................... '',i10/&
        &'' coherent/incoherent elastic flag ..... '',i10/&
        &'' no. atoms in mixed moderator ......... '',i10/&
        &'' max energy for thermal ............... '',f10.3/&
        &'' weight option (0 var, 1 cons, 2 tab) . '',i10)')&
        mti,nbint,mte,ielas,nmix,emax,iwt

   !--read input for dosimetry option
   else if (iopt.eq.3) then
      tempd=300
      read(nsysi,*) matd,tempd

   !--read input for photo-atomic option
   else if (iopt.eq.4) then
      read(nsysi,*) matd
      tempd=0

   !--read input for photo-nuclear option
   else if (iopt.eq.5) then
      read(nsysi,*) matd
      tempd=0

   !--no input required for fix option
   else if (iopt.lt.7.or.iopt.gt.8) then
      call error('acer','illegal iopt.',' ')
   endif

   !--allocate xss array
   allocate(xss(nxss))
   xss=0

   !--prepare fast ace data
   if (iopt.eq.1) then
      call acetop(nendf,npend,ngend,nace,ndir,iprint,itype,mcnpx,suff,&
        hk,izn,awn,matd,tempd,newfor,iopp,ismooth,thin,izaoption)

   !--prepare thermal ace data
   else if (iopt.eq.2) then
      call acesix(npend,nace,ndir,matd,tempd,tname,suff,hk,izn,awn,&
        mti,nbint,mte,ielas,nmix,emax,iwt,iprint,mcnpx)

   !--prepare dosimetry data
   else if (iopt.eq.3) then
      call acedos(matd,tempd,npend,nace,ndir,itype,iprint,mcnpx,&
        suff,hk,izn,awn)

   !--prepare photo-atomic data
   else if (iopt.eq.4) then
      call acepho(nendf,npend,nace,ndir,matd,mcnpx,iprint,itype,&
        suff,hk,izn,awn)

   !--prepare photo-nuclear data
   else if (iopt.eq.5) then
      call acephn(nendf,npend,nace,ndir,matd,tempd,iprint,&
        mcnpx,itype,suff,hk,izn,awn,izaoption)

   !--print or edit ace files
   else if (iopt.ge.7.and.iopt.le.8) then
      itype=iopt-6

      ! read zaid to figure out file type
      if (itype.eq.1) then
         call openz(npend,0)
         if (mcnpx.eq.0) then
            read(npend,'(a10)') hz(1:10)
         else
            read(npend,'(a13)') hz(1:13)
         endif
         call closz(npend)
      else if (itype.eq.2) then
         if (mcnpx.eq.0) then
            read(npend) hz(1:10)
         else
            read(npend) hz(1:13)
         endif
      endif
      if (mcnpx.eq.0) then
         read(hz,'(a9,a1)') str,ht
         if (ht(1:1).ne.'t') then
            read(hz,'(f9.0,a1)') zaid,ht
         endif
      else
         read(hz,'(f10.0,a3)') zaid,ht
      endif

      !--call the appropriate fix routine for this file type
      if (ht(1:1).eq.'c') then
         call acefix(npend,itype,nace,ndir,iprint,ngend,&
           suff,nxtra,hk,izn,awn,mcnpx)
      else if (ht(1:1).eq.'h'.or.ht(1:1).eq.'o'.or.ht(1:1).eq.'r'&
        .or.ht(1:1).eq.'s'.or.ht(1:1).eq.'a') then
         call acefix(npend,itype,nace,ndir,iprint,ngend,&
           suff,nxtra,hk,izn,awn,mcnpx)
      else if (ht(1:1).eq.'t') then
         call thrfix(itype,npend,nace,ndir,iprint,ngend,mcnpx,&
           suff,nxtra,hk,izn,awn)
      else if (ht(1:1).eq.'p') then
         call phofix(itype,npend,nace,ndir,iprint,ngend,mcnpx,&
           suff,nxtra,hk,izn,awn)
      else if (ht(1:1).eq.'u') then
         call phnfix(itype,npend,nace,ndir,iprint,ngend,mcnpx,&
           suff,nxtra,hk,izn,awn)
      else if (ht(1:1).eq.'y') then
         call dosfix(itype,npend,nace,ndir,iprint,ngend,mcnpx,&
           suff,nxtra,hk,izn,awn)
      endif
   endif

   !--deallocate xss array
   deallocate(xss)

   !--acer is finished.
   call timer(time)
   write(nsyso,'(/69x,f8.1,''s''/&
     &1x,7(''**********''),''*******'')') time
   return
   end subroutine acer

end module acem

program njoy
!-----------------------------------------------------------------------
!
!    NJOY Nuclear Data Processing System
!    Version 2016.20
!
!-----------------------------------------------------------------------
!
! NJOY is a system of processing modules intended to convert evaluated
! nuclear data in the ENDF format into forms useful for practical
! applications.  It consists of a number of independent processing
! modules that perform various processing tasks and this main program
! (njoy) that runs the modules in the desired order.  The modules
! currently available are the following:
!
! reconr...reconstruct pointwise cross sections from ENDF/B resonance
!          parameters and interpolation schemes.
!
! broadr...doppler broaden and thin pointwise cross sections.
!
! unresr...compute effective pointwise self-shielded cross sections in
!          the unresolved energy range.
!
! heatr....compute heat production cross sections (kerma) and damage
!          energy production.
!
! thermr...generate neutron scattering cross sections and
!          point-to-point scattering kernels in the thermal range for
!          free or bound atoms.
!
! groupr...generate self-shielded multigroup cross sections and
!          group-to-group scattering and photon production matrices.
!
! gaminr...compute multigroup photon interaction cross sections,
!          scattering matrices, and heat production.
!
! errorr...construct multigroup covariance matrices.
!
! covr.....process covariance data from errorr.
!
! moder....convert between ENDF/B standard coded mode and the njoy
!          blocked binary mode.
!
! dtfr.....output and plot multigroup data for discrete ordinates
!          transport codes.
!
! ccccr....format multigroup data into the CCCC standard interface
!          files ISOTXS, BRKOXS, and DLAYXS.
!
! matxsr...convert multigroup data into the comprehensive MATXS
!          cross section interface format.
!
! resxsr...prepare a CCCC-like file of pointwise resonance
!          cross sections for thermal flux calculations.
!
! acer.....prepare library for the Los Alamos continuous energy
!          Monte Carlo code MCNP.
!
! powr.....convert multigroup data into libraries for the thermal
!          power reactor codes EPRI-CELL and EPRI-CPM.
!
! wimsr....convert multigroup data into libraries for the reactor
!          assembly codes WIMS-D or WIMS-E.
!
! plotr....plot ENDF, PENDF, GENDF, or experimental cross sections,
!          distributions, or matrices.
!
! viewr....view plots from plotr, dtfr, covr, etc. in Postscript.
!
! mixr.....mix file 3 cross sections (for example, to make elemental
!          cross sections) for plotting, etc.
!
! purr.....generate unresolved-resonance probability tables for the
!          MCNP Monte Carlo code.
!
! leapr....generate S(alpha,beta) for thermal moderators.
!
! gaspr....add gas production (MT203-207) to PENDF tape.
!
! Each processing module is implemented as a Fortran-90 module with
! only one public subroutine named as above.  The modules have the
! names as given above with "m" instead of "r".  Processing modules
! communicate through I/O units, and their internal data and
! subroutines are kept private to reduce the possibility of side
! effects between modules.  There are also some modules providing
! common capabilities to all the processing modules:
!
!   module      description
!   ---------   --------------------------------------------
!   version     contains the current version information
!   locale      contains localization parameters
!   mainio      contains the main I/O unit numbers
!   util        contains utility subroutines used by modules
!   endf        contains routines for handling ENDF files
!   math        contains math routines used by other modules
!   physics     contains common physics constants
!
!---input specifications (free format)----------------------------------
!
! card 1       module option
!
!    module    six character module name, e.g., reconr.
!              it is not necessary to use quotes.
!
!          repeat card 1 for each module desired, and
!          use the name "stop" to terminate the program.
!
! See the comments at the start of each module for its specific input
! instructions.
!
!-----------------------------------------------------------------------
   use version ! provides vers,vday
   use locale  ! provides lab,mx
   use mainio  ! provides nsysi,nsyso,nsyse
   use util    ! provides dater,wclock,timer,error
   use endf    ! provides npage,iverf

   use reconm  ! provides reconr
   use broadm  ! provides broadr
   use unresm  ! provides unresr
   use heatm   ! provides heatr
   use thermm  ! provides thermr
   use groupm  ! provides groupr
   use gaminm  ! provides gaminr
   use errorm  ! provides errorr
   use covm    ! provides covr
   use modem   ! provides moder
   use dtfm    ! provides dtfr
   use ccccm   ! provides ccccr
   use matxsm  ! provides matxsr
   use resxsm  ! provides resxsr
   use acem    ! provides acer
   use powm    ! provides powr
   use wimsm   ! provides wimsr
   use plotm   ! provides plotr
   use viewm   ! provides viewr
   use mixm    ! provides mixr
   use purm    ! provides purr
   use leapm   ! provides leapr
   use gaspm   ! provides gaspr

   implicit none
   character(6)::module
   character(8)::date
   character(8)::time
   character(28)::strng
   real(kr)::secs

   !--set page size for blocked binary mode in module endf
   npage=(npage/102)*102

   !--open the NJOY listing file
   !--using nsyso from module mainio
   open(nsyso,file='output')

   !--write njoy banner on main output listing
   !--using information from modules locale and version.
   call dater(date)
   call wclock(time)
   write(nsyso,'(''1'',77(''*'')/ &
    &'' *'',41x,''*'',14x,''*'',18x,''*''/ &
    &'' *'',3x,''$$'',3x,''$$'',7x,''$$'',3x,''$$$$$'',3x, &
    &''$$'',4x,''$$'',3x,''*'',14x,''*'',2x, &
    &''vers: '',a8,2x,''*''/ &
    &'' *'',3x,''$$$'',2x,''$$'',7x,''$$'',2x,''$$$$$$$'',3x, &
    &''$$'',2x,''$$'',4x,''*'',2x,''nuclear'',5x,''*'',2x, &
    &''vday: '',a8,2x,''*''/ &
    &'' *'',3x,''$$$$ $$'',7x,''$$'',2x,''$$'',3x,''$$'',4x, &
    &''$$$$'',5x,''*'',2x,''data'',8x,''*'',2x, &
    &''site: '',a8,2x,''*''/ &
    &'' *'',3x,''$$ $$$$'',2x,''$$'',3x,''$$'',2x,''$$'',3x, &
    &''$$'',5x,''$$'',6x,''*'',2x,''processing'',2x,''*'',2x, &
    &''mach: '',a8,2x,''*''/ &
    &'' *'',3x,''$$'',2x,''$$$'',2x,''$$$$$$$'',2x,''$$$$$$$'', &
    &5x,''$$'',6x,''*'',2x,''system'',6x,''*'',2x, &
    &''date: '',a8,2x,''*''/ &
    &'' *'',3x,''$$'',3x,''$$'',3x,''$$$$$'',4x,''$$$$$'',6x, &
    &''$$'',6x,''*'',14x,''*'',2x, &
    &''time: '',a8,2x,''*''/ &
    &'' *'',41x,''*'',14x,''*'',18x,''*''/ &
    &1x,77(''*''))') vers,vday,lab,mx,date,time

   !--write tty banner on terminal output
   !--using nsyse from module mainio.
   write(nsyse,'(/'' njoy '',a8,1x,a8,38x,a8,1x,a8/ &
    &1x,77(''*''))') vers,vday,date,time

   !--loop over the requested modules
   !--using nsysi from module mainio.
   do
      read(nsysi,*) module
      if (module.eq.'stop') exit
      select case(module)

      case('reconr') ! reconstruct pointwise cross-sections
         call reconr

      case('broadr') ! doppler broaden point cross sections
         call broadr

      case('unresr') ! compute unresolved resonance cross-sections
         call unresr

      case('heatr')  ! compute heating and damage
         call heatr

      case('thermr') ! compute thermal scattering cross sections
         call thermr

      case('groupr')  ! compute self-shielded multigroup cross sections
         call groupr

      case('gaminr') ! compute gamma interaction cross sections.
         call gaminr

      case('errorr') ! compute cross section covariances
         call errorr

      case('covr')   ! process covariance data from errorr
         call covr

      case('moder')  ! change mode of an endf tape
         call moder

      case('dtfr')   ! produce output in dtf format
         call dtfr

      case('ccccr')  ! produce output in cccc-iii interface format
         call ccccr

      case('matxsr') ! produce output in matxs interface format
         call matxsr

      case('resxsr') ! prepare point cross sections for flux calcs
         call resxsr

      case('acer')   ! prepare data for continuous energy monte carlo
         call acer

       case('powr')  ! produce input tapes for epri codes
         call powr

      case('wimsr')  ! produce libraries for wims
         call wimsr

      case('plotr')  ! plot cross sections
         call plotr

      case('viewr')  ! view plots in postscript
         call viewr

      case('mixr')   ! combine cross sections into mixtures or elements
         call mixr

      case('purr')   ! generate unresolved-region probability tables
         call purr

      case('leapr')  ! generate s(alpha,beta) for thermal moderators
         call leapr

      case('gaspr')  ! add gas production (mt203-207) to pendf
         call gaspr

      case ('--')    ! comment card; nothing to do

      case default
         write(strng,'(''illegal module name---'',a6)') module
         call error('njoy',strng,' ')

      end select
   end do

   !--njoy complete
   call timer(secs)
   write(nsyse,'(69x,f8.1,''s''/1x,77(''*''))') secs

end program njoy

module leapm
   ! Provides leapr for NJOY2016.
   use locale
   implicit none
   private
   public leapr

   ! global variables

   ! user's input
   integer::nout
   integer::iprint
   integer::nphon
   integer::mat
   real(kr)::smin
   real(kr)::za
   real(kr)::awr
   real(kr)::spr
   integer::npr
   integer::iel
   integer::nss
   integer::ncold,nsk
   real(kr)::b7
   real(kr)::aws
   real(kr)::sps
   integer::mss
   integer::nalpha,nbeta,lat
   real(kr),dimension(:),allocatable::alpha,beta
   real(kr)::twt,c,tbeta
   real(kr),dimension(:),allocatable::tempr
   integer::np1
   real(kr)::delta1
   real(kr),dimension(:),allocatable::p1
   integer::nd
   real(kr),dimension(:),allocatable::bdel,adel
   integer::nka
   real(kr)::dka
   real(kr),dimension(:),allocatable::ska
   real(kr)::cfrac

   ! other global variables for module
   integer::naint,nbint
   real(kr)::f0,tbar
   real(kr)::arat
   real(kr)::tev,deltab
   real(kr),dimension(:,:,:),allocatable::ssm,ssp
   real(kr),dimension(:),allocatable::dwpix,dwp1
   real(kr),dimension(:),allocatable::tempf,tempf1

   ! min phonon expansion for time warning message
   integer,parameter,public::maxnphon=250

contains

   subroutine leapr
   !--------------------------------------------------------------------
   !
   ! Calculate S(alpha,beta)
   !
   ! Calculates the thermal scattering law, S(alpha,beta), in the
   ! incoherent and gaussian approximations.  The scattering law
   ! for solid-type frequency distributions is calculated using
   ! the phonon expansion method without recourse to the usual
   ! edgewood and sct approximations.  If desired, an analytic
   ! representation of diffusion or free-gas scattering can be
   ! convolved with the solid-type scattering law.  In addition,
   ! up to 50 discrete oscillators can be convolved with the
   ! continuous scattering law.  The results of the calculation
   ! are written out in ENDF-6 File 7 format, ready to be
   ! processed by the thermr module of NJOY.
   !
   ! It is possible to generate S(alpha,beta) for composite
   ! moderators like BeO, where Be in BeO is combined with O in
   ! BeO and normalized to be used with the Be cross section.
   !
   ! Incoherent elastic or coherent elastic scattering functions
   ! can also be included using the ENDF-6 format.  The incoherent
   ! result depends on the Debye-Waller factor computed during the
   ! S(alpha,beta) calculation.  The coherent result is computed
   ! using the methods developed for the thermr module of NJOY
   ! (which were based on the HEXSCAT code).  This scattering
   ! law depends on the Debye-Waller factor from the S(alpha,beta)
   ! calculation, on lattice parameters that are built in to data
   ! statements in the code, and on the coherent scattering cross
   ! section (which is also built in).
   !
   ! A special option exists for liquid hydrogen and deuterium.
   ! A solid-type spectrum and a diffusive spectrum can be given
   ! in the normal way.  The resulting S(alpha,beta) is then
   ! convolved with rotational modes calculated using the method
   ! of Young and Koppel.  Because of the inclusion of spin
   ! correlations, the resulting S(alpha,beta) is not symmetric in
   ! beta, and the lasym option is used in MF7.
   !
   ! This module is loosly based on the British code 'LEAP+ADDELT',
   ! originally written by R.C.F.McLatchie at Harwell (1962,
   ! unpublished), then implemented by A.T.D.Butland at Winfrith
   ! (AEEW 1200, 1973), and finally modified to work better for
   ! cold moderators as part of the thesis of D.J.Picton, now
   ! at the University of Birmingham.  The first ENDF and NJOY
   ! compatible version was prepared by R.E.MacFarlane at
   ! Los Alamos in 1987.  The main changes to the original code
   ! were: 1) the change to NJOY style, 2) the addition of ENDF-6
   ! output, 3) the addition of incoherent elastic output, 4) the
   ! addition of a coherent elastic calculation, 5) a major
   ! speed up of the diffusion calculation by using interpolation
   ! instead of direct recalculation of S-solid(alpha,beta),
   ! and 6) the liquid hydrogen and deuterium treatments.
   ! A second version was prepared by R.E.MacFarlane in 1989 by
   ! removing the Edgewood and SCT approximations in favor of
   ! direct use of the phonon expansion for all phonon orders.
   ! In addition, free gas scattering was added, the code was
   ! simplified and scratch tapes were eliminated.  Thus, the
   ! code takes advantage of the capabilities of large, fast
   ! computers that weren't available to the designers of the
   ! original lEAP code.  This 1992 version changed to using
   ! the asymmetric S(alpha,beta) for better numerics on
   ! short-word machines, added the mixed moderator capability,
   ! rebuilt the discrete-oscillator calculation for better
   ! accuracy, and made many other smaller improvements.
   !
   !----- user input (free format) ---------------------------------
   !
   ! card 1 - units
   !    nout     endf output unit for thermal file
   !
   ! card 2 - title
   !
   ! card 3 - run control
   !    ntempr  number of temperatures (def=1)
   !    iprint  print control (0=min, 1=more, 2=most, def=1)
   !    nphon   phonon-expansion order (def=100)
   !
   ! card 4 - endf output control
   !    mat     endf mat number
   !    za      1000*z+a for principal scatterer
   !    isabt   sab type (0=symmetric, 1=asymmetric, def=0)
   !    ilog    log flag (0=s, 1=log10(s), def=0)
   !    smin    minimum S(alpha, beta) stored in file (def=1e-75)
   !
   ! card 5 - principal scatterer control
   !    awr     weight ratio to neutron for principal scatterer
   !    spr     free atom cross section for principal scatterer
   !    npr     number of principal scattering atoms in compound
   !    iel     coherent elastic option
   !                   0  none (default)
   !                   1  graphite
   !                   2  beryllium
   !                   3  beryllium oxide
   !                   4  aluminum
   !                   5  lead
   !                   6  iron
   !    ncold   cold hydrogen option
   !                   0   none (default)
   !                   1   ortho hydrogen
   !                   2   para hydrogen
   !                   3   otho deuterium
   !                   4   para deuterium
   !    nsk            0   none (default)
   !                   1   vineyard
   !                   2   skold
   !
   ! card 6 - secondary scatterer control
   !    nss     number of secondary scatterers (0 or 1)
   !    b7      secondary scatterer type
   !             (0=sct only, 1=free, 2=diffusion)
   !    aws     weight ratio to neutron for secondary scatterer
   !    sps     free atoms cross section for secondary scatterer
   !    mss     number of atoms of this type in the compound
   !
   ! card 7 - alpha, beta control
   !    nalpha   number of alpha values
   !    nbeta    number of beta values
   !    lat      if lat.eq.1, alpha and beta values are scaled
   !               by .0253/tev, where tev is temp in ev.  (def=0)
   !
   ! card 8 - alpha values (increasing order)
   ! card 9 - beta values (increasing order)
   !
   ! scatterer loop, do temperature loop for principal scatterer.
   !         repeat for secondary scatterer (if any) if b7=0.
   !
   ! temperature loop, repeat cards 10 to 18 for each temperature
   !
   !    card 10 - temperature (k)
   !       a negative value means skip cards 11 to 18,
   !          thereby using previous parameters for this temp.
   !
   !    card 11 -- continuous distribution control
   !       delta    interval in ev
   !       ni       number of points
   !
   !    card 12 -- rho(energy) (order of increasing ev)
   !
   !    card 13 - continuous distribution parameters
   !       twt       translational weight
   !       c         diffusion constant (zero for free gas)
   !       tbeta     normalization for continuous part
   !
   !    card 14 - discrete oscillator control
   !       nd     number of discrete oscillators
   !
   !    card 15 - oscillator energies (ev)
   !    card 16 - oscillator weights (sum to 1.-tbeta-twt)
   !
   !    card 17 - pair correlation control (nsk.ne.0 .or. ncold.ne.0)
   !       nka     number of kappa values
   !       dka     kappa increment (inv. angstroms)
   !
   !    card 18  skappa values in increasing order (inv. ang.)
   !
   !    card 19 - coherent scattering fraction (nsk.ne.0)
   !       cfrac   coherent fraction
   !
   ! card 20 - file 1 comments, repeat until blank line is read.
   !
   !--------------------------------------------------------------------
   use mainio  ! provides nysi,nsyso,nsyse
   use physics ! provides bk (boltzmann constant)
   use util    ! provides timer,openz,error,mess
   ! internals
   integer::itemp,idone,i,ntempr,isabt,ilog,ni,nedge
   integer::isym,mscr,maxb,isecs
   real(kr)::time
   character(4)::title(20)
   character(60)::strng
   real(kr)::temp,emax
   character::text*80
   real(kr),dimension(:),allocatable::bragg
   real(kr),dimension(:),allocatable::scr
   real(kr),parameter::zero=0

   !--initialize
   call timer(time)
   write(nsyso,'(/'' leapr...'',&
     &''compute thermal scattering law'',30x,f8.1,''s'')') time
   write(nsyse,'(/'' leapr...'',60x,f8.1,''s'')') time

   !--read user's global input
   read(nsysi,*) nout
   read(nsysi,*) text
   read(text,'(20a4)') (title(i),i=1,20)
   write(nsyso,'(/5x,20a4)') (title(i),i=1,20)
   ntempr=1
   iprint=1
   nphon=100
   read(nsysi,*) ntempr,iprint,nphon
   isabt=0
   ilog=0
   smin=1.0e-75_kr
   read(nsysi,*) mat,za,isabt,ilog,smin
   write(nsyso,'(/&
     &  '' no. of temperatures .................. '',i10/&
     &  '' print flag ........................... '',i10/&
     &  '' phonon-expansion order ............... '',i10/&
     &  '' endf mat number ...................... '',i10/&
     &  '' za ................................... '',i10/&
     &  '' isabt ................................ '',i10/&
     &  '' ilog ................................. '',i10/&
     &  '' smin.................. ............... '',es10.3)')&
     &  ntempr,iprint,nphon,mat,nint(za),isabt,ilog,smin
   if (isabt.ne.0) write(nsyso,'(/&
     &''*** Warning.  isabt=1 pendf tapes CANNOT be processed '',&
     &''by the NJOY THERMR module ***'')')
   if (isabt.ne.0) call mess('leapr','isabt=1 pendf tapes CANNOT be',&
     'processed by thermr.')
   iel=0
   ncold=0
   nsk=0
   read(nsysi,*) awr,spr,npr,iel,ncold,nsk
   write(nsyso,'(/&
     &  '' awr for principal scatterer .......... '',f10.3/&
     &  '' free xsec for principal scatterer .... '',f10.3/&
     &  '' number of principal atoms ............ '',i10/&
     &  '' elastic option ....................... '',i10/&
     &  '' cold moderator option ................ '',i10/&
     &  '' s(kappa) option ...................... '',i10)')&
     &  awr,spr,npr,iel,ncold,nsk
   b7=0
   aws=0
   sps=0
   mss=0
   read(nsysi,*) nss,b7,aws,sps,mss
   if (nss.gt.0) write(nsyso,'(/&
     &  '' secondary scatterer type ............. '',f10.3/&
     &  '' awr for secondary scatterer .......... '',f10.3/&
     &  '' free xsec for secondary scatterer .... '',f10.3/&
     &  '' number of secondary atoms ............ '',i10)')&
     &  b7,aws,sps,mss
   lat=0
   read(nsysi,*) nalpha,nbeta,lat
   naint=0
   nbint=0
   if (naint.eq.0) naint=1
   if (nbint.eq.0) nbint=1
   allocate(alpha(nalpha))
   allocate(beta(nbeta))
   read(nsysi,*) (alpha(i),i=1,nalpha)
   read(nsysi,*) (beta(i),i=1,nbeta)

   ! warn for excessive computation time
   if (nphon.gt.maxnphon) then
      write(strng,'('' phonon expansion order is larger than '',i3)') maxnphon
      call mess('leapr',strng,'calculation time may be excessive')
   endif

   !--open the output unit
   call openz(nout,1)

   !--allocate storage for ssm (and ssp if needed)
   allocate(ssm(nbeta,nalpha,ntempr))
   if (ncold.ne.0) allocate(ssp(nbeta,nalpha,ntempr))

   !--allocate storage for tempr, dwpix, dwp1, tempf and tempf1
   allocate(tempr(ntempr))
   allocate(dwpix(ntempr))
   allocate(dwp1(ntempr))
   allocate(tempf(ntempr))
   allocate(tempf1(ntempr))

   !--loop over desired scatterers and temperatures
   isecs=0
   arat=1
   idone=0
   do while (idone.eq.0)
      if (isecs.eq.0) write(nsyso,'(/'' principal scatterer...'')')
      if (isecs.gt.0) then
         arat=aws/awr
         write(nsyso,'(/'' secondary scatterer...''/&
           &'' input alpha values divided by'',f7.3)') arat
      endif
      do itemp=1,ntempr
         read(nsysi,*) temp
         tempr(itemp)=abs(temp)
         write(nsyso,'(/'' doing temp ='',f10.2)') temp
         tev=bk*abs(temp)
         if (itemp.eq.1.or.temp.ge.zero) then

            !--read in parameters for a continuous distribution
            read(nsysi,*) delta1,ni
            if (allocated(p1)) deallocate(p1)
            allocate(p1(ni))
            read(nsysi,*) (p1(i),i=1,ni)
            np1=ni
            read(nsysi,*) twt,c,tbeta

            !--read in oscillator data
            read(nsysi,*) nd
            if (nd.gt.0) then
               if (allocated(bdel)) deallocate(bdel)
               if (allocated(adel)) deallocate(adel)
               allocate(bdel(nd))
               allocate(adel(nd))
               read(nsysi,*) (bdel(i),i=1,nd)
               read(nsysi,*) (adel(i),i=1,nd)
            endif

            !--read in pair correlation function, s_kappa
            if ((nsk.gt.0).or.(ncold.gt.0)) then
               read(nsysi,*) nka,dka
               if (allocated(ska)) deallocate(ska)
               allocate(ska(nka))
               read(nsysi,*) (ska(i),i=1,nka)
               if (nsk.eq.1) write(nsyso,'(/'' s(kappa) for vineyard method'')')
               if (nsk.eq.2) write(nsyso,'(/'' s(kappa) for skold method'')')
               do i=1,nka
                  write(nsyso,'(1p,2e12.4)') dka*i,ska(i)
               enddo
            endif

            !--read in coherent fraction for skold method
            if (nsk.gt.0) read(nsysi,*) cfrac

         endif

         !--continuous part of distribution
         call contin(temp,itemp,np1,nphon)

         !--translational part, if any
         if (twt.gt.zero) call trans(itemp)

         !--discrete oscillators, if any
         if (nd.gt.0) call discre(itemp)

         !--check for special hydrogen and deuterium options
         if (ncold.gt.0) call coldh(itemp,temp)

         !--check for skold option for correlations
         if ((nsk.eq.2) .and. (ncold.eq.0))&
            call skold(itemp,temp,ssm,nalpha,nbeta,ntempr)

      !--continue temperature loop
      enddo
      if (allocated(adel)) deallocate(adel)
      if (allocated(bdel)) deallocate(bdel)

      !--save ssm for principal scatterer on scratch file
      if (nss.eq.0.or.b7.gt.zero.or.isecs.gt.0) then
         idone=1
      else
         isecs=isecs+1
         call copys(ssm,nbeta,nalpha,ntempr)
         do itemp=1,ntempr
            tempf1(itemp)=tempf(itemp)
            dwp1(itemp)=dwpix(itemp)
         enddo
      endif
   enddo

   !--construct bragg edges if coherent was requested.
   nedge=0
   if (iel.gt.0) then
      maxb=60000
      allocate(bragg(maxb))
      emax=5
      call coher(iel,npr,bragg,nedge,maxb,emax)
   else
      maxb=1
      allocate(bragg(maxb))
   endif

   !--write output in endf format
   isym=0
   if (ncold.ne.0) isym=1
   if (isabt.eq.1) isym=isym+2
   
   ! Based on endout, to write the actual TSL data, the max number of entries
   ! needed in scr is either 8+2*nalpha, or 8+2*nedge. However, we have no way
   ! of knowing how many comment lines were added to the leaper input. The
   ! previous hard coded limit of 4000 is also used as a possible max as this
   ! has apparently been sufficient to hold all comments in the past.
   mscr = max(8 + 2*nalpha, 8 + 2*nedge, 4000)
   allocate(scr(mscr))
   call endout(ntempr,bragg,nedge,maxb,scr,mscr,isym,ilog)

   deallocate(tempr)
   deallocate(p1)
   deallocate(ssm)
   deallocate(scr)
   if (allocated(ssp)) deallocate(ssp)
   deallocate(alpha)
   deallocate(beta)
   deallocate(dwpix)
   deallocate(dwp1)
   deallocate(tempf)
   deallocate(tempf1)

   !--finished
   call closz(nout)
   call timer(time)
   write(nsyso,'(69x,f8.1,''s''/1x,77(''*''))') time
   return
   end subroutine leapr

   subroutine contin(temp,itemp,np,maxn)
   !--------------------------------------------------------------------
   ! Main routine for calculating S(alpha,beta) at temp
   ! for continuous phonon frequency distributions.
   ! Called by leapr.
   ! Uses start, terpt, convol.
   !--------------------------------------------------------------------
   use physics ! provides pi
   use mainio  ! provides nsyso
   use util    ! provides timer
   ! externals
   real(kr)::temp
   integer::itemp,np,maxn
   ! internals
   integer::i,j,k,n,npn,npl,iprt,jprt
   integer,allocatable,dimension(:)::maxt
   character(3)::tag
   real(kr)::al,be,bel,ex,exx,st,add,sc,alp,alw,ssct,ckk,time
   real(kr)::ff0,ff1,ff2,ff1l,ff2l,sum0,sum1
   real(kr),dimension(:),allocatable::p,tlast,tnow,xa
   real(kr),parameter::therm=0.0253e0_kr
   real(kr),parameter::tiny=1.e-30_kr
   real(kr),parameter::explim=-250.e0_kr
   real(kr),parameter::zero=0

   !--write heading
   write(nsyso,'(/'' solid-type contributions to scattering law'')')

   !--allocate temporary arrays
   allocate(p(np1))
   allocate(tlast(nphon*np1))
   allocate(tnow(nphon*np1))
   allocate(xa(nalpha))
   allocate(maxt(nbeta))

   !--calculate various parameters for this temperature
   call start(itemp,p,np,deltab,tev)
   sc=1
   if (lat.eq.1) sc=therm/tev

   !--start the phonon expansion sum with t1
   do i=1,np
      tlast(i)=p(i)
   enddo
   do j=1,nalpha
      al=alpha(j)*sc/arat
      xa(j)=log(al*f0)
      ex=-f0*al+xa(j)
      exx=0
      if (ex.gt.explim) exx=exp(ex)
      do k=1,nbeta
         be=beta(k)*sc
         st=terpt(p,np,deltab,be)
         add=st*exx
         if (add.lt.tiny) add=0
         ssm(k,j,itemp)=add
      enddo
   enddo
   npl=np

   !--do the phonon expansion sum
   do j=1,nbeta
      maxt(j)=nalpha+1
   enddo
   if (iprint.eq.2) then
      write(nsyso,'(/'' normalization check for phonon expansion'')')
   endif
   if (maxn.gt.maxnphon) then
      call timer(time)
      write(nsyse,'(/'' performing phonon expansion sum'',&
            &37x,f8.1,''s'')'),time
   endif
   do n=2,maxn
      npn=np+npl-1
      call convol(p,tlast,tnow,np,npl,npn,deltab,ckk)
      if (iprint.eq.2) write(nsyso,'(5x,i5,f12.5)') n,ckk
      do j=1,nalpha
         al=alpha(j)*sc/arat
         xa(j)=xa(j)+log(al*f0/n)
         ex=-f0*al+xa(j)
         exx=0
         if (ex.gt.explim) exx=exp(ex)
         do k=1,nbeta
            be=beta(k)*sc
            st=terpt(tnow,npn,deltab,be)
            add=st*exx
            if (add.lt.tiny) add=0
            ssm(k,j,itemp)=ssm(k,j,itemp)+add
            if (ssm(k,j,itemp).ne.zero.and.n.ge.maxn) then
            if (add.gt.ssm(k,j,itemp)/1000.and.j.lt.maxt(k)) maxt(k)=j
            endif
         enddo
      enddo
      do i=1,npn
         tlast(i)=tnow(i)
      enddo
      npl=npn
      if (mod(n,maxnphon).eq.0) then
         call timer(time)
         write(nsyse,'(2x,i5,'' of '',i5,&
               &'' loops done for phonon expansion sum'',17x,f8.1,''s'')')&
               &n,maxn,time
      endif
   enddo
   if (maxn.gt.maxnphon) then
      call timer(time)
      write(nsyse,'(/'' done with phonon expansion sum'',&
            &38x,f8.1,''s'')'),time
   endif

   !--print out start of sct range for each beta
   if (iprint.ne.0) then
      write(nsyso,'(/''         beta   alpha sct'')')
      do i=1,nbeta
         if (i.gt.1) then
            if (maxt(i).gt.maxt(i-1)) maxt(i)=maxt(i-1)
         endif
         if (maxt(i).gt.nalpha) then
            write(nsyso,'(1x,f12.4,''      none'')') beta(i)*sc
         else
            write(nsyso,'(1x,2f12.4)')&
              beta(i)*sc,alpha(maxt(i))*sc/arat
         endif
      enddo
   endif

   !---check the moments of s(alpha,beta)
   if (iprint.eq.1) write(nsyso,&
     '(/'' sab checks''/''      alpha      norm   sum rule'')')
   do j=1,nalpha
      iprt=mod(j-1,naint)+1
      if (j.eq.nalpha) iprt=1
      if (iprt.eq.1) then
         al=alpha(j)*sc/arat
         if (iprint.eq.2) then
            write(nsyso,'(/''  alpha='',f10.4)') al
            write(nsyso,'(5x,''beta'',7x,''s(alpha,beta)'',&
              &6x,''ss(alpha,beta)'',5x,''ss(alpha,-beta)'')')
         endif
         bel=0
         ff1l=0
         ff2l=0
         sum0=0
         sum1=0
         do k=1,nbeta
            jprt=mod(k-1,nbint)+1
            if (k.eq.nbeta) jprt=1
            be=beta(k)*sc
            alw=al*tbeta
            alp=alw*tbar
            ex=-(alw-be)**2/(4*alp)
            ssct=0
            if (ex.gt.explim) ssct=exp(ex)/sqrt(4*pi*alp)
            tag='   '
            if (j.ge.maxt(k)) then
               tag='sct'
               ssm(k,j,itemp)=ssct
            endif
            ff2=ssm(k,j,itemp)
            ff1=ssm(k,j,itemp)*exp(-be)
            ff0=ssm(k,j,itemp)*exp(-be/2)
            if (jprt.eq.1.and.iprint.eq.2.and.ff2.gt.zero)&
              write(nsyso,'(f10.4,1p,e18.5,2e20.5,4x,a3)')&
              be,ff0,ff1,ff2,tag
            if (k.gt.1) then
               sum0=sum0+(be-bel)*(ff1l+ff2l+ff1+ff2)/2
               sum1=sum1+(be-bel)*(ff2l*bel+ff2*be-ff1l*bel-ff1*be)/2
               ff1l=ff1
               ff2l=ff2
               bel=be
            else
               bel=be
               ff1l=ff1
               ff2l=ff2
               sum0=0
               sum1=0
            endif
         enddo
         sum0=sum0/(1-exp(-al*f0))
         sum1=sum1/al/tbeta
         if (iprint.eq.2) then
            write(nsyso,'(''   normalization check ='',f8.4)') sum0
            write(nsyso,'(''        sum rule check ='',f8.4)') sum1
         else if (iprint.eq.1) then
            write(nsyso,'(1x,3f10.4)') al,sum0,sum1
         endif
      endif
   enddo

   !--finished with continuous distribution
   end subroutine contin

   subroutine start(itemp,p,np,deltab,tev)
   !--------------------------------------------------------------------
   ! Computes several integral functions of the
   ! phonon frequency distribution.
   ! Called by contin.
   ! Uses fsum.
   !--------------------------------------------------------------------
   use mainio ! provides nsyso
   ! externals
   integer::itemp,np
   real(kr)::deltab,tev
   real(kr)::p(np)
   ! internals
   integer::i,j,npt
   real(kr)::u,v,vv,tau,an,be,z,ee,bigp,rho,rhoe

   !--copy input spectrum into p array
   deltab=delta1/tev
   do i=1,np1
      p(i)=p1(i)
   enddo
   npt=np1
   u=deltab
   v=exp(deltab/2)
   p(1)=p(2)/deltab**2
   vv=v
   do j=2,np1
      p(j)=p(j)/(u*(vv-1/vv))
      vv=v*vv
      u=u+deltab
   enddo

   !--calculate normalizing constant, an
   tau=1
   tau=tau/2
   an=fsum(1,p,npt,tau,deltab)
   an=an/tbeta
   do i=1,npt
      p(i)=p(i)/an
      be=deltab*(i-1)
      z=exp(be/2)
      rho=p(i)*be*(z-1/z)
   enddo

   !--calculate debye-waller lambda and effective temperature
   f0=fsum(0,p,npt,tau,deltab)
   tbar=fsum(2,p,npt,tau,deltab)/(2*tbeta)

   !--convert p(beta) into t1(beta)
   do i=1,npt
      be=deltab*(i-1)
      p(i)=p(i)*exp(be/2)/f0
   enddo

   !--print out the results
   write(nsyso,'(/'' frequency distribution'')')
   write(nsyso,'(8x,''e'',8x,''rho(e)'',6x,''beta'',&
     & 5x,''rho(beta)'',10x,''bigp'',6x,''t1(beta)'')')
   do i=1,npt
      be=deltab*(i-1)
      ee=be*tev
      z=exp(be/2)
      bigp=p(i)*f0/exp(be/2)
      rho=bigp*be*(z-1/z)
      rhoe=rho*an
      write(nsyso,'(f9.5,1p,e14.4,0p,f10.4,1p,3e14.4)')&
        ee,rhoe,be,rho,bigp,p(i)
   enddo
   dwpix(itemp)=f0
   tempf(itemp)=tbar*tempr(itemp)
   write(nsyso,'(/'' p(beta) is scaled to'',f9.5//&
     &  '' for p-bound only''/&
     &  ''             effective temp = '',f10.3/&
     &  ''        debye-waller lambda='',f10.6)')&
     tbeta,tempf(itemp),f0
   write(nsyso,'(''          factor_ph = '',f10.6)') tbar
   return
   end subroutine start

   real(kr) function fsum(n,p,np,tau,deltab)
   !--------------------------------------------------------------------
   ! Computes integrals over the phonon frequency
   ! of the form
   !    integral 0 to infinity of
   !       2*p*beta**n*hyperbolic
   !    dbeta
   ! where
   !    p is p/beta**2, or rho/(2*beta*sinh(beta/2)), and
   !    'hyperbolic' is cosh(tau*beta) for n even
   !       and sinh(tau*beta) for n odd.
   ! Called by start.
   !--------------------------------------------------------------------
   ! externals
   integer::n,np
   real(kr)::tau,deltab
   real(kr)::p(np)
   ! internals
   integer::ij
   real(kr)::arg,edsq,v,an,be,fs,w,ff

   arg=deltab*tau/2
   edsq=exp(arg)
   v=1
   an=1-2*mod(n,2)
   be=0
   fs=0
   w=1
   do ij=1,np
      if (n.gt.0) w=be**n
      ff=((p(ij)*v)*v+(p(ij)*an/v)/v)*w
      if (ij.eq.1.or.ij.eq.np) ff=ff/2
      fs=fs+ff
      be=be+deltab
      v=v*edsq
   enddo
   fsum=fs*deltab
   return
   end function fsum

   real(kr) function terpt(tn,ntn,delta,be)
   !--------------------------------------------------------------------
   ! Interpolate in a table of t_n(beta) for a required beta.
   ! Called by contin.
   !--------------------------------------------------------------------
   ! externals
   integer::ntn
   real(kr)::delta,be
   real(kr)::tn(ntn)
   ! internals
   integer::i
   real(kr)::bt,btp
   terpt=0
   if (be.gt.ntn*delta) return
   i=int(be/delta)
   if (i.lt.ntn-1) then
      bt=i*delta
      btp=bt+delta
      i=i+1
      terpt=tn(i)+(be-bt)*(tn(i+1)-tn(i))/(btp-bt)
   else
      terpt=0
   endif
   return
   end function terpt

   subroutine convol(t1,tlast,tnext,n1,nl,nn,delta,ckk)
   !--------------------------------------------------------------------
   ! Calculate the next term in the phonon expansion by
   ! convolving t1 with tlast and writing the result in tnext.
   ! The integral of tnext is also checked.
   ! Trapazoidal integration.
   ! Called by start.
   !--------------------------------------------------------------------
   ! externals
   integer::n1,nl,nn
   real(kr)::delta,ckk
   real(kr)::t1(n1),tlast(nl),tnext(nn)
   ! internals
   integer::j,k,i1,i2
   real(kr)::f1,f2,cc,be
   real(kr),parameter::tiny=1.e-30_kr
   real(kr),parameter::zero=0

   ckk=0
   do k=1,nn
      tnext(k)=0
      do j=1,n1
         i1=k+j-2
         i2=k-j
         f1=0
         be=(j-1)*delta
         if (t1(j).gt.zero) then
            if (i1+1.le.nl) f1=tlast(i1+1)*exp(-be)
            f2=0
            if (i2.ge.0.and.i2+1.le.nl) then
               f2=tlast(i2+1)
            else if (i2.lt.0.and.1-i2.le.nl) then
               be=-i2*delta
               f2=tlast(1-i2)*exp(-be)
            endif
            cc=t1(j)*(f1+f2)
            if (j.eq.1.or.j.eq.n1) cc=cc/2
            tnext(k)=tnext(k)+cc
         endif
      enddo
      tnext(k)=tnext(k)*delta
      if (tnext(k).lt.tiny) tnext(k)=0
      cc=tnext(k)
      be=(k-1)*delta
      cc=cc+tnext(k)*exp(-be)
      if (k.eq.1.or.k.eq.nn) cc=cc/2
      ckk=ckk+cc
   enddo
   ckk=ckk*delta
   return
   end subroutine convol

   subroutine trans(itemp)
   !--------------------------------------------------------------------
   ! Controls the addition of a translational contribution
   ! to a continuous S(alpha,beta).  The translational component
   ! can be either diffusion, or a free gas.  The values of the input
   ! s(alpha,beta) for the convolution are obtained by interpolation.
   ! Called by leapr.
   ! Uses stable, sbfill, terps.
   !--------------------------------------------------------------------
   use mainio ! provides nsyso
   use util   ! provides timer
   ! externals
   integer::itemp
   ! internals
   integer::ialpha,ibeta,i,nbt,iprt,jprt,nsd,nu,ndmax
   real(kr)::time,s1,s2,sum0,sum1,ff1,ff2,ff1l,ff2l
   real(kr)::sc,al,deb,ded,delta,f,s,bb,st,be,bel
   real(kr),dimension(:),allocatable::betan,ap,sd,sb
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::c0=.4e0_kr
   real(kr),parameter::c1=1.e0_kr
   real(kr),parameter::c2=1.42e0_kr
   real(kr),parameter::c3=.2e0_kr
   real(kr),parameter::c4=10.e0_kr
   real(kr),parameter::tiny=1.e-30_kr
   real(kr),parameter::zero=0

   !--write heading for translational calculation
   call timer(time)
   write(nsyso,'(/'' translational part of scattering law'',&
     &32x,f8.1,''s'')') time
   sc=1
   if (lat.eq.1) sc=therm/tev

   !---allocate scratch storage
   ndmax=max(nbeta,1000000)
   allocate(betan(nbeta))
   allocate(ap(ndmax))
   allocate(sd(ndmax))
   allocate(sb(ndmax))

   !--alpha loop
   if (iprint.eq.1) write(nsyso,&
     '(/'' sab checks''/''      alpha      norm   sum rule'')')
   do ialpha=1,nalpha
      iprt=mod(ialpha-1,naint)+1
      if (ialpha.eq.nalpha) iprt=1
      al=alpha(ialpha)*sc/arat
      if (iprt.eq.1.and.iprint.eq.2)&
        write(nsyso,'(/'' alpha='',f10.4)') al

      !--choose beta interval for convolution
      ded=c0*(twt*c*al)/sqrt(c1+c2*(twt*c*al)*c)
      if (ded.eq.zero) ded=c3*sqrt(twt*al)
      deb=c4*al*deltab
      delta=deb
      if (ded.lt.delta) delta=ded
      nu=1
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/'' delta d='',e18.5,5x,''delta b='',e18.5,&
        &10x,''delta='',e18.5)') ded,deb,delta

      !--make table of s-diffusion or s-free on this interval
      call stable(ap,sd,nsd,al,delta,iprt,nu,ndmax)
      if (nsd.gt.1) then

         !--copy original ss(-beta) to a temporary array
         do i=1,nbeta
            betan(i)=beta(i)*sc
            ap(i)=ssm(i,ialpha,itemp)
         enddo

         !--loop over beta values
         if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
           '(/'' results after convolution ''/&
           & 4x,'' beta'',7x,''s(alpha,beta)'',6x,''ss(alpha,beta)'',&
           &5x,''ss(alpha,-beta)'')')
         do ibeta=1,nbeta
            jprt=mod(ibeta-1,nbint)+1
            if (ibeta.eq.nbeta) jprt=1
            s=0
            be=betan(ibeta)

            !--prepare table of continuous ss on new interval
            nbt=nsd
            call sbfill(sb,nbt,delta,be,ap,betan,nbeta,ibeta,ndmax)

            !--convolve s-transport with s-continuous
            do i=1,nbt
               f=2*(mod(i-1,2)+1)
               if (i.eq.1.or.i.eq.nbt) f=1
               s=s+f*sd(i)*sb(nbt+i-1)
               bb=(i-1)*delta
               s=s+f*sd(i)*sb(nbt-i+1)*exp(-bb)
            enddo
            s=s*delta/3
            if (s.lt.tiny) s=0
            st=terps(sd,nbt,delta,be)
            if (st.gt.zero) s=s+exp(-al*f0)*st

            !--store results
            ssm(ibeta,ialpha,itemp)=s
            if (s.ne.zero) then
               s1=s*exp(-be/2)
               s2=s*exp(-be)
               if (iprt.eq.1.and.jprt.eq.1.and.iprint.eq.2)&
                 write(nsyso,'(f10.4,1p,e18.5,2e20.5)') be,s1,s2,s
            endif

         !--continue beta loop
         enddo

         !--check moments of calculated s(alpha,beta).
         if (iprt.eq.1) then
            sum0=0
            sum1=0
            ff1l=0
            ff2l=0
            bel=0
            do ibeta=1,nbeta
               be=betan(ibeta)
               ff2=ssm(ibeta,ialpha,itemp)
               ff1=ssm(ibeta,ialpha,itemp)*exp(-be)
               if (ibeta.gt.1) then
                  sum0=sum0+(be-bel)*(ff1l+ff2l+ff1+ff2)/2
                  sum1=sum1+(be-bel)&
                    *(ff2l*bel+ff2*be-ff1l*bel-ff1*be)/2
                  ff1l=ff1
                  ff2l=ff2
                  bel=be
               else
                  bel=be
                  ff1l=ff1
                  ff2l=ff2
                  sum0=0
                  sum1=0
               endif
            enddo
            sum1=sum1/al/(tbeta+twt)
            if (iprint.eq.2) then
               write(nsyso,'(&
                 &''     normalization check ='',f8.4)') sum0
               write(nsyso,'(&
                 &''          sum rule check ='',f8.4)') sum1
            else if (iprint.eq.1) then
               write(nsyso,'(1x,f10.4,2f10.4)') al,sum0,sum1
            endif
         endif
      endif

   !--continue alpha loop
   enddo

   !--update effective temperature
   tempf(itemp)=(tbeta*tempf(itemp)+twt*tempr(itemp))/(tbeta+twt)
   write(nsyso,'(/''     new effective temp = '',f10.3)') tempf(itemp)

   !--deallocate scratch storage
   deallocate(sb)
   deallocate(sd)
   deallocate(ap)
   deallocate(betan)
   return
   end subroutine trans

   subroutine stable(ap,sd,nsd,al,delta,iprt,nu,ndmax)
   !--------------------------------------------------------------------
   ! Sets up table of S-diffusion or S-free in the array sd,
   ! evaluated at intervals delta determined by trans.
   ! Tabulation is continued until
   !       sd(j) is less than 1e-7*sd(1)
   !       or nsd is 1999
   ! Here, nsd is always odd for use with Simpson's rule, and
   ! ap is used for temporary storage of beta values.
   ! This routine returns the -beta side of
   ! the asymmetric S(alpha,beta).
   ! Called by trans.
   ! Uses besk1.
   !--------------------------------------------------------------------
   use mainio ! provide nsyso
   use physics ! provides pi
   ! externals
   integer::nsd,iprt,nu,ndmax
   real(kr)::al,delta,check0,check1,f,bb,sfree
   real(kr)::ap(ndmax),sd(ndmax)
   ! internals
   integer::i,j,idone,icheck
   real(kr)::d,c2,c3,c4,c5,c6,c7,c8,be,ex,wal
   real(kr),parameter::quart=0.25e0_kr
   real(kr),parameter::eps=1.e-7_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1
   icheck=0

   !--diffusion branch
   if (c.ne.zero) then
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/4(4x,''beta'',4x,''ssdiff(-beta)''))')
      d=twt*c
      c2=sqrt(c*c+quart)
      c3=2*d*al
      c4=c3*c3
      c8=c2*c3/pi
      c3=2*d*c*al
      be=0
      j=1
      idone=0
      do while (idone.eq.0)
         c6=sqrt(be*be+c4)
         c7=c6*c2
         if (c7.le.one) c5=c8*exp(c3+be/2)
         if (c7.gt.one) then
            c5=0
            ex=c3-c7+be/2
            c5=c8*exp(ex)
         endif
         sd(j)=c5*besk1(c7)/c6
         ap(j)=be
         be=be+delta
         j=j+1
         if (mod(j,2).eq.0) then
            if (j.ge.ndmax) idone=1
            if (eps*sd(1).ge.sd(j-1)) idone=1
         endif
      enddo
      j=j-1
      nsd=j
      if (iprt.eq.1.and.iprint.eq.2)&
        write(nsyso,'(0pf10.5,1pe15.7,0pf10.5,1pe15.7,0pf10.5,&
        &1pe15.7,0pf10.5,1pe15.7)') (ap(i),sd(i),i=1,j,nu)

   !--free-gas branch
   else
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/4(4x,''beta'',4x,''ssfree(-beta)''))')
      be=0
      j=1
      wal=twt*al
      idone=0
      do while (idone.eq.0)
         ex=-(wal-be)**2/(4*wal)
         sfree=exp(ex)/sqrt(4*pi*wal)
         sd(j)=sfree
         ap(j)=be
         be=be+delta
         j=j+1
         if (mod(j,2).eq.0) then
            if (j.ge.ndmax) idone=1
            if (eps*sd(1).ge.sd(j-1)) idone=1
         endif
      enddo
      j=j-1
      nsd=j
      if (iprt.eq.1.and.iprint.eq.2)&
        write(nsyso,'(0pf10.5,1pe15.7,0pf10.5,1pe15.7,0pf10.5,&
        &1pe15.7,0pf10.5,1pe15.7)') (ap(i),sd(i),i=1,j,nu)
   endif

   !--check the moments of the distribution
   if (iprt.ne.1.or.iprint.ne.2) return
   if (icheck.eq.0) return
   check0=0
   check1=0
   do i=1,nsd
      f=2*(mod(i-1,2)+1)
      if (i.eq.1.or.i.eq.nsd) f=1
      bb=(i-1)*delta
      check0=check0+f*sd(i)
      check0=check0+sd(i)*exp(-bb)
      check1=check1+f*bb*sd(i)
      check1=check1+f*bb*sd(i)*exp(-bb)
   enddo
   check0=check0*delta/3
   check1=check1*delta/3
   check1=check1/(al*twt)
   write(nsyso,'(/'' check0='',f11.7,''   check1='',f11.7)')&
     check0,check1
   return
   end subroutine stable

   real(kr) function terps(sd,nsd,delta,be)
   !--------------------------------------------------------------------
   ! Interpolate in a table of S(alpha,beta) for a required beta.
   ! Used in trans.
   !--------------------------------------------------------------------
   ! externals
   integer::nsd
   real(kr)::delta,be
   real(kr)::sd(nsd)
   ! internals
   integer::i
   real(kr)::bt,btp,st,stp,stt
   real(kr),parameter::slim=-225.e0_kr
   real(kr),parameter::zero=0

   terps=0
   if (be.gt.delta*nsd) return
   i=int(be/delta)
   if (i.lt.nsd-1) then
      bt=i*delta
      btp=bt+delta
      i=i+1
      if (sd(i).le.zero) then
         st=slim
      else
         st=log(sd(i))
      endif
      if (sd(i+1).le.zero) then
         stp=slim
      else
         stp=log(sd(i+1))
      endif
      stt=st+(be-bt)*(stp-st)/(btp-bt)
      terps=0
      if (stt.gt.slim) terps=exp(stt)
      return
   endif
   return
   end function terps

   subroutine sbfill(sb,nbt,delta,be,s,betan,nbeta,nbe,ndmax)
   !--------------------------------------------------------------------
   ! For translational cases only.
   ! Generates s(beta) on a new energy grid for convolution
   ! with a diffusion or free-gas shape.  Interpolation is used.
   ! Called by trans.
   !--------------------------------------------------------------------
   use util    ! provides error
   ! externals
   integer::nbt,nbeta,nbe,ndmax
   real(kr)::delta,be
   real(kr)::sb(ndmax),s(ndmax),betan(nbeta)
   ! internals
   character(60)::strng
   integer::i,j,idone
   real(kr)::bmin,bmax,b,st,stm,arg,bet
   real(kr),parameter::shade=1.00001e0_kr
   real(kr),parameter::slim=-225.e0_kr
   real(kr),parameter::zero=0

   bmin=-be-(nbt-1)*delta
   bmax=-be+(nbt-1)*delta+delta/100
   if ((1+int((bmax-bmin)/delta)).gt.ndmax) then
      write(strng,'(''ndmax needs to be at least '',i6)')&
                    1+int((bmax-bmin)/delta)
      call error('sbfill',strng,' ')
   endif
   j=nbeta
   i=0
   bet=bmin
   do while (bet.le.bmax)
      i=i+1
      b=abs(bet)
      ! search for correct beta range
      idone=0
      do while (idone.eq.0)
         if (b.gt.betan(j)) then
            if (j.eq.nbeta.and.b.lt.shade*betan(j)) then
               idone=1
            else
               if (j.eq.nbeta) then
                  idone=2
               else
                  ! move up
                  j=j+1
               endif
            endif
         else
            if (b.gt.betan(j-1)) then
               idone=1
            else
               if (j.eq.2) then
                  idone=1
               else
                  ! move down
                  j=j-1
               endif
            endif
         endif
      enddo
      ! interpolate in this range
      if (idone.eq.1) then
         if (s(j).le.zero) then
            st=slim
         else
            st=log(s(j))
         endif
         if (s(j-1).le.zero) then
            stm=slim
         else
            stm=log(s(j-1))
         endif
         sb(i)=st+(b-betan(j))*(stm-st)/(betan(j-1)-betan(j))
         if (bet.gt.zero) sb(i)=sb(i)-bet
         arg=sb(i)
         sb(i)=0
         if (arg.gt.slim) sb(i)=exp(arg)
      else
         sb(i)=0
      endif
      ! if delta is to small for the current value of beta, increase it
      do while (bet.eq.(bet+delta))
         delta=delta*10
      end do
      bet=bet+delta
   enddo
   return
   end subroutine sbfill

   real(kr) function besk1(x)
   !--------------------------------------------------------------------
   ! Computes modified Bessel function, K1.
   ! The exponential part for x>1 is omitted (see stable).
   ! Called by stable.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x
   ! internals
   real(kr)::test,v,u,bi1,bi3
   real(kr),parameter::c0=.125e0_kr
   real(kr),parameter::c1=.442850424e0_kr
   real(kr),parameter::c2=.584115288e0_kr
   real(kr),parameter::c3=6.070134559e0_kr
   real(kr),parameter::c4=17.864913364e0_kr
   real(kr),parameter::c5=48.858995315e0_kr
   real(kr),parameter::c6=90.924600045e0_kr
   real(kr),parameter::c7=113.795967431e0_kr
   real(kr),parameter::c8=85.331474517e0_kr
   real(kr),parameter::c9=32.00008698e0_kr
   real(kr),parameter::c10=3.999998802e0_kr
   real(kr),parameter::c11=1.304923514e0_kr
   real(kr),parameter::c12=1.47785657e0_kr
   real(kr),parameter::c13=16.402802501e0_kr
   real(kr),parameter::c14=44.732901977e0_kr
   real(kr),parameter::c15=115.837493464e0_kr
   real(kr),parameter::c16=198.437197312e0_kr
   real(kr),parameter::c17=222.869709703e0_kr
   real(kr),parameter::c18=142.216613971e0_kr
   real(kr),parameter::c19=40.000262262e0_kr
   real(kr),parameter::c20=1.999996391e0_kr
   real(kr),parameter::c21=1.e0_kr
   real(kr),parameter::c22=.5e0_kr
   real(kr),parameter::c23=.5772156649e0_kr
   real(kr),parameter::c24=1.e0_kr
   real(kr),parameter::c25=.0108241775e0_kr
   real(kr),parameter::c26=.0788000118e0_kr
   real(kr),parameter::c27=.2581303765e0_kr
   real(kr),parameter::c28=.5050238576e0_kr
   real(kr),parameter::c29=.663229543e0_kr
   real(kr),parameter::c30=.6283380681e0_kr
   real(kr),parameter::c31=.4594342117e0_kr
   real(kr),parameter::c32=.2847618149e0_kr
   real(kr),parameter::c33=.1736431637e0_kr
   real(kr),parameter::c34=.1280426636e0_kr
   real(kr),parameter::c35=.1468582957e0_kr
   real(kr),parameter::c36=.4699927013e0_kr
   real(kr),parameter::c37=1.2533141373e0_kr

   test=1
   if (x.le.test) then
      v=c0*x
      u=v*v
      bi1=(((((((((c1*u+c2)*u+c3)*u+c4)*u+c5)*u+c6)*u+c7)*u&
        +c8)*u+c9)*u+c10)*v
      bi3=(((((((((c11*u+c12)*u+c13)*u+c14)*u+c15)*u+c16)*u&
        +c17)*u+c18)*u+c19)*u+c20)
      besk1=c21/x+bi1*(log(c22*x)+c23)-v*bi3
   else
      u=c24/x
      bi3=((((((((((((-c25*u+c26)*u-c27)*u+c28)*u-c29)*u+c30)*u&
        -c31)*u+c32)*u-c33)*u+c34)*u-c35)*u+c36)*u+c37)
      besk1=sqrt(u)*bi3
   endif
   return
   end function besk1

   subroutine discre(itemp)
   !--------------------------------------------------------------------
   ! Controls the convolution of discrete oscillators with
   ! the continuous S(alpha,beta) computed in contin.
   ! Called by leapr.
   ! Uses bfact, bfill, exts, sint.
   !--------------------------------------------------------------------
   use mainio  ! provides nsyso
   use util    ! provides timer
   use physics ! provides bk (boltzmann constant)
   ! externals
   integer::itemp
   ! internals
   real(kr)::time,ss,s1,s2,sc,sumn,sumr,st,add,besn,wtsn
   real(kr)::sum0,sum1,bel,ff1,ff2,ff1l,ff2l
   real(kr)::x,db,save,dwc,dwf,al,tbart,wt,be,cn,sn
   real(kr)::tsave,dw0,dwt
   integer::nal,iprt,i,j,k,m,n,ibeta,idone
   integer::jj,nn,jprt,nbx,maxbb,maxdd
   real(kr)::bdeln(50),eb(50),dbw(50),ar(50),dist(50)
   real(kr)::bzero,bplus(50),bminus(50)
   real(kr),dimension(:),allocatable::betan,exb,sexpb
   real(kr),dimension(:),allocatable::bex,rdbex,sex
   real(kr),dimension(:),allocatable::bes,wts,ben,wtn
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::small=1.e-8_kr
   real(kr),parameter::vsmall=1.e-10_kr
   real(kr),parameter::tiny=1.e-20_kr
   real(kr),parameter::zero=0

   !--write heading
   call timer(time)
   write(nsyso,&
     '(/'' discrete-oscillator part of scattering law'',&
     &26x,f8.1,''s'')') time
   sc=1
   if (lat.eq.1) sc=therm/tev

   !--allocate scratch storage
   allocate(betan(nbeta))
   allocate(exb(nbeta))
   allocate(sexpb(nbeta))
   maxbb=2*nbeta+1
   allocate(bex(maxbb))
   allocate(rdbex(maxbb))
   allocate(sex(maxbb))
   maxdd=500
   allocate(bes(maxdd))
   allocate(wts(maxdd))
   allocate(ben(maxdd))
   allocate(wtn(maxdd))

   !--set up oscillator parameters
   dwt=0
   do i=1,nd
      bdeln(i)=bdel(i)/tev
      dwt=dwt+adel(i)
   enddo
   tsave=0
   dw0=dwpix(itemp)
   do i=1,nd
      eb(i)=exp(bdeln(i)/2)
      sn=(eb(i)-1/eb(i))/2
      cn=(eb(i)+1/eb(i))/2
      ar(i)=adel(i)/(sn*bdeln(i))
      dist(i)=adel(i)*bdel(i)*cn/(2*sn)
      tsave=tsave+dist(i)/bk
      dbw(i)=ar(i)*cn
      if (dwpix(itemp).gt.zero) dwpix(itemp)=dwpix(itemp)+dbw(i)
   enddo
   write(nsyso,'(/'' add delta functions''//(5x,i3,1p,2e14.4))')&
     (i,bdeln(i),adel(i),i=1,nd)

   !--prepare functions of beta
   do i=1,nbeta
      be=beta(i)*sc
      exb(i)=exp(-be/2)
      betan(i)=be
   enddo
   call bfill(bex,rdbex,nbx,betan,nbeta,maxbb)
   wt=tbeta
   tbart=tempf(itemp)/tempr(itemp)

   !--main alpha loop
   if (iprint.eq.1) write(nsyso,&
     '(/'' sab checks''/''      alpha      norm   sum rule'')')
   do nal=1,nalpha
      iprt=mod(nal-1,naint)+1
      if (nal.eq.nalpha) iprt=1
      al=alpha(nal)*sc/arat
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/3x,''alpha='',f10.5)') al
      dwf=exp(-al*dw0)
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/''      debye-waller factor='',1p,e12.4)') dwf
      call exts(ssm(1,nal,itemp),sex,exb,betan,nbeta,maxbb)
      do j=1,nbeta
         sexpb(j)=0
      enddo

      !---initialize for delta function calculation
      ben(1)=0
      wtn(1)=1
      nn=1
      n=0

      !--loop over all oscillators
      do i=1,nd
         dwc=al*dbw(i)
         x=al*ar(i)
         call bfact(x,bzero,bplus,bminus,dwc,bdeln(i))

         !--do convolution for the delta functions
         !--n=0 term
         do m=1,nn
            besn=ben(m)
            wtsn=wtn(m)*bzero
            if (besn.le.zero.or.wtsn.ge.small) then
               if (n.lt.maxdd) then
                  n=n+1
                  bes(n)=besn
                  wts(n)=wtsn
               endif
            endif
         enddo

         !--negative n terms
         k=0
         idone=0
         do while (k.lt.50.and.idone.eq.0)
            k=k+1
            if (bminus(k).le.zero) then
               idone=1
            else
               do m=1,nn
                  besn=ben(m)-k*bdeln(i)
                  wtsn=wtn(m)*bminus(k)
                  if (wtsn.ge.small.and.n.lt.maxdd) then
                     n=n+1
                     bes(n)=besn
                     wts(n)=wtsn
                  endif
               enddo
            endif
         enddo

         !--positive n terms
         k=0
         idone=0
         do while (k.lt.50.and.idone.eq.0)
            k=k+1
            if (bplus(k).le.zero) then
               idone=1
            else
               do m=1,nn
                  besn=ben(m)+k*bdeln(i)
                  wtsn=wtn(m)*bplus(k)
                  if (wtsn.ge.small.and.n.lt.maxdd) then
                     n=n+1
                     bes(n)=besn
                     wts(n)=wtsn
                  endif
               enddo
            endif
         enddo

         !--continue oscillator loop
         nn=n
         do m=1,nn
            ben(m)=bes(m)
            wtn(m)=wts(m)
         enddo
         n=0
         wt=wt+adel(i)
         tbart=tbart+dist(i)/bk/tempr(itemp)
      enddo
      n=nn

      !--sort the discrete lines
      !--and throw out the smallest ones
      nn=n-1
      do i=2,n-1
         do j=i+1,n
            if (wts(j).ge.wts(i)) then
               save=wts(j)
               wts(j)=wts(i)
               wts(i)=save
               save=bes(j)
               bes(j)=bes(i)
               bes(i)=save
            endif
         enddo
      enddo
      i=0
      idone=0
      do while (i.lt.nn.and.idone.eq.0)
         i=i+1
         n=i
         if (wts(i).lt.100*small.and.i.gt.5) idone=1
      enddo

      !--report the discrete lines
      if (iprint.ge.2) then
         write(nsyso,'(/''      discrete lines''/&
           &14x,''beta'',6x,''weight'')')
         sumn=0
         sumr=0
         do m=1,n
            write(nsyso,'(6x,f12.4,1p,e12.4)') bes(m),wts(m)
            sumn=sumn+wts(m)
            sumr=sumr-bes(m)*wts(m)
         enddo
         sumr=sumr/al/dwt
         write(nsyso,'(8x,''norm check'',f10.4/&
           &8x,''rule check'',f10.4)')&
           sumn,sumr
      endif

      !--add the continuum part to the scattering law
      do m=1,n
         do j=1,nbeta
            be=-betan(j)-bes(m)
            st=sint(be,bex,rdbex,sex,nbx,al,tbeta+twt,tbart,betan,&
              nbeta,maxbb)
            add=wts(m)*st
            if (add.ge.tiny) sexpb(j)=sexpb(j)+add
         enddo
      enddo

      !--add the delta functions to the scattering law
      !--delta(0.) is saved for the incoherent elastic
      if (twt.le.zero) then
         m=0
         idone=0
         do while (m.lt.n.and.idone.eq.0)
            m=m+1
            if (dwf.lt.vsmall) then
               idone=1
            else
               if (bes(m).lt.zero) then
                  be=-bes(m)
                  if (be.le.betan(nbeta-1)) then
                     db=1000
                     idone=0
                     j=0
                     do while (j.lt.nbeta.and.idone.eq.0)
                        j=j+1
                        jj=j
                        if (abs(be-betan(j)).gt.db) then
                           idone=1
                        else
                           db=abs(be-betan(j))
                        endif
                     enddo
                     if (jj.le.2) then
                        add=wts(m)/betan(jj)
                     else
                        add=2*wts(m)/(betan(jj)-betan(jj-2))
                     endif
                     add=add*dwf
                     if (add.ge.tiny) sexpb(jj-1)=sexpb(jj-1)+add
                  endif
               endif
            endif
         enddo
      endif

      !--record the results
      do j=1,nbeta
         ssm(j,nal,itemp)=sexpb(j)
      enddo
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/4x,'' beta'',7x,''s(alpha,beta)'',7x,''ss(alpha,beta)'',&
        &5x,''ss(alpha,-beta)'')')
      do i=1,nbeta
         be=beta(i)*sc
         ss=ssm(i,nal,itemp)
         s1=ss*exp(-be/2)
         s2=ss*exp(-be)
         jprt=mod(i-1,nbint)+1
         if (i.eq.nbeta) jprt=1
         if (iprt.eq.1.and.jprt.eq.1.and.iprint.eq.2)&
           write(nsyso,'(f10.4,1pe18.5,1p,2e20.5)') betan(i),s1,s2,ss
         enddo

      !--check moments of calculated s(alpha,beta).
      if (iprt.eq.1) then
         sum0=0
         sum1=0
         ff1l=0
         ff2l=0
         bel=0
         do ibeta=1,nbeta
            be=betan(ibeta)
            ff2=ssm(ibeta,nal,itemp)
            ff1=ssm(ibeta,nal,itemp)*exp(-be)
            if (ibeta.gt.1) then
               sum0=sum0+(be-bel)*(ff1l+ff2l+ff1+ff2)/2
               sum1=sum1+(be-bel)*(ff2l*bel+ff2*be-ff1l*bel-ff1*be)/2
               ff1l=ff1
               ff2l=ff2
               bel=be
            else
               bel=be
               ff1l=ff1
               ff2l=ff2
               sum0=0
               sum1=0
            endif
         enddo
         if (twt.eq.zero) sum0=sum0/(1-exp(-al*dwpix(itemp)))
         sum1=sum1/al
         if (iprint.eq.2) then
            write(nsyso,'(''     normalization check ='',f8.4)') sum0
            write(nsyso,'(''          sum rule check ='',f8.4)') sum1
         else if (iprint.eq.1) then
            write(nsyso,'(1x,f10.4,2f10.4)') al,sum0,sum1
         endif
      endif

   !--continue the alpha loop
   enddo

   !--finished
   tempf(itemp)=(tbeta+twt)*tempf(itemp)+tsave
   write(nsyso,'(/&
     &  ''       new effective temp = '',f10.3/&
     &  ''  new debye-waller lambda='',f10.6)')&
     tempf(itemp),dwpix(itemp)
   write(nsyso,'('' discr.-oscill. part of eff. temp = '',f10.3)') tsave
   deallocate(wtn)
   deallocate(ben)
   deallocate(wts)
   deallocate(bes)
   deallocate(sex)
   deallocate(rdbex)
   deallocate(bex)
   deallocate(sexpb)
   deallocate(exb)
   deallocate(betan)
   return
   end subroutine discre

   subroutine bfact(x,bzero,bplus,bminus,dwc,betai)
   !--------------------------------------------------------------------
   ! Calculates the Bessel function terms for discrete oscillators.
   ! Called by discre.
   !--------------------------------------------------------------------
   ! externals
   real(kr)::x,dwc,betai
   real(kr)::bzero,bplus(50),bminus(50)
   ! internals
   integer::i,imax,j
   real(kr)::bn(50)
   real(kr)::y,u,v,bessi0,bessi1,rat,arg
   real(kr),parameter::c0=3.75e0_kr
   real(kr),parameter::c1=1.e0_kr
   real(kr),parameter::c2=3.5156229e0_kr
   real(kr),parameter::c3=3.0899424e0_kr
   real(kr),parameter::c4=1.2067492e0_kr
   real(kr),parameter::c5=0.2659732e0_kr
   real(kr),parameter::c6=0.0360768e0_kr
   real(kr),parameter::c7=0.0045813e0_kr
   real(kr),parameter::c8=0.39894228e0_kr
   real(kr),parameter::c9=0.01328592e0_kr
   real(kr),parameter::c10=0.00225319e0_kr
   real(kr),parameter::c11=0.00157565e0_kr
   real(kr),parameter::c12=0.00916281e0_kr
   real(kr),parameter::c13=0.02057706e0_kr
   real(kr),parameter::c14=0.02635537e0_kr
   real(kr),parameter::c15=0.01647633e0_kr
   real(kr),parameter::c16=0.00392377e0_kr
   real(kr),parameter::c17=0.5e0_kr
   real(kr),parameter::c18=0.87890594e0_kr
   real(kr),parameter::c19=0.51498869e0_kr
   real(kr),parameter::c20=0.15084934e0_kr
   real(kr),parameter::c21=0.02658733e0_kr
   real(kr),parameter::c22=0.00301532e0_kr
   real(kr),parameter::c23=0.00032411e0_kr
   real(kr),parameter::c24=0.02282967e0_kr
   real(kr),parameter::c25=0.02895312e0_kr
   real(kr),parameter::c26=0.01787654e0_kr
   real(kr),parameter::c27=0.00420059e0_kr
   real(kr),parameter::c28=0.39894228e0_kr
   real(kr),parameter::c29=0.03988024e0_kr
   real(kr),parameter::c30=0.00362018e0_kr
   real(kr),parameter::c31=0.00163801e0_kr
   real(kr),parameter::c32=0.01031555e0_kr
   real(kr),parameter::big=1.e10_kr
   real(kr),parameter::tiny=1.e-30_kr
   real(kr),parameter::zero=0
   real(kr),parameter::one=1

   !--compute bessi0
   y=x/c0
   if (y.le.one) then
      u=y*y
      bessi0=c1+u*(c2+u*(c3+u*(c4+u*(c5+u*(c6+u*c7)))))
   else
      v=1/y
      bessi0=(c8+v*(c9+v*(c10+v*(-c11+v*(c12+v*(-c13&
        +v*(c14+v*(-c15+v*c16))))))))/sqrt(x)
   endif

   !--compute bessi1
   if (y.le.one) then
      u=y*y
      bessi1=(c17+u*(c18+u*(c19+u*(c20+u*(c21+u*(c22+u*c23))))))*x
   else
      v=1/y
      bessi1=c24+v*(-c25+v*(c26-v*c27))
      bessi1=c28+v*(-c29+v*(-c30+v*(c31+v*(-c32+v*bessi1))))
      bessi1=bessi1/sqrt(x)
   endif

   !--generate higher orders by reverse recursion
   imax=50
   bn(imax)=0
   bn(imax-1)=1
   i=imax-1
   do while (i.gt.1)
      bn(i-1)=bn(i+1)+i*(2/x)*bn(i)
      i=i-1
      if (bn(i).ge.big) then
         do j=i,imax
            bn(j)=bn(j)/big
         enddo
      endif
   enddo
   rat=bessi1/bn(1)
   do i=1,imax
      bn(i)=bn(i)*rat
      if (bn(i).lt.tiny) bn(i)=0
   enddo

   !--apply exponential terms to bessel functions
   if (y.le.one) then
      bzero=bessi0*exp(-dwc)
      do i=1,imax
         bminus(i)=0
         bplus(i)=0
         if (bn(i).ne.zero) then
            arg=-dwc-i*betai/2
            bplus(i)=0
            bplus(i)=exp(arg)*bn(i)
            if (bplus(i).lt.tiny) bplus(i)=0
            bminus(i)=0
            arg=-dwc+i*betai/2
            bminus(i)=exp(arg)*bn(i)
            if (bminus(i).lt.tiny) bminus(i)=0
         else
            bplus(i)=0
            bminus(i)=0
         endif
      enddo
   else
      bzero=bessi0*exp(-dwc+x)
      do i=1,imax
         bminus(i)=0
         bplus(i)=0
         if (bn(i).ne.zero) then
            bplus(i)=0
            arg=-dwc-i*betai/2+x
            bplus(i)=exp(arg)*bn(i)
            if (bplus(i).lt.tiny) bplus(i)=0
            bminus(i)=0
            arg=-dwc+i*betai/2+x
            bminus(i)=exp(arg)*bn(i)
            if (bminus(i).lt.tiny) bminus(i)=0
         else
            bplus(i)=0
            bminus(i)=0
         endif
      enddo
   endif
   return
   end subroutine bfact

   subroutine bfill(bex,rdbex,nbx,betan,nbetan,maxbb)
   !--------------------------------------------------------------------
   ! Sets up the arrays bex and rdbex used by sint.
   ! Called by discre.
   !--------------------------------------------------------------------
   ! externals
   integer::nbx,nbetan,maxbb
   real(kr)::bex(maxbb),rdbex(maxbb),betan(nbetan)
   ! internals
   integer::i,k,nbxm
   real(kr),parameter::small=1.e-9_kr

   k=nbeta
   do i=1,nbeta
      bex(i)=-betan(k)
      k=k-1
   enddo
   if (betan(1).le.small) then
      bex(nbeta)=0
      k=nbeta+1
   else
      k=nbeta+2
      bex(nbeta+1)=betan(1)
   endif
   do i=2,nbeta
      bex(k)=betan(i)
      k=k+1
   enddo
   nbxm=k-2
   nbx=k-1
   do i=1,nbxm
      rdbex(i)=1/(bex(i+1)-bex(i))
   enddo
   return
   end subroutine bfill

   subroutine exts(sexpb,sex,exb,betan,nbetan,maxbb)
   !--------------------------------------------------------------------
   ! Sets up the array sex for sint.
   ! Here sexpb contains the asymmetric sab for negative beta, and
   ! sex contains the asymmetric sab extended to plus and minus beta.
   ! Called by discre.
   !--------------------------------------------------------------------
   ! externals
   integer::nbetan,maxbb
   real(kr)::sexpb(nbetan),sex(maxbb),exb(maxbb),betan(nbetan)
   ! internals
   integer::i,k
   real(kr),parameter::small=1.e-9_kr

   k=nbeta
   do i=1,nbeta
      sex(i)=sexpb(k)
      k=k-1
   enddo
   if (betan(1).le.small) then
      sex(nbeta)=sexpb(1)
      k=nbeta+1
   else
      k=nbeta+2
      sex(nbeta+1)=sexpb(1)
   endif
   do i=2,nbeta
      sex(k)=sexpb(i)*exb(i)*exb(i)
      k=k+1
   enddo
   return
   end subroutine exts

   real(kr) function sint(x,bex,rdbex,sex,nbx,alph,wt,tbart,&
     betan,nbetan,maxbb)
   !--------------------------------------------------------------------
   ! Interpolates in scattering function, or uses SCT approximation
   ! to extrapolate outside the range in memory.
   ! Called by discre.
   !--------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   integer::nbx,nbetan,maxbb
   real(kr)::x,alph,wt,tbart
   real(kr)::bex(maxbb),rdbex(maxbb),sex(maxbb),betan(nbetan)
   ! internals
   integer::k1,k2,k3,idone
   real(kr)::sv,ex,ss1,ss3
   real(kr),parameter::slim=-225.e0_kr
   real(kr),parameter::zero=0

   !--sct approx
   if (abs(x).gt.betan(nbeta)) then
      if (alph.le.zero) then
         sv=0
      else
         ex=-(wt*alph-abs(x))**2/(4*wt*alph*tbart)
         if (x.gt.zero) ex=ex-x
         sv=exp(ex)/(4*pi*wt*alph*tbart)
      endif
      sint=sv
      return
   endif

   !--interpolation
   k1=1
   k2=nbeta
   k3=nbx
   !  bisect for x
   idone=0
   do while (idone.eq.0)
      if (x.eq.bex(k2)) then
         sv=sex(k2)
         sint=sv
         return
      else if (x.gt.bex(k2)) then
         k1=k2
         k2=(k3-k2)/2+k2
         if (k3-k1.le.1) idone=1
      else
         k3=k2
         k2=(k2-k1)/2+k1
         if (k3-k1.le.1) idone=1
      endif
   enddo
   if (sex(k1).le.zero) then
      ss1=slim
   else
      ss1=log(sex(k1))
   endif
   if (sex(k3).le.zero) then
      ss3=slim
   else
      ss3=log(sex(k3))
   endif
   ex=((bex(k3)-x)*ss1+(x-bex(k1))*ss3)*rdbex(k1)
   sv=0
   if (ex.gt.slim) sv=exp(ex)
   sint=sv
   return
   end function sint

   subroutine coldh(itemp,temp)
   !--------------------------------------------------------------------
   ! Convolve the current solid-type and/or diffusive S(alpha,beta)
   ! with discrete rotational modes for ortho or para hydrogen or
   ! deuterium.   The discrete modes are computed using the formulas
   ! of Young and Koppel for the vibrational ground state with
   ! coding based on contributions from Robert (Grenoble) and
   ! Neef (Julich).  The approach of using solid/diffusive modes
   ! with discrete rotations is based on the work of Keinert and
   ! Sax.  Note that the final S(alpha,beta) is not symmetric in beta.
   !--------------------------------------------------------------------
   use physics ! provides pi,bk,hbar,ev
   use mainio  ! provides nsyso
   use util    ! provides timer
   ! externals
   integer::itemp
   real(kr)::temp
   ! internals
   real(kr)::time,tev,sc,de,x,amassm,bp,sampc,sampi
   real(kr)::snlg,betap,bn,ex,add,snlk,up,down,sn,snorm
   real(kr)::sum0,bel,ff1,ff2,ff1l,ff2l,tmp,total,be
   real(kr)::al,alp,waven,y,sk,swe,swo,wt,tbart,pj
   integer::i,j,k,l,jj,jjmax,jprt,nbx,maxbb
   integer::law,nal,iprt,ipo,jt1,lp,jp,nbe
   real(kr),dimension(:),allocatable::betan,exb
   real(kr),dimension(:),allocatable::bex,rdbex,sex
   real(kr),parameter::pmass=1.6726231e-24_kr
   real(kr),parameter::dmass=3.343586e-24_kr
   real(kr),parameter::deh=0.0147e0_kr
   real(kr),parameter::ded=0.0074e0_kr
   real(kr),parameter::sampch=0.356e0_kr
   real(kr),parameter::sampcd=0.668e0_kr
   real(kr),parameter::sampih=2.526e0_kr
   real(kr),parameter::sampid=0.403e0_kr
   real(kr),parameter::small=1.e-6_kr
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::angst=1.e-8_kr
   integer::ifree=0
   integer::nokap=0
   integer::jterm=3
   real(kr),parameter::zero=0

   !--write header
   call timer(time)
   write(nsyso,'(/'' cold hydrogen or deuterium scattering'',&
     &31x,f8.1,''s'')') time

   !--allocate scratch storage
   allocate(betan(nbeta))
   allocate(exb(nbeta))
   maxbb=2*nbeta+1
   allocate(bex(maxbb))
   allocate(rdbex(maxbb))
   allocate(sex(maxbb))

   !--set up constants
   tev=bk*abs(temp)
   sc=1
   if (lat.eq.1) sc=therm/tev
   law=ncold+1
   de=deh
   if (law.gt.3) de=ded
   x=de/tev
   if (law.gt.3) then
     amassm=6.69E-24_kr
     ! amassm=2*(amassd+amasse)*amu*ev/(clight*clight)
     sampc=sampcd
     bp=hbar/2*sqrt(2/ded/ev/dmass)/angst
     sampi=sampid
   else
     amassm=3.3464e-24_kr
     ! amassm=2*(amassp+amasse)*amu*ev/(clight*clight)
     sampc=sampch
     bp=hbar/2*sqrt(2/deh/ev/pmass)/angst
     sampi=sampih
   endif
   wt=twt+tbeta
   tbart=tempf(itemp)/tempr(itemp)

   !--main alpha loop
   do nal=1,nalpha
      iprt=mod(nal-1,naint)+1
      if (nal.eq.nalpha) iprt=1
      al=alpha(nal)*sc/arat
      alp=wt*al
      waven=angst*sqrt(amassm*tev*ev*al)/hbar
      y=bp*waven
      if (iprt.eq.1) write(nsyso,'(//i4,3x,''alpha='',f10.5)') nal,al
      sk=terpk(ska,nka,dka,waven)
      if (nokap.eq.1) sk=1
      if (iprt.eq.1.and.iprint.eq.2) then
         write(nsyso,'(/'' wave number             ='',f10.4)') waven
         write(nsyso,'('' static structure factor ='',f10.4)') sk
         write(nsyso,'('' oscillators:'')')
      endif

      !--spin-correlation factors
      if (law.eq.2) swe=sampi**2/3
      if (law.eq.2) swo=sk*sampc**2+2*sampi**2/3
      if (law.eq.3) swe=sk*sampc**2
      if (law.eq.3) swo=sampi**2
      if (law.eq.4) swe=sk*sampc**2+5*sampi**2/8
      if (law.eq.4) swo=3*sampi**2/8
      if (law.eq.5) swe=3*sampi**2/4
      if (law.eq.5) swo=sk*sampc**2+sampi**2/4
      snorm=sampi**2+sampc**2
      swe=swe/snorm
      swo=swo/snorm

      !--prepare arrays for sint
      if (nal.eq.1) then
         do i=1,nbeta
            be=beta(i)
            if (lat.eq.1) be=be*therm/tev
            exb(i)=exp(-be/2)
            betan(i)=be
         enddo
         call bfill(bex,rdbex,nbx,betan,nbeta,maxbb)
      endif
      call exts(ssm(1,nal,itemp),sex,exb,betan,nbeta,maxbb)

      !--loop over all beta values
      !    results for positive beta go into ssp
      !    results for negative beta go into ssm
      jjmax=2*nbeta-1
      do jj=1,jjmax
         if (jj.lt.nbeta) k=nbeta-jj+1
         if (jj.ge.nbeta) k=jj-nbeta+1
         be=betan(k)
         if (jj.lt.nbeta) be=-be
         sn=0
         total=0

         !--loop over all oscillators
         ! para-h2: j=0,2,....; ortho-h2: j=1,3,....
         ! ortho-d2: j=0,2,....; para-d2: j=1,3,....
         ipo=1
         if (law.eq.2.or.law.eq.5) ipo=2
         jt1=2*jterm
         if (ipo.eq.2) jt1=jt1+1
         do l=ipo,jt1,2
            j=l-1
            call bt(j,pj,x)

            !--sum over even values of j-prime
            snlg=0
            do lp=1,10,2
               jp=lp-1
               betap=(-j*(j+1)+jp*(jp+1))*x/2
               tmp=(2*jp+1)*pj*swe*4*sumh(j,jp,y)
               if (jj.eq.1.and.tmp.ge.small) then
                  write(nsyso,'(5x,f10.4,2i4,f10.6)') betap,j,jp,tmp
                  total=total+tmp
               endif
               bn=be+betap
               if (ifree.eq.1) then
                  ex=-(alp-abs(bn))**2/(4*alp)
                  if (bn.gt.zero) ex=ex-bn
                  add=exp(ex)/sqrt(4*pi*alp)
               else
                  add=sint(bn,bex,rdbex,sex,nbx,al,wt,tbart,&
                    betan,nbeta,maxbb)
               endif
               snlg=snlg+tmp*add
            enddo

            !--sum over the odd values of j-prime
            snlk=0
            do lp=2,10,2
               jp=lp-1
               betap=(-j*(j+1)+jp*(jp+1))*x/2
               tmp=(2*jp+1)*pj*swo*4*sumh(j,jp,y)
               if (jj.eq.1.and.tmp.ge.small) then
                  write(nsyso,'(5x,f10.4,2i4,f10.6)') betap,j,jp,tmp
                  total=total+tmp
               endif
               bn=be+betap
               if (ifree.eq.1) then
                  ex=-(alp-abs(bn))**2/(4*alp)
                  if (bn.gt.zero) ex=ex-bn
                  add=exp(ex)/sqrt(4*pi*alp)
               else
                  add=sint(bn,bex,rdbex,sex,nbx,al,wt,tbart,&
                    betan,nbeta,maxbb)
               endif
               snlk=snlk+tmp*add
            enddo

            !--continue the j loop
            sn=sn+snlg+snlk
         enddo
         if (jj.eq.1.and.iprt.eq.1) then
            write(nsyso,'(5x,''total'',5x,f10.6)') total
         endif

         !--continue the beta loop
         if (jj.le.nbeta) ssm(k,nal,itemp)=sn
         if (jj.ge.nbeta) ssp(k,nal,itemp)=sn
      enddo

      !--record the results
      if (iprt.eq.1) write(nsyso,&
        '(/4x,'' beta'',7x,''s(alpha,beta)'',7x,&
        &''s(alpha,-beta)'',7x,''ss(alpha,beta)'',&
        &5x,''ss(alpha,-beta)'')')
      do i=1,nbeta
         jprt=mod(i-1,nbint)+1
         if (i.eq.nbeta) jprt=1
         down=ssm(i,nal,itemp)*exb(i)
         up=0
         if (exb(i).ne.zero) up=ssp(i,nal,itemp)/exb(i)
         if (iprt.eq.1.and.jprt.eq.1) write(nsyso,&
           '(f10.4,1p,e18.5,3e20.5)') betan(i),&
           up,down,ssp(i,nal,itemp),ssm(i,nal,itemp)
      enddo

      !--check moments of calculated s(alpha,beta).
      sum0=0
      bel=0
      ff1l=0
      ff2l=0
      do nbe=1,nbeta
         be=betan(nbe)
         ff2=ssm(nbe,nal,itemp)
         ff1=ssp(nbe,nal,itemp)
         if (nbe.ne.1) then
            sum0=sum0+(be-bel)*(ff1l+ff2l+ff1+ff2)/2
            ff1l=ff1
            ff2l=ff2
            bel=be
         else
            bel=be
            ff1l=ff1
            ff2l=ff2
            sum0=0
         endif
      enddo
      write(nsyso,'(''     normalization check ='',f8.4)') sum0

   !--continue the alpha loop
   enddo
   deallocate(sex)
   deallocate(rdbex)
   deallocate(bex)
   deallocate(exb)
   deallocate(betan)
   return
   end subroutine coldh

   subroutine bt(j,pj,x)
   !--------------------------------------------------------------------
   ! Statistical weight factor
   ! for cold hydrogen or deuterium calculation
   !--------------------------------------------------------------------
   ! externals
   integer::j
   real(kr)::pj,x
   ! internals
   integer::i,k
   real(kr)::yy,a,b
   real(kr),parameter::half=0.5e0_kr

   yy=half*j*(j+1)
   a=(2*j+1)*exp(-yy*x)
   b=0
   do i=1,10
      k=2*i-2
      if (mod(j,2).eq.1) k=k+1
      yy=half*k*(k+1)
      b=b+(2*k+1)*exp(-yy*x)
   enddo
   pj=a/(2*b)
   return
   end subroutine bt

   real(kr) function sumh(j,jp,y)
   !--------------------------------------------------------------------
   ! Does sum over Bessel functions and Clebsch-Gordon coefficients
   ! for cold hydrogen or deuterium calculation.
   !--------------------------------------------------------------------
   ! externals
   integer::j,jp
   real(kr)::y
   ! internals
   integer::imk,ipk1,mpk,ipk,n,n1
   real(kr)::sum1,sum2

   if (j.eq.0) then
      sum2=(sjbes(jp,y)*cn(j,jp,jp))**2
   else if (jp.eq.0) then
      sum2=(sjbes(j,y)*cn(j,0,j))**2
   else
      sum1=0
      imk=iabs(j-jp)+1
      ipk1=j+jp+1
      mpk=ipk1-imk
      if (mpk.le.9) then
         ipk=ipk1
      else
         ipk=imk+9
      endif
      do n=imk,ipk
         n1=n-1
         sum1=sum1+(sjbes(n1,y)*cn(j,jp,n1))**2
      enddo
      sum2=sum1
   endif
   sumh=sum2
   return
   end function sumh

   real(kr) function cn(jj,ll,nn)
   !--------------------------------------------------------------------
   ! Clebsch-Gordon coefficients
   ! for cold hydrogen or deuterium calculation
   !--------------------------------------------------------------------
   ! externals
   integer::jj,ll,nn
   ! internals
   integer::i,kdet,kdel,ka1,ka2,ka3,ka4,kb1,kb2,kb3,kb4,iwign
   real(kr)::s,fact,zi,a1,a2,a3,a4,b1,b2,b3,b4,rat,wign
   real(kr),parameter::zero=0

   kdet=(jj+ll+nn)/2
   kdel=jj+ll+nn-2*kdet
   if (kdel.eq.0) then
      ka1=jj+ll+nn
      ka2=jj+ll-nn
      ka3=jj-ll+nn
      ka4=ll-jj+nn
      kb1=ka1/2
      kb2=ka2/2
      kb3=ka3/2
      kb4=ka4/2
      s=0
      fact=1
      do i=1,ka1
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) fact=exp(s)
      a1=sqrt(fact)
      s=0
      fact=1
      do i=1,ka2
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) fact=exp(s)
      a2=sqrt(fact)
      s=0
      fact=1
      do i=1,ka3
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) fact=exp(s)
      a3=sqrt(fact)
      s=0
      fact=1
      do i=1,ka4
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) fact=exp(s)
      a4=sqrt(fact)
      s=0
      b1=1
      do i=1,kb1
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) b1=exp(s)
      s=0
      b2=1
      do i=1,kb2
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) b2=exp(s)
      s=0
      b3=1
      do i=1,kb3
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) b3=exp(s)
      s=0
      b4=1
      do i=1,kb4
         zi=i
         s=s+log(zi)
      enddo
      if (s.gt.zero) b4=exp(s)
      rat=2*nn+1
      rat=rat/(jj+ll+nn+1)
      iwign=(jj+ll-nn)/2
      wign=(-1)**iwign
      wign=wign*sqrt(rat)*b1/a1*a2/b2*a3/b3*a4/b4
   else
      wign=0
   endif
   cn=wign
   return
   end function cn

   real(kr) function sjbes(n,x)
   !--------------------------------------------------------------------
   ! Bessel functions for cold hydrogen or deuterium calculation
   !--------------------------------------------------------------------
   use util ! provides error
   ! externals
   integer::n
   real(kr)::x
   ! internals
   integer::i,k,l,iii,kmax,nm
   real(kr)::w,bessel,y,z,sj,t1,t2,t3
   character(60)::strng
   real(kr),parameter::huge=1.e25_kr
   real(kr),parameter::small=2.e-38_kr
   real(kr),parameter::break1=3.e4_kr
   real(kr),parameter::break2=7.e-4_kr
   real(kr),parameter::break3=0.2e0_kr
   real(kr),parameter::one=1
   real(kr),parameter::ten=10
   real(kr),parameter::hund=100
   real(kr),parameter::zero=0

   !--check for large arguments
   if (n.ge.30000.or.x.gt.break1) then
      write(strng,'(&
        &''value is not accurate  n = '',i7,10x,''x = '',e14.7)') n,x
      call mess('sjbes',strng,' ')
      sjbes=0
      return
   endif

   !--check for bad arguments
   if (x.lt.zero.or.n.lt.0) then
      write(strng,'(&
        &''argument is invalid  n = '',i7,10x,''x = '',e14.7)') n,x
      call error('sjbes',strng,' ')
      sjbes=0
      return
   endif

   !--compute normal values
   if (x.le.break2) then
      w=1
      if (n.eq.0) then
         bessel=w
      else if (n.gt.10) then
         bessel=0
      else
         t1=3
         t2=1
         do i=1,n
            t3=t2*x/t1
            t1=t1+2
            t2=t3
         enddo
         bessel=t3
      endif
   else
      if (x.lt.break3) then
         y=x**2
         w=1-y*(1-y/20)/6
      else
         w=sin(x)/x
      endif
      if (n.eq.0) then
         bessel=w
      else
         if (x.ge.hund) then
            l=int(x/50+18)
         else if (x.ge.ten) then
            l=int(x/10+10)
         else if (x.gt.one) then
            l=int(x/2+5)
         else
            l=5
         endif
         iii=int(x)
         kmax=n
         if (iii.gt.n) kmax=iii
         nm=kmax+l
         z=1/x
         t3=0
         t2=small
         do i=1,nm
            k=nm-i
            t1=(2*k+3)*z*t2-t3
            if (n.eq.k) sj=t1
            if (abs(t1).ge.huge) then
               t1=t1/huge
               t2=t2/huge
               sj=sj/huge
            endif
            t3=t2
            t2=t1
         enddo
         bessel=w*sj/t1
      endif
   endif
   sjbes=bessel
   return
   end function sjbes

   real(kr) function terpk(ska,nka,delta,be)
   !--------------------------------------------------------------------
   ! Interpolate in a table of ska(kappa) for a required kappa.
   ! Called by coldh.
   !--------------------------------------------------------------------
   ! externals
   integer::nka
   real(kr)::ska(nka),delta,be
   ! internals
   integer::i
   real(kr)::bt,btp

   terpk=1
   if (be.gt.nka*delta) return
   i=int(be/delta)
   if (i.lt.nka-1) then
      bt=i*delta
      btp=bt+delta
      i=i+1
      terpk=ska(i)+(be-bt)*(ska(i+1)-ska(i))/(btp-bt)
   endif
   return
   end function terpk

   subroutine copys(sab,nbeta,nalpha,ntempr)
   !--------------------------------------------------------------------
   ! Copy sab for principal scatterer to scratch tape on unit 10.
   !--------------------------------------------------------------------
   use util ! provides openz
   ! externals
   integer::nbeta,nalpha,ntempr
   real(kr)::sab(nbeta,nalpha,ntempr)
   ! internals
   integer::i,j,k,nscr

   nscr=-10
   call openz(nscr,1)
   do k=1,ntempr
      do j=1,nalpha
         write(-nscr) (sab(i,j,k),i=1,nbeta)
      enddo
   enddo
   return
   end subroutine copys

   subroutine coher(lat,natom,b,nbe,maxb,emax)
   !--------------------------------------------------------------------
   ! Compute Bragg energies and associated structure factors
   ! for coherent elastic scattering from graphite, Be, or BeO.
   !--------------------------------------------------------------------
   use mainio  ! provides nsyso
   use physics ! provides pi,hbar,ev,amu,amassn
   use util    ! provides timer,error
   ! externals
   integer::lat,natom,nbe,maxb
   real(kr)::b(maxb),emax
   ! internals
   integer::i,j,k,imax,jmin,idone,ifl,i1m,nw
   integer::i1,i2,i3,l1,l2,l3,i2m,i3m
   real(kr)::time,twopis,amne,econ,tsqx
   real(kr)::a,c,amsc,scoh,c1,c2
   real(kr)::recon,scon,wint,t2,ulim,phi
   real(kr)::w1,w2,w3,tsq,tau,w,f
   real(kr)::x,st,sf,bel,be,bs
   real(kr),parameter::gr1=2.4573e-8_kr
   real(kr),parameter::gr2=6.700e-8_kr
   real(kr),parameter::gr3=12.011e0_kr
   real(kr),parameter::gr4=5.50e0_kr
   real(kr),parameter::be1=2.2856e-8_kr
   real(kr),parameter::be2=3.5832e-8_kr
   real(kr),parameter::be3=9.01e0_kr
   real(kr),parameter::be4=7.53e0_kr
   real(kr),parameter::beo1=2.695e-8_kr
   real(kr),parameter::beo2=4.39e-8_kr
   real(kr),parameter::beo3=12.5e0_kr
   real(kr),parameter::beo4=1.0e0_kr
   real(kr),parameter::al1=4.04e-8_kr
   real(kr),parameter::al3=26.7495e0_kr
   real(kr),parameter::al4=1.495e0_kr
   real(kr),parameter::pb1=4.94e-8_kr
   real(kr),parameter::pb3=207.e0_kr
   real(kr),parameter::pb4=1.e0_kr
   real(kr),parameter::fe1=2.86e-8_kr
   real(kr),parameter::fe3=55.454e0_kr
   real(kr),parameter::fe4=12.9e0_kr
   real(kr),parameter::twothd=0.666666666667e0_kr
   real(kr),parameter::sqrt3=1.732050808e0_kr
   real(kr),parameter::toler=1.e-6_kr
   real(kr),parameter::eps=.05e0_kr
   real(kr),parameter::zero=0

   !--write header
   call timer(time)
   write(nsyso,'(/'' bragg edges for coherent elastic scattering'',&
     &25x,f8.1,''s'')') time

   !--initialize.
   twopis=(2*pi)**2
   amne=amassn*amu
   econ=ev*8*(amne/hbar)/hbar
   recon=1/econ
   tsqx=econ/20
   if (lat.eq.1) then
      ! graphite constants.
      a=gr1
      c=gr2
      amsc=gr3
      scoh=gr4/natom
   else if (lat.eq.2) then
      !  beryllium constants
      a=be1
      c=be2
      amsc=be3
      scoh=be4/natom
   else if (lat.eq.3) then
      !  beryllium oxide constants
      a=beo1
      c=beo2
      amsc=beo3
      scoh=beo4/natom
   else if (lat.eq.4) then
      ! aluminum constants
      a=al1
      amsc=al3
      scoh=al4/natom
   else if (lat.eq.5) then
      ! lead constants
      a=pb1
      amsc=pb3
      scoh=pb4/natom
   else if (lat.eq.6) then
      ! iron constants
      a=fe1
      amsc=fe3
      scoh=fe4/natom
   else
      call error('coh','illegal lat.',' ')
   endif
   if (lat.lt.4) then
      c1=4/(3*a*a)
      c2=1/(c*c)
      scon=scoh*(4*pi)**2/(2*a*a*c*sqrt3*econ)
   else if (lat.ge.4.and.lat.le.5) then
      c1=3/(a*a)
      scon=scoh*(4*pi)**2/(16*a*a*a*econ)
   else if (lat.eq.6) then
      c1=2/(a*a)
      scon=scoh*(4*pi)**2/(8*a*a*a*econ)
   endif
   wint=0
   t2=hbar/(2*amu*amsc)
   ulim=econ*emax
   ifl=1
   nw=maxb

   !--compute lattice factors for hexagonal lattices
   if (lat.gt.3) go to 210
   phi=ulim/twopis
   i1m=int(a*sqrt(phi))
   i1m=i1m+1
   k=0
   do i1=1,i1m
      l1=i1-1
      i2m=int((l1+sqrt(3*(a*a*phi-l1*l1)))/2)
      i2m=i2m+1
      do i2=i1,i2m
         l2=i2-1
         x=phi-c1*(l1*l1+l2*l2-l1*l2)
         i3m=0
         if (x.gt.zero) i3m=int(c*sqrt(x))
         i3m=i3m+1
         do i3=1,i3m
            l3=i3-1
            w1=2
            if (l1.eq.l2) w1=1
            w2=2
            if (l1.eq.0.or.l2.eq.0) w2=1
            if (l1.eq.0.and.l2.eq.0) w2=1
            if (l1.eq.0.and.l2.eq.0) w2=w2/2
            w3=2
            if (l3.eq.0) w3=1
            tsq=tausq(l1,l2,l3,c1,c2,twopis)
            if (tsq.gt.zero.and.tsq.le.ulim) then
               tau=sqrt(tsq)
               w=exp(-tsq*t2*wint)*w1*w2*w3/tau
               f=w*formf(lat,l1,l2,l3)
               if (k.le.0.or.tsq.le.tsqx) then
                  k=k+1
                  if ((2*k).gt.nw) call error('coh',&
                    'storage exceeded',' ')
                  b(ifl+2*k-2)=tsq
                  b(ifl+2*k-1)=f
               else
                  i=0
                  idone=0
                  do while (i.lt.k.and.idone.eq.0)
                     i=i+1
                     if (tsq.ge.b(ifl+2*i-2).and.&
                       tsq.lt.(1+eps)*b(ifl+2*i-2)) then
                           b(ifl+2*i-1)=b(ifl+2*i-1)+f
                        idone=1
                     endif
                  enddo
                  if (idone.eq.0) then
                     k=k+1
                     if ((2*k).gt.nw) call error('coh',&
                       'storage exceeded',' ')
                     b(ifl+2*k-2)=tsq
                     b(ifl+2*k-1)=f
                  endif
               endif
            endif
            tsq=tausq(l1,-l2,l3,c1,c2,twopis)
            if (tsq.gt.zero.and.tsq.le.ulim) then
               tau=sqrt(tsq)
               w=exp(-tsq*t2*wint)*w1*w2*w3/tau
               f=w*formf(lat,l1,-l2,l3)
               if (k.le.0.or.tsq.le.tsqx) then
                  k=k+1
                  if ((2*k).gt.nw) call error('coh',&
                    'storage exceeded',' ')
                  b(ifl+2*k-2)=tsq
                  b(ifl+2*k-1)=f
               else
                  i=0
                  idone=0
                  do while (i.lt.k.and.idone.eq.0)
                     i=i+1
                     if (tsq.ge.b(ifl+2*i-2).and.&
                       tsq.lt.(1+eps)*b(ifl+2*i-2)) then
                        b(ifl+2*i-1)=b(ifl+2*i-1)+f
                        idone=1
                     endif
                  enddo
                  if (idone.eq.0) then
                     k=k+1
                     if ((2*k).gt.nw) call error('coh',&
                       'storage exceeded',' ')
                     b(ifl+2*k-2)=tsq
                     b(ifl+2*k-1)=f
                  endif
               endif
            endif
         enddo
      enddo
   enddo
   imax=k-1
   go to 220

   !--compute lattice factors for fcc lattices
  210 continue
   if (lat.gt.5) go to 215
   phi=ulim/twopis
   i1m=int(a*sqrt(phi))
   i1m=15
   k=0
   do i1=-i1m,i1m
      i2m=i1m
      do i2=-i2m,i2m
         i3m=i1m
         do i3=-i3m,i3m
            tsq=taufcc(i1,i2,i3,c1,twothd,twopis)
            if (tsq.gt.zero.and.tsq.le.ulim) then
               tau=sqrt(tsq)
               w=exp(-tsq*t2*wint)/tau
               f=w*formf(lat,i1,i2,i3)
               k=k+1
               if ((2*k).gt.nw) call error('coh','storage exceeded',' ')
               b(ifl+2*k-2)=tsq
               b(ifl+2*k-1)=f
            endif
         enddo
      enddo
   enddo
   imax=k-1
   go to 220

   !--compute lattice factors for bcc lattices
  215 continue
   phi=ulim/twopis
   i1m=int(a*sqrt(phi))
   i1m=15
   k=0
   do i1=-i1m,i1m
      i2m=i1m
      do i2=-i2m,i2m
         i3m=i1m
         do i3=-i3m,i3m
            tsq=taubcc(i1,i2,i3,twopis)
            if (tsq.gt.zero.and.tsq.le.ulim) then
               tau=sqrt(tsq)
               w=exp(-tsq*t2*wint)/tau
               f=w*formf(lat,i1,i2,i3)
               k=k+1
               if ((2*k).gt.nw) call error('coh','storage exceeded',' ')
               b(ifl+2*k-2)=tsq
               b(ifl+2*k-1)=f
            endif
         enddo
      enddo
   enddo
   imax=k-1

   !--sort lattice factors

  220 continue
   do i=1,imax
      jmin=i+1
      do j=jmin,k
         if (b(ifl+2*j-2).lt.b(ifl+2*i-2)) then
            st=b(ifl+2*i-2)
            sf=b(ifl+2*i-1)
            b(ifl+2*i-2)=b(ifl+2*j-2)
            b(ifl+2*i-1)=b(ifl+2*j-1)
            b(ifl+2*j-2)=st
            b(ifl+2*j-1)=sf
         endif
      enddo
   enddo
   k=k+1
   b(ifl+2*k-2)=ulim
   b(ifl+2*k-1)=b(ifl+2*k-3)
   nw=2*k

   !--convert to practical units
   !--and combine duplicate bragg edges.
   bel=-1
   j=0
   do i=1,k
      be=b(ifl+2*i-2)*recon
      bs=b(ifl+2*i-1)*scon
      if (be-bel.lt.toler) then
         b(ifl+2*j-1)=b(ifl+2*j-1)+bs
      else
         j=j+1
         b(ifl+2*j-2)=be
         b(ifl+2*j-1)=bs
         bel=be
      endif
   enddo
   nbe=j
   maxb=2*nbe
   write(nsyso,'(/''   found'',i5,'' edges below'',&
     &f6.2,'' ev'')') nbe,emax
   return

   contains

      real(kr) function tausq(m1,m2,m3,c1,c2,twopis)
      integer::m1,m2,m3
      real(kr)::c1,c2,twopis
      tausq=(c1*(m1*m1+m2*m2+m1*m2)+(m3*m3*c2))*twopis
      return
      end function tausq

      real(kr) function taufcc(m1,m2,m3,c1,twothd,twopis)
      integer::m1,m2,m3
      real(kr)::c1,twothd,twopis
      taufcc=c1*(m1*m1+m2*m2+m3*m3+twothd*m1*m2&
        +twothd*m1*m3-twothd*m2*m3)*twopis
      return
      end function taufcc

      real(kr) function taubcc(m1,m2,m3,twopis)
      integer::m1,m2,m3
      real(kr)::twopis
      taubcc=c1*(m1*m1+m2*m2+m3*m3+m1*m2+m2*m3+m1*m3)*twopis
      return
      end function taubcc

   end subroutine coher

   subroutine skold(itemp,temp,ssm,nalpha,nbeta,ntempr)
   !--------------------------------------------------------------------
   ! use skold approximation to add in the effects
   ! of intermolecular coherence.
   !--------------------------------------------------------------------
   use mainio  ! provides nsyso
   use physics ! provides bk,ev,hbar,amassn,amu
   use endf    ! provides terp1
   ! externals
   integer::itemp,nalpha,nbeta,ntempr
   real(kr)::temp
   real(kr)::ssm(nbeta,nalpha,ntempr)
   ! internals
   integer::i,j,k,kk,nal,ibeta,iprt,jprt
   real(kr)::tev,sc,amass,al,sk,ap,be,ss,s1,s2
   real(kr)::sum0,sum1,ff1l,ff2l,bel,ff1,ff2,waven
   real(kr)::scoh(1000)
   real(kr),parameter::angst=1.e-8_kr
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::zero=0.0

   !--apply the skold approximation
   tev=bk*abs(temp)
   sc=1
   if (lat.eq.1) sc=therm/tev
   amass=awr*amassn*amu
   do i=1,nbeta
      do j=1,nalpha
         al=alpha(j)*sc/arat
         waven=angst*sqrt(2*amass*tev*ev*al)/hbar
         sk=terpk(ska,nka,dka,waven)
         ap=alpha(j)/sk
         do k=1,nalpha
            kk=k
            if (ap.lt.alpha(k)) exit
         enddo
         if (kk.eq.1) kk=2
         if (ssm(i,kk-1,itemp).eq.zero.or.ssm(i,kk,itemp).eq.zero) then
            scoh(j)=zero
         else
         call terp1(alpha(kk-1),ssm(i,kk-1,itemp),&
           alpha(kk),ssm(i,kk,itemp),ap,scoh(j),5)
         endif
         scoh(j)=scoh(j)*sk
      enddo
      do j=1,nalpha
         ssm(i,j,itemp)=(1-cfrac)*ssm(i,j,itemp)+cfrac*scoh(j)
      enddo
   enddo

   !--report the results
   if (iprint.eq.2) write(nsyso,&
     '(/'' results after applying skold approximation'')')
   do nal=1,nalpha
      iprt=mod(nal-1,naint)+1
      if (nal.eq.nalpha) iprt=1
      al=alpha(nal)*sc/arat
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/3x,''alpha='',f10.5)') al
      if (iprt.eq.1.and.iprint.eq.2) write(nsyso,&
        '(/4x,'' beta'',7x,''s(alpha,beta)'',7x,''ss(alpha,beta)'',&
        &5x,''ss(alpha,-beta)'')')
      do i=1,nbeta
         be=beta(i)*sc
         ss=ssm(i,nal,itemp)
         s1=ss*exp(-be/2)
         s2=ss*exp(-be)
         jprt=mod(i-1,nbint)+1
         if (i.eq.nbeta) jprt=1
         if (iprt.eq.1.and.jprt.eq.1.and.iprint.eq.2)&
           write(nsyso,'(f10.4,1pe18.5,1p,2e20.5)') beta(i),s1,s2,ss
      enddo
      if (iprt.eq.1) then
         sum0=0
         sum1=0
         ff1l=0
         ff2l=0
         bel=0
         do ibeta=1,nbeta
            be=beta(ibeta)
            ff2=ssm(ibeta,nal,itemp)
            ff1=ssm(ibeta,nal,itemp)*exp(-be)
            if (ibeta.gt.1) then
               sum0=sum0+(be-bel)*(ff1l+ff2l+ff1+ff2)/2
               sum1=sum1+(be-bel)*(ff2l*bel+ff2*be-ff1l*bel-ff1*be)/2
               ff1l=ff1
               ff2l=ff2
               bel=be
            else
               bel=be
               ff1l=ff1
               ff2l=ff2
               sum0=0
               sum1=0
            endif
         enddo
         sum1=sum1/al
         if (iprint.eq.2) then
            write(nsyso,'(''     normalization check ='',f8.4)') sum0
            write(nsyso,'(''          sum rule check ='',f8.4)') sum1
         else if (iprint.eq.1) then
            write(nsyso,'(1x,f10.4,2f10.4)') al,sum0,sum1
         endif
      endif
   enddo
   return
   end subroutine skold

   real(kr) function formf(lat,l1,l2,l3)
   !--------------------------------------------------------------------
   ! Compute form factors for the specified lattice.
   !       lat=1    graphite
   !       lat=2    Be
   !       lat=3    BeO
   !       lat=4,5  fcc lattice (aluminum, lead)
   !       lat=6    bcc lattice (iron)
   !--------------------------------------------------------------------
   use physics ! provides pi
   ! externals
   integer::lat,l1,l2,l3
   ! internals
   integer::i
   real(kr)::e1,e2,e3
   real(kr),parameter::c1=7.54e0_kr
   real(kr),parameter::c2=4.24e0_kr
   real(kr),parameter::c3=11.31e0_kr

   if (lat.eq.1) then
      ! graphite.
      i=l3/2
      if ((2*i).ne.l3) then
      formf=sin(pi*(l1-l2)/3)**2
      else
         formf=(6+10*cos(2*pi*(l1-l2)/3))/4
      endif
   else if (lat.eq.2) then
      ! beryllium.
      formf=1+cos(2*pi*(2*l1+4*l2+3*l3)/6)
   else if (lat.eq.3) then
      ! beryllium oxide.
      formf=(1+cos(2*pi*(2*l1+4*l2+3*l3)/6))&
        *(c1+c2+c3*cos(3*pi*l3/4))
   else if (lat.eq.4.or.lat.eq.5) then
      ! fcc lattices.
      e1=2*pi*l1
      e2=2*pi*(l1+l2)
      e3=2*pi*(l1+l3)
      formf=(1+cos(e1)+cos(e2)+cos(e3))**2+(sin(e1)+sin(e2)+sin(e3))**2
   else if (lat.eq.6) then
      ! bcc lattices.
      e1=2*pi*(l1+l2+l3)
      formf=(1+cos(e1))**2+(sin(e1))**2
   endif
   return
   end function formf

   subroutine endout(ntempr,bragg,nedge,maxb,scr,mscr,isym,ilog)
   !--------------------------------------------------------------------
   ! ENDF output routine
   !--------------------------------------------------------------------
   use mainio  ! provide nsyso
   use endf    ! provides endf routines, npage, iverf
   use physics ! provide bk (boltzmann constant)
   use util    ! provides timer,repoz,error,sigfig
   ! externals
   integer::ntempr,maxb,mscr,nedge,isym,ilog
   real(kr)::bragg(maxb)
   real(kr)::scr(mscr)
   ! internals
   real(kr)::time,sum,suml,w,e,sb,sbs,srat,sc,be
   integer::i,j,k,l,nt,jmax,ii,jj,j1,ndw,nbt,ntf,ll
   integer::ncards,idone,nc,n,nb,nw,nprnt,nscr
   character(66)::text
   character(4)::t(17)
   real(kr)::z(17)
   equivalence(t(1),z(1))
   real(kr),parameter::small=1.e-9_kr
   real(kr),parameter::tiny=-999.e0_kr
   real(kr),parameter::tol=0.9e-7_kr
   real(kr),parameter::up=1.01e0_kr
   real(kr),parameter::therm=.0253e0_kr
   real(kr),parameter::zero=0

   !--write header
   call timer(time)
   write(nsyso,'(//'' endf output'',57x,f8.1,''s'')') time
   if (isym.eq.0) then
      write(nsyso,'(/'' endf output is s'')')
   else if (isym.eq.1) then
      write(nsyso,'(/'' endf output is s for +&- beta'')')
   else if (isym.eq.2) then
      write(nsyso,'(/'' endf output is ss for - beta'')')
   else if (isym.eq.3) then
      write(nsyso,'(/'' endf output is ss for +&- beta'')')
   endif
   if (ilog.eq.1) write(nsyso,'('' log10 s or ss is written'')')

   !---compute bound scattering cross sections
   sb=spr*((1+awr)/awr)**2
   if (aws.ne.zero) sbs=sps*((1+aws)/aws)**2

   !--for mixed moderators, merge ssm results
   if (nss.ne.0.and.b7.le.zero) then
      srat=sbs/sb
      nscr=-10
      call repoz(nscr)
      do k=1,ntempr
         do j=1,nalpha
            read(-nscr) (scr(i),i=1,nbeta)
            do i=1,nbeta
               ssm(i,j,k)=srat*ssm(i,j,k)+scr(i)
            enddo
         enddo
      enddo
   endif

   !---display endf t-effective and debye-waller integral
   do i=1,ntempr
      if (nss.eq.0.or.b7.gt.zero) then
         dwpix(i)=dwpix(i)/(awr*tempr(i)*bk)
      else
         dwpix(i)=dwpix(i)/(aws*tempr(i)*bk)
         dwp1(i)=dwp1(i)/(awr*tempr(i)*bk)
      endif
   enddo
   if (nss.eq.0.or.b7.gt.zero) then
      write(nsyso,'(/''    i     tempr       tempf       awr*w''/&
        &(i5,1p,3e12.3))') (i,tempr(i),tempf(i),awr*dwpix(i),i=1,ntempr)
   else
      write(nsyso,'(/26x,''principal'',15x,''secondary''/&
        &''    i     tempr       tempf       awr*w'',&
        &''       tempf       aws*w''/(i5,1p,5e12.3))')&
        (i,tempr(i),tempf1(i),awr*dwp1(i),&
        tempf(i),aws*dwpix(i),i=1,ntempr)
   endif

   !--write endf-6 file 1.
   if (iel.eq.0.and.twt.eq.zero) iel=-1
   write(nsyso,'(//)')
   nprnt=0
   nsp=0
   nsc=0
   math=1
   mfh=0
   mth=0
   nsh=0
   text=' '
   read(text,'(16a4,a2)') (t(i),i=1,17)
   call tpidio(0,nout,nprnt,z,nb,nw)
   math=mat
   mfh=1
   mth=451
   scr(1)=za
   scr(2)=awr
   scr(3)=-1
   scr(4)=0
   scr(5)=0
   scr(6)=0
   call contio(0,nout,nprnt,scr(1),nb,nw)
   scr(1)=0
   scr(2)=0
   scr(3)=0
   scr(4)=0
   scr(5)=0
   scr(6)=6
   call contio(0,nout,nprnt,scr(1),nb,nw)
   scr(1)=1
   scr(2)=0
   scr(3)=0
   scr(4)=0
   scr(5)=12
   scr(6)=6
   call contio(0,nout,nprnt,scr(1),nb,nw)
   scr(1)=0
   scr(2)=0
   scr(3)=0
   scr(4)=0
   scr(5)=0
   scr(6)=2
   if (iel.ne.0) scr(6)=3
   n=6
   nc=0
   idone=0
   do while (idone.eq.0)
      text='$'
      read(nsysi,*) text
      if (text.eq.'$') then
         idone=1
      else
         nc=nc+1
         read(text,'(16a4,a2)') (t(j),j=1,17)
         do j=1,17
            scr(n+j)=z(j)
         enddo
         n=n+17
         if (n.gt.mscr) call error('endout',&
           &'scratch storage exceeded for hollerith data',' ')
      endif
   enddo
   scr(5)=17*nc
   l=1
   call hdatio(0,nout,nprnt,scr(l),nb,nw)
   do while (nb.ne.0)
      l=l+nw
      call moreio(0,nout,nprnt,scr(l),nb,nw)
   enddo
   scr(1)=0
   scr(2)=0
   scr(3)=1
   scr(4)=451
   scr(5)=5+nc+1
   if (iel.ne.0) scr(5)=scr(5)+1
   scr(6)=0
   ii=6
   if (iel.ne.0) then
      scr(ii+1)=0
      scr(ii+2)=0
      scr(ii+3)=7
      scr(ii+4)=2
      if (iel.lt.0) ncards=3+(2*ntempr+4)/6
      if (iel.gt.0) ncards=3+(2*nedge+4)/6
      if (iel.gt.0.and.ntempr.gt.1)&
        ncards=ncards+(ntempr-1)*(1+(nedge+5)/6)
      scr(ii+5)=ncards
      scr(ii+6)=0
      ii=ii+6
   endif
   scr(ii+1)=0
   scr(ii+2)=0
   scr(ii+3)=7
   scr(ii+4)=4
   ncards=2+(2*nalpha+4)/6
   if (ntempr.gt.1) ncards=ncards+(ntempr-1)*(1+(nalpha+5)/6)
   ncards=5+nbeta*ncards
   scr(ii+5)=ncards
   scr(ii+6)=0
   nw=2
   if (iel.ne.0) nw=3
   call dictio(0,nout,nprnt,scr(1),nb,nw)
   call asend(nout,nprnt)
   call afend(nout,nprnt)

   !--write incoherent elastic part
   if (iel.lt.0) then
      mfh=7
      mth=2
      scr(1)=za
      scr(2)=awr
      scr(3)=2
      scr(4)=0
      scr(5)=0
      scr(6)=0
      call contio(0,nout,nprnt,scr(1),nb,nw)
      scr(1)=sb*npr
      scr(2)=0
      scr(3)=0
      scr(4)=0
      scr(5)=1
      ndw=ntempr
      if (ndw.eq.1) ndw=2
      scr(6)=ndw
      scr(7)=ndw
      scr(8)=2
      do i=1,ndw
         if (i.le.ntempr) then
            scr(2*i+7)=tempr(i)
            scr(2*i+8)=sigfig(dwpix(i),7,0)
         else
            scr(2*i+7)=scr(2*i+5)
            scr(2*i+8)=scr(2*i+6)
         endif
      enddo
      call tab1io(0,nout,nprnt,scr(1),nb,nw)
      call asend(nout,nprnt)
   endif

   !--write coherent elastic part
   if (iel.ge.1) then
      mfh=7
      mth=2
      scr(1)=za
      scr(2)=awr
      scr(3)=1
      scr(4)=0
      scr(5)=0
      scr(6)=0
      call contio(0,nout,nprnt,scr(1),nb,nw)

      !--thin out the 1/e part at high energies.
      sum=0
      suml=0
      w=dwpix(1)
      if (nss.gt.0.and.b7.eq.zero) w=(dwpix(1)+dwp1(1))/2
      do j=1,nedge
         e=bragg(1+2*j-2)
         sum=sum+exp(-4*w*e)*bragg(1+2*j-1)
         if (sum-suml.gt.tol*sum) then
            jmax=j
            suml=sum
         endif
      enddo

      !--now output the records for each temperature
      do i=1,ntempr
         if (i.eq.1) then
            scr(1)=tempr(i)
            scr(2)=0
            scr(3)=ntempr-1
            scr(4)=0
            scr(5)=1
            scr(6)=jmax
            scr(7)=jmax
            scr(8)=1
            ii=8
            jj=0
            j1=0
            sum=0
            w=dwpix(i)
            if (nss.gt.0.and.b7.eq.zero) w=(dwpix(i)+dwp1(i))/2
            j=0
            do while (j.lt.nedge)
               j=j+1
               e=bragg(1+2*j-2)
               if (j.le.jmax) jj=jj+2
               scr(ii+jj-1-j1)=sigfig(e,7,0)
               scr(ii+jj-j1)=sum+exp(-4*w*e)*bragg(1+2*j-1)
               sum=scr(ii+jj-j1)
               scr(ii+jj-j1)=sigfig(scr(ii+jj-j1),7,0)
               if (j.ge.nedge.or.jj-j1.ge.npage) then
                  if (ii.ge.8) then
                     call tab1io(0,nout,nprnt,scr(1),nb,nw)
                     ii=0
                     j1=npage
                     idone=1
                  else
                     call moreio(0,nout,nprnt,scr(1),nb,nw)
                     j1=j1+npage
                  endif
               endif
            enddo
         else
            scr(1)=tempr(i)
            scr(2)=0
            scr(3)=2
            scr(4)=0
            scr(5)=jmax
            scr(6)=0
            ii=6
            jj=0
            j1=0
            sum=0
            w=dwpix(i)
            if (nss.gt.0.and.b7.eq.zero) w=(dwpix(i)+dwp1(i))/2
            do j=1,nedge
               if (j.le.jmax) jj=jj+1
               e=sigfig(bragg(1+2*jj-2),7,0)
               scr(ii+jj-j1)=sum+exp(-4*w*e)*bragg(1+2*jj-1)
               sum=scr(ii+jj-j1)
               scr(ii+jj-j1)=sigfig(scr(ii+jj-j1),7,0)
               if (j.ge.nedge.or.jj-j1.ge.npage) then
                  if (ii.ge.6) then
                     call listio(0,nout,nprnt,scr(1),nb,nw)
                     ii=0
                     j1=npage
                  else
                     call moreio(0,nout,nprnt,scr(1),nb,nw)
                     j1=j1+npage
                  endif
               endif
            enddo
         endif
      enddo
      call asend(nout,nprnt)
   endif

   !--write inelastic part
   mfh=7
   mth=4
   scr(1)=za
   scr(2)=awr
   scr(3)=0
   scr(4)=lat
   scr(5)=isym
   scr(6)=0
   call contio(0,nout,nprnt,scr(1),nb,nw)
   scr(1)=0
   scr(2)=0
   scr(3)=0
   if (ilog.ne.0) scr(3)=1
   scr(4)=0
   scr(5)=6
   if (nss.gt.0) scr(5)=6*(nss+1)
   scr(6)=nss
   scr(7)=npr*spr
   scr(8)=beta(nbeta)
   scr(9)=awr
   scr(10)=sigfig(therm*beta(nbeta),7,0)
   scr(11)=0
   scr(12)=npr
   if (nss.ne.0) then
      scr(13)=b7
      scr(14)=mss*sps
      scr(15)=aws
      scr(16)=0
      scr(17)=0
      scr(18)=mss
   endif
   call listio(0,nout,nprnt,scr(1),nb,nw)
   scr(1)=0
   scr(2)=0
   scr(3)=0
   scr(4)=0
   scr(5)=1
   nbt=nbeta
   if (isym.eq.1.or.isym.eq.3) nbt=2*nbeta-1
   scr(6)=nbt
   scr(7)=nbt
   scr(8)=4
   call tab2io(0,nout,nprnt,scr(1),nb,nw)
   ii=0
   do i=1,nbt
      do nt=1,ntempr
         sc=1
         if (lat.eq.1) sc=therm/(bk*tempr(nt))
         if (nt.eq.1) then
            scr(1)=tempr(nt)
            if (mod(isym,2).eq.0) scr(2)=beta(i)
            if (mod(isym,2).eq.1.and.i.lt.nbeta)&
              scr(2)=-beta(nbeta-i+1)
            if (mod(isym,2).eq.1.and.i.ge.nbeta)&
              scr(2)=beta(i-nbeta+1)
            be=scr(2)*sc
            scr(3)=ntempr-1
            scr(4)=0
            scr(5)=1
            scr(6)=nalpha
            scr(7)=nalpha
            scr(8)=4
            do j=1,nalpha
               scr(7+2*j)=alpha(j)
               if (isym.eq.0) then
                  if (ilog.eq.0) then
                     scr(8+2*j)=ssm(i,j,nt)*exp(-be/2)
                     if (scr(8+2*j).ge.small) then
                        scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                     else
                        scr(8+2*j)=sigfig(scr(8+2*j),6,0)
                     endif
                  else
                     scr(8+2*j)=tiny
                     if (ssm(i,j,nt).gt.zero) then
                        scr(8+2*j)=log(ssm(i,j,nt))-be/2
                        scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                     endif
                  endif
               else if (isym.eq.1) then
                  if (i.lt.nbeta) then
                     if (ilog.eq.0) then
                        scr(8+2*j)=ssm(nbeta-i+1,j,nt)*exp(be/2)
                        if (scr(8+2*j).ge.small) then
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        else
                           scr(8+2*j)=sigfig(scr(8+2*j),6,0)
                        endif
                     else
                        scr(8+2*j)=tiny
                        if (ssm(nbeta-i+1,j,nt).gt.zero) then
                           scr(8+2*j)=log(ssm(nbeta-i+1,j,nt))+be/2
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        endif
                     endif
                  else
                     if (ilog.eq.0) then
                        scr(8+2*j)=ssp(i-nbeta+1,j,nt)*exp(be/2)
                        if (scr(8+2*j).ge.small) then
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        else
                           scr(8+2*j)=sigfig(scr(8+2*j),6,0)
                        endif
                     else
                        scr(8+2*j)=tiny
                        if (ssp(i-nbeta+1,j,nt).gt.zero) then
                           scr(8+2*j)=log(ssp(i-nbeta+1,j,nt))+be/2
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        endif
                     endif
                  endif
               else if (isym.eq.2) then
                  if (ilog.eq.0) then
                     scr(8+2*j)=ssm(i,j,nt)
                    if (scr(8+2*j).ge.small) then
                        scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                     else
                        scr(8+2*j)=sigfig(scr(8+2*j),6,0)
                     endif
                  else
                     scr(8+2*j)=tiny
                     if (ssm(i,j,nt).gt.zero) then
                        scr(8+2*j)=log(ssm(i,j,nt))
                        scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                     endif
                  endif
               else if (isym.eq.3) then
                  if (i.lt.nbeta) then
                     if (ilog.eq.0) then
                        scr(8+2*j)=ssm(nbeta-i+1,j,nt)
                        if (scr(8+2*j).ge.small) then
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        else
                           scr(8+2*j)=sigfig(scr(8+2*j),6,0)
                        endif
                     else
                        scr(8+2*j)=tiny
                        if (ssm(nbeta-i+1,j,nt).gt.zero) then
                           scr(8+2*j)=log(ssm(nbeta-i+1,j,nt))
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        endif
                     endif
                  else
                     if (ilog.eq.0) then
                        scr(8+2*j)=ssp(i-nbeta+1,j,nt)
                        if (scr(8+2*j).ge.small) then
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        else
                           scr(8+2*j)=sigfig(scr(8+2*j),6,0)
                        endif
                     else
                        scr(8+2*j)=tiny
                        if (ssp(-nbeta+1,j,nt).gt.zero) then
                           scr(8+2*j)=log(ssp(i-nbeta+1,j,nt))
                           scr(8+2*j)=sigfig(scr(8+2*j),7,0)
                        endif
                     endif
                  endif
               endif
               if (ilog.eq.0.and.scr(8+2*j).lt.smin) scr(8+2*j)=0
            enddo
            call tab1io(0,nout,nprnt,scr(1),nb,nw)
            ll=1+nw
            do while (nb.ne.0)
               call moreio(0,nout,nprnt,scr(ll),nb,nw)
               ll=ll+nw
            enddo
         else
            scr(1)=tempr(nt)
            if (mod(isym,2).eq.0) scr(2)=beta(i)
            if (mod(isym,2).eq.1.and.i.lt.nbeta)&
              scr(2)=-beta(nbeta-i+1)
            if (mod(isym,2).eq.1.and.i.ge.nbeta)&
              scr(2)=beta(i-nbeta+1)
            be=scr(2)*sc
            scr(3)=4
            scr(4)=0
            scr(5)=nalpha
            scr(6)=0
            do j=1,nalpha
               if (isym.eq.0) then
                  if (ilog.eq.0) then
                     scr(6+j)=ssm(i,j,nt)*exp(-be/2)
                     if (scr(6+j).ge.small) then
                        scr(6+j)=sigfig(scr(6+j),7,0)
                     else
                        scr(6+j)=sigfig(scr(6+j),6,0)
                     endif
                  else
                     scr(6+j)=0
                     if (ssm(i,j,nt).gt.zero) then
                        scr(6+j)=log(ssm(i,j,nt))-be/2
                        scr(6+j)=sigfig(scr(6+j),7,0)
                     endif
                  endif
               else if (isym.eq.1) then
                  if (i.lt.nbeta) then
                     if (ilog.eq.0) then
                        scr(6+j)=ssm(nbeta-i+1,j,nt)*exp(be/2)
                        if (scr(6+j).ge.small) then
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        else
                           scr(6+j)=sigfig(scr(6+j),6,0)
                        endif
                     else
                        scr(6+j)=tiny
                        if (ssm(nbeta-i+1,j,nt).gt.zero) then
                           scr(6+j)=log(ssm(nbeta-i+1,j,nt))+be/2
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        endif
                     endif
                  else
                     if (ilog.eq.0) then
                        scr(6+j)=ssp(i-nbeta+1,j,nt)*exp(be/2)
                        if (scr(6+j).ge.small) then
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        else
                           scr(6+j)=sigfig(scr(6+j),6,0)
                        endif
                     else
                        scr(6+j)=tiny
                        if (ssp(i-nbeta+1,j,nt).gt.zero) then
                           scr(6+j)=log(ssp(i-nbeta+1,j,nt))+be/2
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        endif
                     endif
                  endif
               else if (isym.eq.2) then
                  if (ilog.eq.0) then
                     scr(6+j)=ssm(i,j,nt)
                     if (scr(6+j).ge.small) then
                        scr(6+j)=sigfig(scr(6+j),7,0)
                     else
                        scr(6+j)=sigfig(scr(6+j),6,0)
                     endif
                  else
                     scr(6+j)=tiny
                     if (ssm(i,j,nt).gt.zero) then
                        scr(6+j)=log(ssm(i,j,nt))
                        scr(6+j)=sigfig(scr(6+j),7,0)
                     endif
                  endif
               else if (isym.eq.3) then
                  if (i.lt.nbeta) then
                     if (ilog.eq.0) then
                        scr(6+j)=ssm(nbeta-i+1,j,nt)
                        if (scr(6+j).ge.small) then
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        else
                           scr(6+j)=sigfig(scr(6+j),6,0)
                        endif
                     else
                        scr(6+j)=tiny
                        if (ssm(nbeta-i+1,j,nt).gt.zero) then
                           scr(6+j)=log(ssm(nbeta-i+1,j,nt))
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        endif
                     endif
                  else
                     if (ilog.eq.0) then
                        scr(6+j)=ssp(i-nbeta+1,j,nt)
                        if (scr(6+j).ge.small) then
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        else
                           scr(6+j)=sigfig(scr(6+j),6,0)
                        endif
                     else
                        scr(6+j)=tiny
                        if (ssp(-nbeta+1,j,nt).gt.zero) then
                           scr(6+j)=log(ssp(i-nbeta+1,j,nt))
                           scr(6+j)=sigfig(scr(6+j),7,0)
                        endif
                     endif
                  endif
               endif
               if (ilog.eq.0.and.scr(6+j).lt.smin) scr(6+j)=0
            enddo
            call listio(0,nout,nprnt,scr(1),nb,nw)
            ll=1
            do while (nb.ne.0)
               ll=ll+nw
               call moreio(0,nout,nprnt,scr(ll),nb,nw)
            enddo
         endif
      enddo
   enddo
   if (nss.ne.0.and.b7.le.zero) then
      scr(1)=0
      scr(2)=0
      scr(3)=0
      scr(4)=0
      scr(5)=1
      ntf=ntempr
      scr(6)=ntf
      scr(7)=ntf
      scr(8)=2
      do i=1,ntf
         if (i.le.ntempr) then
            scr(2*i+7)=sigfig(tempr(i),7,0)
            scr(2*i+8)=sigfig(tempf1(i),7,0)
         else
            scr(2*i+7)=sigfig(up*scr(2*i+5),7,0)
            scr(2*i+8)=scr(2*i+6)
         endif
      enddo
      call tab1io(0,nout,nprnt,scr(1),nb,nw)
   endif
   scr(1)=0
   scr(2)=0
   scr(3)=0
   scr(4)=0
   scr(5)=1
   ntf=ntempr
   scr(6)=ntf
   scr(7)=ntf
   scr(8)=2
   do i=1,ntf
      if (i.le.ntempr) then
         scr(2*i+7)=sigfig(tempr(i),7,0)
         scr(2*i+8)=sigfig(tempf(i),7,0)
      else
         scr(2*i+7)=sigfig(up*scr(2*i+5),7,0)
         scr(2*i+8)=scr(2*i+6)
      endif
   enddo
   call tab1io(0,nout,nprnt,scr(1),nb,nw)
   call asend(nout,nprnt)
   call afend(nout,nprnt)
   call amend(nout,nprnt)
   call atend(nout,nprnt)
   return
   end subroutine endout

end module leapm
